/***************************************************************************

Copyright (c) Microsoft Corporation. All rights reserved.
This code is licensed under the Visual Studio SDK license terms.
THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.

This code is a part of the Visual Studio Library.

***************************************************************************/

#ifndef IVSSMARTOPENSCOPE_H_10C49CA1_2F46_11D3_A504_00C04F5E0BA5
#define IVSSMARTOPENSCOPE_H_10C49CA1_2F46_11D3_A504_00C04F5E0BA5

#if _MSC_VER > 1000
#pragma once
#endif

#include "compsvcspkg80.h"

#pragma warning(push)
#pragma warning(disable : 4510) // default constructor could not be generated
#pragma warning(disable : 4610) // can never be instantiated - user defined constructor required
#pragma warning(disable : 4512) // assignment operator could not be generated
#pragma warning(disable : 6011) // Dereferencing NULL pointer (a NULL derference is just another kind of failure for a unit test

namespace VSL
{

class IVsSmartOpenScopeNotImpl :
	public IVsSmartOpenScope
{

VSL_DECLARE_NONINSTANTIABLE_BASE_CLASS(IVsSmartOpenScopeNotImpl)

public:

	typedef IVsSmartOpenScope Interface;

	STDMETHOD(OpenScope)(
		/*[in]*/ LPCOLESTR /*wszScope*/,
		/*[in]*/ DWORD /*dwOpenFlags*/,
		/*[in]*/ REFIID /*riid*/,
		/*[out]*/ IUnknown** /*ppIUnk*/)VSL_STDMETHOD_NOTIMPL
};

class IVsSmartOpenScopeMockImpl :
	public IVsSmartOpenScope,
	public MockBase
{

VSL_DECLARE_NONINSTANTIABLE_BASE_CLASS(IVsSmartOpenScopeMockImpl)

public:

VSL_DEFINE_MOCK_CLASS_TYPDEFS(IVsSmartOpenScopeMockImpl)

	typedef IVsSmartOpenScope Interface;
	struct OpenScopeValidValues
	{
		/*[in]*/ LPCOLESTR wszScope;
		/*[in]*/ DWORD dwOpenFlags;
		/*[in]*/ REFIID riid;
		/*[out]*/ IUnknown** ppIUnk;
		HRESULT retValue;
	};

	STDMETHOD(OpenScope)(
		/*[in]*/ LPCOLESTR wszScope,
		/*[in]*/ DWORD dwOpenFlags,
		/*[in]*/ REFIID riid,
		/*[out]*/ IUnknown** ppIUnk)
	{
		VSL_DEFINE_MOCK_METHOD(OpenScope)

		VSL_CHECK_VALIDVALUE_STRINGW(wszScope);

		VSL_CHECK_VALIDVALUE(dwOpenFlags);

		VSL_CHECK_VALIDVALUE(riid);

		VSL_SET_VALIDVALUE_INTERFACE(ppIUnk);

		VSL_RETURN_VALIDVALUES();
	}
};


} // namespace VSL

#pragma warning(pop)

#endif // IVSSMARTOPENSCOPE_H_10C49CA1_2F46_11D3_A504_00C04F5E0BA5
