<?xml version="1.0"?>
<doc>
    <assembly>
        <name>Microsoft.VisualStudio.Modeling.Sdk.DslDefinition</name>
    </assembly>
    <members>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelHelpKeywordHelper">
            <summary>
            Helper class used to map shapes and model elements to help keywords.
            </summary>
            <remarks>
            Double-derived class to allow easier code customization.
            </remarks>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelHelpKeywordHelperBase">
            <summary>
            Helper class used to map shapes and model elements to F1 help keywords.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelHelpKeywordHelperBase.#ctor">
            <summary>
            Constructs a new DslDefinitionModelHelpKeywordHelperBase.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelHelpKeywordHelperBase.Initialize">
            <summary>
            Called to initialize the HelpKeywords dictionary.  Derived classes may override this to add custom keywords to the collection.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelHelpKeywordHelperBase.GetHelpKeyword(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Gets the help keyword associated with the given shape or model element instance.
            </summary>
            <returns>Help keyword, or empty string if there is no associated help keyword.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelHelpKeywordHelperBase.GetDomainRoleHelpKeyword(Microsoft.VisualStudio.Modeling.DomainRoleInfo)">
            <summary>
            Gets the help keyword associated with the given domain role.
            </summary>
            <returns>Help keyword, or empty string if there is no associated help keyword.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelHelpKeywordHelperBase.GetDomainPropertyHelpKeyword(Microsoft.VisualStudio.Modeling.DomainPropertyInfo)">
            <summary>
            Gets the help keyword associated with the given domain property.
            </summary>
            <returns>Help keyword, or empty string if there is no associated help keyword.</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelHelpKeywordHelperBase.HelpKeywords">
            <summary>
            Collection of key/value pairs describing help keywords for this DSL.
            Keys are strings such as domain class names that describe elements of the DSL.
            Values are corresponding help keywords.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelHelpKeywordHelper.#ctor">
            <summary>
            Constructs a new DslDefinitionModelHelpKeywordHelper.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelHelpKeywordHelper.Instance">
            <summary>
            Single instance of the DslDefinitionModelHelpKeywordHelper.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorTypeDescriptionProvider">
            <summary>
            Factory class for ExplorerBehaviorTypeDescriptors.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorTypeDescriptionProvider.#ctor">
            <summary>
            Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorTypeDescriptionProvider.CreateTypeDescriptor(System.ComponentModel.ICustomTypeDescriptor,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Called by the System.ComponentModel framework when it requires a type descriptor instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorTypeDescriptor">
            <summary>
            Custom type descriptor class for ExplorerBehavior elements.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorTypeDescriptor.#ctor(System.ComponentModel.ICustomTypeDescriptor,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorTypeDescriptor.GetProperties(System.Attribute[])">
            <summary>
            Returns a collection of property descriptors an instance of ExplorerBehavior.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorTypeDescriptor.ExplorerTitlePropertyDescriptor1">
            <summary>
            Specialized property descriptor used when the Title property appears on the ExplorerBehavior class.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorTypeDescriptor.ExplorerTitlePropertyDescriptor1.#ctor(Microsoft.VisualStudio.Modeling.Design.ElementTypeDescriptor,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainPropertyInfo,System.Attribute[])">
            <summary>
            Constructs a new ExplorerTitlePropertyDescriptor1.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorTypeDescriptor.ExplorerTitlePropertyDescriptor1.Category">
            <summary>
            Category this property appears in.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorTypeDescriptor.ExplorerExplorerGuidPropertyDescriptor2">
            <summary>
            Specialized property descriptor used when the ExplorerGuid property appears on the ExplorerBehavior class.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorTypeDescriptor.ExplorerExplorerGuidPropertyDescriptor2.#ctor(Microsoft.VisualStudio.Modeling.Design.ElementTypeDescriptor,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainPropertyInfo,System.Attribute[])">
            <summary>
            Constructs a new ExplorerExplorerGuidPropertyDescriptor2.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorTypeDescriptor.ExplorerExplorerGuidPropertyDescriptor2.Category">
            <summary>
            Category this property appears in.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorTypeDescriptionProvider">
            <summary>
            Factory class for XmlSerializationBehaviorTypeDescriptors.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorTypeDescriptionProvider.#ctor">
            <summary>
            Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorTypeDescriptionProvider.CreateTypeDescriptor(System.ComponentModel.ICustomTypeDescriptor,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Called by the System.ComponentModel framework when it requires a type descriptor instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorTypeDescriptor">
            <summary>
            Custom type descriptor class for XmlSerializationBehavior elements.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorTypeDescriptor.#ctor(System.ComponentModel.ICustomTypeDescriptor,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorTypeDescriptor.GetProperties(System.Attribute[])">
            <summary>
            Returns a collection of property descriptors an instance of XmlSerializationBehavior.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorTypeDescriptor.XmlSerializationDefinitionCustomPostLoadPropertyDescriptor1">
            <summary>
            Specialized property descriptor used when the CustomPostLoad property appears on the XmlSerializationBehavior class.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorTypeDescriptor.XmlSerializationDefinitionCustomPostLoadPropertyDescriptor1.#ctor(Microsoft.VisualStudio.Modeling.Design.ElementTypeDescriptor,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainPropertyInfo,System.Attribute[])">
            <summary>
            Constructs a new XmlSerializationDefinitionCustomPostLoadPropertyDescriptor1.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorTypeDescriptor.XmlSerializationDefinitionCustomPostLoadPropertyDescriptor1.Category">
            <summary>
            Category this property appears in.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorTypeDescriptor.XmlSerializationDefinitionRootNamespacePropertyDescriptor2">
            <summary>
            Specialized property descriptor used when the RootNamespace property appears on the XmlSerializationBehavior class.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorTypeDescriptor.XmlSerializationDefinitionRootNamespacePropertyDescriptor2.#ctor(Microsoft.VisualStudio.Modeling.Design.ElementTypeDescriptor,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainPropertyInfo,System.Attribute[])">
            <summary>
            Constructs a new XmlSerializationDefinitionRootNamespacePropertyDescriptor2.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorTypeDescriptor.XmlSerializationDefinitionRootNamespacePropertyDescriptor2.Category">
            <summary>
            Category this property appears in.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorTypeDescriptor.XmlSerializationDefinitionWriteOptionalPropertiesWithDefaultValuePropertyDescriptor3">
            <summary>
            Specialized property descriptor used when the WriteOptionalPropertiesWithDefaultValue property appears on the XmlSerializationBehavior class.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorTypeDescriptor.XmlSerializationDefinitionWriteOptionalPropertiesWithDefaultValuePropertyDescriptor3.#ctor(Microsoft.VisualStudio.Modeling.Design.ElementTypeDescriptor,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainPropertyInfo,System.Attribute[])">
            <summary>
            Constructs a new XmlSerializationDefinitionWriteOptionalPropertiesWithDefaultValuePropertyDescriptor3.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorTypeDescriptor.XmlSerializationDefinitionWriteOptionalPropertiesWithDefaultValuePropertyDescriptor3.Category">
            <summary>
            Category this property appears in.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase">
            <summary>
            Double-derived base class for DomainClass DslLibrary
            </summary>
            <summary>
            Customized DslLibraryBase code.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement">
            <summary>
            DomainClass NamedDomainElement
            Abstract base class for elements of a DSL definition which have names.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement">
            <summary>
            DomainClass AttributedDomainElement
            Domain elements that can have CLR Attributes defined on them.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElement">
            <summary>
            DomainClass DomainElement
            Abstract base class of all components of a domain specific language definition.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElement.DomainClassId">
            <summary>
            DomainElement domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElement.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElement.NotesDomainPropertyId">
            <summary>
            Notes domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElement.notesPropertyStorage">
            <summary>
            Storage for Notes
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElement.Notes">
            <summary>
            Gets or sets the value of Notes domain property.
            Informal notes associated with this element.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElement.NotesPropertyHandler">
            <summary>
            Value handler for the DomainElement.Notes domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElement.NotesPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainElement.Notes domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElement.NotesPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainElement)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElement.NotesPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainElement,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElement.NotesPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainElement.Notes domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement.descriptionStorage">
            <summary>
            Storage for Description DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement.GetDescriptionValue">
            <summary>
            Gets the value of Description
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement.SetDescriptionValue(System.String)">
            <summary>
            Sets the value of Description
            </summary>
            <param name="value"></param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement.DomainClassId">
            <summary>
            AttributedDomainElement domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement.DescriptionDomainPropertyId">
            <summary>
            Description domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement.IsDescriptionTrackingDomainPropertyId">
            <summary>
            IsDescriptionTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement.isDescriptionTrackingPropertyStorage">
            <summary>
            Storage for IsDescriptionTracking
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement.CustomAttributesDomainPropertyId">
            <summary>
            CustomAttributes domain property Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement.GetCustomAttributesValue">
            <summary>
            Method to supply the readonly custom attribute CustomAttributes
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement.ConstructCustomAttributesDescription(Microsoft.VisualStudio.Modeling.LinkedElementCollection{Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute})">
            <summary>
            Internal helper metohd to construct the viewable custom attributes for property grid.
            </summary>
            <param name="attributes"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement.CalculateDescription">
            <summary>
            Calculates the value of Description
            </summary>
            <returns>The value of Description</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement.Description">
            <summary>
            Gets or sets the value of Description domain property.
            Used in the UI and in the code documentation of the generated designer.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement.IsDescriptionTracking">
            <summary>
            Gets or sets the value of IsDescriptionTracking domain property.
            If True, the Description property tracks other data in the DSL definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement.CustomAttributes">
            <summary>
            Gets or sets the value of CustomAttributes domain property.
            Used to attribute the code generated from this element.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement.Attributes">
            <summary>
            Gets a list of Attributes.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement.IsDescriptionTrackingPropertyHandler">
            <summary>
            Tracking change handler for Description
            </summary>
            <summary>
            Value handler for the AttributedDomainElement.IsDescriptionTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement.IsDescriptionTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the AttributedDomainElement.IsDescriptionTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement.IsDescriptionTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement.IsDescriptionTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement.IsDescriptionTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the AttributedDomainElement.IsDescriptionTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement.DescriptionPropertyHandler">
            <summary>
            Value handler for the AttributedDomainElement.Description domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement.DescriptionPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the AttributedDomainElement.Description domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement.DescriptionPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement.DescriptionPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement.DescriptionPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the AttributedDomainElement.Description domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement.CustomAttributesPropertyHandler">
            <summary>
            Value handler for the AttributedDomainElement.CustomAttributes domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement.CustomAttributesPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the AttributedDomainElement.CustomAttributes domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement.CustomAttributesPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement.CustomAttributesPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the AttributedDomainElement.CustomAttributes domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.displayNameStorage">
            <summary>
            Storage for DisplayName DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.GetDisplayNameValue">
            <summary>
            Gets the value of DisplayName
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.SetDisplayNameValue(System.String)">
            <summary>
            Sets the value of DisplayName
            </summary>
            <param name="value"></param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.nameStorage">
            <summary>
            Storage for Name DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.GetNameValue">
            <summary>
            Gets the value of Name
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.SetNameValue(System.String)">
            <summary>
            Sets the value of Name
            </summary>
            <param name="value"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.CalculateName">
            <summary>
            Calculates the value of Name
            </summary>
            <remarks>The base implementation just returns the storage, so that Name behaves like a regular property</remarks>
            <returns>The value of Name</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.DomainClassId">
            <summary>
            NamedDomainElement domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.NameDomainPropertyId">
            <summary>
            Name domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.DisplayNameDomainPropertyId">
            <summary>
            DisplayName domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.HelpKeywordDomainPropertyId">
            <summary>
            HelpKeyword domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.helpKeywordPropertyStorage">
            <summary>
            Storage for HelpKeyword
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.IsDisplayNameTrackingDomainPropertyId">
            <summary>
            IsDisplayNameTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.isDisplayNameTrackingPropertyStorage">
            <summary>
            Storage for IsDisplayNameTracking
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.CalculateDisplayName">
            <summary>
            Calculates the value of DisplayName
            </summary>
            <returns>The value of DisplayName</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.OnNameChanged(System.String,System.String)">
            <summary>
            Called when the Name of a NamedDomainElement changes
            </summary>
            <param name="oldValue"></param>
            <param name="newValue"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.ValidateNameAndDisplayName(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Check for blank DisplayNames
            </summary>
            <param name="context"></param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.ProxyIsNameTracking">
            <summary>
            Virtualized version of IsNameTracking to cope with the fact that derived classes own the IsNameTracking flags
            </summary>
            <remarks>
            Override to map to real IsNameTracking property on classes where Name is a tracking property.
            </remarks>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.Name">
            <summary>
            Gets or sets the value of Name domain property.
            Name of this element.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.DisplayName">
            <summary>
            Gets or sets the value of DisplayName domain property.
            The name that will be displayed in the generated designer for this element.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.HelpKeyword">
            <summary>
            Gets or sets the value of HelpKeyword domain property.
            Optional keyword used to index F1 help for this element.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.IsDisplayNameTracking">
            <summary>
            Gets or sets the value of IsDisplayNameTracking domain property.
            If True, the DisplayName property tracks other data in the DSL definition.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.IsDisplayNameTrackingPropertyHandler">
            <summary>
            Tracking change handler for DisplayName
            </summary>
            <summary>
            Value handler for the NamedDomainElement.IsDisplayNameTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.IsDisplayNameTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the NamedDomainElement.IsDisplayNameTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.IsDisplayNameTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.IsDisplayNameTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.IsDisplayNameTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the NamedDomainElement.IsDisplayNameTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.NamePropertyHandler">
            <summary>
            Value handler for the NamedDomainElement.Name domain property.
            </summary>
            <summary>
            Add a change handler to name to update DisplayName
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.NamePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the NamedDomainElement.Name domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.NamePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.NamePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.NamePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the NamedDomainElement.Name domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.DisplayNamePropertyHandler">
            <summary>
            Value handler for the NamedDomainElement.DisplayName domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.DisplayNamePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the NamedDomainElement.DisplayName domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.DisplayNamePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.DisplayNamePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.DisplayNamePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the NamedDomainElement.DisplayName domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.HelpKeywordPropertyHandler">
            <summary>
            Value handler for the NamedDomainElement.HelpKeyword domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.HelpKeywordPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the NamedDomainElement.HelpKeyword domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.HelpKeywordPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.HelpKeywordPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement.HelpKeywordPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the NamedDomainElement.HelpKeyword domain property.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.ValidateDslLibraryBaseMultiplicity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Checks that the relationships that have a multiplicity of One or OneMany do actually have a link.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.DomainClassId">
            <summary>
            DslLibrary domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.NamespaceDomainPropertyId">
            <summary>
            Namespace domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.namespacePropertyStorage">
            <summary>
            Storage for Namespace
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.AccessModifierDomainPropertyId">
            <summary>
            AccessModifier domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.accessModifierPropertyStorage">
            <summary>
            Storage for AccessModifier
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.MajorVersionDomainPropertyId">
            <summary>
            MajorVersion domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.majorVersionPropertyStorage">
            <summary>
            Storage for MajorVersion
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.MinorVersionDomainPropertyId">
            <summary>
            MinorVersion domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.minorVersionPropertyStorage">
            <summary>
            Storage for MinorVersion
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.BuildDomainPropertyId">
            <summary>
            Build domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.buildPropertyStorage">
            <summary>
            Storage for Build
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.RevisionDomainPropertyId">
            <summary>
            Revision domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.revisionPropertyStorage">
            <summary>
            Storage for Revision
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.CanMerge(Microsoft.VisualStudio.Modeling.ProtoElementBase,Microsoft.VisualStudio.Modeling.ElementGroupPrototype)">
            <summary>
            Returns a value indicating whether the source element represented by the
            specified root ProtoElement can be added to this element.
            </summary>
            <param name="rootElement">
            The root ProtoElement representing a source element.  This can be null, 
            in which case the ElementGroupPrototype does not contain an ProtoElements
            and the code should inspect the ElementGroupPrototype context information.
            </param>
            <param name="elementGroupPrototype">The ElementGroupPrototype that contains the root ProtoElement.</param>
            <returns>true if the source element represented by the ProtoElement can be added to this target element.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.MergeRelate(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Called by the Merge process to create a relationship between 
            this target element and the specified source element. 
            Typically, a parent-child relationship is established
            between the target element (the parent) and the source element 
            (the child), but any relationship can be established.
            </summary>
            <param name="sourceElement">The element that is to be related to this model element.</param>
            <param name="elementGroup">The group of source ModelElements that have been rehydrated into the target store.</param>
            <remarks>
            This method is overriden to create the relationship between the target element and the specified source element.
            The base method does nothing.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.MergeDisconnect(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Performs operation opposite to MergeRelate - i.e. disconnects a given
            element from the current one (removes links created by MergeRelate).
            </summary>
            <param name="sourceElement">Element to be unmerged/disconnected.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.ValidateMonikerAmbiguity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Check to make sure all elements in the model will have unambiguous monikers when serialized.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.MergeRelateDomainClass(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Merge in properties with the attendent side effects on XmlSerialization data
            </summary>
            <param name="sourceElement"></param>
            <param name="elementGroup"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.MergeRelateExplorerBehavior(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Merge ExplorerBehavior into the DslLibrary
            </summary>
            <param name="sourceElement"></param>
            <param name="elementGroup"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.MergeDisconnectExplorerBehavior(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Doing exact the opposite of MergeRelateExplorerBehavior;
            </summary>
            <param name="sourceElement"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.MergeRelateConnector(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Merge in properties with the attendent side effects on XmlSerialization data
            </summary>
            <param name="sourceElement"></param>
            <param name="elementGroup"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.MergeRelateBaseShape(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Merge in properties with the attendent side effects on XmlSerialization data
            </summary>
            <param name="sourceElement"></param>
            <param name="elementGroup"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.AddXmlClassData(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Add XmlClassData to match the given reference type.
            </summary>
            <param name="referenceType"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.OnNamespaceChanged(System.String,System.String)">
            <summary>
            Called when the Namespace of a DslLibrary changes
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.Namespace">
            <summary>
            Gets or sets the value of Namespace domain property.
            Namespace of a DSL library.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.AccessModifier">
            <summary>
            Gets or sets the value of AccessModifier domain property.
            Determines if the access modifier for the class generated from the DSL library
            is public or internal.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.MajorVersion">
            <summary>
            Gets or sets the value of MajorVersion domain property.
            First part of the four part version number.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.MinorVersion">
            <summary>
            Gets or sets the value of MinorVersion domain property.
            Second part of the four part version number.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.Build">
            <summary>
            Gets or sets the value of Build domain property.
            Last part of the four part version number.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.Revision">
            <summary>
            Gets or sets the value of Revision domain property.
            Third part of the four part version number.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.Classes">
            <summary>
            Gets a list of Classes.
            Domain classes defined by the DSL library.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.ReferenceTypes">
            <summary>
            Gets a list of ReferenceTypes.
            Reference types defined by the DSL library.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.Relationships">
            <summary>
            Gets a list of Relationships.
            Domain relationships defined by the DSL library.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.Types">
            <summary>
            Gets a list of Types.
            Domain types defined by the DSL library.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.ConnectionBuilders">
            <summary>
            Gets a list of ConnectionBuilders.
            Connection builders defining the DSL library.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.ExplorerBehavior">
            <summary>
            Gets or sets ExplorerBehavior.
            Explorer behavior defined by the DSL library.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.Connectors">
            <summary>
            Gets a list of Connectors.
            Connectors defined by DSL library.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.DiagramElements">
            <summary>
            Gets a list of DiagramElements.
            Diagram elements defined by the DSL library.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.Shapes">
            <summary>
            Gets a list of Shapes.
            Shapes defined by the DSL library.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.XmlSerializationBehavior">
            <summary>
            Gets or sets XmlSerializationBehavior.
            Xml serialization behavior defined by the DSL library.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.NamespacePropertyHandler">
            <summary>
            Value handler for the DslLibrary.Namespace domain property.
            </summary>
            <summary>
            Handler for namespace changing
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.NamespacePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DslLibrary.Namespace domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.NamespacePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.NamespacePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.NamespacePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DslLibrary.Namespace domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.AccessModifierPropertyHandler">
            <summary>
            Value handler for the DslLibrary.AccessModifier domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.AccessModifierPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DslLibrary.AccessModifier domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.AccessModifierPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.AccessModifierPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase,Microsoft.VisualStudio.Modeling.DslDefinition.TypeAccessModifier)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.AccessModifierPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DslLibrary.AccessModifier domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.MajorVersionPropertyHandler">
            <summary>
            Value handler for the DslLibrary.MajorVersion domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.MajorVersionPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DslLibrary.MajorVersion domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.MajorVersionPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.MajorVersionPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase,System.Int32)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.MajorVersionPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DslLibrary.MajorVersion domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.MinorVersionPropertyHandler">
            <summary>
            Value handler for the DslLibrary.MinorVersion domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.MinorVersionPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DslLibrary.MinorVersion domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.MinorVersionPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.MinorVersionPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase,System.Int32)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.MinorVersionPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DslLibrary.MinorVersion domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.BuildPropertyHandler">
            <summary>
            Value handler for the DslLibrary.Build domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.BuildPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DslLibrary.Build domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.BuildPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.BuildPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase,System.Int32)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.BuildPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DslLibrary.Build domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.RevisionPropertyHandler">
            <summary>
            Value handler for the DslLibrary.Revision domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.RevisionPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DslLibrary.Revision domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.RevisionPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.RevisionPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase,System.Int32)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryBase.RevisionPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DslLibrary.Revision domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship">
            <summary>
            DomainClass DomainRelationship
            Defines a relationship between two domain classes.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass">
            <summary>
            DomainClass DomainClass
            Defines a domain class.
            </summary>
            <summary>
            Partial class on DomainClass to implement IPathHost
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.IPathHost">
            <summary>
            Interface optionally implemented by an embedding parent of a path object to provide 
            path-related environmental data.
            </summary>
            <remarks>
            DomainPath will walk up the embedding hierarchy until it finds this or hits a DslLibrary and gives up.
            This means that it doesn't need to be implemented every place that a path is hosted, but can be in order to improve performance.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.IPathHost.ProvideNamespace(Microsoft.VisualStudio.Modeling.ElementLink)">
            <summary>
            Gives the implementor the opportunity to supply a default namespace for the DomainPath so
            it need not be specified in the concrete syntax.
            </summary>
            <remarks>
            Returning [null] indicates that the host does provide a namespace.
            String.Empty is considered an implementation specifying no namespace.
            </remarks>
            <param name="embeddingLink">
            The relationship link by which the path is connected to its direct parent.
            This parameter allows the host to distinguish between multiple child Paths
            </param>
            <returns>
            The namespace to use for the DomainPath if one is not provided in the conccrete syntax.
            </returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.IPathHost.GetPathStartingPoints">
            <summary>
            Allows the implementor to return a list of DomainClasses (including
            DomainRelationships) from which this path can start.
            </summary>
            <remarks>
            Returning [null] indicates that the host does provide an implementation.
            Returning an empty list indicates that there are no roots.
            </remarks>
            <returns>
            A list of DomainClasses from which the path can start
            </returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.namespaceStorage">
            <summary>
            Storage for Namespace DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.GetNamespaceValue">
            <summary>
            Gets the value of Namespace
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.SetNamespaceValue(System.String)">
            <summary>
            Sets the value of Namespace
            </summary>
            <param name="value"></param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.DomainClassId">
            <summary>
            DomainClass domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.InheritanceModifierDomainPropertyId">
            <summary>
            InheritanceModifier domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.inheritanceModifierPropertyStorage">
            <summary>
            Storage for InheritanceModifier
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.AccessModifierDomainPropertyId">
            <summary>
            AccessModifier domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.accessModifierPropertyStorage">
            <summary>
            Storage for AccessModifier
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.NamespaceDomainPropertyId">
            <summary>
            Namespace domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.HasCustomConstructorDomainPropertyId">
            <summary>
            HasCustomConstructor domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.hasCustomConstructorPropertyStorage">
            <summary>
            Storage for HasCustomConstructor
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.GeneratesDoubleDerivedDomainPropertyId">
            <summary>
            GeneratesDoubleDerived domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.generatesDoubleDerivedPropertyStorage">
            <summary>
            Storage for GeneratesDoubleDerived
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.IsNamespaceTrackingDomainPropertyId">
            <summary>
            IsNamespaceTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.isNamespaceTrackingPropertyStorage">
            <summary>
            Storage for IsNamespaceTracking
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.CanMerge(Microsoft.VisualStudio.Modeling.ProtoElementBase,Microsoft.VisualStudio.Modeling.ElementGroupPrototype)">
            <summary>
            Returns a value indicating whether the source element represented by the
            specified root ProtoElement can be added to this element.
            </summary>
            <param name="rootElement">
            The root ProtoElement representing a source element.  This can be null, 
            in which case the ElementGroupPrototype does not contain an ProtoElements
            and the code should inspect the ElementGroupPrototype context information.
            </param>
            <param name="elementGroupPrototype">The ElementGroupPrototype that contains the root ProtoElement.</param>
            <returns>true if the source element represented by the ProtoElement can be added to this target element.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.MergeRelate(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Called by the Merge process to create a relationship between 
            this target element and the specified source element. 
            Typically, a parent-child relationship is established
            between the target element (the parent) and the source element 
            (the child), but any relationship can be established.
            </summary>
            <param name="sourceElement">The element that is to be related to this model element.</param>
            <param name="elementGroup">The group of source ModelElements that have been rehydrated into the target store.</param>
            <remarks>
            This method is overriden to create the relationship between the target element and the specified source element.
            The base method does nothing.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.MergeDisconnect(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Performs operation opposite to MergeRelate - i.e. disconnects a given
            element from the current one (removes links created by MergeRelate).
            </summary>
            <param name="sourceElement">Element to be unmerged/disconnected.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.GetFullName(System.Boolean)">
            <summary>
            Gets the fully qualified name for this class
            </summary>
            <param name="includeGlobal">whether or not to append 'global::' to the full name</param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.HasMonikerKeyPropertyDefined">
            <summary>
            Return true if any of the properties in this class or a base has IsMonikerKey == true.
            Able to handle cycles in the inheritance hierarchy.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.GetRelativeName(System.String,System.Boolean)">
            <summary>
            Gets the name of the domain class relative to the current namespace. If
            the current namespace is the same as this.Namespace, then we return this.Name. 
            If not, we return this.GetFullName()
            </summary>
            <param name="currentNamespace"></param>
            <param name="includeGlobal">whether or not to prepend 'global::' if a fully qualified name is returned</param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.IsDerivedFrom(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Test if this class is derived from the given class.
            </summary>
            <param name="candidateBase"></param>
            <returns>Whether this class is the same as or derived from the given base class</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.CollectDescendents``1(System.Collections.Generic.List{``0},``0)">
            <summary>
            Internal helper method to collect the descendent classes of the current class.
            </summary>
            <param name="descendants">Collection for holding all the descendents from the startingClass</param>
            <param name="startingClass">indicates where the start traverse clas is</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.GetBaseClassSafely(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the base class unless its the same as the originator. Designer to allow base hierarchy traversal without infinite loop breaks.
            </summary>
            <param name="originatingClass"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.MergeRelateDomainProperty(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Merge in properties with the attendent side effects on XmlSerialization data
            </summary>
            <param name="sourceElement"></param>
            <param name="elementGroup"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.MergeConfigure(Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Configure a newly merged DomainClass
            </summary>
            <param name="elementGroup"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.AddExposeProperty(System.String,System.String,System.String)">
            <summary>
            Add a custom storage domain property to expose some internal property of a shape
            </summary>
            <param name="newPropName">The name of the new property</param>
            <param name="typeNamespace">The namespace of the type that the new property should have</param>
            <param name="typeName">The name of the type that the new property should have</param>
            <remarks>
            This method should only be used for reference types that are in the rhs swimlane
            (i.e. diagram elements and diagram), but there is no single base class for these.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.CalculateNamespace">
            <summary>
            Calculates the value of Namespace
            </summary>
            <returns>The value of Namespace</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.CalculateDescription">
            <summary>
            Calculate the value of Description
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.OnInheritanceModifierChanged(Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceModifier,Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceModifier)">
            <summary>
            Called when InheritanceModifier on a DomainClass changes
            </summary>
            <param name="oldValue"></param>
            <param name="newValue"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.OnNamespaceChanged(System.String,System.String)">
            <summary>
            Called when the Namespace of a DomainClass changes
            </summary>
            <param name="oldValue"></param>
            <param name="newValue"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.OnNameChanged(System.String,System.String)">
            <summary>
            Called when a DomainClass' Name changes
            </summary>
            <param name="oldValue"></param>
            <param name="newValue"></param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.ReservedClassNames">
            <summary>
            The generated code includes classes with these names, so DSL authors mustn't use them.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.ReservedXmlNames">
            <summary>
            These names are used in CDS as XML names, and bust serialization if used
            as XML names in user data. 
            Also, the corresponding names XXXMoniker are disallowed as MonikerNames.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.ValidateReservedNameClash(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Check for clashes with reserved names
            </summary>
            <param name="context"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.IsReservedMonikerName(System.String)">
            <summary>
            Check whether a moniker name is on the reserved list.
            </summary>
            <param name="monikerName">may be null</param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.ValidateDomainClassOnLoad(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Load checks.
            Check that base class is of a compatible type.
            </summary>
            <param name="context"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.ValidateBaseClass(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Check that the base class isn't sealed and has compatible access.
            </summary>
            <param name="context"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.ValidateElementName(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            No more than one property per class may be marked IsElementName.
            </summary>
            <param name="context"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.GetElementDataName(Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementData)">
            <summary>
            Get a non-xml name to identify the XmlElementData.
            </summary>
            <param name="element">DomainProperty != null or DomainRelationship.Source.PropertyName != null</param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.IsMappedInHierarchy">
            <summary>
            Safely traverses the inheritance hierarchy to find any PEL mappings, avoiding 
            cycle traps whether or not these include the start point. Note this may be called from
            validation and tracking properties.
            </summary>
            <returns>true if the DomainClass has or inherits any PEL mappings</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.IsMapped">
            <summary>
            Answer whether this DomainClass is locally mapped to a shape. 
            Does not detect inherited mappings.
            </summary>
            <returns>true if mapped</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.InheritanceModifier">
            <summary>
            Gets or sets the value of InheritanceModifier domain property.
            Determines if the inheritance modifier of the .Net class generated from the
            domain class is none, abstract or sealed.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.AccessModifier">
            <summary>
            Gets or sets the value of AccessModifier domain property.
            Determines if the access modifier for the domain class is public or internal.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.Namespace">
            <summary>
            Gets or sets the value of Namespace domain property.
            Namespace affiliated with this domain class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.HasCustomConstructor">
            <summary>
            Gets or sets the value of HasCustomConstructor domain property.
            If True, indicates that a custom constructor will be provided in code.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.GeneratesDoubleDerived">
            <summary>
            Gets or sets the value of GeneratesDoubleDerived domain property.
            If True, will generate both a base class with all functionality and a partial
            class to support customization through overrides.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.IsNamespaceTracking">
            <summary>
            Gets or sets the value of IsNamespaceTracking domain property.
            If True, the Namespace property tracks other data in the DSL definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.DslLibrary">
            <summary>
            Gets or sets DslLibrary.
            Dsl library defining the reference type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.Properties">
            <summary>
            Gets a list of Properties.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.ElementMergeDirectives">
            <summary>
            Gets a list of ElementMergeDirectives.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.CustomTypeDescriptor">
            <summary>
            Gets or sets CustomTypeDescriptor.
            Definition of the custom type descriptor for the class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.BaseClass">
            <summary>
            Gets or sets BaseClass.
            Base class of this domain class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.SubClasses">
            <summary>
            Gets a list of SubClasses.
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.BaseClass
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.RolesPlayed">
            <summary>
            Gets a list of RolesPlayed.
            Roles played by the class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.ClassData">
            <summary>
            Gets or sets ClassData.
            Xml serialization configuration data for the domain class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.AllDescendants">
            <summary>
            Gets a read-only list of all domain classes directly or indirectly derived form this one.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.AllProperties">
            <summary>
            The set of all DomainProperties both defined on this class and inherited from base classes
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.AllRolesPlayed">
            <summary>
            The set of all DomainRoles both played directly by this class and inherited from base classes
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.IsNamespaceTrackingPropertyHandler">
            <summary>
            Tracking change handler for Namespace
            </summary>
            <summary>
            Value handler for the DomainClass.IsNamespaceTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.IsNamespaceTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainClass.IsNamespaceTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.IsNamespaceTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.IsNamespaceTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.IsNamespaceTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainClass.IsNamespaceTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.InheritanceModifierPropertyHandler">
            <summary>
            Value handler for the DomainClass.InheritanceModifier domain property.
            </summary>
            <summary>
            InheritanceModifier changed handler
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.InheritanceModifierPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainClass.InheritanceModifier domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.InheritanceModifierPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.InheritanceModifierPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceModifier)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.InheritanceModifierPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainClass.InheritanceModifier domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.AccessModifierPropertyHandler">
            <summary>
            Value handler for the DomainClass.AccessModifier domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.AccessModifierPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainClass.AccessModifier domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.AccessModifierPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.AccessModifierPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.TypeAccessModifier)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.AccessModifierPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainClass.AccessModifier domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.NamespacePropertyHandler">
            <summary>
            Value handler for the DomainClass.Namespace domain property.
            </summary>
            <summary>
            Handler for namespace changing
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.NamespacePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainClass.Namespace domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.NamespacePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.NamespacePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.NamespacePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainClass.Namespace domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.HasCustomConstructorPropertyHandler">
            <summary>
            Value handler for the DomainClass.HasCustomConstructor domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.HasCustomConstructorPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainClass.HasCustomConstructor domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.HasCustomConstructorPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.HasCustomConstructorPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.HasCustomConstructorPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainClass.HasCustomConstructor domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.GeneratesDoubleDerivedPropertyHandler">
            <summary>
            Value handler for the DomainClass.GeneratesDoubleDerived domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.GeneratesDoubleDerivedPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainClass.GeneratesDoubleDerived domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.GeneratesDoubleDerivedPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.GeneratesDoubleDerivedPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass.GeneratesDoubleDerivedPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainClass.GeneratesDoubleDerived domain property.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.ValidateDomainRelationshipMultiplicity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Checks that the relationships that have a multiplicity of One or OneMany do actually have a link.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.CalculateName">
            <summary>
            Calculates the value of Name
            </summary>
            <returns>The value of Name</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.DomainClassId">
            <summary>
            DomainRelationship domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.AllowsDuplicatesDomainPropertyId">
            <summary>
            AllowsDuplicates domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.allowsDuplicatesPropertyStorage">
            <summary>
            Storage for AllowsDuplicates
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.IsEmbeddingDomainPropertyId">
            <summary>
            IsEmbedding domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.isEmbeddingPropertyStorage">
            <summary>
            Storage for IsEmbedding
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.IsNameTrackingDomainPropertyId">
            <summary>
            IsNameTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.isNameTrackingPropertyStorage">
            <summary>
            Storage for IsNameTracking
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.FindRoleByName(System.String)">
            <summary>
            Find one of the roles of this relationship given its Name
            </summary>
            <param name="roleName"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.FindRoleByPropertyName(System.String)">
            <summary>
            Find one of the roles of this relationship given its PropertyName
            </summary>
            <param name="propertyName"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.FindByName(Microsoft.VisualStudio.Modeling.Partition,System.String)">
            <summary>
            Find a named relationship in the given partition
            </summary>
            <param name="partition"></param>
            <param name="relFullName"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.OnDeleting">
            <summary>
            OnDeleting override to remove the automatically created ElementMergeDirective and ConnectionBuilder
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.MergeConfigure(Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Configure this relationship if it has been merged into the model
            </summary>
            <param name="elementGroup"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.CalculateNameForDomainRelationship">
            <summary>
            Calculates the value of Name
            </summary>
            <returns>The value of Name</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.OnNameChanged(System.String,System.String)">
            <summary>
            Handler for change of Name of DomainRelationship
            </summary>
            <param name="oldValue"></param>
            <param name="newValue"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.OnNamespaceChanged(System.String,System.String)">
            <summary>
            Handler for change of Namespace of DomainRelationship
            </summary>
            <param name="oldValue"></param>
            <param name="newValue"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.OnInheritanceModifierChanged(Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceModifier,Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceModifier)">
            <summary>
            Handler for InheritanceModifier changed on a DomainRelationship
            </summary>
            <param name="oldValue"></param>
            <param name="newValue"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.ValidateDomainRelationship(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Additional to the validations inherited from DomainClass.
            </summary>
            <param name="context">context object for logging errors/warnings/informationals</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.VerifyUseFullForm(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            If this relationship or its ancestors has a property, the source role of this relationship should be UseFullForm.
            </summary>
            <param name="context"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.VerifyBaseRelationships(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            3420 - roleplayers of a base relationship are compatible 
            </summary>
            <param name="context"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.VerifyRoles(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            private method to verify roles belong to the DomainRelationship
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.VerifyDerivedRoleCompatibility(Microsoft.VisualStudio.Modeling.Validation.ValidationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Discourage the linking of instances of derived class via links of an inappropriately general type. 
            	1. Both roles in the derived relationship should have different role player types from the concrete base
            	2. Assuming (1) is true, then the property names should be the same (only one collection is being modelled)
            In essence the desire is to only support one form of derived relationship where the base relationship is concrete.
            This is for the specific case of constraining the relationship for a derived role player type to reference another
            specific derived role player type. For example in the DSL Designer we have ClassHasBaseClass, a concrete relationship,
            with the derived relationship DiagramHasBaseDiagram. Where one diagram class is derived from another, the link type
            should be DiagramHasBaseDiagram and never ClassHasBaseClass. Similarly for the other derivation of ClassHasBaseClass.
            There is, however, only one such relationship between a "class" and its "base class", so there should only be one
            property on the role players for the opposite role player.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.VerifyAbstractDomainRelWithMultiplicityOneMustHaveOneConcreteChild(Microsoft.VisualStudio.Modeling.Validation.ValidationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Verify case where an abstract relationship with a minimum multiplicity of 1 must have at least one concrete derived relationship
            </summary>
            <param name="context"></param>
            <param name="rel"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.VerifyDerivedRoleMultiplicityOne(Microsoft.VisualStudio.Modeling.Validation.ValidationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,System.Collections.ObjectModel.ReadOnlyCollection{Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole})">
            <summary>
            Verify B, C, D condition above.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.ReportInvalidUpperBoundOnDerivedRelationshp(Microsoft.VisualStudio.Modeling.Validation.ValidationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Method to report the violation listed above (see table above).
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.VerifyAbstractBaseAndSingleDerivation(Microsoft.VisualStudio.Modeling.Validation.ValidationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            helper method to validate Abstract base + single derived relationship
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.FindRolesInDescendentRelationshipPlayedBySameDomainClass(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            For the given base role, this method will find all the descendent roles (via descendent DomainRelationship)
            whose role player is the same as baseRole.RolePlayer
            </summary>
            <param name="baseRole"></param>
            <param name="derivedRole"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.VerifyLinkConnectDirective(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            private method to verify against the LinkConnectDirective. If the rel is refereed by any LinkConnectDirective, it can't be abstract
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.VerifyIsEmbeddingFlag(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Check IsEmbedding conforms to base; check multiplicity and target type.
            </summary>
            <param name="context"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.VerifyAllowDuplicatesFlag(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            private method to verify against the AllowDuplicates flag. We have constraint when the flag is true
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.IsMapped">
            <summary>
            Answer whether this relationship is locally mapped to a connector. 
            Does not detect inherited mappings.
            </summary>
            <returns>true if mapped</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.ProxyIsNameTracking">
            <summary>
            Supply a storage-backed implementation of IsNameTracking
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.AllowsDuplicates">
            <summary>
            Gets or sets the value of AllowsDuplicates domain property.
            If True, permits duplicate links of this domain relationship to be created
            between the same two elements.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.IsEmbedding">
            <summary>
            Gets or sets the value of IsEmbedding domain property.
            Indicates whether the relationship is an embedding or reference relationship.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.IsNameTracking">
            <summary>
            Gets or sets the value of IsNameTracking domain property.
            If True, the Name property tracks other data in the DSL definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.Roles">
            <summary>
            Gets a list of Roles.
            Roles of the relationship. There should be exactly two.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.Target">
            <summary>
            Gets or sets Target.
            Target role of the relationship.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.Source">
            <summary>
            Gets or sets Source.
            Source role of the relationship.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.BaseClass">
            <summary>
            Gets or sets BaseClass.
            The base relationship of this domain relationship.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.SubClasses">
            <summary>
            Gets a list of SubClasses.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.XmlRelationshipData">
            <summary>
            Gets or sets XmlRelationshipData.
            Xml serialization configuration data for the domain relationship.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.AllDescendantRelationships">
            <summary>
            Gets a read-only list of all domain relationships directly or indirectly derived form this one.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.IsNameTrackingPropertyHandler">
            <summary>
            Tracking change handler for Name
            </summary>
            <summary>
            Value handler for the DomainRelationship.IsNameTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.IsNameTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainRelationship.IsNameTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.IsNameTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.IsNameTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.IsNameTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainRelationship.IsNameTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.AllowsDuplicatesPropertyHandler">
            <summary>
            Value handler for the DomainRelationship.AllowsDuplicates domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.AllowsDuplicatesPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainRelationship.AllowsDuplicates domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.AllowsDuplicatesPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.AllowsDuplicatesPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.AllowsDuplicatesPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainRelationship.AllowsDuplicates domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.IsEmbeddingPropertyHandler">
            <summary>
            Value handler for the DomainRelationship.IsEmbedding domain property.
            </summary>
            <summary>
            Handle IsEmbedding change
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.IsEmbeddingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainRelationship.IsEmbedding domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.IsEmbeddingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.IsEmbeddingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship.IsEmbeddingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainRelationship.IsEmbedding domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole">
            <summary>
            DomainClass DomainRole
            Defines a role of a domain relationship. A relationship has exactly two roles.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.ValidateDomainRoleMultiplicity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Checks that the relationships that have a multiplicity of One or OneMany do actually have a link.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.propertyNameStorage">
            <summary>
            Storage for PropertyName DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.GetPropertyNameValue">
            <summary>
            Gets the value of PropertyName
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.SetPropertyNameValue(System.String)">
            <summary>
            Sets the value of PropertyName
            </summary>
            <param name="value"></param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.multiplicityStorage">
            <summary>
            Storage for Multiplicity DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.GetMultiplicityValue">
            <summary>
            Gets the value of Multiplicity
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.SetMultiplicityValue(Microsoft.VisualStudio.Modeling.DslDefinition.Multiplicity)">
            <summary>
            Sets the value of Multiplicity
            </summary>
            <param name="value"></param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.propagatesDeleteStorage">
            <summary>
            Storage for PropagatesDelete DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.GetPropagatesDeleteValue">
            <summary>
            Gets the value of PropagatesDelete
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.SetPropagatesDeleteValue(System.Boolean)">
            <summary>
            Sets the value of PropagatesDelete
            </summary>
            <param name="value"></param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.propagatesCopyStorage">
            <summary>
            Storage for PropagatesCopy DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.GetPropagatesCopyValue">
            <summary>
            Gets the value of PropagatesCopy
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.SetPropagatesCopyValue(System.Boolean)">
            <summary>
            Sets the value of PropagatesCopy
            </summary>
            <param name="value"></param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.propertyDisplayNameStorage">
            <summary>
            Storage for PropertyDisplayName DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.GetPropertyDisplayNameValue">
            <summary>
            Gets the value of PropertyDisplayName
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.SetPropertyDisplayNameValue(System.String)">
            <summary>
            Sets the value of PropertyDisplayName
            </summary>
            <param name="value"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.CalculateName">
            <summary>
            Calculates the value of Name
            </summary>
            <returns>The value of Name</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.DomainClassId">
            <summary>
            DomainRole domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropertyNameDomainPropertyId">
            <summary>
            PropertyName domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyNameTrackingDomainPropertyId">
            <summary>
            IsPropertyNameTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.isPropertyNameTrackingPropertyStorage">
            <summary>
            Storage for IsPropertyNameTracking
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.MultiplicityDomainPropertyId">
            <summary>
            Multiplicity domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropagatesDeleteDomainPropertyId">
            <summary>
            PropagatesDelete domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyGeneratorDomainPropertyId">
            <summary>
            IsPropertyGenerator domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.isPropertyGeneratorPropertyStorage">
            <summary>
            Storage for IsPropertyGenerator
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropagatesCopyDomainPropertyId">
            <summary>
            PropagatesCopy domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.CategoryDomainPropertyId">
            <summary>
            Category domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.categoryPropertyStorage">
            <summary>
            Storage for Category
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropertyGetterAccessModifierDomainPropertyId">
            <summary>
            PropertyGetterAccessModifier domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.propertyGetterAccessModifierPropertyStorage">
            <summary>
            Storage for PropertyGetterAccessModifier
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropertySetterAccessModifierDomainPropertyId">
            <summary>
            PropertySetterAccessModifier domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.propertySetterAccessModifierPropertyStorage">
            <summary>
            Storage for PropertySetterAccessModifier
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyBrowsableDomainPropertyId">
            <summary>
            IsPropertyBrowsable domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.isPropertyBrowsablePropertyStorage">
            <summary>
            Storage for IsPropertyBrowsable
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyUIReadOnlyDomainPropertyId">
            <summary>
            IsPropertyUIReadOnly domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.isPropertyUIReadOnlyPropertyStorage">
            <summary>
            Storage for IsPropertyUIReadOnly
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsNameTrackingDomainPropertyId">
            <summary>
            IsNameTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.isNameTrackingPropertyStorage">
            <summary>
            Storage for IsNameTracking
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsMultiplicityTrackingDomainPropertyId">
            <summary>
            IsMultiplicityTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.isMultiplicityTrackingPropertyStorage">
            <summary>
            Storage for IsMultiplicityTracking
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropagatesDeleteTrackingDomainPropertyId">
            <summary>
            IsPropagatesDeleteTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.isPropagatesDeleteTrackingPropertyStorage">
            <summary>
            Storage for IsPropagatesDeleteTracking
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropagatesCopyTrackingDomainPropertyId">
            <summary>
            IsPropagatesCopyTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.isPropagatesCopyTrackingPropertyStorage">
            <summary>
            Storage for IsPropagatesCopyTracking
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropertyDisplayNameDomainPropertyId">
            <summary>
            PropertyDisplayName domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyDisplayNameTrackingDomainPropertyId">
            <summary>
            IsPropertyDisplayNameTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.isPropertyDisplayNameTrackingPropertyStorage">
            <summary>
            Storage for IsPropertyDisplayNameTracking
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.CalculatePropertyName">
            <summary>
            Calculates the value of PropertyName
            </summary>
            <returns>The value of PropertyName</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.CalculateMultiplicity">
            <summary>
            Calculates the value of Multiplicity
            </summary>
            <returns>The value of Multiplicity</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.CalculatePropagatesDelete">
            <summary>
            Calculates the value of PropagatesDelete
            </summary>
            <returns>The value of PropagatesDelete</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.CalculatePropagatesCopy">
            <summary>
            Calculates the value of PropagatesCopy
            </summary>
            <returns>The value of PropagatesCopy</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.CalculatePropertyDisplayName">
            <summary>
            Calculates the value of PropertyDisplayName
            </summary>
            <returns>The value of PropertyDisplayName</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.CalculateDescription">
            <summary>
            Calculate the value of Description
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.CalculateNameForDomainRole">
            <summary>
            Calculates the value of Name
            </summary>
            <returns>The value of Name</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.OnNameChanged(System.String,System.String)">
            <summary>
            Handler for change of Name of DomainRole
            </summary>
            <param name="oldValue"></param>
            <param name="newValue"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.ValidateName(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Check the Role Name and Property Name are valid.
            </summary>
            <param name="context"></param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.ProxyIsNameTracking">
            <summary>
            Supply a storage-backed implementation of IsNameTracking
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropertyName">
            <summary>
            Gets or sets the value of PropertyName domain property.
            Name of the generated property.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyNameTracking">
            <summary>
            Gets or sets the value of IsPropertyNameTracking domain property.
            If True, the PropertyName property tracks other data in the DSL definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.Multiplicity">
            <summary>
            Gets or sets the value of Multiplicity domain property.
            Constrains the number of links for which an element may play this role. If
            multiplicity is 0..* or 1..*, the generated property represents a collection.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropagatesDelete">
            <summary>
            Gets or sets the value of PropagatesDelete domain property.
            If True, an element playing this role in a link is deleted when the link is
            deleted.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyGenerator">
            <summary>
            Gets or sets the value of IsPropertyGenerator domain property.
            If True, a property on the role player of this role is generated.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropagatesCopy">
            <summary>
            Gets or sets the value of PropagatesCopy domain property.
            If True, an element playing this role in a link is copied when the link is
            copied.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.Category">
            <summary>
            Gets or sets the value of Category domain property.
            Category under which the generated property appears in the properties window.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropertyGetterAccessModifier">
            <summary>
            Gets or sets the value of PropertyGetterAccessModifier domain property.
            Determines the access modifier for the getter of the generated property.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropertySetterAccessModifier">
            <summary>
            Gets or sets the value of PropertySetterAccessModifier domain property.
            Determines the access modifier for the setter of the generated property.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyBrowsable">
            <summary>
            Gets or sets the value of IsPropertyBrowsable domain property.
            If True, the generated property is marked as browsable in its corresponding
            property descriptor. As a result, it can be browsed through the properties
            window.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyUIReadOnly">
            <summary>
            Gets or sets the value of IsPropertyUIReadOnly domain property.
            If True, the generated property can not be edited through the UI when browsed.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsNameTracking">
            <summary>
            Gets or sets the value of IsNameTracking domain property.
            If True, the Name property tracks other data in the DSL definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsMultiplicityTracking">
            <summary>
            Gets or sets the value of IsMultiplicityTracking domain property.
            If True, the Multiplicity property tracks other data in the DSL definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropagatesDeleteTracking">
            <summary>
            Gets or sets the value of IsPropagatesDeleteTracking domain property.
            If True, the PropagatesDelete property tracks other data in the DSL definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropagatesCopyTracking">
            <summary>
            Gets or sets the value of IsPropagatesCopyTracking domain property.
            If True, the PropagatesCopy property tracks other data in the DSL definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropertyDisplayName">
            <summary>
            Gets or sets the value of PropertyDisplayName domain property.
            The name that will be displayed in the generated designer for the generated
            property.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyDisplayNameTracking">
            <summary>
            Gets or sets the value of IsPropertyDisplayNameTracking domain property.
            If True, the PropertyDisplayName property tracks other data in the DSL
            definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.Relationship">
            <summary>
            Gets or sets Relationship.
            Relationship defining the role.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.RolePlayer">
            <summary>
            Gets or sets RolePlayer.
            Class of element playing this role in the relationship.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.CollectionType">
            <summary>
            Gets or sets CollectionType.
            External type used as the collection type for the generated property from this
            role.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.Opposite">
            <summary>
            The opposite role
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.BaseRole">
            <summary>
            Gets the base role for this role
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsMany">
            <summary>
            Returns true if the multiplicity of this role is ZeroMany or OneMany.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsEmbedding">
            <summary>
            Checks if this role is the source role, and the relationship is an embedding relationship
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsEmbedded">
            <summary>
            Checks if this role is the target role, and the relationship is an embedding relationship
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsSource">
            <summary>
            Checks if this role is the source role
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyNameTrackingPropertyHandler">
            <summary>
            Tracking change handler for PropertyName
            </summary>
            <summary>
            Value handler for the DomainRole.IsPropertyNameTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyNameTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainRole.IsPropertyNameTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyNameTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyNameTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyNameTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainRole.IsPropertyNameTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsMultiplicityTrackingPropertyHandler">
            <summary>
            Tracking change handler for Multiplicity
            </summary>
            <summary>
            Value handler for the DomainRole.IsMultiplicityTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsMultiplicityTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainRole.IsMultiplicityTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsMultiplicityTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsMultiplicityTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsMultiplicityTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainRole.IsMultiplicityTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropagatesDeleteTrackingPropertyHandler">
            <summary>
            Tracking change handler for PropagatesDelete
            </summary>
            <summary>
            Value handler for the DomainRole.IsPropagatesDeleteTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropagatesDeleteTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainRole.IsPropagatesDeleteTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropagatesDeleteTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropagatesDeleteTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropagatesDeleteTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainRole.IsPropagatesDeleteTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropagatesCopyTrackingPropertyHandler">
            <summary>
            Tracking change handler for PropagatesCopy
            </summary>
            <summary>
            Value handler for the DomainRole.IsPropagatesCopyTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropagatesCopyTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainRole.IsPropagatesCopyTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropagatesCopyTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropagatesCopyTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropagatesCopyTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainRole.IsPropagatesCopyTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyDisplayNameTrackingPropertyHandler">
            <summary>
            Tracking change handler for PropertyDisplayName
            </summary>
            <summary>
            Value handler for the DomainRole.IsPropertyDisplayNameTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyDisplayNameTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainRole.IsPropertyDisplayNameTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyDisplayNameTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyDisplayNameTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyDisplayNameTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainRole.IsPropertyDisplayNameTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsNameTrackingPropertyHandler">
            <summary>
            Tracking change handler for Name
            </summary>
            <summary>
            Value handler for the DomainRole.IsNameTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsNameTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainRole.IsNameTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsNameTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsNameTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsNameTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainRole.IsNameTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropertyNamePropertyHandler">
            <summary>
            Value handler for the DomainRole.PropertyName domain property.
            </summary>
            <summary>
            
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropertyNamePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainRole.PropertyName domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropertyNamePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropertyNamePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropertyNamePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainRole.PropertyName domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.MultiplicityPropertyHandler">
            <summary>
            Value handler for the DomainRole.Multiplicity domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.MultiplicityPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainRole.Multiplicity domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.MultiplicityPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.MultiplicityPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,Microsoft.VisualStudio.Modeling.DslDefinition.Multiplicity)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.MultiplicityPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainRole.Multiplicity domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropagatesDeletePropertyHandler">
            <summary>
            Value handler for the DomainRole.PropagatesDelete domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropagatesDeletePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainRole.PropagatesDelete domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropagatesDeletePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropagatesDeletePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropagatesDeletePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainRole.PropagatesDelete domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyGeneratorPropertyHandler">
            <summary>
            Value handler for the DomainRole.IsPropertyGenerator domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyGeneratorPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainRole.IsPropertyGenerator domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyGeneratorPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyGeneratorPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyGeneratorPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainRole.IsPropertyGenerator domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropagatesCopyPropertyHandler">
            <summary>
            Value handler for the DomainRole.PropagatesCopy domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropagatesCopyPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainRole.PropagatesCopy domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropagatesCopyPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropagatesCopyPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropagatesCopyPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainRole.PropagatesCopy domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.CategoryPropertyHandler">
            <summary>
            Value handler for the DomainRole.Category domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.CategoryPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainRole.Category domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.CategoryPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.CategoryPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.CategoryPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainRole.Category domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropertyGetterAccessModifierPropertyHandler">
            <summary>
            Value handler for the DomainRole.PropertyGetterAccessModifier domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropertyGetterAccessModifierPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainRole.PropertyGetterAccessModifier domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropertyGetterAccessModifierPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropertyGetterAccessModifierPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,Microsoft.VisualStudio.Modeling.DslDefinition.AccessModifier)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropertyGetterAccessModifierPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainRole.PropertyGetterAccessModifier domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropertySetterAccessModifierPropertyHandler">
            <summary>
            Value handler for the DomainRole.PropertySetterAccessModifier domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropertySetterAccessModifierPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainRole.PropertySetterAccessModifier domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropertySetterAccessModifierPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropertySetterAccessModifierPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,Microsoft.VisualStudio.Modeling.DslDefinition.AccessModifier)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropertySetterAccessModifierPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainRole.PropertySetterAccessModifier domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyBrowsablePropertyHandler">
            <summary>
            Value handler for the DomainRole.IsPropertyBrowsable domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyBrowsablePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainRole.IsPropertyBrowsable domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyBrowsablePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyBrowsablePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyBrowsablePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainRole.IsPropertyBrowsable domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyUIReadOnlyPropertyHandler">
            <summary>
            Value handler for the DomainRole.IsPropertyUIReadOnly domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyUIReadOnlyPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainRole.IsPropertyUIReadOnly domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyUIReadOnlyPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyUIReadOnlyPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.IsPropertyUIReadOnlyPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainRole.IsPropertyUIReadOnly domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropertyDisplayNamePropertyHandler">
            <summary>
            Value handler for the DomainRole.PropertyDisplayName domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropertyDisplayNamePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainRole.PropertyDisplayName domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropertyDisplayNamePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropertyDisplayNamePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole.PropertyDisplayNamePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainRole.PropertyDisplayName domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective">
            <summary>
            DomainClass LinkConnectDirective
            Defines how links of a specific relationship get created by a connection
            builder.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective.ValidateLinkConnectDirectiveMultiplicity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Checks that the relationships that have a multiplicity of One or OneMany do actually have a link.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective.DomainClassId">
            <summary>
            LinkConnectDirective domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective.UsesCustomConnectDomainPropertyId">
            <summary>
            UsesCustomConnect domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective.usesCustomConnectPropertyStorage">
            <summary>
            Storage for UsesCustomConnect
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective.UsesCustomConnect">
            <summary>
            Gets or sets the value of UsesCustomConnect domain property.
            If True, the connection logic is defined by custom code.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective.ConnectionBuilder">
            <summary>
            Gets or sets ConnectionBuilder.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective.TargetDirectives">
            <summary>
            Gets a list of TargetDirectives.
            Role directives specifying how a an element is connected to the target of a
            link.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective.SourceDirectives">
            <summary>
            Gets a list of SourceDirectives.
            Role directives specifying how a an element is connected to the source of a
            link.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective.DomainRelationship">
            <summary>
            Gets or sets DomainRelationship.
            Relationship for which the directive specifies link creation.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective.UsesCustomConnectPropertyHandler">
            <summary>
            Value handler for the LinkConnectDirective.UsesCustomConnect domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective.UsesCustomConnectPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the LinkConnectDirective.UsesCustomConnect domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective.UsesCustomConnectPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective.UsesCustomConnectPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective.UsesCustomConnectPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the LinkConnectDirective.UsesCustomConnect domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective">
            <summary>
            DomainClass RolePlayerConnectDirective
            Directive for connecting a role player to a link. Part of a link connect
            directive.
            </summary>
            <summary>
            Partial class to implement IPathHost
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective.ValidateRolePlayerConnectDirectiveMultiplicity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Checks that the relationships that have a multiplicity of One or OneMany do actually have a link.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective.DomainClassId">
            <summary>
            RolePlayerConnectDirective domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective.UsesRoleSpecificCustomAcceptDomainPropertyId">
            <summary>
            UsesRoleSpecificCustomAccept domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective.usesRoleSpecificCustomAcceptPropertyStorage">
            <summary>
            Storage for UsesRoleSpecificCustomAccept
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective.UsesRoleSpecificCustomConnectDomainPropertyId">
            <summary>
            UsesRoleSpecificCustomConnect domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective.usesRoleSpecificCustomConnectPropertyStorage">
            <summary>
            Storage for UsesRoleSpecificCustomConnect
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective.UsesRoleSpecificCustomAccept">
            <summary>
            Gets or sets the value of UsesRoleSpecificCustomAccept domain property.
            If True, acceptance for connection is defined in custom code.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective.UsesRoleSpecificCustomConnect">
            <summary>
            Gets or sets the value of UsesRoleSpecificCustomConnect domain property.
            If True, connection is performed by custom code.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective.PathToRolePlayer">
            <summary>
            Gets or sets PathToRolePlayer.
            Path to the role player being connected.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective.TargetOf">
            <summary>
            Gets or sets TargetOf.
            Link connect directive this is a target directive of.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective.SourceOf">
            <summary>
            Gets or sets SourceOf.
            Link connect directive this is a source directive of.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective.AcceptingClass">
            <summary>
            Gets or sets AcceptingClass.
            Role players of this class are accepted for connection.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective.UsesRoleSpecificCustomAcceptPropertyHandler">
            <summary>
            Value handler for the RolePlayerConnectDirective.UsesRoleSpecificCustomAccept domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective.UsesRoleSpecificCustomAcceptPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the RolePlayerConnectDirective.UsesRoleSpecificCustomAccept domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective.UsesRoleSpecificCustomAcceptPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective.UsesRoleSpecificCustomAcceptPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective.UsesRoleSpecificCustomAcceptPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the RolePlayerConnectDirective.UsesRoleSpecificCustomAccept domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective.UsesRoleSpecificCustomConnectPropertyHandler">
            <summary>
            Value handler for the RolePlayerConnectDirective.UsesRoleSpecificCustomConnect domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective.UsesRoleSpecificCustomConnectPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the RolePlayerConnectDirective.UsesRoleSpecificCustomConnect domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective.UsesRoleSpecificCustomConnectPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective.UsesRoleSpecificCustomConnectPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective.UsesRoleSpecificCustomConnectPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the RolePlayerConnectDirective.UsesRoleSpecificCustomConnect domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective">
            <summary>
            DomainClass ElementMergeDirective
            Defines the behavior for merging elements of a designated index class into an
            existing element structure.
            </summary>
            <summary>
            Partial class to implement IPathHost
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.ValidateElementMergeDirectiveMultiplicity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Checks that the relationships that have a multiplicity of One or OneMany do actually have a link.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.DomainClassId">
            <summary>
            ElementMergeDirective domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.UsesCustomAcceptDomainPropertyId">
            <summary>
            UsesCustomAccept domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.usesCustomAcceptPropertyStorage">
            <summary>
            Storage for UsesCustomAccept
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.UsesCustomMergeDomainPropertyId">
            <summary>
            UsesCustomMerge domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.usesCustomMergePropertyStorage">
            <summary>
            Storage for UsesCustomMerge
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.AppliesToSubclassesDomainPropertyId">
            <summary>
            AppliesToSubclasses domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.appliesToSubclassesPropertyStorage">
            <summary>
            Storage for AppliesToSubclasses
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.UsesCustomAccept">
            <summary>
            Gets or sets the value of UsesCustomAccept domain property.
            If True, custom code defines whether or not an element of the indexing class can
            be accepted for merge.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.UsesCustomMerge">
            <summary>
            Gets or sets the value of UsesCustomMerge domain property.
            If True, custom code defines how an element of the indexing class is merged.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.AppliesToSubclasses">
            <summary>
            Gets or sets the value of AppliesToSubclasses domain property.
            If False, the merge directive governs merging of elements of the indexing class
            only, not its subclasses.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.ForwardingPath">
            <summary>
            Gets or sets ForwardingPath.
            Path to element to which merge request is forwarded.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.LinkCreationPaths">
            <summary>
            Gets a list of LinkCreationPaths.
            Link creation paths defined by the merge directive.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.DirectiveOf">
            <summary>
            Gets or sets DirectiveOf.
            Class for which this is a merge directive.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.Index">
            <summary>
            Gets or sets Index.
            Class of element whose merging behavior the directive defines.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.UsesCustomAcceptPropertyHandler">
            <summary>
            Value handler for the ElementMergeDirective.UsesCustomAccept domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.UsesCustomAcceptPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the ElementMergeDirective.UsesCustomAccept domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.UsesCustomAcceptPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.UsesCustomAcceptPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.UsesCustomAcceptPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the ElementMergeDirective.UsesCustomAccept domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.UsesCustomMergePropertyHandler">
            <summary>
            Value handler for the ElementMergeDirective.UsesCustomMerge domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.UsesCustomMergePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the ElementMergeDirective.UsesCustomMerge domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.UsesCustomMergePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.UsesCustomMergePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.UsesCustomMergePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the ElementMergeDirective.UsesCustomMerge domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.AppliesToSubclassesPropertyHandler">
            <summary>
            Value handler for the ElementMergeDirective.AppliesToSubclasses domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.AppliesToSubclassesPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the ElementMergeDirective.AppliesToSubclasses domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.AppliesToSubclassesPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.AppliesToSubclassesPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective.AppliesToSubclassesPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the ElementMergeDirective.AppliesToSubclasses domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment">
            <summary>
            DomainClass PathSegment
            Segment of a domain path.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment.ValidatePathSegmentMultiplicity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Checks that the relationships that have a multiplicity of One or OneMany do actually have a link.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment.DomainClassId">
            <summary>
            PathSegment domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment.InterpretationDomainPropertyId">
            <summary>
            Interpretation domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment.interpretationPropertyStorage">
            <summary>
            Storage for Interpretation
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentInterpretation)">
            <summary>
            Construct a segment with a specified role an interpretation
            </summary>
            <param name="store"></param>
            <param name="role"></param>
            <param name="interpretation"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentInterpretation)">
            <summary>
            Construct a segment with a specified role an interpretation
            </summary>
            <param name="partition"></param>
            <param name="role"></param>
            <param name="interpretation"></param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment.Interpretation">
            <summary>
            Gets or sets the value of Interpretation domain property.
            If Elements, the segment navigates to elements playing the designated role for
            the given links; if Links, the segment navigates to the links in which the given
            elements play the designated role.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment.Path">
            <summary>
            Gets or sets Path.
            Path defining the segment.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment.Role">
            <summary>
            Gets or sets Role.
            Role referenced by the segment.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment.InterpretationPropertyHandler">
            <summary>
            Value handler for the PathSegment.Interpretation domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment.InterpretationPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the PathSegment.Interpretation domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment.InterpretationPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment.InterpretationPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment,Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentInterpretation)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment.InterpretationPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the PathSegment.Interpretation domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Editor">
            <summary>
            DomainClass Editor
            Definition of an editor, which may be a designer or custom editor.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.ValidateEditorMultiplicity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Checks that the relationships that have a multiplicity of One or OneMany do actually have a link.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.DomainClassId">
            <summary>
            Editor domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.FileExtensionDomainPropertyId">
            <summary>
            FileExtension domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.fileExtensionPropertyStorage">
            <summary>
            Storage for FileExtension
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.IconDomainPropertyId">
            <summary>
            Icon domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.iconPropertyStorage">
            <summary>
            Storage for Icon
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.EditorGuidDomainPropertyId">
            <summary>
            EditorGuid domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.editorGuidPropertyStorage">
            <summary>
            Storage for EditorGuid
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.CanMerge(Microsoft.VisualStudio.Modeling.ProtoElementBase,Microsoft.VisualStudio.Modeling.ElementGroupPrototype)">
            <summary>
            Returns a value indicating whether the source element represented by the
            specified root ProtoElement can be added to this element.
            </summary>
            <param name="rootElement">
            The root ProtoElement representing a source element.  This can be null, 
            in which case the ElementGroupPrototype does not contain an ProtoElements
            and the code should inspect the ElementGroupPrototype context information.
            </param>
            <param name="elementGroupPrototype">The ElementGroupPrototype that contains the root ProtoElement.</param>
            <returns>true if the source element represented by the ProtoElement can be added to this target element.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.MergeRelate(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Called by the Merge process to create a relationship between 
            this target element and the specified source element. 
            Typically, a parent-child relationship is established
            between the target element (the parent) and the source element 
            (the child), but any relationship can be established.
            </summary>
            <param name="sourceElement">The element that is to be related to this model element.</param>
            <param name="elementGroup">The group of source ModelElements that have been rehydrated into the target store.</param>
            <remarks>
            This method is overriden to create the relationship between the target element and the specified source element.
            The base method does nothing.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.MergeDisconnect(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Performs operation opposite to MergeRelate - i.e. disconnects a given
            element from the current one (removes links created by MergeRelate).
            </summary>
            <param name="sourceElement">Element to be unmerged/disconnected.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.MergeConfigure(Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Configure an editor after it has been merged in to a Dsl.
            </summary>
            <param name="elementGroup"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.ValidateEditorSerializationBehaviorOnLoad(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Validate DslEditor - may not be required after V1
            </summary>
            <param name="context"></param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.FileExtension">
            <summary>
            Gets or sets the value of FileExtension domain property.
            File extension registered for the editor.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.Icon">
            <summary>
            Gets or sets the value of Icon domain property.
            Icon associated with the editor.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.EditorGuid">
            <summary>
            Gets or sets the value of EditorGuid domain property.
            Guid for the editor.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.Dsl">
            <summary>
            Gets or sets Dsl.
            Dsl defining the editor.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.Validation">
            <summary>
            Gets or sets Validation.
            Validation behavior defined by the editor.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.XmlSerializationDefinition">
            <summary>
            Gets or sets XmlSerializationDefinition.
            Xml serialization behavior wrapper defined by the editor.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.ToolboxTabs">
            <summary>
            Gets a list of ToolboxTabs.
            Toolbox tabs defined by the editor.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.RootClass">
            <summary>
            Gets or sets RootClass.
            Root class defining the element represented by the top node of the explorer and
            at the root of the xml document persisting a model.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.FileExtensionPropertyHandler">
            <summary>
            Value handler for the Editor.FileExtension domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.FileExtensionPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Editor.FileExtension domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.FileExtensionPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Editor)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.FileExtensionPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Editor,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.FileExtensionPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Editor.FileExtension domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.IconPropertyHandler">
            <summary>
            Value handler for the Editor.Icon domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.IconPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Editor.Icon domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.IconPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Editor)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.IconPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Editor,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.IconPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Editor.Icon domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.EditorGuidPropertyHandler">
            <summary>
            Value handler for the Editor.EditorGuid domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.EditorGuidPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Editor.EditorGuid domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.EditorGuidPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Editor)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.EditorGuidPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Editor,System.Guid)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.EditorGuidPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Editor.EditorGuid domain property.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.EmbedCheck.VerifyCorrectEmbedding(Microsoft.VisualStudio.Modeling.Validation.ValidationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Postcondition: singleEmbeddings.ContainsKey(domainClass). 
            If domainClass is the target, directly or by inheritance, of any embedding role with a multiplicity of
            one, then singleEmbeddings[domainClass] == that role; otherwise, null.
            </summary>
            <param name="context"></param>
            <param name="domainClass"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Editor.EmbedCheck.IsInheritedRole(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            True iff baseRole.Relationship is a transitive base relationship of subRole.Relationship
            </summary>
            <param name="subRole"></param>
            <param name="baseRole"></param>
            <returns></returns>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ElementTool">
            <summary>
            DomainClass ElementTool
            Defines a tool for creating elements.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Tool">
            <summary>
            DomainClass Tool
            Description for Microsoft.VisualStudio.Modeling.DslDefinition.Tool
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.captionStorage">
            <summary>
            Storage for Caption DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.GetCaptionValue">
            <summary>
            Gets the value of Caption
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.SetCaptionValue(System.String)">
            <summary>
            Sets the value of Caption
            </summary>
            <param name="value"></param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.tooltipStorage">
            <summary>
            Storage for Tooltip DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.GetTooltipValue">
            <summary>
            Gets the value of Tooltip
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.SetTooltipValue(System.String)">
            <summary>
            Sets the value of Tooltip
            </summary>
            <param name="value"></param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.helpKeywordStorage">
            <summary>
            Storage for HelpKeyword DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.GetHelpKeywordValue">
            <summary>
            Gets the value of HelpKeyword
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.SetHelpKeywordValue(System.String)">
            <summary>
            Sets the value of HelpKeyword
            </summary>
            <param name="value"></param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.DomainClassId">
            <summary>
            Tool domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.NameDomainPropertyId">
            <summary>
            Name domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.namePropertyStorage">
            <summary>
            Storage for Name
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.ToolboxIconDomainPropertyId">
            <summary>
            ToolboxIcon domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.toolboxIconPropertyStorage">
            <summary>
            Storage for ToolboxIcon
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.CaptionDomainPropertyId">
            <summary>
            Caption domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.TooltipDomainPropertyId">
            <summary>
            Tooltip domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.HelpKeywordDomainPropertyId">
            <summary>
            HelpKeyword domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.IsCaptionTrackingDomainPropertyId">
            <summary>
            IsCaptionTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.isCaptionTrackingPropertyStorage">
            <summary>
            Storage for IsCaptionTracking
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.IsTooltipTrackingDomainPropertyId">
            <summary>
            IsTooltipTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.isTooltipTrackingPropertyStorage">
            <summary>
            Storage for IsTooltipTracking
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.IsHelpKeywordTrackingDomainPropertyId">
            <summary>
            IsHelpKeywordTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.isHelpKeywordTrackingPropertyStorage">
            <summary>
            Storage for IsHelpKeywordTracking
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.CalculateCaption">
            <summary>
            Calculates the value of Caption
            </summary>
            <returns>The value of Caption</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.CalculateTooltip">
            <summary>
            Calculates the value of Tooltip
            </summary>
            <returns>The value of Tooltip</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.CalculateHelpKeyword">
            <summary>
            Calculates the value of HelpKeyword
            </summary>
            <returns>The value of HelpKeyword</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.Name">
            <summary>
            Gets or sets the value of Name domain property.
            Name of the tool, used for reference.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.ToolboxIcon">
            <summary>
            Gets or sets the value of ToolboxIcon domain property.
            Relative file path of icon displayed in the toolbox for this tool.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.Caption">
            <summary>
            Gets or sets the value of Caption domain property.
            Caption for the tool as displayed in the UI.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.Tooltip">
            <summary>
            Gets or sets the value of Tooltip domain property.
            Text used for the tooltip.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.HelpKeyword">
            <summary>
            Gets or sets the value of HelpKeyword domain property.
            Optional keyword used to index F1 help for the tool.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.IsCaptionTracking">
            <summary>
            Gets or sets the value of IsCaptionTracking domain property.
            If True, the Caption property tracks other data in the DSL definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.IsTooltipTracking">
            <summary>
            Gets or sets the value of IsTooltipTracking domain property.
            If True, the Tooltip property tracks other data in the DSL definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.IsHelpKeywordTracking">
            <summary>
            Gets or sets the value of IsHelpKeywordTracking domain property.
            If True, the HelpKeyword property tracks other data in the DSL definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.ToolboxTab">
            <summary>
            Gets or sets ToolboxTab.
            Toolbox tab defining the tool.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.IsCaptionTrackingPropertyHandler">
            <summary>
            Tracking change handler for Caption
            </summary>
            <summary>
            Value handler for the Tool.IsCaptionTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.IsCaptionTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Tool.IsCaptionTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.IsCaptionTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Tool)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.IsCaptionTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Tool,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.IsCaptionTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Tool.IsCaptionTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.IsTooltipTrackingPropertyHandler">
            <summary>
            Tracking change handler for Tooltip
            </summary>
            <summary>
            Value handler for the Tool.IsTooltipTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.IsTooltipTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Tool.IsTooltipTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.IsTooltipTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Tool)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.IsTooltipTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Tool,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.IsTooltipTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Tool.IsTooltipTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.IsHelpKeywordTrackingPropertyHandler">
            <summary>
            Tracking change handler for HelpKeyword
            </summary>
            <summary>
            Value handler for the Tool.IsHelpKeywordTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.IsHelpKeywordTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Tool.IsHelpKeywordTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.IsHelpKeywordTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Tool)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.IsHelpKeywordTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Tool,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.IsHelpKeywordTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Tool.IsHelpKeywordTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.NamePropertyHandler">
            <summary>
            Value handler for the Tool.Name domain property.
            </summary>
            <summary>
            Handler for Name changes
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.NamePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Tool.Name domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.NamePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Tool)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.NamePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Tool,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.NamePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Tool.Name domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.ToolboxIconPropertyHandler">
            <summary>
            Value handler for the Tool.ToolboxIcon domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.ToolboxIconPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Tool.ToolboxIcon domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.ToolboxIconPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Tool)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.ToolboxIconPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Tool,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.ToolboxIconPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Tool.ToolboxIcon domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.CaptionPropertyHandler">
            <summary>
            Value handler for the Tool.Caption domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.CaptionPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Tool.Caption domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.CaptionPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Tool)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.CaptionPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Tool,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.CaptionPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Tool.Caption domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.TooltipPropertyHandler">
            <summary>
            Value handler for the Tool.Tooltip domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.TooltipPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Tool.Tooltip domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.TooltipPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Tool)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.TooltipPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Tool,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.TooltipPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Tool.Tooltip domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.HelpKeywordPropertyHandler">
            <summary>
            Value handler for the Tool.HelpKeyword domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.HelpKeywordPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Tool.HelpKeyword domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.HelpKeywordPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Tool)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.HelpKeywordPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Tool,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Tool.HelpKeywordPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Tool.HelpKeyword domain property.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementTool.ValidateElementToolMultiplicity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Checks that the relationships that have a multiplicity of One or OneMany do actually have a link.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ElementTool.DomainClassId">
            <summary>
            ElementTool domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementTool.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementTool.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ElementTool.CursorIconDomainPropertyId">
            <summary>
            CursorIcon domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ElementTool.cursorIconPropertyStorage">
            <summary>
            Storage for CursorIcon
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementTool.CursorIcon">
            <summary>
            Gets or sets the value of CursorIcon domain property.
            Icon used for the tool's cursor.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementTool.Class">
            <summary>
            Gets or sets Class.
            Class of element the tool creates.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ElementTool.CursorIconPropertyHandler">
            <summary>
            Value handler for the ElementTool.CursorIcon domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ElementTool.CursorIconPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the ElementTool.CursorIcon domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementTool.CursorIconPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ElementTool)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementTool.CursorIconPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ElementTool,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementTool.CursorIconPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the ElementTool.CursorIcon domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool">
            <summary>
            DomainClass ConnectionTool
            Defines a tool on the toolbox for making a connection.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool.ValidateConnectionToolMultiplicity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Checks that the relationships that have a multiplicity of One or OneMany do actually have a link.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool.DomainClassId">
            <summary>
            ConnectionTool domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool.ReversesDirectionDomainPropertyId">
            <summary>
            ReversesDirection domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool.reversesDirectionPropertyStorage">
            <summary>
            Storage for ReversesDirection
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool.SourceCursorIconDomainPropertyId">
            <summary>
            SourceCursorIcon domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool.sourceCursorIconPropertyStorage">
            <summary>
            Storage for SourceCursorIcon
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool.TargetCursorIconDomainPropertyId">
            <summary>
            TargetCursorIcon domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool.targetCursorIconPropertyStorage">
            <summary>
            Storage for TargetCursorIcon
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool.ReversesDirection">
            <summary>
            Gets or sets the value of ReversesDirection domain property.
            If True, the first element selected is treated as the target of the connection
            and the second element as the source.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool.SourceCursorIcon">
            <summary>
            Gets or sets the value of SourceCursorIcon domain property.
            Icon used for the cursor of the tool before the first element is selected.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool.TargetCursorIcon">
            <summary>
            Gets or sets the value of TargetCursorIcon domain property.
            Icon used for the cursor of the tool after the first element is selected.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool.ConnectionBuilder">
            <summary>
            Gets or sets ConnectionBuilder.
            Connection builder which the tool uses to make a connection.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool.ReversesDirectionPropertyHandler">
            <summary>
            Value handler for the ConnectionTool.ReversesDirection domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool.ReversesDirectionPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the ConnectionTool.ReversesDirection domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool.ReversesDirectionPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool.ReversesDirectionPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool.ReversesDirectionPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the ConnectionTool.ReversesDirection domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool.SourceCursorIconPropertyHandler">
            <summary>
            Value handler for the ConnectionTool.SourceCursorIcon domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool.SourceCursorIconPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the ConnectionTool.SourceCursorIcon domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool.SourceCursorIconPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool.SourceCursorIconPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool.SourceCursorIconPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the ConnectionTool.SourceCursorIcon domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool.TargetCursorIconPropertyHandler">
            <summary>
            Value handler for the ConnectionTool.TargetCursorIcon domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool.TargetCursorIconPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the ConnectionTool.TargetCursorIcon domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool.TargetCursorIconPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool.TargetCursorIconPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool.TargetCursorIconPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the ConnectionTool.TargetCursorIcon domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl">
            <summary>
            DomainClass Dsl
            Definition of a Domain Specific Language, which is also a DslLibrary.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary">
            <summary>
            DomainClass DslLibrary
            Defines a library of components of a DSL definition.
            </summary>
            <summary>
            Partial class on DslLibrary to implement IPathHost
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary.GetFullName(System.Boolean)">
            <summary>
            Gets the full name of this DslLibrary
            </summary>
            <param name="includeGlobal">Whether or not to prepend 'global::' to the full name</param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary.ConstructFullName(System.String,System.String,System.Boolean)">
            <summary>
            Internal helper method to construct full name from namespace + name.
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary.GetRelativeName(System.String,System.Boolean)">
            <summary>
            Gets the name of the DslLibrary relative to the current namespace. If
            the current namespace is the same as this.Namespace, then we return this.Name. 
            If not, we return this.GetFullName()
            </summary>
            <param name="currentNamespace"></param>
            <param name="includeGlobal">whether or not to prepend 'global::' if a fully qualfied name is returned</param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary.FindDomainEnumeration(System.String)">
            <summary>
            For the given full name, this method returns the found DomianEnumeration.
            </summary>
            <returns>null if we can't find the domain enum</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary.EnsureTypeExists(System.String,System.String)">
            <summary>
            Ensure that the given type is in the model by creating it if it isn't.
            </summary>
            <param name="typeNamespace"></param>
            <param name="typeName"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary.CalculateDescription">
            <summary>
            Calculate the value of Description
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary.OnNamespaceChanged(System.String,System.String)">
            <summary>
            Called when the Namespace of a DslLibrary changes
            </summary>
            <param name="oldValue"></param>
            <param name="newValue"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary.OnNameChanged(System.String,System.String)">
            <summary>
            Called when a DslLibrary's Name changes
            </summary>
            <param name="oldValue"></param>
            <param name="newValue"></param>
        </member>
        <member name="E:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary.MergeDomainRelationship">
            <summary>
            Flag that a DomainRelationship is about to be merged and request that extra data for it is provided
            </summary>
            <remarks>
            If this event is not handled or the data in the event args is not provided then the merge will fail.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.ValidateDslMultiplicity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Checks that the relationships that have a multiplicity of One or OneMany do actually have a link.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.packageNamespaceStorage">
            <summary>
            Storage for PackageNamespace DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.GetPackageNamespaceValue">
            <summary>
            Gets the value of PackageNamespace
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.SetPackageNamespaceValue(System.String)">
            <summary>
            Sets the value of PackageNamespace
            </summary>
            <param name="value"></param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.DomainClassId">
            <summary>
            Dsl domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.ProductNameDomainPropertyId">
            <summary>
            ProductName domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.productNamePropertyStorage">
            <summary>
            Storage for ProductName
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.CompanyNameDomainPropertyId">
            <summary>
            CompanyName domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.companyNamePropertyStorage">
            <summary>
            Storage for CompanyName
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.PackageGuidDomainPropertyId">
            <summary>
            PackageGuid domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.packageGuidPropertyStorage">
            <summary>
            Storage for PackageGuid
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.PackageNamespaceDomainPropertyId">
            <summary>
            PackageNamespace domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.IsPackageNamespaceTrackingDomainPropertyId">
            <summary>
            IsPackageNamespaceTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.isPackageNamespaceTrackingPropertyStorage">
            <summary>
            Storage for IsPackageNamespaceTracking
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.CanMerge(Microsoft.VisualStudio.Modeling.ProtoElementBase,Microsoft.VisualStudio.Modeling.ElementGroupPrototype)">
            <summary>
            Returns a value indicating whether the source element represented by the
            specified root ProtoElement can be added to this element.
            </summary>
            <param name="rootElement">
            The root ProtoElement representing a source element.  This can be null, 
            in which case the ElementGroupPrototype does not contain an ProtoElements
            and the code should inspect the ElementGroupPrototype context information.
            </param>
            <param name="elementGroupPrototype">The ElementGroupPrototype that contains the root ProtoElement.</param>
            <returns>true if the source element represented by the ProtoElement can be added to this target element.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.MergeRelate(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Called by the Merge process to create a relationship between 
            this target element and the specified source element. 
            Typically, a parent-child relationship is established
            between the target element (the parent) and the source element 
            (the child), but any relationship can be established.
            </summary>
            <param name="sourceElement">The element that is to be related to this model element.</param>
            <param name="elementGroup">The group of source ModelElements that have been rehydrated into the target store.</param>
            <remarks>
            This method is overriden to create the relationship between the target element and the specified source element.
            The base method does nothing.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.MergeDisconnect(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Performs operation opposite to MergeRelate - i.e. disconnects a given
            element from the current one (removes links created by MergeRelate).
            </summary>
            <param name="sourceElement">Element to be unmerged/disconnected.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.CalculatePackageNamespace">
            <summary>
            Calculates the value of PackageNamespace
            </summary>
            <returns>The value of PackageNamespace</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.OnNameChanged(System.String,System.String)">
            <summary>
            Handler for Name changes on a Dsl
            </summary>
            <param name="oldValue"></param>
            <param name="newValue"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.OnNamespaceChanged(System.String,System.String)">
            <summary>
            Handler for Namespace change on a Dsl
            </summary>
            <param name="oldValue"></param>
            <param name="newValue"></param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.ProductName">
            <summary>
            Gets or sets the value of ProductName domain property.
            The name of the product that will be registered for the Visual Studio package
            generated for this DSL.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.CompanyName">
            <summary>
            Gets or sets the value of CompanyName domain property.
            Name of the company for which the designer generated will be registered in
            Visual Studio.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.PackageGuid">
            <summary>
            Gets or sets the value of PackageGuid domain property.
            The guid for the Visual Studio package generated for this DSL.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.PackageNamespace">
            <summary>
            Gets or sets the value of PackageNamespace domain property.
            The namespace for the Visual Studio package generated for this DSL.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.IsPackageNamespaceTracking">
            <summary>
            Gets or sets the value of IsPackageNamespaceTracking domain property.
            If True, the PackageNamespace property tracks other data in the DSL definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.Editor">
            <summary>
            Gets or sets Editor.
            Editor defined by the DSL.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.Explorer">
            <summary>
            Gets or sets Explorer.
            Explorer defined by the DSL.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.Diagram">
            <summary>
            Gets or sets Diagram.
            Diagram defined by the DSL.
            </summary>
        </member>
        <member name="E:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.MergeDiagramElementMap">
            <summary>
            Flag that a DiagramElementMap is about to be merged and request that extra data for it is provided
            </summary>
            <remarks>
            If this event is not handled or the data in the event args is not provided then the merge will fail.
            </remarks>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.ExplorerTitleMenuName">
            <summary>
            Returns the text used in both the Model Explorer and menu (ie Menu View->"Other Windows"->ExplorerTitleMenuName)
            It constructs the title based on the Explorer.Title + "Explorer"
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.IsPackageNamespaceTrackingPropertyHandler">
            <summary>
            Tracking change handler for PackageNamespace
            </summary>
            <summary>
            Value handler for the Dsl.IsPackageNamespaceTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.IsPackageNamespaceTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Dsl.IsPackageNamespaceTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.IsPackageNamespaceTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Dsl)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.IsPackageNamespaceTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Dsl,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.IsPackageNamespaceTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Dsl.IsPackageNamespaceTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.ProductNamePropertyHandler">
            <summary>
            Value handler for the Dsl.ProductName domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.ProductNamePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Dsl.ProductName domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.ProductNamePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Dsl)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.ProductNamePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Dsl,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.ProductNamePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Dsl.ProductName domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.CompanyNamePropertyHandler">
            <summary>
            Value handler for the Dsl.CompanyName domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.CompanyNamePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Dsl.CompanyName domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.CompanyNamePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Dsl)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.CompanyNamePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Dsl,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.CompanyNamePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Dsl.CompanyName domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.PackageGuidPropertyHandler">
            <summary>
            Value handler for the Dsl.PackageGuid domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.PackageGuidPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Dsl.PackageGuid domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.PackageGuidPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Dsl)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.PackageGuidPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Dsl,System.Guid)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.PackageGuidPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Dsl.PackageGuid domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.PackageNamespacePropertyHandler">
            <summary>
            Value handler for the Dsl.PackageNamespace domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.PackageNamespacePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Dsl.PackageNamespace domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.PackageNamespacePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Dsl)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.PackageNamespacePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Dsl,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Dsl.PackageNamespacePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Dsl.PackageNamespace domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer">
            <summary>
            DomainClass Explorer
            Defines the explorer window associated with the editor for a DSL.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.ValidateExplorerMultiplicity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Checks that the relationships that have a multiplicity of One or OneMany do actually have a link.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.titleStorage">
            <summary>
            Storage for Title DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.GetTitleValue">
            <summary>
            Gets the value of Title
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.SetTitleValue(System.String)">
            <summary>
            Sets the value of Title
            </summary>
            <param name="value"></param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.DomainClassId">
            <summary>
            Explorer domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.ExplorerGuidDomainPropertyId">
            <summary>
            ExplorerGuid domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.explorerGuidPropertyStorage">
            <summary>
            Storage for ExplorerGuid
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.TitleDomainPropertyId">
            <summary>
            Title domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.IsTitleTrackingDomainPropertyId">
            <summary>
            IsTitleTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.isTitleTrackingPropertyStorage">
            <summary>
            Storage for IsTitleTracking
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.CalculateTitle">
            <summary>
            Calculates the value of Title
            </summary>
            <returns>The value of Title</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.ExplorerGuid">
            <summary>
            Gets or sets the value of ExplorerGuid domain property.
            Guid for the explorer window.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.Title">
            <summary>
            Gets or sets the value of Title domain property.
            Text used in the view menu entry and window tab to identify the explorer window.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.IsTitleTracking">
            <summary>
            Gets or sets the value of IsTitleTracking domain property.
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.IsTitleTracking
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.Dsl">
            <summary>
            Gets or sets Dsl.
            Dsl defining the explorer.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.Behavior">
            <summary>
            Gets or sets Behavior.
            Explorer behavior used by this explorer.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.IsTitleTrackingPropertyHandler">
            <summary>
            Tracking change handler for Title
            </summary>
            <summary>
            Value handler for the Explorer.IsTitleTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.IsTitleTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Explorer.IsTitleTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.IsTitleTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Explorer)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.IsTitleTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Explorer,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.IsTitleTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Explorer.IsTitleTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.ExplorerGuidPropertyHandler">
            <summary>
            Value handler for the Explorer.ExplorerGuid domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.ExplorerGuidPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Explorer.ExplorerGuid domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.ExplorerGuidPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Explorer)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.ExplorerGuidPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Explorer,System.Guid)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.ExplorerGuidPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Explorer.ExplorerGuid domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.TitlePropertyHandler">
            <summary>
            Value handler for the Explorer.Title domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.TitlePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Explorer.Title domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.TitlePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Explorer)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.TitlePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Explorer,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Explorer.TitlePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Explorer.Title domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition">
            <summary>
            DomainClass XmlSerializationDefinition
            Defines the Xml serializer used by an editor.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.ValidateXmlSerializationDefinitionMultiplicity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Checks that the relationships that have a multiplicity of One or OneMany do actually have a link.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.DomainClassId">
            <summary>
            XmlSerializationDefinition domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.RootNamespaceDomainPropertyId">
            <summary>
            RootNamespace domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.rootNamespacePropertyStorage">
            <summary>
            Storage for RootNamespace
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.CustomPostLoadDomainPropertyId">
            <summary>
            CustomPostLoad domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.customPostLoadPropertyStorage">
            <summary>
            Storage for CustomPostLoad
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.WriteOptionalPropertiesWithDefaultValueDomainPropertyId">
            <summary>
            WriteOptionalPropertiesWithDefaultValue domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.writeOptionalPropertiesWithDefaultValuePropertyStorage">
            <summary>
            Storage for WriteOptionalPropertiesWithDefaultValue
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.ValidateXmlSerializationDefinition(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            </summary>
            <param name="context">context object for logging errors/warnings/informationals</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.ValidateXmlSerializationDefinitionOnLoad(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            </summary>
            <param name="context">context object for logging errors/warnings/informationals</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.RootNamespace">
            <summary>
            Gets or sets the value of RootNamespace domain property.
            Root xml namespace.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.CustomPostLoad">
            <summary>
            Gets or sets the value of CustomPostLoad domain property.
            If True,  custom code is provided to perform further processing post load.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.WriteOptionalPropertiesWithDefaultValue">
            <summary>
            Gets or sets the value of WriteOptionalPropertiesWithDefaultValue domain property.
            If True, properties with default value will be be written out to the saved file.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.Editor">
            <summary>
            Gets or sets Editor.
            Editor defining the xml serialization behavior wrapper.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.Behavior">
            <summary>
            Gets or sets Behavior.
            Xml serialization behavior used by the definition.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.RootNamespacePropertyHandler">
            <summary>
            Value handler for the XmlSerializationDefinition.RootNamespace domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.RootNamespacePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlSerializationDefinition.RootNamespace domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.RootNamespacePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.RootNamespacePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.RootNamespacePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlSerializationDefinition.RootNamespace domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.CustomPostLoadPropertyHandler">
            <summary>
            Value handler for the XmlSerializationDefinition.CustomPostLoad domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.CustomPostLoadPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlSerializationDefinition.CustomPostLoad domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.CustomPostLoadPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.CustomPostLoadPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.CustomPostLoadPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlSerializationDefinition.CustomPostLoad domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.WriteOptionalPropertiesWithDefaultValuePropertyHandler">
            <summary>
            Value handler for the XmlSerializationDefinition.WriteOptionalPropertiesWithDefaultValue domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.WriteOptionalPropertiesWithDefaultValuePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlSerializationDefinition.WriteOptionalPropertiesWithDefaultValue domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.WriteOptionalPropertiesWithDefaultValuePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.WriteOptionalPropertiesWithDefaultValuePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition.WriteOptionalPropertiesWithDefaultValuePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlSerializationDefinition.WriteOptionalPropertiesWithDefaultValue domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings">
            <summary>
            DomainClass ExplorerNodeSettings
            Defines custom settings for explorer nodes representing elements of the
            designated class.
            </summary>
            <summary>
            Partial class to implement IPathHost
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings.ValidateExplorerNodeSettingsMultiplicity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Checks that the relationships that have a multiplicity of One or OneMany do actually have a link.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings.DomainClassId">
            <summary>
            ExplorerNodeSettings domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings.IconToDisplayDomainPropertyId">
            <summary>
            IconToDisplay domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings.iconToDisplayPropertyStorage">
            <summary>
            Storage for IconToDisplay
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings.ShowsDomainClassDomainPropertyId">
            <summary>
            ShowsDomainClass domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings.showsDomainClassPropertyStorage">
            <summary>
            Storage for ShowsDomainClass
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings.CanMerge(Microsoft.VisualStudio.Modeling.ProtoElementBase,Microsoft.VisualStudio.Modeling.ElementGroupPrototype)">
            <summary>
            Returns a value indicating whether the source element represented by the
            specified root ProtoElement can be added to this element.
            </summary>
            <param name="rootElement">
            The root ProtoElement representing a source element.  This can be null, 
            in which case the ElementGroupPrototype does not contain an ProtoElements
            and the code should inspect the ElementGroupPrototype context information.
            </param>
            <param name="elementGroupPrototype">The ElementGroupPrototype that contains the root ProtoElement.</param>
            <returns>true if the source element represented by the ProtoElement can be added to this target element.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings.MergeRelate(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Called by the Merge process to create a relationship between 
            this target element and the specified source element. 
            Typically, a parent-child relationship is established
            between the target element (the parent) and the source element 
            (the child), but any relationship can be established.
            </summary>
            <param name="sourceElement">The element that is to be related to this model element.</param>
            <param name="elementGroup">The group of source ModelElements that have been rehydrated into the target store.</param>
            <remarks>
            This method is overriden to create the relationship between the target element and the specified source element.
            The base method does nothing.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings.MergeDisconnect(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Performs operation opposite to MergeRelate - i.e. disconnects a given
            element from the current one (removes links created by MergeRelate).
            </summary>
            <param name="sourceElement">Element to be unmerged/disconnected.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings.IconToDisplay">
            <summary>
            Gets or sets the value of IconToDisplay domain property.
            Icon to be displayed against nodes representing elements of the designated
            class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings.ShowsDomainClass">
            <summary>
            Gets or sets the value of ShowsDomainClass domain property.
            If True, the name of the domain class is shown in the explorer node label.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings.PropertyDisplayed">
            <summary>
            Gets or sets PropertyDisplayed.
            Path to the property used to label for the explorer node.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings.ExplorerBehavior">
            <summary>
            Gets or sets ExplorerBehavior.
            Explorer behavior defining the custom explorer node settings.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings.Class">
            <summary>
            Gets or sets Class.
            Class of element to which the settings apply.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings.IconToDisplayPropertyHandler">
            <summary>
            Value handler for the ExplorerNodeSettings.IconToDisplay domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings.IconToDisplayPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the ExplorerNodeSettings.IconToDisplay domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings.IconToDisplayPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings.IconToDisplayPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings.IconToDisplayPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the ExplorerNodeSettings.IconToDisplay domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings.ShowsDomainClassPropertyHandler">
            <summary>
            Value handler for the ExplorerNodeSettings.ShowsDomainClass domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings.ShowsDomainClassPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the ExplorerNodeSettings.ShowsDomainClass domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings.ShowsDomainClassPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings.ShowsDomainClassPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings.ShowsDomainClassPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the ExplorerNodeSettings.ShowsDomainClass domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath">
            <summary>
            DomainClass PropertyPath
            Defines a path navigating to an element or elements and a property of interest
            on the element(s).
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath.ValidatePropertyPathMultiplicity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Checks that the relationships that have a multiplicity of One or OneMany do actually have a link.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath.DomainClassId">
            <summary>
            PropertyPath domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath.MergeConfigure(Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Configures element on completion of the merge operation.
            </summary>
            <param name="elementGroup">Element group being merged.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath.VerifyPropertyPath(Microsoft.VisualStudio.Modeling.Validation.ValidationContext,System.String,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Check a property path.
            </summary>
            <param name="context">Validation context</param>
            <param name="contextDescription">Prefix string for the error message</param>
            <param name="container">Element to be selected when error is double clicked</param>
            <param name="sourceClass">Class that path should start on.</param>
            <param name="sourceDiagramElement"></param>
            <returns></returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath.PathToProperty">
            <summary>
            Gets or sets PathToProperty.
            Path to the property.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath.Property">
            <summary>
            Gets or sets Property.
            Designated property of the element reached by the path.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram">
            <summary>
            DomainClass Diagram
            Defines a diagram, involving the definition of shape and connector maps.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.ValidateDiagramMultiplicity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Checks that the relationships that have a multiplicity of One or OneMany do actually have a link.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.DomainClassId">
            <summary>
            Diagram domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.FillColorDomainPropertyId">
            <summary>
            FillColor domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.fillColorPropertyStorage">
            <summary>
            Storage for FillColor
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.TextColorDomainPropertyId">
            <summary>
            TextColor domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.textColorPropertyStorage">
            <summary>
            Storage for TextColor
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.ExposesFillColorDomainPropertyId">
            <summary>
            ExposesFillColor domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.ExposesTextColorDomainPropertyId">
            <summary>
            ExposesTextColor domain property Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.CanMerge(Microsoft.VisualStudio.Modeling.ProtoElementBase,Microsoft.VisualStudio.Modeling.ElementGroupPrototype)">
            <summary>
            Returns a value indicating whether the source element represented by the
            specified root ProtoElement can be added to this element.
            </summary>
            <param name="rootElement">
            The root ProtoElement representing a source element.  This can be null, 
            in which case the ElementGroupPrototype does not contain an ProtoElements
            and the code should inspect the ElementGroupPrototype context information.
            </param>
            <param name="elementGroupPrototype">The ElementGroupPrototype that contains the root ProtoElement.</param>
            <returns>true if the source element represented by the ProtoElement can be added to this target element.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.MergeRelate(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Called by the Merge process to create a relationship between 
            this target element and the specified source element. 
            Typically, a parent-child relationship is established
            between the target element (the parent) and the source element 
            (the child), but any relationship can be established.
            </summary>
            <param name="sourceElement">The element that is to be related to this model element.</param>
            <param name="elementGroup">The group of source ModelElements that have been rehydrated into the target store.</param>
            <remarks>
            This method is overriden to create the relationship between the target element and the specified source element.
            The base method does nothing.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.MergeDisconnect(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Performs operation opposite to MergeRelate - i.e. disconnects a given
            element from the current one (removes links created by MergeRelate).
            </summary>
            <param name="sourceElement">Element to be unmerged/disconnected.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.GetExposesFillColorValue">
            <summary>
            Calculated property calculator for ExposesFillColor
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.GetExposesTextColorValue">
            <summary>
            Calculated property calculator for ExposesTextColor
            </summary>
            <returns></returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.FillColor">
            <summary>
            Gets or sets the value of FillColor domain property.
            Fill color for the diagram.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.TextColor">
            <summary>
            Gets or sets the value of TextColor domain property.
            Color of text rendered on the diagram.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.ExposesFillColor">
            <summary>
            Gets or sets the value of ExposesFillColor domain property.
            If True, a domain property has been added to the diagram to allow the fill color
            to be exposed in the properties window of the generated designer.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.ExposesTextColor">
            <summary>
            Gets or sets the value of ExposesTextColor domain property.
            If True, a domain property has been added to the diagram to allow the text color
            to be exposed in the properties window of the generated designer.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.ShapeMaps">
            <summary>
            Gets a list of ShapeMaps.
            Shape maps defined by the diagram.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.ConnectorMaps">
            <summary>
            Gets a list of ConnectorMaps.
            Connector maps defined by the diagram.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.Class">
            <summary>
            Gets or sets Class.
            The class of element represented by a diagram.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.Designer">
            <summary>
            Gets or sets Designer.
            Designer referencing the diagram.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.BaseClass">
            <summary>
            Gets or sets BaseClass.
            Base diagram of the diagram.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.SubClasses">
            <summary>
            Gets a list of SubClasses.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.FillColorPropertyHandler">
            <summary>
            Value handler for the Diagram.FillColor domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.FillColorPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Diagram.FillColor domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.FillColorPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.FillColorPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram,System.Drawing.Color)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.FillColorPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Diagram.FillColor domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.TextColorPropertyHandler">
            <summary>
            Value handler for the Diagram.TextColor domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.TextColorPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Diagram.TextColor domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.TextColorPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.TextColorPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram,System.Drawing.Color)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.TextColorPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Diagram.TextColor domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.ExposesFillColorPropertyHandler">
            <summary>
            Value handler for the Diagram.ExposesFillColor domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.ExposesFillColorPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Diagram.ExposesFillColor domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.ExposesFillColorPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.ExposesFillColorPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Diagram.ExposesFillColor domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.ExposesTextColorPropertyHandler">
            <summary>
            Value handler for the Diagram.ExposesTextColor domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.ExposesTextColorPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Diagram.ExposesTextColor domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.ExposesTextColorPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Diagram.ExposesTextColorPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Diagram.ExposesTextColor domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap">
            <summary>
            DomainClass CompartmentMap
            Defines mapping from a compartment to a collection of elements.
            </summary>
            <summary>
            Partial class to implement IPathHost
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap.ValidateCompartmentMapMultiplicity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Checks that the relationships that have a multiplicity of One or OneMany do actually have a link.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap.DomainClassId">
            <summary>
            CompartmentMap domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap.UsesCustomFilterDomainPropertyId">
            <summary>
            UsesCustomFilter domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap.usesCustomFilterPropertyStorage">
            <summary>
            Storage for UsesCustomFilter
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap.DisplaysCustomStringDomainPropertyId">
            <summary>
            DisplaysCustomString domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap.displaysCustomStringPropertyStorage">
            <summary>
            Storage for DisplaysCustomString
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap.UsesCustomFilter">
            <summary>
            Gets or sets the value of UsesCustomFilter domain property.
            If True, the  for each element in the compartment is defined by custom code.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap.DisplaysCustomString">
            <summary>
            Gets or sets the value of DisplaysCustomString domain property.
            If True, the string displayed for each element in the compartment is defined by
            custom code.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap.ElementsDisplayed">
            <summary>
            Gets or sets ElementsDisplayed.
            Path identifying the collection of elements displayed in the compartment.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap.PropertyDisplayed">
            <summary>
            Gets or sets PropertyDisplayed.
            Property path identifying the property to be displayed for each element in the
            compartment.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap.ShapeMap">
            <summary>
            Gets or sets ShapeMap.
            Shape map defining the compartment map.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap.Compartment">
            <summary>
            Gets or sets Compartment.
            Compartment referenced by the compartment map.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap.UsesCustomFilterPropertyHandler">
            <summary>
            Value handler for the CompartmentMap.UsesCustomFilter domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap.UsesCustomFilterPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the CompartmentMap.UsesCustomFilter domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap.UsesCustomFilterPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap.UsesCustomFilterPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap.UsesCustomFilterPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the CompartmentMap.UsesCustomFilter domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap.DisplaysCustomStringPropertyHandler">
            <summary>
            Value handler for the CompartmentMap.DisplaysCustomString domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap.DisplaysCustomStringPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the CompartmentMap.DisplaysCustomString domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap.DisplaysCustomStringPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap.DisplaysCustomStringPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap.DisplaysCustomStringPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the CompartmentMap.DisplaysCustomString domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap">
            <summary>
            DomainClass DecoratorMap
            Defines a mapping between a decorator and a domain property.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap.ValidateDecoratorMapMultiplicity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Checks that the relationships that have a multiplicity of One or OneMany do actually have a link.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap.DomainClassId">
            <summary>
            DecoratorMap domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap.PropertyDisplayed">
            <summary>
            Gets or sets PropertyDisplayed.
            Path identifying property to be displayed by decorator.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap.VisibilityPropertyPath">
            <summary>
            Gets or sets VisibilityPropertyPath.
            Path identifying property used to decide whether or not the decorator is
            visible.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap.DiagramElementMap">
            <summary>
            Gets or sets DiagramElementMap.
            Diagram element map to which the decorator map belongs.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap.Decorator">
            <summary>
            Gets or sets Decorator.
            Decorator referenced by map.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Designer">
            <summary>
            DomainClass Designer
            Defines an editor with a graphical design surface.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Designer.ValidateDesignerMultiplicity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Checks that the relationships that have a multiplicity of One or OneMany do actually have a link.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Designer.DomainClassId">
            <summary>
            Designer domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Designer.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Designer.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Designer.Diagram">
            <summary>
            Gets or sets Diagram.
            Diagram definition used for the designer.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMap">
            <summary>
            DomainClass CompartmentShapeMap
            Defines a mapping between a compartment shape and a domain class.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap">
            <summary>
            DomainClass BaseShapeMap
            Base class for all shape maps.
            </summary>
            <summary>
            Partial class to implement IPathHost
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMap">
            <summary>
            DomainClass DiagramElementMap
            Abstract base class for the definition of mappings between diagram elements and
            domain classes or relationships.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMap.DomainClassId">
            <summary>
            DiagramElementMap domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMap.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMap.DecoratorMaps">
            <summary>
            Gets a list of DecoratorMaps.
            Decorator maps defined by the diagram element map.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap.ValidateBaseShapeMapMultiplicity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Checks that the relationships that have a multiplicity of One or OneMany do actually have a link.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap.DomainClassId">
            <summary>
            BaseShapeMap domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap.HasCustomParentElementDomainPropertyId">
            <summary>
            HasCustomParentElement domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap.hasCustomParentElementPropertyStorage">
            <summary>
            Storage for HasCustomParentElement
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap.HasCustomParentShapeDomainPropertyId">
            <summary>
            HasCustomParentShape domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap.hasCustomParentShapePropertyStorage">
            <summary>
            Storage for HasCustomParentShape
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap.MergeConfigure(Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Configure a BaseShapeMap that is merged with no endpoints
            </summary>
            <param name="elementGroup"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap.SetBaseShape(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShape)">
            <summary>
            Set the value of BaseShape
            </summary>
            <param name="shape"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap.VerifyParent(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Check the Parent Element Path, which we know is non-empty and a valid path to something.
            </summary>
            <param name="context"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap.VerifyParentShapeIsCompatible(Microsoft.VisualStudio.Modeling.Validation.ValidationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,System.Collections.Generic.List{Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapCache.ShapeMapInfo})">
            <summary>
            Check that each possible parent shape is compatible with this shape.
            Checks each subclass of parent, but doesn't check where there are 
            multiple shape maps on one domain class, or where there is anything custom.
            </summary>
            <param name="context"></param>
            <param name="targetRole"></param>
            <param name="possibleMaps"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap.VerifyParentHasShapeMap(Microsoft.VisualStudio.Modeling.Validation.ValidationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,System.Collections.Generic.List{Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapCache.ShapeMapInfo})">
            <summary>
            Check that any parent instance will be mapped to a shape. 
            That is, check that all concrete subclasses in the tree rooted at the 
            parent element class have or inherit a shape map.
            </summary>
            <param name="context"></param>
            <param name="parentElementClass"></param>
            <param name="possibleMaps">List of all mapped classes in this subtree.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap.HasCustomParentElement">
            <summary>
            Gets or sets the value of HasCustomParentElement domain property.
            Indicates that the parent element will be identified through custom code.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap.HasCustomParentShape">
            <summary>
            Gets or sets the value of HasCustomParentShape domain property.
            Indicates that the parent shape will be identified through custom code.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap.ParentElementPath">
            <summary>
            Gets or sets ParentElementPath.
            Path to the subject of the shape, swimlane or diagram that parents the mapped
            shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap.Diagram">
            <summary>
            Gets or sets Diagram.
            Diagram defining the shape map.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap.DecoratorMaps">
            <summary>
            Gets a list of DecoratorMaps.
            Decorator maps defined by the shape map.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap.Class">
            <summary>
            Gets or sets Class.
            Class being mapped.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap.BaseShape">
            <summary>
            Gets or sets BaseShape.
            Base shape referenced by the map.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap.HasCustomParentElementPropertyHandler">
            <summary>
            Value handler for the BaseShapeMap.HasCustomParentElement domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap.HasCustomParentElementPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the BaseShapeMap.HasCustomParentElement domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap.HasCustomParentElementPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap.HasCustomParentElementPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap.HasCustomParentElementPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the BaseShapeMap.HasCustomParentElement domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap.HasCustomParentShapePropertyHandler">
            <summary>
            Value handler for the BaseShapeMap.HasCustomParentShape domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap.HasCustomParentShapePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the BaseShapeMap.HasCustomParentShape domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap.HasCustomParentShapePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap.HasCustomParentShapePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap.HasCustomParentShapePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the BaseShapeMap.HasCustomParentShape domain property.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMap.ValidateCompartmentShapeMapMultiplicity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Checks that the relationships that have a multiplicity of One or OneMany do actually have a link.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMap.DomainClassId">
            <summary>
            CompartmentShapeMap domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMap.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMap.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMap.SetBaseShape(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShape)">
            <summary>
            Set the value of BaseShape using the appropriate concrete type
            </summary>
            <param name="shape"></param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMap.CompartmentMaps">
            <summary>
            Gets a list of CompartmentMaps.
            Compartment maps defined by the compartment shape map.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMap.CompartmentShape">
            <summary>
            Gets or sets CompartmentShape.
            Compartment shape being mapped.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMap">
            <summary>
            DomainClass ShapeMap
            Defines a mapping between a shape and domain class.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMap.ValidateShapeMapMultiplicity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Checks that the relationships that have a multiplicity of One or OneMany do actually have a link.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMap.DomainClassId">
            <summary>
            ShapeMap domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMap.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMap.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMap.SetBaseShape(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShape)">
            <summary>
            Set the value of BaseShape using the appropriate concrete type
            </summary>
            <param name="shape"></param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMap.Shape">
            <summary>
            Gets or sets Shape.
            Shape being mapped.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap">
            <summary>
            DomainClass ConnectorMap
            Defines a mapping between a connector and a domain relationship.
            </summary>
            <summary>
            Partial class to implement IPathHost
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap.ValidateConnectorMapMultiplicity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Checks that the relationships that have a multiplicity of One or OneMany do actually have a link.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap.DomainClassId">
            <summary>
            ConnectorMap domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap.ConnectsCustomSourceDomainPropertyId">
            <summary>
            ConnectsCustomSource domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap.connectsCustomSourcePropertyStorage">
            <summary>
            Storage for ConnectsCustomSource
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap.ConnectsCustomTargetDomainPropertyId">
            <summary>
            ConnectsCustomTarget domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap.connectsCustomTargetPropertyStorage">
            <summary>
            Storage for ConnectsCustomTarget
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap.MergeConfigure(Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Configure a ConnectorMap that is merged with no endpoints
            </summary>
            <param name="elementGroup"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap.HasOrInheritsShapeMap(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Check that this class has or inherits a ShapeMap in the given diagram.
            </summary>
            <param name="domainClass">May be null</param>
            <param name="diagram"></param>
            <returns>True if a ShapeMap was found.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap.ConcreteSubClassWithoutShapeMap(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.Diagram,System.Int32)">
            <summary>
            Check that every concrete subclass of a given root has a ShapeMap in this diagram.
            Returns null if OK; otherwise, returns an example of a concrete subclass (or root itself) without a ShapeMap.
            </summary>
            <param name="root">root class to check</param>
            <param name="diagram">The diagram that the ShapeMaps should belong to</param>
            <param name="loopProtect">Recursion count in case of loop in BaseClass graph</param>
            <returns>null if OK; otherwise, a concrete class without a shape map</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap.ConnectsCustomSource">
            <summary>
            Gets or sets the value of ConnectsCustomSource domain property.
            If True, the element presented by the shape at the source of the connector is
            identified through custom code.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap.ConnectsCustomTarget">
            <summary>
            Gets or sets the value of ConnectsCustomTarget domain property.
            If True, the element presented by the shape at the target of the connector is
            identified through custom code.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap.Diagram">
            <summary>
            Gets or sets Diagram.
            Diagram defining the connector map.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap.DecoratorMaps">
            <summary>
            Gets a list of DecoratorMaps.
            Decorator maps defined by the connector map.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap.Connector">
            <summary>
            Gets or sets Connector.
            Connector being mapped.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap.Relationship">
            <summary>
            Gets or sets Relationship.
            Relationship being mapped.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap.ConnectsCustomSourcePropertyHandler">
            <summary>
            Value handler for the ConnectorMap.ConnectsCustomSource domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap.ConnectsCustomSourcePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the ConnectorMap.ConnectsCustomSource domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap.ConnectsCustomSourcePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap.ConnectsCustomSourcePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap.ConnectsCustomSourcePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the ConnectorMap.ConnectsCustomSource domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap.ConnectsCustomTargetPropertyHandler">
            <summary>
            Value handler for the ConnectorMap.ConnectsCustomTarget domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap.ConnectsCustomTargetPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the ConnectorMap.ConnectsCustomTarget domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap.ConnectsCustomTargetPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap.ConnectsCustomTargetPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap.ConnectsCustomTargetPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the ConnectorMap.ConnectsCustomTarget domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData">
            <summary>
            DomainClass XmlClassData
            Defines how elements of a specific domain class are serialized in xml.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.ValidateXmlClassDataMultiplicity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Checks that the relationships that have a multiplicity of One or OneMany do actually have a link.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.typeNameStorage">
            <summary>
            Storage for TypeName DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.GetTypeNameValue">
            <summary>
            Gets the value of TypeName
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.SetTypeNameValue(System.String)">
            <summary>
            Sets the value of TypeName
            </summary>
            <param name="value"></param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.elementNameStorage">
            <summary>
            Storage for ElementName DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.GetElementNameValue">
            <summary>
            Gets the value of ElementName
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.SetElementNameValue(System.String)">
            <summary>
            Sets the value of ElementName
            </summary>
            <param name="value"></param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.serializeIdStorage">
            <summary>
            Storage for SerializeId DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.GetSerializeIdValue">
            <summary>
            Gets the value of SerializeId
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.SetSerializeIdValue(System.Boolean)">
            <summary>
            Sets the value of SerializeId
            </summary>
            <param name="value"></param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.monikerAttributeNameStorage">
            <summary>
            Storage for MonikerAttributeName DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.GetMonikerAttributeNameValue">
            <summary>
            Gets the value of MonikerAttributeName
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.SetMonikerAttributeNameValue(System.String)">
            <summary>
            Sets the value of MonikerAttributeName
            </summary>
            <param name="value"></param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.monikerElementNameStorage">
            <summary>
            Storage for MonikerElementName DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.GetMonikerElementNameValue">
            <summary>
            Gets the value of MonikerElementName
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.SetMonikerElementNameValue(System.String)">
            <summary>
            Sets the value of MonikerElementName
            </summary>
            <param name="value"></param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.monikerTypeNameStorage">
            <summary>
            Storage for MonikerTypeName DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.GetMonikerTypeNameValue">
            <summary>
            Gets the value of MonikerTypeName
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.SetMonikerTypeNameValue(System.String)">
            <summary>
            Sets the value of MonikerTypeName
            </summary>
            <param name="value"></param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.DomainClassId">
            <summary>
            XmlClassData domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.TypeNameDomainPropertyId">
            <summary>
            TypeName domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.ElementNameDomainPropertyId">
            <summary>
            ElementName domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsCustomDomainPropertyId">
            <summary>
            IsCustom domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.isCustomPropertyStorage">
            <summary>
            Storage for IsCustom
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.SerializeIdDomainPropertyId">
            <summary>
            SerializeId domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.MonikerAttributeNameDomainPropertyId">
            <summary>
            MonikerAttributeName domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.MonikerElementNameDomainPropertyId">
            <summary>
            MonikerElementName domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.MonikerTypeNameDomainPropertyId">
            <summary>
            MonikerTypeName domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsTypeNameTrackingDomainPropertyId">
            <summary>
            IsTypeNameTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.isTypeNameTrackingPropertyStorage">
            <summary>
            Storage for IsTypeNameTracking
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsElementNameTrackingDomainPropertyId">
            <summary>
            IsElementNameTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.isElementNameTrackingPropertyStorage">
            <summary>
            Storage for IsElementNameTracking
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsSerializeIdTrackingDomainPropertyId">
            <summary>
            IsSerializeIdTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.isSerializeIdTrackingPropertyStorage">
            <summary>
            Storage for IsSerializeIdTracking
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsMonikerAttributeNameTrackingDomainPropertyId">
            <summary>
            IsMonikerAttributeNameTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.isMonikerAttributeNameTrackingPropertyStorage">
            <summary>
            Storage for IsMonikerAttributeNameTracking
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsMonikerElementNameTrackingDomainPropertyId">
            <summary>
            IsMonikerElementNameTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.isMonikerElementNameTrackingPropertyStorage">
            <summary>
            Storage for IsMonikerElementNameTracking
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsMonikerTypeNameTrackingDomainPropertyId">
            <summary>
            IsMonikerTypeNameTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.isMonikerTypeNameTrackingPropertyStorage">
            <summary>
            Storage for IsMonikerTypeNameTracking
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.CanMerge(Microsoft.VisualStudio.Modeling.ProtoElementBase,Microsoft.VisualStudio.Modeling.ElementGroupPrototype)">
            <summary>
            Returns a value indicating whether the source element represented by the
            specified root ProtoElement can be added to this element.
            </summary>
            <param name="rootElement">
            The root ProtoElement representing a source element.  This can be null, 
            in which case the ElementGroupPrototype does not contain an ProtoElements
            and the code should inspect the ElementGroupPrototype context information.
            </param>
            <param name="elementGroupPrototype">The ElementGroupPrototype that contains the root ProtoElement.</param>
            <returns>true if the source element represented by the ProtoElement can be added to this target element.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.MergeRelate(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Called by the Merge process to create a relationship between 
            this target element and the specified source element. 
            Typically, a parent-child relationship is established
            between the target element (the parent) and the source element 
            (the child), but any relationship can be established.
            </summary>
            <param name="sourceElement">The element that is to be related to this model element.</param>
            <param name="elementGroup">The group of source ModelElements that have been rehydrated into the target store.</param>
            <remarks>
            This method is overriden to create the relationship between the target element and the specified source element.
            The base method does nothing.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.MergeDisconnect(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Performs operation opposite to MergeRelate - i.e. disconnects a given
            element from the current one (removes links created by MergeRelate).
            </summary>
            <param name="sourceElement">Element to be unmerged/disconnected.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.CalculateTypeName">
            <summary>
            Calculates the value of TypeName
            </summary>
            <returns>The value of TypeName</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.CalculateElementName">
            <summary>
            Calculates the value of ElementName
            </summary>
            <returns>The value of ElementName</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.CalculateSerializeId">
            <summary>
            Calculates the value of SerializeId
            </summary>
            <returns>The value of SerializeId</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.GetSerializeIdValueSafely(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Version of SerializeId getter that avoids infinite recursion up the base class hierarchy
            </summary>
            <remarks>Make sure this code matches the templatized code for a tracking property.</remarks>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.CalculateSerializeIdSafely(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Version of SerializeId calculation that avoids infinite recursion up the base class hierarchy
            </summary>
            <param name="initialClass"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsDirectlyReferenceable(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Determines whether this class is directly referenced as the target of a domain relationship,
            shape (including connector) mapping, or is the diagram root.
            This does not take into account any inherited relationships, and should not call any 
            functions/properties that recurse up the inheritance chain
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.CalculateMonikerAttributeName">
            <summary>
            Calculates the value of MonikerAttributeName
            </summary>
            <returns>The value of MonikerAttributeName</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.CalculateMonikerElementName">
            <summary>
            Calculates the value of MonikerElementName
            </summary>
            <returns>The value of MonikerElementName</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.CalculateMonikerTypeName">
            <summary>
            Calculates the value of MonikerTypeName
            </summary>
            <returns>The value of MonikerTypeName</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.TypeName">
            <summary>
            Gets or sets the value of TypeName domain property.
            Name of the xml type generated in the xsd from the designated domain class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.ElementName">
            <summary>
            Gets or sets the value of ElementName domain property.
            Xml element name used to serialize elements of the designated domain class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsCustom">
            <summary>
            Gets or sets the value of IsCustom domain property.
            If True, serialization of elements of the designated domain class is defined in
            custom code.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.SerializeId">
            <summary>
            Gets or sets the value of SerializeId domain property.
            If True, serialize the element Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.MonikerAttributeName">
            <summary>
            Gets or sets the value of MonikerAttributeName domain property.
            Name of attribute used in moniker elements to contain the reference. If blank,
            the name of the key property or id is used.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.MonikerElementName">
            <summary>
            Gets or sets the value of MonikerElementName domain property.
            Name of the xml element used for monikers to elements of the designated class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.MonikerTypeName">
            <summary>
            Gets or sets the value of MonikerTypeName domain property.
            Name of the xsd type generated for monikers to elements of this class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsTypeNameTracking">
            <summary>
            Gets or sets the value of IsTypeNameTracking domain property.
            If True, the TypeName property tracks other data in the DSL definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsElementNameTracking">
            <summary>
            Gets or sets the value of IsElementNameTracking domain property.
            If True, the ElementName property tracks other data in the DSL definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsSerializeIdTracking">
            <summary>
            Gets or sets the value of IsSerializeIdTracking domain property.
            If True, the SerializeId property tracks other data in the DSL definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsMonikerAttributeNameTracking">
            <summary>
            Gets or sets the value of IsMonikerAttributeNameTracking domain property.
            If True, the MonikerAttributeName property tracks other data in the DSL
            definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsMonikerElementNameTracking">
            <summary>
            Gets or sets the value of IsMonikerElementNameTracking domain property.
            If True, the MonikerElementName property tracks other data in the DSL
            definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsMonikerTypeNameTracking">
            <summary>
            Gets or sets the value of IsMonikerTypeNameTracking domain property.
            If True, the MonikerTypeName property tracks other data in the DSL definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.Behavior">
            <summary>
            Gets or sets Behavior.
            Defining xml serialization behavior.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.ElementData">
            <summary>
            Gets a list of ElementData.
            Xml serialization configuration data for elements of the class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.DomainClass">
            <summary>
            Gets or sets DomainClass.
            Class to which the xml serialization configuration data applies.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsTypeNameTrackingPropertyHandler">
            <summary>
            Tracking change handler for TypeName
            </summary>
            <summary>
            Value handler for the XmlClassData.IsTypeNameTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsTypeNameTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlClassData.IsTypeNameTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsTypeNameTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsTypeNameTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsTypeNameTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlClassData.IsTypeNameTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsElementNameTrackingPropertyHandler">
            <summary>
            Tracking change handler for ElementName
            </summary>
            <summary>
            Value handler for the XmlClassData.IsElementNameTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsElementNameTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlClassData.IsElementNameTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsElementNameTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsElementNameTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsElementNameTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlClassData.IsElementNameTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsSerializeIdTrackingPropertyHandler">
            <summary>
            Tracking change handler for SerializeId
            </summary>
            <summary>
            Value handler for the XmlClassData.IsSerializeIdTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsSerializeIdTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlClassData.IsSerializeIdTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsSerializeIdTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsSerializeIdTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsSerializeIdTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlClassData.IsSerializeIdTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsMonikerAttributeNameTrackingPropertyHandler">
            <summary>
            Tracking change handler for MonikerAttributeName
            </summary>
            <summary>
            Value handler for the XmlClassData.IsMonikerAttributeNameTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsMonikerAttributeNameTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlClassData.IsMonikerAttributeNameTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsMonikerAttributeNameTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsMonikerAttributeNameTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsMonikerAttributeNameTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlClassData.IsMonikerAttributeNameTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsMonikerElementNameTrackingPropertyHandler">
            <summary>
            Tracking change handler for MonikerElementName
            </summary>
            <summary>
            Value handler for the XmlClassData.IsMonikerElementNameTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsMonikerElementNameTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlClassData.IsMonikerElementNameTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsMonikerElementNameTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsMonikerElementNameTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsMonikerElementNameTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlClassData.IsMonikerElementNameTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsMonikerTypeNameTrackingPropertyHandler">
            <summary>
            Tracking change handler for MonikerTypeName
            </summary>
            <summary>
            Value handler for the XmlClassData.IsMonikerTypeNameTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsMonikerTypeNameTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlClassData.IsMonikerTypeNameTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsMonikerTypeNameTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsMonikerTypeNameTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsMonikerTypeNameTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlClassData.IsMonikerTypeNameTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.TypeNamePropertyHandler">
            <summary>
            Value handler for the XmlClassData.TypeName domain property.
            </summary>
            <summary>
            TypeName change handler
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.TypeNamePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlClassData.TypeName domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.TypeNamePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.TypeNamePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.TypeNamePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlClassData.TypeName domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.ElementNamePropertyHandler">
            <summary>
            Value handler for the XmlClassData.ElementName domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.ElementNamePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlClassData.ElementName domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.ElementNamePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.ElementNamePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.ElementNamePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlClassData.ElementName domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsCustomPropertyHandler">
            <summary>
            Value handler for the XmlClassData.IsCustom domain property.
            </summary>
            <summary>
            IsCustom change handler
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsCustomPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlClassData.IsCustom domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsCustomPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsCustomPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.IsCustomPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlClassData.IsCustom domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.SerializeIdPropertyHandler">
            <summary>
            Value handler for the XmlClassData.SerializeId domain property.
            </summary>
            <summary>
            SerializeId change handler
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.SerializeIdPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlClassData.SerializeId domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.SerializeIdPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.SerializeIdPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.SerializeIdPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlClassData.SerializeId domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.MonikerAttributeNamePropertyHandler">
            <summary>
            Value handler for the XmlClassData.MonikerAttributeName domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.MonikerAttributeNamePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlClassData.MonikerAttributeName domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.MonikerAttributeNamePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.MonikerAttributeNamePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.MonikerAttributeNamePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlClassData.MonikerAttributeName domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.MonikerElementNamePropertyHandler">
            <summary>
            Value handler for the XmlClassData.MonikerElementName domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.MonikerElementNamePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlClassData.MonikerElementName domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.MonikerElementNamePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.MonikerElementNamePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.MonikerElementNamePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlClassData.MonikerElementName domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.MonikerTypeNamePropertyHandler">
            <summary>
            Value handler for the XmlClassData.MonikerTypeName domain property.
            </summary>
            <summary>
            MonikerTypeName change handler
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.MonikerTypeNamePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlClassData.MonikerTypeName domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.MonikerTypeNamePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.MonikerTypeNamePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData.MonikerTypeNamePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlClassData.MonikerTypeName domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData">
            <summary>
            DomainClass XmlRelationshipData
            Defines how links of a specific domain relationship are serialized in xml.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementData">
            <summary>
            DomainClass XmlElementData
            Abstract base class for definitions how parts of elements of a domain class are
            serialized in xml.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementData.DomainClassId">
            <summary>
            XmlElementData domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementData.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementData.ClassData">
            <summary>
            Gets or sets ClassData.
            Xml class data defining the element data.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementData.Order">
            <summary>
            Returns the index of this XmlElementData in the XmlClassData.ElementData collection
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.ValidateXmlRelationshipDataMultiplicity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Checks that the relationships that have a multiplicity of One or OneMany do actually have a link.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.useFullFormStorage">
            <summary>
            Storage for UseFullForm DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.GetUseFullFormValue">
            <summary>
            Gets the value of UseFullForm
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.SetUseFullFormValue(System.Boolean)">
            <summary>
            Sets the value of UseFullForm
            </summary>
            <param name="value"></param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.roleElementNameStorage">
            <summary>
            Storage for RoleElementName DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.GetRoleElementNameValue">
            <summary>
            Gets the value of RoleElementName
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.SetRoleElementNameValue(System.String)">
            <summary>
            Sets the value of RoleElementName
            </summary>
            <param name="value"></param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.DomainClassId">
            <summary>
            XmlRelationshipData domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.OmitElementDomainPropertyId">
            <summary>
            OmitElement domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.omitElementPropertyStorage">
            <summary>
            Storage for OmitElement
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.UseFullFormDomainPropertyId">
            <summary>
            UseFullForm domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.RoleElementNameDomainPropertyId">
            <summary>
            RoleElementName domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.HasCustomMonikerSerializationDomainPropertyId">
            <summary>
            HasCustomMonikerSerialization domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.hasCustomMonikerSerializationPropertyStorage">
            <summary>
            Storage for HasCustomMonikerSerialization
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.IsRoleElementNameTrackingDomainPropertyId">
            <summary>
            IsRoleElementNameTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.isRoleElementNameTrackingPropertyStorage">
            <summary>
            Storage for IsRoleElementNameTracking
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.IsUseFullFormTrackingDomainPropertyId">
            <summary>
            IsUseFullFormTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.isUseFullFormTrackingPropertyStorage">
            <summary>
            Storage for IsUseFullFormTracking
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.CalculateUseFullForm">
            <summary>
            Calculates the value of UseFullForm
            </summary>
            <returns>The value of UseFullForm</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.CalculateRoleElementName">
            <summary>
            Calculates the value of RoleElementName
            </summary>
            <returns>The value of RoleElementName</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.OmitElement">
            <summary>
            Gets or sets the value of OmitElement domain property.
            If True, the xml tag corresponding to the source role is omitted from the
            schema.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.UseFullForm">
            <summary>
            Gets or sets the value of UseFullForm domain property.
            If True, links of the relationship are serialized in their full form.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.RoleElementName">
            <summary>
            Gets or sets the value of RoleElementName domain property.
            Name of xml element that is derived from the source role. Defaults to the
            property name.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.HasCustomMonikerSerialization">
            <summary>
            Gets or sets the value of HasCustomMonikerSerialization domain property.
            If true, the user can customize the way that the moniker is represented in its
            serialized form.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.IsRoleElementNameTracking">
            <summary>
            Gets or sets the value of IsRoleElementNameTracking domain property.
            If True, the RoleElementName property tracks other data in the DSL definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.IsUseFullFormTracking">
            <summary>
            Gets or sets the value of IsUseFullFormTracking domain property.
            If True, the UseFullForm property tracks other data in the DSL definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.DomainRelationship">
            <summary>
            Gets or sets DomainRelationship.
            Relationship to which the xml serialization configuration data applies.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.IsUseFullFormTrackingPropertyHandler">
            <summary>
            Tracking change handler for UseFullForm
            </summary>
            <summary>
            Value handler for the XmlRelationshipData.IsUseFullFormTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.IsUseFullFormTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlRelationshipData.IsUseFullFormTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.IsUseFullFormTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.IsUseFullFormTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.IsUseFullFormTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlRelationshipData.IsUseFullFormTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.IsRoleElementNameTrackingPropertyHandler">
            <summary>
            Tracking change handler for RoleElementName
            </summary>
            <summary>
            Value handler for the XmlRelationshipData.IsRoleElementNameTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.IsRoleElementNameTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlRelationshipData.IsRoleElementNameTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.IsRoleElementNameTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.IsRoleElementNameTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.IsRoleElementNameTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlRelationshipData.IsRoleElementNameTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.OmitElementPropertyHandler">
            <summary>
            Value handler for the XmlRelationshipData.OmitElement domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.OmitElementPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlRelationshipData.OmitElement domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.OmitElementPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.OmitElementPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.OmitElementPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlRelationshipData.OmitElement domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.UseFullFormPropertyHandler">
            <summary>
            Value handler for the XmlRelationshipData.UseFullForm domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.UseFullFormPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlRelationshipData.UseFullForm domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.UseFullFormPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.UseFullFormPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.UseFullFormPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlRelationshipData.UseFullForm domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.RoleElementNamePropertyHandler">
            <summary>
            Value handler for the XmlRelationshipData.RoleElementName domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.RoleElementNamePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlRelationshipData.RoleElementName domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.RoleElementNamePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.RoleElementNamePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.RoleElementNamePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlRelationshipData.RoleElementName domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.HasCustomMonikerSerializationPropertyHandler">
            <summary>
            Value handler for the XmlRelationshipData.HasCustomMonikerSerialization domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.HasCustomMonikerSerializationPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlRelationshipData.HasCustomMonikerSerialization domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.HasCustomMonikerSerializationPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.HasCustomMonikerSerializationPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData.HasCustomMonikerSerializationPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlRelationshipData.HasCustomMonikerSerialization domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData">
            <summary>
            DomainClass XmlPropertyData
            Defines how values of a specific domain property are serialized in xml.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.ValidateXmlPropertyDataMultiplicity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Checks that the relationships that have a multiplicity of One or OneMany do actually have a link.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.xmlNameStorage">
            <summary>
            Storage for XmlName DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.GetXmlNameValue">
            <summary>
            Gets the value of XmlName
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.SetXmlNameValue(System.String)">
            <summary>
            Sets the value of XmlName
            </summary>
            <param name="value"></param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.representationStorage">
            <summary>
            Storage for Representation DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.GetRepresentationValue">
            <summary>
            Gets the value of Representation
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.SetRepresentationValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyRepresentation)">
            <summary>
            Sets the value of Representation
            </summary>
            <param name="value"></param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.DomainClassId">
            <summary>
            XmlPropertyData domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.XmlNameDomainPropertyId">
            <summary>
            XmlName domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.RepresentationDomainPropertyId">
            <summary>
            Representation domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.IsMonikerKeyDomainPropertyId">
            <summary>
            IsMonikerKey domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.isMonikerKeyPropertyStorage">
            <summary>
            Storage for IsMonikerKey
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.IsMonikerQualifierDomainPropertyId">
            <summary>
            IsMonikerQualifier domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.isMonikerQualifierPropertyStorage">
            <summary>
            Storage for IsMonikerQualifier
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.IsXmlNameTrackingDomainPropertyId">
            <summary>
            IsXmlNameTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.isXmlNameTrackingPropertyStorage">
            <summary>
            Storage for IsXmlNameTracking
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.IsRepresentationTrackingDomainPropertyId">
            <summary>
            IsRepresentationTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.isRepresentationTrackingPropertyStorage">
            <summary>
            Storage for IsRepresentationTracking
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.CalculateXmlName">
            <summary>
            Calculates the value of XmlName
            </summary>
            <returns>The value of XmlName</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.CalculateRepresentation">
            <summary>
            Calculates the value of Representation
            </summary>
            <returns>The value of Representation</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.XmlName">
            <summary>
            Gets or sets the value of XmlName domain property.
            Name used for the xml attribute or element representing the property.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.Representation">
            <summary>
            Gets or sets the value of Representation domain property.
            If Attribute, the property is serialized as an xml attribute; if Element, it is
            serialized as an element; if Ignore, it is not serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.IsMonikerKey">
            <summary>
            Gets or sets the value of IsMonikerKey domain property.
            If True, the property is used as the key for creating monikers.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.IsMonikerQualifier">
            <summary>
            Gets or sets the value of IsMonikerQualifier domain property.
            If True, the property is used for creating the qualifier in monikers.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.IsXmlNameTracking">
            <summary>
            Gets or sets the value of IsXmlNameTracking domain property.
            If True, the XmlName property tracks other data in the DSL definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.IsRepresentationTracking">
            <summary>
            Gets or sets the value of IsRepresentationTracking domain property.
            If True, the Representation property tracks other data in the DSL definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.DomainProperty">
            <summary>
            Gets or sets DomainProperty.
            Property to which the xml serialization configuration data applies.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.IsXmlNameTrackingPropertyHandler">
            <summary>
            Tracking change handler for XmlName
            </summary>
            <summary>
            Value handler for the XmlPropertyData.IsXmlNameTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.IsXmlNameTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlPropertyData.IsXmlNameTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.IsXmlNameTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.IsXmlNameTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.IsXmlNameTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlPropertyData.IsXmlNameTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.IsRepresentationTrackingPropertyHandler">
            <summary>
            Tracking change handler for Representation
            </summary>
            <summary>
            Value handler for the XmlPropertyData.IsRepresentationTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.IsRepresentationTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlPropertyData.IsRepresentationTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.IsRepresentationTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.IsRepresentationTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.IsRepresentationTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlPropertyData.IsRepresentationTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.XmlNamePropertyHandler">
            <summary>
            Value handler for the XmlPropertyData.XmlName domain property.
            </summary>
            <summary>
            XmlName change handler
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.XmlNamePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlPropertyData.XmlName domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.XmlNamePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.XmlNamePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.XmlNamePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlPropertyData.XmlName domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.RepresentationPropertyHandler">
            <summary>
            Value handler for the XmlPropertyData.Representation domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.RepresentationPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlPropertyData.Representation domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.RepresentationPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.RepresentationPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData,Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyRepresentation)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.RepresentationPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlPropertyData.Representation domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.IsMonikerKeyPropertyHandler">
            <summary>
            Value handler for the XmlPropertyData.IsMonikerKey domain property.
            </summary>
            <summary>
            IsMonikerKey change handler
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.IsMonikerKeyPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlPropertyData.IsMonikerKey domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.IsMonikerKeyPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.IsMonikerKeyPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.IsMonikerKeyPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlPropertyData.IsMonikerKey domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.IsMonikerQualifierPropertyHandler">
            <summary>
            Value handler for the XmlPropertyData.IsMonikerQualifier domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.IsMonikerQualifierPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlPropertyData.IsMonikerQualifier domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.IsMonikerQualifierPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.IsMonikerQualifierPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData.IsMonikerQualifierPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlPropertyData.IsMonikerQualifier domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMap">
            <summary>
            DomainClass SwimLaneMap
            Defines a mapping between a swimlane and a domain class.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMap.ValidateSwimLaneMapMultiplicity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Checks that the relationships that have a multiplicity of One or OneMany do actually have a link.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMap.DomainClassId">
            <summary>
            SwimLaneMap domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMap.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMap.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMap.SetBaseShape(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShape)">
            <summary>
            Set the value of BaseShape using the appropriate concrete type
            </summary>
            <param name="shape"></param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMap.SwimLane">
            <summary>
            Gets or sets SwimLane.
            Swimlane being mapped.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNode">
            <summary>
            DomainClass InheritanceNode
            Node in a Dsl Designer diagram tree which references an inheritance link.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.ArcNode">
            <summary>
            DomainClass ArcNode
            Abstract class for nodes used in a Dsl Designer diagram tree.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.TreeNode">
            <summary>
            DomainClass TreeNode
            Abstract base class for nodes in a Dsl Designer diagram tree.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.TreeNode.DomainClassId">
            <summary>
            TreeNode domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.TreeNode.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.TreeNode.IsInheritanceTreeExpandedDomainPropertyId">
            <summary>
            IsInheritanceTreeExpanded domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.TreeNode.isInheritanceTreeExpandedPropertyStorage">
            <summary>
            Storage for IsInheritanceTreeExpanded
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.TreeNode.IsRelationshipTreeExpandedDomainPropertyId">
            <summary>
            IsRelationshipTreeExpanded domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.TreeNode.isRelationshipTreeExpandedPropertyStorage">
            <summary>
            Storage for IsRelationshipTreeExpanded
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.TreeNode.IsInheritanceTreeExpanded">
            <summary>
            Gets or sets the value of IsInheritanceTreeExpanded domain property.
            If True, the inheritance tree is expanded beneath this node.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.TreeNode.IsRelationshipTreeExpanded">
            <summary>
            Gets or sets the value of IsRelationshipTreeExpanded domain property.
            If True, the relationship tree is expanded beneath this node.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.TreeNode.Subject">
            <summary>
            The class that this node represents on the diagram
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.TreeNode.IsInheritanceTreeExpandedPropertyHandler">
            <summary>
            Value handler for the TreeNode.IsInheritanceTreeExpanded domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.TreeNode.IsInheritanceTreeExpandedPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the TreeNode.IsInheritanceTreeExpanded domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.TreeNode.IsInheritanceTreeExpandedPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDesigner.TreeNode)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.TreeNode.IsInheritanceTreeExpandedPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDesigner.TreeNode,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.TreeNode.IsInheritanceTreeExpandedPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the TreeNode.IsInheritanceTreeExpanded domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.TreeNode.IsRelationshipTreeExpandedPropertyHandler">
            <summary>
            Value handler for the TreeNode.IsRelationshipTreeExpanded domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.TreeNode.IsRelationshipTreeExpandedPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the TreeNode.IsRelationshipTreeExpanded domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.TreeNode.IsRelationshipTreeExpandedPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDesigner.TreeNode)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.TreeNode.IsRelationshipTreeExpandedPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDesigner.TreeNode,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.TreeNode.IsRelationshipTreeExpandedPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the TreeNode.IsRelationshipTreeExpanded domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.ArcNode.DomainClassId">
            <summary>
            ArcNode domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ArcNode.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.ArcNode.IsLeafDomainPropertyId">
            <summary>
            IsLeaf domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.ArcNode.isLeafPropertyStorage">
            <summary>
            Storage for IsLeaf
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ArcNode.GetArcNodesFromSubject(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets the arcs whose subject is the parameter
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ArcNode.GetArcNodesFromSource(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets the arcs whose source is the parameter
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ArcNode.TestDescendantOfSelf(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Test to see if an arc is a descendant of itself
            </summary>
            <param name="theClass"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ArcNode.OnDeleting">
            <summary>
            OnDeleting override for ArcNode to create a RootNode if this arcnode is a non-leaf node
            and it's being deleted because a class further up the tree got deleted. 
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ArcNode.IsLeaf">
            <summary>
            Gets or sets the value of IsLeaf domain property.
            Description for Microsoft.VisualStudio.Modeling.DslDesigner.ArcNode.IsLeaf
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ArcNode.DiagramTree">
            <summary>
            Gets or sets DiagramTree.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ArcNode.ArcSource">
            <summary>
            Get the element representing the LHS of the arc
            </summary>
            <returns>The element representing the LHS of the arc</returns>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.ArcNode.IsLeafPropertyHandler">
            <summary>
            Value handler for the ArcNode.IsLeaf domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.ArcNode.IsLeafPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the ArcNode.IsLeaf domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ArcNode.IsLeafPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDesigner.ArcNode)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ArcNode.IsLeafPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDesigner.ArcNode,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ArcNode.IsLeafPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the ArcNode.IsLeaf domain property.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNode.ValidateInheritanceNodeMultiplicity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Checks that the relationships that have a multiplicity of One or OneMany do actually have a link.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNode.DomainClassId">
            <summary>
            InheritanceNode domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNode.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNode.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNode.CanMerge(Microsoft.VisualStudio.Modeling.ProtoElementBase,Microsoft.VisualStudio.Modeling.ElementGroupPrototype)">
            <summary>
            Returns a value indicating whether the source element represented by the
            specified root ProtoElement can be added to this element.
            </summary>
            <param name="rootElement">
            The root ProtoElement representing a source element.  This can be null, 
            in which case the ElementGroupPrototype does not contain an ProtoElements
            and the code should inspect the ElementGroupPrototype context information.
            </param>
            <param name="elementGroupPrototype">The ElementGroupPrototype that contains the root ProtoElement.</param>
            <returns>true if the source element represented by the ProtoElement can be added to this target element.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNode.ChooseMergeTarget(Microsoft.VisualStudio.Modeling.ElementGroupPrototype)">
            <summary>
            Gets the ModelElement to be used as the target for the ElementGroupPrototype merge 
            process.  
            This is called by the merge process when this element is the target of the merge.  
            This provides this element with the opportunity to forward the target to something 
            other than itself.
            </summary>
            <param name="elementGroupPrototype">The ElementGroupPrototype that will be reconstituted and merged with the target element.</param>
            <returns>The ModelElement to use as the target for the merge process.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNode.ChooseMergeTarget(Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Gets the ModelElement to be used as the target for the ElementGroup merge 
            process.  
            This is called by the merge process when this element is the target of the merge.  
            This provides this element with the opportunity to forward the target to something 
            other than itself.
            </summary>
            <param name="elementGroup">The ElementGroup that will be merged with the target element.</param>
            <returns>The ModelElement to use as the target for the merge process.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNode.MergeRelate(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Called by the Merge process to create a relationship between 
            this target element and the specified source element. 
            Typically, a parent-child relationship is established
            between the target element (the parent) and the source element 
            (the child), but any relationship can be established.
            </summary>
            <param name="sourceElement">The element that is to be related to this model element.</param>
            <param name="elementGroup">The group of source ModelElements that have been rehydrated into the target store.</param>
            <remarks>
            This method is overriden to create the relationship between the target element and the specified source element.
            The base method does nothing.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNode.MergeDisconnect(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Performs operation opposite to MergeRelate - i.e. disconnects a given
            element from the current one (removes links created by MergeRelate).
            </summary>
            <param name="sourceElement">Element to be unmerged/disconnected.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNode.GetInheritanceNodesFromBaseClass(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets the nodes whose base classes is the parameter
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNode.GetInheritanceNodeFromSubClass(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets the single node whose subclass is the parameter
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNode.GetInheritanceNodeFromInheritanceLink(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree,Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass)">
            <summary>
            Gets the node whose link is the given parameter
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNode.InheritanceLink">
            <summary>
            Gets or sets InheritanceLink.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNode.Subject">
            <summary>
            The class that this node represents on the diagram
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNode.ArcSource">
            <summary>
            The LHS of the arc
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.RootNode">
            <summary>
            DomainClass RootNode
            Root node in a Dsl Designer diagram tree.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RootNode.ValidateRootNodeMultiplicity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Checks that the relationships that have a multiplicity of One or OneMany do actually have a link.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.RootNode.DomainClassId">
            <summary>
            RootNode domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RootNode.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RootNode.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RootNode.CanMerge(Microsoft.VisualStudio.Modeling.ProtoElementBase,Microsoft.VisualStudio.Modeling.ElementGroupPrototype)">
            <summary>
            Returns a value indicating whether the source element represented by the
            specified root ProtoElement can be added to this element.
            </summary>
            <param name="rootElement">
            The root ProtoElement representing a source element.  This can be null, 
            in which case the ElementGroupPrototype does not contain an ProtoElements
            and the code should inspect the ElementGroupPrototype context information.
            </param>
            <param name="elementGroupPrototype">The ElementGroupPrototype that contains the root ProtoElement.</param>
            <returns>true if the source element represented by the ProtoElement can be added to this target element.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RootNode.ChooseMergeTarget(Microsoft.VisualStudio.Modeling.ElementGroupPrototype)">
            <summary>
            Gets the ModelElement to be used as the target for the ElementGroupPrototype merge 
            process.  
            This is called by the merge process when this element is the target of the merge.  
            This provides this element with the opportunity to forward the target to something 
            other than itself.
            </summary>
            <param name="elementGroupPrototype">The ElementGroupPrototype that will be reconstituted and merged with the target element.</param>
            <returns>The ModelElement to use as the target for the merge process.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RootNode.ChooseMergeTarget(Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Gets the ModelElement to be used as the target for the ElementGroup merge 
            process.  
            This is called by the merge process when this element is the target of the merge.  
            This provides this element with the opportunity to forward the target to something 
            other than itself.
            </summary>
            <param name="elementGroup">The ElementGroup that will be merged with the target element.</param>
            <returns>The ModelElement to use as the target for the merge process.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RootNode.MergeRelate(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Called by the Merge process to create a relationship between 
            this target element and the specified source element. 
            Typically, a parent-child relationship is established
            between the target element (the parent) and the source element 
            (the child), but any relationship can be established.
            </summary>
            <param name="sourceElement">The element that is to be related to this model element.</param>
            <param name="elementGroup">The group of source ModelElements that have been rehydrated into the target store.</param>
            <remarks>
            This method is overriden to create the relationship between the target element and the specified source element.
            The base method does nothing.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RootNode.MergeDisconnect(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Performs operation opposite to MergeRelate - i.e. disconnects a given
            element from the current one (removes links created by MergeRelate).
            </summary>
            <param name="sourceElement">Element to be unmerged/disconnected.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RootNode.DiagramTree">
            <summary>
            Gets or sets DiagramTree.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RootNode.Class">
            <summary>
            Gets or sets Class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RootNode.Subject">
            <summary>
            The class that this node represents on the diagram
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.SourceRoleNode">
            <summary>
            DomainClass SourceRoleNode
            Node in a Dsl Designer diagram tree which references a source role.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.SourceRoleNode.ValidateSourceRoleNodeMultiplicity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Checks that the relationships that have a multiplicity of One or OneMany do actually have a link.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.SourceRoleNode.DomainClassId">
            <summary>
            SourceRoleNode domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.SourceRoleNode.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.SourceRoleNode.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.SourceRoleNode.CanMerge(Microsoft.VisualStudio.Modeling.ProtoElementBase,Microsoft.VisualStudio.Modeling.ElementGroupPrototype)">
            <summary>
            Returns a value indicating whether the source element represented by the
            specified root ProtoElement can be added to this element.
            </summary>
            <param name="rootElement">
            The root ProtoElement representing a source element.  This can be null, 
            in which case the ElementGroupPrototype does not contain an ProtoElements
            and the code should inspect the ElementGroupPrototype context information.
            </param>
            <param name="elementGroupPrototype">The ElementGroupPrototype that contains the root ProtoElement.</param>
            <returns>true if the source element represented by the ProtoElement can be added to this target element.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.SourceRoleNode.ChooseMergeTarget(Microsoft.VisualStudio.Modeling.ElementGroupPrototype)">
            <summary>
            Gets the ModelElement to be used as the target for the ElementGroupPrototype merge 
            process.  
            This is called by the merge process when this element is the target of the merge.  
            This provides this element with the opportunity to forward the target to something 
            other than itself.
            </summary>
            <param name="elementGroupPrototype">The ElementGroupPrototype that will be reconstituted and merged with the target element.</param>
            <returns>The ModelElement to use as the target for the merge process.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.SourceRoleNode.ChooseMergeTarget(Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Gets the ModelElement to be used as the target for the ElementGroup merge 
            process.  
            This is called by the merge process when this element is the target of the merge.  
            This provides this element with the opportunity to forward the target to something 
            other than itself.
            </summary>
            <param name="elementGroup">The ElementGroup that will be merged with the target element.</param>
            <returns>The ModelElement to use as the target for the merge process.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.SourceRoleNode.MergeRelate(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Called by the Merge process to create a relationship between 
            this target element and the specified source element. 
            Typically, a parent-child relationship is established
            between the target element (the parent) and the source element 
            (the child), but any relationship can be established.
            </summary>
            <param name="sourceElement">The element that is to be related to this model element.</param>
            <param name="elementGroup">The group of source ModelElements that have been rehydrated into the target store.</param>
            <remarks>
            This method is overriden to create the relationship between the target element and the specified source element.
            The base method does nothing.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.SourceRoleNode.MergeDisconnect(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Performs operation opposite to MergeRelate - i.e. disconnects a given
            element from the current one (removes links created by MergeRelate).
            </summary>
            <param name="sourceElement">Element to be unmerged/disconnected.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.SourceRoleNode.GetRoleNodesFromSource(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets the nodes whose source is the parameter
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.SourceRoleNode.GetRoleNodesFromRolePlayer(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets the nodes whose roleplayer is the parameter
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.SourceRoleNode.GetRoleNodeFromRole(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Gets the node whose role is the given parameter
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.SourceRoleNode.Role">
            <summary>
            Gets or sets Role.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.SourceRoleNode.Subject">
            <summary>
            The class that this node represents on the diagram
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.SourceRoleNode.ArcSource">
            <summary>
            The LHS of the arc
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState">
            <summary>
            DomainClass DslDesignerDiagramState
            Defines the state of a diagram representing a DSL definition.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState.ValidateDslDesignerDiagramStateMultiplicity(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Checks that the relationships that have a multiplicity of One or OneMany do actually have a link.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState.DomainClassId">
            <summary>
            DslDesignerDiagramState domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState.DeleteRootNode(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Remove any root node representing the given subject in either tree
            </summary>
            <param name="subject">Whether a root was found and deleted</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState.GetNodesFromSubject(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Find all nodes containing a class within either tree
            </summary>
            <param name="candidate"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState.GetArcNodesFromSubject(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets the arcs whose subject is the parameter in either tree
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState.GetRoleNodeFromRole(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Gets the SourceRoleNode for the given role in either tree
            </summary>
            <param name="role"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState.GetInheritanceNodeFromSubClass(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets the InheritanceNode for the given subClass in either tree
            </summary>
            <param name="subClass"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState.FindDefinition(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Find the definition node on the diagram for a given class
            </summary>
            <param name="subject">The class to find the definition of</param>
            <returns>The definiton node</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState.RelocateDefinition(Microsoft.VisualStudio.Modeling.DslDesigner.ArcNode)">
            <summary>
            Move the definition node to the given arc
            </summary>
            <param name="arc"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState.CreateRoot(Microsoft.VisualStudio.Modeling.DslDesigner.ArcNode)">
            <summary>
            Create a root from the given arc
            </summary>
            <param name="arc"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState.ReparentTreeNodesUnderClass(Microsoft.VisualStudio.Modeling.DslDesigner.TreeNode)">
            <summary>
            Reparent
            </summary>
            <param name="newDefinition">A newly enshrined definition TreeNode</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState.GetOppositeTree(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree)">
            <summary>
            Get the other tree to the one given.
            </summary>
            <param name="tree"></param>
            <returns>The opposite tree</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState.EnsureTrees">
            <summary>
            Make sure that the basic tree structures are present.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState.GetDefaultTreeForClass(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the correct default tree for a given class, ensuring that the intermediate structures are in place.
            </summary>
            <remarks>
            Don't use this except for creating brand new TreeNodes as classes can end up in either tree after user intervention.
            </remarks>
            <param name="theClass">The class to find the right tree for</param>
            <returns>The correct tree</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState.DiagramTrees">
            <summary>
            Gets a list of DiagramTrees.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState.Diagram">
            <summary>
            Gets or sets Diagram.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration">
            <summary>
            DomainClass DomainEnumeration
            Defines an enumeration.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainType">
            <summary>
            DomainClass DomainType
            Abstract base class for external types and enumerations.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainType.namespaceStorage">
            <summary>
            Storage for Namespace DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainType.GetNamespaceValue">
            <summary>
            Gets the value of Namespace
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainType.SetNamespaceValue(System.String)">
            <summary>
            Sets the value of Namespace
            </summary>
            <param name="value"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainType.CalculateNamespace">
            <summary>
            Calculates the value of Namespace
            </summary>
            <remarks>The base implementation just returns the storage, so that Namespace behaves like a regular property</remarks>
            <returns>The value of Namespace</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainType.DomainClassId">
            <summary>
            DomainType domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainType.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainType.NameDomainPropertyId">
            <summary>
            Name domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainType.namePropertyStorage">
            <summary>
            Storage for Name
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainType.NamespaceDomainPropertyId">
            <summary>
            Namespace domain property Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainType.GetFullName(System.Boolean)">
            <summary>
            Gets the fully qualified name of this domain type
            </summary>
            <param name="includeGlobal">whether or not to prepend 'global::' to the full name</param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainType.GetRelativeName(System.String,System.Boolean)">
            <summary>
            Gets the name of the domain type relative to the current namespace. If
            the current namespace is the same as this.Namespace, then we return this.Name. 
            If not, we return this.GetFullName()
            </summary>
            <param name="currentNamespace"></param>
            <param name="includeGlobal">whether or not to prepend 'global::' if the fully qualified name is returned</param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainType.OnNameChanged(System.String,System.String)">
            <summary>
            Called when the Name of a type changes
            </summary>
            <param name="oldValue"></param>
            <param name="newValue"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainType.OnNamespaceChanged(System.String,System.String)">
            <summary>
            Called when the Namespace of a type changes
            </summary>
            <param name="oldValue"></param>
            <param name="newValue"></param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainType.ProxyIsNamespaceTracking">
            <summary>
            Virtualized version of IsNamespaceTracking to cope with the fact that derived classes own the IsNamespaceTracking flags
            </summary>
            <remarks>
            Override to map to real IsNamespaceTracking property on classes where Namespace is a tracking property.
            </remarks>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainType.Name">
            <summary>
            Gets or sets the value of Name domain property.
            Name of the type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainType.Namespace">
            <summary>
            Gets or sets the value of Namespace domain property.
            Namespace affiliated with this type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainType.DslLibrary">
            <summary>
            Gets or sets DslLibrary.
            Dsl library defining the domain type.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainType.NamePropertyHandler">
            <summary>
            Value handler for the DomainType.Name domain property.
            </summary>
            <summary>
            Property handler for Name of a type changing
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainType.NamePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainType.Name domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainType.NamePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainType)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainType.NamePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainType,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainType.NamePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainType.Name domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainType.NamespacePropertyHandler">
            <summary>
            Value handler for the DomainType.Namespace domain property.
            </summary>
            <summary>
            Property handler for Namespace of a type changing
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainType.NamespacePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainType.Namespace domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainType.NamespacePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainType)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainType.NamespacePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainType,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainType.NamespacePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainType.Namespace domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.descriptionStorage">
            <summary>
            Storage for Description DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.GetDescriptionValue">
            <summary>
            Gets the value of Description
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.SetDescriptionValue(System.String)">
            <summary>
            Sets the value of Description
            </summary>
            <param name="value"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.CalculateNamespace">
            <summary>
            Calculates the value of Namespace
            </summary>
            <returns>The value of Namespace</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.DomainClassId">
            <summary>
            DomainEnumeration domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.IsFlagsDomainPropertyId">
            <summary>
            IsFlags domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.isFlagsPropertyStorage">
            <summary>
            Storage for IsFlags
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.AccessModifierDomainPropertyId">
            <summary>
            AccessModifier domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.accessModifierPropertyStorage">
            <summary>
            Storage for AccessModifier
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.DescriptionDomainPropertyId">
            <summary>
            Description domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.IsDescriptionTrackingDomainPropertyId">
            <summary>
            IsDescriptionTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.isDescriptionTrackingPropertyStorage">
            <summary>
            Storage for IsDescriptionTracking
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.CustomAttributesDomainPropertyId">
            <summary>
            CustomAttributes domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.IsNamespaceTrackingDomainPropertyId">
            <summary>
            IsNamespaceTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.isNamespaceTrackingPropertyStorage">
            <summary>
            Storage for IsNamespaceTracking
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.CanMerge(Microsoft.VisualStudio.Modeling.ProtoElementBase,Microsoft.VisualStudio.Modeling.ElementGroupPrototype)">
            <summary>
            Returns a value indicating whether the source element represented by the
            specified root ProtoElement can be added to this element.
            </summary>
            <param name="rootElement">
            The root ProtoElement representing a source element.  This can be null, 
            in which case the ElementGroupPrototype does not contain an ProtoElements
            and the code should inspect the ElementGroupPrototype context information.
            </param>
            <param name="elementGroupPrototype">The ElementGroupPrototype that contains the root ProtoElement.</param>
            <returns>true if the source element represented by the ProtoElement can be added to this target element.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.MergeRelate(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Called by the Merge process to create a relationship between 
            this target element and the specified source element. 
            Typically, a parent-child relationship is established
            between the target element (the parent) and the source element 
            (the child), but any relationship can be established.
            </summary>
            <param name="sourceElement">The element that is to be related to this model element.</param>
            <param name="elementGroup">The group of source ModelElements that have been rehydrated into the target store.</param>
            <remarks>
            This method is overriden to create the relationship between the target element and the specified source element.
            The base method does nothing.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.MergeDisconnect(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Performs operation opposite to MergeRelate - i.e. disconnects a given
            element from the current one (removes links created by MergeRelate).
            </summary>
            <param name="sourceElement">Element to be unmerged/disconnected.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.IsValidEnumDefault(System.String)">
            <summary>
            For the passed in enum default string (in "Enum1" or "F1 | F2 | F3" form), this method determines whether
            the enumDefaults conforms to the literals defined in DomainEnumeration
            </summary>
            <param name="enumDefaults"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.FindLiteral(System.String)">
            <summary>
            Given the literal name, this method returns the corresponding EnumerationLiteral
            </summary>
            <param name="literal">liternal name</param>
            <returns>null if we can't find one</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.GetCustomAttributesValue">
            <summary>
            Method to supply the readonly custom attribute CustomAttributes
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.MergeRelateEnumerationLiteral(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Custom merge method for adding a new literal into the DomainEnum
            </summary>
            <param name="sourceElement"></param>
            <param name="elementGroup"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.CalculateDescription">
            <summary>
            Calculates the value of Description
            </summary>
            <returns>The value of Description</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.CalculateNamespaceForDomainEnumeration">
            <summary>
            Calculates the value of Namespace
            </summary>
            <returns>The value of Namespace</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.OnNameChanged(System.String,System.String)">
            <summary>
            Name of enumeration changed
            </summary>
            <param name="oldValue"></param>
            <param name="newValue"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.OnNamespaceChanged(System.String,System.String)">
            <summary>
            Namespace of enumeration changed
            </summary>
            <param name="oldValue"></param>
            <param name="newValue"></param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.ProxyIsNamespaceTracking">
            <summary>
            Supply a storage-backed implementation of IsNamespaceTracking
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.IsFlags">
            <summary>
            Gets or sets the value of IsFlags domain property.
            If True, defines a flags enumeration.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.AccessModifier">
            <summary>
            Gets or sets the value of AccessModifier domain property.
            Determines if the access modifier for the domain enumeration is public or
            internal.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.Description">
            <summary>
            Gets or sets the value of Description domain property.
            Used in the UI and in the code documentation of the generated designer.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.IsDescriptionTracking">
            <summary>
            Gets or sets the value of IsDescriptionTracking domain property.
            If True, the Description property tracks other data in the DSL definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.CustomAttributes">
            <summary>
            Gets or sets the value of CustomAttributes domain property.
            Used to attribute the code generated from this element.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.IsNamespaceTracking">
            <summary>
            Gets or sets the value of IsNamespaceTracking domain property.
            If True, the Namespace property tracks other data in the DSL definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.Literals">
            <summary>
            Gets a list of Literals.
            Literals defined by the enumeration.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.Attributes">
            <summary>
            Gets a list of Attributes.
            Clr attributes defined for the enumeration.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.IsDescriptionTrackingPropertyHandler">
            <summary>
            Tracking change handler for Description
            </summary>
            <summary>
            Value handler for the DomainEnumeration.IsDescriptionTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.IsDescriptionTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainEnumeration.IsDescriptionTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.IsDescriptionTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.IsDescriptionTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.IsDescriptionTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainEnumeration.IsDescriptionTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.IsNamespaceTrackingPropertyHandler">
            <summary>
            Tracking change handler for Namespace
            </summary>
            <summary>
            Value handler for the DomainEnumeration.IsNamespaceTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.IsNamespaceTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainEnumeration.IsNamespaceTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.IsNamespaceTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.IsNamespaceTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.IsNamespaceTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainEnumeration.IsNamespaceTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.IsFlagsPropertyHandler">
            <summary>
            Value handler for the DomainEnumeration.IsFlags domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.IsFlagsPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainEnumeration.IsFlags domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.IsFlagsPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.IsFlagsPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.IsFlagsPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainEnumeration.IsFlags domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.AccessModifierPropertyHandler">
            <summary>
            Value handler for the DomainEnumeration.AccessModifier domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.AccessModifierPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainEnumeration.AccessModifier domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.AccessModifierPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.AccessModifierPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration,Microsoft.VisualStudio.Modeling.DslDefinition.TypeAccessModifier)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.AccessModifierPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainEnumeration.AccessModifier domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.DescriptionPropertyHandler">
            <summary>
            Value handler for the DomainEnumeration.Description domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.DescriptionPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainEnumeration.Description domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.DescriptionPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.DescriptionPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.DescriptionPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainEnumeration.Description domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.CustomAttributesPropertyHandler">
            <summary>
            Value handler for the DomainEnumeration.CustomAttributes domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.CustomAttributesPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainEnumeration.CustomAttributes domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.CustomAttributesPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration.CustomAttributesPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainEnumeration.CustomAttributes domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder">
            <summary>
            DomainClass ConnectionBuilder
            Defines a connection builder, which is used to create binary connections between
            model elements.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.nameStorage">
            <summary>
            Storage for Name DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.GetNameValue">
            <summary>
            Gets the value of Name
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.SetNameValue(System.String)">
            <summary>
            Sets the value of Name
            </summary>
            <param name="value"></param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.DomainClassId">
            <summary>
            ConnectionBuilder domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.NameDomainPropertyId">
            <summary>
            Name domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.IsCustomDomainPropertyId">
            <summary>
            IsCustom domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.isCustomPropertyStorage">
            <summary>
            Storage for IsCustom
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.IsNameTrackingDomainPropertyId">
            <summary>
            IsNameTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.isNameTrackingPropertyStorage">
            <summary>
            Storage for IsNameTracking
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.CanMerge(Microsoft.VisualStudio.Modeling.ProtoElementBase,Microsoft.VisualStudio.Modeling.ElementGroupPrototype)">
            <summary>
            Returns a value indicating whether the source element represented by the
            specified root ProtoElement can be added to this element.
            </summary>
            <param name="rootElement">
            The root ProtoElement representing a source element.  This can be null, 
            in which case the ElementGroupPrototype does not contain an ProtoElements
            and the code should inspect the ElementGroupPrototype context information.
            </param>
            <param name="elementGroupPrototype">The ElementGroupPrototype that contains the root ProtoElement.</param>
            <returns>true if the source element represented by the ProtoElement can be added to this target element.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.MergeRelate(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Called by the Merge process to create a relationship between 
            this target element and the specified source element. 
            Typically, a parent-child relationship is established
            between the target element (the parent) and the source element 
            (the child), but any relationship can be established.
            </summary>
            <param name="sourceElement">The element that is to be related to this model element.</param>
            <param name="elementGroup">The group of source ModelElements that have been rehydrated into the target store.</param>
            <remarks>
            This method is overriden to create the relationship between the target element and the specified source element.
            The base method does nothing.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.MergeDisconnect(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Performs operation opposite to MergeRelate - i.e. disconnects a given
            element from the current one (removes links created by MergeRelate).
            </summary>
            <param name="sourceElement">Element to be unmerged/disconnected.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.CalculateName">
            <summary>
            Calculates the value of Name
            </summary>
            <returns>The value of Name</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.Name">
            <summary>
            Gets or sets the value of Name domain property.
            Name of the connection builder.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.IsCustom">
            <summary>
            Gets or sets the value of IsCustom domain property.
            If True, the behavior of the connection builder is defined in custom code.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.IsNameTracking">
            <summary>
            Gets or sets the value of IsNameTracking domain property.
            If True, the Name property tracks other data in the DSL definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.LinkConnectDirectives">
            <summary>
            Gets a list of LinkConnectDirectives.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.DslLibrary">
            <summary>
            Gets or sets DslLibrary.
            Dsl library defining the connection builder.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.IsNameTrackingPropertyHandler">
            <summary>
            Tracking change handler for Name
            </summary>
            <summary>
            Value handler for the ConnectionBuilder.IsNameTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.IsNameTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the ConnectionBuilder.IsNameTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.IsNameTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.IsNameTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.IsNameTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the ConnectionBuilder.IsNameTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.NamePropertyHandler">
            <summary>
            Value handler for the ConnectionBuilder.Name domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.NamePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the ConnectionBuilder.Name domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.NamePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.NamePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.NamePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the ConnectionBuilder.Name domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.IsCustomPropertyHandler">
            <summary>
            Value handler for the ConnectionBuilder.IsCustom domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.IsCustomPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the ConnectionBuilder.IsCustom domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.IsCustomPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.IsCustomPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder.IsCustomPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the ConnectionBuilder.IsCustom domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab">
            <summary>
            DomainClass ToolboxTab
            Defines the collection of tools that appear on a single tab in the toolbox.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab.tabTextStorage">
            <summary>
            Storage for TabText DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab.GetTabTextValue">
            <summary>
            Gets the value of TabText
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab.SetTabTextValue(System.String)">
            <summary>
            Sets the value of TabText
            </summary>
            <param name="value"></param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab.DomainClassId">
            <summary>
            ToolboxTab domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab.TabTextDomainPropertyId">
            <summary>
            TabText domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab.IsTabTextTrackingDomainPropertyId">
            <summary>
            IsTabTextTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab.isTabTextTrackingPropertyStorage">
            <summary>
            Storage for IsTabTextTracking
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab.CanMerge(Microsoft.VisualStudio.Modeling.ProtoElementBase,Microsoft.VisualStudio.Modeling.ElementGroupPrototype)">
            <summary>
            Returns a value indicating whether the source element represented by the
            specified root ProtoElement can be added to this element.
            </summary>
            <param name="rootElement">
            The root ProtoElement representing a source element.  This can be null, 
            in which case the ElementGroupPrototype does not contain an ProtoElements
            and the code should inspect the ElementGroupPrototype context information.
            </param>
            <param name="elementGroupPrototype">The ElementGroupPrototype that contains the root ProtoElement.</param>
            <returns>true if the source element represented by the ProtoElement can be added to this target element.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab.MergeRelate(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Called by the Merge process to create a relationship between 
            this target element and the specified source element. 
            Typically, a parent-child relationship is established
            between the target element (the parent) and the source element 
            (the child), but any relationship can be established.
            </summary>
            <param name="sourceElement">The element that is to be related to this model element.</param>
            <param name="elementGroup">The group of source ModelElements that have been rehydrated into the target store.</param>
            <remarks>
            This method is overriden to create the relationship between the target element and the specified source element.
            The base method does nothing.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab.MergeDisconnect(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Performs operation opposite to MergeRelate - i.e. disconnects a given
            element from the current one (removes links created by MergeRelate).
            </summary>
            <param name="sourceElement">Element to be unmerged/disconnected.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab.CalculateTabText">
            <summary>
            Calculates the value of TabText
            </summary>
            <returns>The value of TabText</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab.ValidateTools(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Validate tools in this Tab. 
            We do them here rather than in their own class because some constraints depend on access to the Editor.
            </summary>
            <param name="context"></param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab.TabText">
            <summary>
            Gets or sets the value of TabText domain property.
            Text used to label the tab.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab.IsTabTextTracking">
            <summary>
            Gets or sets the value of IsTabTextTracking domain property.
            If True, the TabText property tracks other data in the DSL definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab.Tools">
            <summary>
            Gets a list of Tools.
            Tools in the toolbox tab.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab.Editor">
            <summary>
            Gets or sets Editor.
            The editor defining the toolbox tab.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab.IsTabTextTrackingPropertyHandler">
            <summary>
            Tracking change handler for TabText
            </summary>
            <summary>
            Value handler for the ToolboxTab.IsTabTextTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab.IsTabTextTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the ToolboxTab.IsTabTextTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab.IsTabTextTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab.IsTabTextTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab.IsTabTextTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the ToolboxTab.IsTabTextTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab.TabTextPropertyHandler">
            <summary>
            Value handler for the ToolboxTab.TabText domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab.TabTextPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the ToolboxTab.TabText domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab.TabTextPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab.TabTextPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab.TabTextPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the ToolboxTab.TabText domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior">
            <summary>
            DomainClass ExplorerBehavior
            Defines custom explorer behavior for designated nodes.
            </summary>
            <summary>
            Partial class to implement IPathHost
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior.nameStorage">
            <summary>
            Storage for Name DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior.GetNameValue">
            <summary>
            Gets the value of Name
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior.SetNameValue(System.String)">
            <summary>
            Sets the value of Name
            </summary>
            <param name="value"></param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior.DomainClassId">
            <summary>
            ExplorerBehavior domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior.NameDomainPropertyId">
            <summary>
            Name domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior.IsNameTrackingDomainPropertyId">
            <summary>
            IsNameTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior.isNameTrackingPropertyStorage">
            <summary>
            Storage for IsNameTracking
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior.CanMerge(Microsoft.VisualStudio.Modeling.ProtoElementBase,Microsoft.VisualStudio.Modeling.ElementGroupPrototype)">
            <summary>
            Returns a value indicating whether the source element represented by the
            specified root ProtoElement can be added to this element.
            </summary>
            <param name="rootElement">
            The root ProtoElement representing a source element.  This can be null, 
            in which case the ElementGroupPrototype does not contain an ProtoElements
            and the code should inspect the ElementGroupPrototype context information.
            </param>
            <param name="elementGroupPrototype">The ElementGroupPrototype that contains the root ProtoElement.</param>
            <returns>true if the source element represented by the ProtoElement can be added to this target element.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior.MergeRelate(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Called by the Merge process to create a relationship between 
            this target element and the specified source element. 
            Typically, a parent-child relationship is established
            between the target element (the parent) and the source element 
            (the child), but any relationship can be established.
            </summary>
            <param name="sourceElement">The element that is to be related to this model element.</param>
            <param name="elementGroup">The group of source ModelElements that have been rehydrated into the target store.</param>
            <remarks>
            This method is overriden to create the relationship between the target element and the specified source element.
            The base method does nothing.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior.MergeDisconnect(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Performs operation opposite to MergeRelate - i.e. disconnects a given
            element from the current one (removes links created by MergeRelate).
            </summary>
            <param name="sourceElement">Element to be unmerged/disconnected.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior.CalculateName">
            <summary>
            Calculates the value of Name
            </summary>
            <returns>The value of Name</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior.Name">
            <summary>
            Gets or sets the value of Name domain property.
            Identifier for referencing the explorer behavior.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior.IsNameTracking">
            <summary>
            Gets or sets the value of IsNameTracking domain property.
            If True, the Name property tracks other data in the DSL definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior.DslLibrary">
            <summary>
            Gets or sets DslLibrary.
            Dsl library defining the explorer behavior.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior.HiddenNodes">
            <summary>
            Gets a list of HiddenNodes.
            Paths to elements whose explorer nodes should be hidden.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior.CustomNodeSettings">
            <summary>
            Gets a list of CustomNodeSettings.
            Custom node settings defined for the explorer behavior.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior.IsNameTrackingPropertyHandler">
            <summary>
            Tracking change handler for Name
            </summary>
            <summary>
            Value handler for the ExplorerBehavior.IsNameTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior.IsNameTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the ExplorerBehavior.IsNameTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior.IsNameTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior.IsNameTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior.IsNameTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the ExplorerBehavior.IsNameTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior.NamePropertyHandler">
            <summary>
            Value handler for the ExplorerBehavior.Name domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior.NamePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the ExplorerBehavior.Name domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior.NamePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior.NamePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior.NamePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the ExplorerBehavior.Name domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator">
            <summary>
            DomainClass Decorator
            Defines a decorator for a shape or connector.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator.displayNameStorage">
            <summary>
            Storage for DisplayName DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator.GetDisplayNameValue">
            <summary>
            Gets the value of DisplayName
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator.SetDisplayNameValue(System.String)">
            <summary>
            Sets the value of DisplayName
            </summary>
            <param name="value"></param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator.DomainClassId">
            <summary>
            Decorator domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator.NameDomainPropertyId">
            <summary>
            Name domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator.namePropertyStorage">
            <summary>
            Storage for Name
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator.DisplayNameDomainPropertyId">
            <summary>
            DisplayName domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator.IsDisplayNameTrackingDomainPropertyId">
            <summary>
            IsDisplayNameTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator.isDisplayNameTrackingPropertyStorage">
            <summary>
            Storage for IsDisplayNameTracking
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator.CalculateDisplayName">
            <summary>
            Calculates the value of DisplayName
            </summary>
            <returns>The value of DisplayName</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator.OnNameChanged(System.String,System.String)">
            <summary>
            Called when the Name of a Decorator changes
            </summary>
            <param name="oldValue"></param>
            <param name="newValue"></param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator.Name">
            <summary>
            Gets or sets the value of Name domain property.
            Name of the decorator.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator.DisplayName">
            <summary>
            Gets or sets the value of DisplayName domain property.
            The name that will be displayed in the generated designer for this decorator.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator.IsDisplayNameTracking">
            <summary>
            Gets or sets the value of IsDisplayNameTracking domain property.
            If True, the Name property tracks other data in the DSL definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator.DiagramElement">
            <summary>
            Gets or sets DiagramElement.
            Diagram element to which the decorator belongs.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator.IsDisplayNameTrackingPropertyHandler">
            <summary>
            Tracking change handler for DisplayName
            </summary>
            <summary>
            Value handler for the Decorator.IsDisplayNameTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator.IsDisplayNameTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Decorator.IsDisplayNameTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator.IsDisplayNameTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Decorator)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator.IsDisplayNameTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Decorator,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator.IsDisplayNameTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Decorator.IsDisplayNameTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator.NamePropertyHandler">
            <summary>
            Value handler for the Decorator.Name domain property.
            </summary>
            <summary>
            Add a change handler to name to update DisplayName
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator.NamePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Decorator.Name domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator.NamePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Decorator)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator.NamePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Decorator,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator.NamePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Decorator.Name domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator.DisplayNamePropertyHandler">
            <summary>
            Value handler for the Decorator.DisplayName domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator.DisplayNamePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Decorator.DisplayName domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator.DisplayNamePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Decorator)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator.DisplayNamePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Decorator,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Decorator.DisplayNamePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Decorator.DisplayName domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator">
            <summary>
            DomainClass TextDecorator
            Defines a decorator that displays text.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.defaultTextStorage">
            <summary>
            Storage for DefaultText DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.GetDefaultTextValue">
            <summary>
            Gets the value of DefaultText
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.SetDefaultTextValue(System.String)">
            <summary>
            Sets the value of DefaultText
            </summary>
            <param name="value"></param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.DomainClassId">
            <summary>
            TextDecorator domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.DefaultTextDomainPropertyId">
            <summary>
            DefaultText domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.FontStyleDomainPropertyId">
            <summary>
            FontStyle domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.fontStylePropertyStorage">
            <summary>
            Storage for FontStyle
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.FontSizeDomainPropertyId">
            <summary>
            FontSize domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.fontSizePropertyStorage">
            <summary>
            Storage for FontSize
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.IsDefaultTextTrackingDomainPropertyId">
            <summary>
            IsDefaultTextTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.isDefaultTextTrackingPropertyStorage">
            <summary>
            Storage for IsDefaultTextTracking
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.CalculateDefaultText">
            <summary>
            Calculates the value of DefaultText
            </summary>
            <returns>The value of DefaultText</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.OnNameChanged(System.String,System.String)">
            <summary>
            Handler for the Name of a TextDecorator changing
            </summary>
            <param name="oldValue"></param>
            <param name="newValue"></param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.DefaultText">
            <summary>
            Gets or sets the value of DefaultText domain property.
            Default text to be displayed, when the decorator is unmapped.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.FontStyle">
            <summary>
            Gets or sets the value of FontStyle domain property.
            Font style for the text displayed in the decorator.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.FontSize">
            <summary>
            Gets or sets the value of FontSize domain property.
            Font size for the text displayed in the decorator.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.IsDefaultTextTracking">
            <summary>
            Gets or sets the value of IsDefaultTextTracking domain property.
            If True, the DefaultText property tracks other data in the DSL definition.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.IsDefaultTextTrackingPropertyHandler">
            <summary>
            Tracking change handler for DefaultText
            </summary>
            <summary>
            Value handler for the TextDecorator.IsDefaultTextTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.IsDefaultTextTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the TextDecorator.IsDefaultTextTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.IsDefaultTextTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.IsDefaultTextTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.IsDefaultTextTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the TextDecorator.IsDefaultTextTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.DefaultTextPropertyHandler">
            <summary>
            Value handler for the TextDecorator.DefaultText domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.DefaultTextPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the TextDecorator.DefaultText domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.DefaultTextPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.DefaultTextPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.DefaultTextPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the TextDecorator.DefaultText domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.FontStylePropertyHandler">
            <summary>
            Value handler for the TextDecorator.FontStyle domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.FontStylePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the TextDecorator.FontStyle domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.FontStylePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.FontStylePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator,System.Drawing.FontStyle)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.FontStylePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the TextDecorator.FontStyle domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.FontSizePropertyHandler">
            <summary>
            Value handler for the TextDecorator.FontSize domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.FontSizePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the TextDecorator.FontSize domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.FontSizePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.FontSizePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator,System.Int32)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecorator.FontSizePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the TextDecorator.FontSize domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement">
            <summary>
            DomainClass DiagramElement
            Abstract base class for the definition of diagram elements, including shapes and
            connectors.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.fixedTooltipTextStorage">
            <summary>
            Storage for FixedTooltipText DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.GetFixedTooltipTextValue">
            <summary>
            Gets the value of FixedTooltipText
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.SetFixedTooltipTextValue(System.String)">
            <summary>
            Sets the value of FixedTooltipText
            </summary>
            <param name="value"></param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.DomainClassId">
            <summary>
            DiagramElement domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.TooltipTypeDomainPropertyId">
            <summary>
            TooltipType domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.tooltipTypePropertyStorage">
            <summary>
            Storage for TooltipType
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.FixedTooltipTextDomainPropertyId">
            <summary>
            FixedTooltipText domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.IsFixedTooltipTextTrackingDomainPropertyId">
            <summary>
            IsFixedTooltipTextTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.isFixedTooltipTextTrackingPropertyStorage">
            <summary>
            Storage for IsFixedTooltipTextTracking
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.TextColorDomainPropertyId">
            <summary>
            TextColor domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.textColorPropertyStorage">
            <summary>
            Storage for TextColor
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.ExposesTextColorDomainPropertyId">
            <summary>
            ExposesTextColor domain property Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.GetExposesTextColorValue">
            <summary>
            Calculated property calculator for ExposesTextColor
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.CalculateFixedTooltipText">
            <summary>
            Calculates the value of FixedTooltipText
            </summary>
            <returns>The value of FixedTooltipText</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.OnNameChanged(System.String,System.String)">
            <summary>
            Name of DiagramElement changed
            </summary>
            <param name="oldValue"></param>
            <param name="newValue"></param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.TooltipType">
            <summary>
            Gets or sets the value of TooltipType domain property.
            If Fixed, the fixed tooltip text is used as the tooltip, if variable the tooltip
            is defined in custom code.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.FixedTooltipText">
            <summary>
            Gets or sets the value of FixedTooltipText domain property.
            Text used for a fixed tooltip.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.IsFixedTooltipTextTracking">
            <summary>
            Gets or sets the value of IsFixedTooltipTextTracking domain property.
            If True, the FixedTooltipText property tracks other data in the DSL definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.TextColor">
            <summary>
            Gets or sets the value of TextColor domain property.
            Color used for text decorators associated with this diagram element.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.ExposesTextColor">
            <summary>
            Gets or sets the value of ExposesTextColor domain property.
            If True, a domain property has been added to the connector to allow the text
            color to be exposed in the properties window of the generated designer.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.Decorators">
            <summary>
            Gets a list of Decorators.
            Decorators for the diagram element.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.DslLibrary">
            <summary>
            Gets or sets DslLibrary.
            Dsl library defining the diagram element.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.IsFixedTooltipTextTrackingPropertyHandler">
            <summary>
            Tracking change handler for FixedTooltipText
            </summary>
            <summary>
            Value handler for the DiagramElement.IsFixedTooltipTextTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.IsFixedTooltipTextTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DiagramElement.IsFixedTooltipTextTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.IsFixedTooltipTextTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.IsFixedTooltipTextTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.IsFixedTooltipTextTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DiagramElement.IsFixedTooltipTextTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.TooltipTypePropertyHandler">
            <summary>
            Value handler for the DiagramElement.TooltipType domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.TooltipTypePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DiagramElement.TooltipType domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.TooltipTypePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.TooltipTypePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement,Microsoft.VisualStudio.Modeling.DslDefinition.TooltipType)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.TooltipTypePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DiagramElement.TooltipType domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.FixedTooltipTextPropertyHandler">
            <summary>
            Value handler for the DiagramElement.FixedTooltipText domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.FixedTooltipTextPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DiagramElement.FixedTooltipText domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.FixedTooltipTextPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.FixedTooltipTextPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.FixedTooltipTextPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DiagramElement.FixedTooltipText domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.TextColorPropertyHandler">
            <summary>
            Value handler for the DiagramElement.TextColor domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.TextColorPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DiagramElement.TextColor domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.TextColorPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.TextColorPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement,System.Drawing.Color)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.TextColorPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DiagramElement.TextColor domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.ExposesTextColorPropertyHandler">
            <summary>
            Value handler for the DiagramElement.ExposesTextColor domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.ExposesTextColorPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DiagramElement.ExposesTextColor domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.ExposesTextColorPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement.ExposesTextColorPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DiagramElement.ExposesTextColor domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior">
            <summary>
            DomainClass XmlSerializationBehavior
            Defines how elements of the domain classes included in the DSL or DSL library
            definition are serialized as xml.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.nameStorage">
            <summary>
            Storage for Name DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.GetNameValue">
            <summary>
            Gets the value of Name
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.SetNameValue(System.String)">
            <summary>
            Sets the value of Name
            </summary>
            <param name="value"></param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.namespaceStorage">
            <summary>
            Storage for Namespace DomainProperty
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.GetNamespaceValue">
            <summary>
            Gets the value of Namespace
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.SetNamespaceValue(System.String)">
            <summary>
            Sets the value of Namespace
            </summary>
            <param name="value"></param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.DomainClassId">
            <summary>
            XmlSerializationBehavior domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.NameDomainPropertyId">
            <summary>
            Name domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.IsNameTrackingDomainPropertyId">
            <summary>
            IsNameTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.isNameTrackingPropertyStorage">
            <summary>
            Storage for IsNameTracking
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.NamespaceDomainPropertyId">
            <summary>
            Namespace domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.IsNamespaceTrackingDomainPropertyId">
            <summary>
            IsNamespaceTracking domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.isNamespaceTrackingPropertyStorage">
            <summary>
            Storage for IsNamespaceTracking
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.CanMerge(Microsoft.VisualStudio.Modeling.ProtoElementBase,Microsoft.VisualStudio.Modeling.ElementGroupPrototype)">
            <summary>
            Returns a value indicating whether the source element represented by the
            specified root ProtoElement can be added to this element.
            </summary>
            <param name="rootElement">
            The root ProtoElement representing a source element.  This can be null, 
            in which case the ElementGroupPrototype does not contain an ProtoElements
            and the code should inspect the ElementGroupPrototype context information.
            </param>
            <param name="elementGroupPrototype">The ElementGroupPrototype that contains the root ProtoElement.</param>
            <returns>true if the source element represented by the ProtoElement can be added to this target element.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.MergeRelate(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Called by the Merge process to create a relationship between 
            this target element and the specified source element. 
            Typically, a parent-child relationship is established
            between the target element (the parent) and the source element 
            (the child), but any relationship can be established.
            </summary>
            <param name="sourceElement">The element that is to be related to this model element.</param>
            <param name="elementGroup">The group of source ModelElements that have been rehydrated into the target store.</param>
            <remarks>
            This method is overriden to create the relationship between the target element and the specified source element.
            The base method does nothing.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.MergeDisconnect(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Performs operation opposite to MergeRelate - i.e. disconnects a given
            element from the current one (removes links created by MergeRelate).
            </summary>
            <param name="sourceElement">Element to be unmerged/disconnected.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.CalculateName">
            <summary>
            Calculates the value of Name
            </summary>
            <returns>The value of Name</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.CalculateNamespace">
            <summary>
            Calculates the value of Namespace
            </summary>
            <returns>The value of Namespace</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.GetFullName(System.Boolean)">
            <summary>
            Gets the fully qualified name of the XmlSerializationBehavior
            </summary>
            <param name="includeGlobal">whether or not to prepend 'global::' to the full name</param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.GetRelativeName(System.String,System.Boolean)">
            <summary>
            Gets the name of the xml serialization behavior relative to the current namespace. If
            the current namespace is the same as this.Namespace, then we return this.Name. 
            If not, we return this.GetFullName()
            </summary>
            <param name="currentNamespace"></param>
            <param name="includeGlobal">whether or not to prepend 'global::' if the full name is returned</param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.FindClassData(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Locate the XmlClassData for the given class
            </summary>
            <param name="classToFind"></param>
            <returns></returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.Name">
            <summary>
            Gets or sets the value of Name domain property.
            Name used for reference.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.IsNameTracking">
            <summary>
            Gets or sets the value of IsNameTracking domain property.
            If True, the Name property tracks other data in the DSL definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.Namespace">
            <summary>
            Gets or sets the value of Namespace domain property.
            Namespace of the classes generated from the XmlSerializationBehavior.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.IsNamespaceTracking">
            <summary>
            Gets or sets the value of IsNamespaceTracking domain property.
            If True, the Namespace property tracks other data in the DSL definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.DslLibrary">
            <summary>
            Gets or sets DslLibrary.
            Dsl library defining the xml serialization behavior.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.ClassData">
            <summary>
            Gets a list of ClassData.
            Xml serialization configuration data defined by this behavior, indexed by class.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.IsNameTrackingPropertyHandler">
            <summary>
            Tracking change handler for Name
            </summary>
            <summary>
            Value handler for the XmlSerializationBehavior.IsNameTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.IsNameTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlSerializationBehavior.IsNameTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.IsNameTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.IsNameTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.IsNameTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlSerializationBehavior.IsNameTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.IsNamespaceTrackingPropertyHandler">
            <summary>
            Tracking change handler for Namespace
            </summary>
            <summary>
            Value handler for the XmlSerializationBehavior.IsNamespaceTracking domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.IsNamespaceTrackingPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlSerializationBehavior.IsNamespaceTracking domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.IsNamespaceTrackingPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.IsNamespaceTrackingPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.IsNamespaceTrackingPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlSerializationBehavior.IsNamespaceTracking domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.NamePropertyHandler">
            <summary>
            Value handler for the XmlSerializationBehavior.Name domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.NamePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlSerializationBehavior.Name domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.NamePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.NamePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.NamePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlSerializationBehavior.Name domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.NamespacePropertyHandler">
            <summary>
            Value handler for the XmlSerializationBehavior.Namespace domain property.
            </summary>
            <summary>
            Handle Namespace changes
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.NamespacePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the XmlSerializationBehavior.Namespace domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.NamespacePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.NamespacePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.NamespacePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the XmlSerializationBehavior.Namespace domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.ClassDataChecker">
            <summary>
            Helper for checking role and property names.
            Create one of these and then call it for each class in the model.
            Caches names of classes already seen.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.ClassDataChecker.CheckRoleAndPropertyNames(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,System.Boolean)">
            <summary>
            Check role and property names of a class for duplication among siblings and ancestors.
            </summary>
            <param name="domainClass"></param>
            <param name="xmlNames">Use the XML property and role names.</param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior.ClassDataChecker.VerifyNoClash(System.Collections.Generic.Dictionary{System.String,Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement},System.String,Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,System.Boolean)">
            <summary>
            Report any duplicate names, and add this one to the dictionary.
            </summary>
            <param name="names"></param>
            <param name="name">Dictionary of names to roles or properties</param>
            <param name="element">Role or Property</param>
            <param name="ownerClass"></param>
            <param name="xmlData">The name is the XML name of the role or property</param>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DslDefinitionModelElementTypeDescriptor">
            <summary>
            TypeDescriptor for DomainPath or PropertyPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DslDefinitionModelElementTypeDescriptor.#ctor(System.ComponentModel.ICustomTypeDescriptor,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            DslDefinitionModelElementTypeDescriptor ctor. It's calling base class directly.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DslDefinitionModelElementTypeDescriptor.GetProperties">
            <summary>
            Override base to supply property descriptors for each property in the model elemnt.
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DslDefinitionModelElementTypeDescriptor.GetProperties(System.Attribute[])">
            <summary>
            Method to supply our own set of property descriptors for the designated ModelElement.
            </summary>
            <param name="attributes"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DslDefinitionModelElementTypeDescriptor.CreatePropertyDescriptor(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainPropertyInfo,System.Attribute[])">
            <summary>
            Create the PropertyDescriptor for a given DomainProperty
            </summary>
            <param name="requestor"></param>
            <param name="domainPropertyInfo"></param>
            <param name="attributes"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DslDefinitionModelElementTypeDescriptor.CreateRolePlayerPropertyDescriptor(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRoleInfo,System.Attribute[])">
            <summary>
            Method to create a PropertyDescriptor which describes a relationship and role to be displayed in the grid.
            </summary>
            <param name="sourceRolePlayer">ModelElement playing the source role.</param>
            <param name="targetRoleInfo">DomainRoleInfo describing the target role.</param>
            <param name="sourceDomainRoleInfoAttributes">Attributes on the source DomainRoleInfo</param>
            <returns>RolePlayerPropertyDescriptor</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DslDefinitionModelElementTypeDescriptor.ShouldCreatePropertyDescriptor(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainPropertyInfo)">
            <summary>
            Gets whether to create type descriptor for a givne property.
            </summary>
            <param name="requestor">Element.</param>
            <param name="domainProperty">Property.</param>
            <returns>True to create descriptor and false otherwise.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DslDefinitionModelElementTypeDescriptor.CreateEditorIconPropertyDescriptor(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainPropertyInfo,System.Attribute[])">
            <summary>
            If this is Editor.Icon property, we will have to provide our own prop desc. This is so that we can update the File.ico file if user changes 
            Ediro.Icon 
            </summary>
            <param name="requestor"></param>
            <param name="domainPropertyInfo"></param>
            <param name="attributes"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DslDefinitionModelElementTypeDescriptor.CreateDomainEnumPropertyDescriptor(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainPropertyInfo,System.Attribute[])">
            <summary>
            If this is the DefaultValue domain property whose type is of DomainEnumeration, we will supply our own DomainEnumPropertyDescriptor.
            If not, return null so the caller can call the base.
            </summary>
            <param name="requestor"></param>
            <param name="domainPropertyInfo"></param>
            <param name="attributes"></param>
            <returns></returns>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase">
            <summary>
            Helper class for serializing and deserializing DslDefinitionModel models.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.ResetTrackingProperties(Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Reset IsXxxTracking properties to their natural values based on comparing storage with calculation
            </summary>
            <param name="store"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.#ctor">
            <summary>
            Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.LoadModel(Microsoft.VisualStudio.Modeling.Store,System.String,Microsoft.VisualStudio.Modeling.ISchemaResolver,Microsoft.VisualStudio.Modeling.Validation.ValidationController)">
            <summary>
            Loads a DslLibrary instance into the default partition of the given store, and ignore serialization result.
            </summary>
            <param name="store">The new DslLibrary instance will be created into the default partition of this store.</param>
            <param name="fileName">Name of the file from which the DslLibrary instance will be deserialized.</param>
            <param name="schemaResolver">
            An ISchemaResolver that allows the serializer to do schema validation on the root element (and everything inside it).
            If null is passed, schema validation will not be performed.
            </param>
            <param name="validationController">
            A ValidationController that will be used to do load-time validation (validations with validation category "Load"). If null
            is passed, load-time validation will not be performed.
            </param>
            <returns>The loaded DslLibrary instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.LoadModel(Microsoft.VisualStudio.Modeling.SerializationResult,Microsoft.VisualStudio.Modeling.Store,System.String,Microsoft.VisualStudio.Modeling.ISchemaResolver,Microsoft.VisualStudio.Modeling.Validation.ValidationController)">
            <summary>
            Loads a DslLibrary instance into the default partition of the given store.
            </summary>
            <param name="serializationResult">Stores serialization result from the load operation.</param>
            <param name="store">The new DslLibrary instance will be created into the default partition of this store.</param>
            <param name="fileName">Name of the file from which the DslLibrary instance will be deserialized.</param>
            <param name="schemaResolver">
            An ISchemaResolver that allows the serializer to do schema validation on the root element (and everything inside it).
            If null is passed, schema validation will not be performed.
            </param>
            <param name="validationController">
            A ValidationController that will be used to do load-time validation (validations with validation category "Load"). If null
            is passed, load-time validation will not be performed.
            </param>
            <returns>The loaded DslLibrary instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.LoadModel(Microsoft.VisualStudio.Modeling.SerializationResult,Microsoft.VisualStudio.Modeling.Partition,System.String,Microsoft.VisualStudio.Modeling.ISchemaResolver,Microsoft.VisualStudio.Modeling.Validation.ValidationController)">
            <summary>
            Loads a DslLibrary instance.
            </summary>
            <param name="serializationResult">Stores serialization result from the load operation.</param>
            <param name="partition">Partition in which the new DslLibrary instance will be created.</param>
            <param name="fileName">Name of the file from which the DslLibrary instance will be deserialized.</param>
            <param name="schemaResolver">
            An ISchemaResolver that allows the serializer to do schema validation on the root element (and everything inside it).
            If null is passed, schema validation will not be performed.
            </param>
            <param name="validationController">
            A ValidationController that will be used to do load-time validation (validations with validation category "Load"). If null
            is passed, load-time validation will not be performed.
            </param>
            <returns>The loaded DslLibrary instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.SaveModel(Microsoft.VisualStudio.Modeling.SerializationResult,Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,System.String)">
            <summary>
            Saves the given model root to the given file, with default encoding (UTF-8), and optional properties with default value will not
            be written out.
            </summary>
            <param name="serializationResult">Stores serialization result from the save operation.</param>
            <param name="modelRoot">DslLibrary instance to be saved.</param>
            <param name="fileName">Name of the file in which the DslLibrary instance will be saved.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.SaveModel(Microsoft.VisualStudio.Modeling.SerializationResult,Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,System.String,System.Boolean)">
            <summary>
            Saves the given model to the given file, with default encoding (UTF-8).
            </summary>
            <param name="serializationResult">Stores serialization result from the save operation.</param>
            <param name="modelRoot">DslLibrary instance to be saved.</param>
            <param name="fileName">Name of the file in which the DslLibrary instance will be saved.</param>
            <param name="writeOptionalPropertiesWithDefaultValue">Whether optional properties with default value will be saved.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.SaveModel(Microsoft.VisualStudio.Modeling.SerializationResult,Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,System.String,System.Text.Encoding,System.Boolean)">
            <summary>
            Saves the given model root to the given file, with specified encoding.
            </summary>
            <param name="serializationResult">Stores serialization result from the save operation.</param>
            <param name="modelRoot">DslLibrary instance to be saved.</param>
            <param name="fileName">Name of the file in which the DslLibrary instance will be saved.</param>
            <param name="encoding">Encoding to use when saving the DslLibrary instance.</param>
            <param name="writeOptionalPropertiesWithDefaultValue">Whether optional properties with default value will be saved.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.InternalSaveModel(Microsoft.VisualStudio.Modeling.SerializationResult,Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,System.String,System.Text.Encoding,System.Boolean)">
            <summary>
            Saves the given model root as a in-memory stream.
            This is a helper used by SaveModel() and SaveModelAndDiagram(). When saving the model and the diagram together, we want to make sure that 
            both can be saved without error before writing the content to disk, so we serialize the model into a in-memory stream first.
            </summary>
            <param name="serializationResult">Stores serialization result from the save operation.</param>
            <param name="modelRoot">DslLibrary instance to be saved.</param>
            <param name="fileName">Name of the file in which the DslLibrary instance will be saved.</param>
            <param name="encoding">Encoding to use when saving the DslLibrary instance.</param>
            <param name="writeOptionalPropertiesWithDefaultValue">Whether optional properties with default value will be saved.</param>
            <returns>In-memory stream containing the serialized DslLibrary instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.InternalSaveDiagram(Microsoft.VisualStudio.Modeling.SerializationResult,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram,System.String,System.Text.Encoding,System.Boolean)">
            <summary>
            Saves the given model root as a in-memory stream.
            This is a helper used by SaveModel() and SaveModelAndDiagram(). When saving the model and the diagram together, we want to make sure that 
            both can be saved without error before writing the content to disk, so we serialize the model into a in-memory stream first.
            </summary>
            <param name="serializationResult">Stores serialization result from the save operation.</param>
            <param name="diagram">DslDesignerDiagram to be saved.</param>
            <param name="diagramFileName">Name of the file in which the diagram will be saved.</param>
            <param name="encoding">Encoding to use when saving the diagram.</param>
            <param name="writeOptionalPropertiesWithDefaultValue">Whether optional properties with default value will be saved.</param>
            <returns>In-memory stream containing the serialized DslDesignerDiagram instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.CreateModelHelper(Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Helper method to create and initialize a new DslLibrary.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.LoadModelAndDiagram(Microsoft.VisualStudio.Modeling.Store,System.String,System.String,Microsoft.VisualStudio.Modeling.ISchemaResolver,Microsoft.VisualStudio.Modeling.Validation.ValidationController)">
            <summary>
            Loads a DslLibrary instance and its associated diagram file into the default partition of the given store, and ignore serialization result.
            </summary>
            <param name="store">The new DslLibrary instance will be created into the default partition of this store.</param>
            <param name="modelFileName">Name of the file from which the DslLibrary instance will be deserialized.</param>
            <param name="diagramFileName">Name of the file from which the DslDesignerDiagram instance will be deserialized.</param>
            <param name="schemaResolver">
            An ISchemaResolver that allows the serializer to do schema validation on the root element (and everything inside it).
            If null is passed, schema validation will not be performed.
            </param>
            <param name="validationController">
            A ValidationController that will be used to do load-time validation (validations with validation category "Load"). If null
            is passed, load-time validation will not be performed.
            </param>
            <returns>The loaded DslLibrary instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.LoadModelAndDiagram(Microsoft.VisualStudio.Modeling.SerializationResult,Microsoft.VisualStudio.Modeling.Store,System.String,System.String,Microsoft.VisualStudio.Modeling.ISchemaResolver,Microsoft.VisualStudio.Modeling.Validation.ValidationController)">
            <summary>
            Loads a DslLibrary instance and its associated diagram file into the default partition of the given store.
            </summary>
            <param name="serializationResult">Stores serialization result from the load operation.</param>
            <param name="store">The new DslLibrary instance will be created into the default partition of this store.</param>
            <param name="modelFileName">Name of the file from which the DslLibrary instance will be deserialized.</param>
            <param name="diagramFileName">Name of the file from which the DslDesignerDiagram instance will be deserialized.</param>
            <param name="schemaResolver">
            An ISchemaResolver that allows the serializer to do schema validation on the root element (and everything inside it).
            If null is passed, schema validation will not be performed.
            </param>
            <param name="validationController">
            A ValidationController that will be used to do load-time validation (validations with validation category "Load"). If null
            is passed, load-time validation will not be performed.
            </param>
            <returns>The loaded DslLibrary instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.LoadModelAndDiagram(Microsoft.VisualStudio.Modeling.SerializationResult,Microsoft.VisualStudio.Modeling.Partition,System.String,Microsoft.VisualStudio.Modeling.Partition,System.String,Microsoft.VisualStudio.Modeling.ISchemaResolver,Microsoft.VisualStudio.Modeling.Validation.ValidationController)">
            <summary>
            Loads a DslLibrary instance and its associated diagram file.
            </summary>
            <param name="serializationResult">Stores serialization result from the load operation.</param>
            <param name="modelPartition">Partition in which the new DslLibrary instance will be created.</param>
            <param name="modelFileName">Name of the file from which the DslLibrary instance will be deserialized.</param>
            <param name="diagramPartition">Partition in which the new DslDesignerDiagram instance will be created.</param>
            <param name="diagramFileName">Name of the file from which the DslDesignerDiagram instance will be deserialized.</param>
            <param name="schemaResolver">
            An ISchemaResolver that allows the serializer to do schema validation on the root element (and everything inside it).
            If null is passed, schema validation will not be performed.
            </param>
            <param name="validationController">
            A ValidationController that will be used to do load-time validation (validations with validation category "Load"). If null
            is passed, load-time validation will not be performed.
            </param>
            <returns>The loaded DslLibrary instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.CreateDiagramHelper(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Helper method to create and initialize a new DslDesignerDiagram.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.SaveModelAndDiagram(Microsoft.VisualStudio.Modeling.SerializationResult,Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,System.String,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram,System.String)">
            <summary>
            Saves the given diagram to the given file, with default encoding (UTF-8), and optional properties with default value will not
            be written out.
            </summary>
            <param name="serializationResult">Stores serialization result from the save operation.</param>
            <param name="modelRoot">DslLibrary instance to be saved.</param>
            <param name="modelFileName">Name of the file in which the CanonicalSampleRoot instance will be saved.</param>
            <param name="diagram">DslDesignerDiagram to be saved.</param>
            <param name="diagramFileName">Name of the file in which the diagram will be saved.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.SaveModelAndDiagram(Microsoft.VisualStudio.Modeling.SerializationResult,Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,System.String,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram,System.String,System.Boolean)">
            <summary>
            Saves the given diagram to the given file, with default encoding (UTF-8).
            </summary>
            <param name="serializationResult">Stores serialization result from the save operation.</param>
            <param name="modelRoot">DslLibrary instance to be saved.</param>
            <param name="modelFileName">Name of the file in which the CanonicalSampleRoot instance will be saved.</param>
            <param name="diagram">DslDesignerDiagram to be saved.</param>
            <param name="diagramFileName">Name of the file in which the diagram will be saved.</param>
            <param name="writeOptionalPropertiesWithDefaultValue">Whether optional properties with default value will be saved.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.SaveModelAndDiagram(Microsoft.VisualStudio.Modeling.SerializationResult,Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,System.String,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram,System.String,System.Text.Encoding,System.Boolean)">
            <summary>
            Saves the given DslLibrary and DslDesignerDiagram to the given files, with specified encoding.
            </summary>
            <param name="serializationResult">Stores serialization result from the save operation.</param>
            <param name="modelRoot">DslLibrary instance to be saved.</param>
            <param name="modelFileName">Name of the file in which the CanonicalSampleRoot instance will be saved.</param>
            <param name="diagram">DslDesignerDiagram to be saved.</param>
            <param name="diagramFileName">Name of the file in which the diagram will be saved.</param>
            <param name="encoding">Encoding to use when saving the diagram.</param>
            <param name="writeOptionalPropertiesWithDefaultValue">Whether optional properties with default value will be saved.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.SaveDiagram(Microsoft.VisualStudio.Modeling.SerializationResult,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram,System.String)">
            <summary>
            Saves the given diagram to the given file, with default encoding (UTF-8), and optional properties with default value will not
            be written out.
            </summary>
            <param name="serializationResult">Stores serialization result from the save operation.</param>
            <param name="diagram">DslDesignerDiagram to be saved.</param>
            <param name="diagramFileName">Name of the file in which the diagram will be saved.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.SaveDiagram(Microsoft.VisualStudio.Modeling.SerializationResult,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram,System.String,System.Boolean)">
            <summary>
            Saves the given diagram to the given file, with default encoding (UTF-8).
            </summary>
            <param name="serializationResult">Stores serialization result from the save operation.</param>
            <param name="diagram">DslDesignerDiagram to be saved.</param>
            <param name="diagramFileName">Name of the file in which the diagram will be saved.</param>
            <param name="writeOptionalPropertiesWithDefaultValue">Whether optional properties with default value will be saved.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.SaveDiagram(Microsoft.VisualStudio.Modeling.SerializationResult,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram,System.String,System.Text.Encoding,System.Boolean)">
            <summary>
            Saves the given DslDesignerDiagram to the given file, with specified encoding.
            </summary>
            <param name="serializationResult">Stores serialization result from the save operation.</param>
            <param name="diagram">DslDesignerDiagram to be saved.</param>
            <param name="diagramFileName">Name of the file in which the diagram will be saved.</param>
            <param name="encoding">Encoding to use when saving the diagram.</param>
            <param name="writeOptionalPropertiesWithDefaultValue">Whether optional properties with default value will be saved.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.GetSerializedModelString(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,System.Text.Encoding)">
            <summary>
            Return the model in XML format
            </summary>
            <param name="modelRoot">ExampleModel instance to be saved.</param>
            <param name="encoding">Encoding to use when saving the ExampleModel instance.</param>
            <returns>Model in XML form</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.directory">
            <summary>
            DomainXmlSerializerDirectory instance used by this DslDefinitionModelSerializationHelper class.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.GetMonikerResolvers(Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            This method creates one SimpleMonikerResolver instance for each DomainModel used in serialization.
            </summary>
            <param name="store">Store on which moniker resolvers will be set up.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.SetupMonikerResolver(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Ensure that moniker resolvers are installed properly on the given store, so that deserialization can be carried out correctly.
            </summary>
            <param name="serializationContext">SerializationContext of the current operations.</param>
            <param name="store">Store on which moniker resolvers will be set up.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.CheckForOrphanedShapes(Microsoft.VisualStudio.Modeling.Diagrams.Diagram,Microsoft.VisualStudio.Modeling.SerializationResult)">
            <summary>
            Go through the diagram to find all shapes that are not connected to a model element. Some of them may be by design, the rest are out-of-sync shapes.
            We want to make sure that all out-of-sync shapes are given a chance to fix themselves up, or post proper warning/error messages.
            </summary>
            <param name="diagram">The diagram of which the shapes are being checked.</param>
            <param name="serializationResult">SerializationResult to store warning/error in case an orphaned shape choose to do so.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.OnPostLoadModel(Microsoft.VisualStudio.Modeling.SerializationResult,Microsoft.VisualStudio.Modeling.Partition,System.String,Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Customize Model Loading.
            </summary>
            <param name="serializationResult">Stores serialization result from the load operation.</param>
            <param name="partition">Partition in which the new DslLibrary instance will be created.</param>
            <param name="fileName">Name of the file from which the DslLibrary instance will be deserialized.</param>
            <param name="modelRoot">The root of the file that was loaded.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.OnPostLoadModelAndDiagram(Microsoft.VisualStudio.Modeling.SerializationResult,Microsoft.VisualStudio.Modeling.Partition,System.String,Microsoft.VisualStudio.Modeling.Partition,System.String,Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram)">
            <summary>
            Customize Model and Diagram Loading.
            </summary>
            <param name="serializationResult">Stores serialization result from the load operation.</param>
            <param name="modelPartition">Partition in which the new DslLibrary instance will be created.</param>
            <param name="modelFileName">Name of the file from which the DslLibrary instance will be deserialized.</param>
            <param name="diagramPartition">Partition in which the new DslDesignerDiagram instance will be created.</param>
            <param name="diagramFileName">Name of the file from which the DslDesignerDiagram instance will be deserialized.</param>
            <param name="modelRoot">The root of the file that was loaded.</param>
            <param name="diagram">The diagram matching the modelRoot.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.Directory">
            <summary>
            DomainXmlSerializerDirectory instance used by this DslDefinitionModelSerializationHelper class.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.SerializationValidationObserver">
            <summary>
            An utility class to collect validation messages during serialization, and store them in serialization result.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.SerializationValidationObserver.serializationResult">
            <summary>
            SerializationResult to store the messages.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.SerializationValidationObserver.validationController">
            <summary>
            ValidationController to get messages from.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.SerializationValidationObserver.#ctor(Microsoft.VisualStudio.Modeling.SerializationResult,Microsoft.VisualStudio.Modeling.Validation.ValidationController)">
            <summary>
            Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.SerializationValidationObserver.Finalize">
            <summary>
            Destructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.SerializationValidationObserver.OnValidationMessageAdded(Microsoft.VisualStudio.Modeling.Validation.ValidationMessage)">
            <summary>
            Called with validation messages are added.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.SerializationValidationObserver.Dispose">
            <summary>
            IDisposable.Dispose().
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.SerializationValidationObserver.Dispose(System.Boolean)">
            <summary>
            Unregister the observer on dispose.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.OrphanedShapeIterator">
            <summary>
            An iterator to collect all the orphaned shapes.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.OrphanedShapeIterator.orphanedShapes">
            <summary>
            Stores all iterated orphaned shapes.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.OrphanedShapeIterator.diagram">
            <summary>
            Diagram that contains the shapes to be iterated.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.OrphanedShapeIterator.#ctor(System.Collections.Generic.List{Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement},Microsoft.VisualStudio.Modeling.Diagrams.Diagram)">
            <summary>
            Constructor.
            </summary>
            <param name="orphanedShapes">Storage for all iterated orphaned shapes.</param>
            <param name="diagram">Diagram that contains the shapes to be iterated.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelperBase.OrphanedShapeIterator.OnShape(Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement)">
            <summary>
            Called when a shape is encountered during iteration. The shape will be stored if it's orphaned.
            A shape is considered "orphaned" if:
            1) It has a PresentationViewsSubject link out of it, but the Subject cannot be resolved.
            2) It is a connector, and the Subject is null (regardless of the existence of PresentationViewsSubject relationship).
            </summary>
            <param name="shape">Shape encountered.</param>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CreateInheritanceLink">
            <summary>
            ConnectionBuilder class to provide logic for constructing connections between elements.
            </summary>
            <summary>
            ConnectionBuilder for Inheritance
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CreateInheritanceLink.CanAcceptSource(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Test whether a given model element is acceptable to this ConnectionBuilder as the source of a connection.
            </summary>
            <param name="candidate">The model element to test.</param>
            <returns>Whether the element can be used as the source of a connection.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CreateInheritanceLink.CanAcceptTarget(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Test whether a given model element is acceptable to this ConnectionBuilder as the target of a connection.
            </summary>
            <param name="candidate">The model element to test.</param>
            <returns>Whether the element can be used as the target of a connection.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CreateInheritanceLink.CanAcceptSourceAndTarget(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Test whether a given pair of model elements are acceptable to this ConnectionBuilder as the source and target of a connection
            </summary>
            <param name="candidateSource">The model element to test as a source</param>
            <param name="candidateTarget">The model element to test as a target</param>
            <returns>Whether the elements can be used as the source and target of a connection</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CreateInheritanceLink.Connect(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Make a connection between the given pair of source and target elements
            </summary>
            <param name="source">The model element to use as the source of the connection</param>
            <param name="target">The model element to use as the target of the connection</param>
            <returns>A link representing the created connection</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CreateInheritanceLink.CanAcceptTreeNodeAsSource(Microsoft.VisualStudio.Modeling.DslDesigner.TreeNode)">
            <summary>
            Accept only nodes which don't already have base classes as source.
            </summary>
            <param name="candidate"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CreateInheritanceLink.CanAcceptTreeNodesAsSourceAndTarget(Microsoft.VisualStudio.Modeling.DslDesigner.TreeNode,Microsoft.VisualStudio.Modeling.DslDesigner.TreeNode)">
            <summary>
            Accept only targets that would not cause a loop and are of the same broad family.
            </summary>
            <param name="sourceNode"></param>
            <param name="targetNode"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CreateInheritanceLink.ConnectSourceToTarget(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Make the connection
            </summary>
            <param name="source"></param>
            <param name="target"></param>
            <returns></returns>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CreateEmbeddingRelationship">
            <summary>
            ConnectionBuilder class to provide logic for constructing connections between elements.
            </summary>
            <summary>
            ConnectionBuilder class to provide logic for constructing connections between elements.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CreateEmbeddingRelationship.CanAcceptSource(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Test whether a given model element is acceptable to this ConnectionBuilder as the source of a connection.
            </summary>
            <param name="candidate">The model element to test.</param>
            <returns>Whether the element can be used as the source of a connection.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CreateEmbeddingRelationship.CanAcceptTarget(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Test whether a given model element is acceptable to this ConnectionBuilder as the target of a connection.
            </summary>
            <param name="candidate">The model element to test.</param>
            <returns>Whether the element can be used as the target of a connection.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CreateEmbeddingRelationship.CanAcceptSourceAndTarget(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Test whether a given pair of model elements are acceptable to this ConnectionBuilder as the source and target of a connection
            </summary>
            <param name="candidateSource">The model element to test as a source</param>
            <param name="candidateTarget">The model element to test as a target</param>
            <returns>Whether the elements can be used as the source and target of a connection</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CreateEmbeddingRelationship.Connect(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Make a connection between the given pair of source and target elements
            </summary>
            <param name="source">The model element to use as the source of the connection</param>
            <param name="target">The model element to use as the target of the connection</param>
            <returns>A link representing the created connection</returns>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CreateReferenceRelationship">
            <summary>
            ConnectionBuilder class to provide logic for constructing connections between elements.
            </summary>
            <summary>
            ConnectionBuilder class to provide logic for constructing connections between elements.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CreateReferenceRelationship.CanAcceptSource(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Test whether a given model element is acceptable to this ConnectionBuilder as the source of a connection.
            </summary>
            <param name="candidate">The model element to test.</param>
            <returns>Whether the element can be used as the source of a connection.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CreateReferenceRelationship.CanAcceptTarget(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Test whether a given model element is acceptable to this ConnectionBuilder as the target of a connection.
            </summary>
            <param name="candidate">The model element to test.</param>
            <returns>Whether the element can be used as the target of a connection.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CreateReferenceRelationship.CanAcceptSourceAndTarget(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Test whether a given pair of model elements are acceptable to this ConnectionBuilder as the source and target of a connection
            </summary>
            <param name="candidateSource">The model element to test as a source</param>
            <param name="candidateTarget">The model element to test as a target</param>
            <returns>Whether the elements can be used as the source and target of a connection</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CreateReferenceRelationship.Connect(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Make a connection between the given pair of source and target elements
            </summary>
            <param name="source">The model element to use as the source of the connection</param>
            <param name="target">The model element to use as the target of the connection</param>
            <returns>A link representing the created connection</returns>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CreateDiagramElementMap">
            <summary>
            Empty ConnectionBuilder class as a placeholder for custom code.
            </summary>
            <summary>
            ConnectionBuilder class to provide logic for constructing connections that represent shape maps
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CreateDiagramElementMap.CanAcceptSource(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Can this connection builder accept the given element as its connection source
            </summary>
            <param name="sourceElement"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CreateDiagramElementMap.CanAcceptSourceAndTarget(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Can this connection builder accept the given elements as its connection source and targets.
            </summary>
            <param name="sourceElement"></param>
            <param name="targetElement"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CreateDiagramElementMap.Connect(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Make the connection between the given elements.
            </summary>
            <param name="sourceElement"></param>
            <param name="targetElement"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CreateDiagramElementMap.CreateDefaultParentElementPath(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap)">
            <summary>
            Create a default parent element path for the given map
            </summary>
            <param name="map"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CreateDiagramElementMap.GetEmbeddingParent(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the role leading to the next class up the embedding hierarchy in the case of a singly parented class
            </summary>
            <remarks>Returns null if the class is multiply parented</remarks>
            <param name="child"></param>
            <returns>The role connecting to the embedding parent domain class or null</returns>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.EmbeddingRelationshipToolConnectAction">
            <summary>
            Handles interaction between the ConnectionBuilder and the corresponding ConnectionTool.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EmbeddingRelationshipToolConnectAction.#ctor(Microsoft.VisualStudio.Modeling.Diagrams.Diagram)">
            <summary>
            Constructs a new EmbeddingRelationshipToolConnectAction for the given Diagram.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EmbeddingRelationshipToolConnectAction.GetCursor(System.Windows.Forms.Cursor,Microsoft.VisualStudio.Modeling.Diagrams.DiagramClientView,Microsoft.VisualStudio.Modeling.Diagrams.PointD)">
            <summary>
            Gets the cursor corresponding to the given mouse position.
            </summary>
            <remarks>
            Changes the cursor to Cursors.No before the first mouse click if the source shape is not valid.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EmbeddingRelationshipToolConnectAction.GetConnectionTypes(Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement,Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement)">
            <summary>
            Returns the EmbeddingRelationshipToolConnectionType associated with this action.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EmbeddingRelationshipToolConnectAction.EmbeddingRelationshipToolConnectionTypeBase.#ctor">
            <summary>
            Constructs a new the EmbeddingRelationshipToolConnectionType with the given ConnectionBuilder.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EmbeddingRelationshipToolConnectAction.EmbeddingRelationshipToolConnectionTypeBase.CanCreateConnection(Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement,Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement,System.String@)">
            <summary>
            Called by the base ConnectAction class to determine if the given shapes can be connected.
            </summary>
            <remarks>
            This implementation delegates calls to the ConnectionBuilder CreateEmbeddingRelationship.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EmbeddingRelationshipToolConnectAction.EmbeddingRelationshipToolConnectionTypeBase.IsValidSourceAndTarget(Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement,Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement)">
            <summary>
            Called by the base ConnectAction class to ask whether the given source and target are valid.
            </summary>
            <remarks>
            Always return true here, to give CanCreateConnection a chance to decide.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EmbeddingRelationshipToolConnectAction.EmbeddingRelationshipToolConnectionTypeBase.CreateConnection(Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement,Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement,Microsoft.VisualStudio.Modeling.Diagrams.PaintFeedbackArgs)">
            <summary>
            Called by the base ConnectAction class to create the underlying relationship.
            </summary>
            <remarks>
            This implementation delegates calls to the ConnectionBuilder CreateEmbeddingRelationship.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EmbeddingRelationshipToolConnectAction.EmbeddingRelationshipToolConnectionType.#ctor">
            <summary>
            Constructs a new the EmbeddingRelationshipToolConnectionType with the given ConnectionBuilder.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ReferenceRelationshipToolConnectAction">
            <summary>
            Handles interaction between the ConnectionBuilder and the corresponding ConnectionTool.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ReferenceRelationshipToolConnectAction.#ctor(Microsoft.VisualStudio.Modeling.Diagrams.Diagram)">
            <summary>
            Constructs a new ReferenceRelationshipToolConnectAction for the given Diagram.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ReferenceRelationshipToolConnectAction.GetCursor(System.Windows.Forms.Cursor,Microsoft.VisualStudio.Modeling.Diagrams.DiagramClientView,Microsoft.VisualStudio.Modeling.Diagrams.PointD)">
            <summary>
            Gets the cursor corresponding to the given mouse position.
            </summary>
            <remarks>
            Changes the cursor to Cursors.No before the first mouse click if the source shape is not valid.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ReferenceRelationshipToolConnectAction.GetConnectionTypes(Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement,Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement)">
            <summary>
            Returns the ReferenceRelationshipToolConnectionType associated with this action.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ReferenceRelationshipToolConnectAction.ReferenceRelationshipToolConnectionTypeBase.#ctor">
            <summary>
            Constructs a new the ReferenceRelationshipToolConnectionType with the given ConnectionBuilder.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ReferenceRelationshipToolConnectAction.ReferenceRelationshipToolConnectionTypeBase.CanCreateConnection(Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement,Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement,System.String@)">
            <summary>
            Called by the base ConnectAction class to determine if the given shapes can be connected.
            </summary>
            <remarks>
            This implementation delegates calls to the ConnectionBuilder CreateReferenceRelationship.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ReferenceRelationshipToolConnectAction.ReferenceRelationshipToolConnectionTypeBase.IsValidSourceAndTarget(Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement,Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement)">
            <summary>
            Called by the base ConnectAction class to ask whether the given source and target are valid.
            </summary>
            <remarks>
            Always return true here, to give CanCreateConnection a chance to decide.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ReferenceRelationshipToolConnectAction.ReferenceRelationshipToolConnectionTypeBase.CreateConnection(Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement,Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement,Microsoft.VisualStudio.Modeling.Diagrams.PaintFeedbackArgs)">
            <summary>
            Called by the base ConnectAction class to create the underlying relationship.
            </summary>
            <remarks>
            This implementation delegates calls to the ConnectionBuilder CreateReferenceRelationship.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ReferenceRelationshipToolConnectAction.ReferenceRelationshipToolConnectionType.#ctor">
            <summary>
            Constructs a new the ReferenceRelationshipToolConnectionType with the given ConnectionBuilder.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceToolConnectAction">
            <summary>
            Handles interaction between the ConnectionBuilder and the corresponding ConnectionTool.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceToolConnectAction.#ctor(Microsoft.VisualStudio.Modeling.Diagrams.Diagram)">
            <summary>
            Constructs a new InheritanceToolConnectAction for the given Diagram.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceToolConnectAction.GetCursor(System.Windows.Forms.Cursor,Microsoft.VisualStudio.Modeling.Diagrams.DiagramClientView,Microsoft.VisualStudio.Modeling.Diagrams.PointD)">
            <summary>
            Gets the cursor corresponding to the given mouse position.
            </summary>
            <remarks>
            Changes the cursor to Cursors.No before the first mouse click if the source shape is not valid.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceToolConnectAction.GetConnectionTypes(Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement,Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement)">
            <summary>
            Returns the InheritanceToolConnectionType associated with this action.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceToolConnectAction.InheritanceToolConnectionTypeBase.#ctor">
            <summary>
            Constructs a new the InheritanceToolConnectionType with the given ConnectionBuilder.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceToolConnectAction.InheritanceToolConnectionTypeBase.CanCreateConnection(Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement,Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement,System.String@)">
            <summary>
            Called by the base ConnectAction class to determine if the given shapes can be connected.
            </summary>
            <remarks>
            This implementation delegates calls to the ConnectionBuilder CreateInheritanceLink.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceToolConnectAction.InheritanceToolConnectionTypeBase.IsValidSourceAndTarget(Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement,Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement)">
            <summary>
            Called by the base ConnectAction class to ask whether the given source and target are valid.
            </summary>
            <remarks>
            Always return true here, to give CanCreateConnection a chance to decide.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceToolConnectAction.InheritanceToolConnectionTypeBase.CreateConnection(Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement,Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement,Microsoft.VisualStudio.Modeling.Diagrams.PaintFeedbackArgs)">
            <summary>
            Called by the base ConnectAction class to create the underlying relationship.
            </summary>
            <remarks>
            This implementation delegates calls to the ConnectionBuilder CreateInheritanceLink.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceToolConnectAction.InheritanceToolConnectionType.#ctor">
            <summary>
            Constructs a new the InheritanceToolConnectionType with the given ConnectionBuilder.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapToolConnectAction">
            <summary>
            Handles interaction between the ConnectionBuilder and the corresponding ConnectionTool.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapToolConnectAction.#ctor(Microsoft.VisualStudio.Modeling.Diagrams.Diagram)">
            <summary>
            Constructs a new DiagramElementMapToolConnectAction for the given Diagram.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapToolConnectAction.GetCursor(System.Windows.Forms.Cursor,Microsoft.VisualStudio.Modeling.Diagrams.DiagramClientView,Microsoft.VisualStudio.Modeling.Diagrams.PointD)">
            <summary>
            Gets the cursor corresponding to the given mouse position.
            </summary>
            <remarks>
            Changes the cursor to Cursors.No before the first mouse click if the source shape is not valid.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapToolConnectAction.GetConnectionTypes(Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement,Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement)">
            <summary>
            Returns the DiagramElementMapToolConnectionType associated with this action.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapToolConnectAction.DiagramElementMapToolConnectionTypeBase.#ctor">
            <summary>
            Constructs a new the DiagramElementMapToolConnectionType with the given ConnectionBuilder.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapToolConnectAction.DiagramElementMapToolConnectionTypeBase.CanCreateConnection(Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement,Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement,System.String@)">
            <summary>
            Called by the base ConnectAction class to determine if the given shapes can be connected.
            </summary>
            <remarks>
            This implementation delegates calls to the ConnectionBuilder CreateDiagramElementMap.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapToolConnectAction.DiagramElementMapToolConnectionTypeBase.IsValidSourceAndTarget(Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement,Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement)">
            <summary>
            Called by the base ConnectAction class to ask whether the given source and target are valid.
            </summary>
            <remarks>
            Always return true here, to give CanCreateConnection a chance to decide.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapToolConnectAction.DiagramElementMapToolConnectionTypeBase.CreateConnection(Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement,Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement,Microsoft.VisualStudio.Modeling.Diagrams.PaintFeedbackArgs)">
            <summary>
            Called by the base ConnectAction class to create the underlying relationship.
            </summary>
            <remarks>
            This implementation delegates calls to the ConnectionBuilder CreateDiagramElementMap.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapToolConnectAction.DiagramElementMapToolConnectionType.#ctor">
            <summary>
            Constructs a new the DiagramElementMapToolConnectionType with the given ConnectionBuilder.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector">
            <summary>
            DomainClass InheritanceConnector
            Description for Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector.FindInheritanceConnectorDecorator(System.String)">
            <summary>
            Finds a decorator associated with InheritanceConnector.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector.InitializeResources(Microsoft.VisualStudio.Modeling.Diagrams.StyleSet)">
            <summary>
            Initializes style set resources for this shape type
            </summary>
            <param name="classStyleSet">The style set for this shape class</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector.DomainClassId">
            <summary>
            InheritanceConnector domain class Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector.TreeOrderDomainPropertyId">
            <summary>
            TreeOrder domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector.treeOrderPropertyStorage">
            <summary>
            Storage for TreeOrder
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector.Forwarder(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Forward type description to true Subject.
            </summary>
            <param name="source"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector.FixConnectorEnds">
            <summary>
            Fix the endpoints of the connector
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector.OnKeyDown(Microsoft.VisualStudio.Modeling.Diagrams.DiagramKeyEventArgs)">
            <summary>
            Connector ignores nudge keys
            </summary>
            <param name="e"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector.GetToolTipText(Microsoft.VisualStudio.Modeling.Diagrams.DiagramItem)">
            <summary>
            Text of tooltip
            </summary>
            <param name="item"></param>
            <returns></returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector.ClassStyleSet">
            <summary>
            Per-class style set for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector.ShapeFields">
            <summary>
            Per-class ShapeFields for this shape.
            </summary>
        </member>
        <member name="E:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector.DecoratorsInitialized">
            <summary>
            Event fired when decorator initialization is complete for this shape type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector.Decorators">
            <summary>
            List containing decorators used by this type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector.TreeOrder">
            <summary>
            Gets or sets the value of TreeOrder domain property.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector.CanManuallyRoute">
            <summary>
            Connector can't manually route
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector.CanMove">
            <summary>
            Connector can't move
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector.DefaultRoutingStyle">
            <summary>
            Use a more conducive routing style
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector.HasToolTip">
            <summary>
            Connector has tooltip
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector.AccessibleName">
            <summary>
            Get the accesible name for the connector
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector.TreeOrderPropertyHandler">
            <summary>
            Value handler for the InheritanceConnector.TreeOrder domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector.TreeOrderPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the InheritanceConnector.TreeOrder domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector.TreeOrderPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector.TreeOrderPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector,System.Int32)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector.TreeOrderPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the InheritanceConnector.TreeOrder domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase">
            <summary>
            Double-derived base class for DomainClass RoleConnector
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase.FindRoleConnectorDecorator(System.String)">
            <summary>
            Finds a decorator associated with RoleConnector.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase.OnInitialize">
            <summary>
            Shape instance initialization.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase.InitializeResources(Microsoft.VisualStudio.Modeling.Diagrams.StyleSet)">
            <summary>
            Initializes style set resources for this shape type
            </summary>
            <param name="classStyleSet">The style set for this shape class</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase.InitializeShapeFields(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField})">
            <summary>
            Initialize the collection of shape fields associated with this shape type.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase.InitializeDecorators(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField},System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.Decorator})">
            <summary>
            Initialize the collection of decorators associated with this shape type.  This method also
            creates shape fields for outer decorators, because these are not part of the shape fields collection
            associated with the shape, so they must be created here rather than in InitializeShapeFields.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase.DomainClassId">
            <summary>
            RoleConnector domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase.MultiplicitySymbolDomainPropertyId">
            <summary>
            MultiplicitySymbol domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase.TreeOrderDomainPropertyId">
            <summary>
            TreeOrder domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase.treeOrderPropertyStorage">
            <summary>
            Storage for TreeOrder
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase.GetMultiplicitySymbolValue">
            <summary>
            Get the string for the multiplicity label
            </summary>
            <returns></returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase.ClassStyleSet">
            <summary>
            Per-class style set for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase.ShapeFields">
            <summary>
            Per-class ShapeFields for this shape.
            </summary>
        </member>
        <member name="E:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase.DecoratorsInitialized">
            <summary>
            Event fired when decorator initialization is complete for this shape type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase.Decorators">
            <summary>
            List containing decorators used by this type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase.MultiplicitySymbol">
            <summary>
            Gets or sets the value of MultiplicitySymbol domain property.
            Description for
            Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnector.Multiplicity Symbol
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase.TreeOrder">
            <summary>
            Gets or sets the value of TreeOrder domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase.MultiplicitySymbolPropertyHandler">
            <summary>
            Value handler for the RoleConnector.MultiplicitySymbol domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase.MultiplicitySymbolPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the RoleConnector.MultiplicitySymbol domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase.MultiplicitySymbolPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase.MultiplicitySymbolPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase.MultiplicitySymbolPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the RoleConnector.MultiplicitySymbol domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase.TreeOrderPropertyHandler">
            <summary>
            Value handler for the RoleConnector.TreeOrder domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase.TreeOrderPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the RoleConnector.TreeOrder domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase.TreeOrderPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase.TreeOrderPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase,System.Int32)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorBase.TreeOrderPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the RoleConnector.TreeOrder domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnector">
            <summary>
            DomainClass RoleConnector
            Description for Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnector
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnector.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnector.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnector.OnInitialize">
            <summary>
            Initialize grid.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnector.Forwarder(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Forward type description to true Subject.
            </summary>
            <param name="source"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnector.UpdateDecoratorStylesAndPosition">
            <summary>
            Updates the styles of decorators and their host decorator shape positions that are dependent on the styles.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnector.EnsureMappingDependentState">
            <summary>
            Update state of shape that is dependent on it being mapped to an element.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnector.FixConnectorEnds">
            <summary>
            Fix the endpoints of the connector
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnector.OnKeyDown(Microsoft.VisualStudio.Modeling.Diagrams.DiagramKeyEventArgs)">
            <summary>
            Connector ignores nudge keys
            </summary>
            <param name="e"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnector.GetToolTipText(Microsoft.VisualStudio.Modeling.Diagrams.DiagramItem)">
            <summary>
            Text of tooltip
            </summary>
            <param name="item"></param>
            <returns></returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnector.CanManuallyRoute">
            <summary>
            Connector can't manually route
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnector.CanMove">
            <summary>
            Connector can't move
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnector.DefaultRoutingStyle">
            <summary>
            Use a more conducive routing style
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnector.HasToolTip">
            <summary>
            Connector has tooltip
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnector.AccessibleName">
            <summary>
            Get the accesible name for the connector
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnector.IsPropertyGeneratorVisualUpdateRule">
            <summary>
            Rule to update dynamic styles when IsPropertyGenerator changes - has to be a rule as it requires updating decorator position when font style changes.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.MapConnector">
            <summary>
            DomainClass MapConnector
            Description for Microsoft.VisualStudio.Modeling.DslDesigner.MapConnector
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.MapConnector.FindMapConnectorDecorator(System.String)">
            <summary>
            Finds a decorator associated with MapConnector.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.MapConnector.InitializeResources(Microsoft.VisualStudio.Modeling.Diagrams.StyleSet)">
            <summary>
            Initializes style set resources for this shape type
            </summary>
            <param name="classStyleSet">The style set for this shape class</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.MapConnector.DomainClassId">
            <summary>
            MapConnector domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.MapConnector.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.MapConnector.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.MapConnector.Forwarder(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Forward type description to true Subject.
            </summary>
            <param name="source"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.MapConnector.OnDoubleClick(Microsoft.VisualStudio.Modeling.Diagrams.DiagramPointEventArgs)">
            <summary>
            Make double-click show details window.
            </summary>
            <param name="e"></param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.MapConnector.ClassStyleSet">
            <summary>
            Per-class style set for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.MapConnector.ShapeFields">
            <summary>
            Per-class ShapeFields for this shape.
            </summary>
        </member>
        <member name="E:Microsoft.VisualStudio.Modeling.DslDesigner.MapConnector.DecoratorsInitialized">
            <summary>
            Event fired when decorator initialization is complete for this shape type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.MapConnector.Decorators">
            <summary>
            List containing decorators used by this type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.MapConnector.DefaultRoutingStyle">
            <summary>
            Gets the default line routing style for this connector.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.MapConnector.CanManuallyRoute">
            <summary>
            Connector can't manually route
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.MapConnector.AccessibleName">
            <summary>
            Get the accesible name for the connector
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase">
            <summary>
            Double-derived base class for DomainClass DslDesignerDiagram
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.InitializeResources(Microsoft.VisualStudio.Modeling.Diagrams.StyleSet)">
            <summary>
            Initializes style set resources for this shape type
            </summary>
            <param name="classStyleSet">The style set for this shape class</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.InitializeSwimlanes">
            <summary>
            Initializes the starting swimlanes in a new Diagram.
            </summary>
            <remarks>
            This method is not called during successful deserialization, only when either a blank diagram is created or diagram deserialization fails and a diagram is created to make things work.
            
            This method does not create shapes for swimlanes with shape maps specified in the DSL definition, only those swimlanes which are not mapped.
            The assumption here is that if a swimlane is mapped to a domain class, then an instance of that class  will be created when the element mapped to the diagram is created,
            and swimlane shapes will be created as part of view fixup.
            </remarks>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.subscribedCompartmentItemsEvents">
            <summary>
            Whether compartment items change events are subscribed to.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.SubscribeCompartmentItemsEvents">
            <summary>
            Subscribe to events fired when compartment items changes.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.UnsubscribeCompartmentItemsEvents">
            <summary>
            Unsubscribe to events fired when compartment items changes.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.CompartmentItemAdded(System.Object,Microsoft.VisualStudio.Modeling.ElementAddedEventArgs)">
            <summary>
            Event for element added.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.CompartmentItemDeleted(System.Object,Microsoft.VisualStudio.Modeling.ElementDeletedEventArgs)">
            <summary>
            Event for element deleted.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.CompartmentItemPropertyChanged(System.Object,Microsoft.VisualStudio.Modeling.ElementPropertyChangedEventArgs)">
            <summary>
            Event for element property changed.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.CompartmentItemRolePlayerChanged(System.Object,Microsoft.VisualStudio.Modeling.RolePlayerChangedEventArgs)">
            <summary>
            Event for role-player changed.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.CompartmentItemRolePlayerOrderChanged(System.Object,Microsoft.VisualStudio.Modeling.RolePlayerOrderChangedEventArgs)">
            <summary>
            Event for role-player order changed.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.ShouldAddShapeForElement(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Called during view fixup to ask the parent whether a shape should be created for the given child element.
            </summary>
            <remarks>
            Always return true, since we assume there is only one diagram per model file for DSL scenarios.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.OnChildConfiguring(Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement,System.Boolean)">
            <summary>
            Called during view fixup to configure the given child element, after it has been created.
            </summary>
            <remarks>
            Custom code for choosing the shapes attached to either end of a connector is called from here.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.GetSourceAndTargetForConnector(Microsoft.VisualStudio.Modeling.Diagrams.BinaryLinkShape,Microsoft.VisualStudio.Modeling.Diagrams.NodeShape@,Microsoft.VisualStudio.Modeling.Diagrams.NodeShape@)">
            <summary>
            helper method to find the shapes for either end of a connector, including calling the user's custom code
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.GetEndShapesForConnector(Microsoft.VisualStudio.Modeling.Diagrams.BinaryLinkShape)">
            <summary>
            Helper method to find shapes for either end of a connector by looking for shapes associated with either end of the relationship mapped to the connector.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.GetSourceRolePlayerForLinkMappedByConnector(Microsoft.VisualStudio.Modeling.Diagrams.BinaryLinkShape)">
            <summary>
            Get the source role-player of the link that would be mapped by the given connector
            </summary>
            <param name="connector">The given connector.</param>
            <returns>The source role-player of the link that would be mapped by the given connector.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.GetTargetRolePlayerForLinkMappedByConnector(Microsoft.VisualStudio.Modeling.Diagrams.BinaryLinkShape)">
            <summary>
            Get the target role-player of the link that would be mapped by the given connector
            </summary>
            <param name="connector">The given connector.</param>
            <returns>The target role-player of the link that would be mapped by the given connector.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.CreateChildShape(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Creates a new shape for the given model element as part of view fixup
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.InitializeShapeFields(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField})">
            <summary>
            Initialize shape decorator mappings.  This is done here rather than in individual shapes because decorator maps
            are defined per diagram type rather than per shape type.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.OnViewMouseEnter(Microsoft.VisualStudio.Modeling.Diagrams.DiagramPointEventArgs)">
            <summary>
            Override to provide the right mouse action when trying
            to create links on the diagram
            </summary>
            <param name="pointArgs"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.OnConnectActionDeactivated(System.Object,Microsoft.VisualStudio.Modeling.Diagrams.DiagramEventArgs)">
            <summary>
            Snap toolbox selection back to regular pointer after using a custom connect action.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.Dispose(System.Boolean)">
            <summary>
            Dispose of connect actions.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.DomainClassId">
            <summary>
            DslDesignerDiagram domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.TriggerDiagramLayoutDomainPropertyId">
            <summary>
            TriggerDiagramLayout domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.triggerDiagramLayoutPropertyStorage">
            <summary>
            Storage for TriggerDiagramLayout
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.CreateMatchingShapeForNodeSubject(Microsoft.VisualStudio.Modeling.DslDesigner.TreeNode)">
            <summary>
            Make the right shape for the subject of a given tree node.
            </summary>
            <param name="node"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.GetMap(Microsoft.VisualStudio.Modeling.DslDesigner.MapConnector)">
            <summary>
            Get the DiagramElementMap mapped by this MapConnector. The mapped map can be either a ShapeMap or a ConnectorMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.GetPresentation(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Get the shape presenting the given mel on this diagram (if any)
            </summary>
            <param name="element"></param>
            <returns>the shape presenting element on this diagram or null</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.ShouldExcludeFromInvalidationTracking(Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement)">
            <summary>
            Calculates whether or not specific types of shapes should be excluded
            from the invalidation tracking for the diagram. 
            </summary>
            <param name="shape">shape to check</param>
            <returns>true means exclude it from the tracking; false don't exclude it.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.IsRelationshipRequired(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Test if a relationship must be shown on the diagram as a class
            </summary>
            <param name="relationship"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.FindSubject(Microsoft.VisualStudio.Modeling.Diagrams.CompartmentShape)">
            <summary>
            Gets the Subject associated with the given Shape.
            </summary>
            <param name="shape">Shape whose Subject will be returned.</param>
            <returns>Subject of the given Shape.</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.ClassStyleSet">
            <summary>
            Per-class style set for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.ShapeFields">
            <summary>
            Per-class ShapeFields for this shape
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.TargetToolboxItemFilterAttributes">
            <summary>
            Toolbox item filter attributes for this diagram.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.HasSwimlanes">
            <summary>
            Gets whether or not swimlanes are supported in this Diagram.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.TriggerDiagramLayout">
            <summary>
            Gets or sets the value of TriggerDiagramLayout domain property.
            Description for
            Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.Trigger Diagram
            Layout
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.DiagramState">
            <summary>
            Gets or sets DiagramState.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.DomainModelElementsSwimLane">
            <summary>
            Access the DomainModelElements swimlane shape
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.DiagramElementsSwimLane">
            <summary>
            Access the DiagramElements swimlane shape
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.AbstractClassShapeDecoratorMap">
            <summary>
            Class containing decorator path traversal methods for AbstractClassShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.AbstractClassShapeDecoratorMap.OnDecoratorsInitialized(System.Object,System.EventArgs)">
            <summary>
            Event handler called when decorator initialization is complete for AbstractClassShape.  Adds decorator mappings for this shape or connector.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.ClassShapeDecoratorMap">
            <summary>
            Class containing decorator path traversal methods for ClassShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.ClassShapeDecoratorMap.OnDecoratorsInitialized(System.Object,System.EventArgs)">
            <summary>
            Event handler called when decorator initialization is complete for ClassShape.  Adds decorator mappings for this shape or connector.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.RelationshipAsClassShapeDecoratorMap">
            <summary>
            Class containing decorator path traversal methods for RelationshipAsClassShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.RelationshipAsClassShapeDecoratorMap.OnDecoratorsInitialized(System.Object,System.EventArgs)">
            <summary>
            Event handler called when decorator initialization is complete for RelationshipAsClassShape.  Adds decorator mappings for this shape or connector.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.DiagramShapeDecoratorMap">
            <summary>
            Class containing decorator path traversal methods for DiagramShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.DiagramShapeDecoratorMap.OnDecoratorsInitialized(System.Object,System.EventArgs)">
            <summary>
            Event handler called when decorator initialization is complete for DiagramShape.  Adds decorator mappings for this shape or connector.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.ShapeShapeDecoratorMap">
            <summary>
            Class containing decorator path traversal methods for ShapeShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.ShapeShapeDecoratorMap.OnDecoratorsInitialized(System.Object,System.EventArgs)">
            <summary>
            Event handler called when decorator initialization is complete for ShapeShape.  Adds decorator mappings for this shape or connector.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.GeometryShapeShapeDecoratorMap">
            <summary>
            Class containing decorator path traversal methods for GeometryShapeShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.GeometryShapeShapeDecoratorMap.OnDecoratorsInitialized(System.Object,System.EventArgs)">
            <summary>
            Event handler called when decorator initialization is complete for GeometryShapeShape.  Adds decorator mappings for this shape or connector.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.PortShapeDecoratorMap">
            <summary>
            Class containing decorator path traversal methods for PortShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.PortShapeDecoratorMap.OnDecoratorsInitialized(System.Object,System.EventArgs)">
            <summary>
            Event handler called when decorator initialization is complete for PortShape.  Adds decorator mappings for this shape or connector.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.SwimLaneShapeDecoratorMap">
            <summary>
            Class containing decorator path traversal methods for SwimLaneShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.SwimLaneShapeDecoratorMap.OnDecoratorsInitialized(System.Object,System.EventArgs)">
            <summary>
            Event handler called when decorator initialization is complete for SwimLaneShape.  Adds decorator mappings for this shape or connector.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.ImageShapeShapeDecoratorMap">
            <summary>
            Class containing decorator path traversal methods for ImageShapeShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.ImageShapeShapeDecoratorMap.OnDecoratorsInitialized(System.Object,System.EventArgs)">
            <summary>
            Event handler called when decorator initialization is complete for ImageShapeShape.  Adds decorator mappings for this shape or connector.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.CompartmentShapeShapeDecoratorMap">
            <summary>
            Class containing decorator path traversal methods for CompartmentShapeShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.CompartmentShapeShapeDecoratorMap.OnDecoratorsInitialized(System.Object,System.EventArgs)">
            <summary>
            Event handler called when decorator initialization is complete for CompartmentShapeShape.  Adds decorator mappings for this shape or connector.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.ConnectorShapeDecoratorMap">
            <summary>
            Class containing decorator path traversal methods for ConnectorShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.ConnectorShapeDecoratorMap.OnDecoratorsInitialized(System.Object,System.EventArgs)">
            <summary>
            Event handler called when decorator initialization is complete for ConnectorShape.  Adds decorator mappings for this shape or connector.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.RelationshipShapeDecoratorMap">
            <summary>
            Class containing decorator path traversal methods for RelationshipShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.RelationshipShapeDecoratorMap.OnDecoratorsInitialized(System.Object,System.EventArgs)">
            <summary>
            Event handler called when decorator initialization is complete for RelationshipShape.  Adds decorator mappings for this shape or connector.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.RoleConnectorDecoratorMap">
            <summary>
            Class containing decorator path traversal methods for RoleConnector.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.RoleConnectorDecoratorMap.OnDecoratorsInitialized(System.Object,System.EventArgs)">
            <summary>
            Event handler called when decorator initialization is complete for RoleConnector.  Adds decorator mappings for this shape or connector.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.TriggerDiagramLayoutPropertyHandler">
            <summary>
            Value handler for the DslDesignerDiagram.TriggerDiagramLayout domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.TriggerDiagramLayoutPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DslDesignerDiagram.TriggerDiagramLayout domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.TriggerDiagramLayoutPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.TriggerDiagramLayoutPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramBase.TriggerDiagramLayoutPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DslDesignerDiagram.TriggerDiagramLayout domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram">
            <summary>
            DomainClass DslDesignerDiagram
            Description for Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.navigateSwimlaneSwitch">
            <summary>
            Flip this every time the navigation goes into the swimlanes
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.OnInitialize">
            <summary>
            Set up event watchers for Holophraxis
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.EnsureDiagramState">
            <summary>
            Make sure we've got a DiagramState object
            </summary>
            <returns></returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.rand">
            <summary>
            Random number generator to help graph layout object balance its internal structures 
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.OnChildConfiguring(Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement,System.Boolean)">
            <summary>
            Override the setup of shapes on the diagram.
            </summary>
            <param name="child"></param>
            <param name="createdDuringViewFixup"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.ConfigureConnectorEndPoints(Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement)">
            <summary>
            When a connector is about to be configured, configure any needed ends first.
            </summary>
            <param name="child"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.ChooseParentShape(Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement)">
            <summary>
            Pick parenting for children of diagram.
            </summary>
            <param name="childShape"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.GetSwimlaneForTree(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree)">
            <summary>
            Get the swimlane representing a given tree
            </summary>
            <param name="tree"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.GetClassShapeReferenceType(Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShapeBase)">
            <summary>
            Get the class that a class shape is mapped to.
            </summary>
            <param name="shape"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.InitializeShapeFields(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField})">
            <summary>
            Setup ShapeFields/Decorators for Shapes used on this diagram.
            </summary>
            <param name="shapeFields"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.OnClassShapeDecoratorsInitialized(System.Object,System.EventArgs)">
            <summary>
            Event handler called when decorator initialization is complete for any concrete class derived from AbstractClassShape.  Adds EXTRA decorator mappings for this shape or connector.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.OnRelationshipShapeDecoratorsInitialized(System.Object,System.EventArgs)">
            <summary>
            Event handler called when decorator initialization is complete for RelationshipShape.  Adds EXTRA decorator mappings for this shape or connector.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.OnRoleConnectorDecoratorsInitialized(System.Object,System.EventArgs)">
            <summary>
            Event handler called when decorator initialization is complete for RoleConnector.  Adds EXTRA decorator mappings for this shape or connector.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.OnChildAssociatedPropertyChanged(Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement,Microsoft.VisualStudio.Modeling.Diagrams.PropertyChangedEventArgs)">
            <summary>
            Called when a property associated with a child shape has changed.
            </summary>
            <param name="shape"></param>
            <param name="e"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.NestedTreeSetVisible(Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape,System.Boolean)">
            <summary>
            Set [in]visible the relationships sourced at this concept.
            </summary>
            <param name="shape"></param>
            <param name="visible"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.InheritanceTreeSetVisible(Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape,System.Boolean)">
            <summary>
            Set [in]visible the inheritors of this concept.
            </summary>
            <param name="shape"></param>
            <param name="visible"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.ScheduleLayout">
            <summary>
            Raises an event to cause layout after end of current outer transaction.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.ScheduleLayout(Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement)">
            <summary>
            Raises an event to cause layout after end of current outer transaction.
            </summary>
            <param name="shapeToEnsureVisible">A shape that must be visible after the layout</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.ActionLayoutRule">
            <summary>
            Reposition all shapes on the diagram.
            Called from ReLayoutRule.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.InitializeSwimlanes">
            <summary>
            When we're creating a diagram from scratch this will be called so we can clear the flag and allow the layout to proceed.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.PerformLayout">
            <summary>
            Lay out the diagram.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.GetOppositeSwimlane(Microsoft.VisualStudio.Modeling.Diagrams.SwimlaneShape)">
            <summary>
            Get the opposite swimlane to the given one
            </summary>
            <param name="originalSwimlane"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.IsReferenceTypeRequiredOnDiagram(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Must the given class be shown on the diagram.
            </summary>
            <param name="checkee"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.ToggleUserRoot(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Toggle whether a reference type is a diagram root at the user's behest
            </summary>
            <param name="userRoot">The root to toggle</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.IsUserRoot(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Is the given type a root as specified by the user
            </summary>
            <param name="candidate"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.EnsureRelationshipAsClassOnDiagrams(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Make sure that the given relationship is shown as a class on all diagrams
            </summary>
            <param name="relationship"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.NavigateDescend(Microsoft.VisualStudio.Modeling.Diagrams.SelectedShapesCollection)">
            <summary>
            Navigate into alternating swimlanes
            </summary>
            <param name="selection"></param>
            <returns></returns>
        </member>
        <member name="E:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.BeginLongOperation">
            <summary>
            Event to notify clients that we're about to do something that might be time-expensive, such as relayout or restructure.
            </summary>
        </member>
        <member name="E:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.ShowDetails">
            <summary>
            Request that the container of this diagram show details windows
            </summary>
        </member>
        <member name="E:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.NavigateToShape">
            <summary>
            Request that the container of this diagram navigate to the given shape
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.LayoutRule">
            <summary>
            Rule class to handle scheduling layout of the diagram.
            </summary>
            <remarks>
            Runs just before line rerouting - must run after shape anchoring.
            </remarks>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.FixUpDiagram">
            <summary>
            Rule that initiates view fixup when an element that has an associated shape is added to the model. 
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentItemAddRule">
            <summary>
            Rule to update compartments when an item is added to the list
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentItemAddRule.ElementAdded(Microsoft.VisualStudio.Modeling.ElementAddedEventArgs)">
            <summary>
            Called when an element is added. 
            </summary>
            <param name="e"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentItemAddRule.UpdateCompartments(System.Collections.IEnumerable,System.Type,System.String,System.Boolean)">
            <summary>
            Updates the compartments for the shapes associated to the given list of model elements
            </summary>
            <param name="elements">List of model elements</param>
            <param name="shapeType">The type of shape that needs updating</param>
            <param name="compartmentName">The name of the compartment to update</param>
            <param name="repaintOnly">If true, the method will only invalidate the shape for a repaint, without re-initializing the shape.</param>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentItemDeleteRule">
            <summary>
            Rule to update compartments when an items is removed from the list
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentItemDeleteRule.ElementDeleted(Microsoft.VisualStudio.Modeling.ElementDeletedEventArgs)">
            <summary>
            Called when an element is deleted
            </summary>
            <param name="e"></param>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentItemChangeRule">
            <summary>
            Rule to update compartments when the property on an item being displayed changes.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentItemChangeRule.ElementPropertyChanged(Microsoft.VisualStudio.Modeling.ElementPropertyChangedEventArgs)">
            <summary>
            Called when an element is changed
            </summary>
            <param name="e"></param>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentItemRolePlayerChangeRule">
            <summary>
            Rule to update compartments when a roleplayer change happens
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentItemRolePlayerChangeRule.RolePlayerChanged(Microsoft.VisualStudio.Modeling.RolePlayerChangedEventArgs)">
            <summary>
            Called when the roleplayer on a link changes.
            </summary>
            <param name="e"></param>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentItemRolePlayerPositionChangeRule">
            <summary>
            Rule to update compartments when the order of items in the list changes.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentItemRolePlayerPositionChangeRule.RolePlayerPositionChanged(Microsoft.VisualStudio.Modeling.RolePlayerOrderChangedEventArgs)">
            <summary>
            Called when the order of a roleplayer in a relationship changes
            </summary>
            <param name="e"></param>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DecoratorPropertyChanged">
            <summary>
            A rule which fires when data mapped to outer text decorators has changed,
            so we can update the decorator host's bounds.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.ConnectorRolePlayerChanged">
            <summary>
            Reroute a connector when the role players of its underlying relationship change
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ConnectorRolePlayerChanged.RolePlayerChanged(Microsoft.VisualStudio.Modeling.RolePlayerChangedEventArgs)">
            <summary>
            Reroute a connector when the role players of its underlying relationship change
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty">
            <summary>
            DomainClass DomainProperty
            Description for Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.DomainClassId">
            <summary>
            DomainProperty domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.DefaultValueDomainPropertyId">
            <summary>
            DefaultValue domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.KindDomainPropertyId">
            <summary>
            Kind domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.kindPropertyStorage">
            <summary>
            Storage for Kind
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.CategoryDomainPropertyId">
            <summary>
            Category domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.categoryPropertyStorage">
            <summary>
            Storage for Category
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.GetterAccessModifierDomainPropertyId">
            <summary>
            GetterAccessModifier domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.getterAccessModifierPropertyStorage">
            <summary>
            Storage for GetterAccessModifier
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.SetterAccessModifierDomainPropertyId">
            <summary>
            SetterAccessModifier domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.setterAccessModifierPropertyStorage">
            <summary>
            Storage for SetterAccessModifier
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.IsElementNameDomainPropertyId">
            <summary>
            IsElementName domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.isElementNamePropertyStorage">
            <summary>
            Storage for IsElementName
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.IsBrowsableDomainPropertyId">
            <summary>
            IsBrowsable domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.isBrowsablePropertyStorage">
            <summary>
            Storage for IsBrowsable
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.IsUIReadOnlyDomainPropertyId">
            <summary>
            IsUIReadOnly domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.isUIReadOnlyPropertyStorage">
            <summary>
            Storage for IsUIReadOnly
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.defaultValueStorage">
            <summary>
            Custom storage for DefaultValue, which has null value by default (all the generated
            string-type properties have string.Empty value by default).
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.GetDefaultValueValue">
            <summary>
            Get the value of DefaultValue property.
            </summary>
            <returns>Value of DefaultValue property.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.SetDefaultValueValue(System.String)">
            <summary>
            Set the value of DefaultValue property.
            </summary>
            <param name="newValue">New value of DefaultValue property.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.MergeConfigure(Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Configure a newly merged DomainProperty
            </summary>
            <param name="elementGroup"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.CalculateDescription">
            <summary>
            Calculate the value of Description
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.OnNameChanged(System.String,System.String)">
            <summary>
            Handler for change of name of a DomainProperty
            </summary>
            <param name="oldValue"></param>
            <param name="newValue"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.ValidateName(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Check the property name is valid.
            Overrides the ValidateName in NamedDomainElement.
            </summary>
            <param name="context"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.ValidateDefaultValue(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Validate the domain property
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.ValidateElementName(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Validate the domain class
            </summary>
            <param name="context">context object for logging errors/warnings/informationals</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.DefaultValue">
            <summary>
            Gets or sets the value of DefaultValue domain property.
            Default value for the property, provided as a string.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.Kind">
            <summary>
            Gets or sets the value of Kind domain property.
            Determines whether the property is normal, calculated or requires custom
            storage.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.Category">
            <summary>
            Gets or sets the value of Category domain property.
            Category under which the property appears in the properties window.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.GetterAccessModifier">
            <summary>
            Gets or sets the value of GetterAccessModifier domain property.
            Determines the access modifier for the getter.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.SetterAccessModifier">
            <summary>
            Gets or sets the value of SetterAccessModifier domain property.
            Determines the access modifier for the setter.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.IsElementName">
            <summary>
            Gets or sets the value of IsElementName domain property.
            If True, the property should be used as the name of the element in which the
            property is embedded.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.IsBrowsable">
            <summary>
            Gets or sets the value of IsBrowsable domain property.
            If True, the property is marked as browsable in its corresponding property
            descriptor. As a result, it can be browsed through the properties window.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.IsUIReadOnly">
            <summary>
            Gets or sets the value of IsUIReadOnly domain property.
            If True, the property can not be edited through the UI when browsed.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.Class">
            <summary>
            Gets or sets Class.
            Class for which this is a domain property.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.Type">
            <summary>
            Gets or sets Type.
            Type of the property.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.ElementNameProvider">
            <summary>
            Gets or sets ElementNameProvider.
            External type which provides values for this property, which must have Is
            Element Name set to true.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.XmlElement">
            <summary>
            Gets or sets XmlElement.
            Xml serialization configuration data for the domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.DefaultValuePropertyHandler">
            <summary>
            Value handler for the DomainProperty.DefaultValue domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.DefaultValuePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainProperty.DefaultValue domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.DefaultValuePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.DefaultValuePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.DefaultValuePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainProperty.DefaultValue domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.KindPropertyHandler">
            <summary>
            Value handler for the DomainProperty.Kind domain property.
            </summary>
            <summary>
            Change handler for Kind
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.KindPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainProperty.Kind domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.KindPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.KindPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty,Microsoft.VisualStudio.Modeling.DslDefinition.PropertyKind)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.KindPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainProperty.Kind domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.CategoryPropertyHandler">
            <summary>
            Value handler for the DomainProperty.Category domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.CategoryPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainProperty.Category domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.CategoryPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.CategoryPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.CategoryPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainProperty.Category domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.GetterAccessModifierPropertyHandler">
            <summary>
            Value handler for the DomainProperty.GetterAccessModifier domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.GetterAccessModifierPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainProperty.GetterAccessModifier domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.GetterAccessModifierPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.GetterAccessModifierPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty,Microsoft.VisualStudio.Modeling.DslDefinition.AccessModifier)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.GetterAccessModifierPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainProperty.GetterAccessModifier domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.SetterAccessModifierPropertyHandler">
            <summary>
            Value handler for the DomainProperty.SetterAccessModifier domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.SetterAccessModifierPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainProperty.SetterAccessModifier domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.SetterAccessModifierPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.SetterAccessModifierPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty,Microsoft.VisualStudio.Modeling.DslDefinition.AccessModifier)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.SetterAccessModifierPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainProperty.SetterAccessModifier domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.IsElementNamePropertyHandler">
            <summary>
            Value handler for the DomainProperty.IsElementName domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.IsElementNamePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainProperty.IsElementName domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.IsElementNamePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.IsElementNamePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.IsElementNamePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainProperty.IsElementName domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.IsBrowsablePropertyHandler">
            <summary>
            Value handler for the DomainProperty.IsBrowsable domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.IsBrowsablePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainProperty.IsBrowsable domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.IsBrowsablePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.IsBrowsablePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.IsBrowsablePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainProperty.IsBrowsable domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.IsUIReadOnlyPropertyHandler">
            <summary>
            Value handler for the DomainProperty.IsUIReadOnly domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.IsUIReadOnlyPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainProperty.IsUIReadOnly domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.IsUIReadOnlyPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.IsUIReadOnlyPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty.IsUIReadOnlyPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainProperty.IsUIReadOnly domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral">
            <summary>
            DomainClass EnumerationLiteral
            Defines a literal for an enumeration.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral.DomainClassId">
            <summary>
            EnumerationLiteral domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral.NameDomainPropertyId">
            <summary>
            Name domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral.namePropertyStorage">
            <summary>
            Storage for Name
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral.ValueDomainPropertyId">
            <summary>
            Value domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral.valuePropertyStorage">
            <summary>
            Storage for Value
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral.CalculateDescription">
            <summary>
            Calculate the value of Description
            </summary>
            <returns></returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral.Name">
            <summary>
            Gets or sets the value of Name domain property.
            Name of the literal.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral.Value">
            <summary>
            Gets or sets the value of Value domain property.
            Integer associated with the literal. May be null.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral.Enumeration">
            <summary>
            Gets or sets Enumeration.
            Enumeration defining the literal.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral.NamePropertyHandler">
            <summary>
            Value handler for the EnumerationLiteral.Name domain property.
            </summary>
            <summary>
            Update description when Name property changes
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral.NamePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the EnumerationLiteral.Name domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral.NamePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral.NamePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral.NamePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the EnumerationLiteral.Name domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral.ValuePropertyHandler">
            <summary>
            Value handler for the EnumerationLiteral.Value domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral.ValuePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the EnumerationLiteral.Value domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral.ValuePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral.ValuePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral,System.Nullable{System.Int32})">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral.ValuePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the EnumerationLiteral.Value domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ExternalType">
            <summary>
            DomainClass ExternalType
            Provides a point of reference to an external type.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExternalType.DomainClassId">
            <summary>
            ExternalType domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExternalType.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExternalType.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute">
            <summary>
            DomainClass ClrAttribute
            Defines CLR attributes in a DSL definition.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute.DomainClassId">
            <summary>
            ClrAttribute domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute.NameDomainPropertyId">
            <summary>
            Name domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute.namePropertyStorage">
            <summary>
            Storage for Name
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute.ValidateClrAttribute(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Validate the domain class
            </summary>
            <param name="context">context object for logging errors/warnings/informationals</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute.Name">
            <summary>
            Gets or sets the value of Name domain property.
            Name of the attribute.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute.Parameters">
            <summary>
            Gets a list of Parameters.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute.NamePropertyHandler">
            <summary>
            Value handler for the ClrAttribute.Name domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute.NamePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the ClrAttribute.Name domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute.NamePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute.NamePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute.NamePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the ClrAttribute.Name domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameter">
            <summary>
            DomainClass AttributeParameter
            Parameter of a Clr Attribute.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameter.DomainClassId">
            <summary>
            AttributeParameter domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameter.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameter.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameter.NameDomainPropertyId">
            <summary>
            Name domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameter.namePropertyStorage">
            <summary>
            Storage for Name
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameter.ValueDomainPropertyId">
            <summary>
            Value domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameter.valuePropertyStorage">
            <summary>
            Storage for Value
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameter.Name">
            <summary>
            Gets or sets the value of Name domain property.
            Name of the attribute parameter.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameter.Value">
            <summary>
            Gets or sets the value of Value domain property.
            Value of this attribute parameter.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameter.Attribute">
            <summary>
            Gets or sets Attribute.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameter.NamePropertyHandler">
            <summary>
            Value handler for the AttributeParameter.Name domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameter.NamePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the AttributeParameter.Name domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameter.NamePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameter)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameter.NamePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameter,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameter.NamePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the AttributeParameter.Name domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameter.ValuePropertyHandler">
            <summary>
            Value handler for the AttributeParameter.Value domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameter.ValuePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the AttributeParameter.Value domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameter.ValuePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameter)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameter.ValuePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameter,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameter.ValuePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the AttributeParameter.Value domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath">
            <summary>
            DomainClass DomainPath
            An expression for navigating across domain classes and relationships in a DSL
            definition.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath.SegmentSeparatorCharacter">
            <summary>
            The separator used between segments in a DomainPath's concrete syntax
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath.LinksInterpretationCharacter">
            <summary>
            The character used to denote that a role should be interpreted as a traversal to Links in a DomainPath's concrete syntax
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath.ElementsInterpretationCharacter">
            <summary>
            The character used to denote that a role should be interpreted as a traversal to Elements in a DomainPath's concrete syntax
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath.DomainClassId">
            <summary>
            DomainPath domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath.lastInitializationData">
            <summary>
            The last string that this DomainPath was initialized from.
            </summary>
            <remarks>
            There are no guarantees that this matches the current content of the path.
            Only use this if you know you haven't changed the object since Initialize
            This is used to "ressurect" DomainPaths that were discarded as part of UI parsing.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath.InitializeFromDeletedPath(Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Initialize a current, active DomainPath with the initialization data from a previously deleted one
            </summary>
            <param name="deletedPath"></param>
            <returns>Whether the path has segments</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath.Compare(Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Compare two DomainPaths for value equivalence
            </summary>
            <returns>True if the paths are equivalent</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath.Initialize(System.String,System.Boolean)">
            <summary>
            Initialize a DomainPath from a serialized format
            </summary>
            <param name="serialization"></param>
            <param name="monikerize">Whether to monikerize the Role references in any PathSegments created</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath.GetHostProvidedNamespace">
            <summary>
            Walk the embedding hierarchy looking for an IPathHost to give us a default namespace
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath.GetValidStartingPoints">
            <summary>
            Returns a list of DomainClasses from which the path
            can start.
            </summary>
            <remarks>
            Walks up the embedding hierarchy looking for an IPathHost that
            to give us the list.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath.ExecuteActionOnPathHost(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath.ActOnPathHost)">
            <summary>
            Recursively walks up the embedding hierarchy looking for implementations
            of IPathHost. When it finds one, it executes the specified delegate.
            </summary>
            <remarks>
            The delegate returns a boolean indicating whether to continue searching.
            </remarks>
            <param name="child">Child object from which to start</param>
            <param name="op">Action to execute when an IPathHost implementation is found</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath.GetParentPathHost(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Walks up the embedding hierarchy and returns the first
            class above the child that implements IPathHost.
            </summary>
            <remarks>
            Returns null if no matches found.
            The search starts above the child i.e. the child will never
            be returned, even if it implements IPathHost.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath.ToString">
            <summary>
            Serialize a path to a string using the concrete syntax.
            </summary>
            <returns>The path expressed as a string</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath.VerifyPath(Microsoft.VisualStudio.Modeling.Validation.ValidationContext,System.String,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Check for errors in a DomainPath.
            Type compatibility checks are more strict at the start of a path than between segments and at the end.
            The starting class must be type-compatible with the initial segment. 
            The target class of each segment must be either type-compatible or castable to the source of the next.
            </summary>
            <param name="context"></param>
            <param name="contextDescription">Prefix to any error message generated here.</param>
            <param name="container">Element to select when error message is double clicked.</param>
            <param name="startType">DomainClass with which the start of the path should be compatible (or null to omit this check)</param>
            <param name="endType">DomainClass with which the end of the path should be compatible (or null to omit this check)</param>
            <returns>True if no errors</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath.ValidateCanParseDomainPath(Microsoft.VisualStudio.Modeling.Validation.ValidationContext)">
            <summary>
            Validate that the domain path can be parsed. If if can't be parsed,
            then it won't be possible to reload the model.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath.Segments">
            <summary>
            Gets a list of Segments.
            Segments of the path.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath.IsCollectionPath">
            <summary>
            Is this path collection valued or single valued?
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath.TargetType">
            <summary>
            The type of the final link 
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath.ActOnPathHost">
            <summary>
            Delegate called by ExecuteActionOnPathHost as it walks up the embedding hierarchy
            </summary>
            <param name="host">The path host on which to operate</param>
            <returns>A flag that indicates whether to continue processing (true=continue)</returns>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CustomEditor">
            <summary>
            DomainClass CustomEditor
            Defines an editor whose main design surface is implemented by custom code.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CustomEditor.DomainClassId">
            <summary>
            CustomEditor domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomEditor.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomEditor.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Validation">
            <summary>
            DomainClass Validation
            Defines the validation behavior for an editor.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.DomainClassId">
            <summary>
            Validation domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesMenuDomainPropertyId">
            <summary>
            UsesMenu domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.usesMenuPropertyStorage">
            <summary>
            Storage for UsesMenu
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesOpenDomainPropertyId">
            <summary>
            UsesOpen domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.usesOpenPropertyStorage">
            <summary>
            Storage for UsesOpen
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesSaveDomainPropertyId">
            <summary>
            UsesSave domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.usesSavePropertyStorage">
            <summary>
            Storage for UsesSave
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesCustomDomainPropertyId">
            <summary>
            UsesCustom domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.usesCustomPropertyStorage">
            <summary>
            Storage for UsesCustom
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesLoadDomainPropertyId">
            <summary>
            UsesLoad domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.usesLoadPropertyStorage">
            <summary>
            Storage for UsesLoad
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesMenu">
            <summary>
            Gets or sets the value of UsesMenu domain property.
            If True, validation methods which execute when the validate menu option is
            selected are employed.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesOpen">
            <summary>
            Gets or sets the value of UsesOpen domain property.
            If True, validation methods which execute on open (after successful load) are
            employed.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesSave">
            <summary>
            Gets or sets the value of UsesSave domain property.
            If True, validation methods which execute on save are employed.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesCustom">
            <summary>
            Gets or sets the value of UsesCustom domain property.
            If True, custom validation methods are employed.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesLoad">
            <summary>
            Gets or sets the value of UsesLoad domain property.
            If True, validation methods which execute on load are employed.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.Editor">
            <summary>
            Gets or sets Editor.
            Editor defining the validation behavior.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesMenuPropertyHandler">
            <summary>
            Value handler for the Validation.UsesMenu domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesMenuPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Validation.UsesMenu domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesMenuPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Validation)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesMenuPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Validation,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesMenuPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Validation.UsesMenu domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesOpenPropertyHandler">
            <summary>
            Value handler for the Validation.UsesOpen domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesOpenPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Validation.UsesOpen domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesOpenPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Validation)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesOpenPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Validation,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesOpenPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Validation.UsesOpen domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesSavePropertyHandler">
            <summary>
            Value handler for the Validation.UsesSave domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesSavePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Validation.UsesSave domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesSavePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Validation)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesSavePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Validation,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesSavePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Validation.UsesSave domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesCustomPropertyHandler">
            <summary>
            Value handler for the Validation.UsesCustom domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesCustomPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Validation.UsesCustom domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesCustomPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Validation)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesCustomPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Validation,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesCustomPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Validation.UsesCustom domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesLoadPropertyHandler">
            <summary>
            Value handler for the Validation.UsesLoad domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesLoadPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Validation.UsesLoad domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesLoadPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Validation)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesLoadPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Validation,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Validation.UsesLoadPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Validation.UsesLoad domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Port">
            <summary>
            DomainClass Port
            Defines a port shape.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShape">
            <summary>
            DomainClass GeometryShape
            Defines a shape with a geometric outline.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Shape">
            <summary>
            DomainClass Shape
            Abstract base class for geometry and compartment shapes.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShape">
            <summary>
            DomainClass BaseShape
            Abstract base class for all kinds of shape.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShape.DomainClassId">
            <summary>
            BaseShape domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShape.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShape.DslLibrary">
            <summary>
            Gets or sets DslLibrary.
            Dsl library defining the shape.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.DomainClassId">
            <summary>
            Shape domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.FillColorDomainPropertyId">
            <summary>
            FillColor domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.fillColorPropertyStorage">
            <summary>
            Storage for FillColor
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.OutlineColorDomainPropertyId">
            <summary>
            OutlineColor domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.outlineColorPropertyStorage">
            <summary>
            Storage for OutlineColor
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.InitialWidthDomainPropertyId">
            <summary>
            InitialWidth domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.initialWidthPropertyStorage">
            <summary>
            Storage for InitialWidth
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.InitialHeightDomainPropertyId">
            <summary>
            InitialHeight domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.initialHeightPropertyStorage">
            <summary>
            Storage for InitialHeight
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.OutlineDashStyleDomainPropertyId">
            <summary>
            OutlineDashStyle domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.outlineDashStylePropertyStorage">
            <summary>
            Storage for OutlineDashStyle
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.OutlineThicknessDomainPropertyId">
            <summary>
            OutlineThickness domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.outlineThicknessPropertyStorage">
            <summary>
            Storage for OutlineThickness
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.FillGradientModeDomainPropertyId">
            <summary>
            FillGradientMode domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.fillGradientModePropertyStorage">
            <summary>
            Storage for FillGradientMode
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.HasDefaultConnectionPointsDomainPropertyId">
            <summary>
            HasDefaultConnectionPoints domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.hasDefaultConnectionPointsPropertyStorage">
            <summary>
            Storage for HasDefaultConnectionPoints
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.ExposesOutlineColorAsPropertyDomainPropertyId">
            <summary>
            ExposesOutlineColorAsProperty domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.ExposesFillColorAsPropertyDomainPropertyId">
            <summary>
            ExposesFillColorAsProperty domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.ExposesOutlineDashStyleAsPropertyDomainPropertyId">
            <summary>
            ExposesOutlineDashStyleAsProperty domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.ExposesOutlineThicknessAsPropertyDomainPropertyId">
            <summary>
            ExposesOutlineThicknessAsProperty domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.ExposesFillGradientModeDomainPropertyId">
            <summary>
            ExposesFillGradientMode domain property Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.CanMerge(Microsoft.VisualStudio.Modeling.ProtoElementBase,Microsoft.VisualStudio.Modeling.ElementGroupPrototype)">
            <summary>
            Returns a value indicating whether the source element represented by the
            specified root ProtoElement can be added to this element.
            </summary>
            <param name="rootElement">
            The root ProtoElement representing a source element.  This can be null, 
            in which case the ElementGroupPrototype does not contain an ProtoElements
            and the code should inspect the ElementGroupPrototype context information.
            </param>
            <param name="elementGroupPrototype">The ElementGroupPrototype that contains the root ProtoElement.</param>
            <returns>true if the source element represented by the ProtoElement can be added to this target element.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.MergeRelate(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Called by the Merge process to create a relationship between 
            this target element and the specified source element. 
            Typically, a parent-child relationship is established
            between the target element (the parent) and the source element 
            (the child), but any relationship can be established.
            </summary>
            <param name="sourceElement">The element that is to be related to this model element.</param>
            <param name="elementGroup">The group of source ModelElements that have been rehydrated into the target store.</param>
            <remarks>
            This method is overriden to create the relationship between the target element and the specified source element.
            The base method does nothing.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.MergeDisconnect(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Performs operation opposite to MergeRelate - i.e. disconnects a given
            element from the current one (removes links created by MergeRelate).
            </summary>
            <param name="sourceElement">Element to be unmerged/disconnected.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.GetExposesOutlineColorAsPropertyValue">
            <summary>
            Calculated property calculator for ExposesOutlineColor
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.GetExposesFillColorAsPropertyValue">
            <summary>
            Calculated property calculator for ExposesFillColor
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.GetExposesOutlineDashStyleAsPropertyValue">
            <summary>
            Calculated property calculator for ExposesOutlineDashStyle
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.GetExposesOutlineThicknessAsPropertyValue">
            <summary>
            Calculated property calculator for ExposesOutlineThickness
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.GetExposesFillGradientModeValue">
            <summary>
            Calculated property calculator for ExposesFillGradientMode
            </summary>
            <returns></returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.FillColor">
            <summary>
            Gets or sets the value of FillColor domain property.
            Fill color of this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.OutlineColor">
            <summary>
            Gets or sets the value of OutlineColor domain property.
            Outline color of this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.InitialWidth">
            <summary>
            Gets or sets the value of InitialWidth domain property.
            Initial width of this shape, in inches.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.InitialHeight">
            <summary>
            Gets or sets the value of InitialHeight domain property.
            Initial height of this shape, in inches.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.OutlineDashStyle">
            <summary>
            Gets or sets the value of OutlineDashStyle domain property.
            Outline dash style of this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.OutlineThickness">
            <summary>
            Gets or sets the value of OutlineThickness domain property.
            Outline thickness of this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.FillGradientMode">
            <summary>
            Gets or sets the value of FillGradientMode domain property.
            Fill gradient mode of this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.HasDefaultConnectionPoints">
            <summary>
            Gets or sets the value of HasDefaultConnectionPoints domain property.
            If True, the shape will use top, bottom, left and right connection points in the
            generated designer.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.ExposesOutlineColorAsProperty">
            <summary>
            Gets or sets the value of ExposesOutlineColorAsProperty domain property.
            If True, a domain property has been added to the shape to allow the outline
            color to be exposed in the properties window of the generated designer.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.ExposesFillColorAsProperty">
            <summary>
            Gets or sets the value of ExposesFillColorAsProperty domain property.
            If True, a domain property has been added to the shape to allow the fill color
            to be exposed in the properties window of the generated designer.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.ExposesOutlineDashStyleAsProperty">
            <summary>
            Gets or sets the value of ExposesOutlineDashStyleAsProperty domain property.
            If True, a domain property has been added to the shape to allow the outline dash
            style to be exposed in the properties window of the generated designer.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.ExposesOutlineThicknessAsProperty">
            <summary>
            Gets or sets the value of ExposesOutlineThicknessAsProperty domain property.
            If True, a domain property has been added to the shape to allow the outline
            thickness to be exposed in the properties window of the generated designer.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.ExposesFillGradientMode">
            <summary>
            Gets or sets the value of ExposesFillGradientMode domain property.
            If True, a domain property has been added to the shape to allow the fill
            gradient mode to be exposed in the properties window of the generated designer.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.FillColorPropertyHandler">
            <summary>
            Value handler for the Shape.FillColor domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.FillColorPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Shape.FillColor domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.FillColorPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Shape)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.FillColorPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Shape,System.Drawing.Color)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.FillColorPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Shape.FillColor domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.OutlineColorPropertyHandler">
            <summary>
            Value handler for the Shape.OutlineColor domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.OutlineColorPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Shape.OutlineColor domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.OutlineColorPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Shape)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.OutlineColorPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Shape,System.Drawing.Color)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.OutlineColorPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Shape.OutlineColor domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.InitialWidthPropertyHandler">
            <summary>
            Value handler for the Shape.InitialWidth domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.InitialWidthPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Shape.InitialWidth domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.InitialWidthPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Shape)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.InitialWidthPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Shape,System.Double)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.InitialWidthPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Shape.InitialWidth domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.InitialHeightPropertyHandler">
            <summary>
            Value handler for the Shape.InitialHeight domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.InitialHeightPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Shape.InitialHeight domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.InitialHeightPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Shape)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.InitialHeightPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Shape,System.Double)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.InitialHeightPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Shape.InitialHeight domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.OutlineDashStylePropertyHandler">
            <summary>
            Value handler for the Shape.OutlineDashStyle domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.OutlineDashStylePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Shape.OutlineDashStyle domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.OutlineDashStylePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Shape)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.OutlineDashStylePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Shape,System.Drawing.Drawing2D.DashStyle)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.OutlineDashStylePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Shape.OutlineDashStyle domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.OutlineThicknessPropertyHandler">
            <summary>
            Value handler for the Shape.OutlineThickness domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.OutlineThicknessPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Shape.OutlineThickness domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.OutlineThicknessPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Shape)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.OutlineThicknessPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Shape,System.Double)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.OutlineThicknessPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Shape.OutlineThickness domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.FillGradientModePropertyHandler">
            <summary>
            Value handler for the Shape.FillGradientMode domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.FillGradientModePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Shape.FillGradientMode domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.FillGradientModePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Shape)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.FillGradientModePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Shape,Microsoft.VisualStudio.Modeling.DslDefinition.FillGradientMode)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.FillGradientModePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Shape.FillGradientMode domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.HasDefaultConnectionPointsPropertyHandler">
            <summary>
            Value handler for the Shape.HasDefaultConnectionPoints domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.HasDefaultConnectionPointsPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Shape.HasDefaultConnectionPoints domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.HasDefaultConnectionPointsPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Shape)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.HasDefaultConnectionPointsPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Shape,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.HasDefaultConnectionPointsPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Shape.HasDefaultConnectionPoints domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.ExposesOutlineColorAsPropertyPropertyHandler">
            <summary>
            Value handler for the Shape.ExposesOutlineColorAsProperty domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.ExposesOutlineColorAsPropertyPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Shape.ExposesOutlineColorAsProperty domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.ExposesOutlineColorAsPropertyPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Shape)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.ExposesOutlineColorAsPropertyPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Shape.ExposesOutlineColorAsProperty domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.ExposesFillColorAsPropertyPropertyHandler">
            <summary>
            Value handler for the Shape.ExposesFillColorAsProperty domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.ExposesFillColorAsPropertyPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Shape.ExposesFillColorAsProperty domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.ExposesFillColorAsPropertyPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Shape)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.ExposesFillColorAsPropertyPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Shape.ExposesFillColorAsProperty domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.ExposesOutlineDashStyleAsPropertyPropertyHandler">
            <summary>
            Value handler for the Shape.ExposesOutlineDashStyleAsProperty domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.ExposesOutlineDashStyleAsPropertyPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Shape.ExposesOutlineDashStyleAsProperty domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.ExposesOutlineDashStyleAsPropertyPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Shape)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.ExposesOutlineDashStyleAsPropertyPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Shape.ExposesOutlineDashStyleAsProperty domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.ExposesOutlineThicknessAsPropertyPropertyHandler">
            <summary>
            Value handler for the Shape.ExposesOutlineThicknessAsProperty domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.ExposesOutlineThicknessAsPropertyPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Shape.ExposesOutlineThicknessAsProperty domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.ExposesOutlineThicknessAsPropertyPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Shape)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.ExposesOutlineThicknessAsPropertyPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Shape.ExposesOutlineThicknessAsProperty domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.ExposesFillGradientModePropertyHandler">
            <summary>
            Value handler for the Shape.ExposesFillGradientMode domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.ExposesFillGradientModePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Shape.ExposesFillGradientMode domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.ExposesFillGradientModePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Shape)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Shape.ExposesFillGradientModePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Shape.ExposesFillGradientMode domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShape.DomainClassId">
            <summary>
            GeometryShape domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShape.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShape.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShape.GeometryDomainPropertyId">
            <summary>
            Geometry domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShape.geometryPropertyStorage">
            <summary>
            Storage for Geometry
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShape.Geometry">
            <summary>
            Gets or sets the value of Geometry domain property.
            Outline geometry of this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShape.BaseClass">
            <summary>
            Gets or sets BaseClass.
            Base geometry shape of this geometry shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShape.SubClasses">
            <summary>
            Gets a list of SubClasses.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShape.GeometryPropertyHandler">
            <summary>
            Value handler for the GeometryShape.Geometry domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShape.GeometryPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the GeometryShape.Geometry domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShape.GeometryPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShape)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShape.GeometryPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShape,Microsoft.VisualStudio.Modeling.DslDefinition.ShapeGeometry)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShape.GeometryPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the GeometryShape.Geometry domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Port.DomainClassId">
            <summary>
            Port domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Port.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Port.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Port.BaseClass">
            <summary>
            Gets or sets BaseClass.
            Base port of this port.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Port.SubClasses">
            <summary>
            Gets a list of SubClasses.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor">
            <summary>
            DomainClass DomainTypeDescriptor
            Allows the default type descriptor for a domain class to be customized.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor.DomainClassId">
            <summary>
            DomainTypeDescriptor domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor.CustomCodedDomainPropertyId">
            <summary>
            CustomCoded domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor.customCodedPropertyStorage">
            <summary>
            Storage for CustomCoded
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor.CanMerge(Microsoft.VisualStudio.Modeling.ProtoElementBase,Microsoft.VisualStudio.Modeling.ElementGroupPrototype)">
            <summary>
            Returns a value indicating whether the source element represented by the
            specified root ProtoElement can be added to this element.
            </summary>
            <param name="rootElement">
            The root ProtoElement representing a source element.  This can be null, 
            in which case the ElementGroupPrototype does not contain an ProtoElements
            and the code should inspect the ElementGroupPrototype context information.
            </param>
            <param name="elementGroupPrototype">The ElementGroupPrototype that contains the root ProtoElement.</param>
            <returns>true if the source element represented by the ProtoElement can be added to this target element.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor.MergeRelate(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Called by the Merge process to create a relationship between 
            this target element and the specified source element. 
            Typically, a parent-child relationship is established
            between the target element (the parent) and the source element 
            (the child), but any relationship can be established.
            </summary>
            <param name="sourceElement">The element that is to be related to this model element.</param>
            <param name="elementGroup">The group of source ModelElements that have been rehydrated into the target store.</param>
            <remarks>
            This method is overriden to create the relationship between the target element and the specified source element.
            The base method does nothing.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor.MergeDisconnect(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Performs operation opposite to MergeRelate - i.e. disconnects a given
            element from the current one (removes links created by MergeRelate).
            </summary>
            <param name="sourceElement">Element to be unmerged/disconnected.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor.CustomCoded">
            <summary>
            Gets or sets the value of CustomCoded domain property.
            If True, the type descriptor is defined by custom code.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor.PathsOfCustomPropertyDescriptors">
            <summary>
            Gets a list of PathsOfCustomPropertyDescriptors.
            Paths identifying properties to be included in the type descriptor.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor.Class">
            <summary>
            Gets or sets Class.
            Class to which the custom type descriptor applies.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor.CustomCodedPropertyHandler">
            <summary>
            Value handler for the DomainTypeDescriptor.CustomCoded domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor.CustomCodedPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the DomainTypeDescriptor.CustomCoded domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor.CustomCodedPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor.CustomCodedPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor.CustomCodedPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the DomainTypeDescriptor.CustomCoded domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Connector">
            <summary>
            DomainClass Connector
            Defines a connector.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.DomainClassId">
            <summary>
            Connector domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.ColorDomainPropertyId">
            <summary>
            Color domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.colorPropertyStorage">
            <summary>
            Storage for Color
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.DashStyleDomainPropertyId">
            <summary>
            DashStyle domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.dashStylePropertyStorage">
            <summary>
            Storage for DashStyle
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.SourceEndStyleDomainPropertyId">
            <summary>
            SourceEndStyle domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.sourceEndStylePropertyStorage">
            <summary>
            Storage for SourceEndStyle
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.TargetEndStyleDomainPropertyId">
            <summary>
            TargetEndStyle domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.targetEndStylePropertyStorage">
            <summary>
            Storage for TargetEndStyle
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.ThicknessDomainPropertyId">
            <summary>
            Thickness domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.thicknessPropertyStorage">
            <summary>
            Storage for Thickness
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.RoutingStyleDomainPropertyId">
            <summary>
            RoutingStyle domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.routingStylePropertyStorage">
            <summary>
            Storage for RoutingStyle
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.ExposesColorAsPropertyDomainPropertyId">
            <summary>
            ExposesColorAsProperty domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.ExposesDashStyleAsPropertyDomainPropertyId">
            <summary>
            ExposesDashStyleAsProperty domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.ExposesThicknessAsPropertyDomainPropertyId">
            <summary>
            ExposesThicknessAsProperty domain property Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.CanMerge(Microsoft.VisualStudio.Modeling.ProtoElementBase,Microsoft.VisualStudio.Modeling.ElementGroupPrototype)">
            <summary>
            Returns a value indicating whether the source element represented by the
            specified root ProtoElement can be added to this element.
            </summary>
            <param name="rootElement">
            The root ProtoElement representing a source element.  This can be null, 
            in which case the ElementGroupPrototype does not contain an ProtoElements
            and the code should inspect the ElementGroupPrototype context information.
            </param>
            <param name="elementGroupPrototype">The ElementGroupPrototype that contains the root ProtoElement.</param>
            <returns>true if the source element represented by the ProtoElement can be added to this target element.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.MergeRelate(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Called by the Merge process to create a relationship between 
            this target element and the specified source element. 
            Typically, a parent-child relationship is established
            between the target element (the parent) and the source element 
            (the child), but any relationship can be established.
            </summary>
            <param name="sourceElement">The element that is to be related to this model element.</param>
            <param name="elementGroup">The group of source ModelElements that have been rehydrated into the target store.</param>
            <remarks>
            This method is overriden to create the relationship between the target element and the specified source element.
            The base method does nothing.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.MergeDisconnect(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Performs operation opposite to MergeRelate - i.e. disconnects a given
            element from the current one (removes links created by MergeRelate).
            </summary>
            <param name="sourceElement">Element to be unmerged/disconnected.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.GetExposesColorAsPropertyValue">
            <summary>
            Calculated property calculator for ExposesColor
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.GetExposesDashStyleAsPropertyValue">
            <summary>
            Calculated property calculator for ExposesDashStyle
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.GetExposesThicknessAsPropertyValue">
            <summary>
            Calculated property calculator for ExposesThickness
            </summary>
            <returns></returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.Color">
            <summary>
            Gets or sets the value of Color domain property.
            The color of this connector.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.DashStyle">
            <summary>
            Gets or sets the value of DashStyle domain property.
            The dash style for the line for this connector.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.SourceEndStyle">
            <summary>
            Gets or sets the value of SourceEndStyle domain property.
            The source end style for this connector.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.TargetEndStyle">
            <summary>
            Gets or sets the value of TargetEndStyle domain property.
            The target end style for this connector.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.Thickness">
            <summary>
            Gets or sets the value of Thickness domain property.
            The thickness of the line for this connector, measured in inches.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.RoutingStyle">
            <summary>
            Gets or sets the value of RoutingStyle domain property.
            The style used for routing the connector. A rectilinear connector makes right
            angled turns as necessary, a straight connector does not.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.ExposesColorAsProperty">
            <summary>
            Gets or sets the value of ExposesColorAsProperty domain property.
            If True, then a domain property has been added to the connector to allow the
            color to be exposed in the properties window of the generated designer.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.ExposesDashStyleAsProperty">
            <summary>
            Gets or sets the value of ExposesDashStyleAsProperty domain property.
            If True, then a domain property has been added to the connector to allow the
            dash style to be exposed in the properties window of the generated designer.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.ExposesThicknessAsProperty">
            <summary>
            Gets or sets the value of ExposesThicknessAsProperty domain property.
            If True, then a domain property has been added to the connector to allow the
            thickness to be exposed in the properties window of the generated designer.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.BaseClass">
            <summary>
            Gets or sets BaseClass.
            Base connector of this connector.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.SubClasses">
            <summary>
            Gets a list of SubClasses.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.ColorPropertyHandler">
            <summary>
            Value handler for the Connector.Color domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.ColorPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Connector.Color domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.ColorPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Connector)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.ColorPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Connector,System.Drawing.Color)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.ColorPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Connector.Color domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.DashStylePropertyHandler">
            <summary>
            Value handler for the Connector.DashStyle domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.DashStylePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Connector.DashStyle domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.DashStylePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Connector)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.DashStylePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Connector,System.Drawing.Drawing2D.DashStyle)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.DashStylePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Connector.DashStyle domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.SourceEndStylePropertyHandler">
            <summary>
            Value handler for the Connector.SourceEndStyle domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.SourceEndStylePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Connector.SourceEndStyle domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.SourceEndStylePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Connector)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.SourceEndStylePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Connector,Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorEndStyle)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.SourceEndStylePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Connector.SourceEndStyle domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.TargetEndStylePropertyHandler">
            <summary>
            Value handler for the Connector.TargetEndStyle domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.TargetEndStylePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Connector.TargetEndStyle domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.TargetEndStylePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Connector)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.TargetEndStylePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Connector,Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorEndStyle)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.TargetEndStylePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Connector.TargetEndStyle domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.ThicknessPropertyHandler">
            <summary>
            Value handler for the Connector.Thickness domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.ThicknessPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Connector.Thickness domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.ThicknessPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Connector)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.ThicknessPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Connector,System.Double)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.ThicknessPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Connector.Thickness domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.RoutingStylePropertyHandler">
            <summary>
            Value handler for the Connector.RoutingStyle domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.RoutingStylePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Connector.RoutingStyle domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.RoutingStylePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Connector)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.RoutingStylePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Connector,Microsoft.VisualStudio.Modeling.DslDefinition.RoutingStyle)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.RoutingStylePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Connector.RoutingStyle domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.ExposesColorAsPropertyPropertyHandler">
            <summary>
            Value handler for the Connector.ExposesColorAsProperty domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.ExposesColorAsPropertyPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Connector.ExposesColorAsProperty domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.ExposesColorAsPropertyPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Connector)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.ExposesColorAsPropertyPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Connector.ExposesColorAsProperty domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.ExposesDashStyleAsPropertyPropertyHandler">
            <summary>
            Value handler for the Connector.ExposesDashStyleAsProperty domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.ExposesDashStyleAsPropertyPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Connector.ExposesDashStyleAsProperty domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.ExposesDashStyleAsPropertyPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Connector)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.ExposesDashStyleAsPropertyPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Connector.ExposesDashStyleAsProperty domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.ExposesThicknessAsPropertyPropertyHandler">
            <summary>
            Value handler for the Connector.ExposesThicknessAsProperty domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.ExposesThicknessAsPropertyPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Connector.ExposesThicknessAsProperty domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.ExposesThicknessAsPropertyPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Connector)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Connector.ExposesThicknessAsPropertyPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Connector.ExposesThicknessAsProperty domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment">
            <summary>
            DomainClass Compartment
            Defines a compartment of a compartment shape.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.DomainClassId">
            <summary>
            Compartment domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.FillColorDomainPropertyId">
            <summary>
            FillColor domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.fillColorPropertyStorage">
            <summary>
            Storage for FillColor
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitleFillColorDomainPropertyId">
            <summary>
            TitleFillColor domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.titleFillColorPropertyStorage">
            <summary>
            Storage for TitleFillColor
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.NameDomainPropertyId">
            <summary>
            Name domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.namePropertyStorage">
            <summary>
            Storage for Name
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.DefaultExpandCollapseStateDomainPropertyId">
            <summary>
            DefaultExpandCollapseState domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.defaultExpandCollapseStatePropertyStorage">
            <summary>
            Storage for DefaultExpandCollapseState
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitleFontStyleDomainPropertyId">
            <summary>
            TitleFontStyle domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.titleFontStylePropertyStorage">
            <summary>
            Storage for TitleFontStyle
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitleFontSizeDomainPropertyId">
            <summary>
            TitleFontSize domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.titleFontSizePropertyStorage">
            <summary>
            Storage for TitleFontSize
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.EntryFontStyleDomainPropertyId">
            <summary>
            EntryFontStyle domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.entryFontStylePropertyStorage">
            <summary>
            Storage for EntryFontStyle
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.EntryFontSizeDomainPropertyId">
            <summary>
            EntryFontSize domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.entryFontSizePropertyStorage">
            <summary>
            Storage for EntryFontSize
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitleDomainPropertyId">
            <summary>
            Title domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.titlePropertyStorage">
            <summary>
            Storage for Title
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.EntryTextColorDomainPropertyId">
            <summary>
            EntryTextColor domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.entryTextColorPropertyStorage">
            <summary>
            Storage for EntryTextColor
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitleTextColorDomainPropertyId">
            <summary>
            TitleTextColor domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.titleTextColorPropertyStorage">
            <summary>
            Storage for TitleTextColor
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.FillColor">
            <summary>
            Gets or sets the value of FillColor domain property.
            Fill color of the compartment.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitleFillColor">
            <summary>
            Gets or sets the value of TitleFillColor domain property.
            Fill color for the title area of the compartment.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.Name">
            <summary>
            Gets or sets the value of Name domain property.
            Name of the compartment.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.DefaultExpandCollapseState">
            <summary>
            Gets or sets the value of DefaultExpandCollapseState domain property.
            If Expanded, then the compartment is expanded on creation.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitleFontStyle">
            <summary>
            Gets or sets the value of TitleFontStyle domain property.
            Font style for text in the title of the compartment.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitleFontSize">
            <summary>
            Gets or sets the value of TitleFontSize domain property.
            Font size for text in the title of the compartment.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.EntryFontStyle">
            <summary>
            Gets or sets the value of EntryFontStyle domain property.
            Font style of an entry in the compartment list.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.EntryFontSize">
            <summary>
            Gets or sets the value of EntryFontSize domain property.
            Font size of an entry in the compartment list.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.Title">
            <summary>
            Gets or sets the value of Title domain property.
            Text that is displayed as the title of the compartment.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.EntryTextColor">
            <summary>
            Gets or sets the value of EntryTextColor domain property.
            Text color of an entry in the compartment list.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitleTextColor">
            <summary>
            Gets or sets the value of TitleTextColor domain property.
            Color of text in the title of the compartment.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.Shape">
            <summary>
            Gets or sets Shape.
            Compartment shape defining the compartments.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.CompartmentMaps">
            <summary>
            Gets a list of CompartmentMaps.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.FillColorPropertyHandler">
            <summary>
            Value handler for the Compartment.FillColor domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.FillColorPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Compartment.FillColor domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.FillColorPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Compartment)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.FillColorPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Compartment,System.Drawing.Color)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.FillColorPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Compartment.FillColor domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitleFillColorPropertyHandler">
            <summary>
            Value handler for the Compartment.TitleFillColor domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitleFillColorPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Compartment.TitleFillColor domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitleFillColorPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Compartment)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitleFillColorPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Compartment,System.Drawing.Color)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitleFillColorPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Compartment.TitleFillColor domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.NamePropertyHandler">
            <summary>
            Value handler for the Compartment.Name domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.NamePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Compartment.Name domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.NamePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Compartment)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.NamePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Compartment,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.NamePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Compartment.Name domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.DefaultExpandCollapseStatePropertyHandler">
            <summary>
            Value handler for the Compartment.DefaultExpandCollapseState domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.DefaultExpandCollapseStatePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Compartment.DefaultExpandCollapseState domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.DefaultExpandCollapseStatePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Compartment)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.DefaultExpandCollapseStatePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Compartment,Microsoft.VisualStudio.Modeling.DslDefinition.ExpandCollapseState)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.DefaultExpandCollapseStatePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Compartment.DefaultExpandCollapseState domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitleFontStylePropertyHandler">
            <summary>
            Value handler for the Compartment.TitleFontStyle domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitleFontStylePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Compartment.TitleFontStyle domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitleFontStylePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Compartment)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitleFontStylePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Compartment,System.Drawing.FontStyle)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitleFontStylePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Compartment.TitleFontStyle domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitleFontSizePropertyHandler">
            <summary>
            Value handler for the Compartment.TitleFontSize domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitleFontSizePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Compartment.TitleFontSize domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitleFontSizePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Compartment)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitleFontSizePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Compartment,System.Int32)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitleFontSizePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Compartment.TitleFontSize domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.EntryFontStylePropertyHandler">
            <summary>
            Value handler for the Compartment.EntryFontStyle domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.EntryFontStylePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Compartment.EntryFontStyle domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.EntryFontStylePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Compartment)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.EntryFontStylePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Compartment,System.Drawing.FontStyle)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.EntryFontStylePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Compartment.EntryFontStyle domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.EntryFontSizePropertyHandler">
            <summary>
            Value handler for the Compartment.EntryFontSize domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.EntryFontSizePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Compartment.EntryFontSize domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.EntryFontSizePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Compartment)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.EntryFontSizePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Compartment,System.Int32)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.EntryFontSizePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Compartment.EntryFontSize domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitlePropertyHandler">
            <summary>
            Value handler for the Compartment.Title domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitlePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Compartment.Title domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitlePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Compartment)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitlePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Compartment,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitlePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Compartment.Title domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.EntryTextColorPropertyHandler">
            <summary>
            Value handler for the Compartment.EntryTextColor domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.EntryTextColorPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Compartment.EntryTextColor domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.EntryTextColorPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Compartment)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.EntryTextColorPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Compartment,System.Drawing.Color)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.EntryTextColorPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Compartment.EntryTextColor domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitleTextColorPropertyHandler">
            <summary>
            Value handler for the Compartment.TitleTextColor domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitleTextColorPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the Compartment.TitleTextColor domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitleTextColorPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Compartment)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitleTextColorPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.Compartment,System.Drawing.Color)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Compartment.TitleTextColorPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the Compartment.TitleTextColor domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape">
            <summary>
            DomainClass CompartmentShape
            Defines a shape with compartments that can contain lists of single-line text
            entries.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.DomainClassId">
            <summary>
            CompartmentShape domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.GeometryDomainPropertyId">
            <summary>
            Geometry domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.geometryPropertyStorage">
            <summary>
            Storage for Geometry
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.IsSingleCompartmentHeaderVisibleDomainPropertyId">
            <summary>
            IsSingleCompartmentHeaderVisible domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.isSingleCompartmentHeaderVisiblePropertyStorage">
            <summary>
            Storage for IsSingleCompartmentHeaderVisible
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.DefaultExpandCollapseStateDomainPropertyId">
            <summary>
            DefaultExpandCollapseState domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.defaultExpandCollapseStatePropertyStorage">
            <summary>
            Storage for DefaultExpandCollapseState
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.CanMerge(Microsoft.VisualStudio.Modeling.ProtoElementBase,Microsoft.VisualStudio.Modeling.ElementGroupPrototype)">
            <summary>
            Returns a value indicating whether the source element represented by the
            specified root ProtoElement can be added to this element.
            </summary>
            <param name="rootElement">
            The root ProtoElement representing a source element.  This can be null, 
            in which case the ElementGroupPrototype does not contain an ProtoElements
            and the code should inspect the ElementGroupPrototype context information.
            </param>
            <param name="elementGroupPrototype">The ElementGroupPrototype that contains the root ProtoElement.</param>
            <returns>true if the source element represented by the ProtoElement can be added to this target element.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.MergeRelate(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Called by the Merge process to create a relationship between 
            this target element and the specified source element. 
            Typically, a parent-child relationship is established
            between the target element (the parent) and the source element 
            (the child), but any relationship can be established.
            </summary>
            <param name="sourceElement">The element that is to be related to this model element.</param>
            <param name="elementGroup">The group of source ModelElements that have been rehydrated into the target store.</param>
            <remarks>
            This method is overriden to create the relationship between the target element and the specified source element.
            The base method does nothing.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.MergeDisconnect(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Performs operation opposite to MergeRelate - i.e. disconnects a given
            element from the current one (removes links created by MergeRelate).
            </summary>
            <param name="sourceElement">Element to be unmerged/disconnected.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.Geometry">
            <summary>
            Gets or sets the value of Geometry domain property.
            Outline geometry of this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.IsSingleCompartmentHeaderVisible">
            <summary>
            Gets or sets the value of IsSingleCompartmentHeaderVisible domain property.
            If False and the shape has a single compartment, the header of the compartment
            is not visible.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.DefaultExpandCollapseState">
            <summary>
            Gets or sets the value of DefaultExpandCollapseState domain property.
            If Expanded, the compartments are shown on creation. If Collapsed, they are not.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.Compartments">
            <summary>
            Gets a list of Compartments.
            Compartments defined by the compartment shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.BaseClass">
            <summary>
            Gets or sets BaseClass.
            Base compartment shape of this compartment shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.SubClasses">
            <summary>
            Gets a list of SubClasses.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.GeometryPropertyHandler">
            <summary>
            Value handler for the CompartmentShape.Geometry domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.GeometryPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the CompartmentShape.Geometry domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.GeometryPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.GeometryPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape,Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeGeometry)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.GeometryPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the CompartmentShape.Geometry domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.IsSingleCompartmentHeaderVisiblePropertyHandler">
            <summary>
            Value handler for the CompartmentShape.IsSingleCompartmentHeaderVisible domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.IsSingleCompartmentHeaderVisiblePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the CompartmentShape.IsSingleCompartmentHeaderVisible domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.IsSingleCompartmentHeaderVisiblePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.IsSingleCompartmentHeaderVisiblePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.IsSingleCompartmentHeaderVisiblePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the CompartmentShape.IsSingleCompartmentHeaderVisible domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.DefaultExpandCollapseStatePropertyHandler">
            <summary>
            Value handler for the CompartmentShape.DefaultExpandCollapseState domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.DefaultExpandCollapseStatePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the CompartmentShape.DefaultExpandCollapseState domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.DefaultExpandCollapseStatePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.DefaultExpandCollapseStatePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape,Microsoft.VisualStudio.Modeling.DslDefinition.ExpandCollapseState)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape.DefaultExpandCollapseStatePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the CompartmentShape.DefaultExpandCollapseState domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShape">
            <summary>
            DomainClass ImageShape
            Defines a shape that displays an image.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShape.DomainClassId">
            <summary>
            ImageShape domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShape.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShape.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShape.ImageDomainPropertyId">
            <summary>
            Image domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShape.imagePropertyStorage">
            <summary>
            Storage for Image
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShape.Image">
            <summary>
            Gets or sets the value of Image domain property.
            Path to the image file to be used for this image shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShape.BaseClass">
            <summary>
            Gets or sets BaseClass.
            Base image shape of this image shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShape.SubClasses">
            <summary>
            Gets a list of SubClasses.
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShape.BaseImageShape
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShape.ImagePropertyHandler">
            <summary>
            Value handler for the ImageShape.Image domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShape.ImagePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the ImageShape.Image domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShape.ImagePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ImageShape)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShape.ImagePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ImageShape,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShape.ImagePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the ImageShape.Image domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.IconDecorator">
            <summary>
            DomainClass IconDecorator
            Defines a decorator that displays an icon or image.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.IconDecorator.DomainClassId">
            <summary>
            IconDecorator domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.IconDecorator.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.IconDecorator.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.IconDecorator.DefaultIconDomainPropertyId">
            <summary>
            DefaultIcon domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.IconDecorator.defaultIconPropertyStorage">
            <summary>
            Storage for DefaultIcon
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.IconDecorator.DefaultIcon">
            <summary>
            Gets or sets the value of DefaultIcon domain property.
            Path to the icon or image file to be displayed by default.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.IconDecorator.DefaultIconPropertyHandler">
            <summary>
            Value handler for the IconDecorator.DefaultIcon domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.IconDecorator.DefaultIconPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the IconDecorator.DefaultIcon domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.IconDecorator.DefaultIconPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.IconDecorator)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.IconDecorator.DefaultIconPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.IconDecorator,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.IconDecorator.DefaultIconPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the IconDecorator.DefaultIcon domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ExpandCollapseDecorator">
            <summary>
            DomainClass ExpandCollapseDecorator
            Special decorator used for showing and hiding the compartments or subshapes of a
            shape.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExpandCollapseDecorator.DomainClassId">
            <summary>
            ExpandCollapseDecorator domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExpandCollapseDecorator.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExpandCollapseDecorator.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilter">
            <summary>
            DomainClass PropertyFilter
            Defines a filter for a domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilter.DomainClassId">
            <summary>
            PropertyFilter domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilter.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilter.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilter.FilteringValueDomainPropertyId">
            <summary>
            FilteringValue domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilter.filteringValuePropertyStorage">
            <summary>
            Storage for FilteringValue
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilter.FilteringValue">
            <summary>
            Gets or sets the value of FilteringValue domain property.
            The value for which the filter returns true.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilter.VisibilityPropertyPath">
            <summary>
            Gets or sets VisibilityPropertyPath.
            Visibility property path defining the filter.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilter.FilteringValuePropertyHandler">
            <summary>
            Value handler for the PropertyFilter.FilteringValue domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilter.FilteringValuePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the PropertyFilter.FilteringValue domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilter.FilteringValuePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilter)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilter.FilteringValuePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilter,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilter.FilteringValuePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the PropertyFilter.FilteringValue domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPath">
            <summary>
            DomainClass VisibilityPropertyPath
            Defines a property path used to determine whether an element such as a decorator
            is visible or not.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPath.DomainClassId">
            <summary>
            VisibilityPropertyPath domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPath.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPath.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPath.PropertyFilters">
            <summary>
            Gets a list of PropertyFilters.
            Property values used for filtering.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane">
            <summary>
            DomainClass SwimLane
            Defines a swimlane.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.DomainClassId">
            <summary>
            SwimLane domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.HeaderFillColorDomainPropertyId">
            <summary>
            HeaderFillColor domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.headerFillColorPropertyStorage">
            <summary>
            Storage for HeaderFillColor
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.SeparatorLineStyleDomainPropertyId">
            <summary>
            SeparatorLineStyle domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.separatorLineStylePropertyStorage">
            <summary>
            Storage for SeparatorLineStyle
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.SeparatorColorDomainPropertyId">
            <summary>
            SeparatorColor domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.separatorColorPropertyStorage">
            <summary>
            Storage for SeparatorColor
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.BodyFillColorDomainPropertyId">
            <summary>
            BodyFillColor domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.bodyFillColorPropertyStorage">
            <summary>
            Storage for BodyFillColor
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.InitialWidthDomainPropertyId">
            <summary>
            InitialWidth domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.initialWidthPropertyStorage">
            <summary>
            Storage for InitialWidth
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.InitialHeightDomainPropertyId">
            <summary>
            InitialHeight domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.initialHeightPropertyStorage">
            <summary>
            Storage for InitialHeight
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.AlignmentDomainPropertyId">
            <summary>
            Alignment domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.alignmentPropertyStorage">
            <summary>
            Storage for Alignment
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.SeparatorThicknessDomainPropertyId">
            <summary>
            SeparatorThickness domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.separatorThicknessPropertyStorage">
            <summary>
            Storage for SeparatorThickness
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.CanMerge(Microsoft.VisualStudio.Modeling.ProtoElementBase,Microsoft.VisualStudio.Modeling.ElementGroupPrototype)">
            <summary>
            Returns a value indicating whether the source element represented by the
            specified root ProtoElement can be added to this element.
            </summary>
            <param name="rootElement">
            The root ProtoElement representing a source element.  This can be null, 
            in which case the ElementGroupPrototype does not contain an ProtoElements
            and the code should inspect the ElementGroupPrototype context information.
            </param>
            <param name="elementGroupPrototype">The ElementGroupPrototype that contains the root ProtoElement.</param>
            <returns>true if the source element represented by the ProtoElement can be added to this target element.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.MergeRelate(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ElementGroup)">
            <summary>
            Called by the Merge process to create a relationship between 
            this target element and the specified source element. 
            Typically, a parent-child relationship is established
            between the target element (the parent) and the source element 
            (the child), but any relationship can be established.
            </summary>
            <param name="sourceElement">The element that is to be related to this model element.</param>
            <param name="elementGroup">The group of source ModelElements that have been rehydrated into the target store.</param>
            <remarks>
            This method is overriden to create the relationship between the target element and the specified source element.
            The base method does nothing.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.MergeDisconnect(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Performs operation opposite to MergeRelate - i.e. disconnects a given
            element from the current one (removes links created by MergeRelate).
            </summary>
            <param name="sourceElement">Element to be unmerged/disconnected.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.HeaderFillColor">
            <summary>
            Gets or sets the value of HeaderFillColor domain property.
            Fill color for the header of the swimlane.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.SeparatorLineStyle">
            <summary>
            Gets or sets the value of SeparatorLineStyle domain property.
            Style of the separator line.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.SeparatorColor">
            <summary>
            Gets or sets the value of SeparatorColor domain property.
            Color of the separator line.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.BodyFillColor">
            <summary>
            Gets or sets the value of BodyFillColor domain property.
            Fill color for the body of the swimlane.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.InitialWidth">
            <summary>
            Gets or sets the value of InitialWidth domain property.
            Initial width of this swimlane, in inches. Only applicable to vertical
            swimlanes.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.InitialHeight">
            <summary>
            Gets or sets the value of InitialHeight domain property.
            Initial height of this swimlane, in inches. Only applicable to horizontal
            swimlanes.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.Alignment">
            <summary>
            Gets or sets the value of Alignment domain property.
            Whether the swimlane is horizontally or vertically aligned.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.SeparatorThickness">
            <summary>
            Gets or sets the value of SeparatorThickness domain property.
            Thickness of the separator line.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.Decorators">
            <summary>
            Gets a list of Decorators.
            Decorators defined by the swimlane.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.BaseClass">
            <summary>
            Gets or sets BaseClass.
            Base swimlane of this swimlane.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.SubClasses">
            <summary>
            Gets a list of SubClasses.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.HeaderFillColorPropertyHandler">
            <summary>
            Value handler for the SwimLane.HeaderFillColor domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.HeaderFillColorPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the SwimLane.HeaderFillColor domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.HeaderFillColorPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.HeaderFillColorPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane,System.Drawing.Color)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.HeaderFillColorPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the SwimLane.HeaderFillColor domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.SeparatorLineStylePropertyHandler">
            <summary>
            Value handler for the SwimLane.SeparatorLineStyle domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.SeparatorLineStylePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the SwimLane.SeparatorLineStyle domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.SeparatorLineStylePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.SeparatorLineStylePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane,System.Drawing.Drawing2D.DashStyle)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.SeparatorLineStylePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the SwimLane.SeparatorLineStyle domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.SeparatorColorPropertyHandler">
            <summary>
            Value handler for the SwimLane.SeparatorColor domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.SeparatorColorPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the SwimLane.SeparatorColor domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.SeparatorColorPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.SeparatorColorPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane,System.Drawing.Color)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.SeparatorColorPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the SwimLane.SeparatorColor domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.BodyFillColorPropertyHandler">
            <summary>
            Value handler for the SwimLane.BodyFillColor domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.BodyFillColorPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the SwimLane.BodyFillColor domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.BodyFillColorPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.BodyFillColorPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane,System.Drawing.Color)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.BodyFillColorPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the SwimLane.BodyFillColor domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.InitialWidthPropertyHandler">
            <summary>
            Value handler for the SwimLane.InitialWidth domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.InitialWidthPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the SwimLane.InitialWidth domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.InitialWidthPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.InitialWidthPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane,System.Double)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.InitialWidthPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the SwimLane.InitialWidth domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.InitialHeightPropertyHandler">
            <summary>
            Value handler for the SwimLane.InitialHeight domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.InitialHeightPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the SwimLane.InitialHeight domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.InitialHeightPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.InitialHeightPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane,System.Double)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.InitialHeightPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the SwimLane.InitialHeight domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.AlignmentPropertyHandler">
            <summary>
            Value handler for the SwimLane.Alignment domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.AlignmentPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the SwimLane.Alignment domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.AlignmentPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.AlignmentPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane,Microsoft.VisualStudio.Modeling.Diagrams.SwimlaneAlignment)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.AlignmentPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the SwimLane.Alignment domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.SeparatorThicknessPropertyHandler">
            <summary>
            Value handler for the SwimLane.SeparatorThickness domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.SeparatorThicknessPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the SwimLane.SeparatorThickness domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.SeparatorThicknessPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.SeparatorThicknessPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane,System.Double)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane.SeparatorThicknessPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the SwimLane.SeparatorThickness domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree">
            <summary>
            DomainClass DslDesignerDiagramTree
            Defines the tree structure for a diagram representing a DSL definition.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree.DomainClassId">
            <summary>
            DslDesignerDiagramTree domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree.TreeContainsClass(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,System.Boolean)">
            <summary>
            Find out if a reference type is already represented in a tree
            </summary>
            <param name="candidate"></param>
            <param name="notLeaf">Only return true if the reference type already has a non-leaf stored in the tree; leaves are ignored</param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree.GetNodeFromClass(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,System.Boolean)">
            <summary>
            Find a node containing a class within a tree
            </summary>
            <param name="candidate"></param>
            <param name="notLeaf">Only return a node if the reference type already has a non-leaf stored in the tree; leaves are ignored</param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree.GetNodesFromSubject(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Find all nodes containing a class within a tree
            </summary>
            <param name="candidate"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree.GetTreeFromNode(Microsoft.VisualStudio.Modeling.DslDesigner.TreeNode)">
            <summary>
            Get the tree the node is part of
            </summary>
            <param name="node"></param>
            <returns>The containing tree</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree.Roots">
            <summary>
            Gets a list of Roots.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree.DiagramState">
            <summary>
            Gets or sets DiagramState.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree.Arcs">
            <summary>
            Gets a list of Arcs.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelDomainModel">
            <summary>
            DomainModel DslDefinitionModelDomainModel
            Definition of the Dsl Designer.
            </summary>
            <summary>
            DomainModel class for DomainDomainModel
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelDomainModel.ResourceBaseName">
            <summary>
            The base name of this model's resources.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelDomainModel.DomainModelId">
            <summary>
            DslDefinitionModelDomainModel domain model Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelDomainModel.#ctor(Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Constructor.
            </summary>
            <param name="store">Store containing the domain model.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelDomainModel.GetGeneratedDomainModelTypes">
            <summary>
            Gets the list of generated domain model types (classes, rules, relationships).
            </summary>
            <returns>List of types.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelDomainModel.GetGeneratedDomainProperties">
            <summary>
            Gets the list of generated domain properties.
            </summary>
            <returns>List of property data.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelDomainModel.GetGeneratedDomainRoles">
            <summary>
            Gets the list of generated domain roles.
            </summary>
            <returns>List of role data.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelDomainModel.CreateElement(Microsoft.VisualStudio.Modeling.Partition,System.Type,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Creates an element of specified type.
            </summary>
            <param name="partition">Partition where element is to be created.</param>
            <param name="elementType">Element type which belongs to this domain model.</param>
            <param name="propertyAssignments">New element property assignments.</param>
            <returns>Created element.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelDomainModel.CreateElementLink(Microsoft.VisualStudio.Modeling.Partition,System.Type,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Creates an element link of specified type.
            </summary>
            <param name="partition">Partition where element is to be created.</param>
            <param name="elementLinkType">Element link type which belongs to this domain model.</param>
            <param name="roleAssignments">List of relationship role assignments for the new link.</param>
            <param name="propertyAssignments">New element property assignments.</param>
            <returns>Created element link.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelDomainModel.copyClosure">
            <summary>
            CopyClosure cache
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelDomainModel.removeClosure">
            <summary>
            DeleteClosure cache
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelDomainModel.GetClosureFilter(Microsoft.VisualStudio.Modeling.ClosureType,System.Collections.Generic.ICollection{Microsoft.VisualStudio.Modeling.ModelElement})">
            <summary>
            Returns an IElementVisitorFilter that corresponds to the ClosureType.
            </summary>
            <param name="type">closure type</param>
            <param name="rootElements">collection of root elements</param>
            <returns>IElementVisitorFilter or null</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelDomainModel.EnableDiagramRules(Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Enables rules in this domain model related to diagram fixup for the given store.
            If diagram data will be loaded into the store, this method should be called first to ensure
            that the diagram behaves properly.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelDomainModel.DisableDiagramRules(Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Disables rules in this domain model related to diagram fixup for the given store.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelDomainModel.GetCustomDomainModelTypes">
            <summary>
            Override to add the fake ModelElementDomainClass.
            </summary>
            <returns></returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelDomainModel.ResourceManager">
            <summary>
            Gets the DomainModel's ResourceManager. If the ResourceManager does not already exist, then it is created.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelDomainModel.SingletonResourceManager">
            <summary>
            Gets the Singleton ResourceManager for this domain model.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelDomainModel.CopyClosure">
            <summary>
            CopyClosure cache
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelDomainModel.DeleteClosure">
            <summary>
            DeleteClosure cache
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelDeleteClosure">
            <summary>
            Remove closure visitor filter
            </summary>
            <summary>
            This is a VisitorFilter that is usually invoked by the BreadthFirstRolePlayerFirstElementWalker as the result
            of a user deleting a ModelElement.  The walker traverses the tree of relationships with DSL attribute 
            PropagatesDelete true, and as it visits each node the walker adds that element to the list of elements to be 
            deleted (the closure), then examines all associated links for more candidates.  In this way the single action 
            of deleting a DomanRelationship is extended to delete associated DomainRoles, various Shapes, and the Links 
            connecting them.
            </summary>
            <remarks>
            Class is defined in ..\GeneratedCode\DomainModel.cs, which is generated from the DSL Definition model.
            </remarks>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelDeleteClosureBase">
            <summary>
            Base class for remove closure visitor filter
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelDeleteClosureBase.domainRoles">
            <summary>
            DomainRoles
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelDeleteClosureBase.#ctor">
            <summary>
            Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelDeleteClosureBase.ShouldVisitRelationship(Microsoft.VisualStudio.Modeling.ElementWalker,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRoleInfo,Microsoft.VisualStudio.Modeling.DomainRelationshipInfo,Microsoft.VisualStudio.Modeling.ElementLink)">
            <summary>
            Called to ask the filter if a particular relationship from a source element should be included in the traversal
            </summary>
            <param name="walker">ElementWalker that is traversing the model</param>
            <param name="sourceElement">Model Element playing the source role</param>
            <param name="sourceRoleInfo">DomainRoleInfo of the role that the source element is playing in the relationship</param>
            <param name="domainRelationshipInfo">DomainRelationshipInfo for the ElementLink in question</param>
            <param name="targetRelationship">Relationship in question</param>
            <returns>Yes if the relationship should be traversed</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelDeleteClosureBase.ShouldVisitRolePlayer(Microsoft.VisualStudio.Modeling.ElementWalker,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ElementLink,Microsoft.VisualStudio.Modeling.DomainRoleInfo,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Called to ask the filter if a particular role player should be Visited during traversal
            </summary>
            <param name="walker">ElementWalker that is traversing the model</param>
            <param name="sourceElement">Model Element playing the source role</param>
            <param name="elementLink">Element Link that forms the relationship to the role player in question</param>
            <param name="targetDomainRole">DomainRoleInfo of the target role</param>
            <param name="targetRolePlayer">Model Element that plays the target role in the relationship</param>
            <returns></returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelDeleteClosureBase.DomainRoles">
            <summary>
            DomainRoles
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelDeleteClosure.#ctor">
            <summary>
            Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelDeleteClosure.ShouldVisitRolePlayer(Microsoft.VisualStudio.Modeling.ElementWalker,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ElementLink,Microsoft.VisualStudio.Modeling.DomainRoleInfo,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method is called to ask the filter if a particular role player associated with an ElementLink should 
            be Visited during traversal. This overrides the generated ShouldVisitRolePlayer() method, which examines 
            the PropagateDelete attribute on the ElementLink to decide whether to visit the associated role players. 
            In this case the RelationshipPort, the shape drawn as a little square where a relationship is connected to 
            a class, was not deleted with the relationship. The reason is that the link used to connect the 
            RelationshipPort (a shape) to the RoleConnector (also a shape) is a subtype of ElementLink called 
            LinkConnectsToNode. Instances of this link type are used to associate various NodeShapes with LinkShapes 
            and so do not propagate deletes, although in the case of the RelationshipPort it should. The same problem 
            existed for InheritancePort, which like RelationshipPort extends TogglePort.
            
            This method is called for every ElementLink visited during a delete. If the link in question is an
            instance of LinkConnectsToNode and the roleplayer is a TogglePort, then the port shape may not be needed
            anymore. By checking how many links are left to the target role player this method returns 
            VisitorFilterResult.YES if there is exactly one link to the port, VisitorFilterResult.DoNotCare otherwise.
            This ensures that when the last link to the node is deleted the port shape is deleted as well.
            </summary>
            <param name="walker">ElementWalker that is traversing the model</param>
            <param name="sourceElement">Model Element playing the source role</param>
            <param name="elementLink">Element Link that forms the relationship to the role player in question</param>
            <param name="targetDomainRole">DomainRoleInfo of the target role</param>
            <param name="targetRolePlayer">Model Element that plays the target role in the relationship</param>
            <returns></returns>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelCopyClosure">
            <summary>
            Copy closure visitor filter
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelCopyClosureBase">
            <summary>
            Base class for copy closure visitor filter
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelCopyClosureBase.domainRoles">
            <summary>
            DomainRoles
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelCopyClosureBase.#ctor">
            <summary>
            Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelCopyClosureBase.ShouldVisitRelationship(Microsoft.VisualStudio.Modeling.ElementWalker,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRoleInfo,Microsoft.VisualStudio.Modeling.DomainRelationshipInfo,Microsoft.VisualStudio.Modeling.ElementLink)">
            <summary>
            Called to ask the filter if a particular relationship from a source element should be included in the traversal
            </summary>
            <param name="walker">ElementWalker traversing the model</param>
            <param name="sourceElement">Model Element playing the source role</param>
            <param name="sourceRoleInfo">DomainRoleInfo of the role that the source element is playing in the relationship</param>
            <param name="domainRelationshipInfo">DomainRelationshipInfo for the ElementLink in question</param>
            <param name="targetRelationship">Relationship in question</param>
            <returns>Yes if the relationship should be traversed</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelCopyClosureBase.ShouldVisitRolePlayer(Microsoft.VisualStudio.Modeling.ElementWalker,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ElementLink,Microsoft.VisualStudio.Modeling.DomainRoleInfo,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Called to ask the filter if a particular role player should be Visited during traversal
            </summary>
            <param name="walker">ElementWalker traversing the model</param>
            <param name="sourceElement">Model Element playing the source role</param>
            <param name="elementLink">Element Link that forms the relationship to the role player in question</param>
            <param name="targetDomainRole">DomainRoleInfo of the target role</param>
            <param name="targetRolePlayer">Model Element that plays the target role in the relationship</param>
            <returns></returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelCopyClosureBase.DomainRoles">
            <summary>
            DomainRoles
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelCopyClosure.#ctor">
            <summary>
            Constructor
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.AccessModifier">
            <summary>
            DomainEnumeration: AccessModifier
            Description for Microsoft.VisualStudio.Modeling.DslDefinition.AccessModifier
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.AccessModifier.Public">
            <summary>
            Public
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.AccessModifier.Public
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.AccessModifier.Assembly">
            <summary>
            Assembly
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.AccessModifier.Assembly
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.AccessModifier.Private">
            <summary>
            Private
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.AccessModifier.Private
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.AccessModifier.Family">
            <summary>
            Family
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.AccessModifier.Family
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.AccessModifier.FamilyOrAssembly">
            <summary>
            FamilyOrAssembly
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.AccessModifier.FamilyOrAssembly
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.TypeAccessModifier">
            <summary>
            DomainEnumeration: TypeAccessModifier
            Description for Microsoft.VisualStudio.Modeling.DslDefinition.TypeAccessModifier
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.TypeAccessModifier.Public">
            <summary>
            Public
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.TypeAccessModifier.Public
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.TypeAccessModifier.Assembly">
            <summary>
            Assembly
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.TypeAccessModifier.Assembly
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceModifier">
            <summary>
            DomainEnumeration: InheritanceModifier
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceModifier
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceModifier.None">
            <summary>
            None
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceModifier.None
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceModifier.Abstract">
            <summary>
            Abstract
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceModifier.Abstract
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceModifier.Sealed">
            <summary>
            Sealed
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceModifier.Sealed
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyKind">
            <summary>
            DomainEnumeration: PropertyKind
            Description for Microsoft.VisualStudio.Modeling.DslDefinition.PropertyKind
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyKind.Normal">
            <summary>
            Normal
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.PropertyKind.Normal
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyKind.Calculated">
            <summary>
            Calculated
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.PropertyKind.Calculated
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyKind.CustomStorage">
            <summary>
            CustomStorage
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.PropertyKind.CustomStorage
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Multiplicity">
            <summary>
            DomainEnumeration: Multiplicity
            Description for Microsoft.VisualStudio.Modeling.DslDefinition.Multiplicity
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Multiplicity.ZeroMany">
            <summary>
            ZeroMany
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.Multiplicity.ZeroMany
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Multiplicity.One">
            <summary>
            One
            Description for Microsoft.VisualStudio.Modeling.DslDefinition.Multiplicity.One
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Multiplicity.ZeroOne">
            <summary>
            ZeroOne
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.Multiplicity.ZeroOne
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Multiplicity.OneMany">
            <summary>
            OneMany
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.Multiplicity.OneMany
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentInterpretation">
            <summary>
            DomainEnumeration: PathSegmentInterpretation
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentInterpretation
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentInterpretation.Elements">
            <summary>
            Elements
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentInterpretation.Elements
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentInterpretation.Links">
            <summary>
            Links
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentInterpretation.Links
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorEndStyle">
            <summary>
            DomainEnumeration: ConnectorEndStyle
            Description for Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorEndStyle
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorEndStyle.None">
            <summary>
            None
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorEndStyle.None
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorEndStyle.HollowArrow">
            <summary>
            HollowArrow
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorEndStyle.HollowArrow
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorEndStyle.EmptyArrow">
            <summary>
            EmptyArrow
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorEndStyle.EmptyArrow
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorEndStyle.FilledArrow">
            <summary>
            FilledArrow
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorEndStyle.FilledArrow
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorEndStyle.EmptyDiamond">
            <summary>
            EmptyDiamond
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorEndStyle.EmptyDiamond
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorEndStyle.FilledDiamond">
            <summary>
            FilledDiamond
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorEndStyle.FilledDiamond
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorDecoratorPosition">
            <summary>
            DomainEnumeration: ConnectorDecoratorPosition
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorDecoratorPosition
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorDecoratorPosition.SourceTop">
            <summary>
            SourceTop
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorDecoratorPosition.SourceTop
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorDecoratorPosition.SourceBottom">
            <summary>
            SourceBottom
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorDecoratorPosition.SourceBottom
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorDecoratorPosition.TargetTop">
            <summary>
            TargetTop
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorDecoratorPosition.TargetTop
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorDecoratorPosition.TargetBottom">
            <summary>
            TargetBottom
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorDecoratorPosition.TargetBottom
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition">
            <summary>
            DomainEnumeration: ShapeDecoratorPosition
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.InnerTopLeft">
            <summary>
            InnerTopLeft
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.InnerTopLeft
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.InnerTopCenter">
            <summary>
            InnerTopCenter
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.InnerTopCenter
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.InnerTopRight">
            <summary>
            InnerTopRight
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.InnerTopRight
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.InnerMiddleLeft">
            <summary>
            InnerMiddleLeft
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.InnerMiddleLeft
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.Center">
            <summary>
            Center
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.Center
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.InnerMiddleRight">
            <summary>
            InnerMiddleRight
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.InnerMiddleRight
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.InnerBottomLeft">
            <summary>
            InnerBottomLeft
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.InnerBottomLeft
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.InnerBottomCenter">
            <summary>
            InnerBottomCenter
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.InnerBottomCenter
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.InnerBottomRight">
            <summary>
            InnerBottomRight
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.InnerBottomRight
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.OuterTopLeft">
            <summary>
            OuterTopLeft
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.OuterTopLeft
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.OuterTopCenter">
            <summary>
            OuterTopCenter
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.OuterTopCenter
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.OuterTopRight">
            <summary>
            OuterTopRight
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.OuterTopRight
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.OuterMiddleLeft">
            <summary>
            OuterMiddleLeft
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.OuterMiddleLeft
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.OuterMiddleRight">
            <summary>
            OuterMiddleRight
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.OuterMiddleRight
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.OuterBottomLeft">
            <summary>
            OuterBottomLeft
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.OuterBottomLeft
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.OuterBottomCenter">
            <summary>
            OuterBottomCenter
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.OuterBottomCenter
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.OuterBottomRight">
            <summary>
            OuterBottomRight
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition.OuterBottomRight
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeGeometry">
            <summary>
            DomainEnumeration: CompartmentShapeGeometry
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeGeometry
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeGeometry.Rectangle">
            <summary>
            Rectangle
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeGeometry.Rectangle
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeGeometry.RoundedRectangle">
            <summary>
            RoundedRectangle
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeGeometry.RoundedRectangle
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.RoutingStyle">
            <summary>
            DomainEnumeration: RoutingStyle
            Description for Microsoft.VisualStudio.Modeling.DslDefinition.RoutingStyle
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RoutingStyle.Rectilinear">
            <summary>
            Rectilinear
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.RoutingStyle.Rectilinear
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RoutingStyle.Straight">
            <summary>
            Straight
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.RoutingStyle.Straight
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeGeometry">
            <summary>
            DomainEnumeration: ShapeGeometry
            Description for Microsoft.VisualStudio.Modeling.DslDefinition.ShapeGeometry
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeGeometry.Rectangle">
            <summary>
            Rectangle
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ShapeGeometry.Rectangle
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeGeometry.RoundedRectangle">
            <summary>
            RoundedRectangle
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ShapeGeometry.RoundedRectangle
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeGeometry.Ellipse">
            <summary>
            Ellipse
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ShapeGeometry.Ellipse
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeGeometry.Circle">
            <summary>
            Circle
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ShapeGeometry.Circle
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.TooltipType">
            <summary>
            DomainEnumeration: TooltipType
            Description for Microsoft.VisualStudio.Modeling.DslDefinition.TooltipType
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.TooltipType.None">
            <summary>
            None
            Description for Microsoft.VisualStudio.Modeling.DslDefinition.TooltipType.None
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.TooltipType.Fixed">
            <summary>
            Fixed
            Description for Microsoft.VisualStudio.Modeling.DslDefinition.TooltipType.Fixed
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.TooltipType.Variable">
            <summary>
            Variable
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.TooltipType.Variable
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ExpandCollapseState">
            <summary>
            DomainEnumeration: ExpandCollapseState
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ExpandCollapseState
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExpandCollapseState.Expanded">
            <summary>
            Expanded
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ExpandCollapseState.Expanded
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExpandCollapseState.Collapsed">
            <summary>
            Collapsed
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ExpandCollapseState.Collapsed
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.FillGradientMode">
            <summary>
            DomainEnumeration: FillGradientMode
            Description for Microsoft.VisualStudio.Modeling.DslDefinition.FillGradientMode
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.FillGradientMode.Horizontal">
            <summary>
            Horizontal
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.FillGradientMode.Horizontal
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.FillGradientMode.Vertical">
            <summary>
            Vertical
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.FillGradientMode.Vertical
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.FillGradientMode.ForwardDiagonal">
            <summary>
            ForwardDiagonal
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.FillGradientMode.ForwardDiagonal
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.FillGradientMode.BackwardDiagonal">
            <summary>
            BackwardDiagonal
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.FillGradientMode.BackwardDiagonal
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.FillGradientMode.None">
            <summary>
            None
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.FillGradientMode.None
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyRepresentation">
            <summary>
            DomainEnumeration: XmlPropertyRepresentation
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyRepresentation
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyRepresentation.Attribute">
            <summary>
            Attribute
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyRepresentation.Attribute
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyRepresentation.Element">
            <summary>
            Element
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyRepresentation.Element
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyRepresentation.Ignore">
            <summary>
            Ignore
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyRepresentation.Ignore
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneDecoratorPosition">
            <summary>
            DomainEnumeration: SwimLaneDecoratorPosition
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneDecoratorPosition
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneDecoratorPosition.InnerTopLeft">
            <summary>
            InnerTopLeft
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneDecoratorPosition.InnerTopLeft
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneDecoratorPosition.InnerTopCenter">
            <summary>
            InnerTopCenter
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneDecoratorPosition.InnerTopCenter
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneDecoratorPosition.InnerTopRight">
            <summary>
            InnerTopRight
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneDecoratorPosition.InnerTopRight
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClasses">
            <summary>
            DomainRelationship DslLibraryHasClasses
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClasses
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypes">
            <summary>
            DomainRelationship DslLibraryHasReferenceTypes
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypes.DomainClassId">
            <summary>
            DslLibraryHasReferenceTypes domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypes.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">The Partition instance containing this ElementLink</param>
            <param name="roleAssignments">A set of role assignments for roleplayer initialization</param>
            <param name="propertyAssignments">A set of attribute assignments for attribute initialization</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypes.DslLibraryDomainRoleId">
            <summary>
            DslLibrary domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypes.GetDslLibrary(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets DslLibrary.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypes.SetDslLibrary(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Sets DslLibrary.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypes.ReferenceTypeDomainRoleId">
            <summary>
            ReferenceType domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypes.GetReferenceTypes(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Gets a list of ReferenceTypes.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypes.GetLinksToReferenceTypes(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Get the list of DslLibraryHasReferenceTypes links to a DslLibrary.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypes.GetLinkToDslLibrary(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the DslLibraryHasReferenceTypes link to a DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypes.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get any DslLibraryHasReferenceTypes links between a given DslLibrary and a DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypes.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the one DslLibraryHasReferenceTypes link between a given DslLibraryand a DomainClass.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypes.DslLibrary">
            <summary>
            DomainRole DslLibrary
            Reference types defined by the DSL library.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypes.ReferenceType">
            <summary>
            DomainRole ReferenceType
            Dsl library defining the reference type.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClasses.DomainClassId">
            <summary>
            DslLibraryHasClasses domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClasses.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Constructor
            Creates a DslLibraryHasClasses link in the same Partition as the given DslLibrary
            </summary>
            <param name="source">DslLibrary to use as the source of the relationship.</param>
            <param name="target">DomainClass to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClasses.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClasses.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClasses.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClasses.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClasses.DslLibraryDomainRoleId">
            <summary>
            DslLibrary domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClasses.GetDslLibrary(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets DslLibrary.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClasses.SetDslLibrary(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Sets DslLibrary.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClasses.ClassDomainRoleId">
            <summary>
            Class domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClasses.GetClasses(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Gets a list of Classes.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClasses.GetLinksToClasses(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Get the list of DslLibraryHasClasses links to a DslLibrary.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClasses.GetLinkToDslLibrary(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the DslLibraryHasClasses link to a DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClasses.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get any DslLibraryHasClasses links between a given DslLibrary and a DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClasses.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the one DslLibraryHasClasses link between a given DslLibraryand a DomainClass.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClasses.DslLibrary">
            <summary>
            DomainRole DslLibrary
            Domain classes defined by the DSL library.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClasses.Class">
            <summary>
            DomainRole Class
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClasses.ReferenceType">
            <summary>
            Gets the element playing Class domain role.
            Dsl library defining the reference type.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationships">
            <summary>
            DomainRelationship DslLibraryHasRelationships
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationships.DomainClassId">
            <summary>
            DslLibraryHasRelationships domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationships.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Constructor
            Creates a DslLibraryHasRelationships link in the same Partition as the given DslLibrary
            </summary>
            <param name="source">DslLibrary to use as the source of the relationship.</param>
            <param name="target">DomainRelationship to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationships.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationships.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationships.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationships.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationships.DslLibraryDomainRoleId">
            <summary>
            DslLibrary domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationships.GetDslLibrary(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Gets DslLibrary.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationships.SetDslLibrary(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship,Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Sets DslLibrary.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationships.RelationshipDomainRoleId">
            <summary>
            Relationship domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationships.GetRelationships(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Gets a list of Relationships.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationships.GetLinksToRelationships(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Get the list of DslLibraryHasRelationships links to a DslLibrary.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationships.GetLinkToDslLibrary(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Get the DslLibraryHasRelationships link to a DomainRelationship.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationships.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Get any DslLibraryHasRelationships links between a given DslLibrary and a DomainRelationship.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationships.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Get the one DslLibraryHasRelationships link between a given DslLibraryand a DomainRelationship.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationships.DslLibrary">
            <summary>
            DomainRole DslLibrary
            Domain relationships defined by the DSL library.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationships.Relationship">
            <summary>
            DomainRole Relationship
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationships.Relationship
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationships.ReferenceType">
            <summary>
            Gets the element playing Relationship domain role.
            Dsl library defining the reference type.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRoles">
            <summary>
            DomainRelationship RelationshipHasRoles
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRoles.DomainClassId">
            <summary>
            RelationshipHasRoles domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRoles.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">The Partition instance containing this ElementLink</param>
            <param name="roleAssignments">A set of role assignments for roleplayer initialization</param>
            <param name="propertyAssignments">A set of attribute assignments for attribute initialization</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRoles.RelationshipDomainRoleId">
            <summary>
            Relationship domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRoles.GetRelationship(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Gets Relationship.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRoles.SetRelationship(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Sets Relationship.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRoles.RoleDomainRoleId">
            <summary>
            Role domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRoles.GetRoles(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Gets a list of Roles.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRoles.GetLinksToRoles(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Get the list of RelationshipHasRoles links to a DomainRelationship.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRoles.GetLinkToRelationship(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Get the RelationshipHasRoles link to a DomainRole.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRoles.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Get any RelationshipHasRoles links between a given DomainRelationship and a DomainRole.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRoles.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Get the one RelationshipHasRoles link between a given DomainRelationshipand a DomainRole.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRoles.Relationship">
            <summary>
            DomainRole Relationship
            Roles of the relationship. There should be exactly two.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRoles.Role">
            <summary>
            DomainRole Role
            Relationship defining the role.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTarget">
            <summary>
            DomainRelationship RelationshipHasTarget
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTarget.DomainClassId">
            <summary>
            RelationshipHasTarget domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTarget.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Constructor
            Creates a RelationshipHasTarget link in the same Partition as the given DomainRelationship
            </summary>
            <param name="source">DomainRelationship to use as the source of the relationship.</param>
            <param name="target">DomainRole to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTarget.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTarget.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTarget.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTarget.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTarget.RelationshipDomainRoleId">
            <summary>
            Relationship domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTarget.GetRelationship(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Gets Relationship.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTarget.SetRelationship(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Sets Relationship.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTarget.TargetDomainRoleId">
            <summary>
            Target domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTarget.GetTarget(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Gets Target.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTarget.SetTarget(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Sets Target.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTarget.GetLinkToTarget(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Get the RelationshipHasTarget link to a DomainRelationship.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTarget.GetLinkToRelationship(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Get the RelationshipHasTarget link to a DomainRole.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTarget.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Get any RelationshipHasTarget links between a given DomainRelationship and a DomainRole.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTarget.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Get the one RelationshipHasTarget link between a given DomainRelationshipand a DomainRole.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTarget.Relationship">
            <summary>
            DomainRole Relationship
            Target role of the relationship.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTarget.Target">
            <summary>
            DomainRole Target
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTarget.Role">
            <summary>
            Gets the element playing Target domain role.
            Relationship defining the role.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSource">
            <summary>
            DomainRelationship RelationshipHasSource
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSource.DomainClassId">
            <summary>
            RelationshipHasSource domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSource.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Constructor
            Creates a RelationshipHasSource link in the same Partition as the given DomainRelationship
            </summary>
            <param name="source">DomainRelationship to use as the source of the relationship.</param>
            <param name="target">DomainRole to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSource.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSource.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSource.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSource.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSource.RelationshipDomainRoleId">
            <summary>
            Relationship domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSource.GetRelationship(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Gets Relationship.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSource.SetRelationship(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Sets Relationship.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSource.SourceDomainRoleId">
            <summary>
            Source domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSource.GetSource(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Gets Source.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSource.SetSource(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Sets Source.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSource.GetLinkToSource(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Get the RelationshipHasSource link to a DomainRelationship.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSource.GetLinkToRelationship(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Get the RelationshipHasSource link to a DomainRole.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSource.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Get any RelationshipHasSource links between a given DomainRelationship and a DomainRole.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSource.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Get the one RelationshipHasSource link between a given DomainRelationshipand a DomainRole.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSource.Relationship">
            <summary>
            DomainRole Relationship
            Source role of the relationship.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSource.Source">
            <summary>
            DomainRole Source
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSource.Role">
            <summary>
            Gets the element playing Source domain role.
            Relationship defining the role.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasProperties">
            <summary>
            DomainRelationship ClassHasProperties
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasProperties.DomainClassId">
            <summary>
            ClassHasProperties domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasProperties.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Constructor
            Creates a ClassHasProperties link in the same Partition as the given DomainClass
            </summary>
            <param name="source">DomainClass to use as the source of the relationship.</param>
            <param name="target">DomainProperty to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasProperties.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasProperties.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasProperties.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasProperties.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasProperties.ClassDomainRoleId">
            <summary>
            Class domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasProperties.GetClass(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Gets Class.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasProperties.SetClass(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Sets Class.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasProperties.PropertyDomainRoleId">
            <summary>
            Property domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasProperties.GetProperties(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets a list of Properties.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasProperties.GetLinksToProperties(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the list of ClassHasProperties links to a DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasProperties.GetLinkToClass(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Get the ClassHasProperties link to a DomainProperty.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasProperties.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Get any ClassHasProperties links between a given DomainClass and a DomainProperty.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasProperties.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Get the one ClassHasProperties link between a given DomainClassand a DomainProperty.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasProperties.Class">
            <summary>
            DomainRole Class
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasProperties.Property">
            <summary>
            DomainRole Property
            Class for which this is a domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypes">
            <summary>
            DomainRelationship DslLibraryHasTypes
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypes.DomainClassId">
            <summary>
            DslLibraryHasTypes domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypes.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDefinition.DomainType)">
            <summary>
            Constructor
            Creates a DslLibraryHasTypes link in the same Partition as the given DslLibrary
            </summary>
            <param name="source">DslLibrary to use as the source of the relationship.</param>
            <param name="target">DomainType to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypes.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypes.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypes.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypes.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypes.DslLibraryDomainRoleId">
            <summary>
            DslLibrary domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypes.GetDslLibrary(Microsoft.VisualStudio.Modeling.DslDefinition.DomainType)">
            <summary>
            Gets DslLibrary.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypes.SetDslLibrary(Microsoft.VisualStudio.Modeling.DslDefinition.DomainType,Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Sets DslLibrary.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypes.TypeDomainRoleId">
            <summary>
            Type domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypes.GetTypes(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Gets a list of Types.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypes.GetLinksToTypes(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Get the list of DslLibraryHasTypes links to a DslLibrary.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypes.GetLinkToDslLibrary(Microsoft.VisualStudio.Modeling.DslDefinition.DomainType)">
            <summary>
            Get the DslLibraryHasTypes link to a DomainType.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypes.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDefinition.DomainType)">
            <summary>
            Get any DslLibraryHasTypes links between a given DslLibrary and a DomainType.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypes.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDefinition.DomainType)">
            <summary>
            Get the one DslLibraryHasTypes link between a given DslLibraryand a DomainType.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypes.DslLibrary">
            <summary>
            DomainRole DslLibrary
            Domain types defined by the DSL library.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypes.Type">
            <summary>
            DomainRole Type
            Dsl library defining the domain type.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiterals">
            <summary>
            DomainRelationship EnumerationHasLiterals
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiterals.DomainClassId">
            <summary>
            EnumerationHasLiterals domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiterals.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration,Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral)">
            <summary>
            Constructor
            Creates a EnumerationHasLiterals link in the same Partition as the given DomainEnumeration
            </summary>
            <param name="source">DomainEnumeration to use as the source of the relationship.</param>
            <param name="target">EnumerationLiteral to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiterals.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiterals.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiterals.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiterals.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiterals.EnumerationDomainRoleId">
            <summary>
            Enumeration domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiterals.GetEnumeration(Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral)">
            <summary>
            Gets Enumeration.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiterals.SetEnumeration(Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral,Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration)">
            <summary>
            Sets Enumeration.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiterals.LiteralDomainRoleId">
            <summary>
            Literal domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiterals.GetLiterals(Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration)">
            <summary>
            Gets a list of Literals.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiterals.GetLinksToLiterals(Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration)">
            <summary>
            Get the list of EnumerationHasLiterals links to a DomainEnumeration.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiterals.GetLinkToEnumeration(Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral)">
            <summary>
            Get the EnumerationHasLiterals link to a EnumerationLiteral.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiterals.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration,Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral)">
            <summary>
            Get any EnumerationHasLiterals links between a given DomainEnumeration and a EnumerationLiteral.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiterals.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration,Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteral)">
            <summary>
            Get the one EnumerationHasLiterals link between a given DomainEnumerationand a EnumerationLiteral.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiterals.Enumeration">
            <summary>
            DomainRole Enumeration
            Literals defined by the enumeration.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiterals.Literal">
            <summary>
            DomainRole Literal
            Enumeration defining the literal.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributes">
            <summary>
            DomainRelationship AttributedDomainElementHasAttributes
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributes.DomainClassId">
            <summary>
            AttributedDomainElementHasAttributes domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributes.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement,Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute)">
            <summary>
            Constructor
            Creates a AttributedDomainElementHasAttributes link in the same Partition as the given AttributedDomainElement
            </summary>
            <param name="source">AttributedDomainElement to use as the source of the relationship.</param>
            <param name="target">ClrAttribute to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributes.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributes.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributes.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributes.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributes.ElementDomainRoleId">
            <summary>
            Element domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributes.GetElement(Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute)">
            <summary>
            Gets Element.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributes.SetElement(Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute,Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement)">
            <summary>
            Sets Element.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributes.AttributeDomainRoleId">
            <summary>
            Attribute domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributes.GetAttributes(Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement)">
            <summary>
            Gets a list of Attributes.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributes.GetLinksToAttributes(Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement)">
            <summary>
            Get the list of AttributedDomainElementHasAttributes links to a AttributedDomainElement.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributes.GetLinkToElement(Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute)">
            <summary>
            Get the AttributedDomainElementHasAttributes link to a ClrAttribute.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributes.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement,Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute)">
            <summary>
            Get any AttributedDomainElementHasAttributes links between a given AttributedDomainElement and a ClrAttribute.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributes.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement,Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute)">
            <summary>
            Get the one AttributedDomainElementHasAttributes link between a given AttributedDomainElementand a ClrAttribute.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributes.Element">
            <summary>
            DomainRole Element
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributes.Attribute">
            <summary>
            DomainRole Attribute
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributes">
            <summary>
            DomainRelationship EnumerationHasAttributes
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributes.DomainClassId">
            <summary>
            EnumerationHasAttributes domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributes.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration,Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute)">
            <summary>
            Constructor
            Creates a EnumerationHasAttributes link in the same Partition as the given DomainEnumeration
            </summary>
            <param name="source">DomainEnumeration to use as the source of the relationship.</param>
            <param name="target">ClrAttribute to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributes.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributes.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributes.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributes.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributes.EnumerationDomainRoleId">
            <summary>
            Enumeration domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributes.GetEnumeration(Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute)">
            <summary>
            Gets Enumeration.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributes.SetEnumeration(Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute,Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration)">
            <summary>
            Sets Enumeration.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributes.AttributeDomainRoleId">
            <summary>
            Attribute domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributes.GetAttributes(Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration)">
            <summary>
            Gets a list of Attributes.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributes.GetLinksToAttributes(Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration)">
            <summary>
            Get the list of EnumerationHasAttributes links to a DomainEnumeration.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributes.GetLinkToEnumeration(Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute)">
            <summary>
            Get the EnumerationHasAttributes link to a ClrAttribute.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributes.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration,Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute)">
            <summary>
            Get any EnumerationHasAttributes links between a given DomainEnumeration and a ClrAttribute.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributes.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration,Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute)">
            <summary>
            Get the one EnumerationHasAttributes link between a given DomainEnumerationand a ClrAttribute.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributes.Enumeration">
            <summary>
            DomainRole Enumeration
            Clr attributes defined for the enumeration.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributes.Attribute">
            <summary>
            DomainRole Attribute
            Enumeration defining the attribute.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParameters">
            <summary>
            DomainRelationship AttributeHasParameters
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParameters.DomainClassId">
            <summary>
            AttributeHasParameters domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParameters.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute,Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameter)">
            <summary>
            Constructor
            Creates a AttributeHasParameters link in the same Partition as the given ClrAttribute
            </summary>
            <param name="source">ClrAttribute to use as the source of the relationship.</param>
            <param name="target">AttributeParameter to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParameters.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParameters.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParameters.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParameters.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParameters.AttributeDomainRoleId">
            <summary>
            Attribute domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParameters.GetAttribute(Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameter)">
            <summary>
            Gets Attribute.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParameters.SetAttribute(Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameter,Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute)">
            <summary>
            Sets Attribute.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParameters.ParameterDomainRoleId">
            <summary>
            Parameter domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParameters.GetParameters(Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute)">
            <summary>
            Gets a list of Parameters.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParameters.GetLinksToParameters(Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute)">
            <summary>
            Get the list of AttributeHasParameters links to a ClrAttribute.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParameters.GetLinkToAttribute(Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameter)">
            <summary>
            Get the AttributeHasParameters link to a AttributeParameter.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParameters.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute,Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameter)">
            <summary>
            Get any AttributeHasParameters links between a given ClrAttribute and a AttributeParameter.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParameters.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute,Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameter)">
            <summary>
            Get the one AttributeHasParameters link between a given ClrAttributeand a AttributeParameter.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParameters.Attribute">
            <summary>
            DomainRole Attribute
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParameters.Parameter">
            <summary>
            DomainRole Parameter
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayer">
            <summary>
            DomainRelationship RolePlayerConnectDirectiveHasPathToRolePlayer
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayer.DomainClassId">
            <summary>
            RolePlayerConnectDirectiveHasPathToRolePlayer domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayer.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Constructor
            Creates a RolePlayerConnectDirectiveHasPathToRolePlayer link in the same Partition as the given RolePlayerConnectDirective
            </summary>
            <param name="source">RolePlayerConnectDirective to use as the source of the relationship.</param>
            <param name="target">DomainPath to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayer.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayer.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayer.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayer.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayer.RolePlayerConnectDirectiveDomainRoleId">
            <summary>
            RolePlayerConnectDirective domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayer.GetRolePlayerConnectDirective(Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Gets RolePlayerConnectDirective.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayer.SetRolePlayerConnectDirective(Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath,Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective)">
            <summary>
            Sets RolePlayerConnectDirective.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayer.PathToRolePlayerDomainRoleId">
            <summary>
            PathToRolePlayer domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayer.GetPathToRolePlayer(Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective)">
            <summary>
            Gets PathToRolePlayer.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayer.SetPathToRolePlayer(Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Sets PathToRolePlayer.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayer.GetLinkToPathToRolePlayer(Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective)">
            <summary>
            Get the RolePlayerConnectDirectiveHasPathToRolePlayer link to a RolePlayerConnectDirective.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayer.GetLinkToRolePlayerConnectDirective(Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Get the RolePlayerConnectDirectiveHasPathToRolePlayer link to a DomainPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayer.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Get any RolePlayerConnectDirectiveHasPathToRolePlayer links between a given RolePlayerConnectDirective and a DomainPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayer.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Get the one RolePlayerConnectDirectiveHasPathToRolePlayer link between a given RolePlayerConnectDirectiveand a DomainPath.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayer.RolePlayerConnectDirective">
            <summary>
            DomainRole RolePlayerConnectDirective
            Path to the role player being connected.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayer.PathToRolePlayer">
            <summary>
            DomainRole PathToRolePlayer
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPath">
            <summary>
            DomainRelationship ElementMergeDirectiveHasForwardingPath
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPath.DomainClassId">
            <summary>
            ElementMergeDirectiveHasForwardingPath domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPath.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Constructor
            Creates a ElementMergeDirectiveHasForwardingPath link in the same Partition as the given ElementMergeDirective
            </summary>
            <param name="source">ElementMergeDirective to use as the source of the relationship.</param>
            <param name="target">DomainPath to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPath.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPath.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPath.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPath.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPath.ElementMergeDirectiveDomainRoleId">
            <summary>
            ElementMergeDirective domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPath.GetForwardingElementMergeDirective(Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Gets ForwardingElementMergeDirective.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPath.SetForwardingElementMergeDirective(Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath,Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective)">
            <summary>
            Sets ForwardingElementMergeDirective.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPath.ForwardingPathDomainRoleId">
            <summary>
            ForwardingPath domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPath.GetForwardingPath(Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective)">
            <summary>
            Gets ForwardingPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPath.SetForwardingPath(Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Sets ForwardingPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPath.GetLinkToForwardingPath(Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective)">
            <summary>
            Get the ElementMergeDirectiveHasForwardingPath link to a ElementMergeDirective.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPath.GetLinkToForwardingElementMergeDirective(Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Get the ElementMergeDirectiveHasForwardingPath link to a DomainPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPath.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Get any ElementMergeDirectiveHasForwardingPath links between a given ElementMergeDirective and a DomainPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPath.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Get the one ElementMergeDirectiveHasForwardingPath link between a given ElementMergeDirectiveand a DomainPath.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPath.ElementMergeDirective">
            <summary>
            DomainRole ElementMergeDirective
            Path to element to which merge request is forwarded.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPath.ForwardingPath">
            <summary>
            DomainRole ForwardingPath
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPaths">
            <summary>
            DomainRelationship ElementMergeDirectiveHasLinkCreationPaths
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPaths.DomainClassId">
            <summary>
            ElementMergeDirectiveHasLinkCreationPaths domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPaths.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Constructor
            Creates a ElementMergeDirectiveHasLinkCreationPaths link in the same Partition as the given ElementMergeDirective
            </summary>
            <param name="source">ElementMergeDirective to use as the source of the relationship.</param>
            <param name="target">DomainPath to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPaths.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPaths.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPaths.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPaths.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPaths.ElementMergeDirectiveDomainRoleId">
            <summary>
            ElementMergeDirective domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPaths.GetElementMergeDirective(Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Gets ElementMergeDirective.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPaths.SetElementMergeDirective(Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath,Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective)">
            <summary>
            Sets ElementMergeDirective.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPaths.LinkCreationPathDomainRoleId">
            <summary>
            LinkCreationPath domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPaths.GetLinkCreationPaths(Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective)">
            <summary>
            Gets a list of LinkCreationPaths.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPaths.GetLinksToLinkCreationPaths(Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective)">
            <summary>
            Get the list of ElementMergeDirectiveHasLinkCreationPaths links to a ElementMergeDirective.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPaths.GetLinkToElementMergeDirective(Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Get the ElementMergeDirectiveHasLinkCreationPaths link to a DomainPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPaths.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Get any ElementMergeDirectiveHasLinkCreationPaths links between a given ElementMergeDirective and a DomainPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPaths.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Get the one ElementMergeDirectiveHasLinkCreationPaths link between a given ElementMergeDirectiveand a DomainPath.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPaths.ElementMergeDirective">
            <summary>
            DomainRole ElementMergeDirective
            Link creation paths defined by the merge directive.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPaths.LinkCreationPath">
            <summary>
            DomainRole LinkCreationPath
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderHasLinkConnectDirectives">
            <summary>
            DomainRelationship ConnectionBuilderHasLinkConnectDirectives
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderHasLinkConnectDirectives.DomainClassId">
            <summary>
            ConnectionBuilderHasLinkConnectDirectives domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderHasLinkConnectDirectives.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder,Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective)">
            <summary>
            Constructor
            Creates a ConnectionBuilderHasLinkConnectDirectives link in the same Partition as the given ConnectionBuilder
            </summary>
            <param name="source">ConnectionBuilder to use as the source of the relationship.</param>
            <param name="target">LinkConnectDirective to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderHasLinkConnectDirectives.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderHasLinkConnectDirectives.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderHasLinkConnectDirectives.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderHasLinkConnectDirectives.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderHasLinkConnectDirectives.ConnectionBuilderDomainRoleId">
            <summary>
            ConnectionBuilder domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderHasLinkConnectDirectives.GetConnectionBuilder(Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective)">
            <summary>
            Gets ConnectionBuilder.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderHasLinkConnectDirectives.SetConnectionBuilder(Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective,Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder)">
            <summary>
            Sets ConnectionBuilder.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderHasLinkConnectDirectives.LinkConnectDirectiveDomainRoleId">
            <summary>
            LinkConnectDirective domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderHasLinkConnectDirectives.GetLinkConnectDirectives(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder)">
            <summary>
            Gets a list of LinkConnectDirectives.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderHasLinkConnectDirectives.GetLinksToLinkConnectDirectives(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder)">
            <summary>
            Get the list of ConnectionBuilderHasLinkConnectDirectives links to a ConnectionBuilder.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderHasLinkConnectDirectives.GetLinkToConnectionBuilder(Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective)">
            <summary>
            Get the ConnectionBuilderHasLinkConnectDirectives link to a LinkConnectDirective.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderHasLinkConnectDirectives.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder,Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective)">
            <summary>
            Get any ConnectionBuilderHasLinkConnectDirectives links between a given ConnectionBuilder and a LinkConnectDirective.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderHasLinkConnectDirectives.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder,Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective)">
            <summary>
            Get the one ConnectionBuilderHasLinkConnectDirectives link between a given ConnectionBuilderand a LinkConnectDirective.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderHasLinkConnectDirectives.ConnectionBuilder">
            <summary>
            DomainRole ConnectionBuilder
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderHasLinkConnectDirectives.LinkConnectDirective">
            <summary>
            DomainRole LinkConnectDirective
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectives">
            <summary>
            DomainRelationship LinkConnectDirectiveHasTargetDirectives
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectives.DomainClassId">
            <summary>
            LinkConnectDirectiveHasTargetDirectives domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectives.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective,Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective)">
            <summary>
            Constructor
            Creates a LinkConnectDirectiveHasTargetDirectives link in the same Partition as the given LinkConnectDirective
            </summary>
            <param name="source">LinkConnectDirective to use as the source of the relationship.</param>
            <param name="target">RolePlayerConnectDirective to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectives.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectives.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectives.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectives.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectives.TargetOfDomainRoleId">
            <summary>
            TargetOf domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectives.GetTargetOf(Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective)">
            <summary>
            Gets TargetOf.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectives.SetTargetOf(Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective,Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective)">
            <summary>
            Sets TargetOf.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectives.TargetDirectiveDomainRoleId">
            <summary>
            TargetDirective domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectives.GetTargetDirectives(Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective)">
            <summary>
            Gets a list of TargetDirectives.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectives.GetLinksToTargetDirectives(Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective)">
            <summary>
            Get the list of LinkConnectDirectiveHasTargetDirectives links to a LinkConnectDirective.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectives.GetLinkToTargetOf(Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective)">
            <summary>
            Get the LinkConnectDirectiveHasTargetDirectives link to a RolePlayerConnectDirective.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectives.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective,Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective)">
            <summary>
            Get any LinkConnectDirectiveHasTargetDirectives links between a given LinkConnectDirective and a RolePlayerConnectDirective.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectives.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective,Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective)">
            <summary>
            Get the one LinkConnectDirectiveHasTargetDirectives link between a given LinkConnectDirectiveand a RolePlayerConnectDirective.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectives.TargetOf">
            <summary>
            DomainRole TargetOf
            Role directives specifying how a an element is connected to the target of a
            link.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectives.TargetDirective">
            <summary>
            DomainRole TargetDirective
            Link connect directive this is a target directive of.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectives">
            <summary>
            DomainRelationship LinkConnectDirectiveHasSourceDirectives
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectives.DomainClassId">
            <summary>
            LinkConnectDirectiveHasSourceDirectives domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectives.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective,Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective)">
            <summary>
            Constructor
            Creates a LinkConnectDirectiveHasSourceDirectives link in the same Partition as the given LinkConnectDirective
            </summary>
            <param name="source">LinkConnectDirective to use as the source of the relationship.</param>
            <param name="target">RolePlayerConnectDirective to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectives.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectives.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectives.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectives.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectives.SourceOfDomainRoleId">
            <summary>
            SourceOf domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectives.GetSourceOf(Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective)">
            <summary>
            Gets SourceOf.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectives.SetSourceOf(Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective,Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective)">
            <summary>
            Sets SourceOf.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectives.SourceDirectiveDomainRoleId">
            <summary>
            SourceDirective domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectives.GetSourceDirectives(Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective)">
            <summary>
            Gets a list of SourceDirectives.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectives.GetLinksToSourceDirectives(Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective)">
            <summary>
            Get the list of LinkConnectDirectiveHasSourceDirectives links to a LinkConnectDirective.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectives.GetLinkToSourceOf(Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective)">
            <summary>
            Get the LinkConnectDirectiveHasSourceDirectives link to a RolePlayerConnectDirective.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectives.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective,Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective)">
            <summary>
            Get any LinkConnectDirectiveHasSourceDirectives links between a given LinkConnectDirective and a RolePlayerConnectDirective.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectives.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective,Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective)">
            <summary>
            Get the one LinkConnectDirectiveHasSourceDirectives link between a given LinkConnectDirectiveand a RolePlayerConnectDirective.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectives.SourceOf">
            <summary>
            DomainRole SourceOf
            Role directives specifying how a an element is connected to the source of a
            link.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectives.SourceDirective">
            <summary>
            DomainRole SourceDirective
            Link connect directive this is a source directive of.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuilders">
            <summary>
            DomainRelationship DslLibraryHasConnectionBuilders
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuilders.DomainClassId">
            <summary>
            DslLibraryHasConnectionBuilders domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuilders.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder)">
            <summary>
            Constructor
            Creates a DslLibraryHasConnectionBuilders link in the same Partition as the given DslLibrary
            </summary>
            <param name="source">DslLibrary to use as the source of the relationship.</param>
            <param name="target">ConnectionBuilder to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuilders.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuilders.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuilders.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuilders.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuilders.DslLibraryDomainRoleId">
            <summary>
            DslLibrary domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuilders.GetDslLibrary(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder)">
            <summary>
            Gets DslLibrary.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuilders.SetDslLibrary(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder,Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Sets DslLibrary.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuilders.ConnectionBuilderDomainRoleId">
            <summary>
            ConnectionBuilder domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuilders.GetConnectionBuilders(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Gets a list of ConnectionBuilders.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuilders.GetLinksToConnectionBuilders(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Get the list of DslLibraryHasConnectionBuilders links to a DslLibrary.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuilders.GetLinkToDslLibrary(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder)">
            <summary>
            Get the DslLibraryHasConnectionBuilders link to a ConnectionBuilder.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuilders.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder)">
            <summary>
            Get any DslLibraryHasConnectionBuilders links between a given DslLibrary and a ConnectionBuilder.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuilders.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder)">
            <summary>
            Get the one DslLibraryHasConnectionBuilders link between a given DslLibraryand a ConnectionBuilder.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuilders.DslLibrary">
            <summary>
            DomainRole DslLibrary
            Connection builders defining the DSL library.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuilders.ConnectionBuilder">
            <summary>
            DomainRole ConnectionBuilder
            Dsl library defining the connection builder.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectives">
            <summary>
            DomainRelationship ClassHasElementMergeDirectives
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectives.DomainClassId">
            <summary>
            ClassHasElementMergeDirectives domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectives.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective)">
            <summary>
            Constructor
            Creates a ClassHasElementMergeDirectives link in the same Partition as the given DomainClass
            </summary>
            <param name="source">DomainClass to use as the source of the relationship.</param>
            <param name="target">ElementMergeDirective to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectives.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectives.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectives.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectives.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectives.ClassDomainRoleId">
            <summary>
            Class domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectives.GetDirectiveOf(Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective)">
            <summary>
            Gets DirectiveOf.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectives.SetDirectiveOf(Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Sets DirectiveOf.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectives.DirectiveDomainRoleId">
            <summary>
            Directive domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectives.GetElementMergeDirectives(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets a list of ElementMergeDirectives.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectives.GetLinksToElementMergeDirectives(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the list of ClassHasElementMergeDirectives links to a DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectives.GetLinkToDirectiveOf(Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective)">
            <summary>
            Get the ClassHasElementMergeDirectives link to a ElementMergeDirective.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectives.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective)">
            <summary>
            Get any ClassHasElementMergeDirectives links between a given DomainClass and a ElementMergeDirective.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectives.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective)">
            <summary>
            Get the one ClassHasElementMergeDirectives link between a given DomainClassand a ElementMergeDirective.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectives.Class">
            <summary>
            DomainRole Class
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectives.Directive">
            <summary>
            DomainRole Directive
            Class for which this is a merge directive.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegments">
            <summary>
            DomainRelationship PathHasSegments
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegments.DomainClassId">
            <summary>
            PathHasSegments domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegments.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath,Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment)">
            <summary>
            Constructor
            Creates a PathHasSegments link in the same Partition as the given DomainPath
            </summary>
            <param name="source">DomainPath to use as the source of the relationship.</param>
            <param name="target">PathSegment to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegments.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegments.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegments.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegments.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegments.PathDomainRoleId">
            <summary>
            Path domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegments.GetPath(Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment)">
            <summary>
            Gets Path.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegments.SetPath(Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Sets Path.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegments.SegmentDomainRoleId">
            <summary>
            Segment domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegments.GetSegments(Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Gets a list of Segments.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegments.GetLinksToSegments(Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Get the list of PathHasSegments links to a DomainPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegments.GetLinkToPath(Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment)">
            <summary>
            Get the PathHasSegments link to a PathSegment.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegments.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath,Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment)">
            <summary>
            Get any PathHasSegments links between a given DomainPath and a PathSegment.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegments.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath,Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment)">
            <summary>
            Get the one PathHasSegments link between a given DomainPathand a PathSegment.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegments.Path">
            <summary>
            DomainRole Path
            Segments of the path.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegments.Segment">
            <summary>
            DomainRole Segment
            Path defining the segment.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesEditor">
            <summary>
            DomainRelationship DslDefinesEditor
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesEditor.DomainClassId">
            <summary>
            DslDefinesEditor domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesEditor.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.Dsl,Microsoft.VisualStudio.Modeling.DslDefinition.Editor)">
            <summary>
            Constructor
            Creates a DslDefinesEditor link in the same Partition as the given Dsl
            </summary>
            <param name="source">Dsl to use as the source of the relationship.</param>
            <param name="target">Editor to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesEditor.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesEditor.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesEditor.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesEditor.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesEditor.DslDomainRoleId">
            <summary>
            Dsl domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesEditor.GetDsl(Microsoft.VisualStudio.Modeling.DslDefinition.Editor)">
            <summary>
            Gets Dsl.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesEditor.SetDsl(Microsoft.VisualStudio.Modeling.DslDefinition.Editor,Microsoft.VisualStudio.Modeling.DslDefinition.Dsl)">
            <summary>
            Sets Dsl.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesEditor.EditorDomainRoleId">
            <summary>
            Editor domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesEditor.GetEditor(Microsoft.VisualStudio.Modeling.DslDefinition.Dsl)">
            <summary>
            Gets Editor.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesEditor.SetEditor(Microsoft.VisualStudio.Modeling.DslDefinition.Dsl,Microsoft.VisualStudio.Modeling.DslDefinition.Editor)">
            <summary>
            Sets Editor.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesEditor.GetLinkToEditor(Microsoft.VisualStudio.Modeling.DslDefinition.Dsl)">
            <summary>
            Get the DslDefinesEditor link to a Dsl.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesEditor.GetLinkToDsl(Microsoft.VisualStudio.Modeling.DslDefinition.Editor)">
            <summary>
            Get the DslDefinesEditor link to a Editor.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesEditor.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.Dsl,Microsoft.VisualStudio.Modeling.DslDefinition.Editor)">
            <summary>
            Get any DslDefinesEditor links between a given Dsl and a Editor.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesEditor.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.Dsl,Microsoft.VisualStudio.Modeling.DslDefinition.Editor)">
            <summary>
            Get the one DslDefinesEditor link between a given Dsland a Editor.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesEditor.Dsl">
            <summary>
            DomainRole Dsl
            Editor defined by the DSL.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesEditor.Editor">
            <summary>
            DomainRole Editor
            Dsl defining the editor.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabHasTools">
            <summary>
            DomainRelationship ToolboxTabHasTools
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabHasTools.DomainClassId">
            <summary>
            ToolboxTabHasTools domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabHasTools.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab,Microsoft.VisualStudio.Modeling.DslDefinition.Tool)">
            <summary>
            Constructor
            Creates a ToolboxTabHasTools link in the same Partition as the given ToolboxTab
            </summary>
            <param name="source">ToolboxTab to use as the source of the relationship.</param>
            <param name="target">Tool to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabHasTools.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabHasTools.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabHasTools.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabHasTools.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabHasTools.ToolboxTabDomainRoleId">
            <summary>
            ToolboxTab domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabHasTools.GetToolboxTab(Microsoft.VisualStudio.Modeling.DslDefinition.Tool)">
            <summary>
            Gets ToolboxTab.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabHasTools.SetToolboxTab(Microsoft.VisualStudio.Modeling.DslDefinition.Tool,Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab)">
            <summary>
            Sets ToolboxTab.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabHasTools.ToolDomainRoleId">
            <summary>
            Tool domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabHasTools.GetTools(Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab)">
            <summary>
            Gets a list of Tools.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabHasTools.GetLinksToTools(Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab)">
            <summary>
            Get the list of ToolboxTabHasTools links to a ToolboxTab.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabHasTools.GetLinkToToolboxTab(Microsoft.VisualStudio.Modeling.DslDefinition.Tool)">
            <summary>
            Get the ToolboxTabHasTools link to a Tool.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabHasTools.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab,Microsoft.VisualStudio.Modeling.DslDefinition.Tool)">
            <summary>
            Get any ToolboxTabHasTools links between a given ToolboxTab and a Tool.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabHasTools.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab,Microsoft.VisualStudio.Modeling.DslDefinition.Tool)">
            <summary>
            Get the one ToolboxTabHasTools link between a given ToolboxTaband a Tool.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabHasTools.ToolboxTab">
            <summary>
            DomainRole ToolboxTab
            Tools in the toolbox tab.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabHasTools.Tool">
            <summary>
            DomainRole Tool
            Toolbox tab defining the tool.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasValidation">
            <summary>
            DomainRelationship EditorHasValidation
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasValidation.DomainClassId">
            <summary>
            EditorHasValidation domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasValidation.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.Editor,Microsoft.VisualStudio.Modeling.DslDefinition.Validation)">
            <summary>
            Constructor
            Creates a EditorHasValidation link in the same Partition as the given Editor
            </summary>
            <param name="source">Editor to use as the source of the relationship.</param>
            <param name="target">Validation to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasValidation.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasValidation.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasValidation.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasValidation.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasValidation.EditorDomainRoleId">
            <summary>
            Editor domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasValidation.GetEditor(Microsoft.VisualStudio.Modeling.DslDefinition.Validation)">
            <summary>
            Gets Editor.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasValidation.SetEditor(Microsoft.VisualStudio.Modeling.DslDefinition.Validation,Microsoft.VisualStudio.Modeling.DslDefinition.Editor)">
            <summary>
            Sets Editor.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasValidation.ValidationDomainRoleId">
            <summary>
            Validation domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasValidation.GetValidation(Microsoft.VisualStudio.Modeling.DslDefinition.Editor)">
            <summary>
            Gets Validation.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasValidation.SetValidation(Microsoft.VisualStudio.Modeling.DslDefinition.Editor,Microsoft.VisualStudio.Modeling.DslDefinition.Validation)">
            <summary>
            Sets Validation.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasValidation.GetLinkToValidation(Microsoft.VisualStudio.Modeling.DslDefinition.Editor)">
            <summary>
            Get the EditorHasValidation link to a Editor.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasValidation.GetLinkToEditor(Microsoft.VisualStudio.Modeling.DslDefinition.Validation)">
            <summary>
            Get the EditorHasValidation link to a Validation.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasValidation.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.Editor,Microsoft.VisualStudio.Modeling.DslDefinition.Validation)">
            <summary>
            Get any EditorHasValidation links between a given Editor and a Validation.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasValidation.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.Editor,Microsoft.VisualStudio.Modeling.DslDefinition.Validation)">
            <summary>
            Get the one EditorHasValidation link between a given Editorand a Validation.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasValidation.Editor">
            <summary>
            DomainRole Editor
            Validation behavior defined by the editor.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasValidation.Validation">
            <summary>
            DomainRole Validation
            Editor defining the validation behavior.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorer">
            <summary>
            DomainRelationship DslDefinesExplorer
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorer.DomainClassId">
            <summary>
            DslDefinesExplorer domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorer.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.Dsl,Microsoft.VisualStudio.Modeling.DslDefinition.Explorer)">
            <summary>
            Constructor
            Creates a DslDefinesExplorer link in the same Partition as the given Dsl
            </summary>
            <param name="source">Dsl to use as the source of the relationship.</param>
            <param name="target">Explorer to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorer.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorer.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorer.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorer.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorer.DslDomainRoleId">
            <summary>
            Dsl domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorer.GetDsl(Microsoft.VisualStudio.Modeling.DslDefinition.Explorer)">
            <summary>
            Gets Dsl.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorer.SetDsl(Microsoft.VisualStudio.Modeling.DslDefinition.Explorer,Microsoft.VisualStudio.Modeling.DslDefinition.Dsl)">
            <summary>
            Sets Dsl.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorer.ExplorerDomainRoleId">
            <summary>
            Explorer domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorer.GetExplorer(Microsoft.VisualStudio.Modeling.DslDefinition.Dsl)">
            <summary>
            Gets Explorer.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorer.SetExplorer(Microsoft.VisualStudio.Modeling.DslDefinition.Dsl,Microsoft.VisualStudio.Modeling.DslDefinition.Explorer)">
            <summary>
            Sets Explorer.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorer.GetLinkToExplorer(Microsoft.VisualStudio.Modeling.DslDefinition.Dsl)">
            <summary>
            Get the DslDefinesExplorer link to a Dsl.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorer.GetLinkToDsl(Microsoft.VisualStudio.Modeling.DslDefinition.Explorer)">
            <summary>
            Get the DslDefinesExplorer link to a Explorer.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorer.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.Dsl,Microsoft.VisualStudio.Modeling.DslDefinition.Explorer)">
            <summary>
            Get any DslDefinesExplorer links between a given Dsl and a Explorer.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorer.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.Dsl,Microsoft.VisualStudio.Modeling.DslDefinition.Explorer)">
            <summary>
            Get the one DslDefinesExplorer link between a given Dsland a Explorer.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorer.Dsl">
            <summary>
            DomainRole Dsl
            Explorer defined by the DSL.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorer.Explorer">
            <summary>
            DomainRole Explorer
            Dsl defining the explorer.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasXmlSerializationDefinition">
            <summary>
            DomainRelationship EditorHasXmlSerializationDefinition
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasXmlSerializationDefinition.DomainClassId">
            <summary>
            EditorHasXmlSerializationDefinition domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasXmlSerializationDefinition.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.Editor,Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition)">
            <summary>
            Constructor
            Creates a EditorHasXmlSerializationDefinition link in the same Partition as the given Editor
            </summary>
            <param name="source">Editor to use as the source of the relationship.</param>
            <param name="target">XmlSerializationDefinition to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasXmlSerializationDefinition.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasXmlSerializationDefinition.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasXmlSerializationDefinition.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasXmlSerializationDefinition.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasXmlSerializationDefinition.EditorDomainRoleId">
            <summary>
            Editor domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasXmlSerializationDefinition.GetEditor(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition)">
            <summary>
            Gets Editor.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasXmlSerializationDefinition.SetEditor(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition,Microsoft.VisualStudio.Modeling.DslDefinition.Editor)">
            <summary>
            Sets Editor.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasXmlSerializationDefinition.XmlSerializationDefinitionDomainRoleId">
            <summary>
            XmlSerializationDefinition domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasXmlSerializationDefinition.GetXmlSerializationDefinition(Microsoft.VisualStudio.Modeling.DslDefinition.Editor)">
            <summary>
            Gets XmlSerializationDefinition.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasXmlSerializationDefinition.SetXmlSerializationDefinition(Microsoft.VisualStudio.Modeling.DslDefinition.Editor,Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition)">
            <summary>
            Sets XmlSerializationDefinition.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasXmlSerializationDefinition.GetLinkToXmlSerializationDefinition(Microsoft.VisualStudio.Modeling.DslDefinition.Editor)">
            <summary>
            Get the EditorHasXmlSerializationDefinition link to a Editor.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasXmlSerializationDefinition.GetLinkToEditor(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition)">
            <summary>
            Get the EditorHasXmlSerializationDefinition link to a XmlSerializationDefinition.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasXmlSerializationDefinition.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.Editor,Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition)">
            <summary>
            Get any EditorHasXmlSerializationDefinition links between a given Editor and a XmlSerializationDefinition.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasXmlSerializationDefinition.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.Editor,Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition)">
            <summary>
            Get the one EditorHasXmlSerializationDefinition link between a given Editorand a XmlSerializationDefinition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasXmlSerializationDefinition.Editor">
            <summary>
            DomainRole Editor
            Xml serialization behavior wrapper defined by the editor.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasXmlSerializationDefinition.XmlSerializationDefinition">
            <summary>
            DomainRole XmlSerializationDefinition
            Editor defining the xml serialization behavior wrapper.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasToolboxTabs">
            <summary>
            DomainRelationship EditorHasToolboxTabs
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasToolboxTabs.DomainClassId">
            <summary>
            EditorHasToolboxTabs domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasToolboxTabs.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.Editor,Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab)">
            <summary>
            Constructor
            Creates a EditorHasToolboxTabs link in the same Partition as the given Editor
            </summary>
            <param name="source">Editor to use as the source of the relationship.</param>
            <param name="target">ToolboxTab to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasToolboxTabs.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasToolboxTabs.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasToolboxTabs.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasToolboxTabs.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasToolboxTabs.EditorDomainRoleId">
            <summary>
            Editor domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasToolboxTabs.GetEditor(Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab)">
            <summary>
            Gets Editor.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasToolboxTabs.SetEditor(Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab,Microsoft.VisualStudio.Modeling.DslDefinition.Editor)">
            <summary>
            Sets Editor.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasToolboxTabs.ToolboxTabDomainRoleId">
            <summary>
            ToolboxTab domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasToolboxTabs.GetToolboxTabs(Microsoft.VisualStudio.Modeling.DslDefinition.Editor)">
            <summary>
            Gets a list of ToolboxTabs.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasToolboxTabs.GetLinksToToolboxTabs(Microsoft.VisualStudio.Modeling.DslDefinition.Editor)">
            <summary>
            Get the list of EditorHasToolboxTabs links to a Editor.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasToolboxTabs.GetLinkToEditor(Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab)">
            <summary>
            Get the EditorHasToolboxTabs link to a ToolboxTab.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasToolboxTabs.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.Editor,Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab)">
            <summary>
            Get any EditorHasToolboxTabs links between a given Editor and a ToolboxTab.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasToolboxTabs.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.Editor,Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab)">
            <summary>
            Get the one EditorHasToolboxTabs link between a given Editorand a ToolboxTab.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasToolboxTabs.Editor">
            <summary>
            DomainRole Editor
            Toolbox tabs defined by the editor.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.EditorHasToolboxTabs.ToolboxTab">
            <summary>
            DomainRole ToolboxTab
            The editor defining the toolbox tab.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorerBehavior">
            <summary>
            DomainRelationship DslDefinesExplorerBehavior
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorerBehavior.DomainClassId">
            <summary>
            DslDefinesExplorerBehavior domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorerBehavior.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior)">
            <summary>
            Constructor
            Creates a DslDefinesExplorerBehavior link in the same Partition as the given DslLibrary
            </summary>
            <param name="source">DslLibrary to use as the source of the relationship.</param>
            <param name="target">ExplorerBehavior to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorerBehavior.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorerBehavior.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorerBehavior.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorerBehavior.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorerBehavior.DslDomainRoleId">
            <summary>
            Dsl domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorerBehavior.GetDslLibrary(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior)">
            <summary>
            Gets DslLibrary.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorerBehavior.SetDslLibrary(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior,Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Sets DslLibrary.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorerBehavior.ExplorerBehaviorDomainRoleId">
            <summary>
            ExplorerBehavior domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorerBehavior.GetExplorerBehavior(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Gets ExplorerBehavior.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorerBehavior.SetExplorerBehavior(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior)">
            <summary>
            Sets ExplorerBehavior.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorerBehavior.GetLinkToExplorerBehavior(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Get the DslDefinesExplorerBehavior link to a DslLibrary.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorerBehavior.GetLinkToDslLibrary(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior)">
            <summary>
            Get the DslDefinesExplorerBehavior link to a ExplorerBehavior.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorerBehavior.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior)">
            <summary>
            Get any DslDefinesExplorerBehavior links between a given DslLibrary and a ExplorerBehavior.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorerBehavior.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior)">
            <summary>
            Get the one DslDefinesExplorerBehavior link between a given DslLibraryand a ExplorerBehavior.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorerBehavior.Dsl">
            <summary>
            DomainRole Dsl
            Explorer behavior defined by the DSL library.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinesExplorerBehavior.ExplorerBehavior">
            <summary>
            DomainRole ExplorerBehavior
            Dsl library defining the explorer behavior.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor">
            <summary>
            DomainRelationship CustomPropertyDescriptor
            Relates a type descriptor to a property path, thereby defining a custom property
            descriptor.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.DomainClassId">
            <summary>
            CustomPropertyDescriptor domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor,Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath)">
            <summary>
            Constructor
            Creates a CustomPropertyDescriptor link in the same Partition as the given DomainTypeDescriptor
            </summary>
            <param name="source">DomainTypeDescriptor to use as the source of the relationship.</param>
            <param name="target">PropertyPath to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.TypeDescriptorDomainRoleId">
            <summary>
            TypeDescriptor domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.GetTypeDescriptor(Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath)">
            <summary>
            Gets TypeDescriptor.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.SetTypeDescriptor(Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath,Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor)">
            <summary>
            Sets TypeDescriptor.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.DistantPropertyPathDomainRoleId">
            <summary>
            DistantPropertyPath domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.GetPathsOfCustomPropertyDescriptors(Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor)">
            <summary>
            Gets a list of PathsOfCustomPropertyDescriptors.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.IsUIReadOnlyDomainPropertyId">
            <summary>
            IsUIReadOnly domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.isUIReadOnlyPropertyStorage">
            <summary>
            Storage for IsUIReadOnly
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.CategoryDomainPropertyId">
            <summary>
            Category domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.categoryPropertyStorage">
            <summary>
            Storage for Category
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.GeneratesCustomPropertyDescriptorDomainPropertyId">
            <summary>
            GeneratesCustomPropertyDescriptor domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.generatesCustomPropertyDescriptorPropertyStorage">
            <summary>
            Storage for GeneratesCustomPropertyDescriptor
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.DisplayNameDomainPropertyId">
            <summary>
            DisplayName domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.displayNamePropertyStorage">
            <summary>
            Storage for DisplayName
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.GetLinksToPathsOfCustomPropertyDescriptors(Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor)">
            <summary>
            Get the list of CustomPropertyDescriptor links to a DomainTypeDescriptor.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.GetLinkToTypeDescriptor(Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath)">
            <summary>
            Get the CustomPropertyDescriptor link to a PropertyPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor,Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath)">
            <summary>
            Get any CustomPropertyDescriptor links between a given DomainTypeDescriptor and a PropertyPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor,Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath)">
            <summary>
            Get the one CustomPropertyDescriptor link between a given DomainTypeDescriptorand a PropertyPath.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.TypeDescriptor">
            <summary>
            DomainRole TypeDescriptor
            Paths identifying properties to be included in the type descriptor.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.DistantPropertyPath">
            <summary>
            DomainRole DistantPropertyPath
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.IsUIReadOnly">
            <summary>
            Gets or sets the value of IsUIReadOnly domain property.
            If True, the property can not be edited through the UI when browsed.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.Category">
            <summary>
            Gets or sets the value of Category domain property.
            Category under which the property appears in the properties window.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.GeneratesCustomPropertyDescriptor">
            <summary>
            Gets or sets the value of GeneratesCustomPropertyDescriptor domain property.
            If True, a custom property descriptor is generated.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.DisplayName">
            <summary>
            Gets or sets the value of DisplayName domain property.
            The name that will be displayed in the generated designer for the property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.IsUIReadOnlyPropertyHandler">
            <summary>
            Value handler for the CustomPropertyDescriptor.IsUIReadOnly domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.IsUIReadOnlyPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the CustomPropertyDescriptor.IsUIReadOnly domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.IsUIReadOnlyPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.IsUIReadOnlyPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.IsUIReadOnlyPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the CustomPropertyDescriptor.IsUIReadOnly domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.CategoryPropertyHandler">
            <summary>
            Value handler for the CustomPropertyDescriptor.Category domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.CategoryPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the CustomPropertyDescriptor.Category domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.CategoryPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.CategoryPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.CategoryPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the CustomPropertyDescriptor.Category domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.GeneratesCustomPropertyDescriptorPropertyHandler">
            <summary>
            Value handler for the CustomPropertyDescriptor.GeneratesCustomPropertyDescriptor domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.GeneratesCustomPropertyDescriptorPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the CustomPropertyDescriptor.GeneratesCustomPropertyDescriptor domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.GeneratesCustomPropertyDescriptorPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.GeneratesCustomPropertyDescriptorPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor,System.Boolean)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.GeneratesCustomPropertyDescriptorPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the CustomPropertyDescriptor.GeneratesCustomPropertyDescriptor domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.DisplayNamePropertyHandler">
            <summary>
            Value handler for the CustomPropertyDescriptor.DisplayName domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.DisplayNamePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the CustomPropertyDescriptor.DisplayName domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.DisplayNamePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.DisplayNamePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor,System.String)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor.DisplayNamePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the CustomPropertyDescriptor.DisplayName domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPath">
            <summary>
            DomainRelationship ExplorerNodeSettingsHasPropertyDisplayedPath
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPath.DomainClassId">
            <summary>
            ExplorerNodeSettingsHasPropertyDisplayedPath domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPath.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings,Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath)">
            <summary>
            Constructor
            Creates a ExplorerNodeSettingsHasPropertyDisplayedPath link in the same Partition as the given ExplorerNodeSettings
            </summary>
            <param name="source">ExplorerNodeSettings to use as the source of the relationship.</param>
            <param name="target">PropertyPath to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPath.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPath.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPath.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPath.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPath.ExplorerNodeSettingsDomainRoleId">
            <summary>
            ExplorerNodeSettings domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPath.GetExplorerNodeSettings(Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath)">
            <summary>
            Gets ExplorerNodeSettings.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPath.SetExplorerNodeSettings(Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath,Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings)">
            <summary>
            Sets ExplorerNodeSettings.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPath.PropertyDisplayedPathDomainRoleId">
            <summary>
            PropertyDisplayedPath domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPath.GetPropertyDisplayed(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings)">
            <summary>
            Gets PropertyDisplayed.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPath.SetPropertyDisplayed(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings,Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath)">
            <summary>
            Sets PropertyDisplayed.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPath.GetLinkToPropertyDisplayed(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings)">
            <summary>
            Get the ExplorerNodeSettingsHasPropertyDisplayedPath link to a ExplorerNodeSettings.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPath.GetLinkToExplorerNodeSettings(Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath)">
            <summary>
            Get the ExplorerNodeSettingsHasPropertyDisplayedPath link to a PropertyPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPath.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings,Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath)">
            <summary>
            Get any ExplorerNodeSettingsHasPropertyDisplayedPath links between a given ExplorerNodeSettings and a PropertyPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPath.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings,Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath)">
            <summary>
            Get the one ExplorerNodeSettingsHasPropertyDisplayedPath link between a given ExplorerNodeSettingsand a PropertyPath.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPath.ExplorerNodeSettings">
            <summary>
            DomainRole ExplorerNodeSettings
            Path to the property used to label for the explorer node.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPath.PropertyDisplayedPath">
            <summary>
            DomainRole PropertyDisplayedPath
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptor">
            <summary>
            DomainRelationship DomainClassHasCustomTypeDescriptor
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptor.DomainClassId">
            <summary>
            DomainClassHasCustomTypeDescriptor domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptor.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor)">
            <summary>
            Constructor
            Creates a DomainClassHasCustomTypeDescriptor link in the same Partition as the given DomainClass
            </summary>
            <param name="source">DomainClass to use as the source of the relationship.</param>
            <param name="target">DomainTypeDescriptor to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptor.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptor.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptor.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptor.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptor.ClassDomainRoleId">
            <summary>
            Class domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptor.GetClass(Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor)">
            <summary>
            Gets Class.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptor.SetClass(Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Sets Class.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptor.CustomTypeDescriptorDomainRoleId">
            <summary>
            CustomTypeDescriptor domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptor.GetCustomTypeDescriptor(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets CustomTypeDescriptor.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptor.SetCustomTypeDescriptor(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor)">
            <summary>
            Sets CustomTypeDescriptor.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptor.GetLinkToCustomTypeDescriptor(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the DomainClassHasCustomTypeDescriptor link to a DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptor.GetLinkToClass(Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor)">
            <summary>
            Get the DomainClassHasCustomTypeDescriptor link to a DomainTypeDescriptor.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptor.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor)">
            <summary>
            Get any DomainClassHasCustomTypeDescriptor links between a given DomainClass and a DomainTypeDescriptor.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptor.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor)">
            <summary>
            Get the one DomainClassHasCustomTypeDescriptor link between a given DomainClassand a DomainTypeDescriptor.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptor.Class">
            <summary>
            DomainRole Class
            Definition of the custom type descriptor for the class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptor.CustomTypeDescriptor">
            <summary>
            DomainRole CustomTypeDescriptor
            Class to which the custom type descriptor applies.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodes">
            <summary>
            DomainRelationship ExplorerHidesNodes
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodes.DomainClassId">
            <summary>
            ExplorerHidesNodes domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodes.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Constructor
            Creates a ExplorerHidesNodes link in the same Partition as the given ExplorerBehavior
            </summary>
            <param name="source">ExplorerBehavior to use as the source of the relationship.</param>
            <param name="target">DomainPath to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodes.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodes.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodes.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodes.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodes.ExplorerDomainRoleId">
            <summary>
            Explorer domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodes.GetExplorerBehavior(Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Gets ExplorerBehavior.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodes.SetExplorerBehavior(Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath,Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior)">
            <summary>
            Sets ExplorerBehavior.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodes.HiddenNodeDomainRoleId">
            <summary>
            HiddenNode domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodes.GetHiddenNodes(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior)">
            <summary>
            Gets a list of HiddenNodes.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodes.GetLinksToHiddenNodes(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior)">
            <summary>
            Get the list of ExplorerHidesNodes links to a ExplorerBehavior.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodes.GetLinkToExplorerBehavior(Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Get the ExplorerHidesNodes link to a DomainPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodes.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Get any ExplorerHidesNodes links between a given ExplorerBehavior and a DomainPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodes.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Get the one ExplorerHidesNodes link between a given ExplorerBehaviorand a DomainPath.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodes.Explorer">
            <summary>
            DomainRole Explorer
            Paths to elements whose explorer nodes should be hidden.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodes.HiddenNode">
            <summary>
            DomainRole HiddenNode
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettings">
            <summary>
            DomainRelationship ExplorerBehaviorHasNodeSettings
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettings.DomainClassId">
            <summary>
            ExplorerBehaviorHasNodeSettings domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettings.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior,Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings)">
            <summary>
            Constructor
            Creates a ExplorerBehaviorHasNodeSettings link in the same Partition as the given ExplorerBehavior
            </summary>
            <param name="source">ExplorerBehavior to use as the source of the relationship.</param>
            <param name="target">ExplorerNodeSettings to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettings.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettings.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettings.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettings.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettings.ExplorerBehaviorDomainRoleId">
            <summary>
            ExplorerBehavior domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettings.GetExplorerBehavior(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings)">
            <summary>
            Gets ExplorerBehavior.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettings.SetExplorerBehavior(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings,Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior)">
            <summary>
            Sets ExplorerBehavior.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettings.CustomNodeSettingsDomainRoleId">
            <summary>
            CustomNodeSettings domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettings.GetCustomNodeSettings(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior)">
            <summary>
            Gets a list of CustomNodeSettings.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettings.GetLinksToCustomNodeSettings(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior)">
            <summary>
            Get the list of ExplorerBehaviorHasNodeSettings links to a ExplorerBehavior.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettings.GetLinkToExplorerBehavior(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings)">
            <summary>
            Get the ExplorerBehaviorHasNodeSettings link to a ExplorerNodeSettings.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettings.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior,Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings)">
            <summary>
            Get any ExplorerBehaviorHasNodeSettings links between a given ExplorerBehavior and a ExplorerNodeSettings.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettings.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior,Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings)">
            <summary>
            Get the one ExplorerBehaviorHasNodeSettings link between a given ExplorerBehaviorand a ExplorerNodeSettings.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettings.ExplorerBehavior">
            <summary>
            DomainRole ExplorerBehavior
            Custom node settings defined for the explorer behavior.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettings.CustomNodeSettings">
            <summary>
            DomainRole CustomNodeSettings
            Explorer behavior defining the custom explorer node settings.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators">
            <summary>
            DomainRelationship ShapeHasDecorators
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecorators">
            <summary>
            DomainRelationship DiagramElementHasDecorators
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecorators.DomainClassId">
            <summary>
            DiagramElementHasDecorators domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecorators.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">The Partition instance containing this ElementLink</param>
            <param name="roleAssignments">A set of role assignments for roleplayer initialization</param>
            <param name="propertyAssignments">A set of attribute assignments for attribute initialization</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecorators.DiagramElementDomainRoleId">
            <summary>
            DiagramElement domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecorators.GetDiagramElement(Microsoft.VisualStudio.Modeling.DslDefinition.Decorator)">
            <summary>
            Gets DiagramElement.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecorators.SetDiagramElement(Microsoft.VisualStudio.Modeling.DslDefinition.Decorator,Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement)">
            <summary>
            Sets DiagramElement.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecorators.DecoratorDomainRoleId">
            <summary>
            Decorator domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecorators.GetDecorators(Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement)">
            <summary>
            Gets a list of Decorators.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecorators.GetLinksToDecorators(Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement)">
            <summary>
            Get the list of DiagramElementHasDecorators links to a DiagramElement.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecorators.GetLinkToDiagramElement(Microsoft.VisualStudio.Modeling.DslDefinition.Decorator)">
            <summary>
            Get the DiagramElementHasDecorators link to a Decorator.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecorators.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement,Microsoft.VisualStudio.Modeling.DslDefinition.Decorator)">
            <summary>
            Get any DiagramElementHasDecorators links between a given DiagramElement and a Decorator.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecorators.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement,Microsoft.VisualStudio.Modeling.DslDefinition.Decorator)">
            <summary>
            Get the one DiagramElementHasDecorators link between a given DiagramElementand a Decorator.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecorators.DiagramElement">
            <summary>
            DomainRole DiagramElement
            Decorators for the diagram element.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecorators.Decorator">
            <summary>
            DomainRole Decorator
            Diagram element to which the decorator belongs.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.DomainClassId">
            <summary>
            ShapeHasDecorators domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.Shape,Microsoft.VisualStudio.Modeling.DslDefinition.Decorator)">
            <summary>
            Constructor
            Creates a ShapeHasDecorators link in the same Partition as the given Shape
            </summary>
            <param name="source">Shape to use as the source of the relationship.</param>
            <param name="target">Decorator to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.ShapeDomainRoleId">
            <summary>
            Shape domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.GetShape(Microsoft.VisualStudio.Modeling.DslDefinition.Decorator)">
            <summary>
            Gets Shape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.SetShape(Microsoft.VisualStudio.Modeling.DslDefinition.Decorator,Microsoft.VisualStudio.Modeling.DslDefinition.Shape)">
            <summary>
            Sets Shape.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.DecoratorDomainRoleId">
            <summary>
            Decorator domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.GetDecorators(Microsoft.VisualStudio.Modeling.DslDefinition.Shape)">
            <summary>
            Gets a list of Decorators.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.PositionDomainPropertyId">
            <summary>
            Position domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.positionPropertyStorage">
            <summary>
            Storage for Position
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.HorizontalOffsetDomainPropertyId">
            <summary>
            HorizontalOffset domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.horizontalOffsetPropertyStorage">
            <summary>
            Storage for HorizontalOffset
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.VerticalOffsetDomainPropertyId">
            <summary>
            VerticalOffset domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.verticalOffsetPropertyStorage">
            <summary>
            Storage for VerticalOffset
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.GetLinksToDecorators(Microsoft.VisualStudio.Modeling.DslDefinition.Shape)">
            <summary>
            Get the list of ShapeHasDecorators links to a Shape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.GetLinkToShape(Microsoft.VisualStudio.Modeling.DslDefinition.Decorator)">
            <summary>
            Get the ShapeHasDecorators link to a Decorator.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.Shape,Microsoft.VisualStudio.Modeling.DslDefinition.Decorator)">
            <summary>
            Get any ShapeHasDecorators links between a given Shape and a Decorator.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.Shape,Microsoft.VisualStudio.Modeling.DslDefinition.Decorator)">
            <summary>
            Get the one ShapeHasDecorators link between a given Shapeand a Decorator.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.Shape">
            <summary>
            DomainRole Shape
            Decorators defined by the shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.DiagramElement">
            <summary>
            Gets the element playing Shape domain role.
            Decorators for the diagram element.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.Decorator">
            <summary>
            DomainRole Decorator
            Shape defining the decorator.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.Position">
            <summary>
            Gets or sets the value of Position domain property.
            Default position of the decorator.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.HorizontalOffset">
            <summary>
            Gets or sets the value of HorizontalOffset domain property.
            Horizontal offset in inches relative to the default position of the decorator.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.VerticalOffset">
            <summary>
            Gets or sets the value of VerticalOffset domain property.
            Vertical offset in inches relative to the default position of the decorator.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.PositionPropertyHandler">
            <summary>
            Value handler for the ShapeHasDecorators.Position domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.PositionPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the ShapeHasDecorators.Position domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.PositionPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.PositionPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators,Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.PositionPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the ShapeHasDecorators.Position domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.HorizontalOffsetPropertyHandler">
            <summary>
            Value handler for the ShapeHasDecorators.HorizontalOffset domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.HorizontalOffsetPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the ShapeHasDecorators.HorizontalOffset domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.HorizontalOffsetPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.HorizontalOffsetPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators,System.Double)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.HorizontalOffsetPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the ShapeHasDecorators.HorizontalOffset domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.VerticalOffsetPropertyHandler">
            <summary>
            Value handler for the ShapeHasDecorators.VerticalOffset domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.VerticalOffsetPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the ShapeHasDecorators.VerticalOffset domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.VerticalOffsetPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.VerticalOffsetPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators,System.Double)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecorators.VerticalOffsetPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the ShapeHasDecorators.VerticalOffset domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators">
            <summary>
            DomainRelationship ConnectorHasDecorators
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.DomainClassId">
            <summary>
            ConnectorHasDecorators domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.Connector,Microsoft.VisualStudio.Modeling.DslDefinition.Decorator)">
            <summary>
            Constructor
            Creates a ConnectorHasDecorators link in the same Partition as the given Connector
            </summary>
            <param name="source">Connector to use as the source of the relationship.</param>
            <param name="target">Decorator to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.ConnectorDomainRoleId">
            <summary>
            Connector domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.GetConnector(Microsoft.VisualStudio.Modeling.DslDefinition.Decorator)">
            <summary>
            Gets Connector.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.SetConnector(Microsoft.VisualStudio.Modeling.DslDefinition.Decorator,Microsoft.VisualStudio.Modeling.DslDefinition.Connector)">
            <summary>
            Sets Connector.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.DecoratorDomainRoleId">
            <summary>
            Decorator domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.GetDecorators(Microsoft.VisualStudio.Modeling.DslDefinition.Connector)">
            <summary>
            Gets a list of Decorators.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.PositionDomainPropertyId">
            <summary>
            Position domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.positionPropertyStorage">
            <summary>
            Storage for Position
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.OffsetFromShapeDomainPropertyId">
            <summary>
            OffsetFromShape domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.offsetFromShapePropertyStorage">
            <summary>
            Storage for OffsetFromShape
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.OffsetFromLineDomainPropertyId">
            <summary>
            OffsetFromLine domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.offsetFromLinePropertyStorage">
            <summary>
            Storage for OffsetFromLine
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.GetLinksToDecorators(Microsoft.VisualStudio.Modeling.DslDefinition.Connector)">
            <summary>
            Get the list of ConnectorHasDecorators links to a Connector.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.GetLinkToConnector(Microsoft.VisualStudio.Modeling.DslDefinition.Decorator)">
            <summary>
            Get the ConnectorHasDecorators link to a Decorator.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.Connector,Microsoft.VisualStudio.Modeling.DslDefinition.Decorator)">
            <summary>
            Get any ConnectorHasDecorators links between a given Connector and a Decorator.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.Connector,Microsoft.VisualStudio.Modeling.DslDefinition.Decorator)">
            <summary>
            Get the one ConnectorHasDecorators link between a given Connectorand a Decorator.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.Connector">
            <summary>
            DomainRole Connector
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.DiagramElement">
            <summary>
            Gets the element playing Connector domain role.
            Decorators for the diagram element.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.Decorator">
            <summary>
            DomainRole Decorator
            Connector to which the decorator belongs.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.Position">
            <summary>
            Gets or sets the value of Position domain property.
            Default position of the decorator.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.OffsetFromShape">
            <summary>
            Gets or sets the value of OffsetFromShape domain property.
            Offset in inches of the decorator from the shape relative to its default
            position.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.OffsetFromLine">
            <summary>
            Gets or sets the value of OffsetFromLine domain property.
            Offset in inches of the decorator from the line relative to its default
            position.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.PositionPropertyHandler">
            <summary>
            Value handler for the ConnectorHasDecorators.Position domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.PositionPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the ConnectorHasDecorators.Position domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.PositionPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.PositionPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators,Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorDecoratorPosition)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.PositionPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the ConnectorHasDecorators.Position domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.OffsetFromShapePropertyHandler">
            <summary>
            Value handler for the ConnectorHasDecorators.OffsetFromShape domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.OffsetFromShapePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the ConnectorHasDecorators.OffsetFromShape domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.OffsetFromShapePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.OffsetFromShapePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators,System.Double)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.OffsetFromShapePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the ConnectorHasDecorators.OffsetFromShape domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.OffsetFromLinePropertyHandler">
            <summary>
            Value handler for the ConnectorHasDecorators.OffsetFromLine domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.OffsetFromLinePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the ConnectorHasDecorators.OffsetFromLine domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.OffsetFromLinePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.OffsetFromLinePropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators,System.Double)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecorators.OffsetFromLinePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the ConnectorHasDecorators.OffsetFromLine domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectors">
            <summary>
            DomainRelationship DslLibraryDefinesConnectors
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElements">
            <summary>
            DomainRelationship DslLibraryDefinesElements
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElements.DomainClassId">
            <summary>
            DslLibraryDefinesElements domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElements.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">The Partition instance containing this ElementLink</param>
            <param name="roleAssignments">A set of role assignments for roleplayer initialization</param>
            <param name="propertyAssignments">A set of attribute assignments for attribute initialization</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElements.DslLibraryDomainRoleId">
            <summary>
            DslLibrary domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElements.GetDslLibrary(Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement)">
            <summary>
            Gets DslLibrary.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElements.SetDslLibrary(Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement,Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Sets DslLibrary.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElements.DiagramElementDomainRoleId">
            <summary>
            DiagramElement domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElements.GetDiagramElements(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Gets a list of DiagramElements.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElements.GetLinksToDiagramElements(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Get the list of DslLibraryDefinesElements links to a DslLibrary.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElements.GetLinkToDslLibrary(Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement)">
            <summary>
            Get the DslLibraryDefinesElements link to a DiagramElement.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElements.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement)">
            <summary>
            Get any DslLibraryDefinesElements links between a given DslLibrary and a DiagramElement.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElements.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElement)">
            <summary>
            Get the one DslLibraryDefinesElements link between a given DslLibraryand a DiagramElement.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElements.DslLibrary">
            <summary>
            DomainRole DslLibrary
            Diagram elements defined by the DSL library.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElements.DiagramElement">
            <summary>
            DomainRole DiagramElement
            Dsl library defining the diagram element.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElements.ReferenceType">
            <summary>
            Gets the element playing DiagramElement domain role.
            Dsl library defining the reference type.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectors.DomainClassId">
            <summary>
            DslLibraryDefinesConnectors domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectors.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDefinition.Connector)">
            <summary>
            Constructor
            Creates a DslLibraryDefinesConnectors link in the same Partition as the given DslLibrary
            </summary>
            <param name="source">DslLibrary to use as the source of the relationship.</param>
            <param name="target">Connector to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectors.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectors.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectors.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectors.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectors.DslLibraryDomainRoleId">
            <summary>
            DslLibrary domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectors.GetDslLibrary(Microsoft.VisualStudio.Modeling.DslDefinition.Connector)">
            <summary>
            Gets DslLibrary.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectors.SetDslLibrary(Microsoft.VisualStudio.Modeling.DslDefinition.Connector,Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Sets DslLibrary.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectors.ConnectorDomainRoleId">
            <summary>
            Connector domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectors.GetConnectors(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Gets a list of Connectors.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectors.GetLinksToConnectors(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Get the list of DslLibraryDefinesConnectors links to a DslLibrary.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectors.GetLinkToDslLibrary(Microsoft.VisualStudio.Modeling.DslDefinition.Connector)">
            <summary>
            Get the DslLibraryDefinesConnectors link to a Connector.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectors.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDefinition.Connector)">
            <summary>
            Get any DslLibraryDefinesConnectors links between a given DslLibrary and a Connector.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectors.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDefinition.Connector)">
            <summary>
            Get the one DslLibraryDefinesConnectors link between a given DslLibraryand a Connector.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectors.DslLibrary">
            <summary>
            DomainRole DslLibrary
            Connectors defined by DSL library.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectors.Connector">
            <summary>
            DomainRole Connector
            Dsl library defining the connector.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectors.DiagramElement">
            <summary>
            Gets the element playing Connector domain role.
            Dsl library defining the diagram element.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasCompartments">
            <summary>
            DomainRelationship ShapeHasCompartments
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasCompartments.DomainClassId">
            <summary>
            ShapeHasCompartments domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasCompartments.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape,Microsoft.VisualStudio.Modeling.DslDefinition.Compartment)">
            <summary>
            Constructor
            Creates a ShapeHasCompartments link in the same Partition as the given CompartmentShape
            </summary>
            <param name="source">CompartmentShape to use as the source of the relationship.</param>
            <param name="target">Compartment to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasCompartments.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasCompartments.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasCompartments.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasCompartments.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasCompartments.ShapeDomainRoleId">
            <summary>
            Shape domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasCompartments.GetShape(Microsoft.VisualStudio.Modeling.DslDefinition.Compartment)">
            <summary>
            Gets Shape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasCompartments.SetShape(Microsoft.VisualStudio.Modeling.DslDefinition.Compartment,Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape)">
            <summary>
            Sets Shape.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasCompartments.CompartmentDomainRoleId">
            <summary>
            Compartment domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasCompartments.GetCompartments(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape)">
            <summary>
            Gets a list of Compartments.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasCompartments.GetLinksToCompartments(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape)">
            <summary>
            Get the list of ShapeHasCompartments links to a CompartmentShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasCompartments.GetLinkToShape(Microsoft.VisualStudio.Modeling.DslDefinition.Compartment)">
            <summary>
            Get the ShapeHasCompartments link to a Compartment.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasCompartments.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape,Microsoft.VisualStudio.Modeling.DslDefinition.Compartment)">
            <summary>
            Get any ShapeHasCompartments links between a given CompartmentShape and a Compartment.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasCompartments.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape,Microsoft.VisualStudio.Modeling.DslDefinition.Compartment)">
            <summary>
            Get the one ShapeHasCompartments link between a given CompartmentShapeand a Compartment.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasCompartments.Shape">
            <summary>
            DomainRole Shape
            Compartments defined by the compartment shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasCompartments.Compartment">
            <summary>
            DomainRole Compartment
            Compartment shape defining the compartments.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapes">
            <summary>
            DomainRelationship DslLibraryDefinesShapes
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapes.DomainClassId">
            <summary>
            DslLibraryDefinesShapes domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapes.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDefinition.BaseShape)">
            <summary>
            Constructor
            Creates a DslLibraryDefinesShapes link in the same Partition as the given DslLibrary
            </summary>
            <param name="source">DslLibrary to use as the source of the relationship.</param>
            <param name="target">BaseShape to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapes.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapes.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapes.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapes.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapes.DslLibraryDomainRoleId">
            <summary>
            DslLibrary domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapes.GetDslLibrary(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShape)">
            <summary>
            Gets DslLibrary.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapes.SetDslLibrary(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShape,Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Sets DslLibrary.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapes.ShapeDomainRoleId">
            <summary>
            Shape domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapes.GetShapes(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Gets a list of Shapes.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapes.GetLinksToShapes(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Get the list of DslLibraryDefinesShapes links to a DslLibrary.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapes.GetLinkToDslLibrary(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShape)">
            <summary>
            Get the DslLibraryDefinesShapes link to a BaseShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapes.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDefinition.BaseShape)">
            <summary>
            Get any DslLibraryDefinesShapes links between a given DslLibrary and a BaseShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapes.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDefinition.BaseShape)">
            <summary>
            Get the one DslLibraryDefinesShapes link between a given DslLibraryand a BaseShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapes.DslLibrary">
            <summary>
            DomainRole DslLibrary
            Shapes defined by the DSL library.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapes.Shape">
            <summary>
            DomainRole Shape
            Dsl library defining the shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapes.DiagramElement">
            <summary>
            Gets the element playing Shape domain role.
            Dsl library defining the diagram element.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathHasPath">
            <summary>
            DomainRelationship PropertyPathHasPath
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathHasPath.DomainClassId">
            <summary>
            PropertyPathHasPath domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathHasPath.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Constructor
            Creates a PropertyPathHasPath link in the same Partition as the given PropertyPath
            </summary>
            <param name="source">PropertyPath to use as the source of the relationship.</param>
            <param name="target">DomainPath to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathHasPath.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathHasPath.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathHasPath.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathHasPath.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathHasPath.PropertyPathDomainRoleId">
            <summary>
            PropertyPath domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathHasPath.GetPropertyPath(Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Gets PropertyPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathHasPath.SetPropertyPath(Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath,Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath)">
            <summary>
            Sets PropertyPath.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathHasPath.PathDomainRoleId">
            <summary>
            Path domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathHasPath.GetPathToProperty(Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath)">
            <summary>
            Gets PathToProperty.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathHasPath.SetPathToProperty(Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Sets PathToProperty.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathHasPath.GetLinkToPathToProperty(Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath)">
            <summary>
            Get the PropertyPathHasPath link to a PropertyPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathHasPath.GetLinkToPropertyPath(Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Get the PropertyPathHasPath link to a DomainPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathHasPath.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Get any PropertyPathHasPath links between a given PropertyPath and a DomainPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathHasPath.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Get the one PropertyPathHasPath link between a given PropertyPathand a DomainPath.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathHasPath.PropertyPath">
            <summary>
            DomainRole PropertyPath
            Path to the property.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathHasPath.Path">
            <summary>
            DomainRole Path
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPath">
            <summary>
            DomainRelationship CompartmentMapHasElementsDisplayedPath
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPath.DomainClassId">
            <summary>
            CompartmentMapHasElementsDisplayedPath domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPath.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Constructor
            Creates a CompartmentMapHasElementsDisplayedPath link in the same Partition as the given CompartmentMap
            </summary>
            <param name="source">CompartmentMap to use as the source of the relationship.</param>
            <param name="target">DomainPath to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPath.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPath.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPath.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPath.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPath.CompartmentMapDomainRoleId">
            <summary>
            CompartmentMap domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPath.GetCompartmentMap(Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Gets CompartmentMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPath.SetCompartmentMap(Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath,Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap)">
            <summary>
            Sets CompartmentMap.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPath.PathDomainRoleId">
            <summary>
            Path domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPath.GetElementsDisplayed(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap)">
            <summary>
            Gets ElementsDisplayed.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPath.SetElementsDisplayed(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Sets ElementsDisplayed.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPath.GetLinkToElementsDisplayed(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap)">
            <summary>
            Get the CompartmentMapHasElementsDisplayedPath link to a CompartmentMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPath.GetLinkToCompartmentMap(Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Get the CompartmentMapHasElementsDisplayedPath link to a DomainPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPath.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Get any CompartmentMapHasElementsDisplayedPath links between a given CompartmentMap and a DomainPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPath.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Get the one CompartmentMapHasElementsDisplayedPath link between a given CompartmentMapand a DomainPath.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPath.CompartmentMap">
            <summary>
            DomainRole CompartmentMap
            Path identifying the collection of elements displayed in the compartment.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPath.Path">
            <summary>
            DomainRole Path
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPath">
            <summary>
            DomainRelationship ShapeMapHasParentElementPath
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPath.DomainClassId">
            <summary>
            ShapeMapHasParentElementPath domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPath.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Constructor
            Creates a ShapeMapHasParentElementPath link in the same Partition as the given BaseShapeMap
            </summary>
            <param name="source">BaseShapeMap to use as the source of the relationship.</param>
            <param name="target">DomainPath to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPath.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPath.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPath.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPath.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPath.ShapeMapDomainRoleId">
            <summary>
            ShapeMap domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPath.GetShapeMap(Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Gets ShapeMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPath.SetShapeMap(Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath,Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap)">
            <summary>
            Sets ShapeMap.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPath.ParentElementPathDomainRoleId">
            <summary>
            ParentElementPath domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPath.GetParentElementPath(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap)">
            <summary>
            Gets ParentElementPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPath.SetParentElementPath(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Sets ParentElementPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPath.GetLinkToParentElementPath(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap)">
            <summary>
            Get the ShapeMapHasParentElementPath link to a BaseShapeMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPath.GetLinkToShapeMap(Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Get the ShapeMapHasParentElementPath link to a DomainPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPath.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Get any ShapeMapHasParentElementPath links between a given BaseShapeMap and a DomainPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPath.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Get the one ShapeMapHasParentElementPath link between a given BaseShapeMapand a DomainPath.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPath.ShapeMap">
            <summary>
            DomainRole ShapeMap
            Path to the subject of the shape, swimlane or diagram that parents the mapped
            shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPath.ParentElementPath">
            <summary>
            DomainRole ParentElementPath
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPath">
            <summary>
            DomainRelationship CompartmentMapHasPropertyDisplayedPath
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPath.DomainClassId">
            <summary>
            CompartmentMapHasPropertyDisplayedPath domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPath.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap,Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath)">
            <summary>
            Constructor
            Creates a CompartmentMapHasPropertyDisplayedPath link in the same Partition as the given CompartmentMap
            </summary>
            <param name="source">CompartmentMap to use as the source of the relationship.</param>
            <param name="target">PropertyPath to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPath.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPath.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPath.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPath.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPath.CompartmentMapDomainRoleId">
            <summary>
            CompartmentMap domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPath.GetCompartmentMap(Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath)">
            <summary>
            Gets CompartmentMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPath.SetCompartmentMap(Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath,Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap)">
            <summary>
            Sets CompartmentMap.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPath.PropertyPathDomainRoleId">
            <summary>
            PropertyPath domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPath.GetPropertyDisplayed(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap)">
            <summary>
            Gets PropertyDisplayed.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPath.SetPropertyDisplayed(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap,Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath)">
            <summary>
            Sets PropertyDisplayed.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPath.GetLinkToPropertyDisplayed(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap)">
            <summary>
            Get the CompartmentMapHasPropertyDisplayedPath link to a CompartmentMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPath.GetLinkToCompartmentMap(Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath)">
            <summary>
            Get the CompartmentMapHasPropertyDisplayedPath link to a PropertyPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPath.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap,Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath)">
            <summary>
            Get any CompartmentMapHasPropertyDisplayedPath links between a given CompartmentMap and a PropertyPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPath.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap,Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath)">
            <summary>
            Get the one CompartmentMapHasPropertyDisplayedPath link between a given CompartmentMapand a PropertyPath.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPath.CompartmentMap">
            <summary>
            DomainRole CompartmentMap
            Property path identifying the property to be displayed for each element in the
            compartment.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPath.PropertyPath">
            <summary>
            DomainRole PropertyPath
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPath">
            <summary>
            DomainRelationship DecoratorMapHasPropertyDisplayedPath
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPath.DomainClassId">
            <summary>
            DecoratorMapHasPropertyDisplayedPath domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPath.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap,Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath)">
            <summary>
            Constructor
            Creates a DecoratorMapHasPropertyDisplayedPath link in the same Partition as the given DecoratorMap
            </summary>
            <param name="source">DecoratorMap to use as the source of the relationship.</param>
            <param name="target">PropertyPath to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPath.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPath.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPath.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPath.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPath.DecoratorMapDomainRoleId">
            <summary>
            DecoratorMap domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPath.GetDecoratorMap(Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath)">
            <summary>
            Gets DecoratorMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPath.SetDecoratorMap(Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath,Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap)">
            <summary>
            Sets DecoratorMap.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPath.PropertyPathDomainRoleId">
            <summary>
            PropertyPath domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPath.GetPropertyDisplayed(Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap)">
            <summary>
            Gets PropertyDisplayed.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPath.SetPropertyDisplayed(Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap,Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath)">
            <summary>
            Sets PropertyDisplayed.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPath.GetLinkToPropertyDisplayed(Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap)">
            <summary>
            Get the DecoratorMapHasPropertyDisplayedPath link to a DecoratorMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPath.GetLinkToDecoratorMap(Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath)">
            <summary>
            Get the DecoratorMapHasPropertyDisplayedPath link to a PropertyPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPath.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap,Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath)">
            <summary>
            Get any DecoratorMapHasPropertyDisplayedPath links between a given DecoratorMap and a PropertyPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPath.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap,Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath)">
            <summary>
            Get the one DecoratorMapHasPropertyDisplayedPath link between a given DecoratorMapand a PropertyPath.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPath.DecoratorMap">
            <summary>
            DomainRole DecoratorMap
            Path identifying property to be displayed by decorator.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPath.PropertyPath">
            <summary>
            DomainRole PropertyPath
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFilters">
            <summary>
            DomainRelationship VisibilityPropertyPathHasPropertyFilters
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFilters.DomainClassId">
            <summary>
            VisibilityPropertyPathHasPropertyFilters domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFilters.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPath,Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilter)">
            <summary>
            Constructor
            Creates a VisibilityPropertyPathHasPropertyFilters link in the same Partition as the given VisibilityPropertyPath
            </summary>
            <param name="source">VisibilityPropertyPath to use as the source of the relationship.</param>
            <param name="target">PropertyFilter to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFilters.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFilters.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFilters.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFilters.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFilters.VisibilityPropertyPathDomainRoleId">
            <summary>
            VisibilityPropertyPath domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFilters.GetVisibilityPropertyPath(Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilter)">
            <summary>
            Gets VisibilityPropertyPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFilters.SetVisibilityPropertyPath(Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilter,Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPath)">
            <summary>
            Sets VisibilityPropertyPath.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFilters.PropertyFilterDomainRoleId">
            <summary>
            PropertyFilter domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFilters.GetPropertyFilters(Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPath)">
            <summary>
            Gets a list of PropertyFilters.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFilters.GetLinksToPropertyFilters(Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPath)">
            <summary>
            Get the list of VisibilityPropertyPathHasPropertyFilters links to a VisibilityPropertyPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFilters.GetLinkToVisibilityPropertyPath(Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilter)">
            <summary>
            Get the VisibilityPropertyPathHasPropertyFilters link to a PropertyFilter.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFilters.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPath,Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilter)">
            <summary>
            Get any VisibilityPropertyPathHasPropertyFilters links between a given VisibilityPropertyPath and a PropertyFilter.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFilters.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPath,Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilter)">
            <summary>
            Get the one VisibilityPropertyPathHasPropertyFilters link between a given VisibilityPropertyPathand a PropertyFilter.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFilters.VisibilityPropertyPath">
            <summary>
            DomainRole VisibilityPropertyPath
            Property values used for filtering.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFilters.PropertyFilter">
            <summary>
            DomainRole PropertyFilter
            Visibility property path defining the filter.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasVisibilityPropertyPath">
            <summary>
            DomainRelationship DecoratorMapHasVisibilityPropertyPath
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasVisibilityPropertyPath.DomainClassId">
            <summary>
            DecoratorMapHasVisibilityPropertyPath domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasVisibilityPropertyPath.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap,Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPath)">
            <summary>
            Constructor
            Creates a DecoratorMapHasVisibilityPropertyPath link in the same Partition as the given DecoratorMap
            </summary>
            <param name="source">DecoratorMap to use as the source of the relationship.</param>
            <param name="target">VisibilityPropertyPath to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasVisibilityPropertyPath.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasVisibilityPropertyPath.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasVisibilityPropertyPath.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasVisibilityPropertyPath.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasVisibilityPropertyPath.DecoratorMapDomainRoleId">
            <summary>
            DecoratorMap domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasVisibilityPropertyPath.GetDecoratorMap(Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPath)">
            <summary>
            Gets DecoratorMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasVisibilityPropertyPath.SetDecoratorMap(Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPath,Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap)">
            <summary>
            Sets DecoratorMap.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasVisibilityPropertyPath.VisibilityPropertyPathDomainRoleId">
            <summary>
            VisibilityPropertyPath domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasVisibilityPropertyPath.GetVisibilityPropertyPath(Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap)">
            <summary>
            Gets VisibilityPropertyPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasVisibilityPropertyPath.SetVisibilityPropertyPath(Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap,Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPath)">
            <summary>
            Sets VisibilityPropertyPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasVisibilityPropertyPath.GetLinkToVisibilityPropertyPath(Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap)">
            <summary>
            Get the DecoratorMapHasVisibilityPropertyPath link to a DecoratorMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasVisibilityPropertyPath.GetLinkToDecoratorMap(Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPath)">
            <summary>
            Get the DecoratorMapHasVisibilityPropertyPath link to a VisibilityPropertyPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasVisibilityPropertyPath.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap,Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPath)">
            <summary>
            Get any DecoratorMapHasVisibilityPropertyPath links between a given DecoratorMap and a VisibilityPropertyPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasVisibilityPropertyPath.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap,Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPath)">
            <summary>
            Get the one DecoratorMapHasVisibilityPropertyPath link between a given DecoratorMapand a VisibilityPropertyPath.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasVisibilityPropertyPath.DecoratorMap">
            <summary>
            DomainRole DecoratorMap
            Path identifying property used to decide whether or not the decorator is
            visible.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasVisibilityPropertyPath.VisibilityPropertyPath">
            <summary>
            DomainRole VisibilityPropertyPath
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslHasDiagram">
            <summary>
            DomainRelationship DslHasDiagram
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslHasDiagram.DomainClassId">
            <summary>
            DslHasDiagram domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslHasDiagram.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.Dsl,Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Constructor
            Creates a DslHasDiagram link in the same Partition as the given Dsl
            </summary>
            <param name="source">Dsl to use as the source of the relationship.</param>
            <param name="target">Diagram to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslHasDiagram.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslHasDiagram.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslHasDiagram.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslHasDiagram.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslHasDiagram.DslDomainRoleId">
            <summary>
            Dsl domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslHasDiagram.GetDsl(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Gets Dsl.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslHasDiagram.SetDsl(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram,Microsoft.VisualStudio.Modeling.DslDefinition.Dsl)">
            <summary>
            Sets Dsl.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslHasDiagram.DiagramDomainRoleId">
            <summary>
            Diagram domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslHasDiagram.GetDiagram(Microsoft.VisualStudio.Modeling.DslDefinition.Dsl)">
            <summary>
            Gets Diagram.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslHasDiagram.SetDiagram(Microsoft.VisualStudio.Modeling.DslDefinition.Dsl,Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Sets Diagram.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslHasDiagram.GetLinkToDiagram(Microsoft.VisualStudio.Modeling.DslDefinition.Dsl)">
            <summary>
            Get the DslHasDiagram link to a Dsl.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslHasDiagram.GetLinkToDsl(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Get the DslHasDiagram link to a Diagram.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslHasDiagram.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.Dsl,Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Get any DslHasDiagram links between a given Dsl and a Diagram.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslHasDiagram.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.Dsl,Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Get the one DslHasDiagram link between a given Dsland a Diagram.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslHasDiagram.Dsl">
            <summary>
            DomainRole Dsl
            Diagram defined by the DSL.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslHasDiagram.DslLibrary">
            <summary>
            Gets the element playing Dsl domain role.
            Reference types defined by the DSL library.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslHasDiagram.Diagram">
            <summary>
            DomainRole Diagram
            Dsl defining the diagram.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslHasDiagram.ReferenceType">
            <summary>
            Gets the element playing Diagram domain role.
            Dsl library defining the reference type.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMaps">
            <summary>
            DomainRelationship DiagramHasShapeMaps
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMaps.DomainClassId">
            <summary>
            DiagramHasShapeMaps domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMaps.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram,Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap)">
            <summary>
            Constructor
            Creates a DiagramHasShapeMaps link in the same Partition as the given Diagram
            </summary>
            <param name="source">Diagram to use as the source of the relationship.</param>
            <param name="target">BaseShapeMap to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMaps.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMaps.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMaps.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMaps.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMaps.DiagramDomainRoleId">
            <summary>
            Diagram domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMaps.GetDiagram(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap)">
            <summary>
            Gets Diagram.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMaps.SetDiagram(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap,Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Sets Diagram.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMaps.ShapeMapDomainRoleId">
            <summary>
            ShapeMap domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMaps.GetShapeMaps(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Gets a list of ShapeMaps.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMaps.GetLinksToShapeMaps(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Get the list of DiagramHasShapeMaps links to a Diagram.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMaps.GetLinkToDiagram(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap)">
            <summary>
            Get the DiagramHasShapeMaps link to a BaseShapeMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMaps.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram,Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap)">
            <summary>
            Get any DiagramHasShapeMaps links between a given Diagram and a BaseShapeMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMaps.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram,Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap)">
            <summary>
            Get the one DiagramHasShapeMaps link between a given Diagramand a BaseShapeMap.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMaps.Diagram">
            <summary>
            DomainRole Diagram
            Shape maps defined by the diagram.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMaps.ShapeMap">
            <summary>
            DomainRole ShapeMap
            Diagram defining the shape map.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMaps">
            <summary>
            DomainRelationship DiagramHasConnectorMaps
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMaps.DomainClassId">
            <summary>
            DiagramHasConnectorMaps domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMaps.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram,Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap)">
            <summary>
            Constructor
            Creates a DiagramHasConnectorMaps link in the same Partition as the given Diagram
            </summary>
            <param name="source">Diagram to use as the source of the relationship.</param>
            <param name="target">ConnectorMap to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMaps.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMaps.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMaps.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMaps.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMaps.DiagramDomainRoleId">
            <summary>
            Diagram domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMaps.GetDiagram(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap)">
            <summary>
            Gets Diagram.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMaps.SetDiagram(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap,Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Sets Diagram.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMaps.ConnectorMapDomainRoleId">
            <summary>
            ConnectorMap domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMaps.GetConnectorMaps(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Gets a list of ConnectorMaps.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMaps.GetLinksToConnectorMaps(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Get the list of DiagramHasConnectorMaps links to a Diagram.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMaps.GetLinkToDiagram(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap)">
            <summary>
            Get the DiagramHasConnectorMaps link to a ConnectorMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMaps.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram,Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap)">
            <summary>
            Get any DiagramHasConnectorMaps links between a given Diagram and a ConnectorMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMaps.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram,Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap)">
            <summary>
            Get the one DiagramHasConnectorMaps link between a given Diagramand a ConnectorMap.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMaps.Diagram">
            <summary>
            DomainRole Diagram
            Connector maps defined by the diagram.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMaps.ConnectorMap">
            <summary>
            DomainRole ConnectorMap
            Diagram defining the connector map.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapHasCompartmentMaps">
            <summary>
            DomainRelationship CompartmentShapeMapHasCompartmentMaps
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapHasCompartmentMaps.DomainClassId">
            <summary>
            CompartmentShapeMapHasCompartmentMaps domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapHasCompartmentMaps.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMap,Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap)">
            <summary>
            Constructor
            Creates a CompartmentShapeMapHasCompartmentMaps link in the same Partition as the given CompartmentShapeMap
            </summary>
            <param name="source">CompartmentShapeMap to use as the source of the relationship.</param>
            <param name="target">CompartmentMap to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapHasCompartmentMaps.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapHasCompartmentMaps.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapHasCompartmentMaps.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapHasCompartmentMaps.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapHasCompartmentMaps.ShapeMapDomainRoleId">
            <summary>
            ShapeMap domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapHasCompartmentMaps.GetShapeMap(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap)">
            <summary>
            Gets ShapeMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapHasCompartmentMaps.SetShapeMap(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap,Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMap)">
            <summary>
            Sets ShapeMap.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapHasCompartmentMaps.CompartmentMapDomainRoleId">
            <summary>
            CompartmentMap domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapHasCompartmentMaps.GetCompartmentMaps(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMap)">
            <summary>
            Gets a list of CompartmentMaps.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapHasCompartmentMaps.GetLinksToCompartmentMaps(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMap)">
            <summary>
            Get the list of CompartmentShapeMapHasCompartmentMaps links to a CompartmentShapeMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapHasCompartmentMaps.GetLinkToShapeMap(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap)">
            <summary>
            Get the CompartmentShapeMapHasCompartmentMaps link to a CompartmentMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapHasCompartmentMaps.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMap,Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap)">
            <summary>
            Get any CompartmentShapeMapHasCompartmentMaps links between a given CompartmentShapeMap and a CompartmentMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapHasCompartmentMaps.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMap,Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap)">
            <summary>
            Get the one CompartmentShapeMapHasCompartmentMaps link between a given CompartmentShapeMapand a CompartmentMap.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapHasCompartmentMaps.ShapeMap">
            <summary>
            DomainRole ShapeMap
            Compartment maps defined by the compartment shape map.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapHasCompartmentMaps.CompartmentMap">
            <summary>
            DomainRole CompartmentMap
            Shape map defining the compartment map.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasDecoratorMaps">
            <summary>
            DomainRelationship ShapeMapHasDecoratorMaps
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMaps">
            <summary>
            DomainRelationship DiagramElementMapHasDecoratorMaps
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMaps.DomainClassId">
            <summary>
            DiagramElementMapHasDecoratorMaps domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMaps.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">The Partition instance containing this ElementLink</param>
            <param name="roleAssignments">A set of role assignments for roleplayer initialization</param>
            <param name="propertyAssignments">A set of attribute assignments for attribute initialization</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMaps.DiagramElementMapDomainRoleId">
            <summary>
            DiagramElementMap domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMaps.GetDiagramElementMap(Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap)">
            <summary>
            Gets DiagramElementMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMaps.SetDiagramElementMap(Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap,Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMap)">
            <summary>
            Sets DiagramElementMap.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMaps.DecoratorMapDomainRoleId">
            <summary>
            DecoratorMap domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMaps.GetDecoratorMaps(Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMap)">
            <summary>
            Gets a list of DecoratorMaps.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMaps.GetLinksToDecoratorMaps(Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMap)">
            <summary>
            Get the list of DiagramElementMapHasDecoratorMaps links to a DiagramElementMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMaps.GetLinkToDiagramElementMap(Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap)">
            <summary>
            Get the DiagramElementMapHasDecoratorMaps link to a DecoratorMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMaps.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMap,Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap)">
            <summary>
            Get any DiagramElementMapHasDecoratorMaps links between a given DiagramElementMap and a DecoratorMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMaps.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMap,Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap)">
            <summary>
            Get the one DiagramElementMapHasDecoratorMaps link between a given DiagramElementMapand a DecoratorMap.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMaps.DiagramElementMap">
            <summary>
            DomainRole DiagramElementMap
            Decorator maps defined by the diagram element map.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMaps.DecoratorMap">
            <summary>
            DomainRole DecoratorMap
            Diagram element map to which the decorator map belongs.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasDecoratorMaps.DomainClassId">
            <summary>
            ShapeMapHasDecoratorMaps domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasDecoratorMaps.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap,Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap)">
            <summary>
            Constructor
            Creates a ShapeMapHasDecoratorMaps link in the same Partition as the given BaseShapeMap
            </summary>
            <param name="source">BaseShapeMap to use as the source of the relationship.</param>
            <param name="target">DecoratorMap to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasDecoratorMaps.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasDecoratorMaps.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasDecoratorMaps.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasDecoratorMaps.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasDecoratorMaps.ShapeMapDomainRoleId">
            <summary>
            ShapeMap domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasDecoratorMaps.GetShapeMap(Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap)">
            <summary>
            Gets ShapeMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasDecoratorMaps.SetShapeMap(Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap,Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap)">
            <summary>
            Sets ShapeMap.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasDecoratorMaps.DecoratorMapDomainRoleId">
            <summary>
            DecoratorMap domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasDecoratorMaps.GetDecoratorMaps(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap)">
            <summary>
            Gets a list of DecoratorMaps.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasDecoratorMaps.GetLinksToDecoratorMaps(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap)">
            <summary>
            Get the list of ShapeMapHasDecoratorMaps links to a BaseShapeMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasDecoratorMaps.GetLinkToShapeMap(Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap)">
            <summary>
            Get the ShapeMapHasDecoratorMaps link to a DecoratorMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasDecoratorMaps.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap,Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap)">
            <summary>
            Get any ShapeMapHasDecoratorMaps links between a given BaseShapeMap and a DecoratorMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasDecoratorMaps.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap,Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap)">
            <summary>
            Get the one ShapeMapHasDecoratorMaps link between a given BaseShapeMapand a DecoratorMap.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasDecoratorMaps.ShapeMap">
            <summary>
            DomainRole ShapeMap
            Decorator maps defined by the shape map.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasDecoratorMaps.DiagramElementMap">
            <summary>
            Gets the element playing ShapeMap domain role.
            Decorator maps defined by the diagram element map.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasDecoratorMaps.DecoratorMap">
            <summary>
            DomainRole DecoratorMap
            Shape map defining the decorator map.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapHasDecoratorMaps">
            <summary>
            DomainRelationship ConnectorMapHasDecoratorMaps
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapHasDecoratorMaps.DomainClassId">
            <summary>
            ConnectorMapHasDecoratorMaps domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapHasDecoratorMaps.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap,Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap)">
            <summary>
            Constructor
            Creates a ConnectorMapHasDecoratorMaps link in the same Partition as the given ConnectorMap
            </summary>
            <param name="source">ConnectorMap to use as the source of the relationship.</param>
            <param name="target">DecoratorMap to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapHasDecoratorMaps.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapHasDecoratorMaps.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapHasDecoratorMaps.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapHasDecoratorMaps.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapHasDecoratorMaps.ConnectorMapDomainRoleId">
            <summary>
            ConnectorMap domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapHasDecoratorMaps.GetConnectorMap(Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap)">
            <summary>
            Gets ConnectorMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapHasDecoratorMaps.SetConnectorMap(Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap,Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap)">
            <summary>
            Sets ConnectorMap.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapHasDecoratorMaps.DecoratorMapDomainRoleId">
            <summary>
            DecoratorMap domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapHasDecoratorMaps.GetDecoratorMaps(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap)">
            <summary>
            Gets a list of DecoratorMaps.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapHasDecoratorMaps.GetLinksToDecoratorMaps(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap)">
            <summary>
            Get the list of ConnectorMapHasDecoratorMaps links to a ConnectorMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapHasDecoratorMaps.GetLinkToConnectorMap(Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap)">
            <summary>
            Get the ConnectorMapHasDecoratorMaps link to a DecoratorMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapHasDecoratorMaps.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap,Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap)">
            <summary>
            Get any ConnectorMapHasDecoratorMaps links between a given ConnectorMap and a DecoratorMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapHasDecoratorMaps.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap,Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap)">
            <summary>
            Get the one ConnectorMapHasDecoratorMaps link between a given ConnectorMapand a DecoratorMap.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapHasDecoratorMaps.ConnectorMap">
            <summary>
            DomainRole ConnectorMap
            Decorator maps defined by the connector map.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapHasDecoratorMaps.DiagramElementMap">
            <summary>
            Gets the element playing ConnectorMap domain role.
            Decorator maps defined by the diagram element map.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapHasDecoratorMaps.DecoratorMap">
            <summary>
            DomainRole DecoratorMap
            Connector map defining the decorator map.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasXmlSerializationBehavior">
            <summary>
            DomainRelationship DslLibraryHasXmlSerializationBehavior
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasXmlSerializationBehavior.DomainClassId">
            <summary>
            DslLibraryHasXmlSerializationBehavior domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasXmlSerializationBehavior.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior)">
            <summary>
            Constructor
            Creates a DslLibraryHasXmlSerializationBehavior link in the same Partition as the given DslLibrary
            </summary>
            <param name="source">DslLibrary to use as the source of the relationship.</param>
            <param name="target">XmlSerializationBehavior to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasXmlSerializationBehavior.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasXmlSerializationBehavior.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasXmlSerializationBehavior.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasXmlSerializationBehavior.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasXmlSerializationBehavior.DslLibraryDomainRoleId">
            <summary>
            DslLibrary domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasXmlSerializationBehavior.GetDslLibrary(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior)">
            <summary>
            Gets DslLibrary.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasXmlSerializationBehavior.SetDslLibrary(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior,Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Sets DslLibrary.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasXmlSerializationBehavior.XmlSerializationBehaviorDomainRoleId">
            <summary>
            XmlSerializationBehavior domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasXmlSerializationBehavior.GetXmlSerializationBehavior(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Gets XmlSerializationBehavior.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasXmlSerializationBehavior.SetXmlSerializationBehavior(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior)">
            <summary>
            Sets XmlSerializationBehavior.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasXmlSerializationBehavior.GetLinkToXmlSerializationBehavior(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Get the DslLibraryHasXmlSerializationBehavior link to a DslLibrary.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasXmlSerializationBehavior.GetLinkToDslLibrary(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior)">
            <summary>
            Get the DslLibraryHasXmlSerializationBehavior link to a XmlSerializationBehavior.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasXmlSerializationBehavior.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior)">
            <summary>
            Get any DslLibraryHasXmlSerializationBehavior links between a given DslLibrary and a XmlSerializationBehavior.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasXmlSerializationBehavior.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior)">
            <summary>
            Get the one DslLibraryHasXmlSerializationBehavior link between a given DslLibraryand a XmlSerializationBehavior.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasXmlSerializationBehavior.DslLibrary">
            <summary>
            DomainRole DslLibrary
            Xml serialization behavior defined by the DSL library.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasXmlSerializationBehavior.XmlSerializationBehavior">
            <summary>
            DomainRole XmlSerializationBehavior
            Dsl library defining the xml serialization behavior.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassData">
            <summary>
            DomainRelationship XmlSerializationBehaviorHasXmlClassData
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassData.DomainClassId">
            <summary>
            XmlSerializationBehaviorHasXmlClassData domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassData.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior,Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData)">
            <summary>
            Constructor
            Creates a XmlSerializationBehaviorHasXmlClassData link in the same Partition as the given XmlSerializationBehavior
            </summary>
            <param name="source">XmlSerializationBehavior to use as the source of the relationship.</param>
            <param name="target">XmlClassData to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassData.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassData.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassData.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassData.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassData.BehaviorDomainRoleId">
            <summary>
            Behavior domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassData.GetBehavior(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData)">
            <summary>
            Gets Behavior.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassData.SetBehavior(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData,Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior)">
            <summary>
            Sets Behavior.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassData.ClassDataDomainRoleId">
            <summary>
            ClassData domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassData.GetClassData(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior)">
            <summary>
            Gets a list of ClassData.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassData.GetLinksToClassData(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior)">
            <summary>
            Get the list of XmlSerializationBehaviorHasXmlClassData links to a XmlSerializationBehavior.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassData.GetLinkToBehavior(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData)">
            <summary>
            Get the XmlSerializationBehaviorHasXmlClassData link to a XmlClassData.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassData.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior,Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData)">
            <summary>
            Get any XmlSerializationBehaviorHasXmlClassData links between a given XmlSerializationBehavior and a XmlClassData.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassData.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior,Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData)">
            <summary>
            Get the one XmlSerializationBehaviorHasXmlClassData link between a given XmlSerializationBehaviorand a XmlClassData.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassData.Behavior">
            <summary>
            DomainRole Behavior
            Xml serialization configuration data defined by this behavior, indexed by class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassData.ClassData">
            <summary>
            DomainRole ClassData
            Defining xml serialization behavior.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementData">
            <summary>
            DomainRelationship XmlClassDataHasXmlElementData
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementData.DomainClassId">
            <summary>
            XmlClassDataHasXmlElementData domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementData.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData,Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementData)">
            <summary>
            Constructor
            Creates a XmlClassDataHasXmlElementData link in the same Partition as the given XmlClassData
            </summary>
            <param name="source">XmlClassData to use as the source of the relationship.</param>
            <param name="target">XmlElementData to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementData.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementData.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementData.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementData.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementData.XmlClassDataDomainRoleId">
            <summary>
            XmlClassData domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementData.GetClassData(Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementData)">
            <summary>
            Gets ClassData.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementData.SetClassData(Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementData,Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData)">
            <summary>
            Sets ClassData.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementData.XmlElementDataDomainRoleId">
            <summary>
            XmlElementData domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementData.GetElementData(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData)">
            <summary>
            Gets a list of ElementData.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementData.GetLinksToElementData(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData)">
            <summary>
            Get the list of XmlClassDataHasXmlElementData links to a XmlClassData.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementData.GetLinkToClassData(Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementData)">
            <summary>
            Get the XmlClassDataHasXmlElementData link to a XmlElementData.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementData.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData,Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementData)">
            <summary>
            Get any XmlClassDataHasXmlElementData links between a given XmlClassData and a XmlElementData.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementData.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData,Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementData)">
            <summary>
            Get the one XmlClassDataHasXmlElementData link between a given XmlClassDataand a XmlElementData.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementData.XmlClassData">
            <summary>
            DomainRole XmlClassData
            Xml serialization configuration data for elements of the class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementData.XmlElementData">
            <summary>
            DomainRole XmlElementData
            Xml class data defining the element data.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators">
            <summary>
            DomainRelationship SwimLaneHasDecorators
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.DomainClassId">
            <summary>
            SwimLaneHasDecorators domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane,Microsoft.VisualStudio.Modeling.DslDefinition.Decorator)">
            <summary>
            Constructor
            Creates a SwimLaneHasDecorators link in the same Partition as the given SwimLane
            </summary>
            <param name="source">SwimLane to use as the source of the relationship.</param>
            <param name="target">Decorator to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.SwimLaneDomainRoleId">
            <summary>
            SwimLane domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.GetSwimlane(Microsoft.VisualStudio.Modeling.DslDefinition.Decorator)">
            <summary>
            Gets Swimlane.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.SetSwimlane(Microsoft.VisualStudio.Modeling.DslDefinition.Decorator,Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane)">
            <summary>
            Sets Swimlane.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.DecoratorDomainRoleId">
            <summary>
            Decorator domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.GetDecorators(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane)">
            <summary>
            Gets a list of Decorators.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.PositionDomainPropertyId">
            <summary>
            Position domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.positionPropertyStorage">
            <summary>
            Storage for Position
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.HorizontalOffsetDomainPropertyId">
            <summary>
            HorizontalOffset domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.horizontalOffsetPropertyStorage">
            <summary>
            Storage for HorizontalOffset
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.VerticalOffsetDomainPropertyId">
            <summary>
            VerticalOffset domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.verticalOffsetPropertyStorage">
            <summary>
            Storage for VerticalOffset
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.GetLinksToDecorators(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane)">
            <summary>
            Get the list of SwimLaneHasDecorators links to a SwimLane.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.GetLinkToSwimlane(Microsoft.VisualStudio.Modeling.DslDefinition.Decorator)">
            <summary>
            Get the SwimLaneHasDecorators link to a Decorator.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane,Microsoft.VisualStudio.Modeling.DslDefinition.Decorator)">
            <summary>
            Get any SwimLaneHasDecorators links between a given SwimLane and a Decorator.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane,Microsoft.VisualStudio.Modeling.DslDefinition.Decorator)">
            <summary>
            Get the one SwimLaneHasDecorators link between a given SwimLaneand a Decorator.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.SwimLane">
            <summary>
            DomainRole SwimLane
            Decorators defined by the swimlane.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.DiagramElement">
            <summary>
            Gets the element playing SwimLane domain role.
            Decorators for the diagram element.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.Decorator">
            <summary>
            DomainRole Decorator
            Swimlane defining the decorator.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.Position">
            <summary>
            Gets or sets the value of Position domain property.
            Default position of the decorator.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.HorizontalOffset">
            <summary>
            Gets or sets the value of HorizontalOffset domain property.
            Horizontal offset relative to the default position of the decorator.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.VerticalOffset">
            <summary>
            Gets or sets the value of VerticalOffset domain property.
            Vertical offset relative to the default position of the decorator.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.PositionPropertyHandler">
            <summary>
            Value handler for the SwimLaneHasDecorators.Position domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.PositionPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the SwimLaneHasDecorators.Position domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.PositionPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.PositionPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators,Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneDecoratorPosition)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.PositionPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the SwimLaneHasDecorators.Position domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.HorizontalOffsetPropertyHandler">
            <summary>
            Value handler for the SwimLaneHasDecorators.HorizontalOffset domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.HorizontalOffsetPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the SwimLaneHasDecorators.HorizontalOffset domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.HorizontalOffsetPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.HorizontalOffsetPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators,System.Double)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.HorizontalOffsetPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the SwimLaneHasDecorators.HorizontalOffset domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.VerticalOffsetPropertyHandler">
            <summary>
            Value handler for the SwimLaneHasDecorators.VerticalOffset domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.VerticalOffsetPropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the SwimLaneHasDecorators.VerticalOffset domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.VerticalOffsetPropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.VerticalOffsetPropertyHandler.SetValue(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators,System.Double)">
            <summary>
            Sets property value on an element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <param name="newValue">New property value.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecorators.VerticalOffsetPropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the SwimLaneHasDecorators.VerticalOffset domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasRoots">
            <summary>
            DomainRelationship DiagramTreeHasRoots
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasRoots.DomainClassId">
            <summary>
            DiagramTreeHasRoots domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasRoots.#ctor(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree,Microsoft.VisualStudio.Modeling.DslDesigner.RootNode)">
            <summary>
            Constructor
            Creates a DiagramTreeHasRoots link in the same Partition as the given DslDesignerDiagramTree
            </summary>
            <param name="source">DslDesignerDiagramTree to use as the source of the relationship.</param>
            <param name="target">RootNode to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasRoots.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasRoots.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasRoots.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasRoots.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasRoots.TreeDomainRoleId">
            <summary>
            Tree domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasRoots.GetDiagramTree(Microsoft.VisualStudio.Modeling.DslDesigner.RootNode)">
            <summary>
            Gets DiagramTree.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasRoots.SetDiagramTree(Microsoft.VisualStudio.Modeling.DslDesigner.RootNode,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree)">
            <summary>
            Sets DiagramTree.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasRoots.RootDomainRoleId">
            <summary>
            Root domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasRoots.GetRoots(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree)">
            <summary>
            Gets a list of Roots.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasRoots.GetLinksToRoots(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree)">
            <summary>
            Get the list of DiagramTreeHasRoots links to a DslDesignerDiagramTree.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasRoots.GetLinkToDiagramTree(Microsoft.VisualStudio.Modeling.DslDesigner.RootNode)">
            <summary>
            Get the DiagramTreeHasRoots link to a RootNode.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasRoots.GetLinks(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree,Microsoft.VisualStudio.Modeling.DslDesigner.RootNode)">
            <summary>
            Get any DiagramTreeHasRoots links between a given DslDesignerDiagramTree and a RootNode.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasRoots.GetLink(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree,Microsoft.VisualStudio.Modeling.DslDesigner.RootNode)">
            <summary>
            Get the one DiagramTreeHasRoots link between a given DslDesignerDiagramTreeand a RootNode.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasRoots.Tree">
            <summary>
            DomainRole Tree
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasRoots.Root">
            <summary>
            DomainRole Root
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDomainModelElementTree">
            <summary>
            DomainRelationship DslDesignerDiagramStateHasDomainModelElementTree
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramTrees">
            <summary>
            DomainRelationship DslDesignerDiagramStateHasDiagramTrees
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramTrees.DomainClassId">
            <summary>
            DslDesignerDiagramStateHasDiagramTrees domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramTrees.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">The Partition instance containing this ElementLink</param>
            <param name="roleAssignments">A set of role assignments for roleplayer initialization</param>
            <param name="propertyAssignments">A set of attribute assignments for attribute initialization</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramTrees.DiagramStateDomainRoleId">
            <summary>
            DiagramState domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramTrees.GetDiagramState(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree)">
            <summary>
            Gets DiagramState.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramTrees.SetDiagramState(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState)">
            <summary>
            Sets DiagramState.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramTrees.DiagramTreeDomainRoleId">
            <summary>
            DiagramTree domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramTrees.GetDiagramTrees(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState)">
            <summary>
            Gets a list of DiagramTrees.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramTrees.GetLinksToDiagramTrees(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState)">
            <summary>
            Get the list of DslDesignerDiagramStateHasDiagramTrees links to a DslDesignerDiagramState.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramTrees.GetLinkToDiagramState(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree)">
            <summary>
            Get the DslDesignerDiagramStateHasDiagramTrees link to a DslDesignerDiagramTree.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramTrees.GetLinks(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree)">
            <summary>
            Get any DslDesignerDiagramStateHasDiagramTrees links between a given DslDesignerDiagramState and a DslDesignerDiagramTree.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramTrees.GetLink(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree)">
            <summary>
            Get the one DslDesignerDiagramStateHasDiagramTrees link between a given DslDesignerDiagramStateand a DslDesignerDiagramTree.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramTrees.DiagramState">
            <summary>
            DomainRole DiagramState
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramTrees.DiagramTree">
            <summary>
            DomainRole DiagramTree
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDomainModelElementTree.DomainClassId">
            <summary>
            DslDesignerDiagramStateHasDomainModelElementTree domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDomainModelElementTree.#ctor(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree)">
            <summary>
            Constructor
            Creates a DslDesignerDiagramStateHasDomainModelElementTree link in the same Partition as the given DslDesignerDiagramState
            </summary>
            <param name="source">DslDesignerDiagramState to use as the source of the relationship.</param>
            <param name="target">DslDesignerDiagramTree to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDomainModelElementTree.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDomainModelElementTree.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDomainModelElementTree.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDomainModelElementTree.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDomainModelElementTree.DiagramStateDomainRoleId">
            <summary>
            DiagramState domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDomainModelElementTree.GetDiagramState(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree)">
            <summary>
            Gets DiagramState.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDomainModelElementTree.SetDiagramState(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState)">
            <summary>
            Sets DiagramState.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDomainModelElementTree.DomainModelElementTreeDomainRoleId">
            <summary>
            DomainModelElementTree domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDomainModelElementTree.GetDomainModelElementTree(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState)">
            <summary>
            Gets DomainModelElementTree.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDomainModelElementTree.SetDomainModelElementTree(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree)">
            <summary>
            Sets DomainModelElementTree.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDomainModelElementTree.GetLinkToDomainModelElementTree(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState)">
            <summary>
            Get the DslDesignerDiagramStateHasDomainModelElementTree link to a DslDesignerDiagramState.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDomainModelElementTree.GetLinkToDiagramState(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree)">
            <summary>
            Get the DslDesignerDiagramStateHasDomainModelElementTree link to a DslDesignerDiagramTree.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDomainModelElementTree.GetLinks(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree)">
            <summary>
            Get any DslDesignerDiagramStateHasDomainModelElementTree links between a given DslDesignerDiagramState and a DslDesignerDiagramTree.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDomainModelElementTree.GetLink(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree)">
            <summary>
            Get the one DslDesignerDiagramStateHasDomainModelElementTree link between a given DslDesignerDiagramStateand a DslDesignerDiagramTree.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDomainModelElementTree.DiagramState">
            <summary>
            DomainRole DiagramState
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDomainModelElementTree.DomainModelElementTree">
            <summary>
            DomainRole DomainModelElementTree
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDomainModelElementTree.DiagramTree">
            <summary>
            Gets the element playing DomainModelElementTree domain role.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramElementTree">
            <summary>
            DomainRelationship DslDesignerDiagramStateHasDiagramElementTree
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramElementTree.DomainClassId">
            <summary>
            DslDesignerDiagramStateHasDiagramElementTree domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramElementTree.#ctor(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree)">
            <summary>
            Constructor
            Creates a DslDesignerDiagramStateHasDiagramElementTree link in the same Partition as the given DslDesignerDiagramState
            </summary>
            <param name="source">DslDesignerDiagramState to use as the source of the relationship.</param>
            <param name="target">DslDesignerDiagramTree to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramElementTree.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramElementTree.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramElementTree.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramElementTree.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramElementTree.DiagramStateDomainRoleId">
            <summary>
            DiagramState domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramElementTree.GetDiagramState(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree)">
            <summary>
            Gets DiagramState.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramElementTree.SetDiagramState(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState)">
            <summary>
            Sets DiagramState.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramElementTree.DiagramElementTreeDomainRoleId">
            <summary>
            DiagramElementTree domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramElementTree.GetDiagramElementTree(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState)">
            <summary>
            Gets DiagramElementTree.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramElementTree.SetDiagramElementTree(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree)">
            <summary>
            Sets DiagramElementTree.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramElementTree.GetLinkToDiagramElementTree(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState)">
            <summary>
            Get the DslDesignerDiagramStateHasDiagramElementTree link to a DslDesignerDiagramState.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramElementTree.GetLinkToDiagramState(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree)">
            <summary>
            Get the DslDesignerDiagramStateHasDiagramElementTree link to a DslDesignerDiagramTree.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramElementTree.GetLinks(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree)">
            <summary>
            Get any DslDesignerDiagramStateHasDiagramElementTree links between a given DslDesignerDiagramState and a DslDesignerDiagramTree.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramElementTree.GetLink(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree)">
            <summary>
            Get the one DslDesignerDiagramStateHasDiagramElementTree link between a given DslDesignerDiagramStateand a DslDesignerDiagramTree.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramElementTree.DiagramState">
            <summary>
            DomainRole DiagramState
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramElementTree.DiagramElementTree">
            <summary>
            DomainRole DiagramElementTree
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramElementTree.DiagramTree">
            <summary>
            Gets the element playing DiagramElementTree domain role.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasArcs">
            <summary>
            DomainRelationship DiagramTreeHasArcs
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasArcs.DomainClassId">
            <summary>
            DiagramTreeHasArcs domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasArcs.#ctor(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree,Microsoft.VisualStudio.Modeling.DslDesigner.ArcNode)">
            <summary>
            Constructor
            Creates a DiagramTreeHasArcs link in the same Partition as the given DslDesignerDiagramTree
            </summary>
            <param name="source">DslDesignerDiagramTree to use as the source of the relationship.</param>
            <param name="target">ArcNode to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasArcs.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasArcs.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasArcs.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasArcs.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasArcs.DiagramTreeDomainRoleId">
            <summary>
            DiagramTree domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasArcs.GetDiagramTree(Microsoft.VisualStudio.Modeling.DslDesigner.ArcNode)">
            <summary>
            Gets DiagramTree.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasArcs.SetDiagramTree(Microsoft.VisualStudio.Modeling.DslDesigner.ArcNode,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree)">
            <summary>
            Sets DiagramTree.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasArcs.ArcNodeDomainRoleId">
            <summary>
            ArcNode domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasArcs.GetArcs(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree)">
            <summary>
            Gets a list of Arcs.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasArcs.GetLinksToArcs(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree)">
            <summary>
            Get the list of DiagramTreeHasArcs links to a DslDesignerDiagramTree.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasArcs.GetLinkToDiagramTree(Microsoft.VisualStudio.Modeling.DslDesigner.ArcNode)">
            <summary>
            Get the DiagramTreeHasArcs link to a ArcNode.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasArcs.GetLinks(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree,Microsoft.VisualStudio.Modeling.DslDesigner.ArcNode)">
            <summary>
            Get any DiagramTreeHasArcs links between a given DslDesignerDiagramTree and a ArcNode.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasArcs.GetLink(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree,Microsoft.VisualStudio.Modeling.DslDesigner.ArcNode)">
            <summary>
            Get the one DiagramTreeHasArcs link between a given DslDesignerDiagramTreeand a ArcNode.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasArcs.DiagramTree">
            <summary>
            DomainRole DiagramTree
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasArcs.ArcNode">
            <summary>
            DomainRole ArcNode
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass">
            <summary>
            DomainRelationship ClassHasBaseClass
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.DomainClassId">
            <summary>
            ClassHasBaseClass domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Constructor
            Creates a ClassHasBaseClass link in the same Partition as the given DomainClass
            </summary>
            <param name="source">DomainClass to use as the source of the relationship.</param>
            <param name="target">DomainClass to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.SubClassDomainRoleId">
            <summary>
            SubClass domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.GetSubClasses(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets a list of SubClasses.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.BaseClassDomainRoleId">
            <summary>
            BaseClass domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.GetBaseClass(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets BaseClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.SetBaseClass(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Sets BaseClass.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.DerivedClassNameDomainPropertyId">
            <summary>
            DerivedClassName domain property Id.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.DerivedClassNamespaceDomainPropertyId">
            <summary>
            DerivedClassNamespace domain property Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.GetLinkToBaseClass(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the ClassHasBaseClass link to a DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.GetLinksToSubClasses(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the list of ClassHasBaseClass links to a DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get any ClassHasBaseClass links between a given DomainClass and a DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the one ClassHasBaseClass link between a given DomainClassand a DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.GetDerivedClassNameValue">
            <summary>
            Get the name of the derived class (for calculated IMS property)
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.GetDerivedClassNamespaceValue">
            <summary>
            Get the namespace of the derived class (for calculated IMS property)
            </summary>
            <returns></returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.SubClass">
            <summary>
            DomainRole SubClass
            Base class of this domain class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.BaseClass">
            <summary>
            DomainRole BaseClass
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.BaseClass
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.DerivedClassName">
            <summary>
            Gets or sets the value of DerivedClassName domain property.
            Provides the derived class name as a property on the link.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.DerivedClassNamespace">
            <summary>
            Gets or sets the value of DerivedClassNamespace domain property.
            Provides the derived class namespace as a property on the link.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.DerivedClassNamePropertyHandler">
            <summary>
            Value handler for the ClassHasBaseClass.DerivedClassName domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.DerivedClassNamePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the ClassHasBaseClass.DerivedClassName domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.DerivedClassNamePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.DerivedClassNamePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the ClassHasBaseClass.DerivedClassName domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.DerivedClassNamespacePropertyHandler">
            <summary>
            Value handler for the ClassHasBaseClass.DerivedClassNamespace domain property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.DerivedClassNamespacePropertyHandler.Instance">
            <summary>
            Gets the singleton instance of the ClassHasBaseClass.DerivedClassNamespace domain property value handler.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.DerivedClassNamespacePropertyHandler.GetValue(Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass)">
            <summary>
            Gets a strongly-typed value of the property on specified element.
            </summary>
            <param name="element">Element which owns the property.</param>
            <returns>Property value.</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.DerivedClassNamespacePropertyHandler.DomainPropertyId">
            <summary>
            Gets the Id of the ClassHasBaseClass.DerivedClassNamespace domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayer">
            <summary>
            DomainRelationship RoleHasRolePlayer
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayer.DomainClassId">
            <summary>
            RoleHasRolePlayer domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayer.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Constructor
            Creates a RoleHasRolePlayer link in the same Partition as the given DomainRole
            </summary>
            <param name="source">DomainRole to use as the source of the relationship.</param>
            <param name="target">DomainClass to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayer.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayer.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayer.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayer.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayer.RoleDomainRoleId">
            <summary>
            Role domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayer.GetRolesPlayed(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets a list of RolesPlayed.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayer.RolePlayerDomainRoleId">
            <summary>
            RolePlayer domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayer.GetRolePlayer(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Gets RolePlayer.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayer.SetRolePlayer(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Sets RolePlayer.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayer.GetLinkToRolePlayer(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Get the RoleHasRolePlayer link to a DomainRole.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayer.GetLinksToRolesPlayed(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the list of RoleHasRolePlayer links to a DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayer.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get any RoleHasRolePlayer links between a given DomainRole and a DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayer.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the one RoleHasRolePlayer link between a given DomainRoleand a DomainClass.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayer.Role">
            <summary>
            DomainRole Role
            Class of element playing this role in the relationship.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayer.RolePlayer">
            <summary>
            DomainRole RolePlayer
            Roles played by the class.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationship">
            <summary>
            DomainRelationship RelationshipHasBaseRelationship
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationship.DomainClassId">
            <summary>
            RelationshipHasBaseRelationship domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationship.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Constructor
            Creates a RelationshipHasBaseRelationship link in the same Partition as the given DomainRelationship
            </summary>
            <param name="source">DomainRelationship to use as the source of the relationship.</param>
            <param name="target">DomainRelationship to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationship.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationship.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationship.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationship.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationship.SubRelationshipDomainRoleId">
            <summary>
            SubRelationship domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationship.GetSubClasses(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Gets a list of SubClasses.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationship.BaseRelationshipDomainRoleId">
            <summary>
            BaseRelationship domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationship.GetBaseClass(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Gets BaseClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationship.SetBaseClass(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Sets BaseClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationship.GetLinkToBaseClass(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Get the RelationshipHasBaseRelationship link to a DomainRelationship.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationship.GetLinksToSubClasses(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Get the list of RelationshipHasBaseRelationship links to a DomainRelationship.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationship.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Get any RelationshipHasBaseRelationship links between a given DomainRelationship and a DomainRelationship.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationship.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Get the one RelationshipHasBaseRelationship link between a given DomainRelationshipand a DomainRelationship.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationship.SubRelationship">
            <summary>
            DomainRole SubRelationship
            The base relationship of this domain relationship.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationship.SubClass">
            <summary>
            Gets the element playing SubRelationship domain role.
            Base class of this domain class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationship.BaseRelationship">
            <summary>
            DomainRole BaseRelationship
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationship.BaseClass">
            <summary>
            Gets the element playing BaseRelationship domain role.
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.BaseClass
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasType">
            <summary>
            DomainRelationship PropertyHasType
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasType.DomainClassId">
            <summary>
            PropertyHasType domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasType.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty,Microsoft.VisualStudio.Modeling.DslDefinition.DomainType)">
            <summary>
            Constructor
            Creates a PropertyHasType link in the same Partition as the given DomainProperty
            </summary>
            <param name="source">DomainProperty to use as the source of the relationship.</param>
            <param name="target">DomainType to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasType.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasType.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasType.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasType.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasType.PropertyDomainRoleId">
            <summary>
            Property domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasType.GetProperties(Microsoft.VisualStudio.Modeling.DslDefinition.DomainType)">
            <summary>
            Gets a list of Properties.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasType.TypeDomainRoleId">
            <summary>
            Type domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasType.GetType(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Gets Type.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasType.SetType(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty,Microsoft.VisualStudio.Modeling.DslDefinition.DomainType)">
            <summary>
            Sets Type.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasType.GetLinkToType(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Get the PropertyHasType link to a DomainProperty.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasType.GetLinksToProperties(Microsoft.VisualStudio.Modeling.DslDefinition.DomainType)">
            <summary>
            Get the list of PropertyHasType links to a DomainType.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasType.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty,Microsoft.VisualStudio.Modeling.DslDefinition.DomainType)">
            <summary>
            Get any PropertyHasType links between a given DomainProperty and a DomainType.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasType.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty,Microsoft.VisualStudio.Modeling.DslDefinition.DomainType)">
            <summary>
            Get the one PropertyHasType link between a given DomainPropertyand a DomainType.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasType.Property">
            <summary>
            DomainRole Property
            Type of the property.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasType.Type">
            <summary>
            DomainRole Type
            Properties this is a type for.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionType">
            <summary>
            DomainRelationship DomainRoleImplementedByCollectionType
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionType.DomainClassId">
            <summary>
            DomainRoleImplementedByCollectionType domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionType.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,Microsoft.VisualStudio.Modeling.DslDefinition.ExternalType)">
            <summary>
            Constructor
            Creates a DomainRoleImplementedByCollectionType link in the same Partition as the given DomainRole
            </summary>
            <param name="source">DomainRole to use as the source of the relationship.</param>
            <param name="target">ExternalType to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionType.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionType.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionType.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionType.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionType.DomainRoleDomainRoleId">
            <summary>
            DomainRole domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionType.GetDomainRole(Microsoft.VisualStudio.Modeling.DslDefinition.ExternalType)">
            <summary>
            Gets a list of DomainRole.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionType.ExternalTypeDomainRoleId">
            <summary>
            ExternalType domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionType.GetCollectionType(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Gets CollectionType.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionType.SetCollectionType(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,Microsoft.VisualStudio.Modeling.DslDefinition.ExternalType)">
            <summary>
            Sets CollectionType.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionType.GetLinkToCollectionType(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Get the DomainRoleImplementedByCollectionType link to a DomainRole.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionType.GetLinksToDomainRole(Microsoft.VisualStudio.Modeling.DslDefinition.ExternalType)">
            <summary>
            Get the list of DomainRoleImplementedByCollectionType links to a ExternalType.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionType.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,Microsoft.VisualStudio.Modeling.DslDefinition.ExternalType)">
            <summary>
            Get any DomainRoleImplementedByCollectionType links between a given DomainRole and a ExternalType.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionType.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,Microsoft.VisualStudio.Modeling.DslDefinition.ExternalType)">
            <summary>
            Get the one DomainRoleImplementedByCollectionType link between a given DomainRoleand a ExternalType.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionType.DomainRole">
            <summary>
            DomainRole DomainRole
            External type used as the collection type for the generated property from this
            role.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionType.ExternalType">
            <summary>
            DomainRole ExternalType
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProvider">
            <summary>
            DomainRelationship DomainPropertyHasElementNameProvider
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProvider.DomainClassId">
            <summary>
            DomainPropertyHasElementNameProvider domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProvider.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty,Microsoft.VisualStudio.Modeling.DslDefinition.ExternalType)">
            <summary>
            Constructor
            Creates a DomainPropertyHasElementNameProvider link in the same Partition as the given DomainProperty
            </summary>
            <param name="source">DomainProperty to use as the source of the relationship.</param>
            <param name="target">ExternalType to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProvider.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProvider.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProvider.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProvider.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProvider.DomainPropertyDomainRoleId">
            <summary>
            DomainProperty domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProvider.GetDomainProperty(Microsoft.VisualStudio.Modeling.DslDefinition.ExternalType)">
            <summary>
            Gets a list of DomainProperty.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProvider.NameProviderTypeDomainRoleId">
            <summary>
            NameProviderType domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProvider.GetElementNameProvider(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Gets ElementNameProvider.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProvider.SetElementNameProvider(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty,Microsoft.VisualStudio.Modeling.DslDefinition.ExternalType)">
            <summary>
            Sets ElementNameProvider.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProvider.GetLinkToElementNameProvider(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Get the DomainPropertyHasElementNameProvider link to a DomainProperty.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProvider.GetLinksToDomainProperty(Microsoft.VisualStudio.Modeling.DslDefinition.ExternalType)">
            <summary>
            Get the list of DomainPropertyHasElementNameProvider links to a ExternalType.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProvider.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty,Microsoft.VisualStudio.Modeling.DslDefinition.ExternalType)">
            <summary>
            Get any DomainPropertyHasElementNameProvider links between a given DomainProperty and a ExternalType.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProvider.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty,Microsoft.VisualStudio.Modeling.DslDefinition.ExternalType)">
            <summary>
            Get the one DomainPropertyHasElementNameProvider link between a given DomainPropertyand a ExternalType.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProvider.DomainProperty">
            <summary>
            DomainRole DomainProperty
            External type which provides values for this property, which must have Is
            Element Name set to true.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProvider.NameProviderType">
            <summary>
            DomainRole NameProviderType
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirective">
            <summary>
            DomainRelationship ClassIndexesElementMergeDirective
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirective.DomainClassId">
            <summary>
            ClassIndexesElementMergeDirective domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirective.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Constructor
            Creates a ClassIndexesElementMergeDirective link in the same Partition as the given ElementMergeDirective
            </summary>
            <param name="source">ElementMergeDirective to use as the source of the relationship.</param>
            <param name="target">DomainClass to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirective.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirective.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirective.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirective.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirective.IndexingMergeDirectiveDomainRoleId">
            <summary>
            IndexingMergeDirective domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirective.GetIndexingElementMergeDirectives(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets a list of IndexingElementMergeDirectives.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirective.IndexDomainRoleId">
            <summary>
            Index domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirective.GetIndex(Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective)">
            <summary>
            Gets Index.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirective.SetIndex(Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Sets Index.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirective.GetLinkToIndex(Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective)">
            <summary>
            Get the ClassIndexesElementMergeDirective link to a ElementMergeDirective.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirective.GetLinksToIndexingElementMergeDirectives(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the list of ClassIndexesElementMergeDirective links to a DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirective.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get any ClassIndexesElementMergeDirective links between a given ElementMergeDirective and a DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirective.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the one ClassIndexesElementMergeDirective link between a given ElementMergeDirectiveand a DomainClass.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirective.IndexingMergeDirective">
            <summary>
            DomainRole IndexingMergeDirective
            Class of element whose merging behavior the directive defines.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirective.Index">
            <summary>
            DomainRole Index
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClass">
            <summary>
            DomainRelationship RolePlayerConnectDirectiveAcceptsClass
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClass.DomainClassId">
            <summary>
            RolePlayerConnectDirectiveAcceptsClass domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClass.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Constructor
            Creates a RolePlayerConnectDirectiveAcceptsClass link in the same Partition as the given RolePlayerConnectDirective
            </summary>
            <param name="source">RolePlayerConnectDirective to use as the source of the relationship.</param>
            <param name="target">DomainClass to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClass.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClass.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClass.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClass.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClass.RolePlayerConnectDirectiveDomainRoleId">
            <summary>
            RolePlayerConnectDirective domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClass.GetRolePlayerConnectDirectives(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets a list of RolePlayerConnectDirectives.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClass.AcceptingClassDomainRoleId">
            <summary>
            AcceptingClass domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClass.GetAcceptingClass(Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective)">
            <summary>
            Gets AcceptingClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClass.SetAcceptingClass(Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Sets AcceptingClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClass.GetLinkToAcceptingClass(Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective)">
            <summary>
            Get the RolePlayerConnectDirectiveAcceptsClass link to a RolePlayerConnectDirective.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClass.GetLinksToRolePlayerConnectDirectives(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the list of RolePlayerConnectDirectiveAcceptsClass links to a DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClass.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get any RolePlayerConnectDirectiveAcceptsClass links between a given RolePlayerConnectDirective and a DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClass.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the one RolePlayerConnectDirectiveAcceptsClass link between a given RolePlayerConnectDirectiveand a DomainClass.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClass.RolePlayerConnectDirective">
            <summary>
            DomainRole RolePlayerConnectDirective
            Role players of this class are accepted for connection.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClass.AcceptingClass">
            <summary>
            DomainRole AcceptingClass
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationship">
            <summary>
            DomainRelationship LinkConnectDirectiveReferencesDomainRelationship
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationship.DomainClassId">
            <summary>
            LinkConnectDirectiveReferencesDomainRelationship domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationship.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Constructor
            Creates a LinkConnectDirectiveReferencesDomainRelationship link in the same Partition as the given LinkConnectDirective
            </summary>
            <param name="source">LinkConnectDirective to use as the source of the relationship.</param>
            <param name="target">DomainRelationship to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationship.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationship.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationship.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationship.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationship.LinkConnectDirectiveDomainRoleId">
            <summary>
            LinkConnectDirective domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationship.GetLinkConnectDirectives(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Gets a list of LinkConnectDirectives.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationship.DomainRelationshipDomainRoleId">
            <summary>
            DomainRelationship domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationship.GetDomainRelationship(Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective)">
            <summary>
            Gets DomainRelationship.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationship.SetDomainRelationship(Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Sets DomainRelationship.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationship.GetLinkToDomainRelationship(Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective)">
            <summary>
            Get the LinkConnectDirectiveReferencesDomainRelationship link to a LinkConnectDirective.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationship.GetLinksToLinkConnectDirectives(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Get the list of LinkConnectDirectiveReferencesDomainRelationship links to a DomainRelationship.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationship.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Get any LinkConnectDirectiveReferencesDomainRelationship links between a given LinkConnectDirective and a DomainRelationship.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationship.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Get the one LinkConnectDirectiveReferencesDomainRelationship link between a given LinkConnectDirectiveand a DomainRelationship.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationship.LinkConnectDirective">
            <summary>
            DomainRole LinkConnectDirective
            Relationship for which the directive specifies link creation.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationship.DomainRelationship">
            <summary>
            DomainRole DomainRelationship
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRole">
            <summary>
            DomainRelationship PathSegmentReferencesRole
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRole.DomainClassId">
            <summary>
            PathSegmentReferencesRole domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRole.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Constructor
            Creates a PathSegmentReferencesRole link in the same Partition as the given PathSegment
            </summary>
            <param name="source">PathSegment to use as the source of the relationship.</param>
            <param name="target">DomainRole to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRole.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRole.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRole.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRole.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRole.PathSegmentDomainRoleId">
            <summary>
            PathSegment domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRole.GetPathSegments(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Gets a list of PathSegments.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRole.RoleDomainRoleId">
            <summary>
            Role domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRole.GetRole(Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment)">
            <summary>
            Gets Role.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRole.SetRole(Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Sets Role.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRole.GetLinkToRole(Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment)">
            <summary>
            Get the PathSegmentReferencesRole link to a PathSegment.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRole.GetLinksToPathSegments(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Get the list of PathSegmentReferencesRole links to a DomainRole.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRole.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Get any PathSegmentReferencesRole links between a given PathSegment and a DomainRole.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRole.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Get the one PathSegmentReferencesRole link between a given PathSegmentand a DomainRole.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRole.PathSegment">
            <summary>
            DomainRole PathSegment
            Role referenced by the segment.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRole.Role">
            <summary>
            DomainRole Role
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClass">
            <summary>
            DomainRelationship ObjectToolReferencesClass
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClass.DomainClassId">
            <summary>
            ObjectToolReferencesClass domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClass.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.ElementTool,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Constructor
            Creates a ObjectToolReferencesClass link in the same Partition as the given ElementTool
            </summary>
            <param name="source">ElementTool to use as the source of the relationship.</param>
            <param name="target">DomainClass to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClass.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClass.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClass.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClass.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClass.ToolDomainRoleId">
            <summary>
            Tool domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClass.GetTools(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets a list of Tools.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClass.ClassDomainRoleId">
            <summary>
            Class domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClass.GetClass(Microsoft.VisualStudio.Modeling.DslDefinition.ElementTool)">
            <summary>
            Gets Class.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClass.SetClass(Microsoft.VisualStudio.Modeling.DslDefinition.ElementTool,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Sets Class.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClass.GetLinkToClass(Microsoft.VisualStudio.Modeling.DslDefinition.ElementTool)">
            <summary>
            Get the ObjectToolReferencesClass link to a ElementTool.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClass.GetLinksToTools(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the list of ObjectToolReferencesClass links to a DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClass.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.ElementTool,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get any ObjectToolReferencesClass links between a given ElementTool and a DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClass.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.ElementTool,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the one ObjectToolReferencesClass link between a given ElementTooland a DomainClass.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClass.Tool">
            <summary>
            DomainRole Tool
            Class of element the tool creates.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClass.Class">
            <summary>
            DomainRole Class
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClass">
            <summary>
            DomainRelationship DslEditorIdentifiesRootClass
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClass.DomainClassId">
            <summary>
            DslEditorIdentifiesRootClass domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClass.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.Editor,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Constructor
            Creates a DslEditorIdentifiesRootClass link in the same Partition as the given Editor
            </summary>
            <param name="source">Editor to use as the source of the relationship.</param>
            <param name="target">DomainClass to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClass.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClass.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClass.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClass.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClass.RootForDomainRoleId">
            <summary>
            RootFor domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClass.GetRootFor(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets RootFor.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClass.SetRootFor(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.Editor)">
            <summary>
            Sets RootFor.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClass.RootClassDomainRoleId">
            <summary>
            RootClass domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClass.GetRootClass(Microsoft.VisualStudio.Modeling.DslDefinition.Editor)">
            <summary>
            Gets RootClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClass.SetRootClass(Microsoft.VisualStudio.Modeling.DslDefinition.Editor,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Sets RootClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClass.GetLinkToRootClass(Microsoft.VisualStudio.Modeling.DslDefinition.Editor)">
            <summary>
            Get the DslEditorIdentifiesRootClass link to a Editor.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClass.GetLinkToRootFor(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the DslEditorIdentifiesRootClass link to a DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClass.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.Editor,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get any DslEditorIdentifiesRootClass links between a given Editor and a DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClass.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.Editor,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the one DslEditorIdentifiesRootClass link between a given Editorand a DomainClass.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClass.RootFor">
            <summary>
            DomainRole RootFor
            Root class defining the element represented by the top node of the explorer and
            at the root of the xml document persisting a model.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClass.RootClass">
            <summary>
            DomainRole RootClass
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilder">
            <summary>
            DomainRelationship ConnectorToolReferencesConnectionBuilder
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilder.DomainClassId">
            <summary>
            ConnectorToolReferencesConnectionBuilder domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilder.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool,Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder)">
            <summary>
            Constructor
            Creates a ConnectorToolReferencesConnectionBuilder link in the same Partition as the given ConnectionTool
            </summary>
            <param name="source">ConnectionTool to use as the source of the relationship.</param>
            <param name="target">ConnectionBuilder to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilder.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilder.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilder.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilder.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilder.ToolDomainRoleId">
            <summary>
            Tool domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilder.GetTools(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder)">
            <summary>
            Gets a list of Tools.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilder.ConnectionBuilderDomainRoleId">
            <summary>
            ConnectionBuilder domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilder.GetConnectionBuilder(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool)">
            <summary>
            Gets ConnectionBuilder.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilder.SetConnectionBuilder(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool,Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder)">
            <summary>
            Sets ConnectionBuilder.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilder.GetLinkToConnectionBuilder(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool)">
            <summary>
            Get the ConnectorToolReferencesConnectionBuilder link to a ConnectionTool.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilder.GetLinksToTools(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder)">
            <summary>
            Get the list of ConnectorToolReferencesConnectionBuilder links to a ConnectionBuilder.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilder.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool,Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder)">
            <summary>
            Get any ConnectorToolReferencesConnectionBuilder links between a given ConnectionTool and a ConnectionBuilder.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilder.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool,Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder)">
            <summary>
            Get the one ConnectorToolReferencesConnectionBuilder link between a given ConnectionTooland a ConnectionBuilder.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilder.Tool">
            <summary>
            DomainRole Tool
            Connection builder which the tool uses to make a connection.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilder.ConnectionBuilder">
            <summary>
            DomainRole ConnectionBuilder
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehavior">
            <summary>
            DomainRelationship XmlSerializationDefinitionReferencesBehavior
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehavior.DomainClassId">
            <summary>
            XmlSerializationDefinitionReferencesBehavior domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehavior.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition,Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior)">
            <summary>
            Constructor
            Creates a XmlSerializationDefinitionReferencesBehavior link in the same Partition as the given XmlSerializationDefinition
            </summary>
            <param name="source">XmlSerializationDefinition to use as the source of the relationship.</param>
            <param name="target">XmlSerializationBehavior to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehavior.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehavior.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehavior.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehavior.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehavior.XmlSerializationDefinitionDomainRoleId">
            <summary>
            XmlSerializationDefinition domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehavior.GetXmlSerializationDefinition(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior)">
            <summary>
            Gets XmlSerializationDefinition.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehavior.SetXmlSerializationDefinition(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior,Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition)">
            <summary>
            Sets XmlSerializationDefinition.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehavior.BehaviorDomainRoleId">
            <summary>
            Behavior domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehavior.GetBehavior(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition)">
            <summary>
            Gets Behavior.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehavior.SetBehavior(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition,Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior)">
            <summary>
            Sets Behavior.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehavior.GetLinkToBehavior(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition)">
            <summary>
            Get the XmlSerializationDefinitionReferencesBehavior link to a XmlSerializationDefinition.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehavior.GetLinkToXmlSerializationDefinition(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior)">
            <summary>
            Get the XmlSerializationDefinitionReferencesBehavior link to a XmlSerializationBehavior.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehavior.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition,Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior)">
            <summary>
            Get any XmlSerializationDefinitionReferencesBehavior links between a given XmlSerializationDefinition and a XmlSerializationBehavior.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehavior.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition,Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior)">
            <summary>
            Get the one XmlSerializationDefinitionReferencesBehavior link between a given XmlSerializationDefinitionand a XmlSerializationBehavior.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehavior.XmlSerializationDefinition">
            <summary>
            DomainRole XmlSerializationDefinition
            Xml serialization behavior used by the definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehavior.Behavior">
            <summary>
            DomainRole Behavior
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehavior">
            <summary>
            DomainRelationship ExplorerReferencesBehavior
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehavior.DomainClassId">
            <summary>
            ExplorerReferencesBehavior domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehavior.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.Explorer,Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior)">
            <summary>
            Constructor
            Creates a ExplorerReferencesBehavior link in the same Partition as the given Explorer
            </summary>
            <param name="source">Explorer to use as the source of the relationship.</param>
            <param name="target">ExplorerBehavior to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehavior.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehavior.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehavior.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehavior.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehavior.ExplorerDomainRoleId">
            <summary>
            Explorer domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehavior.GetExplorer(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior)">
            <summary>
            Gets Explorer.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehavior.SetExplorer(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior,Microsoft.VisualStudio.Modeling.DslDefinition.Explorer)">
            <summary>
            Sets Explorer.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehavior.BehaviorDomainRoleId">
            <summary>
            Behavior domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehavior.GetBehavior(Microsoft.VisualStudio.Modeling.DslDefinition.Explorer)">
            <summary>
            Gets Behavior.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehavior.SetBehavior(Microsoft.VisualStudio.Modeling.DslDefinition.Explorer,Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior)">
            <summary>
            Sets Behavior.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehavior.GetLinkToBehavior(Microsoft.VisualStudio.Modeling.DslDefinition.Explorer)">
            <summary>
            Get the ExplorerReferencesBehavior link to a Explorer.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehavior.GetLinkToExplorer(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior)">
            <summary>
            Get the ExplorerReferencesBehavior link to a ExplorerBehavior.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehavior.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.Explorer,Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior)">
            <summary>
            Get any ExplorerReferencesBehavior links between a given Explorer and a ExplorerBehavior.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehavior.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.Explorer,Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior)">
            <summary>
            Get the one ExplorerReferencesBehavior link between a given Explorerand a ExplorerBehavior.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehavior.Explorer">
            <summary>
            DomainRole Explorer
            Explorer behavior used by this explorer.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehavior.Behavior">
            <summary>
            DomainRole Behavior
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClass">
            <summary>
            DomainRelationship ExplorerNodeSettingsReferencesClass
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClass.DomainClassId">
            <summary>
            ExplorerNodeSettingsReferencesClass domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClass.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Constructor
            Creates a ExplorerNodeSettingsReferencesClass link in the same Partition as the given ExplorerNodeSettings
            </summary>
            <param name="source">ExplorerNodeSettings to use as the source of the relationship.</param>
            <param name="target">DomainClass to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClass.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClass.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClass.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClass.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClass.ExplorerNodeSettingsDomainRoleId">
            <summary>
            ExplorerNodeSettings domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClass.GetExplorerNodeSettings(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets ExplorerNodeSettings.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClass.SetExplorerNodeSettings(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings)">
            <summary>
            Sets ExplorerNodeSettings.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClass.ClassDomainRoleId">
            <summary>
            Class domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClass.GetClass(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings)">
            <summary>
            Gets Class.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClass.SetClass(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Sets Class.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClass.GetLinkToClass(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings)">
            <summary>
            Get the ExplorerNodeSettingsReferencesClass link to a ExplorerNodeSettings.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClass.GetLinkToExplorerNodeSettings(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the ExplorerNodeSettingsReferencesClass link to a DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClass.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get any ExplorerNodeSettingsReferencesClass links between a given ExplorerNodeSettings and a DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClass.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the one ExplorerNodeSettingsReferencesClass link between a given ExplorerNodeSettingsand a DomainClass.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClass.ExplorerNodeSettings">
            <summary>
            DomainRole ExplorerNodeSettings
            Class of element to which the settings apply.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClass.Class">
            <summary>
            DomainRole Class
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShape">
            <summary>
            DomainRelationship ShapeMapReferencesShape
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShape">
            <summary>
            DomainRelationship BaseShapeMapReferencesBaseShape
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShape.DomainClassId">
            <summary>
            BaseShapeMapReferencesBaseShape domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShape.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">The Partition instance containing this ElementLink</param>
            <param name="roleAssignments">A set of role assignments for roleplayer initialization</param>
            <param name="propertyAssignments">A set of attribute assignments for attribute initialization</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShape.BaseShapeMapDomainRoleId">
            <summary>
            BaseShapeMap domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShape.GetBaseShapeMaps(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShape)">
            <summary>
            Gets a list of BaseShapeMaps.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShape.BaseShapeDomainRoleId">
            <summary>
            BaseShape domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShape.GetBaseShape(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap)">
            <summary>
            Gets BaseShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShape.SetBaseShape(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap,Microsoft.VisualStudio.Modeling.DslDefinition.BaseShape)">
            <summary>
            Sets BaseShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShape.GetLinkToBaseShape(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap)">
            <summary>
            Get the BaseShapeMapReferencesBaseShape link to a BaseShapeMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShape.GetLinksToBaseShapeMaps(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShape)">
            <summary>
            Get the list of BaseShapeMapReferencesBaseShape links to a BaseShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShape.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap,Microsoft.VisualStudio.Modeling.DslDefinition.BaseShape)">
            <summary>
            Get any BaseShapeMapReferencesBaseShape links between a given BaseShapeMap and a BaseShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShape.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap,Microsoft.VisualStudio.Modeling.DslDefinition.BaseShape)">
            <summary>
            Get the one BaseShapeMapReferencesBaseShape link between a given BaseShapeMapand a BaseShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShape.BaseShapeMap">
            <summary>
            DomainRole BaseShapeMap
            Base shape referenced by the map.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShape.BaseShape">
            <summary>
            DomainRole BaseShape
            Maps that reference this base shape.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShape.DomainClassId">
            <summary>
            ShapeMapReferencesShape domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShape.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMap,Microsoft.VisualStudio.Modeling.DslDefinition.Shape)">
            <summary>
            Constructor
            Creates a ShapeMapReferencesShape link in the same Partition as the given ShapeMap
            </summary>
            <param name="source">ShapeMap to use as the source of the relationship.</param>
            <param name="target">Shape to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShape.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShape.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShape.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShape.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShape.ShapeMapDomainRoleId">
            <summary>
            ShapeMap domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShape.GetShapeMaps(Microsoft.VisualStudio.Modeling.DslDefinition.Shape)">
            <summary>
            Gets a list of ShapeMaps.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShape.ShapeDomainRoleId">
            <summary>
            Shape domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShape.GetShape(Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMap)">
            <summary>
            Gets Shape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShape.SetShape(Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMap,Microsoft.VisualStudio.Modeling.DslDefinition.Shape)">
            <summary>
            Sets Shape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShape.GetLinkToShape(Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMap)">
            <summary>
            Get the ShapeMapReferencesShape link to a ShapeMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShape.GetLinksToShapeMaps(Microsoft.VisualStudio.Modeling.DslDefinition.Shape)">
            <summary>
            Get the list of ShapeMapReferencesShape links to a Shape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShape.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMap,Microsoft.VisualStudio.Modeling.DslDefinition.Shape)">
            <summary>
            Get any ShapeMapReferencesShape links between a given ShapeMap and a Shape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShape.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMap,Microsoft.VisualStudio.Modeling.DslDefinition.Shape)">
            <summary>
            Get the one ShapeMapReferencesShape link between a given ShapeMapand a Shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShape.ShapeMap">
            <summary>
            DomainRole ShapeMap
            Shape being mapped.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShape.BaseShapeMap">
            <summary>
            Gets the element playing ShapeMap domain role.
            Base shape referenced by the map.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShape.Shape">
            <summary>
            DomainRole Shape
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShape.BaseShape">
            <summary>
            Gets the element playing Shape domain role.
            Maps that reference this base shape.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecorator">
            <summary>
            DomainRelationship DecoratorMapReferencesDecorator
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecorator.DomainClassId">
            <summary>
            DecoratorMapReferencesDecorator domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecorator.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap,Microsoft.VisualStudio.Modeling.DslDefinition.Decorator)">
            <summary>
            Constructor
            Creates a DecoratorMapReferencesDecorator link in the same Partition as the given DecoratorMap
            </summary>
            <param name="source">DecoratorMap to use as the source of the relationship.</param>
            <param name="target">Decorator to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecorator.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecorator.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecorator.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecorator.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecorator.MapDomainRoleId">
            <summary>
            Map domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecorator.GetMaps(Microsoft.VisualStudio.Modeling.DslDefinition.Decorator)">
            <summary>
            Gets a list of Maps.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecorator.DecoratorDomainRoleId">
            <summary>
            Decorator domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecorator.GetDecorator(Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap)">
            <summary>
            Gets Decorator.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecorator.SetDecorator(Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap,Microsoft.VisualStudio.Modeling.DslDefinition.Decorator)">
            <summary>
            Sets Decorator.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecorator.GetLinkToDecorator(Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap)">
            <summary>
            Get the DecoratorMapReferencesDecorator link to a DecoratorMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecorator.GetLinksToMaps(Microsoft.VisualStudio.Modeling.DslDefinition.Decorator)">
            <summary>
            Get the list of DecoratorMapReferencesDecorator links to a Decorator.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecorator.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap,Microsoft.VisualStudio.Modeling.DslDefinition.Decorator)">
            <summary>
            Get any DecoratorMapReferencesDecorator links between a given DecoratorMap and a Decorator.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecorator.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap,Microsoft.VisualStudio.Modeling.DslDefinition.Decorator)">
            <summary>
            Get the one DecoratorMapReferencesDecorator link between a given DecoratorMapand a Decorator.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecorator.Map">
            <summary>
            DomainRole Map
            Decorator referenced by map.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecorator.Decorator">
            <summary>
            DomainRole Decorator
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnector">
            <summary>
            DomainRelationship ConnectorMapReferencesConnector
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnector.DomainClassId">
            <summary>
            ConnectorMapReferencesConnector domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnector.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap,Microsoft.VisualStudio.Modeling.DslDefinition.Connector)">
            <summary>
            Constructor
            Creates a ConnectorMapReferencesConnector link in the same Partition as the given ConnectorMap
            </summary>
            <param name="source">ConnectorMap to use as the source of the relationship.</param>
            <param name="target">Connector to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnector.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnector.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnector.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnector.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnector.ConnectorMapDomainRoleId">
            <summary>
            ConnectorMap domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnector.GetConnectorMaps(Microsoft.VisualStudio.Modeling.DslDefinition.Connector)">
            <summary>
            Gets a list of ConnectorMaps.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnector.ConnectorDomainRoleId">
            <summary>
            Connector domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnector.GetConnector(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap)">
            <summary>
            Gets Connector.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnector.SetConnector(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap,Microsoft.VisualStudio.Modeling.DslDefinition.Connector)">
            <summary>
            Sets Connector.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnector.GetLinkToConnector(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap)">
            <summary>
            Get the ConnectorMapReferencesConnector link to a ConnectorMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnector.GetLinksToConnectorMaps(Microsoft.VisualStudio.Modeling.DslDefinition.Connector)">
            <summary>
            Get the list of ConnectorMapReferencesConnector links to a Connector.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnector.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap,Microsoft.VisualStudio.Modeling.DslDefinition.Connector)">
            <summary>
            Get any ConnectorMapReferencesConnector links between a given ConnectorMap and a Connector.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnector.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap,Microsoft.VisualStudio.Modeling.DslDefinition.Connector)">
            <summary>
            Get the one ConnectorMapReferencesConnector link between a given ConnectorMapand a Connector.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnector.ConnectorMap">
            <summary>
            DomainRole ConnectorMap
            Connector being mapped.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnector.Connector">
            <summary>
            DomainRole Connector
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesProperty">
            <summary>
            DomainRelationship PropertyPathReferencesProperty
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesProperty.DomainClassId">
            <summary>
            PropertyPathReferencesProperty domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesProperty.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath,Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Constructor
            Creates a PropertyPathReferencesProperty link in the same Partition as the given PropertyPath
            </summary>
            <param name="source">PropertyPath to use as the source of the relationship.</param>
            <param name="target">DomainProperty to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesProperty.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesProperty.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesProperty.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesProperty.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesProperty.PropertyPathDomainRoleId">
            <summary>
            PropertyPath domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesProperty.GetPropertyPaths(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Gets a list of PropertyPaths.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesProperty.PropertyDomainRoleId">
            <summary>
            Property domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesProperty.GetProperty(Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath)">
            <summary>
            Gets Property.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesProperty.SetProperty(Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath,Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Sets Property.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesProperty.GetLinkToProperty(Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath)">
            <summary>
            Get the PropertyPathReferencesProperty link to a PropertyPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesProperty.GetLinksToPropertyPaths(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Get the list of PropertyPathReferencesProperty links to a DomainProperty.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesProperty.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath,Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Get any PropertyPathReferencesProperty links between a given PropertyPath and a DomainProperty.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesProperty.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath,Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Get the one PropertyPathReferencesProperty link between a given PropertyPathand a DomainProperty.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesProperty.PropertyPath">
            <summary>
            DomainRole PropertyPath
            Designated property of the element reached by the path.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesProperty.Property">
            <summary>
            DomainRole Property
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClass">
            <summary>
            DomainRelationship ShapeMapReferencesClass
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClass.DomainClassId">
            <summary>
            ShapeMapReferencesClass domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClass.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Constructor
            Creates a ShapeMapReferencesClass link in the same Partition as the given BaseShapeMap
            </summary>
            <param name="source">BaseShapeMap to use as the source of the relationship.</param>
            <param name="target">DomainClass to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClass.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClass.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClass.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClass.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClass.ShapeMapDomainRoleId">
            <summary>
            ShapeMap domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClass.GetShapeMaps(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets a list of ShapeMaps.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClass.ClassDomainRoleId">
            <summary>
            Class domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClass.GetClass(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap)">
            <summary>
            Gets Class.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClass.SetClass(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Sets Class.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClass.GetLinkToClass(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap)">
            <summary>
            Get the ShapeMapReferencesClass link to a BaseShapeMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClass.GetLinksToShapeMaps(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the list of ShapeMapReferencesClass links to a DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClass.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get any ShapeMapReferencesClass links between a given BaseShapeMap and a DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClass.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the one ShapeMapReferencesClass link between a given BaseShapeMapand a DomainClass.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClass.ShapeMap">
            <summary>
            DomainRole ShapeMap
            Class being mapped.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClass.Class">
            <summary>
            DomainRole Class
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClass">
            <summary>
            DomainRelationship DiagramRepresentsClass
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClass.DomainClassId">
            <summary>
            DiagramRepresentsClass domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClass.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Constructor
            Creates a DiagramRepresentsClass link in the same Partition as the given Diagram
            </summary>
            <param name="source">Diagram to use as the source of the relationship.</param>
            <param name="target">DomainClass to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClass.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClass.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClass.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClass.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClass.DiagramDomainRoleId">
            <summary>
            Diagram domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClass.GetDiagrams(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets a list of Diagrams.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClass.ClassDomainRoleId">
            <summary>
            Class domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClass.GetClass(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Gets Class.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClass.SetClass(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Sets Class.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClass.GetLinkToClass(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Get the DiagramRepresentsClass link to a Diagram.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClass.GetLinksToDiagrams(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the list of DiagramRepresentsClass links to a DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClass.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get any DiagramRepresentsClass links between a given Diagram and a DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClass.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the one DiagramRepresentsClass link between a given Diagramand a DomainClass.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClass.Diagram">
            <summary>
            DomainRole Diagram
            The class of element represented by a diagram.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClass.Class">
            <summary>
            DomainRole Class
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartment">
            <summary>
            DomainRelationship CompartmentMapsReferToCompartment
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartment.DomainClassId">
            <summary>
            CompartmentMapsReferToCompartment domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartment.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap,Microsoft.VisualStudio.Modeling.DslDefinition.Compartment)">
            <summary>
            Constructor
            Creates a CompartmentMapsReferToCompartment link in the same Partition as the given CompartmentMap
            </summary>
            <param name="source">CompartmentMap to use as the source of the relationship.</param>
            <param name="target">Compartment to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartment.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartment.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartment.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartment.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartment.CompartmentMapDomainRoleId">
            <summary>
            CompartmentMap domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartment.GetCompartmentMaps(Microsoft.VisualStudio.Modeling.DslDefinition.Compartment)">
            <summary>
            Gets a list of CompartmentMaps.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartment.CompartmentDomainRoleId">
            <summary>
            Compartment domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartment.GetCompartment(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap)">
            <summary>
            Gets Compartment.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartment.SetCompartment(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap,Microsoft.VisualStudio.Modeling.DslDefinition.Compartment)">
            <summary>
            Sets Compartment.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartment.GetLinkToCompartment(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap)">
            <summary>
            Get the CompartmentMapsReferToCompartment link to a CompartmentMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartment.GetLinksToCompartmentMaps(Microsoft.VisualStudio.Modeling.DslDefinition.Compartment)">
            <summary>
            Get the list of CompartmentMapsReferToCompartment links to a Compartment.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartment.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap,Microsoft.VisualStudio.Modeling.DslDefinition.Compartment)">
            <summary>
            Get any CompartmentMapsReferToCompartment links between a given CompartmentMap and a Compartment.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartment.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap,Microsoft.VisualStudio.Modeling.DslDefinition.Compartment)">
            <summary>
            Get the one CompartmentMapsReferToCompartment link between a given CompartmentMapand a Compartment.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartment.CompartmentMap">
            <summary>
            DomainRole CompartmentMap
            Compartment referenced by the compartment map.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartment.Compartment">
            <summary>
            DomainRole Compartment
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagram">
            <summary>
            DomainRelationship DesignerHasDiagram
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagram.DomainClassId">
            <summary>
            DesignerHasDiagram domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagram.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.Designer,Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Constructor
            Creates a DesignerHasDiagram link in the same Partition as the given Designer
            </summary>
            <param name="source">Designer to use as the source of the relationship.</param>
            <param name="target">Diagram to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagram.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagram.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagram.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagram.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagram.GraphicalEditorDomainRoleId">
            <summary>
            GraphicalEditor domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagram.GetDesigner(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Gets Designer.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagram.SetDesigner(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram,Microsoft.VisualStudio.Modeling.DslDefinition.Designer)">
            <summary>
            Sets Designer.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagram.DiagramDomainRoleId">
            <summary>
            Diagram domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagram.GetDiagram(Microsoft.VisualStudio.Modeling.DslDefinition.Designer)">
            <summary>
            Gets Diagram.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagram.SetDiagram(Microsoft.VisualStudio.Modeling.DslDefinition.Designer,Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Sets Diagram.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagram.GetLinkToDiagram(Microsoft.VisualStudio.Modeling.DslDefinition.Designer)">
            <summary>
            Get the DesignerHasDiagram link to a Designer.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagram.GetLinkToDesigner(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Get the DesignerHasDiagram link to a Diagram.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagram.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.Designer,Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Get any DesignerHasDiagram links between a given Designer and a Diagram.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagram.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.Designer,Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Get the one DesignerHasDiagram link between a given Designerand a Diagram.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagram.GraphicalEditor">
            <summary>
            DomainRole GraphicalEditor
            Diagram definition used for the designer.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagram.Diagram">
            <summary>
            DomainRole Diagram
            Designer referencing the diagram.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationship">
            <summary>
            DomainRelationship ConnectorMapReferencesRelationship
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationship.DomainClassId">
            <summary>
            ConnectorMapReferencesRelationship domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationship.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Constructor
            Creates a ConnectorMapReferencesRelationship link in the same Partition as the given ConnectorMap
            </summary>
            <param name="source">ConnectorMap to use as the source of the relationship.</param>
            <param name="target">DomainRelationship to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationship.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationship.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationship.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationship.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationship.ConnectorMapDomainRoleId">
            <summary>
            ConnectorMap domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationship.GetConnectorMaps(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Gets a list of ConnectorMaps.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationship.RelationshipDomainRoleId">
            <summary>
            Relationship domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationship.GetRelationship(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap)">
            <summary>
            Gets Relationship.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationship.SetRelationship(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Sets Relationship.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationship.GetLinkToRelationship(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap)">
            <summary>
            Get the ConnectorMapReferencesRelationship link to a ConnectorMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationship.GetLinksToConnectorMaps(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Get the list of ConnectorMapReferencesRelationship links to a DomainRelationship.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationship.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Get any ConnectorMapReferencesRelationship links between a given ConnectorMap and a DomainRelationship.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationship.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Get the one ConnectorMapReferencesRelationship link between a given ConnectorMapand a DomainRelationship.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationship.ConnectorMap">
            <summary>
            DomainRole ConnectorMap
            Relationship being mapped.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationship.Relationship">
            <summary>
            DomainRole Relationship
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShape">
            <summary>
            DomainRelationship CompartmentShapeMapReferencesCompartmentShape
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShape.DomainClassId">
            <summary>
            CompartmentShapeMapReferencesCompartmentShape domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShape.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMap,Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape)">
            <summary>
            Constructor
            Creates a CompartmentShapeMapReferencesCompartmentShape link in the same Partition as the given CompartmentShapeMap
            </summary>
            <param name="source">CompartmentShapeMap to use as the source of the relationship.</param>
            <param name="target">CompartmentShape to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShape.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShape.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShape.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShape.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShape.ShapeMapDomainRoleId">
            <summary>
            ShapeMap domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShape.GetCompartmentShapeMaps(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape)">
            <summary>
            Gets a list of CompartmentShapeMaps.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShape.ShapeDomainRoleId">
            <summary>
            Shape domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShape.GetCompartmentShape(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMap)">
            <summary>
            Gets CompartmentShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShape.SetCompartmentShape(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMap,Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape)">
            <summary>
            Sets CompartmentShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShape.GetLinkToCompartmentShape(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMap)">
            <summary>
            Get the CompartmentShapeMapReferencesCompartmentShape link to a CompartmentShapeMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShape.GetLinksToCompartmentShapeMaps(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape)">
            <summary>
            Get the list of CompartmentShapeMapReferencesCompartmentShape links to a CompartmentShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShape.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMap,Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape)">
            <summary>
            Get any CompartmentShapeMapReferencesCompartmentShape links between a given CompartmentShapeMap and a CompartmentShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShape.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMap,Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape)">
            <summary>
            Get the one CompartmentShapeMapReferencesCompartmentShape link between a given CompartmentShapeMapand a CompartmentShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShape.ShapeMap">
            <summary>
            DomainRole ShapeMap
            Compartment shape being mapped.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShape.BaseShapeMap">
            <summary>
            Gets the element playing ShapeMap domain role.
            Base shape referenced by the map.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShape.Shape">
            <summary>
            DomainRole Shape
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShape.BaseShape">
            <summary>
            Gets the element playing Shape domain role.
            Maps that reference this base shape.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClass">
            <summary>
            DomainRelationship XmlClassDataAppliesToDomainClass
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClass.DomainClassId">
            <summary>
            XmlClassDataAppliesToDomainClass domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClass.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Constructor
            Creates a XmlClassDataAppliesToDomainClass link in the same Partition as the given XmlClassData
            </summary>
            <param name="source">XmlClassData to use as the source of the relationship.</param>
            <param name="target">DomainClass to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClass.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClass.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClass.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClass.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClass.XmlClassDataDomainRoleId">
            <summary>
            XmlClassData domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClass.GetClassData(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets ClassData.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClass.SetClassData(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData)">
            <summary>
            Sets ClassData.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClass.DomainClassDomainRoleId">
            <summary>
            DomainClass domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClass.GetDomainClass(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData)">
            <summary>
            Gets DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClass.SetDomainClass(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Sets DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClass.GetLinkToDomainClass(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData)">
            <summary>
            Get the XmlClassDataAppliesToDomainClass link to a XmlClassData.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClass.GetLinkToClassData(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the XmlClassDataAppliesToDomainClass link to a DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClass.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get any XmlClassDataAppliesToDomainClass links between a given XmlClassData and a DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClass.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the one XmlClassDataAppliesToDomainClass link between a given XmlClassDataand a DomainClass.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClass.XmlClassData">
            <summary>
            DomainRole XmlClassData
            Class to which the xml serialization configuration data applies.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClass.DomainClass">
            <summary>
            DomainRole DomainClass
            Xml serialization configuration data for the domain class.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationship">
            <summary>
            DomainRelationship XmlRelationshipDataAppliesToDomainRelationship
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationship.DomainClassId">
            <summary>
            XmlRelationshipDataAppliesToDomainRelationship domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationship.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Constructor
            Creates a XmlRelationshipDataAppliesToDomainRelationship link in the same Partition as the given XmlRelationshipData
            </summary>
            <param name="source">XmlRelationshipData to use as the source of the relationship.</param>
            <param name="target">DomainRelationship to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationship.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationship.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationship.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationship.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationship.XmlRelationshipDataDomainRoleId">
            <summary>
            XmlRelationshipData domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationship.GetXmlRelationshipData(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Gets XmlRelationshipData.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationship.SetXmlRelationshipData(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship,Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData)">
            <summary>
            Sets XmlRelationshipData.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationship.DomainRelationshipDomainRoleId">
            <summary>
            DomainRelationship domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationship.GetDomainRelationship(Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData)">
            <summary>
            Gets DomainRelationship.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationship.SetDomainRelationship(Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Sets DomainRelationship.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationship.GetLinkToDomainRelationship(Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData)">
            <summary>
            Get the XmlRelationshipDataAppliesToDomainRelationship link to a XmlRelationshipData.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationship.GetLinkToXmlRelationshipData(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Get the XmlRelationshipDataAppliesToDomainRelationship link to a DomainRelationship.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationship.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Get any XmlRelationshipDataAppliesToDomainRelationship links between a given XmlRelationshipData and a DomainRelationship.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationship.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Get the one XmlRelationshipDataAppliesToDomainRelationship link between a given XmlRelationshipDataand a DomainRelationship.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationship.XmlRelationshipData">
            <summary>
            DomainRole XmlRelationshipData
            Relationship to which the xml serialization configuration data applies.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationship.DomainRelationship">
            <summary>
            DomainRole DomainRelationship
            Xml serialization configuration data for the domain relationship.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainProperty">
            <summary>
            DomainRelationship XmlElementAppliesToDomainProperty
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainProperty.DomainClassId">
            <summary>
            XmlElementAppliesToDomainProperty domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainProperty.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData,Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Constructor
            Creates a XmlElementAppliesToDomainProperty link in the same Partition as the given XmlPropertyData
            </summary>
            <param name="source">XmlPropertyData to use as the source of the relationship.</param>
            <param name="target">DomainProperty to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainProperty.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainProperty.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainProperty.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainProperty.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainProperty.XmlElementDomainRoleId">
            <summary>
            XmlElement domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainProperty.GetXmlElement(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Gets XmlElement.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainProperty.SetXmlElement(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty,Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData)">
            <summary>
            Sets XmlElement.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainProperty.DomainPropertyDomainRoleId">
            <summary>
            DomainProperty domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainProperty.GetDomainProperty(Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData)">
            <summary>
            Gets DomainProperty.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainProperty.SetDomainProperty(Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData,Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Sets DomainProperty.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainProperty.GetLinkToDomainProperty(Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData)">
            <summary>
            Get the XmlElementAppliesToDomainProperty link to a XmlPropertyData.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainProperty.GetLinkToXmlElement(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Get the XmlElementAppliesToDomainProperty link to a DomainProperty.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainProperty.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData,Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Get any XmlElementAppliesToDomainProperty links between a given XmlPropertyData and a DomainProperty.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainProperty.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData,Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Get the one XmlElementAppliesToDomainProperty link between a given XmlPropertyDataand a DomainProperty.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainProperty.XmlElement">
            <summary>
            DomainRole XmlElement
            Property to which the xml serialization configuration data applies.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainProperty.DomainProperty">
            <summary>
            DomainRole DomainProperty
            Xml serialization configuration data for the domain property.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLane">
            <summary>
            DomainRelationship SwimLaneMapReferencesSwimLane
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLane.DomainClassId">
            <summary>
            SwimLaneMapReferencesSwimLane domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLane.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMap,Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane)">
            <summary>
            Constructor
            Creates a SwimLaneMapReferencesSwimLane link in the same Partition as the given SwimLaneMap
            </summary>
            <param name="source">SwimLaneMap to use as the source of the relationship.</param>
            <param name="target">SwimLane to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLane.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLane.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLane.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLane.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLane.SwimLaneMapDomainRoleId">
            <summary>
            SwimLaneMap domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLane.GetSwimLaneMaps(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane)">
            <summary>
            Gets a list of SwimLaneMaps.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLane.SwimLaneDomainRoleId">
            <summary>
            SwimLane domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLane.GetSwimLane(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMap)">
            <summary>
            Gets SwimLane.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLane.SetSwimLane(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMap,Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane)">
            <summary>
            Sets SwimLane.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLane.GetLinkToSwimLane(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMap)">
            <summary>
            Get the SwimLaneMapReferencesSwimLane link to a SwimLaneMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLane.GetLinksToSwimLaneMaps(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane)">
            <summary>
            Get the list of SwimLaneMapReferencesSwimLane links to a SwimLane.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLane.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMap,Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane)">
            <summary>
            Get any SwimLaneMapReferencesSwimLane links between a given SwimLaneMap and a SwimLane.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLane.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMap,Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane)">
            <summary>
            Get the one SwimLaneMapReferencesSwimLane link between a given SwimLaneMapand a SwimLane.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLane.SwimLaneMap">
            <summary>
            DomainRole SwimLaneMap
            Swimlane being mapped.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLane.BaseShapeMap">
            <summary>
            Gets the element playing SwimLaneMap domain role.
            Base shape referenced by the map.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLane.SwimLane">
            <summary>
            DomainRole SwimLane
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLane.BaseShape">
            <summary>
            Gets the element playing SwimLane domain role.
            Maps that reference this base shape.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.RootNodeReferencesClass">
            <summary>
            DomainRelationship RootNodeReferencesClass
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.RootNodeReferencesClass.DomainClassId">
            <summary>
            RootNodeReferencesClass domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RootNodeReferencesClass.#ctor(Microsoft.VisualStudio.Modeling.DslDesigner.RootNode,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Constructor
            Creates a RootNodeReferencesClass link in the same Partition as the given RootNode
            </summary>
            <param name="source">RootNode to use as the source of the relationship.</param>
            <param name="target">DomainClass to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RootNodeReferencesClass.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RootNodeReferencesClass.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RootNodeReferencesClass.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RootNodeReferencesClass.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.RootNodeReferencesClass.RootNodeDomainRoleId">
            <summary>
            RootNode domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RootNodeReferencesClass.GetRootNodes(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets a list of RootNodes.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.RootNodeReferencesClass.ClassDomainRoleId">
            <summary>
            Class domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RootNodeReferencesClass.GetClass(Microsoft.VisualStudio.Modeling.DslDesigner.RootNode)">
            <summary>
            Gets Class.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RootNodeReferencesClass.SetClass(Microsoft.VisualStudio.Modeling.DslDesigner.RootNode,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Sets Class.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RootNodeReferencesClass.GetLinkToClass(Microsoft.VisualStudio.Modeling.DslDesigner.RootNode)">
            <summary>
            Get the RootNodeReferencesClass link to a RootNode.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RootNodeReferencesClass.GetLinksToRootNodes(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the list of RootNodeReferencesClass links to a DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RootNodeReferencesClass.GetLinks(Microsoft.VisualStudio.Modeling.DslDesigner.RootNode,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get any RootNodeReferencesClass links between a given RootNode and a DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RootNodeReferencesClass.GetLink(Microsoft.VisualStudio.Modeling.DslDesigner.RootNode,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the one RootNodeReferencesClass link between a given RootNodeand a DomainClass.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RootNodeReferencesClass.RootNode">
            <summary>
            DomainRole RootNode
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RootNodeReferencesClass.Class">
            <summary>
            DomainRole Class
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.RoleNodeReferencesRole">
            <summary>
            DomainRelationship RoleNodeReferencesRole
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.RoleNodeReferencesRole.DomainClassId">
            <summary>
            RoleNodeReferencesRole domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleNodeReferencesRole.#ctor(Microsoft.VisualStudio.Modeling.DslDesigner.SourceRoleNode,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Constructor
            Creates a RoleNodeReferencesRole link in the same Partition as the given SourceRoleNode
            </summary>
            <param name="source">SourceRoleNode to use as the source of the relationship.</param>
            <param name="target">DomainRole to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleNodeReferencesRole.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleNodeReferencesRole.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleNodeReferencesRole.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleNodeReferencesRole.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.RoleNodeReferencesRole.RoleNodeDomainRoleId">
            <summary>
            RoleNode domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleNodeReferencesRole.GetRoleNodes(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Gets a list of RoleNodes.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.RoleNodeReferencesRole.RoleDomainRoleId">
            <summary>
            Role domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleNodeReferencesRole.GetRole(Microsoft.VisualStudio.Modeling.DslDesigner.SourceRoleNode)">
            <summary>
            Gets Role.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleNodeReferencesRole.SetRole(Microsoft.VisualStudio.Modeling.DslDesigner.SourceRoleNode,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Sets Role.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleNodeReferencesRole.GetLinkToRole(Microsoft.VisualStudio.Modeling.DslDesigner.SourceRoleNode)">
            <summary>
            Get the RoleNodeReferencesRole link to a SourceRoleNode.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleNodeReferencesRole.GetLinksToRoleNodes(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Get the list of RoleNodeReferencesRole links to a DomainRole.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleNodeReferencesRole.GetLinks(Microsoft.VisualStudio.Modeling.DslDesigner.SourceRoleNode,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Get any RoleNodeReferencesRole links between a given SourceRoleNode and a DomainRole.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RoleNodeReferencesRole.GetLink(Microsoft.VisualStudio.Modeling.DslDesigner.SourceRoleNode,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Get the one RoleNodeReferencesRole link between a given SourceRoleNodeand a DomainRole.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RoleNodeReferencesRole.RoleNode">
            <summary>
            DomainRole RoleNode
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RoleNodeReferencesRole.Role">
            <summary>
            DomainRole Role
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNodeReferencesInheritanceLink">
            <summary>
            DomainRelationship InheritanceNodeReferencesInheritanceLink
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNodeReferencesInheritanceLink.DomainClassId">
            <summary>
            InheritanceNodeReferencesInheritanceLink domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNodeReferencesInheritanceLink.#ctor(Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNode,Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass)">
            <summary>
            Constructor
            Creates a InheritanceNodeReferencesInheritanceLink link in the same Partition as the given InheritanceNode
            </summary>
            <param name="source">InheritanceNode to use as the source of the relationship.</param>
            <param name="target">ClassHasBaseClass to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNodeReferencesInheritanceLink.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNodeReferencesInheritanceLink.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNodeReferencesInheritanceLink.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNodeReferencesInheritanceLink.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNodeReferencesInheritanceLink.InheritanceNodeDomainRoleId">
            <summary>
            InheritanceNode domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNodeReferencesInheritanceLink.GetInheritanceNodes(Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass)">
            <summary>
            Gets a list of InheritanceNodes.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNodeReferencesInheritanceLink.InheritanceLinkDomainRoleId">
            <summary>
            InheritanceLink domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNodeReferencesInheritanceLink.GetInheritanceLink(Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNode)">
            <summary>
            Gets InheritanceLink.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNodeReferencesInheritanceLink.SetInheritanceLink(Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNode,Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass)">
            <summary>
            Sets InheritanceLink.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNodeReferencesInheritanceLink.GetLinkToInheritanceLink(Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNode)">
            <summary>
            Get the InheritanceNodeReferencesInheritanceLink link to a InheritanceNode.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNodeReferencesInheritanceLink.GetLinksToInheritanceNodes(Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass)">
            <summary>
            Get the list of InheritanceNodeReferencesInheritanceLink links to a ClassHasBaseClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNodeReferencesInheritanceLink.GetLinks(Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNode,Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass)">
            <summary>
            Get any InheritanceNodeReferencesInheritanceLink links between a given InheritanceNode and a ClassHasBaseClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNodeReferencesInheritanceLink.GetLink(Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNode,Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass)">
            <summary>
            Get the one InheritanceNodeReferencesInheritanceLink link between a given InheritanceNodeand a ClassHasBaseClass.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNodeReferencesInheritanceLink.InheritanceNode">
            <summary>
            DomainRole InheritanceNode
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNodeReferencesInheritanceLink.InheritanceLink">
            <summary>
            DomainRole InheritanceLink
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramHasDiagramState">
            <summary>
            DomainRelationship DslDesignerDiagramHasDiagramState
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramHasDiagramState.DomainClassId">
            <summary>
            DslDesignerDiagramHasDiagramState domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramHasDiagramState.#ctor(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState)">
            <summary>
            Constructor
            Creates a DslDesignerDiagramHasDiagramState link in the same Partition as the given DslDesignerDiagram
            </summary>
            <param name="source">DslDesignerDiagram to use as the source of the relationship.</param>
            <param name="target">DslDesignerDiagramState to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramHasDiagramState.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramHasDiagramState.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramHasDiagramState.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramHasDiagramState.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramHasDiagramState.DiagramDomainRoleId">
            <summary>
            Diagram domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramHasDiagramState.GetDiagram(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState)">
            <summary>
            Gets Diagram.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramHasDiagramState.SetDiagram(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram)">
            <summary>
            Sets Diagram.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramHasDiagramState.DiagramStateDomainRoleId">
            <summary>
            DiagramState domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramHasDiagramState.GetDiagramState(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram)">
            <summary>
            Gets DiagramState.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramHasDiagramState.SetDiagramState(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState)">
            <summary>
            Sets DiagramState.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramHasDiagramState.GetLinkToDiagramState(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram)">
            <summary>
            Get the DslDesignerDiagramHasDiagramState link to a DslDesignerDiagram.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramHasDiagramState.GetLinkToDiagram(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState)">
            <summary>
            Get the DslDesignerDiagramHasDiagramState link to a DslDesignerDiagramState.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramHasDiagramState.GetLinks(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState)">
            <summary>
            Get any DslDesignerDiagramHasDiagramState links between a given DslDesignerDiagram and a DslDesignerDiagramState.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramHasDiagramState.GetLink(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState)">
            <summary>
            Get the one DslDesignerDiagramHasDiagramState link between a given DslDesignerDiagramand a DslDesignerDiagramState.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramHasDiagramState.Diagram">
            <summary>
            DomainRole Diagram
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramHasDiagramState.DiagramState">
            <summary>
            DomainRole DiagramState
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLane">
            <summary>
            DomainRelationship SwimLaneHasBaseSwimLane
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLane
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLane.DomainClassId">
            <summary>
            SwimLaneHasBaseSwimLane domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLane.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane,Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane)">
            <summary>
            Constructor
            Creates a SwimLaneHasBaseSwimLane link in the same Partition as the given SwimLane
            </summary>
            <param name="source">SwimLane to use as the source of the relationship.</param>
            <param name="target">SwimLane to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLane.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLane.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLane.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLane.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLane.SubSwimLaneDomainRoleId">
            <summary>
            SubSwimLane domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLane.GetSubClasses(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane)">
            <summary>
            Gets a list of SubClasses.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLane.BaseSwimLaneDomainRoleId">
            <summary>
            BaseSwimLane domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLane.GetBaseClass(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane)">
            <summary>
            Gets BaseClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLane.SetBaseClass(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane,Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane)">
            <summary>
            Sets BaseClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLane.GetLinkToBaseClass(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane)">
            <summary>
            Get the SwimLaneHasBaseSwimLane link to a SwimLane.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLane.GetLinksToSubClasses(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane)">
            <summary>
            Get the list of SwimLaneHasBaseSwimLane links to a SwimLane.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLane.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane,Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane)">
            <summary>
            Get any SwimLaneHasBaseSwimLane links between a given SwimLane and a SwimLane.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLane.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane,Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane)">
            <summary>
            Get the one SwimLaneHasBaseSwimLane link between a given SwimLaneand a SwimLane.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLane.SubSwimLane">
            <summary>
            DomainRole SubSwimLane
            Base swimlane of this swimlane.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLane.SubClass">
            <summary>
            Gets the element playing SubSwimLane domain role.
            Base class of this domain class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLane.BaseSwimLane">
            <summary>
            DomainRole BaseSwimLane
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLane.BaseClass">
            <summary>
            Gets the element playing BaseSwimLane domain role.
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.BaseClass
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShape">
            <summary>
            DomainRelationship CompartmentShapeHasBaseCompartmentShape
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShape.DomainClassId">
            <summary>
            CompartmentShapeHasBaseCompartmentShape domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShape.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape,Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape)">
            <summary>
            Constructor
            Creates a CompartmentShapeHasBaseCompartmentShape link in the same Partition as the given CompartmentShape
            </summary>
            <param name="source">CompartmentShape to use as the source of the relationship.</param>
            <param name="target">CompartmentShape to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShape.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShape.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShape.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShape.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShape.SubCompartmentShapeDomainRoleId">
            <summary>
            SubCompartmentShape domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShape.GetSubClasses(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape)">
            <summary>
            Gets a list of SubClasses.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShape.BaseCompartmentShapeDomainRoleId">
            <summary>
            BaseCompartmentShape domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShape.GetBaseClass(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape)">
            <summary>
            Gets BaseClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShape.SetBaseClass(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape,Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape)">
            <summary>
            Sets BaseClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShape.GetLinkToBaseClass(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape)">
            <summary>
            Get the CompartmentShapeHasBaseCompartmentShape link to a CompartmentShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShape.GetLinksToSubClasses(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape)">
            <summary>
            Get the list of CompartmentShapeHasBaseCompartmentShape links to a CompartmentShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShape.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape,Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape)">
            <summary>
            Get any CompartmentShapeHasBaseCompartmentShape links between a given CompartmentShape and a CompartmentShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShape.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape,Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape)">
            <summary>
            Get the one CompartmentShapeHasBaseCompartmentShape link between a given CompartmentShapeand a CompartmentShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShape.SubCompartmentShape">
            <summary>
            DomainRole SubCompartmentShape
            Base compartment shape of this compartment shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShape.SubClass">
            <summary>
            Gets the element playing SubCompartmentShape domain role.
            Base class of this domain class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShape.BaseCompartmentShape">
            <summary>
            DomainRole BaseCompartmentShape
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShape.BaseClass">
            <summary>
            Gets the element playing BaseCompartmentShape domain role.
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.BaseClass
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShape">
            <summary>
            DomainRelationship ImageShapeHasBaseImageShape
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShape.DomainClassId">
            <summary>
            ImageShapeHasBaseImageShape domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShape.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.ImageShape,Microsoft.VisualStudio.Modeling.DslDefinition.ImageShape)">
            <summary>
            Constructor
            Creates a ImageShapeHasBaseImageShape link in the same Partition as the given ImageShape
            </summary>
            <param name="source">ImageShape to use as the source of the relationship.</param>
            <param name="target">ImageShape to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShape.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShape.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShape.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShape.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShape.SubImageShapeDomainRoleId">
            <summary>
            SubImageShape domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShape.GetSubClasses(Microsoft.VisualStudio.Modeling.DslDefinition.ImageShape)">
            <summary>
            Gets a list of SubClasses.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShape.BaseImageShapeDomainRoleId">
            <summary>
            BaseImageShape domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShape.GetBaseClass(Microsoft.VisualStudio.Modeling.DslDefinition.ImageShape)">
            <summary>
            Gets BaseClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShape.SetBaseClass(Microsoft.VisualStudio.Modeling.DslDefinition.ImageShape,Microsoft.VisualStudio.Modeling.DslDefinition.ImageShape)">
            <summary>
            Sets BaseClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShape.GetLinkToBaseClass(Microsoft.VisualStudio.Modeling.DslDefinition.ImageShape)">
            <summary>
            Get the ImageShapeHasBaseImageShape link to a ImageShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShape.GetLinksToSubClasses(Microsoft.VisualStudio.Modeling.DslDefinition.ImageShape)">
            <summary>
            Get the list of ImageShapeHasBaseImageShape links to a ImageShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShape.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.ImageShape,Microsoft.VisualStudio.Modeling.DslDefinition.ImageShape)">
            <summary>
            Get any ImageShapeHasBaseImageShape links between a given ImageShape and a ImageShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShape.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.ImageShape,Microsoft.VisualStudio.Modeling.DslDefinition.ImageShape)">
            <summary>
            Get the one ImageShapeHasBaseImageShape link between a given ImageShapeand a ImageShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShape.SubImageShape">
            <summary>
            DomainRole SubImageShape
            Base image shape of this image shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShape.SubClass">
            <summary>
            Gets the element playing SubImageShape domain role.
            Base class of this domain class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShape.BaseImageShape">
            <summary>
            DomainRole BaseImageShape
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShape.BaseImageShape
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShape.BaseClass">
            <summary>
            Gets the element playing BaseImageShape domain role.
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.BaseClass
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShape">
            <summary>
            DomainRelationship GeometryShapeHasBaseGeometryShape
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShape.DomainClassId">
            <summary>
            GeometryShapeHasBaseGeometryShape domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShape.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShape,Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShape)">
            <summary>
            Constructor
            Creates a GeometryShapeHasBaseGeometryShape link in the same Partition as the given GeometryShape
            </summary>
            <param name="source">GeometryShape to use as the source of the relationship.</param>
            <param name="target">GeometryShape to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShape.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShape.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShape.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShape.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShape.SubGeometryShapeDomainRoleId">
            <summary>
            SubGeometryShape domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShape.GetSubClasses(Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShape)">
            <summary>
            Gets a list of SubClasses.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShape.BaseGeometryShapeDomainRoleId">
            <summary>
            BaseGeometryShape domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShape.GetBaseClass(Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShape)">
            <summary>
            Gets BaseClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShape.SetBaseClass(Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShape,Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShape)">
            <summary>
            Sets BaseClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShape.GetLinkToBaseClass(Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShape)">
            <summary>
            Get the GeometryShapeHasBaseGeometryShape link to a GeometryShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShape.GetLinksToSubClasses(Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShape)">
            <summary>
            Get the list of GeometryShapeHasBaseGeometryShape links to a GeometryShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShape.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShape,Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShape)">
            <summary>
            Get any GeometryShapeHasBaseGeometryShape links between a given GeometryShape and a GeometryShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShape.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShape,Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShape)">
            <summary>
            Get the one GeometryShapeHasBaseGeometryShape link between a given GeometryShapeand a GeometryShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShape.SubGeometryShape">
            <summary>
            DomainRole SubGeometryShape
            Base geometry shape of this geometry shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShape.SubClass">
            <summary>
            Gets the element playing SubGeometryShape domain role.
            Base class of this domain class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShape.BaseGeometryShape">
            <summary>
            DomainRole BaseGeometryShape
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShape.BaseClass">
            <summary>
            Gets the element playing BaseGeometryShape domain role.
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.BaseClass
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePort">
            <summary>
            DomainRelationship PortHasBasePort
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePort.DomainClassId">
            <summary>
            PortHasBasePort domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePort.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.Port,Microsoft.VisualStudio.Modeling.DslDefinition.Port)">
            <summary>
            Constructor
            Creates a PortHasBasePort link in the same Partition as the given Port
            </summary>
            <param name="source">Port to use as the source of the relationship.</param>
            <param name="target">Port to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePort.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePort.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePort.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePort.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePort.SubPortDomainRoleId">
            <summary>
            SubPort domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePort.GetSubClasses(Microsoft.VisualStudio.Modeling.DslDefinition.Port)">
            <summary>
            Gets a list of SubClasses.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePort.BasePortDomainRoleId">
            <summary>
            BasePort domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePort.GetBaseClass(Microsoft.VisualStudio.Modeling.DslDefinition.Port)">
            <summary>
            Gets BaseClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePort.SetBaseClass(Microsoft.VisualStudio.Modeling.DslDefinition.Port,Microsoft.VisualStudio.Modeling.DslDefinition.Port)">
            <summary>
            Sets BaseClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePort.GetLinkToBaseClass(Microsoft.VisualStudio.Modeling.DslDefinition.Port)">
            <summary>
            Get the PortHasBasePort link to a Port.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePort.GetLinksToSubClasses(Microsoft.VisualStudio.Modeling.DslDefinition.Port)">
            <summary>
            Get the list of PortHasBasePort links to a Port.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePort.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.Port,Microsoft.VisualStudio.Modeling.DslDefinition.Port)">
            <summary>
            Get any PortHasBasePort links between a given Port and a Port.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePort.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.Port,Microsoft.VisualStudio.Modeling.DslDefinition.Port)">
            <summary>
            Get the one PortHasBasePort link between a given Portand a Port.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePort.SubPort">
            <summary>
            DomainRole SubPort
            Base port of this port.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePort.SubGeometryShape">
            <summary>
            Gets the element playing SubPort domain role.
            Base geometry shape of this geometry shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePort.BasePort">
            <summary>
            DomainRole BasePort
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePort.BaseGeometryShape">
            <summary>
            Gets the element playing BasePort domain role.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnector">
            <summary>
            DomainRelationship ConnectorHasBaseConnector
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnector.DomainClassId">
            <summary>
            ConnectorHasBaseConnector domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnector.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.Connector,Microsoft.VisualStudio.Modeling.DslDefinition.Connector)">
            <summary>
            Constructor
            Creates a ConnectorHasBaseConnector link in the same Partition as the given Connector
            </summary>
            <param name="source">Connector to use as the source of the relationship.</param>
            <param name="target">Connector to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnector.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnector.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnector.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnector.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnector.SubConnectorDomainRoleId">
            <summary>
            SubConnector domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnector.GetSubClasses(Microsoft.VisualStudio.Modeling.DslDefinition.Connector)">
            <summary>
            Gets a list of SubClasses.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnector.BaseConnectorDomainRoleId">
            <summary>
            BaseConnector domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnector.GetBaseClass(Microsoft.VisualStudio.Modeling.DslDefinition.Connector)">
            <summary>
            Gets BaseClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnector.SetBaseClass(Microsoft.VisualStudio.Modeling.DslDefinition.Connector,Microsoft.VisualStudio.Modeling.DslDefinition.Connector)">
            <summary>
            Sets BaseClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnector.GetLinkToBaseClass(Microsoft.VisualStudio.Modeling.DslDefinition.Connector)">
            <summary>
            Get the ConnectorHasBaseConnector link to a Connector.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnector.GetLinksToSubClasses(Microsoft.VisualStudio.Modeling.DslDefinition.Connector)">
            <summary>
            Get the list of ConnectorHasBaseConnector links to a Connector.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnector.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.Connector,Microsoft.VisualStudio.Modeling.DslDefinition.Connector)">
            <summary>
            Get any ConnectorHasBaseConnector links between a given Connector and a Connector.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnector.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.Connector,Microsoft.VisualStudio.Modeling.DslDefinition.Connector)">
            <summary>
            Get the one ConnectorHasBaseConnector link between a given Connectorand a Connector.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnector.SubConnector">
            <summary>
            DomainRole SubConnector
            Base connector of this connector.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnector.SubClass">
            <summary>
            Gets the element playing SubConnector domain role.
            Base class of this domain class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnector.BaseConnector">
            <summary>
            DomainRole BaseConnector
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnector.BaseClass">
            <summary>
            Gets the element playing BaseConnector domain role.
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.BaseClass
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagram">
            <summary>
            DomainRelationship DiagramHasBaseDiagram
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagram
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagram.DomainClassId">
            <summary>
            DiagramHasBaseDiagram domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagram.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram,Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Constructor
            Creates a DiagramHasBaseDiagram link in the same Partition as the given Diagram
            </summary>
            <param name="source">Diagram to use as the source of the relationship.</param>
            <param name="target">Diagram to use as the target of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagram.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagram.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagram.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagram.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.RoleAssignment[],Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new link is to be created.</param>
            <param name="roleAssignments">List of relationship role assignments.</param>
            <param name="propertyAssignments">List of properties assignments to set on the new link.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagram.SubDiagramDomainRoleId">
            <summary>
            SubDiagram domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagram.GetSubClasses(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Gets a list of SubClasses.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagram.BaseDiagramDomainRoleId">
            <summary>
            BaseDiagram domain role Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagram.GetBaseClass(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Gets BaseClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagram.SetBaseClass(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram,Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Sets BaseClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagram.GetLinkToBaseClass(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Get the DiagramHasBaseDiagram link to a Diagram.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagram.GetLinksToSubClasses(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Get the list of DiagramHasBaseDiagram links to a Diagram.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagram.GetLinks(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram,Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Get any DiagramHasBaseDiagram links between a given Diagram and a Diagram.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagram.GetLink(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram,Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Get the one DiagramHasBaseDiagram link between a given Diagramand a Diagram.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagram.SubDiagram">
            <summary>
            DomainRole SubDiagram
            Base diagram of the diagram.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagram.SubClass">
            <summary>
            Gets the element playing SubDiagram domain role.
            Base class of this domain class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagram.BaseDiagram">
            <summary>
            DomainRole BaseDiagram
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagram.BaseClass">
            <summary>
            Gets the element playing BaseDiagram domain role.
            Description for
            Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClass.BaseClass
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase">
            <summary>
            Partial class to handle serialization of DslLibrary instance as a root-level XML element.
            </summary>
            <summary>
            Serializer DslLibrarySerializerBase for DomainClass DslLibrary.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElementSerializer">
            <summary>
            Serializer NamedDomainElementSerializer for DomainClass NamedDomainElement.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementSerializer">
            <summary>
            Serializer AttributedDomainElementSerializer for DomainClass AttributedDomainElement.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElementSerializer">
            <summary>
            Serializer DomainElementSerializer for DomainClass DomainElement.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElementSerializer.#ctor">
            <summary>
            DomainElementSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElementSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            DomainElement is abstract and cannot be instantiated, so this method throws NotSupportedException.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DomainElement element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainElement instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElementSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainElement instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElementSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainElement instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElementSerializer.ReadPropertiesFromElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as nested XML elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element, but it can be either a property 
            or a child element. 
            This method will read as many properties as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered ("unknown" means it's not a property. It can be either a bogus tag, or
               a child model element). In this case, this method will position the reader at the open tag of the unknown element. This
               implies the if the first child XML element is unknown, this method should return immediately and do nothing.
            2) When all properties are read. In this case, the reader will be positioned at the next tag, which is either the open tag
               of the next sibling (which can be the open tag of a child model element), or the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainElement instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElementSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DomainElement based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DomainElement, a new DomainElement instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DomainElement instance, or null if the reader is not pointing to a serialized DomainElement instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElementSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DomainElement based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DomainElement.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DomainElement instance should be created.</param>	
            <returns>Created DomainElement instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElementSerializer.derivedClasses">
            <summary>
            Stores a mapping from XmlTagName to DomainClassInfo that derives from DomainElement, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElementSerializer.ConstructDerivedClassesLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the apping from XmlTagName to DomainClassInfo that derives from DomainElement.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElementSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DomainElement itself) instance of DomainElement based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElementSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DomainElement based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElementSerializer.derivedClassMonikers">
            <summary>
            Stores a mapping from Moniker Xml tag name to DomainClassInfo that derives from DomainElement, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElementSerializer.ConstructDerivedClassMonikersLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the mapping from Moniker Xml tag name to DomainClassInfo that derives from DomainElement.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElementSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized DomainElement instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainElement instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the DomainElement instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the DomainElement instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElementSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one DomainElement instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainElement instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElementSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainElement instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElementSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainElement instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElementSerializer.WritePropertiesAsElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainElement,System.Xml.XmlWriter)">
            <summary>
            Serialize all properties that need to be stored as nested XML elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainElement instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElementSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given DomainElement instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DomainElement instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the DomainElement instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElementSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DomainElement instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElementSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElementSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainElementSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementSerializer.#ctor">
            <summary>
            AttributedDomainElementSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            AttributedDomainElement is abstract and cannot be instantiated, so this method throws NotSupportedException.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the AttributedDomainElement element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory AttributedDomainElement instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory AttributedDomainElement instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory AttributedDomainElement instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory AttributedDomainElement instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementSerializer.ReadAttributedDomainElementHasAttributesInstances(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement,System.Xml.XmlReader)">
            <summary>
            Reads all instances of relationship AttributedDomainElementHasAttributes.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize all instances and ignore all bogus tags. When the
            method returns, the reader will be positioned at the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory AttributedDomainElement instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of AttributedDomainElement based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized AttributedDomainElement, a new AttributedDomainElement instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created AttributedDomainElement instance, or null if the reader is not pointing to a serialized AttributedDomainElement instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of AttributedDomainElement based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of AttributedDomainElement.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new AttributedDomainElement instance should be created.</param>	
            <returns>Created AttributedDomainElement instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementSerializer.derivedClasses">
            <summary>
            Stores a mapping from XmlTagName to DomainClassInfo that derives from AttributedDomainElement, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementSerializer.ConstructDerivedClassesLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the apping from XmlTagName to DomainClassInfo that derives from AttributedDomainElement.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including AttributedDomainElement itself) instance of AttributedDomainElement based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of AttributedDomainElement based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementSerializer.derivedClassMonikers">
            <summary>
            Stores a mapping from Moniker Xml tag name to DomainClassInfo that derives from AttributedDomainElement, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementSerializer.ConstructDerivedClassMonikersLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the mapping from Moniker Xml tag name to DomainClassInfo that derives from AttributedDomainElement.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized AttributedDomainElement instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">AttributedDomainElement instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the AttributedDomainElement instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the AttributedDomainElement instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one AttributedDomainElement instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">AttributedDomainElement instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">AttributedDomainElement instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">AttributedDomainElement instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElement,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">AttributedDomainElement instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given AttributedDomainElement instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">AttributedDomainElement instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the AttributedDomainElement instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">AttributedDomainElement instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElementSerializer.#ctor">
            <summary>
            NamedDomainElementSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElementSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            NamedDomainElement is abstract and cannot be instantiated, so this method throws NotSupportedException.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the NamedDomainElement element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory NamedDomainElement instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElementSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory NamedDomainElement instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElementSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of NamedDomainElement based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized NamedDomainElement, a new NamedDomainElement instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created NamedDomainElement instance, or null if the reader is not pointing to a serialized NamedDomainElement instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElementSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of NamedDomainElement based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of NamedDomainElement.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new NamedDomainElement instance should be created.</param>	
            <returns>Created NamedDomainElement instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElementSerializer.derivedClasses">
            <summary>
            Stores a mapping from XmlTagName to DomainClassInfo that derives from NamedDomainElement, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElementSerializer.ConstructDerivedClassesLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the apping from XmlTagName to DomainClassInfo that derives from NamedDomainElement.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElementSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including NamedDomainElement itself) instance of NamedDomainElement based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElementSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of NamedDomainElement based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElementSerializer.derivedClassMonikers">
            <summary>
            Stores a mapping from Moniker Xml tag name to DomainClassInfo that derives from NamedDomainElement, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElementSerializer.ConstructDerivedClassMonikersLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the mapping from Moniker Xml tag name to DomainClassInfo that derives from NamedDomainElement.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElementSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized NamedDomainElement instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">NamedDomainElement instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the NamedDomainElement instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the NamedDomainElement instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElementSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one NamedDomainElement instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">NamedDomainElement instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElementSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">NamedDomainElement instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElementSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given NamedDomainElement instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">NamedDomainElement instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the NamedDomainElement instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElementSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">NamedDomainElement instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElementSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElementSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElementSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.ReadRootElement(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ISchemaResolver)">
            <summary>
            Public ReadRootElement() method that deserializes a root-level DslLibrary instance from XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslLibrary instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="schemaResolver">An ISchemaResolver that allows the serializer to do schema validation on the root element (and everything inside it).</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.CheckVersion(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader)">
            <summary>
            Checks the version of the file being read.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">Reader for the file being read. The reader is positioned at the open tag of the root element being read.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.WriteRootElement(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Public WriteRootElement() method that serializes a root-level DslLibrary instance to XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DslLibrary instance that will be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.#ctor">
            <summary>
            DslLibrarySerializerBase Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DslLibrary instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DslLibrary element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslLibrary instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslLibrary instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslLibrary instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory DslLibrary instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.ReadDslLibraryHasClassesInstances(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,System.Xml.XmlReader)">
            <summary>
            Reads all instances of relationship DslLibraryHasClasses.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize all instances and ignore all bogus tags. When the
            method returns, the reader will be positioned at the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslLibrary instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.ReadDslLibraryHasRelationshipsInstances(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,System.Xml.XmlReader)">
            <summary>
            Reads all instances of relationship DslLibraryHasRelationships.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize all instances and ignore all bogus tags. When the
            method returns, the reader will be positioned at the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslLibrary instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.ReadDslLibraryHasTypesInstances(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,System.Xml.XmlReader)">
            <summary>
            Reads all instances of relationship DslLibraryHasTypes.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize all instances and ignore all bogus tags. When the
            method returns, the reader will be positioned at the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslLibrary instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.ReadDslLibraryDefinesShapesInstances(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,System.Xml.XmlReader)">
            <summary>
            Reads all instances of relationship DslLibraryDefinesShapes.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize all instances and ignore all bogus tags. When the
            method returns, the reader will be positioned at the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslLibrary instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.ReadDslLibraryDefinesConnectorsInstances(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,System.Xml.XmlReader)">
            <summary>
            Reads all instances of relationship DslLibraryDefinesConnectors.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize all instances and ignore all bogus tags. When the
            method returns, the reader will be positioned at the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslLibrary instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.ReadDslLibraryHasConnectionBuildersInstances(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,System.Xml.XmlReader)">
            <summary>
            Reads all instances of relationship DslLibraryHasConnectionBuilders.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize all instances and ignore all bogus tags. When the
            method returns, the reader will be positioned at the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslLibrary instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DslLibrary based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DslLibrary, a new DslLibrary instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DslLibrary instance, or null if the reader is not pointing to a serialized DslLibrary instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DslLibrary based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DslLibrary.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DslLibrary instance should be created.</param>	
            <returns>Created DslLibrary instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.derivedClasses">
            <summary>
            Stores a mapping from XmlTagName to DomainClassInfo that derives from DslLibrary, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.ConstructDerivedClassesLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the apping from XmlTagName to DomainClassInfo that derives from DslLibrary.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DslLibrary itself) instance of DslLibrary based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DslLibrary based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.derivedClassMonikers">
            <summary>
            Stores a mapping from Moniker Xml tag name to DomainClassInfo that derives from DslLibrary, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.ConstructDerivedClassMonikersLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the mapping from Moniker Xml tag name to DomainClassInfo that derives from DslLibrary.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized DslLibrary instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DslLibrary instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the DslLibrary instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the DslLibrary instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one DslLibrary instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DslLibrary instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DslLibrary instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DslLibrary instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DslLibrary instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given DslLibrary instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DslLibrary instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the DslLibrary instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DslLibrary instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DslLibrary.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of DslLibrary.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of DslLibrary in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.DslDefinitionModelSerializationBehaviorSchemaValidationCallback">
            <summary>
            A utility class to handle schema validation warning/error
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.DslDefinitionModelSerializationBehaviorSchemaValidationCallback.serializationContext">
            <summary>
            SerializationContext to store schema validation warning/error.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.DslDefinitionModelSerializationBehaviorSchemaValidationCallback.reader">
            <summary>
            Reader that generates the schema warning/error.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.DslDefinitionModelSerializationBehaviorSchemaValidationCallback.#ctor(Microsoft.VisualStudio.Modeling.SerializationContext)">
            <summary>
            Constructor
            </summary>
            <param name="serializationContext">SerializationContext to be used to store schema validation warning/error.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.DslDefinitionModelSerializationBehaviorSchemaValidationCallback.Handler(System.Object,System.Xml.Schema.ValidationEventArgs)">
            <summary>
            Callback to handler schema validation warning/error.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializerBase.DslDefinitionModelSerializationBehaviorSchemaValidationCallback.Reader">
            <summary>
            Sets the reader that generates the schema validation warning/error.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializerBase">
            <summary>
            Partial class to handle serialization of DslDesignerDiagram instance as a root-level XML element.
            </summary>
            <summary>
            Serializer DslDesignerDiagramSerializerBase for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializerBase.ReadRootElement(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ISchemaResolver)">
            <summary>
            Public ReadRootElement() method that deserializes a root-level DslDesignerDiagram instance from XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslDesignerDiagram instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="schemaResolver">An ISchemaResolver that allows the serializer to do schema validation on the root element (and everything inside it).</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializerBase.CheckVersion(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader)">
            <summary>
            Checks the version of the file being read.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">Reader for the file being read. The reader is positioned at the open tag of the root element being read.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializerBase.WriteRootElement(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Public WriteRootElement() method that serializes a root-level DslDesignerDiagram instance to XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DslDesignerDiagram instance that will be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializerBase.#ctor">
            <summary>
            DslDesignerDiagramSerializerBase Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializerBase.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DslDesignerDiagram instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DslDesignerDiagram element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslDesignerDiagram instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializerBase.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslDesignerDiagram instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializerBase.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslDesignerDiagram instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializerBase.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory DslDesignerDiagram instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializerBase.ReadDslDesignerDiagramHasDiagramStateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram,System.Xml.XmlReader)">
            <summary>
            Reads instance of relationship DslDesignerDiagramHasDiagramState.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize only the first valid instance and ignore all the
            rest tags (because the multiplicity allows only one instance). When the method returns, the reader will be positioned at 
            the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslDesignerDiagram instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializerBase.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DslDesignerDiagram based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DslDesignerDiagram, a new DslDesignerDiagram instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DslDesignerDiagram instance, or null if the reader is not pointing to a serialized DslDesignerDiagram instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializerBase.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DslDesignerDiagram based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DslDesignerDiagram.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DslDesignerDiagram instance should be created.</param>	
            <returns>Created DslDesignerDiagram instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializerBase.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DslDesignerDiagram itself) instance of DslDesignerDiagram based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializerBase.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DslDesignerDiagram based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializerBase.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized DslDesignerDiagram instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DslDesignerDiagram instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the DslDesignerDiagram instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the DslDesignerDiagram instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializerBase.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one DslDesignerDiagram instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DslDesignerDiagram instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializerBase.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DslDesignerDiagram instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializerBase.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DslDesignerDiagram instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializerBase.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DslDesignerDiagram instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializerBase.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given DslDesignerDiagram instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DslDesignerDiagram instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the DslDesignerDiagram instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializerBase.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DslDesignerDiagram instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializerBase.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DslDesignerDiagram.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializerBase.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializerBase.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializerBase.DslDefinitionModelSerializationBehaviorSchemaValidationCallback">
            <summary>
            A utility class to handle schema validation warning/error
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializerBase.DslDefinitionModelSerializationBehaviorSchemaValidationCallback.serializationContext">
            <summary>
            SerializationContext to store schema validation warning/error.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializerBase.DslDefinitionModelSerializationBehaviorSchemaValidationCallback.reader">
            <summary>
            Reader that generates the schema warning/error.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializerBase.DslDefinitionModelSerializationBehaviorSchemaValidationCallback.#ctor(Microsoft.VisualStudio.Modeling.SerializationContext)">
            <summary>
            Constructor
            </summary>
            <param name="serializationContext">SerializationContext to be used to store schema validation warning/error.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializerBase.DslDefinitionModelSerializationBehaviorSchemaValidationCallback.Handler(System.Object,System.Xml.Schema.ValidationEventArgs)">
            <summary>
            Callback to handler schema validation warning/error.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializerBase.DslDefinitionModelSerializationBehaviorSchemaValidationCallback.Reader">
            <summary>
            Sets the reader that generates the schema validation warning/error.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelper">
            <summary>
            Helper class for serializing and deserializing DslDefinitionModel models.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelper.#ctor">
            <summary>
            Private constructor to prevent direct instantiation.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelper.instance">
            <summary>
            Singleton instance.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelper.CreateModelHelper(Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            For DslDesigner, we want to create a Dsl instead of a DslLibrary if the model file is empty.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelper.CreateDiagramHelper(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Override base implementation to initialize DiagramState.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationHelper.Instance">
            <summary>
            Singleton instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializer">
            <summary>
            Serializer DslLibrarySerializer for DomainClass DslLibrary.
            </summary>
            <summary>
            Partial class to handle serialization of DslLibrary instance as a root-level XML element.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializer.#ctor">
            <summary>
            DslLibrarySerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrarySerializer.CheckVersion(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader)">
            <summary>
            Checks version of the DSL file being read.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassSerializer">
            <summary>
            Serializer DomainClassSerializer for DomainClass DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassSerializer.#ctor">
            <summary>
            DomainClassSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DomainClass instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DomainClass element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainClass instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainClass instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainClass instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory DomainClass instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassSerializer.ReadDomainClassHasCustomTypeDescriptorInstance(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,System.Xml.XmlReader)">
            <summary>
            Reads instance of relationship DomainClassHasCustomTypeDescriptor.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize only the first valid instance and ignore all the
            rest tags (because the multiplicity allows only one instance). When the method returns, the reader will be positioned at 
            the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainClass instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassSerializer.ReadClassHasPropertiesInstances(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,System.Xml.XmlReader)">
            <summary>
            Reads all instances of relationship ClassHasProperties.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize all instances and ignore all bogus tags. When the
            method returns, the reader will be positioned at the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainClass instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassSerializer.ReadClassHasElementMergeDirectivesInstances(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,System.Xml.XmlReader)">
            <summary>
            Reads all instances of relationship ClassHasElementMergeDirectives.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize all instances and ignore all bogus tags. When the
            method returns, the reader will be positioned at the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainClass instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DomainClass based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DomainClass, a new DomainClass instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DomainClass instance, or null if the reader is not pointing to a serialized DomainClass instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DomainClass based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DomainClass.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DomainClass instance should be created.</param>	
            <returns>Created DomainClass instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassSerializer.derivedClasses">
            <summary>
            Stores a mapping from XmlTagName to DomainClassInfo that derives from DomainClass, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassSerializer.ConstructDerivedClassesLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the apping from XmlTagName to DomainClassInfo that derives from DomainClass.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DomainClass itself) instance of DomainClass based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DomainClass based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassSerializer.derivedClassMonikers">
            <summary>
            Stores a mapping from Moniker Xml tag name to DomainClassInfo that derives from DomainClass, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassSerializer.ConstructDerivedClassMonikersLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the mapping from Moniker Xml tag name to DomainClassInfo that derives from DomainClass.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized DomainClass instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainClass instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the DomainClass instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the DomainClass instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one DomainClass instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainClass instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainClass instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainClass instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainClass instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given DomainClass instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DomainClass instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the DomainClass instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DomainClass instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DomainClass.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of DomainClass.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of DomainClass in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationshipSerializer">
            <summary>
            Serializer DomainRelationshipSerializer for DomainClass DomainRelationship.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationshipSerializer.#ctor">
            <summary>
            DomainRelationshipSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationshipSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DomainRelationship instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DomainRelationship element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainRelationship instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationshipSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainRelationship instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationshipSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainRelationship instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationshipSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory DomainRelationship instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationshipSerializer.ReadRelationshipHasSourceInstance(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship,System.Xml.XmlReader)">
            <summary>
            Reads instance of relationship RelationshipHasSource.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize only the first valid instance and ignore all the
            rest tags (because the multiplicity allows only one instance). When the method returns, the reader will be positioned at 
            the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainRelationship instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationshipSerializer.ReadRelationshipHasTargetInstance(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship,System.Xml.XmlReader)">
            <summary>
            Reads instance of relationship RelationshipHasTarget.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize only the first valid instance and ignore all the
            rest tags (because the multiplicity allows only one instance). When the method returns, the reader will be positioned at 
            the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainRelationship instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationshipSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DomainRelationship based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DomainRelationship, a new DomainRelationship instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DomainRelationship instance, or null if the reader is not pointing to a serialized DomainRelationship instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationshipSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DomainRelationship based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DomainRelationship.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DomainRelationship instance should be created.</param>	
            <returns>Created DomainRelationship instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationshipSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DomainRelationship itself) instance of DomainRelationship based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationshipSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DomainRelationship based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationshipSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized DomainRelationship instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainRelationship instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the DomainRelationship instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the DomainRelationship instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationshipSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one DomainRelationship instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainRelationship instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationshipSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainRelationship instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationshipSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainRelationship instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationshipSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainRelationship instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationshipSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given DomainRelationship instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DomainRelationship instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the DomainRelationship instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationshipSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DomainRelationship instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationshipSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DomainRelationship.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationshipSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of DomainRelationship.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationshipSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of DomainRelationship in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleSerializer">
            <summary>
            Serializer DomainRoleSerializer for DomainClass DomainRole.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleSerializer.#ctor">
            <summary>
            DomainRoleSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DomainRole instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DomainRole element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainRole instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainRole instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainRole instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory DomainRole instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleSerializer.ReadRoleHasRolePlayerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,System.Xml.XmlReader)">
            <summary>
            Reads instance of relationship RoleHasRolePlayer.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize only the first valid instance and ignore all the
            rest tags (because the multiplicity allows only one instance). When the method returns, the reader will be positioned at 
            the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainRole instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleSerializer.ReadDomainRoleImplementedByCollectionTypeInstance(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,System.Xml.XmlReader)">
            <summary>
            Reads instance of relationship DomainRoleImplementedByCollectionType.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize only the first valid instance and ignore all the
            rest tags (because the multiplicity allows only one instance). When the method returns, the reader will be positioned at 
            the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainRole instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DomainRole based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DomainRole, a new DomainRole instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DomainRole instance, or null if the reader is not pointing to a serialized DomainRole instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DomainRole based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DomainRole.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DomainRole instance should be created.</param>	
            <returns>Created DomainRole instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DomainRole itself) instance of DomainRole based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DomainRole based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized DomainRole instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainRole instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the DomainRole instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the DomainRole instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one DomainRole instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainRole instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainRole instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainRole instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainRole instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given DomainRole instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DomainRole instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the DomainRole instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DomainRole instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DomainRole.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of DomainRole.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of DomainRole in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertySerializer">
            <summary>
            Serializer DomainPropertySerializer for DomainClass DomainProperty.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertySerializer.#ctor">
            <summary>
            DomainPropertySerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertySerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DomainProperty instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DomainProperty element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainProperty instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertySerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainProperty instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertySerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainProperty instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertySerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory DomainProperty instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertySerializer.ReadPropertyHasTypeInstance(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty,System.Xml.XmlReader)">
            <summary>
            Reads instance of relationship PropertyHasType.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize only the first valid instance and ignore all the
            rest tags (because the multiplicity allows only one instance). When the method returns, the reader will be positioned at 
            the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainProperty instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertySerializer.ReadDomainPropertyHasElementNameProviderInstance(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty,System.Xml.XmlReader)">
            <summary>
            Reads instance of relationship DomainPropertyHasElementNameProvider.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize only the first valid instance and ignore all the
            rest tags (because the multiplicity allows only one instance). When the method returns, the reader will be positioned at 
            the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainProperty instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertySerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DomainProperty based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DomainProperty, a new DomainProperty instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DomainProperty instance, or null if the reader is not pointing to a serialized DomainProperty instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertySerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DomainProperty based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DomainProperty.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DomainProperty instance should be created.</param>	
            <returns>Created DomainProperty instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertySerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DomainProperty itself) instance of DomainProperty based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertySerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DomainProperty based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertySerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized DomainProperty instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainProperty instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the DomainProperty instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the DomainProperty instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertySerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one DomainProperty instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainProperty instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertySerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainProperty instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertySerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainProperty instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertySerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainProperty instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertySerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given DomainProperty instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DomainProperty instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the DomainProperty instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertySerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DomainProperty instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertySerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DomainProperty.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertySerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of DomainProperty.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertySerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of DomainProperty in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeSerializer">
            <summary>
            Serializer DomainTypeSerializer for DomainClass DomainType.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeSerializer.#ctor">
            <summary>
            DomainTypeSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            DomainType is abstract and cannot be instantiated, so this method throws NotSupportedException.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DomainType element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainType instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainType instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DomainType based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DomainType, a new DomainType instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DomainType instance, or null if the reader is not pointing to a serialized DomainType instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DomainType based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DomainType.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DomainType instance should be created.</param>	
            <returns>Created DomainType instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeSerializer.derivedClasses">
            <summary>
            Stores a mapping from XmlTagName to DomainClassInfo that derives from DomainType, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeSerializer.ConstructDerivedClassesLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the apping from XmlTagName to DomainClassInfo that derives from DomainType.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DomainType itself) instance of DomainType based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DomainType based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeSerializer.derivedClassMonikers">
            <summary>
            Stores a mapping from Moniker Xml tag name to DomainClassInfo that derives from DomainType, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeSerializer.ConstructDerivedClassMonikersLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the mapping from Moniker Xml tag name to DomainClassInfo that derives from DomainType.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized DomainType instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainType instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the DomainType instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the DomainType instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one DomainType instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainType instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainType instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given DomainType instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DomainType instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the DomainType instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DomainType instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumerationSerializer">
            <summary>
            Serializer DomainEnumerationSerializer for DomainClass DomainEnumeration.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumerationSerializer.#ctor">
            <summary>
            DomainEnumerationSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumerationSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DomainEnumeration instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DomainEnumeration element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainEnumeration instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumerationSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainEnumeration instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumerationSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainEnumeration instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumerationSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory DomainEnumeration instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumerationSerializer.ReadEnumerationHasLiteralsInstances(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration,System.Xml.XmlReader)">
            <summary>
            Reads all instances of relationship EnumerationHasLiterals.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize all instances and ignore all bogus tags. When the
            method returns, the reader will be positioned at the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainEnumeration instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumerationSerializer.ReadEnumerationHasAttributesInstances(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration,System.Xml.XmlReader)">
            <summary>
            Reads all instances of relationship EnumerationHasAttributes.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize all instances and ignore all bogus tags. When the
            method returns, the reader will be positioned at the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainEnumeration instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumerationSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DomainEnumeration based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DomainEnumeration, a new DomainEnumeration instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DomainEnumeration instance, or null if the reader is not pointing to a serialized DomainEnumeration instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumerationSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DomainEnumeration based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DomainEnumeration.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DomainEnumeration instance should be created.</param>	
            <returns>Created DomainEnumeration instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumerationSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DomainEnumeration itself) instance of DomainEnumeration based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumerationSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DomainEnumeration based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumerationSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized DomainEnumeration instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainEnumeration instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the DomainEnumeration instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the DomainEnumeration instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumerationSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one DomainEnumeration instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainEnumeration instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumerationSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainEnumeration instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumerationSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainEnumeration instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumerationSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainEnumeration instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumerationSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given DomainEnumeration instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DomainEnumeration instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the DomainEnumeration instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumerationSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DomainEnumeration instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumerationSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DomainEnumeration.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumerationSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of DomainEnumeration.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumerationSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of DomainEnumeration in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteralSerializer">
            <summary>
            Serializer EnumerationLiteralSerializer for DomainClass EnumerationLiteral.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteralSerializer.#ctor">
            <summary>
            EnumerationLiteralSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteralSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one EnumerationLiteral instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the EnumerationLiteral element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory EnumerationLiteral instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteralSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory EnumerationLiteral instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteralSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of EnumerationLiteral based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized EnumerationLiteral, a new EnumerationLiteral instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created EnumerationLiteral instance, or null if the reader is not pointing to a serialized EnumerationLiteral instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteralSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of EnumerationLiteral based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of EnumerationLiteral.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new EnumerationLiteral instance should be created.</param>	
            <returns>Created EnumerationLiteral instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteralSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including EnumerationLiteral itself) instance of EnumerationLiteral based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteralSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of EnumerationLiteral based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteralSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized EnumerationLiteral instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">EnumerationLiteral instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the EnumerationLiteral instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the EnumerationLiteral instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteralSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one EnumerationLiteral instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">EnumerationLiteral instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteralSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">EnumerationLiteral instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteralSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given EnumerationLiteral instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">EnumerationLiteral instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the EnumerationLiteral instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteralSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">EnumerationLiteral instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteralSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of EnumerationLiteral.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteralSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of EnumerationLiteral.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationLiteralSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of EnumerationLiteral in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ExternalTypeSerializer">
            <summary>
            Serializer ExternalTypeSerializer for DomainClass ExternalType.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExternalTypeSerializer.#ctor">
            <summary>
            ExternalTypeSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExternalTypeSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one ExternalType instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ExternalType element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ExternalType instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExternalTypeSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ExternalType based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ExternalType, a new ExternalType instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ExternalType instance, or null if the reader is not pointing to a serialized ExternalType instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExternalTypeSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ExternalType based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ExternalType.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ExternalType instance should be created.</param>	
            <returns>Created ExternalType instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExternalTypeSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ExternalType itself) instance of ExternalType based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExternalTypeSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ExternalType based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExternalTypeSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized ExternalType instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ExternalType instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the ExternalType instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the ExternalType instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExternalTypeSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one ExternalType instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ExternalType instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExternalTypeSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given ExternalType instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ExternalType instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the ExternalType instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExternalTypeSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ExternalType instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExternalTypeSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of ExternalType.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExternalTypeSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of ExternalType.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExternalTypeSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of ExternalType in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttributeSerializer">
            <summary>
            Serializer ClrAttributeSerializer for DomainClass ClrAttribute.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttributeSerializer.#ctor">
            <summary>
            ClrAttributeSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttributeSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one ClrAttribute instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ClrAttribute element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ClrAttribute instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttributeSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ClrAttribute instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttributeSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ClrAttribute instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttributeSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory ClrAttribute instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttributeSerializer.ReadAttributeHasParametersInstances(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute,System.Xml.XmlReader)">
            <summary>
            Reads all instances of relationship AttributeHasParameters.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize all instances and ignore all bogus tags. When the
            method returns, the reader will be positioned at the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ClrAttribute instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttributeSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ClrAttribute based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ClrAttribute, a new ClrAttribute instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ClrAttribute instance, or null if the reader is not pointing to a serialized ClrAttribute instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttributeSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ClrAttribute based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ClrAttribute.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ClrAttribute instance should be created.</param>	
            <returns>Created ClrAttribute instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttributeSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ClrAttribute itself) instance of ClrAttribute based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttributeSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ClrAttribute based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttributeSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized ClrAttribute instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ClrAttribute instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the ClrAttribute instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the ClrAttribute instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttributeSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one ClrAttribute instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ClrAttribute instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttributeSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ClrAttribute instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttributeSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ClrAttribute instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttributeSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ClrAttribute instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttributeSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given ClrAttribute instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ClrAttribute instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the ClrAttribute instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttributeSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ClrAttribute instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttributeSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of ClrAttribute.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttributeSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttributeSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameterSerializer">
            <summary>
            Serializer AttributeParameterSerializer for DomainClass AttributeParameter.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameterSerializer.#ctor">
            <summary>
            AttributeParameterSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameterSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one AttributeParameter instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the AttributeParameter element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory AttributeParameter instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameterSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory AttributeParameter instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameterSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of AttributeParameter based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized AttributeParameter, a new AttributeParameter instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created AttributeParameter instance, or null if the reader is not pointing to a serialized AttributeParameter instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameterSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of AttributeParameter based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of AttributeParameter.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new AttributeParameter instance should be created.</param>	
            <returns>Created AttributeParameter instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameterSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including AttributeParameter itself) instance of AttributeParameter based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameterSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of AttributeParameter based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameterSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized AttributeParameter instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">AttributeParameter instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the AttributeParameter instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the AttributeParameter instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameterSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one AttributeParameter instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">AttributeParameter instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameterSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">AttributeParameter instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameterSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given AttributeParameter instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">AttributeParameter instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the AttributeParameter instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameterSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">AttributeParameter instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameterSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of AttributeParameter.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameterSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeParameterSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveSerializer">
            <summary>
            Serializer LinkConnectDirectiveSerializer for DomainClass LinkConnectDirective.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveSerializer.#ctor">
            <summary>
            LinkConnectDirectiveSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one LinkConnectDirective instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the LinkConnectDirective element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory LinkConnectDirective instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory LinkConnectDirective instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory LinkConnectDirective instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory LinkConnectDirective instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveSerializer.ReadLinkConnectDirectiveHasSourceDirectivesInstances(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective,System.Xml.XmlReader)">
            <summary>
            Reads all instances of relationship LinkConnectDirectiveHasSourceDirectives.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize all instances and ignore all bogus tags. When the
            method returns, the reader will be positioned at the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory LinkConnectDirective instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveSerializer.ReadLinkConnectDirectiveHasTargetDirectivesInstances(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective,System.Xml.XmlReader)">
            <summary>
            Reads all instances of relationship LinkConnectDirectiveHasTargetDirectives.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize all instances and ignore all bogus tags. When the
            method returns, the reader will be positioned at the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory LinkConnectDirective instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of LinkConnectDirective based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized LinkConnectDirective, a new LinkConnectDirective instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created LinkConnectDirective instance, or null if the reader is not pointing to a serialized LinkConnectDirective instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of LinkConnectDirective based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of LinkConnectDirective.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new LinkConnectDirective instance should be created.</param>	
            <returns>Created LinkConnectDirective instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including LinkConnectDirective itself) instance of LinkConnectDirective based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of LinkConnectDirective based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized LinkConnectDirective instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">LinkConnectDirective instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the LinkConnectDirective instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the LinkConnectDirective instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one LinkConnectDirective instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">LinkConnectDirective instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">LinkConnectDirective instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">LinkConnectDirective instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirective,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">LinkConnectDirective instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given LinkConnectDirective instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">LinkConnectDirective instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the LinkConnectDirective instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">LinkConnectDirective instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of LinkConnectDirective.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveSerializer">
            <summary>
            Serializer RolePlayerConnectDirectiveSerializer for DomainClass RolePlayerConnectDirective.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveSerializer.#ctor">
            <summary>
            RolePlayerConnectDirectiveSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one RolePlayerConnectDirective instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the RolePlayerConnectDirective element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory RolePlayerConnectDirective instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory RolePlayerConnectDirective instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory RolePlayerConnectDirective instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory RolePlayerConnectDirective instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveSerializer.ReadRolePlayerConnectDirectiveAcceptsClassInstance(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective,System.Xml.XmlReader)">
            <summary>
            Reads instance of relationship RolePlayerConnectDirectiveAcceptsClass.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize only the first valid instance and ignore all the
            rest tags (because the multiplicity allows only one instance). When the method returns, the reader will be positioned at 
            the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory RolePlayerConnectDirective instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveSerializer.ReadRolePlayerConnectDirectiveHasPathToRolePlayerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective,System.Xml.XmlReader)">
            <summary>
            Reads instance of relationship RolePlayerConnectDirectiveHasPathToRolePlayer.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize only the first valid instance and ignore all the
            rest tags (because the multiplicity allows only one instance). When the method returns, the reader will be positioned at 
            the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory RolePlayerConnectDirective instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of RolePlayerConnectDirective based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized RolePlayerConnectDirective, a new RolePlayerConnectDirective instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created RolePlayerConnectDirective instance, or null if the reader is not pointing to a serialized RolePlayerConnectDirective instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of RolePlayerConnectDirective based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of RolePlayerConnectDirective.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new RolePlayerConnectDirective instance should be created.</param>	
            <returns>Created RolePlayerConnectDirective instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including RolePlayerConnectDirective itself) instance of RolePlayerConnectDirective based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of RolePlayerConnectDirective based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized RolePlayerConnectDirective instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">RolePlayerConnectDirective instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the RolePlayerConnectDirective instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the RolePlayerConnectDirective instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one RolePlayerConnectDirective instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">RolePlayerConnectDirective instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">RolePlayerConnectDirective instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">RolePlayerConnectDirective instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirective,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">RolePlayerConnectDirective instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given RolePlayerConnectDirective instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">RolePlayerConnectDirective instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the RolePlayerConnectDirective instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">RolePlayerConnectDirective instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of RolePlayerConnectDirective.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderSerializer">
            <summary>
            Serializer ConnectionBuilderSerializer for DomainClass ConnectionBuilder.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderSerializer.#ctor">
            <summary>
            ConnectionBuilderSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one ConnectionBuilder instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ConnectionBuilder element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ConnectionBuilder instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ConnectionBuilder instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ConnectionBuilder instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory ConnectionBuilder instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ConnectionBuilder based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ConnectionBuilder, a new ConnectionBuilder instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ConnectionBuilder instance, or null if the reader is not pointing to a serialized ConnectionBuilder instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ConnectionBuilder based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ConnectionBuilder.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ConnectionBuilder instance should be created.</param>	
            <returns>Created ConnectionBuilder instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ConnectionBuilder itself) instance of ConnectionBuilder based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ConnectionBuilder based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized ConnectionBuilder instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ConnectionBuilder instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the ConnectionBuilder instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the ConnectionBuilder instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one ConnectionBuilder instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ConnectionBuilder instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ConnectionBuilder instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ConnectionBuilder instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilder,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ConnectionBuilder instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given ConnectionBuilder instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ConnectionBuilder instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the ConnectionBuilder instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ConnectionBuilder instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of ConnectionBuilder.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of ConnectionBuilder.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of ConnectionBuilder in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveSerializer">
            <summary>
            Serializer ElementMergeDirectiveSerializer for DomainClass ElementMergeDirective.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveSerializer.#ctor">
            <summary>
            ElementMergeDirectiveSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one ElementMergeDirective instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ElementMergeDirective element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ElementMergeDirective instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ElementMergeDirective instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ElementMergeDirective instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory ElementMergeDirective instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveSerializer.ReadClassIndexesElementMergeDirectiveInstance(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective,System.Xml.XmlReader)">
            <summary>
            Reads instance of relationship ClassIndexesElementMergeDirective.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize only the first valid instance and ignore all the
            rest tags (because the multiplicity allows only one instance). When the method returns, the reader will be positioned at 
            the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ElementMergeDirective instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveSerializer.ReadElementMergeDirectiveHasLinkCreationPathsInstances(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective,System.Xml.XmlReader)">
            <summary>
            Reads all instances of relationship ElementMergeDirectiveHasLinkCreationPaths.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize all instances and ignore all bogus tags. When the
            method returns, the reader will be positioned at the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ElementMergeDirective instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveSerializer.ReadElementMergeDirectiveHasForwardingPathInstance(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective,System.Xml.XmlReader)">
            <summary>
            Reads instance of relationship ElementMergeDirectiveHasForwardingPath.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize only the first valid instance and ignore all the
            rest tags (because the multiplicity allows only one instance). When the method returns, the reader will be positioned at 
            the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ElementMergeDirective instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ElementMergeDirective based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ElementMergeDirective, a new ElementMergeDirective instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ElementMergeDirective instance, or null if the reader is not pointing to a serialized ElementMergeDirective instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ElementMergeDirective based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ElementMergeDirective.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ElementMergeDirective instance should be created.</param>	
            <returns>Created ElementMergeDirective instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ElementMergeDirective itself) instance of ElementMergeDirective based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ElementMergeDirective based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized ElementMergeDirective instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ElementMergeDirective instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the ElementMergeDirective instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the ElementMergeDirective instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one ElementMergeDirective instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ElementMergeDirective instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ElementMergeDirective instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ElementMergeDirective instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirective,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ElementMergeDirective instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given ElementMergeDirective instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ElementMergeDirective instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the ElementMergeDirective instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ElementMergeDirective instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of ElementMergeDirective.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer">
            <summary>
            Serializer DomainPathSerializer for DomainClass DomainPath.
            </summary>
            <summary>
            Custom serialization support for DomainPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.#ctor">
            <summary>
            DomainPathSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.DefaultConstructor">
            <summary>
            Default implementation of constructor, which does nothing.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DomainPath instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DomainPath element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainPath instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.DefaultRead(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Default implementation of Read().
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainPath instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.DefaultReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Default implementation of ReadElements().
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory DomainPath instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.ReadPathHasSegmentsInstances(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath,System.Xml.XmlReader)">
            <summary>
            Reads all instances of relationship PathHasSegments.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize all instances and ignore all bogus tags. When the
            method returns, the reader will be positioned at the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainPath instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DomainPath based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DomainPath, a new DomainPath instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DomainPath instance, or null if the reader is not pointing to a serialized DomainPath instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.DefaultTryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Default implementation of TryCreateInstance().
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DomainPath based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DomainPath.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DomainPath instance should be created.</param>	
            <returns>Created DomainPath instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.DefaultCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Default implementation of CreateInstance().
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DomainPath itself) instance of DomainPath based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.DefaultTryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Default implementation of TryCreateMonikerInstance().
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DomainPath based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.DefaultCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Default implementation of CreateMonikerInstance().
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized DomainPath instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainPath instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the DomainPath instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the DomainPath instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one DomainPath instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainPath instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.DefaultWrite(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Default implementation of Write().
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainPath instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.DefaultWriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Default implementation of WriteElements().
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainPath instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given DomainPath instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DomainPath instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the DomainPath instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.DefaultCalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Default implementation of CalculateQualifiedName().
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DomainPath instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.DefaultGetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Default implementation of GetMonikerQualifier().
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.CustomConstructor">
            <summary>
             Customized initialization method called during construction.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.CustomRead(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            CustomRead() method that deserializes one Path instance from XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Path instance to get the read content.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.CustomReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            DomainPath element doesn't contain nested child elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainPath instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>      
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.CustomTryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DomainPath based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.CustomCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DomainPath based on the tag currently pointed by the reader.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DomainPath instance should be created.</param>	
            <returns>Created DomainPath instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.CustomTryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            DomainPath cannot be monikerized.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.CustomCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            DomainPath cannot be monikerized.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.CustomWrite(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one DomainPath instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Path instance to be written.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.CustomWriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            DomainPath element doesn't contain nested child elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainPath instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.CustomCalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a reference to the DomainPath
            </summary>
            <returns>A fully qualified string reference to the DomainPath</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.CustomGetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            GetMonikerQualifier returns the long form reference to a model element. The long form reference consists of 
            /Qualifier/short form reference. This method calculates the Qualifier, if it exists.
            </summary>
            <returns>Value of this element's moniker qualifier property, if it has one, or the value of the 
            container's moniker qualifier property.</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DomainPath.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.DefaultXmlTagName">
            <summary>
            Default implementation of XmlTagName.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPathSerializer.CustomXmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DomainPath.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentSerializer">
            <summary>
            Serializer PathSegmentSerializer for DomainClass PathSegment.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentSerializer.#ctor">
            <summary>
            PathSegmentSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one PathSegment instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the PathSegment element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory PathSegment instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory PathSegment instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory PathSegment instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory PathSegment instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of PathSegment based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized PathSegment, a new PathSegment instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created PathSegment instance, or null if the reader is not pointing to a serialized PathSegment instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of PathSegment based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of PathSegment.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new PathSegment instance should be created.</param>	
            <returns>Created PathSegment instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including PathSegment itself) instance of PathSegment based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of PathSegment based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized PathSegment instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">PathSegment instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the PathSegment instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the PathSegment instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one PathSegment instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">PathSegment instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">PathSegment instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">PathSegment instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">PathSegment instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given PathSegment instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">PathSegment instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the PathSegment instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">PathSegment instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of PathSegment.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.EditorSerializer">
            <summary>
            Serializer EditorSerializer for DomainClass Editor.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorSerializer.#ctor">
            <summary>
            EditorSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Editor is abstract and cannot be instantiated, so this method throws NotSupportedException.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the Editor element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Editor instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Editor instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Editor instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.Editor,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory Editor instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorSerializer.ReadDslEditorIdentifiesRootClassInstance(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.Editor,System.Xml.XmlReader)">
            <summary>
            Reads instance of relationship DslEditorIdentifiesRootClass.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize only the first valid instance and ignore all the
            rest tags (because the multiplicity allows only one instance). When the method returns, the reader will be positioned at 
            the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Editor instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of Editor based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized Editor, a new Editor instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created Editor instance, or null if the reader is not pointing to a serialized Editor instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of Editor based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of Editor.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new Editor instance should be created.</param>	
            <returns>Created Editor instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.EditorSerializer.derivedClasses">
            <summary>
            Stores a mapping from XmlTagName to DomainClassInfo that derives from Editor, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorSerializer.ConstructDerivedClassesLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the apping from XmlTagName to DomainClassInfo that derives from Editor.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including Editor itself) instance of Editor based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of Editor based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.EditorSerializer.derivedClassMonikers">
            <summary>
            Stores a mapping from Moniker Xml tag name to DomainClassInfo that derives from Editor, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorSerializer.ConstructDerivedClassMonikersLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the mapping from Moniker Xml tag name to DomainClassInfo that derives from Editor.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized Editor instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Editor instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the Editor instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the Editor instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one Editor instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Editor instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Editor instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Editor instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.Editor,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Editor instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given Editor instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">Editor instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the Editor instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EditorSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">Editor instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.EditorSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.EditorSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.EditorSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CustomEditorSerializer">
            <summary>
            Serializer CustomEditorSerializer for DomainClass CustomEditor.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomEditorSerializer.#ctor">
            <summary>
            CustomEditorSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomEditorSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one CustomEditor instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the CustomEditor element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory CustomEditor instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomEditorSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of CustomEditor based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized CustomEditor, a new CustomEditor instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created CustomEditor instance, or null if the reader is not pointing to a serialized CustomEditor instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomEditorSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of CustomEditor based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of CustomEditor.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new CustomEditor instance should be created.</param>	
            <returns>Created CustomEditor instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomEditorSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including CustomEditor itself) instance of CustomEditor based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomEditorSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of CustomEditor based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomEditorSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized CustomEditor instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">CustomEditor instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the CustomEditor instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the CustomEditor instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomEditorSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one CustomEditor instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">CustomEditor instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomEditorSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given CustomEditor instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">CustomEditor instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the CustomEditor instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomEditorSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">CustomEditor instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CustomEditorSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of CustomEditor.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CustomEditorSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CustomEditorSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ElementToolSerializer">
            <summary>
            Serializer ElementToolSerializer for DomainClass ElementTool.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ToolSerializer">
            <summary>
            Serializer ToolSerializer for DomainClass Tool.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolSerializer.#ctor">
            <summary>
            ToolSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Tool is abstract and cannot be instantiated, so this method throws NotSupportedException.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the Tool element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Tool instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Tool instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of Tool based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized Tool, a new Tool instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created Tool instance, or null if the reader is not pointing to a serialized Tool instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of Tool based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of Tool.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new Tool instance should be created.</param>	
            <returns>Created Tool instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ToolSerializer.derivedClasses">
            <summary>
            Stores a mapping from XmlTagName to DomainClassInfo that derives from Tool, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolSerializer.ConstructDerivedClassesLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the apping from XmlTagName to DomainClassInfo that derives from Tool.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including Tool itself) instance of Tool based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of Tool based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ToolSerializer.derivedClassMonikers">
            <summary>
            Stores a mapping from Moniker Xml tag name to DomainClassInfo that derives from Tool, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolSerializer.ConstructDerivedClassMonikersLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the mapping from Moniker Xml tag name to DomainClassInfo that derives from Tool.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized Tool instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Tool instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the Tool instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the Tool instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one Tool instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Tool instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Tool instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given Tool instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">Tool instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the Tool instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">Tool instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ToolSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ToolSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ToolSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementToolSerializer.#ctor">
            <summary>
            ElementToolSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementToolSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one ElementTool instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ElementTool element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ElementTool instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementToolSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ElementTool instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementToolSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ElementTool instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementToolSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.ElementTool,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory ElementTool instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementToolSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ElementTool based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ElementTool, a new ElementTool instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ElementTool instance, or null if the reader is not pointing to a serialized ElementTool instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementToolSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ElementTool based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ElementTool.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ElementTool instance should be created.</param>	
            <returns>Created ElementTool instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementToolSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ElementTool itself) instance of ElementTool based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementToolSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ElementTool based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementToolSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized ElementTool instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ElementTool instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the ElementTool instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the ElementTool instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementToolSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one ElementTool instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ElementTool instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementToolSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ElementTool instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementToolSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ElementTool instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementToolSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.ElementTool,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ElementTool instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementToolSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given ElementTool instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ElementTool instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the ElementTool instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementToolSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ElementTool instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementToolSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of ElementTool.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementToolSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of ElementTool.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementToolSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of ElementTool in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionToolSerializer">
            <summary>
            Serializer ConnectionToolSerializer for DomainClass ConnectionTool.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionToolSerializer.#ctor">
            <summary>
            ConnectionToolSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionToolSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one ConnectionTool instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ConnectionTool element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ConnectionTool instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionToolSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ConnectionTool instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionToolSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ConnectionTool instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionToolSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory ConnectionTool instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionToolSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ConnectionTool based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ConnectionTool, a new ConnectionTool instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ConnectionTool instance, or null if the reader is not pointing to a serialized ConnectionTool instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionToolSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ConnectionTool based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ConnectionTool.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ConnectionTool instance should be created.</param>	
            <returns>Created ConnectionTool instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionToolSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ConnectionTool itself) instance of ConnectionTool based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionToolSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ConnectionTool based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionToolSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized ConnectionTool instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ConnectionTool instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the ConnectionTool instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the ConnectionTool instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionToolSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one ConnectionTool instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ConnectionTool instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionToolSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ConnectionTool instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionToolSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ConnectionTool instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionToolSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionTool,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ConnectionTool instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionToolSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given ConnectionTool instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ConnectionTool instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the ConnectionTool instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionToolSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ConnectionTool instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionToolSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of ConnectionTool.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionToolSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of ConnectionTool.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionToolSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of ConnectionTool in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationSerializer">
            <summary>
            Serializer ValidationSerializer for DomainClass Validation.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationSerializer.#ctor">
            <summary>
            ValidationSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one Validation instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the Validation element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Validation instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Validation instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of Validation based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized Validation, a new Validation instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created Validation instance, or null if the reader is not pointing to a serialized Validation instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of Validation based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of Validation.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new Validation instance should be created.</param>	
            <returns>Created Validation instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including Validation itself) instance of Validation based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of Validation based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized Validation instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Validation instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the Validation instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the Validation instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one Validation instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Validation instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Validation instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given Validation instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">Validation instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the Validation instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">Validation instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of Validation.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslSerializer">
            <summary>
            Serializer DslSerializer for DomainClass Dsl.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslSerializer.#ctor">
            <summary>
            DslSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one Dsl instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the Dsl element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Dsl instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Dsl instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Dsl instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.Dsl,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory Dsl instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of Dsl based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized Dsl, a new Dsl instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created Dsl instance, or null if the reader is not pointing to a serialized Dsl instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of Dsl based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of Dsl.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new Dsl instance should be created.</param>	
            <returns>Created Dsl instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including Dsl itself) instance of Dsl based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of Dsl based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized Dsl instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Dsl instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the Dsl instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the Dsl instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one Dsl instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Dsl instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Dsl instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Dsl instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.Dsl,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Dsl instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given Dsl instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">Dsl instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the Dsl instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">Dsl instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of Dsl.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of Dsl.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of Dsl in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerSerializer">
            <summary>
            Serializer ExplorerSerializer for DomainClass Explorer.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerSerializer.#ctor">
            <summary>
            ExplorerSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one Explorer instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the Explorer element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Explorer instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Explorer instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Explorer instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.Explorer,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory Explorer instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of Explorer based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized Explorer, a new Explorer instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created Explorer instance, or null if the reader is not pointing to a serialized Explorer instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of Explorer based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of Explorer.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new Explorer instance should be created.</param>	
            <returns>Created Explorer instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including Explorer itself) instance of Explorer based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of Explorer based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized Explorer instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Explorer instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the Explorer instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the Explorer instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one Explorer instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Explorer instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Explorer instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Explorer instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.Explorer,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Explorer instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given Explorer instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">Explorer instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the Explorer instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">Explorer instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of Explorer.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionSerializer">
            <summary>
            Serializer XmlSerializationDefinitionSerializer for DomainClass XmlSerializationDefinition.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionSerializer.#ctor">
            <summary>
            XmlSerializationDefinitionSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one XmlSerializationDefinition instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the XmlSerializationDefinition element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory XmlSerializationDefinition instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory XmlSerializationDefinition instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory XmlSerializationDefinition instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory XmlSerializationDefinition instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of XmlSerializationDefinition based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized XmlSerializationDefinition, a new XmlSerializationDefinition instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created XmlSerializationDefinition instance, or null if the reader is not pointing to a serialized XmlSerializationDefinition instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of XmlSerializationDefinition based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of XmlSerializationDefinition.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new XmlSerializationDefinition instance should be created.</param>	
            <returns>Created XmlSerializationDefinition instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including XmlSerializationDefinition itself) instance of XmlSerializationDefinition based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of XmlSerializationDefinition based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized XmlSerializationDefinition instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">XmlSerializationDefinition instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the XmlSerializationDefinition instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the XmlSerializationDefinition instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one XmlSerializationDefinition instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">XmlSerializationDefinition instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">XmlSerializationDefinition instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">XmlSerializationDefinition instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinition,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">XmlSerializationDefinition instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given XmlSerializationDefinition instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">XmlSerializationDefinition instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the XmlSerializationDefinition instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">XmlSerializationDefinition instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of XmlSerializationDefinition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabSerializer">
            <summary>
            Serializer ToolboxTabSerializer for DomainClass ToolboxTab.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabSerializer.#ctor">
            <summary>
            ToolboxTabSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one ToolboxTab instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ToolboxTab element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ToolboxTab instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ToolboxTab instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ToolboxTab instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory ToolboxTab instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ToolboxTab based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ToolboxTab, a new ToolboxTab instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ToolboxTab instance, or null if the reader is not pointing to a serialized ToolboxTab instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ToolboxTab based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ToolboxTab.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ToolboxTab instance should be created.</param>	
            <returns>Created ToolboxTab instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ToolboxTab itself) instance of ToolboxTab based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ToolboxTab based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized ToolboxTab instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ToolboxTab instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the ToolboxTab instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the ToolboxTab instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one ToolboxTab instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ToolboxTab instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ToolboxTab instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ToolboxTab instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTab,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ToolboxTab instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given ToolboxTab instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ToolboxTab instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the ToolboxTab instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ToolboxTab instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of ToolboxTab.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ToolboxTabSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.PortSerializer">
            <summary>
            Serializer PortSerializer for DomainClass Port.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeSerializer">
            <summary>
            Serializer GeometryShapeSerializer for DomainClass GeometryShape.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeSerializer">
            <summary>
            Serializer ShapeSerializer for DomainClass Shape.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeSerializer">
            <summary>
            Serializer BaseShapeSerializer for DomainClass BaseShape.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementSerializer">
            <summary>
            Serializer DiagramElementSerializer for DomainClass DiagramElement.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementSerializer.#ctor">
            <summary>
            DiagramElementSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            DiagramElement is abstract and cannot be instantiated, so this method throws NotSupportedException.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DiagramElement element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DiagramElement instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DiagramElement instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DiagramElement based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DiagramElement, a new DiagramElement instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DiagramElement instance, or null if the reader is not pointing to a serialized DiagramElement instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DiagramElement based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DiagramElement.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DiagramElement instance should be created.</param>	
            <returns>Created DiagramElement instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementSerializer.derivedClasses">
            <summary>
            Stores a mapping from XmlTagName to DomainClassInfo that derives from DiagramElement, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementSerializer.ConstructDerivedClassesLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the apping from XmlTagName to DomainClassInfo that derives from DiagramElement.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DiagramElement itself) instance of DiagramElement based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DiagramElement based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementSerializer.derivedClassMonikers">
            <summary>
            Stores a mapping from Moniker Xml tag name to DomainClassInfo that derives from DiagramElement, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementSerializer.ConstructDerivedClassMonikersLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the mapping from Moniker Xml tag name to DomainClassInfo that derives from DiagramElement.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized DiagramElement instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DiagramElement instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the DiagramElement instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the DiagramElement instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one DiagramElement instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DiagramElement instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DiagramElement instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given DiagramElement instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DiagramElement instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the DiagramElement instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DiagramElement instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeSerializer.#ctor">
            <summary>
            BaseShapeSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            BaseShape is abstract and cannot be instantiated, so this method throws NotSupportedException.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the BaseShape element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory BaseShape instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of BaseShape based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized BaseShape, a new BaseShape instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created BaseShape instance, or null if the reader is not pointing to a serialized BaseShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of BaseShape based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of BaseShape.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new BaseShape instance should be created.</param>	
            <returns>Created BaseShape instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeSerializer.derivedClasses">
            <summary>
            Stores a mapping from XmlTagName to DomainClassInfo that derives from BaseShape, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeSerializer.ConstructDerivedClassesLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the apping from XmlTagName to DomainClassInfo that derives from BaseShape.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including BaseShape itself) instance of BaseShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of BaseShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeSerializer.derivedClassMonikers">
            <summary>
            Stores a mapping from Moniker Xml tag name to DomainClassInfo that derives from BaseShape, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeSerializer.ConstructDerivedClassMonikersLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the mapping from Moniker Xml tag name to DomainClassInfo that derives from BaseShape.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized BaseShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">BaseShape instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the BaseShape instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the BaseShape instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one BaseShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">BaseShape instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given BaseShape instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">BaseShape instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the BaseShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">BaseShape instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeSerializer.#ctor">
            <summary>
            ShapeSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Shape is abstract and cannot be instantiated, so this method throws NotSupportedException.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the Shape element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Shape instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Shape instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Shape instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.Shape,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory Shape instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of Shape based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized Shape, a new Shape instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created Shape instance, or null if the reader is not pointing to a serialized Shape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of Shape based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of Shape.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new Shape instance should be created.</param>	
            <returns>Created Shape instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeSerializer.derivedClasses">
            <summary>
            Stores a mapping from XmlTagName to DomainClassInfo that derives from Shape, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeSerializer.ConstructDerivedClassesLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the apping from XmlTagName to DomainClassInfo that derives from Shape.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including Shape itself) instance of Shape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of Shape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeSerializer.derivedClassMonikers">
            <summary>
            Stores a mapping from Moniker Xml tag name to DomainClassInfo that derives from Shape, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeSerializer.ConstructDerivedClassMonikersLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the mapping from Moniker Xml tag name to DomainClassInfo that derives from Shape.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized Shape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Shape instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the Shape instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the Shape instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one Shape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Shape instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Shape instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Shape instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.Shape,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Shape instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given Shape instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">Shape instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the Shape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">Shape instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeSerializer.#ctor">
            <summary>
            GeometryShapeSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one GeometryShape instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the GeometryShape element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory GeometryShape instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory GeometryShape instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of GeometryShape based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized GeometryShape, a new GeometryShape instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created GeometryShape instance, or null if the reader is not pointing to a serialized GeometryShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of GeometryShape based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of GeometryShape.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new GeometryShape instance should be created.</param>	
            <returns>Created GeometryShape instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeSerializer.derivedClasses">
            <summary>
            Stores a mapping from XmlTagName to DomainClassInfo that derives from GeometryShape, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeSerializer.ConstructDerivedClassesLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the apping from XmlTagName to DomainClassInfo that derives from GeometryShape.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including GeometryShape itself) instance of GeometryShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of GeometryShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeSerializer.derivedClassMonikers">
            <summary>
            Stores a mapping from Moniker Xml tag name to DomainClassInfo that derives from GeometryShape, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeSerializer.ConstructDerivedClassMonikersLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the mapping from Moniker Xml tag name to DomainClassInfo that derives from GeometryShape.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized GeometryShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">GeometryShape instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the GeometryShape instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the GeometryShape instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one GeometryShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">GeometryShape instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">GeometryShape instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given GeometryShape instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">GeometryShape instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the GeometryShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">GeometryShape instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of GeometryShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of GeometryShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of GeometryShape in a serialized monikerized instance.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortSerializer.#ctor">
            <summary>
            PortSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one Port instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the Port element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Port instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of Port based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized Port, a new Port instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created Port instance, or null if the reader is not pointing to a serialized Port instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of Port based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of Port.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new Port instance should be created.</param>	
            <returns>Created Port instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including Port itself) instance of Port based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of Port based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized Port instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Port instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the Port instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the Port instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one Port instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Port instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given Port instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">Port instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the Port instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">Port instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PortSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of Port.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PortSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of Port.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PortSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of Port in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorSerializer">
            <summary>
            Serializer ExplorerBehaviorSerializer for DomainClass ExplorerBehavior.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorSerializer.#ctor">
            <summary>
            ExplorerBehaviorSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one ExplorerBehavior instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ExplorerBehavior element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ExplorerBehavior instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ExplorerBehavior instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ExplorerBehavior instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory ExplorerBehavior instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorSerializer.ReadExplorerBehaviorHasNodeSettingsInstances(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior,System.Xml.XmlReader)">
            <summary>
            Reads all instances of relationship ExplorerBehaviorHasNodeSettings.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize all instances and ignore all bogus tags. When the
            method returns, the reader will be positioned at the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ExplorerBehavior instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorSerializer.ReadExplorerHidesNodesInstances(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior,System.Xml.XmlReader)">
            <summary>
            Reads all instances of relationship ExplorerHidesNodes.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize all instances and ignore all bogus tags. When the
            method returns, the reader will be positioned at the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ExplorerBehavior instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ExplorerBehavior based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ExplorerBehavior, a new ExplorerBehavior instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ExplorerBehavior instance, or null if the reader is not pointing to a serialized ExplorerBehavior instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ExplorerBehavior based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ExplorerBehavior.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ExplorerBehavior instance should be created.</param>	
            <returns>Created ExplorerBehavior instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ExplorerBehavior itself) instance of ExplorerBehavior based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ExplorerBehavior based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized ExplorerBehavior instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ExplorerBehavior instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the ExplorerBehavior instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the ExplorerBehavior instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one ExplorerBehavior instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ExplorerBehavior instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ExplorerBehavior instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ExplorerBehavior instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehavior,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ExplorerBehavior instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given ExplorerBehavior instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ExplorerBehavior instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the ExplorerBehavior instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ExplorerBehavior instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of ExplorerBehavior.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of ExplorerBehavior.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of ExplorerBehavior in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptorSerializer">
            <summary>
            Serializer DomainTypeDescriptorSerializer for DomainClass DomainTypeDescriptor.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptorSerializer.#ctor">
            <summary>
            DomainTypeDescriptorSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptorSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DomainTypeDescriptor instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DomainTypeDescriptor element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainTypeDescriptor instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptorSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainTypeDescriptor instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptorSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainTypeDescriptor instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptorSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory DomainTypeDescriptor instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptorSerializer.ReadCustomPropertyDescriptorInstances(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor,System.Xml.XmlReader)">
            <summary>
            Reads all instances of relationship CustomPropertyDescriptor.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize all instances and ignore all bogus tags. When the
            method returns, the reader will be positioned at the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainTypeDescriptor instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptorSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DomainTypeDescriptor based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DomainTypeDescriptor, a new DomainTypeDescriptor instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DomainTypeDescriptor instance, or null if the reader is not pointing to a serialized DomainTypeDescriptor instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptorSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DomainTypeDescriptor based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DomainTypeDescriptor.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DomainTypeDescriptor instance should be created.</param>	
            <returns>Created DomainTypeDescriptor instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptorSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DomainTypeDescriptor itself) instance of DomainTypeDescriptor based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptorSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DomainTypeDescriptor based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptorSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized DomainTypeDescriptor instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainTypeDescriptor instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the DomainTypeDescriptor instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the DomainTypeDescriptor instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptorSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one DomainTypeDescriptor instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainTypeDescriptor instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptorSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainTypeDescriptor instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptorSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainTypeDescriptor instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptorSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptor,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainTypeDescriptor instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptorSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given DomainTypeDescriptor instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DomainTypeDescriptor instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the DomainTypeDescriptor instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptorSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DomainTypeDescriptor instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptorSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DomainTypeDescriptor.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptorSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainTypeDescriptorSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsSerializer">
            <summary>
            Serializer ExplorerNodeSettingsSerializer for DomainClass ExplorerNodeSettings.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsSerializer.#ctor">
            <summary>
            ExplorerNodeSettingsSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one ExplorerNodeSettings instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ExplorerNodeSettings element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ExplorerNodeSettings instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ExplorerNodeSettings instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ExplorerNodeSettings instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory ExplorerNodeSettings instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsSerializer.ReadExplorerNodeSettingsReferencesClassInstance(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings,System.Xml.XmlReader)">
            <summary>
            Reads instance of relationship ExplorerNodeSettingsReferencesClass.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize only the first valid instance and ignore all the
            rest tags (because the multiplicity allows only one instance). When the method returns, the reader will be positioned at 
            the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ExplorerNodeSettings instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsSerializer.ReadExplorerNodeSettingsHasPropertyDisplayedPathInstance(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings,System.Xml.XmlReader)">
            <summary>
            Reads instance of relationship ExplorerNodeSettingsHasPropertyDisplayedPath.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize only the first valid instance and ignore all the
            rest tags (because the multiplicity allows only one instance). When the method returns, the reader will be positioned at 
            the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ExplorerNodeSettings instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ExplorerNodeSettings based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ExplorerNodeSettings, a new ExplorerNodeSettings instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ExplorerNodeSettings instance, or null if the reader is not pointing to a serialized ExplorerNodeSettings instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ExplorerNodeSettings based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ExplorerNodeSettings.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ExplorerNodeSettings instance should be created.</param>	
            <returns>Created ExplorerNodeSettings instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ExplorerNodeSettings itself) instance of ExplorerNodeSettings based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ExplorerNodeSettings based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized ExplorerNodeSettings instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ExplorerNodeSettings instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the ExplorerNodeSettings instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the ExplorerNodeSettings instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one ExplorerNodeSettings instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ExplorerNodeSettings instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ExplorerNodeSettings instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ExplorerNodeSettings instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettings,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ExplorerNodeSettings instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given ExplorerNodeSettings instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ExplorerNodeSettings instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the ExplorerNodeSettings instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ExplorerNodeSettings instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of ExplorerNodeSettings.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorSerializer">
            <summary>
            Serializer DecoratorSerializer for DomainClass Decorator.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorSerializer.#ctor">
            <summary>
            DecoratorSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Decorator is abstract and cannot be instantiated, so this method throws NotSupportedException.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the Decorator element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Decorator instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Decorator instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of Decorator based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized Decorator, a new Decorator instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created Decorator instance, or null if the reader is not pointing to a serialized Decorator instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of Decorator based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of Decorator.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new Decorator instance should be created.</param>	
            <returns>Created Decorator instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorSerializer.derivedClasses">
            <summary>
            Stores a mapping from XmlTagName to DomainClassInfo that derives from Decorator, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorSerializer.ConstructDerivedClassesLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the apping from XmlTagName to DomainClassInfo that derives from Decorator.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including Decorator itself) instance of Decorator based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of Decorator based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorSerializer.derivedClassMonikers">
            <summary>
            Stores a mapping from Moniker Xml tag name to DomainClassInfo that derives from Decorator, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorSerializer.ConstructDerivedClassMonikersLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the mapping from Moniker Xml tag name to DomainClassInfo that derives from Decorator.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized Decorator instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Decorator instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the Decorator instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the Decorator instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one Decorator instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Decorator instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Decorator instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given Decorator instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">Decorator instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the Decorator instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">Decorator instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorSerializer">
            <summary>
            Serializer ConnectorSerializer for DomainClass Connector.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorSerializer.#ctor">
            <summary>
            ConnectorSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one Connector instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the Connector element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Connector instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Connector instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Connector instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.Connector,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory Connector instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of Connector based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized Connector, a new Connector instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created Connector instance, or null if the reader is not pointing to a serialized Connector instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of Connector based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of Connector.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new Connector instance should be created.</param>	
            <returns>Created Connector instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including Connector itself) instance of Connector based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of Connector based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized Connector instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Connector instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the Connector instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the Connector instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one Connector instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Connector instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Connector instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Connector instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.Connector,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Connector instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given Connector instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">Connector instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the Connector instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">Connector instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of Connector.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of Connector.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of Connector in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentSerializer">
            <summary>
            Serializer CompartmentSerializer for DomainClass Compartment.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentSerializer.#ctor">
            <summary>
            CompartmentSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one Compartment instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the Compartment element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Compartment instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Compartment instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of Compartment based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized Compartment, a new Compartment instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created Compartment instance, or null if the reader is not pointing to a serialized Compartment instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of Compartment based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of Compartment.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new Compartment instance should be created.</param>	
            <returns>Created Compartment instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including Compartment itself) instance of Compartment based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of Compartment based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized Compartment instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Compartment instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the Compartment instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the Compartment instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one Compartment instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Compartment instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Compartment instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given Compartment instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">Compartment instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the Compartment instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">Compartment instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of Compartment.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of Compartment.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of Compartment in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeSerializer">
            <summary>
            Serializer CompartmentShapeSerializer for DomainClass CompartmentShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeSerializer.#ctor">
            <summary>
            CompartmentShapeSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one CompartmentShape instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the CompartmentShape element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory CompartmentShape instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory CompartmentShape instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory CompartmentShape instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory CompartmentShape instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of CompartmentShape based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized CompartmentShape, a new CompartmentShape instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created CompartmentShape instance, or null if the reader is not pointing to a serialized CompartmentShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of CompartmentShape based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of CompartmentShape.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new CompartmentShape instance should be created.</param>	
            <returns>Created CompartmentShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including CompartmentShape itself) instance of CompartmentShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of CompartmentShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized CompartmentShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">CompartmentShape instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the CompartmentShape instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the CompartmentShape instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one CompartmentShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">CompartmentShape instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">CompartmentShape instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">CompartmentShape instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShape,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">CompartmentShape instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given CompartmentShape instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">CompartmentShape instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the CompartmentShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">CompartmentShape instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of CompartmentShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of CompartmentShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of CompartmentShape in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeSerializer">
            <summary>
            Serializer ImageShapeSerializer for DomainClass ImageShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeSerializer.#ctor">
            <summary>
            ImageShapeSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one ImageShape instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ImageShape element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ImageShape instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ImageShape instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ImageShape based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ImageShape, a new ImageShape instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ImageShape instance, or null if the reader is not pointing to a serialized ImageShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ImageShape based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ImageShape.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ImageShape instance should be created.</param>	
            <returns>Created ImageShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ImageShape itself) instance of ImageShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ImageShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized ImageShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ImageShape instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the ImageShape instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the ImageShape instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one ImageShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ImageShape instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ImageShape instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given ImageShape instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ImageShape instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the ImageShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ImageShape instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of ImageShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of ImageShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of ImageShape in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.IconDecoratorSerializer">
            <summary>
            Serializer IconDecoratorSerializer for DomainClass IconDecorator.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.IconDecoratorSerializer.#ctor">
            <summary>
            IconDecoratorSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.IconDecoratorSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one IconDecorator instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the IconDecorator element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory IconDecorator instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.IconDecoratorSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory IconDecorator instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.IconDecoratorSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of IconDecorator based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized IconDecorator, a new IconDecorator instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created IconDecorator instance, or null if the reader is not pointing to a serialized IconDecorator instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.IconDecoratorSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of IconDecorator based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of IconDecorator.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new IconDecorator instance should be created.</param>	
            <returns>Created IconDecorator instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.IconDecoratorSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including IconDecorator itself) instance of IconDecorator based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.IconDecoratorSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of IconDecorator based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.IconDecoratorSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized IconDecorator instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">IconDecorator instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the IconDecorator instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the IconDecorator instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.IconDecoratorSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one IconDecorator instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">IconDecorator instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.IconDecoratorSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">IconDecorator instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.IconDecoratorSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given IconDecorator instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">IconDecorator instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the IconDecorator instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.IconDecoratorSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">IconDecorator instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.IconDecoratorSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of IconDecorator.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.IconDecoratorSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of IconDecorator.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.IconDecoratorSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of IconDecorator in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecoratorSerializer">
            <summary>
            Serializer TextDecoratorSerializer for DomainClass TextDecorator.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecoratorSerializer.#ctor">
            <summary>
            TextDecoratorSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecoratorSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one TextDecorator instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the TextDecorator element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory TextDecorator instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecoratorSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory TextDecorator instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecoratorSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of TextDecorator based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized TextDecorator, a new TextDecorator instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created TextDecorator instance, or null if the reader is not pointing to a serialized TextDecorator instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecoratorSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of TextDecorator based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of TextDecorator.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new TextDecorator instance should be created.</param>	
            <returns>Created TextDecorator instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecoratorSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including TextDecorator itself) instance of TextDecorator based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecoratorSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of TextDecorator based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecoratorSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized TextDecorator instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">TextDecorator instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the TextDecorator instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the TextDecorator instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecoratorSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one TextDecorator instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">TextDecorator instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecoratorSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">TextDecorator instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecoratorSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given TextDecorator instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">TextDecorator instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the TextDecorator instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecoratorSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">TextDecorator instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecoratorSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of TextDecorator.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecoratorSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of TextDecorator.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.TextDecoratorSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of TextDecorator in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ExpandCollapseDecoratorSerializer">
            <summary>
            Serializer ExpandCollapseDecoratorSerializer for DomainClass ExpandCollapseDecorator.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExpandCollapseDecoratorSerializer.#ctor">
            <summary>
            ExpandCollapseDecoratorSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExpandCollapseDecoratorSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one ExpandCollapseDecorator instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ExpandCollapseDecorator element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ExpandCollapseDecorator instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExpandCollapseDecoratorSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ExpandCollapseDecorator based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ExpandCollapseDecorator, a new ExpandCollapseDecorator instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ExpandCollapseDecorator instance, or null if the reader is not pointing to a serialized ExpandCollapseDecorator instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExpandCollapseDecoratorSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ExpandCollapseDecorator based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ExpandCollapseDecorator.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ExpandCollapseDecorator instance should be created.</param>	
            <returns>Created ExpandCollapseDecorator instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExpandCollapseDecoratorSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ExpandCollapseDecorator itself) instance of ExpandCollapseDecorator based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExpandCollapseDecoratorSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ExpandCollapseDecorator based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExpandCollapseDecoratorSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized ExpandCollapseDecorator instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ExpandCollapseDecorator instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the ExpandCollapseDecorator instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the ExpandCollapseDecorator instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExpandCollapseDecoratorSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one ExpandCollapseDecorator instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ExpandCollapseDecorator instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExpandCollapseDecoratorSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given ExpandCollapseDecorator instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ExpandCollapseDecorator instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the ExpandCollapseDecorator instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExpandCollapseDecoratorSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ExpandCollapseDecorator instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExpandCollapseDecoratorSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of ExpandCollapseDecorator.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExpandCollapseDecoratorSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of ExpandCollapseDecorator.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExpandCollapseDecoratorSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of ExpandCollapseDecorator in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathSerializer">
            <summary>
            Serializer PropertyPathSerializer for DomainClass PropertyPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathSerializer.#ctor">
            <summary>
            PropertyPathSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one PropertyPath instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the PropertyPath element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory PropertyPath instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory PropertyPath instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory PropertyPath instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of PropertyPath based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized PropertyPath, a new PropertyPath instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created PropertyPath instance, or null if the reader is not pointing to a serialized PropertyPath instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of PropertyPath based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of PropertyPath.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new PropertyPath instance should be created.</param>	
            <returns>Created PropertyPath instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathSerializer.derivedClasses">
            <summary>
            Stores a mapping from XmlTagName to DomainClassInfo that derives from PropertyPath, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathSerializer.ConstructDerivedClassesLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the apping from XmlTagName to DomainClassInfo that derives from PropertyPath.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including PropertyPath itself) instance of PropertyPath based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of PropertyPath based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathSerializer.derivedClassMonikers">
            <summary>
            Stores a mapping from Moniker Xml tag name to DomainClassInfo that derives from PropertyPath, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathSerializer.ConstructDerivedClassMonikersLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the mapping from Moniker Xml tag name to DomainClassInfo that derives from PropertyPath.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized PropertyPath instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">PropertyPath instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the PropertyPath instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the PropertyPath instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one PropertyPath instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">PropertyPath instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">PropertyPath instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPath,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">PropertyPath instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given PropertyPath instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">PropertyPath instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the PropertyPath instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">PropertyPath instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of PropertyPath.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilterSerializer">
            <summary>
            Serializer PropertyFilterSerializer for DomainClass PropertyFilter.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilterSerializer.#ctor">
            <summary>
            PropertyFilterSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilterSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one PropertyFilter instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the PropertyFilter element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory PropertyFilter instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilterSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory PropertyFilter instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilterSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of PropertyFilter based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized PropertyFilter, a new PropertyFilter instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created PropertyFilter instance, or null if the reader is not pointing to a serialized PropertyFilter instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilterSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of PropertyFilter based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of PropertyFilter.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new PropertyFilter instance should be created.</param>	
            <returns>Created PropertyFilter instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilterSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including PropertyFilter itself) instance of PropertyFilter based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilterSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of PropertyFilter based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilterSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized PropertyFilter instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">PropertyFilter instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the PropertyFilter instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the PropertyFilter instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilterSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one PropertyFilter instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">PropertyFilter instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilterSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">PropertyFilter instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilterSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given PropertyFilter instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">PropertyFilter instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the PropertyFilter instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilterSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">PropertyFilter instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilterSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of PropertyFilter.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilterSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyFilterSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathSerializer">
            <summary>
            Serializer VisibilityPropertyPathSerializer for DomainClass VisibilityPropertyPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathSerializer.#ctor">
            <summary>
            VisibilityPropertyPathSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one VisibilityPropertyPath instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the VisibilityPropertyPath element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory VisibilityPropertyPath instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory VisibilityPropertyPath instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPath,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory VisibilityPropertyPath instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathSerializer.ReadVisibilityPropertyPathHasPropertyFiltersInstances(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPath,System.Xml.XmlReader)">
            <summary>
            Reads all instances of relationship VisibilityPropertyPathHasPropertyFilters.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize all instances and ignore all bogus tags. When the
            method returns, the reader will be positioned at the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory VisibilityPropertyPath instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of VisibilityPropertyPath based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized VisibilityPropertyPath, a new VisibilityPropertyPath instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created VisibilityPropertyPath instance, or null if the reader is not pointing to a serialized VisibilityPropertyPath instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of VisibilityPropertyPath based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of VisibilityPropertyPath.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new VisibilityPropertyPath instance should be created.</param>	
            <returns>Created VisibilityPropertyPath instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including VisibilityPropertyPath itself) instance of VisibilityPropertyPath based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of VisibilityPropertyPath based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized VisibilityPropertyPath instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">VisibilityPropertyPath instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the VisibilityPropertyPath instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the VisibilityPropertyPath instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one VisibilityPropertyPath instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">VisibilityPropertyPath instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">VisibilityPropertyPath instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPath,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">VisibilityPropertyPath instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given VisibilityPropertyPath instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">VisibilityPropertyPath instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the VisibilityPropertyPath instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">VisibilityPropertyPath instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of VisibilityPropertyPath.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramSerializer">
            <summary>
            Serializer DiagramSerializer for DomainClass Diagram.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramSerializer.#ctor">
            <summary>
            DiagramSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one Diagram instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the Diagram element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Diagram instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Diagram instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Diagram instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.Diagram,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory Diagram instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramSerializer.ReadDiagramRepresentsClassInstance(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.Diagram,System.Xml.XmlReader)">
            <summary>
            Reads instance of relationship DiagramRepresentsClass.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize only the first valid instance and ignore all the
            rest tags (because the multiplicity allows only one instance). When the method returns, the reader will be positioned at 
            the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Diagram instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramSerializer.ReadDiagramHasShapeMapsInstances(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.Diagram,System.Xml.XmlReader)">
            <summary>
            Reads all instances of relationship DiagramHasShapeMaps.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize all instances and ignore all bogus tags. When the
            method returns, the reader will be positioned at the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Diagram instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramSerializer.ReadDiagramHasConnectorMapsInstances(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.Diagram,System.Xml.XmlReader)">
            <summary>
            Reads all instances of relationship DiagramHasConnectorMaps.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize all instances and ignore all bogus tags. When the
            method returns, the reader will be positioned at the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Diagram instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of Diagram based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized Diagram, a new Diagram instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created Diagram instance, or null if the reader is not pointing to a serialized Diagram instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of Diagram based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of Diagram.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new Diagram instance should be created.</param>	
            <returns>Created Diagram instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including Diagram itself) instance of Diagram based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of Diagram based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized Diagram instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Diagram instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the Diagram instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the Diagram instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one Diagram instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Diagram instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Diagram instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Diagram instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.Diagram,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Diagram instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given Diagram instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">Diagram instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the Diagram instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">Diagram instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of Diagram.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of Diagram.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of Diagram in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapSerializer">
            <summary>
            Serializer CompartmentMapSerializer for DomainClass CompartmentMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapSerializer.#ctor">
            <summary>
            CompartmentMapSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one CompartmentMap instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the CompartmentMap element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory CompartmentMap instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory CompartmentMap instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory CompartmentMap instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory CompartmentMap instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapSerializer.ReadCompartmentMapHasElementsDisplayedPathInstance(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap,System.Xml.XmlReader)">
            <summary>
            Reads instance of relationship CompartmentMapHasElementsDisplayedPath.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize only the first valid instance and ignore all the
            rest tags (because the multiplicity allows only one instance). When the method returns, the reader will be positioned at 
            the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory CompartmentMap instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapSerializer.ReadCompartmentMapHasPropertyDisplayedPathInstance(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap,System.Xml.XmlReader)">
            <summary>
            Reads instance of relationship CompartmentMapHasPropertyDisplayedPath.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize only the first valid instance and ignore all the
            rest tags (because the multiplicity allows only one instance). When the method returns, the reader will be positioned at 
            the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory CompartmentMap instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of CompartmentMap based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized CompartmentMap, a new CompartmentMap instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created CompartmentMap instance, or null if the reader is not pointing to a serialized CompartmentMap instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of CompartmentMap based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of CompartmentMap.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new CompartmentMap instance should be created.</param>	
            <returns>Created CompartmentMap instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including CompartmentMap itself) instance of CompartmentMap based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of CompartmentMap based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized CompartmentMap instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">CompartmentMap instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the CompartmentMap instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the CompartmentMap instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one CompartmentMap instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">CompartmentMap instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">CompartmentMap instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">CompartmentMap instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMap,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">CompartmentMap instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given CompartmentMap instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">CompartmentMap instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the CompartmentMap instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">CompartmentMap instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of CompartmentMap.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapSerializer">
            <summary>
            Serializer DecoratorMapSerializer for DomainClass DecoratorMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapSerializer.#ctor">
            <summary>
            DecoratorMapSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DecoratorMap instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DecoratorMap element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DecoratorMap instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DecoratorMap instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory DecoratorMap instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapSerializer.ReadDecoratorMapHasPropertyDisplayedPathInstance(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap,System.Xml.XmlReader)">
            <summary>
            Reads instance of relationship DecoratorMapHasPropertyDisplayedPath.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize only the first valid instance and ignore all the
            rest tags (because the multiplicity allows only one instance). When the method returns, the reader will be positioned at 
            the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DecoratorMap instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DecoratorMap based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DecoratorMap, a new DecoratorMap instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DecoratorMap instance, or null if the reader is not pointing to a serialized DecoratorMap instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DecoratorMap based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DecoratorMap.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DecoratorMap instance should be created.</param>	
            <returns>Created DecoratorMap instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DecoratorMap itself) instance of DecoratorMap based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DecoratorMap based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized DecoratorMap instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DecoratorMap instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the DecoratorMap instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the DecoratorMap instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one DecoratorMap instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DecoratorMap instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DecoratorMap instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DecoratorMap instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given DecoratorMap instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DecoratorMap instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the DecoratorMap instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DecoratorMap instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DecoratorMap.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerSerializer">
            <summary>
            Serializer DesignerSerializer for DomainClass Designer.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerSerializer.#ctor">
            <summary>
            DesignerSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one Designer instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the Designer element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Designer instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory Designer instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.Designer,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory Designer instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of Designer based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized Designer, a new Designer instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created Designer instance, or null if the reader is not pointing to a serialized Designer instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of Designer based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of Designer.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new Designer instance should be created.</param>	
            <returns>Created Designer instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including Designer itself) instance of Designer based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of Designer based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized Designer instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Designer instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the Designer instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the Designer instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one Designer instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Designer instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Designer instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.Designer,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">Designer instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given Designer instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">Designer instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the Designer instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">Designer instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of Designer.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapSerializer">
            <summary>
            Serializer CompartmentShapeMapSerializer for DomainClass CompartmentShapeMap.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapSerializer">
            <summary>
            Serializer BaseShapeMapSerializer for DomainClass BaseShapeMap.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapSerializer">
            <summary>
            Serializer DiagramElementMapSerializer for DomainClass DiagramElementMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapSerializer.#ctor">
            <summary>
            DiagramElementMapSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            DiagramElementMap is abstract and cannot be instantiated, so this method throws NotSupportedException.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DiagramElementMap element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DiagramElementMap instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DiagramElementMap based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DiagramElementMap, a new DiagramElementMap instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DiagramElementMap instance, or null if the reader is not pointing to a serialized DiagramElementMap instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DiagramElementMap based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DiagramElementMap.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DiagramElementMap instance should be created.</param>	
            <returns>Created DiagramElementMap instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapSerializer.derivedClasses">
            <summary>
            Stores a mapping from XmlTagName to DomainClassInfo that derives from DiagramElementMap, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapSerializer.ConstructDerivedClassesLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the apping from XmlTagName to DomainClassInfo that derives from DiagramElementMap.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DiagramElementMap itself) instance of DiagramElementMap based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DiagramElementMap based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapSerializer.derivedClassMonikers">
            <summary>
            Stores a mapping from Moniker Xml tag name to DomainClassInfo that derives from DiagramElementMap, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapSerializer.ConstructDerivedClassMonikersLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the mapping from Moniker Xml tag name to DomainClassInfo that derives from DiagramElementMap.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized DiagramElementMap instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DiagramElementMap instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the DiagramElementMap instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the DiagramElementMap instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one DiagramElementMap instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DiagramElementMap instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given DiagramElementMap instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DiagramElementMap instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the DiagramElementMap instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DiagramElementMap instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapSerializer.#ctor">
            <summary>
            BaseShapeMapSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            BaseShapeMap is abstract and cannot be instantiated, so this method throws NotSupportedException.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the BaseShapeMap element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory BaseShapeMap instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory BaseShapeMap instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory BaseShapeMap instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory BaseShapeMap instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapSerializer.ReadShapeMapHasParentElementPathInstance(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap,System.Xml.XmlReader)">
            <summary>
            Reads instance of relationship ShapeMapHasParentElementPath.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize only the first valid instance and ignore all the
            rest tags (because the multiplicity allows only one instance). When the method returns, the reader will be positioned at 
            the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory BaseShapeMap instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of BaseShapeMap based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized BaseShapeMap, a new BaseShapeMap instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created BaseShapeMap instance, or null if the reader is not pointing to a serialized BaseShapeMap instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of BaseShapeMap based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of BaseShapeMap.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new BaseShapeMap instance should be created.</param>	
            <returns>Created BaseShapeMap instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapSerializer.derivedClasses">
            <summary>
            Stores a mapping from XmlTagName to DomainClassInfo that derives from BaseShapeMap, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapSerializer.ConstructDerivedClassesLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the apping from XmlTagName to DomainClassInfo that derives from BaseShapeMap.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including BaseShapeMap itself) instance of BaseShapeMap based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of BaseShapeMap based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapSerializer.derivedClassMonikers">
            <summary>
            Stores a mapping from Moniker Xml tag name to DomainClassInfo that derives from BaseShapeMap, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapSerializer.ConstructDerivedClassMonikersLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the mapping from Moniker Xml tag name to DomainClassInfo that derives from BaseShapeMap.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized BaseShapeMap instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">BaseShapeMap instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the BaseShapeMap instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the BaseShapeMap instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one BaseShapeMap instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">BaseShapeMap instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">BaseShapeMap instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">BaseShapeMap instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">BaseShapeMap instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given BaseShapeMap instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">BaseShapeMap instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the BaseShapeMap instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">BaseShapeMap instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapSerializer.#ctor">
            <summary>
            CompartmentShapeMapSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one CompartmentShapeMap instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the CompartmentShapeMap element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory CompartmentShapeMap instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory CompartmentShapeMap instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMap,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory CompartmentShapeMap instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of CompartmentShapeMap based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized CompartmentShapeMap, a new CompartmentShapeMap instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created CompartmentShapeMap instance, or null if the reader is not pointing to a serialized CompartmentShapeMap instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of CompartmentShapeMap based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of CompartmentShapeMap.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new CompartmentShapeMap instance should be created.</param>	
            <returns>Created CompartmentShapeMap instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including CompartmentShapeMap itself) instance of CompartmentShapeMap based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of CompartmentShapeMap based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized CompartmentShapeMap instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">CompartmentShapeMap instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the CompartmentShapeMap instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the CompartmentShapeMap instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one CompartmentShapeMap instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">CompartmentShapeMap instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">CompartmentShapeMap instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMap,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">CompartmentShapeMap instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given CompartmentShapeMap instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">CompartmentShapeMap instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the CompartmentShapeMap instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">CompartmentShapeMap instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of CompartmentShapeMap.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapSerializer">
            <summary>
            Serializer ShapeMapSerializer for DomainClass ShapeMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapSerializer.#ctor">
            <summary>
            ShapeMapSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one ShapeMap instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ShapeMap element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ShapeMap instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ShapeMap instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMap,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory ShapeMap instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ShapeMap based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ShapeMap, a new ShapeMap instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ShapeMap instance, or null if the reader is not pointing to a serialized ShapeMap instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ShapeMap based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ShapeMap.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ShapeMap instance should be created.</param>	
            <returns>Created ShapeMap instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ShapeMap itself) instance of ShapeMap based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ShapeMap based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized ShapeMap instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ShapeMap instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the ShapeMap instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the ShapeMap instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one ShapeMap instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ShapeMap instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ShapeMap instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMap,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ShapeMap instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given ShapeMap instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ShapeMap instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the ShapeMap instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ShapeMap instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of ShapeMap.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapSerializer">
            <summary>
            Serializer ConnectorMapSerializer for DomainClass ConnectorMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapSerializer.#ctor">
            <summary>
            ConnectorMapSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one ConnectorMap instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ConnectorMap element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ConnectorMap instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ConnectorMap instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ConnectorMap instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory ConnectorMap instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ConnectorMap based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ConnectorMap, a new ConnectorMap instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ConnectorMap instance, or null if the reader is not pointing to a serialized ConnectorMap instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ConnectorMap based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ConnectorMap.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ConnectorMap instance should be created.</param>	
            <returns>Created ConnectorMap instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ConnectorMap itself) instance of ConnectorMap based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ConnectorMap based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized ConnectorMap instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ConnectorMap instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the ConnectorMap instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the ConnectorMap instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one ConnectorMap instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ConnectorMap instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ConnectorMap instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ConnectorMap instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMap,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ConnectorMap instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given ConnectorMap instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ConnectorMap instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the ConnectorMap instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ConnectorMap instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of ConnectorMap.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorSerializer">
            <summary>
            Serializer XmlSerializationBehaviorSerializer for DomainClass XmlSerializationBehavior.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorSerializer.#ctor">
            <summary>
            XmlSerializationBehaviorSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one XmlSerializationBehavior instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the XmlSerializationBehavior element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory XmlSerializationBehavior instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory XmlSerializationBehavior instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory XmlSerializationBehavior instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory XmlSerializationBehavior instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorSerializer.ReadXmlSerializationBehaviorHasXmlClassDataInstances(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior,System.Xml.XmlReader)">
            <summary>
            Reads all instances of relationship XmlSerializationBehaviorHasXmlClassData.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize all instances and ignore all bogus tags. When the
            method returns, the reader will be positioned at the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory XmlSerializationBehavior instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of XmlSerializationBehavior based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized XmlSerializationBehavior, a new XmlSerializationBehavior instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created XmlSerializationBehavior instance, or null if the reader is not pointing to a serialized XmlSerializationBehavior instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of XmlSerializationBehavior based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of XmlSerializationBehavior.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new XmlSerializationBehavior instance should be created.</param>	
            <returns>Created XmlSerializationBehavior instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including XmlSerializationBehavior itself) instance of XmlSerializationBehavior based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of XmlSerializationBehavior based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized XmlSerializationBehavior instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">XmlSerializationBehavior instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the XmlSerializationBehavior instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the XmlSerializationBehavior instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one XmlSerializationBehavior instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">XmlSerializationBehavior instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">XmlSerializationBehavior instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">XmlSerializationBehavior instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehavior,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">XmlSerializationBehavior instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given XmlSerializationBehavior instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">XmlSerializationBehavior instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the XmlSerializationBehavior instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">XmlSerializationBehavior instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of XmlSerializationBehavior.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of XmlSerializationBehavior.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of XmlSerializationBehavior in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataSerializer">
            <summary>
            Serializer XmlClassDataSerializer for DomainClass XmlClassData.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataSerializer.#ctor">
            <summary>
            XmlClassDataSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one XmlClassData instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the XmlClassData element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory XmlClassData instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory XmlClassData instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory XmlClassData instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory XmlClassData instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataSerializer.ReadXmlClassDataHasXmlElementDataInstances(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData,System.Xml.XmlReader)">
            <summary>
            Reads all instances of relationship XmlClassDataHasXmlElementData.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize all instances and ignore all bogus tags. When the
            method returns, the reader will be positioned at the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory XmlClassData instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of XmlClassData based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized XmlClassData, a new XmlClassData instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created XmlClassData instance, or null if the reader is not pointing to a serialized XmlClassData instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of XmlClassData based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of XmlClassData.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new XmlClassData instance should be created.</param>	
            <returns>Created XmlClassData instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including XmlClassData itself) instance of XmlClassData based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of XmlClassData based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized XmlClassData instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">XmlClassData instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the XmlClassData instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the XmlClassData instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one XmlClassData instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">XmlClassData instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">XmlClassData instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">XmlClassData instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassData,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">XmlClassData instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given XmlClassData instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">XmlClassData instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the XmlClassData instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">XmlClassData instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of XmlClassData.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataSerializer">
            <summary>
            Serializer XmlRelationshipDataSerializer for DomainClass XmlRelationshipData.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementDataSerializer">
            <summary>
            Serializer XmlElementDataSerializer for DomainClass XmlElementData.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementDataSerializer.#ctor">
            <summary>
            XmlElementDataSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementDataSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            XmlElementData is abstract and cannot be instantiated, so this method throws NotSupportedException.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the XmlElementData element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory XmlElementData instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementDataSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of XmlElementData based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized XmlElementData, a new XmlElementData instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created XmlElementData instance, or null if the reader is not pointing to a serialized XmlElementData instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementDataSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of XmlElementData based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of XmlElementData.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new XmlElementData instance should be created.</param>	
            <returns>Created XmlElementData instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementDataSerializer.derivedClasses">
            <summary>
            Stores a mapping from XmlTagName to DomainClassInfo that derives from XmlElementData, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementDataSerializer.ConstructDerivedClassesLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the apping from XmlTagName to DomainClassInfo that derives from XmlElementData.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementDataSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including XmlElementData itself) instance of XmlElementData based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementDataSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of XmlElementData based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementDataSerializer.derivedClassMonikers">
            <summary>
            Stores a mapping from Moniker Xml tag name to DomainClassInfo that derives from XmlElementData, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementDataSerializer.ConstructDerivedClassMonikersLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the mapping from Moniker Xml tag name to DomainClassInfo that derives from XmlElementData.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementDataSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized XmlElementData instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">XmlElementData instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the XmlElementData instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the XmlElementData instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementDataSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one XmlElementData instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">XmlElementData instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementDataSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given XmlElementData instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">XmlElementData instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the XmlElementData instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementDataSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">XmlElementData instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementDataSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementDataSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementDataSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataSerializer.#ctor">
            <summary>
            XmlRelationshipDataSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one XmlRelationshipData instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the XmlRelationshipData element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory XmlRelationshipData instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory XmlRelationshipData instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory XmlRelationshipData instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory XmlRelationshipData instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of XmlRelationshipData based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized XmlRelationshipData, a new XmlRelationshipData instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created XmlRelationshipData instance, or null if the reader is not pointing to a serialized XmlRelationshipData instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of XmlRelationshipData based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of XmlRelationshipData.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new XmlRelationshipData instance should be created.</param>	
            <returns>Created XmlRelationshipData instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including XmlRelationshipData itself) instance of XmlRelationshipData based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of XmlRelationshipData based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized XmlRelationshipData instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">XmlRelationshipData instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the XmlRelationshipData instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the XmlRelationshipData instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one XmlRelationshipData instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">XmlRelationshipData instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">XmlRelationshipData instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">XmlRelationshipData instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipData,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">XmlRelationshipData instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given XmlRelationshipData instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">XmlRelationshipData instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the XmlRelationshipData instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">XmlRelationshipData instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of XmlRelationshipData.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyDataSerializer">
            <summary>
            Serializer XmlPropertyDataSerializer for DomainClass XmlPropertyData.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyDataSerializer.#ctor">
            <summary>
            XmlPropertyDataSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyDataSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one XmlPropertyData instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the XmlPropertyData element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory XmlPropertyData instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyDataSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory XmlPropertyData instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyDataSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory XmlPropertyData instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyDataSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory XmlPropertyData instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyDataSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of XmlPropertyData based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized XmlPropertyData, a new XmlPropertyData instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created XmlPropertyData instance, or null if the reader is not pointing to a serialized XmlPropertyData instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyDataSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of XmlPropertyData based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of XmlPropertyData.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new XmlPropertyData instance should be created.</param>	
            <returns>Created XmlPropertyData instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyDataSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including XmlPropertyData itself) instance of XmlPropertyData based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyDataSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of XmlPropertyData based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyDataSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized XmlPropertyData instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">XmlPropertyData instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the XmlPropertyData instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the XmlPropertyData instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyDataSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one XmlPropertyData instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">XmlPropertyData instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyDataSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">XmlPropertyData instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyDataSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">XmlPropertyData instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyDataSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyData,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">XmlPropertyData instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyDataSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given XmlPropertyData instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">XmlPropertyData instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the XmlPropertyData instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyDataSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">XmlPropertyData instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyDataSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of XmlPropertyData.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyDataSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlPropertyDataSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneSerializer">
            <summary>
            Serializer SwimLaneSerializer for DomainClass SwimLane.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneSerializer.#ctor">
            <summary>
            SwimLaneSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one SwimLane instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the SwimLane element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory SwimLane instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory SwimLane instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory SwimLane instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory SwimLane instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneSerializer.ReadSwimLaneHasDecoratorsInstances(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane,System.Xml.XmlReader)">
            <summary>
            Reads all instances of relationship SwimLaneHasDecorators.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize all instances and ignore all bogus tags. When the
            method returns, the reader will be positioned at the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory SwimLane instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of SwimLane based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized SwimLane, a new SwimLane instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created SwimLane instance, or null if the reader is not pointing to a serialized SwimLane instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of SwimLane based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of SwimLane.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new SwimLane instance should be created.</param>	
            <returns>Created SwimLane instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including SwimLane itself) instance of SwimLane based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of SwimLane based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized SwimLane instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">SwimLane instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the SwimLane instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the SwimLane instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one SwimLane instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">SwimLane instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">SwimLane instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">SwimLane instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.SwimLane,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">SwimLane instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given SwimLane instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">SwimLane instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the SwimLane instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">SwimLane instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of SwimLane.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of SwimLane.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of SwimLane in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapSerializer">
            <summary>
            Serializer SwimLaneMapSerializer for DomainClass SwimLaneMap.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapSerializer.#ctor">
            <summary>
            SwimLaneMapSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one SwimLaneMap instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the SwimLaneMap element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory SwimLaneMap instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory SwimLaneMap instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMap,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory SwimLaneMap instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapSerializer.ReadSwimLaneMapReferencesSwimLaneInstance(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMap,System.Xml.XmlReader)">
            <summary>
            Reads instance of relationship SwimLaneMapReferencesSwimLane.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize only the first valid instance and ignore all the
            rest tags (because the multiplicity allows only one instance). When the method returns, the reader will be positioned at 
            the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory SwimLaneMap instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of SwimLaneMap based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized SwimLaneMap, a new SwimLaneMap instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created SwimLaneMap instance, or null if the reader is not pointing to a serialized SwimLaneMap instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of SwimLaneMap based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of SwimLaneMap.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new SwimLaneMap instance should be created.</param>	
            <returns>Created SwimLaneMap instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including SwimLaneMap itself) instance of SwimLaneMap based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of SwimLaneMap based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized SwimLaneMap instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">SwimLaneMap instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the SwimLaneMap instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the SwimLaneMap instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one SwimLaneMap instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">SwimLaneMap instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">SwimLaneMap instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMap,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">SwimLaneMap instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given SwimLaneMap instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">SwimLaneMap instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the SwimLaneMap instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">SwimLaneMap instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of SwimLaneMap.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.TreeNodeSerializer">
            <summary>
            Serializer TreeNodeSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.TreeNode.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TreeNodeSerializer.#ctor">
            <summary>
            TreeNodeSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TreeNodeSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            TreeNode is abstract and cannot be instantiated, so this method throws NotSupportedException.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the TreeNode element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory TreeNode instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TreeNodeSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory TreeNode instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TreeNodeSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of TreeNode based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized TreeNode, a new TreeNode instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created TreeNode instance, or null if the reader is not pointing to a serialized TreeNode instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TreeNodeSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of TreeNode based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of TreeNode.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new TreeNode instance should be created.</param>	
            <returns>Created TreeNode instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.TreeNodeSerializer.derivedClasses">
            <summary>
            Stores a mapping from XmlTagName to DomainClassInfo that derives from TreeNode, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TreeNodeSerializer.ConstructDerivedClassesLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the apping from XmlTagName to DomainClassInfo that derives from TreeNode.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TreeNodeSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including TreeNode itself) instance of TreeNode based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TreeNodeSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of TreeNode based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.TreeNodeSerializer.derivedClassMonikers">
            <summary>
            Stores a mapping from Moniker Xml tag name to DomainClassInfo that derives from TreeNode, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TreeNodeSerializer.ConstructDerivedClassMonikersLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the mapping from Moniker Xml tag name to DomainClassInfo that derives from TreeNode.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TreeNodeSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized TreeNode instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">TreeNode instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the TreeNode instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the TreeNode instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TreeNodeSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one TreeNode instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">TreeNode instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TreeNodeSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">TreeNode instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TreeNodeSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given TreeNode instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">TreeNode instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the TreeNode instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TreeNodeSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">TreeNode instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.TreeNodeSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.TreeNodeSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.TreeNodeSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeSerializer">
            <summary>
            Serializer InheritanceNodeSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNode.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ArcNodeSerializer">
            <summary>
            Serializer ArcNodeSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.ArcNode.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ArcNodeSerializer.#ctor">
            <summary>
            ArcNodeSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ArcNodeSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            ArcNode is abstract and cannot be instantiated, so this method throws NotSupportedException.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ArcNode element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ArcNode instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ArcNodeSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ArcNode instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ArcNodeSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ArcNode based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ArcNode, a new ArcNode instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ArcNode instance, or null if the reader is not pointing to a serialized ArcNode instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ArcNodeSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ArcNode based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ArcNode.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ArcNode instance should be created.</param>	
            <returns>Created ArcNode instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ArcNodeSerializer.derivedClasses">
            <summary>
            Stores a mapping from XmlTagName to DomainClassInfo that derives from ArcNode, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ArcNodeSerializer.ConstructDerivedClassesLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the apping from XmlTagName to DomainClassInfo that derives from ArcNode.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ArcNodeSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ArcNode itself) instance of ArcNode based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ArcNodeSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ArcNode based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ArcNodeSerializer.derivedClassMonikers">
            <summary>
            Stores a mapping from Moniker Xml tag name to DomainClassInfo that derives from ArcNode, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ArcNodeSerializer.ConstructDerivedClassMonikersLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the mapping from Moniker Xml tag name to DomainClassInfo that derives from ArcNode.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ArcNodeSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized ArcNode instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ArcNode instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the ArcNode instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the ArcNode instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ArcNodeSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one ArcNode instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ArcNode instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ArcNodeSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ArcNode instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ArcNodeSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given ArcNode instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ArcNode instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the ArcNode instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ArcNodeSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ArcNode instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ArcNodeSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ArcNodeSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ArcNodeSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeSerializer.#ctor">
            <summary>
            InheritanceNodeSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one InheritanceNode instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the InheritanceNode element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory InheritanceNode instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory InheritanceNode instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNode,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory InheritanceNode instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeSerializer.ReadInheritanceNodeReferencesInheritanceLinkInstance(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNode,System.Xml.XmlReader)">
            <summary>
            Reads instance of relationship InheritanceNodeReferencesInheritanceLink.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize only the first valid instance and ignore all the
            rest tags (because the multiplicity allows only one instance). When the method returns, the reader will be positioned at 
            the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory InheritanceNode instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of InheritanceNode based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized InheritanceNode, a new InheritanceNode instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created InheritanceNode instance, or null if the reader is not pointing to a serialized InheritanceNode instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of InheritanceNode based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of InheritanceNode.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new InheritanceNode instance should be created.</param>	
            <returns>Created InheritanceNode instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including InheritanceNode itself) instance of InheritanceNode based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of InheritanceNode based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized InheritanceNode instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">InheritanceNode instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the InheritanceNode instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the InheritanceNode instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one InheritanceNode instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">InheritanceNode instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">InheritanceNode instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNode,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">InheritanceNode instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given InheritanceNode instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">InheritanceNode instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the InheritanceNode instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">InheritanceNode instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of InheritanceNode.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of InheritanceNode.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of InheritanceNode in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeSerializer">
            <summary>
            Serializer RootNodeSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.RootNode.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeSerializer.#ctor">
            <summary>
            RootNodeSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one RootNode instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the RootNode element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory RootNode instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory RootNode instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDesigner.RootNode,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory RootNode instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeSerializer.ReadRootNodeReferencesClassInstance(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDesigner.RootNode,System.Xml.XmlReader)">
            <summary>
            Reads instance of relationship RootNodeReferencesClass.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize only the first valid instance and ignore all the
            rest tags (because the multiplicity allows only one instance). When the method returns, the reader will be positioned at 
            the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory RootNode instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of RootNode based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized RootNode, a new RootNode instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created RootNode instance, or null if the reader is not pointing to a serialized RootNode instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of RootNode based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of RootNode.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new RootNode instance should be created.</param>	
            <returns>Created RootNode instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including RootNode itself) instance of RootNode based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of RootNode based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized RootNode instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">RootNode instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the RootNode instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the RootNode instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one RootNode instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">RootNode instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">RootNode instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDesigner.RootNode,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">RootNode instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given RootNode instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">RootNode instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the RootNode instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">RootNode instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of RootNode.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of RootNode.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of RootNode in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.SourceRoleNodeSerializer">
            <summary>
            Serializer SourceRoleNodeSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.SourceRoleNode.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SourceRoleNodeSerializer.#ctor">
            <summary>
            SourceRoleNodeSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SourceRoleNodeSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one SourceRoleNode instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the SourceRoleNode element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory SourceRoleNode instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SourceRoleNodeSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory SourceRoleNode instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SourceRoleNodeSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDesigner.SourceRoleNode,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory SourceRoleNode instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SourceRoleNodeSerializer.ReadRoleNodeReferencesRoleInstance(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDesigner.SourceRoleNode,System.Xml.XmlReader)">
            <summary>
            Reads instance of relationship RoleNodeReferencesRole.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize only the first valid instance and ignore all the
            rest tags (because the multiplicity allows only one instance). When the method returns, the reader will be positioned at 
            the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory SourceRoleNode instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SourceRoleNodeSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of SourceRoleNode based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized SourceRoleNode, a new SourceRoleNode instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created SourceRoleNode instance, or null if the reader is not pointing to a serialized SourceRoleNode instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SourceRoleNodeSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of SourceRoleNode based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of SourceRoleNode.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new SourceRoleNode instance should be created.</param>	
            <returns>Created SourceRoleNode instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SourceRoleNodeSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including SourceRoleNode itself) instance of SourceRoleNode based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SourceRoleNodeSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of SourceRoleNode based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SourceRoleNodeSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized SourceRoleNode instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">SourceRoleNode instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the SourceRoleNode instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the SourceRoleNode instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SourceRoleNodeSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one SourceRoleNode instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">SourceRoleNode instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SourceRoleNodeSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">SourceRoleNode instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SourceRoleNodeSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDesigner.SourceRoleNode,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">SourceRoleNode instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SourceRoleNodeSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given SourceRoleNode instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">SourceRoleNode instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the SourceRoleNode instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SourceRoleNodeSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">SourceRoleNode instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SourceRoleNodeSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of SourceRoleNode.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SourceRoleNodeSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of SourceRoleNode.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SourceRoleNodeSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of SourceRoleNode in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramTreeSerializer">
            <summary>
            Serializer DslDesignerDiagramTreeSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramTreeSerializer.#ctor">
            <summary>
            DslDesignerDiagramTreeSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramTreeSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DslDesignerDiagramTree instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DslDesignerDiagramTree element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslDesignerDiagramTree instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramTreeSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslDesignerDiagramTree instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramTreeSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory DslDesignerDiagramTree instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramTreeSerializer.ReadDiagramTreeHasRootsInstances(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree,System.Xml.XmlReader)">
            <summary>
            Reads all instances of relationship DiagramTreeHasRoots.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize all instances and ignore all bogus tags. When the
            method returns, the reader will be positioned at the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslDesignerDiagramTree instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramTreeSerializer.ReadDiagramTreeHasArcsInstances(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree,System.Xml.XmlReader)">
            <summary>
            Reads all instances of relationship DiagramTreeHasArcs.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize all instances and ignore all bogus tags. When the
            method returns, the reader will be positioned at the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslDesignerDiagramTree instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramTreeSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DslDesignerDiagramTree based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DslDesignerDiagramTree, a new DslDesignerDiagramTree instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DslDesignerDiagramTree instance, or null if the reader is not pointing to a serialized DslDesignerDiagramTree instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramTreeSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DslDesignerDiagramTree based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DslDesignerDiagramTree.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DslDesignerDiagramTree instance should be created.</param>	
            <returns>Created DslDesignerDiagramTree instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramTreeSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DslDesignerDiagramTree itself) instance of DslDesignerDiagramTree based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramTreeSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DslDesignerDiagramTree based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramTreeSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized DslDesignerDiagramTree instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DslDesignerDiagramTree instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the DslDesignerDiagramTree instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the DslDesignerDiagramTree instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramTreeSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one DslDesignerDiagramTree instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DslDesignerDiagramTree instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramTreeSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DslDesignerDiagramTree instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramTreeSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DslDesignerDiagramTree instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramTreeSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given DslDesignerDiagramTree instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DslDesignerDiagramTree instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the DslDesignerDiagramTree instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramTreeSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DslDesignerDiagramTree instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramTreeSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DslDesignerDiagramTree.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramTreeSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramTreeSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateSerializer">
            <summary>
            Serializer DslDesignerDiagramStateSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateSerializer.#ctor">
            <summary>
            DslDesignerDiagramStateSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DslDesignerDiagramState instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DslDesignerDiagramState element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslDesignerDiagramState instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslDesignerDiagramState instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateSerializer.ReadChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState,System.Xml.XmlReader)">
            <summary>
            This method deserializes all child model elements.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first child XML element to deserialized.
            This method will read as many child elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the 
               open tag of the unknown element. This implies the if the first child XML element is unknown, this method 
               should return immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="element">In-memory DslDesignerDiagramState instance that will get the deserialized data.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateSerializer.ReadDslDesignerDiagramStateHasDomainModelElementTreeInstance(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState,System.Xml.XmlReader)">
            <summary>
            Reads instance of relationship DslDesignerDiagramStateHasDomainModelElementTree.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize only the first valid instance and ignore all the
            rest tags (because the multiplicity allows only one instance). When the method returns, the reader will be positioned at 
            the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslDesignerDiagramState instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateSerializer.ReadDslDesignerDiagramStateHasDiagramElementTreeInstance(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState,System.Xml.XmlReader)">
            <summary>
            Reads instance of relationship DslDesignerDiagramStateHasDiagramElementTree.
            </summary>
            <remarks>
            The caller will position the reader at the open tag of the first XML element inside the relationship tag, so it can be
            either the first instance, or a bogus tag. This method will deserialize only the first valid instance and ignore all the
            rest tags (because the multiplicity allows only one instance). When the method returns, the reader will be positioned at 
            the end tag of the relationship (or EOF if somehow that happens).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslDesignerDiagramState instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DslDesignerDiagramState based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DslDesignerDiagramState, a new DslDesignerDiagramState instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DslDesignerDiagramState instance, or null if the reader is not pointing to a serialized DslDesignerDiagramState instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DslDesignerDiagramState based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DslDesignerDiagramState.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DslDesignerDiagramState instance should be created.</param>	
            <returns>Created DslDesignerDiagramState instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DslDesignerDiagramState itself) instance of DslDesignerDiagramState based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DslDesignerDiagramState based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized DslDesignerDiagramState instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DslDesignerDiagramState instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the DslDesignerDiagramState instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the DslDesignerDiagramState instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one DslDesignerDiagramState instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DslDesignerDiagramState instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DslDesignerDiagramState instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateSerializer.WriteChildElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramState,System.Xml.XmlWriter)">
            <summary>
            Serialize all child model elements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DslDesignerDiagramState instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given DslDesignerDiagramState instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DslDesignerDiagramState instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the DslDesignerDiagramState instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DslDesignerDiagramState instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DslDesignerDiagramState.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClassesSerializer">
            <summary>
            Serializer DslLibraryHasClassesSerializer for DomainClass DslLibraryHasClasses.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypesSerializer">
            <summary>
            Serializer DslLibraryHasReferenceTypesSerializer for DomainClass DslLibraryHasReferenceTypes.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypesSerializer.#ctor">
            <summary>
            DslLibraryHasReferenceTypesSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypesSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            DslLibraryHasReferenceTypes is abstract and cannot be instantiated, so this method throws NotSupportedException.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DslLibraryHasReferenceTypes element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslLibraryHasReferenceTypes instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypesSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player ReferenceType.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslLibraryHasReferenceTypes instance that will link to the target DomainClass instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypesSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslLibraryHasReferenceTypes instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypesSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslLibraryHasReferenceTypes instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypesSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DslLibraryHasReferenceTypes based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DslLibraryHasReferenceTypes, a new DslLibraryHasReferenceTypes instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DslLibraryHasReferenceTypes instance, or null if the reader is not pointing to a serialized DslLibraryHasReferenceTypes instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypesSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DslLibraryHasReferenceTypes based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DslLibraryHasReferenceTypes.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DslLibraryHasReferenceTypes instance should be created.</param>	
            <returns>Created DslLibraryHasReferenceTypes instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypesSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of DslLibraryHasReferenceTypes based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            DslLibraryHasReferenceTypes type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from DslLibraryHasReferenceTypes, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypesSerializer.derivedClasses">
            <summary>
            Stores a mapping from XmlTagName to DomainClassInfo that derives from DslLibraryHasReferenceTypes, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypesSerializer.ConstructDerivedClassesLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the apping from XmlTagName to DomainClassInfo that derives from DslLibraryHasReferenceTypes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypesSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DslLibraryHasReferenceTypes itself) instance of DslLibraryHasReferenceTypes based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypesSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DslLibraryHasReferenceTypes based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypesSerializer.derivedClassMonikers">
            <summary>
            Stores a mapping from Moniker Xml tag name to DomainClassInfo that derives from DslLibraryHasReferenceTypes, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypesSerializer.ConstructDerivedClassMonikersLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the mapping from Moniker Xml tag name to DomainClassInfo that derives from DslLibraryHasReferenceTypes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypesSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized DslLibraryHasReferenceTypes instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DslLibraryHasReferenceTypes instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the DslLibraryHasReferenceTypes instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the DslLibraryHasReferenceTypes instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypesSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one DslLibraryHasReferenceTypes instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DslLibraryHasReferenceTypes instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypesSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DslLibraryHasReferenceTypes instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypesSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DslLibraryHasReferenceTypes instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypesSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given DslLibraryHasReferenceTypes instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DslLibraryHasReferenceTypes instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the DslLibraryHasReferenceTypes instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypesSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DslLibraryHasReferenceTypes instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypesSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypesSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypesSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypesSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasReferenceTypesSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClassesSerializer.#ctor">
            <summary>
            DslLibraryHasClassesSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClassesSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DslLibraryHasClasses instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DslLibraryHasClasses element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslLibraryHasClasses instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClassesSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DslLibraryHasClasses based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DslLibraryHasClasses, a new DslLibraryHasClasses instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DslLibraryHasClasses instance, or null if the reader is not pointing to a serialized DslLibraryHasClasses instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClassesSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DslLibraryHasClasses based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DslLibraryHasClasses.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DslLibraryHasClasses instance should be created.</param>	
            <returns>Created DslLibraryHasClasses instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClassesSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of DslLibraryHasClasses based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            DslLibraryHasClasses type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from DslLibraryHasClasses, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClassesSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DslLibraryHasClasses itself) instance of DslLibraryHasClasses based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClassesSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DslLibraryHasClasses based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClassesSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClassesSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClassesSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DslLibraryHasClasses.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClassesSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClassesSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClassesSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasClassesSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationshipsSerializer">
            <summary>
            Serializer DslLibraryHasRelationshipsSerializer for DomainClass DslLibraryHasRelationships.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationshipsSerializer.#ctor">
            <summary>
            DslLibraryHasRelationshipsSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationshipsSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DslLibraryHasRelationships instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DslLibraryHasRelationships element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslLibraryHasRelationships instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationshipsSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player Relationship.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslLibraryHasRelationships instance that will link to the target DomainRelationship instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationshipsSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DslLibraryHasRelationships based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DslLibraryHasRelationships, a new DslLibraryHasRelationships instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DslLibraryHasRelationships instance, or null if the reader is not pointing to a serialized DslLibraryHasRelationships instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationshipsSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DslLibraryHasRelationships based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DslLibraryHasRelationships.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DslLibraryHasRelationships instance should be created.</param>	
            <returns>Created DslLibraryHasRelationships instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationshipsSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of DslLibraryHasRelationships based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            DslLibraryHasRelationships type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from DslLibraryHasRelationships, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationshipsSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DslLibraryHasRelationships itself) instance of DslLibraryHasRelationships based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationshipsSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DslLibraryHasRelationships based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationshipsSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationshipsSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationshipsSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DslLibraryHasRelationships.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationshipsSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationshipsSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationshipsSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasRelationshipsSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRolesSerializer">
            <summary>
            Serializer RelationshipHasRolesSerializer for DomainClass RelationshipHasRoles.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRolesSerializer.#ctor">
            <summary>
            RelationshipHasRolesSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRolesSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            RelationshipHasRoles is abstract and cannot be instantiated, so this method throws NotSupportedException.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the RelationshipHasRoles element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory RelationshipHasRoles instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRolesSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player Role.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory RelationshipHasRoles instance that will link to the target DomainRole instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRolesSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory RelationshipHasRoles instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRolesSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory RelationshipHasRoles instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRolesSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of RelationshipHasRoles based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized RelationshipHasRoles, a new RelationshipHasRoles instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created RelationshipHasRoles instance, or null if the reader is not pointing to a serialized RelationshipHasRoles instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRolesSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of RelationshipHasRoles based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of RelationshipHasRoles.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new RelationshipHasRoles instance should be created.</param>	
            <returns>Created RelationshipHasRoles instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRolesSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of RelationshipHasRoles based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            RelationshipHasRoles type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from RelationshipHasRoles, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRolesSerializer.derivedClasses">
            <summary>
            Stores a mapping from XmlTagName to DomainClassInfo that derives from RelationshipHasRoles, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRolesSerializer.ConstructDerivedClassesLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the apping from XmlTagName to DomainClassInfo that derives from RelationshipHasRoles.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRolesSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including RelationshipHasRoles itself) instance of RelationshipHasRoles based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRolesSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of RelationshipHasRoles based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRolesSerializer.derivedClassMonikers">
            <summary>
            Stores a mapping from Moniker Xml tag name to DomainClassInfo that derives from RelationshipHasRoles, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRolesSerializer.ConstructDerivedClassMonikersLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the mapping from Moniker Xml tag name to DomainClassInfo that derives from RelationshipHasRoles.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRolesSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized RelationshipHasRoles instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">RelationshipHasRoles instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the RelationshipHasRoles instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the RelationshipHasRoles instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRolesSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one RelationshipHasRoles instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">RelationshipHasRoles instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRolesSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">RelationshipHasRoles instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRolesSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">RelationshipHasRoles instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRolesSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given RelationshipHasRoles instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">RelationshipHasRoles instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the RelationshipHasRoles instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRolesSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">RelationshipHasRoles instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRolesSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRolesSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRolesSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRolesSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasRolesSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTargetSerializer">
            <summary>
            Serializer RelationshipHasTargetSerializer for DomainClass RelationshipHasTarget.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTargetSerializer.#ctor">
            <summary>
            RelationshipHasTargetSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTargetSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one RelationshipHasTarget instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the RelationshipHasTarget element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory RelationshipHasTarget instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTargetSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of RelationshipHasTarget based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized RelationshipHasTarget, a new RelationshipHasTarget instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created RelationshipHasTarget instance, or null if the reader is not pointing to a serialized RelationshipHasTarget instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTargetSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of RelationshipHasTarget based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of RelationshipHasTarget.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new RelationshipHasTarget instance should be created.</param>	
            <returns>Created RelationshipHasTarget instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTargetSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of RelationshipHasTarget based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            RelationshipHasTarget type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from RelationshipHasTarget, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTargetSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including RelationshipHasTarget itself) instance of RelationshipHasTarget based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTargetSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of RelationshipHasTarget based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTargetSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTargetSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTargetSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of RelationshipHasTarget.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTargetSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTargetSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTargetSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasTargetSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSourceSerializer">
            <summary>
            Serializer RelationshipHasSourceSerializer for DomainClass RelationshipHasSource.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSourceSerializer.#ctor">
            <summary>
            RelationshipHasSourceSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSourceSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one RelationshipHasSource instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the RelationshipHasSource element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory RelationshipHasSource instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSourceSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of RelationshipHasSource based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized RelationshipHasSource, a new RelationshipHasSource instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created RelationshipHasSource instance, or null if the reader is not pointing to a serialized RelationshipHasSource instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSourceSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of RelationshipHasSource based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of RelationshipHasSource.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new RelationshipHasSource instance should be created.</param>	
            <returns>Created RelationshipHasSource instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSourceSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of RelationshipHasSource based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            RelationshipHasSource type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from RelationshipHasSource, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSourceSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including RelationshipHasSource itself) instance of RelationshipHasSource based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSourceSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of RelationshipHasSource based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSourceSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSourceSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSourceSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of RelationshipHasSource.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSourceSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSourceSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSourceSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasSourceSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasPropertiesSerializer">
            <summary>
            Serializer ClassHasPropertiesSerializer for DomainClass ClassHasProperties.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasPropertiesSerializer.#ctor">
            <summary>
            ClassHasPropertiesSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasPropertiesSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one ClassHasProperties instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ClassHasProperties element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ClassHasProperties instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasPropertiesSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player Property.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ClassHasProperties instance that will link to the target DomainProperty instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasPropertiesSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ClassHasProperties based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ClassHasProperties, a new ClassHasProperties instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ClassHasProperties instance, or null if the reader is not pointing to a serialized ClassHasProperties instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasPropertiesSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ClassHasProperties based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ClassHasProperties.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ClassHasProperties instance should be created.</param>	
            <returns>Created ClassHasProperties instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasPropertiesSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of ClassHasProperties based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            ClassHasProperties type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from ClassHasProperties, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasPropertiesSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ClassHasProperties itself) instance of ClassHasProperties based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasPropertiesSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ClassHasProperties based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasPropertiesSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasPropertiesSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasPropertiesSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of ClassHasProperties.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasPropertiesSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasPropertiesSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasPropertiesSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasPropertiesSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypesSerializer">
            <summary>
            Serializer DslLibraryHasTypesSerializer for DomainClass DslLibraryHasTypes.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypesSerializer.#ctor">
            <summary>
            DslLibraryHasTypesSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypesSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DslLibraryHasTypes instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DslLibraryHasTypes element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslLibraryHasTypes instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypesSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player Type.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslLibraryHasTypes instance that will link to the target DomainType instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypesSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DslLibraryHasTypes based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DslLibraryHasTypes, a new DslLibraryHasTypes instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DslLibraryHasTypes instance, or null if the reader is not pointing to a serialized DslLibraryHasTypes instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypesSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DslLibraryHasTypes based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DslLibraryHasTypes.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DslLibraryHasTypes instance should be created.</param>	
            <returns>Created DslLibraryHasTypes instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypesSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of DslLibraryHasTypes based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            DslLibraryHasTypes type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from DslLibraryHasTypes, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypesSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DslLibraryHasTypes itself) instance of DslLibraryHasTypes based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypesSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DslLibraryHasTypes based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypesSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypesSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypesSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DslLibraryHasTypes.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypesSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypesSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypesSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasTypesSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiteralsSerializer">
            <summary>
            Serializer EnumerationHasLiteralsSerializer for DomainClass EnumerationHasLiterals.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiteralsSerializer.#ctor">
            <summary>
            EnumerationHasLiteralsSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiteralsSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one EnumerationHasLiterals instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the EnumerationHasLiterals element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory EnumerationHasLiterals instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiteralsSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player Literal.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory EnumerationHasLiterals instance that will link to the target EnumerationLiteral instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiteralsSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of EnumerationHasLiterals based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized EnumerationHasLiterals, a new EnumerationHasLiterals instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created EnumerationHasLiterals instance, or null if the reader is not pointing to a serialized EnumerationHasLiterals instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiteralsSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of EnumerationHasLiterals based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of EnumerationHasLiterals.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new EnumerationHasLiterals instance should be created.</param>	
            <returns>Created EnumerationHasLiterals instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiteralsSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of EnumerationHasLiterals based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            EnumerationHasLiterals type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from EnumerationHasLiterals, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiteralsSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including EnumerationHasLiterals itself) instance of EnumerationHasLiterals based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiteralsSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of EnumerationHasLiterals based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiteralsSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiteralsSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiteralsSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of EnumerationHasLiterals.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiteralsSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiteralsSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiteralsSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasLiteralsSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributesSerializer">
            <summary>
            Serializer AttributedDomainElementHasAttributesSerializer for DomainClass AttributedDomainElementHasAttributes.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributesSerializer.#ctor">
            <summary>
            AttributedDomainElementHasAttributesSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributesSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one AttributedDomainElementHasAttributes instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the AttributedDomainElementHasAttributes element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory AttributedDomainElementHasAttributes instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributesSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player Attribute.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory AttributedDomainElementHasAttributes instance that will link to the target ClrAttribute instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributesSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of AttributedDomainElementHasAttributes based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized AttributedDomainElementHasAttributes, a new AttributedDomainElementHasAttributes instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created AttributedDomainElementHasAttributes instance, or null if the reader is not pointing to a serialized AttributedDomainElementHasAttributes instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributesSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of AttributedDomainElementHasAttributes based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of AttributedDomainElementHasAttributes.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new AttributedDomainElementHasAttributes instance should be created.</param>	
            <returns>Created AttributedDomainElementHasAttributes instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributesSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of AttributedDomainElementHasAttributes based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            AttributedDomainElementHasAttributes type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from AttributedDomainElementHasAttributes, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributesSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including AttributedDomainElementHasAttributes itself) instance of AttributedDomainElementHasAttributes based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributesSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of AttributedDomainElementHasAttributes based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributesSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributesSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributesSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of AttributedDomainElementHasAttributes.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributesSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributesSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributesSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributedDomainElementHasAttributesSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributesSerializer">
            <summary>
            Serializer EnumerationHasAttributesSerializer for DomainClass EnumerationHasAttributes.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributesSerializer.#ctor">
            <summary>
            EnumerationHasAttributesSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributesSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one EnumerationHasAttributes instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the EnumerationHasAttributes element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory EnumerationHasAttributes instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributesSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player Attribute.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory EnumerationHasAttributes instance that will link to the target ClrAttribute instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributesSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of EnumerationHasAttributes based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized EnumerationHasAttributes, a new EnumerationHasAttributes instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created EnumerationHasAttributes instance, or null if the reader is not pointing to a serialized EnumerationHasAttributes instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributesSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of EnumerationHasAttributes based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of EnumerationHasAttributes.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new EnumerationHasAttributes instance should be created.</param>	
            <returns>Created EnumerationHasAttributes instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributesSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of EnumerationHasAttributes based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            EnumerationHasAttributes type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from EnumerationHasAttributes, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributesSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including EnumerationHasAttributes itself) instance of EnumerationHasAttributes based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributesSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of EnumerationHasAttributes based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributesSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributesSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributesSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of EnumerationHasAttributes.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributesSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributesSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributesSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.EnumerationHasAttributesSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParametersSerializer">
            <summary>
            Serializer AttributeHasParametersSerializer for DomainClass AttributeHasParameters.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParametersSerializer.#ctor">
            <summary>
            AttributeHasParametersSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParametersSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one AttributeHasParameters instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the AttributeHasParameters element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory AttributeHasParameters instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParametersSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player Parameter.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory AttributeHasParameters instance that will link to the target AttributeParameter instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParametersSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of AttributeHasParameters based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized AttributeHasParameters, a new AttributeHasParameters instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created AttributeHasParameters instance, or null if the reader is not pointing to a serialized AttributeHasParameters instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParametersSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of AttributeHasParameters based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of AttributeHasParameters.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new AttributeHasParameters instance should be created.</param>	
            <returns>Created AttributeHasParameters instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParametersSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of AttributeHasParameters based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            AttributeHasParameters type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from AttributeHasParameters, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParametersSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including AttributeHasParameters itself) instance of AttributeHasParameters based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParametersSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of AttributeHasParameters based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParametersSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParametersSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParametersSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of AttributeHasParameters.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParametersSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParametersSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParametersSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AttributeHasParametersSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayerSerializer">
            <summary>
            Serializer RolePlayerConnectDirectiveHasPathToRolePlayerSerializer for DomainClass RolePlayerConnectDirectiveHasPathToRolePlayer.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayerSerializer.#ctor">
            <summary>
            RolePlayerConnectDirectiveHasPathToRolePlayerSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayerSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one RolePlayerConnectDirectiveHasPathToRolePlayer instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the RolePlayerConnectDirectiveHasPathToRolePlayer element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory RolePlayerConnectDirectiveHasPathToRolePlayer instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayerSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player PathToRolePlayer.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory RolePlayerConnectDirectiveHasPathToRolePlayer instance that will link to the target DomainPath instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayerSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of RolePlayerConnectDirectiveHasPathToRolePlayer based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized RolePlayerConnectDirectiveHasPathToRolePlayer, a new RolePlayerConnectDirectiveHasPathToRolePlayer instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created RolePlayerConnectDirectiveHasPathToRolePlayer instance, or null if the reader is not pointing to a serialized RolePlayerConnectDirectiveHasPathToRolePlayer instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayerSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of RolePlayerConnectDirectiveHasPathToRolePlayer based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of RolePlayerConnectDirectiveHasPathToRolePlayer.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new RolePlayerConnectDirectiveHasPathToRolePlayer instance should be created.</param>	
            <returns>Created RolePlayerConnectDirectiveHasPathToRolePlayer instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayerSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of RolePlayerConnectDirectiveHasPathToRolePlayer based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            RolePlayerConnectDirectiveHasPathToRolePlayer type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from RolePlayerConnectDirectiveHasPathToRolePlayer, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayerSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including RolePlayerConnectDirectiveHasPathToRolePlayer itself) instance of RolePlayerConnectDirectiveHasPathToRolePlayer based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayerSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of RolePlayerConnectDirectiveHasPathToRolePlayer based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayerSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayerSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayerSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of RolePlayerConnectDirectiveHasPathToRolePlayer.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayerSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayerSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayerSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveHasPathToRolePlayerSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPathSerializer">
            <summary>
            Serializer ElementMergeDirectiveHasForwardingPathSerializer for DomainClass ElementMergeDirectiveHasForwardingPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPathSerializer.#ctor">
            <summary>
            ElementMergeDirectiveHasForwardingPathSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPathSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one ElementMergeDirectiveHasForwardingPath instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ElementMergeDirectiveHasForwardingPath element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ElementMergeDirectiveHasForwardingPath instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPathSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player ForwardingPath.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ElementMergeDirectiveHasForwardingPath instance that will link to the target DomainPath instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPathSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ElementMergeDirectiveHasForwardingPath based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ElementMergeDirectiveHasForwardingPath, a new ElementMergeDirectiveHasForwardingPath instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ElementMergeDirectiveHasForwardingPath instance, or null if the reader is not pointing to a serialized ElementMergeDirectiveHasForwardingPath instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPathSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ElementMergeDirectiveHasForwardingPath based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ElementMergeDirectiveHasForwardingPath.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ElementMergeDirectiveHasForwardingPath instance should be created.</param>	
            <returns>Created ElementMergeDirectiveHasForwardingPath instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPathSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of ElementMergeDirectiveHasForwardingPath based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            ElementMergeDirectiveHasForwardingPath type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from ElementMergeDirectiveHasForwardingPath, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPathSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ElementMergeDirectiveHasForwardingPath itself) instance of ElementMergeDirectiveHasForwardingPath based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPathSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ElementMergeDirectiveHasForwardingPath based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPathSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPathSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPathSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of ElementMergeDirectiveHasForwardingPath.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPathSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPathSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPathSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasForwardingPathSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPathsSerializer">
            <summary>
            Serializer ElementMergeDirectiveHasLinkCreationPathsSerializer for DomainClass ElementMergeDirectiveHasLinkCreationPaths.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPathsSerializer.#ctor">
            <summary>
            ElementMergeDirectiveHasLinkCreationPathsSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPathsSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one ElementMergeDirectiveHasLinkCreationPaths instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ElementMergeDirectiveHasLinkCreationPaths element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ElementMergeDirectiveHasLinkCreationPaths instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPathsSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player LinkCreationPath.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ElementMergeDirectiveHasLinkCreationPaths instance that will link to the target DomainPath instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPathsSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ElementMergeDirectiveHasLinkCreationPaths based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ElementMergeDirectiveHasLinkCreationPaths, a new ElementMergeDirectiveHasLinkCreationPaths instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ElementMergeDirectiveHasLinkCreationPaths instance, or null if the reader is not pointing to a serialized ElementMergeDirectiveHasLinkCreationPaths instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPathsSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ElementMergeDirectiveHasLinkCreationPaths based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ElementMergeDirectiveHasLinkCreationPaths.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ElementMergeDirectiveHasLinkCreationPaths instance should be created.</param>	
            <returns>Created ElementMergeDirectiveHasLinkCreationPaths instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPathsSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of ElementMergeDirectiveHasLinkCreationPaths based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            ElementMergeDirectiveHasLinkCreationPaths type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from ElementMergeDirectiveHasLinkCreationPaths, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPathsSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ElementMergeDirectiveHasLinkCreationPaths itself) instance of ElementMergeDirectiveHasLinkCreationPaths based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPathsSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ElementMergeDirectiveHasLinkCreationPaths based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPathsSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPathsSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPathsSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of ElementMergeDirectiveHasLinkCreationPaths.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPathsSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPathsSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPathsSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ElementMergeDirectiveHasLinkCreationPathsSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectivesSerializer">
            <summary>
            Serializer LinkConnectDirectiveHasTargetDirectivesSerializer for DomainClass LinkConnectDirectiveHasTargetDirectives.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectivesSerializer.#ctor">
            <summary>
            LinkConnectDirectiveHasTargetDirectivesSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectivesSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one LinkConnectDirectiveHasTargetDirectives instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the LinkConnectDirectiveHasTargetDirectives element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory LinkConnectDirectiveHasTargetDirectives instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectivesSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player TargetDirective.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory LinkConnectDirectiveHasTargetDirectives instance that will link to the target RolePlayerConnectDirective instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectivesSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of LinkConnectDirectiveHasTargetDirectives based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized LinkConnectDirectiveHasTargetDirectives, a new LinkConnectDirectiveHasTargetDirectives instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created LinkConnectDirectiveHasTargetDirectives instance, or null if the reader is not pointing to a serialized LinkConnectDirectiveHasTargetDirectives instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectivesSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of LinkConnectDirectiveHasTargetDirectives based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of LinkConnectDirectiveHasTargetDirectives.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new LinkConnectDirectiveHasTargetDirectives instance should be created.</param>	
            <returns>Created LinkConnectDirectiveHasTargetDirectives instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectivesSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of LinkConnectDirectiveHasTargetDirectives based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            LinkConnectDirectiveHasTargetDirectives type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from LinkConnectDirectiveHasTargetDirectives, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectivesSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including LinkConnectDirectiveHasTargetDirectives itself) instance of LinkConnectDirectiveHasTargetDirectives based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectivesSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of LinkConnectDirectiveHasTargetDirectives based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectivesSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectivesSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectivesSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of LinkConnectDirectiveHasTargetDirectives.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectivesSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectivesSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectivesSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasTargetDirectivesSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectivesSerializer">
            <summary>
            Serializer LinkConnectDirectiveHasSourceDirectivesSerializer for DomainClass LinkConnectDirectiveHasSourceDirectives.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectivesSerializer.#ctor">
            <summary>
            LinkConnectDirectiveHasSourceDirectivesSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectivesSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one LinkConnectDirectiveHasSourceDirectives instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the LinkConnectDirectiveHasSourceDirectives element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory LinkConnectDirectiveHasSourceDirectives instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectivesSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player SourceDirective.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory LinkConnectDirectiveHasSourceDirectives instance that will link to the target RolePlayerConnectDirective instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectivesSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of LinkConnectDirectiveHasSourceDirectives based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized LinkConnectDirectiveHasSourceDirectives, a new LinkConnectDirectiveHasSourceDirectives instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created LinkConnectDirectiveHasSourceDirectives instance, or null if the reader is not pointing to a serialized LinkConnectDirectiveHasSourceDirectives instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectivesSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of LinkConnectDirectiveHasSourceDirectives based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of LinkConnectDirectiveHasSourceDirectives.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new LinkConnectDirectiveHasSourceDirectives instance should be created.</param>	
            <returns>Created LinkConnectDirectiveHasSourceDirectives instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectivesSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of LinkConnectDirectiveHasSourceDirectives based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            LinkConnectDirectiveHasSourceDirectives type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from LinkConnectDirectiveHasSourceDirectives, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectivesSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including LinkConnectDirectiveHasSourceDirectives itself) instance of LinkConnectDirectiveHasSourceDirectives based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectivesSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of LinkConnectDirectiveHasSourceDirectives based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectivesSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectivesSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectivesSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of LinkConnectDirectiveHasSourceDirectives.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectivesSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectivesSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectivesSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveHasSourceDirectivesSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuildersSerializer">
            <summary>
            Serializer DslLibraryHasConnectionBuildersSerializer for DomainClass DslLibraryHasConnectionBuilders.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuildersSerializer.#ctor">
            <summary>
            DslLibraryHasConnectionBuildersSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuildersSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DslLibraryHasConnectionBuilders instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DslLibraryHasConnectionBuilders element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslLibraryHasConnectionBuilders instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuildersSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player ConnectionBuilder.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslLibraryHasConnectionBuilders instance that will link to the target ConnectionBuilder instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuildersSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DslLibraryHasConnectionBuilders based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DslLibraryHasConnectionBuilders, a new DslLibraryHasConnectionBuilders instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DslLibraryHasConnectionBuilders instance, or null if the reader is not pointing to a serialized DslLibraryHasConnectionBuilders instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuildersSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DslLibraryHasConnectionBuilders based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DslLibraryHasConnectionBuilders.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DslLibraryHasConnectionBuilders instance should be created.</param>	
            <returns>Created DslLibraryHasConnectionBuilders instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuildersSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of DslLibraryHasConnectionBuilders based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            DslLibraryHasConnectionBuilders type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from DslLibraryHasConnectionBuilders, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuildersSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DslLibraryHasConnectionBuilders itself) instance of DslLibraryHasConnectionBuilders based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuildersSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DslLibraryHasConnectionBuilders based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuildersSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuildersSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuildersSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DslLibraryHasConnectionBuilders.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuildersSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuildersSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuildersSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryHasConnectionBuildersSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectivesSerializer">
            <summary>
            Serializer ClassHasElementMergeDirectivesSerializer for DomainClass ClassHasElementMergeDirectives.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectivesSerializer.#ctor">
            <summary>
            ClassHasElementMergeDirectivesSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectivesSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one ClassHasElementMergeDirectives instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ClassHasElementMergeDirectives element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ClassHasElementMergeDirectives instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectivesSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player Directive.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ClassHasElementMergeDirectives instance that will link to the target ElementMergeDirective instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectivesSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ClassHasElementMergeDirectives based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ClassHasElementMergeDirectives, a new ClassHasElementMergeDirectives instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ClassHasElementMergeDirectives instance, or null if the reader is not pointing to a serialized ClassHasElementMergeDirectives instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectivesSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ClassHasElementMergeDirectives based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ClassHasElementMergeDirectives.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ClassHasElementMergeDirectives instance should be created.</param>	
            <returns>Created ClassHasElementMergeDirectives instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectivesSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of ClassHasElementMergeDirectives based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            ClassHasElementMergeDirectives type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from ClassHasElementMergeDirectives, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectivesSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ClassHasElementMergeDirectives itself) instance of ClassHasElementMergeDirectives based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectivesSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ClassHasElementMergeDirectives based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectivesSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectivesSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectivesSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of ClassHasElementMergeDirectives.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectivesSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectivesSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectivesSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasElementMergeDirectivesSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegmentsSerializer">
            <summary>
            Serializer PathHasSegmentsSerializer for DomainClass PathHasSegments.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegmentsSerializer.#ctor">
            <summary>
            PathHasSegmentsSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegmentsSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one PathHasSegments instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the PathHasSegments element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory PathHasSegments instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegmentsSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player Segment.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory PathHasSegments instance that will link to the target PathSegment instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegmentsSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of PathHasSegments based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized PathHasSegments, a new PathHasSegments instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created PathHasSegments instance, or null if the reader is not pointing to a serialized PathHasSegments instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegmentsSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of PathHasSegments based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of PathHasSegments.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new PathHasSegments instance should be created.</param>	
            <returns>Created PathHasSegments instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegmentsSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of PathHasSegments based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            PathHasSegments type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from PathHasSegments, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegmentsSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including PathHasSegments itself) instance of PathHasSegments based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegmentsSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of PathHasSegments based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegmentsSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegmentsSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegmentsSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of PathHasSegments.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegmentsSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegmentsSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegmentsSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegmentsSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptorSerializer">
            <summary>
            Serializer CustomPropertyDescriptorSerializer for DomainClass CustomPropertyDescriptor.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptorSerializer.#ctor">
            <summary>
            CustomPropertyDescriptorSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptorSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one CustomPropertyDescriptor instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the CustomPropertyDescriptor element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory CustomPropertyDescriptor instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptorSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player DistantPropertyPath.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory CustomPropertyDescriptor instance that will link to the target PropertyPath instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptorSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory CustomPropertyDescriptor instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptorSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of CustomPropertyDescriptor based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized CustomPropertyDescriptor, a new CustomPropertyDescriptor instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created CustomPropertyDescriptor instance, or null if the reader is not pointing to a serialized CustomPropertyDescriptor instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptorSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of CustomPropertyDescriptor based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of CustomPropertyDescriptor.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new CustomPropertyDescriptor instance should be created.</param>	
            <returns>Created CustomPropertyDescriptor instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptorSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of CustomPropertyDescriptor based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            CustomPropertyDescriptor type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from CustomPropertyDescriptor, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptorSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including CustomPropertyDescriptor itself) instance of CustomPropertyDescriptor based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptorSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of CustomPropertyDescriptor based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptorSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized CustomPropertyDescriptor instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">CustomPropertyDescriptor instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the CustomPropertyDescriptor instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the CustomPropertyDescriptor instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptorSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one CustomPropertyDescriptor instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">CustomPropertyDescriptor instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptorSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">CustomPropertyDescriptor instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptorSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given CustomPropertyDescriptor instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">CustomPropertyDescriptor instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the CustomPropertyDescriptor instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptorSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">CustomPropertyDescriptor instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptorSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of CustomPropertyDescriptor.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptorSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptorSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptorSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptorSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPathSerializer">
            <summary>
            Serializer ExplorerNodeSettingsHasPropertyDisplayedPathSerializer for DomainClass ExplorerNodeSettingsHasPropertyDisplayedPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPathSerializer.#ctor">
            <summary>
            ExplorerNodeSettingsHasPropertyDisplayedPathSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPathSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one ExplorerNodeSettingsHasPropertyDisplayedPath instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ExplorerNodeSettingsHasPropertyDisplayedPath element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ExplorerNodeSettingsHasPropertyDisplayedPath instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPathSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player PropertyDisplayedPath.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ExplorerNodeSettingsHasPropertyDisplayedPath instance that will link to the target PropertyPath instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPathSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ExplorerNodeSettingsHasPropertyDisplayedPath based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ExplorerNodeSettingsHasPropertyDisplayedPath, a new ExplorerNodeSettingsHasPropertyDisplayedPath instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ExplorerNodeSettingsHasPropertyDisplayedPath instance, or null if the reader is not pointing to a serialized ExplorerNodeSettingsHasPropertyDisplayedPath instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPathSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ExplorerNodeSettingsHasPropertyDisplayedPath based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ExplorerNodeSettingsHasPropertyDisplayedPath.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ExplorerNodeSettingsHasPropertyDisplayedPath instance should be created.</param>	
            <returns>Created ExplorerNodeSettingsHasPropertyDisplayedPath instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPathSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of ExplorerNodeSettingsHasPropertyDisplayedPath based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            ExplorerNodeSettingsHasPropertyDisplayedPath type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from ExplorerNodeSettingsHasPropertyDisplayedPath, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPathSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ExplorerNodeSettingsHasPropertyDisplayedPath itself) instance of ExplorerNodeSettingsHasPropertyDisplayedPath based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPathSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ExplorerNodeSettingsHasPropertyDisplayedPath based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPathSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPathSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPathSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of ExplorerNodeSettingsHasPropertyDisplayedPath.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPathSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPathSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPathSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsHasPropertyDisplayedPathSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptorSerializer">
            <summary>
            Serializer DomainClassHasCustomTypeDescriptorSerializer for DomainClass DomainClassHasCustomTypeDescriptor.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptorSerializer.#ctor">
            <summary>
            DomainClassHasCustomTypeDescriptorSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptorSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DomainClassHasCustomTypeDescriptor instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DomainClassHasCustomTypeDescriptor element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainClassHasCustomTypeDescriptor instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptorSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player CustomTypeDescriptor.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainClassHasCustomTypeDescriptor instance that will link to the target DomainTypeDescriptor instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptorSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DomainClassHasCustomTypeDescriptor based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DomainClassHasCustomTypeDescriptor, a new DomainClassHasCustomTypeDescriptor instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DomainClassHasCustomTypeDescriptor instance, or null if the reader is not pointing to a serialized DomainClassHasCustomTypeDescriptor instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptorSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DomainClassHasCustomTypeDescriptor based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DomainClassHasCustomTypeDescriptor.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DomainClassHasCustomTypeDescriptor instance should be created.</param>	
            <returns>Created DomainClassHasCustomTypeDescriptor instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptorSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of DomainClassHasCustomTypeDescriptor based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            DomainClassHasCustomTypeDescriptor type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from DomainClassHasCustomTypeDescriptor, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptorSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DomainClassHasCustomTypeDescriptor itself) instance of DomainClassHasCustomTypeDescriptor based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptorSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DomainClassHasCustomTypeDescriptor based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptorSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptorSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptorSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DomainClassHasCustomTypeDescriptor.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptorSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptorSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptorSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassHasCustomTypeDescriptorSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodesSerializer">
            <summary>
            Serializer ExplorerHidesNodesSerializer for DomainClass ExplorerHidesNodes.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodesSerializer.#ctor">
            <summary>
            ExplorerHidesNodesSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodesSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one ExplorerHidesNodes instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ExplorerHidesNodes element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ExplorerHidesNodes instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodesSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player HiddenNode.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ExplorerHidesNodes instance that will link to the target DomainPath instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodesSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ExplorerHidesNodes based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ExplorerHidesNodes, a new ExplorerHidesNodes instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ExplorerHidesNodes instance, or null if the reader is not pointing to a serialized ExplorerHidesNodes instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodesSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ExplorerHidesNodes based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ExplorerHidesNodes.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ExplorerHidesNodes instance should be created.</param>	
            <returns>Created ExplorerHidesNodes instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodesSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of ExplorerHidesNodes based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            ExplorerHidesNodes type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from ExplorerHidesNodes, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodesSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ExplorerHidesNodes itself) instance of ExplorerHidesNodes based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodesSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ExplorerHidesNodes based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodesSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodesSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodesSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of ExplorerHidesNodes.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodesSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodesSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodesSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerHidesNodesSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettingsSerializer">
            <summary>
            Serializer ExplorerBehaviorHasNodeSettingsSerializer for DomainClass ExplorerBehaviorHasNodeSettings.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettingsSerializer.#ctor">
            <summary>
            ExplorerBehaviorHasNodeSettingsSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettingsSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one ExplorerBehaviorHasNodeSettings instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ExplorerBehaviorHasNodeSettings element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ExplorerBehaviorHasNodeSettings instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettingsSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player CustomNodeSettings.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ExplorerBehaviorHasNodeSettings instance that will link to the target ExplorerNodeSettings instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettingsSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ExplorerBehaviorHasNodeSettings based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ExplorerBehaviorHasNodeSettings, a new ExplorerBehaviorHasNodeSettings instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ExplorerBehaviorHasNodeSettings instance, or null if the reader is not pointing to a serialized ExplorerBehaviorHasNodeSettings instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettingsSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ExplorerBehaviorHasNodeSettings based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ExplorerBehaviorHasNodeSettings.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ExplorerBehaviorHasNodeSettings instance should be created.</param>	
            <returns>Created ExplorerBehaviorHasNodeSettings instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettingsSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of ExplorerBehaviorHasNodeSettings based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            ExplorerBehaviorHasNodeSettings type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from ExplorerBehaviorHasNodeSettings, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettingsSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ExplorerBehaviorHasNodeSettings itself) instance of ExplorerBehaviorHasNodeSettings based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettingsSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ExplorerBehaviorHasNodeSettings based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettingsSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettingsSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettingsSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of ExplorerBehaviorHasNodeSettings.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettingsSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettingsSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettingsSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerBehaviorHasNodeSettingsSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecoratorsSerializer">
            <summary>
            Serializer ShapeHasDecoratorsSerializer for DomainClass ShapeHasDecorators.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecoratorsSerializer">
            <summary>
            Serializer DiagramElementHasDecoratorsSerializer for DomainClass DiagramElementHasDecorators.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecoratorsSerializer.#ctor">
            <summary>
            DiagramElementHasDecoratorsSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecoratorsSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            DiagramElementHasDecorators is abstract and cannot be instantiated, so this method throws NotSupportedException.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DiagramElementHasDecorators element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DiagramElementHasDecorators instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecoratorsSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player Decorator.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DiagramElementHasDecorators instance that will link to the target Decorator instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecoratorsSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DiagramElementHasDecorators instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecoratorsSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DiagramElementHasDecorators instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecoratorsSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DiagramElementHasDecorators based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DiagramElementHasDecorators, a new DiagramElementHasDecorators instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DiagramElementHasDecorators instance, or null if the reader is not pointing to a serialized DiagramElementHasDecorators instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecoratorsSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DiagramElementHasDecorators based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DiagramElementHasDecorators.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DiagramElementHasDecorators instance should be created.</param>	
            <returns>Created DiagramElementHasDecorators instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecoratorsSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of DiagramElementHasDecorators based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            DiagramElementHasDecorators type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from DiagramElementHasDecorators, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecoratorsSerializer.derivedClasses">
            <summary>
            Stores a mapping from XmlTagName to DomainClassInfo that derives from DiagramElementHasDecorators, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecoratorsSerializer.ConstructDerivedClassesLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the apping from XmlTagName to DomainClassInfo that derives from DiagramElementHasDecorators.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecoratorsSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DiagramElementHasDecorators itself) instance of DiagramElementHasDecorators based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecoratorsSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DiagramElementHasDecorators based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecoratorsSerializer.derivedClassMonikers">
            <summary>
            Stores a mapping from Moniker Xml tag name to DomainClassInfo that derives from DiagramElementHasDecorators, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecoratorsSerializer.ConstructDerivedClassMonikersLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the mapping from Moniker Xml tag name to DomainClassInfo that derives from DiagramElementHasDecorators.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecoratorsSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized DiagramElementHasDecorators instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DiagramElementHasDecorators instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the DiagramElementHasDecorators instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the DiagramElementHasDecorators instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecoratorsSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one DiagramElementHasDecorators instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DiagramElementHasDecorators instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecoratorsSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DiagramElementHasDecorators instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecoratorsSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DiagramElementHasDecorators instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecoratorsSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given DiagramElementHasDecorators instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DiagramElementHasDecorators instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the DiagramElementHasDecorators instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecoratorsSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DiagramElementHasDecorators instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecoratorsSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecoratorsSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecoratorsSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecoratorsSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecoratorsSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecoratorsSerializer.#ctor">
            <summary>
            ShapeHasDecoratorsSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecoratorsSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one ShapeHasDecorators instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ShapeHasDecorators element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ShapeHasDecorators instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecoratorsSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ShapeHasDecorators instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecoratorsSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ShapeHasDecorators based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ShapeHasDecorators, a new ShapeHasDecorators instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ShapeHasDecorators instance, or null if the reader is not pointing to a serialized ShapeHasDecorators instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecoratorsSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ShapeHasDecorators based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ShapeHasDecorators.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ShapeHasDecorators instance should be created.</param>	
            <returns>Created ShapeHasDecorators instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecoratorsSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of ShapeHasDecorators based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            ShapeHasDecorators type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from ShapeHasDecorators, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecoratorsSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ShapeHasDecorators itself) instance of ShapeHasDecorators based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecoratorsSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ShapeHasDecorators based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecoratorsSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized ShapeHasDecorators instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ShapeHasDecorators instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the ShapeHasDecorators instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the ShapeHasDecorators instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecoratorsSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one ShapeHasDecorators instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ShapeHasDecorators instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecoratorsSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ShapeHasDecorators instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecoratorsSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given ShapeHasDecorators instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ShapeHasDecorators instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the ShapeHasDecorators instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecoratorsSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ShapeHasDecorators instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecoratorsSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of ShapeHasDecorators.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecoratorsSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecoratorsSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecoratorsSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeHasDecoratorsSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecoratorsSerializer">
            <summary>
            Serializer ConnectorHasDecoratorsSerializer for DomainClass ConnectorHasDecorators.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecoratorsSerializer.#ctor">
            <summary>
            ConnectorHasDecoratorsSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecoratorsSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one ConnectorHasDecorators instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ConnectorHasDecorators element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ConnectorHasDecorators instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecoratorsSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ConnectorHasDecorators instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecoratorsSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ConnectorHasDecorators based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ConnectorHasDecorators, a new ConnectorHasDecorators instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ConnectorHasDecorators instance, or null if the reader is not pointing to a serialized ConnectorHasDecorators instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecoratorsSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ConnectorHasDecorators based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ConnectorHasDecorators.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ConnectorHasDecorators instance should be created.</param>	
            <returns>Created ConnectorHasDecorators instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecoratorsSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of ConnectorHasDecorators based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            ConnectorHasDecorators type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from ConnectorHasDecorators, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecoratorsSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ConnectorHasDecorators itself) instance of ConnectorHasDecorators based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecoratorsSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ConnectorHasDecorators based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecoratorsSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized ConnectorHasDecorators instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ConnectorHasDecorators instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the ConnectorHasDecorators instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the ConnectorHasDecorators instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecoratorsSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one ConnectorHasDecorators instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ConnectorHasDecorators instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecoratorsSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ConnectorHasDecorators instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecoratorsSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given ConnectorHasDecorators instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ConnectorHasDecorators instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the ConnectorHasDecorators instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecoratorsSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ConnectorHasDecorators instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecoratorsSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of ConnectorHasDecorators.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecoratorsSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecoratorsSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecoratorsSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasDecoratorsSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectorsSerializer">
            <summary>
            Serializer DslLibraryDefinesConnectorsSerializer for DomainClass DslLibraryDefinesConnectors.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElementsSerializer">
            <summary>
            Serializer DslLibraryDefinesElementsSerializer for DomainClass DslLibraryDefinesElements.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElementsSerializer.#ctor">
            <summary>
            DslLibraryDefinesElementsSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElementsSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            DslLibraryDefinesElements is abstract and cannot be instantiated, so this method throws NotSupportedException.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DslLibraryDefinesElements element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslLibraryDefinesElements instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElementsSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DslLibraryDefinesElements based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DslLibraryDefinesElements, a new DslLibraryDefinesElements instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DslLibraryDefinesElements instance, or null if the reader is not pointing to a serialized DslLibraryDefinesElements instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElementsSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DslLibraryDefinesElements based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DslLibraryDefinesElements.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DslLibraryDefinesElements instance should be created.</param>	
            <returns>Created DslLibraryDefinesElements instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElementsSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of DslLibraryDefinesElements based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            DslLibraryDefinesElements type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from DslLibraryDefinesElements, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElementsSerializer.derivedClasses">
            <summary>
            Stores a mapping from XmlTagName to DomainClassInfo that derives from DslLibraryDefinesElements, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElementsSerializer.ConstructDerivedClassesLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the apping from XmlTagName to DomainClassInfo that derives from DslLibraryDefinesElements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElementsSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DslLibraryDefinesElements itself) instance of DslLibraryDefinesElements based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElementsSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DslLibraryDefinesElements based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElementsSerializer.derivedClassMonikers">
            <summary>
            Stores a mapping from Moniker Xml tag name to DomainClassInfo that derives from DslLibraryDefinesElements, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElementsSerializer.ConstructDerivedClassMonikersLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the mapping from Moniker Xml tag name to DomainClassInfo that derives from DslLibraryDefinesElements.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElementsSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized DslLibraryDefinesElements instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DslLibraryDefinesElements instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the DslLibraryDefinesElements instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the DslLibraryDefinesElements instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElementsSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one DslLibraryDefinesElements instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DslLibraryDefinesElements instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElementsSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given DslLibraryDefinesElements instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DslLibraryDefinesElements instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the DslLibraryDefinesElements instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElementsSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DslLibraryDefinesElements instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElementsSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElementsSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElementsSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElementsSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesElementsSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectorsSerializer.#ctor">
            <summary>
            DslLibraryDefinesConnectorsSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectorsSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DslLibraryDefinesConnectors instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DslLibraryDefinesConnectors element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslLibraryDefinesConnectors instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectorsSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player Connector.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslLibraryDefinesConnectors instance that will link to the target Connector instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectorsSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DslLibraryDefinesConnectors based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DslLibraryDefinesConnectors, a new DslLibraryDefinesConnectors instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DslLibraryDefinesConnectors instance, or null if the reader is not pointing to a serialized DslLibraryDefinesConnectors instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectorsSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DslLibraryDefinesConnectors based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DslLibraryDefinesConnectors.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DslLibraryDefinesConnectors instance should be created.</param>	
            <returns>Created DslLibraryDefinesConnectors instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectorsSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of DslLibraryDefinesConnectors based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            DslLibraryDefinesConnectors type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from DslLibraryDefinesConnectors, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectorsSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DslLibraryDefinesConnectors itself) instance of DslLibraryDefinesConnectors based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectorsSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DslLibraryDefinesConnectors based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectorsSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectorsSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectorsSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DslLibraryDefinesConnectors.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectorsSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectorsSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectorsSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesConnectorsSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapesSerializer">
            <summary>
            Serializer DslLibraryDefinesShapesSerializer for DomainClass DslLibraryDefinesShapes.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapesSerializer.#ctor">
            <summary>
            DslLibraryDefinesShapesSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapesSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DslLibraryDefinesShapes instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DslLibraryDefinesShapes element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslLibraryDefinesShapes instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapesSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player Shape.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslLibraryDefinesShapes instance that will link to the target BaseShape instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapesSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DslLibraryDefinesShapes based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DslLibraryDefinesShapes, a new DslLibraryDefinesShapes instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DslLibraryDefinesShapes instance, or null if the reader is not pointing to a serialized DslLibraryDefinesShapes instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapesSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DslLibraryDefinesShapes based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DslLibraryDefinesShapes.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DslLibraryDefinesShapes instance should be created.</param>	
            <returns>Created DslLibraryDefinesShapes instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapesSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of DslLibraryDefinesShapes based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            DslLibraryDefinesShapes type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from DslLibraryDefinesShapes, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapesSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DslLibraryDefinesShapes itself) instance of DslLibraryDefinesShapes based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapesSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DslLibraryDefinesShapes based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapesSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapesSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapesSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DslLibraryDefinesShapes.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapesSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapesSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapesSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslLibraryDefinesShapesSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPathSerializer">
            <summary>
            Serializer CompartmentMapHasElementsDisplayedPathSerializer for DomainClass CompartmentMapHasElementsDisplayedPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPathSerializer.#ctor">
            <summary>
            CompartmentMapHasElementsDisplayedPathSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPathSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one CompartmentMapHasElementsDisplayedPath instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the CompartmentMapHasElementsDisplayedPath element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory CompartmentMapHasElementsDisplayedPath instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPathSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player Path.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory CompartmentMapHasElementsDisplayedPath instance that will link to the target DomainPath instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPathSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of CompartmentMapHasElementsDisplayedPath based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized CompartmentMapHasElementsDisplayedPath, a new CompartmentMapHasElementsDisplayedPath instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created CompartmentMapHasElementsDisplayedPath instance, or null if the reader is not pointing to a serialized CompartmentMapHasElementsDisplayedPath instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPathSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of CompartmentMapHasElementsDisplayedPath based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of CompartmentMapHasElementsDisplayedPath.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new CompartmentMapHasElementsDisplayedPath instance should be created.</param>	
            <returns>Created CompartmentMapHasElementsDisplayedPath instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPathSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of CompartmentMapHasElementsDisplayedPath based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            CompartmentMapHasElementsDisplayedPath type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from CompartmentMapHasElementsDisplayedPath, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPathSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including CompartmentMapHasElementsDisplayedPath itself) instance of CompartmentMapHasElementsDisplayedPath based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPathSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of CompartmentMapHasElementsDisplayedPath based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPathSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPathSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPathSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of CompartmentMapHasElementsDisplayedPath.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPathSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPathSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPathSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasElementsDisplayedPathSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPathSerializer">
            <summary>
            Serializer ShapeMapHasParentElementPathSerializer for DomainClass ShapeMapHasParentElementPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPathSerializer.#ctor">
            <summary>
            ShapeMapHasParentElementPathSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPathSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one ShapeMapHasParentElementPath instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ShapeMapHasParentElementPath element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ShapeMapHasParentElementPath instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPathSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player ParentElementPath.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ShapeMapHasParentElementPath instance that will link to the target DomainPath instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPathSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ShapeMapHasParentElementPath based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ShapeMapHasParentElementPath, a new ShapeMapHasParentElementPath instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ShapeMapHasParentElementPath instance, or null if the reader is not pointing to a serialized ShapeMapHasParentElementPath instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPathSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ShapeMapHasParentElementPath based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ShapeMapHasParentElementPath.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ShapeMapHasParentElementPath instance should be created.</param>	
            <returns>Created ShapeMapHasParentElementPath instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPathSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of ShapeMapHasParentElementPath based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            ShapeMapHasParentElementPath type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from ShapeMapHasParentElementPath, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPathSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ShapeMapHasParentElementPath itself) instance of ShapeMapHasParentElementPath based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPathSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ShapeMapHasParentElementPath based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPathSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPathSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPathSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of ShapeMapHasParentElementPath.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPathSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPathSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPathSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapHasParentElementPathSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPathSerializer">
            <summary>
            Serializer CompartmentMapHasPropertyDisplayedPathSerializer for DomainClass CompartmentMapHasPropertyDisplayedPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPathSerializer.#ctor">
            <summary>
            CompartmentMapHasPropertyDisplayedPathSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPathSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one CompartmentMapHasPropertyDisplayedPath instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the CompartmentMapHasPropertyDisplayedPath element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory CompartmentMapHasPropertyDisplayedPath instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPathSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player PropertyPath.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory CompartmentMapHasPropertyDisplayedPath instance that will link to the target PropertyPath instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPathSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of CompartmentMapHasPropertyDisplayedPath based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized CompartmentMapHasPropertyDisplayedPath, a new CompartmentMapHasPropertyDisplayedPath instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created CompartmentMapHasPropertyDisplayedPath instance, or null if the reader is not pointing to a serialized CompartmentMapHasPropertyDisplayedPath instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPathSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of CompartmentMapHasPropertyDisplayedPath based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of CompartmentMapHasPropertyDisplayedPath.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new CompartmentMapHasPropertyDisplayedPath instance should be created.</param>	
            <returns>Created CompartmentMapHasPropertyDisplayedPath instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPathSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of CompartmentMapHasPropertyDisplayedPath based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            CompartmentMapHasPropertyDisplayedPath type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from CompartmentMapHasPropertyDisplayedPath, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPathSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including CompartmentMapHasPropertyDisplayedPath itself) instance of CompartmentMapHasPropertyDisplayedPath based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPathSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of CompartmentMapHasPropertyDisplayedPath based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPathSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPathSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPathSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of CompartmentMapHasPropertyDisplayedPath.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPathSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPathSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPathSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapHasPropertyDisplayedPathSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPathSerializer">
            <summary>
            Serializer DecoratorMapHasPropertyDisplayedPathSerializer for DomainClass DecoratorMapHasPropertyDisplayedPath.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPathSerializer.#ctor">
            <summary>
            DecoratorMapHasPropertyDisplayedPathSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPathSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DecoratorMapHasPropertyDisplayedPath instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DecoratorMapHasPropertyDisplayedPath element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DecoratorMapHasPropertyDisplayedPath instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPathSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player PropertyPath.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DecoratorMapHasPropertyDisplayedPath instance that will link to the target PropertyPath instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPathSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DecoratorMapHasPropertyDisplayedPath based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DecoratorMapHasPropertyDisplayedPath, a new DecoratorMapHasPropertyDisplayedPath instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DecoratorMapHasPropertyDisplayedPath instance, or null if the reader is not pointing to a serialized DecoratorMapHasPropertyDisplayedPath instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPathSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DecoratorMapHasPropertyDisplayedPath based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DecoratorMapHasPropertyDisplayedPath.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DecoratorMapHasPropertyDisplayedPath instance should be created.</param>	
            <returns>Created DecoratorMapHasPropertyDisplayedPath instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPathSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of DecoratorMapHasPropertyDisplayedPath based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            DecoratorMapHasPropertyDisplayedPath type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from DecoratorMapHasPropertyDisplayedPath, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPathSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DecoratorMapHasPropertyDisplayedPath itself) instance of DecoratorMapHasPropertyDisplayedPath based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPathSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DecoratorMapHasPropertyDisplayedPath based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPathSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPathSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPathSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DecoratorMapHasPropertyDisplayedPath.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPathSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPathSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPathSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapHasPropertyDisplayedPathSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFiltersSerializer">
            <summary>
            Serializer VisibilityPropertyPathHasPropertyFiltersSerializer for DomainClass VisibilityPropertyPathHasPropertyFilters.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFiltersSerializer.#ctor">
            <summary>
            VisibilityPropertyPathHasPropertyFiltersSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFiltersSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one VisibilityPropertyPathHasPropertyFilters instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the VisibilityPropertyPathHasPropertyFilters element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory VisibilityPropertyPathHasPropertyFilters instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFiltersSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player PropertyFilter.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory VisibilityPropertyPathHasPropertyFilters instance that will link to the target PropertyFilter instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFiltersSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of VisibilityPropertyPathHasPropertyFilters based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized VisibilityPropertyPathHasPropertyFilters, a new VisibilityPropertyPathHasPropertyFilters instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created VisibilityPropertyPathHasPropertyFilters instance, or null if the reader is not pointing to a serialized VisibilityPropertyPathHasPropertyFilters instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFiltersSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of VisibilityPropertyPathHasPropertyFilters based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of VisibilityPropertyPathHasPropertyFilters.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new VisibilityPropertyPathHasPropertyFilters instance should be created.</param>	
            <returns>Created VisibilityPropertyPathHasPropertyFilters instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFiltersSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of VisibilityPropertyPathHasPropertyFilters based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            VisibilityPropertyPathHasPropertyFilters type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from VisibilityPropertyPathHasPropertyFilters, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFiltersSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including VisibilityPropertyPathHasPropertyFilters itself) instance of VisibilityPropertyPathHasPropertyFilters based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFiltersSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of VisibilityPropertyPathHasPropertyFilters based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFiltersSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFiltersSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFiltersSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of VisibilityPropertyPathHasPropertyFilters.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFiltersSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFiltersSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFiltersSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.VisibilityPropertyPathHasPropertyFiltersSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMapsSerializer">
            <summary>
            Serializer DiagramHasShapeMapsSerializer for DomainClass DiagramHasShapeMaps.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMapsSerializer.#ctor">
            <summary>
            DiagramHasShapeMapsSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMapsSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DiagramHasShapeMaps instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DiagramHasShapeMaps element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DiagramHasShapeMaps instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMapsSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player ShapeMap.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DiagramHasShapeMaps instance that will link to the target BaseShapeMap instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMapsSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DiagramHasShapeMaps based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DiagramHasShapeMaps, a new DiagramHasShapeMaps instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DiagramHasShapeMaps instance, or null if the reader is not pointing to a serialized DiagramHasShapeMaps instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMapsSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DiagramHasShapeMaps based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DiagramHasShapeMaps.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DiagramHasShapeMaps instance should be created.</param>	
            <returns>Created DiagramHasShapeMaps instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMapsSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of DiagramHasShapeMaps based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            DiagramHasShapeMaps type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from DiagramHasShapeMaps, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMapsSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DiagramHasShapeMaps itself) instance of DiagramHasShapeMaps based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMapsSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DiagramHasShapeMaps based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMapsSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMapsSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMapsSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DiagramHasShapeMaps.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMapsSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMapsSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMapsSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasShapeMapsSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMapsSerializer">
            <summary>
            Serializer DiagramHasConnectorMapsSerializer for DomainClass DiagramHasConnectorMaps.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMapsSerializer.#ctor">
            <summary>
            DiagramHasConnectorMapsSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMapsSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DiagramHasConnectorMaps instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DiagramHasConnectorMaps element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DiagramHasConnectorMaps instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMapsSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player ConnectorMap.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DiagramHasConnectorMaps instance that will link to the target ConnectorMap instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMapsSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DiagramHasConnectorMaps based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DiagramHasConnectorMaps, a new DiagramHasConnectorMaps instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DiagramHasConnectorMaps instance, or null if the reader is not pointing to a serialized DiagramHasConnectorMaps instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMapsSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DiagramHasConnectorMaps based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DiagramHasConnectorMaps.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DiagramHasConnectorMaps instance should be created.</param>	
            <returns>Created DiagramHasConnectorMaps instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMapsSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of DiagramHasConnectorMaps based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            DiagramHasConnectorMaps type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from DiagramHasConnectorMaps, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMapsSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DiagramHasConnectorMaps itself) instance of DiagramHasConnectorMaps based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMapsSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DiagramHasConnectorMaps based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMapsSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMapsSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMapsSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DiagramHasConnectorMaps.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMapsSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMapsSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMapsSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasConnectorMapsSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMapsSerializer">
            <summary>
            Serializer DiagramElementMapHasDecoratorMapsSerializer for DomainClass DiagramElementMapHasDecoratorMaps.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMapsSerializer.#ctor">
            <summary>
            DiagramElementMapHasDecoratorMapsSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMapsSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            DiagramElementMapHasDecoratorMaps is abstract and cannot be instantiated, so this method throws NotSupportedException.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DiagramElementMapHasDecoratorMaps element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DiagramElementMapHasDecoratorMaps instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMapsSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player DecoratorMap.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DiagramElementMapHasDecoratorMaps instance that will link to the target DecoratorMap instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMapsSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DiagramElementMapHasDecoratorMaps instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMapsSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DiagramElementMapHasDecoratorMaps instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMapsSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DiagramElementMapHasDecoratorMaps based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DiagramElementMapHasDecoratorMaps, a new DiagramElementMapHasDecoratorMaps instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DiagramElementMapHasDecoratorMaps instance, or null if the reader is not pointing to a serialized DiagramElementMapHasDecoratorMaps instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMapsSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DiagramElementMapHasDecoratorMaps based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DiagramElementMapHasDecoratorMaps.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DiagramElementMapHasDecoratorMaps instance should be created.</param>	
            <returns>Created DiagramElementMapHasDecoratorMaps instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMapsSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of DiagramElementMapHasDecoratorMaps based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            DiagramElementMapHasDecoratorMaps type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from DiagramElementMapHasDecoratorMaps, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMapsSerializer.derivedClasses">
            <summary>
            Stores a mapping from XmlTagName to DomainClassInfo that derives from DiagramElementMapHasDecoratorMaps, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMapsSerializer.ConstructDerivedClassesLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the apping from XmlTagName to DomainClassInfo that derives from DiagramElementMapHasDecoratorMaps.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMapsSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DiagramElementMapHasDecoratorMaps itself) instance of DiagramElementMapHasDecoratorMaps based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMapsSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DiagramElementMapHasDecoratorMaps based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMapsSerializer.derivedClassMonikers">
            <summary>
            Stores a mapping from Moniker Xml tag name to DomainClassInfo that derives from DiagramElementMapHasDecoratorMaps, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMapsSerializer.ConstructDerivedClassMonikersLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the mapping from Moniker Xml tag name to DomainClassInfo that derives from DiagramElementMapHasDecoratorMaps.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMapsSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized DiagramElementMapHasDecoratorMaps instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DiagramElementMapHasDecoratorMaps instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the DiagramElementMapHasDecoratorMaps instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the DiagramElementMapHasDecoratorMaps instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMapsSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one DiagramElementMapHasDecoratorMaps instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DiagramElementMapHasDecoratorMaps instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMapsSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DiagramElementMapHasDecoratorMaps instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMapsSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DiagramElementMapHasDecoratorMaps instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMapsSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given DiagramElementMapHasDecoratorMaps instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DiagramElementMapHasDecoratorMaps instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the DiagramElementMapHasDecoratorMaps instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMapsSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DiagramElementMapHasDecoratorMaps instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMapsSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMapsSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMapsSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMapsSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMapHasDecoratorMapsSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassDataSerializer">
            <summary>
            Serializer XmlSerializationBehaviorHasXmlClassDataSerializer for DomainClass XmlSerializationBehaviorHasXmlClassData.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassDataSerializer.#ctor">
            <summary>
            XmlSerializationBehaviorHasXmlClassDataSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassDataSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one XmlSerializationBehaviorHasXmlClassData instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the XmlSerializationBehaviorHasXmlClassData element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory XmlSerializationBehaviorHasXmlClassData instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassDataSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player ClassData.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory XmlSerializationBehaviorHasXmlClassData instance that will link to the target XmlClassData instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassDataSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of XmlSerializationBehaviorHasXmlClassData based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized XmlSerializationBehaviorHasXmlClassData, a new XmlSerializationBehaviorHasXmlClassData instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created XmlSerializationBehaviorHasXmlClassData instance, or null if the reader is not pointing to a serialized XmlSerializationBehaviorHasXmlClassData instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassDataSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of XmlSerializationBehaviorHasXmlClassData based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of XmlSerializationBehaviorHasXmlClassData.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new XmlSerializationBehaviorHasXmlClassData instance should be created.</param>	
            <returns>Created XmlSerializationBehaviorHasXmlClassData instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassDataSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of XmlSerializationBehaviorHasXmlClassData based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            XmlSerializationBehaviorHasXmlClassData type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from XmlSerializationBehaviorHasXmlClassData, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassDataSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including XmlSerializationBehaviorHasXmlClassData itself) instance of XmlSerializationBehaviorHasXmlClassData based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassDataSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of XmlSerializationBehaviorHasXmlClassData based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassDataSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassDataSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassDataSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of XmlSerializationBehaviorHasXmlClassData.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassDataSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassDataSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassDataSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationBehaviorHasXmlClassDataSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementDataSerializer">
            <summary>
            Serializer XmlClassDataHasXmlElementDataSerializer for DomainClass XmlClassDataHasXmlElementData.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementDataSerializer.#ctor">
            <summary>
            XmlClassDataHasXmlElementDataSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementDataSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one XmlClassDataHasXmlElementData instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the XmlClassDataHasXmlElementData element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory XmlClassDataHasXmlElementData instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementDataSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player XmlElementData.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory XmlClassDataHasXmlElementData instance that will link to the target XmlElementData instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementDataSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of XmlClassDataHasXmlElementData based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized XmlClassDataHasXmlElementData, a new XmlClassDataHasXmlElementData instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created XmlClassDataHasXmlElementData instance, or null if the reader is not pointing to a serialized XmlClassDataHasXmlElementData instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementDataSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of XmlClassDataHasXmlElementData based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of XmlClassDataHasXmlElementData.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new XmlClassDataHasXmlElementData instance should be created.</param>	
            <returns>Created XmlClassDataHasXmlElementData instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementDataSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of XmlClassDataHasXmlElementData based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            XmlClassDataHasXmlElementData type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from XmlClassDataHasXmlElementData, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementDataSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including XmlClassDataHasXmlElementData itself) instance of XmlClassDataHasXmlElementData based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementDataSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of XmlClassDataHasXmlElementData based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementDataSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementDataSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementDataSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of XmlClassDataHasXmlElementData.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementDataSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementDataSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementDataSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataHasXmlElementDataSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecoratorsSerializer">
            <summary>
            Serializer SwimLaneHasDecoratorsSerializer for DomainClass SwimLaneHasDecorators.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecoratorsSerializer.#ctor">
            <summary>
            SwimLaneHasDecoratorsSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecoratorsSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one SwimLaneHasDecorators instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the SwimLaneHasDecorators element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory SwimLaneHasDecorators instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecoratorsSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory SwimLaneHasDecorators instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecoratorsSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of SwimLaneHasDecorators based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized SwimLaneHasDecorators, a new SwimLaneHasDecorators instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created SwimLaneHasDecorators instance, or null if the reader is not pointing to a serialized SwimLaneHasDecorators instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecoratorsSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of SwimLaneHasDecorators based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of SwimLaneHasDecorators.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new SwimLaneHasDecorators instance should be created.</param>	
            <returns>Created SwimLaneHasDecorators instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecoratorsSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of SwimLaneHasDecorators based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            SwimLaneHasDecorators type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from SwimLaneHasDecorators, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecoratorsSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including SwimLaneHasDecorators itself) instance of SwimLaneHasDecorators based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecoratorsSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of SwimLaneHasDecorators based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecoratorsSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized SwimLaneHasDecorators instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">SwimLaneHasDecorators instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the SwimLaneHasDecorators instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the SwimLaneHasDecorators instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecoratorsSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one SwimLaneHasDecorators instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">SwimLaneHasDecorators instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecoratorsSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">SwimLaneHasDecorators instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecoratorsSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given SwimLaneHasDecorators instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">SwimLaneHasDecorators instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the SwimLaneHasDecorators instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecoratorsSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">SwimLaneHasDecorators instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecoratorsSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of SwimLaneHasDecorators.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecoratorsSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecoratorsSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecoratorsSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasDecoratorsSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasRootsSerializer">
            <summary>
            Serializer DiagramTreeHasRootsSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasRoots.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasRootsSerializer.#ctor">
            <summary>
            DiagramTreeHasRootsSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasRootsSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DiagramTreeHasRoots instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DiagramTreeHasRoots element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DiagramTreeHasRoots instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasRootsSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player Root.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DiagramTreeHasRoots instance that will link to the target RootNode instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasRootsSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DiagramTreeHasRoots based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DiagramTreeHasRoots, a new DiagramTreeHasRoots instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DiagramTreeHasRoots instance, or null if the reader is not pointing to a serialized DiagramTreeHasRoots instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasRootsSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DiagramTreeHasRoots based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DiagramTreeHasRoots.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DiagramTreeHasRoots instance should be created.</param>	
            <returns>Created DiagramTreeHasRoots instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasRootsSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of DiagramTreeHasRoots based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            DiagramTreeHasRoots type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from DiagramTreeHasRoots, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasRootsSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DiagramTreeHasRoots itself) instance of DiagramTreeHasRoots based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasRootsSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DiagramTreeHasRoots based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasRootsSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasRootsSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasRootsSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DiagramTreeHasRoots.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasRootsSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasRootsSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasRootsSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasRootsSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDomainModelElementTreeSerializer">
            <summary>
            Serializer DslDesignerDiagramStateHasDomainModelElementTreeSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDomainModelElementTree.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramTreesSerializer">
            <summary>
            Serializer DslDesignerDiagramStateHasDiagramTreesSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramTrees.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramTreesSerializer.#ctor">
            <summary>
            DslDesignerDiagramStateHasDiagramTreesSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramTreesSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            DslDesignerDiagramStateHasDiagramTrees is abstract and cannot be instantiated, so this method throws NotSupportedException.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DslDesignerDiagramStateHasDiagramTrees element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslDesignerDiagramStateHasDiagramTrees instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramTreesSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player DiagramTree.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslDesignerDiagramStateHasDiagramTrees instance that will link to the target DslDesignerDiagramTree instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramTreesSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslDesignerDiagramStateHasDiagramTrees instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramTreesSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslDesignerDiagramStateHasDiagramTrees instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramTreesSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DslDesignerDiagramStateHasDiagramTrees based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DslDesignerDiagramStateHasDiagramTrees, a new DslDesignerDiagramStateHasDiagramTrees instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DslDesignerDiagramStateHasDiagramTrees instance, or null if the reader is not pointing to a serialized DslDesignerDiagramStateHasDiagramTrees instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramTreesSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DslDesignerDiagramStateHasDiagramTrees based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DslDesignerDiagramStateHasDiagramTrees.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DslDesignerDiagramStateHasDiagramTrees instance should be created.</param>	
            <returns>Created DslDesignerDiagramStateHasDiagramTrees instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramTreesSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of DslDesignerDiagramStateHasDiagramTrees based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            DslDesignerDiagramStateHasDiagramTrees type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from DslDesignerDiagramStateHasDiagramTrees, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramTreesSerializer.derivedClasses">
            <summary>
            Stores a mapping from XmlTagName to DomainClassInfo that derives from DslDesignerDiagramStateHasDiagramTrees, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramTreesSerializer.ConstructDerivedClassesLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the apping from XmlTagName to DomainClassInfo that derives from DslDesignerDiagramStateHasDiagramTrees.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramTreesSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DslDesignerDiagramStateHasDiagramTrees itself) instance of DslDesignerDiagramStateHasDiagramTrees based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramTreesSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DslDesignerDiagramStateHasDiagramTrees based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramTreesSerializer.derivedClassMonikers">
            <summary>
            Stores a mapping from Moniker Xml tag name to DomainClassInfo that derives from DslDesignerDiagramStateHasDiagramTrees, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramTreesSerializer.ConstructDerivedClassMonikersLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the mapping from Moniker Xml tag name to DomainClassInfo that derives from DslDesignerDiagramStateHasDiagramTrees.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramTreesSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized DslDesignerDiagramStateHasDiagramTrees instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DslDesignerDiagramStateHasDiagramTrees instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the DslDesignerDiagramStateHasDiagramTrees instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the DslDesignerDiagramStateHasDiagramTrees instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramTreesSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one DslDesignerDiagramStateHasDiagramTrees instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DslDesignerDiagramStateHasDiagramTrees instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramTreesSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DslDesignerDiagramStateHasDiagramTrees instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramTreesSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DslDesignerDiagramStateHasDiagramTrees instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramTreesSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given DslDesignerDiagramStateHasDiagramTrees instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DslDesignerDiagramStateHasDiagramTrees instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the DslDesignerDiagramStateHasDiagramTrees instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramTreesSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DslDesignerDiagramStateHasDiagramTrees instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramTreesSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramTreesSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramTreesSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramTreesSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramTreesSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDomainModelElementTreeSerializer.#ctor">
            <summary>
            DslDesignerDiagramStateHasDomainModelElementTreeSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDomainModelElementTreeSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DslDesignerDiagramStateHasDomainModelElementTree instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DslDesignerDiagramStateHasDomainModelElementTree element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslDesignerDiagramStateHasDomainModelElementTree instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDomainModelElementTreeSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DslDesignerDiagramStateHasDomainModelElementTree based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DslDesignerDiagramStateHasDomainModelElementTree, a new DslDesignerDiagramStateHasDomainModelElementTree instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DslDesignerDiagramStateHasDomainModelElementTree instance, or null if the reader is not pointing to a serialized DslDesignerDiagramStateHasDomainModelElementTree instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDomainModelElementTreeSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DslDesignerDiagramStateHasDomainModelElementTree based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DslDesignerDiagramStateHasDomainModelElementTree.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DslDesignerDiagramStateHasDomainModelElementTree instance should be created.</param>	
            <returns>Created DslDesignerDiagramStateHasDomainModelElementTree instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDomainModelElementTreeSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of DslDesignerDiagramStateHasDomainModelElementTree based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            DslDesignerDiagramStateHasDomainModelElementTree type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from DslDesignerDiagramStateHasDomainModelElementTree, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDomainModelElementTreeSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DslDesignerDiagramStateHasDomainModelElementTree itself) instance of DslDesignerDiagramStateHasDomainModelElementTree based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDomainModelElementTreeSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DslDesignerDiagramStateHasDomainModelElementTree based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDomainModelElementTreeSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDomainModelElementTreeSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDomainModelElementTreeSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DslDesignerDiagramStateHasDomainModelElementTree.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDomainModelElementTreeSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDomainModelElementTreeSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDomainModelElementTreeSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDomainModelElementTreeSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramElementTreeSerializer">
            <summary>
            Serializer DslDesignerDiagramStateHasDiagramElementTreeSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramStateHasDiagramElementTree.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramElementTreeSerializer.#ctor">
            <summary>
            DslDesignerDiagramStateHasDiagramElementTreeSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramElementTreeSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DslDesignerDiagramStateHasDiagramElementTree instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DslDesignerDiagramStateHasDiagramElementTree element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslDesignerDiagramStateHasDiagramElementTree instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramElementTreeSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DslDesignerDiagramStateHasDiagramElementTree based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DslDesignerDiagramStateHasDiagramElementTree, a new DslDesignerDiagramStateHasDiagramElementTree instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DslDesignerDiagramStateHasDiagramElementTree instance, or null if the reader is not pointing to a serialized DslDesignerDiagramStateHasDiagramElementTree instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramElementTreeSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DslDesignerDiagramStateHasDiagramElementTree based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DslDesignerDiagramStateHasDiagramElementTree.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DslDesignerDiagramStateHasDiagramElementTree instance should be created.</param>	
            <returns>Created DslDesignerDiagramStateHasDiagramElementTree instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramElementTreeSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of DslDesignerDiagramStateHasDiagramElementTree based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            DslDesignerDiagramStateHasDiagramElementTree type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from DslDesignerDiagramStateHasDiagramElementTree, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramElementTreeSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DslDesignerDiagramStateHasDiagramElementTree itself) instance of DslDesignerDiagramStateHasDiagramElementTree based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramElementTreeSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DslDesignerDiagramStateHasDiagramElementTree based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramElementTreeSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramElementTreeSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramElementTreeSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DslDesignerDiagramStateHasDiagramElementTree.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramElementTreeSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramElementTreeSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramElementTreeSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramStateHasDiagramElementTreeSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasArcsSerializer">
            <summary>
            Serializer DiagramTreeHasArcsSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasArcs.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasArcsSerializer.#ctor">
            <summary>
            DiagramTreeHasArcsSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasArcsSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DiagramTreeHasArcs instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DiagramTreeHasArcs element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DiagramTreeHasArcs instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasArcsSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player ArcNode.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DiagramTreeHasArcs instance that will link to the target ArcNode instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasArcsSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DiagramTreeHasArcs based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DiagramTreeHasArcs, a new DiagramTreeHasArcs instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DiagramTreeHasArcs instance, or null if the reader is not pointing to a serialized DiagramTreeHasArcs instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasArcsSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DiagramTreeHasArcs based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DiagramTreeHasArcs.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DiagramTreeHasArcs instance should be created.</param>	
            <returns>Created DiagramTreeHasArcs instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasArcsSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of DiagramTreeHasArcs based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            DiagramTreeHasArcs type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from DiagramTreeHasArcs, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasArcsSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DiagramTreeHasArcs itself) instance of DiagramTreeHasArcs based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasArcsSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DiagramTreeHasArcs based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasArcsSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasArcsSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasArcsSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DiagramTreeHasArcs.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasArcsSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasArcsSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasArcsSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramTreeHasArcsSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClassSerializer">
            <summary>
            Serializer ClassHasBaseClassSerializer for DomainClass ClassHasBaseClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClassSerializer.#ctor">
            <summary>
            ClassHasBaseClassSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClassSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one ClassHasBaseClass instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ClassHasBaseClass element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ClassHasBaseClass instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClassSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player BaseClass.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ClassHasBaseClass instance that will link to the target DomainClass instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClassSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ClassHasBaseClass instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClassSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ClassHasBaseClass instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClassSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ClassHasBaseClass based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ClassHasBaseClass, a new ClassHasBaseClass instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ClassHasBaseClass instance, or null if the reader is not pointing to a serialized ClassHasBaseClass instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClassSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of ClassHasBaseClass based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            ClassHasBaseClass type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from ClassHasBaseClass, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClassSerializer.InternalTryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition,System.Boolean)">
            <summary>
            Internal helper method for TryCreateInstance() and TryCreateDerivedInstance().
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <param name="derivedTypesOnly">If true, this method will only check derived types, but not the domain class iitself.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClassSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ClassHasBaseClass based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ClassHasBaseClass.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ClassHasBaseClass instance should be created.</param>	
            <returns>Created ClassHasBaseClass instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClassSerializer.derivedClasses">
            <summary>
            Stores a mapping from XmlTagName to DomainClassInfo that derives from ClassHasBaseClass, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClassSerializer.ConstructDerivedClassesLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the apping from XmlTagName to DomainClassInfo that derives from ClassHasBaseClass.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClassSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ClassHasBaseClass itself) instance of ClassHasBaseClass based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClassSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ClassHasBaseClass based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClassSerializer.derivedClassMonikers">
            <summary>
            Stores a mapping from Moniker Xml tag name to DomainClassInfo that derives from ClassHasBaseClass, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClassSerializer.ConstructDerivedClassMonikersLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the mapping from Moniker Xml tag name to DomainClassInfo that derives from ClassHasBaseClass.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClassSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized ClassHasBaseClass instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ClassHasBaseClass instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the ClassHasBaseClass instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the ClassHasBaseClass instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClassSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one ClassHasBaseClass instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ClassHasBaseClass instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClassSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ClassHasBaseClass instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClassSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ClassHasBaseClass instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClassSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given ClassHasBaseClass instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ClassHasBaseClass instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the ClassHasBaseClass instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClassSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ClassHasBaseClass instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClassSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a DomainClass
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of DomainClass that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of DomainClass</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of DomainClass instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClassSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a DomainClass.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClassSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of ClassHasBaseClass.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClassSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of ClassHasBaseClass.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClassSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of ClassHasBaseClass in a serialized monikerized instance.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClassSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassHasBaseClassSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayerSerializer">
            <summary>
            Serializer RoleHasRolePlayerSerializer for DomainClass RoleHasRolePlayer.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayerSerializer.#ctor">
            <summary>
            RoleHasRolePlayerSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayerSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one RoleHasRolePlayer instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the RoleHasRolePlayer element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory RoleHasRolePlayer instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayerSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player RolePlayer.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory RoleHasRolePlayer instance that will link to the target DomainClass instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayerSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of RoleHasRolePlayer based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized RoleHasRolePlayer, a new RoleHasRolePlayer instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created RoleHasRolePlayer instance, or null if the reader is not pointing to a serialized RoleHasRolePlayer instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayerSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of RoleHasRolePlayer based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of RoleHasRolePlayer.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new RoleHasRolePlayer instance should be created.</param>	
            <returns>Created RoleHasRolePlayer instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayerSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of RoleHasRolePlayer based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            RoleHasRolePlayer type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from RoleHasRolePlayer, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayerSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including RoleHasRolePlayer itself) instance of RoleHasRolePlayer based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayerSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of RoleHasRolePlayer based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayerSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayerSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayerSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a DomainClass
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of DomainRole that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of DomainClass</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of DomainClass instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayerSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a DomainClass.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayerSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of RoleHasRolePlayer.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayerSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayerSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayerSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RoleHasRolePlayerSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationshipSerializer">
            <summary>
            Serializer RelationshipHasBaseRelationshipSerializer for DomainClass RelationshipHasBaseRelationship.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationshipSerializer.#ctor">
            <summary>
            RelationshipHasBaseRelationshipSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationshipSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one RelationshipHasBaseRelationship instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the RelationshipHasBaseRelationship element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory RelationshipHasBaseRelationship instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationshipSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player BaseRelationship.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory RelationshipHasBaseRelationship instance that will link to the target DomainRelationship instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationshipSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of RelationshipHasBaseRelationship based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized RelationshipHasBaseRelationship, a new RelationshipHasBaseRelationship instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created RelationshipHasBaseRelationship instance, or null if the reader is not pointing to a serialized RelationshipHasBaseRelationship instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationshipSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of RelationshipHasBaseRelationship based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of RelationshipHasBaseRelationship.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new RelationshipHasBaseRelationship instance should be created.</param>	
            <returns>Created RelationshipHasBaseRelationship instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationshipSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of RelationshipHasBaseRelationship based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            RelationshipHasBaseRelationship type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from RelationshipHasBaseRelationship, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationshipSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including RelationshipHasBaseRelationship itself) instance of RelationshipHasBaseRelationship based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationshipSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of RelationshipHasBaseRelationship based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationshipSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized RelationshipHasBaseRelationship instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">RelationshipHasBaseRelationship instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the RelationshipHasBaseRelationship instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the RelationshipHasBaseRelationship instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationshipSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one RelationshipHasBaseRelationship instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">RelationshipHasBaseRelationship instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationshipSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given RelationshipHasBaseRelationship instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">RelationshipHasBaseRelationship instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the RelationshipHasBaseRelationship instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationshipSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">RelationshipHasBaseRelationship instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationshipSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a DomainRelationship
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of DomainRelationship that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of DomainRelationship</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of DomainRelationship instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationshipSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a DomainRelationship.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationshipSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of RelationshipHasBaseRelationship.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationshipSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of RelationshipHasBaseRelationship.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationshipSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of RelationshipHasBaseRelationship in a serialized monikerized instance.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationshipSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipHasBaseRelationshipSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasTypeSerializer">
            <summary>
            Serializer PropertyHasTypeSerializer for DomainClass PropertyHasType.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasTypeSerializer.#ctor">
            <summary>
            PropertyHasTypeSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasTypeSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one PropertyHasType instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the PropertyHasType element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory PropertyHasType instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasTypeSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player Type.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory PropertyHasType instance that will link to the target DomainType instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasTypeSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of PropertyHasType based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized PropertyHasType, a new PropertyHasType instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created PropertyHasType instance, or null if the reader is not pointing to a serialized PropertyHasType instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasTypeSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of PropertyHasType based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of PropertyHasType.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new PropertyHasType instance should be created.</param>	
            <returns>Created PropertyHasType instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasTypeSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of PropertyHasType based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            PropertyHasType type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from PropertyHasType, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasTypeSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including PropertyHasType itself) instance of PropertyHasType based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasTypeSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of PropertyHasType based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasTypeSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasTypeSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasTypeSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a DomainType
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of DomainProperty that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of DomainType</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of DomainType instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasTypeSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a DomainType.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasTypeSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of PropertyHasType.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasTypeSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasTypeSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasTypeSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyHasTypeSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionTypeSerializer">
            <summary>
            Serializer DomainRoleImplementedByCollectionTypeSerializer for DomainClass DomainRoleImplementedByCollectionType.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionTypeSerializer.#ctor">
            <summary>
            DomainRoleImplementedByCollectionTypeSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionTypeSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DomainRoleImplementedByCollectionType instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DomainRoleImplementedByCollectionType element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainRoleImplementedByCollectionType instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionTypeSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player ExternalType.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainRoleImplementedByCollectionType instance that will link to the target ExternalType instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionTypeSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DomainRoleImplementedByCollectionType based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DomainRoleImplementedByCollectionType, a new DomainRoleImplementedByCollectionType instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DomainRoleImplementedByCollectionType instance, or null if the reader is not pointing to a serialized DomainRoleImplementedByCollectionType instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionTypeSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DomainRoleImplementedByCollectionType based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DomainRoleImplementedByCollectionType.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DomainRoleImplementedByCollectionType instance should be created.</param>	
            <returns>Created DomainRoleImplementedByCollectionType instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionTypeSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of DomainRoleImplementedByCollectionType based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            DomainRoleImplementedByCollectionType type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from DomainRoleImplementedByCollectionType, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionTypeSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DomainRoleImplementedByCollectionType itself) instance of DomainRoleImplementedByCollectionType based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionTypeSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DomainRoleImplementedByCollectionType based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionTypeSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionTypeSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionTypeSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a ExternalType
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of DomainRole that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of ExternalType</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of ExternalType instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionTypeSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a ExternalType.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionTypeSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DomainRoleImplementedByCollectionType.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionTypeSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionTypeSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionTypeSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainRoleImplementedByCollectionTypeSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProviderSerializer">
            <summary>
            Serializer DomainPropertyHasElementNameProviderSerializer for DomainClass DomainPropertyHasElementNameProvider.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProviderSerializer.#ctor">
            <summary>
            DomainPropertyHasElementNameProviderSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProviderSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DomainPropertyHasElementNameProvider instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DomainPropertyHasElementNameProvider element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainPropertyHasElementNameProvider instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProviderSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player NameProviderType.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainPropertyHasElementNameProvider instance that will link to the target ExternalType instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProviderSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DomainPropertyHasElementNameProvider based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DomainPropertyHasElementNameProvider, a new DomainPropertyHasElementNameProvider instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DomainPropertyHasElementNameProvider instance, or null if the reader is not pointing to a serialized DomainPropertyHasElementNameProvider instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProviderSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DomainPropertyHasElementNameProvider based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DomainPropertyHasElementNameProvider.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DomainPropertyHasElementNameProvider instance should be created.</param>	
            <returns>Created DomainPropertyHasElementNameProvider instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProviderSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of DomainPropertyHasElementNameProvider based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            DomainPropertyHasElementNameProvider type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from DomainPropertyHasElementNameProvider, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProviderSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DomainPropertyHasElementNameProvider itself) instance of DomainPropertyHasElementNameProvider based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProviderSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DomainPropertyHasElementNameProvider based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProviderSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProviderSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProviderSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a ExternalType
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of DomainProperty that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of ExternalType</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of ExternalType instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProviderSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a ExternalType.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProviderSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DomainPropertyHasElementNameProvider.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProviderSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProviderSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProviderSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainPropertyHasElementNameProviderSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirectiveSerializer">
            <summary>
            Serializer ClassIndexesElementMergeDirectiveSerializer for DomainClass ClassIndexesElementMergeDirective.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirectiveSerializer.#ctor">
            <summary>
            ClassIndexesElementMergeDirectiveSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirectiveSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one ClassIndexesElementMergeDirective instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ClassIndexesElementMergeDirective element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ClassIndexesElementMergeDirective instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirectiveSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player Index.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ClassIndexesElementMergeDirective instance that will link to the target DomainClass instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirectiveSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ClassIndexesElementMergeDirective based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ClassIndexesElementMergeDirective, a new ClassIndexesElementMergeDirective instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ClassIndexesElementMergeDirective instance, or null if the reader is not pointing to a serialized ClassIndexesElementMergeDirective instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirectiveSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ClassIndexesElementMergeDirective based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ClassIndexesElementMergeDirective.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ClassIndexesElementMergeDirective instance should be created.</param>	
            <returns>Created ClassIndexesElementMergeDirective instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirectiveSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of ClassIndexesElementMergeDirective based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            ClassIndexesElementMergeDirective type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from ClassIndexesElementMergeDirective, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirectiveSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ClassIndexesElementMergeDirective itself) instance of ClassIndexesElementMergeDirective based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirectiveSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ClassIndexesElementMergeDirective based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirectiveSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirectiveSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirectiveSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a DomainClass
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of ElementMergeDirective that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of DomainClass</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of DomainClass instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirectiveSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a DomainClass.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirectiveSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of ClassIndexesElementMergeDirective.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirectiveSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirectiveSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirectiveSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassIndexesElementMergeDirectiveSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClassSerializer">
            <summary>
            Serializer RolePlayerConnectDirectiveAcceptsClassSerializer for DomainClass RolePlayerConnectDirectiveAcceptsClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClassSerializer.#ctor">
            <summary>
            RolePlayerConnectDirectiveAcceptsClassSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClassSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one RolePlayerConnectDirectiveAcceptsClass instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the RolePlayerConnectDirectiveAcceptsClass element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory RolePlayerConnectDirectiveAcceptsClass instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClassSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player AcceptingClass.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory RolePlayerConnectDirectiveAcceptsClass instance that will link to the target DomainClass instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClassSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of RolePlayerConnectDirectiveAcceptsClass based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized RolePlayerConnectDirectiveAcceptsClass, a new RolePlayerConnectDirectiveAcceptsClass instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created RolePlayerConnectDirectiveAcceptsClass instance, or null if the reader is not pointing to a serialized RolePlayerConnectDirectiveAcceptsClass instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClassSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of RolePlayerConnectDirectiveAcceptsClass based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of RolePlayerConnectDirectiveAcceptsClass.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new RolePlayerConnectDirectiveAcceptsClass instance should be created.</param>	
            <returns>Created RolePlayerConnectDirectiveAcceptsClass instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClassSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of RolePlayerConnectDirectiveAcceptsClass based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            RolePlayerConnectDirectiveAcceptsClass type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from RolePlayerConnectDirectiveAcceptsClass, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClassSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including RolePlayerConnectDirectiveAcceptsClass itself) instance of RolePlayerConnectDirectiveAcceptsClass based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClassSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of RolePlayerConnectDirectiveAcceptsClass based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClassSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClassSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClassSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a DomainClass
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of RolePlayerConnectDirective that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of DomainClass</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of DomainClass instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClassSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a DomainClass.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClassSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of RolePlayerConnectDirectiveAcceptsClass.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClassSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClassSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClassSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RolePlayerConnectDirectiveAcceptsClassSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationshipSerializer">
            <summary>
            Serializer LinkConnectDirectiveReferencesDomainRelationshipSerializer for DomainClass LinkConnectDirectiveReferencesDomainRelationship.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationshipSerializer.#ctor">
            <summary>
            LinkConnectDirectiveReferencesDomainRelationshipSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationshipSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationshipSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationshipSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationshipSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationshipSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationshipSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationshipSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a DomainRelationship
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of LinkConnectDirective that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of DomainRelationship</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of DomainRelationship instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationshipSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a DomainRelationship.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationshipSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationshipSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationshipSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationshipSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.LinkConnectDirectiveReferencesDomainRelationshipSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRoleSerializer">
            <summary>
            Serializer PathSegmentReferencesRoleSerializer for DomainClass PathSegmentReferencesRole.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRoleSerializer.#ctor">
            <summary>
            PathSegmentReferencesRoleSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRoleSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRoleSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRoleSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRoleSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRoleSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRoleSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRoleSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a DomainRole
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of PathSegment that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of DomainRole</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of DomainRole instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRoleSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a DomainRole.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRoleSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRoleSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRoleSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRoleSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentReferencesRoleSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClassSerializer">
            <summary>
            Serializer ObjectToolReferencesClassSerializer for DomainClass ObjectToolReferencesClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClassSerializer.#ctor">
            <summary>
            ObjectToolReferencesClassSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClassSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClassSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClassSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClassSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClassSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClassSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClassSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a DomainClass
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of ElementTool that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of DomainClass</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of DomainClass instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClassSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a DomainClass.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClassSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClassSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClassSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClassSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ObjectToolReferencesClassSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClassSerializer">
            <summary>
            Serializer DslEditorIdentifiesRootClassSerializer for DomainClass DslEditorIdentifiesRootClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClassSerializer.#ctor">
            <summary>
            DslEditorIdentifiesRootClassSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClassSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DslEditorIdentifiesRootClass instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DslEditorIdentifiesRootClass element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslEditorIdentifiesRootClass instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClassSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player RootClass.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslEditorIdentifiesRootClass instance that will link to the target DomainClass instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClassSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DslEditorIdentifiesRootClass based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DslEditorIdentifiesRootClass, a new DslEditorIdentifiesRootClass instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DslEditorIdentifiesRootClass instance, or null if the reader is not pointing to a serialized DslEditorIdentifiesRootClass instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClassSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DslEditorIdentifiesRootClass based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DslEditorIdentifiesRootClass.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DslEditorIdentifiesRootClass instance should be created.</param>	
            <returns>Created DslEditorIdentifiesRootClass instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClassSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of DslEditorIdentifiesRootClass based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            DslEditorIdentifiesRootClass type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from DslEditorIdentifiesRootClass, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClassSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DslEditorIdentifiesRootClass itself) instance of DslEditorIdentifiesRootClass based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClassSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DslEditorIdentifiesRootClass based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClassSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClassSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClassSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a DomainClass
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of Editor that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of DomainClass</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of DomainClass instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClassSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a DomainClass.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClassSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DslEditorIdentifiesRootClass.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClassSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClassSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClassSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslEditorIdentifiesRootClassSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilderSerializer">
            <summary>
            Serializer ConnectorToolReferencesConnectionBuilderSerializer for DomainClass ConnectorToolReferencesConnectionBuilder.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilderSerializer.#ctor">
            <summary>
            ConnectorToolReferencesConnectionBuilderSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilderSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilderSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilderSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilderSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilderSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilderSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilderSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a ConnectionBuilder
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of ConnectionTool that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of ConnectionBuilder</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of ConnectionBuilder instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilderSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a ConnectionBuilder.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilderSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilderSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilderSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilderSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorToolReferencesConnectionBuilderSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehaviorSerializer">
            <summary>
            Serializer XmlSerializationDefinitionReferencesBehaviorSerializer for DomainClass XmlSerializationDefinitionReferencesBehavior.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehaviorSerializer.#ctor">
            <summary>
            XmlSerializationDefinitionReferencesBehaviorSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehaviorSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehaviorSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehaviorSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehaviorSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehaviorSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehaviorSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehaviorSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a XmlSerializationBehavior
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of XmlSerializationDefinition that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of XmlSerializationBehavior</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of XmlSerializationBehavior instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehaviorSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a XmlSerializationBehavior.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehaviorSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehaviorSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehaviorSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehaviorSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlSerializationDefinitionReferencesBehaviorSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehaviorSerializer">
            <summary>
            Serializer ExplorerReferencesBehaviorSerializer for DomainClass ExplorerReferencesBehavior.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehaviorSerializer.#ctor">
            <summary>
            ExplorerReferencesBehaviorSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehaviorSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehaviorSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehaviorSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehaviorSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehaviorSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehaviorSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehaviorSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a ExplorerBehavior
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of Explorer that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of ExplorerBehavior</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of ExplorerBehavior instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehaviorSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a ExplorerBehavior.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehaviorSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehaviorSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehaviorSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehaviorSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerReferencesBehaviorSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClassSerializer">
            <summary>
            Serializer ExplorerNodeSettingsReferencesClassSerializer for DomainClass ExplorerNodeSettingsReferencesClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClassSerializer.#ctor">
            <summary>
            ExplorerNodeSettingsReferencesClassSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClassSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one ExplorerNodeSettingsReferencesClass instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ExplorerNodeSettingsReferencesClass element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ExplorerNodeSettingsReferencesClass instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClassSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player Class.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ExplorerNodeSettingsReferencesClass instance that will link to the target DomainClass instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClassSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ExplorerNodeSettingsReferencesClass based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ExplorerNodeSettingsReferencesClass, a new ExplorerNodeSettingsReferencesClass instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ExplorerNodeSettingsReferencesClass instance, or null if the reader is not pointing to a serialized ExplorerNodeSettingsReferencesClass instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClassSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ExplorerNodeSettingsReferencesClass based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ExplorerNodeSettingsReferencesClass.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ExplorerNodeSettingsReferencesClass instance should be created.</param>	
            <returns>Created ExplorerNodeSettingsReferencesClass instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClassSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of ExplorerNodeSettingsReferencesClass based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            ExplorerNodeSettingsReferencesClass type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from ExplorerNodeSettingsReferencesClass, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClassSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ExplorerNodeSettingsReferencesClass itself) instance of ExplorerNodeSettingsReferencesClass based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClassSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ExplorerNodeSettingsReferencesClass based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClassSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClassSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClassSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a DomainClass
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of ExplorerNodeSettings that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of DomainClass</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of DomainClass instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClassSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a DomainClass.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClassSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of ExplorerNodeSettingsReferencesClass.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClassSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClassSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClassSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ExplorerNodeSettingsReferencesClassSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShapeSerializer">
            <summary>
            Serializer ShapeMapReferencesShapeSerializer for DomainClass ShapeMapReferencesShape.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShapeSerializer">
            <summary>
            Serializer BaseShapeMapReferencesBaseShapeSerializer for DomainClass BaseShapeMapReferencesBaseShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShapeSerializer.#ctor">
            <summary>
            BaseShapeMapReferencesBaseShapeSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShapeSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            BaseShapeMapReferencesBaseShape is abstract and cannot be instantiated, so this method throws NotSupportedException.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the BaseShapeMapReferencesBaseShape element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory BaseShapeMapReferencesBaseShape instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShapeSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player BaseShape.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory BaseShapeMapReferencesBaseShape instance that will link to the target BaseShape instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShapeSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory BaseShapeMapReferencesBaseShape instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShapeSerializer.ReadElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This methods deserializes nested XML elements inside the passed-in element.
            </summary>
            <remarks>
            The caller will guarantee that the current element does have nested XML elements, and the call will position the 
            reader at the open tag of the first child XML element.
            This method will read as many child XML elements as it can. It returns under three circumstances:
            1) When an unknown child XML element is encountered. In this case, this method will position the reader at the open 
               tag of the unknown element. This implies the if the first child XML element is unknown, this method should return 
               immediately and do nothing.
            2) When all child XML elemnets are read. In this case, the reader will be positioned at the end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory BaseShapeMapReferencesBaseShape instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShapeSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of BaseShapeMapReferencesBaseShape based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized BaseShapeMapReferencesBaseShape, a new BaseShapeMapReferencesBaseShape instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created BaseShapeMapReferencesBaseShape instance, or null if the reader is not pointing to a serialized BaseShapeMapReferencesBaseShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShapeSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of BaseShapeMapReferencesBaseShape based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of BaseShapeMapReferencesBaseShape.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new BaseShapeMapReferencesBaseShape instance should be created.</param>	
            <returns>Created BaseShapeMapReferencesBaseShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShapeSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of BaseShapeMapReferencesBaseShape based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            BaseShapeMapReferencesBaseShape type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from BaseShapeMapReferencesBaseShape, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShapeSerializer.derivedClasses">
            <summary>
            Stores a mapping from XmlTagName to DomainClassInfo that derives from BaseShapeMapReferencesBaseShape, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShapeSerializer.ConstructDerivedClassesLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the apping from XmlTagName to DomainClassInfo that derives from BaseShapeMapReferencesBaseShape.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShapeSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including BaseShapeMapReferencesBaseShape itself) instance of BaseShapeMapReferencesBaseShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShapeSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of BaseShapeMapReferencesBaseShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShapeSerializer.derivedClassMonikers">
            <summary>
            Stores a mapping from Moniker Xml tag name to DomainClassInfo that derives from BaseShapeMapReferencesBaseShape, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShapeSerializer.ConstructDerivedClassMonikersLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the mapping from Moniker Xml tag name to DomainClassInfo that derives from BaseShapeMapReferencesBaseShape.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShapeSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized BaseShapeMapReferencesBaseShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">BaseShapeMapReferencesBaseShape instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the BaseShapeMapReferencesBaseShape instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the BaseShapeMapReferencesBaseShape instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShapeSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one BaseShapeMapReferencesBaseShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">BaseShapeMapReferencesBaseShape instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShapeSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">BaseShapeMapReferencesBaseShape instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShapeSerializer.WriteElements(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            This methods serializes 1) properties serialized as nested XML elements and 2) child model elements into XML. 
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">BaseShapeMapReferencesBaseShape instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>        
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShapeSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given BaseShapeMapReferencesBaseShape instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">BaseShapeMapReferencesBaseShape instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the BaseShapeMapReferencesBaseShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShapeSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">BaseShapeMapReferencesBaseShape instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShapeSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a BaseShape
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of BaseShapeMap that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of BaseShape</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of BaseShape instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShapeSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a BaseShape.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShapeSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShapeSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShapeSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShapeSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMapReferencesBaseShapeSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShapeSerializer.#ctor">
            <summary>
            ShapeMapReferencesShapeSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShapeSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShapeSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShapeSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShapeSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShapeSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShapeSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShapeSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a Shape
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of ShapeMap that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of Shape</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of Shape instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShapeSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a Shape.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShapeSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShapeSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShapeSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShapeSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesShapeSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecoratorSerializer">
            <summary>
            Serializer DecoratorMapReferencesDecoratorSerializer for DomainClass DecoratorMapReferencesDecorator.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecoratorSerializer.#ctor">
            <summary>
            DecoratorMapReferencesDecoratorSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecoratorSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecoratorSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecoratorSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecoratorSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecoratorSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecoratorSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecoratorSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a Decorator
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of DecoratorMap that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of Decorator</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of Decorator instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecoratorSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a Decorator.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecoratorSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecoratorSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecoratorSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecoratorSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMapReferencesDecoratorSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnectorSerializer">
            <summary>
            Serializer ConnectorMapReferencesConnectorSerializer for DomainClass ConnectorMapReferencesConnector.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnectorSerializer.#ctor">
            <summary>
            ConnectorMapReferencesConnectorSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnectorSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnectorSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnectorSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnectorSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnectorSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnectorSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnectorSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a Connector
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of ConnectorMap that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of Connector</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of Connector instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnectorSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a Connector.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnectorSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnectorSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnectorSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnectorSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesConnectorSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesPropertySerializer">
            <summary>
            Serializer PropertyPathReferencesPropertySerializer for DomainClass PropertyPathReferencesProperty.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesPropertySerializer.#ctor">
            <summary>
            PropertyPathReferencesPropertySerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesPropertySerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesPropertySerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesPropertySerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesPropertySerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesPropertySerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesPropertySerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesPropertySerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a DomainProperty
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of PropertyPath that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of DomainProperty</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of DomainProperty instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesPropertySerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a DomainProperty.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesPropertySerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesPropertySerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesPropertySerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesPropertySerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PropertyPathReferencesPropertySerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClassSerializer">
            <summary>
            Serializer ShapeMapReferencesClassSerializer for DomainClass ShapeMapReferencesClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClassSerializer.#ctor">
            <summary>
            ShapeMapReferencesClassSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClassSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClassSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClassSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClassSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClassSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClassSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClassSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a DomainClass
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of BaseShapeMap that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of DomainClass</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of DomainClass instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClassSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a DomainClass.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClassSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClassSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClassSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClassSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapReferencesClassSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClassSerializer">
            <summary>
            Serializer DiagramRepresentsClassSerializer for DomainClass DiagramRepresentsClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClassSerializer.#ctor">
            <summary>
            DiagramRepresentsClassSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClassSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DiagramRepresentsClass instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DiagramRepresentsClass element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DiagramRepresentsClass instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClassSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player Class.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DiagramRepresentsClass instance that will link to the target DomainClass instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClassSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DiagramRepresentsClass based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DiagramRepresentsClass, a new DiagramRepresentsClass instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DiagramRepresentsClass instance, or null if the reader is not pointing to a serialized DiagramRepresentsClass instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClassSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DiagramRepresentsClass based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DiagramRepresentsClass.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DiagramRepresentsClass instance should be created.</param>	
            <returns>Created DiagramRepresentsClass instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClassSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of DiagramRepresentsClass based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            DiagramRepresentsClass type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from DiagramRepresentsClass, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClassSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DiagramRepresentsClass itself) instance of DiagramRepresentsClass based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClassSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DiagramRepresentsClass based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClassSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClassSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClassSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a DomainClass
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of Diagram that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of DomainClass</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of DomainClass instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClassSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a DomainClass.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClassSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DiagramRepresentsClass.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClassSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClassSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClassSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramRepresentsClassSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartmentSerializer">
            <summary>
            Serializer CompartmentMapsReferToCompartmentSerializer for DomainClass CompartmentMapsReferToCompartment.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartmentSerializer.#ctor">
            <summary>
            CompartmentMapsReferToCompartmentSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartmentSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartmentSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartmentSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartmentSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartmentSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartmentSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartmentSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a Compartment
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of CompartmentMap that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of Compartment</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of Compartment instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartmentSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a Compartment.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartmentSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartmentSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartmentSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartmentSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentMapsReferToCompartmentSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagramSerializer">
            <summary>
            Serializer DesignerHasDiagramSerializer for DomainClass DesignerHasDiagram.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagramSerializer.#ctor">
            <summary>
            DesignerHasDiagramSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagramSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagramSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagramSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagramSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagramSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagramSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagramSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a Diagram
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of Designer that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of Diagram</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of Diagram instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagramSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a Diagram.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagramSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagramSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagramSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagramSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DesignerHasDiagramSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationshipSerializer">
            <summary>
            Serializer ConnectorMapReferencesRelationshipSerializer for DomainClass ConnectorMapReferencesRelationship.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationshipSerializer.#ctor">
            <summary>
            ConnectorMapReferencesRelationshipSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationshipSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationshipSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationshipSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationshipSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationshipSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationshipSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationshipSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a DomainRelationship
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of ConnectorMap that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of DomainRelationship</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of DomainRelationship instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationshipSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a DomainRelationship.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationshipSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationshipSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationshipSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationshipSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorMapReferencesRelationshipSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShapeSerializer">
            <summary>
            Serializer CompartmentShapeMapReferencesCompartmentShapeSerializer for DomainClass CompartmentShapeMapReferencesCompartmentShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShapeSerializer.#ctor">
            <summary>
            CompartmentShapeMapReferencesCompartmentShapeSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShapeSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShapeSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShapeSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShapeSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShapeSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShapeSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShapeSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a CompartmentShape
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of CompartmentShapeMap that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of CompartmentShape</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of CompartmentShape instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShapeSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a CompartmentShape.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShapeSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShapeSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShapeSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShapeSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeMapReferencesCompartmentShapeSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClassSerializer">
            <summary>
            Serializer XmlClassDataAppliesToDomainClassSerializer for DomainClass XmlClassDataAppliesToDomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClassSerializer.#ctor">
            <summary>
            XmlClassDataAppliesToDomainClassSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClassSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClassSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClassSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClassSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClassSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClassSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClassSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a DomainClass
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of XmlClassData that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of DomainClass</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of DomainClass instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClassSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a DomainClass.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClassSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClassSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClassSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClassSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlClassDataAppliesToDomainClassSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationshipSerializer">
            <summary>
            Serializer XmlRelationshipDataAppliesToDomainRelationshipSerializer for DomainClass XmlRelationshipDataAppliesToDomainRelationship.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationshipSerializer.#ctor">
            <summary>
            XmlRelationshipDataAppliesToDomainRelationshipSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationshipSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationshipSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationshipSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationshipSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationshipSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationshipSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationshipSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a DomainRelationship
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of XmlRelationshipData that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of DomainRelationship</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of DomainRelationship instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationshipSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a DomainRelationship.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationshipSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationshipSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationshipSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationshipSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlRelationshipDataAppliesToDomainRelationshipSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainPropertySerializer">
            <summary>
            Serializer XmlElementAppliesToDomainPropertySerializer for DomainClass XmlElementAppliesToDomainProperty.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainPropertySerializer.#ctor">
            <summary>
            XmlElementAppliesToDomainPropertySerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainPropertySerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainPropertySerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainPropertySerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainPropertySerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainPropertySerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainPropertySerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainPropertySerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a DomainProperty
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of XmlPropertyData that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of DomainProperty</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of DomainProperty instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainPropertySerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a DomainProperty.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainPropertySerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainPropertySerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainPropertySerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainPropertySerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.XmlElementAppliesToDomainPropertySerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLaneSerializer">
            <summary>
            Serializer SwimLaneMapReferencesSwimLaneSerializer for DomainClass SwimLaneMapReferencesSwimLane.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLaneSerializer.#ctor">
            <summary>
            SwimLaneMapReferencesSwimLaneSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLaneSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one SwimLaneMapReferencesSwimLane instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the SwimLaneMapReferencesSwimLane element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory SwimLaneMapReferencesSwimLane instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLaneSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player SwimLane.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory SwimLaneMapReferencesSwimLane instance that will link to the target SwimLane instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLaneSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of SwimLaneMapReferencesSwimLane based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized SwimLaneMapReferencesSwimLane, a new SwimLaneMapReferencesSwimLane instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created SwimLaneMapReferencesSwimLane instance, or null if the reader is not pointing to a serialized SwimLaneMapReferencesSwimLane instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLaneSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of SwimLaneMapReferencesSwimLane based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of SwimLaneMapReferencesSwimLane.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new SwimLaneMapReferencesSwimLane instance should be created.</param>	
            <returns>Created SwimLaneMapReferencesSwimLane instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLaneSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of SwimLaneMapReferencesSwimLane based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            SwimLaneMapReferencesSwimLane type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from SwimLaneMapReferencesSwimLane, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLaneSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including SwimLaneMapReferencesSwimLane itself) instance of SwimLaneMapReferencesSwimLane based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLaneSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of SwimLaneMapReferencesSwimLane based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLaneSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLaneSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLaneSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a SwimLane
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of SwimLaneMap that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of SwimLane</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of SwimLane instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLaneSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a SwimLane.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLaneSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of SwimLaneMapReferencesSwimLane.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLaneSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLaneSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLaneSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneMapReferencesSwimLaneSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeReferencesClassSerializer">
            <summary>
            Serializer RootNodeReferencesClassSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.RootNodeReferencesClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeReferencesClassSerializer.#ctor">
            <summary>
            RootNodeReferencesClassSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeReferencesClassSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one RootNodeReferencesClass instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the RootNodeReferencesClass element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory RootNodeReferencesClass instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeReferencesClassSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player Class.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory RootNodeReferencesClass instance that will link to the target DomainClass instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeReferencesClassSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of RootNodeReferencesClass based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized RootNodeReferencesClass, a new RootNodeReferencesClass instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created RootNodeReferencesClass instance, or null if the reader is not pointing to a serialized RootNodeReferencesClass instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeReferencesClassSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of RootNodeReferencesClass based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of RootNodeReferencesClass.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new RootNodeReferencesClass instance should be created.</param>	
            <returns>Created RootNodeReferencesClass instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeReferencesClassSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of RootNodeReferencesClass based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            RootNodeReferencesClass type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from RootNodeReferencesClass, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeReferencesClassSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including RootNodeReferencesClass itself) instance of RootNodeReferencesClass based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeReferencesClassSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of RootNodeReferencesClass based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeReferencesClassSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeReferencesClassSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeReferencesClassSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a DomainClass
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of RootNode that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of DomainClass</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of DomainClass instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeReferencesClassSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a DomainClass.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeReferencesClassSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of RootNodeReferencesClass.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeReferencesClassSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeReferencesClassSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeReferencesClassSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RootNodeReferencesClassSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.RoleNodeReferencesRoleSerializer">
            <summary>
            Serializer RoleNodeReferencesRoleSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.RoleNodeReferencesRole.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleNodeReferencesRoleSerializer.#ctor">
            <summary>
            RoleNodeReferencesRoleSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleNodeReferencesRoleSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one RoleNodeReferencesRole instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the RoleNodeReferencesRole element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory RoleNodeReferencesRole instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleNodeReferencesRoleSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player Role.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory RoleNodeReferencesRole instance that will link to the target DomainRole instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleNodeReferencesRoleSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of RoleNodeReferencesRole based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized RoleNodeReferencesRole, a new RoleNodeReferencesRole instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created RoleNodeReferencesRole instance, or null if the reader is not pointing to a serialized RoleNodeReferencesRole instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleNodeReferencesRoleSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of RoleNodeReferencesRole based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of RoleNodeReferencesRole.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new RoleNodeReferencesRole instance should be created.</param>	
            <returns>Created RoleNodeReferencesRole instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleNodeReferencesRoleSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of RoleNodeReferencesRole based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            RoleNodeReferencesRole type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from RoleNodeReferencesRole, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleNodeReferencesRoleSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including RoleNodeReferencesRole itself) instance of RoleNodeReferencesRole based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleNodeReferencesRoleSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of RoleNodeReferencesRole based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleNodeReferencesRoleSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleNodeReferencesRoleSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleNodeReferencesRoleSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a DomainRole
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of SourceRoleNode that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of DomainRole</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of DomainRole instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleNodeReferencesRoleSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a DomainRole.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RoleNodeReferencesRoleSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of RoleNodeReferencesRole.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RoleNodeReferencesRoleSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RoleNodeReferencesRoleSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RoleNodeReferencesRoleSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RoleNodeReferencesRoleSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeReferencesInheritanceLinkSerializer">
            <summary>
            Serializer InheritanceNodeReferencesInheritanceLinkSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceNodeReferencesInheritanceLink.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeReferencesInheritanceLinkSerializer.#ctor">
            <summary>
            InheritanceNodeReferencesInheritanceLinkSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeReferencesInheritanceLinkSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one InheritanceNodeReferencesInheritanceLink instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the InheritanceNodeReferencesInheritanceLink element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory InheritanceNodeReferencesInheritanceLink instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeReferencesInheritanceLinkSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player InheritanceLink.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory InheritanceNodeReferencesInheritanceLink instance that will link to the target ClassHasBaseClass instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeReferencesInheritanceLinkSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of InheritanceNodeReferencesInheritanceLink based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized InheritanceNodeReferencesInheritanceLink, a new InheritanceNodeReferencesInheritanceLink instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created InheritanceNodeReferencesInheritanceLink instance, or null if the reader is not pointing to a serialized InheritanceNodeReferencesInheritanceLink instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeReferencesInheritanceLinkSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of InheritanceNodeReferencesInheritanceLink based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of InheritanceNodeReferencesInheritanceLink.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new InheritanceNodeReferencesInheritanceLink instance should be created.</param>	
            <returns>Created InheritanceNodeReferencesInheritanceLink instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeReferencesInheritanceLinkSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of InheritanceNodeReferencesInheritanceLink based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            InheritanceNodeReferencesInheritanceLink type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from InheritanceNodeReferencesInheritanceLink, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeReferencesInheritanceLinkSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including InheritanceNodeReferencesInheritanceLink itself) instance of InheritanceNodeReferencesInheritanceLink based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeReferencesInheritanceLinkSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of InheritanceNodeReferencesInheritanceLink based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeReferencesInheritanceLinkSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeReferencesInheritanceLinkSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeReferencesInheritanceLinkSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a ClassHasBaseClass
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of InheritanceNode that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of ClassHasBaseClass</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of ClassHasBaseClass instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeReferencesInheritanceLinkSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a ClassHasBaseClass.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeReferencesInheritanceLinkSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of InheritanceNodeReferencesInheritanceLink.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeReferencesInheritanceLinkSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeReferencesInheritanceLinkSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeReferencesInheritanceLinkSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceNodeReferencesInheritanceLinkSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramHasDiagramStateSerializer">
            <summary>
            Serializer DslDesignerDiagramHasDiagramStateSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramHasDiagramState.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramHasDiagramStateSerializer.#ctor">
            <summary>
            DslDesignerDiagramHasDiagramStateSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramHasDiagramStateSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DslDesignerDiagramHasDiagramState instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DslDesignerDiagramHasDiagramState element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslDesignerDiagramHasDiagramState instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramHasDiagramStateSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player DiagramState.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DslDesignerDiagramHasDiagramState instance that will link to the target DslDesignerDiagramState instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramHasDiagramStateSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DslDesignerDiagramHasDiagramState based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DslDesignerDiagramHasDiagramState, a new DslDesignerDiagramHasDiagramState instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DslDesignerDiagramHasDiagramState instance, or null if the reader is not pointing to a serialized DslDesignerDiagramHasDiagramState instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramHasDiagramStateSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DslDesignerDiagramHasDiagramState based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DslDesignerDiagramHasDiagramState.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DslDesignerDiagramHasDiagramState instance should be created.</param>	
            <returns>Created DslDesignerDiagramHasDiagramState instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramHasDiagramStateSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of DslDesignerDiagramHasDiagramState based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            DslDesignerDiagramHasDiagramState type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from DslDesignerDiagramHasDiagramState, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramHasDiagramStateSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DslDesignerDiagramHasDiagramState itself) instance of DslDesignerDiagramHasDiagramState based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramHasDiagramStateSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DslDesignerDiagramHasDiagramState based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramHasDiagramStateSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramHasDiagramStateSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Not Supported.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramHasDiagramStateSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DslDesignerDiagramHasDiagramState.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramHasDiagramStateSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramHasDiagramStateSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramHasDiagramStateSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramHasDiagramStateSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLaneSerializer">
            <summary>
            Serializer SwimLaneHasBaseSwimLaneSerializer for DomainClass SwimLaneHasBaseSwimLane.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLaneSerializer.#ctor">
            <summary>
            SwimLaneHasBaseSwimLaneSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLaneSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one SwimLaneHasBaseSwimLane instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the SwimLaneHasBaseSwimLane element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory SwimLaneHasBaseSwimLane instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLaneSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player BaseSwimLane.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory SwimLaneHasBaseSwimLane instance that will link to the target SwimLane instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLaneSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of SwimLaneHasBaseSwimLane based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized SwimLaneHasBaseSwimLane, a new SwimLaneHasBaseSwimLane instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created SwimLaneHasBaseSwimLane instance, or null if the reader is not pointing to a serialized SwimLaneHasBaseSwimLane instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLaneSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of SwimLaneHasBaseSwimLane based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of SwimLaneHasBaseSwimLane.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new SwimLaneHasBaseSwimLane instance should be created.</param>	
            <returns>Created SwimLaneHasBaseSwimLane instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLaneSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of SwimLaneHasBaseSwimLane based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            SwimLaneHasBaseSwimLane type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from SwimLaneHasBaseSwimLane, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLaneSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including SwimLaneHasBaseSwimLane itself) instance of SwimLaneHasBaseSwimLane based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLaneSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of SwimLaneHasBaseSwimLane based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLaneSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized SwimLaneHasBaseSwimLane instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">SwimLaneHasBaseSwimLane instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the SwimLaneHasBaseSwimLane instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the SwimLaneHasBaseSwimLane instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLaneSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one SwimLaneHasBaseSwimLane instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">SwimLaneHasBaseSwimLane instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLaneSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given SwimLaneHasBaseSwimLane instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">SwimLaneHasBaseSwimLane instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the SwimLaneHasBaseSwimLane instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLaneSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">SwimLaneHasBaseSwimLane instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLaneSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a SwimLane
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of SwimLane that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of SwimLane</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of SwimLane instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLaneSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a SwimLane.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLaneSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of SwimLaneHasBaseSwimLane.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLaneSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of SwimLaneHasBaseSwimLane.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLaneSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of SwimLaneHasBaseSwimLane in a serialized monikerized instance.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLaneSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneHasBaseSwimLaneSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShapeSerializer">
            <summary>
            Serializer CompartmentShapeHasBaseCompartmentShapeSerializer for DomainClass CompartmentShapeHasBaseCompartmentShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShapeSerializer.#ctor">
            <summary>
            CompartmentShapeHasBaseCompartmentShapeSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShapeSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one CompartmentShapeHasBaseCompartmentShape instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the CompartmentShapeHasBaseCompartmentShape element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory CompartmentShapeHasBaseCompartmentShape instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShapeSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player BaseCompartmentShape.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory CompartmentShapeHasBaseCompartmentShape instance that will link to the target CompartmentShape instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShapeSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of CompartmentShapeHasBaseCompartmentShape based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized CompartmentShapeHasBaseCompartmentShape, a new CompartmentShapeHasBaseCompartmentShape instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created CompartmentShapeHasBaseCompartmentShape instance, or null if the reader is not pointing to a serialized CompartmentShapeHasBaseCompartmentShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShapeSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of CompartmentShapeHasBaseCompartmentShape based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of CompartmentShapeHasBaseCompartmentShape.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new CompartmentShapeHasBaseCompartmentShape instance should be created.</param>	
            <returns>Created CompartmentShapeHasBaseCompartmentShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShapeSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of CompartmentShapeHasBaseCompartmentShape based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            CompartmentShapeHasBaseCompartmentShape type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from CompartmentShapeHasBaseCompartmentShape, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShapeSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including CompartmentShapeHasBaseCompartmentShape itself) instance of CompartmentShapeHasBaseCompartmentShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShapeSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of CompartmentShapeHasBaseCompartmentShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShapeSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized CompartmentShapeHasBaseCompartmentShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">CompartmentShapeHasBaseCompartmentShape instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the CompartmentShapeHasBaseCompartmentShape instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the CompartmentShapeHasBaseCompartmentShape instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShapeSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one CompartmentShapeHasBaseCompartmentShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">CompartmentShapeHasBaseCompartmentShape instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShapeSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given CompartmentShapeHasBaseCompartmentShape instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">CompartmentShapeHasBaseCompartmentShape instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the CompartmentShapeHasBaseCompartmentShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShapeSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">CompartmentShapeHasBaseCompartmentShape instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShapeSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a CompartmentShape
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of CompartmentShape that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of CompartmentShape</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of CompartmentShape instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShapeSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a CompartmentShape.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShapeSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of CompartmentShapeHasBaseCompartmentShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShapeSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of CompartmentShapeHasBaseCompartmentShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShapeSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of CompartmentShapeHasBaseCompartmentShape in a serialized monikerized instance.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShapeSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeHasBaseCompartmentShapeSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShapeSerializer">
            <summary>
            Serializer ImageShapeHasBaseImageShapeSerializer for DomainClass ImageShapeHasBaseImageShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShapeSerializer.#ctor">
            <summary>
            ImageShapeHasBaseImageShapeSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShapeSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one ImageShapeHasBaseImageShape instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ImageShapeHasBaseImageShape element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ImageShapeHasBaseImageShape instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShapeSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player BaseImageShape.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ImageShapeHasBaseImageShape instance that will link to the target ImageShape instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShapeSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ImageShapeHasBaseImageShape based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ImageShapeHasBaseImageShape, a new ImageShapeHasBaseImageShape instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ImageShapeHasBaseImageShape instance, or null if the reader is not pointing to a serialized ImageShapeHasBaseImageShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShapeSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ImageShapeHasBaseImageShape based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ImageShapeHasBaseImageShape.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ImageShapeHasBaseImageShape instance should be created.</param>	
            <returns>Created ImageShapeHasBaseImageShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShapeSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of ImageShapeHasBaseImageShape based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            ImageShapeHasBaseImageShape type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from ImageShapeHasBaseImageShape, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShapeSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ImageShapeHasBaseImageShape itself) instance of ImageShapeHasBaseImageShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShapeSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ImageShapeHasBaseImageShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShapeSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized ImageShapeHasBaseImageShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ImageShapeHasBaseImageShape instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the ImageShapeHasBaseImageShape instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the ImageShapeHasBaseImageShape instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShapeSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one ImageShapeHasBaseImageShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ImageShapeHasBaseImageShape instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShapeSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given ImageShapeHasBaseImageShape instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ImageShapeHasBaseImageShape instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the ImageShapeHasBaseImageShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShapeSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ImageShapeHasBaseImageShape instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShapeSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a ImageShape
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of ImageShape that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of ImageShape</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of ImageShape instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShapeSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a ImageShape.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShapeSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of ImageShapeHasBaseImageShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShapeSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of ImageShapeHasBaseImageShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShapeSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of ImageShapeHasBaseImageShape in a serialized monikerized instance.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShapeSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeHasBaseImageShapeSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShapeSerializer">
            <summary>
            Serializer GeometryShapeHasBaseGeometryShapeSerializer for DomainClass GeometryShapeHasBaseGeometryShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShapeSerializer.#ctor">
            <summary>
            GeometryShapeHasBaseGeometryShapeSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShapeSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one GeometryShapeHasBaseGeometryShape instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the GeometryShapeHasBaseGeometryShape element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory GeometryShapeHasBaseGeometryShape instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShapeSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player BaseGeometryShape.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory GeometryShapeHasBaseGeometryShape instance that will link to the target GeometryShape instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShapeSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of GeometryShapeHasBaseGeometryShape based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized GeometryShapeHasBaseGeometryShape, a new GeometryShapeHasBaseGeometryShape instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created GeometryShapeHasBaseGeometryShape instance, or null if the reader is not pointing to a serialized GeometryShapeHasBaseGeometryShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShapeSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of GeometryShapeHasBaseGeometryShape based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            GeometryShapeHasBaseGeometryShape type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from GeometryShapeHasBaseGeometryShape, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShapeSerializer.InternalTryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition,System.Boolean)">
            <summary>
            Internal helper method for TryCreateInstance() and TryCreateDerivedInstance().
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <param name="derivedTypesOnly">If true, this method will only check derived types, but not the domain class iitself.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShapeSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of GeometryShapeHasBaseGeometryShape based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of GeometryShapeHasBaseGeometryShape.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new GeometryShapeHasBaseGeometryShape instance should be created.</param>	
            <returns>Created GeometryShapeHasBaseGeometryShape instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShapeSerializer.derivedClasses">
            <summary>
            Stores a mapping from XmlTagName to DomainClassInfo that derives from GeometryShapeHasBaseGeometryShape, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShapeSerializer.ConstructDerivedClassesLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the apping from XmlTagName to DomainClassInfo that derives from GeometryShapeHasBaseGeometryShape.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShapeSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including GeometryShapeHasBaseGeometryShape itself) instance of GeometryShapeHasBaseGeometryShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShapeSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of GeometryShapeHasBaseGeometryShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShapeSerializer.derivedClassMonikers">
            <summary>
            Stores a mapping from Moniker Xml tag name to DomainClassInfo that derives from GeometryShapeHasBaseGeometryShape, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShapeSerializer.ConstructDerivedClassMonikersLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the mapping from Moniker Xml tag name to DomainClassInfo that derives from GeometryShapeHasBaseGeometryShape.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShapeSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized GeometryShapeHasBaseGeometryShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">GeometryShapeHasBaseGeometryShape instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the GeometryShapeHasBaseGeometryShape instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the GeometryShapeHasBaseGeometryShape instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShapeSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one GeometryShapeHasBaseGeometryShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">GeometryShapeHasBaseGeometryShape instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShapeSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given GeometryShapeHasBaseGeometryShape instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">GeometryShapeHasBaseGeometryShape instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the GeometryShapeHasBaseGeometryShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShapeSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">GeometryShapeHasBaseGeometryShape instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShapeSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a GeometryShape
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of GeometryShape that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of GeometryShape</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of GeometryShape instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShapeSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a GeometryShape.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShapeSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of GeometryShapeHasBaseGeometryShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShapeSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of GeometryShapeHasBaseGeometryShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShapeSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of GeometryShapeHasBaseGeometryShape in a serialized monikerized instance.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShapeSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeHasBaseGeometryShapeSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePortSerializer">
            <summary>
            Serializer PortHasBasePortSerializer for DomainClass PortHasBasePort.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePortSerializer.#ctor">
            <summary>
            PortHasBasePortSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePortSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one PortHasBasePort instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the PortHasBasePort element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory PortHasBasePort instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePortSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player BasePort.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory PortHasBasePort instance that will link to the target Port instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePortSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of PortHasBasePort based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized PortHasBasePort, a new PortHasBasePort instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created PortHasBasePort instance, or null if the reader is not pointing to a serialized PortHasBasePort instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePortSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of PortHasBasePort based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of PortHasBasePort.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new PortHasBasePort instance should be created.</param>	
            <returns>Created PortHasBasePort instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePortSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of PortHasBasePort based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            PortHasBasePort type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from PortHasBasePort, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePortSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including PortHasBasePort itself) instance of PortHasBasePort based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePortSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of PortHasBasePort based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePortSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized PortHasBasePort instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">PortHasBasePort instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the PortHasBasePort instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the PortHasBasePort instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePortSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one PortHasBasePort instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">PortHasBasePort instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePortSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given PortHasBasePort instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">PortHasBasePort instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the PortHasBasePort instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePortSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">PortHasBasePort instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePortSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a Port
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of Port that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of Port</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of Port instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePortSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a Port.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePortSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of PortHasBasePort.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePortSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of PortHasBasePort.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePortSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of PortHasBasePort in a serialized monikerized instance.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePortSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PortHasBasePortSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnectorSerializer">
            <summary>
            Serializer ConnectorHasBaseConnectorSerializer for DomainClass ConnectorHasBaseConnector.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnectorSerializer.#ctor">
            <summary>
            ConnectorHasBaseConnectorSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnectorSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one ConnectorHasBaseConnector instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ConnectorHasBaseConnector element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ConnectorHasBaseConnector instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnectorSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player BaseConnector.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ConnectorHasBaseConnector instance that will link to the target Connector instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnectorSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ConnectorHasBaseConnector based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ConnectorHasBaseConnector, a new ConnectorHasBaseConnector instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ConnectorHasBaseConnector instance, or null if the reader is not pointing to a serialized ConnectorHasBaseConnector instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnectorSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ConnectorHasBaseConnector based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ConnectorHasBaseConnector.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ConnectorHasBaseConnector instance should be created.</param>	
            <returns>Created ConnectorHasBaseConnector instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnectorSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of ConnectorHasBaseConnector based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            ConnectorHasBaseConnector type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from ConnectorHasBaseConnector, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnectorSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ConnectorHasBaseConnector itself) instance of ConnectorHasBaseConnector based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnectorSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ConnectorHasBaseConnector based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnectorSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized ConnectorHasBaseConnector instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ConnectorHasBaseConnector instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the ConnectorHasBaseConnector instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the ConnectorHasBaseConnector instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnectorSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one ConnectorHasBaseConnector instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ConnectorHasBaseConnector instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnectorSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given ConnectorHasBaseConnector instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ConnectorHasBaseConnector instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the ConnectorHasBaseConnector instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnectorSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ConnectorHasBaseConnector instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnectorSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a Connector
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of Connector that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of Connector</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of Connector instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnectorSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a Connector.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnectorSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of ConnectorHasBaseConnector.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnectorSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of ConnectorHasBaseConnector.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnectorSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of ConnectorHasBaseConnector in a serialized monikerized instance.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnectorSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorHasBaseConnectorSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagramSerializer">
            <summary>
            Serializer DiagramHasBaseDiagramSerializer for DomainClass DiagramHasBaseDiagram.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagramSerializer.#ctor">
            <summary>
            DiagramHasBaseDiagramSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagramSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DiagramHasBaseDiagram instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DiagramHasBaseDiagram element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DiagramHasBaseDiagram instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagramSerializer.ReadTargetRolePlayer(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method reads the target role player BaseDiagram.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at the open tag of the first child XML element.
            This method will read only one target role player instance. The method will skip any child XML element it encounters until it reaches:
            1) The open tag of the target role player.
            2) The end tag of the parent element (dangling relationship).
            3) EOF (dangling relationship).
            After the call, the reader is positioned at:
            1) The open tag of the next child element after the target role player.
            2) The end tag of the parent element.
            3) EOF.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DiagramHasBaseDiagram instance that will link to the target Diagram instance.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagramSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DiagramHasBaseDiagram based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DiagramHasBaseDiagram, a new DiagramHasBaseDiagram instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DiagramHasBaseDiagram instance, or null if the reader is not pointing to a serialized DiagramHasBaseDiagram instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagramSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DiagramHasBaseDiagram based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DiagramHasBaseDiagram.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DiagramHasBaseDiagram instance should be created.</param>	
            <returns>Created DiagramHasBaseDiagram instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagramSerializer.TryCreateDerivedInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct derived instance of DiagramHasBaseDiagram based on the tag currently pointed by the reader.
            Note that the difference between this method and the above one is that this method will never create an instance of the
            DiagramHasBaseDiagram type itself, only derived types are checked.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>
            <returns>Created instance that derives from DiagramHasBaseDiagram, or null if the reader is not pointing to such a serialized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagramSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DiagramHasBaseDiagram itself) instance of DiagramHasBaseDiagram based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagramSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DiagramHasBaseDiagram based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagramSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized DiagramHasBaseDiagram instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DiagramHasBaseDiagram instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the DiagramHasBaseDiagram instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the DiagramHasBaseDiagram instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagramSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one DiagramHasBaseDiagram instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DiagramHasBaseDiagram instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagramSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given DiagramHasBaseDiagram instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DiagramHasBaseDiagram instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the DiagramHasBaseDiagram instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagramSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DiagramHasBaseDiagram instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagramSerializer.MonikerizeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,System.String,Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Calculates a Moniker, given a reference to a Diagram
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Instance of Diagram that contains the given serialized reference</param>
            <param name="domainClassId">DomainClassId of the model element that the given moniker string will be resolved to.</param>
            <param name="monikerString">Serialized string reference to an instance of Diagram</param>
            <param name="store">Store where the Moniker will be created</param>
            <returns>A Moniker encapsulating the serialized string reference of Diagram instance</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagramSerializer.SerializeReference(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculates a monikerized string reference to a Diagram.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="sourceElement">Source side of reference relationship. The referenced target element will be serialized.</param>
            <param name="targetElement">Target side of relationship that will be serialized.</param>
            <returns>A monikerized string reference to target element.</returns>		
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagramSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DiagramHasBaseDiagram.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagramSerializer.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of DiagramHasBaseDiagram.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagramSerializer.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of DiagramHasBaseDiagram in a serialized monikerized instance.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagramSerializer.SerializesId">
            <summary>
            Exposes whether serializers derived from this class are serializing Id.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramHasBaseDiagramSerializer.UsesFullForm">
            <summary>
            Exposes whether serializers derived from this class are serializing this relationship in full form.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.AbstractClassShapeSerializerBase">
            <summary>
            Serializer AbstractClassShapeSerializerBase for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AbstractClassShapeSerializerBase.#ctor">
            <summary>
            AbstractClassShapeSerializerBase Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AbstractClassShapeSerializerBase.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            AbstractClassShape is abstract and cannot be instantiated, so this method throws NotSupportedException.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the AbstractClassShape element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory AbstractClassShape instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AbstractClassShapeSerializerBase.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of AbstractClassShape based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized AbstractClassShape, a new AbstractClassShape instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created AbstractClassShape instance, or null if the reader is not pointing to a serialized AbstractClassShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AbstractClassShapeSerializerBase.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of AbstractClassShape based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of AbstractClassShape.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new AbstractClassShape instance should be created.</param>	
            <returns>Created AbstractClassShape instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.AbstractClassShapeSerializerBase.derivedClasses">
            <summary>
            Stores a mapping from XmlTagName to DomainClassInfo that derives from AbstractClassShape, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AbstractClassShapeSerializerBase.ConstructDerivedClassesLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the apping from XmlTagName to DomainClassInfo that derives from AbstractClassShape.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AbstractClassShapeSerializerBase.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including AbstractClassShape itself) instance of AbstractClassShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AbstractClassShapeSerializerBase.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of AbstractClassShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.AbstractClassShapeSerializerBase.derivedClassMonikers">
            <summary>
            Stores a mapping from Moniker Xml tag name to DomainClassInfo that derives from AbstractClassShape, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AbstractClassShapeSerializerBase.ConstructDerivedClassMonikersLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the mapping from Moniker Xml tag name to DomainClassInfo that derives from AbstractClassShape.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AbstractClassShapeSerializerBase.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized AbstractClassShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">AbstractClassShape instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the AbstractClassShape instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the AbstractClassShape instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AbstractClassShapeSerializerBase.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one AbstractClassShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">AbstractClassShape instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AbstractClassShapeSerializerBase.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given AbstractClassShape instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">AbstractClassShape instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the AbstractClassShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AbstractClassShapeSerializerBase.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">AbstractClassShape instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AbstractClassShapeSerializerBase.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AbstractClassShapeSerializerBase.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.AbstractClassShapeSerializerBase.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.AbstractClassShapeSerializer">
            <summary>
            Serializer AbstractClassShapeSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.AbstractClassShapeSerializer.#ctor">
            <summary>
            AbstractClassShapeSerializer Constructor
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ClassShapeSerializerBase">
            <summary>
            Serializer ClassShapeSerializerBase for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.ClassShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassShapeSerializerBase.#ctor">
            <summary>
            ClassShapeSerializerBase Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassShapeSerializerBase.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one ClassShape instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ClassShape element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ClassShape instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassShapeSerializerBase.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ClassShape based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ClassShape, a new ClassShape instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ClassShape instance, or null if the reader is not pointing to a serialized ClassShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassShapeSerializerBase.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ClassShape based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ClassShape.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ClassShape instance should be created.</param>	
            <returns>Created ClassShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassShapeSerializerBase.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ClassShape itself) instance of ClassShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassShapeSerializerBase.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ClassShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassShapeSerializerBase.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized ClassShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ClassShape instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the ClassShape instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the ClassShape instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassShapeSerializerBase.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one ClassShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ClassShape instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassShapeSerializerBase.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given ClassShape instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ClassShape instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the ClassShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassShapeSerializerBase.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ClassShape instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassShapeSerializerBase.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of ClassShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassShapeSerializerBase.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of ClassShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ClassShapeSerializerBase.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of ClassShape in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ClassShapeSerializer">
            <summary>
            Serializer ClassShapeSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.ClassShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ClassShapeSerializer.#ctor">
            <summary>
            ClassShapeSerializer Constructor
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipAsClassShapeSerializerBase">
            <summary>
            Serializer RelationshipAsClassShapeSerializerBase for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipAsClassShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipAsClassShapeSerializerBase.#ctor">
            <summary>
            RelationshipAsClassShapeSerializerBase Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipAsClassShapeSerializerBase.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one RelationshipAsClassShape instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the RelationshipAsClassShape element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory RelationshipAsClassShape instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipAsClassShapeSerializerBase.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of RelationshipAsClassShape based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized RelationshipAsClassShape, a new RelationshipAsClassShape instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created RelationshipAsClassShape instance, or null if the reader is not pointing to a serialized RelationshipAsClassShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipAsClassShapeSerializerBase.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of RelationshipAsClassShape based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of RelationshipAsClassShape.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new RelationshipAsClassShape instance should be created.</param>	
            <returns>Created RelationshipAsClassShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipAsClassShapeSerializerBase.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including RelationshipAsClassShape itself) instance of RelationshipAsClassShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipAsClassShapeSerializerBase.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of RelationshipAsClassShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipAsClassShapeSerializerBase.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized RelationshipAsClassShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">RelationshipAsClassShape instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the RelationshipAsClassShape instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the RelationshipAsClassShape instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipAsClassShapeSerializerBase.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one RelationshipAsClassShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">RelationshipAsClassShape instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipAsClassShapeSerializerBase.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given RelationshipAsClassShape instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">RelationshipAsClassShape instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the RelationshipAsClassShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipAsClassShapeSerializerBase.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">RelationshipAsClassShape instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipAsClassShapeSerializerBase.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of RelationshipAsClassShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipAsClassShapeSerializerBase.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of RelationshipAsClassShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipAsClassShapeSerializerBase.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of RelationshipAsClassShape in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipAsClassShapeSerializer">
            <summary>
            Serializer RelationshipAsClassShapeSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipAsClassShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipAsClassShapeSerializer.#ctor">
            <summary>
            RelationshipAsClassShapeSerializer Constructor
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipShapeSerializerBase">
            <summary>
            Serializer RelationshipShapeSerializerBase for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipShapeSerializerBase.#ctor">
            <summary>
            RelationshipShapeSerializerBase Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipShapeSerializerBase.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one RelationshipShape instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the RelationshipShape element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory RelationshipShape instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipShapeSerializerBase.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of RelationshipShape based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized RelationshipShape, a new RelationshipShape instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created RelationshipShape instance, or null if the reader is not pointing to a serialized RelationshipShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipShapeSerializerBase.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of RelationshipShape based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of RelationshipShape.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new RelationshipShape instance should be created.</param>	
            <returns>Created RelationshipShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipShapeSerializerBase.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including RelationshipShape itself) instance of RelationshipShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipShapeSerializerBase.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of RelationshipShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipShapeSerializerBase.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized RelationshipShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">RelationshipShape instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the RelationshipShape instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the RelationshipShape instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipShapeSerializerBase.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one RelationshipShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">RelationshipShape instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipShapeSerializerBase.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given RelationshipShape instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">RelationshipShape instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the RelationshipShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipShapeSerializerBase.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">RelationshipShape instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipShapeSerializerBase.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of RelationshipShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipShapeSerializerBase.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of RelationshipShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipShapeSerializerBase.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of RelationshipShape in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipShapeSerializer">
            <summary>
            Serializer RelationshipShapeSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipShapeSerializer.#ctor">
            <summary>
            RelationshipShapeSerializer Constructor
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramShapeSerializerBase">
            <summary>
            Serializer DiagramShapeSerializerBase for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.DiagramShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramShapeSerializerBase.#ctor">
            <summary>
            DiagramShapeSerializerBase Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramShapeSerializerBase.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DiagramShape instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DiagramShape element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DiagramShape instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramShapeSerializerBase.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DiagramShape based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DiagramShape, a new DiagramShape instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DiagramShape instance, or null if the reader is not pointing to a serialized DiagramShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramShapeSerializerBase.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DiagramShape based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DiagramShape.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DiagramShape instance should be created.</param>	
            <returns>Created DiagramShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramShapeSerializerBase.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DiagramShape itself) instance of DiagramShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramShapeSerializerBase.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DiagramShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramShapeSerializerBase.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized DiagramShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DiagramShape instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the DiagramShape instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the DiagramShape instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramShapeSerializerBase.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one DiagramShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DiagramShape instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramShapeSerializerBase.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given DiagramShape instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DiagramShape instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the DiagramShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramShapeSerializerBase.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DiagramShape instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramShapeSerializerBase.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DiagramShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramShapeSerializerBase.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of DiagramShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramShapeSerializerBase.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of DiagramShape in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramShapeSerializer">
            <summary>
            Serializer DiagramShapeSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.DiagramShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramShapeSerializer.#ctor">
            <summary>
            DiagramShapeSerializer Constructor
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeShapeSerializerBase">
            <summary>
            Serializer ShapeShapeSerializerBase for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.ShapeShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeShapeSerializerBase.#ctor">
            <summary>
            ShapeShapeSerializerBase Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeShapeSerializerBase.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            ShapeShape is abstract and cannot be instantiated, so this method throws NotSupportedException.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ShapeShape element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ShapeShape instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeShapeSerializerBase.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ShapeShape based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ShapeShape, a new ShapeShape instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ShapeShape instance, or null if the reader is not pointing to a serialized ShapeShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeShapeSerializerBase.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ShapeShape based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ShapeShape.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ShapeShape instance should be created.</param>	
            <returns>Created ShapeShape instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeShapeSerializerBase.derivedClasses">
            <summary>
            Stores a mapping from XmlTagName to DomainClassInfo that derives from ShapeShape, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeShapeSerializerBase.ConstructDerivedClassesLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the apping from XmlTagName to DomainClassInfo that derives from ShapeShape.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeShapeSerializerBase.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ShapeShape itself) instance of ShapeShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeShapeSerializerBase.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ShapeShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeShapeSerializerBase.derivedClassMonikers">
            <summary>
            Stores a mapping from Moniker Xml tag name to DomainClassInfo that derives from ShapeShape, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeShapeSerializerBase.ConstructDerivedClassMonikersLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the mapping from Moniker Xml tag name to DomainClassInfo that derives from ShapeShape.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeShapeSerializerBase.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized ShapeShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ShapeShape instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the ShapeShape instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the ShapeShape instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeShapeSerializerBase.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one ShapeShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ShapeShape instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeShapeSerializerBase.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given ShapeShape instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ShapeShape instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the ShapeShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeShapeSerializerBase.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ShapeShape instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeShapeSerializerBase.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeShapeSerializerBase.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeShapeSerializerBase.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeShapeSerializer">
            <summary>
            Serializer ShapeShapeSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.ShapeShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeShapeSerializer.#ctor">
            <summary>
            ShapeShapeSerializer Constructor
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeShapeSerializerBase">
            <summary>
            Serializer GeometryShapeShapeSerializerBase for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.GeometryShapeShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeShapeSerializerBase.#ctor">
            <summary>
            GeometryShapeShapeSerializerBase Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeShapeSerializerBase.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one GeometryShapeShape instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the GeometryShapeShape element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory GeometryShapeShape instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeShapeSerializerBase.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of GeometryShapeShape based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized GeometryShapeShape, a new GeometryShapeShape instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created GeometryShapeShape instance, or null if the reader is not pointing to a serialized GeometryShapeShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeShapeSerializerBase.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of GeometryShapeShape based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of GeometryShapeShape.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new GeometryShapeShape instance should be created.</param>	
            <returns>Created GeometryShapeShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeShapeSerializerBase.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including GeometryShapeShape itself) instance of GeometryShapeShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeShapeSerializerBase.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of GeometryShapeShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeShapeSerializerBase.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized GeometryShapeShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">GeometryShapeShape instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the GeometryShapeShape instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the GeometryShapeShape instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeShapeSerializerBase.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one GeometryShapeShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">GeometryShapeShape instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeShapeSerializerBase.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given GeometryShapeShape instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">GeometryShapeShape instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the GeometryShapeShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeShapeSerializerBase.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">GeometryShapeShape instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeShapeSerializerBase.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of GeometryShapeShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeShapeSerializerBase.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of GeometryShapeShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeShapeSerializerBase.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of GeometryShapeShape in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeShapeSerializer">
            <summary>
            Serializer GeometryShapeShapeSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.GeometryShapeShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.GeometryShapeShapeSerializer.#ctor">
            <summary>
            GeometryShapeShapeSerializer Constructor
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.PortShapeSerializerBase">
            <summary>
            Serializer PortShapeSerializerBase for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.PortShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortShapeSerializerBase.#ctor">
            <summary>
            PortShapeSerializerBase Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortShapeSerializerBase.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one PortShape instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the PortShape element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory PortShape instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortShapeSerializerBase.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of PortShape based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized PortShape, a new PortShape instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created PortShape instance, or null if the reader is not pointing to a serialized PortShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortShapeSerializerBase.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of PortShape based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of PortShape.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new PortShape instance should be created.</param>	
            <returns>Created PortShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortShapeSerializerBase.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including PortShape itself) instance of PortShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortShapeSerializerBase.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of PortShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortShapeSerializerBase.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized PortShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">PortShape instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the PortShape instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the PortShape instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortShapeSerializerBase.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one PortShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">PortShape instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortShapeSerializerBase.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given PortShape instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">PortShape instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the PortShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortShapeSerializerBase.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">PortShape instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PortShapeSerializerBase.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of PortShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PortShapeSerializerBase.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of PortShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PortShapeSerializerBase.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of PortShape in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.PortShapeSerializer">
            <summary>
            Serializer PortShapeSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.PortShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PortShapeSerializer.#ctor">
            <summary>
            PortShapeSerializer Constructor
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneShapeSerializerBase">
            <summary>
            Serializer SwimLaneShapeSerializerBase for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.SwimLaneShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneShapeSerializerBase.#ctor">
            <summary>
            SwimLaneShapeSerializerBase Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneShapeSerializerBase.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one SwimLaneShape instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the SwimLaneShape element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory SwimLaneShape instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneShapeSerializerBase.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of SwimLaneShape based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized SwimLaneShape, a new SwimLaneShape instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created SwimLaneShape instance, or null if the reader is not pointing to a serialized SwimLaneShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneShapeSerializerBase.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of SwimLaneShape based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of SwimLaneShape.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new SwimLaneShape instance should be created.</param>	
            <returns>Created SwimLaneShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneShapeSerializerBase.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including SwimLaneShape itself) instance of SwimLaneShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneShapeSerializerBase.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of SwimLaneShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneShapeSerializerBase.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized SwimLaneShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">SwimLaneShape instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the SwimLaneShape instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the SwimLaneShape instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneShapeSerializerBase.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one SwimLaneShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">SwimLaneShape instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneShapeSerializerBase.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given SwimLaneShape instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">SwimLaneShape instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the SwimLaneShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneShapeSerializerBase.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">SwimLaneShape instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneShapeSerializerBase.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of SwimLaneShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneShapeSerializerBase.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of SwimLaneShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneShapeSerializerBase.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of SwimLaneShape in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneShapeSerializer">
            <summary>
            Serializer SwimLaneShapeSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.SwimLaneShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.SwimLaneShapeSerializer.#ctor">
            <summary>
            SwimLaneShapeSerializer Constructor
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeShapeSerializerBase">
            <summary>
            Serializer ImageShapeShapeSerializerBase for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.ImageShapeShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeShapeSerializerBase.#ctor">
            <summary>
            ImageShapeShapeSerializerBase Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeShapeSerializerBase.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one ImageShapeShape instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ImageShapeShape element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ImageShapeShape instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeShapeSerializerBase.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ImageShapeShape based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ImageShapeShape, a new ImageShapeShape instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ImageShapeShape instance, or null if the reader is not pointing to a serialized ImageShapeShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeShapeSerializerBase.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ImageShapeShape based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ImageShapeShape.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ImageShapeShape instance should be created.</param>	
            <returns>Created ImageShapeShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeShapeSerializerBase.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ImageShapeShape itself) instance of ImageShapeShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeShapeSerializerBase.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ImageShapeShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeShapeSerializerBase.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized ImageShapeShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ImageShapeShape instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the ImageShapeShape instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the ImageShapeShape instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeShapeSerializerBase.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one ImageShapeShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ImageShapeShape instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeShapeSerializerBase.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given ImageShapeShape instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ImageShapeShape instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the ImageShapeShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeShapeSerializerBase.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ImageShapeShape instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeShapeSerializerBase.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of ImageShapeShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeShapeSerializerBase.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of ImageShapeShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeShapeSerializerBase.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of ImageShapeShape in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeShapeSerializer">
            <summary>
            Serializer ImageShapeShapeSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.ImageShapeShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ImageShapeShapeSerializer.#ctor">
            <summary>
            ImageShapeShapeSerializer Constructor
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeShapeSerializerBase">
            <summary>
            Serializer CompartmentShapeShapeSerializerBase for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentShapeShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeShapeSerializerBase.#ctor">
            <summary>
            CompartmentShapeShapeSerializerBase Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeShapeSerializerBase.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one CompartmentShapeShape instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the CompartmentShapeShape element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory CompartmentShapeShape instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeShapeSerializerBase.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of CompartmentShapeShape based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized CompartmentShapeShape, a new CompartmentShapeShape instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created CompartmentShapeShape instance, or null if the reader is not pointing to a serialized CompartmentShapeShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeShapeSerializerBase.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of CompartmentShapeShape based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of CompartmentShapeShape.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new CompartmentShapeShape instance should be created.</param>	
            <returns>Created CompartmentShapeShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeShapeSerializerBase.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including CompartmentShapeShape itself) instance of CompartmentShapeShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeShapeSerializerBase.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of CompartmentShapeShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeShapeSerializerBase.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized CompartmentShapeShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">CompartmentShapeShape instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the CompartmentShapeShape instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the CompartmentShapeShape instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeShapeSerializerBase.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one CompartmentShapeShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">CompartmentShapeShape instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeShapeSerializerBase.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given CompartmentShapeShape instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">CompartmentShapeShape instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the CompartmentShapeShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeShapeSerializerBase.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">CompartmentShapeShape instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeShapeSerializerBase.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of CompartmentShapeShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeShapeSerializerBase.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of CompartmentShapeShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeShapeSerializerBase.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of CompartmentShapeShape in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeShapeSerializer">
            <summary>
            Serializer CompartmentShapeShapeSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentShapeShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CompartmentShapeShapeSerializer.#ctor">
            <summary>
            CompartmentShapeShapeSerializer Constructor
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorShapeSerializerBase">
            <summary>
            Serializer ConnectorShapeSerializerBase for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.ConnectorShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorShapeSerializerBase.#ctor">
            <summary>
            ConnectorShapeSerializerBase Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorShapeSerializerBase.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one ConnectorShape instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the ConnectorShape element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory ConnectorShape instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorShapeSerializerBase.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of ConnectorShape based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized ConnectorShape, a new ConnectorShape instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created ConnectorShape instance, or null if the reader is not pointing to a serialized ConnectorShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorShapeSerializerBase.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of ConnectorShape based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of ConnectorShape.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new ConnectorShape instance should be created.</param>	
            <returns>Created ConnectorShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorShapeSerializerBase.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including ConnectorShape itself) instance of ConnectorShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorShapeSerializerBase.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of ConnectorShape based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorShapeSerializerBase.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized ConnectorShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ConnectorShape instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the ConnectorShape instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the ConnectorShape instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorShapeSerializerBase.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one ConnectorShape instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">ConnectorShape instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorShapeSerializerBase.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given ConnectorShape instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ConnectorShape instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the ConnectorShape instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorShapeSerializerBase.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">ConnectorShape instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorShapeSerializerBase.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of ConnectorShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorShapeSerializerBase.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of ConnectorShape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorShapeSerializerBase.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of ConnectorShape in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorShapeSerializer">
            <summary>
            Serializer ConnectorShapeSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.ConnectorShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectorShapeSerializer.#ctor">
            <summary>
            ConnectorShapeSerializer Constructor
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.TogglePortSerializer">
            <summary>
            Serializer TogglePortSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.TogglePort.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TogglePortSerializer.#ctor">
            <summary>
            TogglePortSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TogglePortSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            TogglePort is abstract and cannot be instantiated, so this method throws NotSupportedException.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the TogglePort element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory TogglePort instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TogglePortSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of TogglePort based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized TogglePort, a new TogglePort instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created TogglePort instance, or null if the reader is not pointing to a serialized TogglePort instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TogglePortSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of TogglePort based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of TogglePort.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new TogglePort instance should be created.</param>	
            <returns>Created TogglePort instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.TogglePortSerializer.derivedClasses">
            <summary>
            Stores a mapping from XmlTagName to DomainClassInfo that derives from TogglePort, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TogglePortSerializer.ConstructDerivedClassesLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the apping from XmlTagName to DomainClassInfo that derives from TogglePort.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TogglePortSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including TogglePort itself) instance of TogglePort based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TogglePortSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of TogglePort based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.TogglePortSerializer.derivedClassMonikers">
            <summary>
            Stores a mapping from Moniker Xml tag name to DomainClassInfo that derives from TogglePort, created on demand.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TogglePortSerializer.ConstructDerivedClassMonikersLookupTable(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.DomainDataDirectory)">
            <summary>
            Construct the mapping from Moniker Xml tag name to DomainClassInfo that derives from TogglePort.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="domainDataDirectory">DomainDataDirectory to be used to discover all derived classes.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TogglePortSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized TogglePort instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">TogglePort instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the TogglePort instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the TogglePort instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TogglePortSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one TogglePort instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">TogglePort instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TogglePortSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given TogglePort instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">TogglePort instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the TogglePort instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TogglePortSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">TogglePort instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.TogglePortSerializer.XmlTagName">
            <summary>
            Cannot be serialized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.TogglePortSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.TogglePortSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.InheritancePortSerializerBase">
            <summary>
            Serializer InheritancePortSerializerBase for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.InheritancePort.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritancePortSerializerBase.#ctor">
            <summary>
            InheritancePortSerializerBase Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritancePortSerializerBase.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one InheritancePort instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the InheritancePort element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory InheritancePort instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritancePortSerializerBase.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of InheritancePort based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized InheritancePort, a new InheritancePort instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created InheritancePort instance, or null if the reader is not pointing to a serialized InheritancePort instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritancePortSerializerBase.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of InheritancePort based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of InheritancePort.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new InheritancePort instance should be created.</param>	
            <returns>Created InheritancePort instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritancePortSerializerBase.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including InheritancePort itself) instance of InheritancePort based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritancePortSerializerBase.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of InheritancePort based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritancePortSerializerBase.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized InheritancePort instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">InheritancePort instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the InheritancePort instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the InheritancePort instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritancePortSerializerBase.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one InheritancePort instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">InheritancePort instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritancePortSerializerBase.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given InheritancePort instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">InheritancePort instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the InheritancePort instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritancePortSerializerBase.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">InheritancePort instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.InheritancePortSerializerBase.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of InheritancePort.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.InheritancePortSerializerBase.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of InheritancePort.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.InheritancePortSerializerBase.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of InheritancePort in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.InheritancePortSerializer">
            <summary>
            Serializer InheritancePortSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.InheritancePort.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritancePortSerializer.#ctor">
            <summary>
            InheritancePortSerializer Constructor
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipPortSerializerBase">
            <summary>
            Serializer RelationshipPortSerializerBase for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipPort.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipPortSerializerBase.#ctor">
            <summary>
            RelationshipPortSerializerBase Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipPortSerializerBase.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one RelationshipPort instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the RelationshipPort element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory RelationshipPort instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipPortSerializerBase.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of RelationshipPort based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized RelationshipPort, a new RelationshipPort instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created RelationshipPort instance, or null if the reader is not pointing to a serialized RelationshipPort instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipPortSerializerBase.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of RelationshipPort based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of RelationshipPort.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new RelationshipPort instance should be created.</param>	
            <returns>Created RelationshipPort instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipPortSerializerBase.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including RelationshipPort itself) instance of RelationshipPort based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipPortSerializerBase.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of RelationshipPort based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipPortSerializerBase.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized RelationshipPort instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">RelationshipPort instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the RelationshipPort instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the RelationshipPort instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipPortSerializerBase.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one RelationshipPort instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">RelationshipPort instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipPortSerializerBase.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given RelationshipPort instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">RelationshipPort instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the RelationshipPort instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipPortSerializerBase.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">RelationshipPort instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipPortSerializerBase.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of RelationshipPort.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipPortSerializerBase.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of RelationshipPort.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipPortSerializerBase.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of RelationshipPort in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipPortSerializer">
            <summary>
            Serializer RelationshipPortSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipPort.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RelationshipPortSerializer.#ctor">
            <summary>
            RelationshipPortSerializer Constructor
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainModelElementsSerializerBase">
            <summary>
            Serializer DomainModelElementsSerializerBase for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.DomainModelElements.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainModelElementsSerializerBase.#ctor">
            <summary>
            DomainModelElementsSerializerBase Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainModelElementsSerializerBase.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DomainModelElements instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DomainModelElements element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DomainModelElements instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainModelElementsSerializerBase.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DomainModelElements based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DomainModelElements, a new DomainModelElements instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DomainModelElements instance, or null if the reader is not pointing to a serialized DomainModelElements instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainModelElementsSerializerBase.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DomainModelElements based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DomainModelElements.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DomainModelElements instance should be created.</param>	
            <returns>Created DomainModelElements instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainModelElementsSerializerBase.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DomainModelElements itself) instance of DomainModelElements based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainModelElementsSerializerBase.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DomainModelElements based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainModelElementsSerializerBase.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized DomainModelElements instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainModelElements instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the DomainModelElements instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the DomainModelElements instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainModelElementsSerializerBase.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one DomainModelElements instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DomainModelElements instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainModelElementsSerializerBase.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given DomainModelElements instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DomainModelElements instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the DomainModelElements instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainModelElementsSerializerBase.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DomainModelElements instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainModelElementsSerializerBase.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DomainModelElements.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainModelElementsSerializerBase.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of DomainModelElements.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DomainModelElementsSerializerBase.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of DomainModelElements in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainModelElementsSerializer">
            <summary>
            Serializer DomainModelElementsSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.DomainModelElements.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainModelElementsSerializer.#ctor">
            <summary>
            DomainModelElementsSerializer Constructor
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementsSerializerBase">
            <summary>
            Serializer DiagramElementsSerializerBase for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.DiagramElements.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementsSerializerBase.#ctor">
            <summary>
            DiagramElementsSerializerBase Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementsSerializerBase.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one DiagramElements instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the DiagramElements element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory DiagramElements instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementsSerializerBase.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of DiagramElements based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized DiagramElements, a new DiagramElements instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created DiagramElements instance, or null if the reader is not pointing to a serialized DiagramElements instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementsSerializerBase.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of DiagramElements based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of DiagramElements.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new DiagramElements instance should be created.</param>	
            <returns>Created DiagramElements instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementsSerializerBase.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including DiagramElements itself) instance of DiagramElements based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementsSerializerBase.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of DiagramElements based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementsSerializerBase.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized DiagramElements instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DiagramElements instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the DiagramElements instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the DiagramElements instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementsSerializerBase.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one DiagramElements instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">DiagramElements instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementsSerializerBase.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given DiagramElements instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DiagramElements instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the DiagramElements instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementsSerializerBase.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">DiagramElements instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementsSerializerBase.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of DiagramElements.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementsSerializerBase.MonikerTagName">
            <summary>
            This is the XML tag name used to serialize a monikerized instance of DiagramElements.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementsSerializerBase.MonikerAttributeName">
            <summary>
            This is the name of the XML attribute that stores the moniker of DiagramElements in a serialized monikerized instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementsSerializer">
            <summary>
            Serializer DiagramElementsSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.DiagramElements.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementsSerializer.#ctor">
            <summary>
            DiagramElementsSerializer Constructor
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceConnectorSerializer">
            <summary>
            Serializer InheritanceConnectorSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceConnectorSerializer.#ctor">
            <summary>
            InheritanceConnectorSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceConnectorSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one InheritanceConnector instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the InheritanceConnector element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory InheritanceConnector instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceConnectorSerializer.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory InheritanceConnector instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceConnectorSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of InheritanceConnector based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized InheritanceConnector, a new InheritanceConnector instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created InheritanceConnector instance, or null if the reader is not pointing to a serialized InheritanceConnector instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceConnectorSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of InheritanceConnector based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of InheritanceConnector.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new InheritanceConnector instance should be created.</param>	
            <returns>Created InheritanceConnector instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceConnectorSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including InheritanceConnector itself) instance of InheritanceConnector based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceConnectorSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of InheritanceConnector based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceConnectorSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized InheritanceConnector instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">InheritanceConnector instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the InheritanceConnector instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the InheritanceConnector instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceConnectorSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one InheritanceConnector instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">InheritanceConnector instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceConnectorSerializer.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">InheritanceConnector instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceConnectorSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given InheritanceConnector instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">InheritanceConnector instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the InheritanceConnector instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceConnectorSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">InheritanceConnector instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceConnectorSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of InheritanceConnector.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceConnectorSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceConnectorSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.RoleConnectorSerializerBase">
            <summary>
            Serializer RoleConnectorSerializerBase for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnector.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleConnectorSerializerBase.#ctor">
            <summary>
            RoleConnectorSerializerBase Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleConnectorSerializerBase.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one RoleConnector instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the RoleConnector element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory RoleConnector instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleConnectorSerializerBase.ReadPropertiesFromAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            This method deserializes all properties that are serialized as XML attributes.
            </summary>
            <remarks>
            Because this method only handles properties serialized as XML attributes, the passed-in reader shouldn't be moved inside this method.
            The caller will guarantee that the reader is positioned on the open XML tag of the current element being deserialized.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory RoleConnector instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleConnectorSerializerBase.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of RoleConnector based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized RoleConnector, a new RoleConnector instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created RoleConnector instance, or null if the reader is not pointing to a serialized RoleConnector instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleConnectorSerializerBase.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of RoleConnector based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of RoleConnector.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new RoleConnector instance should be created.</param>	
            <returns>Created RoleConnector instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleConnectorSerializerBase.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including RoleConnector itself) instance of RoleConnector based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleConnectorSerializerBase.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of RoleConnector based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleConnectorSerializerBase.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized RoleConnector instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">RoleConnector instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the RoleConnector instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the RoleConnector instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleConnectorSerializerBase.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one RoleConnector instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">RoleConnector instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleConnectorSerializerBase.WritePropertiesAsAttributes(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter)">
            <summary>
            Write all properties that need to be serialized as XML attributes.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">RoleConnector instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param> 
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleConnectorSerializerBase.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given RoleConnector instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">RoleConnector instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the RoleConnector instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleConnectorSerializerBase.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">RoleConnector instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RoleConnectorSerializerBase.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of RoleConnector.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RoleConnectorSerializerBase.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.RoleConnectorSerializerBase.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.RoleConnectorSerializer">
            <summary>
            Serializer RoleConnectorSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnector.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.RoleConnectorSerializer.#ctor">
            <summary>
            RoleConnectorSerializer Constructor
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.MapConnectorSerializer">
            <summary>
            Serializer MapConnectorSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.MapConnector.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.MapConnectorSerializer.#ctor">
            <summary>
            MapConnectorSerializer Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.MapConnectorSerializer.Read(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlReader)">
            <summary>
            Public Read() method that deserializes one MapConnector instance from XML.
            </summary>
            <remarks>
            When this method is called, caller guarantees that the passed-in XML reader is positioned at the open XML tag
            of the MapConnector element that is about to be deserialized. 
            The method needs to ensure that when it returns, the reader is positioned at the open XML tag of the next sibling element,
            or the close tag of the parent element (or EOF).
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">In-memory MapConnector instance that will get the deserialized data.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.MapConnectorSerializer.TryCreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a correct instance of MapConnector based on the tag currently pointed by the reader. If the reader
            is positioned at a serialized MapConnector, a new MapConnector instance will be created in the given partition, otherwise 
            null is returned.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new elements should be created.</param>	
            <returns>Created MapConnector instance, or null if the reader is not pointing to a serialized MapConnector instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.MapConnectorSerializer.CreateInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates an instance of MapConnector based on the tag currently pointed by the reader. The reader is guaranteed (by the caller)
            to be pointed at a serialized instance of MapConnector.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the ModelRoot instance being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="partition">Partition in which new MapConnector instance should be created.</param>	
            <returns>Created MapConnector instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.MapConnectorSerializer.TryCreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of the correct derived (including MapConnector itself) instance of MapConnector based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.MapConnectorSerializer.CreateMonikerInstance(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,Microsoft.VisualStudio.Modeling.ModelElement,System.Guid,Microsoft.VisualStudio.Modeling.Partition)">
            <summary>
            This method creates a Moniker of MapConnector based on the tag currently pointed by the reader.
            </summary>
            <remarks>
            The caller will guarantee that the reader is positioned at open XML tag of the next element being read. This method should
            not move the reader; the reader should remain at the same position when this method returns.
            </remarks>		
            <param name="serializationContext">Serialization context.</param>
            <param name="reader">XmlReader to read serialized data from.</param>
            <param name="sourceRolePlayer">The source role-player instance from which the moniker being created is referenced.</param>
            <param name="relDomainClassId">The DomainClass Id of the relationship that connects the sourceRolePlayer to the moniker being created.</param>
            <param name="partition">The new Moniker should be created in the Store associated with this partition.</param>			
            <returns>Created ModelRoot instance, or null if the reader is not pointing to a correct monikerized instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.MapConnectorSerializer.WriteMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRelationshipXmlSerializer)">
            <summary>
            Public WriteMoniker() method that writes a monikerized MapConnector instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">MapConnector instance to be monikerized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="sourceRolePlayer">Source element that references the MapConnector instance being monikerized.</param>
            <param name="relSerializer">Serializer that handles the relationship connecting the source element to the MapConnector instance being monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.MapConnectorSerializer.Write(Microsoft.VisualStudio.Modeling.SerializationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.Xml.XmlWriter,Microsoft.VisualStudio.Modeling.RootElementSettings)">
            <summary>
            Public Write() method that serializes one MapConnector instance into XML.
            </summary>
            <param name="serializationContext">Serialization context.</param>
            <param name="element">MapConnector instance to be serialized.</param>
            <param name="writer">XmlWriter to write serialized data to.</param>
            <param name="rootElementSettings">
            The root element settings if the passed in element is serialized as a root element in the XML. The root element contains additional
            information like schema target namespace, version, etc.
            This should only be passed for root-level elements. Null should be passed for rest elements (and ideally call the Write() method 
            without this parameter).
            </param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.MapConnectorSerializer.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method calculates a moniker to a given MapConnector instance.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">MapConnector instance to calculate qualified name for.</param>
            <returns>A fully qualified string moniker to the MapConnector instance.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.MapConnectorSerializer.GetMonikerQualifier(Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            A domain class can be monikerized in different ways: standard /qualifier/key mechanism, custom moniker, or element ID. If the domain class is serialized
            using standard /qualifier/key mechanism, this method returns the qualifier of the moniker; if the domain class uses other ways for monikerization, this method
            returns empty string.
            </summary>
            <param name="directory">Directory to look up serializer based on model element type.</param>
            <param name="element">MapConnector instance to get moniker qualifier from.</param>
            <returns>
            Value of this element's moniker qualifier property, if it has one, or the value of the container's moniker qualifier property. Or empty string if this
            element is not monikerized using standard /qualifier/key mechanism.
            </returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.MapConnectorSerializer.XmlTagName">
            <summary>
            This is the XML tag name used to serialize an instance of MapConnector.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.MapConnectorSerializer.MonikerTagName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.MapConnectorSerializer.MonikerAttributeName">
            <summary>
            Cannot be monikerized.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializer">
            <summary>
            Serializer DslDesignerDiagramSerializer for DomainClass Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagram.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDesignerDiagramSerializer.#ctor">
            <summary>
            DslDesignerDiagramSerializer Constructor
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorBase">
            <summary>
            A DomainXmlSerializationBehavior implementation for defined behavior DslDefinitionModelSerializationBehavior.
            This is the abstract base of the double-derived implementation.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorBase.serializerTypes">
            <summary>
            A dictionary that maps DomainClass Id to DomainClassXmlSerializer types.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorBase.#ctor">
            <summary>
            Protected constructor to prevent public instantiation.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorBase.CustomSerializerTypes">
            <summary>
            Allows custom serializers to be added.
            Base implementation doesn't do anything.
            </summary>
            <returns>Custom serializer types, null or empty list if there's no custom serializer types.</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorBase.AllSerializers">
            <summary>
            This provides a mapping from DomainClass Id to DomainXmlSerializer implementation types.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehavior">
            <summary>
            A DomainXmlSerializationBehavior implementation for defined behavior DslDefinitionModelSerializationBehavior.
            This is the concrete type of the double-derived implementation.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehavior.instance">
            <summary>
            Singleton instance.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehavior.#ctor">
            <summary>
            Private constructor to prevent public instantiation.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehavior.Instance">
            <summary>
            Singleton instance.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorMonikerResolver">
            <summary>
            Moniker resolver for serialization behavior DslDefinitionModelSerializationBehavior.
            </summary>
            <summary>
            A moniker resolver that can cope with the custom moniker keys used in the DomainPath implementation
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorMonikerResolver.directory">
            <summary>
            Look-up directory to find serializers for domain classes.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorMonikerResolver.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.DomainXmlSerializerDirectory)">
            <summary>
            Constructor.
            </summary>
            <param name="store">Store for this moniker resolver.</param>
            <param name="directory">Directory to used by this resolver to look up for serializers.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorMonikerResolver.CanBeMonikerized(Microsoft.VisualStudio.Modeling.DomainClassInfo)">
            <summary>
            Tells if a DomainClass can be monikerized or not.
            </summary>
            <param name="domainClassInfo">DomainClassInfo of the DomainClass to be checked.</param>
            <returns>True if the DomainClass can be monikerized, false otherwise.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorMonikerResolver.CalculateQualifiedName(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Calculate the fully qualified monikerized string of the given ModelElement.
            </summary>
            <param name="mel">ModelElement to get moniker from.</param>
            <returns>Calculated moniker string, returns null or empty string is the given ModelElement cannot be monikerized.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorMonikerResolver.OnUnresolvedMoniker(Microsoft.VisualStudio.Modeling.SerializationResult,Microsoft.VisualStudio.Modeling.Moniker)">
            <summary>
            Called at the end of synchronization when they're unresolved monikers.
            </summary>
            <param name="serializationResult">SerializationResult to store error/warning messages.</param>
            <param name="moniker">Unresolved moniker.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorMonikerResolver.OnMonikerResolvedToDuplicateLink(Microsoft.VisualStudio.Modeling.SerializationResult,Microsoft.VisualStudio.Modeling.Moniker)">
            <summary>
            Called when resolving a moniker causes a duplicate link to be created.
            </summary>
            <param name="serializationResult">SerializationResult to store error/warning messages.</param>
            <param name="moniker">Moniker that causes duplicate link to be created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorMonikerResolver.OnAmbiguousMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,System.String,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Called when two new elements are giving the same moniker, which will cause ambiguity during moniker resolution.
            </summary>
            <param name="context">SerializationContext to store error/warning messages.</param>
            <param name="moniker">Moniker that both elements give.</param>
            <param name="element1">The first element giving the moniker.</param>
            <param name="element2">The second element giving the same moniker.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorMonikerResolver.ProcessAddedElement(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            This method is called when an added model element is being processed at the end of deserialization transaction.
            </summary>
            <param name="mel">A model element created during deserialization</param>
            <returns>True if the model element is processed and its moniker is added into the lookup table. This method returns false
            if a moniker has already been recorded for the model element or if it cannot be monikerized.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorMonikerResolver.ResolveMoniker(Microsoft.VisualStudio.Modeling.Moniker)">
            <summary>
            Resolves a moniker defined Dsl model.
            Special-case ModelElement to support special relationships that uses ModelElement as target role player (i.e. PresentationViewsSubject).
            </summary>
            <param name="moniker">Moniker to resolve.</param>
            <returns>Resolved ModelElement, or null if not resolved</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorMonikerResolver.UnresolvedMonikerExceptionMessage">
            <summary>
            Error message for UnresolvedMonikerException.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorSerializationMessages">
            <summary>
            Utility class to provide serialization messages
            </summary>
            <summary>
            Partial class to provide additional serialization messages
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorSerializationMessages.AmbiguousSchema(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,System.String,System.String)">
            <summary>
            Add a warning for ambiguous schemas.
            </summary>
            <param name="serializationContext">SerializationContext to add the warning message to.</param>
            <param name="reader">The reader pointing to where the message is raised.</param>
            <param name="targetNamespace">Target namespace to be resolved.</param>
            <param name="schemaPath">The schema that is used to resolve the definition of the target namespace.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorSerializationMessages.ExpectingFullFormRelationship(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,System.Type)">
            <summary>
            Add a warning when a full-form relationship seems to be serialized in short-form.
            </summary>
            <param name="serializationContext">SerializationContext to add the warning message to.</param>
            <param name="reader">The reader pointing to where the message is raised.</param>
            <param name="relationshipType">Type of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorSerializationMessages.ExpectingShortFormRelationship(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,System.Type)">
            <summary>
            Add a warning when a short-form relationship seems to be serialized in full-form.
            </summary>
            <param name="serializationContext">SerializationContext to add the warning message to.</param>
            <param name="reader">The reader pointing to where the message is raised.</param>
            <param name="relationshipType">Type of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorSerializationMessages.IgnoredPropertyValue(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,System.String,System.Type,System.String)">
            <summary>
            Add a warning for invalid property value with the given type, which will be ignored.
            </summary>
            <param name="serializationContext">SerializationContext to add the warning message to.</param>
            <param name="reader">The reader pointing to where the message is raised.</param>
            <param name="propertyName">Name of the property.</param>
            <param name="propertyType">Type of the property.</param>
            <param name="value">Invalid value that causes this warning.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorSerializationMessages.MissingId(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,System.Guid)">
            <summary>
            Add a warning for missing "Id" property.
            </summary>
            <param name="serializationContext">SerializationContext to add the warning message to.</param>
            <param name="reader">The reader pointing to where the message is raised.</param>
            <param name="newId">Auto-generated new Id.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorSerializationMessages.MonikerResolvedToDuplicateLink(Microsoft.VisualStudio.Modeling.SerializationResult,Microsoft.VisualStudio.Modeling.Moniker)">
            <summary>
            Add an warning for moniker resolved to duplicate link. The moniker will be ignored.
            </summary>
            <param name="serializationResult">SerializationResult to add the error message to.</param>
            <param name="moniker">Offending moniker.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorSerializationMessages.NoSchema(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,System.String)">
            <summary>
            Add a warning for no schema found for the given target namespace, schema validation will be skipped in this case.
            </summary>
            <param name="serializationContext">SerializationContext to add the warning message to.</param>
            <param name="reader">The reader pointing to where the message is raised.</param>
            <param name="targetNamespace">Target namespace that cannot be resolved.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorSerializationMessages.SchemaValidationError(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,System.String)">
            <summary>
            Add a warning for schema validation error.
            </summary>
            <param name="serializationContext">SerializationContext to add the warning message to.</param>
            <param name="reader">The reader pointing to where the message is raised.</param>
            <param name="message">Validation message reported from schema validation.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorSerializationMessages.UnexpectedXmlElement(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader)">
            <summary>
            Add an warning for unexpected XML element.
            </summary>
            <param name="serializationContext">SerializationContext to add the warning message to.</param>
            <param name="reader">The reader pointing to where the message is raised.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorSerializationMessages.AmbiguousMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,System.String,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Add an error for ambiguous moniker.
            </summary>
            <param name="serializationContext">SerializationContext to add the error message to.</param>
            <param name="moniker">The ambiguous moniker string.</param>
            <param name="element1">The first element using the given moniker.</param>
            <param name="element2">The second element using the given moniker.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorSerializationMessages.CannotMonikerizeElement(Microsoft.VisualStudio.Modeling.SerializationContext,System.String)">
            <summary>
            Add an error for not able to monikerize an instance of the given DomainClass.
            </summary>
            <param name="serializationContext">SerializationContext to add the error message to.</param>
            <param name="domainClassName">Name of the DomainClass whose instance cannot be monikerized.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorSerializationMessages.DanglingRelationship(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,System.String)">
            <summary>
            Add an error for dangling relationship instance.
            </summary>
            <param name="serializationContext">SerializationContext to add the error message to.</param>
            <param name="reader">The reader pointing to where the message is raised.</param>
            <param name="relationshipType">Type name of the relationship.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorSerializationMessages.InvalidPropertyValue(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,System.String,System.Type,System.String)">
            <summary>
            Add an error for invalid property value with given type.
            </summary>
            <param name="serializationContext">SerializationContext to add the error message to.</param>
            <param name="reader">The reader pointing to where the message is raised.</param>
            <param name="propertyName">Name of the property.</param>
            <param name="propertyType">Type of the property.</param>
            <param name="value">Invalid value that causes this error.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorSerializationMessages.MissingMoniker(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,System.String)">
            <summary>
            Add an error for missing moniker.
            </summary>
            <param name="serializationContext">SerializationContext to add the error message to.</param>
            <param name="reader">The reader pointing to where the message is raised.</param>
            <param name="monikerAttributeName">Name of the attribute that should hold the moniker.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorSerializationMessages.UnresolvedMoniker(Microsoft.VisualStudio.Modeling.SerializationResult,Microsoft.VisualStudio.Modeling.Moniker)">
            <summary>
            Add an error for unresolved moniker.
            </summary>
            <param name="serializationResult">SerializationResult to add the error message to.</param>
            <param name="moniker">Unresolved moniker.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorSerializationMessages.VersionMismatch(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,System.Version,System.Version)">
            <summary>
            Add an error for Version mismatch.
            </summary>
            <param name="serializationContext">SerializationContext to add the error message to.</param>
            <param name="reader">The reader pointing to where the message is raised.</param>
            <param name="expectedVersion">The version that's expected.</param>
            <param name="actualVersion">Actual version from the file.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorSerializationMessages.MinorVersionMismatch(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,System.Int32,System.Int32)">
            <summary>
            Add a warning for MinorVersion mismatch.
            </summary>
            <param name="serializationContext">SerializationContext to add the error message to.</param>
            <param name="reader">The reader pointing to where the message is raised.</param>
            <param name="actualVersion">Actual version from the file.</param>
            <param name="expectedVersion">The version that's expected.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorSerializationMessages.MajorVersionMismatch(Microsoft.VisualStudio.Modeling.SerializationContext,System.Xml.XmlReader,System.Int32,System.Int32)">
            <summary>
            Add an error for MajorVersion mismatch.
            </summary>
            <param name="serializationContext">SerializationContext to add the error message to.</param>
            <param name="reader">The reader pointing to where the message is raised.</param>
            <param name="actualVersion">Actual version from the file.</param>
            <param name="expectedVersion">The version that's expected.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelSerializationBehaviorSerializationMessages.ResourceManager">
            <summary>
            ResourceManager to get serialization messages from.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShapeBase">
            <summary>
            Double-derived base class for DomainClass AbstractClassShape
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShapeBase.InitializeResources(Microsoft.VisualStudio.Modeling.Diagrams.StyleSet)">
            <summary>
            Initializes style set resources for this shape type
            </summary>
            <param name="classStyleSet">The style set for this shape class</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShapeBase.InitializeShapeFields(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField})">
            <summary>
            Initialize the collection of shape fields associated with this shape type.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShapeBase.InitializeDecorators(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField},System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.Decorator})">
            <summary>
            Initialize the collection of decorators associated with this shape type.  This method also
            creates shape fields for outer decorators, because these are not part of the shape fields collection
            associated with the shape, so they must be created here rather than in InitializeShapeFields.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShapeBase.OnBoundsFixup(Microsoft.VisualStudio.Modeling.Diagrams.BoundsFixupState,System.Int32,System.Boolean)">
            <summary>
            Ensure outer decorators are placed appropriately.  This is called during view fixup,
            after the shape has been associated with the model element.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShapeBase.GetToolTipText(Microsoft.VisualStudio.Modeling.Diagrams.DiagramItem)">
            <summary>
            Gets the tooltip text.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShapeBase.GetCompartmentDescriptions">
            <summary>
            Gets an array of CompartmentDescription for all compartments shown on this shape
            (including compartments defined on base shapes).
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShapeBase.GetCompartmentMappings(System.Type)">
            <summary>
            Gets an array of CompartmentMappings for all compartments displayed on this shape
            (including compartment maps defined on base shapes). 
            </summary>
            <param name="melType">The type of the DomainClass that this shape is mapped to</param>
            <returns></returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShapeBase.DomainClassId">
            <summary>
            AbstractClassShape domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShapeBase.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShapeBase.inheritancePort">
            <summary>
            Cache of port to host inheritance links
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShapeBase.relationshipPort">
            <summary>
            Cache of port to host relationship links
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShapeBase.ResetRelationshipPortCache">
            <summary>
            Internal method the reset the cahce
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShapeBase.ResetInheritancePortCache">
            <summary>
            Internal method the reset the cahce
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShapeBase.DefaultSize">
            <summary>
            Default size for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShapeBase.HasBackgroundGradient">
            <summary>
            Indicates whether this shape displays a background gradient.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShapeBase.BackgroundGradientMode">
            <summary>
            Indicates the direction of the gradient.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShapeBase.ShapeGeometry">
            <summary>
            Specifies the geometry used by this shape
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShapeBase.HasToolTip">
            <summary>
            Gets a value indicating whether this shape displays a tooltip.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShapeBase.IsSingleCompartmentHeaderVisible">
            <summary>
            Returns a value indicating whether compartment header should be visible if there is only one of them.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShapeBase.InheritancePort">
            <summary>
            Port to host inheritance links
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShapeBase.RelationshipPort">
            <summary>
            Port to host relationship links
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShapeBase.Diagram">
            <summary>
            Make Diagram property more specific
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShapeBase.ReferenceType">
            <summary>
            The DomainClass represented by this shape
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape">
            <summary>
            DomainClass AbstractClassShape
            Description for Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape.Forwarder(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Forward type description to true Subject.
            </summary>
            <param name="source"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape.OnInitialize">
            <summary>
            Setup initial shape size and position
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape.UpdateInstanceStyles">
            <summary>
            Update the styles that vary on a per shape instance basis
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape.GetCompartmentMappings(System.Type)">
            <summary>
            Amend the compartment mappings to include image getter delegate.
            </summary>
            <param name="melType"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape.PropertiesCompartmentImageGetter(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Provide the correct image for a Domainproeprty compartment lien item
            </summary>
            <param name="element"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape.EnsureCompartments">
            <summary>
            Set up compartments on creation or load
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape.EnsureMappingDependentState">
            <summary>
            Ensure that the shape has the correct set of state to match the element it is associated with.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape.ResizeToContent">
            <summary>
            Make the class shape just big enough to hold its content horizontally.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape.MeasureDisplayText(System.String,System.Drawing.Font,System.Drawing.StringFormat)">
            <summary>
            Helper method to measure given text.
            </summary>
            <returns>Size of resulting text.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape.IsDescendantOfSelf">
            <summary>
            Test whether a class is embedded (directly or indirectly) in itself
            </summary>
            <returns></returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape.ReferenceTypeSourcesRoles">
            <summary>
            Is the class we present the source of any relationships?
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape.IsLeaf">
            <summary>
            Whether this shape is presenting itself as a leaf.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape.IsRoot">
            <summary>
            Whether this shape is presenting itself as a root.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape.ShouldTryParentShapeForMergeOnToolboxDoubleClick">
            <summary>
            Controls what happens when this ShapeElement is selected and the user double-clicks a toolbox item.
            By default, if CanMerge() fails for this ShapeElement, the double-click action will terminate.
            If a shape overrides this method to return true, the toolbox double-click will walk up to this
            ShapeElement's ParentShape and try the CanMerge() again.
            </summary>
            <value></value>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape.InheritancePortBoundsRules">
            <summary>
            Class to manange the positioning of the inheritance port
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape.RelationshipPortBoundsRules">
            <summary>
            Class to manange the positioning of the relationship port
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.ClassShapeBase">
            <summary>
            Double-derived base class for DomainClass ClassShape
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ClassShapeBase.FindClassShapeDecorator(System.String)">
            <summary>
            Finds a decorator associated with ClassShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ClassShapeBase.OnInitialize">
            <summary>
            Shape instance initialization.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ClassShapeBase.InitializeResources(Microsoft.VisualStudio.Modeling.Diagrams.StyleSet)">
            <summary>
            Initializes style set resources for this shape type
            </summary>
            <param name="classStyleSet">The style set for this shape class</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ClassShapeBase.InitializeShapeFields(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField})">
            <summary>
            Initialize the collection of shape fields associated with this shape type.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ClassShapeBase.InitializeDecorators(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField},System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.Decorator})">
            <summary>
            Initialize the collection of decorators associated with this shape type.  This method also
            creates shape fields for outer decorators, because these are not part of the shape fields collection
            associated with the shape, so they must be created here rather than in InitializeShapeFields.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ClassShapeBase.GetCompartmentDescriptions">
            <summary>
            Gets an array of CompartmentDescription for all compartments shown on this shape
            (including compartments defined on base shapes).
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ClassShapeBase.GetCompartmentMappings(System.Type)">
            <summary>
            Gets an array of CompartmentMappings for all compartments displayed on this shape
            (including compartment maps defined on base shapes). 
            </summary>
            <param name="melType">The type of the DomainClass that this shape is mapped to</param>
            <returns></returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.ClassShapeBase.DomainClassId">
            <summary>
            ClassShape domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ClassShapeBase.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ClassShapeBase.ClassStyleSet">
            <summary>
            Per-class style set for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ClassShapeBase.ShapeFields">
            <summary>
            Per-class ShapeFields for this shape.
            </summary>
        </member>
        <member name="E:Microsoft.VisualStudio.Modeling.DslDesigner.ClassShapeBase.DecoratorsInitialized">
            <summary>
            Event fired when decorator initialization is complete for this shape type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ClassShapeBase.Decorators">
            <summary>
            List containing decorators used by this type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ClassShapeBase.DefaultSize">
            <summary>
            Default size for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ClassShapeBase.HasBackgroundGradient">
            <summary>
            Indicates whether this shape displays a background gradient.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ClassShapeBase.BackgroundGradientMode">
            <summary>
            Indicates the direction of the gradient.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ClassShapeBase.ShapeGeometry">
            <summary>
            Specifies the geometry used by this shape
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ClassShapeBase.IsSingleCompartmentHeaderVisible">
            <summary>
            Returns a value indicating whether compartment header should be visible if there is only one of them.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.ClassShape">
            <summary>
            DomainClass ClassShape
            Description for Microsoft.VisualStudio.Modeling.DslDesigner.ClassShape
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ClassShape.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ClassShape.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipAsClassShapeBase">
            <summary>
            Double-derived base class for DomainClass RelationshipAsClassShape
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipAsClassShapeBase.FindRelationshipAsClassShapeDecorator(System.String)">
            <summary>
            Finds a decorator associated with RelationshipAsClassShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipAsClassShapeBase.OnInitialize">
            <summary>
            Shape instance initialization.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipAsClassShapeBase.InitializeResources(Microsoft.VisualStudio.Modeling.Diagrams.StyleSet)">
            <summary>
            Initializes style set resources for this shape type
            </summary>
            <param name="classStyleSet">The style set for this shape class</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipAsClassShapeBase.InitializeShapeFields(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField})">
            <summary>
            Initialize the collection of shape fields associated with this shape type.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipAsClassShapeBase.InitializeDecorators(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField},System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.Decorator})">
            <summary>
            Initialize the collection of decorators associated with this shape type.  This method also
            creates shape fields for outer decorators, because these are not part of the shape fields collection
            associated with the shape, so they must be created here rather than in InitializeShapeFields.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipAsClassShapeBase.GetCompartmentDescriptions">
            <summary>
            Gets an array of CompartmentDescription for all compartments shown on this shape
            (including compartments defined on base shapes).
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipAsClassShapeBase.GetCompartmentMappings(System.Type)">
            <summary>
            Gets an array of CompartmentMappings for all compartments displayed on this shape
            (including compartment maps defined on base shapes). 
            </summary>
            <param name="melType">The type of the DomainClass that this shape is mapped to</param>
            <returns></returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipAsClassShapeBase.DomainClassId">
            <summary>
            RelationshipAsClassShape domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipAsClassShapeBase.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipAsClassShapeBase.ClassStyleSet">
            <summary>
            Per-class style set for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipAsClassShapeBase.ShapeFields">
            <summary>
            Per-class ShapeFields for this shape.
            </summary>
        </member>
        <member name="E:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipAsClassShapeBase.DecoratorsInitialized">
            <summary>
            Event fired when decorator initialization is complete for this shape type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipAsClassShapeBase.Decorators">
            <summary>
            List containing decorators used by this type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipAsClassShapeBase.DefaultSize">
            <summary>
            Default size for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipAsClassShapeBase.HasBackgroundGradient">
            <summary>
            Indicates whether this shape displays a background gradient.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipAsClassShapeBase.BackgroundGradientMode">
            <summary>
            Indicates the direction of the gradient.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipAsClassShapeBase.ShapeGeometry">
            <summary>
            Specifies the geometry used by this shape
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipAsClassShapeBase.IsSingleCompartmentHeaderVisible">
            <summary>
            Returns a value indicating whether compartment header should be visible if there is only one of them.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipAsClassShape">
            <summary>
            DomainClass RelationshipAsClassShape
            Description for
            Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipAsClassShape
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipAsClassShape.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipAsClassShape.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShapeBase">
            <summary>
            Double-derived base class for DomainClass RelationshipShape
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShapeBase.FindRelationshipShapeDecorator(System.String)">
            <summary>
            Finds a decorator associated with RelationshipShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShapeBase.OnInitialize">
            <summary>
            Shape instance initialization.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShapeBase.InitializeResources(Microsoft.VisualStudio.Modeling.Diagrams.StyleSet)">
            <summary>
            Initializes style set resources for this shape type
            </summary>
            <param name="classStyleSet">The style set for this shape class</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShapeBase.InitializeShapeFields(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField})">
            <summary>
            Initialize the collection of shape fields associated with this shape type.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShapeBase.InitializeDecorators(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField},System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.Decorator})">
            <summary>
            Initialize the collection of decorators associated with this shape type.  This method also
            creates shape fields for outer decorators, because these are not part of the shape fields collection
            associated with the shape, so they must be created here rather than in InitializeShapeFields.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShapeBase.OnBoundsFixup(Microsoft.VisualStudio.Modeling.Diagrams.BoundsFixupState,System.Int32,System.Boolean)">
            <summary>
            Ensure outer decorators are placed appropriately.  This is called during view fixup,
            after the shape has been associated with the model element.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShapeBase.GetCompartmentDescriptions">
            <summary>
            Gets an array of CompartmentDescription for all compartments shown on this shape
            (including compartments defined on base shapes).
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShapeBase.GetCompartmentMappings(System.Type)">
            <summary>
            Gets an array of CompartmentMappings for all compartments displayed on this shape
            (including compartment maps defined on base shapes). 
            </summary>
            <param name="melType">The type of the DomainClass that this shape is mapped to</param>
            <returns></returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShapeBase.DomainClassId">
            <summary>
            RelationshipShape domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShapeBase.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShapeBase.ClassStyleSet">
            <summary>
            Per-class style set for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShapeBase.ShapeFields">
            <summary>
            Per-class ShapeFields for this shape.
            </summary>
        </member>
        <member name="E:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShapeBase.DecoratorsInitialized">
            <summary>
            Event fired when decorator initialization is complete for this shape type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShapeBase.Decorators">
            <summary>
            List containing decorators used by this type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShapeBase.DefaultSize">
            <summary>
            Default size for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShapeBase.HasBackgroundGradient">
            <summary>
            Indicates whether this shape displays a background gradient.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShapeBase.BackgroundGradientMode">
            <summary>
            Indicates the direction of the gradient.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShapeBase.IsSingleCompartmentHeaderVisible">
            <summary>
            Returns a value indicating whether compartment header should be visible if there is only one of them.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShape">
            <summary>
            DomainClass RelationshipShape
            Description for Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShape
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShape.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShape.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShape.UpdateInstanceStyles">
            <summary>
            Update the styles that vary on a per shape instance basis
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShape.OnInitialize">
            <summary>
            Modify the initial bounds for this shape
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShape.GetCompartmentMappings(System.Type)">
            <summary>
            Amend the compartment mappings to include image getter delegate.
            </summary>
            <param name="melType"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShape.PropertiesCompartmentImageGetter(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Provide the correct image for a Domainproeprty compartment lien item
            </summary>
            <param name="element"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShape.EnsureCompartments">
            <summary>
            Set up compartments on creation or load
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShape.HasToolTip">
            <summary>
            Connector has tooltip
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramShapeBase">
            <summary>
            Double-derived base class for DomainClass DiagramShape
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramShapeBase.FindDiagramShapeDecorator(System.String)">
            <summary>
            Finds a decorator associated with DiagramShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramShapeBase.OnInitialize">
            <summary>
            Shape instance initialization.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramShapeBase.InitializeResources(Microsoft.VisualStudio.Modeling.Diagrams.StyleSet)">
            <summary>
            Initializes style set resources for this shape type
            </summary>
            <param name="classStyleSet">The style set for this shape class</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramShapeBase.InitializeShapeFields(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField})">
            <summary>
            Initialize the collection of shape fields associated with this shape type.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramShapeBase.InitializeDecorators(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField},System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.Decorator})">
            <summary>
            Initialize the collection of decorators associated with this shape type.  This method also
            creates shape fields for outer decorators, because these are not part of the shape fields collection
            associated with the shape, so they must be created here rather than in InitializeShapeFields.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramShapeBase.GetCompartmentDescriptions">
            <summary>
            Gets an array of CompartmentDescription for all compartments shown on this shape
            (including compartments defined on base shapes).
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramShapeBase.GetCompartmentMappings(System.Type)">
            <summary>
            Gets an array of CompartmentMappings for all compartments displayed on this shape
            (including compartment maps defined on base shapes). 
            </summary>
            <param name="melType">The type of the DomainClass that this shape is mapped to</param>
            <returns></returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramShapeBase.DomainClassId">
            <summary>
            DiagramShape domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramShapeBase.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramShapeBase.ClassStyleSet">
            <summary>
            Per-class style set for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramShapeBase.ShapeFields">
            <summary>
            Per-class ShapeFields for this shape.
            </summary>
        </member>
        <member name="E:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramShapeBase.DecoratorsInitialized">
            <summary>
            Event fired when decorator initialization is complete for this shape type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramShapeBase.Decorators">
            <summary>
            List containing decorators used by this type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramShapeBase.DefaultSize">
            <summary>
            Default size for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramShapeBase.HasBackgroundGradient">
            <summary>
            Indicates whether this shape displays a background gradient.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramShapeBase.BackgroundGradientMode">
            <summary>
            Indicates the direction of the gradient.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramShapeBase.ShapeGeometry">
            <summary>
            Specifies the geometry used by this shape
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramShapeBase.IsSingleCompartmentHeaderVisible">
            <summary>
            Returns a value indicating whether compartment header should be visible if there is only one of them.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramShape">
            <summary>
            DomainClass DiagramShape
            Description for Microsoft.VisualStudio.Modeling.DslDesigner.DiagramShape
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramShape.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramShape.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.ShapeShapeBase">
            <summary>
            Double-derived base class for DomainClass ShapeShape
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ShapeShapeBase.InitializeResources(Microsoft.VisualStudio.Modeling.Diagrams.StyleSet)">
            <summary>
            Initializes style set resources for this shape type
            </summary>
            <param name="classStyleSet">The style set for this shape class</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ShapeShapeBase.GetCompartmentDescriptions">
            <summary>
            Gets an array of CompartmentDescription for all compartments shown on this shape
            (including compartments defined on base shapes).
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ShapeShapeBase.GetCompartmentMappings(System.Type)">
            <summary>
            Gets an array of CompartmentMappings for all compartments displayed on this shape
            (including compartment maps defined on base shapes). 
            </summary>
            <param name="melType">The type of the DomainClass that this shape is mapped to</param>
            <returns></returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.ShapeShapeBase.DomainClassId">
            <summary>
            ShapeShape domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ShapeShapeBase.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ShapeShapeBase.DefaultSize">
            <summary>
            Default size for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ShapeShapeBase.HasBackgroundGradient">
            <summary>
            Indicates whether this shape displays a background gradient.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ShapeShapeBase.BackgroundGradientMode">
            <summary>
            Indicates the direction of the gradient.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ShapeShapeBase.ShapeGeometry">
            <summary>
            Specifies the geometry used by this shape
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ShapeShapeBase.IsSingleCompartmentHeaderVisible">
            <summary>
            Returns a value indicating whether compartment header should be visible if there is only one of them.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.ShapeShape">
            <summary>
            DomainClass ShapeShape
            Description for Microsoft.VisualStudio.Modeling.DslDesigner.ShapeShape
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ShapeShape.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ShapeShape.GetCompartmentMappings(System.Type)">
            <summary>
            Amend the compartment mappings to include image getter delegate.
            </summary>
            <param name="melType"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ShapeShape.DecoratorCompartmentImageGetter(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Provide the correct image for a Decorator compartment line item
            </summary>
            <param name="element"></param>
            <returns></returns>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.GeometryShapeShapeBase">
            <summary>
            Double-derived base class for DomainClass GeometryShapeShape
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.GeometryShapeShapeBase.FindGeometryShapeShapeDecorator(System.String)">
            <summary>
            Finds a decorator associated with GeometryShapeShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.GeometryShapeShapeBase.OnInitialize">
            <summary>
            Shape instance initialization.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.GeometryShapeShapeBase.InitializeResources(Microsoft.VisualStudio.Modeling.Diagrams.StyleSet)">
            <summary>
            Initializes style set resources for this shape type
            </summary>
            <param name="classStyleSet">The style set for this shape class</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.GeometryShapeShapeBase.InitializeShapeFields(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField})">
            <summary>
            Initialize the collection of shape fields associated with this shape type.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.GeometryShapeShapeBase.InitializeDecorators(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField},System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.Decorator})">
            <summary>
            Initialize the collection of decorators associated with this shape type.  This method also
            creates shape fields for outer decorators, because these are not part of the shape fields collection
            associated with the shape, so they must be created here rather than in InitializeShapeFields.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.GeometryShapeShapeBase.OnBoundsFixup(Microsoft.VisualStudio.Modeling.Diagrams.BoundsFixupState,System.Int32,System.Boolean)">
            <summary>
            Ensure outer decorators are placed appropriately.  This is called during view fixup,
            after the shape has been associated with the model element.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.GeometryShapeShapeBase.GetCompartmentDescriptions">
            <summary>
            Gets an array of CompartmentDescription for all compartments shown on this shape
            (including compartments defined on base shapes).
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.GeometryShapeShapeBase.GetCompartmentMappings(System.Type)">
            <summary>
            Gets an array of CompartmentMappings for all compartments displayed on this shape
            (including compartment maps defined on base shapes). 
            </summary>
            <param name="melType">The type of the DomainClass that this shape is mapped to</param>
            <returns></returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.GeometryShapeShapeBase.DomainClassId">
            <summary>
            GeometryShapeShape domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.GeometryShapeShapeBase.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.GeometryShapeShapeBase.ClassStyleSet">
            <summary>
            Per-class style set for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.GeometryShapeShapeBase.ShapeFields">
            <summary>
            Per-class ShapeFields for this shape.
            </summary>
        </member>
        <member name="E:Microsoft.VisualStudio.Modeling.DslDesigner.GeometryShapeShapeBase.DecoratorsInitialized">
            <summary>
            Event fired when decorator initialization is complete for this shape type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.GeometryShapeShapeBase.Decorators">
            <summary>
            List containing decorators used by this type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.GeometryShapeShapeBase.DefaultSize">
            <summary>
            Default size for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.GeometryShapeShapeBase.HasBackgroundGradient">
            <summary>
            Indicates whether this shape displays a background gradient.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.GeometryShapeShapeBase.BackgroundGradientMode">
            <summary>
            Indicates the direction of the gradient.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.GeometryShapeShapeBase.ShapeGeometry">
            <summary>
            Specifies the geometry used by this shape
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.GeometryShapeShapeBase.IsSingleCompartmentHeaderVisible">
            <summary>
            Returns a value indicating whether compartment header should be visible if there is only one of them.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.GeometryShapeShape">
            <summary>
            DomainClass GeometryShapeShape
            Description for Microsoft.VisualStudio.Modeling.DslDesigner.GeometryShapeShape
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.GeometryShapeShape.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.GeometryShapeShape.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.PortShapeBase">
            <summary>
            Double-derived base class for DomainClass PortShape
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.PortShapeBase.FindPortShapeDecorator(System.String)">
            <summary>
            Finds a decorator associated with PortShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.PortShapeBase.OnInitialize">
            <summary>
            Shape instance initialization.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.PortShapeBase.InitializeResources(Microsoft.VisualStudio.Modeling.Diagrams.StyleSet)">
            <summary>
            Initializes style set resources for this shape type
            </summary>
            <param name="classStyleSet">The style set for this shape class</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.PortShapeBase.InitializeShapeFields(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField})">
            <summary>
            Initialize the collection of shape fields associated with this shape type.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.PortShapeBase.InitializeDecorators(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField},System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.Decorator})">
            <summary>
            Initialize the collection of decorators associated with this shape type.  This method also
            creates shape fields for outer decorators, because these are not part of the shape fields collection
            associated with the shape, so they must be created here rather than in InitializeShapeFields.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.PortShapeBase.OnBoundsFixup(Microsoft.VisualStudio.Modeling.Diagrams.BoundsFixupState,System.Int32,System.Boolean)">
            <summary>
            Ensure outer decorators are placed appropriately.  This is called during view fixup,
            after the shape has been associated with the model element.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.PortShapeBase.GetCompartmentDescriptions">
            <summary>
            Gets an array of CompartmentDescription for all compartments shown on this shape
            (including compartments defined on base shapes).
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.PortShapeBase.GetCompartmentMappings(System.Type)">
            <summary>
            Gets an array of CompartmentMappings for all compartments displayed on this shape
            (including compartment maps defined on base shapes). 
            </summary>
            <param name="melType">The type of the DomainClass that this shape is mapped to</param>
            <returns></returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.PortShapeBase.DomainClassId">
            <summary>
            PortShape domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.PortShapeBase.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.PortShapeBase.ClassStyleSet">
            <summary>
            Per-class style set for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.PortShapeBase.ShapeFields">
            <summary>
            Per-class ShapeFields for this shape.
            </summary>
        </member>
        <member name="E:Microsoft.VisualStudio.Modeling.DslDesigner.PortShapeBase.DecoratorsInitialized">
            <summary>
            Event fired when decorator initialization is complete for this shape type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.PortShapeBase.Decorators">
            <summary>
            List containing decorators used by this type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.PortShapeBase.DefaultSize">
            <summary>
            Default size for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.PortShapeBase.HasBackgroundGradient">
            <summary>
            Indicates whether this shape displays a background gradient.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.PortShapeBase.BackgroundGradientMode">
            <summary>
            Indicates the direction of the gradient.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.PortShapeBase.ShapeGeometry">
            <summary>
            Specifies the geometry used by this shape
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.PortShapeBase.IsSingleCompartmentHeaderVisible">
            <summary>
            Returns a value indicating whether compartment header should be visible if there is only one of them.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.PortShape">
            <summary>
            DomainClass PortShape
            Description for Microsoft.VisualStudio.Modeling.DslDesigner.PortShape
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.PortShape.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.PortShape.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.SwimLaneShapeBase">
            <summary>
            Double-derived base class for DomainClass SwimLaneShape
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.SwimLaneShapeBase.FindSwimLaneShapeDecorator(System.String)">
            <summary>
            Finds a decorator associated with SwimLaneShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.SwimLaneShapeBase.OnInitialize">
            <summary>
            Shape instance initialization.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.SwimLaneShapeBase.InitializeResources(Microsoft.VisualStudio.Modeling.Diagrams.StyleSet)">
            <summary>
            Initializes style set resources for this shape type
            </summary>
            <param name="classStyleSet">The style set for this shape class</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.SwimLaneShapeBase.InitializeShapeFields(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField})">
            <summary>
            Initialize the collection of shape fields associated with this shape type.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.SwimLaneShapeBase.InitializeDecorators(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField},System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.Decorator})">
            <summary>
            Initialize the collection of decorators associated with this shape type.  This method also
            creates shape fields for outer decorators, because these are not part of the shape fields collection
            associated with the shape, so they must be created here rather than in InitializeShapeFields.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.SwimLaneShapeBase.OnBoundsFixup(Microsoft.VisualStudio.Modeling.Diagrams.BoundsFixupState,System.Int32,System.Boolean)">
            <summary>
            Ensure outer decorators are placed appropriately.  This is called during view fixup,
            after the shape has been associated with the model element.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.SwimLaneShapeBase.GetCompartmentDescriptions">
            <summary>
            Gets an array of CompartmentDescription for all compartments shown on this shape
            (including compartments defined on base shapes).
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.SwimLaneShapeBase.GetCompartmentMappings(System.Type)">
            <summary>
            Gets an array of CompartmentMappings for all compartments displayed on this shape
            (including compartment maps defined on base shapes). 
            </summary>
            <param name="melType">The type of the DomainClass that this shape is mapped to</param>
            <returns></returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.SwimLaneShapeBase.DomainClassId">
            <summary>
            SwimLaneShape domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.SwimLaneShapeBase.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.SwimLaneShapeBase.ClassStyleSet">
            <summary>
            Per-class style set for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.SwimLaneShapeBase.ShapeFields">
            <summary>
            Per-class ShapeFields for this shape.
            </summary>
        </member>
        <member name="E:Microsoft.VisualStudio.Modeling.DslDesigner.SwimLaneShapeBase.DecoratorsInitialized">
            <summary>
            Event fired when decorator initialization is complete for this shape type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.SwimLaneShapeBase.Decorators">
            <summary>
            List containing decorators used by this type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.SwimLaneShapeBase.DefaultSize">
            <summary>
            Default size for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.SwimLaneShapeBase.HasBackgroundGradient">
            <summary>
            Indicates whether this shape displays a background gradient.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.SwimLaneShapeBase.BackgroundGradientMode">
            <summary>
            Indicates the direction of the gradient.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.SwimLaneShapeBase.ShapeGeometry">
            <summary>
            Specifies the geometry used by this shape
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.SwimLaneShapeBase.IsSingleCompartmentHeaderVisible">
            <summary>
            Returns a value indicating whether compartment header should be visible if there is only one of them.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.SwimLaneShape">
            <summary>
            DomainClass SwimLaneShape
            Description for Microsoft.VisualStudio.Modeling.DslDesigner.SwimLaneShape
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.SwimLaneShape.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.SwimLaneShape.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.ImageShapeShapeBase">
            <summary>
            Double-derived base class for DomainClass ImageShapeShape
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ImageShapeShapeBase.FindImageShapeShapeDecorator(System.String)">
            <summary>
            Finds a decorator associated with ImageShapeShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ImageShapeShapeBase.OnInitialize">
            <summary>
            Shape instance initialization.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ImageShapeShapeBase.InitializeResources(Microsoft.VisualStudio.Modeling.Diagrams.StyleSet)">
            <summary>
            Initializes style set resources for this shape type
            </summary>
            <param name="classStyleSet">The style set for this shape class</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ImageShapeShapeBase.InitializeShapeFields(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField})">
            <summary>
            Initialize the collection of shape fields associated with this shape type.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ImageShapeShapeBase.InitializeDecorators(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField},System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.Decorator})">
            <summary>
            Initialize the collection of decorators associated with this shape type.  This method also
            creates shape fields for outer decorators, because these are not part of the shape fields collection
            associated with the shape, so they must be created here rather than in InitializeShapeFields.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ImageShapeShapeBase.OnBoundsFixup(Microsoft.VisualStudio.Modeling.Diagrams.BoundsFixupState,System.Int32,System.Boolean)">
            <summary>
            Ensure outer decorators are placed appropriately.  This is called during view fixup,
            after the shape has been associated with the model element.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ImageShapeShapeBase.GetCompartmentDescriptions">
            <summary>
            Gets an array of CompartmentDescription for all compartments shown on this shape
            (including compartments defined on base shapes).
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ImageShapeShapeBase.GetCompartmentMappings(System.Type)">
            <summary>
            Gets an array of CompartmentMappings for all compartments displayed on this shape
            (including compartment maps defined on base shapes). 
            </summary>
            <param name="melType">The type of the DomainClass that this shape is mapped to</param>
            <returns></returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.ImageShapeShapeBase.DomainClassId">
            <summary>
            ImageShapeShape domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ImageShapeShapeBase.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ImageShapeShapeBase.ClassStyleSet">
            <summary>
            Per-class style set for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ImageShapeShapeBase.ShapeFields">
            <summary>
            Per-class ShapeFields for this shape.
            </summary>
        </member>
        <member name="E:Microsoft.VisualStudio.Modeling.DslDesigner.ImageShapeShapeBase.DecoratorsInitialized">
            <summary>
            Event fired when decorator initialization is complete for this shape type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ImageShapeShapeBase.Decorators">
            <summary>
            List containing decorators used by this type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ImageShapeShapeBase.DefaultSize">
            <summary>
            Default size for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ImageShapeShapeBase.HasBackgroundGradient">
            <summary>
            Indicates whether this shape displays a background gradient.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ImageShapeShapeBase.BackgroundGradientMode">
            <summary>
            Indicates the direction of the gradient.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ImageShapeShapeBase.ShapeGeometry">
            <summary>
            Specifies the geometry used by this shape
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ImageShapeShapeBase.IsSingleCompartmentHeaderVisible">
            <summary>
            Returns a value indicating whether compartment header should be visible if there is only one of them.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.ImageShapeShape">
            <summary>
            DomainClass ImageShapeShape
            Description for Microsoft.VisualStudio.Modeling.DslDesigner.ImageShapeShape
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ImageShapeShape.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ImageShapeShape.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentShapeShapeBase">
            <summary>
            Double-derived base class for DomainClass CompartmentShapeShape
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentShapeShapeBase.FindCompartmentShapeShapeDecorator(System.String)">
            <summary>
            Finds a decorator associated with CompartmentShapeShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentShapeShapeBase.OnInitialize">
            <summary>
            Shape instance initialization.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentShapeShapeBase.InitializeResources(Microsoft.VisualStudio.Modeling.Diagrams.StyleSet)">
            <summary>
            Initializes style set resources for this shape type
            </summary>
            <param name="classStyleSet">The style set for this shape class</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentShapeShapeBase.InitializeShapeFields(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField})">
            <summary>
            Initialize the collection of shape fields associated with this shape type.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentShapeShapeBase.InitializeDecorators(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField},System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.Decorator})">
            <summary>
            Initialize the collection of decorators associated with this shape type.  This method also
            creates shape fields for outer decorators, because these are not part of the shape fields collection
            associated with the shape, so they must be created here rather than in InitializeShapeFields.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentShapeShapeBase.OnBoundsFixup(Microsoft.VisualStudio.Modeling.Diagrams.BoundsFixupState,System.Int32,System.Boolean)">
            <summary>
            Ensure outer decorators are placed appropriately.  This is called during view fixup,
            after the shape has been associated with the model element.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentShapeShapeBase.GetCompartmentDescriptions">
            <summary>
            Gets an array of CompartmentDescription for all compartments shown on this shape
            (including compartments defined on base shapes).
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentShapeShapeBase.GetCompartmentMappings(System.Type)">
            <summary>
            Gets an array of CompartmentMappings for all compartments displayed on this shape
            (including compartment maps defined on base shapes). 
            </summary>
            <param name="melType">The type of the DomainClass that this shape is mapped to</param>
            <returns></returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentShapeShapeBase.DomainClassId">
            <summary>
            CompartmentShapeShape domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentShapeShapeBase.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentShapeShapeBase.ClassStyleSet">
            <summary>
            Per-class style set for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentShapeShapeBase.ShapeFields">
            <summary>
            Per-class ShapeFields for this shape.
            </summary>
        </member>
        <member name="E:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentShapeShapeBase.DecoratorsInitialized">
            <summary>
            Event fired when decorator initialization is complete for this shape type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentShapeShapeBase.Decorators">
            <summary>
            List containing decorators used by this type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentShapeShapeBase.DefaultSize">
            <summary>
            Default size for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentShapeShapeBase.HasBackgroundGradient">
            <summary>
            Indicates whether this shape displays a background gradient.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentShapeShapeBase.BackgroundGradientMode">
            <summary>
            Indicates the direction of the gradient.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentShapeShapeBase.ShapeGeometry">
            <summary>
            Specifies the geometry used by this shape
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentShapeShapeBase.IsSingleCompartmentHeaderVisible">
            <summary>
            Returns a value indicating whether compartment header should be visible if there is only one of them.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentShapeShape">
            <summary>
            DomainClass CompartmentShapeShape
            Description for
            Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentShapeShape
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentShapeShape.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentShapeShape.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentShapeShape.GetCompartmentMappings(System.Type)">
            <summary>
            Amend the compartment mappings to include image getter delegate.
            </summary>
            <param name="melType"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.CompartmentShapeShape.CompartmentCompartmentImageGetter(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Provide the correct image for a Compartment compartment lien item
            </summary>
            <param name="element"></param>
            <returns></returns>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.ConnectorShapeBase">
            <summary>
            Double-derived base class for DomainClass ConnectorShape
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ConnectorShapeBase.FindConnectorShapeDecorator(System.String)">
            <summary>
            Finds a decorator associated with ConnectorShape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ConnectorShapeBase.OnInitialize">
            <summary>
            Shape instance initialization.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ConnectorShapeBase.InitializeResources(Microsoft.VisualStudio.Modeling.Diagrams.StyleSet)">
            <summary>
            Initializes style set resources for this shape type
            </summary>
            <param name="classStyleSet">The style set for this shape class</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ConnectorShapeBase.InitializeShapeFields(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField})">
            <summary>
            Initialize the collection of shape fields associated with this shape type.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ConnectorShapeBase.InitializeDecorators(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField},System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.Decorator})">
            <summary>
            Initialize the collection of decorators associated with this shape type.  This method also
            creates shape fields for outer decorators, because these are not part of the shape fields collection
            associated with the shape, so they must be created here rather than in InitializeShapeFields.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ConnectorShapeBase.OnBoundsFixup(Microsoft.VisualStudio.Modeling.Diagrams.BoundsFixupState,System.Int32,System.Boolean)">
            <summary>
            Ensure outer decorators are placed appropriately.  This is called during view fixup,
            after the shape has been associated with the model element.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ConnectorShapeBase.GetCompartmentDescriptions">
            <summary>
            Gets an array of CompartmentDescription for all compartments shown on this shape
            (including compartments defined on base shapes).
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ConnectorShapeBase.GetCompartmentMappings(System.Type)">
            <summary>
            Gets an array of CompartmentMappings for all compartments displayed on this shape
            (including compartment maps defined on base shapes). 
            </summary>
            <param name="melType">The type of the DomainClass that this shape is mapped to</param>
            <returns></returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.ConnectorShapeBase.DomainClassId">
            <summary>
            ConnectorShape domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ConnectorShapeBase.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ConnectorShapeBase.ClassStyleSet">
            <summary>
            Per-class style set for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ConnectorShapeBase.ShapeFields">
            <summary>
            Per-class ShapeFields for this shape.
            </summary>
        </member>
        <member name="E:Microsoft.VisualStudio.Modeling.DslDesigner.ConnectorShapeBase.DecoratorsInitialized">
            <summary>
            Event fired when decorator initialization is complete for this shape type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ConnectorShapeBase.Decorators">
            <summary>
            List containing decorators used by this type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ConnectorShapeBase.DefaultSize">
            <summary>
            Default size for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ConnectorShapeBase.HasBackgroundGradient">
            <summary>
            Indicates whether this shape displays a background gradient.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ConnectorShapeBase.BackgroundGradientMode">
            <summary>
            Indicates the direction of the gradient.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ConnectorShapeBase.ShapeGeometry">
            <summary>
            Specifies the geometry used by this shape
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.ConnectorShapeBase.IsSingleCompartmentHeaderVisible">
            <summary>
            Returns a value indicating whether compartment header should be visible if there is only one of them.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.ConnectorShape">
            <summary>
            DomainClass ConnectorShape
            Description for Microsoft.VisualStudio.Modeling.DslDesigner.ConnectorShape
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ConnectorShape.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ConnectorShape.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.TogglePort">
            <summary>
            DomainClass TogglePort
            Description for Microsoft.VisualStudio.Modeling.DslDesigner.TogglePort
            </summary>
            <summary>
            Base class for the two port classes
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.TogglePort.DomainClassId">
            <summary>
            TogglePort domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.TogglePort.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.TogglePort.PortToTreeNode(Microsoft.VisualStudio.Modeling.Diagrams.PresentationElement)">
            <summary>
            Navigate from Port shape to hosting TreeNode mel
            </summary>
            <param name="context"></param>
            <returns></returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.TogglePort.DefaultSize">
            <summary>
            Default size for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.TogglePort.HasBackgroundGradient">
            <summary>
            Indicates whether this shape displays a background gradient.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.TogglePort.BackgroundGradientMode">
            <summary>
            Indicates the direction of the gradient.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.TogglePort.AccessibleRole">
            <summary>
            This shape behaves as a pushbutton
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.InheritancePortBase">
            <summary>
            Double-derived base class for DomainClass InheritancePort
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritancePortBase.FindInheritancePortDecorator(System.String)">
            <summary>
            Finds a decorator associated with InheritancePort.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritancePortBase.InitializeResources(Microsoft.VisualStudio.Modeling.Diagrams.StyleSet)">
            <summary>
            Initializes style set resources for this shape type
            </summary>
            <param name="classStyleSet">The style set for this shape class</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.InheritancePortBase.DomainClassId">
            <summary>
            InheritancePort domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritancePortBase.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.InheritancePortBase.ClassStyleSet">
            <summary>
            Per-class style set for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.InheritancePortBase.ShapeFields">
            <summary>
            Per-class ShapeFields for this shape.
            </summary>
        </member>
        <member name="E:Microsoft.VisualStudio.Modeling.DslDesigner.InheritancePortBase.DecoratorsInitialized">
            <summary>
            Event fired when decorator initialization is complete for this shape type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.InheritancePortBase.Decorators">
            <summary>
            List containing decorators used by this type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.InheritancePortBase.DefaultSize">
            <summary>
            Default size for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.InheritancePortBase.HasBackgroundGradient">
            <summary>
            Indicates whether this shape displays a background gradient.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.InheritancePortBase.BackgroundGradientMode">
            <summary>
            Indicates the direction of the gradient.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.InheritancePort">
            <summary>
            DomainClass InheritancePort
            Description for Microsoft.VisualStudio.Modeling.DslDesigner.InheritancePort
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritancePort.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritancePort.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritancePort.InitializeShapeFields(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField})">
            <summary>
            Create ExpandCollapse shapefield
            </summary>
            <param name="shapeFields"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritancePort.TreeNodeToPorts(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Navigate from the hosting TreeNode mel to Port shapes
            </summary>
            <param name="context"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritancePort.OnClick(Microsoft.VisualStudio.Modeling.Diagrams.DiagramPointEventArgs)">
            <summary>
            Handle clicks on the Panel's buttons
            </summary>
            <param name="e"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritancePort.AccessibleDoDefaultAction">
            <summary>
            Do the default action
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.InheritancePort.AccessibleDefaultActionDescription">
            <summary>
            Description for default action
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipPortBase">
            <summary>
            Double-derived base class for DomainClass RelationshipPort
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipPortBase.FindRelationshipPortDecorator(System.String)">
            <summary>
            Finds a decorator associated with RelationshipPort.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipPortBase.InitializeResources(Microsoft.VisualStudio.Modeling.Diagrams.StyleSet)">
            <summary>
            Initializes style set resources for this shape type
            </summary>
            <param name="classStyleSet">The style set for this shape class</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipPortBase.DomainClassId">
            <summary>
            RelationshipPort domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipPortBase.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipPortBase.ClassStyleSet">
            <summary>
            Per-class style set for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipPortBase.ShapeFields">
            <summary>
            Per-class ShapeFields for this shape.
            </summary>
        </member>
        <member name="E:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipPortBase.DecoratorsInitialized">
            <summary>
            Event fired when decorator initialization is complete for this shape type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipPortBase.Decorators">
            <summary>
            List containing decorators used by this type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipPortBase.DefaultSize">
            <summary>
            Default size for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipPortBase.HasBackgroundGradient">
            <summary>
            Indicates whether this shape displays a background gradient.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipPortBase.BackgroundGradientMode">
            <summary>
            Indicates the direction of the gradient.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipPort">
            <summary>
            DomainClass RelationshipPort
            Description for Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipPort
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipPort.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipPort.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipPort.InitializeShapeFields(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField})">
            <summary>
            Create ExpandCollapse shapefield
            </summary>
            <param name="shapeFields"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipPort.TreeNodeToPorts(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Navigate from the hosting TreeNode mel to Port shapes
            </summary>
            <param name="context"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipPort.OnClick(Microsoft.VisualStudio.Modeling.Diagrams.DiagramPointEventArgs)">
            <summary>
            Handle clicks on the Panel's buttons
            </summary>
            <param name="e"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipPort.AccessibleDoDefaultAction">
            <summary>
            Do the default action
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipPort.AccessibleDefaultActionDescription">
            <summary>
            Description for default action
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DomainModelElementsBase">
            <summary>
            Double-derived base class for DomainClass DomainModelElements
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DomainModelElementsBase.FindDomainModelElementsDecorator(System.String)">
            <summary>
            Finds a decorator associated with DomainModelElements.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DomainModelElementsBase.OnInitialize">
            <summary>
            Shape instance initialization.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DomainModelElementsBase.InitializeResources(Microsoft.VisualStudio.Modeling.Diagrams.StyleSet)">
            <summary>
            Initializes style set resources for this shape type
            </summary>
            <param name="classStyleSet">The style set for this shape class</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DomainModelElementsBase.InitializeShapeFields(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField})">
            <summary>
            Initialize the collection of shape fields associated with this shape type.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DomainModelElementsBase.InitializeDecorators(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField},System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.Decorator})">
            <summary>
            Initialize the collection of decorators associated with this shape type.  This method also
            creates shape fields for outer decorators, because these are not part of the shape fields collection
            associated with the shape, so they must be created here rather than in InitializeShapeFields.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.DomainModelElementsBase.DomainClassId">
            <summary>
            DomainModelElements domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DomainModelElementsBase.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DomainModelElementsBase.ClassStyleSet">
            <summary>
            Per-class style set for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DomainModelElementsBase.ShapeFields">
            <summary>
            Per-class ShapeFields for this shape.
            </summary>
        </member>
        <member name="E:Microsoft.VisualStudio.Modeling.DslDesigner.DomainModelElementsBase.DecoratorsInitialized">
            <summary>
            Event fired when decorator initialization is complete for this shape type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DomainModelElementsBase.Decorators">
            <summary>
            List containing decorators used by this type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DomainModelElementsBase.DefaultSize">
            <summary>
            Default size for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DomainModelElementsBase.ShouldAutoPlaceChildShapes">
            <summary>
            Indicate that child shapes should added through view fixup should be placed automatically.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DomainModelElements">
            <summary>
            DomainClass DomainModelElements
            Description for Microsoft.VisualStudio.Modeling.DslDesigner.DomainModelElements
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DomainModelElements.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DomainModelElements.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DomainModelElements.Forwarder(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Forward type description to Diagram.
            </summary>
            <param name="source"></param>
            <returns></returns>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramElementsBase">
            <summary>
            Double-derived base class for DomainClass DiagramElements
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramElementsBase.FindDiagramElementsDecorator(System.String)">
            <summary>
            Finds a decorator associated with DiagramElements.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramElementsBase.OnInitialize">
            <summary>
            Shape instance initialization.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramElementsBase.InitializeResources(Microsoft.VisualStudio.Modeling.Diagrams.StyleSet)">
            <summary>
            Initializes style set resources for this shape type
            </summary>
            <param name="classStyleSet">The style set for this shape class</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramElementsBase.InitializeShapeFields(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField})">
            <summary>
            Initialize the collection of shape fields associated with this shape type.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramElementsBase.InitializeDecorators(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.ShapeField},System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.Diagrams.Decorator})">
            <summary>
            Initialize the collection of decorators associated with this shape type.  This method also
            creates shape fields for outer decorators, because these are not part of the shape fields collection
            associated with the shape, so they must be created here rather than in InitializeShapeFields.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramElementsBase.DomainClassId">
            <summary>
            DiagramElements domain class Id.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramElementsBase.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor.
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramElementsBase.ClassStyleSet">
            <summary>
            Per-class style set for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramElementsBase.ShapeFields">
            <summary>
            Per-class ShapeFields for this shape.
            </summary>
        </member>
        <member name="E:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramElementsBase.DecoratorsInitialized">
            <summary>
            Event fired when decorator initialization is complete for this shape type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramElementsBase.Decorators">
            <summary>
            List containing decorators used by this type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramElementsBase.DefaultSize">
            <summary>
            Default size for this shape.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramElementsBase.ShouldAutoPlaceChildShapes">
            <summary>
            Indicate that child shapes should added through view fixup should be placed automatically.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramElements">
            <summary>
            DomainClass DiagramElements
            Description for Microsoft.VisualStudio.Modeling.DslDesigner.DiagramElements
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramElements.#ctor(Microsoft.VisualStudio.Modeling.Store,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="store">Store where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramElements.#ctor(Microsoft.VisualStudio.Modeling.Partition,Microsoft.VisualStudio.Modeling.PropertyAssignment[])">
            <summary>
            Constructor
            </summary>
            <param name="partition">Partition where new element is to be created.</param>
            <param name="propertyAssignments">List of domain property id/value pairs to set once the element is created.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramElements.Forwarder(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Forward type description to Diagram.
            </summary>
            <param name="source"></param>
            <returns></returns>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelToolboxHelper">
            <summary>
            Helper class used to create and initialize toolbox items for this DSL.
            </summary>
            <remarks>
            Double-derived class to allow easier code customization.
            </remarks>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelToolboxHelperBase">
            <summary>
            Helper class used to create and initialize toolbox items for this DSL.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelToolboxHelperBase.ToolboxFilterString">
            <summary>
            Toolbox item filter string used to identify DslDefinitionModel toolbox items.  
            </summary>
            <remarks>
            See the MSDN documentation for the ToolboxItemFilterAttribute class for more information on toolbox
            item filters.
            </remarks>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelToolboxHelperBase.EmbeddingRelationshipToolFilterString">
            <summary>
            Toolbox item filter string used to identify EmbeddingRelationshipTool connector tool.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelToolboxHelperBase.ReferenceRelationshipToolFilterString">
            <summary>
            Toolbox item filter string used to identify ReferenceRelationshipTool connector tool.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelToolboxHelperBase.InheritanceToolFilterString">
            <summary>
            Toolbox item filter string used to identify InheritanceTool connector tool.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelToolboxHelperBase.DiagramElementMapToolFilterString">
            <summary>
            Toolbox item filter string used to identify DiagramElementMapTool connector tool.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelToolboxHelperBase.#ctor(System.IServiceProvider)">
            <summary>
            Constructs a new DslDefinitionModelToolboxHelperBase.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelToolboxHelperBase.CreateToolboxItems">
            <summary>
            Returns a list of toolbox items for use with this DSL.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelToolboxHelperBase.CreateElementToolPrototype(Microsoft.VisualStudio.Modeling.Store,System.Guid)">
            <summary>
            Creates an ElementGroupPrototype for the element tool corresponding to the given domain class id.
            Default behavior is to create a prototype containing an instance of the domain class.
            Derived classes may override this to add additional information to the prototype.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelToolboxHelperBase.ServiceProvider">
            <summary>
            Serivce provider used to access services from the hosting environment.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelToolboxHelperBase.DefaultToolboxTabName">
            <summary>
            Returns the display name of the tab that should be opened by default when the editor is opened.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelToolboxHelperBase.DefaultToolboxTabToolboxItemsCount">
            <summary>
            Returns the toolbox items count in the default tool box tab.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelToolboxHelper.#ctor(System.IServiceProvider)">
            <summary>
            Constructs a new DslDefinitionModelToolboxHelper.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelToolboxHelper.CreateElementToolPrototype(Microsoft.VisualStudio.Modeling.Store,System.Guid)">
            <summary>
            Customize the creation of toolbox prototypes
            </summary>
            <param name="store"></param>
            <param name="domainClassId"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelToolboxHelper.CreateToolboxItems">
            <summary>
            Returns a list of toolbox items for use with this DSL.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDefinitionModelToolboxHelper.CreateNamedClassPrototype(Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Create the EGP for the NamedClass toolbox item
            </summary>
            <param name="store"></param>
            <returns></returns>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessor">
            <summary>
            Double-derived template directive processor that provides Dsl files
            The implementation is done in DslDirectiveProcessorBase. This class
            exist so users can customize behavior easily.
            </summary>
            <summary>
            Double-derived template directive processor that provides Dsl files
            The implementation is done in DslDirectiveProcessorBase. This class
            exist so users can customize behavior easily.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessorBase">
            <summary>
            Base implementation for template directive processor that provides Dsl files
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessorBase.DslDirectiveProcessorName">
            <summary>
            The friendly name of this processor.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessorBase.requiresFileParameter">
            <summary>
            The name for the requires parameter that provides the filename of the model
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessorBase.requiresValidationParameter">
            <summary>
            The name for the requires parameter that provides the validation categories to run. 
            The value for this parameter defaults to String.Empty
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessorBase.providesModelParameter">
            <summary>
            The name for the provides parameter whose value decides the name of the property 
            generated by this DirectiveProcessor. The property returns the root element of
            the model in the given file. 
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessorBase.defaultProvidesModelParameter">
            <summary>
            The default value of the provides parameter above. It defaults to the name of
            the parameter itself.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessorBase.supportedDirectiveName">
            <summary>
            The directive name that is supported by this direcive processor. This defaults
            to the name of the model. 
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessorBase.oneTimeCodeGenerated">
            <summary>
            Flag to ensure that some code is only generated once regardless of how many times the processor is used.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessorBase.#ctor">
            <summary>
            Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessorBase.IsDirectiveSupported(System.String)">
            <summary>
            Check if the directive name is supported by this directive processor
            </summary>
            <param name="directiveName"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessorBase.StartProcessingRun(System.CodeDom.Compiler.CodeDomProvider,System.String,System.CodeDom.Compiler.CompilerErrorCollection)">
            <summary>
            Override StartProcessingRun to reset the helpers flag.
            </summary>
            <param name="languageProvider"></param>
            <param name="templateContents"></param>
            <param name="errors"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessorBase.InitializeRequiresDictionary(System.String,System.Collections.Generic.IDictionary{System.String,System.String})">
            <summary>
            Override to initialize requires dictionary
            </summary>
            <param name="directiveName"></param>
            <param name="requiresDictionary"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessorBase.InitializeProvidesDictionary(System.String,System.Collections.Generic.IDictionary{System.String,System.String})">
            <summary>
            Override to initialize provides dictinoary
            </summary>
            <param name="directiveName"></param>
            <param name="providesDictionary"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessorBase.GenerateTransformCode(System.String,System.Text.StringBuilder,System.CodeDom.Compiler.CodeDomProvider,System.Collections.Generic.IDictionary{System.String,System.String},System.Collections.Generic.IDictionary{System.String,System.String})">
            <summary>
            Generate the code to access the model. Use to CodeDomProvider so we are language-agnostic
            </summary>
            <param name="directiveName"></param>
            <param name="codeBuffer"></param>
            <param name="languageProvider"></param>
            <param name="requiresArguments"></param>
            <param name="providesArguments"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessorBase.GeneratePreInitializationCode(System.String,System.Text.StringBuilder,System.CodeDom.Compiler.CodeDomProvider,System.Collections.Generic.IDictionary{System.String,System.String},System.Collections.Generic.IDictionary{System.String,System.String})">
            <summary>
            Contribute additively to initialization code for the TextTransformation generated class.
            </summary>
            <remarks>
            This code will be added before the call to the base class.
            </remarks>
            <param name="directiveName"></param>
            <param name="codeBuffer"></param>
            <param name="languageProvider"></param>
            <param name="requiresArguments"></param>
            <param name="providesArguments"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessorBase.GeneratePostInitializationCode(System.String,System.Text.StringBuilder,System.CodeDom.Compiler.CodeDomProvider,System.Collections.Generic.IDictionary{System.String,System.String},System.Collections.Generic.IDictionary{System.String,System.String})">
            <summary>
            Contribute additively to initialization code for the TextTransformation generated class.
            </summary>
            <remarks>
            This code will be added after the call to the base class.
            </remarks>
            <param name="directiveName"></param>
            <param name="codeBuffer"></param>
            <param name="languageProvider"></param>
            <param name="requiresArguments"></param>
            <param name="providesArguments"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessorBase.PostProcessArguments(System.String,System.Collections.Generic.IDictionary{System.String,System.String},System.Collections.Generic.IDictionary{System.String,System.String})">
            <summary>
            Process arguments
            </summary>
            <param name="directiveName"></param>
            <param name="requiresArguments"></param>
            <param name="providesArguments"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessorBase.GetImportsForProcessingRun">
            <summary>
            Return namespace imports necessary for running template
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessorBase.GetReferencesForProcessingRun">
            <summary>
            Get assembly references needed for running template
            </summary>
            <returns></returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessorBase.FriendlyName">
            <summary>
            The friendly name of this processor.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessorBase.LoadDiagramData">
            <summary>
            Property that indicates whether this directive processor needs access to diagram data as well as
            model data.  Normally, this is not the case so the default value of this property is false.
            Derived classes may override this property to change the value.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessor.#ctor">
            <summary>
            Constructor
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessor.codeDomProvider">
            <summary>
            private reference to the CodeDomProvider for code-generation
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessor.oneTimeCodeGenerated">
            <summary>
            Flag to ensure that some code is only generated once regardless of how many times the processor is used.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessor.validationCategories">
            <summary>
            Hold the set of validation categories requested to apply
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessor.StartProcessingRun(System.CodeDom.Compiler.CodeDomProvider,System.String,System.CodeDom.Compiler.CompilerErrorCollection)">
            <summary>
            Override StartProcessingRun to get the reference to the CodeDomProvider
            </summary>
            <param name="languageProvider"></param>
            <param name="templateContents"></param>
            <param name="errors"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessor.InitializeRequiresDictionary(System.String,System.Collections.Generic.IDictionary{System.String,System.String})">
            <summary>
            Override InitializeRequiresDictionary to add additional paramaters to determine resource name
            </summary>
            <param name="directiveName"></param>
            <param name="requiresDictionary"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessor.InitializeProvidesDictionary(System.String,System.Collections.Generic.IDictionary{System.String,System.String})">
            <summary>
            Override InitializeProvidesDictionary to add GeneratedResourceName parameter
            </summary>
            <param name="directiveName"></param>
            <param name="providesDictionary"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessor.GenerateTransformCode(System.String,System.Text.StringBuilder,System.CodeDom.Compiler.CodeDomProvider,System.Collections.Generic.IDictionary{System.String,System.String},System.Collections.Generic.IDictionary{System.String,System.String})">
            <summary>
            Override GenerateTransformCode to add code to provide the 'GeneratedResourceName' property if requested.
            </summary>
            <param name="directiveName"></param>
            <param name="codeBuffer"></param>
            <param name="languageProvider"></param>
            <param name="requiresArguments"></param>
            <param name="providesArguments"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessor.GetClassCodeForProcessingRun">
            <summary>
            Override base to add an extra Dsl Property
            </summary>
            <remarks>
            This DirectiveProcessor can load either a Dsl or a DslLibrary so needs both.
            </remarks>
            <returns>Class code with added Dsl property</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessor.GeneratePostInitializationCode(System.String,System.Text.StringBuilder,System.CodeDom.Compiler.CodeDomProvider,System.Collections.Generic.IDictionary{System.String,System.String},System.Collections.Generic.IDictionary{System.String,System.String})">
            <summary>
            Override to get whether we need to perform validation on this run.
            </summary>
            <param name="directiveName"></param>
            <param name="codeBuffer"></param>
            <param name="languageProvider"></param>
            <param name="requiresArguments"></param>
            <param name="providesArguments"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslDirectiveProcessor.GetPostInitializationCodeForProcessingRun">
            <summary>
            Override GetPostInitializationCodeForProcessingRun to surround all file
            loads with a top-level transaction. We do this so that the moniker cache 
            does not get flushed after each file is loaded, so that cross-model monikers
            can be resolved by loading both models in T4 using directives.
            </summary>
            <returns></returns>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.AttributeBackendStorage">
            <summary>
            Internal back end storage for the tree grid shown in the dialog
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.AttributeBackendStorage.#ctor(Microsoft.VisualStudio.Modeling.LinkedElementCollection{Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute})">
            <summary>
            Ctor to take an AttributedDomainElement object and load it up in the prop grid.
            </summary>
            <param name="attributes"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.AttributeBackendStorage.GetAttributeName(System.Int32)">
            <summary>
            For the given indexPos into the attributes defined, return the attribute name.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.AttributeBackendStorage.GetAttributeParameter(System.Int32)">
            <summary>
            For the given indexPos into the attributes defined, return the parameters list defined in the designated 
            attribute
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.AttributeBackendStorage.UpdateAttributeName(System.Int32,System.String)">
            <summary>
            For the given indexPos into the attributes defined, update the attribute name
            </summary>
            <param name="indexPos"></param>
            <param name="attributeName"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.AttributeBackendStorage.AddAttributeDefintion(Microsoft.VisualStudio.Modeling.DslDefinition.ClrAttribute)">
            <summary>
            For the given ClrAttribute, this method will add an entry in the string collection and parametersCollection.
            </summary>
            <param name="clrAttr"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.AttributeBackendStorage.AddNewAttributeDefintion(System.String)">
            <summary>
            Create a new attribute, adds into the string collection as well se creating the place holder for staging the paramters
            </summary>
            <param name="newAttributeName"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.AttributeBackendStorage.RemoveAttributeDefintion(System.Int32)">
            <summary>
            For the given indexPos into the attributes defined, remove the attribute from the string collection and the associated 
            parameters collection. 
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.AttributeBackendStorage.Count">
            <summary>
            Returns number of attributes currently defined in the grid.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.StagedParameter">
            <summary>
            Struct for holding the the parameter value and NamedPropertyName (optional).
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BaseClassRolePlayerPropertyDescriptor">
            <summary>
            Provide custom types for the model.
            This will probably need amending once we're generatign a type descriptor provider.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BaseClassRolePlayerPropertyDescriptor.#ctor(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRoleInfo,System.Attribute[])">
            <summary>
            Constructor
            </summary>
            <param name="sourcePlayer">Source of this RolePlayerPropertyDescriptor.</param>
            <param name="domainRole">The domain data for the role that is being edited.</param>
            <param name="sourceDomainRoleInfoAttributes">Attributes modifying property descriptor behavior.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BaseClassRolePlayerPropertyDescriptor.ShouldIncludeCandidate(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Method to determine whether to include this candidate into the 
            </summary>
            <param name="currentRoleplayer"></param>
            <param name="eachCandidate"></param>
            <returns></returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BaseClassRolePlayerPropertyDescriptor.ElementList">
            <summary>
            List of valid role players for this property value.  By default, this will be all elements
            in the store of the type specified by RoleTypeConstraint.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BaseRelationshipPlayerPropertyDescriptor">
            <summary>
            Provide custom base domain class for the selected DomainRelationship.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BaseRelationshipPlayerPropertyDescriptor.#ctor(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRoleInfo,System.Attribute[])">
            <summary>
            Constructor
            </summary>
            <param name="sourcePlayer">Source of this RolePlayerPropertyDescriptor.</param>
            <param name="domainRole">The domain data for the role that is being edited.</param>
            <param name="sourceDomainRoleInfoAttributes">Attributes modifying property descriptor behavior.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BaseRelationshipPlayerPropertyDescriptor.ShouldIncludeCandidate(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Method to determine whether to include this candidate into the 
            </summary>
            <param name="currentRoleplayer"></param>
            <param name="eachCandidate"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BaseRelationshipPlayerPropertyDescriptor.SetValue(System.Object,System.Object)">
            <summary>
            Sets the value of the property.
            </summary>
            <param name="component"></param>
            <param name="value"></param>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ElementNameProviderPlayerPropertyDescriptor">
            <summary>
            Provide custom types for the model.
            This will probably need amending once we're generatign a type descriptor provider.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ElementNameProviderPlayerPropertyDescriptor.#ctor(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRoleInfo,System.Attribute[])">
            <summary>
            Constructor
            </summary>
            <param name="sourcePlayer">Source of this RolePlayerPropertyDescriptor.</param>
            <param name="domainRole">The domain data for the role that is being edited.</param>
            <param name="sourceDomainRoleInfoAttributes">Attributes modifying property descriptor behavior.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ElementNameProviderPlayerPropertyDescriptor.ElementList">
            <summary>
            List of valid role players for this property value.  By default, this will be all elements
            in the store of the type specified by RoleTypeConstraint.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.PropertyPathPropertyPlayerPropertyDescriptor">
            <summary>
            Provide custom types for the model.
            This will probably need amending once we're generatign a type descriptor provider.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.PropertyPathPropertyPlayerPropertyDescriptor.#ctor(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainRoleInfo,System.Attribute[])">
            <summary>
            Constructor
            </summary>
            <param name="sourcePlayer">Source of this RolePlayerPropertyDescriptor.</param>
            <param name="domainRole">The domain data for the role that is being edited.</param>
            <param name="sourceDomainRoleInfoAttributes">Attributes modifying property descriptor behavior.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.PropertyPathPropertyPlayerPropertyDescriptor.ElementList">
            <summary>
            List of valid role players for this property value.  By default, this will be all elements
            in the store of the type specified by RoleTypeConstraint.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BaseShapeMapEndpointPickerDialog.#ctor(System.IServiceProvider,Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary,Microsoft.VisualStudio.Modeling.DslDefinition.BaseShapeMap)">
            <summary>
            Constructor
            </summary>
            <param name="serviceProvider"></param>
            <param name="library"></param>
            <param name="map"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BaseShapeMapEndpointPickerDialog.EndpointPickerDialog_Load(System.Object,System.EventArgs)">
            <summary>
            Load the form
            </summary>
            <param name="sender"></param>
            <param name="e"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BaseShapeMapEndpointPickerDialog.PopulateSourceList">
            <summary>
            Fill the source list in the dialog with items.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BaseShapeMapEndpointPickerDialog.PopulateTargetList">
            <summary>
            Fill the target list in the dialog with items.
            </summary>
            
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BaseShapeMapEndpointPickerDialog.sourceComboBox_SelectedIndexChanged(System.Object,System.EventArgs)">
            <summary>
            Handler for source item changed
            </summary>
            <param name="sender"></param>
            <param name="e"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BaseShapeMapEndpointPickerDialog.targetComboBox_SelectedIndexChanged(System.Object,System.EventArgs)">
            <summary>
            Handler for target itme changed
            </summary>
            <param name="sender"></param>
            <param name="e"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BaseShapeMapEndpointPickerDialog.UpdateStates">
            <summary>
            Update the enabled states of controls.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BaseShapeMapEndpointPickerDialog.components">
            <summary>
            Required designer variable.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BaseShapeMapEndpointPickerDialog.Dispose(System.Boolean)">
            <summary>
            Clean up any resources being used.
            </summary>
            <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BaseShapeMapEndpointPickerDialog.InitializeComponent">
            <summary>
            Required method for Designer support - do not modify
            the contents of this method with the code editor.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BaseShapeMapEndpointPickerDialog.F1Keyword">
            <summary>
            Specifies F1 keyword for this dialog.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.AttributeBranch">
            <summary>
            Displays information for the members of a ClrType.  Maintains a filtered cache
            of members, since derived classes are usually interested in a subset of 
            the entire list.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch">
            <summary>
            Summary description for ClrAttributeDesignerBranch.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.IClrAttributeDesignerBranch">
            <summary>
            Interface that contains extra public APIs used by the 
            operation designer extensions to the VirtualTree control.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.IClrAttributeDesignerBranch.ProcessKeyPress(System.Int32,System.Int32,System.Char,System.Windows.Forms.Keys)">
            <summary>
            Gives the branch a chance to handle key press events
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.IClrAttributeDesignerBranch.ProcessKeyDown(System.Int32,System.Int32,System.Windows.Forms.KeyEventArgs)">
            <summary>
            Gives the branch a chance to handle key down events
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.IClrAttributeDesignerBranch.GetValueSupported(System.Int32,System.Int32)">
            <summary>
            Retrieves info about whether the branch supported editing/viewing 
            the given cell.
            </summary>
            <param name="row"></param>
            <param name="column"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.IClrAttributeDesignerBranch.GetDefaultAction(System.Int32)">
            <summary>
            Specifies the default command that should be executed for the specified index.
            The default command is executed when the tree control is double-clicked on.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.IClrAttributeDesignerBranch.InsertCreatorNode(System.Int32,System.Int32)">
            <summary>
            Indicates that a new creator node should be inserted at the given index
            </summary>
            <param name="index">absolute index to insert</param>
            <param name="creatorNodeIndex">specifies the creator node to insert</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.IClrAttributeDesignerBranch.EndInsert(System.Int32)">
            <summary>
            Called to indicate that the branch should end insert mode.
            </summary>
            <param name="row">row index specifying the insertion</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.IClrAttributeDesignerBranch.ReadOnly">
            <summary>
            Gets/sets read-only state of the entire branch.  Text in read-only branches appears grayed-out
            and cannot be edited.  Creator nodes also do not appear.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.IClrAttributeDesignerInitializeBranch">
            <summary>
            provides a mechanism for root branches created via the OperationDesignerRootBranch 
            attribute to be sited with the current selection and column collection.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.IClrAttributeDesignerInitializeBranch.Initialize(System.Object,Microsoft.VisualStudio.Modeling.DslDefinition.Design.ColumnDescriptor[])">
            <summary>
            Called to initialize the branch
            </summary>
            <param name="selection">currently selected object</param>
            <param name="columns">columns currently displayed in the tree</param>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.AppendIndex">
            <summary>
            Constant passed to OnCreatorNodeEditCommitted to indicate that
            the value should be appended to the current list, rather than
            inserted at a given position
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.BrowsingObject">
            <summary>
            Custom ObjectStyle for use with IBranch.GetObject.
            Provide the object to be pushed to the property browser.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.Design.ColumnDescriptor[])">
            <summary>
            Create a new branch.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.#ctor">
            <summary>
            Create a new branch.  Initialize must be called to set columns after construction.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.Initialize(System.Object,Microsoft.VisualStudio.Modeling.DslDefinition.Design.ColumnDescriptor[])">
            <summary>
            Derived classes may override this to perform initialization.
            </summary>
            <param name="component">Selected component that this branch may act on.</param>
            <param name="passedInColumns">columns to act on.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.GetElement(System.Int32)">
            <summary>
            Returns the IMS element at the given index
            </summary>
            <param name="index">Index into this branch</param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.GetIndexForElement(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Returns the index for the given IMS element
            </summary>
            <param name="element">ModelElement that exists in this branch</param>
            <returns>Returns the index for the given IMS element</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.GetExpandedBranch(System.Int32)">
            <summary>
            Returns the branch created by expanding the node at the given index
            </summary>
            <param name="index">Index into this branch</param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.IsExpandable(System.Int32)">
            <summary>
            Return true if the given child index represents an expandable node
            </summary>
            <param name="index">Index into this branch</param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.GetCreatorNodeText(System.Int32)">
            <summary>
            Returns the text for the given creator node index (e.g. "&lt;new parameter&gt;")
            </summary>
            <param name="index"></param>
            <returns>Returns the text for the given creator node index.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.OnCreatorNodeEditCommitted(System.Int32,System.Object,System.Int32)">
            <summary>
            Called when the user commits an edit in a creator node
            </summary>
            <param name="index">Creator node index (0 is the first creator node)</param>
            <param name="value">Resulting value entered by the user</param>
            <param name="insertIndex">index where newly created node should be inserted.  A value of
            ClrAttributeDesignerBranch.Append indicates that it should be appended at the end of the list.</param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.GetTipText(System.Int32,System.Int32,Microsoft.VisualStudio.VirtualTreeGrid.ToolTipType)">
            <summary>
            Returns tool tip text
            </summary>
            <param name="row">Index into this branch</param>
            <param name="column">Column tooltip was requested for</param>
            <param name="tipType">Type of tool tip requested</param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.LocateTrackingObject(System.Object,Microsoft.VisualStudio.VirtualTreeGrid.LocateObjectData)">
            <summary>
            Each node in the tree can have an associated tracking object used to indentify it.
            The branch can override this method to return the row index corresponding to the given 
            object.  
            </summary>
            <param name="locateData">If the object is a direct child of this branch, set locateData.Options = TrackingObjectAction.ThisLevel.
            If the object is deeper in the tree, the branch should set it to TrackingObjectAction.NextLevel,
            locateData.Row should be set to the row where the search should continue.
            </param>
            <param name="tracked">Object to track</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.GetBrowsingObject(System.Int32)">
            <summary>
            Returns the object to be pushed to the property browser for the given index.
            The base class just returns the element at that index, 
            Derived classes may override this to push custom objects.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.GetValueSupported(System.Int32,System.Int32)">
            <summary>
            Allows derived classes to specify supported states for a particular cell.  The base implementation
            takes into account branch-level read-only state, and column value supported state.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.GetDisplayData(System.Int32,System.Int32,Microsoft.VisualStudio.VirtualTreeGrid.VirtualTreeDisplayDataMasks)">
            <summary>
            Returns structure describing how this branch should be displayed.
            </summary>
            <param name="row">Index into this branch</param>
            <param name="column">Column index</param>
            <param name="requiredData">The data that must be filled in</param>
            <returns>Structure to be filled with display information.  By default, 
            No icon is specified, and read-only and creator nodes are grayed out.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.GetAccessibilityData(System.Int32,System.Int32)">
            <summary>
            Retrieve accessibility data for the item at the given row, column
            </summary>
            <param name="row">Target row</param>
            <param name="column">Target column</param>
            <returns>Populated VirtualTreeAccessibilityData structue, or VirtualTreeAccessibilityData.Empty</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.BeginLabelEdit(System.Int32,System.Int32,System.String@,System.Int32@,System.Object@)">
            <summary>
            Called to initiate an in-place edit
            </summary>
            <param name="row">Index into this branch</param>
            <param name="column">Column index</param>
            <param name="alternateText">Text to display when editing commences.  By default, creator nodes
            display the empty string when initially edited</param>
            <param name="maxTextLength">Maximum length of the text to be edited</param>
            <param name="customInPlaceEdit"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.GetText(System.Int32,System.Int32)">
            <summary>
            Returns the text for the given cell
            </summary>
            <param name="row">Index into this branch</param>
            <param name="column">Column index</param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.CommitLabelEdit(System.Int32,System.Int32,System.String)">
            <summary>
            Called when the user commits an in-place edit
            </summary>
            <param name="row">Index into this branch</param>
            <param name="column">Column index</param>
            <param name="newText">New value entered by the user</param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.ProcessKeyPress(System.Int32,System.Int32,System.Char,System.Windows.Forms.Keys)">
            <summary>
            Handles special key bindings for key press events.
            </summary>
            <param name="row">Index into this branch</param>
            <param name="column">Column index</param>
            <param name="key">Character typed by the user</param>
            <param name="modifiers">Any modifiers keys currently held down</param>
            <returns>ProcessKeyResult structure that indicates what action should be taken (if any)</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.ProcessKeyDown(System.Int32,System.Int32,System.Windows.Forms.KeyEventArgs)">
            <summary>
            Handles special key bindings for key down events.  Base class handles space and tab.
            </summary>
            <param name="row">Index into this branch</param>
            <param name="column">Column index</param>
            <param name="e">Standard KeyEventArgs</param>
            <returns>ProcessKeyResult structure that indicates what action should be taken (if any)</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.AddEventHandlers">
            <summary>
            Add any event handlers (IMS, for example) for any events the branch needs to listen to. 
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.RemoveEventHandlers">
            <summary>
            Remove any event handlers previously added
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.GetDefaultAction(System.Int32)">
            <summary>
            Specifies the default command that should be executed for the specified index.
            The default command is executed when the tree control is double-clicked on.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.IsExpandable(System.Int32,System.Int32)">
            <summary>
            IBranch interface implementation.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.BeginLabelEdit(System.Int32,System.Int32,Microsoft.VisualStudio.VirtualTreeGrid.VirtualTreeLabelEditActivationStyles)">
            <summary>
            IBranch interface implementation.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.LocateObject(System.Object,Microsoft.VisualStudio.VirtualTreeGrid.ObjectStyle,System.Int32)">
            <summary>
            IBranch interface implementation.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.ColumnStyles(System.Int32)">
            <summary>
            IMultiColumnBranch interface implementation.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.GetJaggedColumnCount(System.Int32)">
            <summary>
            IMultiColumnBranch interface implementation.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.ToggleState(System.Int32,System.Int32)">
            <summary>
            Called by the tree when item state is toggled (by clicking on the state icon, etc.).  Used to support checkboxes
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.SynchronizeState(System.Int32,System.Int32,Microsoft.VisualStudio.VirtualTreeGrid.IBranch,System.Int32,System.Int32)">
            <summary>
            Called by the tree when the tree is in multiselect node and a state is toggled. Used to support synchronizing checkbox states.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.OnStartDrag(System.Object,System.Int32,System.Int32,Microsoft.VisualStudio.VirtualTreeGrid.DragReason)">
            <summary>
            IBranch interface implementation.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.OnGiveFeedback(System.Windows.Forms.GiveFeedbackEventArgs,System.Int32,System.Int32)">
            <summary>
            IBranch interface implementation.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.OnQueryContinueDrag(System.Windows.Forms.QueryContinueDragEventArgs,System.Int32,System.Int32)">
            <summary>
            IBranch interface implementation.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.OnDragEvent(System.Object,System.Int32,System.Int32,Microsoft.VisualStudio.VirtualTreeGrid.DragEventType,System.Windows.Forms.DragEventArgs)">
            <summary>
            IBranch interface implementation.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.DoBranchModification(Microsoft.VisualStudio.VirtualTreeGrid.BranchModificationEventArgs)">
            <summary>
            Should be called by derived classes to indicate that a branch modification (add, remove, reorder) has occurred.
            </summary>
            <param name="modification">Indicates the type of modification</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.GetColumns">
            <summary>
            Returns the array of columns currently supported by this branch.
            </summary>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.GetService(System.Type)">
            <summary>
            Allows access to services
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.InsertCreatorNode(System.Int32,System.Int32)">
            <summary>
            Indicates that a new creator node should be inserted at the given index
            </summary>
            <param name="index">absolute index to insert</param>
            <param name="creatorNodeIndex">specifies the creator node to insert</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.EndInsert(System.Int32)">
            <summary>
            Called to indicate that the branch should end insert mode.
            </summary>
            <param name="row">row index specifying the insertion</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.ElementCount">
            <summary>
            Count of all elements in this branch
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.CreatorNodeCount">
            <summary>
            Count of the creator nodes that appear at the end of this branch
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.Features">
            <summary>
            Flags specifying branch behavior
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.ReadOnly">
            <summary>
            Gets/sets read-only state of this branch.  Text in read-only branches appears grayed-out
            and cannot be edited.  Creator nodes also do not appear.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.ItemCount">
            <summary>
            Count of all items in the branch, includes both elements and creator nodes
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.VisibleItemCount">
            <summary>
            IBranch interface implementation.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.ColumnCount">
            <summary>
            IMultiColumnBranch interface implementation.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.UpdateCounter">
            <summary>
            IBranch interface implementation.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.InVirtualTreeEdit">
            <summary>
            Do not use.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.AbortVirtualTreeEdit">
            <summary>
            Do not use.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerBranch.InCreatorNodeCommit">
            <summary>
            May be used by derived classes to determine whether a creator node edit is currently in progress for this branch.
            This information may be required by event handlers, which may not have enough context to determine this themselves.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.AttributeBranch.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.Design.AttributeBackendStorage,Microsoft.VisualStudio.Modeling.DslDefinition.Design.ColumnDescriptor[])">
            <summary>
            Construct a new type branch.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.AttributeBranch.GetCreatorNodeText(System.Int32)">
            <summary>
            Returns the text for the creator node at the given index
            </summary>
            <param name="index"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.AttributeBranch.GetElement(System.Int32)">
            <summary>
            Returns the element at the given index.
            </summary>
            <param name="index"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.AttributeBranch.GetIndexForElement(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Returns the index for the given element.
            </summary>
            <param name="element"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.AttributeBranch.ProcessKeyDown(System.Int32,System.Int32,System.Windows.Forms.KeyEventArgs)">
            <summary>
            Process key down messages
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.AttributeBranch.ProcessKeyPress(System.Int32,System.Int32,System.Char,System.Windows.Forms.Keys)">
            <summary>
            
            </summary>
            <param name="row"></param>
            <param name="column"></param>
            <param name="key"></param>
            <param name="modifiers"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.AttributeBranch.OnCreatorNodeEditCommitted(System.Int32,System.Object,System.Int32)">
            <summary>
            Called when a creator node edit is committed
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.AttributeBranch.GetDisplayData(System.Int32,System.Int32,Microsoft.VisualStudio.VirtualTreeGrid.VirtualTreeDisplayDataMasks)">
            <summary>
            Called on the branch to provide display information.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.AttributeBranch.GetExpandedBranch(System.Int32)">
            <summary>
            Returns the expanded branch that contains parameters for the method at the given index
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.AttributeBranch.GetText(System.Int32,System.Int32)">
            <summary>
            Gets text for this branch.  Overriden to provide special handling for generics in the name column.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.AttributeBranch.IsExpandable(System.Int32)">
            <summary>
            Members are expandable if they are methods that contain parameters
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.AttributeBranch.ElementCount">
            <summary>
            Returns the count of all members
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.AttributeBranch.CreatorNodeCount">
            <summary>
            Returns the count of creator nodes
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ParameterBranch">
            <summary>
            Contains implementation common to all parameter branches (member and delegate)
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ParameterBranch.#ctor(System.Collections.Generic.List{Microsoft.VisualStudio.Modeling.DslDefinition.Design.StagedParameter},Microsoft.VisualStudio.Modeling.DslDefinition.Design.ColumnDescriptor[])">
            <summary>
            
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ParameterBranch.GetDisplayData(System.Int32,System.Int32,Microsoft.VisualStudio.VirtualTreeGrid.VirtualTreeDisplayDataMasks)">
            <summary>
            
            </summary>
            <param name="row"></param>
            <param name="column"></param>
            <param name="requiredData"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ParameterBranch.ProcessKeyDown(System.Int32,System.Int32,System.Windows.Forms.KeyEventArgs)">
            <summary>
            Process key down messages
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ParameterBranch.GetElement(System.Int32)">
            <summary>
            
            </summary>
            <param name="index"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ParameterBranch.GetIndexForElement(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            
            </summary>
            <param name="element"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ParameterBranch.GetText(System.Int32,System.Int32)">
            <summary>
            Gets text for this branch.  Overriden to provide special handling for generics in the name column.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ParameterBranch.OnCreatorNodeEditCommitted(System.Int32,System.Object,System.Int32)">
            <summary>
            
            </summary>
            <param name="index"></param>
            <param name="value"></param>
            <param name="insertIndex">index where newly created node should be inserted.  A value of
            ClrAttributeDesignerBranch.Append indicates that it should be appended at the end of the list.</param>
            <returns></returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ParameterBranch.Features">
            <summary>
            
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ParameterBranch.CreatorNodeCount">
            <summary>
            
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ParameterBranch.ElementCount">
            <summary>
            
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BranchStrings">
            <summary>
              A strongly-typed resource class, for looking up localized strings, etc.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BranchStrings.ResourceManager">
            <summary>
              Returns the cached ResourceManager instance used by this class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BranchStrings.Culture">
            <summary>
              Overrides the current thread's CurrentUICulture property for all
              resource lookups using this strongly typed resource class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BranchStrings.AddAttribute">
            <summary>
              Looks up a localized string similar to &lt;add attribute&gt;.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BranchStrings.AddParameter">
            <summary>
              Looks up a localized string similar to &lt;add parameter&gt;.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BranchStrings.ArgumentNotString">
            <summary>
              Looks up a localized string similar to Argument is not of type string.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BranchStrings.ComboAccDesc">
            <summary>
              Looks up a localized string similar to Value may be edited through a drop down.  Press Alt+Down to open the drop down..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BranchStrings.LauncherAccDesc">
            <summary>
              Looks up a localized string similar to Value may be edited through a dialog box.  Press Alt+Down to open the dialog box..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BranchStrings.NamedArgumentShouldBeAtTheEndError">
             <summary>
               Looks up a localized string similar to Named argument {1} of attribute {0} should be listed at the end of the position arguments (constructor parameters).
            Please move the named argument to the end of the attribute definition..
             </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BranchStrings.UpdateAttribute">
            <summary>
              Looks up a localized string similar to Update attribute.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.CheckBoxState">
            <summary>
            Represents a tri-state checkbox
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ColumnDescriptor">
            <summary>
            Class which represents a column in the tree.  Derived from property descriptor so it can 
            be used in the property grid as well.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ColumnDescriptor.#ctor(System.String)">
            <summary>
            Create a new column descriptor.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ColumnDescriptor.#ctor(System.String,System.Single)">
            <summary>
            Create a new column descriptor.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ColumnDescriptor.GetValueSupported(System.Object)">
            <summary>
            Returns the supported state for the given component.  This state may be
            a combination of the ClrAttributeDesignerValueSupportedStates values, which
            determine properties such as whether a particular cell supports an in-place 
            editor, and whether it allows keyboard navigation.
            </summary>
            <param name="component">object instance</param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ColumnDescriptor.GetInPlaceEdit(System.Object,System.String@)">
            <summary>
            Returns the in-place editor for the given component.  May be either a type,
            which will be instantiated, or an instance.  Must implement
            IVirtualTreeInPlaceControl.  Base implementation checks to see if a TypeEditorHost (drop-down)
            can be created via ClrAttributeDesignerTreeControl.CreateTypeEditorHost, otherwise, returns a 
            text box as the default edit control.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ColumnDescriptor.AddEventHandlers(Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Called to indicate that the column should add any necessary event handlers
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ColumnDescriptor.RemoveEventHandlers(Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Called to indicate that the column should remove its event handlers
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ColumnDescriptor.AllowKeyDownProcessing(System.Windows.Forms.KeyEventArgs)">
            <summary>
            Allows columns to specify whether they want to allow special key processing
            to occur for a given key down event (i.e., special keystrokes for typing signatures).  Return true to
            allow this processing, false to use the default key processing provided by 
            the control.  Default value is false (allow special processing).
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ColumnDescriptor.AllowKeyPressProcessing(System.Char,System.Windows.Forms.Keys)">
            <summary>
            Allows columns to specify whether they want to allow special key processing
            to occur for a given key press event (i.e., special keystrokes for typing signatures).  Return true to
            allow this processing, false to use the default key processing provided by 
            the control.  Default value is false (allow special processing).
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ColumnDescriptor.GetCheckBoxValue(System.Object)">
            <summary>
            Derived classes that specify ColumnIsCheckBox should override this
            to determine the check box state for the given component
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ColumnDescriptor.ToggleCheckBoxValue(System.Object)">
            <summary>
            Derived classes that specify ColumnIsCheckBox should override this
            to toggle the check box state for the given component
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ColumnDescriptor.GetCheckBoxTransactionName(System.Object)">
            <summary>
            Allows derived classes to specify a transaction name when a check box
            in a header branch is toggled.
            </summary>
            <param name="component"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ColumnDescriptor.GetTipText(System.Object)">
            <summary>
            Allows columns to specify custom tooltip text.  Default behavior is to return null, which specifies that
            the same text that is displayed in the column should be used
            </summary>
            <param name="component"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ColumnDescriptor.Dispose(System.Boolean)">
            <summary>
            Column descriptors may override this to do required cleanup.  Called when the tree control
            owning the column is disposed.
            </summary>
            <param name="disposing"></param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ColumnDescriptor.InitialPercentage">
            <summary>
            Initial width of this column, as a percentage of the total width.  A value of
            The default value of ColumnDescriptor.CalculatePercentage indicates that the percentage should be calculated by the tree control.
            Otherwise, the value should be in the range (0, 1).
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ColumnDescriptor.Host">
            <summary>
            Gets/sets the host used to provide services to this column
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ColumnDescriptor.ColumnIsCheckBox">
            <summary>
            Specify this if a check box should be displayed in the column 
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerValueSupportedStates">
            <remarks>
            Describes the view/edit state of a particular value (cell) in the grid.
            </remarks>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerValueSupportedStates.Default">
            <summary>
            Default state, value displayed normally (not read-only), but no in-place editing or keyboard navigation supported.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerValueSupportedStates.DisplayReadOnly">
            <summary>
            Value should be displayed as read-only.  Controls the VirtualTreeDisplayData.GrayText flag in the base
            implementation of GetDisplayData.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerValueSupportedStates.Unsupported">
            <summary>
            Value should be displayed as read-only, also implies no support for in-place editing or keyboard navigation.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerValueSupportedStates.SupportsInPlaceEdit">
            <summary>
            Value can be in-place edited.  If this flag is set on a ColumnDescriptor, the ColumnDescriptor.GetInPlaceEdit
            will be called to retrieve an in-place edit control.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerValueSupportedStates.SupportsKeyboardNavigation">
            <summary>
            Value supports keyboard navigation (e.g., should be included as a tab stop).
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerValueSupportedStates.Supported">
            <summary>
            Supports editing and keyboard navigation.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.IClrAttributeDesignerColumnHost">
            <summary>
            Provides a mechanism for columns to call back on the hosting grid
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.IClrAttributeDesignerColumnHost.Refresh(System.Object)">
            <summary>
            Refreshes the grid
            </summary>
            <param name="tracking">If specified, only the row corresponding to this tracking object will be refreshed.
            If null, the entire grid will be refreshed.</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.IClrAttributeDesignerColumnHost.Store">
            <summary>
            Retrieves the current store
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.IClrAttributeDesignerColumnHost.InLabelEdit">
            <summary>
            Retrieves the current label edit state of the tree control.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BranchGlyphs">
            <summary>
            Contains glyphs used by the Port/Class details windows
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BranchGlyphs.OpenCloseParameterIndex">
            <summary>
            Open and closed parameter glyph index.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BranchGlyphs.OpenParameterIndex">
            <summary>
            Open parameter glyph index.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BranchGlyphs.CloseParameterIndex">
            <summary>
            Close parameter glyph index.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BranchGlyphs.ParameterSeparatorIndex">
            <summary>
            Parameter separator glyph index (comma).
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BranchGlyphs.#ctor">
            <summary>
            Private constructor to avoid generating public one.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.BranchGlyphs.ImageList">
            <summary>
            Image list containing common Port/Class details glyphs.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerTreeControl">
            <summary>
            Class derived from VirtualTreeControl containing operation designer-specific code
            such as special key bindings
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerTreeControl.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.Design.IClrAttributeDesignerColumnHost)">
            <summary>
            ClrAttributeDesignerTreeControl
            </summary>
            <param name="columnHost">Column host used by the control</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerTreeControl.Dispose(System.Boolean)">
            <summary>
            Call Dispose on all columns.
            </summary>
            <param name="disposing"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerTreeControl.DisplayException(System.Exception)">
            <summary>
            Overridden to use IUIService for displaying error messages to the user, and to
            prevent CheckoutException.Canceled from being redisplayed to user
            </summary>
            <param name="exception">an exception thrown to the underlying VirtualTreeControl</param>
            <returns>Return true to swallow an exception, false to rethrow it.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerTreeControl.SetColumns(Microsoft.VisualStudio.Modeling.DslDefinition.Design.ColumnDescriptor[])">
            <summary>
            Set the columns to be displayed by the tree control
            </summary>
            <param name="columns"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerTreeControl.AddColumnEventHandlers(Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Enables event handlers for all columns in the tree
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerTreeControl.RemoveColumnEventHandlers(Microsoft.VisualStudio.Modeling.Store)">
            <summary>
            Disbles event handlers for all columns in the tree
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerTreeControl.PopulateTree(Microsoft.VisualStudio.Modeling.DslDefinition.Design.AttributeBackendStorage)">
            <summary>
            Populates the tree via attributes specifed on th root object.  This object usually corresponds to
            the selection made in a designer.
            </summary>
            <returns>True if the tree was populated.  False if the object passed in doesn't specify any branches.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerTreeControl.ProcessDialogKey(System.Windows.Forms.Keys)">
            <summary>
            Overriden to preprocess key messages.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerTreeControl.ProcessDialogChar(System.Char)">
            <summary>
            Overriden to preprocess key messages.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerTreeControl.OnKeyPress(System.Windows.Forms.KeyPressEventArgs)">
            <summary>
            
            </summary>
            <param name="e"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerTreeControl.OnKeyDown(System.Windows.Forms.KeyEventArgs)">
            <summary>
            
            </summary>
            <param name="e"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerTreeControl.OnDoubleClick(Microsoft.VisualStudio.VirtualTreeGrid.DoubleClickEventArgs)">
            <summary>
            Overriden to execute the default action specified by the currently selected branch.
            </summary>
            <param name="e"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerTreeControl.FindCurrentColumnOfType(Microsoft.VisualStudio.Modeling.DslDefinition.Design.ProcessKeyResult)">
            <summary>
            retrieves the column index given a type.  Assumes there
            will only be a single instance of each type in the columns array.
            returns -1 if the column is not found
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerTreeControl.GetLastColumnIndex(Microsoft.VisualStudio.VirtualTreeGrid.IBranch,System.Int32)">
            <summary>
            Gets the last column index for the given branch/row.  Accounts for
            jagged columns
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerTreeControl.OnDrawItem(System.Windows.Forms.DrawItemEventArgs)">
            <summary>
            If BatchDrawItem == true, store the index of the item to be drawn,
            but dont actually do the drawing until BatchDrawItem is set to false.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerTreeControl.InvalidateItem(System.Int32)">
            <summary>
            Invalidate a specific row in the tree
            </summary>
            <param name="absIndex">index of the row to invalidate</param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerTreeControl.DefaultColumns">
            <summary>
            Allows a set of default columns.  If no columns are specified via attributes on the object
            passed to PopulateTree, these default columns will be used.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerTreeControl.BatchDrawItem">
            <summary>
            If set to true, draw item messages will be batched up by the control,
            then sent when BatchDrawItem is set to false
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerTreeControl.IgnoreDrawItem">
            <summary>
            If set to true, draw item messages will be discarded by the control
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerTreeControl.SelectedItemInfo">
            <summary>
            
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerInPlaceEdit">
            <summary>
            
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerInPlaceEdit.#ctor">
            <summary>
            
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerInPlaceEdit.OnKeyPress(System.Windows.Forms.KeyPressEventArgs)">
            <summary>
            Pass KeyPress events on to the parent control for special handling
            </summary>
            <param name="e"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerInPlaceEdit.OnKeyDown(System.Windows.Forms.KeyEventArgs)">
            <summary>
            Pass KeyDown events on to the parent control for special handling
            </summary>
            <param name="e"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerInPlaceEdit.OnLostFocus(System.EventArgs)">
            <summary>
            End insertion mode when focus is lost
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributeDesignerInPlaceEdit.ProcessCmdKey(System.Windows.Forms.Message@,System.Windows.Forms.Keys)">
            <summary>
            Forward certain key combinations directly to the text box (e.g. Ctrl-Z)
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.KeyAction">
            <summary>
            
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.KeyAction.Handle">
            <summary>
            
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.KeyAction.Discard">
            <summary>
            
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.KeyAction.Process">
            <summary>
            
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.NavigationDirection">
            <summary>
            
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.NavigationDirection.None">
            <summary>
            
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.NavigationDirection.Up">
            <summary>
            
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.NavigationDirection.Down">
            <summary>
            
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.NavigationDirection.Left">
            <summary>
            
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.NavigationDirection.Right">
            <summary>
            
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ProcessKeyResult">
            <summary>
            Structure filled out by a branch when a key is pressed.  
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ProcessKeyResult.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.Design.KeyAction)">
            <summary>
            Construct a ProcessKeyResult structure with the given action
            </summary>
            <param name="action"></param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ProcessKeyResult.Action">
            <summary>
            Specifies the resulting action that should be taken in response to
            a key press.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ProcessKeyResult.ColumnType">
            <summary>
            Next column to set focus to.  if this is null and KeyAction is Handled,
            the control will determine the next editable
            column and set focus to it.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ProcessKeyResult.BranchType">
            <summary>
            Type of branch to set focus to.  If this is non-null,
            it will be processed first, then ColumnType
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ProcessKeyResult.Direction">
            <summary>
            True iff the search should proceed forward
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ProcessKeyResult.ExpandBranch">
            <summary>
            True iff current branch should be expanded 
            before searching.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ProcessKeyResult.Local">
            <summary>
            True iff the search should stop at the
            current branch.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ProcessKeyResult.StartLabelEdit">
            <summary>
            True iff the cell should be placed in edit mode
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ProcessKeyReturn">
            <summary>
            Enum returned from ClrAttributeDesignerTreeControl.ProcessKeyDown and ClrAttributeDesignerTreeControl.ProcessKeyPress.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ProcessKeyReturn.NotHandled">
            <summary>
            Branch indicated it did not want to handle the key.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ProcessKeyReturn.KeyHandledNoAction">
            <summary>
            Branch indicated it wanted the key, but no action occurred as a result of handling.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ProcessKeyReturn.KeyHandledActionOccurred">
            <summary>
            Branch indicated it wanted the key, and an action occurred as a result of handling.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributesForm.OnParameterExpandableCheck(System.Object,System.EventArgs)">
            <summary>
            Timer callback to determine whether to disable/enable the "view paramater" button. We only need to enable the button 
            when it can expand the contracted parameters (ie. Some of the items in the tree view is contracted).
            </summary>
            <param name="sender"></param>
            <param name="args"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributesForm.IsTreeExpandable">
            <summary>
            Private method to determine whether there's any top level item can be expanded...
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributesForm.OnLoad(System.EventArgs)">
            <summary>
            Method is called when form is loaded.
            </summary>
            <param name="e"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributesForm.Refresh(System.Object)">
            <summary>
            Refreshes the grid
            </summary>
            <param name="tracking">If specified, only the row corresponding to this tracking object will be refreshed.
            If null, the entire grid will be refreshed.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributesForm.viewParametersButton_Click(System.Object,System.EventArgs)">
            <summary>
            event handler when user clicks the view parameters button
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributesForm.components">
            <summary>
            Required designer variable.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributesForm.Dispose(System.Boolean)">
            <summary>
            Clean up any resources being used.
            </summary>
            <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributesForm.InitializeComponent">
            <summary>
            Required method for Designer support - do not modify
            the contents of this method with the code editor.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributesForm.F1Keyword">
            <summary>
            Specifies F1 keyword for this dialog.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributesForm.Store">
            <summary>
            Retrieves the current store
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributesForm.InLabelEdit">
            <summary>
            Retrieves the current label edit state of the tree control.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.OperationDesignerSite">
            <summary>
            Used to site the tree control in the window.  Provides access to shell services.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.OperationDesignerSite.#ctor(System.IServiceProvider)">
            <summary>
            Create an OperationDesignerSite.
            </summary>
            <param name="serviceProvider"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.OperationDesignerSite.GetService(System.Type)">
            <summary>
            
            </summary>
            <param name="serviceType"></param>
            <returns></returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.OperationDesignerSite.Component">
            <summary>
            
            </summary>
            <value></value>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.OperationDesignerSite.Container">
            <summary>
            
            </summary>
            <value></value>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.OperationDesignerSite.DesignMode">
            <summary>
            
            </summary>
            <value></value>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.OperationDesignerSite.Name">
            <summary>
            
            </summary>
            <value></value>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributesInstanceEditor.#ctor">
            <summary>
            Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributesInstanceEditor.EditValue(System.ComponentModel.ITypeDescriptorContext,System.IServiceProvider,System.Object)">
            <summary>
            Edits the specified object's value using the editor style indicated by GetEditStyle.
            </summary>
            <param name="context">An ITypeDescriptorContext that can be used to gain additional context information</param>
            <param name="provider">An IServiceProvider that this editor can use to obtain services</param>
            <param name="value">The object to edit</param>
            <returns>The new value of the object</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ClrAttributesInstanceEditor.GetEditStyle(System.ComponentModel.ITypeDescriptorContext)">
            <summary>
            Gets the editor style used by the EditValue method
            </summary>
            <param name="context">An ITypeDescriptorContext that can be used to gain additional context information</param>
            <returns>A UITypeEditorEditStyle value that indicates the style of editor used by EditValue. If the UITypeEditor does not support this method, then GetEditStyle will return None</returns>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ConnectorDecoratorPositionEditor">
            <summary>
            Custom editor for the ConnectorDecoratorPosition enumeration values.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DecoratorPositionControl`1">
            <summary>
            Base class for decorator position editor controls.
            </summary>
            <typeparam name="T">Enumeration type edited by this control.</typeparam>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DecoratorPositionControl`1.OnGotFocus(System.EventArgs)">
            <summary>
            Passes focus to area buttons.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DecoratorPositionControl`1.Select(System.Boolean,System.Boolean)">
            <summary>
            Passes selection for appropriate child control.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DecoratorPositionControl`1.OnPaintBackground(System.Windows.Forms.PaintEventArgs)">
            <summary>
            Paints background. Override this method to paint shape.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DecoratorPositionControl`1.GetAreaColor(`0)">
            <summary>
            Gets the color of the given area.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DecoratorPositionControl`1.AddArea(`0,System.Drawing.Rectangle,System.Windows.Forms.AnchorStyles)">
            <summary>
            Adds new area to control.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DecoratorPositionControl`1.OnAreaClick(System.Object,System.EventArgs)">
            <summary>
            Reacts to area click event by updating selected value and closing the editor.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DecoratorPositionControl`1.ShapeBrush">
            <summary>
            Gets brush to paint shape inner area.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DecoratorPositionControl`1.ShapeOutlinePen">
            <summary>
            Gets pen to draw shape outline.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DecoratorPositionControl`1.OuterAreaColor">
            <summary>
            Gets color of outer shape areas.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DecoratorPositionControl`1.InnerAreaColor">
            <summary>
            Gets color of inner shape areas.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DecoratorPositionControl`1.AreaSize">
            <summary>
            Gets standard area size.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DecoratorPositionControl`1.SelectedValue">
            <summary>
            Gets currently selected enum value.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ConnectorEndStyleEditor">
            <summary>
            Custom UI type editor for the ConnectorEndStyle enumeration.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ConnectorMapEndpointPickerDialog.#ctor(System.IServiceProvider,Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Constructor
            </summary>
            <param name="serviceProvider"></param>
            <param name="library"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ConnectorMapEndpointPickerDialog.EndpointPickerDialog_Load(System.Object,System.EventArgs)">
            <summary>
            Load the form
            </summary>
            <param name="sender"></param>
            <param name="e"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ConnectorMapEndpointPickerDialog.PopulateSourceList">
            <summary>
            Fill the source list in the dialog with items.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ConnectorMapEndpointPickerDialog.PopulateTargetList">
            <summary>
            Fill the target list in the dialog with items.
            </summary>
            
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ConnectorMapEndpointPickerDialog.sourceComboBox_SelectedIndexChanged(System.Object,System.EventArgs)">
            <summary>
            Handler for source item changed
            </summary>
            <param name="sender"></param>
            <param name="e"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ConnectorMapEndpointPickerDialog.targetComboBox_SelectedIndexChanged(System.Object,System.EventArgs)">
            <summary>
            Handler for target itme changed
            </summary>
            <param name="sender"></param>
            <param name="e"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ConnectorMapEndpointPickerDialog.UpdateStates">
            <summary>
            Update the enabled states of controls.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ConnectorMapEndpointPickerDialog.components">
            <summary>
            Required designer variable.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ConnectorMapEndpointPickerDialog.Dispose(System.Boolean)">
            <summary>
            Clean up any resources being used.
            </summary>
            <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ConnectorMapEndpointPickerDialog.InitializeComponent">
            <summary>
            Required method for Designer support - do not modify
            the contents of this method with the code editor.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ConnectorMapEndpointPickerDialog.F1Keyword">
            <summary>
            Specifies F1 keyword for this dialog.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DashStyleEditor">
            <summary>
            Custom UI type editor for the DashStyle enumeration values.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DomainEnumPropertyDescriptor">
            <summary>
            Provide custom types for the model.
            This will probably need amending once we're generatign a type descriptor provider.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DomainEnumPropertyDescriptor.#ctor(Microsoft.VisualStudio.Modeling.Design.ElementTypeDescriptor,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainPropertyInfo,Microsoft.VisualStudio.Modeling.DslDefinition.DomainEnumeration,System.Attribute[])">
            <summary>
            The DomainEnumPropertyDescriptor only operate upon a domain property of type enum
            </summary>
            <param name="owner">Owner of this object</param>
            <param name="modelElement">ModelElement whose property will be operated upon. This may be null, in which case GetValue() and SetValue() actually use the argument passed in.</param>
            <param name="domainProperty">Property (Required)</param>
            <param name="domainEnum">DomainEnumeration type of this domainProperty</param>
            <param name="attributes">Array of Attributes for this property descriptor</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DomainEnumPropertyDescriptor.GetEditor(System.Type)">
            <summary>
            Returns the editor for the specified type.
            </summary>
            <param name="editorBaseType"></param>
            <returns></returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DomainEnumPropertyDescriptor.Converter">
            <summary>
            Gets the type converter of the property descriptor.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ListBoxControl">
            <summary>
            class used for showing the list box for regular domain enumeration.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ListBoxControl.ListBoxControl_Click(System.Object,System.EventArgs)">
            <summary>
            event handler when this list box loses focus. We need to close down the list box.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.EnumerationEditor">
            <summary>
            Editor for the regular editor, we need to add the extra (none) to indicate no default value.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.EnumerationEditor.EditValue(System.ComponentModel.ITypeDescriptorContext,System.IServiceProvider,System.Object)">
            <summary>
            Method is called when user choose the editor.
            </summary>
            <returns></returns>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DomainEnumConverter">
            <summary>
            Converter for converting the enum strin.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DomainEnumConverter.GetStandardValuesExclusive(System.ComponentModel.ITypeDescriptorContext)">
            <summary>
            Gets a value indicating whether the list of standard values returned from GetStandardValues in an exclusive list using the specified context.
            </summary>
            <param name="context"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DomainEnumConverter.CanConvertTo(System.ComponentModel.ITypeDescriptorContext,System.Type)">
            <summary>
            Converts the given value object to the specified type, using the arguments.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DomainEnumConverter.CanConvertFrom(System.ComponentModel.ITypeDescriptorContext,System.Type)">
            <summary>
            Indicates conversion can happen from a String.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DslDefinitionModelElementPropertyDescriptor">
            <summary>
            Provide custom property descriptor for domain classes defined in the DslDefintion namespace
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DslDefinitionModelElementPropertyDescriptor.#ctor(Microsoft.VisualStudio.Modeling.Design.ElementTypeDescriptor,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainPropertyInfo,System.Attribute[])">
            <summary>
            DslDefinitionModelElementPropertyDescriptor is for concept property
            </summary>
            <param name="owner">Owner of this object</param>
            <param name="modelElement">ModelElement whose property will be operated upon. This may be null, in which case GetValue() and SetValue() actually use the argument passed in.</param>
            <param name="domainProperty">Property (Required)</param>
            <param name="attributes">Array of Attributes for this property descriptor</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DslDefinitionModelElementPropertyDescriptor.SetValue(System.Object,System.Object)">
            <summary>
            Sets the value of the property.
            </summary>
            <param name="component"></param>
            <param name="value"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DslDefinitionModelElementPropertyDescriptor.VerifyNamedDomainProperty(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainPropertyInfo,System.String)">
            <summary>
            Internal helper method to make sure that the Named DomainPoperty 
            </summary>
            <param name="modelElement"></param>
            <param name="domainProperty"></param>
            <param name="newValue"></param>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DslDefinitionModelElementTrackingPropertyDescriptor">
            <summary>
            Provide custom tracking property descriptor for domain classes defined in the DslDefintion namespace
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DslDefinitionModelElementTrackingPropertyDescriptor.#ctor(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainPropertyInfo,Microsoft.VisualStudio.Modeling.DomainPropertyInfo,System.Attribute[])">
            <summary>
            The ElementPropertyDescriptor can operate upon a specific element
            passed in to the constructor, or it can accept a null element.
            
            If a specific element is provided, GetValue(), SetValue(), and
            the other methods will ignore the object argument passed in
            and will instead use that specific element.
            
            If a null element is provided, GetValue(), SetValue(), and 
            the other methods will use the object argument passed in.
            </summary>
            <param name="modelElement">ModelElement whose property will be operated upon. This may be null, in which case GetValue() and SetValue() actually use the argument passed in.</param>
            <param name="domainProperty">Property (Required)</param>
            <param name="trackingProperty">(Boolean)Property that handles whether this property is tracking.</param>
            <param name="attributes">Array of Attributes for this property descriptor</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DslDefinitionModelElementTrackingPropertyDescriptor.SetValue(System.Object,System.Object)">
            <summary>
            Sets the value of the property.
            </summary>
            <param name="component"></param>
            <param name="value"></param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DslDefinitionModelElementTrackingPropertyDescriptor.IsReadOnly">
            <summary>
            Returns whether this property is readonly or not.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.EditorIconPropertyDescriptor">
            <summary>
            propety descriptor for the Editor.Icon property. We need to override existing File.ico file in sibling DslPackage\Resources\File.ico file
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.EditorIconPropertyDescriptor.#ctor(Microsoft.VisualStudio.Modeling.Design.ElementTypeDescriptor,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.DomainPropertyInfo,System.Attribute[])">
            <summary>
            The DomainEnumPropertyDescriptor only operate upon a domain property of type enum
            </summary>
            <param name="owner">Owner of this object</param>
            <param name="modelElement">ModelElement whose property will be operated upon. This may be null, in which case GetValue() and SetValue() actually use the argument passed in.</param>
            <param name="domainProperty">Property (Required)</param>
            <param name="domainEnum">DomainEnumeration type of this domainProperty</param>
            <param name="attributes">Array of Attributes for this property descriptor</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.EditorIconPropertyDescriptor.SetValue(System.Object,System.Object)">
            <summary>
            Override this so we can update DslPackage\resources\File.ico file. This is the icon associated with the language file.
            </summary>
            <param name="component"></param>
            <param name="value"></param>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.CustomEnumConverter">
            <summary>
            Base class for custom enum converters which display custom value strings.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.MultiplicityConverter">
            <summary>
            Type converter for the Multiplicity enumeration values.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.AccessModifierConverter">
            <summary>
            Type converter for the AccessModifier enumeration values.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.TypeAccessModifierConverter">
            <summary>
            Type converter for the TypeAccessModifier enumeration values.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.InheritanceModifierConverter">
            <summary>
            Type converter for the InheritanceModifier enumeration values.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.FillGradientModeEditor">
            <summary>
            Custom UI type editor for FillGradientMode enumeration values.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ImageResourceEditorContextAttribute">
            <summary>
            Attribute used to pass project context information to the ImageResourceDialog.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ImageResourceEditorContextAttribute.GetRootPath(System.Object)">
            <summary>
            Gets directory containing the document that selected component belongs to.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ImageResourceEditorContextAttribute.FindProjectItems(System.Object,System.Collections.Generic.IEnumerable{System.String})">
            <summary>
            Gets collection of full paths to files with given extensions from the project that component belongs to.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ImageResourceKind">
            <summary>
            Kind of image resource to be supplied into the ImageResourceFilterAttribute.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ImageResourceFilterAttribute">
            <summary>
            Specifies which types of image resources allowed for a given domain property representing a resource image path.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ImageResourceFilterAttribute.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.Design.ImageResourceKind)">
            <summary>
            Creates a new instance of the ImageResourceFilterAttribute class.
            </summary>
            <param name="kind">Kind of image resource.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ImageResourceFilterAttribute.IsSupported(System.String)">
            <summary>
            Returns true if specified file exists on disk and of supported image type.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ImageResourceFilterAttribute.Kind">
            <summary>
            Gets image resource kind.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ImageResourceFilterAttribute.DialogTitle">
            <summary>
            Gets dialog title for specified image resource kind.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ImageResourceFilterAttribute.FileFilter">
            <summary>
            Gets file filter for specified image resource kind.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ImageResourceFilterAttribute.Extensions">
            <summary>
            Gets list of extensions corresponding to specified image resource kind.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ImageResourceDialog">
            <summary>
            Custom editor form for image resources stored in domain model.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ImageResourceDialog.components">
            <summary>
            Required designer variable.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ImageResourceDialog.Dispose(System.Boolean)">
            <summary>
            Clean up any resources being used.
            </summary>
            <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ImageResourceDialog.InitializeComponent">
            <summary>
            Required method for Designer support - do not modify
            the contents of this method with the code editor.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ImageResourceDialog.F1Keyword">
            <summary>
            Specifies F1 keyword for this dialog.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ImageResourceEditor">
            <summary>
            Custom editor for image resources stored in domain model.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ImageResourceEditor.SetContext(System.ComponentModel.ITypeDescriptorContext,System.Boolean)">
            <summary>
            Initializes image resource editing context from the given ITypeDescriptorContext instance.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ImageResourceEditor.GetSelectedItems(System.ComponentModel.ITypeDescriptorContext)">
            <summary>
            Returns an array of the selected objects from the
            property descriptor context.
            </summary>
            <remarks>If multiple items have been selected in the property grid,
            the context.Instance will be an array of those items. Otherwise it
            will be the single selected item.</remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ImageResourceEditor.GetSelectedItemAttributes(System.Object[])">
            <summary>
            Returns a list of the attributes for the selected items
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ImageResourceEditor.GetFullPath(System.String)">
            <summary>
            Given a path relative to root path, returns a full path of the same file.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ImageResourceEditor.GetRelativePath(System.String)">
            <summary>
            Given a full path to a file, returns a path relative to the root path.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ImageResourceEditor.IsCursorFile(System.String)">
            <summary>
            Returns ture if specified file name represents a .cur file.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ImageResourceEditor.IsIconFile(System.String)">
            <summary>
            Returns true if specified file name represents a .ico file.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ImageResourceEditor.GetEditStyle(System.ComponentModel.ITypeDescriptorContext)">
            <summary>
            Tells property grid to display modal dialog form as editing style.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ImageResourceEditor.EditValue(System.ComponentModel.ITypeDescriptorContext,System.IServiceProvider,System.Object)">
            <summary>
            Performs value editing for the property grid using modal ImageResourceDialog form.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ImageResourceEditor.GetPaintValueSupported(System.ComponentModel.ITypeDescriptorContext)">
            <summary>
            Tells property grid that this editor paints value in its cell.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ImageResourceEditor.PaintValue(System.Drawing.Design.PaintValueEventArgs)">
            <summary>
            Paints image to the property grid cell.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ImageResourceEditor.GetCachedImage(System.String,System.Drawing.Size)">
            <summary>
            Load image from file on disk, converts it to given size and returns cached Image instance.
            Note that this method doesn't deal with image file changes on disk which might cause
            some inconsistency between UI and actual image file contents, but since it's rather 
            informational representation, it is not a big problem vs. performance gains.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.NameColumn.#ctor">
            <summary>
            Construct a NameColumn
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.NameColumn.GetValue(System.Object)">
            <summary>
            Returns the value of this column, given an object instance.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.NameColumn.SetValue(System.Object,System.Object)">
            <summary>
            Set the value of this column, given an object instance and a new value.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.NameColumn.GetValueSupported(System.Object)">
            <summary>
            Returns true if this column supports viewing or editing the given component.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.NamePropertyColumn.#ctor">
            <summary>
            Construct a NamePropertyColumn
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.NamePropertyColumn.GetValue(System.Object)">
            <summary>
            Returns the value of this column, given an object instance.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.NamePropertyColumn.SetValue(System.Object,System.Object)">
            <summary>
            Set the value of this column, given an object instance and a new value.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.NamePropertyColumn.GetValueSupported(System.Object)">
            <summary>
            Returns true if this column supports viewing or editing the given component.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DomainPathTypeConverter">
            <summary>
            Type convertor parses and deals with DomainPaths - works in conjunction with DomainPathpropertyDescriptor
            </summary>
            <remarks>
            This TypeConvertor converts string representations of DomainPaths to deleted instances of DomainPaths.
            </remarks>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DomainPathPropertyDescriptor">
            <summary>
            Property descriptor that handles using a DomainPath (which is a role player) as a property
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DomainPathPropertyDescriptor.role">
            <summary>
             The role that is being edited if this describes a property on a class that has a Path as a child.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DomainPathPropertyDescriptor.editor">
            <summary>
            Editor instance for DomainPaths
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DomainPathPropertyDescriptor.#ctor(Microsoft.VisualStudio.Modeling.DomainRoleInfo,System.Attribute[])">
            <summary>
            Constructor for use when adding a DomainPath property on any object
            </summary>
            <param name="role"></param>
            <param name="attrs"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DomainPathPropertyDescriptor.#ctor(System.String,System.Attribute[])">
            <summary>
            Constructor for use when adding a "content" property to DomainPath
            </summary>
            <param name="name"></param>
            <param name="attrs"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DomainPathPropertyDescriptor.GetEditor(System.Type)">
            <summary>
            Get an editor for the property.
            </summary>
            <param name="editorBaseType"></param>
            <returns></returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DomainPathPropertyDescriptor.Description">
            <summary>
            Returns the path description.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DomainPathPropertyDescriptor.DisplayName">
            <summary>
            Gets the name that can be displayed in a window, such as a Properties window.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DomainPathPropertyDescriptor.Category">
            <summary>
            Returns the Category where this property is placed under. This will be the Domain
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DomainPathEditor">
            <summary>
            Custom UI type editor for DomainPaths.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DomainPathEditor.TreeEditorControl">
            <summary>
            Tree control displayed in the drop down.
            </summary>
            <remarks>
            Subclasses the basic PathEditorTreeView control to change
            some of the key handling / selection behaviour.
            </remarks>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.PathEditorTreeView">
            <summary>
            Custom treeview control used to build valid DomainPaths.
            </summary>
            <remarks>One or more domain classes can be added as roots of the tree.
            The tree does NOT react to changes in the model (i.e. DomainClasses
            being added / removed / renamed). Currently the control is only intended
            to be used from drop-downs (PropertiesGrid or PathEditorComboTree), and
            will be rebuild each time it is used. The user won't be able to make any
            changes to the model without closing the dropdown first.</remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.PathEditorTreeView.SetStartPoints(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass})">
            <summary>
            Specifies multiple domain classes as starting points
            for navigation.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.PathEditorTreeView.SetStartPoint(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Specifies a single domain class as a starting point
            for navigation.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.PathEditorTreeView.AddRoot(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,System.Boolean)">
            <summary>
            Adds a new root domain class
            </summary>
            <param name="domainClass"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.PathEditorTreeView.EnsureChildNodesExist(System.Windows.Forms.TreeNode)">
            <summary>
            Create and add the child nodes for the specified node.
            Any existing nodes are replaced.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.PathEditorTreeView.IsRoleSameOrDerived(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Returns a flag indicating whether the roles are the same,
            or potentialChild derives from potentialParent.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.PathEditorTreeView.SearchHierarchyForMultiplicityManyLinks(System.Windows.Forms.TreeNode)">
            <summary>
            Searches up the tree for nodes that describe links that have a 
            multiplicity of "many".
            /// </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.PathEditorTreeView.CreateAndSiteNode(Microsoft.VisualStudio.Modeling.DslDefinition.Design.PathEditorTreeView.SegmentNodeInfo,System.Boolean,System.Windows.Forms.TreeNode)">
            <summary>
            Create, site and return a new node
            </summary>
            <remarks>
            Sets the icon, text and tag properties. Also works out if a dummy
            node should be added to cause a +/- arrow to be added.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.PathEditorTreeView.GetNodeText(System.Windows.Forms.TreeNode,Microsoft.VisualStudio.Modeling.DslDefinition.Design.PathEditorTreeView.SegmentNodeInfo)">
            <summary>
            Returns the text string to display for a node
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.PathEditorTreeView.DescriptionMatchesPreviousChild(System.String,System.Windows.Forms.TreeNode)">
            <summary>
            Returns whether a previous child node has used the supplied text description
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.PathEditorTreeView.GetAllSegmentsFromClass(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Returns a list of all of the valid segments for the supplied domain class
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.PathEditorTreeView.AddSegmentsForRelationship(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship,System.Collections.Generic.List{Microsoft.VisualStudio.Modeling.DslDefinition.Design.PathEditorTreeView.SegmentNodeInfo})">
            <summary>
            Adds all of the path segments (source and target) for the relationship.
            This includes any inherited path segments.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.PathEditorTreeView.OnBeforeExpand(System.Windows.Forms.TreeViewCancelEventArgs)">
            <summary>
            Reload the child nodes every time a node is expanded.
            </summary>
            <param name="e"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.PathEditorTreeView.GetPathSyntax">
            <summary>
            Returns the full path syntax for the currently selected node,
            including full namespaces.
            </summary>
            <remarks>
            If the current node is a root node, then this is treated as
            an empty path i.e. an empty string is returned.
            </remarks>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.PathEditorTreeView.PrependPathSyntax(System.Text.StringBuilder,System.Windows.Forms.TreeNode)">
            <summary>
            Recursively gets the path syntax for previous nodes, then adds the 
            syntax for this node
            </summary>
            <returns>Flag indicating whether the method prepended anything onto the path</returns>
            <remarks>No danger of infinite recursion since tree is hierarchical.</remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.PathEditorTreeView.GetSegmentSyntax(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,Microsoft.VisualStudio.Modeling.DslDefinition.PathSegmentInterpretation)">
            <summary>
            Returns the full path syntax for a single path segment that
            is described by the supplied role and interpretation.
            </summary>
            <remarks>Factored like this so it can be used easily with 
            both SegmentNodeInfo and PathSegment instances.</remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.PathEditorTreeView.ExpandPath(Microsoft.VisualStudio.Modeling.DslDefinition.DomainPath)">
            <summary>
            Selects node in the tree corresponding to the supplied path and
            expands the tree so this node is visible.
            </summary>
            <remarks>If the path is null, the first root node will be selected</remarks>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.PathEditorTreeView.components">
            <summary>
            Required designer variable.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.PathEditorTreeView.Dispose(System.Boolean)">
            <summary>
            Clean up any resources being used.
            </summary>
            <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.PathEditorTreeView.InitializeComponent">
            <summary>
            Required method for Designer support - do not modify 
            the contents of this method with the code editor.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.PathEditorTreeView.DummyChildNode">
            <summary>
            Marker class
            </summary>
            <remarks>Used to cause expand/collapse icon to appear for a node that
            has not had its real children created yet.</remarks>
        </member>
        <!-- Badly formed XML comment ignored for member "T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.PathEditorTreeView.RootNode" -->
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.PathEditorTreeView.SegmentNodeInfo">
            <summary>
            Lightweight version of the domain class "PathSegment" i.e. not 
            Store based.
            </summary>
            <remarks>Used the PathEditorTreeView to store additional information
            about nodes in the Node.Tag property.
            Contains additional calculated display properties</remarks>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.PathEditorTreeView.SegmentNodeInfo.DisplayText">
            <summary>
            Returns the text description to display for this segment
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.PathEditorTreeView.SegmentNodeInfo.FullPathSegmentSyntax">
            <summary>
            Returns the full path syntax for this segment i.e. includes
            the full relationship name.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.PathEditorTreeView.SegmentNodeInfo.Destination">
            <summary>
            Returns the DomainClass (or DomainRelationship) that 
            will be reached by following the path segment.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.PathEditorTreeView.PathEditorIcons">
            <summary>
            Static class to get and hold icon resources
            </summary>
            <remarks>
            No finalizer, so the dispose method on the ImageList won't
            be called explicitly - will be called by the GC.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.RelationshipEndpointPickerDialog.#ctor(System.IServiceProvider,Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Constructor
            </summary>
            <param name="serviceProvider"></param>
            <param name="library"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.RelationshipEndpointPickerDialog.EndpointPickerDialog_Load(System.Object,System.EventArgs)">
            <summary>
            Load the form
            </summary>
            <param name="sender"></param>
            <param name="e"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.RelationshipEndpointPickerDialog.PopulateSourceList">
            <summary>
            Fill the source list in the dialog with items.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.RelationshipEndpointPickerDialog.PopulateTargetList">
            <summary>
            Fill the target list in the dialog with items.
            </summary>
            
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.RelationshipEndpointPickerDialog.sourceComboBox_SelectedIndexChanged(System.Object,System.EventArgs)">
            <summary>
            Handler for source item changed
            </summary>
            <param name="sender"></param>
            <param name="e"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.RelationshipEndpointPickerDialog.targetComboBox_SelectedIndexChanged(System.Object,System.EventArgs)">
            <summary>
            Handler for target itme changed
            </summary>
            <param name="sender"></param>
            <param name="e"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.RelationshipEndpointPickerDialog.UpdateStates">
            <summary>
            Update the enabled states of controls.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.RelationshipEndpointPickerDialog.components">
            <summary>
            Required designer variable.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.RelationshipEndpointPickerDialog.Dispose(System.Boolean)">
            <summary>
            Clean up any resources being used.
            </summary>
            <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.RelationshipEndpointPickerDialog.InitializeComponent">
            <summary>
            Required method for Designer support - do not modify
            the contents of this method with the code editor.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Design.RelationshipEndpointPickerDialog.F1Keyword">
            <summary>
            Specifies F1 keyword for this dialog.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ElementListItem">
            <summary>
            List control item representing a model element.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ElementListItem.Element">
            <summary>
            Element represented by this item.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ElementListItem.ToString">
            <summary>
            Gets represented element's name.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ElementListItem.Equals(System.Object)">
            <summary>
            Compares this list item to another list item or ModelElement.
            Returns true if elements represented are the same and false otherwise.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ElementListItem.GetHashCode">
            <summary>
            Gets hashcode of the represented element.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.RoutingStyleEditor">
            <summary>
            Custom UI type editor for RoutingStyle enumeration values.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ShapeDecoratorPositionEditor">
            <summary>
            Custom editor for the ShapeDecoratorPosition enumeration values.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.ShapeGeometryEditor">
            <summary>
            Custom UI type editor for ShapeGeometry and CompartmentShapeGeometry enumeration values.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.SwimLaneDecoratorPositionEditor">
            <summary>
            Custom editor for the SwimLaneDecoratorPosition enumeration values.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.TextBoxValidationHelper">
            <summary>
            Provides validation timer and tooltip for text box and combo box controls.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DslDefinitionModelTypeDescriptorProvider">
            <summary>
            Provide custom types for the model.
            This will probably need amending once we're generatign a type descriptor provider.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.Design.DslDefinitionModelTypeDescriptorProvider.CreateTypeDescriptor(System.ComponentModel.ICustomTypeDescriptor,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Virtual method to supply our own type descriptor
            </summary>
            <returns>DslDefinitionModelElementTypeDescriptor object</returns>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities">
            <summary>
            Utilities used by the code-generation templates
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetAccessModifier(Microsoft.VisualStudio.Modeling.DslDefinition.AccessModifier)">
            <summary>
            Gets the C# access modifier keyword for the given AccessModifier enum
            </summary>
            <param name="modifier"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetTypeAccessModifier(Microsoft.VisualStudio.Modeling.DslDefinition.TypeAccessModifier)">
            <summary>
            Gets the C# access modifier keyword for the given TypeAccessModifier enum
            </summary>
            <param name="modifier"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetInheritanceModifier(Microsoft.VisualStudio.Modeling.DslDefinition.InheritanceModifier)">
            <summary>
            Gets the C# modifier keyword for the given InheritanceModifier enum
            </summary>
            <param name="modifier"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetGenerationInheritanceModifier(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Gets the class modifier for a domain class. Returns "abstract" if the 
            class is a double derived class because the generated class (base class) in
            a double-derived pair is always abstract
            </summary>
            <param name="domainClass"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetGeneratedLinkAccessModifier(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Returns the most limited type access modifier among the passed in DomainRelationship and its role players.
            </summary>
            <param name="domainRelationship"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetGeneratedPropertyGetterAccessModifier(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Returns the getter property modifier to be used for the Get/Set properties in the DomainRelationship class
            </summary>
            <param name="role">role where the property is generated for.</param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetGeneratedPropertySetterAccessModifier(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Returns the setter property modifier to be used for the Get/Set properties in the DomainRelationship class
            </summary>
            <param name="role">role where the property is generated for.</param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetGeneratedPropertySetter(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole,Microsoft.VisualStudio.Modeling.DslDefinition.AccessModifier)">
            <summary>
            Figure out the access modifier for the static property, we cannot simply use the role.PropertyGetterAccessModifier. We have to find out the most limited 
            scoped modifier among role.PropertyGetterAccessModifier, source roleplayer and target roleplayer
            </summary>
            <param name="role"></param>
            <param name="modifier"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetBaseClass(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,System.String)">
            <summary>
            Gets the string for declaring the base class of a domain class.
            If the base class is not defined, ModelElement is used.
            </summary>
            <param name="domainClass"></param>
            <param name="defaultBaseClass">The default base class to use if one is not specified.</param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetBaseRelationship(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Gets the string for declaring the base relationship of a domain relationship.
            If the base class is not defined, ElementLink is used.
            </summary>
            <param name="domainRelationship"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetDomainTypeFullName(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Gets the full name of the type of the DomainProperty (including generic parameters) relative
            to the namespace of the property's class.
            </summary>
            <param name="property"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetDomainTypeFullName(Microsoft.VisualStudio.Modeling.DslDefinition.DomainType,System.String)">
            <summary>
            Gets the full name of the DomainType (including generic parameters) relative to the
            given current namespace.
            </summary>
            <param name="type"></param>
            <param name="currentNamespace"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetPackageNamespace(Microsoft.VisualStudio.Modeling.DslDefinition.Dsl)">
            <summary>
            Get Dsl package name for the given Dsl.
            </summary>
            <param name="dsl">Dsl instance whose package name will be returned.</param>
            <returns>The package name of the given Dsl.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.IsDecimalNumberType(System.String)">
            <summary>
            Returns true if the provided typeName is a decimal type.
            </summary>
            <param name="typeName"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetNumberTypeSuffix(System.String)">
            <summary>
            Returns proper type suffix so the default value is gen'ed correctly.
            </summary>
            <param name="typeName"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.IsSystemSByte(System.String)">
            <summary>
            Returns whether this is a sbyte.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.IsSystemByte(System.String)">
            <summary>
            Returns whether this is a byte.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.IsSystemInt16(System.String)">
            <summary>
            Returns whether this is a short.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.IsSystemUInt16(System.String)">
            <summary>
            Returns whether this is a ushort.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.IsSystemInt32(System.String)">
            <summary>
            Returns whether this is a int.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.IsSystemUInt32(System.String)">
            <summary>
            Returns whether this is a uint.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.IsSystemInt64(System.String)">
            <summary>
            Returns whether this is a long.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.IsSystemUInt64(System.String)">
            <summary>
            Returns whether this is a ulong.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.IsSystemDecimal(System.String)">
            <summary>
            Returns whether this is a decimal.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.IsSystemDouble(System.String)">
            <summary>
            Returns whether this is a double .
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.IsSystemSingle(System.String)">
            <summary>
            Returns whether this is a float.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.IsStringType(System.String)">
            <summary>
            returns true if typeName represents a string ("string" or "System.String")
            </summary>
            <param name="typeName"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.IsBooleanType(System.String)">
            <summary>
            returns true if typeName represents bool ("bool" or "System.Boolean")
            </summary>
            <param name="typeName"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.IsCharType(System.String)">
            <summary>
            returns true if typeName represents char ("char" or "System.Char")
            </summary>
            <param name="typeName"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.IsGuidType(System.String)">
            <summary>
            returns true if typeName represents Guid ("System.Guid")
            </summary>
            <param name="typeName"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.IsStringProperty(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            returns true if the property is of type string.
            </summary>
            <param name="domainProperty"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetPropertyDefaultValue(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty,System.Boolean@)">
            <summary>
            Returns the string to declare the default value of a property (in the form "= defaultValue"
            </summary>
            <param name="property"></param>
            <param name="needsDeserialization"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetPropertyDefaultValueAttribute(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Gets the string for the constructor of the System.ComponentModel.DefaultValueAttribute.
            </summary>
            <param name="property"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.WrapAsCSharpString(System.String)">
            <summary>
            Wrap the given string into a string literal in C# syntax.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetPropertyKind(Microsoft.VisualStudio.Modeling.DslDefinition.PropertyKind)">
            <summary>
            Returns the string for the kind of the kind of the property for the DomainPropertyAttribute
            constructor.
            </summary>
            <param name="propertyKind"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetPropertyHandlerName(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Gets the name of a property handler for a property 
            </summary>
            <param name="property"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetGuid(System.Guid)">
            <summary>
            Returns a string of the form "new System.Guid(xxx)" where xxx is the string form of the given guid.
            </summary>
            <param name="guid"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.IsMultiple(Microsoft.VisualStudio.Modeling.DslDefinition.Multiplicity)">
            <summary>
            returns true if the upper bound of the given multiplicity is *
            </summary>
            <param name="multiplicity"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetGenerationClassName(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Returns the name of the class to be generated. In the case of a double-derived
            class, we add 'Base' to the name of the domain class. If not, the 
            name of the domain class is used.
            </summary>
            <param name="domainClass"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetNameProperty(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Return a property (in this or a base class) that can be used to idenfify an element to the user.
            Returns the property marked IsElementName.
            If there is none, returns the property marked IsMonikerKey.
            If there is none, returns null.
            </summary>
            <param name="domainClass"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetCamelCase(System.String)">
            <summary>
            Conver the input string to camel case by lower-casing the first character
            </summary>
            <param name="input"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetBasePropertyHandlerName(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Gets the base class for the PropertyHandler for the given property. The base class is
            different if it's a calculated property.
            </summary>
            <param name="property"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetSameNameBaseRole(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Returns the base role of the given role if it has the same name as the given role
            </summary>
            <param name="role"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetBaseRole(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Gets the base role of the given role if one exists. If not, it returns null.
            </summary>
            <param name="role"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetTypeRole(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Gets the role that determines the type of the generated property for this role. 
            This is the most-base role that has the same name as this role.
            </summary>
            <param name="role"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetDesigner(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Get the Designer defined in the given DslLibrary.
            </summary>
            <param name="dslLibrary">DslLibrary instance whose defined Designer will be returned.</param>
            <returns>The Designer defined in the given DslLibrary, null if none is defined.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.IsOuterDecorator(Microsoft.VisualStudio.Modeling.DslDefinition.ShapeDecoratorPosition)">
            <summary>
            Returns true if the given ShapeDecorationPosition is an outer decorator.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.IsOuterDecorator(Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementHasDecorators)">
            <summary>
            Returns true if the given link connects to an outer decorator.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetDiagramElementForDecoratorMap(Microsoft.VisualStudio.Modeling.DslDefinition.DecoratorMap)">
            <summary>
            Gets the diagram element associated with the shape or connector map
            that defines a decorator map.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetSegmentOutputType(Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment)">
            <summary>
            For the given pathSegment, this method returns its output fully qualified type name.
            </summary>
            <param name="segment"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetSegmentInputType(Microsoft.VisualStudio.Modeling.DslDefinition.PathSegment)">
            <summary>
            For the given pathSegment, this method returns its input fully qualified type name.
            </summary>
            <param name="segment"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.HasCustomTypeDescriptor(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Returns true if the given class has a custom type descriptor defined, false otherwise.
            </summary>
            <remarks>A custom type descriptor is defined if either the "CustomCoded" property is
            true, or if it has one or more property paths defined.</remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.RequiresGeneratedPropertyDescriptor(Microsoft.VisualStudio.Modeling.DslDefinition.CustomPropertyDescriptor)">
            <summary>
            Returns true if the given descriptor requires a PropertyDescriptor derived class to be generated, false otherwise.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetVersionString(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Get the version of a DslLibrary in string form.
            </summary>
            <param name="dslLibrary">DslLibrary to get version from.</param>
            <returns>The version of the given DslLibrary in the format of "1.2.3.4".</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.DefinesDiagramElements(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            True if the given DslLibrary defines diagram elements, false otherwise.
            Diagram elements are elements that are included in DslLibrary.DiagramElements, plus diagram (if one is defined).
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.HasCompartmentMaps(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            True if the given Diagram defines CompartmentMaps.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetSerializedDomainClasses(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Get a list of all DomainClasses in the given DslLibrary that will have serializers generated.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.IsRootClass(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            If a DomainClass is a root class, all its serialization-related methods/properties will be virtual (unless it's sealed);
            otherwise, these methods/properties will be "override" and will call base implementations.
            Currently, a DomainClass is a root class if it derives from Microsoft.VisualStudio.Modeling.ModelElement directly.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.HasNonAbstractBaseClass(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Tells if the given DomainClass has a non-abstract base class. There is needed to determine if a "new" keyword needs to be
            generated.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetMethodModifier(System.Boolean,System.Boolean)">
            <summary>
            Gets the method modifier (virtual, override, etc.) in generated code with the given parameters.
            </summary>
            <param name="isRootClass">Whether the class containing the method is a root class.</param>
            <param name="isSealed">Whether the class containing the method is sealed.</param>
            <returns>The correct method modifier that will be used in code generation.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetPropertyTagName(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Gets the XML tag name of the given DomainProperty. The tag name will be either the XML attribute name if the property is 
            serialized as an XML attribute, or XML element name if the property is serialized as a nested XML element.
            </summary>
            <param name="prop">DomainProperty whose XML tag name will be returned.</param>
            <returns>The XML tag name of the given DomainProperty.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetAttributeProperties(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,System.Int32@)">
            <summary>
            Returns all DomainProperties defined on the given DomainClass that will be serialized as XML attribute.
            </summary>
            <param name="domainClass">DomainClass whose domain properties that are seralized as XML attributes will be returned.</param>
            <param name="calculatedAttribPropCount">The number of calculated properties among the returned domain properties.</param>
            <returns>All DomainProperties defined on the given DomainClass that will be serialized as XML attribute. Empty list if none is found.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetElementProperties(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,System.Int32@)">
            <summary>
            Returns all DomainProperties defined on the given DomainClass that will be serialized as nested XML element.
            </summary>
            <param name="domainClass">>DomainClass whose domain properties that are seralized as nested XML elements will be returned.</param>
            <param name="calculatedElementPropCount">The number of calculated properties among the returned domain properties.</param>
            <returns>All DomainProperties defined on the given DomainClass that will be serialized as nested XML element. Empty list if none is found.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetRelationshipTagName(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Get the XML role element name for the given role's relationship.
            Note: this is the RoleElementName (if defined), not the XML tag name for a full-form relationship (which is returned from GetDomainClassXmlTagName()).
            </summary>
            <param name="role">DomainRole whose relationship's role element name will be returned.</param>
            <returns>The role element name of the given role.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.CalculateInheritanceDepth(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Given a DomainClass, calculate the inheritance depth in generated code (taking into consideration of double-derived base classes).
            This is used to determine whether we need a SuppressMessage attribute for "excessive inheritance".
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.SortDomainClassesByInheritance``1(System.Collections.Generic.IEnumerable{``0})">
            <summary>
            Sort a collection of DomainClasses based on relative inheritance relationships. The most derived one will appear first in the sort result.
            This is used in following situation:
            Say there're 4 DomainClasses A, B, C and D. You need to generate some code like following:
            ...
            A a = obj as A;
            if (a != null) ...
            B b = obj as B;
            if (b != null) ...
            C c = obj as C;
            if (c != null) ...
            D d = obj as D;
            if (d != null) ...
            ...
            If C derives from A, the above code is wrong; the correct code should check for C first before checking for A. That's why this method 
            should be called to sorted the DomainClasses in inheritance order, and the generated code will look like:
            ...
            C c = obj as C;
            if (c != null) ...
            A a = obj as A;
            if (a != null) ...
            B b = obj as B;
            if (b != null) ...
            D d = obj as D;
            if (d != null) ...
            ...
            </summary>
            <typeparam name="T"></typeparam>
            <param name="input"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.SortList``1(System.Collections.Generic.IList{``0},Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetOrder{``0})">
            <summary>
            In-place sort a list using insertion sort.
            </summary>
            <param name="list">List of items to sort.</param>
            <param name="getOrderDelegate">A GetOrder delegate to get the order of the each element in the list.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.SortProperties(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty})">
            <summary>
            Sort DomainProperties based on XmlElement.Order (if specified). By default, the order of each property is 0. Properties with smaller
            order will appear first. Properties of the same order will not be sorted (i.e. they'll keep their relative order after sorting). 
            The sorting is in-place, so the passed-in collection will be changed directly.
            </summary>
            <param name="props">Properties to be sorted.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.SortRoles(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole})">
            <summary>
            Sort DomainRoles based on XmlRelationshipElement.Order (if specified). By default, the order of each role is 0. Roles with smaller
            order will appear first. Roles of the same order will not be sorted (i.e. they'll keep their relative order after sorting). 
            The sorting is in-place, so the passed-in collection will be changed directly.
            </summary>
            <param name="roles">Roles to be sorted.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetDomainClassXmlTagName(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the XmlTagName for a domain class. 
            </summary>
            <param name="domainClass">DomainClass whose XmlTagName will be returned.</param>
            <returns>The Xml tag name of the given DomainClass.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetDomainClassSchemaTypeName(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the schema type name for the given domain class.
            </summary>
            <param name="domainClass">DomainClass whose schema type name will be returned.</param>
            <returns>The schema type name of the given DomainClass.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetDomainClassMonikerTagName(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the MonikerTagName for a domain class, when it is serialized as a moniker.
            Note that the tag name cannot be the same for moniker, because that will require 
            two definitions of the same element in the generated schema. The default name 
            used (if not specified using "XmlClassData.MonikerElementName"), will be the non-moniker XmlTagName
            followed by "Moniker".
            </summary>
            <param name="domainClass">DomainClass whose MonikerTagName will be returned.</param>
            <returns>The moniker tag name of the given DomainClass.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetDomainClassMonikerSchemaTypeName(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the moniker schema type name for the given domain class.
            </summary>
            <param name="domainClass">DomainClass whose moniker schema type name will be returned.</param>
            <returns>The moniker schema type name of the given DomainClass.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetPropertyRepresentation(Microsoft.VisualStudio.Modeling.DslDefinition.DomainProperty)">
            <summary>
            Get the PropertyRepresentation (Attribute, Element, or Ignored) of the given DomainProperty. Default is Attribute
            if not specified.
            </summary>
            <param name="domainProperty">DomainProperty whose PropertyRepresentation will be returned.</param>
            <returns>The PropertyRepresentation of the given DomainProperty.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.OmitElement(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Gets if the given DomainRelationship is serialized as "OmitElement" (without the role element tag).
            </summary>
            <param name="domainRelationship">DomainRelationship to check.</param>
            <returns>True if the given DomainRelationship is serialized as "OmitElement", false otherwise.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.UseFullForm(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Gets if the given DomainRelationship is serialized in full-form.
            </summary>
            <param name="domainRelationship">DomainRelationship to check.</param>
            <returns>True if the given DomainRelationship is serialized in full-form, false otherwise.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.AllowMultiple(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRole)">
            <summary>
            Gets if the given role allows multiple instances, based on its Multiplicity.
            </summary>
            <param name="role">DomainRole to check.</param>
            <returns>True if the role allows multiple, false otherwise.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.DefinesNewTargetRole(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            In relationship derivation, a relationship can use the same target role-player as its parent relationship, or it can define a new one (which
            derives from the parent relationship's target role-player). This method tells whether the given DomainRelationship defines a new target role-
            player.
            </summary>
            <param name="domainRelationship">DomainRelationship to check.</param>
            <returns>True if the given DomainRelationship defines a new target role-player, false otherwise.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.HasCustomBaseImplementation(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Whether the given DomainClass (or any of its base DomainClasses) is marked as "IsCustom", which means the serialization is customized.
            </summary>
            <param name="domainClass">DomainClass to check.</param>
            <returns>True if the given DomainClass (or any of its base DomainClasses) is marked as "IsCustom", false otherwise.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.MapToSchemaType(Microsoft.VisualStudio.Modeling.DslDefinition.DomainType)">
            <summary>
            Map a DomainType to its schema type.
            </summary>
            <param name="domainType">DomainType whose schema type will be returned.</param>
            <returns>The schema type for the given DomainType.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.AddSerializationResourceStrings(System.Collections.Generic.Dictionary{System.String,System.Collections.Generic.KeyValuePair{System.String,System.String}})">
            <summary>
            Add resource strings used by generated serializers. The string added here are not localized, because they're used 
            to generate resx file, which will be localized.
            </summary>
            <param name="resourcedStrings">Storage for added strings.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GenerateFontStyle(System.Drawing.FontStyle)">
            <summary>
            Create the correct syntax for initializing a font's style.
            </summary>
            <param name="fontSettings"></param>
            <returns></returns>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.CodeGenerationUtilities.GetOrder`1">
            <summary>
            Delegate used by SortList&lt;T&gt; method to get the order of an element.
            </summary>
            <param name="instance"></param>
            <returns></returns>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassInheritanceComparer">
            <summary>
            Class to order domain classes by their inheritance tree, so leaf classes come first.
            </summary>
            <remarks>
            Do not use this class with a SortedList or SortedDictionary class as the fact that it returns 0 for unrelated classes
            means that keys will no longer be based on object identity.
            </remarks>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassInheritanceComparer`1">
            <summary>
            Class to order domain classes by their inheritance tree, so leaf classes come first.
            </summary>
            <remarks>
            Do not use this class with a SortedList or SortedDictionary class as the fact that it returns 0 for unrelated classes
            means that keys will no longer be based on object identity.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassInheritanceComparer`1.Compare(System.Object,System.Object)">
            <summary>
            Compare two Domain Classes
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassInheritanceComparer`1.Compare(`0,`0)">
            <summary>
            Compare two domain classes
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DomainClassInheritanceComparer`1.GetInheritanceDepth(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get the inheritance depth of a DomainClass.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.UniqueSerializerNameGenerator">
            <summary>
            Used to generate unique serializer names based on DomainClass name.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.UniqueSerializerNameGenerator.nameMapping">
            <summary>
            Maps DomainClass to its serializer name.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.UniqueSerializerNameGenerator.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.DslLibrary)">
            <summary>
            Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.UniqueSerializerNameGenerator.#ctor(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass})">
            <summary>
            Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.UniqueSerializerNameGenerator.GetSerializerName(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get a unique serializer name for the given DomainClass.
            </summary>
            <param name="domainClass">DomainClass to get unique serializer name for.</param>
            <returns>Unique serializer name for the given DomainClass.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.UniqueSerializerNameGenerator.GetGenerationSerializerName(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Get name of the class that contains the actual generated implementation of serializer for the given DomainClass.
            </summary>
            <param name="domainClass">DomainClass to get unique serializer name for.</param>
            <returns>Unique serializer name for the given DomainClass.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.UniqueSerializerNameGenerator.BuildNameMapping(System.Collections.Generic.IList{Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass})">
            <summary>
            Build the mapping from DomainClass to unique serializer name.
            </summary>
            <param name="domainClasses">List of DomainClasses defined in the same DslLibrary, which may contain name conflicts.</param>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.UniqueSerializerNameGenerator.DomainClassNamespaceComparer">
            <summary>
            Utility class used to sort DomainClasses by namespace.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.UniqueSerializerNameGenerator.DomainClassNamespaceComparer.#ctor">
            <summary>
            Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.UniqueSerializerNameGenerator.DomainClassNamespaceComparer.Compare(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Compare two DomainClasses based on namespace.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ConnectionBuilderHelper">
            <summary>
            Common ConnectionBuilder code
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.MergeDiagramElementMapEventArgs">
            <summary>
            Simple class to gather DiagramElementMap required merge data.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.MergeDiagramElementMapEventArgs.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.DiagramElementMap)">
            <summary>
            Constructor
            </summary>
            <param name="map"></param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.MergeDiagramElementMapEventArgs.Map">
            <summary>
            The map that is about to be merged
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.MergeDiagramElementMapEventArgs.ModelElement">
            <summary>
            The class that will play the source in this map
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.MergeDiagramElementMapEventArgs.DiagramElement">
            <summary>
            The element that will play the target in this map
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.GeneratedDomainModelTypes">
            <summary>
            A class that contains the types of generated rules as static variables.
            This class will be reflected on to get the rule types for loading
            the domain model.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.MergeDomainRelationshipEventArgs">
            <summary>
            Simple class to gather DomainRelationship required merge data.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.MergeDomainRelationshipEventArgs.#ctor(Microsoft.VisualStudio.Modeling.DslDefinition.DomainRelationship)">
            <summary>
            Constructor
            </summary>
            <param name="relationship"></param>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.MergeDomainRelationshipEventArgs.Relationship">
            <summary>
            The Domain Relationship that is about to be merged
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.MergeDomainRelationshipEventArgs.SourceRolePlayer">
            <summary>
            The class that will play the source in this relationship
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.MergeDomainRelationshipEventArgs.TargetRolePlayer">
            <summary>
            The class that will play the target in this relationship
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.MergeDomainRelationshipEventArgs.IsEmbedding">
            <summary>
            Is the relationship embedding or reference
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ModelingPathException">
            <summary>
            Exception for errors when dealing with Paths in models
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ModelingPathException.#ctor">
            <summary>
            Construct an exception for errors when dealing with Paths in models
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ModelingPathException.#ctor(System.String)">
            <summary>
            Construct an exception for errors when dealing with Paths in models
            </summary>
            <param name="message"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ModelingPathException.#ctor(System.String,System.Exception)">
            <summary>
            Construct an exception for errors when dealing with Paths in models
            </summary>
            <param name="message"></param>
            <param name="inner"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ModelingPathException.#ctor(System.Runtime.Serialization.SerializationInfo,System.Runtime.Serialization.StreamingContext)">
            <summary>
            Construct an exception for errors when dealing with Paths in models
            </summary>
            <param name="info"></param>
            <param name="context"></param>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.PathHasSegmentsDeleteRule">
            <summary>
            Rule to delete path if the last segment is deleted
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PluralizationHelper.GetPlural(System.String,System.String@)">
            <summary>
            Get the plural of the given root word
            </summary>
            <param name="root"></param>
            <param name="plural"></param>
            <returns>Whether the pluralization succeeded</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PluralizationHelper.PluralizationImplementation.#ctor">
            <summary>
            Constructor
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.PluralizationHelper.PluralizationImplementation.GetPlural(System.String,System.String@)">
            <summary>
            Get the plural of the given root word
            </summary>
            <param name="root"></param>
            <param name="plural"></param>
            <returns>Whether the pluralization succeeded</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.PluralizationHelper.PluralizationImplementation.CSharpProvider">
            <summary>
            Returns the CodeDomProvider class for validation.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.ReferenceTypeAddedSerializationFixupRule">
            <summary>
            Rule to update XmlClassData when a new domainclass is added
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipAddedSerializationFixupRule">
            <summary>
            Rule to update XmlRelationshipData when a new relationship is added
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.PropertyAddedSerializationFixupRule">
            <summary>
            Rule to update XmlPropertyData when a DomainProperty is added
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.SerializationStrings">
            <summary>
              A strongly-typed resource class, for looking up localized strings, etc.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SerializationStrings.ResourceManager">
            <summary>
              Returns the cached ResourceManager instance used by this class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SerializationStrings.Culture">
            <summary>
              Overrides the current thread's CurrentUICulture property for all
              resource lookups using this strongly typed resource class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SerializationStrings.MajorVersionMismatch">
            <summary>
              Looks up a localized string similar to Unsupported MajorVersion {0}, can only support {1}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.SerializationStrings.MinorVersionMismatch">
            <summary>
              Looks up a localized string similar to Unsupported MinorVersion {0}, can only support {1}..
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.TrackingHelper">
            <summary>
            Helper class for tracking calculations
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.TrackingHelper.pascalFindRegex">
            <summary>
            Finds the transition for a lower case to upper case character in a Pascal or camel string
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TrackingHelper.UpdateTrackingProperty(Microsoft.VisualStudio.Modeling.ModelElement,System.Guid)">
            <summary>
            Notify the given property on the given element as having changed
            </summary>
            <param name="element"></param>
            <param name="propertyId"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.TrackingHelper.UpdateTrackingCollectionProperty(Microsoft.VisualStudio.Modeling.Store,System.Collections.IEnumerable,System.Guid,System.Guid)">
            <summary>
            Notify the given property on the elements in a given collection if the given tracking property is true.
            </summary>
            <param name="store"></param>
            <param name="collection"></param>
            <param name="propertyId"></param>
            <param name="trackingPropertyId"></param>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.TrackingStrings">
            <summary>
              A strongly-typed resource class, for looking up localized strings, etc.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.TrackingStrings.ResourceManager">
            <summary>
              Returns the cached ResourceManager instance used by this class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.TrackingStrings.Culture">
            <summary>
              Overrides the current thread's CurrentUICulture property for all
              resource lookups using this strongly typed resource class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.TrackingStrings.EmbeddingRelationshipName">
            <summary>
              Looks up a localized string similar to {0}Has{1}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.TrackingStrings.ExplorerBehaviorName">
            <summary>
              Looks up a localized string similar to {0}ExplorerBehavior.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.TrackingStrings.MonikerName">
            <summary>
              Looks up a localized string similar to {0}Moniker.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.TrackingStrings.NamedConnectionBuilder">
            <summary>
              Looks up a localized string similar to {0}Builder.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.TrackingStrings.NumberedConnectionBuilder">
            <summary>
              Looks up a localized string similar to Builder{0}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.TrackingStrings.OnePartDescription">
            <summary>
              Looks up a localized string similar to Description for {0}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.TrackingStrings.ReferenceRelationshipName">
            <summary>
              Looks up a localized string similar to {0}References{1}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.TrackingStrings.ReflexiveSourceName">
            <summary>
              Looks up a localized string similar to Source{0}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.TrackingStrings.ReflexiveTargetName">
            <summary>
              Looks up a localized string similar to Target{0}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.TrackingStrings.SerializationBehaviorName">
            <summary>
              Looks up a localized string similar to {0}SerializationBehavior.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.TrackingStrings.TwoPartDescription">
            <summary>
              Looks up a localized string similar to Description for {0}.{1}.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapCache">
            <summary>
            A cache of the shapes that are mapped to each domain class.
            Intended to be kept in the validation property bag.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapCache.rawMappings">
            <summary>
            Quick lookup for the explicit ShapeMaps.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapCache.mapsWithSubclasses">
            <summary>
            List of all the mappings that could be applied to members
            of this DomainClass, including subclasses.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapCache.SetRawMappings(Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Create quick lookup table of all the ShapeMaps defined in this diagram.
            </summary>
            <param name="mappingDiagram"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapCache.PossibleMaps(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            Get the ShapeMaps applicable to a DomainClass in this diagram.
            The list includes all the ShapeMaps that could be applied to 
            an instance of this class, including those from all subclasses.
            </summary>
            <param name="domainClass"></param>
            <param name="mappingDiagram"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapCache.ApplicableMaps(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.Diagram)">
            <summary>
            The ShapeMaps applicable to this domain class: 
            directly defined or if not defined, the first inherited set.
            </summary>
            <param name="domainClass"></param>
            <param name="mappingDiagram"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapCache.GetMapInfo(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            The ShapeMaps applicable to this domain class: 
            directly defined or if not defined, the first inherited set.
            </summary>
            <param name="domainClass"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapCache.GetAllSubMaps(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapCache.ShapeMapInfo,System.Collections.Generic.List{Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapCache.ShapeMapInfo})">
            <summary>
            ShapeMaps that might apply to any member of this class, including subclasses.
            </summary>
            <param name="domainClass">Class to get applicable shapemaps of</param>
            <param name="superClass">an ancestor class or null - stop if we get back to this</param>
            <param name="parentInfo">Doesn't add info if it's the same as this. Can be null.</param>
            <param name="allMaps">List to add info of this and subclasses to.</param>
            <returns></returns>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ShapeMapCache.ShapeMapInfo">
            <summary>
            Cache information about the shape maps we have found.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings">
            <summary>
              A strongly-typed resource class, for looking up localized strings, etc.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.ResourceManager">
            <summary>
              Returns the cached ResourceManager instance used by this class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.Culture">
            <summary>
              Overrides the current thread's CurrentUICulture property for all
              resource lookups using this strongly typed resource class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E0000GeneralError">
            <summary>
              Looks up a localized string similar to Error {0}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E2020ElementToolCreatingRoot">
            <summary>
              Looks up a localized string similar to ElementTool {0} should not create the editor&apos;s root class {1}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E2030ElementToolWrongType">
            <summary>
              Looks up a localized string similar to ElementTool {0} should create a proper DomainClass, but {1} is a {2}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E2050DuplicateToolName">
            <summary>
              Looks up a localized string similar to ToolboxTab {0} has two Tools with the same name {1}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E2051EmptyToolName">
            <summary>
              Looks up a localized string similar to ToolboxTab {0} has a Tool with a blank name..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E2060ToolboxIconInvalid">
            <summary>
              Looks up a localized string similar to Tool {0} has an invalid icon &quot;{1}&quot;. This property should be the file path of a bitmap (bmp) file..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E2061ToolboxIconFileNotFound">
            <summary>
              Looks up a localized string similar to Tool {0} icon file &quot;{1}&quot; not found..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E2070ToolboxHelpKeywordFormat">
            <summary>
              Looks up a localized string similar to Tool {0} has an invalid Help keyword &quot;{1}&quot;. .
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E2080ToolboxCaptionEmpty">
            <summary>
              Looks up a localized string similar to Tool {0} has an empty caption..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E2090SourceCursorIconInvalid">
            <summary>
              Looks up a localized string similar to Connection Tool {0} has an invalid source icon &quot;{1}&quot;. This property should either be empty, or the file path of a bitmap (bmp) file. .
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E2091SourceCursorIconFileNotFound">
            <summary>
              Looks up a localized string similar to Connection Tool {0} source icon file &quot;{1}&quot; not found. .
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E2100TargetCursorIconInvalid">
            <summary>
              Looks up a localized string similar to Connection Tool {0} has an invalid target icon &quot;{1}&quot;. This property should either be empty, or the file path of a bitmap (bmp) file..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E2101TargetCursorIconFileNotFound">
            <summary>
              Looks up a localized string similar to Connection Tool {0} target icon file &quot;{1}&quot; not found..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E2110DuplicateToolboxTabText">
            <summary>
              Looks up a localized string similar to Editor for DSL {0} has two ToolboxTabs with the same tab text: &quot;{1}&quot;..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E2111EmptyToolboxTabText">
            <summary>
              Looks up a localized string similar to Editor for DSL {0} has a ToolboxTab with an empty TabText..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E2120EditorIconInvalid">
            <summary>
              Looks up a localized string similar to Editor for DSL {0} has an invalid Icon file path &quot;{1}&quot;..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E2121EditorIconFileNotFound">
            <summary>
              Looks up a localized string similar to Icon file &quot;{1}&quot; not found for editor for DSL {0}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E2130EditorFileExtension">
            <summary>
              Looks up a localized string similar to Invalid file extension &quot;{1}&quot; defined in editor for DSL {0}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E2152DslEditorRootClassWrongType">
            <summary>
              Looks up a localized string similar to Editor root class {0} should be a proper DomainClass, but it is a {1}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E2155DslEditorRootClassUndefined">
            <summary>
              Looks up a localized string similar to Editor has no RootClass..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E2180InvalidXmlSerializationNamespace">
            <summary>
              Looks up a localized string similar to XmlSerializationDefinition for Dsl {0} has an invalid XML namespace &quot;{1}&quot;. It should be a valid URI, or blank..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E2200EditorEmptyGuid">
            <summary>
              Looks up a localized string similar to Editor Guid is invalid or empty..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E2210ExplorerEmptyGuid">
            <summary>
              Looks up a localized string similar to Explorer guid invalid or empty..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E2215ExplorerInvalidName">
            <summary>
              Looks up a localized string similar to Invalid Explorer name..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3000InternalClassName">
            <summary>
              Looks up a localized string similar to The class name {0} is reserved for generated code..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3001InternalXmlName">
            <summary>
              Looks up a localized string similar to The XML Element name {0} and Element Moniker name {0}Moniker are reserved, as they are used internally..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3005InvalidDisplayName">
            <summary>
              Looks up a localized string similar to DisplayName and Name for {0} {1} must not be empty.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3010DslLibraryNameNotUnique">
            <summary>
              Looks up a localized string similar to The full name of DslLibrary {0} is the same as that of one of its children..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3040DslLibraryClassMemberWrongType">
            <summary>
              Looks up a localized string similar to Each member of a DSL Library&apos;s classes list should be a proper DomainClass, but {1} in {0} is a {2}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3041InvalidNamespace">
            <summary>
              Looks up a localized string similar to {2}  {1}  has an invalid namespace &quot;{0}&quot;..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3042InvalidIdentifier">
            <summary>
              Looks up a localized string similar to The name of the {1} &quot;{0}&quot; in {2} is invalid..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3043InvalidIdentifierNoContext">
            <summary>
              Looks up a localized string similar to The name of the {1} &quot;{0}&quot; is invalid..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3045DslLibraryVersionOutOfRange">
            <summary>
              Looks up a localized string similar to Version, revision and build numbers of a DSL or DSL Library must all be zero or positive..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3050DomainEnumerationNameNotUnique">
            <summary>
              Looks up a localized string similar to The full name of DomainEnumeration {0} is the same as that of one of its siblings..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3060EnumerationLiteralNameNotUnique">
            <summary>
              Looks up a localized string similar to The DomainEnumeration {0} has duplicate literals &quot;{1}&quot;..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3061EnumerationValueNotNullOrInteger">
            <summary>
              Looks up a localized string similar to DomainEnumeration {0} literal {1}: invalid value &quot;{2}&quot; must either be empty or an integer..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3070NameNotUniqueSameType">
            <summary>
              Looks up a localized string similar to {0} has the same name as another {1}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3071NameNotUniqueDifferentType">
            <summary>
              Looks up a localized string similar to {1} {0} has the same name as a {2}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3080DomainClassHasCircularInheritance">
            <summary>
              Looks up a localized string similar to The {1} {0} has circular inheritance among its ancestors..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3090BaseDomainClassIsSealed">
            <summary>
              Looks up a localized string similar to The domain class {0} cannot inherit from the sealed base class {1}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3100DuplicateDoubleDerivedClassDefined">
            <summary>
              Looks up a localized string similar to {1} {0} has the same name as another element of the language. The {3} {2} has GenerateDoubleDerived set, and will generate a base class with the same name..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3110DslEditorRootClassCannotBeAbstract">
            <summary>
              Looks up a localized string similar to The root class {0} of the Editor cannot be abstract..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3120ClassReferredByElementToolCannotBeAbstract">
            <summary>
              Looks up a localized string similar to The DomainClass {0} to which ElementTool {1} refers cannot be abstract..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3131OrphanDomainClass">
            <summary>
              Looks up a localized string similar to DomainClass {0} is created by an ElementTool, but is not transitively embedded under a root of the model..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3140OnlyOneDomainPropertyIsMonikerKeyAllowed">
            <summary>
              Looks up a localized string similar to Both DomainProperties {1} in DomainClass {0} and {3} in DomainClass {2} have IsMonikerKey set to true. At most one is allowed through the inheritance chain..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3160BaseDomainClassAccessibility">
            <summary>
              Looks up a localized string similar to {2} {0} is more accessible than its base {1}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3170DomainPropertyNameNotUnique">
            <summary>
              Looks up a localized string similar to {0} has the same name as {1}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3171DomainPropertyNameNotAllowed">
            <summary>
              Looks up a localized string similar to In {0}, &quot;{1}&quot; may not be used as the name of a property, because that name is automatically defined in every {2}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3180DomainPropertyNameClashWithClass">
            <summary>
              Looks up a localized string similar to {0} must not be named the same as its class, nor the same with suffix &quot;Base&quot;..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3181DomainRoleNameClashWithInternal">
            <summary>
              Looks up a localized string similar to In {0}, &quot;{1}&quot; may not be used as the name of a role, because that name is automatically defined in every DomainRelationship..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3182RolePropertyNameClashWithInternal">
            <summary>
              Looks up a localized string similar to In relationship {0}, &quot;{1}&quot; may not be used as a Property Name for the role player {3}, because that name is automatically defined for every {2}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3185RolePropertyPrivateNoDerivation">
            <summary>
              Looks up a localized string similar to A property generated from a role cannot be overridden if its Getter or Setter access modifier is set to Private. {0} has the same name as {1} but one of them has a private Getter or Setter..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3190InvalidDefaultValue">
            <summary>
              Looks up a localized string similar to The defined default value &quot;{2}&quot; for DomainProperty {0}.{1} is invalid for its type..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3191DomainPropertyUnrecognizedExternalType">
            <summary>
              Looks up a localized string similar to DomainProperty {0}.{1} has an unrecognized external type {2}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3192DefaultValueNotUsingInvariantCulture">
            <summary>
              Looks up a localized string similar to The defined default value &quot;{2}&quot; for DomainProperty {0}.{1} is invalid for its type under InvariantCulture..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3210MonikerQualifierPropertyShouldBeStringType">
            <summary>
              Looks up a localized string similar to DomainProperty {0} should be of type System.String if its IsMonikerQualifier property is set to true..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3220MonikerKeyPropertyShouldBeStringType">
            <summary>
              Looks up a localized string similar to If the value of the IsMonikerKey property is set to true for the DomainProperty {0} then the DomainProperty {0} should be of type System.String..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3230OnlyOneDomainPropertyElementNameTrueAllowed">
            <summary>
              Looks up a localized string similar to Both {0} and {1} DomainProperties have IsElementName set to true in class {2}. You can set this value to true for no more than one DomainProperty..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3240ElementNameProviderIsNotAllowed">
            <summary>
              Looks up a localized string similar to The IsElementName property is not set to true for the DomainProperty {0}. It cannot have an ElementNameProvider property attached to it..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3241NamePropertyWrongType">
            <summary>
              Looks up a localized string similar to Domain Property {0} is marked IsName, but has type {1}. Unless it has an ElementNameProvider, the type of a Name property should be System.String..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3250PropertyTypeAccessibility">
            <summary>
              Looks up a localized string similar to DomainProperty {0} is more accessible than its Type {1}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3260MonikersInaccessible">
            <summary>
              Looks up a localized string similar to Property {1}.{0} is a Moniker Key or Moniker Qualifier in its XML Property Data, and so both setter and getter access modifiers must not be &quot;private&quot; or &quot;assembly&quot; (internal).  .
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3280TypeDefinedInOtherModel">
            <summary>
              Looks up a localized string similar to DomainProperty {0} has a type {1} which is defined in an unrelated DSL..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3285InvalidPropertyType">
            <summary>
              Looks up a localized string similar to Invalid type for property &quot;{0}&quot; in class {1}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3300DomainRoleNameNotUnique">
            <summary>
              Looks up a localized string similar to The DomainRole name {1} in relationship {0} is also a property or role name in {2} {3}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3310AllowDupInconsistentWithEmbeddingAndMultiplicity">
            <summary>
              Looks up a localized string similar to The DomainRelationship {0} has an invalid combination of settings. If the AllowDuplicate property is set to true, the IsEmbedding property should be set to false, and the role&apos;s multiplicity should be set to 1..* or 0..*..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3320MismatchingAllowDupFromBaseRelationship">
            <summary>
              Looks up a localized string similar to The AllowDuplicates property does not match the DomainRelationship {0} and its base relationship {1}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3331MismatchBaseClassAndBaseRelationship">
            <summary>
              Looks up a localized string similar to Define a BaseRelationship (rather than a BaseClass) for DomainRelationship {0}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3340MismatchBaseClassLink">
            <summary>
              Looks up a localized string similar to ReferenceType {0} is connected to its base class by the wrong type of link. Use a tag that matches the derived type of the ReferenceType..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3350TargetRolePlayerMustBeProperDomainClassInEmbeddingRelationship">
            <summary>
              Looks up a localized string similar to The Embedding Relationship {0} has target {1}. The target role player of an embedding must be a DomainClass and not a {2}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3360MismatchingIsEmbeddingFromBaseRelationship">
            <summary>
              Looks up a localized string similar to The IsEmbedding property of the derived DomainRelationship {0} should be set true, to conform to that of its Base Relationship {1}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3370BaseRelationMustBeAbstractWhenIsEmbeddingMismatchFromBase">
            <summary>
              Looks up a localized string similar to The base DomainRelationship {0} must be abstract if its IsEmbedding property does not match that of the derived embedding DomainRelationship {1}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3390AbstractRelationshipCannotBeReferredByLinkConnectDirective">
            <summary>
              Looks up a localized string similar to The abstract DomainRelationship {0} cannot be referred to by LinkConnectDirective(s)..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3400SubclassesAreDomainRelationships">
            <summary>
              Looks up a localized string similar to Every subclass of a DomainRelationship must be a DomainRelationship, but {0} has a subclass {1} which is a {2}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3410IncompatibleDomainRoleAccessModifier">
            <summary>
              Looks up a localized string similar to The PropertyGetterAccessModifier or PropertySetterAccessModifier property of the DomainRole {0} is incompatible with the access modifier for the DomainRelationship {1}. If the access modifier for the DomainRelationship is set to Assembly (internal), the PropertyGetterAccessModifier and PropertySetterAccessModifier properties must be set to Assembly or Private..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3420BaseRelationshipRolePlayerIncompatible">
            <summary>
              Looks up a localized string similar to Relationship {0} has base {1} but  class {3}  playing role {2} is not assignable to class {5} playing role {4} of the base relationship..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3430RolePlayerAndDomainRelationshipDifferentModel">
            <summary>
              Looks up a localized string similar to The role player {0} for the DomainRole {1} and DomainRelationship {1} properties should be in the same model when the value of the IsPropertyGenerator property is set to true..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3440DomainRolePropertyNameInvalid">
            <summary>
              Looks up a localized string similar to Missing or invalid Property name &quot;{2}&quot; in DomainRole {0}.{1}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3445DomainRolePlayerInvalid">
            <summary>
              Looks up a localized string similar to DomainRole {0}.{1} missing or invalid RolePlayer..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3450RoleCollectionTypeIncompatibleWithMultiplicity">
            <summary>
              Looks up a localized string similar to The collection type of the DomainRole {0}.{1} is incompatible with its role multiplicity. For the multiplicity of this collection type, you can specify only 0..* or 1..*..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3460InconsistentEmbeddedRoleMultiplicityAmongDescendents">
            <summary>
              Looks up a localized string similar to The DomainClass {0} and its base classes are the target role players for more than one relationship with IsEmbedded set true.   DomainRoles {1}.{2} and {3}.{4} both should have multiplicity 0..1..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3465TargetMultiplicityMaxOne">
            <summary>
              Looks up a localized string similar to Embedding relationship {0} role with property name {1} must have a multiplicity of 0..1 or 1..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3480DerivedRelationshipLowerBoundZero">
            <summary>
              Looks up a localized string similar to The lower bound on the derived DomainRole {0}.{1} is 1, which prevents the other derived DomainRole {2}.{3} from being instantiated. You should consider changing the lower bound to Zero..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3510DerivedRelationshipUpperBoundMustBeOne">
            <summary>
              Looks up a localized string similar to The upper bound of the multiplicity for the parent DomainRole {0}.{1} is 1. The upper bound of the child DomainRole {2}.{3} must be 1..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3570ReferenceTargetRequiresMonikerOrSerialize">
            <summary>
              Looks up a localized string similar to Class {0} is the target of one or more non-embedding relationships, or is mapped to a shape. In its XML Class Data, you must either set SerializeId=&quot;true&quot;, IsCustom=&quot;true&quot;, or IsMonikerKey=&quot;true&quot; for a Domain Property, on this class or a base class..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E3575AllowsDuplicateRequiresMonikerOrSerialize">
            <summary>
              Looks up a localized string similar to Relationship {0} is the target of one or more non-embedding relationships, or has AllowsDuplicate=&quot;true&quot; and is mapped to a connector. In its XML Class Data, you must either set SerializeId=&quot;true&quot;, IsCustom=&quot;true&quot;, or IsMonikerKey=&quot;true&quot; for a Domain Property, on this relationship or a base relationship..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E4000PathMustHaveSegments">
            <summary>
              Looks up a localized string similar to Empty path in {0}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E4005InvalidRole">
            <summary>
              Looks up a localized string similar to {0}: segment {1} has an unrecognized relationship namespace and name, or an invalid role for the relationship.  A role segment (&quot;!&quot;) must have a role name; a link segment (&quot;.&quot;) must have a property name..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E4010PathSegmentDislocation">
            <summary>
              Looks up a localized string similar to {0}: segment {1} is not a valid path from {2}, which can not be assigned or cast to a {3}. .
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E4015PathInitialDislocation">
            <summary>
              Looks up a localized string similar to {0}: segment {1} is not a valid path from {2}, which is not assignable to a {3}. .
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E4020PathElementSegmentDislocation">
            <summary>
              Looks up a localized string similar to {0}: role segment {1} is invalid from {2}, which is not a relationship..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E4030OnlyLastLinksMultiple">
            <summary>
              Looks up a localized string similar to {0}: only the last Links segment in a Path may have a role with multiplicity Many..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E4040PathEndDislocation">
            <summary>
              Looks up a localized string similar to {0}: final segment class {1} is not assignable to the path destination class {2}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E4100PropertyNotInContainer">
            <summary>
              Looks up a localized string similar to {0}: Property {1} does not belong to expected owner {2}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E4110NoPropertyInPropertyPath">
            <summary>
              Looks up a localized string similar to No property defined in {0}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E4120CannotParseDomainPath">
            <summary>
              Looks up a localized string similar to DomainPath cannot be parsed. Check that the names of all domain classes and relationships referred to in the domain path are valid..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E5000ElementMergeMissingIndex">
            <summary>
              Looks up a localized string similar to Invalid or missing Index class in Element Merge Directive in {0}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E5010DuplicateElementMergeDirectives">
            <summary>
              Looks up a localized string similar to Class {0} has more than one Element Merge Directive with the same Index class {1}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E5030ElementMergeHasForwardingAndLinkCreation">
            <summary>
              Looks up a localized string similar to Element Merge Directive in class {0} for index {1} has both a ForwardingPath and a LinkCreationPath..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E5031ElementMergeHasForwardingAndCustom">
            <summary>
              Looks up a localized string similar to Element Merge Directive in class {0} for index {1} both has a ForwardingPath, and UsesCustomAccept or UsesCustomMerge are set..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E5040ElementMergeHasCollectionForwardingPath">
            <summary>
              Looks up a localized string similar to Element Merge Directive in class {0} for index {1} has a ForwardingPath that refers to a collection..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E5050LinkCreationPathTarget">
            <summary>
              Looks up a localized string similar to In Element Merge Directive in class {0} for index class {1}, the index class is not assignable to the target role {3} of the final segment of LinkPath {2}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E5060LinkCreationPathMustBeLinks">
            <summary>
              Looks up a localized string similar to In Element Merge Directive in class {0} for index {1}, LinkPath {2} should end in a link segment (&quot;.&quot;)..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E5070LinkCreationPathMustNotBeAbstract">
            <summary>
              Looks up a localized string similar to In Element Merge Directive in class {0} for index {1}, in link creation path {2} the relationship {3} is abstract. The final segment of a link creation path must not use an abstract relationship..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E5080OneLinkCreationPathIsEmbedding">
            <summary>
              Looks up a localized string similar to Exactly one of the LinkCreationPaths in Element Merge Directive in class {0} for {1} should refer to an Embedding relationship. .
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E5090RolePlayerConnectDirectivePathCollection">
            <summary>
              Looks up a localized string similar to RolePlayerConnectDirective for class {0} in ConnectionBuilder {1} must have a non-collection Path..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E5110DuplicateConnectionBuilderNames">
            <summary>
              Looks up a localized string similar to Duplicate ConnectionBuilder names &quot;{0}&quot; .
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E5111ConnectionBuilderEmptyName">
            <summary>
              Looks up a localized string similar to Empty ConnectionBuilder name..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E5130LinkDirectiveCustomOrRelationship">
            <summary>
              Looks up a localized string similar to LinkConnectDirective in ConnectionBuilder {0} has no DomainRelationship and is not UsesCustomConnect..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E5150LinkConnectorTargetTypeIncompatible">
            <summary>
              Looks up a localized string similar to LinkConnectDirective in ConnectionBuilder {0} for DomainRelationship {1} has a {4} accepting {3}, which is not assignable to the role player {2}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E6010RootCannotBeSerialized">
            <summary>
              Looks up a localized string similar to In the XML Class Data of the Editor&apos;s Root Class {0}, you must either set SerializeId true, or set IsMonikerKey true for one of its properties; otherwise the model cannot be saved..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E6040XmlClassDataDuplicateTypeName">
            <summary>
              Looks up a localized string similar to TypeName {0} in XML Class Data for class {1} is the same as another TypeName, or the name of a class without an explicit TypeName..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E6041XmlClassDataInvalidTypeName">
            <summary>
              Looks up a localized string similar to Invalid TypeName &quot;{0}&quot; in XML Class Data for {1}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E6060XmlClassDataDuplicateElementName">
            <summary>
              Looks up a localized string similar to Element Name {0} in XML Class Data for class {1} is the same as another Element Name, or the name of a class without an explicit Element Name..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E6061XmlClassDataInvalidElementName">
            <summary>
              Looks up a localized string similar to Invalid ElementName &quot;{0}&quot; in XML Class Data for {1}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E6062XmlClassDataInvalidClass">
            <summary>
              Looks up a localized string similar to Invalid DomainClass moniker in XML Class Data {0}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E6065XmlElementNameSameAsMoniker">
            <summary>
              Looks up a localized string similar to XML MonikerElementName {0} for class {1} must be different from the  ElementName..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E6067XmlInvalidMonikerAttributeName">
            <summary>
              Looks up a localized string similar to Moniker Attribute name &apos;{1}&apos; in class {0} is not a valid XML name..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E6068XmlInvalidMonikerElementName">
            <summary>
              Looks up a localized string similar to Moniker Element name &apos;{1}&apos; in class {0} is not a valid XML name..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E6070XmlPropertyMoniker">
            <summary>
              Looks up a localized string similar to MonikerAttribute in XML Class Data {0} refers to property {1}, but that property has IsMonikerKey set to false or its Representation is not set to Attribute..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E6071DuplicateMonikerKey">
            <summary>
              Looks up a localized string similar to IsMonikerKey may be set true in only one XML Property Data in each XML Class Data. Both {1} and {2} in {0} have IsMonikerKey set true..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E6072DuplicateMonikerQualifier">
            <summary>
              Looks up a localized string similar to In XML Class Data {0}, both properties {1} and {2} have  IsMonikerQualifier set true. There may only be one MonikerQualifier in each class..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E6073MonikerAttributeNameEmptyAndSerializeId">
            <summary>
              Looks up a localized string similar to XML Class Data {0} has SerializeId set true, but has no MonikerAttributeName..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E6076MonikerAttributeNameEmptyAndPropertyIsMoniker">
            <summary>
              Looks up a localized string similar to XML Class Data {0} has no MonikerAttributeName, but has XML Property Data {1} with IsMonikerKey set true..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E6085InvalidDomainRelationshipReference">
            <summary>
              Looks up a localized string similar to Invalid DomainRelationship reference in XML Class Data {0} role element {1}: invalid or missing relationship moniker..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E6086IncompatibleDomainRelationshipReference">
            <summary>
              Looks up a localized string similar to Invalid DomainRelationship reference in XML Class Data {0}: relationship {1} with source role player {2} is not compatible with XML Class Data class {3}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E6087InvalidRoleElementName">
            <summary>
              Looks up a localized string similar to Invalid RoleElementName &quot;{1}&quot; in XmlRelationshipData {2} in XML Class Data {0}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E6115PropertiesUseFullForm">
            <summary>
              Looks up a localized string similar to In the XML Class Data for class {1}, the XmlRelationshipData for relationship {0} should include UseFullForm=&quot;true&quot; because the relationship has or inherits properties..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E6117AllowDuplicatesUseFullForm">
            <summary>
              Looks up a localized string similar to In the XML Class Data for class {1}, the XmlRelationshipData for relationship {0} should include UserFullForm=&quot;true&quot; because the relationship has AllowDuplicates=true..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E6125CustomRelationsUseFullForm">
            <summary>
              Looks up a localized string similar to XmlRelationshipData {1} in XML Class Data {0} should set UseFullForm true, because the relationship has IsCustom set true..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E6130XmlPropertyDataInvalidDomainProperty">
            <summary>
              Looks up a localized string similar to Invalid DomainProperty reference in XML Property Data in XML Class Data {0}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E6140DuplicateXmlElementName">
            <summary>
              Looks up a localized string similar to The name &quot;{0}&quot; is the XML property or role name for more than one property or relationship source in XML Class Data for class {1}. Both {1}.{2} and {3}.{4} use this XML name. .
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E6150MonikerMustBeAttributeRepresentation">
            <summary>
              Looks up a localized string similar to XML Property Data {1} in XML Class Data {0} has IsMonikerKey or IsMonikerQualifier set true, and must have Representation set to Attribute..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E7010NegativeWidthHeightThickness">
            <summary>
              Looks up a localized string similar to {0} may not have negative width, height or thickness..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E7080FixedTooltipTextEmpty">
            <summary>
              Looks up a localized string similar to DiagramElement {0} has Fixed TooltipType, but an empty FixedTooltipText..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E7100DuplicateDecoratorName">
            <summary>
              Looks up a localized string similar to DiagramElement {0} has more than one decorator with the same name &quot;{1}&quot;..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E7101EmptyDecoratorName">
            <summary>
              Looks up a localized string similar to DiagramElement {0} has a decorator with an empty name..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E7140ExpandCollapseNotOnShape">
            <summary>
              Looks up a localized string similar to ExpandCollapseDecorator on {0} should be attached only to a Shape..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E7150IconDecoratorImageInvalid">
            <summary>
              Looks up a localized string similar to Invalid icon file &quot;{1}&quot; on IconDecorator in shape {0}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E7151IconDecoratorImageFileNotFound">
            <summary>
              Looks up a localized string similar to Icon file &quot;{1}&quot; for IconDecorator in shape {0}: file not found..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E7160ImageShapeImageInvalid">
            <summary>
              Looks up a localized string similar to Invalid image file {1} on ImageShape {0}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E7161ImageShapeImageFileNotFound">
            <summary>
              Looks up a localized string similar to Image file &quot;{1}&quot; on Image Shape {0}: file not found..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E7170CompartmentNameDuplicate">
            <summary>
              Looks up a localized string similar to CompartmentShape {0} more than one compartment is named &quot;{1}&quot;..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E7171CompartmentNameEmpty">
            <summary>
              Looks up a localized string similar to CompartmentShape {0} has a compartment with an empty name..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E7180CompartmentFontSizeOutOfRange">
            <summary>
              Looks up a localized string similar to CompartmentShape {0} compartment {1} - font or title size out of range..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E7200ElementMergeInvalidOnShape">
            <summary>
              Looks up a localized string similar to {0}:Shapes and Connectors may not have Element Merge Directives..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E7210ElementCustomMergeInvalidOnDiagramElement">
            <summary>
              Looks up a localized string similar to {0}: the Element Merge Directive of a Diagram Element may not set UsesCustomMerge to true..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E7220ElementMergeLinkCreationPathsInvalidOnDiagramElement">
            <summary>
              Looks up a localized string similar to {0}: the Element Merge Directive of a Diagram Element may not have a LinkCreationPath..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E8077ShapeMapParentElementPathNull">
            <summary>
              Looks up a localized string similar to The Parent Element Path for Shape Map from {0} to {1} must not be null..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E8080ShapeMapParentElementNotCollection">
            <summary>
              Looks up a localized string similar to The Parent Element Path for Shape Map from {0} to {1}  must not be a collection path..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E8100MappedShapeOccursInUnmappedShapes">
            <summary>
              Looks up a localized string similar to Shape {0} occurs both in the Unmapped Shapes list and in a Shape Map..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E8130MappingDiagramClass">
            <summary>
              Looks up a localized string similar to Shape Map for shape {0} maps to the diagram root class {1}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E8140ShapeMapInvalidForCompartmentShape">
            <summary>
              Looks up a localized string similar to Use a CompartmentShapeMap to map CompartmentShape {0}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E8141ShapeMapInvalidForSwimLane">
            <summary>
              Looks up a localized string similar to Use a SwimLaneMap to map SwimLane {0}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E8142NoShapeNorDiagramMappedToParentElement">
            <summary>
              Looks up a localized string similar to No shape or diagram displays class {0} (or its concrete subclasses) which is referenced as the Parent Element in ShapeMap from {0} to {1}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E8145InvalidParentShapeType">
            <summary>
              Looks up a localized string similar to A {0} may not be parented on a {1}. In the ShapeMap mapping {2} to {3}, the parent element path leads to {4}, whose mapped shape is {5}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E8146InvalidParentSubclassShapeType">
            <summary>
              Looks up a localized string similar to A {0} may not be parented on a {1}. In the ShapeMap mapping {2} to {3}, the parent element path leads to {4}, which has a subclass {6} whose mapped shape is {5}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E8150DuplicateCompartment">
            <summary>
              Looks up a localized string similar to CompartmentShapeMap {0} has more than one map for compartment {1}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E8155MissingCompartmentMap">
            <summary>
              Looks up a localized string similar to CompartmentShapeMap for {0} contains no map for compartment {1}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E8160CompartmentElementsDisplayedCollection">
            <summary>
              Looks up a localized string similar to ElementsDisplayed path must be a collection in Compartment map {1} in CompartmentShapeMap {0}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E8161CompartmentElementsDisplayedInvalid">
            <summary>
              Looks up a localized string similar to Missing or invalid ElementsDisplayed in CompartmentMap {0}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E8191CompartmentMapPropertyDisplayedInvalid">
            <summary>
              Looks up a localized string similar to Missing or invalid PropertyDisplayed in CompartmentMap {0}, and DisplaysCustomString is not set true..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E8201ConnectorMapMissingRelationOrConnector">
            <summary>
              Looks up a localized string similar to A ConnectorMap has a missing Connector or Relationship..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E8210ConnectorMapSourceNotMapped">
            <summary>
              Looks up a localized string similar to Non-abstract source role player {1} of the Relationship mapped to Connector {0} is not mapped to any shape, and ConnectsCustomSource is not set to true..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E8211ConnectorMapTargetNotMapped">
            <summary>
              Looks up a localized string similar to Non-abstract source role player {1} of the Relationship mapped to Connector {0} is not mapped to any shape, and ConnectsCustomSource is not set to true..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E8215ConnectorMapNotAbstract">
            <summary>
              Looks up a localized string similar to Abstract Connector {0} may not have a ConnectorMap..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E8225InvalidDecoratorMapNoVisibilityOrProperty">
            <summary>
              Looks up a localized string similar to Decorator map in {0} for {1} should have a display property or a visibility property or both..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E8230InconsistentSwimlaneAlignment">
            <summary>
              Looks up a localized string similar to In one DSL, all the swim lanes must be aligned in the same direction. In DSL {0}, swim lanes {1} and {2} have their Alignment properties set differently..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E8250DuplicateShapeMap">
            <summary>
              Looks up a localized string similar to Two shape maps map the same shape {0} to the same class {1}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E8260InconsistentConnectorMapCustomization">
            <summary>
              Looks up a localized string similar to ConnectorMaps from both {1} and {2} map to the same connector {0}, and must have the same settings for Custom Source and Custom Target..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E8265DuplicateConnectorMap">
            <summary>
              Looks up a localized string similar to There is more than one Connector Map mapping {0} to {1}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.E9060PropertyPathInTypeDescriptor">
            <summary>
              Looks up a localized string similar to PropertyPath {0} in Custom Type Descriptor for {1} is invalid..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.N0101XmlDefinitionNoBehavior">
            <summary>
              Looks up a localized string similar to XmlSerializationBehavior is not referenced by any XmlDefinition..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.N0110EditorNoValidation">
            <summary>
              Looks up a localized string similar to Editor has no Validation settings..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.N0120DslNoDiagram">
            <summary>
              Looks up a localized string similar to DSL {0} has no Diagram specified for its Designer..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.N2140EditorDslMustEqualRootLibrary">
            <summary>
              Looks up a localized string similar to DslLibrary of the root class, {0}, is not the same as Dsl of this Editor, {1}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.N2150XmlSerializationInconsistent">
            <summary>
              Looks up a localized string similar to The XmlSerializationDefinition.Behavior ({0}) of this Editor is not the same as the Dsl&apos;s XmlSerializationBehavior ({1}).
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.N2220ExplorerHasNoBehavior">
            <summary>
              Looks up a localized string similar to DSL has no Explorer or Explorer has no ExplorerBehavior..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.N3435InvalidRole">
            <summary>
              Looks up a localized string similar to Missing source or target role on relationship {0}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.N3461RootIsEmbeddedTarget">
            <summary>
              Looks up a localized string similar to {0} is a Diagram or the root of an editor, but also is the target of embedding {1}.{2}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.N3640EmptyGuid">
            <summary>
              Looks up a localized string similar to Id for {0} {1} is the empty Guid..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.N7050IncompatibleBase">
            <summary>
              Looks up a localized string similar to {2} {0} may not have a {1} as a base..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.N8075ShapeMapInvalidShapeOrClass">
            <summary>
              Looks up a localized string similar to Missing or invalid class or shape moniker in Shape Map for {0}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.N8180InvalidCompartment">
            <summary>
              Looks up a localized string similar to Compartment map {0} has a missing compartment moniker, or the compartment does not belong to the shape being mapped..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.N8220InvalidDecoratorMapDecoratorReference">
            <summary>
              Looks up a localized string similar to DecoratorMap in {0} for {1} has an invalid Decorator reference..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.W2160EditorRootClassUnequalDiagramClass">
            <summary>
              Looks up a localized string similar to The Editor&apos;s Root Class {0} is not the same as the Diagram&apos;s Root Class {1}. This may give rise to unexpected effects..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.W3062EnumerationFlagsShouldHaveValues">
            <summary>
              Looks up a localized string similar to The Enumeration {0} has IsFlags set, but not every literal has an assigned value. Flags literals should have power-of-two values to be able to compose correctly..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.W3130OrphanDomainClass">
            <summary>
              Looks up a localized string similar to DomainClass {0} is not abstract, and is neither a root of the model nor embedded within it..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.W3200InvalidDefaultDomainValue">
            <summary>
              Looks up a localized string similar to The default domain value &quot;{2}&quot; has been incorrectly defined for the DomainProperty {0}.{1}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.W3380AbstractDomainRelationWithMultiplicityOneMustHaveChild">
            <summary>
              Looks up a localized string similar to The abstract DomainRelationship {0} with a minimum multiplicity of 1 must have at least one concrete derived relationship..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.W3470DerivedDomainRelationshipMustBeInstantiated">
            <summary>
              Looks up a localized string similar to The role multiplicity of the abstract base DomainRelationship {0} is 1 or 1..*. The role multiplicity of the sole derived DomainRelationship {1} is 0..1 or 0..*. The child relationship must be instantiated..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.W3490DerivedRelationshipCannotBeInstantiated">
            <summary>
              Looks up a localized string similar to The DomainRelationship(s) {0} cannot be instantiated because the DomainRelationship {2} will always instantiate the base DomainRelationship {1}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.W3500BaseRelationshipMissingAbstract">
            <summary>
              Looks up a localized string similar to The DomainRelationship {0} cannot be instantiated because the base relationship {1} is not abstract..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.W3505BaseRoleNotSameNamedOrAbstract">
            <summary>
              Looks up a localized string similar to The derived DomainRole {0}.{1} property name, {2}, differs from the property name, {5}, of its base role {3}.{4}, but the base relationship is not abstract. This pattern has been deprecated and will not be supported in a future release..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.W3506AmbiguousDerivedRoleOfConcreteBase">
            <summary>
              Looks up a localized string similar to The DomainRole {0}.{1} is part of a derived relationship with a non-abstract base, but has the same role player type, {2}, as the base role {3}.{4}. This pattern has been deprecated and will not be supported in a future release..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.W3520ChangeBaseDomainRelationLowerBound">
            <summary>
              Looks up a localized string similar to The base DomainRelationship {0} is abstract, and the relationship will be instantiated by derived DomainRelationship {1}. You should consider changing the lower bound of the multiplicity for the base DomainRole {2}.{3} from 0..1 to 1..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.W3565InheritSerializeId">
            <summary>
              Looks up a localized string similar to In the XML Class Data for {0}, you should set SerializeId=&quot;true&quot; because SerializeId is set in a base relationship..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.W3571ReferenceTargetRequiresMonikerSerializeOrCustom">
            <summary>
              Looks up a localized string similar to Class {0} is the target of one or more non-embedding relationship, but you have not set SerializeId or designated a MonikerKey property. You have set IsCustom=&quot;true&quot;; your custom code must generate monikers for this class..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.W3576AllowsDuplicateRequiresMonikerSerializeOrCustom">
            <summary>
              Looks up a localized string similar to Relationship {0} has AllowsDuplicates=&quot;true&quot;, but you have not set SerializeId. You have set IsCustom=&quot;true&quot;: your custom code must provide monikers for this class..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.W6051NoXmlClassData">
            <summary>
              Looks up a localized string similar to XML Class Data missing for {0} {1}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.W6088RoleElementNameIgnored">
            <summary>
              Looks up a localized string similar to RoleElementName {2} is ignored in XmlRelationshipData {1} in XML Class Data {0} because OmitElement is set true..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.W6090NoUseFullFormOrOmitOnAbstract">
            <summary>
              Looks up a localized string similar to Relationship {0} has InheritanceModifier=abstract, and so its XmlRelationshipData should have neither UseFullForm nor OmitElement set true..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.W6100DerivedRelationUseFullForm">
            <summary>
              Looks up a localized string similar to XmlRelationshipData {1} in XML Class Data {0} should set UseFullForm true, because the relationship is derived from a non-abstract relationship {2}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.W6110DerivedRelationNoOmit">
            <summary>
              Looks up a localized string similar to XmlRelationshipData {1} in XML Class Data {0} should not set OmitElement true, because the relationship is derived from a non-abstract relationship..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.W6160MonikerShouldBeName">
            <summary>
              Looks up a localized string similar to In class {0}, property {1} is marked as the MonikerKey. Consider setting IsElementName=true for this property, to help users avoid saving a model with it left blank..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.W6170MonikerShouldHaveDefault">
            <summary>
              Looks up a localized string similar to In class {0}, property {1} is marked as the MonikerKey, but has no default value. Provide a default value, to help users avoid saving a model with this property left blank..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.W7310BadCompartmentDecoratorLocation">
            <summary>
              Looks up a localized string similar to Decorator {0} in CompartmentShape {1} is in position {2}. Each decorator in a CompartmentShape should be in an InnerTop or an Outer location. Use the VerticalOffset property if necessary..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.W8143SubclassOfParentElementNotMappedToShapeNorDiagram">
            <summary>
              Looks up a localized string similar to There is no Shape mapped to subclass {0} of the Parent Element {1} referenced by the Shape Map from {2} to {3}. This may cause errors if you allow users to create a {3} on a {0}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.W9065DomainTypeDescriptorHasIncompatibleProperties">
            <summary>
              Looks up a localized string similar to DomainTypeDescriptor for {0} should not have CustomCoded=True and also have PropertyPaths.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.W9070DomainTypeDescriptorPropertiesNotSpecified">
            <summary>
              Looks up a localized string similar to DomainTypeDescriptor for {0} should either have CustomCode=True or specify at least one PropertyPath.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.X01IdentifyProperty">
            <summary>
              Looks up a localized string similar to Property {0} in {1} {2}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.X02IdentifyRole">
            <summary>
              Looks up a localized string similar to Role {0} in Relationship {1}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.X03IdentifyRoleProperty">
            <summary>
              Looks up a localized string similar to Property {0} in {1} {2} generated from Role {3} of Relationship {4}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.X10PropertyPath">
            <summary>
              Looks up a localized string similar to {2} in {1} for {0}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.X11DisplayedElementsPath">
            <summary>
              Looks up a localized string similar to Displayed Elements path in Compartment Map for {0} in {1}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.X12CompartmentMapPath">
            <summary>
              Looks up a localized string similar to Property Path in Compartment Map for {0} in {1}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.X13PathContext">
            <summary>
              Looks up a localized string similar to {2} in {1} {0}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.X14ElementMergeDirective">
            <summary>
              Looks up a localized string similar to {0} in Element Merge Directive for {1} {2}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.X21DecoratorMapPropertyPath">
            <summary>
              Looks up a localized string similar to PropertyPath in Decorator Map for decorator {2} in {0} for {1}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.ValidationStrings.X22DecoratorMapVisibilityPath">
            <summary>
              Looks up a localized string similar to VisibilityPath in Decorator Map for decorator {2} in {0} for {1}.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId">
            <summary>
            Enumeration of the predefined DMDM constraint validation Errors.
            Start Error names with "E", warnings with "W".
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E0000GeneralError">
            <summary>
            General error id for debugging.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.N0101XmlDefinitionNoBehavior">
            <summary>
            Validation error - XmlDefinition has no XmlSerializationBehavior
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.N0110EditorNoValidation">
            <summary>
            Validation error - Editor has no Validation
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.N0120DslNoDiagram">
            <summary>
            Validation error - DSL has no Diagram
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E2020ElementToolCreatingRoot">
            <summary>
            Validation error - tool attempts to create root
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E2030ElementToolWrongType">
            <summary>
            Validation error - tool attempts to create a DomainRelationship or diagram element
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E2050DuplicateToolName">
            <summary>
            Validation error - duplicate tool name
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E2051EmptyToolName">
            <summary>
            Validation error - empty tool name
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E2060ToolboxIconInvalid">
            <summary>
            Validation error - invalid tool icon
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E2061ToolboxIconFileNotFound">
            <summary>
            Validation error - tool icon file not found
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E2070ToolboxHelpKeywordFormat">
            <summary>
            Validation error - tool help key invalid format
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E2080ToolboxCaptionEmpty">
            <summary>
            Validation error - no toolbox item caption
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E2090SourceCursorIconInvalid">
            <summary>
            Validation error - connector source cursor icon filepath invalid
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E2091SourceCursorIconFileNotFound">
            <summary>
            Validation error - connector source cursor icon file not found
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E2100TargetCursorIconInvalid">
            <summary>
            Validation error - connector target cursor icon filepath invalid
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E2101TargetCursorIconFileNotFound">
            <summary>
            Validation error - connector target cursor icon file not found
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E2110DuplicateToolboxTabText">
            <summary>
            Validation error - duplicate toolbox tab title.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E2111EmptyToolboxTabText">
            <summary>
            Validation error - empty toolbox tab title.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E2120EditorIconInvalid">
            <summary>
            Validation error - editor icon file path invalid.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E2121EditorIconFileNotFound">
            <summary>
            Validation error - editor icon file not found.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E2130EditorFileExtension">
            <summary>
            Validation error - file extension invalid.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.N2140EditorDslMustEqualRootLibrary">
            <summary>
            Validation error - inconsistent DSL referred to by Editor and root class.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.N2150XmlSerializationInconsistent">
            <summary>
            Validation error - inconsistent DSL references from XmlSerialization and designer.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E2152DslEditorRootClassWrongType">
            <summary>
            Validation error - editor root class is not a plain DomainClass.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E2155DslEditorRootClassUndefined">
            <summary>
            Validation error - editor root class is not specified.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.W2160EditorRootClassUnequalDiagramClass">
            <summary>
            Validation warning - the Root Class of the Editor should currently be the same as the Diagram class
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E2180InvalidXmlSerializationNamespace">
            <summary>
            Validation error - XmlSerialization invalid XML namespace.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E2200EditorEmptyGuid">
            <summary>
            Validation error - invalid editor guid
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E2210ExplorerEmptyGuid">
            <summary>
            Validation error - invalid explorer guid
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E2215ExplorerInvalidName">
            <summary>
            Validation error - invalid explorer name
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.N2220ExplorerHasNoBehavior">
            <summary>
            Validation error - Explorer has no behavior
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3000InternalClassName">
            <summary>
            Validation error - Name clashes with generated code.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3001InternalXmlName">
            <summary>
            Validation error - XML Name clashes with CDS.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3005InvalidDisplayName">
            <summary>
            Validation error - Blank name or displayname.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3040DslLibraryClassMemberWrongType">
            <summary>
            Validation error - Dsl Library Classes should all be plain DomainClasses.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3041InvalidNamespace">
            <summary>
            Validation error - invalid namespace.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3042InvalidIdentifier">
            <summary>
            Validation error - Invalid C# identifier.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3043InvalidIdentifierNoContext">
            <summary>
            Validation error - Invalid C# identifier.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3045DslLibraryVersionOutOfRange">
            <summary>
            Validation error - Negative version number.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3060EnumerationLiteralNameNotUnique">
            <summary>
            Validation error - Duplicate literal name within an enumeration.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3061EnumerationValueNotNullOrInteger">
            <summary>
            Validation error - Provided enumeration value is not an integer.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.W3062EnumerationFlagsShouldHaveValues">
            <summary>
            Validation warning - if IsFlags is set, literals should all have values.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3070NameNotUniqueSameType">
            <summary>
            Validation error - Duplicate names among DomainClasses in same namespace.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3071NameNotUniqueDifferentType">
            <summary>
            Validation error - Duplicate names among DomainClasses in same namespace.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3080DomainClassHasCircularInheritance">
            <summary>
            Validation error - circular inheritance among DomainClasses.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3090BaseDomainClassIsSealed">
            <summary>
            Validation error - Base class is sealed.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3100DuplicateDoubleDerivedClassDefined">
            <summary>
            Validation error - Class name ends "DoubleDerived".
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3110DslEditorRootClassCannotBeAbstract">
            <summary>
            Validation error - Abstract root class.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3120ClassReferredByElementToolCannotBeAbstract">
            <summary>
            Validation error - Abstract tool class.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.W3130OrphanDomainClass">
            <summary>
            Validation error - class not transitively embedded in root.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3160BaseDomainClassAccessibility">
            <summary>
            Validation error - Base class less accessible than derived.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3170DomainPropertyNameNotUnique">
            <summary>
            Validation error - Duplicate property name. 
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3171DomainPropertyNameNotAllowed">
            <summary>
            Validation error - property name clash with implicit base class.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3180DomainPropertyNameClashWithClass">
            <summary>
            Validation error - Property and role names clash.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3181DomainRoleNameClashWithInternal">
            <summary>
            Validation error - Property name clash with implicit base class.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3182RolePropertyNameClashWithInternal">
            <summary>
            Validaiton error - Property name clash with implicit base class.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3185RolePropertyPrivateNoDerivation">
            <summary>
            Validation error - can't override role property if private
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3190InvalidDefaultValue">
            <summary>
            Validation error - default value not valid for property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3192DefaultValueNotUsingInvariantCulture">
            <summary>
            Validation error - default value not using InvariantCulture.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.W3200InvalidDefaultDomainValue">
            <summary>
            Validation error - default value not valid for property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3230OnlyOneDomainPropertyElementNameTrueAllowed">
            <summary>
            Validation error - Multiple properties marked IsElementName.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3240ElementNameProviderIsNotAllowed">
            <summary>
            Validation error - ElementNameProvider but not IsElementName.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3241NamePropertyWrongType">
            <summary>
            Validation error - non-string property marked IsElementName.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3250PropertyTypeAccessibility">
            <summary>
            Validation error - property type less accessible than property.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3260MonikersInaccessible">
            <summary>
            Validation error - MonikerKey or Moniker Qualifier is private or internal
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3280TypeDefinedInOtherModel">
            <summary>
            Validation error - Type is defined in a separate model not imported by this.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3285InvalidPropertyType">
            <summary>
            Validation error - Invalid property type.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3300DomainRoleNameNotUnique">
            <summary>
            Validation error - Duplicate role name.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3310AllowDupInconsistentWithEmbeddingAndMultiplicity">
            <summary>
            Validation error - AllowDuplicate means not an Embedding and Multiplicity many.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3320MismatchingAllowDupFromBaseRelationship">
            <summary>
            Validation error - AllowDuplicate must be consistent with base relationship.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3331MismatchBaseClassAndBaseRelationship">
            <summary>
            Validation error - Relationship cannot inherit from DomainClass.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3340MismatchBaseClassLink">
            <summary>
            Validation error - Base class links must be of correct type.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3350TargetRolePlayerMustBeProperDomainClassInEmbeddingRelationship">
            <summary>
            Validation error - Target of embedding may not be a relationship.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3360MismatchingIsEmbeddingFromBaseRelationship">
            <summary>
            Validation error - IsEmbedding must match base relationship.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3370BaseRelationMustBeAbstractWhenIsEmbeddingMismatchFromBase">
            <summary>
            Validation error - IsEmbedding must match base.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.W3380AbstractDomainRelationWithMultiplicityOneMustHaveChild">
            <summary>
            Validation error - abstract relationship with a non-zero multiplicity but no child.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3390AbstractRelationshipCannotBeReferredByLinkConnectDirective">
            <summary>
            Validation error - link connect directive must refer to a DomainClass.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3420BaseRelationshipRolePlayerIncompatible">
            <summary>
            Validation error - Role player of base relationship is not a base of this roleplayer.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3430RolePlayerAndDomainRelationshipDifferentModel">
            <summary>
            Validation error - roleplayer and relationship are in different models.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.N3435InvalidRole">
            <summary>
            Validation error - missing or invalid role.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3440DomainRolePropertyNameInvalid">
            <summary>
            Validation error - invalid or missing role property name.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3445DomainRolePlayerInvalid">
            <summary>
            Validation error - invalid or missing role player.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3450RoleCollectionTypeIncompatibleWithMultiplicity">
            <summary>
            Validation error - specified role collection type is mismatched to the multiplicity.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3460InconsistentEmbeddedRoleMultiplicityAmongDescendents">
            <summary>
            Validation error - multiplicities must be compatible with base.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.N3461RootIsEmbeddedTarget">
            <summary>
            Validation error - Editor Root is also target of embedding with 'one' multiplicity.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3465TargetMultiplicityMaxOne">
            <summary>
            Validation error - Embedding relationships may not have "many" target multiplicity.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.W3470DerivedDomainRelationshipMustBeInstantiated">
            <summary>
            Validation error - abstract relationship with non-zero multiplicity forces derived relations to be instantiated.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3480DerivedRelationshipLowerBoundZero">
            <summary>
            Validation error - mismatched derived relationship multiplicity.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.W3490DerivedRelationshipCannotBeInstantiated">
            <summary>
            Validation error - concrete base with multiplicity One prevents children from being instantiated.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.W3500BaseRelationshipMissingAbstract">
            <summary>
            Validation error - Base relationship is not abstract.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.W3505BaseRoleNotSameNamedOrAbstract">
            <summary>
            Validation error - Derived relationship has different role property name(s) to concrete base relationship.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.W3506AmbiguousDerivedRoleOfConcreteBase">
            <summary>
            Validation error - Derived relationship has same role player type(s) as a concrete base relationship.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3510DerivedRelationshipUpperBoundMustBeOne">
            <summary>
            Validation error - mismatched derived relationship multiplicity.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.W3520ChangeBaseDomainRelationLowerBound">
            <summary>
            Validation error - inappropriate multiplicity on base relationship.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.W3565InheritSerializeId">
            <summary>
            Validation error - SerializeId required.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3570ReferenceTargetRequiresMonikerOrSerialize">
            <summary>
            Validation error - moniker required.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.W3571ReferenceTargetRequiresMonikerSerializeOrCustom">
            <summary>
            Validation warning - moniker required.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E3575AllowsDuplicateRequiresMonikerOrSerialize">
            <summary>
            Validation error - moniker required.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.W3576AllowsDuplicateRequiresMonikerSerializeOrCustom">
            <summary>
            Validation warning - moniker required.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.N3640EmptyGuid">
            <summary>
            Validation error - empty guid not allowed - no open.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E4000PathMustHaveSegments">
            <summary>
            Validation error - empty path not allowed.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E4005InvalidRole">
            <summary>
            Validation error - invalid or missing role in path.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E4010PathSegmentDislocation">
            <summary>
            Validation error - target of path segment not compatible with source of next.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E4015PathInitialDislocation">
            <summary>
            Validation warning - target of path segment not with initial class.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E4020PathElementSegmentDislocation">
            <summary>
            Validation error - target of path segment not compatible with source of next.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E4030OnlyLastLinksMultiple">
            <summary>
            Validation error - multiple links not allowed except as final path segment.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E4040PathEndDislocation">
            <summary>
            Validation error - final segment of path incompatible with target class.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E4100PropertyNotInContainer">
            <summary>
            Validation error - property in path belongs to a different class from that referred to
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E4110NoPropertyInPropertyPath">
            <summary>
            Validation error - no property defined in a property path.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E4120CannotParseDomainPath">
            <summary>
            Validation error - domain path can't be parsed
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E5000ElementMergeMissingIndex">
            <summary>
            Validation error - no index class in ElementMerge.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E5010DuplicateElementMergeDirectives">
            <summary>
            Validation error - two ElementMerges for same index class.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E5030ElementMergeHasForwardingAndLinkCreation">
            <summary>
            Validation error - ElementMerge has both forwarding and link creation paths.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E5031ElementMergeHasForwardingAndCustom">
            <summary>
            Validation error - ElementMerge has not forwarding path and IsCustom set.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E5040ElementMergeHasCollectionForwardingPath">
            <summary>
            Validation error - ElementMerge forwarding path must not be multiple.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E5050LinkCreationPathTarget">
            <summary>
            Validation error - LinkCreation path is not compatible with index class.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E5060LinkCreationPathMustBeLinks">
            <summary>
            Validation error - link creation path must end in a links segment.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E5070LinkCreationPathMustNotBeAbstract">
            <summary>
            Validation error - the final segment of a link creation path must not be abstract.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E5090RolePlayerConnectDirectivePathCollection">
            <summary>
            Validation error - RolePlayerConnectDirective must not be a collection path.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E5110DuplicateConnectionBuilderNames">
            <summary>
            Validation error - duplicate ConnectionBuilder names.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E5111ConnectionBuilderEmptyName">
            <summary>
            Validation error - empty ConnectionBuilder name.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E5130LinkDirectiveCustomOrRelationship">
            <summary>
            Validation error - ConnectionBuilder must either have a LinkConnectDirective or be UsesCustomConnect.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E5150LinkConnectorTargetTypeIncompatible">
            <summary>
            Validation error - LinkConnectDirective wrong target type.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E6010RootCannotBeSerialized">
            <summary>
            Validation error - Root class must have SerializeId or a Moniker Key.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E6040XmlClassDataDuplicateTypeName">
            <summary>
            Validation error - Duplicate type names for XmlClassData
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E6041XmlClassDataInvalidTypeName">
            <summary>
            Validation error - Empty type name in XmlClassData.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E6060XmlClassDataDuplicateElementName">
            <summary>
            Validation error - duplicate element names in XmlClassData.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E6061XmlClassDataInvalidElementName">
            <summary>
            Validation error - empty element name in XmlClassData.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E6062XmlClassDataInvalidClass">
            <summary>
            Validation error - invalid or missing class moniker in XmlClassData.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E6065XmlElementNameSameAsMoniker">
            <summary>
            Validation error - MonikerElementName must not be same as ElementName
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E6067XmlInvalidMonikerAttributeName">
            <summary>
            Validation error - Moniker attribute name must be valid XML name
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E6068XmlInvalidMonikerElementName">
            <summary>
            Validation error - Moniker element name must be valid XML name
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E6070XmlPropertyMoniker">
            <summary>
            Validation error - invalid property moniker in XmlClassData.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E6071DuplicateMonikerKey">
            <summary>
            Validation error - more than one property marked as moniker key.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E6072DuplicateMonikerQualifier">
            <summary>
            Validation error - more than one property marked as moniker qualifier.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E6085InvalidDomainRelationshipReference">
            <summary>
            Validation error - Invalid domain relationship moniker.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E6086IncompatibleDomainRelationshipReference">
            <summary>
            Validation error - Invalid domain relationship moniker.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E6087InvalidRoleElementName">
            <summary>
            Validation error - Invalid domain relationship moniker.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.W6088RoleElementNameIgnored">
            <summary>
            Validation warning - RoleElementName not required with Omit.
            </summary>        
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.W6090NoUseFullFormOrOmitOnAbstract">
            <summary>
            Validation warning - No Omit nor UseFullForm on abstract relationships.
            </summary>    
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.W6100DerivedRelationUseFullForm">
            <summary>
            Validation error - UseFullForm in a derived relationship.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.W6110DerivedRelationNoOmit">
            <summary>
            Validation error - omit not recommended on derived relationship.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E6115PropertiesUseFullForm">
            <summary>
            Validation error - UseFullForm required.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E6117AllowDuplicatesUseFullForm">
            <summary>
            Validation error - UseFullForm required.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E6125CustomRelationsUseFullForm">
            <summary>
            Validation error - Set UseFullForm where the relationship is custom.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E6130XmlPropertyDataInvalidDomainProperty">
            <summary>
            Validation error - invalid or missing domain property moniker in XmlPropertyData.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E6140DuplicateXmlElementName">
            <summary>
            Validation error - Duplicate Xml property or role element name in XmlClassData.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E6150MonikerMustBeAttributeRepresentation">
            <summary>
            Validation error - do not set Ignore in properties that are Moniker Key or Qualifier.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.W6160MonikerShouldBeName">
            <summary>
            Validation warning - Moniker should be Element Name
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.W6170MonikerShouldHaveDefault">
            <summary>
            Validation warning - Moniker should be have a default value
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E7100DuplicateDecoratorName">
            <summary>
            Validation error - Duplicate decorator name.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E7101EmptyDecoratorName">
            <summary>
            Validation error - empty decorator name.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E7010NegativeWidthHeightThickness">
            <summary>
            Validation error - negative width, height or thickness.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.N7050IncompatibleBase">
            <summary>
            Validation error - incompatible base shape.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E7080FixedTooltipTextEmpty">
            <summary>
            Validation error - TooltipText marked as fixed, but none supplied.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E7140ExpandCollapseNotOnShape">
            <summary>
            Validation error - ExpandCollapse decorator inappropriate on this diagram element.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E7150IconDecoratorImageInvalid">
            <summary>
            Validation error - invalid icon decorator file path.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E7151IconDecoratorImageFileNotFound">
            <summary>
            Validation error - icon decorator file not found.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E7160ImageShapeImageInvalid">
            <summary>
            Validation error - invalid image file path.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E7161ImageShapeImageFileNotFound">
            <summary>
            Validation error - image shape file not found.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E7170CompartmentNameDuplicate">
            <summary>
            Validation error - duplicate compartment name.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E7171CompartmentNameEmpty">
            <summary>
            Validation error - empty compartment name.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E7180CompartmentFontSizeOutOfRange">
            <summary>
            Validation error - invalid font size.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E7200ElementMergeInvalidOnShape">
            <summary>
            Validation error - element merge not valid on a shape.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E7210ElementCustomMergeInvalidOnDiagramElement">
            <summary>
            Validation error - custom merge invalid on a diagram.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E7220ElementMergeLinkCreationPathsInvalidOnDiagramElement">
            <summary>
            Validation error - link creation paths not valid on a diagram.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.W7310BadCompartmentDecoratorLocation">
            <summary>
            Validation warning - compartment decorator should be Outer or InnerTop.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.N8075ShapeMapInvalidShapeOrClass">
            <summary>
            Validation error - invalid or missing shape or class moniker.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E8077ShapeMapParentElementPathNull">
            <summary>
            Validation error - parent element must not be null
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E8080ShapeMapParentElementNotCollection">
            <summary>
            Validation error - parent element must not be a collection.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E8100MappedShapeOccursInUnmappedShapes">
            <summary>
            Validation error - shape occurs both in mapped shapes and unmapped shapes list.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E8130MappingDiagramClass">
            <summary>
            Validation error - can't map diagram class.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E8140ShapeMapInvalidForCompartmentShape">
            <summary>
            Validation error - use CompartmentShapeMap for a CompartmentShape.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E8141ShapeMapInvalidForSwimLane">
            <summary>
            Validation error - use appropriate map for a SwimLane.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E8142NoShapeNorDiagramMappedToParentElement">
            <summary>
            Validation error - no shape or diagram mapped to parent element path (or non-abstract subclasses).
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.W8143SubclassOfParentElementNotMappedToShapeNorDiagram">
            <summary>
            Vaildation warning - subclass of parent isn't mapped to shape or diagram.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E8145InvalidParentShapeType">
            <summary>
            Validation error - invalid shape parenting.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E8146InvalidParentSubclassShapeType">
            <summary>
            Validation error - invalid shape parenting.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E8150DuplicateCompartment">
            <summary>
            Validation error - duplicate compartment map.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E8155MissingCompartmentMap">
            <summary>
            Validation error - compartment not mapped.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E8160CompartmentElementsDisplayedCollection">
            <summary>
            Validation error - compartments must display collections.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E8161CompartmentElementsDisplayedInvalid">
            <summary>
            Validation error - missing ElementsDisplayed in compertment map.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.N8180InvalidCompartment">
            <summary>
            Validation error - invalid or missing comparment moniker.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E8191CompartmentMapPropertyDisplayedInvalid">
            <summary>
            Validation error - invalid custom string.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E8201ConnectorMapMissingRelationOrConnector">
            <summary>
            Validation error - invalid ConnectorMap.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E8210ConnectorMapSourceNotMapped">
            <summary>
            Validation error - invalid ConnectorMap.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E8211ConnectorMapTargetNotMapped">
            <summary>
            Validation error - invalid ConnectorMap.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E8215ConnectorMapNotAbstract">
            <summary>
            Validation error - invalid ConnectorMap.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.N8220InvalidDecoratorMapDecoratorReference">
            <summary>
            Validation error - invalid DecoratorMap.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E8225InvalidDecoratorMapNoVisibilityOrProperty">
            <summary>
            Validation error - decorator map has neither visibility nor property path
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E8230InconsistentSwimlaneAlignment">
            <summary>
            Validation error - swimlanes oriented in different directions.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E8250DuplicateShapeMap">
            <summary>
            Validation error - two shapemaps map the same shape to the same class.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E8260InconsistentConnectorMapCustomization">
            <summary>
            Validation error - differing customization settings on maps to same connector.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E8265DuplicateConnectorMap">
            <summary>
            Validation error - two connector maps map the same relationship and connector.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.E9060PropertyPathInTypeDescriptor">
            <summary>
            Validation error - invalid property path.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.W9065DomainTypeDescriptorHasIncompatibleProperties">
            <summary>
            Validation warning - DomainTypeDescriptor has both CustomCoded=true and PropertyPaths specified
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId.W9070DomainTypeDescriptorPropertiesNotSpecified">
            <summary>
            Validation warning - DomainTypeDescriptor has neither CustomCoded=true nor any PropertyPaths specified
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.ExternalTypeVerificationFlavor">
            <summary>
            Internal enum to allow us to understand whether we're validating ExternalType or its type argument (if it's a generic). E.g.
            List &lt; System.Guid &gt;
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.errorMap">
            <summary>
            dictionary for holding a map DMDMViolationId-->ViolationError. It allows us to do a fast look up.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.#cctor">
            <summary>
            Set up a cache of ViolationErrors.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.PropertyNameReservedInClass(System.String,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Whether a name is already used in the framework class
            corresponding to a DSL Definition.
            </summary>
            <param name="name"></param>
            <param name="domainClass"></param>
            <returns></returns>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.baseTypes">
            <summary>
            Map from DSL Definition class to the corresponding framework base class.
            Must include all concrete subclasses of DomainClass.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.GetPublicPropertyNames(System.Type)">
            <summary>
            Get the public property names for a given type.
            <param name="type"></param>
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.ConstructErrorCode(Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId)">
            <summary>
            Construct the error code for the given errorId with the format "DSLxxxx" where xxxx is the enum value.
            </summary>
            <param name="errorId"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.GetErrorMessage(Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId,System.Object[])">
            <summary>
            This method will return the formatted mesage with the passed in args.
            </summary>
            <param name="errorId">DSL constraint violation enum value</param>
            <param name="args">An System.Object array containing zero or more objects to format.</param>
            <returns>A copy of format in which the format items have been replaced by the System.String equivalent of the corresponding instances of System.Object in args.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.ReportConstraintViolation(Microsoft.VisualStudio.Modeling.Validation.ValidationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId,System.String,Microsoft.VisualStudio.Modeling.ModelElement[])">
            <summary>
            Internal helper method to report an error/warning/message based on the passed in errorId with the formatted displayErrorMessage (returned from GetErrorMessage)
            </summary>
            <param name="context">context object for logging errors/warnings/informationals</param>
            <param name="errorId">DSL constraint violation enum value</param>
            <param name="displayErrorMessage">formatted displayed message</param>
            <param name="args">An System.Object array containing zero or more error model elemnents</param>
            <returns>true if log is successful.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.ReportViolation(Microsoft.VisualStudio.Modeling.Validation.ValidationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DslViolationId,System.Object[])">
            <summary>
            Report an error/warning/message; formats the error message with the supplied arguments.
            </summary>
            <param name="context"></param>
            <param name="errorId"></param>
            <param name="arguments">Mixture of strings and ModelElements. Strings are used as message formatting arguments, ModelElements are highlighted when user selects error. The ModelElements may be passed as a single array.</param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.VerifyIdentifier(Microsoft.VisualStudio.Modeling.Validation.ValidationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.String,System.String,Microsoft.VisualStudio.Modeling.ModelElement[])">
            <summary>
            Verify the passed in identifier and report error if the identifier is invalid
            </summary>
            <param name="context">validation context</param>
            <param name="item">specific object that is being named</param>
            <param name="identifier">name (of the item) to be verified.</param>
            <param name="contextName">Name of context in which named item appears. May be null.</param>
            <param name="args">objects to be highlighted on error (probably including item)</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.VerifyNamespaceAndIdentifier(Microsoft.VisualStudio.Modeling.Validation.ValidationContext,Microsoft.VisualStudio.Modeling.ModelElement,System.String,System.String,System.String,Microsoft.VisualStudio.Modeling.ModelElement[])">
            <summary>
            Verify the passed in identifier/namespace and report error if the identifier is invalid
            </summary>
            <param name="context">validation context</param>
            <param name="item">item that has the name and namespace to be verified</param>
            <param name="nameSpace">namespace (of the item) to be verified.</param>
            <param name="identifier">name (of the item) to be verified.</param>
            <param name="contextName">Name of context in which named item appears. May be null.</param>
            <param name="args">objects to be highlighted on error (probably including item)</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.IsValidIdentifier(System.String)">
            <summary>
            Internal helper method to determine whether the passed in identifier is valid or not.
            </summary>
            <param name="identifier">identifier to be verified</param>
            <returns>true if this is a valid identifier</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.IsValidXmlName(System.String)">
            <summary>
            According to XML Spec.
            </summary>
            <param name="name"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.IsValidImageFile(System.String,Microsoft.VisualStudio.Modeling.DslDefinition.Design.ImageResourceKind)">
            <summary>
            Determine whether an image file reference is valid.
            </summary>
            <param name="path">The image path to be checked.</param>
            <param name="imageType">The image type expected.</param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.IsProperDomainClass(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            
            </summary>
            <param name="domainClass"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.HasCompatibleBaseClass(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Rules for BaseClass compatibility among various kinds of DomainClass.
            Principal rule is that each type may only have the same type as a BaseClass.
            </summary>
            <param name="domainClass"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.FileExists(System.String)">
            <summary>
            Check whether a file exists (relative to the model file).
            </summary>
            <param name="path"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.IsValidDotDelimitedName(System.String)">
            <summary>
            Internal helper to determine for a given dot delimited name  (e.g. MS.VS.Modeling.Shell.Foo ) is valid or not. 
            NOTE this helper method does not take into consideratin of generic.  (e.g MS.VS.Modeling.Shell.Bar &lt;T&gt; would be 
            treated as invalid..)
            </summary>
            <param name="nameSpace">namespace name to be verified</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.MoreAccessible(Microsoft.VisualStudio.Modeling.DslDefinition.AccessModifier,Microsoft.VisualStudio.Modeling.DslDefinition.AccessModifier)">
            <summary>
            Check whether an AccessModifier is more or equally accessible than another.
            private &lt; { Family | Assembly } &lt; FamilyOrAssembly &lt; public
            </summary>
            <param name="more">The modifier that is more or equal iff we return true</param>
            <param name="less">The modifier that is less or equal iff we return true</param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.TypeCompatible(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Determine whether members of one class can be assigned to another.
            </summary>
            <param name="subclass">The result is true if this is the same or a transitive subclass of the other parameter.</param>
            <param name="superclass">The result is true if this is the same or a transitive superclass of the other parameter.</param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.FindDomainClass``1(System.String,System.Collections.IEnumerable,Microsoft.VisualStudio.Modeling.ModelElement@)">
            <summary>
            For a given full name, this method tries to see if the passed in DomainClass collection has an DomainClass which has the same name
            </summary>
            <typeparam name="T">Type of object of interest for finding</typeparam>
            <param name="domainClassFullName">DomainClass/DomainRelationship full name</param>
            <param name="collection">The collection of DomainClass to search for.</param>
            <param name="foundElement">The DomainClass/DomainRelationship which matches the name</param>
            <returns>true if there's a match</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.FindDomainClass``1(System.String,System.Collections.IEnumerable,Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement@)">
            <summary>
            For a given full name, this method tries to see if the passed in DomainClass collection has an DomainClass which has the same name
            </summary>
            <typeparam name="T">Type of object of interest for finding</typeparam>
            <param name="domainClassFullName">DomainClass/DomainRelationship full name</param>
            <param name="collection">The collection of DomainClass to search for.</param>
            <param name="excludeObject">DomainObject object excluded from checking</param>
            <param name="foundElement">The DomainClass/DomainRelationship which matches the name</param>
            <returns>true if there's a match</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.IsValidExternalTypeIdentifier(System.String,Microsoft.VisualStudio.Modeling.DslDefinition.ExternalTypeVerificationFlavor)">
            <summary>
            Mechanism to parse. It will break up the type parameter as well as array decls.
            Note that this calling method will reset the existing TypeInstance stored in the ParseType.
            Note that a ClrModelException will be thrown if the given string fails to parse in the syntax
            of the specified language.
            </summary>
            <param name="externalTypeName">The string to parse</param>
            <param name="flavor">Indicate whehter we're validating an external type or the type argument (within the externaltype). E.g. List&gt;System.Guid&lt; </param>
            <remarks>
            For external type, the name has to be a valid name. It can't include any leading namespace name. The namespace can be specified in the Namespace 
            domain property. For the type argument, we are allowing the type name to be specified with the namespace. The reason is that we don't have a way 
            for user the specified namesapce for each type arg. Therefore, both List&gt;System.Guid&lt; and  List&gt;Guid&lt; are valid
            Since this is recursing, we need the flavor to indicate whether we're validating the type or the type-argument.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.IsExternalGenericTypeNameValid(Microsoft.VisualStudio.Modeling.DslDefinition.ExternalTypeVerificationFlavor,System.String,System.Int32,System.Int32)">
            <summary>
            Check an external type name that is generic
            </summary>
            <param name="flavor"></param>
            <param name="instantiatedTypeName"></param>
            <param name="textLen"></param>
            <param name="indexGenericOpenDelim"></param>
            <returns></returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.PropertyNamesReserved">
            <summary>
            A dictionary of public property names used in framework classes.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.CSharpProvider">
            <summary>
            Returns the CodeDomProvider class for validation.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.ViolationError">
            <summary>
            private struct for storing the violation type, error code and string (unformatted).
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.PropertyMapInfo">
            <summary>
            Information about Properties and Roles.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.ClassCacheInfo">
            <summary>
            Information extracted from Classes.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.ClassCacheInfo.AllProperties">
            <summary>
            Map from property names to Properties or Roles.
            Includes generated properties; and for DomainRelationships, includes roles.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.ClassCacheInfo.IsReferenceTarget">
            <summary>
            This class is the target of a non-embedding relationship
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.PropertyNameCache">
            <summary>
            Verify and cache information about classes and their properties.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.PropertyNameCache.VerifyAndGetAllProperties(Microsoft.VisualStudio.Modeling.Validation.ValidationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Check name clashes among properties and roles.
            </summary>
            <param name="context"></param>
            <param name="subjectClass"></param>
            <param name="stopClass"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.PropertyNameCache.AddProperty(Microsoft.VisualStudio.Modeling.Validation.ValidationContext,Microsoft.VisualStudio.Modeling.DslDefinition.DslValidationUtility.ClassCacheInfo,System.String,Microsoft.VisualStudio.Modeling.DslDefinition.NamedDomainElement,Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass,System.Boolean)">
            <summary>
            Check a property or role and add it to the dictionary for this class.
            For a role, pass in the DomainRelationship as subjectClass, the role as property, the role name as propertyName.
            For a relationship-generated property, pass in the role-playing DomainClass, the role, and the PropertyName.
            For a DomainProperty, pass in the DomainClass and the property name.
            </summary>
            <param name="context">Validation Context</param>
            <param name="classInfo">Property dictionary for this class</param>
            <param name="propertyName">Name of the generated property</param>
            <param name="propertyOrRole">Property or Role</param>
            <param name="subjectClass">Class to which the dictionary and property or role belong.</param>
            <param name="isGeneratedProperty">This is a property generated from a relationship role.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDefinition.NameUniqueChecker.Check(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Check that the name of a DomainClass (including Relationship, Shape, Diagram) is not the same as another seen before.
            </summary>
            <param name="domainClass"></param>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DomainElementResolver">
            <summary>
            Utilities to resolve the actual MEL for the given Pel
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DomainElementResolver.Resolve(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            For the given presentation element, this method tries to resolve the associated mel. 
            The DslDesigner has the following setup
             Pel -->  Mel (DslDesigner) -- > Mel (IMS)
             It will go thru the nessary traversal to find the actual Mel.
            </summary>
            <param name="presentationElement"></param>
            <returns></returns>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.NavigateToShapeEventArgs">
            <summary>
            Simple class to pass a shape as args to an event.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.ExpandCollapseButtonField">
            <summary>
            A ExpandCollapseButtonField is the button hanging off the bottom of a class shape that has expand/collapse properties
            and perhaps a symbol as well.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ExpandCollapseButtonField.DoPaint(Microsoft.VisualStudio.Modeling.Diagrams.DiagramPaintEventArgs,Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement)">
            <summary>
            Draws the contents of the ShapeField.
            </summary>
            <param name="e">A DiagramPaintEventArgs that contains the event data.</param>
            <param name="parentShape">The parent shape of this field.</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ExpandCollapseButtonField.GetAccessibleName(Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement)">
            <summary>
            Returns the default accessible name for an image field.
            </summary>
            <param name="parentShape">The ShapeElement that contains this ShapeField.</param>
            <returns>The accessible name.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ExpandCollapseButtonField.GetAccessibleDescription(Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement)">
            <summary>
            Returns the default accessible description for an image field.
            </summary>
            <param name="parentShape">The ShapeElement that contains this ShapeField.</param>
            <returns>The accessible description.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ExpandCollapseButtonField.GetAccessibleRole(Microsoft.VisualStudio.Modeling.Diagrams.ShapeElement)">
            <summary>
            This expand/collapse field is a PushButton
            </summary>
            <param name="parentShape"></param>
            <returns></returns>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceTriangle">
            <summary>
            This is an arrow decorator consisting of a triangle poiting in the direction of the inheritance base.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceTriangle.#ctor">
            <summary>
            Default constructor does nothing, but needed for serialization.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceTriangle.GetPath(Microsoft.VisualStudio.Modeling.Diagrams.RectangleD)">
            <summary>
            Returns the GraphicsPath for this LinkDecorator based on the bounding box passed in.
            </summary>
            <param name="bounds">Rectangle in which to draw the path.</param>
            <returns>GraphicsPath for resulting LinkDecorator.</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceTriangle.Instance">
            <summary>
            The singleton instance of this class
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceTriangle.BrushId">
            <summary>
            Use a white background brush for the decorator's fill
            </summary>
            <value>The brush to use</value>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.PropertyGlyphs">
            <summary>
            Class to retieve glyphs for properties
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.PropertyGlyphs.MemberGlyphCount">
            <summary>
            Hard-coded max number of possible images.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.PropertyGlyphs.glyphImages">
            <summary>
            Array to store member glyph images themselves. Indexed by AccessModifier.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.PropertyGlyphs.glyphImageList">
            <summary>
            Class View's image list from which we get the images when needed.
            Delay-initialized.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.PropertyGlyphs.GetPropertyGlyph(Microsoft.VisualStudio.Modeling.DslDefinition.AccessModifier,System.IServiceProvider)">
            <summary>
            Gets Property glyph for specified AccessModifier level 
            </summary>
            <param name="modifier">Modifier to get image for.</param>
            <param name="serviceProvider">Service provider to use if need to get image list.</param>
            <returns>Property glyph as Image.</returns>
            <remarks>
            	This method should be lightning fast since we draw A LOT of images on design
            	surface and pretty much every time we want an image we call this method. Be
            	very careful with changing it!
            </remarks>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnectorDecoratorBoundsRules">
            <summary>
            Rule class to stop RoleConnector labels from overlapping their vertical line segment.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.ReferenceTypeAddedTreeFixupRule">
            <summary>
            Rule to update roots when a new domainclass is added
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipAddedTreeFixupRule">
            <summary>
            Rule to update SourceRoleNodes when a new relationship is added
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceAddedTreeFixupRule">
            <summary>
            Rule to update InheritanceNodes when a new inheritance relationship is added
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.AutoTree">
            <summary>
            Class to provide logic for creating a tree structure automatically when the diagram doesn't already contain such a thing.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.AutoTree.ClassIsRoot(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Returns whether a class should be used as a root.
            </summary>
            <remarks>
            Just a very simple algorithm as mass use of auto tree is not in any way a common case.
            Classes are made a root if they are not explicitly embedded in anything or if there is ambiguity over where they should be embedded
            because they are emedded in multiple places.
            </remarks>
            <param name="candidate">Class to test</param>
            <returns>Whether or not the class is a root.</returns>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.CustomDomainModelTypes">
            <summary>
            Rules for TreeFixup
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.TreeLayoutOptions">
            <summary>
            Strategy class to hold parameterizations for tree layout.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.TreeLayoutOptions.LinkAttachmentVerticalOffset">
            <summary>
            The offset from the top of the shape where links attach
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.TreeLayout">
            <summary>
            Helper class to perform layout and to navigate around the presentation shape graph without using the MELs.
            </summary>
        </member>
        <member name="F:Microsoft.VisualStudio.Modeling.DslDesigner.TreeLayout.LayoutPriority">
            <summary>
            When in a transaction to do the relayout
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.TreeLayout.LayoutTree(Microsoft.VisualStudio.Modeling.DslDesigner.DslDesignerDiagramTree,Microsoft.VisualStudio.Modeling.Diagrams.SwimlaneShape,System.Double,System.Double)">
            <summary>
            Layout a tree onto a given swimlane starting at a given position
            </summary>
            <param name="tree"></param>
            <param name="swimLane"></param>
            <param name="xPos"></param>
            <param name="yPos"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.TreeLayout.IsInDiagramTree(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Test whether the given class belongs in the diagram tree (or the domainmodel tree)
            </summary>
            <param name="theClass"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.TreeLayout.RelationDownLinksSourcedAt(Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape)">
            <summary>
            Get all the Relation links descending from a Definition shape.
            </summary>
            <param name="parent">ConceptDefinitionShape from which RelationLinks descend</param>
            <returns>List of BinaryLinkShape. May be empty.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.TreeLayout.InheritanceLinksSourcedAt(Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape)">
            <summary>
            Get all the Inheritance links descending from a supertype Definition shape.
            </summary>
            <param name="superType">superType</param>
            <returns>List of InheritanceLink</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.TreeLayout.TargetClassFromTargetLink(Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnector)">
            <summary>
            Given a target RoleConnector, find the Class shape that is attached to it as a target.
            </summary>
            <param name="targetLink">The RoleConnector to search from</param>
            <returns>Class shape</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.TreeLayout.TargetLinkFromRelationshipShape(Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShape)">
            <summary>
            Given a relationship shape, get the role connector going to the target.
            </summary>
            <param name="relShape"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.TreeLayout.SourceLinkFromRelationshipShape(Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShape)">
            <summary>
            Given a relationship shape, get the role connector going to the source
            </summary>
            <param name="relShape"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.TreeLayout.MoveClassShapeDown(Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape)">
            <summary>
            Move given shape down one position in the tree hierarchy.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.TreeLayout.MoveClassShapeUp(Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape)">
            <summary>
            Move given shape up one position in the tree hierarchy.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.TreeLayout.CanMoveClassShapeDown(Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape)">
            <summary>
            Returns true if given shape can be moved down one position in the tree hierarchy, false otherwise.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.TreeLayout.CanMoveClassShapeUp(Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape)">
            <summary>
            Returns true if given shape can be moved up one position in the tree hierarchy, false otherwise.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.TreeLayout.InheritanceConnectorTargeting(Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape)">
            <summary>
            InheritanceConnector targeting a ClassShape, if there is one.
            </summary>
            <param name="classShape">Node from which InheritanceConnector may descend.</param>
            <returns>An InheritanceConnector, or null if there is none.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.TreeLayout.InheritanceConnectorLeftSide(Microsoft.VisualStudio.Modeling.DslDesigner.InheritanceConnector)">
            <summary>
            Get the class shape at the LHS of this inheritance connector
            </summary>
            <param name="connector"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.TreeLayout.SourceRoleConnectorLeftSide(Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnector)">
            <summary>
            Get the class shape at the LHS of this source role connector
            </summary>
            <param name="connector"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.TreeLayout.RoleConnectorTargeting(Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape)">
            <summary>
            RoleConnector targeting a ClassShape, if there is one.
            </summary>
            <param name="classShape">Node to which RoleConnector may attach.</param>
            <returns>A RoleConnector, or null if there is none.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.TreeLayout.ConnectedLinkShapes(Microsoft.VisualStudio.Modeling.Diagrams.NodeShape)">
            <summary>
            Gets a collection of the LinkShapes connected to this NodeShape.
            Use this in preference to methods on NodeShape
            as it works before the GraphObject has been drawn.
            </summary>
            <param name="nodeShape">NodeShape</param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.TreeLayout.GetParentClassShape(Microsoft.VisualStudio.Modeling.DslDesigner.AbstractClassShape)">
            <summary>
            Get the class shape that is the definiton from which the given class shape is "Hung". i.e. its "tree" parent
            </summary>
            <param name="classShape"></param>
            <returns></returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.TreeLayout.ClassShapeFromRelationship(Microsoft.VisualStudio.Modeling.DslDesigner.RelationshipShape,Microsoft.VisualStudio.Modeling.DslDesigner.RoleConnector)">
            <summary>
            Get the class shape connected to the relatinship by the opposite link to the one given
            </summary>
            <param name="relationshipShape">The shape to start at</param>
            <param name="notVia">Avoiding this link</param>
            <returns></returns>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.ViewFixupIndirection">
            <summary>
            Class to allow fixup rules to have extra code in a single standard place
            </summary>
            <remarks>
            When the model is used in command line tools, it is imperative that UI code is not executed
            A Store that does not have the DslDesignerUI member set to something won't perform any UI operations
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ViewFixupIndirection.FixUpDiagram(Microsoft.VisualStudio.Modeling.ModelElement,Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Perform the Diagram Fixup and whatever else is necessary
            </summary>
            <param name="parent"></param>
            <param name="child"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ViewFixupIndirection.ScheduleLayout(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Schedule a layout for diagrams presenting the element
            </summary>
            <param name="element"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ViewFixupIndirection.RecreateDefinitionLinks(Microsoft.VisualStudio.Modeling.DslDefinition.DomainClass)">
            <summary>
            Recreate links from a definition shape when they have been destroyed (typically due to bring shape here/split tree)
            </summary>
            <param name="referenceType"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ViewFixupIndirection.ReparentClassShapes(Microsoft.VisualStudio.Modeling.DslDesigner.ArcNode)">
            <summary>
            Reparent the shapes representing the given node onto the opposite swimlane when the underlying tree changes
            </summary>
            <param name="arcNode"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ViewFixupIndirection.DeleteShapesOfPresentedElements(Microsoft.VisualStudio.Modeling.ModelElement)">
            <summary>
            Delete all shapes for a MEL
            </summary>
            <param name="element"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ViewFixupIndirection.DeleteMapConnectors(Microsoft.VisualStudio.Modeling.DslDefinition.DomainElement)">
            <summary>
            Delete all of the mapping connectors hooked to the presentations of the given ArcNode or DomainRelationship.
            </summary>
            <param name="presentedElement"></param>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.ScheduleLayoutOnShapeAddRule">
            <summary>
            Class to schedule a layout whenever something is added to the diagram or a swimlane
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ScheduleLayoutOnShapeAddRule.ElementAdded(Microsoft.VisualStudio.Modeling.ElementAddedEventArgs)">
            <summary>
            Called whenever a shape is added to a parent shape.
            </summary>
            <param name="e">Argument to event</param>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.BaseClassRolePlayerChanged">
            <summary>
            Class to schedule a layout every time a base class changes
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.BaseClassRolePlayerChanged.RolePlayerChanged(Microsoft.VisualStudio.Modeling.RolePlayerChangedEventArgs)">
            <summary>
            Reroute a connector when the role players of its underlying relationship change
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.ScheduleLayoutOnShapeDeleteRule">
            <summary>
            Class to schedule a layout every time a shape is deleted
            </summary>
            <summary>
            Class to schedule a layout whenever something is deleted from the diagram or a swimlane
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.ScheduleLayoutOnShapeDeleteRule.ElementDeleted(Microsoft.VisualStudio.Modeling.ElementDeletedEventArgs)">
            <summary>
            Called whenever a shape is deleted from a parent shape.
            </summary>
            <param name="e">Argument to event</param>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.ArcNodeLeafChangedEarlyRule">
            <summary>
            Earlier priority rule to downgrade elements when they are demoted from definition 
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.ArcNodeReparentMiddleRule">
            <summary>
            Middle priority rule to reparent ClassShapes representing ArcNodes that have been reparented after they've been disconnected and before they're reconnected.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.ArcNodeLeafChangedLateRule">
            <summary>
            Later priority rule to upgrade elements when they are promoted to Definition
            /// </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasRootsRecreateLinksRule">
            <summary>
            Rule triggered late when a root is added to the tree navigator to make sure it is linked up
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.DiagramTreeHasRootsRecreateLinksRule.ElementAdded(Microsoft.VisualStudio.Modeling.ElementAddedEventArgs)">
            <summary>
            Called when a DiagramTreeHasRoots association is created.
            </summary>
            <param name="e">Argument to event</param>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.MapConnectorLogicalRolePlayerChanged">
            <summary>
            Reroute a MapConnector when the role players of its logical endpoints change
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.MapConnectorLogicalRolePlayerChanged.RolePlayerChanged(Microsoft.VisualStudio.Modeling.RolePlayerChangedEventArgs)">
            <summary>
            Reroute a connector when the role players of its underlying relationship change
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.EnsureRelationshipHasBaseRelationshipRolePlayerChangedAsClass">
            <summary>
            Rule fires when a relationship gets a change of base relationship, make sure that both are shown as classes on the diagram.
            </summary>
            <remarks>
            Note priority must be before AddConnectionRulePriority as this expects then end-Nodes to be present.
            </remarks>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.EnsureRelationshipHasBaseRelationshipRolePlayerChangedAsClass.RolePlayerChanged(Microsoft.VisualStudio.Modeling.RolePlayerChangedEventArgs)">
            <summary>
            Rule fires when a relationship gets given a new base relationship 
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.EnsureRelationshipHasBaseRelationshipAddedAsClass">
            <summary>
            Rule fires when a relationship gets given a new base relationship, make sure that both are shown as classes on the diagram.
            </summary>
            <remarks>
            Note priority must be before AddConnectionRulePriority as this expects then end-Nodes to be present.
            </remarks>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDesigner.PropertyHasTypeRolePlayerChangedRule">
            <summary>
            Rule to update DomainProperty when its DomainType is changed.
            </summary>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.DslDesigner.PropertyHasTypeRolePlayerChangedRule.RolePlayerChanged(Microsoft.VisualStudio.Modeling.RolePlayerChangedEventArgs)">
            <summary>
            public virtual method for the client to have his own user-defined role player rule class
            </summary>
            <param name="e"></param>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.CriticalException.IsCriticalException(System.Exception)">
            <summary>
            	Gets whether exception is a critical one and can't be ignored with corrupting
            	AppDomain state.
            </summary>
            <param name="ex">Exception to test.</param>
            <returns>True if exception should not be swallowed.</returns>
        </member>
        <member name="M:Microsoft.VisualStudio.Modeling.CriticalException.ThrowOrShow(System.IServiceProvider,System.Exception)">
            <summary>
            	Shows non-critical exceptions to the user and returns false or
            	returns true for critical exceptions.
            </summary>
            <param name="serviceProvider">Service provider to use to display error message.</param>
            <param name="ex">Exception to handle.</param>
            <returns>True if exception is critical and can't be ignored.</returns>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.CriticalException.DisableExceptionFilter">
            <summary>
            	Gets whether exception filtering is disabled base on registry settings.
            </summary>
        </member>
        <member name="T:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources">
            <summary>
              A strongly-typed resource class, for looking up localized strings, etc.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.ResourceManager">
            <summary>
              Returns the cached ResourceManager instance used by this class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.Culture">
            <summary>
              Overrides the current thread's CurrentUICulture property for all
              resource lookups using this strongly typed resource class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.AccessibleName_InheritanceConnector">
            <summary>
              Looks up a localized string similar to Inheritance from {0} to {1}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.AccessibleName_MapConnector">
            <summary>
              Looks up a localized string similar to Map from {0} to {1}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.AccessibleName_RoleConnector">
            <summary>
              Looks up a localized string similar to {0} role {1} in relationship {2}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.ArgumentException_InvalidEnumValue">
            <summary>
              Looks up a localized string similar to Invalid enumeration value {0} for enum type {1}..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.ConnectorSource">
            <summary>
              Looks up a localized string similar to Source.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.ConnectorTarget">
            <summary>
              Looks up a localized string similar to Target.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.DomainEnumerationNoDefault">
            <summary>
              Looks up a localized string similar to (none).
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.ExpandCollapseButtonFieldAccessibleDescription">
            <summary>
              Looks up a localized string similar to Button to expand or collapse a sub tree..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.ExpandCollapseButtonFieldAccessibleName">
            <summary>
              Looks up a localized string similar to Expand Collapse Button.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.ExpectingDomainPathException">
            <summary>
              Looks up a localized string similar to Expecting an instance of DomainPath object..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.ExplorerTitle">
            <summary>
              Looks up a localized string similar to {0} Explorer.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.FailedToParsePath">
            <summary>
              Looks up a localized string similar to Failed to parse path &apos;{0}&apos;..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.FailedToResolvePath_InvalidPropertyName">
            <summary>
              Looks up a localized string similar to Failed to resolve path &apos;{0}&apos;, relationship &apos;{1}&apos; does not have role with PropertyName &apos;{2}&apos;..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.FailedToResolvePath_InvalidRole">
            <summary>
              Looks up a localized string similar to Failed to resolve path &apos;{0}&apos;, relationship &apos;{1}&apos; does not have role named &apos;{2}&apos;..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.FailedToResolvePath_NeedFullyQualifiedRelationship">
            <summary>
              Looks up a localized string similar to Failed to resolve path &apos;{0}&apos;, initial segment must provide a fully qualified relationship..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.FailedToResolvePath_UnknownRelationship">
            <summary>
              Looks up a localized string similar to Failed to resolve path &apos;{0}&apos;, unknown relationship &apos;{1}&apos;..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.ImageEditor_BitmapFilter">
            <summary>
              Looks up a localized string similar to Bitmap files(*.bmp)|*.bmp|All files(*.*)|*.*.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.ImageEditor_CursorFilter">
            <summary>
              Looks up a localized string similar to Cursor files(*.cur)|*.cur|All files(*.*)|*.*.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.ImageEditor_IconFilter">
            <summary>
              Looks up a localized string similar to Icon files(*.ico)|*.ico|All files(*.*)|*.*.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.ImageEditor_ImageFilter">
            <summary>
              Looks up a localized string similar to Image files(*.gif;*.jpg;*.jpeg;*.bmp;*.wmf;*.emf;*.png)|*.gif;*.jpg;*.jpeg;*.bmp;*.wmf;*.emf;*.png|All files(*.*)|*.*.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.ImageEditor_SelectBitmap">
            <summary>
              Looks up a localized string similar to Select Bitmap.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.ImageEditor_SelectCursor">
            <summary>
              Looks up a localized string similar to Select Cursor.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.ImageEditor_SelectIcon">
            <summary>
              Looks up a localized string similar to Select Icon.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.ImageEditor_SelectImage">
            <summary>
              Looks up a localized string similar to Select Image.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.InvalidDslPackageResourcesDirectory">
             <summary>
               Looks up a localized string similar to File &apos;{0}&apos; cannot be copied to a non-exist directory &apos;{1}&apos;.
            Please verify the directory exists..
             </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.InvalidIcoFile">
             <summary>
               Looks up a localized string similar to File &apos;{0}&apos; is not a valid icon file.
            Please verify this is a correct icon file..
             </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.InvalidPathToolTipTitle">
            <summary>
              Looks up a localized string similar to Invalid Path.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.MagicPropertyName_Color">
            <summary>
              Looks up a localized string similar to Color.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.MagicPropertyName_DashStyle">
            <summary>
              Looks up a localized string similar to DashStyle.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.MagicPropertyName_FillColor">
            <summary>
              Looks up a localized string similar to FillColor.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.MagicPropertyName_FillGradientMode">
            <summary>
              Looks up a localized string similar to FillGradientMode.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.MagicPropertyName_OutlineColor">
            <summary>
              Looks up a localized string similar to OutlineColor.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.MagicPropertyName_OutlineDashStyle">
            <summary>
              Looks up a localized string similar to OutlineDashStyle.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.MagicPropertyName_OutlineThickness">
            <summary>
              Looks up a localized string similar to OutlineThickness.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.MagicPropertyName_TextColor">
            <summary>
              Looks up a localized string similar to TextColor.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.MagicPropertyName_Thickness">
            <summary>
              Looks up a localized string similar to Thickness.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.MergeFailed_BaseShapeMap">
            <summary>
              Looks up a localized string similar to A merge of a ShapeMap was aborted because the source and target were not provided..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.MergeFailed_ConnectorMap">
            <summary>
              Looks up a localized string similar to A merge of a ConnectorMap was aborted because the source and target were not provided..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.MergeFailed_DomainRelationship">
            <summary>
              Looks up a localized string similar to A merge of a DomainRelationship was aborted because the source and target were not provided..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.MinimumMultiplicity_MissingLink">
            <summary>
              Looks up a localized string similar to {0} {1} has no {2}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.NamedClassToolToolboxItem">
            <summary>
              Looks up a localized string similar to Named Domain Class.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.NamedClassToolToolboxTooltip">
            <summary>
              Looks up a localized string similar to Create a Domain Class with a Name property.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.NamedDomainPropertyIdentifierTooLongError">
            <summary>
              Looks up a localized string similar to DomainProperty {0}.{1} cannot be an empty string or length over {2} bytes..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.NamePropertyName">
            <summary>
              Looks up a localized string similar to Name.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.PathDescription">
            <summary>
              Looks up a localized string similar to An expression for navigating across domain classes and relationships in a DSL definition..
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.PathDisplayName">
            <summary>
              Looks up a localized string similar to Path Definition.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.PathEditingSetValue">
            <summary>
              Looks up a localized string similar to Set {0} value.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.PathEditorComboTreeHelpText">
            <summary>
              Looks up a localized string similar to Editor for DomainPaths.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.PathMalformed">
            <summary>
              Looks up a localized string similar to &lt;malformed path&gt;.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.PropertyLineItemText">
            <summary>
              Looks up a localized string similar to  {0} : {1}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.RoleConnectorToolTipText">
             <summary>
               Looks up a localized string similar to Role Name: {0}
            Property Name: {1}
            Multiplicity: {2}.
             </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.Tracking_DomainClass_Description">
            <summary>
              Looks up a localized string similar to Description for {0}.{1}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.Tracking_DomainEnumeration_Description">
            <summary>
              Looks up a localized string similar to Description for {0}.{1}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.Tracking_DomainProperty_Description">
            <summary>
              Looks up a localized string similar to Description for {0}.{1}.{2}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.Tracking_DomainRelationship_EmbeddingName">
            <summary>
              Looks up a localized string similar to {0}Has{1}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.Tracking_DomainRelationship_ReferenceName">
            <summary>
              Looks up a localized string similar to {0}References{1}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.Tracking_DomainRole_Description">
            <summary>
              Looks up a localized string similar to Description for {0}.{1}.{2}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.Tracking_DslLibrary_Description">
            <summary>
              Looks up a localized string similar to Description for {0}.{1}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.Tracking_EnumerationLiteral_Description">
            <summary>
              Looks up a localized string similar to Description for {0}.{1}.{2}.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.Undo_ExpandCollapseInheritance">
            <summary>
              Looks up a localized string similar to Expand/Collapse Inheritance Tree.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.Undo_ExpandCollapseRelationships">
            <summary>
              Looks up a localized string similar to Expand/Collapse Relationship Tree.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.Undo_ExposeProperty">
            <summary>
              Looks up a localized string similar to Expose Diagram Element Property.
            </summary>
        </member>
        <member name="P:Microsoft.VisualStudio.Modeling.DslDefinition.Properties.Resources.Undo_ShowAsClass">
            <summary>
              Looks up a localized string similar to Show Relationship as Class.
            </summary>
        </member>
    </members>
</doc>
