/*****************************************************************************
	msobtn.h: enum of IDs for standard control names

	Owner: chrismcb
	Copyright (c) 1994-95 Microsoft Corporation
	Generated file!  Do not edit!

	WARNING!! Please read TBBTN.AWK.
	IDs for standard control names. Office will keep the names and bitmaps;
	clients can refer to them simply by ID.
 
	msotcid = ###, (Button Strip, Button Image) Label Note
	see \\office\plans96\misc\command bars\strips\Allicons.bmp for icons
*****************************************************************************/

enum
	{
	msotcidUser = 32768, // app-custom controls should use tcid >= msotcidUser
	msotcidNil = 0,		//(0,25) Label: '&Nil' NOTE: special value
	msotcidCustom = 1,		//(0,25) Label: '&Custom' NOTE: used for user-defined buttons
	msotcidSpelling = 2,		//(1,5) Label: '&Spelling...'
	msotcidSave = 3,		//(1,0) Label: '&Save' NOTE: File Save
	msotcidPrint = 4,		//(1,3) Label: '&Print...' NOTE: brings up the dialog -- use msotcidPrintDefault for the toolbar button
	msotcidWholePage = 5,		//(19,20) Label: '&One Page' NOTE: Full Page Zoom
	msotcidPageWidth = 6,		//(21,12) Label: '&Fit To Window' NOTE: Zoom to Page Width
	msotcidZoom100 = 7,		//(21,13) Label: '&Zoom 100%' NOTE: used to be in Word
	msotcidTable = 8,		//(1,14) Label: '&Insert Table...' NOTE: Insert Table
	msotcidColumns = 9,		//(1,16) Label: '&Columns...' NOTE: columns dialog -- use msotcidColumnsDropdown for columns grid control
	msotcidFrame = 10,		//(25,7) Label: '&Frame' NOTE: Insert Frame
	msotcidNumbering = 11,		//(0,26) Label: '&Numbering' NOTE: cf. NumberingVerticalTB & VerticalBT rotated icons
	msotcidBullets = 12,		//(0,27) Label: '&Bullets' NOTE: cf. BulletsVerticalTB and VerticalBT icons
	msotcidPortraitLandscape = 13,		//(18,22) Label: '&Portrait/Landscape' NOTE: Portrait / Landscape pages
	msotcidOutdent = 14,		//(0,28) Label: '&Decrease Indent' NOTE: cf. icons of OutdentVerticalTB and OutdentVerticalBT
	msotcidIndent = 15,		//(0,29) Label: '&Increase Indent' NOTE: cf. icons of IndentVerticalTB & IndentVerticalBT
	msotcidInsertDrawing = 16,		//(1,24) Label: '&Insert Drawing' NOTE: inserts a drawing object
	msotcidGraph = 17,		//(1,23) Label: 'C&hart' NOTE: Insert Picture cascade
	msotcidNew = 18,		//(0,11) Label: '&New...' NOTE: File New
	msotcidCopy = 19,		//(1,7) Label: '&Copy' NOTE: Copy
	msotcidUndo2 = 20,		//(48,2) Label: '&Undo' NOTE: Undo (obsolete)
	msotcidCut = 21,		//(1,6) Label: 'Cu&t' NOTE: Cut
	msotcidPaste = 22,		//(1,8) Label: '&Paste' NOTE: Paste
	msotcidOpen = 23,		//(0,10) Label: '&Open...' NOTE: File Open
	msotcidEnvelope = 24,		//(25,26) Label: '&Envelope' NOTE: Envelope - [PGM: is anyone using?]
	msotcidZoom = 25,		//(34,20) Label: '&Zoom' NOTE: Zoom (magnifying glass icon)
	msotcidEquation = 26,		//(4,11) Label: '&Equation Editor' NOTE: Equation Editor
	msotcidMicrophone = 27,		//(37,14) Label: '&Custom'
	msotcidPageView2 = 28,		//(56,25) Label: '&Page View' NOTE: Page View (obsolete)
	msotcidBacktrack = 29,		//(25,6) Label: '&Custom' NOTE: backtracking footprints
	msotcidBrush = 30,		//(27,20) Label: '&Pen Comment' NOTE: Pen Annotation
	msotcidPencil = 31,		//(59,9) Label: '&Custom' NOTE: Pencil
	msotcidFolder = 32,		//(27,16) Label: '&Custom' NOTE: Gray Folder
	msotcidClock = 33,		//(28,6) Label: '&Custom' NOTE: White Clock
	msotcidPasteJar = 34,		//(27,25) Label: '&Custom' NOTE: Paste Jar
	msotcidArrowToolbar = 35,		//(11,19) Label: '&Custom' NOTE: Arrow and Toolbar
	msotcidICantIdentifyIt = 36,		//(26,14) Label: '&Custom' NOTE: Boxes
	msotcidRepeat = 37,		//(4,14) Label: '&Repeat' NOTE: Repeat
	msotcidUpArrow2 = 38,		//(43,18) Label: '&Custom' NOTE: Blue Up Arrow
	msotcidRightArrow2 = 39,		//(26,6) Label: '&Custom' NOTE: Blue Right Arrow
	msotcidDownArrow2 = 40,		//(26,7) Label: '&Custom' NOTE: Blue Down Arrow
	msotcidLeftArrow2 = 41,		//(26,10) Label: '&Custom' NOTE: Blue Left Arrow
	msotcidWord = 42,		//(37,23) Label: '&Microsoft Word' NOTE: Microsoft Word
	msotcidUse_msotcidFlowchart_Instead = 43,		//(47,12) Label: '&Custom' NOTE: Flowchart (don't use)
	msotcidArrowAndPage = 44,		//(26,8) Label: '&Custom' NOTE: Arrow and Page
	msotcidUse_msotcidMail_Instead = 45,		//(26,9) Label: '&Custom' NOTE: Mail Slot (don't use)
	msotcidUse_msotcidFind_Instead = 46,		//(4,16) Label: '&Custom' NOTE: Find (don't use)
	msotcidClear = 47,		//(17,9) Label: 'Cle&ar' NOTE: Clear eraser
	msotcidUse_msotcidWatch_Instead = 48,		//(39,28) Label: '&Custom' NOTE: Eyeglasses (don't use)
	msotcidQuestion = 49,		//(23,18) Label: '&Custom' NOTE: Yellow Question Mark
	msotcidUse_msotcidCalculator_Instead = 50,		//(13,22) Label: '&Custom' NOTE: Calculator (don't use)
	msotcidBreakpoint = 51,		//(13,23) Label: '&Breakpoint' NOTE: Breakpoint
	msotcidPiggy = 52,		//(25,5) Label: '&Piggy Bank' NOTE: Piggy Bank
	msotcidPaperStack = 53,		//(36,20) Label: '&Custom' NOTE: Stack of Paper
	msotcidSingleSpacing = 54,		//(34,5) Label: '&Single Spacing'
	msotcidOneAndAHalfSpacing = 55,		//(13,4) Label: '&1.5 Spacing'
	msotcidDoubleSpacing = 56,		//(15,16) Label: '&Double Spacing'
	msotcidSuperscript = 57,		//(54,25) Label: '&Superscript'
	msotcidSubscript = 58,		//(4,3) Label: '&Subscript'
	msotcidHappyFace = 59,		//(7,23) Label: '&Happy Face!'
	msotcidDoubleUnderline = 60,		//(13,3) Label: '&Double Underline'
	msotcidWordUnderline = 61,		//(13,2) Label: '&Word Underline'
	msotcidGrowFont2 = 62,		//(13,1) Label: '&Grow Font'
	msotcidShrinkFont2 = 63,		//(13,17) Label: '&Shrink Font'
	msotcidKeyboard = 64,		//(13,18) Label: '&Custom'
	msotcidDialog2 = 65,		//(27,24) Label: '&Dialog Box' NOTE: Dialog Box
	msotcidUse_msotcidExcel_Instead = 66,		//(46,7) Label: '&Custom' NOTE: Microsoft Excel (don't use)
	msotcidTrashCan = 67,		//(37,6) Label: '&Custom'
	msotcidSpeaker = 68,		//(37,12) Label: '&Custom' NOTE: Loudspeaker
	msotcidScreen = 69,		//(28,11) Label: '&Custom'
	msotcid0 = 70,		//(44,24) Label: '&Number 0'
	msotcid1 = 71,		//(36,13) Label: 'Show Heading &1' NOTE: Word uses 1-9 for outline view
	msotcid2 = 72,		//(36,16) Label: 'Show Heading &2'
	msotcid3 = 73,		//(36,11) Label: 'Show Heading &3'
	msotcid4 = 74,		//(36,10) Label: 'Show Heading &4'
	msotcid5 = 75,		//(44,0) Label: 'Show Heading &5'
	msotcid6 = 76,		//(44,13) Label: 'Show Heading &6'
	msotcid7 = 77,		//(19,9) Label: 'Show Heading &7'
	msotcid8 = 78,		//(43,23) Label: 'Show Heading &8'
	msotcid9 = 79,		//(43,28) Label: 'Show Heading &9'
	msotcidA = 80,		//(48,27) Label: '&Letter A'
	msotcidB = 81,		//(48,28) Label: '&Letter B'
	msotcidC = 82,		//(48,29) Label: '&Letter C'
	msotcidD = 83,		//(49,0) Label: '&Letter D'
	msotcidE = 84,		//(49,1) Label: '&Letter E'
	msotcidF = 85,		//(49,2) Label: '&Letter F'
	msotcidG = 86,		//(49,3) Label: '&Letter G'
	msotcidH = 87,		//(49,4) Label: '&Letter H'
	msotcidI = 88,		//(49,5) Label: '&Letter I'
	msotcidJ = 89,		//(49,6) Label: '&Letter J'
	msotcidK = 90,		//(49,7) Label: '&Letter K'
	msotcidL = 91,		//(49,8) Label: '&Letter L'
	msotcidM = 92,		//(49,9) Label: '&Letter M'
	msotcidN = 93,		//(49,10) Label: '&Letter N'
	msotcidO = 94,		//(49,11) Label: '&Letter O'
	msotcidP = 95,		//(49,12) Label: '&Letter P'
	msotcidQ = 96,		//(49,13) Label: '&Letter Q'
	msotcidR = 97,		//(49,14) Label: '&Letter R'
	msotcidS = 98,		//(49,15) Label: '&Letter S'
	msotcidT = 99,		//(49,16) Label: '&Letter T'
	msotcidU = 100,		//(49,17) Label: '&Letter U'
	msotcidV = 101,		//(49,18) Label: '&Letter V'
	msotcidW = 102,		//(49,19) Label: '&Letter W'
	msotcidX = 103,		//(49,20) Label: '&Letter X'
	msotcidY = 104,		//(49,21) Label: '&Letter Y'
	msotcidZ = 105,		//(56,10) Label: '&Letter Z'
	msotcidClose = 106,		//(7,24) Label: '&Close' NOTE: File Close - cf. msotcidCloseWindow
	msotcidTableAutoFormat = 107,		//(6,28) Label: 'Table Auto&Format...' NOTE: use this for tables, grids, etc.
	msotcidFormatPainter = 108,		//(1,9) Label: '&Format Painter'
	msotcidPrintPreview = 109,		//(1,4) Label: 'Print Pre&view'
	msotcidCopyFormat = 110,		//(36,17) Label: '&Pick Up Style'
	msotcidPasteFormat = 111,		//(28,22) Label: '&Apply Style'
	msotcidBlank = 112,		//(39,16) Label: '&Custom' NOTE: Blank
	msotcidBold = 113,		//(0,20) Label: '&Bold'
	msotcidItalic = 114,		//(0,21) Label: '&Italic'
	msotcidUnderline = 115,		//(0,22) Label: '&Underline'
	msotcidGridBorder2 = 116,		//(37,7) Label: '&Custom' NOTE: XL Grid Borders
	msotcidBottomBorder2 = 117,		//(54,22) Label: '&Custom' NOTE: XL Bottom Border
	msotcidDarkShading2 = 118,		//(27,15) Label: '&Dark Shading' NOTE: XL Dk Gray Shading
	msotcidParagraphMark = 119,		//(3,14) Label: '&Show All' NOTE: Show All (used by Word)
	msotcidLeftJustify = 120,		//(0,23) Label: 'Align &Left' NOTE: use these 4 only for text formatting, see msotcidAlignObjectLeft for control or drawing alignment
	msotcidRightJustify = 121,		//(1,18) Label: 'Align &Right'
	msotcidCentered = 122,		//(0,24) Label: '&Center' NOTE: Centered (for text)
	msotcidFullJustify = 123,		//(2,28) Label: '&Justify'
	msotcidContextHelp = 124,		//(14,29) Label: 'What's &This?' NOTE: context sensitive help/quicktip -- only Ren uses as a menu item in 97...
	msotcidDate = 125,		//(24,23) Label: '&Date' NOTE: Insert Date
	msotcidTime = 126,		//(28,4) Label: '&Time' NOTE: Insert Time
	msotcidPageNumbers = 127,		//(7,26) Label: 'Page N&umbers...' NOTE: Insert Page Numbers
	msotcidUndo = 128,		//(1,10) Label: '&Undo'
	msotcidRedo = 129,		//(1,11) Label: '&Redo'
	msotcidLine = 130,		//(2,7) Label: '&Line' NOTE: drawing tool, may be obsolete?
	msotcidRectangle = 131,		//(37,26) Label: 'R&ectangle'
	msotcidLeftArrow = 132,		//(56,7) Label: '&Promote' NOTE: Outline Promote
	msotcidRightArrow = 133,		//(60,26) Label: '&Demote' NOTE: Outline Demote
	msotcidUpArrow = 134,		//(24,16) Label: 'Move &Up' NOTE: Outline Move Up
	msotcidDownArrow = 135,		//(12,12) Label: '&Move Down' NOTE: Outline Move Down
	msotcidDoubleRightArrow = 136,		//(13,20) Label: 'Demote to &Body Text' NOTE: Outline Body Text
	msotcidExpand2 = 137,		//(47,14) Label: '&Expand' NOTE: for outlining
	msotcidCollapse2 = 138,		//(48,15) Label: '&Collapse' NOTE: for outlining
	msotcidTextbox = 139,		//(2,11) Label: 'Te&xt Box'
	msotcidFindFile = 140,		//(47,10) Label: '&Find File...'
	msotcidFind = 141,		//(4,16) Label: '&Find...' NOTE: Edit Find (binoculars)
	msotcidExcelTable = 142,		//(1,15) Label: '&Insert Excel Spreadsheet' NOTE: Insert Excel Table
	msotcidPageBreak2 = 143,		//(47,8) Label: '&Page Break' NOTE: Insert Page Break
	msotcidWordAutoFormat = 144,		//(65,11) Label: '&AutoFormat...' NOTE: Word AutoFormat
	msotcidTopBorder = 145,		//(36,23) Label: '&Top Border' NOTE: Top Border
	msotcidBottomBorder = 146,		//(6,21) Label: '&Bottom Border' NOTE: Bottom Border
	msotcidLeftBorder = 147,		//(36,24) Label: '&Left Border' NOTE: Left Border
	msotcidRightBorder = 148,		//(36,25) Label: '&Right Border' NOTE: Right Border
	msotcidInsideBorder = 149,		//(36,26) Label: '&Inside Borders' NOTE: Inside Border
	msotcidBoxBorder = 150,		//(5,2) Label: '&Outside Borders' NOTE: Outside Border
	msotcidNoBorder = 151,		//(36,27) Label: '&No Border' NOTE: No Border
	msotcidEllipse = 152,		//(24,18) Label: '&Ellipse'
	msotcidArc = 153,		//(26,0) Label: '&Arc'
	msotcidFirstRecord = 154,		//(46,10) Label: '&First' NOTE: Mail Merge First Record
	msotcidPreviousRecord = 155,		//(46,11) Label: '&Previous' NOTE: Mail Merge Previous Record
	msotcidNextRecord = 156,		//(46,12) Label: '&Next' NOTE: Mail Merge Next Record
	msotcidLastRecord = 157,		//(67,23) Label: '&Last' NOTE: Mail Merge Last Record
	msotcidInsertMergeField = 158,		//(24,20) Label: '&Insert Merge Field' NOTE: Mail Merge Insert Field
	msotcidMergeToDocument = 159,		//(64,27) Label: '&Merge to Document' NOTE: Merge to Document
	msotcidMergeToPrinter = 160,		//(12,3) Label: '&Merge to Printer' NOTE: Merge to Printer
	msotcidCheckMerge = 161,		//(12,4) Label: '&Error Check Merge' NOTE: Error Check Merge
	msotcidEditTable = 162,		//(12,5) Label: '&Data Form' NOTE: Edit Source Table of merge - cf. msotcidDataForm for XL
	msotcidShowMergeData = 163,		//(22,24) Label: '&Show Fields/Values' NOTE: Show merge Fields / Values
	msotcidGroup = 164,		//(8,1) Label: '&Group' NOTE: Group drawing objects
	msotcidUngroup = 165,		//(8,2) Label: '&Ungroup' NOTE: Ungroup
	msotcidBringToFront = 166,		//(3,10) Label: 'Bring to Fron&t'
	msotcidSendToBack = 167,		//(46,3) Label: 'Send to Bac&k'
	msotcidAboveText = 168,		//(28,15) Label: 'Bring in F&ront of Text'
	msotcidBehindText = 169,		//(37,21) Label: 'Send Be&hind Text'
	msotcidBringForward = 170,		//(28,10) Label: 'Bring &Forward'
	msotcidSendBackward = 171,		//(37,25) Label: 'Send &Backward'
	msotcidMagnifier = 172,		//(29,0) Label: '&Magnifier' NOTE: Magnifier (used by Word Print Preview)
	msotcidShrinkOnePage = 173,		//(18,17) Label: '&Shrink One Page'
	msotcidBlank2 = 174,		//(39,16) Label: '&Custom' NOTE: use msotcidBlank if you need a blank button face
	msotcidUse_msotbcidWholePage_Instead = 175,		//(4,12) Label: '&Full Page View' NOTE: Full Page View (don't use)
	msotcidNotebook = 176,		//(64,10) Label: '&Custom' NOTE: custom face
	msotcidMultiplePages = 177,		//(21,10) Label: '&Multiple Pages' NOTE: Multi Page Zoom
	msotcidFullScreen = 178,		//(5,27) Label: 'F&ull Screen' NOTE: View Full Screen
	msotcidRuler = 179,		//(7,25) Label: '&Ruler' NOTE: View Ruler
	msotcidRoundedRectangle = 180,		//(24,26) Label: '&Rounded Rectangle'
	msotcidCassetteTape = 181,		//(34,29) Label: '&Voice Comment' NOTE: Voice Annotation
	msotcidPointer = 182,		//(2,6) Label: '&Select Objects' NOTE: Pointer (for drawing selection)
	msotcidFindInTable = 183,		//(21,11) Label: '&Find in Field' NOTE: Find in table
	msotcidRecord = 184,		//(63,19) Label: '&Record New Macro...' NOTE: Record macro
	msotcidPauseRecorder = 185,		//(25,29) Label: '&Pause Recording' NOTE: Pause Recorder
	msotcidPlay = 186,		//(4,17) Label: '&Macros...' NOTE: brings up the macro dialog
	msotcidTrace = 187,		//(24,27) Label: '&Trace' NOTE: Trace macro
	msotcidStepIn = 188,		//(24,28) Label: 'Step &In'
	msotcidPause = 189,		//(25,14) Label: '&Pause' NOTE: Pause macro
	msotcidFlowchart = 190,		//(23,21) Label: '&Macro...' NOTE: Macro (is anyone using this anymore?)
	msotcidDialog = 191,		//(28,13) Label: '&Dialog Editor' NOTE: Dialog Editor
	msotcidREM = 192,		//(28,14) Label: '&Comment Block' NOTE: VBE
	msotcidRecordOne = 193,		//(19,7) Label: '&Record Next' NOTE: Record Next
	msotcidStepOver = 194,		//(28,12) Label: 'Step &Over'
	msotcidSpiralNotebook = 195,		//(36,22) Label: '&Custom' NOTE: Spiral Notebook
	msotcidFlipHorizontal = 196,		//(37,18) Label: 'Flip &Horizontal'
	msotcidFlipVertical = 197,		//(37,10) Label: 'Flip &Vertical'
	msotcidRotateRight = 198,		//(36,8) Label: 'Rotate &Right' NOTE: rotate drawing objects
	msotcidRotateLeft = 199,		//(37,16) Label: 'Rotate &Left'
	msotcidPolygonFreehand = 200,		//(36,6) Label: '&Freeform'
	msotcidCallout = 201,		//(46,4) Label: '&Callout'
	msotcidMagnifierF = 202,		//(46,5) Label: '&Custom' NOTE: unused
	msotcidBorders = 203,		//(12,7) Label: '&Borders' NOTE: Borders Toolbar
	msotcidDrawing = 204,		//(1,24) Label: '&Drawing' NOTE: show Drawing toolbar
	msotcidAutoText = 205,		//(46,8) Label: 'AutoTe&xt...'
	msotcidEditPolygon = 206,		//(8,6) Label: '&Edit Points'
	msotcidFillColor = 207,		//(43,29) Label: '&Fill Color' NOTE: Toggles fill color on and off - use FillColorSplitDropdown for an MRU dropdown
	msotcidLineColor = 208,		//(36,7) Label: '&Line Color' NOTE: toggles line color - use LineColorSplitDropdown for an MRU dropdown
	msotcidCalloutOptions = 209,		//(27,21) Label: '&Callout Options' NOTE: Callout Options
	msotcidSortUp = 210,		//(1,21) Label: 'Sort &Ascending' NOTE: Sort Ascending
	msotcidSortDown = 211,		//(1,22) Label: 'Sort Des&cending' NOTE: Sort Descending
	msotcidDesign2 = 212,		//(9,11) Label: 'Table &Design' NOTE: Table Design
	msotcidAddRecord = 213,		//(65,26) Label: '&Add Record' NOTE: Add Record to table
	msotcidDeleteRecord = 214,		//(16,7) Label: '&Delete Record' NOTE: Delete Record from table
	msotcidUpdateFields = 215,		//(4,10) Label: '&Update Field' NOTE: Word
	msotcidDatabase = 216,		//(27,18) Label: '&Database...' NOTE: Insert Database
	msotcidGrid2 = 217,		//(7,10) Label: 'Gr&id...' NOTE: Grid Settings
	msotcidWordPicture = 218,		//(12,2) Label: 'Word Pict&ure' NOTE: Insert Word Picture
	msotcidEditBox = 219,		//(23,20) Label: '&Edit Box' NOTE: Edit Box
	msotcidCheckbox = 220,		//(21,19) Label: 'C&heck Box' NOTE: Checkbox
	msotcidCombo = 221,		//(55,5) Label: '&Combo Box' NOTE: Combo Box
	msotcidProperties = 222,		//(5,13) Label: 'Propert&ies' NOTE: Form Field Properties
	msotcidFieldShading = 223,		//(35,5) Label: '&Show Field Shading' NOTE: Show Field Shading
	msotcidNormalView = 224,		//(4,18) Label: '&Normal' NOTE: Normal View
	msotcidProtectForm = 225,		//(38,25) Label: '&Protect Form' NOTE: protect document for forms
	msotcidAutoSum = 226,		//(1,20) Label: '&AutoSum' NOTE: AutoSum
	msotcidLineStyle2 = 227,		//(47,15) Label: '&Line/Border Style' NOTE: Line Style
	msotcidStop = 228,		//(26,1) Label: '&Stop Recording' NOTE: Stop macro
	msotcidWatch = 229,		//(22,27) Label: '&Quick Watch' NOTE: Watch variable
	msotcidMasterDocumentView = 230,		//(25,23) Label: '&Master Document View' NOTE: Word - Master Document View
	msotcidCreateSubdocument = 231,		//(37,20) Label: '&Create Subdocument' NOTE: Create Subdocument
	msotcidDeleteSubdocument = 232,		//(28,5) Label: '&Delete Subdocument' NOTE: Delete Subdocument
	msotcidImportSubdocument = 233,		//(36,18) Label: '&Import Subdocument' NOTE: Import Subdocument
	msotcidSplitSubdocument = 234,		//(12,21) Label: '&Split Subdocument' NOTE: Split Subdocument
	msotcidMergeSubdocument = 235,		//(12,20) Label: '&Merge Subdocument' NOTE: Merge Subdocument
	msotcidProtectSubdocument = 236,		//(37,11) Label: '&Protect Subdocument' NOTE: Protect Subdocument
	msotcidHeaderOrFooter = 237,		//(46,6) Label: '&Show Header/Footer' NOTE: show header or show footer toggle
	msotcidPreviousHeader = 238,		//(11,17) Label: '&Previous Header' NOTE: Previous Header
	msotcidNextHeader = 239,		//(26,15) Label: '&Next Header' NOTE: Next Header
	msotcidNewHeader = 240,		//(33,20) Label: '&New Header' NOTE: New Header
	msotcidDeleteHeader = 241,		//(46,9) Label: '&Delete Header' NOTE: Delete Header
	msotcidAlign = 242,		//(10,7) Label: '&Align' NOTE: Align drawing objects
	msotcidArrow = 243,		//(2,8) Label: '&Arrow' NOTE: Arrow
	msotcidMainMergeDocument = 244,		//(25,27) Label: '&Main Document' NOTE: go to Main Document of mail merge
	msotcidMergeOptions = 245,		//(28,3) Label: '&Merge...' NOTE: Mail Merge Options
	msotcidMailMergeHelper = 246,		//(10,22) Label: 'Mail Me&rge...' NOTE: Mail Merge Helper
	msotcidPageSetup = 247,		//(57,29) Label: 'Page Set&up...' NOTE: Page Setup
	msotcidHideBodyText = 248,		//(58,0) Label: '&Hide Body Text' NOTE: Hide Body Text
	msotcidSelectRecords = 249,		//(58,1) Label: '&Select Records' NOTE: Select Records for mail merge
	msotcidLinkToPreviousHeader = 250,		//(58,2) Label: '&Link to Previous' NOTE: Link to Previous Header
	msotcidFirstLineView = 251,		//(58,3) Label: '&First Line Only View' NOTE: First Line Only View
	msotcidShowFormatting = 252,		//(7,9) Label: '&Show Formatting' NOTE: Show Formatting
	msotcidFontDialog = 253,		//(4,25) Label: '&Font...' NOTE: Format Font
	msotcidStyleDialog = 254,		//(8,19) Label: '&Style...' NOTE: Format Style
	msotcidFontSize = 255,		//(58,4) Label: '&Font Size' NOTE: icon for when msotcidFontSizeCombo is docked vertically
	msotcidBordersDialog = 256,		//(62,8) Label: '&Borders Dialog' NOTE: Borders Dialog
	msotcidShadingDialog = 257,		//(46,13) Label: '&Shading Dialog' NOTE: Shading Dialog
	msotcidSend = 258,		//(57,22) Label: 'S&end...' NOTE: NOTE: apps with a Send To cascade should use msotcidSendToMailRecipient
	msotcidRoutingSlip = 259,		//(10,1) Label: '&Routing Recipient...' NOTE: File / Send to  menu
	msotcidFootnote = 260,		//(39,26) Label: 'Foot&note...' NOTE: Insert Footnote
	msotcidWordArt = 261,		//(44,16) Label: '&WordArt...' NOTE: Use msotcidInsertTextEffect instead!
	msotcidMail = 262,		//(52,12) Label: 'Microsoft &Mail' NOTE: Microsoft Mail
	msotcidExcel = 263,		//(10,12) Label: 'Microsoft &Excel' NOTE: Microsoft Excel
	msotcidAccess = 264,		//(4,7) Label: 'Microsoft &Access' NOTE: Microsoft Access
	msotcidSchedule = 265,		//(17,12) Label: 'Microsoft &Schedule+' NOTE: Microsoft Schedule+
	msotcidFoxPro = 266,		//(17,11) Label: 'Microsoft Visual &FoxPro' NOTE: Microsoft Visual FoxPro
	msotcidPowerPoint = 267,		//(17,13) Label: 'Microsoft &PowerPoint' NOTE: Microsoft PowerPoint
	msotcidPublisher = 268,		//(21,8) Label: 'Microsoft Pu&blisher' NOTE: Microsoft Publisher
	msotcidProject = 269,		//(21,0) Label: 'Microsoft P&roject' NOTE: Microsoft Project
	msotcidFromDisk = 270,		//(19,21) Label: '&From Disk' NOTE: From Disk
	msotcidToDisk = 271,		//(21,21) Label: '&To Disk' NOTE: To Disk
	msotcidQuarterNote = 272,		//(4,6) Label: '&Musical Note' NOTE: Musical Note
	msotcidBell = 273,		//(9,12) Label: '&Bell' NOTE: Bell
	msotcidSpeechBalloon = 274,		//(9,13) Label: '&Speech Balloon' NOTE: Speech Balloon
	msotcidTelephone = 275,		//(9,14) Label: '&Telephone' NOTE: Telephone
	msotcidSadFace = 276,		//(9,15) Label: '&Sad Face' NOTE: Sad Face
	msotcidKey = 277,		//(9,16) Label: '&Key' NOTE: Key
	msotcidNotebook2 = 278,		//(9,17) Label: '&Big Notebook' NOTE: Big Notebook
	msotcidPushpin = 279,		//(9,18) Label: '&Pushpin' NOTE: Pushpin
	msotcidCamera = 280,		//(9,19) Label: '&Camera' NOTE: Camera
	msotcidVideoCamera = 281,		//(9,20) Label: '&Video Camera' NOTE: Video Camera
	msotcidButton = 282,		//(9,21) Label: '&Button' NOTE: Button
	msotcidCalculator = 283,		//(9,22) Label: '&Calculator' NOTE: Calculator
	msotcidBookshelf = 284,		//(9,23) Label: '&Microsoft Bookshelf' NOTE: Microsoft Bookshelf
	msotcidPresentIt = 285,		//(9,24) Label: 'Microsoft &PowerPoint' NOTE: Present It
	msotcidSolitaire = 286,		//(9,25) Label: '&Solitaire' NOTE: Solitaire
	msotcidPageLayoutView = 287,		//(4,20) Label: '&Print Layout' NOTE: Page Layout
	msotcidFieldCodes = 288,		//(9,27) Label: 'View Fiel&d Codes' NOTE: View Field Codes
	msotcidDropCap = 289,		//(9,28) Label: '&Drop Cap...' NOTE: Drop Cap
	msotcidStrikethrough2 = 290,		//(9,29) Label: '&Strikethrough' NOTE: Strikethrough
	msotcidSmallCaps = 291,		//(10,0) Label: '&Small Caps' NOTE: Small Caps
	msotcidDeleteCells = 292,		//(8,22) Label: '&Delete Cells' NOTE: Delete Cells
	msotcidDeleteRows = 293,		//(10,2) Label: 'Delete &Rows' NOTE: Delete Rows
	msotcidDeleteColumns = 294,		//(10,3) Label: 'Delete &Columns' NOTE: Delete Columns
	msotcidInsertCells = 295,		//(10,4) Label: 'C&ells...' NOTE: Insert Cells
	msotcidInsertRows = 296,		//(10,5) Label: '&Rows' NOTE: Insert Rows
	msotcidInsertColumns = 297,		//(10,6) Label: '&Columns' NOTE: Insert Columns
	msotcidArrangeWindows = 298,		//(8,7) Label: '&Arrange All' NOTE: Arrange Windows
	msotcidAdjustMargins = 299,		//(10,8) Label: '&Adjust Margins' NOTE: Adjust Margins
	msotcidGridlines = 300,		//(16,27) Label: 'Grid&lines' NOTE: Word - table gridlines, don't use for other kinds of gridlines
	msotcidOpenSubdocument = 301,		//(10,10) Label: '&Open Subdocument' NOTE: Open Subdocument
	msotcidSplit = 302,		//(10,11) Label: '&Split' NOTE: Split Window
	msotcidNewWindow = 303,		//(8,26) Label: '&New Window' NOTE: New Window
	msotcidCompareDocuments = 304,		//(10,13) Label: '&Legal Blackline...' NOTE: Compare
	msotcidRevisionsAcceptRejectChanges = 305,		//(0,25) Label: '&Accept or Reject Changes...' NOTE: review revisions
	msotcidAllCaps = 306,		//(10,15) Label: '&All Caps' NOTE: All Caps
	msotcidDisassembleMetafile = 307,		//(10,16) Label: '&Disassemble Picture' NOTE: Disassemble Picture
	msotcidSymbol = 308,		//(10,17) Label: '&Symbol...' NOTE: Insert Symbol
	msotcidChangeCase = 309,		//(10,18) Label: 'Change Cas&e...' NOTE: Change Case
	msotcidShrinkFont1Pt = 310,		//(10,19) Label: '&Shrink Font 1 Pt' NOTE: Shrink Font One Point
	msotcidGrowFont1Pt = 311,		//(10,20) Label: '&Grow Font 1 Pt' NOTE: Grow Font One Point
	msotcidRepaginate = 312,		//(10,21) Label: '&Repaginate' NOTE: Repaginate
	msotcidReplace = 313,		//(8,11) Label: 'R&eplace...' NOTE: Replace
	msotcidStartOfLine = 314,		//(10,23) Label: '&Start of Line' NOTE: Start of Line
	msotcidEndOfLine = 315,		//(10,24) Label: '&End of Line' NOTE: End of Line
	msotcidPageUp = 316,		//(10,25) Label: '&Page Up' NOTE: Page Up
	msotcidPageDown = 317,		//(10,26) Label: '&Page Down' NOTE: Page Down
	msotcidTextboxVertical = 318,		//(2,12) Label: '&Vertical Text Box' NOTE: Vertical Textbox
	msotcidStartOfDocument = 319,		//(10,28) Label: '&Start of Document' NOTE: Start of Document
	msotcidEndOfDocument = 320,		//(10,29) Label: '&End of Document' NOTE: End of Document
	msotcidAOCENextLetter = 321,		//(11,0) Label: '&Next Letter' NOTE: AOCE (Apple) mail commands-Mac only
	msotcidAOCEAddMailer = 322,		//(11,1) Label: 'Add &Mailer' NOTE: AOCE Add Mailer
	msotcidAOCEDeleteMailer = 323,		//(11,2) Label: '&Delete Mailer' NOTE: AOCE Delete Mailer
	msotcidAOCEExpandMailer = 324,		//(11,3) Label: '&Expand Mailer' NOTE: AOCE Expand Mailer
	msotcidAOCESendMail = 325,		//(11,4) Label: '&Send Mail' NOTE: AOCE Send Mail
	msotcidAOCEReplyMail = 326,		//(11,5) Label: '&Reply' NOTE: AOCE Reply Mail
	msotcidAOCEReplyAllMail = 327,		//(11,6) Label: 'Reply &All' NOTE: AOCE Reply All Mail
	msotcidAOCEForwardMail = 328,		//(11,7) Label: '&Forward' NOTE: AOCE Forward Mail
	msotcidGrammar = 329,		//(11,8) Label: '&Grammar...' NOTE: Grammar
	msotcidNO = 330,		//(11,9) Label: '&Not Applicable' NOTE: Not Applicable
	msotcidSwitcher_Close_CloseAll = 331,		//(7,24) Label: '&Close' NOTE: context sensitive, Close or Close All
	msotcidSwitcher_TextToOrFromTable = 332,		//(48,13) Label: '&Text to/from Table' NOTE: context sensitive, Text to Table or Table to Text
	msotcidSwitcher_InsertTableRowColumnCells = 333,		//(1,14) Label: '&Insert Table' NOTE: context sensitive, Insert Table/Row/Column/Cells
	msotcidSwitcher_DeleteRowColumnCells = 334,		//(48,13) Label: '&Delete Rows/Columns/Cells' NOTE: context sensitive, Delete Cell/Row/Column
	msotcidSwitcher_Redo_Repeat = 335,		//(48,13) Label: '&Repeat' NOTE: context sensitive, Redo or Repeat
	msotcidSwitcher_Protect_Unprotect = 336,		//(0,25) Label: '&Protect Document' NOTE: context sensitive, Protect or Unprotect
	msotcidSwitcher_InsertFrame_FormatFrame = 337,		//(48,13) Label: '&Insert Frame' NOTE: context sensitive, Insert or Format Frame
	msotcidRegroup = 338,		//(8,3) Label: 'Regr&oup' NOTE: regroup (Escher)
	msotcidThreeDee = 339,		//(2,24) Label: '&3-D Style' NOTE: 3D
	msotcidHighlight = 340,		//(5,3) Label: '&Highlight' NOTE: Highlight
	msotcidTipWizardBox = 341,		//(11,20) Label: '&Tip Wizard 1' NOTE: Tip Wizard Box
	msotcidTipWizardOff = 342,		//(11,21) Label: '&Tip Wizard 2' NOTE: Tip Wizard Off
	msotcidTipWizard = 343,		//(11,22) Label: '&Tip Wizard 3' NOTE: Tip Wizard On
	msotcidTipWizardBlank = 344,		//(0,25) Label: '&Tip Wizard 4' NOTE: Tip Wizard Blank
	msotcidTipWizardHelp = 345,		//(11,24) Label: '&Tip Wizard 5' NOTE: Tip Wizard Help
	msotcidTipWizardChange = 346,		//(11,25) Label: '&Tip Wizard 6' NOTE: Tip Wizard Change
	msotcidTipWizardChange0 = 347,		//(11,26) Label: '&Tip Wizard 7' NOTE: Tip Wizard Change 0
	msotcidTipWizardUndo = 348,		//(11,27) Label: '&Tip Wizard 8' NOTE: Tip Wizard Undo
	msotcidTipWizardInactive = 349,		//(11,28) Label: '&Tip Wizard 9' NOTE: Tip Wizard Inactive
	msotcidTipWizardArrow = 350,		//(11,29) Label: '&Tip Wizard 10' NOTE: Tip Wizard Arrow
	msotcidTipWizard1 = 351,		//(11,22) Label: '&Tip Wizard 11' NOTE: Tip Wizard 1
	msotcidTipWizardRed = 352,		//(11,23) Label: '&Tip Wizard 12' NOTE: Tip Wizard Red
	msotcidAddressBook = 353,		//(6,9) Label: 'Address &Book...' NOTE: Address Book
	msotcidReply = 354,		//(6,4) Label: '&Reply' NOTE: Reply
	msotcidReplyAll = 355,		//(6,5) Label: 'Reply to A&ll' NOTE: Reply All
	msotcidForward = 356,		//(6,6) Label: 'For&ward' NOTE: Forward
	msotcidMailMove = 357,		//(12,6) Label: '&Move Mail' NOTE: ???is this obsolete 'cause of Move?
	msotcidMailDelete = 358,		//(43,19) Label: '&Delete Mail' NOTE: Delete Mail
	msotcidPreviousMessage = 359,		//(55,10) Label: '&Item' NOTE: Previous Message
	msotcidNextMessage = 360,		//(17,8) Label: '&Item' NOTE: Next Message
	msotcidMailCheckNames = 361,		//(67,25) Label: 'Chec&k Names' NOTE: Check Names
	msotcidMailSelectNames = 362,		//(12,11) Label: 'Select &Names...' NOTE: Select Names
	msotcidSend2 = 363,		//(61,12) Label: 'Se&nd...' NOTE: Send
	msotcidPrintArea = 364,		//(12,13) Label: '&Set Print Area' NOTE: Set Print Area
	msotcidNewMacro = 365,		//(12,14) Label: '&Insert MS Excel 4.0 Macro'
	msotcidNewWorksheet = 366,		//(12,15) Label: '&Insert Worksheet' NOTE: Excel
	msotcidNewChart = 367,		//(12,16) Label: '&Insert Chart Sheet'
	msotcidClearFormatting = 368,		//(12,17) Label: '&Clear Formatting'
	msotcidPasteFormatting = 369,		//(12,18) Label: '&Paste Formatting'
	msotcidPasteValues = 370,		//(12,19) Label: '&Paste Values'
	msotcidFillRight = 371,		//(8,0) Label: '&Right'
	msotcidFillDown = 372,		//(7,29) Label: '&Down'
	msotcidEquals = 373,		//(12,22) Label: '&Equal Sign' NOTE: Equals Sign
	msotcidPlus = 374,		//(12,23) Label: '&Plus Sign' NOTE: Plus Sign
	msotcidMinus = 375,		//(12,24) Label: '&Minus Sign' NOTE: Minus Sign
	msotcidMultiply = 376,		//(12,25) Label: '&Multiplication Sign' NOTE: Multiply Sign
	msotcidDivide = 377,		//(12,26) Label: '&Division Sign' NOTE: Divide Sign
	msotcidExponent = 378,		//(12,27) Label: '&Exponentiation Sign' NOTE: Exponent Sign
	msotcidLeftParenthesis = 379,		//(12,28) Label: '&Left Parenthesis' NOTE: Left Parenthesis
	msotcidRightParenthesis = 380,		//(12,29) Label: '&Right Parenthesis' NOTE: Right Parenthesis
	msotcidColon = 381,		//(13,0) Label: '&Colon' NOTE: Colon
	msotcidComma = 382,		//(13,16) Label: '&Comma' NOTE: Comma
	msotcidPercent = 383,		//(13,15) Label: '&Percent Sign' NOTE: Percent Sign
	msotcidDollar = 384,		//(13,14) Label: '&Dollar Sign' NOTE: Dollar Sign
	msotcidFunction = 385,		//(14,7) Label: '&Function...' NOTE: Function Wizard
	msotcidCharacterScaling = 386,		//(24,3) Label: '&Character Scaling' NOTE: Word
	msotcidConstrainToNumbers = 387,		//(13,6) Label: '&Constrain Numeric' NOTE: Constrain to Numbers
	msotcidBoxBorder2 = 388,		//(13,7) Label: '&XL Outline Border' NOTE: XL Outline Border
	msotcidLeftBorder2 = 389,		//(13,8) Label: '&XL Left Border' NOTE: XL Left Border
	msotcidRightBorder2 = 390,		//(13,9) Label: '&XL Right Border' NOTE: XL Right Border
	msotcidTopBorder2 = 391,		//(13,10) Label: '&XL Top Border' NOTE: XL Top Border
	msotcidDoubleBottomBorder2 = 392,		//(13,11) Label: '&XL Double Border' NOTE: don't use - XL Double Border
	msotcidLightShading2 = 393,		//(13,12) Label: '&Light Shading' NOTE: XL Light Shading
	msotcidShadow = 394,		//(2,23) Label: '&Shadow Style' NOTE: Shadow
	msotcidCurrencyFormat = 395,		//(6,16) Label: '&Currency Style' NOTE: Currency Format
	msotcidPercentageFormat = 396,		//(6,17) Label: '&Percent Style' NOTE: Percentage Format
	msotcidCommaFormat = 397,		//(6,18) Label: '&Comma Style' NOTE: Comma Format
	msotcidIncreaseDecimals = 398,		//(6,19) Label: '&Increase Decimal' NOTE: Increase Decimal Places
	msotcidDecreaseDecimals = 399,		//(6,20) Label: '&Decrease Decimal' NOTE: Decrease Decimal Places
	msotcidStrikethrough = 400,		//(13,19) Label: '&Strikethrough' NOTE: Strikethrough
	msotcidFontColor = 401,		//(2,19) Label: '&Font Color' NOTE: Font Color
	msotcidCenterAcross = 402,		//(1,19) Label: '&Merge and Center' NOTE: Center Across Columns
	msotcidGrowFont = 403,		//(3,4) Label: '&Increase Font Size' NOTE: Excel [PGM -- same icon as GrowFont1Pt)
	msotcidShrinkFont = 404,		//(3,3) Label: '&Decrease Font Size' NOTE: Shrink Font
	msotcidStackedText = 405,		//(13,24) Label: '&Vertical Text' NOTE: Stacked Orientation
	msotcidClimbingText = 406,		//(13,25) Label: '&Rotate Text Up' NOTE: Climbing Orientation
	msotcidDescendingText = 407,		//(13,26) Label: '&Rotate Text Down' NOTE: Descending Orientation
	msotcidDistributeHorizontally = 408,		//(13,27) Label: 'Distribute &Horizontally' NOTE: Escher - spreads out objects horizontally
	msotcidFreehand = 409,		//(13,28) Label: '&Scribble' NOTE: Freehand
	msotcidMarqueeSelect = 410,		//(13,29) Label: '&Select Graphics' NOTE: Select Graphics
	msotcidPolygon = 411,		//(14,0) Label: '&Polygon' NOTE: Polygon
	msotcidFilledRectangle = 412,		//(14,1) Label: '&Filled Rectangle' NOTE: Filled Rectangle
	msotcidFilledEllipse = 413,		//(14,2) Label: '&Filled Ellipse' NOTE: Filled Ellipse
	msotcidFilledArc = 414,		//(14,3) Label: '&Filled Arc' NOTE: Filled Arc
	msotcidFilledPolygon = 415,		//(14,4) Label: '&Filled Polygon' NOTE: Filled Polygon
	msotcidFilledPolygonFreehand = 416,		//(14,5) Label: '&Filled Freeform' NOTE: Filled Polygon/Freehand
	msotcidColor = 417,		//(25,8) Label: '&Color' NOTE: Color
	msotcidAreaChart = 418,		//(5,22) Label: '&Area Chart' NOTE: Area Chart
	msotcidBarChart = 419,		//(14,8) Label: '&Bar Chart' NOTE: Bar Chart
	msotcidColumnChart = 420,		//(14,9) Label: '&Column Chart' NOTE: Column Chart
	msotcidStackedColumnChart = 421,		//(35,7) Label: '&Stacked Column Chart' NOTE: Stacked Column Chart
	msotcidLineChart = 422,		//(14,11) Label: '&Line Chart' NOTE: Line Chart
	msotcidPieChart = 423,		//(14,12) Label: '&Pie Chart' NOTE: Pie Chart
	msotcidAreaChart3D = 424,		//(14,13) Label: '&3-D Area Chart' NOTE: 3-D Area Chart
	msotcidBarChart3D = 425,		//(14,14) Label: '&3-D Bar Chart' NOTE: 3-D Bar Chart
	msotcidColumnChart3D = 426,		//(36,3) Label: '&3-D Clustered Column Chart' NOTE: 3-D Column Chart
	msotcidPerspectiveChart3D = 427,		//(14,16) Label: '&3-D Column Chart' NOTE: 3-D Perspective Chart
	msotcidLineChart3D = 428,		//(14,17) Label: '&3-D Line Chart' NOTE: 3-D Line Chart
	msotcidPieChart3D = 429,		//(14,18) Label: '&3-D Pie Chart' NOTE: 3-D Pie Chart
	msotcidXYChart = 430,		//(14,19) Label: '&(XY) Scatter Chart' NOTE: Scatter (XY) Chart
	msotcidSurfaceChart3D = 431,		//(14,20) Label: '&3-D Surface Chart' NOTE: 3-D Surface Chart
	msotcidRadarChart = 432,		//(14,21) Label: '&Radar Chart' NOTE: Radar Chart
	msotcidLineColumnChart = 433,		//(36,19) Label: '&Line/Column Chart' NOTE: Line/Column Chart
	msotcidStockChart = 434,		//(35,17) Label: '&Volume/High-Low-Close Chart' NOTE: Volume High-Low-Close Chart
	msotcidDefaultChart = 435,		//(23,27) Label: '&Default Chart' NOTE: Default Chart Format
	msotcidChartWizard = 436,		//(1,23) Label: '&Chart Wizard' NOTE: Chart Wizard
	msotcidHorizontalGridlines = 437,		//(5,24) Label: '&Value Axis Gridlines' NOTE: Horizontal Gridlines
	msotcidVerticalGridlines = 438,		//(5,23) Label: '&Category Axis Gridlines' NOTE: Vertical Gridlines
	msotcidLegend = 439,		//(6,25) Label: '&Legend' NOTE: Legend
	msotcidOutlineSymbols = 440,		//(25,13) Label: '&Show Outline Symbols' NOTE: Outline Symbols
	msotcidSelectVisible = 441,		//(25,25) Label: '&Select Visible Cells' NOTE: Select Visible Cells
	msotcidSelectRegion = 442,		//(25,24) Label: '&Select Current Region' NOTE: Select Region
	msotcidFreezePanes = 443,		//(25,11) Label: '&Freeze Panes'
	msotcidZoomIn = 444,		//(3,16) Label: '&Zoom In' NOTE: Zoom In
	msotcidZoomOut = 445,		//(3,15) Label: '&Zoom Out' NOTE: Zoom Out
	msotcidRadioButton = 446,		//(15,5) Label: 'O&ption Button' NOTE: Excel
	msotcidScrollBar = 447,		//(15,6) Label: '&Scroll Bar' NOTE: Scroll Bar
	msotcidListBox = 448,		//(15,7) Label: 'L&ist Box' NOTE: List Box
	msotcidDoughnutChart = 449,		//(14,15) Label: '&Doughnut Chart' NOTE: Doughnut Chart
	msotcidUntraceDependents = 450,		//(15,9) Label: '&Remove Dependent Arrows' NOTE: Remove Dependent Arrows
	msotcidTraceDependents = 451,		//(15,10) Label: 'Trace &Dependents' NOTE: Trace Dependents
	msotcidUntracePrecedents = 452,		//(15,11) Label: '&Remove Precedent Arrows' NOTE: Remove Precedent Arrows
	msotcidRemoveAllArrows = 453,		//(15,12) Label: 'Remove &All Arrows' NOTE: Remove All Arrows
	msotcidAttachNote = 454,		//(15,13) Label: '&Attach Note' NOTE: Attach Note
	msotcidUpdateReadOnly = 455,		//(15,14) Label: '&Update File' NOTE: Update Read-Only File
	msotcidReadOnly = 456,		//(15,15) Label: '&Toggle Read Only' NOTE: Toggle Read-Only
	msotcidPivotTable = 457,		//(14,26) Label: '&Wizard...' NOTE: Pivot Table
	msotcidFilter = 458,		//(15,17) Label: 'Auto&Filter' NOTE: Excel - is this redundant with msotcidAutoFilter?  Should that ID have this icon too?
	msotcidUpdate = 459,		//(7,1) Label: '&Refresh Data' NOTE: Refresh Data
	msotcidPivotTableField = 460,		//(7,4) Label: 'Field Setti&ngs...' NOTE: PivotTable Field
	msotcidShowPages = 461,		//(15,20) Label: 'Show &Pages...' NOTE: Show Pages
	msotcidExpand = 462,		//(7,0) Label: '&Show Detail' NOTE: Show Detail
	msotcidError = 463,		//(15,22) Label: 'Trace &Error' NOTE: Trace Error
	msotcidCollapse = 464,		//(6,29) Label: '&Hide Detail' NOTE: Hide Detail
	msotcidDistributeVertically = 465,		//(15,24) Label: 'Distribute &Vertically' NOTE: Escher - distributes objects evenly vertically
	msotcidSelectAllDrawingObjects = 466,		//(15,25) Label: '&Select All Drawing Objects' NOTE: Escher - selects all drawing objects
	msotcidGroupBox = 467,		//(15,26) Label: '&Group Box' NOTE: Group Box
	msotcidSpinner = 468,		//(15,27) Label: '&Spinner' NOTE: Spinner
	msotcidTabOrder = 469,		//(15,28) Label: 'Ta&b Order...' NOTE: Tab Order
	msotcidLightSwitch = 470,		//(15,29) Label: '&Run Dialog' NOTE: Run Dialog
	msotcidCombinationListEdit = 471,		//(16,0) Label: '&Combination List-Edit' NOTE: Combination List-Edit
	msotcidModule = 472,		//(16,1) Label: '&Insert Module' NOTE: Insert Module
	msotcidObjectBrowser = 473,		//(21,23) Label: '&Object Browser' NOTE: Object Browser
	msotcidMenu = 474,		//(16,3) Label: '&Menu Editor' NOTE: Menu Editor
	msotcidCombinationDropdownEdit = 475,		//(16,4) Label: '&Combination Drop-Down Edit' NOTE: Combination Drop-Down Edit
	msotcidLabel = 476,		//(16,5) Label: '&Label' NOTE: Label
	msotcidIntegral = 477,		//(16,6) Label: '&Custom' NOTE: Integral
	msotcidDelete = 478,		//(6,3) Label: '&Delete' NOTE: Delete
	msotcidFish = 479,		//(16,8) Label: '&Custom' NOTE: Fish
	msotcidCoffee = 480,		//(16,9) Label: '&Custom' NOTE: Coffee Mug
	msotcidHeart = 481,		//(16,10) Label: '&Custom' NOTE: Heart
	msotcidDiamond = 482,		//(16,11) Label: '&Custom' NOTE: Diamond
	msotcidSpade = 483,		//(16,12) Label: '&Custom' NOTE: Spade
	msotcidClub = 484,		//(16,13) Label: '&Custom' NOTE: Club
	msotcidGrid = 485,		//(16,14) Label: '&Grid' NOTE: Grid
	msotcidTracePrecedents = 486,		//(16,15) Label: '&Trace Precedents' NOTE: Trace Precedents
	msotcidInfo = 487,		//(16,16) Label: '&Show Info Window' NOTE: Show Info Window
	msotcidEditCode = 488,		//(16,17) Label: '&Code' NOTE: Excel [PGM OBSOLETE - use msotcidCodeWindow instead]
	msotcidInsertDialog = 489,		//(16,18) Label: '&Dialog' NOTE: Insert Dialog
	msotcidBorderWidth1 = 490,		//(16,19) Label: '&Line/Border Width' NOTE: Border Width 1
	msotcidBorderWidth2 = 491,		//(16,20) Label: '&Line/Border Width' NOTE: Border Width 2
	msotcidBorderWidth3 = 492,		//(16,21) Label: '&Line/Border Width' NOTE: Border Width 3
	msotcidBorderWidth4 = 493,		//(16,22) Label: '&Line/Border Width' NOTE: Border Width 4
	msotcidBorderWidth5 = 494,		//(16,23) Label: '&Line/Border Width' NOTE: Border Width 5
	msotcidBorderWidth6 = 495,		//(16,24) Label: '&Line/Border Width' NOTE: Border Width 6
	msotcidBorderWidthHairline = 496,		//(16,25) Label: '&Line/Border Width' NOTE: Hairline Border
	msotcidApplyFilter = 497,		//(18,21) Label: 'Appl&y Filter/Sort' NOTE: Apply Filter
	msotcidDatasheetView = 498,		//(5,18) Label: 'View Data&sheet' NOTE: Datasheet View
	msotcidEditFilter = 499,		//(16,28) Label: '&Advanced Filter/Sort...' NOTE: Edit Filter
	msotcidSubform = 500,		//(16,29) Label: '&Subform' NOTE: Subform / Subreport
	msotcidFieldList = 501,		//(17,0) Label: 'Field &List' NOTE: Field List
	msotcidFormView = 502,		//(17,1) Label: '&Form View' NOTE: Form View
	msotcidAlignGeneral = 503,		//(17,2) Label: '&Align General' NOTE: General Alignment
	msotcidSortingGrouping = 504,		//(17,3) Label: '&Sorting and Grouping' NOTE: Sorting and Grouping
	msotcidPrimaryKey = 505,		//(17,4) Label: 'Primary &Key' NOTE: Primary Key
	msotcidNextProcedure = 506,		//(17,5) Label: '&Next Procedure' NOTE: Next Procedure
	msotcidBoundObjectFrame = 507,		//(38,28) Label: '&Bound Object Frame' NOTE: Bound Object Frame
	msotcidUnboundObjectFrame = 508,		//(38,29) Label: '&Unbound Object Frame' NOTE: Unbound Object Frame
	msotcidPageBreak = 509,		//(15,18) Label: 'Page &Break' NOTE: Page Break
	msotcidPreviousProcedure = 510,		//(55,21) Label: '&Previous Procedure' NOTE: Previous Procedure
	msotcidPrintSetup = 511,		//(17,10) Label: 'P&rint Setup...'
	msotcidNewForm = 512,		//(9,3) Label: '&Form' NOTE: New Form
	msotcidNewQuery = 513,		//(9,2) Label: '&Query' NOTE: New Query
	msotcidNewReport = 514,		//(9,4) Label: '&Report' NOTE: New Report
	msotcidRestart = 515,		//(17,14) Label: '&Reset' NOTE: Restart a macro
	msotcidShowConditionsColumn = 516,		//(17,15) Label: '&Conditions' NOTE: Show Conditions Column
	msotcidShowAllRecords = 517,		//(17,16) Label: '&Show All Records' NOTE: Show All Records
	msotcidShowNamesColumn = 518,		//(17,17) Label: '&Macro Names' NOTE: Show macro name column
	msotcidToolLock = 519,		//(17,18) Label: '&Tool Lock' NOTE: Tool Lock
	msotcidToggleButton = 520,		//(47,9) Label: 'To&ggle Button' NOTE: Toggle Button
	msotcidRunMacro = 521,		//(67,26) Label: 'R&un Macro' NOTE: Run Macro
	msotcidOptions = 522,		//(0,25) Label: '&Options...' NOTE: Tools Options
	msotcidRelationships = 523,		//(5,14) Label: '&Relationships...' NOTE: Relationships
	msotcidImport = 524,		//(17,23) Label: '&Import...' NOTE: Import
	msotcidExport = 525,		//(17,24) Label: '&Export...' NOTE: Export
	msotcidAttachTable = 526,		//(17,25) Label: '&Attach Table...' NOTE: Attach Table
	msotcidEditIndexes = 527,		//(17,26) Label: '&Indexes' NOTE: Edit Indexes
	msotcidSQL = 528,		//(17,27) Label: 'S&QL View' NOTE: SQL
	msotcidTableNames = 529,		//(17,28) Label: 'Table &Names' NOTE: shows table names in the query builder
	msotcidAddTable = 530,		//(17,29) Label: 'S&how Table...'
	msotcidSelectQueryType = 531,		//(18,0) Label: '&Select Query' NOTE: changes the query type
	msotcidCrosstabQueryType = 532,		//(18,1) Label: 'Crossta&b Query'
	msotcidMakeTableQueryType = 533,		//(18,2) Label: 'Ma&ke Table Query...'
	msotcidUpdateQueryType = 534,		//(18,3) Label: '&Update Query'
	msotcidAppendQueryType = 535,		//(18,4) Label: 'A&ppend Query...'
	msotcidDeleteQueryType = 536,		//(18,5) Label: '&Delete Query'
	msotcidQueryParameters = 537,		//(18,6) Label: 'Para&meters...'
	msotcidSaveRecord = 538,		//(18,7) Label: 'Save Rec&ord'
	msotcidNewRecord = 539,		//(4,4) Label: 'Ne&w Record'
	msotcidAllowEditing = 540,		//(18,9) Label: 'Allow &Editing'
	msotcidRowHeight = 541,		//(18,10) Label: '&Row Height...'
	msotcidColumnWidth = 542,		//(18,11) Label: '&Column Width...'
	msotcidUnhideColumns = 543,		//(18,12) Label: '&Unhide Columns...'
	msotcidFreezeColumns = 544,		//(18,13) Label: 'Free&ze Columns'
	msotcidGridlines2 = 545,		//(18,14) Label: '&Gridlines' NOTE: Access
	msotcidInsertObject = 546,		//(7,28) Label: '&Object...'
	msotcidSaveAsReport = 547,		//(18,16) Label: 'Sa&ve As Report...' NOTE: Access
	msotcidToolbox = 548,		//(4,1) Label: 'Control T&oolbox' NOTE: toggle Control Toolbox bar -- cf. ShowToolbox, ShowToolboxBar, CustomControls
	msotcidSnapToGrid = 549,		//(18,18) Label: 'To &Grid' NOTE: Snap to Grid
	msotcidSizeToGrid = 550,		//(18,19) Label: 'Size to &Grid' NOTE: resize object to grid boundaries
	msotcidSizeToFit = 551,		//(18,20) Label: 'Size to &Fit'
	msotcidAlignLeft = 552,		//(0,25) Label: '&Use msotcidAlignObjectsLeft' NOTE: PGM: Obsolete--use msotcidAlignObjectsLeft etc.
	msotcidAlignRight = 553,		//(0,25) Label: '&Use msotcidAlignObjectsRight' NOTE: OBSOLETE
	msotcidAlignTop = 554,		//(0,25) Label: '&Use msotcidAlignObjectsTop' NOTE: OBSOLETE
	msotcidAlignBottom = 555,		//(0,25) Label: '&Use msotcidAlignObjectsBottom' NOTE: OBSOLETE
	msotcidPageHeader = 556,		//(18,25) Label: 'P&age Header/Footer' NOTE: header/footer
	msotcidFormHeader = 557,		//(18,26) Label: 'Form &Header/Footer' NOTE: header/footer
	msotcidSamplePreview = 558,		//(18,27) Label: 'La&yout Preview' NOTE: aka layout preview
	msotcidNewProcedure = 559,		//(18,28) Label: '&Procedure...' NOTE: Insert Procedure
	msotcidDebugWindow = 560,		//(18,29) Label: '&Debug Window' NOTE: Debug Window (for vba) [PGM-OBSOLETE use msotcidImmediateWindow instead]
	msotcidRaised = 561,		//(19,0) Label: '&Special Effect: Raised' NOTE: special effect
	msotcidSunken = 562,		//(19,1) Label: '&Special Effect: Sunken' NOTE: special effect
	msotcidCueCards = 563,		//(19,2) Label: '&Cue Cards'
	msotcidHelpSearch = 564,		//(19,3) Label: '&Search...' NOTE: search in help
	msotcidToNotepad = 565,		//(19,4) Label: '&Output to Notepad' NOTE: Report to Notepad
	msotcidToExcel = 566,		//(19,5) Label: '&Analyze It with Microsoft Excel' NOTE: Report to Excel
	msotcidToWord = 567,		//(19,6) Label: '&Publish It with Microsoft Word' NOTE: Report to Word
	msotcidAutoDial = 568,		//(62,23) Label: '&AutoDialer'
	msotcidCancel = 569,		//(0,25) Label: 'C&ancel' NOTE: used for right-drag-drop, maybe elsewhere
	msotcidFindNext = 570,		//(39,25) Label: 'Find Ne&xt' NOTE: Find Next
	msotcidDuplicate = 571,		//(19,10) Label: 'Dup&licate' NOTE: Duplicate
	msotcidPermissions = 572,		//(19,11) Label: 'User and Group &Permissions...' NOTE: Set Permissions
	msotcidAlignToGrid = 573,		//(19,12) Label: 'Align to &Grid' NOTE: Align to Grid
	msotcidReportHeader = 574,		//(19,13) Label: 'Report &Header/Footer' NOTE: Report Header / Footer
	msotcidViewProcedures = 575,		//(19,14) Label: '&View Procedures' NOTE: View Procedures
	msotcidUndoCurrentField = 576,		//(19,15) Label: '&Undo Current Field' NOTE: Undo Current Field
	msotcidDatabaseWindow = 577,		//(4,8) Label: '&Database Window' NOTE: Database Window
	msotcidCompileAll = 578,		//(19,17) Label: 'Compile All &Modules' NOTE: Compile All Modules
	msotcidClearAllBreakpoints = 579,		//(19,18) Label: '&Clear All Breakpoints' NOTE: Clear All Breakpoints
	msotcidFlat = 580,		//(19,19) Label: '&Special Effect: Flat' NOTE: flat border style
	msotcidQuickForm = 581,		//(5,15) Label: 'AutoF&orm' NOTE: Quick Form
	msotcidQuickReport = 582,		//(9,8) Label: 'AutoR&eport' NOTE: Quick Report
	msotcidNewTable = 583,		//(9,1) Label: '&Table' NOTE: New Table
	msotcidTableDefault = 584,		//(19,23) Label: '&Table Default' NOTE: Table Default
	msotcidQueryDefault = 585,		//(19,24) Label: '&Query Default' NOTE: Query Default
	msotcidFormDefault = 586,		//(19,25) Label: '&Form Default' NOTE: Form Default
	msotcidReportDefault = 587,		//(19,26) Label: '&Report Default' NOTE: Report Default
	msotcidMacroDefault = 588,		//(19,27) Label: '&Macro Default' NOTE: Macro Default
	msotcidModuleDefault = 589,		//(19,28) Label: '&Module Default' NOTE: Access [PGM redundant icon with Module]
	msotcidStackOfForms = 590,		//(19,29) Label: '&Stack of Forms' NOTE: Stack of Forms
	msotcidStackOfReports = 591,		//(20,0) Label: '&Stack of Reports' NOTE: Stack of Reports
	msotcidPencilAndQuery = 592,		//(20,1) Label: '&Pencil and Query' NOTE: Pencil and Query
	msotcidPencilAndPage = 593,		//(20,2) Label: '&Pencil and Page' NOTE: Pencil and Page
	msotcidFirstRecordVertical = 594,		//(20,3) Label: '&First Record' NOTE: First Record Vert
	msotcidPreviousRecordVertical = 595,		//(20,4) Label: '&Previous Record' NOTE: Previous Record Vert
	msotcidNextRecordVertical = 596,		//(20,5) Label: '&Next Record' NOTE: Next Record Vert
	msotcidLastRecordVertical = 597,		//(20,6) Label: '&Last Record' NOTE: Last Record Vert
	msotcidNewSmallTable = 598,		//(20,7) Label: '&New Small Table' NOTE: New Small Table
	msotcidNewSmallTables = 599,		//(20,8) Label: '&New Small Tables' NOTE: New Small Tables
	msotcidSelectSmallTable = 600,		//(20,9) Label: '&Select Small Table' NOTE: Select Small Table
	msotcidFilter2 = 601,		//(4,2) Label: '&Toggle Filter' NOTE: Apply Filter (this is the one Access is using)
	msotcidFilterOptions = 602,		//(20,11) Label: '&Filter Options' NOTE: Filter Options
	msotcidFilterUnchecked = 603,		//(20,12) Label: '&Filter Unchecked' NOTE: Filter Unchecked
	msotcidFilterChecked = 604,		//(20,13) Label: '&Filter Checked' NOTE: Filter Checked
	msotcidDeleteFilter = 605,		//(20,14) Label: '&Remove Filter/Sort' NOTE: Delete Filter
	msotcidDialogAndArrow = 606,		//(20,15) Label: '&Dialog and Arrow' NOTE: Dialog and Arrow
	msotcidHead = 607,		//(20,16) Label: '&Head' NOTE: Head
	msotcidReminder = 608,		//(20,17) Label: 'Re&minder' NOTE: Ren
	msotcidHandshake = 609,		//(20,18) Label: '&Handshake' NOTE: Handshake
	msotcidGlobe = 610,		//(20,19) Label: '&Globe' NOTE: Globe
	msotcidHammer = 611,		//(20,20) Label: 'C&ustomize Combo Box...' NOTE: Forms - customize a control
	msotcidCalendar = 612,		//(20,21) Label: '&Calendar' NOTE: Calendar
	msotcidSolidBorder = 613,		//(20,22) Label: '&Line/Border Style' NOTE: Solid border
	msotcidDashesBorder = 614,		//(20,23) Label: '&Line/Border Style' NOTE: Dashes border
	msotcidShortDashesBorder = 615,		//(20,24) Label: '&Line/Border Style' NOTE: Short Dashes border
	msotcidDotsBorder = 616,		//(20,25) Label: '&Line/Border Style' NOTE: Dots border
	msotcidSparseDotsBorder = 617,		//(20,26) Label: '&Line/Border Style' NOTE: Sparse Dots border
	msotcidDashDotBorder = 618,		//(20,27) Label: '&Line/Border Style' NOTE: Dash-Dot Border
	msotcidDashDotDotBorder = 619,		//(20,28) Label: '&Line/Border Style' NOTE: Dash-Dot-Dot Border
	msotcidCallStack = 620,		//(20,29) Label: 'Ca&lls...' NOTE: Call Stack
	msotcidNewModule = 621,		//(9,7) Label: 'Mod&ule' NOTE: New Module
	msotcidDirectRelationships = 622,		//(21,1) Label: 'Show Dire&ct' NOTE: Show
	msotcidAllRelationships = 623,		//(21,2) Label: 'Show A&ll' NOTE: Show All Relationships
	msotcidWizardBuilder = 624,		//(21,3) Label: '&Wizard Builder' NOTE: Wizard Builder
	msotcidControlWizards = 625,		//(21,4) Label: 'Control &Wizards' NOTE: Control Wizards
	msotcidMergeItWithWord = 626,		//(5,9) Label: '&Merge It with Microsoft Word' NOTE: Merge to Word
	msotcidBarCode = 627,		//(21,6) Label: '&Bar Code' NOTE: Bar Code
	msotcidFilterByForm = 628,		//(18,15) Label: '&Filter By Form' NOTE: The "By" is capitalized on purpose, according to Access
	msotcidNewAccessMacro = 629,		//(9,6) Label: '&Macro' NOTE: new access macro
	msotcidAccessAutoFormat = 630,		//(21,9) Label: 'Auto&Format...' NOTE: Access AutoFormat
	msotcidLargeIcons = 631,		//(8,27) Label: 'Lar&ge Icons' NOTE: Large Icon shell view
	msotcidSmallIcons = 632,		//(8,28) Label: 'S&mall Icons' NOTE: Small Icon shell view
	msotcidList = 633,		//(8,29) Label: 'L&ist' NOTE: List shell view
	msotcidDetails = 634,		//(9,0) Label: '&Details' NOTE: Details shell view
	msotcidGridlinesBoth = 635,		//(21,14) Label: '&Gridlines: Both' NOTE: Both Gridlines
	msotcidVerticalGridlines2 = 636,		//(21,15) Label: '&Gridlines: Vertical' NOTE: Vertical Gridlines
	msotcidHorizontalGridlines2 = 637,		//(21,16) Label: '&Gridlines: Horizontal' NOTE: Horizontal Gridlines
	msotcidNoGridlines = 638,		//(21,17) Label: '&Gridlines: None' NOTE: No Gridlines
	msotcidTwoPages = 639,		//(21,18) Label: '&Two Pages' NOTE: Two Pages
	msotcidFilterBySelection = 640,		//(54,23) Label: 'Filter By &Selection' NOTE: Filter by Selection
	msotcidGridColor = 641,		//(21,20) Label: '&Grid Color' NOTE: Grid Color
	msotcidCustomControls = 642,		//(9,9) Label: '&More Controls...' NOTE: use this for the dropdown of registered OCX types
	msotcidPow = 643,		//(21,22) Label: '&Pow!' NOTE: Pow!
	msotcidDeleteRecord2 = 644,		//(4,9) Label: 'Delete &Record' NOTE: Delete Record
	msotcidWand1 = 645,		//(21,24) Label: '&Build...' NOTE: Access - build button
	msotcidWand2 = 646,		//(21,25) Label: '&Wand 2' NOTE: Wand 2
	msotcidWand3 = 647,		//(21,26) Label: '&Wand 3' NOTE: Wand 3
	msotcidWand4 = 648,		//(21,27) Label: '&Wand 4' NOTE: Wand 4
	msotcidWand5 = 649,		//(21,28) Label: '&Wand 5' NOTE: Wand 5
	msotcidWand6 = 650,		//(21,29) Label: '&Wand 6' NOTE: Wand 6
	msotcidWand7 = 651,		//(22,0) Label: '&Wand 7' NOTE: Wand 7
	msotcidWand8 = 652,		//(22,1) Label: '&Wand 8' NOTE: Wand 8
	msotcidSortByModified = 653,		//(22,2) Label: 'By &Modified' NOTE: Sort by Modified
	msotcidSortByType = 654,		//(22,3) Label: 'By &Type' NOTE: Sort by Type
	msotcidSortByName = 655,		//(22,4) Label: 'By &Name' NOTE: Sort by Name
	msotcidSortByCreated = 656,		//(22,5) Label: 'By &Created' NOTE: Sort by Created
	msotcidPivot = 657,		//(22,6) Label: '&Pivot' NOTE: Pivot
	msotcidDatabaseDocumenter = 658,		//(22,7) Label: '&Documenter' NOTE: Database Documenter
	msotcidDatabaseOptimizer = 659,		//(22,8) Label: '&Performance' NOTE: Database Optimizer
	msotcidDatabaseNormalizer = 660,		//(5,10) Label: '&Table' NOTE: Database Normalizer
	msotcidBackColor = 661,		//(22,10) Label: '&Back Color' NOTE: Back Color
	msotcidTextColor = 662,		//(22,11) Label: '&Text/Fore Color' NOTE: Text Color
	msotcidLineColor2 = 663,		//(22,12) Label: '&Line/Border Color' NOTE: Line Color
	msotcidAlignObjectsLeft = 664,		//(22,13) Label: 'Align &Left' NOTE: use to align drawing objects & controls, not text
	msotcidAlignObjectsRight = 665,		//(22,14) Label: 'Align &Right' NOTE: Align Objects Right
	msotcidAlignObjectsTop = 666,		//(22,15) Label: 'Align &Top' NOTE: Align Objects Top
	msotcidAlignObjectsBottom = 667,		//(22,16) Label: 'Align &Bottom' NOTE: Align Objects Bottom
	msotcidAlignObjectsCenteredHorizontal = 668,		//(22,17) Label: 'Align &Center' NOTE: Align Objects Centered Horizontal
	msotcidAlignObjectsCenteredVertical = 669,		//(22,18) Label: 'Align &Middle' NOTE: Align Objects Centered Vertical
	msotcidDummy670 = 670,		//(0,25) Label: '' NOTE: Formerly TitleBuild
	msotcidDummy671 = 671,		//(0,25) Label: '' NOTE: Formerly BodyBuild
	msotcidDummy672 = 672,		//(0,25) Label: '' NOTE: Formerly LaserBuild
	msotcidDummy673 = 673,		//(0,25) Label: '' NOTE: Formerly DriveInBuild
	msotcidDummy674 = 674,		//(0,25) Label: '' NOTE: Formerly ReverseBuild
	msotcidDummy675 = 675,		//(0,25) Label: '' NOTE: Formerly FlyingBuild
	msotcidDummy676 = 676,		//(0,25) Label: '' NOTE: Formerly CameraBuild
	msotcidDummy677 = 677,		//(0,25) Label: '' NOTE: Formerly TypewriterBuild
	msotcidDummy678 = 678,		//(0,25) Label: '' NOTE: Formerly DropInBuild
	msotcidDummy679 = 679,		//(0,25) Label: '' NOTE: Formerly ZoomBuild
	msotcidNewSlide = 680,		//(7,8) Label: 'N&ew Slide' NOTE: New Slide
	msotcidWordTable = 681,		//(28,9) Label: '&Insert Word Table' NOTE: Insert Word Table
	msotcidClipArt = 682,		//(2,15) Label: '&Clip Art...' NOTE: on the Insert/Picture cascade
	msotcidClearItemDefaults = 683,		//(0,25) Label: '&Clear Item Defaults' NOTE: Access
	msotcidReportIt = 684,		//(35,4) Label: '&ReportIt' NOTE: ReportIt
	msotcidBlackWhiteToggle = 685,		//(60,17) Label: '&Black and White' NOTE: Black and White Toggle
	msotcidTextShadow = 686,		//(7,6) Label: '&Shadow' NOTE: Shadow
	msotcidTextColor2 = 687,		//(26,13) Label: '&Text Color' NOTE: Text Color
	msotcidRotate = 688,		//(3,11) Label: 'Free Ro&tate' NOTE: Rotate
	msotcidAutoShapes = 689,		//(23,8) Label: '&More AutoShapes' NOTE: Escher
	msotcidFillColor2 = 690,		//(0,25) Label: '&dummy'
	msotcidLineColor3 = 691,		//(0,25) Label: '&dummy'
	msotcidLineStyle = 692,		//(2,20) Label: '&Line Style' NOTE: Line Style
	msotcidDashStyle = 693,		//(2,21) Label: '&Dash Style' NOTE: Dash Style
	msotcidArrowStyle = 694,		//(2,22) Label: '&Arrow Style' NOTE: Arrow Style
	msotcidCopyToPersonalContacts = 695,		//(12,10) Label: 'Cop&y to Personal Contacts' NOTE: Ren
	msotcidShadowColor = 696,		//(0,25) Label: '&dummy'
	msotcidDuplicate2 = 697,		//(12,9) Label: '&Duplicate' NOTE: Duplicate
	msotcidIncreaseParagraphSpacing = 698,		//(60,1) Label: '&Increase Paragraph Spacing' NOTE: Increase Paragraph Spacing
	msotcidDecreaseParagraphSpacing = 699,		//(19,22) Label: '&Decrease Paragraph Spacing' NOTE: Decrease Paragraph Spacing
	msotcidSlideLayout = 700,		//(56,11) Label: 'Slide &Layout...' NOTE: Slide Layout
	msotcidSlideTemplate = 701,		//(9,26) Label: 'Apply &Design Template...' NOTE: Slide Template
	msotcidOrgChart = 702,		//(47,17) Label: '&Organization Chart' NOTE: Org Chart
	msotcidInsertPresentation = 703,		//(23,24) Label: '&Embed Presentation' NOTE: Insert Presentation
	msotcidInsertSlide = 704,		//(23,23) Label: '&Embed Slide' NOTE: Insert Slide
	msotcidCollapseAll = 705,		//(19,16) Label: '&Collapse All' NOTE: Collapse All
	msotcidExpandAll = 706,		//(2,5) Label: '&Expand All' NOTE: Expand All
	msotcidPresentationPrintOptions = 707,		//(47,6) Label: '&Presentation Print Options' NOTE: PPT - in well, only for when inside a binder
	msotcidSlideShowStop = 708,		//(0,25) Label: '&Stop' NOTE: PPT
	msotcidSlideShowHome = 709,		//(0,25) Label: '&Home' NOTE: PPT
	msotcidSlideShowAdvance = 710,		//(0,25) Label: '&Advance' NOTE: PPT
	msotcidSlideShowReverse = 711,		//(0,25) Label: '&Reverse' NOTE: PPT
	msotcidYokoGumi = 712,		//(48,4) Label: '&Yoko-Gumi' NOTE: PPT - FE only
	msotcidExposeProperties = 713,		//(0,25) Label: '&Expose Properties' NOTE: PPT
	msotcidDoubleStrikethrough = 714,		//(34,12) Label: '&Double Strikethrough' NOTE: Word
	msotcidInsertAutoSignature = 715,		//(0,25) Label: '&AutoSignature' NOTE: Ren - cf. msotcidAutoSignature
	msotcidInsertColumn = 716,		//(10,6) Label: '&Column' NOTE: Access - singular string, cf. InsertColumns and InsertColumns2
	msotcidInsertColumn2 = 717,		//(10,6) Label: 'Insert &Column' NOTE: Access - version of InsertColumn used on shortcut menu
	msotcidEncryptMessage = 718,		//(53,8) Label: 'Encr&ypt Message' NOTE: Ren
	msotcidDigitallySignMessage = 719,		//(15,4) Label: 'Digi&tally Sign' NOTE: Ren
	msotcidVerifySignature = 720,		//(28,16) Label: '&Verify Signature...' NOTE: Ren
	msotcidCreateMailRule = 721,		//(7,19) Label: '&Create Rule...' NOTE: Ren
	msotcidCloseAllItems = 722,		//(0,25) Label: 'Clos&e All Items' NOTE: Ren
	msotcidNormalViewExcel = 723,		//(14,25) Label: '&Normal' NOTE: Excel
	msotcidPageLayoutViewExcel = 724,		//(15,2) Label: '&Page Break Preview' NOTE: Excel
	msotcidCollapseParent = 725,		//(0,25) Label: 'C&ollapse Parent' NOTE: VBE, Access
	msotcidFillEffectsTextureOnly = 726,		//(0,25) Label: '&Fill Effects...' NOTE: Escher - used on color drodowns, cf. msotcidFillEffects
	msotcidTinyIconOnlineView = 727,		//(54,24) Label: '&Online Layout View' NOTE: Word - tiny button in scroll bar
	msotcidCharacterMap = 728,		//(24,17) Label: '&Character Map'
	msotcidHideSlide = 729,		//(50,17) Label: '&Hide Slide'
	msotcidBuild = 730,		//(60,4) Label: '&Build' NOTE: PPT - for animated builds
	msotcidTransition = 731,		//(15,19) Label: 'Slide &Transition' NOTE: Slide transition
	msotcidCrop = 732,		//(24,21) Label: '&Crop'
	msotcidAutoContent = 733,		//(24,22) Label: '&AutoContent Wizard'
	msotcidRehearseTiming = 734,		//(15,21) Label: '&Rehearse Timings'
	msotcidGuides = 735,		//(24,24) Label: '&Show Guides' NOTE: Show Guides
	msotcidSlideView = 736,		//(56,23) Label: '&Slide'
	msotcidOutlineView = 737,		//(4,21) Label: '&Outline'
	msotcidSlideSorterView = 738,		//(14,28) Label: 'Sli&de Sorter'
	msotcidNotesView = 739,		//(15,1) Label: '&Notes Page'
	msotcidSlideshow = 740,		//(15,0) Label: 'Slide Sho&w'
	msotcidSlideMaster = 741,		//(25,0) Label: '&Slide Master'
	msotcidBlackWhite = 742,		//(25,1) Label: 'Grayscale S&etting' NOTE: b&w mode - used as a button menu on a context menu
	msotcidNumberOfPages = 743,		//(25,2) Label: '&Number of Pages' NOTE: Inserts # of pages
	msotcidTrueTypeFont = 744,		//(25,3) Label: '&TrueType Font' NOTE: icon for the Font dropdown
	msotcidPrinterFont = 745,		//(25,4) Label: '&Printer Font' NOTE: icon for the Font dropdown
	msotcidNoIcon = 746,		//(0,25) Label: '&No Icon' NOTE: special ID - this image used for all menu items w/o icons
	msotcidCloseAll = 747,		//(7,24) Label: '&Close All'
	msotcidSaveAs = 748,		//(0,25) Label: 'Save &As...'
	msotcidSaveAll = 749,		//(8,10) Label: 'Save A&ll'
	msotcidFileProperties = 750,		//(0,25) Label: 'Propert&ies' NOTE: File Properties
	msotcidTemplates = 751,		//(0,25) Label: 'Templates and Add-&Ins...' NOTE: Templates & add-ins
	msotcidExit = 752,		//(0,25) Label: 'E&xit' NOTE: on Mac, this automatically turns into Quit
	msotcidExitWithRestore = 753,		//(0,25) Label: 'Exit &With Restore Session' NOTE: Word - Exit with Restore session
	msotcidCopyAsPicture = 754,		//(0,25) Label: '&Copy As Picture'
	msotcidPasteSpecial = 755,		//(0,25) Label: 'Paste &Special...'
	msotcidSelectAll = 756,		//(0,25) Label: 'Select A&ll'
	msotcidGoTo = 757,		//(44,14) Label: '&Go To...'
	msotcidBookmark = 758,		//(0,25) Label: 'Boo&kmark...'
	msotcidLinks = 759,		//(0,25) Label: 'Lin&ks...' NOTE: Edit Links
	msotcidOnlineView = 760,		//(44,15) Label: 'Onlin&e Layout' NOTE: Online View
	msotcidToolbars = 761,		//(0,25) Label: '&Toolbars...' NOTE: Apps should not use - View Toolbars
	msotcidHeaderAndFooter = 762,		//(5,25) Label: '&Header and Footer' NOTE: View Header and Footer
	msotcidFooter = 763,		//(0,25) Label: '&Footer' NOTE: Word
	msotcidFootnotes = 764,		//(0,25) Label: '&Footnotes' NOTE: View Footnotes
	msotcidPatternAutomaticSwatch = 765,		//(0,25) Label: '&Automatic Pattern' NOTE: XL
	msotcidBreak = 766,		//(0,25) Label: '&Break...' NOTE: Insert Break
	msotcidInsertTextBox = 767,		//(5,29) Label: 'Insert Text B&ox' NOTE: appears on Word's Format menu
	msotcidDateAndTime = 768,		//(0,25) Label: 'Date and &Time...' NOTE: Insert Date and Time
	msotcidInsertNumber = 769,		//(0,25) Label: 'Numb&er...' NOTE: Insert Number
	msotcidReference = 770,		//(0,25) Label: '&Reference...' NOTE: Insert Reference
	msotcidSequence = 771,		//(0,25) Label: 'Se&quence...' NOTE: Insert Sequence
	msotcidField = 772,		//(0,25) Label: '&Field...' NOTE: Insert Field
	msotcidFormField = 773,		//(0,25) Label: 'For&m Field...' NOTE: Insert Form Field
	msotcidCaption = 774,		//(0,25) Label: '&Caption...' NOTE: Insert Caption
	msotcidCrossReference = 775,		//(0,25) Label: 'Cross-&reference...' NOTE: Insert Cross-reference
	msotcidIndexAndTables = 776,		//(0,25) Label: 'In&dex and Tables...' NOTE: Insert Index and Tables
	msotcidInsertFile = 777,		//(7,27) Label: 'Fi&le...' NOTE: Insert File
	msotcidTinyIconEmbeddedTrueTypeFont = 778,		//(48,1) Label: '&Embedded TrueType Font' NOTE: used in Font dropdown, cf. PrinterFont and TrueTypeFont
	msotcidParagraphDialog = 779,		//(4,26) Label: '&Paragraph...' NOTE: Format Paragraph
	msotcidTabsDialog = 780,		//(0,25) Label: '&Tabs...' NOTE: Format Tabs
	msotcidBorderShadingDialog = 781,		//(0,25) Label: '&Borders and Shading...' NOTE: Format Border and Shading
	msotcidTextFlow = 782,		//(3,13) Label: 'Te&xt Direction...' NOTE: Format Text Flow
	msotcidBulletsAndNumbering = 783,		//(4,27) Label: 'Bullets and &Numbering...' NOTE: Bullets and Numbering
	msotcidHeadingNumbering = 784,		//(0,25) Label: '&Heading Numbering...' NOTE: Heading Numbering
	msotcidProtectDocument = 785,		//(0,25) Label: '&Protect Document...' NOTE: Tools Protect Document
	msotcidAutoFormatDialog = 786,		//(0,25) Label: '&AutoFormat...' NOTE: Format AutoFormat
	msotcidStyleGallery = 787,		//(0,25) Label: 'Style &Gallery...' NOTE: Style Gallery
	msotcidFrameDialog = 788,		//(0,25) Label: 'Fra&me...' NOTE: Format Frame (obsolete! see msotcidFormatFrame)
	msotcidPictureDialog = 789,		//(0,25) Label: '&Reserved' NOTE: obsolete-see msotcidFormatPicture
	msotcidLanguage = 790,		//(8,20) Label: 'Set &Language...' NOTE: Format Language
	msotcidFormatDrawingObject = 791,		//(68,21) Label: 'Aut&oShape...' NOTE: Escher - cf. msotcidFormatDrawingObject2 for context menus
	msotcidWordCount = 792,		//(0,25) Label: '&Word Count...' NOTE: Word Count
	msotcidAutoCorrect = 793,		//(65,6) Label: '&AutoCorrect Options...' NOTE: AutoCorrect
	msotcidEnvelopesAndLabels = 794,		//(25,26) Label: '&Envelopes and Labels...' NOTE: Envelopes and Labels
	msotcidLabels = 795,		//(0,25) Label: 'Lab&els...' NOTE: Labels
	msotcidLetters = 796,		//(0,25) Label: 'Letter Wi&zard...' NOTE: Letters
	msotcidCustomize = 797,		//(0,25) Label: '&Customize...' NOTE: Customize
	msotcidMergeCells = 798,		//(39,8) Label: '&Merge Cells' NOTE: Merge Cells
	msotcidOptionsDialog = 799,		//(0,25) Label: '&Options...' NOTE: OBSOLETE--use msotcidOptions
	msotcidSplitCells = 800,		//(39,11) Label: 'S&plit Cells...' NOTE: Split Cells
	msotcidSelectRow = 801,		//(0,25) Label: 'Select &Row' NOTE: Select Row
	msotcidSelectColumn = 802,		//(0,25) Label: 'Select &Column' NOTE: Select Column
	msotcidSelectTable = 803,		//(0,25) Label: 'Select T&able' NOTE: Select Table
	msotcidCellHeightWidth = 804,		//(0,25) Label: 'Cell Height and &Width...' NOTE: Cell Height and Width
	msotcidTableHeadings = 805,		//(0,25) Label: '&Heading Rows Repeat' NOTE: Table Headings
	msotcidTextToTable = 806,		//(0,25) Label: 'Con&vert Text to Table...' NOTE: Convert Text to Table
	msotcidTableFormula = 807,		//(0,25) Label: 'F&ormula...' NOTE: Table Formula
	msotcidSplitTable = 808,		//(0,25) Label: 'Split &Table' NOTE: Split Table
	msotcidShowClipboard = 809,		//(4,15) Label: 'Office Clip&board...' NOTE: Show Clipboard
	msotcidHelpIndex = 810,		//(0,25) Label: '&use msotcidHelpTopics instead' NOTE: obsolete -- use msotcidHelpTopics instead
	msotcidHelpQuickPreview = 811,		//(0,25) Label: '&Quick Preview' NOTE: Help Quick Preview
	msotcidHelpExamplesAndDemos = 812,		//(0,25) Label: '&Examples and Demos' NOTE: Help Examples and Demos
	msotcidWordPerfectHelp = 813,		//(0,25) Label: 'Word&Perfect Help...' NOTE: WordPerfect Help
	msotcidTipOfTheDay = 814,		//(0,25) Label: 'Ti&p of the Day...' NOTE: Tip of the Day
	msotcidPSSHelp = 815,		//(44,2) Label: '&Technical Support' NOTE: PSS Help
	msotcidSkipNumbering = 816,		//(0,25) Label: '&Skip Numbering' NOTE: Skip Numbering
	msotcidStopNumbering = 817,		//(0,25) Label: '&Stop Numbering' NOTE: Stop Numbering
	msotcidCustomizeKeyboard = 818,		//(0,25) Label: 'Customize &Keyboard...' NOTE: Customize Keyboard
	msotcidCustomizeReset = 819,		//(0,25) Label: '&Reset' NOTE: Reset (customize)
	msotcidCustomizeRename = 820,		//(0,25) Label: '&Name:' NOTE: Rename (customize)
	msotcidCustomizeShow = 821,		//(0,25) Label: '&Show' NOTE: Show (customize)
	msotcidCustomizeHide = 822,		//(0,25) Label: '&Hide' NOTE: Hide (customize)
	msotcidCustomizeDelete = 823,		//(0,25) Label: '&Delete' NOTE: Delete (customize)
	msotcidCustomizeChangeIcon = 824,		//(0,25) Label: 'Change &Icon...' NOTE: Change Icon (customize)
	msotcidCustomizeAssignMacro = 825,		//(0,25) Label: 'Assign &Macro...' NOTE: Assign Macro (customize)
	msotcidShowAllHeadings = 826,		//(0,25) Label: 'A&ll' NOTE: Show All Headings
	msotcidUpdateIMEDictionary = 827,		//(0,25) Label: 'Update &IME Dictionary...' NOTE: Update IME Dictionary
	msotcidDisableIME = 828,		//(0,25) Label: '&Disable IME' NOTE: Disable IME
	msotcidToolbarList = 829,		//(0,25) Label: '&Toolbar Name Goes Here' NOTE: every toolbar in the toolbar list uses this ID, with the string overridden
	msotcidWindowList = 830,		//(0,25) Label: '&Window Name Goes Here' NOTE: every entry in the Window menu uses this ID, with the string overridden
	msotcidRecentFileList = 831,		//(0,25) Label: '&Recent File Name Goes Here' NOTE: every file in the MRU uses this ID, with the string overridden
	msotcidCopyButtonImage = 832,		//(0,25) Label: '&Copy Button Image' NOTE: Copy Button Image
	msotcidPasteButtonImage = 833,		//(0,25) Label: '&Paste Button Image' NOTE: Paste Button Image
	msotcidResetButtonImage = 834,		//(0,25) Label: 'Re&set Button Image' NOTE: Reset Button Image
	msotcidEditButtonImage = 835,		//(0,25) Label: '&Edit Button Image...' NOTE: Edit Button Image
	msotcidChooseButtonImage = 836,		//(0,25) Label: 'Choose &Button Image...' NOTE: Choose Button Image
	msotcidCreateTask = 837,		//(57,28) Label: '&Create Microsoft Outlook Task' NOTE: Used by apps besides Ren.  Ren uses msotcidNewTask
	msotcidMinimizeWindow = 838,		//(1,27) Label: 'Mi&nimize' NOTE: system menu command
	msotcidRestoreWindow = 839,		//(1,28) Label: '&Restore' NOTE: system menu command
	msotcidCloseWindow = 840,		//(1,17) Label: '&Close' NOTE: system menu command
	msotcidMoveWindow = 841,		//(0,25) Label: '&Move' NOTE: system menu command
	msotcidSizeWindow = 842,		//(0,25) Label: '&Size' NOTE: system menu command
	msotcidMaximizeWindow = 843,		//(40,8) Label: 'Ma&ximize' NOTE: system menu command
	msotcidNextWindow = 844,		//(0,25) Label: 'Nex&t Window' NOTE: system menu command
	msotcidPrintReport = 845,		//(0,25) Label: 'Print R&eport...' NOTE: Print Report [PGM-should this be container?]
	msotcidSaveWorkspace = 846,		//(0,25) Label: 'Save &Workspace...' NOTE: Save Workspace
	msotcidDeleteSheet = 847,		//(0,25) Label: 'De&lete Sheet' NOTE: Delete Sheet
	msotcidMoveCopySheet = 848,		//(0,25) Label: '&Move or Copy Sheet...' NOTE: Move or Copy Sheet
	msotcidFormulaBar = 849,		//(0,25) Label: '&Formula Bar' NOTE: View Formula Bar
	msotcidStatusBar = 850,		//(0,25) Label: '&Status Bar' NOTE: View Status Bar
	msotcidViewManager = 851,		//(0,25) Label: '&View Manager...' NOTE: View Manager
	msotcidInsertWorksheet = 852,		//(48,7) Label: '&Worksheet' NOTE: Insert Worksheet
	msotcidChartAutoFormat = 853,		//(0,25) Label: '&AutoFormat...' NOTE: Chart AutoFormat
	msotcidInsertNote = 854,		//(0,25) Label: 'No&te...' NOTE: Insert Note
	msotcidFormatCells = 855,		//(5,13) Label: 'C&ells...' NOTE: Format cells
	msotcidGoalSeek = 856,		//(0,25) Label: '&Goal Seek...' NOTE: Goal Seek
	msotcidScenarios = 857,		//(0,25) Label: 'Sc&enarios...' NOTE: Scenarios
	msotcidSolver = 858,		//(0,25) Label: 'Sol&ver...' NOTE: Solver
	msotcidAssignMacro = 859,		//(0,25) Label: 'Assig&n Macro...' NOTE: Assign Macro
	msotcidDataForm = 860,		//(0,25) Label: 'F&orm...' NOTE: Data Form
	msotcidSubtotals = 861,		//(0,25) Label: 'Su&btotals...' NOTE: Subtotals
	msotcidDataTable = 862,		//(0,25) Label: '&Table...' NOTE: Data Table
	msotcidConsolidate = 863,		//(0,25) Label: 'Co&nsolidate...' NOTE: Consolidate
	msotcidGetExternalData = 864,		//(0,25) Label: 'Import E&xternal Data...' NOTE: Get External Data
	msotcidHideWindow = 865,		//(0,25) Label: '&Hide'
	msotcidUnhideWindow = 866,		//(0,25) Label: '&Unhide...'
	msotcidFillUp = 867,		//(0,25) Label: '&Up'
	msotcidFillLeft = 868,		//(62,22) Label: '&Left'
	msotcidFillAcrossWorksheets = 869,		//(0,25) Label: '&Across Worksheets...'
	msotcidFillSeries = 870,		//(0,25) Label: '&Series...'
	msotcidFillJustify = 871,		//(0,25) Label: '&Justify'
	msotcidClearFormats = 872,		//(0,25) Label: '&Formats'
	msotcidClearContents = 873,		//(0,25) Label: '&Contents'
	msotcidClearNotes = 874,		//(0,25) Label: 'Co&mments'
	msotcidInsertChartOnThisSheet = 875,		//(0,25) Label: '&On This Sheet'
	msotcidInsertChartAsNewSheet = 876,		//(0,25) Label: '&As New Sheet'
	msotcidInsertXLMMacro = 877,		//(0,25) Label: 'MS &Excel 4.0 Macro' NOTE: Insert XLM Macro
	msotcidDefineName = 878,		//(0,25) Label: '&Define...'
	msotcidPasteName = 879,		//(40,5) Label: '&Paste...'
	msotcidCreateName = 880,		//(0,25) Label: '&Create...'
	msotcidApplyName = 881,		//(0,25) Label: '&Apply...'
	msotcidRowAutoFit = 882,		//(0,25) Label: '&AutoFit' NOTE: Format Row Autofit
	msotcidRowHide = 883,		//(0,25) Label: '&Hide' NOTE: Format Row Hide
	msotcidRowUnhide = 884,		//(0,25) Label: '&Unhide' NOTE: Format Row Unhide
	msotcidColumnAutoFit = 885,		//(0,25) Label: '&AutoFit Selection' NOTE: Format Column AutoFit
	msotcidColumnHide = 886,		//(0,25) Label: '&Hide' NOTE: Format Column Hide
	msotcidColumnUnhide = 887,		//(0,25) Label: '&Unhide' NOTE: Format Column Unhide
	msotcidColumnStandardWidth = 888,		//(0,25) Label: '&Standard Width...' NOTE: Format Column Standard Width
	msotcidRenameSheet = 889,		//(0,25) Label: '&Rename'
	msotcidHideSheet = 890,		//(0,25) Label: '&Hide'
	msotcidUnhideSheet = 891,		//(0,25) Label: '&Unhide...'
	msotcidAuditingBar = 892,		//(0,25) Label: '&Show Formula Auditing Toolbar' NOTE: Auditing Toolbar
	msotcidProtectSheet = 893,		//(57,5) Label: '&Protect Sheet...' NOTE: Protect Sheet
	msotcidProtectWorkbook = 894,		//(57,6) Label: 'Protect &Workbook...' NOTE: Protect Workbook
	msotcidRecordMacro = 895,		//(63,19) Label: '&Record New Macro...' NOTE: Record Macro
	msotcidRelativeReferences = 896,		//(39,4) Label: '&Use Relative References' NOTE: Use Relative References
	msotcidMarkRecordingPosition = 897,		//(0,25) Label: '&Mark Position for Recording' NOTE: Mark Recording Position
	msotcidRecordAtMark = 898,		//(0,25) Label: 'R&ecord at Mark' NOTE: Record at Mark
	msotcidAutoFilter = 899,		//(24,2) Label: 'Auto&Filter'
	msotcidShowAll2 = 900,		//(0,25) Label: '&Show All' NOTE: Show All (autofilter)
	msotcidAdvancedFilter = 901,		//(0,25) Label: '&Advanced Filter...'
	msotcidOutlineGroup = 902,		//(60,26) Label: '&Group...' NOTE: Excel - cf. msotcidRightArrow
	msotcidOutlineUngroup = 903,		//(56,7) Label: '&Ungroup...' NOTE: Excel - cf. msotcidLeftArrow
	msotcidAutoOutline = 904,		//(0,25) Label: '&Auto Outline'
	msotcidClearOutline = 905,		//(0,25) Label: '&Clear Outline'
	msotcidOutlineSettings = 906,		//(0,25) Label: 'S&ettings...'
	msotcidClearSeries = 907,		//(0,25) Label: '&Series' NOTE: Clear Chart series
	msotcidViewSizedWithWindow = 908,		//(0,25) Label: 'Sized with &Window'
	msotcidInsertTitles = 909,		//(0,25) Label: '&Titles...' NOTE: Chart
	msotcidInsertDataLabels = 910,		//(0,25) Label: '&Data Labels...' NOTE: Chart
	msotcidInsertLegend = 911,		//(0,25) Label: '&Legend'
	msotcidInsertAxes = 912,		//(0,25) Label: 'A&xes...'
	msotcidInsertGridlines = 913,		//(0,25) Label: '&Gridlines...' NOTE: Chart
	msotcidInsertTrendline = 914,		//(0,25) Label: 'Add T&rendline...'
	msotcidInsertErrorBars = 915,		//(0,25) Label: 'Error &Bars...'
	msotcidTableToolbar = 916,		//(1,13) Label: '&Tables and Borders Toolbar' NOTE: Word - toggles the table/borders toolbar
	msotcidFormatSelected = 917,		//(5,16) Label: '&Selected Object' NOTE: Format selected chart object 
	msotcidChartType = 918,		//(0,25) Label: 'Chart T&ype...' NOTE: Chart Type
	msotcidFormat3DView = 919,		//(0,25) Label: '3-D &View...' NOTE: 3-D View
	msotcidOK = 920,		//(0,25) Label: '&OK' NOTE: OK (used in several contexts)
	msotcidClosePane = 921,		//(0,25) Label: '&Close' NOTE: Close lower pane
	msotcidClosePicture = 922,		//(0,25) Label: '&Close Picture' NOTE: stop editing picture
	msotcidClosePreview = 923,		//(0,25) Label: '&Close' NOTE: Close print preview
	msotcidCloseHeader = 924,		//(0,25) Label: '&Close' NOTE: Close header/footer
	msotcidZoomDialog = 925,		//(0,25) Label: '&Zoom...' NOTE: View Zoom command
	msotcidF1Help = 926,		//(11,14) Label: 'Help on &Keyword' NOTE: F1 Help (same as hitting F1)
	msotcidHelpAbout = 927,		//(0,25) Label: '&About' NOTE: Help About
	msotcidSortDialog = 928,		//(1,21) Label: '&Sort...' NOTE: Sort dialog
	msotcidTableToText = 929,		//(0,25) Label: 'Con&vert Table to Text...' NOTE: Convert table to text (see #804 too)
	msotcidMacro = 930,		//(0,25) Label: '&Macro...' NOTE: Tools Macro
	msotcidInsertPicture = 931,		//(2,16) Label: '&Picture...' NOTE: Insert Picture
	msotcidLabelRange = 932,		//(0,25) Label: '&Label...' NOTE: Label Range (used in Names cascade)
	msotcidPublish = 933,		//(0,25) Label: '&Create Publisher...' NOTE: Publish (publish & subscribe)
	msotcidSubscribe = 934,		//(0,25) Label: '&Subscribe To...' NOTE: Subscribe (publish & subscribe)
	msotcidAOCEOpenMail = 935,		//(0,25) Label: '&Open Mail...' NOTE: Open Mail (Mac-specific)
	msotcidLotusHelp = 936,		//(0,25) Label: '&Lotus 1-2-3 Help...' NOTE: Lotus 1-2-3 Help (for Excel)
	msotcidAnswerWizard = 937,		//(0,25) Label: '&Answer Wizard...' NOTE: Answer Wizard
	msotcidPostDocument = 938,		//(37,22) Label: '&Exchange Folder...' NOTE: File / Send to menu
	msotcidProcedureDefinition = 939,		//(0,25) Label: '&Procedure Definition' NOTE: View procedure definition
	msotcidEditWatch = 940,		//(34,1) Label: '&Edit Watch...' NOTE: Edit watch (for vba)
	msotcidInstantWatch = 941,		//(39,28) Label: 'Instant &Watch...' NOTE: PGM redundant with msotcidWatch
	msotcidVBReferences = 942,		//(43,13) Label: 'Re&ferences...' NOTE: Tools References (for vb)
	msotcidAddInManager = 943,		//(0,25) Label: 'Add-&Ins...' NOTE: Add-in Manager
	msotcidMakeAddIn = 944,		//(0,25) Label: 'Ma&ke Add-In...' NOTE: Make Add-in (for excel)
	msotcidInsertSheet = 945,		//(0,25) Label: '&Insert...' NOTE: Insert new ply (excel)
	msotcidSelectAllSheets = 946,		//(0,25) Label: '&Select All Sheets' NOTE: Select all sheets (excel)
	msotcidCharacterStyle = 947,		//(11,10) Label: '&Character Style' NOTE: bitmap for character styles
	msotcidParagraphStyle = 948,		//(11,11) Label: '&Paragraph Style' NOTE: bitmap for paragraph styles
	msotcidFileSharing = 949,		//(0,25) Label: 'File S&haring...' NOTE: for multiuser editing in Excel
	msotcidCustomViews = 950,		//(0,25) Label: 'Custom &Views...' NOTE: view manager for Excel
	msotcidPhoneticString = 951,		//(0,25) Label: 'Phonetic &String...' NOTE: used by XL-J for IME??
	msotcidSheetBackground = 952,		//(0,25) Label: '&Background...' NOTE: sets sheet background color?  Excel
	msotcidMultiPlanHelp = 953,		//(0,25) Label: '&MultiPlan Help' NOTE: only used by Korean Excel?
	msotcidChartSourceData = 954,		//(0,25) Label: '&Source Data...' NOTE: new for xl 95
	msotcidChartPlacement = 955,		//(0,25) Label: '&Location...' NOTE: new for xl 95
	msotcidDisplayChartOptions = 956,		//(39,9) Label: 'Chart Opt&ions...' NOTE: Excel
	msotcidSheetList = 957,		//(0,25) Label: '&Sheet List' NOTE: the list of sheets in a book
	msotcidMoreSheets = 958,		//(0,25) Label: '&More Sheets...' NOTE: used if more than 9 sheets
	msotcidMoreWindows = 959,		//(0,25) Label: '&More Windows...' NOTE: used if more than 9 windows
	msotcidCalculateNow = 960,		//(42,18) Label: '&Calculate Now' NOTE: xl recalc
	msotcidEditObject = 961,		//(0,25) Label: '&Object...' NOTE: used by xl for non-OLE "objects" like pictures
	msotcidFormatObject = 962,		//(68,21) Label: '&Object...' NOTE: Excel, Escher
	msotcidCreateAutoText = 963,		//(0,25) Label: '&Create AutoText...' NOTE: Word
	msotcidRunQuery = 964,		//(11,12) Label: '&Run' NOTE: run query/macro (for access)
	msotcidImageControl = 965,		//(11,13) Label: 'Im&age' NOTE: image control (used by access)
	msotcidRuler2 = 966,		//(11,15) Label: '&Ruler' NOTE: ruler (for access)
	msotcidShowGrid = 967,		//(11,16) Label: '&Grid' NOTE: show grid (for access)
	msotcidBuiltInMenuList = 968,		//(0,25) Label: '&Built In Menu' NOTE: used by Office customize, override the label
	msotcidQuitCustomize = 969,		//(0,25) Label: '&Quit Customize' NOTE: used by Office customize
	msotcidToggleLeftPane = 970,		//(25,9) Label: '&Show/Hide Left Pane' NOTE: toggle left pane (for Binder)
	msotcidAddSection = 971,		//(0,25) Label: '&Add...' NOTE: Add binder section
	msotcidAddSectionFromFile = 972,		//(0,25) Label: 'Add from &File...' NOTE: Add binder section from file
	msotcidDeleteSection = 973,		//(0,25) Label: '&Delete' NOTE: Delete binder section
	msotcidDuplicateSection = 974,		//(0,25) Label: 'Du&plicate...' NOTE: Duplicate binder section
	msotcidRenameSection = 975,		//(0,25) Label: '&Rename' NOTE: Rename binder section
	msotcidRearrangeSections = 976,		//(0,25) Label: 'R&earrange...' NOTE: Rearrange binder sections
	msotcidHideSection = 977,		//(0,25) Label: '&Hide' NOTE: Hide binder section
	msotcidUnhideSection = 978,		//(0,25) Label: 'U&nhide' NOTE: Unhide binder section
	msotcidSaveSectionAsFile = 979,		//(0,25) Label: '&Save as File...' NOTE: Save binder section as file
	msotcidOpenSection = 980,		//(0,25) Label: 'Vie&w Outside' NOTE: Open binder section outside
	msotcidSectionProperties = 981,		//(0,25) Label: 'Section Propert&ies' NOTE: Binder section properties
	msotcidMicrosoftNetwork = 982,		//(0,25) Label: '&Microsoft Network' NOTE: Help, MSN
	msotcidHelpTopics = 983,		//(25,10) Label: '&Contents and Index' NOTE: <app> help topics (override string)
	msotcidOfficeAssistant = 984,		//(0,19) Label: '&Help' NOTE: shows/hides the Office Assistant (brings up Help)
	msotcidSectionPageSetup = 985,		//(0,25) Label: '&Page Setup' NOTE: page setup for one binder section
	msotcidSectionPrint = 986,		//(1,3) Label: '&Print' NOTE: print this section of binder
	msotcidChartDataTable = 987,		//(5,21) Label: '&Data Table' NOTE: used by excel
	msotcidPlotByColumn = 988,		//(5,20) Label: 'Series in &Columns' NOTE: plot data by columns
	msotcidPlotByRow = 989,		//(5,19) Label: 'Series in &Rows' NOTE: plot data by rows
	msotcidCheckmark = 990,		//(4,22) Label: '&Checkmark' NOTE: Office -- used for checked menu items
	msotcidPivotTableStructuredSelection = 991,		//(25,15) Label: '&Enable Selection' NOTE: toggles pivot table structured selection
	msotcidPivotTableFormula = 992,		//(25,16) Label: '&List Formulas' NOTE: pivot table formula
	msotcidPivotTableSelectData = 993,		//(25,17) Label: '&Data'
	msotcidPivotTableSelectDataAndLabel = 994,		//(25,18) Label: 'Label &and Data'
	msotcidPivotTableSelectLabels = 995,		//(25,19) Label: '&Label'
	msotcidAutoTextAdd = 996,		//(0,25) Label: '&New...' NOTE: new autotext entry
	msotcidPasteAsPicture = 997,		//(0,25) Label: '&Paste As Picture' NOTE: pastes clipboard as a picture
	msotcidPastePictureLink = 998,		//(0,25) Label: 'Paste Picture Li&nk' NOTE: Excel uses this
	msotcidCalculateDocument = 999,		//(0,25) Label: '&Calculate Document'
	};

enum
	{
	msotcidAssistantSeeTips = 1000,		//(11,22) Label: 'See &Tips' NOTE: TFC (PGM - obsolete?  OfficeAssistantTip?)
	msotcidAssistantOptions = 1001,		//(0,25) Label: '&Options...' NOTE: TFC
	msotcidAssistantPicker = 1002,		//(0,25) Label: '&Choose Assistant...' NOTE: TFC
	msotcidAssistantAnimate = 1003,		//(35,6) Label: '&Animate!' NOTE: TFC
	msotcidAssistantHide = 1004,		//(0,25) Label: '&Hide Assistant' NOTE: TFC
	msotcidMoreColors = 1005,		//(0,25) Label: '&More Colors...' NOTE: Escher--used in color dropdowns
	msotcidFillEffects = 1006,		//(0,25) Label: '&Fill Effects...' NOTE: Escher--used in color dropdowns
	msotcidPatternFill = 1007,		//(0,25) Label: '&Patterned Line...' NOTE: Escher--used in line style dropdown
	msotcidMore = 1008,		//(0,25) Label: '&More...' NOTE: generic More button, used by Escher
	msotcidProgrammingHelp = 1009,		//(0,25) Label: '&Programming Help' NOTE: tells character to give VBA help
	msotcidAutoIconVisible = 1010,		//(0,25) Label: 'Defa&ult Style' NOTE: Office -- used by customize
	msotcidTextOnly = 1011,		//(0,25) Label: '&Text Only (Always)' NOTE: Office -- used by customize
	msotcidIconAndText = 1012,		//(0,25) Label: 'Image &and Text' NOTE: Office -- used by customize
	msotcidRotateTextUp45Degrees = 1013,		//(6,27) Label: '&Angle Counterclockwise' NOTE: text slanting upwards 45 degrees
	msotcidRotateTextDown45Degrees = 1014,		//(6,26) Label: '&Angle Clockwise' NOTE: text slanting down 45 degrees
	msotcidOpenURL = 1015,		//(8,9) Label: '&Open Hyperlink' NOTE: Web
	msotcidOpenStartPage = 1016,		//(25,28) Label: '&Start Page' NOTE: Web - takes you to home page
	msotcidWebGoBack = 1017,		//(57,0) Label: '&Back' NOTE: Web - icon for Back/History dropdown
	msotcidWebGoForward = 1018,		//(59,8) Label: '&Forward' NOTE: Web - go forward in history list
	msotcidWebStopLoading = 1019,		//(5,8) Label: '&Stop' NOTE: Web - Stop loading page
	msotcidWebRefresh = 1020,		//(5,7) Label: '&Refresh' NOTE: Web - refresh page
	msotcidFavorites = 1021,		//(26,3) Label: 'Open &Favorites...' NOTE: Favorites (used by Open & Web)
	msotcidAddToFavorites = 1022,		//(26,4) Label: '&Add to Favorites...' NOTE: add selection to Favorites folder
	msotcidHideOtherBars = 1023,		//(26,5) Label: '&Show Only Web Toolbar' NOTE: Web - hides all toolbars except for Web
	msotcidBrowsePrevious = 1024,		//(0,0) Label: '&Previous' NOTE: small icons for browsers in vert. scrollbar
	msotcidBrowseNext = 1025,		//(0,1) Label: '&Next' NOTE: browse next page
	msotcidBrowsePreviousActive = 1026,		//(22,29) Label: '&Previous' NOTE: browse previous <object>
	msotcidBrowseNextActive = 1027,		//(23,4) Label: '&Next' NOTE: browse next <object>
	msotcidBrowseSelector = 1028,		//(0,6) Label: '&Select Browse Object' NOTE: choose browsing mode
	msotcidInsertGraphic = 1029,		//(26,11) Label: '&Insert Graphic' NOTE: Escher - menu
	msotcidInsertDrawingServer = 1030,		//(26,12) Label: '&Insert Draw Server Object' NOTE: Escher - icon needs revising
	msotcidInsertTextEffect = 1031,		//(2,13) Label: '&WordArt...' NOTE: Escher
	msotcidInsertDiagram = 1032,		//(2,14) Label: 'Dia&gram...' NOTE: Escher - insert diagram
	msotcidRerouteConnections = 1033,		//(8,4) Label: 'Rerou&te Connectors' NOTE: Escher - reroute connections
	msotcidSaveGraphicAsClipArt = 1034,		//(26,16) Label: 'Sa&ve to Clip Organizer' NOTE: Escher
	msotcidNudgeUp = 1035,		//(26,17) Label: '&Up' NOTE: Escher
	msotcidNudgeDown = 1036,		//(26,18) Label: '&Down' NOTE: Escher
	msotcidNudgeLeft = 1037,		//(26,19) Label: '&Left' NOTE: Escher
	msotcidNudgeRight = 1038,		//(26,20) Label: '&Right' NOTE: Escher
	msotcidAlignRelativeToPage = 1039,		//(42,12) Label: 'Relative t&o Page' NOTE: Escher
	msotcidDistributeRelativeToPage = 1040,		//(0,25) Label: 'R&elative to Page/Slide' NOTE: Escher
	msotcidSpline = 1041,		//(26,21) Label: '&Curve' NOTE: Escher
	msotcidStraightConnector = 1042,		//(26,22) Label: 'St&raight Connector' NOTE: Escher
	msotcidAngledConnector = 1043,		//(26,23) Label: '&Elbow Connector' NOTE: Escher
	msotcidCurvedConnector = 1044,		//(26,24) Label: 'C&urved Connector' NOTE: Escher
	msotcidCallout2 = 1045,		//(26,25) Label: '&Callout2' NOTE: Escher - icon needs revising
	msotcidCallout3 = 1046,		//(26,26) Label: '&Callout3' NOTE: Escher - icon needs revising
	msotcidMoreShapes1 = 1047,		//(26,27) Label: '&Callouts' NOTE: Escher
	msotcidMoreShapes2 = 1048,		//(26,28) Label: '&Flowchart' NOTE: Escher
	msotcidMoreShapes3 = 1049,		//(26,29) Label: 'Block &Arrows' NOTE: Escher
	msotcidMoreShapes4 = 1050,		//(27,0) Label: '&Stars and Banners' NOTE: Escher
	msotcidMoreFillColors = 1051,		//(0,25) Label: '&More Fill Colors...' NOTE: Escher
	msotcidMoreLineColors = 1052,		//(0,25) Label: '&More Line Colors...' NOTE: Escher
	msotcidLinePatternFill = 1053,		//(0,25) Label: '&Patterned Lines...' NOTE: Escher - for lines
	msotcidMoreLines = 1054,		//(0,25) Label: '&More Lines...' NOTE: Escher
	msotcidMoreArrows = 1055,		//(0,25) Label: '&More Arrows...' NOTE: Escher
	msotcidMoreShadows = 1056,		//(0,25) Label: '&Shadow Settings...' NOTE: Escher
	msotcidMore3D = 1057,		//(0,25) Label: '&3-D Settings...' NOTE: Escher
	msotcidTextEffectShape = 1058,		//(27,1) Label: '&WordArt Shape' NOTE: Escher
	msotcidTextEffectAlignment = 1059,		//(27,2) Label: '&WordArt Alignment' NOTE: Escher
	msotcidTextEffectTracking = 1060,		//(27,3) Label: '&WordArt Character Spacing' NOTE: Escher
	msotcidRotateCharacters = 1061,		//(27,4) Label: '&WordArt Vertical Text' NOTE: Escher
	msotcidStretchText = 1062,		//(27,5) Label: '&Stretch to Fill' NOTE: Escher - PGM: OBSOLETE?
	msotcidSameHeightLetters = 1063,		//(27,6) Label: '&WordArt Same Letter Heights' NOTE: Escher
	msotcidMoreContrast = 1064,		//(27,7) Label: '&More Contrast' NOTE: Escher - next 4 icons need revising
	msotcidLessContrast = 1065,		//(27,8) Label: '&Less Contrast' NOTE: Escher
	msotcidMoreBrightness = 1066,		//(27,9) Label: '&More Brightness' NOTE: Escher
	msotcidLessBrightness = 1067,		//(27,10) Label: '&Less Brightness' NOTE: Escher
	msotcidNudgeShadowUp = 1068,		//(27,11) Label: '&Nudge Shadow Up' NOTE: Escher
	msotcidNudgeShadowDown = 1069,		//(27,12) Label: '&Nudge Shadow Down' NOTE: Escher
	msotcidNudgeShadowLeft = 1070,		//(27,13) Label: '&Nudge Shadow Left' NOTE: Escher
	msotcidNudgeShadowRight = 1071,		//(27,14) Label: '&Nudge Shadow Right' NOTE: Escher
	msotcidMoreShadowColors = 1072,		//(0,25) Label: '&More Shadow Colors...' NOTE: Escher
	msotcidMoreExtrusionColors = 1073,		//(0,25) Label: '&More 3-D Colors...' NOTE: Escher
	msotcidHighPriority = 1074,		//(45,29) Label: '&Importance: High' NOTE: Ren
	msotcidLowPriority = 1075,		//(17,20) Label: 'I&mportance: Low' NOTE: Ren
	msotcidMove = 1076,		//(27,17) Label: '&Move' NOTE: Move, as opposed to Copy
	msotcidShowNavigationPane = 1077,		//(7,13) Label: 'Fold&er List' NOTE: Ren
	msotcidAutoSignature = 1078,		//(0,25) Label: 'Au&toSignature...' NOTE: Ren
	msotcidAttachment = 1079,		//(7,27) Label: '&File...' NOTE: Ren - note that this ID is different from Word's msotcidInsertFile
	msotcidHelpAboutOutlook = 1080,		//(0,25) Label: '&About Microsoft Outlook...' NOTE: Ren (they aren't able to override strings; other apps should use msotcidHelpAbout)
	msotcidOpenInDesignView = 1081,		//(9,11) Label: '&Design View' NOTE: Access
	msotcidAddToTasks = 1082,		//(27,23) Label: 'Add to Tas&k Manager' NOTE: Ren
	msotcidDeleteWatch = 1083,		//(0,25) Label: '&Delete Watch' NOTE: Access
	msotcidPlanner = 1084,		//(4,5) Label: '&Plan a Meeting...' NOTE: Ren
	msotcidChangeFormColor = 1085,		//(0,25) Label: '&Change Form Color' NOTE: Access
	msotcidInvite = 1086,		//(67,29) Label: 'In&vite Attendees' NOTE: Ren
	msotcidAcceptInvitation = 1087,		//(56,24) Label: 'A&ccept' NOTE: Ren
	msotcidDeclineInvitation = 1088,		//(48,6) Label: '&Decline' NOTE: Ren
	msotcidTentativeAcceptInvitation = 1089,		//(15,3) Label: 'Tent&ative' NOTE: Ren
	msotcidToggleRequestFields = 1090,		//(7,22) Label: '&Request' NOTE: Ren
	msotcidHideDebugColumns = 1091,		//(0,25) Label: '&Hide Debug Columns' NOTE: Access
	msotcidAlwaysOnTop = 1092,		//(0,25) Label: 'Always on &Top' NOTE: Ren
	msotcidSaveAllModules = 1093,		//(0,25) Label: 'Save All &Modules' NOTE: Access
	msotcidDailyView = 1094,		//(64,18) Label: 'Da&y' NOTE: Ren
	msotcidWeeklyView = 1095,		//(21,7) Label: '&Week' NOTE: Ren
	msotcidMonthlyView = 1096,		//(43,21) Label: '&Month' NOTE: Ren
	msotcidFindPrevious = 1097,		//(0,25) Label: 'Find Pre&vious' NOTE: Access
	msotcidToday = 1098,		//(64,17) Label: 'Go to Tod&ay' NOTE: Ren
	msotcidNewContact = 1099,		//(26,2) Label: '&Contact' NOTE: Ren
	msotcidNewTask = 1100,		//(57,28) Label: '&Task' NOTE: Ren
	msotcidRemoteMode = 1101,		//(0,25) Label: 'R&emote Tools' NOTE: Ren
	msotcidConnect = 1102,		//(67,24) Label: 'Connec&t...' NOTE: Ren
	msotcidDisconnect = 1103,		//(68,8) Label: 'D&isconnect' NOTE: Ren
	msotcidMarkForDownload = 1104,		//(68,11) Label: 'Mark to &Retrieve' NOTE: Ren
	msotcidUnmarkAllForDownload = 1105,		//(57,10) Label: '&Unmark All' NOTE: Ren
	msotcidNewAppointment = 1106,		//(55,9) Label: '&Appointment' NOTE: Ren
	msotcidMarkForUrgentDownload = 1107,		//(28,17) Label: 'Mark for &Urgent Download' NOTE: Ren
	msotcidTextEffectAlignLeft = 1108,		//(28,18) Label: '&Left Align' NOTE: Escher
	msotcidTextEffectAlignCenter = 1109,		//(28,19) Label: '&Center' NOTE: Escher
	msotcidShapeAccentBorderCallout3 = 1110,		//(28,21) Label: '&Line Callout 4 (Border and Accent Bar)' NOTE: Escher shape
	msotcidShapeRectangle = 1111,		//(2,9) Label: '&Rectangle' NOTE: Escher shape - start of Standard Palette
	msotcidShapeParallelogram = 1112,		//(28,23) Label: '&Parallelogram' NOTE: Escher shape
	msotcidShapeTrapezoid = 1113,		//(28,24) Label: '&Trapezoid' NOTE: Escher shape
	msotcidShapeDiamond = 1114,		//(28,25) Label: '&Diamond' NOTE: Escher shape
	msotcidShapeRoundRectangle = 1115,		//(28,26) Label: '&Rounded Rectangle' NOTE: Escher shape
	msotcidShapeOctagon = 1116,		//(28,27) Label: '&Octagon' NOTE: Escher shape
	msotcidShapeIsocelesTriangle = 1117,		//(28,28) Label: '&Isosceles Triangle' NOTE: Escher shape
	msotcidShapeRightTriangle = 1118,		//(28,29) Label: '&Right Triangle' NOTE: Escher shape
	msotcidShapeEllipse = 1119,		//(2,10) Label: '&Oval' NOTE: Escher shape
	msotcidShapeHexagon = 1120,		//(29,1) Label: '&Hexagon' NOTE: Escher shape
	msotcidShapePlus = 1121,		//(29,2) Label: '&Cross' NOTE: Escher shape
	msotcidShapeCube = 1122,		//(29,3) Label: '&Cube' NOTE: Escher shape
	msotcidShapePlaque = 1123,		//(29,4) Label: '&Plaque' NOTE: Escher shape
	msotcidShapePentagon = 1124,		//(29,5) Label: '&Regular Pentagon' NOTE: Escher shape
	msotcidShapeWave = 1125,		//(29,6) Label: '&Wave' NOTE: Escher shape
	msotcidShapeCan = 1126,		//(29,7) Label: '&Can' NOTE: Escher shape
	msotcidShapeVerticalScroll = 1127,		//(29,8) Label: '&Vertical Scroll' NOTE: Escher shape
	msotcidShapeHorizontalScroll = 1128,		//(29,9) Label: '&Horizontal Scroll' NOTE: Escher shape
	msotcidShapeFoldedCorner = 1129,		//(29,10) Label: '&Folded Corner' NOTE: Escher shape
	msotcidShapeBevel = 1130,		//(29,11) Label: '&Bevel' NOTE: Escher shape
	msotcidShapeSmileyFace = 1131,		//(29,12) Label: '&Smiley Face' NOTE: Escher shape
	msotcidShapeDonut = 1132,		//(29,13) Label: '&Donut' NOTE: Escher shape
	msotcidShapeNoSmoking = 1133,		//(29,14) Label: '&\"No\" Symbol' NOTE: Escher shape
	msotcidShapeBlockArc = 1134,		//(29,15) Label: '&Block Arc' NOTE: Escher shape
	msotcidShapeLeftBracket = 1135,		//(29,16) Label: '&Left Bracket' NOTE: Escher shape
	msotcidShapeRightBracket = 1136,		//(29,17) Label: '&Right Bracket' NOTE: Escher shape
	msotcidShapeLeftBrace = 1137,		//(29,18) Label: '&Left Brace' NOTE: Escher shape
	msotcidShapeRightBrace = 1138,		//(29,19) Label: '&Right Brace' NOTE: Escher shape
	msotcidShapeArc = 1139,		//(29,20) Label: '&Arc' NOTE: Escher shape
	msotcidShapeLightningBolt = 1140,		//(29,21) Label: '&Lightning Bolt' NOTE: Escher shape
	msotcidShapeHeart = 1141,		//(29,22) Label: '&Heart' NOTE: Escher shape
	msotcidShapeRightArrow = 1142,		//(29,23) Label: '&Right Arrow' NOTE: Escher shape - start of Block Arrows Palette
	msotcidShapeLeftArrow = 1143,		//(29,24) Label: '&Left Arrow' NOTE: Escher shape
	msotcidShapeUpArrow = 1144,		//(29,25) Label: '&Up Arrow' NOTE: Escher shape
	msotcidShapeDownArrow = 1145,		//(29,26) Label: '&Down Arrow' NOTE: Escher shape
	msotcidShapeLeftRightArrow = 1146,		//(29,27) Label: '&Left-Right Arrow' NOTE: Escher shape
	msotcidShapeUpDownArrow = 1147,		//(29,28) Label: '&Up-Down Arrow' NOTE: Escher shape
	msotcidShapeQuadArrow = 1148,		//(29,29) Label: '&Quad Arrow' NOTE: Escher shape
	msotcidShapeLeftRightUpArrow = 1149,		//(30,0) Label: '&Left-Right-Up Arrow' NOTE: Escher shape
	msotcidShapeLeftUpArrow = 1150,		//(30,1) Label: '&Left-Up Arrow' NOTE: Escher shape
	msotcidShapeBentUpArrow = 1151,		//(30,2) Label: '&Bent-Up Arrow' NOTE: Escher shape
	msotcidShapeBentArrow = 1152,		//(30,3) Label: '&Bent Arrow' NOTE: Escher shape
	msotcidShapeUturnArrow = 1153,		//(30,4) Label: '&U-Turn Arrow' NOTE: Escher shape
	msotcidShapeStripedRightArrow = 1154,		//(30,5) Label: '&Striped Right Arrow' NOTE: Escher shape
	msotcidShapeNotchedRightArrow = 1155,		//(30,6) Label: '&Notched Right Arrow' NOTE: Escher shape
	msotcidShapeHomePlate = 1156,		//(30,7) Label: '&Pentagon' NOTE: Escher shape
	msotcidShapeChevron = 1157,		//(30,8) Label: '&Chevron' NOTE: Escher shape
	msotcidShapeCircularArrow = 1158,		//(30,9) Label: '&Circular Arrow' NOTE: Escher shape
	msotcidShapeNotchedCircularArrow = 1159,		//(0,25) Label: '&Reserved' NOTE: Escher shape UNUSED
	msotcidShapeCurvedRightArrow = 1160,		//(30,11) Label: '&Curved Right Arrow' NOTE: Escher shape
	msotcidShapeCurvedLeftArrow = 1161,		//(30,12) Label: '&Curved Left Arrow' NOTE: Escher shape
	msotcidShapeCurvedUpArrow = 1162,		//(30,13) Label: '&Curved Up Arrow' NOTE: Escher shape
	msotcidShapeCurvedDownArrow = 1163,		//(30,14) Label: '&Curved Down Arrow' NOTE: Escher shape
	msotcidShapeRightArrowCallout = 1164,		//(30,15) Label: '&Right Arrow Callout' NOTE: Escher shape - start of Callouts palette
	msotcidShapeLeftArrowCallout = 1165,		//(30,16) Label: '&Left Arrow Callout' NOTE: Escher shape
	msotcidShapeUpArrowCallout = 1166,		//(30,17) Label: '&Up Arrow Callout' NOTE: Escher shape
	msotcidShapeDownArrowCallout = 1167,		//(30,18) Label: '&Down Arrow Callout' NOTE: Escher shape
	msotcidShapeLeftRightArrowCallout = 1168,		//(30,19) Label: '&Left-Right Arrow Callout' NOTE: Escher shape
	msotcidShapeUpDownArrowCallout = 1169,		//(30,20) Label: '&Up-Down Arrow Callout' NOTE: Escher shape
	msotcidShapeQuadArrowCallout = 1170,		//(30,21) Label: '&Quad Arrow Callout' NOTE: Escher shape
	msotcidShapeBalloon = 1171,		//(30,22) Label: '&Balloon' NOTE: Escher shape
	msotcidShapeWedgeRectCallout = 1172,		//(30,23) Label: '&Rectangular Callout' NOTE: Escher shape
	msotcidShapeWedgeRRectCallout = 1173,		//(30,24) Label: '&Rounded Rectangular Callout' NOTE: Escher shape
	msotcidShapeWedgeEllipseCallout = 1174,		//(30,25) Label: '&Oval Callout' NOTE: Escher shape
	msotcidShapeCloudCallout = 1175,		//(30,26) Label: '&Cloud Callout' NOTE: Escher shape
	msotcidShapeBorderCallout1 = 1176,		//(30,27) Label: '&Line Callout 2' NOTE: Escher shape
	msotcidShapeBorderCallout2 = 1177,		//(30,28) Label: '&Line Callout 3' NOTE: Escher shape
	msotcidShapeBorderCallout3 = 1178,		//(30,29) Label: '&Line Callout 4' NOTE: Escher shape
	msotcidShapeRibbon = 1179,		//(31,0) Label: '&Down Ribbon' NOTE: Escher shape - start of Seals&Banners palette
	msotcidShapeRibbon2 = 1180,		//(31,1) Label: '&Up Ribbon' NOTE: Escher shape
	msotcidShapeEllipseRibbon = 1181,		//(31,2) Label: '&Curved Down Ribbon' NOTE: Escher shape
	msotcidShapeEllipseRibbon2 = 1182,		//(31,3) Label: '&Curved Up Ribbon' NOTE: Escher shape
	msotcidShapeStar = 1183,		//(31,4) Label: '&5-Point Star' NOTE: Escher shape
	msotcidShapeSeal8 = 1184,		//(31,5) Label: '&8-Point Star' NOTE: Escher shape
	msotcidShapeSeal16 = 1185,		//(31,6) Label: '&16-Point Star' NOTE: Escher shape
	msotcidShapeSeal24 = 1186,		//(31,7) Label: '&24-Point Star' NOTE: Escher shape
	msotcidShapeSeal32 = 1187,		//(31,8) Label: '&32-Point Star' NOTE: Escher shape
	msotcidShapeIrregularSeal1 = 1188,		//(31,9) Label: '&Explosion 1' NOTE: Escher shape
	msotcidShapeIrregularSeal2 = 1189,		//(31,10) Label: '&Explosion 2' NOTE: Escher shape
	msotcidShapeFlowChartProcess = 1190,		//(31,11) Label: '&Flowchart: Process' NOTE: Escher shape - start of Flow Chart palette
	msotcidShapeFlowChartAlternateProcess = 1191,		//(31,12) Label: '&Flowchart: Alternate Process' NOTE: Escher shape
	msotcidShapeFlowChartDecision = 1192,		//(31,13) Label: '&Flowchart: Decision' NOTE: Escher shape
	msotcidShapeFlowChartInputOutput = 1193,		//(31,14) Label: '&Flowchart: Data' NOTE: Escher shape
	msotcidShapeFlowChartPredefinedProcess = 1194,		//(31,15) Label: '&Flowchart: Predefined Process' NOTE: Escher shape
	msotcidShapeFlowChartInternalStorage = 1195,		//(31,16) Label: '&Flowchart: Internal Storage' NOTE: Escher shape
	msotcidShapeFlowChartDocument = 1196,		//(31,17) Label: '&Flowchart: Document' NOTE: Escher shape
	msotcidShapeFlowChartMultidocument = 1197,		//(31,18) Label: '&Flowchart: Multidocument' NOTE: Escher shape
	msotcidShapeFlowChartTerminator = 1198,		//(31,19) Label: '&Flowchart: Terminator' NOTE: Escher shape
	msotcidShapeFlowChartPreparation = 1199,		//(31,20) Label: '&Flowchart: Preparation' NOTE: Escher shape
	msotcidShapeFlowChartManualInput = 1200,		//(31,21) Label: '&Flowchart: Manual Input' NOTE: Escher shape
	msotcidShapeFlowChartManualOperation = 1201,		//(31,22) Label: '&Flowchart: Manual Operation' NOTE: Escher shape
	msotcidShapeFlowChartConnector = 1202,		//(31,23) Label: '&Flowchart: Connector' NOTE: Escher shape
	msotcidShapeFlowChartOffpageConnector = 1203,		//(31,24) Label: '&Flowchart: Off-page Connector' NOTE: Escher shape
	msotcidShapeFlowChartPunchedCard = 1204,		//(31,25) Label: '&Flowchart: Card' NOTE: Escher shape
	msotcidShapeFlowChartPunchedTape = 1205,		//(31,26) Label: '&Flowchart: Punched Tape' NOTE: Escher shape
	msotcidShapeFlowChartSummingJunction = 1206,		//(31,27) Label: '&Flowchart: Summing Junction' NOTE: Escher shape
	msotcidShapeFlowChartOr = 1207,		//(31,28) Label: '&Flowchart: Or' NOTE: Escher shape
	msotcidShapeFlowChartCollate = 1208,		//(31,29) Label: '&Flowchart: Collate' NOTE: Escher shape
	msotcidShapeFlowChartSort = 1209,		//(32,0) Label: '&Flowchart: Sort' NOTE: Escher shape
	msotcidShapeFlowChartExtract = 1210,		//(32,1) Label: '&Flowchart: Extract' NOTE: Escher shape
	msotcidShapeFlowChartMerge = 1211,		//(32,2) Label: '&Flowchart: Merge' NOTE: Escher shape
	msotcidShapeFlowChartOfflineStorage = 1212,		//(0,25) Label: '&Reserved' NOTE: Escher shape - UNUSED
	msotcidShapeFlowChartOnlineStorage = 1213,		//(32,4) Label: '&Flowchart: Stored Data' NOTE: Escher shape
	msotcidShapeFlowChartMagneticTape = 1214,		//(32,5) Label: '&Flowchart: Sequential Access Storage' NOTE: Escher shape
	msotcidShapeFlowChartMagneticDisk = 1215,		//(32,6) Label: '&Flowchart: Magnetic Disk' NOTE: Escher shape
	msotcidShapeFlowChartMagneticDrum = 1216,		//(32,7) Label: '&Flowchart: Direct Access Storage' NOTE: Escher shape
	msotcidShapeFlowChartDisplay = 1217,		//(32,8) Label: '&Flowchart: Display' NOTE: Escher shape
	msotcidShapeFlowChartDelay = 1218,		//(32,9) Label: '&Flowchart: Delay' NOTE: Escher shape
	msotcidShapeBorderCallout90 = 1219,		//(32,10) Label: '&Line Callout 1' NOTE: Escher shape
	msotcidShapeAccentCallout90 = 1220,		//(32,11) Label: '&Line Callout 1 (Accent Bar)' NOTE: Escher shape
	msotcidShapeAccentCallout1 = 1221,		//(32,12) Label: '&Line Callout 2 (Accent Bar)' NOTE: Escher shape
	msotcidShapeAccentCallout2 = 1222,		//(32,13) Label: '&Line Callout 3 (Accent Bar)' NOTE: Escher shape
	msotcidShapeAccentCallout3 = 1223,		//(32,14) Label: '&Line Callout 4 (Accent Bar)' NOTE: Escher shape
	msotcidShapeCallout90 = 1224,		//(32,15) Label: '&Line Callout 1 (No Border)' NOTE: Escher shape
	msotcidShapeCallout1 = 1225,		//(32,16) Label: '&Line Callout 2 (No Border)' NOTE: Escher shape
	msotcidShapeCallout2 = 1226,		//(32,17) Label: '&Line Callout 3 (No Border)' NOTE: Escher shape
	msotcidShapeCallout3 = 1227,		//(32,18) Label: '&Line Callout 4 (No Border)' NOTE: Escher shape
	msotcidShapeAccentBorderCallout90 = 1228,		//(32,19) Label: '&Line Callout 1 (Border and Accent Bar)' NOTE: Escher shape
	msotcidShapeAccentBorderCallout1 = 1229,		//(32,20) Label: '&Line Callout 2 (Border and Accent Bar)' NOTE: Escher shape
	msotcidShapeAccentBorderCallout2 = 1230,		//(32,21) Label: '&Line Callout 3 (Border and Accent Bar)' NOTE: Escher shape
	msotcidChangeToShapeAccentBorderCallout3 = 1231,		//(28,21) Label: '&Change Shape to Line Callout 4 (Border and Accent Bar)' NOTE: Escher - change autoshape
	msotcidChangeToShapeRectangle = 1232,		//(2,9) Label: '&Change Shape to Rectangle' NOTE: Escher - change autoshape
	msotcidChangeToShapeParallelogram = 1233,		//(28,23) Label: '&Change Shape to Parallelogram' NOTE: Escher - change autoshape
	msotcidChangeToShapeTrapezoid = 1234,		//(28,24) Label: '&Change Shape to Trapezoid' NOTE: Escher - change autoshape
	msotcidChangeToShapeDiamond = 1235,		//(28,25) Label: '&Change Shape to Diamond' NOTE: Escher - change autoshape
	msotcidChangeToShapeRoundRectangle = 1236,		//(28,26) Label: '&Change Shape to Rounded Rectangle' NOTE: Escher - change autoshape
	msotcidChangeToShapeOctagon = 1237,		//(28,27) Label: '&Change Shape to Octagon' NOTE: Escher - change autoshape
	msotcidChangeToShapeIsocelesTriangle = 1238,		//(28,28) Label: '&Change Shape to Isosceles Triangle' NOTE: Escher - change autoshape
	msotcidChangeToShapeRightTriangle = 1239,		//(28,29) Label: '&Change Shape to Right Triangle' NOTE: Escher - change autoshape
	msotcidChangeToShapeEllipse = 1240,		//(2,10) Label: '&Change Shape to Oval' NOTE: Escher - change autoshape
	msotcidChangeToShapeHexagon = 1241,		//(29,1) Label: '&Change Shape to Hexagon' NOTE: Escher - change autoshape
	msotcidChangeToShapePlus = 1242,		//(29,2) Label: '&Change Shape to Cross' NOTE: Escher - change autoshape
	msotcidChangeToShapeCube = 1243,		//(29,3) Label: '&Change Shape to Cube' NOTE: Escher - change autoshape
	msotcidChangeToShapePlaque = 1244,		//(29,4) Label: '&Change Shape to Plaque' NOTE: Escher - change autoshape
	msotcidChangeToShapePentagon = 1245,		//(29,5) Label: '&Change Shape to Regular Pentagon' NOTE: Escher - change autoshape
	msotcidChangeToShapeWave = 1246,		//(29,6) Label: '&Change Shape to Wave' NOTE: Escher - change autoshape
	msotcidChangeToShapeCan = 1247,		//(29,7) Label: '&Change Shape to Can' NOTE: Escher - change autoshape
	msotcidChangeToShapeVerticalScroll = 1248,		//(29,8) Label: '&Change Shape to Vertical Scroll' NOTE: Escher - change autoshape
	msotcidChangeToShapeHorizontalScroll = 1249,		//(29,9) Label: '&Change Shape to Horizontal Scroll' NOTE: Escher - change autoshape
	msotcidChangeToShapeFoldedCorner = 1250,		//(29,10) Label: '&Change Shape to Folded Corner' NOTE: Escher - change autoshape
	msotcidChangeToShapeBevel = 1251,		//(29,11) Label: '&Change Shape to Bevel' NOTE: Escher - change autoshape
	msotcidChangeToShapeSmileyFace = 1252,		//(29,12) Label: '&Change Shape to Smiley Face' NOTE: Escher - change autoshape
	msotcidChangeToShapeDonut = 1253,		//(29,13) Label: '&Change Shape to Donut' NOTE: Escher - change autoshape
	msotcidChangeToShapeNoSmoking = 1254,		//(29,14) Label: '&Change Shape to \"No\" Symbol' NOTE: Escher - change autoshape
	msotcidChangeToShapeBlockArc = 1255,		//(29,15) Label: '&Change Shape to Block Arc' NOTE: Escher - change autoshape
	msotcidChangeToShapeLeftBracket = 1256,		//(29,16) Label: '&Change Shape to Left Bracket' NOTE: Escher - change autoshape
	msotcidChangeToShapeRightBracket = 1257,		//(29,17) Label: '&Change Shape to Right Bracket' NOTE: Escher - change autoshape
	msotcidChangeToShapeLeftBrace = 1258,		//(29,18) Label: '&Change Shape to Left Brace' NOTE: Escher - change autoshape
	msotcidChangeToShapeRightBrace = 1259,		//(29,19) Label: '&Change Shape to Right Brace' NOTE: Escher - change autoshape
	msotcidChangeToShapeArc = 1260,		//(29,20) Label: '&Change Shape to Arc' NOTE: Escher - change autoshape
	msotcidChangeToShapeLightningBolt = 1261,		//(29,21) Label: '&Change Shape to Lightning Bolt' NOTE: Escher - change autoshape
	msotcidChangeToShapeHeart = 1262,		//(29,22) Label: '&Change Shape to Heart' NOTE: Escher - change autoshape
	msotcidChangeToShapeRightArrow = 1263,		//(29,23) Label: '&Change Shape to Right Arrow' NOTE: Escher - change autoshape
	msotcidChangeToShapeLeftArrow = 1264,		//(29,24) Label: '&Change Shape to Left Arrow' NOTE: Escher - change autoshape
	msotcidChangeToShapeUpArrow = 1265,		//(29,25) Label: '&Change Shape to Up Arrow' NOTE: Escher - change autoshape
	msotcidChangeToShapeDownArrow = 1266,		//(29,26) Label: '&Change Shape to Down Arrow' NOTE: Escher - change autoshape
	msotcidChangeToShapeLeftRightArrow = 1267,		//(29,27) Label: '&Change Shape to Left-Right Arrow' NOTE: Escher - change autoshape
	msotcidChangeToShapeUpDownArrow = 1268,		//(29,28) Label: '&Change Shape to Up-Down Arrow' NOTE: Escher - change autoshape
	msotcidChangeToShapeQuadArrow = 1269,		//(29,29) Label: '&Change Shape to Quad Arrow' NOTE: Escher - change autoshape
	msotcidChangeToShapeLeftRightUpArrow = 1270,		//(30,0) Label: '&Change Shape to Left-Right-Up Arrow' NOTE: Escher - change autoshape
	msotcidChangeToShapeLeftUpArrow = 1271,		//(30,1) Label: '&Change Shape to Left-Up Arrow' NOTE: Escher - change autoshape
	msotcidChangeToShapeBentUpArrow = 1272,		//(30,2) Label: '&Change Shape to Bent-Up Arrow' NOTE: Escher - change autoshape
	msotcidChangeToShapeBentArrow = 1273,		//(30,3) Label: '&Change Shape to Bent Arrow' NOTE: Escher - change autoshape
	msotcidChangeToShapeUturnArrow = 1274,		//(30,4) Label: '&Change Shape to U-Turn Arrow' NOTE: Escher - change autoshape
	msotcidChangeToShapeStripedRightArrow = 1275,		//(30,5) Label: '&Change Shape to Striped Right Arrow' NOTE: Escher - change autoshape
	msotcidChangeToShapeNotchedRightArrow = 1276,		//(30,6) Label: '&Change Shape to Notched Right Arrow' NOTE: Escher - change autoshape
	msotcidChangeToShapeHomePlate = 1277,		//(30,7) Label: '&Change Shape to Pentagon' NOTE: Escher - change autoshape
	msotcidChangeToShapeChevron = 1278,		//(30,8) Label: '&Change Shape to Chevron' NOTE: Escher - change autoshape
	msotcidChangeToShapeCircularArrow = 1279,		//(30,9) Label: '&Change Shape to Circular Arrow' NOTE: Escher - change autoshape
	msotcidChangeToShapeNotchedCircularArrow = 1280,		//(0,25) Label: '&Change Shape to Reserved' NOTE: Escher - UNUSED
	msotcidChangeToShapeCurvedRightArrow = 1281,		//(30,11) Label: '&Change Shape to Curved Right Arrow' NOTE: Escher - change autoshape
	msotcidChangeToShapeCurvedLeftArrow = 1282,		//(30,12) Label: '&Change Shape to Curved Left Arrow' NOTE: Escher - change autoshape
	msotcidChangeToShapeCurvedUpArrow = 1283,		//(30,13) Label: '&Change Shape to Curved Up Arrow' NOTE: Escher - change autoshape
	msotcidChangeToShapeCurvedDownArrow = 1284,		//(30,14) Label: '&Change Shape to Curved Down Arrow' NOTE: Escher - change autoshape
	msotcidChangeToShapeRightArrowCallout = 1285,		//(30,15) Label: '&Change Shape to Right Arrow Callout' NOTE: Escher - change autoshape
	msotcidChangeToShapeLeftArrowCallout = 1286,		//(30,16) Label: '&Change Shape to Left Arrow Callout' NOTE: Escher - change autoshape
	msotcidChangeToShapeUpArrowCallout = 1287,		//(30,17) Label: '&Change Shape to Up Arrow Callout' NOTE: Escher - change autoshape
	msotcidChangeToShapeDownArrowCallout = 1288,		//(30,18) Label: '&Change Shape to Down Arrow Callout' NOTE: Escher - change autoshape
	msotcidChangeToShapeLeftRightArrowCallout = 1289,		//(30,19) Label: '&Change Shape to Left-Right Arrow Callout' NOTE: Escher - change autoshape
	msotcidChangeToShapeUpDownArrowCallout = 1290,		//(30,20) Label: '&Change Shape to Up-Down Arrow Callout' NOTE: Escher - change autoshape
	msotcidChangeToShapeQuadArrowCallout = 1291,		//(30,21) Label: '&Change Shape to Quad Arrow Callout' NOTE: Escher - change autoshape
	msotcidChangeToShapeBalloon = 1292,		//(30,22) Label: '&Change Shape to Balloon' NOTE: Escher - change autoshape
	msotcidChangeToShapeWedgeRectCallout = 1293,		//(30,23) Label: '&Change Shape to Rectangular Callout' NOTE: Escher - change autoshape
	msotcidChangeToShapeWedgeRRectCallout = 1294,		//(30,24) Label: '&Change Shape to Rounded Rectangular Callout' NOTE: Escher - change autoshape
	msotcidChangeToShapeWedgeEllipseCallout = 1295,		//(30,25) Label: '&Change Shape to Oval Callout' NOTE: Escher - change autoshape
	msotcidChangeToShapeCloudCallout = 1296,		//(30,26) Label: '&Change Shape to Cloud Callout' NOTE: Escher - change autoshape
	msotcidChangeToShapeBorderCallout1 = 1297,		//(30,27) Label: '&Change Shape to Line Callout 2' NOTE: Escher - change autoshape
	msotcidChangeToShapeBorderCallout2 = 1298,		//(30,28) Label: '&Change Shape to Line Callout 3' NOTE: Escher - change autoshape
	msotcidChangeToShapeBorderCallout3 = 1299,		//(30,29) Label: '&Change Shape to Line Callout 4' NOTE: Escher - change autoshape
	msotcidChangeToShapeRibbon = 1300,		//(31,0) Label: '&Change Shape to Down Ribbon' NOTE: Escher - change autoshape
	msotcidChangeToShapeRibbon2 = 1301,		//(31,1) Label: '&Change Shape to Up Ribbon' NOTE: Escher - change autoshape
	msotcidChangeToShapeEllipseRibbon = 1302,		//(31,2) Label: '&Change Shape to Curved Down Ribbon' NOTE: Escher - change autoshape
	msotcidChangeToShapeEllipseRibbon2 = 1303,		//(31,3) Label: '&Change Shape to Curved Up Ribbon' NOTE: Escher - change autoshape
	msotcidChangeToShapeStar = 1304,		//(31,4) Label: '&Change Shape to 5-Point Star' NOTE: Escher - change autoshape
	msotcidChangeToShapeSeal8 = 1305,		//(31,5) Label: '&Change Shape to 8-Point Star' NOTE: Escher - change autoshape
	msotcidChangeToShapeSeal16 = 1306,		//(31,6) Label: '&Change Shape to 16-Point Star' NOTE: Escher - change autoshape
	msotcidChangeToShapeSeal24 = 1307,		//(31,7) Label: '&Change Shape to 24-Point Star' NOTE: Escher - change autoshape
	msotcidChangeToShapeSeal32 = 1308,		//(31,8) Label: '&Change Shape to 32-Point Star' NOTE: Escher - change autoshape
	msotcidChangeToShapeIrregularSeal1 = 1309,		//(31,9) Label: '&Change Shape to Explosion 1' NOTE: Escher - change autoshape
	msotcidChangeToShapeIrregularSeal2 = 1310,		//(31,10) Label: '&Change Shape to Explosion 2' NOTE: Escher - change autoshape
	msotcidChangeToShapeFlowChartProcess = 1311,		//(31,11) Label: '&Change Shape to Flowchart: Process' NOTE: Escher - change autoshape
	msotcidChangeToShapeFlowChartAlternateProcess = 1312,		//(31,12) Label: '&Change Shape to Flowchart: Alternate Process' NOTE: Escher - change autoshape
	msotcidChangeToShapeFlowChartDecision = 1313,		//(31,13) Label: '&Change Shape to Flowchart: Decision' NOTE: Escher - change autoshape
	msotcidChangeToShapeFlowChartInputOutput = 1314,		//(31,14) Label: '&Change Shape to Flowchart: Data' NOTE: Escher - change autoshape
	msotcidChangeToShapeFlowChartPredefinedProcess = 1315,		//(31,15) Label: '&Change Shape to Flowchart: Predefined Process' NOTE: Escher - change autoshape
	msotcidChangeToShapeFlowChartInternalStorage = 1316,		//(31,16) Label: '&Change Shape to Flowchart: Internal Storage' NOTE: Escher - change autoshape
	msotcidChangeToShapeFlowChartDocument = 1317,		//(31,17) Label: '&Change Shape to Flowchart: Document' NOTE: Escher - change autoshape
	msotcidChangeToShapeFlowChartMultidocument = 1318,		//(31,18) Label: '&Change Shape to Flowchart: Multidocument' NOTE: Escher - change autoshape
	msotcidChangeToShapeFlowChartTerminator = 1319,		//(31,19) Label: '&Change Shape to Flowchart: Terminator' NOTE: Escher - change autoshape
	msotcidChangeToShapeFlowChartPreparation = 1320,		//(31,20) Label: '&Change Shape to Flowchart: Preparation' NOTE: Escher - change autoshape
	msotcidChangeToShapeFlowChartManualInput = 1321,		//(31,21) Label: '&Change Shape to Flowchart: Manual Input' NOTE: Escher - change autoshape
	msotcidChangeToShapeFlowChartManualOperation = 1322,		//(31,22) Label: '&Change Shape to Flowchart: Manual Operation' NOTE: Escher - change autoshape
	msotcidChangeToShapeFlowChartConnector = 1323,		//(31,23) Label: '&Change Shape to Flowchart: Connector' NOTE: Escher - change autoshape
	msotcidChangeToShapeFlowChartOffpageConnector = 1324,		//(31,24) Label: '&Change Shape to Flowchart: Off-page Connector' NOTE: Escher - change autoshape
	msotcidChangeToShapeFlowChartPunchedCard = 1325,		//(31,25) Label: '&Change Shape to Flowchart: Card' NOTE: Escher - change autoshape
	msotcidChangeToShapeFlowChartPunchedTape = 1326,		//(31,26) Label: '&Change Shape to Flowchart: Punched Tape' NOTE: Escher - change autoshape
	msotcidChangeToShapeFlowChartSummingJunction = 1327,		//(31,27) Label: '&Change Shape to Flowchart: Summing Junction' NOTE: Escher - change autoshape
	msotcidChangeToShapeFlowChartOr = 1328,		//(31,28) Label: '&Change Shape to Flowchart: Or' NOTE: Escher - change autoshape
	msotcidChangeToShapeFlowChartCollate = 1329,		//(31,29) Label: '&Change Shape to Flowchart: Collate' NOTE: Escher - change autoshape
	msotcidChangeToShapeFlowChartSort = 1330,		//(32,0) Label: '&Change Shape to Flowchart: Sort' NOTE: Escher - change autoshape
	msotcidChangeToShapeFlowChartExtract = 1331,		//(32,1) Label: '&Change Shape to Flowchart: Extract' NOTE: Escher - change autoshape
	msotcidChangeToShapeFlowChartMerge = 1332,		//(32,2) Label: '&Change Shape to Flowchart: Merge' NOTE: Escher - change autoshape
	msotcidChangeToShapeFlowChartOfflineStorage = 1333,		//(0,25) Label: '&Change Shape to Reserved' NOTE: Escher - unused
	msotcidChangeToShapeFlowChartOnlineStorage = 1334,		//(32,4) Label: '&Change Shape to Flowchart: Stored Data' NOTE: Escher - change autoshape
	msotcidChangeToShapeFlowChartMagneticTape = 1335,		//(32,5) Label: '&Change Shape to Flowchart: Sequential Access Storage' NOTE: Escher - change autoshape
	msotcidChangeToShapeFlowChartMagneticDisk = 1336,		//(32,6) Label: '&Change Shape to Flowchart: Magnetic Disk' NOTE: Escher - change autoshape
	msotcidChangeToShapeFlowChartMagneticDrum = 1337,		//(32,7) Label: '&Change Shape to Flowchart: Direct Access Storage' NOTE: Escher - change autoshape
	msotcidChangeToShapeFlowChartDisplay = 1338,		//(32,8) Label: '&Change Shape to Flowchart: Display' NOTE: Escher - change autoshape
	msotcidChangeToShapeFlowChartDelay = 1339,		//(32,9) Label: '&Change Shape to Flowchart: Delay' NOTE: Escher - change autoshape
	msotcidChangeToShapeBorderCallout90 = 1340,		//(32,10) Label: '&Change Shape to Line Callout 1' NOTE: Escher - change autoshape
	msotcidChangeToShapeAccentCallout90 = 1341,		//(32,11) Label: '&Change Shape to Line Callout 1 (Accent Bar)' NOTE: Escher - change autoshape
	msotcidChangeToShapeAccentCallout1 = 1342,		//(32,12) Label: '&Change Shape to Line Callout 2 (Accent Bar)' NOTE: Escher - change autoshape
	msotcidChangeToShapeAccentCallout2 = 1343,		//(32,13) Label: '&Change Shape to Line Callout 3 (Accent Bar)' NOTE: Escher - change autoshape
	msotcidChangeToShapeAccentCallout3 = 1344,		//(32,14) Label: '&Change Shape to Line Callout 4 (Accent Bar)' NOTE: Escher - change autoshape
	msotcidChangeToShapeCallout90 = 1345,		//(32,15) Label: '&Change Shape to Line Callout 1 (No Border)' NOTE: Escher - change autoshape
	msotcidChangeToShapeCallout1 = 1346,		//(32,16) Label: '&Change Shape to Line Callout 2 (No Border)' NOTE: Escher - change autoshape
	msotcidChangeToShapeCallout2 = 1347,		//(32,17) Label: '&Change Shape to Line Callout 3 (No Border)' NOTE: Escher - change autoshape
	msotcidChangeToShapeCallout3 = 1348,		//(32,18) Label: '&Change Shape to Line Callout 4 (No Border)' NOTE: Escher - change autoshape
	msotcidChangeToShapeAccentBorderCallout90 = 1349,		//(32,19) Label: '&Change Shape to Line Callout 1 (Border and Accent Bar)' NOTE: Escher - change autoshape
	msotcidChangeToShapeAccentBorderCallout1 = 1350,		//(32,20) Label: '&Change Shape to Line Callout 2 (Border and Accent Bar)' NOTE: Escher - change autoshape
	msotcidChangeToShapeAccentBorderCallout2 = 1351,		//(32,21) Label: '&Change Shape to Line Callout 3 (Border and Accent Bar)' NOTE: Escher - change autoshape
	msotcidTextEffectAlignRight = 1352,		//(28,20) Label: '&Right Align' NOTE: Escher
	msotcidTextEffectLetterJustify = 1353,		//(39,0) Label: 'Le&tter Justify' NOTE: Escher
	msotcidTextEffectWordJustify = 1354,		//(45,22) Label: '&Word Justify' NOTE: Escher
	msotcidTextEffectStretchJustify = 1355,		//(45,23) Label: '&Stretch Justify' NOTE: Escher
	msotcidTextEffectTrackingVeryTight = 1356,		//(0,25) Label: 'Very T&ight' NOTE: Escher
	msotcidTextEffectTrackingTight = 1357,		//(0,25) Label: '&Tight' NOTE: Escher
	msotcidTextEffectTrackingNormal = 1358,		//(0,25) Label: '&Normal' NOTE: Escher
	msotcidTextEffectTrackingLoose = 1359,		//(0,25) Label: '&Loose' NOTE: Escher
	msotcidTextEffectTrackingVeryLoose = 1360,		//(0,25) Label: '&Very Loose' NOTE: Escher
	msotcidTextEffectKern = 1361,		//(0,25) Label: '&Kern Character Pairs' NOTE: Escher
	msotcidResetPicture = 1362,		//(33,21) Label: '&Reset Picture' NOTE: Escher
	msotcidInlinePicture = 1363,		//(33,22) Label: '&Inline Picture' NOTE: Escher
	msotcidRecolorPicture = 1364,		//(33,23) Label: '&Recolor Picture' NOTE: Escher
	msotcidImageAutomatic = 1365,		//(0,25) Label: '&Automatic' NOTE: Escher
	msotcidImageGrayscale = 1366,		//(0,25) Label: '&Grayscale' NOTE: Escher
	msotcidImageBlackAndWhite = 1367,		//(0,25) Label: '&Black && White' NOTE: Escher
	msotcidImageWatermark = 1368,		//(0,25) Label: '&Washout' NOTE: Escher
	msotcidTextWrapSquare = 1369,		//(33,24) Label: '&Square' NOTE: Escher
	msotcidTextWrapTight = 1370,		//(33,25) Label: '&Tight' NOTE: Escher
	msotcidTextWrapNone = 1371,		//(33,26) Label: '&None' NOTE: Escher
	msotcidToggleWrapPolygonMode = 1372,		//(33,27) Label: '&Edit Wrap Points' NOTE: Escher
	msotcidReset3DRotation = 1373,		//(0,25) Label: '&Reset 3-D Rotation' NOTE: Escher
	msotcidToggle3D = 1374,		//(32,22) Label: '&3-D On/Off' NOTE: Escher
	msotcid3DTiltForward = 1375,		//(32,23) Label: '&Tilt Down' NOTE: Escher
	msotcid3DTiltBackward = 1376,		//(32,24) Label: '&Tilt Up' NOTE: Escher
	msotcid3DTiltLeft = 1377,		//(32,25) Label: '&Tilt Left' NOTE: Escher
	msotcid3DTiltRight = 1378,		//(32,26) Label: '&Tilt Right' NOTE: Escher
	msotcidExtrusionDepth = 1379,		//(32,27) Label: '&Depth' NOTE: Escher - menu
	msotcidExtrusionDirection = 1380,		//(32,28) Label: '&Direction' NOTE: Escher - menu
	msotcidExtrusionColor = 1381,		//(32,29) Label: '&3-D Color' NOTE: Escher - OBSOLETE use msotcid3DColorSplitDropdown
	msotcid3DLighting = 1382,		//(33,0) Label: '&Lighting' NOTE: Escher - menu
	msotcid3DSurfaceMaterial = 1383,		//(33,1) Label: '&Surface' NOTE: Escher - menu
	msotcidExtrusionDepthNone = 1384,		//(33,2) Label: '&0 pt.' NOTE: Escher
	msotcidExtrusionDepth1 = 1385,		//(33,3) Label: '&36 pt.' NOTE: Escher
	msotcidExtrusionDepth2 = 1386,		//(33,4) Label: '&72 pt.' NOTE: Escher
	msotcidExtrusionDepth3 = 1387,		//(33,5) Label: '&144 pt.' NOTE: Escher
	msotcidExtrusionDepth4 = 1388,		//(33,6) Label: '&288 pt.' NOTE: Escher
	msotcidExtrusionDepthInfinite = 1389,		//(33,7) Label: '&Infinity' NOTE: Escher
	msotcidPerspectiveExtrusion = 1390,		//(33,8) Label: '&Perspective' NOTE: Escher
	msotcidParallelExtrusion = 1391,		//(33,9) Label: 'P&arallel' NOTE: Escher
	msotcidFlatLighting = 1392,		//(33,10) Label: '&Bright' NOTE: Escher
	msotcidNormalLighting = 1393,		//(33,11) Label: '&Normal' NOTE: Escher
	msotcidHarshLighting = 1394,		//(33,12) Label: '&Dim' NOTE: Escher
	msotcidMatteFinish = 1395,		//(33,13) Label: '&Matte' NOTE: Escher
	msotcidPlasticFinish = 1396,		//(33,14) Label: '&Plastic' NOTE: Escher
	msotcidDullMetalFinish = 1397,		//(33,15) Label: '&Dull Metal' NOTE: Escher
	msotcidPolishedMetalFinish = 1398,		//(33,16) Label: 'Me&tal' NOTE: Escher
	msotcidWireframe = 1399,		//(33,17) Label: '&Wire Frame' NOTE: Escher
	msotcidAddObjectText = 1400,		//(0,25) Label: 'Add Te&xt' NOTE: Escher
	msotcidEditObjectText = 1401,		//(0,25) Label: 'Edit Te&xt' NOTE: Escher
	msotcidSnapToShapes = 1402,		//(33,18) Label: 'To &Shape' NOTE: Escher
	msotcidImageEditing = 1403,		//(33,19) Label: '&Color' NOTE: Escher
	msotcidTextWrapping = 1404,		//(8,5) Label: '&Text Wrapping' NOTE: Escher - menu
	msotcidChangeShapeMenu0 = 1405,		//(3,19) Label: '&Basic Shapes' NOTE: Escher - menu
	msotcidChangeShapeMenu1 = 1406,		//(26,27) Label: '&Callouts' NOTE: Escher - menu
	msotcidChangeShapeMenu2 = 1407,		//(26,28) Label: '&Flowchart' NOTE: Escher - menu
	msotcidChangeShapeMenu3 = 1408,		//(26,29) Label: 'Block &Arrows' NOTE: Escher - menu
	msotcidChangeShapeMenu4 = 1409,		//(27,0) Label: '&Stars and Banners' NOTE: Escher - menu
	msotcidShowTextEffectsBar = 1410,		//(0,25) Label: 'Show WordArt Tool&bar' NOTE: Escher
	msotcidHideTextEffectsBar = 1411,		//(0,25) Label: 'Hide WordArt Tool&bar' NOTE: Escher
	msotcidExitRotateMode = 1412,		//(0,25) Label: '&Exit Rotate Mode' NOTE: Escher
	msotcidShowPictureBar = 1413,		//(0,25) Label: 'Show Picture Too&lbar' NOTE: Escher
	msotcidHidePictureBar = 1414,		//(0,25) Label: 'Hide Picture Too&lbar' NOTE: Escher
	msotcidAddNode = 1415,		//(0,25) Label: '&Add Point' NOTE: Escher - curves menu
	msotcidDeleteNode = 1416,		//(0,25) Label: 'De&lete Point' NOTE: Escher
	msotcidMakeSegmentStraight = 1417,		//(0,25) Label: '&Straight Segment' NOTE: Escher
	msotcidMakeSegmentCurved = 1418,		//(0,25) Label: '&Curved Segment' NOTE: Escher
	msotcidCutNode = 1419,		//(0,25) Label: 'Cu&t Point' NOTE: Escher
	msotcidCloseCurve = 1420,		//(0,25) Label: 'Close &Path' NOTE: Escher
	msotcidAutoVertex = 1421,		//(0,25) Label: 'Au&to Point' NOTE: Escher
	msotcidSmoothVertex = 1422,		//(0,25) Label: '&Smooth Point' NOTE: Escher
	msotcidStraightVertex = 1423,		//(0,25) Label: 'St&raight Point' NOTE: Escher
	msotcidCornerVertex = 1424,		//(0,25) Label: '&Corner Point' NOTE: Escher
	msotcidExitEditCurve = 1425,		//(0,25) Label: 'Exit &Edit Point' NOTE: Escher - yes, the string is "Exit &Edit Point"
	msotcidCanvasSize = 1426,		//(0,25) Label: '&Canvas Size...' NOTE: Escher Server
	msotcidSwitcher_BehindAboveText = 1427,		//(48,13) Label: '&no label' NOTE: Word toggle command
	msotcidFormsDesign = 1428,		//(0,25) Label: 'Forms &Design' NOTE: toggles between design & run mode
	msotcidRemoveSplit = 1429,		//(10,11) Label: 'Remove &Split' NOTE: Word
	msotcidEditRoutingSlip = 1430,		//(0,25) Label: 'Edit &Routing Slip' NOTE: PGM - obsolete now?
	msotcidFileSaveUpdateAll = 1431,		//(0,25) Label: 'Save and Update Al&l'
	msotcidSaveCopyAs = 1432,		//(0,25) Label: 'Save Copy &As...'
	msotcidSaveTemplate = 1433,		//(0,25) Label: '&Save Template'
	msotcidResumeRecorder = 1434,		//(25,29) Label: '&Resume Recorder'
	msotcidArrangeIcons = 1435,		//(0,25) Label: '&Arrange Icons'
	msotcidPasteRows = 1436,		//(1,8) Label: '&Paste Rows' NOTE: Word
	msotcidPasteColumns = 1437,		//(1,8) Label: '&Paste Columns' NOTE: Word
	msotcidPasteCells = 1438,		//(1,8) Label: '&Paste Cells' NOTE: Word
	msotcidUnprotectDocument = 1439,		//(0,25) Label: 'Un&protect Document'
	msotcidFormatPicture = 1440,		//(68,21) Label: 'P&icture...' NOTE: Escher - cf. msotcidFormatPicture2 for use on context menus
	msotcidFormatFrame = 1441,		//(0,25) Label: '&Format Frame...'
	msotcidMoreHistory = 1442,		//(0,25) Label: 'Open &History Folder' NOTE: Web
	msotcidHistoryMenu = 1443,		//(0,25) Label: '&THIS ID IS OBSOLETE' NOTE: PGM - OBSOLETE
	msotcidFavoritesMenu = 1444,		//(0,25) Label: '&THIS ID IS OBSOLETE' NOTE: PGM - OBSOLETE
	msotcidURL = 1445,		//(7,18) Label: '&URL' NOTE: Web - a URL in favorites menu
	msotcidSectionPrintPreview = 1446,		//(1,4) Label: '&Print Preview' NOTE: Binder
	msotcidTextEnvelopesSwatch = 1447,		//(0,25) Label: '&Text Envelopes' NOTE: swatch of text obj shapes
	msotcidDashStyleSwatch = 1448,		//(0,25) Label: '&Dash Styles' NOTE: Escher
	msotcidArrowStyleSwatch = 1449,		//(0,25) Label: '&Arrow Styles' NOTE: Escher
	msotcidShadowStyleSwatch = 1450,		//(0,25) Label: '&Shadow Styles' NOTE: Escher
	msotcid3DStyleSwatch = 1451,		//(0,25) Label: '&3-D Styles' NOTE: Escher
	msotcidCustomIconsSwatch = 1452,		//(0,25) Label: '&Custom Icons' NOTE: used by Office customize
	msotcidFillColorNoneSwatch = 1453,		//(0,25) Label: '&No Color' NOTE: Escher -
	msotcidFillColorAutomaticSwatch = 1454,		//(0,25) Label: '&Automatic Color' NOTE: Escher -
	msotcidFillColorSchemeSwatch = 1455,		//(0,25) Label: '&Color Scheme' NOTE: Escher -
	msotcidFillColorPickerSwatch = 1456,		//(0,25) Label: '&Standard Colors' NOTE: Escher -
	msotcidFillColorMRUSwatch = 1457,		//(0,25) Label: '&Recently Used Colors' NOTE: Escher -
	msotcidLineColorNoneSwatch = 1458,		//(0,25) Label: '&No Color' NOTE: Escher -
	msotcidLineColorAutomaticSwatch = 1459,		//(0,25) Label: '&Automatic Color' NOTE: Escher -
	msotcidLineColorSchemeSwatch = 1460,		//(0,25) Label: '&Color Scheme' NOTE: Escher -
	msotcidLineColorPickerSwatch = 1461,		//(0,25) Label: '&Standard Colors' NOTE: Escher -
	msotcidLineColorMRUSwatch = 1462,		//(0,25) Label: '&Recently Used Colors' NOTE: Escher -
	msotcidShadowColorNoneSwatch = 1463,		//(0,25) Label: '&No Color' NOTE: Escher -
	msotcidShadowColorAutomaticSwatch = 1464,		//(0,25) Label: '&Automatic Color' NOTE: Escher -
	msotcidShadowColorSchemeSwatch = 1465,		//(0,25) Label: '&Color Scheme' NOTE: Escher -
	msotcidShadowColorPickerSwatch = 1466,		//(0,25) Label: '&Standard Colors' NOTE: Escher -
	msotcidShadowColorMRUSwatch = 1467,		//(0,25) Label: '&Recently Used Colors' NOTE: Escher -
	msotcid3DColorNoneSwatch = 1468,		//(0,25) Label: '&No Color' NOTE: Escher -
	msotcid3DColorAutomaticSwatch = 1469,		//(0,25) Label: '&Automatic Color' NOTE: Escher -
	msotcid3DColorSchemeSwatch = 1470,		//(0,25) Label: '&Color Scheme' NOTE: Escher -
	msotcid3DColorPickerSwatch = 1471,		//(0,25) Label: '&Standard Colors' NOTE: Escher -
	msotcid3DColorMRUSwatch = 1472,		//(0,25) Label: '&Recently Used Colors' NOTE: Escher -
	msotcidLightingDirectionSwatch = 1473,		//(0,25) Label: '&Lighting Direction' NOTE: Escher - 3x3 swatch of directions
	msotcidSimpleGradientColorNoneSwatch = 1474,		//(0,25) Label: '&No Color'
	msotcidSimpleGradientColorAutomaticSwatch = 1475,		//(0,25) Label: '&Automatic Color'
	msotcidSimpleGradientColorSchemeSwatch = 1476,		//(0,25) Label: '&Color Scheme'
	msotcidSimpleGradientColorPickerSwatch = 1477,		//(0,25) Label: '&Standard Colors'
	msotcidSimpleGradientColorMRUSwatch = 1478,		//(0,25) Label: 'Dlg Single Gradient Color &1 Menu'
	msotcidSimpleGradientColorMoreSwatch = 1479,		//(0,25) Label: '&More Colors...'
	msotcidGradientColor1NoneSwatch = 1480,		//(0,25) Label: '&No Color'
	msotcidGradientColor1AutomaticSwatch = 1481,		//(0,25) Label: '&Automatic Color'
	msotcidGradientColor1SchemeSwatch = 1482,		//(0,25) Label: '&Color Scheme'
	msotcidGradientColor1PickerSwatch = 1483,		//(0,25) Label: '&Standard Colors'
	msotcidGradientColor1MRUSwatch = 1484,		//(0,25) Label: '&Recently Used Colors'
	msotcidGradientColor1MoreSwatch = 1485,		//(0,25) Label: '&More Colors...'
	msotcidGradientColor2NoneSwatch = 1486,		//(0,25) Label: '&No Color'
	msotcidGradientColor2AutomaticSwatch = 1487,		//(0,25) Label: '&Automatic Color'
	msotcidGradientColor2SchemeSwatch = 1488,		//(0,25) Label: '&Color Scheme'
	msotcidGradientColor2PickerSwatch = 1489,		//(0,25) Label: '&Standard Colors'
	msotcidGradientColor2MRUSwatch = 1490,		//(0,25) Label: '&Recently Used Colors'
	msotcidGradientColor2MoreSwatch = 1491,		//(0,25) Label: '&More Colors...'
	msotcidDlgPatternForegroundColorNoneSwatch = 1492,		//(0,25) Label: '&No Color' NOTE: Escher
	msotcidDlgPatternForegroundColorAutomaticSwatch = 1493,		//(0,25) Label: '&Automatic Color' NOTE: Escher
	msotcidDlgPatternForegroundColorSchemeSwatch = 1494,		//(0,25) Label: '&Color Scheme' NOTE: Escher
	msotcidDlgPatternForegroundColorPickerSwatch = 1495,		//(0,25) Label: '&Standard Colors' NOTE: Escher
	msotcidDlgPatternForegroundColorMRUSwatch = 1496,		//(0,25) Label: '&Recently Used Colors' NOTE: Escher
	msotcidDlgPatternForegroundColorMoreSwatch = 1497,		//(0,25) Label: '&More Colors...' NOTE: Escher
	msotcidDlgPatternBackgroundColorNoneSwatch = 1498,		//(0,25) Label: '&No Color' NOTE: Escher
	msotcidDlgPatternBackgroundColorAutomaticSwatch = 1499,		//(0,25) Label: '&Automatic Color' NOTE: Escher
	msotcidDlgPatternBackgroundColorSchemeSwatch = 1500,		//(0,25) Label: '&Color Scheme' NOTE: Escher
	msotcidDlgPatternBackgroundColorPickerSwatch = 1501,		//(0,25) Label: '&Standard Colors' NOTE: Escher
	msotcidDlgPatternBackgroundColorMRUSwatch = 1502,		//(0,25) Label: '&Recently Used Colors' NOTE: Escher
	msotcidDlgPatternBackgroundColorMoreSwatch = 1503,		//(0,25) Label: '&More Colors...' NOTE: Escher
	msotcidDlgLineColorNoneSwatch = 1504,		//(0,25) Label: '&No Color' NOTE: Escher
	msotcidDlgLineColorAutomaticSwatch = 1505,		//(0,25) Label: '&Automatic Color' NOTE: Escher
	msotcidDlgLineColorSchemeSwatch = 1506,		//(0,25) Label: '&Color Scheme' NOTE: Escher
	msotcidDlgLineColorPickerSwatch = 1507,		//(0,25) Label: '&Standard Colors' NOTE: Escher
	msotcidDlgLineColorMRUSwatch = 1508,		//(0,25) Label: '&Recently Used Colors' NOTE: Escher
	msotcidDlgLineColorMoreSwatch = 1509,		//(0,25) Label: '&More Colors...' NOTE: Escher
	msotcidDlgColorNoneSwatch = 1510,		//(0,25) Label: '&No Color' NOTE: Escher - standalone swatches inside dlgs
	msotcidDlgColorSchemeSwatch = 1511,		//(0,25) Label: '&Color Scheme'
	msotcidDlgColorPickerSwatch = 1512,		//(0,25) Label: '&Standard Colors'
	msotcidDlgColorMRUSwatch = 1513,		//(0,25) Label: '&Recently Used Colors'
	msotcidDlgLineStyleSwatch = 1514,		//(0,25) Label: '&Line Style'
	msotcidDlgLineWidthSwatch = 1515,		//(0,25) Label: '&Line Width'
	msotcidDlgDashStyleSwatch = 1516,		//(0,25) Label: '&Dash Style'
	msotcidDlgArrow1StyleSwatch = 1517,		//(0,25) Label: '&Style'
	msotcidDlgArrow1SizeSwatch = 1518,		//(0,25) Label: '&Size'
	msotcidDlgArrow2StyleSwatch = 1519,		//(0,25) Label: '&Style'
	msotcidDlgArrow2SizeSwatch = 1520,		//(0,25) Label: '&Size'
	msotcidExtrusionDirectionSwatch = 1521,		//(0,25) Label: '&Extrusion Direction' NOTE: Escher
	msotcidSimpleGradientColorMenu = 1522,		//(0,25) Label: 'Dlg Single Gradient Color &1 Menu' NOTE: Escher
	msotcidGradientColor1Menu = 1523,		//(0,25) Label: 'Color &1 ' NOTE: Escher
	msotcidGradientColor2Menu = 1524,		//(0,25) Label: 'Color &2 ' NOTE: Escher
	msotcidDlgPatternForegroundColor = 1525,		//(0,25) Label: '&Foreground' NOTE: Escher
	msotcidDlgPatternBackgroundColorMenu = 1526,		//(0,25) Label: '&Background' NOTE: Escher
	msotcidDlgLineColorMenu = 1527,		//(0,25) Label: 'Line C&olor' NOTE: Escher
	msotcidDlgLineStyleMenu = 1528,		//(0,25) Label: 'Line &Style'
	msotcidDlgLineWidthMenu = 1529,		//(0,25) Label: 'Dlg Line &Width Menu'
	msotcidDlgDashStyleMenu = 1530,		//(0,25) Label: '&Dashed'
	msotcidDlgConnectorStyleMenu = 1531,		//(0,25) Label: 'Dlg Co&nnector Menu'
	msotcidDlgArrow1StyleMenu = 1532,		//(0,25) Label: '&Begin Arrow Style'
	msotcidDlgArrow1SizeMenu = 1533,		//(0,25) Label: 'Begin Arrow S&ize'
	msotcidDlgArrow2StyleMenu = 1534,		//(0,25) Label: '&End Arrow Style'
	msotcidDlgArrow2SizeMenu = 1535,		//(0,25) Label: 'End Arrow Si&ze' NOTE: more
	msotcidPatternedLines = 1536,		//(0,25) Label: '&Patterned Lines...' NOTE: Escher - used on line color menu in Format Object dialog
	msotcidDlgStraightConnector = 1537,		//(26,22) Label: '&Straight' NOTE: Escher - used in menu in dialog
	msotcidDlgAngledConnector = 1538,		//(26,23) Label: '&Elbow' NOTE: Escher
	msotcidDlgCurvedConnector = 1539,		//(26,24) Label: '&Curved' NOTE: Escher
	msotcidEditPicture = 1540,		//(0,25) Label: '&Edit Picture' NOTE: Escher
	msotcidOpenPicture = 1541,		//(0,25) Label: '&Open Picture' NOTE: Escher
	msotcidEditOLEObject = 1542,		//(0,25) Label: '&Edit Object' NOTE: presumably would override string with object name
	msotcidOpenOLEObject = 1543,		//(0,25) Label: '&Open Object' NOTE: presumably would override string with object name
	msotcidBrowseByPage = 1544,		//(34,9) Label: '&Browse by Page' NOTE: Word - icons for browse tool
	msotcidBrowseBySection = 1545,		//(34,10) Label: '&Browse by Section' NOTE: Word
	msotcidBrowseByAnnotation = 1546,		//(34,11) Label: '&Browse by Comment' NOTE: Word
	msotcidBrowseByFootnote = 1547,		//(44,12) Label: '&Browse by Footnote' NOTE: Word
	msotcidBrowseByEndnote = 1548,		//(34,13) Label: '&Browse by Endnote' NOTE: Word
	msotcidBrowseByField = 1549,		//(44,11) Label: '&Browse by Field' NOTE: Word
	msotcidBrowseByTable = 1550,		//(1,14) Label: '&Browse by Table' NOTE: Word
	msotcidBrowseByGraphic = 1551,		//(34,16) Label: '&Browse by Graphic' NOTE: Word
	msotcidBrowseByIP = 1552,		//(34,17) Label: '&Browse by IP' NOTE: Word
	msotcidBrowseByHeading = 1553,		//(34,18) Label: '&Browse by Heading' NOTE: Word
	msotcidPageNumber = 1554,		//(34,19) Label: '&Page Number'
	msotcidSectionNumber = 1555,		//(35,10) Label: '&Section Number' NOTE: Binder
	msotcidSectionName = 1556,		//(35,11) Label: '&Section Name' NOTE: Binder
	msotcidBinderName = 1557,		//(35,13) Label: '&Binder Name' NOTE: Binder
	msotcidTotalSections = 1558,		//(35,12) Label: '&Number of Sections' NOTE: Binder
	msotcidOfficeAssistantTip = 1559,		//(27,27) Label: '&Office Assistant' NOTE: icon of assistant with tip
	msotcidBinderOptions = 1560,		//(0,25) Label: '&Binder Options...' NOTE: options for whole binder
	msotcidViewVisualBasicCode = 1561,		//(38,23) Label: '&View Code' NOTE: VB
	msotcidNotesAction = 1562,		//(0,25) Label: '&<your string here>' NOTE: repeated on NotesFlow bar for each action
	msotcidLineWidthSwatch = 1563,		//(0,25) Label: '&Line Width' NOTE: Escher - see also DlgLineWidthSwatch
	msotcidRemoveFromCalendar = 1564,		//(0,25) Label: 'Remove from &Calendar' NOTE: Ren
	msotcidNextBinderSection = 1565,		//(0,25) Label: '&Next Section' NOTE: Binder
	msotcidPreviousBinderSection = 1566,		//(0,25) Label: '&Previous Section' NOTE: Binder
	msotcidCloseView = 1567,		//(0,25) Label: '&Close' NOTE: used to exit a mode or view, e.g. Print Preview
	msotcidCreateMenuFromMacro = 1568,		//(0,25) Label: '&Create Menu From Macro' NOTE: Access - backward compatibility
	msotcidCreateToolbarFromMacro = 1569,		//(0,25) Label: 'Create &Toolbar From Macro' NOTE: Access - backward compatibility
	msotcidCreateShortcutMenuFromMacro = 1570,		//(0,25) Label: 'Create S&hortcut Menu From Macro' NOTE: Access - backward compatibility
	msotcidNewDrawing = 1571,		//(10,14) Label: '&New Drawing' NOTE: Word - Insert Picture cascade
	msotcidCustomExtrusionEdit = 1572,		//(0,25) Label: '&Custom:' NOTE: Escher
	msotcidCustomLineWidthEdit = 1573,		//(0,25) Label: '&Custom Width:' NOTE: Escher
	msotcidWebOpenInNewWindow = 1574,		//(0,25) Label: 'Open in New &Window' NOTE: Web
	msotcidWebCopyHyperlink = 1575,		//(0,25) Label: '&Copy Hyperlink' NOTE: Web
	msotcidWebInsertHyperlink = 1576,		//(1,12) Label: 'Hyperl&ink...' NOTE: Web
	msotcidWebEditHyperlink = 1577,		//(1,12) Label: 'Edit &Hyperlink...' NOTE: Web
	msotcidWebEditHyperlinkText = 1578,		//(0,25) Label: '&Select Hyperlink' NOTE: Web
	msotcidWebOpenHyperlinkDialog = 1579,		//(0,25) Label: '&Open Hyperlink Dialog...' NOTE: Web
	msotcidBinderPreviewNextSection = 1580,		//(0,25) Label: 'Ne&xt Section' NOTE: Binder - for use on preview toolbar
	msotcidBinderPreviewPreviousSection = 1581,		//(0,25) Label: 'P&revious Section' NOTE: Binder - for use on preview toolbar
	msotcidLineWidth = 1582,		//(34,28) Label: '&Line Width' NOTE: Escher
	msotcidAddToPrintArea = 1583,		//(0,25) Label: '&Add to Print Area' NOTE: XL
	msotcidClearPrintArea = 1584,		//(0,25) Label: '&Clear Print Area' NOTE: Excel
	msotcidResetManualPageBreaks = 1585,		//(0,25) Label: 'Reset &All Page Breaks'
	msotcidRemoveFromPrintArea = 1586,		//(0,25) Label: '&Exclude From Print Area'
	msotcidRemovePageBreak = 1587,		//(0,25) Label: 'Remove Page &Break' NOTE: for XL only (cf. the "real" msotcidPageBreak)
	msotcidInsertPageBreak = 1588,		//(0,25) Label: 'Insert Page &Break' NOTE: for XL only (cf. the "real" msotcidPageBreak)
	msotcidNewComment = 1589,		//(5,28) Label: 'Co&mment'
	msotcidPreviousComment = 1590,		//(35,0) Label: '&Previous Comment'
	msotcidNextComment = 1591,		//(35,1) Label: '&Next Comment'
	msotcidDeleteComment = 1592,		//(35,2) Label: 'Delete Co&mment'
	msotcidShowComment = 1593,		//(35,3) Label: 'Sh&ow Comment' NOTE: use msotcidHideComment for alternate string
	msotcidShowAllComments = 1594,		//(5,26) Label: '&Comments' NOTE: use msotcidHideAllComments for alt string
	msotcidHideComment = 1595,		//(0,25) Label: '&Hide Comment' NOTE: alternate string for msotcidShowComment
	msotcidHideAllComments = 1596,		//(0,25) Label: '&OBSOLETE ID' NOTE: PGM - OBSOLETE
	msotcidPivotTableInsertField = 1597,		//(0,25) Label: 'Calculated &Field...'
	msotcidPivotTableInsertItem = 1598,		//(0,25) Label: 'Calculated &Item...'
	msotcidPivotTableInsertBlank = 1599,		//(0,25) Label: '&Insert Blank'
	msotcidPivotTableSelectTable = 1600,		//(0,25) Label: 'Entire &Table'
	msotcidPivotTableRecalc = 1601,		//(0,25) Label: '&Recalculate'
	msotcidPivotTableHideItem = 1602,		//(0,25) Label: '&Hide Item'
	msotcidPivotTableShowItem = 1603,		//(0,25) Label: '&Show Item'
	msotcidPivotTableProperties = 1604,		//(0,25) Label: 'Table &Options...'
	msotcidToggleDesignMode = 1605,		//(9,11) Label: '&Design Mode' NOTE: VBE
	msotcidTextEffectGallery = 1606,		//(28,1) Label: '&WordArt Gallery' NOTE: Escher
	msotcidFormFieldOptions = 1607,		//(5,13) Label: 'Prope&rties' NOTE: Word
	msotcidPhoneticClear = 1608,		//(0,25) Label: '&Clear Phonetic Field' NOTE: (FE) clear phonetic field
	msotcidPhoneticDelete = 1609,		//(0,25) Label: '&Delete Phonetic Info' NOTE: (FE) delete phonetic info
	msotcidPhoneticHide = 1610,		//(48,21) Label: '&Hide Phonetic Field' NOTE: (FE) hide phonetic field
	msotcidPhoneticInsert = 1611,		//(48,19) Label: '&Edit' NOTE: (FE) create phonetic info while editing cell
	msotcidPreviewFullScreen = 1612,		//(5,27) Label: 'F&ull Screen' NOTE: Word - bug 134687, alternate form of FullScreen
	msotcidPhoneticProperties = 1613,		//(48,20) Label: 'Se&ttings...' NOTE: (FE) change properties of phonetic field
	msotcidPhoneticShow = 1614,		//(48,21) Label: '&Show or Hide' NOTE: (FE) show phonetic field
	msotcidPhoneticShowAll = 1615,		//(0,25) Label: '&Show All Phonetic Fields' NOTE: (FE) show all phonetic fields on sheet
	msotcidChartTypeSwatch = 1616,		//(0,25) Label: '&Chart Type' NOTE: Excel swatch of chart types
	msotcidPatternSwatch = 1617,		//(0,25) Label: '&Pattern'
	msotcidBorderSwatch = 1618,		//(0,25) Label: '&Border'
	msotcidDlgColorAutoSwatch = 1619,		//(0,25) Label: '&Automatic color' NOTE: XL - automatic color in dialog dropdowns
	msotcidDlgPatternSwatch = 1620,		//(0,25) Label: '&Pattern' NOTE: XL - pattern swatch in dialog dropdowns
	msotcidCustomTextEffectSpacingEdit = 1621,		//(0,25) Label: '&Custom:' NOTE: Escher - custom text tracking
	msotcidChartSelectionDropdown = 1622,		//(0,25) Label: '&Chart Objects:' NOTE: Excel - dropdown to select a chart element
	msotcidCircularReferenceDropdown = 1623,		//(0,25) Label: '&Navigate Circular Reference:' NOTE: XL - list of cells in circular ref list
	msotcidLineToolSplitDropdown = 1624,		//(0,25) Label: '&Line Tools' NOTE: Escher - MRU of line tools - PGM: OBSOLETE
	msotcidShapeToolSplitDropdown = 1625,		//(0,25) Label: '&AutoShape Tools' NOTE: Escher - MRU of shape tools - PGM: OBSOLETE
	msotcidAutoScroll = 1626,		//(0,25) Label: '&Auto Scroll' NOTE: Word
	msotcidSmallColorSchemeSwatch = 1627,		//(0,25) Label: '&Color Picker' NOTE: 16 color swatch, always small button size
	msotcidSmallColorPickerSwatch = 1628,		//(0,25) Label: '&Color Picker' NOTE: 40 color swatch, always small button size
	msotcidChartPropertiesColorSchemeSwatch = 1629,		//(0,25) Label: '&Color Scheme' NOTE: Graph - Chart Properties
	msotcidChartPropertiesColorPickerSwatch = 1630,		//(0,25) Label: '&Color Picker' NOTE: Graph - Chart properties
	msotcidExpandSubdocuments = 1631,		//(34,26) Label: '&Expand Subdocuments' NOTE: see msotcidSwitcher_ExpandCollapseSubdocuments
	msotcidCollapseSubdocuments = 1632,		//(34,27) Label: '&Collapse Subdocuments' NOTE: see msotcidSwitcher_ExpandCollapseSubdocuments
	msotcidSwitcher_ExpandCollapseSubdocuments = 1633,		//(48,13) Label: '&Expand/Collapse Subdocuments' NOTE: core cmd--switches bet. expand & collapse
	msotcidTearOffHandle = 1634,		//(0,25) Label: '&Drag to make this menu float' NOTE: office internal
	msotcidBubbleChart = 1635,		//(14,10) Label: '&Bubble Chart'
	msotcidCylinderChart3D = 1636,		//(14,22) Label: '&3-D Cylinder Chart'
	msotcidPyramidChart3D = 1637,		//(14,24) Label: '&3-D Pyramid Chart'
	msotcidConeChart3D = 1638,		//(14,23) Label: '&3-D Cone Chart'
	msotcidDoubleArrow = 1639,		//(35,18) Label: '&Double Arrow' NOTE: Escher
	msotcidDoorwayExit = 1640,		//(19,8) Label: '&Doorway' NOTE: open door with arrow
	msotcidMoveHere = 1641,		//(27,17) Label: '&use msotcidRightDragMove instead' NOTE: PGM: OBSOLETE
	msotcidCopyHere = 1642,		//(1,7) Label: '&use msotcidRightDragCopy instead' NOTE: PGM: OBSOLETE
	msotcidInternationalCurrency = 1643,		//(35,19) Label: '&Currency' NOTE: int'l currency symbol, for Excel
	msotcidCenterHorizontallyInForm = 1644,		//(35,20) Label: '&Horizontally' NOTE: Forms
	msotcidCenterVerticallyInForm = 1645,		//(35,21) Label: '&Vertically' NOTE: Forms
	msotcidSizeToControlWidth = 1646,		//(35,22) Label: '&Width' NOTE: Forms
	msotcidSizeToControlHeight = 1647,		//(35,23) Label: '&Height' NOTE: Forms
	msotcidSizeToControlHeightAndWidth = 1648,		//(35,24) Label: '&Both' NOTE: Forms
	msotcidHorizontalSpacingDecrease = 1649,		//(35,25) Label: '&Decrease' NOTE: Forms
	msotcidHorizontalSpacingIncrease = 1650,		//(35,26) Label: '&Increase' NOTE: Forms
	msotcidHorizontalSpacingRemove = 1651,		//(35,27) Label: '&Remove' NOTE: Forms
	msotcidVerticalSpacingDecrease = 1652,		//(35,28) Label: '&Decrease' NOTE: Forms
	msotcidVerticalSpacingIncrease = 1653,		//(35,29) Label: '&Increase' NOTE: Forms
	msotcidVerticalSpacingRemove = 1654,		//(36,0) Label: '&Remove' NOTE: Forms
	msotcidArrangeButtonsBottom = 1655,		//(36,1) Label: '&Bottom' NOTE: Forms
	msotcidArrangeButtonsRight = 1656,		//(36,2) Label: '&Right' NOTE: Forms
	msotcidCancelMeeting = 1657,		//(37,9) Label: '&Cancel Meeting' NOTE: Ren
	msotcidCreatePublicFolderShortcut = 1658,		//(0,25) Label: 'Create Public Folder &Shortcut' NOTE: Ren
	msotcidExplore = 1659,		//(0,25) Label: '&Explore...' NOTE: Ren
	msotcidCreateSubfolder = 1660,		//(44,28) Label: 'Create &Subfolder...' NOTE: Ren
	msotcidOpenFolder = 1661,		//(0,10) Label: '&Open Folder' NOTE: Ren
	msotcidRenameFolder = 1662,		//(67,28) Label: '&Rename Folder...' NOTE: Ren
	msotcidPrivate = 1663,		//(0,25) Label: 'Pri&vate' NOTE: Ren
	msotcidAcceptTask = 1664,		//(56,24) Label: 'A&ccept' NOTE: Ren
	msotcidSaveAndNew = 1665,		//(36,4) Label: 'Sav&e and New' NOTE: Ren - save and create new contact
	msotcidGroupBy = 1666,		//(36,5) Label: '&Group By...' NOTE: Ren
	msotcidCopyFolder = 1667,		//(68,0) Label: '&Copy Folder...' NOTE: Ren
	msotcidDeleteFolder = 1668,		//(68,5) Label: '&Delete Folder' NOTE: Ren
	msotcidMoveFolder = 1669,		//(67,27) Label: '&Move Folder...' NOTE: Ren
	msotcidDisconnectNetworkDrive = 1670,		//(36,9) Label: '&Disconnect Network Drive...' NOTE: like in explorer
	msotcidEmptyTrash = 1671,		//(7,20) Label: 'Empt&y \"<0s#25>\" Folder' NOTE: Ren
	msotcidRecordInJournal = 1672,		//(45,27) Label: 'Record in &Journal' NOTE: Ren
	msotcidConnectNetworkDrive = 1673,		//(36,12) Label: '&Map Network Drive...' NOTE: Ren
	msotcidMarkAsRead = 1674,		//(24,19) Label: 'Mar&k as Read' NOTE: Ren
	msotcidMarkAsUnread = 1675,		//(7,12) Label: 'Mark as U&nread' NOTE: Ren
	msotcidCopyToFolder = 1676,		//(36,15) Label: 'Cop&y to Folder...' NOTE: Ren
	msotcidCheckForNewMail = 1677,		//(17,21) Label: '&Check for New Mail' NOTE: Ren
	msotcidTagMessage = 1678,		//(7,22) Label: '&Message Flag...' NOTE: Ren 
	msotcidMoveToFolder = 1679,		//(6,2) Label: '&Move to Folder...' NOTE: Ren
	msotcidMakeNoteBlue = 1680,		//(0,25) Label: '&Blue' NOTE: Ren
	msotcidMakeNoteGreen = 1681,		//(0,25) Label: '&Green' NOTE: Ren
	msotcidMakeNotePink = 1682,		//(0,25) Label: '&Pink' NOTE: Ren
	msotcidMakeNoteWhite = 1683,		//(0,25) Label: '&White' NOTE: Ren
	msotcidMakeNoteYellow = 1684,		//(0,25) Label: '&Yellow' NOTE: Ren
	msotcidShowAllTasks = 1685,		//(0,25) Label: '&All Tasks' NOTE: Ren
	msotcidShowUpcomingTasks = 1686,		//(0,25) Label: 'Ta&sks for Next Seven Days' NOTE: Ren
	msotcidShowActiveTasks = 1687,		//(0,25) Label: 'A&ctive Tasks for Selected Days' NOTE: Ren
	msotcidShowIncompleteTasks = 1688,		//(0,25) Label: '&Today's Tasks' NOTE: Ren
	msotcidShowCompletedTasks = 1689,		//(0,25) Label: 'Tas&ks Completed on Selected Days' NOTE: Ren
	msotcidShowOverdueTasks = 1690,		//(0,25) Label: '&Overdue Tasks' NOTE: Ren
	msotcidFillColorSplitDropdown = 1691,		//(2,17) Label: '&Fill Color' NOTE: Escher - the MRU color picker menu
	msotcidLineColorSplitDropdown = 1692,		//(2,18) Label: '&Line Color' NOTE: Escher - the MRU color picker menu
	msotcidShadowColorSplitDropdown = 1693,		//(27,29) Label: '&Shadow Color' NOTE: Escher - the MRU color picker menu
	msotcid3DColorSplitDropdown = 1694,		//(28,0) Label: '&3-D Color' NOTE: Escher - the MRU color picker menu
	msotcidVisualBasicEnvironment = 1695,		//(36,28) Label: '&Visual Basic Editor' NOTE: used in the apps to bring up VBE
	msotcidFramePicture = 1696,		//(0,25) Label: '&Frame Picture' NOTE: Word
	msotcidPublisherOptions = 1697,		//(0,25) Label: 'Publisher &Options...' NOTE: Mac only
	msotcidSubscriberOptions = 1698,		//(0,25) Label: 'Subscriber &Options...' NOTE: Mac only
	msotcidDoubleBottomBorder = 1699,		//(36,29) Label: '&Bottom Double Border' NOTE: XL
	msotcidThickBottomBorder = 1700,		//(37,0) Label: '&Thick Bottom Border' NOTE: XL
	msotcidTopAndBottomBorder = 1701,		//(37,1) Label: '&Top and Bottom Border' NOTE: XL
	msotcidTopAndDoubleBottomBorder = 1702,		//(37,2) Label: '&Top and Double Bottom Border' NOTE: XL
	msotcidTopAndThickBottomBorder = 1703,		//(37,3) Label: '&Top and Thick Bottom Border' NOTE: XL
	msotcidGridBorder = 1704,		//(37,4) Label: '&All Borders' NOTE: Word, XL
	msotcidThickOutsideBorder = 1705,		//(37,5) Label: '&Thick Box Border' NOTE: XL
	msotcidWebSetBackground = 1706,		//(4,28) Label: 'Bac&kground...' NOTE: Web authoring
	msotcidSendToFax = 1707,		//(43,22) Label: '&Fax Recipient...' NOTE: Word
	msotcidSendToPublish = 1708,		//(0,25) Label: '&Reserved' NOTE: PGM: OBSOLETE
	msotcidAutoSummarize = 1709,		//(68,23) Label: 'A&utoSummarize...' NOTE: Word
	msotcidShareDocument = 1710,		//(0,25) Label: 'S&hare Document...' NOTE: Word - leave mnemonic as U! (see bug 39049)
	msotcidSortTable = 1711,		//(0,25) Label: 'Sor&t...' NOTE: Word - sort when selection is in a table
	msotcidSortText = 1712,		//(0,25) Label: 'OBSOLETE (Sor&t Text...)' NOTE: Word/obsolete  PGM
	msotcidSaveVersion = 1713,		//(44,26) Label: '&Save Version...' NOTE: Word
	msotcidToggleNavigationPane = 1714,		//(6,11) Label: '&Document Map' NOTE: Word - cf. Show/HideNavigationPane, ToggleLeftPane
	msotcidAcceptRevision = 1715,		//(44,19) Label: 'Acc&ept Change'
	msotcidRejectRevision = 1716,		//(44,20) Label: '&Reject Change'
	msotcidCheckIn = 1717,		//(0,25) Label: '&Check-in'
	msotcidCheckOut = 1718,		//(0,25) Label: '&Check-out'
	msotcidAOCEContractMailer = 1719,		//(0,25) Label: '&Contract Mailer' NOTE: Word - Mac only
	msotcidBookshelfLookup = 1720,		//(0,25) Label: 'Loo&k Up Reference...' NOTE: Word
	msotcidBookshelfDefine = 1721,		//(0,25) Label: '&Define' NOTE: Word
	msotcidMacCustomPageSetupGX = 1722,		//(0,25) Label: 'Custom Page S&etup' NOTE: Mac only, for GX support
	msotcidMacPrintOneGX = 1723,		//(0,25) Label: 'P&rint One Copy' NOTE: Mac only, for GX support
	msotcidLineStyleDropdown = 1724,		//(0,25) Label: '&Border Style' NOTE: Word's owner-draw border width dropdown
	msotcidAddToWorkMenu = 1725,		//(0,25) Label: '&Add to Work Menu' NOTE: Word, Mac only, adds cmd to "Work" menu
	msotcidExitAutoSummaryView = 1726,		//(0,25) Label: '&Close' NOTE: Word - exits the view
	msotcidMacPageSetup = 1727,		//(0,25) Label: 'Page Set&up...' NOTE: brings up the Mac standard dialog
	msotcidFontCombo = 1728,		//(0,25) Label: '&Font:' NOTE: the Font combo box
	msotcidDisplayMAPIDetails = 1729,		//(0,25) Label: '&Who Is...' NOTE: Word
	msotcidRecordNumberEdit = 1730,		//(0,25) Label: '&Record:' NOTE: Word - the current merge record
	msotcidFontSizeCombo = 1731,		//(0,25) Label: '&Font Size:' NOTE: the Font Size combobox
	msotcidStyleCombo = 1732,		//(0,25) Label: '&Style:' NOTE: the Style combobox
	msotcidZoomCombo = 1733,		//(0,25) Label: '&Zoom:' NOTE: the Zoom combobox
	msotcidObjectList = 1734,		//(0,25) Label: '&Object:' NOTE: VB - list of objects that have events
	msotcidProcedureList = 1735,		//(0,25) Label: '&Event:' NOTE: VB - list of events for an object
	msotcidFieldNameCombo = 1736,		//(0,25) Label: 'Go To &Field:' NOTE: Access - the current field
	msotcidScenarioCombo = 1737,		//(0,25) Label: '&Scenario:' NOTE: XL
	msotcidShadingDropdown = 1738,		//(0,25) Label: '&Shading:' NOTE: Word - owner draw shading dropdown
	msotcidRenameEdit = 1739,		//(0,25) Label: '&Name:' NOTE: use for renaming things
	msotcidURLCombo = 1740,		//(0,25) Label: '&Address:' NOTE: Web - where you type a URL
	msotcidCreateMap = 1741,		//(60,25) Label: 'M&ap...' NOTE: XL - map server
	msotcidMergeCellsAcross = 1742,		//(43,24) Label: '&Merge Across' NOTE: XL
	msotcidDocumentLayout = 1743,		//(0,25) Label: '&Document Layout...' NOTE: Mac only - used alongside the Mac's standard Page Setup dlg
	msotcidMessageQuickPreview = 1744,		//(7,15) Label: 'Auto&Preview' NOTE: Ren; 3-line view of messages
	msotcidActualSize = 1745,		//(37,8) Label: '&Actual Size' NOTE: shows the page at actual size; NOTE icon same as Word's Magnifier
	msotcidDeleteGroup = 1746,		//(0,25) Label: 'R&emove Group' NOTE: Ren - removes a grouping category
	msotcidDeleteFavoritesShortcut = 1747,		//(0,25) Label: 'Re&move from Outlook Bar' NOTE: Ren - removes item from favorites
	msotcidFieldGrabber = 1748,		//(43,17) Label: 'Field &Chooser' NOTE: Ren - shows/hides the "field grabber"
	msotcidGoToDate = 1749,		//(0,25) Label: 'Go to Dat&e...' NOTE: Ren - go to any date
	msotcidToggleGroupByZone = 1750,		//(22,9) Label: 'Group &By Box' NOTE: Ren - toggles the group by zone
	msotcidToggleMessageHeader = 1751,		//(56,22) Label: '&Message Header' NOTE: toggle header part of message
	msotcidFilterDialog = 1752,		//(0,25) Label: 'Fi&lter...' NOTE: PGM: i think there are some redundant Filter ID's
	msotcidMarkForCopy = 1753,		//(68,3) Label: 'Mark to Retrieve a &Copy' NOTE: Ren - remote mail
	msotcidMeetingRequest = 1754,		//(67,29) Label: 'Meeting Re&quest' NOTE: Ren
	msotcidNewFolder = 1755,		//(44,28) Label: 'Fold&er...' NOTE: Ren
	msotcidAddNewGroup = 1756,		//(0,25) Label: '&Add New Group' NOTE: Ren 
	msotcidNewMessage = 1757,		//(2,25) Label: '&Mail Message' NOTE: Ren
	msotcidNewNote = 1758,		//(72,13) Label: '&Note' NOTE: Ren
	msotcidEditRecurrence = 1759,		//(65,23) Label: 'Edit Re&currence...' NOTE: Ren - change recurrence properties
	msotcidSendStatusReport = 1760,		//(37,24) Label: 'S&end Status Report' NOTE: Ren
	msotcidNewTaskRequest = 1761,		//(45,21) Label: 'New Task Re&quest' NOTE: Ren
	msotcidParentFolder = 1762,		//(55,4) Label: '&Up One Level' NOTE: Ren
	msotcidImagerPicture = 1763,		//(37,27) Label: '&Photo Editor Picture' NOTE: inserts an Imager picture
	msotcidImagerScan = 1764,		//(37,28) Label: 'From &Scanner or Camera...' NOTE: inserts an Imager scan
	msotcidViewModeSplitDropdown = 1765,		//(0,25) Label: '&View Mode' NOTE: Access - menu of views (design/form/etc)
	msotcidQueryTypeSplitMenu = 1766,		//(0,25) Label: 'Q&uery Type' NOTE: Access - menu of query types
	msotcidBorderWidthSplitMenu = 1767,		//(0,25) Label: '&Line/Border Width' NOTE: Access
	msotcidGridlinesSplitMenu = 1768,		//(0,25) Label: '&Gridlines' NOTE: Access
	msotcidSpecialEffectSplitMenu = 1769,		//(0,25) Label: 'Sp&ecial Effect' NOTE: Access
	msotcidGridlineColorSplitMenu = 1770,		//(0,25) Label: '&Gridline Color' NOTE: Access
	msotcidCompileLoadedModules = 1771,		//(39,29) Label: 'Compile Loa&ded Modules' NOTE: Access
	msotcidQueryTopValuesCombo = 1772,		//(0,25) Label: '&Top Values' NOTE: Access - lets you make a top N query
	msotcidDatabaseShowTables = 1773,		//(19,23) Label: '&Tables' NOTE: Access - changes active tab on DBC
	msotcidDatabaseShowQueries = 1774,		//(19,24) Label: '&Queries' NOTE: Access
	msotcidDatabaseShowForms = 1775,		//(19,25) Label: '&Forms' NOTE: Access
	msotcidDatabaseShowReports = 1776,		//(19,26) Label: '&Reports' NOTE: Access
	msotcidDatabaseShowMacros = 1777,		//(19,27) Label: '&Macros' NOTE: Access
	msotcidDatabaseShowModules = 1778,		//(19,28) Label: 'Mod&ules' NOTE: Access
	msotcidClearTab = 1779,		//(0,25) Label: '&Clear Tab' NOTE: Access
	msotcidSelectForm = 1780,		//(0,25) Label: 'Select Fo&rm' NOTE: Access
	msotcidSelectReport = 1781,		//(0,25) Label: 'Select &Report' NOTE: Access
	msotcidSelectRecord = 1782,		//(0,25) Label: 'Se&lect Record' NOTE: Access
	msotcidClearQueryGrid = 1783,		//(0,25) Label: 'Cle&ar Grid' NOTE: Access - clears the QBE grid
	msotcidSelectAllRecords = 1784,		//(0,25) Label: 'Select &All Records' NOTE: Access
	msotcidTestValidationRules = 1785,		//(0,25) Label: 'T&est Validation Rules' NOTE: Access
	msotcidClearLayout = 1786,		//(39,27) Label: 'Cle&ar Layout' NOTE: Access - clear relationships layout
	msotcidRename = 1787,		//(0,25) Label: 'Rena&me' NOTE: Access
	msotcidCreateShortcut = 1788,		//(0,25) Label: 'Create &Shortcut...' NOTE: Access - creates a desktop shortcut for a DB object
	msotcidSaveLayout = 1789,		//(0,25) Label: '&Save Layout' NOTE: Access
	msotcidSaveAsQuery = 1790,		//(38,27) Label: 'Save &As Query' NOTE: Access
	msotcidLoadFromQuery = 1791,		//(38,26) Label: 'Load from &Query...' NOTE: Access
	msotcidSaveAsText = 1792,		//(0,25) Label: '&Save as Text' NOTE: Access
	msotcidRenameColumn = 1793,		//(0,25) Label: 'Re&name Column' NOTE: Access
	msotcidUnfreezeAllColumns = 1794,		//(0,25) Label: 'Unfreeze &All Columns' NOTE: Access
	msotcidLinkTables = 1795,		//(17,25) Label: '&Link Tables...' NOTE: Access
	msotcidLookupColumn = 1796,		//(0,25) Label: '&Lookup Column...' NOTE: Access - cf. similar command LookupField
	msotcidInsertTab = 1797,		//(0,25) Label: 'T&ab' NOTE: Access, PPT
	msotcidInsertCustomControl = 1798,		//(0,25) Label: '&OLE Controls' NOTE: Access
	msotcidTwelvePages = 1799,		//(0,25) Label: 'T&welve Pages' NOTE: Access
	msotcidEightPages = 1800,		//(0,25) Label: '&Eight Pages' NOTE: Access
	msotcidFourPages = 1801,		//(0,25) Label: '&Four Pages' NOTE: Access
	msotcidRemoveTable = 1802,		//(0,25) Label: 'R&emove Table' NOTE: Access
	msotcidDataEntry = 1803,		//(0,25) Label: '&Data Entry' NOTE: Access
	msotcidRefreshRecords = 1804,		//(0,25) Label: 'Refres&h' NOTE: Access
	msotcidEditRelationship = 1805,		//(0,25) Label: 'Edit &Relationship...' NOTE: Access
	msotcidHideTable = 1806,		//(0,25) Label: '&Hide Table' NOTE: Access
	msotcidReplicationRecoverDesignMaster = 1807,		//(0,25) Label: 'Recover &Design Master...' NOTE: Access replication
	msotcidReplicationResolveConflicts = 1808,		//(0,25) Label: '&Resolve Conflicts...' NOTE: Access
	msotcidReplicationCreateReplica = 1809,		//(44,21) Label: '&Create Replica...' NOTE: Access
	msotcidReplicationSynchronizeNow = 1810,		//(0,25) Label: '&Synchronize Now...' NOTE: Access
	msotcidStepToCursor = 1811,		//(43,10) Label: '&Run to Cursor' NOTE: Access
	msotcidSetNextStatement = 1812,		//(43,11) Label: 'Set &Next Statement' NOTE: Access - sets next statement in debugger
	msotcidShowNextStatement = 1813,		//(43,12) Label: 'Show Ne&xt Statement' NOTE: Access
	msotcidSetDatabasePassword = 1814,		//(0,25) Label: 'Set &Database Password...' NOTE: Acess
	msotcidUserLevelSecurityWizard = 1815,		//(0,25) Label: 'User-Level Security &Wizard...' NOTE: Access
	msotcidUserAndGroupAccounts = 1816,		//(0,25) Label: 'User and Group &Accounts...' NOTE: Access
	msotcidEtched = 1817,		//(37,29) Label: '&Special Effect: Etched' NOTE: Access
	msotcidShadowed = 1818,		//(38,0) Label: '&Special Effect: Shadowed' NOTE: Access
	msotcidChiseled = 1819,		//(38,1) Label: '&Special Effect: Chiseled' NOTE: Access
	msotcidAddWatch = 1820,		//(48,16) Label: '&Add Watch...' NOTE: VBE
	msotcidStartupSettings = 1821,		//(0,25) Label: 'Start&up...' NOTE: Access - sets database startup properties
	msotcidLastPosition = 1822,		//(0,25) Label: 'Last Positio&n' NOTE: Access
	msotcidSubformDatasheet = 1823,		//(5,18) Label: 'S&ubform Datasheet' NOTE: Access
	msotcidJoinProperties = 1824,		//(0,25) Label: '&Join Properties' NOTE: Access
	msotcidLineUpIcons = 1825,		//(0,25) Label: 'Line &Up Icons' NOTE: Access
	msotcidCascadeWindows = 1826,		//(8,8) Label: '&Cascade' NOTE: Access - PGM redundant with ArrangeWindows?
	msotcidTileWindows = 1827,		//(0,25) Label: '&Tile' NOTE: Access [PGM obsolete with TileWindowsHorizontal & Vertical]
	msotcidFitToWindow = 1828,		//(0,25) Label: 'Si&ze to Fit Form' NOTE: Access
	msotcidZoom200 = 1829,		//(0,25) Label: '&200%' NOTE: Access
	msotcidZoom150 = 1830,		//(0,25) Label: '&150%' NOTE: Access
	msotcidZoom75 = 1831,		//(0,25) Label: '&75%' NOTE: Access
	msotcidZoom50 = 1832,		//(0,25) Label: '&50%' NOTE: Access
	msotcidZoom25 = 1833,		//(0,25) Label: '&25%' NOTE: Access
	msotcidZoom10 = 1834,		//(0,25) Label: '&10%' NOTE: Access
	msotcidUserTable = 1835,		//(19,23) Label: '&Table' NOTE: Access - used when user drags an object to a bar (override the string)
	msotcidUserQuery = 1836,		//(19,24) Label: '&Query' NOTE: Access
	msotcidUserForm = 1837,		//(19,25) Label: '&Form' NOTE: Access
	msotcidUserReport = 1838,		//(19,26) Label: '&Report' NOTE: Access
	msotcidUserMacro = 1839,		//(19,27) Label: '&Macro' NOTE: Access
	msotcidInsideHorizontalBorder = 1840,		//(38,4) Label: 'Inside &Horizontal Border' NOTE: Word
	msotcidInsideVerticalBorder = 1841,		//(38,5) Label: 'Inside &Vertical Border' NOTE: Word
	msotcidDiagonalDownBorder = 1842,		//(38,6) Label: 'Diagonal &Down Border' NOTE: Word
	msotcidDiagonalUpBorder = 1843,		//(38,7) Label: 'Diagonal &Up Border' NOTE: Word
	msotcidOpenHighLowCloseChart = 1844,		//(38,8) Label: '&Open-High-Low-Close Chart' NOTE: FE Excel
	msotcidMagicEightBall = 1845,		//(38,9) Label: '&Magic Eight Ball' NOTE: Access - inside joke
	msotcidTextDirectionLeftToRight = 1846,		//(3,1) Label: '&Left-to-Right' NOTE: Middle East apps
	msotcidTextDirectionRightToLeft = 1847,		//(3,2) Label: '&Right-to-Left' NOTE: Middle East apps
	msotcidOCXCheckbox = 1848,		//(38,12) Label: 'C&heck Box' NOTE: Forms - adds the OCX to the document/form
	msotcidFind_Excel = 1849,		//(4,16) Label: '&Find...' NOTE: Excel - cf msotcidFind, XL has a diff. quicktip
	msotcidOCXTextbox = 1850,		//(38,14) Label: '&Text Box' NOTE: Forms
	msotcidOCXButton = 1851,		//(38,15) Label: 'Command &Button' NOTE: Forms
	msotcidOCXRadioButton = 1852,		//(38,16) Label: '&Option Button' NOTE: Forms
	msotcidOCXListBox = 1853,		//(38,17) Label: '&List Box' NOTE: Forms
	msotcidOCXDropdownCombo = 1854,		//(38,18) Label: 'Combo Bo&x' NOTE: Forms
	msotcidOCXToggleButton = 1855,		//(38,19) Label: 'To&ggle Button' NOTE: Forms
	msotcidOCXSpin = 1856,		//(38,20) Label: 'Spi&n Button' NOTE: Forms
	msotcidOCXScrollbar = 1857,		//(38,21) Label: '&Scroll Bar' NOTE: Forms
	msotcidOCXLabel = 1858,		//(38,22) Label: 'L&abel' NOTE: Forms
	msotcidShadowColorSemiTransparent = 1859,		//(0,25) Label: '&Semitransparent Shadow' NOTE: Escher - used for shadow color
	msotcidToggleBccField = 1860,		//(0,25) Label: '&Bcc Field' NOTE: toggle the bcc field
	msotcidCurrentViewSettings = 1861,		//(0,25) Label: '&View Summary...' NOTE: Ren
	msotcidDefineViews = 1862,		//(0,25) Label: '&Define Views...' NOTE: Ren
	msotcidOpenOtherUserFolder = 1863,		//(0,25) Label: '&Exchange Server Folder...' NOTE: Ren
	msotcidShowFields = 1864,		//(0,25) Label: '&Fields...' NOTE: Ren
	msotcidShowFirstItem = 1865,		//(0,25) Label: 'Fi&rst Item in Folder' NOTE: Ren
	msotcidToggleFormattingBar = 1866,		//(0,25) Label: '&Format Bar' NOTE: Ren
	msotcidToggleFromField = 1867,		//(0,25) Label: 'From F&ield' NOTE: Ren
	msotcidGoToFolder = 1868,		//(0,25) Label: '&Go to Folder...' NOTE: Ren
	msotcidHideColumn = 1869,		//(0,25) Label: '&Hide Column' NOTE: Ren
	msotcidHideItemsInGroup = 1870,		//(0,25) Label: '&Collapse This Group' NOTE: Ren
	msotcidNextHighImportanceItem = 1871,		//(0,25) Label: '&High Importance Item' NOTE: Ren
	msotcidPreviousHighImportanceItem = 1872,		//(0,25) Label: '&High Importance Item' NOTE: Ren
	msotcidIncludeTasksWithNoDueDate = 1873,		//(0,25) Label: 'Include Tasks With No &Due Date' NOTE: Ren
	msotcidNewItemSplitMenu = 1874,		//(0,25) Label: '&New Item' NOTE: Ren
	msotcidOtherOptions = 1875,		//(0,25) Label: 'Form&at View...' NOTE: Ren
	msotcidOpenOtherPersonalFolder = 1876,		//(0,25) Label: '&Personal Folder...' NOTE: Ren
	msotcidRefreshScreen = 1877,		//(0,25) Label: 'Refres&h' NOTE: Ren
	msotcidRenameGroup = 1878,		//(0,25) Label: '&Rename Group' NOTE: Ren
	msotcidRenamePage = 1879,		//(0,25) Label: '&Rename Page...' NOTE: Ren
	msotcidRenameShortcut = 1880,		//(0,25) Label: '&Rename Shortcut' NOTE: Ren
	msotcidRequestResponses = 1881,		//(0,25) Label: 'Reques&t Responses' NOTE: Ren
	msotcidServices = 1882,		//(0,25) Label: 'Ser&vices...' NOTE: Ren - show services dialog
	msotcidSharing = 1883,		//(0,25) Label: '&Sharing...' NOTE: Ren - set up sharing on folder
	msotcidShowItemsInGroup = 1884,		//(0,25) Label: '&Expand This Group' NOTE: Ren
	msotcidFlagMessage = 1885,		//(7,22) Label: 'Flag &Message' NOTE: Ren - cf. msotcidTagMessage
	msotcidArchive = 1886,		//(0,25) Label: 'A&rchive...' NOTE: Ren - backup old items & remove them
	msotcidBestFit = 1887,		//(0,25) Label: 'Best &Fit' NOTE: Ren
	msotcidSelectDisplayedCategories = 1888,		//(0,25) Label: 'Categor&ies...' NOTE: Ren
	msotcidChangeTimeZone = 1889,		//(0,25) Label: 'Change Time &Zone...' NOTE: Ren
	msotcidCheckForNewMailOn = 1890,		//(0,25) Label: 'Check for Ne&w Mail On...' NOTE: Ren
	msotcidCloseAndLogOff = 1891,		//(0,25) Label: 'Exit and &Log Off' NOTE: Ren
	msotcidColumnProperties = 1892,		//(0,25) Label: '&Column Properties...' NOTE: Ren
	msotcidCurrentViewCombo = 1893,		//(0,25) Label: 'Current &View' NOTE: Ren
	msotcidDefinePrintStyles = 1894,		//(0,25) Label: 'Define Print &Styles...' NOTE: Ren
	msotcidFindContact = 1895,		//(0,25) Label: 'Find &Contact' NOTE: Ren
	msotcidFindItem = 1896,		//(0,25) Label: 'Find &Item' NOTE: Ren
	msotcidFindOriginalMessage = 1897,		//(0,25) Label: '&Related Messages...' NOTE: Ren
	msotcidFormatColumns = 1898,		//(0,25) Label: 'For&mat Columns...' NOTE: Ren
	msotcidNextIncompleteTask = 1899,		//(0,25) Label: 'In&complete Task' NOTE: Ren
	msotcidPreviousIncompleteTask = 1900,		//(0,25) Label: 'In&complete Task' NOTE: Ren
	msotcidNextItemFromSender = 1901,		//(0,25) Label: 'Item from &Sender' NOTE: Ren
	msotcidPreviousItemFromSender = 1902,		//(0,25) Label: 'Item from &Sender' NOTE: Ren
	msotcidNextItemInConversation = 1903,		//(0,25) Label: 'Item in &Conversation Topic' NOTE: Ren
	msotcidPreviousItemInConversation = 1904,		//(0,25) Label: 'Item in &Conversation Topic' NOTE: Ren
	msotcidMarkForDownloadCopy = 1905,		//(0,25) Label: 'Mark for Retrieval of &Copy' NOTE: Ren
	msotcidMarkAllAsRead = 1906,		//(0,25) Label: 'Mark All as R&ead' NOTE: Ren
	msotcidMarkTagComplete = 1907,		//(27,26) Label: 'Flag Com&plete' NOTE: Ren
	msotcidNewContactFromSameCompany = 1908,		//(0,25) Label: 'New &Contact from Same Company' NOTE: Ren
	msotcidNewEvent = 1909,		//(0,25) Label: 'New &Event' NOTE: Ren
	msotcidNewMessageFromForm = 1910,		//(0,25) Label: 'Ch&oose Form...' NOTE: Ren
	msotcidReInviteToMeeting = 1911,		//(0,25) Label: 'Re&cover Meeting' NOTE: Ren
	msotcidResetTaskSequence = 1912,		//(0,25) Label: '&Save Task Order' NOTE: Ren
	msotcidSaveFormDesign = 1913,		//(46,0) Label: 'Publish &Form As...' NOTE: Ren
	msotcidSaveSearch = 1914,		//(0,25) Label: 'Save &Search...' NOTE: Ren
	msotcidSaveAndNewInCompany = 1915,		//(0,25) Label: 'Save and New in C&ompany' NOTE: Ren
	msotcidShowAllItemsAndHeaders = 1916,		//(0,25) Label: 'E&xpand All' NOTE: Ren
	msotcidShowOnlyGroupHeaders = 1917,		//(0,25) Label: 'Colla&pse All' NOTE: Ren
	msotcidShowToolbox = 1918,		//(0,25) Label: '&Toolbox' NOTE: Ren - different string from msotcidToolbox "Control Toolbox"
	msotcidSkipOccurrence = 1919,		//(0,25) Label: 'S&kip Occurrence' NOTE: Ren
	msotcidToggleSplitPage = 1920,		//(0,25) Label: 'Separate Read La&yout' NOTE: Ren - splits page into read & send
	msotcidUnmark = 1921,		//(68,4) Label: 'U&nmark' NOTE: Ren
	msotcidWebOpenSearchPage = 1922,		//(6,14) Label: 'Search the &Web' NOTE: Web
	msotcidFavoritesSubmenu = 1923,		//(7,17) Label: '&<favorites subfolder>' NOTE: (override the string) used in favorites menu to be like Internet Explorer
	msotcidLeftToRightDocument = 1924,		//(17,6) Label: '&Left-to-Right Document' NOTE: used by Middle East apps
	msotcidRightToLeftDoucment = 1925,		//(17,7) Label: '&Right-to-Left Document' NOTE: used by Middle East apps
	msotcidFontColorAutomaticSwatch = 1926,		//(0,25) Label: '&Automatic Color' NOTE: Excel
	msotcidFontColorSchemeSwatch = 1927,		//(0,25) Label: '&Color Scheme' NOTE: XL
	msotcidFontColorPickerSwatch = 1928,		//(0,25) Label: '&Color' NOTE: XL
	msotcidPatternColorSchemeSwatch = 1929,		//(0,25) Label: '&Color Scheme' NOTE: XL
	msotcidPatternColorPickerSwatch = 1930,		//(0,25) Label: '&Color' NOTE: XL
	msotcidXLEscherSchemeSwatch = 1931,		//(0,25) Label: '&Color Scheme' NOTE: XL - generic interface with Escher
	msotcidXLEscherPickerSwatch = 1932,		//(0,25) Label: '&Color' NOTE: XL - generic interface with Escher
	msotcidXLSmEscherSchemeSwatch = 1933,		//(0,25) Label: '&Color' NOTE: XL - generic interface with Escher
	msotcidXLSmEscherPickerSwatch = 1934,		//(0,25) Label: '&Color' NOTE: XL - generic interface with Escher
	msotcidDlgGridlineColor = 1935,		//(0,25) Label: '&Gridline Color' NOTE: XL - these are owner-drawn menu controls in dlgs that look like dropdowns
	msotcidDlgFontColor = 1936,		//(0,25) Label: '&Font Color' NOTE: XL
	msotcidDlgPattern = 1937,		//(0,25) Label: '&Pattern' NOTE: XL
	msotcidDlgCrtPattern = 1938,		//(0,25) Label: '&Pattern' NOTE: XL
	msotcidBorderColor = 1939,		//(0,25) Label: '&Border Color' NOTE: XL
	msotcidBorderCrtColor = 1940,		//(0,25) Label: '&Border Color' NOTE: XL
	msotcidDlgArLn = 1941,		//(0,25) Label: '&Line' NOTE: XL
	msotcidDlgLnSsLn = 1942,		//(0,25) Label: '' NOTE: XL
	msotcidDlgLnSsMkF = 1943,		//(0,25) Label: '' NOTE: XL
	msotcidDlgLnSsMkB = 1944,		//(0,25) Label: '' NOTE: XL
	msotcidDlgLnLn = 1945,		//(0,25) Label: '' NOTE: XL
	msotcidDlgAxLn = 1946,		//(0,25) Label: '' NOTE: XL
	msotcidAlternateTextbox = 1947,		//(5,29) Label: '&Text Box' NOTE: Because Word and PPT need different commands
	msotcidWebQuery = 1948,		//(39,1) Label: 'Run &Web Query...' NOTE: Excel
	msotcidRunDatabaseQuery = 1949,		//(39,2) Label: 'Run &Database Query...' NOTE: Excel
	msotcidEditQuery = 1950,		//(39,3) Label: '&Edit Query...' NOTE: Excel
	msotcidDataRangeProperties = 1951,		//(5,13) Label: 'D&ata Range Properties...' NOTE: Excel [PGM redundant icon]
	msotcidUpdateAll = 1952,		//(39,5) Label: 'Refresh &All' NOTE: Excel - refresh all data in query
	msotcidCancelRefresh = 1953,		//(39,6) Label: '&Cancel Refresh' NOTE: Excel
	msotcidRefreshStatus = 1954,		//(39,7) Label: '&Refresh Status' NOTE: Excel - give status of data refresh
	msotcidHideColumns = 1955,		//(0,25) Label: '&Hide Columns' NOTE: Access [PGM sort of redundant with HideColumn]
	msotcidPasteLink = 1956,		//(0,25) Label: 'Paste Li&nk...'
	msotcidInsertChart = 1957,		//(1,23) Label: 'C&hart...' NOTE: Excel - replaces old InsertChart{OnThis,AsNew}Sheet IDs
	msotcidChartDatasheet = 1958,		//(39,13) Label: '&Datasheet' NOTE: Excel 
	msotcidFormatNumber = 1959,		//(0,25) Label: '&Number...' NOTE: Excel
	msotcidIncludeRowOrColumn = 1960,		//(0,25) Label: '&Include Row/Col...' NOTE: Chart
	msotcidExcludeRowOrColumn = 1961,		//(0,25) Label: '&Exclude Row/Col...' NOTE: Chart
	msotcidPlotOnXAxis = 1962,		//(0,25) Label: '&Plot on X Axis' NOTE: Chart
	msotcidAddDataToChart = 1963,		//(0,25) Label: '&Add Data...' NOTE: Chart
	msotcidClearAll = 1964,		//(17,9) Label: '&All' NOTE: Excel - their version of msotcidClear
	msotcidOLEObjectVerbList = 1965,		//(0,25) Label: '&<verb>' NOTE: use one of these for each OLE verb, and override the string
	msotcidPickFromList = 1966,		//(0,25) Label: 'Pic&k From List...' NOTE: Excel
	msotcidOLEObjectConvert = 1967,		//(0,25) Label: 'Con&vert...' NOTE: convert an OLE 2 object from one type to another
	msotcidUngroupSheets = 1968,		//(0,25) Label: '&Ungroup Sheets' NOTE: Excel - ungroups multiply selected plies
	msotcidCreateNewShortcut = 1969,		//(0,25) Label: 'Add to Outloo&k Bar...' NOTE: Ren - creates new shortcut in the shortcut bar
	msotcidForwardMultipleItems = 1970,		//(6,6) Label: '&Forward Items' NOTE: Ren - forward multiple selected items
	msotcidHidePage = 1971,		//(0,25) Label: 'Display T&his Page' NOTE: Ren - hide/toggle page in design mode
	msotcidNewPostInThisFolder = 1972,		//(37,22) Label: '&New Post in This Folder' NOTE: Ren
	msotcidViewAnyNumberOfDays = 1973,		//(0,25) Label: '&Number of Days' NOTE: Ren - view any # of days in calendar
	msotcidReplyWithMessage = 1974,		//(6,4) Label: '&Reply with Message' NOTE: Ren - reply to sender with a mail message
	msotcidSaveAndClose = 1975,		//(1,0) Label: '&Save and Close' NOTE: Ren
	msotcidAssignTask = 1976,		//(45,21) Label: 'Assi&gn Task' NOTE: Ren - send task request for selected tasks
	msotcidEditRecurrencePattern = 1977,		//(65,23) Label: 'Rec&urrence...' NOTE: Ren - change appointment recurrence
	msotcidNewMessageToContact = 1978,		//(47,11) Label: 'New &Message to Contact' NOTE: Ren
	msotcidNewTaskForContact = 1979,		//(43,27) Label: 'New &Task for Contact' NOTE: Ren
	msotcidNewMeetingWithContact = 1980,		//(43,26) Label: 'New Meetin&g with Contact' NOTE: Ren
	msotcidNewMessageToAttendees = 1981,		//(2,25) Label: 'New Message to Attendee&s' NOTE: Ren
	msotcidNewPhoneCallToContact = 1982,		//(62,23) Label: 'New P&hone Call to Contact' NOTE: Ren
	msotcidResendInvitation = 1983,		//(61,12) Label: 'Sen&d Update' NOTE: Ren - updates an already sent invitation
	msotcidReplyAllWithMailMessage = 1984,		//(6,5) Label: 'Reply to All with &Message' NOTE: Ren
	msotcidPostReplyToFolder = 1985,		//(45,28) Label: 'Post Reply to This &Folder' NOTE: Ren
	msotcidSendTaskRequestAgain = 1986,		//(61,12) Label: '&Send Again...' NOTE: Ren
	msotcidViewAppointmentInCalendar = 1987,		//(37,19) Label: 'Ca&lendar...' NOTE: Ren
	msotcidFillColorAndPatternSplitDropdown = 1988,		//(38,2) Label: '&Pattern' NOTE: Excel - does both back color and pattern
	msotcidCreateJournalEntry = 1989,		//(45,27) Label: '&Journal Entry' NOTE: Ren
	msotcidCreateJournalEntry2 = 1990,		//(45,27) Label: '&Journal Entry' NOTE: Ren
	msotcidViewLastItemInFolder = 1991,		//(0,25) Label: '&Last Item in Folder' NOTE: Ren
	msotcidNewAppointment2 = 1992,		//(55,9) Label: '&New Appointment' NOTE: Ren
	msotcidNewContact2 = 1993,		//(26,2) Label: '&New Contact' NOTE: Ren
	msotcidNewJournalEntry = 1994,		//(45,27) Label: '&New Journal Entry' NOTE: Ren
	msotcidNewMailMessage = 1995,		//(2,25) Label: 'New &Mail Message' NOTE: Ren - same icon as NewMessage, different string
	msotcidNewNote2 = 1996,		//(72,13) Label: '&New Note' NOTE: Ren
	msotcidNewTask2 = 1997,		//(57,28) Label: '&New Task' NOTE: Ren
	msotcidPreviousTaggedMessage = 1998,		//(0,25) Label: '&Flagged Message' NOTE: Ren
	msotcidNextTaggedMessage = 1999,		//(0,25) Label: '&Flagged Message' NOTE: Ren
	};

enum
	{
	msotcidNextUnreadItem = 2000,		//(0,25) Label: '&Unread Item' NOTE: Ren
	msotcidNextUnreadItem2 = 2001,		//(0,25) Label: '&Unread Item' NOTE: Ren
	msotcidCancelTask = 2002,		//(39,12) Label: '&Cancel' NOTE: Ren - cancel send form for task
	msotcidCancelAcceptTask = 2003,		//(39,12) Label: '&Cancel Accept' NOTE: Ren - cancel accepting task
	msotcidCancelAssignTask = 2004,		//(39,12) Label: '&Cancel Assignment' NOTE: Ren - Cancel assigning task
	msotcidCancelDeclineTask = 2005,		//(39,12) Label: '&Cancel Decline' NOTE: Ren - cancel declining this task
	msotcidNewTaskRequest2 = 2006,		//(45,21) Label: 'Task &Request' NOTE: Ren
	msotcidNewPostInThisFolder2 = 2007,		//(37,22) Label: 'New Po&st in This Folder' NOTE: Ren
	msotcidResendInvitation2 = 2008,		//(61,12) Label: 'R&e-send' NOTE: Ren
	msotcidShowRenFields = 2009,		//(0,25) Label: 'Show &Fields...' NOTE: Ren
	msotcidEditRecurrenceSeries = 2010,		//(17,19) Label: 'Edit Ser&ies' NOTE: Ren - edit appointment recurrence series
	msotcidCloseSDI = 2011,		//(0,25) Label: '&Close' NOTE: use this instead of "Exit" in SDI apps
	msotcidAlwaysCalcNone = 2012,		//(0,25) Label: '&None' NOTE: Excel - AlwaysCalc popup menu
	msotcidAlwaysCalcAverage = 2013,		//(0,25) Label: '&Average' NOTE: Excel
	msotcidAlwaysCalcCounta = 2014,		//(0,25) Label: '&Count' NOTE: Excel
	msotcidAlwaysCalcCount = 2015,		//(0,25) Label: 'C&ount Nums' NOTE: Excel
	msotcidAlwaysCalcMax = 2016,		//(0,25) Label: '&Max' NOTE: Excel
	msotcidAlwaysCalcMin = 2017,		//(0,25) Label: 'M&in' NOTE: Excel
	msotcidAlwaysCalcSum = 2018,		//(1,20) Label: '&Sum' NOTE: Excel - end of AlwaysCalc list
	msotcidAutoFillCopy = 2019,		//(1,7) Label: '&Copy Cells' NOTE: Excel - non-default AutoFill
	msotcidAutoFillSeriesDefault = 2020,		//(0,25) Label: 'Fill &Series' NOTE: Excel
	msotcidAutoFillCopyFormats = 2021,		//(0,25) Label: 'Fill &Formatting Only' NOTE: Excel
	msotcidAutoFillCopyValues = 2022,		//(0,25) Label: 'Fill With&out Formatting' NOTE: Excel
	msotcidAutoFillDays = 2023,		//(0,25) Label: 'Fill &Days' NOTE: Excel
	msotcidAutoFillWeekdays = 2024,		//(0,25) Label: 'Fill &Weekdays' NOTE: Excel
	msotcidAutoFillMonths = 2025,		//(0,25) Label: 'Fill &Months' NOTE: Excel
	msotcidAutoFillYears = 2026,		//(0,25) Label: 'Fill &Years' NOTE: Excel
	msotcidAutoFillLinearTrend = 2027,		//(0,25) Label: '&Linear Trend' NOTE: Excel
	msotcidAutoFillGrowthTrend = 2028,		//(0,25) Label: '&Growth Trend' NOTE: Excel
	msotcidAutoFillSeriesDialog = 2029,		//(0,25) Label: 'S&eries...' NOTE: Excel - end of AutoFill list
	msotcidVisualPrintPreview = 2030,		//(0,25) Label: 'Visu&al Print Preview' NOTE: Excel
	msotcidNewComment2 = 2031,		//(5,28) Label: 'Insert Co&mment' NOTE: Excel - alt. text for context menu
	msotcidConditionsSelectSame = 2032,		//(0,25) Label: 'Select &Same' NOTE: Excel
	msotcidConditionsSelectAll = 2033,		//(0,25) Label: 'Select &All' NOTE: Excel
	msotcidValidationDefine = 2034,		//(0,25) Label: 'Va&lidation...' NOTE: Excel
	msotcidValidationMarkInvalidData = 2035,		//(46,1) Label: '&Circle Invalid Data' NOTE: Excel
	msotcidValidationSelectSame = 2036,		//(0,25) Label: '&Select Same' NOTE: Excel [PGM - check tooltip]
	msotcidQueryProperties = 2037,		//(5,13) Label: '&Properties...' NOTE: Excel
	msotcidResetPrintArea = 2038,		//(0,25) Label: '&Reset Print Area' NOTE: Excel
	msotcidMacAddRoutingSlip = 2039,		//(10,1) Label: 'Add &Routing Slip...' NOTE: Excel
	msotcidSharedWorkbooks = 2040,		//(0,25) Label: 'Sha&re Workbook...' NOTE: Excel
	msotcidRevisionsTrackChanges = 2041,		//(65,5) Label: '&Track Changes' NOTE: Word
	msotcidRevisionsHighlightChanges = 2042,		//(46,16) Label: '&Highlight Changes...' NOTE: Word
	msotcidQueryDesign = 2043,		//(9,11) Label: 'Query &Design' NOTE: Access - (use msotcidDesign2 for Table Design)
	msotcidMergeWorkbook = 2044,		//(0,25) Label: 'Compare and Merge &Workbooks...' NOTE: Excel
	msotcidRightDragCopy = 2045,		//(1,7) Label: '&Copy Here' NOTE: right-drag and drop - also see msotcidCopyHere
	msotcidRightDragMove = 2046,		//(27,17) Label: '&Move Here' NOTE: also see msotcidMoveHere
	msotcidRightDragCopyFormats = 2047,		//(0,25) Label: 'Copy Here as &Formats Only' NOTE: Excel right-drag
	msotcidRightDragCopyValues = 2048,		//(0,25) Label: 'Copy Here as &Values Only' NOTE: Excel right-drag
	msotcidRightDragCopyShiftDown = 2049,		//(0,25) Label: '&Shift Down and Copy' NOTE: Excel
	msotcidRightDragCopyShiftRight = 2050,		//(0,25) Label: 'Shif&t Right and Copy' NOTE: Excel
	msotcidRightDragMoveShiftDown = 2051,		//(0,25) Label: 'Shift &Down and Move' NOTE: Excel
	msotcidRightDragMoveShiftRight = 2052,		//(0,25) Label: 'Shift &Right and Move' NOTE: Excel
	msotcidXLRunSavedQuery = 2053,		//(0,25) Label: 'Run &Saved Query...' NOTE: Excel - Get External Data submenu
	msotcidXLCreateNewQuery = 2054,		//(9,2) Label: '&New Database Query...' NOTE: Excel - Get External Data submenu
	msotcidValidationUnmarkInvalidData = 2055,		//(46,2) Label: '&Clear Validation Circles' NOTE: Excel
	msotcidEditComments = 2056,		//(39,14) Label: '&Edit Comment' NOTE: Word - also see ShowAllComments
	msotcidSetStartPage = 2057,		//(0,25) Label: 'Set Start &Page...' NOTE: Web
	msotcidSetSearchPage = 2058,		//(0,25) Label: 'Set Sear&ch Page...' NOTE: Web
	msotcidTableDrawTool = 2059,		//(6,22) Label: 'Dra&w Table' NOTE: Word
	msotcidTableEraseTool = 2060,		//(6,23) Label: '&Eraser' NOTE: Word
	msotcidAlignTableCellTop = 2061,		//(39,19) Label: 'Align &Top' NOTE: Word
	msotcidAlignTableCellVerticalCenter = 2062,		//(39,20) Label: 'Center &Vertically' NOTE: Word
	msotcidAlignTableCellBottom = 2063,		//(39,21) Label: 'Align &Bottom' NOTE: Word
	msotcidAlignTableCellLeft = 2064,		//(39,22) Label: 'Align &Left' NOTE: Word
	msotcidAlignTableCellHorizontalCenter = 2065,		//(39,23) Label: 'Center &Horizontally' NOTE: Word
	msotcidAlignTableCellRight = 2066,		//(39,24) Label: 'Align &Right' NOTE: Word
	msotcidDistributeColumn = 2067,		//(8,24) Label: 'Distribute Columns Evenl&y' NOTE: Word
	msotcidDistributeRow = 2068,		//(8,23) Label: 'Distribute Rows Eve&nly' NOTE: Word
	msotcidAutoArrangeIcons = 2069,		//(0,25) Label: '&Auto Arrange' NOTE: Access
	msotcidConvertDatabase = 2070,		//(0,25) Label: 'To &Current Access Database Version...' NOTE: Access
	msotcidCompactDatabase = 2071,		//(0,25) Label: '&Compact and Repair Database...' NOTE: Access
	msotcidRepairDatabase = 2072,		//(0,25) Label: '&Repair Database' NOTE: Access
	msotcidMakeMDXFile = 2073,		//(40,0) Label: '&Make MDE File...' NOTE: Access
	msotcidEncryptDecryptDatabase = 2074,		//(0,25) Label: '&Encrypt/Decrypt Database...' NOTE: Access
	msotcidPasteAppend = 2075,		//(0,25) Label: 'Paste Appe&nd' NOTE: Access
	msotcidDeleteTab = 2076,		//(0,25) Label: 'De&lete Tab' NOTE: Access
	msotcidSizeToTallest = 2077,		//(0,25) Label: 'To &Tallest' NOTE: Access
	msotcidSizeToShortest = 2078,		//(0,25) Label: 'To &Shortest' NOTE: Access
	msotcidSizeToWidest = 2079,		//(0,25) Label: 'To &Widest' NOTE: Access
	msotcidSizeToNarrowest = 2080,		//(0,25) Label: 'To &Narrowest' NOTE: Access
	msotcidUnionQuery = 2081,		//(40,1) Label: '&Union' NOTE: Access
	msotcidDataDefinitionLanguageQuery = 2082,		//(40,2) Label: 'Da&ta Definition' NOTE: Access
	msotcidSQLPassThroughQuery = 2083,		//(40,3) Label: '&Pass-Through' NOTE: Access
	msotcidTransparentBackColor = 2084,		//(0,25) Label: '&Transparent' NOTE: Access
	msotcidTransparentLineColor = 2085,		//(0,25) Label: '&Transparent' NOTE: Access
	msotcidBuildEvent = 2086,		//(0,25) Label: 'Build &Event...' NOTE: Access
	msotcidClearGrid = 2087,		//(39,27) Label: 'Cle&ar Grid' NOTE: Access
	msotcidOCXFrame = 2088,		//(13,5) Label: '&Frame' NOTE: Forms
	msotcidOCXImage = 2089,		//(40,6) Label: '&Image' NOTE: Foms
	msotcidWebOptions = 2090,		//(40,7) Label: '&Options' NOTE: not the Office 9 feature - Web - button menu for options to set start & search pages
	msotcidStraightConnectorStyle = 2091,		//(26,22) Label: '&Straight Connector' NOTE: Escher - change connector to this style
	msotcidAngledConnectorStyle = 2092,		//(26,23) Label: '&Elbow Connector' NOTE: Escher - change connector to this style
	msotcidCurvedConnectorStyle = 2093,		//(26,24) Label: 'C&urved Connector' NOTE: Escher - change connector to this style
	msotcidEditTextOfTextEffect = 2094,		//(0,25) Label: 'Edit Te&xt...' NOTE: Escher
	msotcidAttachToTask = 2095,		//(28,2) Label: '&Attach to Task' NOTE: Project
	msotcidCostTrackingForm = 2096,		//(34,6) Label: '&Cost Tracking' NOTE: Project
	msotcidTaskEarnedValueForm = 2097,		//(34,7) Label: '&Task Earned Value' NOTE: Project
	msotcidMSProjectDataEntryForm = 2098,		//(34,8) Label: '&Entry' NOTE: Project
	msotcidScheduleTrackingForm = 2099,		//(40,9) Label: '&Schedule Tracking' NOTE: Project
	msotcidTaskRelationshipsForm = 2100,		//(40,10) Label: '&Task Relationships' NOTE: Project
	msotcidTrackingForm = 2101,		//(40,11) Label: '&Tracking' NOTE: Project
	msotcidWorkTrackingForm = 2102,		//(40,12) Label: '&Work Tracking' NOTE: Project
	msotcidResourceAssignment = 2103,		//(40,13) Label: '&Resource Assignment' NOTE: Project
	msotcidLevelingHelpTopics = 2104,		//(40,14) Label: '&Leveling Help Topics' NOTE: Project
	msotcidTaskAssignmentTable = 2105,		//(40,15) Label: '&Task Assignment Table' NOTE: Project
	msotcidMSProjectInformationDialog = 2106,		//(40,16) Label: '&Information' NOTE: Project
	msotcidUpdateAsScheduled = 2107,		//(40,17) Label: '&Update as Scheduled' NOTE: Project
	msotcidRescheduleWork = 2108,		//(40,18) Label: '&Reschedule Work' NOTE: Project
	msotcidOpenFromDatabase = 2109,		//(40,19) Label: '&Open From Database...' NOTE: Project
	msotcidTimeScaleZoomIn = 2110,		//(40,20) Label: '&Zoom In' NOTE: Project
	msotcidTimeScaleZoomOut = 2111,		//(40,21) Label: '&Zoom Out' NOTE: Project
	msotcidMSProjectSampleMacro = 2112,		//(40,22) Label: '&Sample Macro' NOTE: Project
	msotcidTeamStatus = 2113,		//(40,23) Label: 'Team&Status...' NOTE: Project
	msotcidResourceAllocationView = 2114,		//(40,24) Label: '&Resource Allocation View' NOTE: Project
	msotcidMSProjectUpdateResources = 2115,		//(40,25) Label: '&Update Resources' NOTE: Project
	msotcidSaveToDatabase = 2116,		//(40,26) Label: '&Save to Database...' NOTE: Project
	msotcidTeamUpdate = 2117,		//(40,27) Label: 'Team&Update...' NOTE: Project
	msotcid0PercentComplete = 2118,		//(40,28) Label: '&0% Complete' NOTE: Project
	msotcid25PercentComplete = 2119,		//(40,29) Label: '&25% Complete' NOTE: Project
	msotcid50PercentComplete = 2120,		//(41,0) Label: '&50% Complete' NOTE: Project
	msotcid75PercentComplete = 2121,		//(41,1) Label: '&75% Complete' NOTE: Project
	msotcid100PercentComplete = 2122,		//(41,2) Label: '&100% Complete' NOTE: Project
	msotcidSortByDate = 2123,		//(41,3) Label: '&Sort by Date' NOTE: Project (cf. msotcidSortByCreated)
	msotcidTaskEntryView = 2124,		//(41,4) Label: '&Task Entry View' NOTE: Project
	msotcidUpdateTaskRange = 2125,		//(41,5) Label: '&Update Task Range' NOTE: Project
	msotcidWorkgroupBar = 2126,		//(41,6) Label: '&Workgroup Toolbar' NOTE: Project
	msotcidFilterByResource = 2127,		//(41,7) Label: '&Using Resource' NOTE: Project
	msotcidGotoOverallocation = 2128,		//(41,8) Label: '&Go to Overallocation' NOTE: Project
	msotcidMSProjectUpdateTasks = 2129,		//(41,9) Label: '&Update Tasks' NOTE: Project
	msotcidProjectStatistics = 2130,		//(41,10) Label: '&Project Statistics' NOTE: Project
	msotcidResourceAssignment2 = 2131,		//(41,11) Label: '&Resource Assignment' NOTE: Project
	msotcidResourceDetails = 2132,		//(5,13) Label: '&Resource Details' NOTE: Project
	msotcidTeamAssign = 2133,		//(41,12) Label: '&TeamAssign' NOTE: Project
	msotcidExpandAll2 = 2134,		//(41,13) Label: 'Show &All Tasks' NOTE: Project (cf. msotcidExpandAll)
	msotcidOutlineSymbols2 = 2135,		//(41,14) Label: '&Outline Symbols' NOTE: Project (cf. msotcidOutlineSymbols)
	msotcidMSProjectCustomForms = 2136,		//(41,15) Label: '&Custom Forms' NOTE: Project
	msotcidUnlinkTasks = 2137,		//(41,16) Label: '&Unlink Tasks' NOTE: Project
	msotcidGanttChartWizard = 2138,		//(41,17) Label: 'GanttChart&Wizard...' NOTE: Project
	msotcidArrowOnForm = 2139,		//(41,18) Label: '&Custom' NOTE: Project custom face
	msotcidBarsAndPercent = 2140,		//(41,19) Label: '&Custom' NOTE: Project custom face
	msotcidBody = 2141,		//(41,20) Label: '&Custom' NOTE: Project custom face
	msotcidCalendarMonth = 2142,		//(41,21) Label: '&Custom' NOTE: Project custom face
	msotcidCalendarWeek = 2143,		//(41,22) Label: '&Custom' NOTE: Project custom face
	msotcidGears = 2144,		//(41,23) Label: '&Custom' NOTE: Project custom face
	msotcidClockAndFace = 2145,		//(41,24) Label: '&Custom' NOTE: Project custom face
	msotcidHourglass = 2146,		//(41,25) Label: '&Custom' NOTE: Project custom face
	msotcidFourGanttBars = 2147,		//(41,26) Label: '&Custom' NOTE: Project custom face
	msotcidFemaleFace = 2148,		//(41,27) Label: '&Custom' NOTE: Project custom face
	msotcidHandStartOfGanttChart = 2149,		//(41,28) Label: '&Custom' NOTE: Project custom face
	msotcidHandEndOfGanttChart = 2150,		//(41,29) Label: '&Custom' NOTE: Project custom face
	msotcidRunningPerson = 2151,		//(42,0) Label: '&Custom' NOTE: Project custom face
	msotcidBalanceScales = 2152,		//(42,1) Label: '&Custom' NOTE: Project custom face
	msotcidKitchenTable = 2153,		//(42,2) Label: '&Custom' NOTE: Project custom face
	msotcidWindowWithCurtains = 2154,		//(42,3) Label: '&Custom' NOTE: Project custom face
	msotcidAddTextToTextEffect = 2155,		//(0,25) Label: 'Add Te&xt' NOTE: Escher
	msotcidMoveObjectHere = 2156,		//(0,25) Label: '&Move Object Here' NOTE: right-drag, paste object instead of native data
	msotcidCopyObjectHere = 2157,		//(0,25) Label: 'C&opy Object Here' NOTE: right-drag, paste object instead of native data
	msotcidCreateLinkHere = 2158,		//(0,25) Label: '&Link Here' NOTE: right-drag, creates OLE link to source data
	msotcidCreateHyperlinkHere = 2159,		//(1,12) Label: 'Create &Hyperlink Here' NOTE: right-drag, creates a hyperlink icon to source web page
	msotcidCreateShortcutHere = 2160,		//(0,25) Label: 'Create &Shortcut Here' NOTE: right-drag, creates OLE object and displays it as an icon
	msotcidInsertRows2 = 2161,		//(10,5) Label: '&Insert Rows' NOTE: Word - different string from msotcidInsertRows
	msotcidInsertColumns2 = 2162,		//(10,6) Label: '&Insert Columns' NOTE: Word - more alternate strings
	msotcidInsertCells2 = 2163,		//(10,4) Label: 'Ins&ert Cells...' NOTE: Word
	msotcidDeleteCells2 = 2164,		//(8,22) Label: '&Delete Cells...' NOTE: Word
	msotcidDeleteRows2 = 2165,		//(10,2) Label: '&Delete Rows' NOTE: Word
	msotcidDeleteColumns2 = 2166,		//(10,3) Label: '&Delete Columns' NOTE: Word
	msotcidCycleFillColor = 2167,		//(25,8) Label: '&Cycle Fill Color' NOTE: Project
	msotcidMSProjectGoToSelectedTask = 2168,		//(42,4) Label: '&Go to Selected Task' NOTE: Project
	msotcidLinkTasks = 2169,		//(42,5) Label: '&Link Tasks' NOTE: Project
	msotcidConsolidateProjects = 2170,		//(42,6) Label: '&Consolidate Projects' NOTE: Project
	msotcidOrganizer = 2171,		//(42,7) Label: '&Organizer' NOTE: Project
	msotcidWindowWithSWArrow = 2172,		//(42,8) Label: '&Custom' NOTE: Project custom face
	msotcidHandWithMagicWand = 2173,		//(42,9) Label: '&Custom' NOTE: Project custom face
	msotcidEye = 2174,		//(42,10) Label: '&Custom' NOTE: Project custom face
	msotcidToggleShadow = 2175,		//(42,11) Label: '&Shadow On/Off' NOTE: Escher - (cf. msotcidShadow, which is used for the shadow menu)
	msotcidAddTextToTextBox = 2176,		//(0,25) Label: 'Add Te&xt' NOTE: Escher
	msotcidEditTextOfTextBox = 2177,		//(0,25) Label: 'Edit Te&xt' NOTE: Escher
	msotcidLabelVertical = 2178,		//(0,25) Label: '&Vertical Label Tool' NOTE: Escher - PGM is this obsolete?
	msotcidSetObjectDefaults = 2179,		//(0,25) Label: 'Set AutoShape &Defaults' NOTE: Escher
	msotcidShowHiddenObjects = 2180,		//(0,25) Label: 'Show &Hidden Objects' NOTE: Access
	msotcidAlignRelativeToSlide = 2181,		//(42,12) Label: 'Relative t&o Slide' NOTE: Escher - PPT version of AlignRelativeToPage
	msotcidAlignRelativeToDrawing = 2182,		//(42,12) Label: 'Relative t&o Drawing Canvas' NOTE: Escher
	msotcidShadowNoneSwatch = 2183,		//(0,25) Label: '&No Shadow' NOTE: Escher
	msotcid3DNoneSwatch = 2184,		//(0,25) Label: '&No 3-D' NOTE: Escher
	msotcidThesaurus = 2185,		//(0,25) Label: '&Thesaurus...' NOTE: Word
	msotcidStopRecorder = 2186,		//(26,1) Label: 'Stop &Recording' NOTE: VB
	msotcidSwitcher_Stop_StopRecorder = 2187,		//(26,1) Label: '&Stop' NOTE: Word - "core" command that switches
	msotcidSendToMailRecipient = 2188,		//(2,4) Label: 'M&ail Recipient (as Attachment)...' NOTE: used on Send To cascade, instead of msotcidSend2 or msotcidSend
	msotcidAutoSummaryViewByHighlight = 2189,		//(16,26) Label: '&Highlight/Show Only Summary' NOTE: Word
	msotcidMasterDocument = 2190,		//(25,23) Label: '&Master Document' NOTE: Word - appears on menu, cf. MasterDocumentView
	msotcidMSWordHelp = 2191,		//(0,25) Label: '&Help' NOTE: Word command well
	msotcidMSWordHelpMSN = 2192,		//(0,25) Label: '&Help MSN' NOTE: Word command well
	msotcidMSWordHelpUsingHelp = 2193,		//(0,25) Label: '&Help Using Help' NOTE: Word command well
	msotcidMSWordHelpTipOfTheDay = 2194,		//(0,25) Label: '&Help Tip Of The Day' NOTE: Word command well
	msotcidMSWordMicrosoftSystemInfo = 2195,		//(0,25) Label: '&Microsoft System Info' NOTE: Word command well
	msotcidMSWordHelpWordPerfectHelpOptions = 2196,		//(0,25) Label: '&WordPerfect Help Options...' NOTE: Word command well
	msotcidMSWordOvertype = 2197,		//(0,25) Label: '&Overtype' NOTE: Word command well
	msotcidMSWordExtendSelection = 2198,		//(0,25) Label: '&Extend Selection' NOTE: Word command well
	msotcidMSWordSpike = 2199,		//(0,25) Label: '&Spike' NOTE: Word command well
	msotcidMSWordInsertSpike = 2200,		//(0,25) Label: '&Insert Spike' NOTE: Word command well
	msotcidMSWordChangeCase = 2201,		//(0,25) Label: '&Change Case' NOTE: Word command well
	msotcidMSWordMoveText = 2202,		//(0,25) Label: '&Move Text' NOTE: Word command well
	msotcidMSWordCopyText = 2203,		//(0,25) Label: '&Copy Text' NOTE: Word command well
	msotcidMSWordInsertAutoText = 2204,		//(0,25) Label: '&Insert AutoText' NOTE: Word command well
	msotcidMSWordApplyAutoTextName = 2205,		//(0,25) Label: '&Apply AutoText Name' NOTE: Word command well
	msotcidMSWordOtherPane = 2206,		//(0,25) Label: '&Other Pane' NOTE: Word command well
	msotcidCreateRelationship = 2207,		//(0,25) Label: '&Create Relationship' NOTE: Access
	msotcidMSWordPrevWindow = 2208,		//(0,25) Label: '&Previous Window' NOTE: Word command well
	msotcidMSWordNextField = 2209,		//(0,25) Label: '&Next Field' NOTE: Word command well
	msotcidMSWordPrevField = 2210,		//(0,25) Label: '&Previous Field' NOTE: Word command well
	msotcidMSWordColumnSelect = 2211,		//(0,25) Label: '&Column Select' NOTE: Word command well
	msotcidMSWordInsertFieldChars = 2212,		//(0,25) Label: '&Insert Field Chars' NOTE: Word command well
	msotcidMSWordInsertListNumField = 2213,		//(44,17) Label: '&Insert ListNum Field' NOTE: Word command well
	msotcidMSWordUnlinkFields = 2214,		//(0,25) Label: '&Unlink Fields' NOTE: Word command well
	msotcidMSWordLockFields = 2215,		//(0,25) Label: '&Lock Fields' NOTE: Word command well
	msotcidMSWordUnlockFields = 2216,		//(0,25) Label: '&Unlock Fields' NOTE: Word command well
	msotcidMSWordUpdateSource = 2217,		//(0,25) Label: '&Update Source' NOTE: Word command well
	msotcidMSWordHangingIndent = 2218,		//(0,25) Label: '&Hanging Indent' NOTE: Word command well
	msotcidMSWordUnHang = 2219,		//(0,25) Label: '&Un Hang' NOTE: Word command well
	msotcidMSWordCondensed = 2220,		//(0,25) Label: '&Condensed' NOTE: Word command well
	msotcidMSWordExpanded = 2221,		//(0,25) Label: '&Expanded' NOTE: Word command well
	msotcidMSWordLowered = 2222,		//(0,25) Label: '&Lowered' NOTE: Word command well
	msotcidMSWordRaised = 2223,		//(0,25) Label: '&Raised' NOTE: Word command well
	msotcidMSWordFontSize = 2224,		//(0,25) Label: '&Font Size' NOTE: Word command well
	msotcidMSWordHidden = 2225,		//(0,25) Label: '&Hidden' NOTE: Word command well
	msotcidMSWordNormalFontSpacing = 2226,		//(0,25) Label: '&Normal Font Spacing' NOTE: Word command well
	msotcidMSWordNormalFontPosition = 2227,		//(0,25) Label: '&Normal Font Position' NOTE: Word command well
	msotcidMSWordColor = 2228,		//(0,25) Label: '&Color' NOTE: Word command well
	msotcidMSWordParaWidowOrphanControl = 2229,		//(0,25) Label: '&Para Widow Orphan Control' NOTE: Word command well
	msotcidMSWordParaKeepLinesTogether = 2230,		//(0,25) Label: '&Para Keep Lines Together' NOTE: Word command well
	msotcidMSWordParaKeepWithNext = 2231,		//(0,25) Label: '&Para Keep With Next' NOTE: Word command well
	msotcidMSWordParaPageBreakBefore = 2232,		//(0,25) Label: '&Para Page Break Before' NOTE: Word command well
	msotcidMSWordCloseUpPara = 2233,		//(45,25) Label: '&No Space Before' NOTE: Word command well
	msotcidMSWordOpenUpPara = 2234,		//(45,26) Label: '&Space Before' NOTE: Word command well
	msotcidSwitcher_OpenUpPara_CloseUpPara = 2235,		//(48,13) Label: '&Add/Remove Space Before' NOTE: Word command well
	msotcidMSWordResetPara = 2236,		//(0,25) Label: '&Reset Para' NOTE: Word command well
	msotcidMSWordGoBack = 2237,		//(0,25) Label: '&Previous Edit' NOTE: Word command well
	msotcidMSWordNextInsert = 2238,		//(0,25) Label: '&Next Edit' NOTE: Word command well
	msotcidMSWordSaveTemplate = 2239,		//(0,25) Label: '&Save Template' NOTE: Word command well
	msotcidMSWordPasteFormat = 2240,		//(0,25) Label: '&Paste Format' NOTE: Word command well
	msotcidMSWordPrevPage = 2241,		//(0,25) Label: '&Previous Page' NOTE: Word command well
	msotcidMSWordNextPage = 2242,		//(0,25) Label: '&Next Page' NOTE: Word command well
	msotcidMSWordNextObject = 2243,		//(0,25) Label: '&Next Object' NOTE: Word command well
	msotcidMSWordPrevObject = 2244,		//(0,25) Label: '&Previous Object' NOTE: Word command well
	msotcidMSWordFileConfirmConversions = 2245,		//(0,25) Label: '&File Confirm Conversions' NOTE: Word command well
	msotcidMSWordMailMergeOpenDataSource = 2246,		//(64,12) Label: '&Open Data Source' NOTE: Word command well
	msotcidMSWordMailMergeOpenHeaderSource = 2247,		//(0,25) Label: '&Mail Merge Open Header Source' NOTE: Word command well
	msotcidMSWordMailMergeUseAddressBook = 2248,		//(0,25) Label: '&Mail Merge Use Address Book' NOTE: Word command well
	msotcidMSWordOrganizer = 2249,		//(0,25) Label: '&Organizer' NOTE: Word command well
	msotcidMSWordPrintFromFileName = 2250,		//(0,25) Label: '&Print From File Name' NOTE: Word command well
	msotcidMSWordMailMergeQueryOptions = 2251,		//(0,25) Label: '&Query Options' NOTE: Word command well
	msotcidMSWordMailMergeInsertIf = 2252,		//(0,25) Label: '&Mail Merge Insert If' NOTE: Word command well
	msotcidMSWordMailMergeInsertMergeRec = 2253,		//(0,25) Label: '&Mail Merge Insert Merge Rec' NOTE: Word command well
	msotcidMSWordMailMergeInsertMergeSeq = 2254,		//(0,25) Label: '&Mail Merge Insert Merge Seq' NOTE: Word command well
	msotcidMSWordMailMergeInsertNext = 2255,		//(0,25) Label: '&Mail Merge Insert Next' NOTE: Word command well
	msotcidMSWordMailMergeInsertNextIf = 2256,		//(0,25) Label: '&Mail Merge Insert Next If' NOTE: Word command well
	msotcidMSWordMailMergeInsertSkipIf = 2257,		//(0,25) Label: '&Mail Merge Insert Skip If' NOTE: Word command well
	msotcidMSWordMailMergeInsertFillIn = 2258,		//(0,25) Label: '&Mail Merge Insert Fill In' NOTE: Word command well
	msotcidMSWordMailMergeInsertAsk = 2259,		//(0,25) Label: '&Mail Merge Insert Ask' NOTE: Word command well
	msotcidMSWordMailMergeInsertSet = 2260,		//(0,25) Label: '&Mail Merge Insert Set' NOTE: Word command well
	msotcidMSWordMailMergeReset = 2261,		//(0,25) Label: '&Mail Merge Reset' NOTE: Word command well
	msotcidMSWordMailMergeCreateDataSource = 2262,		//(0,25) Label: '&Mail Merge Create Data Source' NOTE: Word command well
	msotcidMSWordMailMergeCreateHeaderSource = 2263,		//(0,25) Label: '&Mail Merge Create Header Source' NOTE: Word command well
	msotcidMSWordGoToPreviousSection = 2264,		//(0,25) Label: '&Go To Previous Section' NOTE: Word command well
	msotcidMSWordGoToNextSection = 2265,		//(0,25) Label: '&Go To Next Section' NOTE: Word command well
	msotcidMSWordGoToPreviousPage = 2266,		//(0,25) Label: '&Go To Previous Page' NOTE: Word command well
	msotcidMSWordGoToNextPage = 2267,		//(0,25) Label: '&Go To Next Page' NOTE: Word command well
	msotcidMSWordGoToPreviousFootnote = 2268,		//(0,25) Label: '&Go To Previous Footnote' NOTE: Word command well
	msotcidMSWordGoToNextFootnote = 2269,		//(0,25) Label: '&Go To Next Footnote' NOTE: Word command well
	msotcidMSWordGoToPreviousEndnote = 2270,		//(0,25) Label: '&Go To Previous Endnote' NOTE: Word command well
	msotcidMSWordGoToNextEndnote = 2271,		//(0,25) Label: '&Go To Next Endnote' NOTE: Word command well
	msotcidMSWordActivateObject = 2272,		//(0,25) Label: '&Activate Object' NOTE: Word command well
	msotcidMSWordTableRowHeight = 2273,		//(0,25) Label: '&Table Row Height' NOTE: Word command well
	msotcidMSWordTableColumnWidth = 2274,		//(0,25) Label: '&Table Column Width' NOTE: Word command well
	msotcidMSWordTableUpdateAutoFormat = 2275,		//(0,25) Label: '&Table Update AutoFormat' NOTE: Word command well
	msotcidMSWordViewZoomQuery = 2276,		//(0,25) Label: '&View Zoom Query' NOTE: Word command well
	msotcidMSWordViewDraft = 2277,		//(0,25) Label: '&View Draft' NOTE: Word command well
	msotcidMSWordViewOutlineSplitToolbar = 2278,		//(0,25) Label: '&View Outline Split Toolbar' NOTE: Word command well
	msotcidMSWordNewToolbar = 2279,		//(0,25) Label: '&New Toolbar' NOTE: Word command well
	msotcidMSWordToolbarList = 2280,		//(0,25) Label: '&Reserved' NOTE: PGM - this should not be used
	msotcidMSWordNavigationPaneSynch = 2281,		//(0,25) Label: '&Navigation Pane Synch' NOTE: Word command well
	msotcidMSWordViewStatusBar = 2282,		//(0,25) Label: '&View Status Bar' NOTE: PGM - use StatusBar instead
	msotcidMSWordNormalViewHeaderArea = 2283,		//(0,25) Label: '&Normal View Header Area' NOTE: Word command well
	msotcidMSWordInsertSectionBreak = 2284,		//(0,25) Label: '&Insert Section Break' NOTE: Word command well
	msotcidMSWordInsertEndnoteNow = 2285,		//(0,25) Label: '&Insert Endnote Now' NOTE: Word command well
	msotcidMSWordEditConvertAllFootnotes = 2286,		//(0,25) Label: '&Edit Convert All Footnotes' NOTE: Word command well
	msotcidMSWordEditConvertAllEndnotes = 2287,		//(0,25) Label: '&Edit Convert All Endnotes' NOTE: Word command well
	msotcidMSWordEditSwapAllNotes = 2288,		//(0,25) Label: '&Edit Swap All Notes' NOTE: Word command well
	msotcidMSWordInsertSymbol2 = 2289,		//(0,25) Label: '&Insert Symbol2' NOTE: Word command well
	msotcidMSWordSymbol = 2290,		//(0,25) Label: '&Symbol' NOTE: Word command well
	msotcidMSWordInsertEnSpace = 2291,		//(0,25) Label: '&Insert En Space' NOTE: Word command well
	msotcidMSWordInsertEmSpace = 2292,		//(0,25) Label: '&Insert Em Space' NOTE: Word command well
	msotcidMSWordMarkIndexEntry = 2293,		//(0,25) Label: '&Mark Index Entry' NOTE: Word command well
	msotcidMSWordAutoMarkIndexEntries = 2294,		//(0,25) Label: '&Auto Mark Index Entries' NOTE: Word command well
	msotcidMSWordMarkCitation = 2295,		//(0,25) Label: '&Mark Citation' NOTE: Word command well
	msotcidMSWordEditTOACategory = 2296,		//(0,25) Label: '&Edit TOA Category' NOTE: Word command well
	msotcidMSWordToaRichEditEnter = 2297,		//(0,25) Label: '&Toa Rich Edit Enter' NOTE: Word command well
	msotcidMSWordInsertIndex = 2298,		//(0,25) Label: '&Insert Index' NOTE: Word command well
	msotcidMSWordInsertTableOfContents = 2299,		//(0,25) Label: '&Insert Table Of Contents' NOTE: Word command well
	msotcidMSWordMarkTableOfContentsEntry = 2300,		//(0,25) Label: '&Mark Table Of Contents Entry' NOTE: Word command well
	msotcidMSWordInsertTableOfFigures = 2301,		//(0,25) Label: '&Insert Table Of Figures' NOTE: Word command well
	msotcidMSWordInsertTableOfAuthorities = 2302,		//(0,25) Label: '&Insert Table Of Authorities' NOTE: Word command well
	msotcidMSWordInsertTableOfCaptionsOptions = 2303,		//(0,25) Label: '&Insert Table Of Captions Options' NOTE: Word command well
	msotcidMSWordInsertTableOfContentsOptions = 2304,		//(0,25) Label: '&Insert Table Of Contents Options' NOTE: Word command well
	msotcidMSWordDrawUnselect = 2305,		//(0,25) Label: '&Draw Unselect' NOTE: Word command well
	msotcidMSWordDrawSelectNext = 2306,		//(0,25) Label: '&Draw Select Next' NOTE: Word command well
	msotcidMSWordDrawSelectPrevious = 2307,		//(0,25) Label: '&Draw Select Previous' NOTE: Word command well
	msotcidMSWordTextboxLinking = 2308,		//(3,5) Label: 'C&reate Text Box Link' NOTE: Word
	msotcidMSWordTextboxUnlinking = 2309,		//(3,6) Label: '&Break Forward Link' NOTE: Word
	msotcidMSWordGotoNextLinkedTextBox = 2310,		//(3,8) Label: '&Next Text Box' NOTE: Word
	msotcidMSWordGotoPrevLinkedTextBox = 2311,		//(3,7) Label: '&Previous Text Box' NOTE: Word
	msotcidMSWordOfficeDrawingCommand = 2312,		//(0,25) Label: '&Office Drawing Command' NOTE: Word command well
	msotcidMSWordShading = 2313,		//(0,25) Label: '&Shading' NOTE: Word command well
	msotcidMSWordBorders = 2314,		//(0,25) Label: '&Borders' NOTE: Word command well
	msotcidMSWordFormatSectionLayout = 2315,		//(0,25) Label: '&Format Section Layout' NOTE: Word command well
	msotcidMSWordColumns = 2316,		//(0,25) Label: '&Columns' NOTE: Word command well
	msotcidMSWordAfmtMsg = 2317,		//(0,25) Label: '&Afmt Msg' NOTE: Word command well
	msotcidMSWordReviewAutoFormatChanges = 2318,		//(0,25) Label: '&Review AutoFormat Changes' NOTE: Word command well
	msotcidMSWordRedefineStyle = 2319,		//(0,25) Label: '&Redefine Style' NOTE: Word command well
	msotcidMSWordAutoRedefStyle = 2320,		//(0,25) Label: '&Auto Redef Style' NOTE: Word command well
	msotcidMSWordApplyStyleName = 2321,		//(0,25) Label: '&Apply Style Name' NOTE: Word command well
	msotcidMSWordApplyHeading1 = 2322,		//(0,25) Label: '&Apply Heading 1' NOTE: Word command well
	msotcidMSWordApplyHeading2 = 2323,		//(0,25) Label: '&Apply Heading 2' NOTE: Word command well
	msotcidMSWordApplyHeading3 = 2324,		//(0,25) Label: '&Apply Heading 3' NOTE: Word command well
	msotcidMSWordApplyListBullet = 2325,		//(0,25) Label: '&Apply List Bullet' NOTE: Word command well
	msotcidMSWordConvertTextboxToFrame = 2326,		//(0,25) Label: '&Convert Text Box To Frame' NOTE: Word command well
	msotcidMSWordFormatObjectCore = 2327,		//(0,25) Label: '&Format Object Core' NOTE: Word command well
	msotcidMSWordFormatListMacro = 2328,		//(0,25) Label: '&Format List Macro' NOTE: Word command well
	msotcidMSWordFormatListModifyLevel = 2329,		//(0,25) Label: '&Format List Modify Level' NOTE: Word command well
	msotcidMSWordPromoteList = 2330,		//(0,25) Label: '&Promote List' NOTE: Word command well
	msotcidMSWordDemoteList = 2331,		//(0,25) Label: '&Demote List' NOTE: Word command well
	msotcidMSWordFormatNumberTable = 2332,		//(0,25) Label: '&Format Number Table' NOTE: Word command well
	msotcidMSWordToolsSpellSelection = 2333,		//(0,25) Label: '&Tools Spell Selection' NOTE: Word command well
	msotcidMSWordNextMisspelling = 2334,		//(0,25) Label: '&Next Misspelling' NOTE: Word command well
	msotcidMSWordFixGrammarIgnoreSent = 2335,		//(0,25) Label: '&Fix Grammar Ignore Sent' NOTE: Word command well
	msotcidMSWordToolsHyphenationManual = 2336,		//(0,25) Label: '&Tools Hyphenation Manual' NOTE: Word command well
	msotcidMSWordToolsBulletsNumbers = 2337,		//(0,25) Label: '&Tools Bullets Numbers' NOTE: Word command well
	msotcidMSWordToolsMergeRevisions = 2338,		//(0,25) Label: 'Compare and Merge &Documents...' NOTE: Word
	msotcidMSWordToolsCalculate = 2339,		//(0,25) Label: '&Tools Calculate' NOTE: Word command well
	msotcidMSWordToolsCustomizeKeyboardShortcut = 2340,		//(0,25) Label: '&Tools Customize Keyboard Shortcut' NOTE: Word command well
	msotcidMSWordToolsCustomizeAddMenuShortcut = 2341,		//(0,25) Label: '&Tools Customize Add Menu Shortcut' NOTE: Word command well
	msotcidMSWordToolsCustomizeRemoveMenuShortcut = 2342,		//(0,25) Label: '&Tools Customize Remove Menu Shortcut' NOTE: Word command well
	msotcidMSWordListCommands = 2343,		//(0,25) Label: '&List Commands' NOTE: Word command well
	msotcidMSWordToolsOptionsGeneral = 2344,		//(0,25) Label: '&Tools Options General' NOTE: Word command well
	msotcidMSWordToolsOptionsCompatibility = 2345,		//(0,25) Label: '&Tools Options Compatibility' NOTE: Word command well
	msotcidMSWordToolsOptionsPrint = 2346,		//(0,25) Label: '&Tools Options Print' NOTE: Word command well
	msotcidMSWordToolsOptionsSave = 2347,		//(0,25) Label: '&Tools Options Save' NOTE: Word command well
	msotcidMSWordToolsOptionsSpelling = 2348,		//(0,25) Label: '&Tools Options Spelling' NOTE: Word command well
	msotcidMSWordToolsSpellingRecheckDocument = 2349,		//(0,25) Label: '&Tools Spelling Recheck Document' NOTE: Word command well
	msotcidMSWordToolsOptionsUserInfo = 2350,		//(0,25) Label: '&Tools Options User Info' NOTE: Word command well
	msotcidMSWordToolsOptionsAutoFormatW7 = 2351,		//(0,25) Label: '&Tools Options AutoFormat W7' NOTE: Word command well
	msotcidMSWordToolsOptionsAutoFormat = 2352,		//(0,25) Label: '&Tools Options AutoFormat' NOTE: Word command well
	msotcidMSWordToolsOptionsAutoFormatAsYouType = 2353,		//(0,25) Label: '&Tools Options AutoFormat As You Type' NOTE: Word command well
	msotcidMSWordToolsOptionsRevisions = 2354,		//(0,25) Label: '&Options...' NOTE: Word
	msotcidMSWordToolsOptionsEdit = 2355,		//(0,25) Label: '&Tools Options Edit' NOTE: Word command well
	msotcidMSWordMailMergeConvertChevrons = 2356,		//(0,25) Label: '&Mail Merge Convert Chevrons' NOTE: Word command well
	msotcidMSWordMailMergeAskToConvertChevrons = 2357,		//(0,25) Label: '&Mail Merge Ask To Convert Chevrons' NOTE: Word command well
	msotcidMSWordShowClipboard = 2358,		//(4,15) Label: 'Office Clip&board' NOTE: Word command well
	msotcidMSWordDocClose = 2359,		//(0,25) Label: '&Doc Close' NOTE: Word command well
	msotcidMSWordControlRun = 2360,		//(0,25) Label: '&Control Run' NOTE: Word command well
	msotcidMSWordRunPrintManager = 2361,		//(0,25) Label: '&Run Print Manager' NOTE: Word command well
	msotcidMSWordShrinkSelection = 2362,		//(0,25) Label: '&Shrink Selection' NOTE: Word command well
	msotcidMSWordNormalStyle = 2363,		//(0,25) Label: '&Normal Style' NOTE: Word command well
	msotcidMSWordNextCell = 2364,		//(0,25) Label: '&Next Cell' NOTE: Word command well
	msotcidMSWordPrevCell = 2365,		//(0,25) Label: '&Previous Cell' NOTE: Word command well
	msotcidMSWordStartOfRow = 2366,		//(0,25) Label: '&Start Of Row' NOTE: Word command well
	msotcidMSWordEndOfRow = 2367,		//(0,25) Label: '&End Of Row' NOTE: Word command well
	msotcidMSWordStartOfColumn = 2368,		//(0,25) Label: '&Start Of Column' NOTE: Word command well
	msotcidMSWordEndOfColumn = 2369,		//(0,25) Label: '&End Of Column' NOTE: Word command well
	msotcidMSWordInsertColumnBreakW7 = 2370,		//(0,25) Label: '&Insert Column Break W7' NOTE: Word command well
	msotcidMSWordInsertColumnBreak = 2371,		//(0,25) Label: '&Insert Column Break' NOTE: Word command well
	msotcidMSWordAppMinimize = 2372,		//(0,25) Label: '&Minimize All' NOTE: Word command well
	msotcidMSWordAppMaximize = 2373,		//(0,25) Label: '&Maximize All' NOTE: Word command well
	msotcidMSWordAppRestore = 2374,		//(0,25) Label: '&Restore All' NOTE: Word command well
	msotcidMSWordDoFieldClick = 2375,		//(0,25) Label: '&Do Field Click' NOTE: Word command well
	msotcidMSWordSelectCurFont = 2376,		//(0,25) Label: '&Select Cur Font' NOTE: Word command well
	msotcidMSWordSelectCurAlignment = 2377,		//(0,25) Label: '&Select Cur Alignment' NOTE: Word command well
	msotcidMSWordSelectCurSpacing = 2378,		//(0,25) Label: '&Select Cur Spacing' NOTE: Word command well
	msotcidMSWordSelectCurIndent = 2379,		//(0,25) Label: '&Select Cur Indent' NOTE: Word command well
	msotcidMSWordSelectCurTabs = 2380,		//(0,25) Label: '&Select Cur Tabs' NOTE: Word command well
	msotcidMSWordSelectCurColor = 2381,		//(0,25) Label: '&Select Cur Color' NOTE: Word command well
	msotcidMSWordRemoveFrames = 2382,		//(0,25) Label: '&Remove Frames' NOTE: Word command well
	msotcidMSWordMenuMode = 2383,		//(0,25) Label: '&Menu Mode' NOTE: Word command well
	msotcidMSWordFormatPageNumber = 2384,		//(49,24) Label: '&Format Page Numbers' NOTE: Word
	msotcidMSWordViewZoom200 = 2385,		//(0,25) Label: '&View Zoom200' NOTE: Word command well
	msotcidMSWordViewZoom75 = 2386,		//(0,25) Label: '&View Zoom75' NOTE: Word command well
	msotcidMSWordFormatAddrFonts = 2387,		//(0,25) Label: '&Format Addr Fonts' NOTE: Word command well
	msotcidMSWordFormatRetAddrFonts = 2388,		//(0,25) Label: '&Format Ret Addr Fonts' NOTE: Word command well
	msotcidMSWordToolsOptionsFileLocations = 2389,		//(0,25) Label: '&Tools Options File Locations' NOTE: Word command well
	msotcidMSWordToolsCreateDirectory = 2390,		//(0,25) Label: '&Tools Create Directory' NOTE: Word command well
	msotcidMSWordUpdateToc = 2391,		//(0,25) Label: '&Update Table of Contents' NOTE: Word command well
	msotcidMSWordNextFormField = 2392,		//(0,25) Label: '&Next Form Field' NOTE: Word command well
	msotcidMSWordPrevFormField = 2393,		//(0,25) Label: '&Previous Form Field' NOTE: Word command well
	msotcidMSWordStartFormField = 2394,		//(0,25) Label: '&Start Form Field' NOTE: Word command well
	msotcidMSWordEndFormField = 2395,		//(0,25) Label: '&End Form Field' NOTE: Word command well
	msotcidMSWordFirstFormField = 2396,		//(0,25) Label: '&First Form Field' NOTE: Word command well
	msotcidMSWordLastFormField = 2397,		//(0,25) Label: '&Last Form Field' NOTE: Word command well
	msotcidMSWordGotoNoteHelp = 2398,		//(0,25) Label: '&Goto Note Help' NOTE: Word command well
	msotcidMSWordViewFootnoteSeparator = 2399,		//(0,25) Label: '&View Footnote Separator' NOTE: Word command well
	msotcidMSWordViewFootnoteContSeparator = 2400,		//(0,25) Label: '&View Footnote Cont Separator' NOTE: Word command well
	msotcidMSWordViewFootnoteContNotice = 2401,		//(0,25) Label: '&View Footnote Cont Notice' NOTE: Word command well
	msotcidMSWordViewEndnoteSeparator = 2402,		//(0,25) Label: '&View Endnote Separator' NOTE: Word command well
	msotcidMSWordViewEndnoteContSeparator = 2403,		//(0,25) Label: '&View Endnote Cont Separator' NOTE: Word command well
	msotcidMSWordViewEndnoteContNotice = 2404,		//(0,25) Label: '&View Endnote Cont Notice' NOTE: Word command well
	msotcidMSWordSpellCompleted = 2405,		//(0,25) Label: '&Spell Completed' NOTE: Word command well
	msotcidMSWordGramCompleted = 2406,		//(0,25) Label: '&Gram Completed' NOTE: Word command well
	msotcidMSWordFormLeft = 2407,		//(0,25) Label: '&Form Left' NOTE: Word command well
	msotcidMSWordFormRight = 2408,		//(0,25) Label: '&Form Right' NOTE: Word command well
	msotcidMSWordFormUp = 2409,		//(0,25) Label: '&Form Up' NOTE: Word command well
	msotcidMSWordFormDown = 2410,		//(0,25) Label: '&Form Down' NOTE: Word command well
	msotcidMSWordFormFieldHelp = 2411,		//(0,25) Label: '&Form Field Help' NOTE: Word command well
	msotcidMSWordInsertAutoCaption = 2412,		//(0,25) Label: '&Insert Auto Caption' NOTE: Word command well
	msotcidMSWordInsertAddCaption = 2413,		//(0,25) Label: '&Insert Add Caption' NOTE: Word command well
	msotcidMSWordInsertCaptionNumbering = 2414,		//(0,25) Label: '&Insert Caption Numbering' NOTE: Word command well
	msotcidMSWordToolsAutoCorrectReplaceText = 2415,		//(0,25) Label: '&Tools AutoCorrect Replace Text' NOTE: Word command well
	msotcidMSWordToolsAutoCorrectInitialCaps = 2416,		//(0,25) Label: '&Tools AutoCorrect Initial Caps' NOTE: Word command well
	msotcidMSWordToolsAutoCorrectSentenceCaps = 2417,		//(0,25) Label: '&Tools AutoCorrect Sentence Caps' NOTE: Word command well
	msotcidMSWordToolsAutoCorrectDays = 2418,		//(0,25) Label: '&Tools AutoCorrect Days' NOTE: Word command well
	msotcidMSWordToolsAutoCorrectSmartQuotes = 2419,		//(0,25) Label: '&Tools AutoCorrect Smart Quotes' NOTE: Word command well
	msotcidMSWordToolsAutoCorrectCapsLockOff = 2420,		//(0,25) Label: '&Tools AutoCorrect Caps Lock Off' NOTE: Word command well
	msotcidMSWordToolsAutoCorrectExceptions = 2421,		//(0,25) Label: '&Tools AutoCorrect Exceptions' NOTE: Word command well
	msotcidMSWordAutoSummaryViewLevel = 2422,		//(0,25) Label: '&Percent of Original' NOTE: Word command well
	msotcidMSWordToggleCheckBox = 2423,		//(0,25) Label: '&Toggle Check Box' NOTE: Word command well
	msotcidMSWordDropListBox = 2424,		//(0,25) Label: '&Drop List Box' NOTE: Word command well
	msotcidMSWordAddCustomDictionary = 2425,		//(0,25) Label: '&Add Custom Dictionary' NOTE: Word command well
	msotcidMSWordNewCustomDictionary = 2426,		//(0,25) Label: '&New Custom Dictionary' NOTE: Word command well
	msotcidMSWordAppSize = 2427,		//(0,25) Label: '&Size All' NOTE: Word command well
	msotcidMSWordAppMove = 2428,		//(0,25) Label: '&Move All' NOTE: Word command well
	msotcidMSWordConnect = 2429,		//(0,25) Label: '&Connect' NOTE: Word command well
	msotcidMSWordToolsOptionsView = 2430,		//(0,25) Label: '&Tools Options View' NOTE: Word command well
	msotcidMSWordToolsOptionsViewNormal = 2431,		//(0,25) Label: '&Tools Options View Normal' NOTE: Word command well
	msotcidMSWordToolsOptionsViewMacro = 2432,		//(0,25) Label: '&Tools Options View Macro' NOTE: Word command well
	msotcidMSWordToolsOptionsViewOutline = 2433,		//(0,25) Label: '&Tools Options View Outline' NOTE: Word command well
	msotcidMSWordToolsOptionsViewPage = 2434,		//(0,25) Label: '&Tools Options View Page' NOTE: Word command well
	msotcidMSWordToolsOptionsViewOnline = 2435,		//(0,25) Label: '&Tools Options View Online' NOTE: Word command well
	msotcidMSWordGotoAnnotationScope = 2436,		//(0,25) Label: '&Goto Annotation Scope' NOTE: Word command well
	msotcidMSWordFontSubstitution = 2437,		//(0,25) Label: '&Font Substitution' NOTE: Word command well
	msotcidMSWordScreenRefresh = 2438,		//(0,25) Label: '&Screen Refresh' NOTE: Word command well
	msotcidMSWordCharLeft = 2439,		//(0,25) Label: '&Char Left' NOTE: Word command well
	msotcidMSWordCharRight = 2440,		//(0,25) Label: '&Char Right' NOTE: Word command well
	msotcidMSWordWordLeft = 2441,		//(0,25) Label: '&Word Left' NOTE: Word command well
	msotcidMSWordWordRight = 2442,		//(0,25) Label: '&Word Right' NOTE: Word command well
	msotcidMSWordSentLeft = 2443,		//(0,25) Label: '&Sent Left' NOTE: Word command well
	msotcidMSWordSentRight = 2444,		//(0,25) Label: '&Sent Right' NOTE: Word command well
	msotcidMSWordParaUp = 2445,		//(0,25) Label: '&Para Up' NOTE: Word command well
	msotcidMSWordParaDown = 2446,		//(0,25) Label: '&Para Down' NOTE: Word command well
	msotcidMSWordLineUp = 2447,		//(0,25) Label: '&Line Up' NOTE: Word command well
	msotcidMSWordLineDown = 2448,		//(0,25) Label: '&Line Down' NOTE: Word command well
	msotcidMSWordCharLeftExtend = 2449,		//(0,25) Label: '&Char Left Extend' NOTE: Word command well
	msotcidMSWordCharRightExtend = 2450,		//(0,25) Label: '&Char Right Extend' NOTE: Word command well
	msotcidMSWordWordLeftExtend = 2451,		//(0,25) Label: '&Word Left Extend' NOTE: Word command well
	msotcidMSWordWordRightExtend = 2452,		//(0,25) Label: '&Word Right Extend' NOTE: Word command well
	msotcidMSWordSentLeftExtend = 2453,		//(0,25) Label: '&Sent Left Extend' NOTE: Word command well
	msotcidMSWordSentRightExtend = 2454,		//(0,25) Label: '&Sent Right Extend' NOTE: Word command well
	msotcidMSWordParaUpExtend = 2455,		//(0,25) Label: '&Para Up Extend' NOTE: Word command well
	msotcidMSWordParaDownExtend = 2456,		//(0,25) Label: '&Para Down Extend' NOTE: Word command well
	msotcidMSWordLineUpExtend = 2457,		//(0,25) Label: '&Line Up Extend' NOTE: Word command well
	msotcidMSWordLineDownExtend = 2458,		//(0,25) Label: '&Line Down Extend' NOTE: Word command well
	msotcidMSWordPageUpExtend = 2459,		//(0,25) Label: '&Page Up Extend' NOTE: Word command well
	msotcidMSWordPageDownExtend = 2460,		//(0,25) Label: '&Page Down Extend' NOTE: Word command well
	msotcidMSWordStartOfLineExtend = 2461,		//(0,25) Label: '&Start Of Line Extend' NOTE: Word command well
	msotcidMSWordEndOfLineExtend = 2462,		//(0,25) Label: '&End Of Line Extend' NOTE: Word command well
	msotcidMSWordStartOfWindowExtend = 2463,		//(0,25) Label: '&Start Of Window Extend' NOTE: Word command well
	msotcidMSWordEndOfWindowExtend = 2464,		//(0,25) Label: '&End Of Window Extend' NOTE: Word command well
	msotcidMSWordStartOfDocExtend = 2465,		//(0,25) Label: '&Start Of Doc Extend' NOTE: Word command well
	msotcidMSWordEndOfDocExtend = 2466,		//(0,25) Label: '&End Of Doc Extend' NOTE: Word command well
	msotcidMSWordSymbolFont = 2467,		//(0,25) Label: '&Symbol Font' NOTE: Word command well
	msotcidMSWordUnimp = 2468,		//(0,25) Label: '&Unimp' NOTE: Word command well
	msotcidMSWordToolsGramSettings = 2469,		//(0,25) Label: '&Tools Gram Settings' NOTE: Word command well
	msotcidMSWordGramStats = 2470,		//(0,25) Label: '&Gram Stats' NOTE: Word command well
	msotcidFilledShadow = 2471,		//(34,14) Label: '&Filled Shadow' NOTE: Escher
	msotcidEditTextEffect = 2472,		//(0,25) Label: '&Edit WordArt' NOTE: Escher
	msotcidCalendarDay = 2473,		//(34,15) Label: '&Custom' NOTE: Project
	msotcidMSProjectEquals = 2474,		//(42,13) Label: '&Custom' NOTE: Project
	msotcidMSProjectMoveWindow = 2475,		//(42,14) Label: '&Custom' NOTE: Project
	msotcidMSProjectSort = 2476,		//(42,15) Label: '&Custom' NOTE: Project
	msotcidMSProjectMinimizeWindow = 2477,		//(42,16) Label: '&Custom' NOTE: Project
	msotcidMSProjectInfoWindow = 2478,		//(42,17) Label: '&Information' NOTE: Project
	msotcidMSProjectCopyAsPicture = 2479,		//(42,19) Label: '&Copy Picture' NOTE: Project
	msotcidTimeGrid5Minutes = 2480,		//(0,25) Label: '&5 Minutes' NOTE: Ren
	msotcidTimeGrid10Minutes = 2481,		//(0,25) Label: '10 &Minutes' NOTE: Ren
	msotcidTimeGrid15Minutes = 2482,		//(0,25) Label: '&15 Minutes' NOTE: Ren
	msotcidTimeGrid30Minutes = 2483,		//(0,25) Label: '&30 Minutes' NOTE: Ren
	msotcidTimeGrid60Minutes = 2484,		//(0,25) Label: '6&0 Minutes' NOTE: Ren
	msotcidTimeGrid6Minutes = 2485,		//(0,25) Label: '&6 Minutes' NOTE: Ren
	msotcidViewReports = 2486,		//(19,26) Label: '&Reports...' NOTE: Project
	msotcidCancelInvitation = 2487,		//(37,9) Label: 'Cancel In&vitation' NOTE: Ren
	msotcidOutOfOffice = 2488,		//(0,25) Label: 'O&ut of Office...' NOTE: Ren
	msotcidWorkWeekView = 2489,		//(0,25) Label: 'Wo&rk Week' NOTE: Ren
	msotcidAcceptRequestWithoutComment = 2490,		//(0,25) Label: '&Accept Request Without Comment' NOTE: Ren
	msotcidAddressNewXXX = 2491,		//(0,25) Label: 'A&ddress New <0S>' NOTE: Ren
	msotcidCopyHereAsXXXWithAttachment = 2492,		//(0,25) Label: '&Copy Here as <0S> with Attachment' NOTE: Ren
	msotcidCreateHereAsXXXWithText = 2493,		//(0,25) Label: 'Copy Here as <0S> with &Text' NOTE: Ren
	msotcidCopyHereAsXXXWithShortcut = 2494,		//(0,25) Label: 'Copy Here as <0S> with &Shortcut' NOTE: Ren
	msotcidDeclineRequestWithoutComment = 2495,		//(0,25) Label: '&Decline Request Without Comment' NOTE: Ren
	msotcidMoveHereAsXXXWithAttachment = 2496,		//(0,25) Label: '&Move Here as <0S> with Attachment' NOTE: Ren
	msotcidExploreWebPage = 2497,		//(43,25) Label: 'E&xplore Web Page' NOTE: Ren
	msotcidNewLetterToContact = 2498,		//(12,1) Label: 'New &Letter to Contact' NOTE: Ren
	msotcidCopy_foldername = 2499,		//(68,0) Label: '&Copy \"<0s#25>\"...' NOTE: Ren
	msotcidDelete_foldername = 2500,		//(68,5) Label: '&Delete \"<0s#25>\"' NOTE: Ren
	msotcidNewCall = 2501,		//(62,23) Label: '&New Call...' NOTE: Ren
	msotcidPropertiesFor_foldername = 2502,		//(5,13) Label: 'Propert&ies<1P// for \"/><0s#25><1p//\"/>' NOTE: Ren
	msotcidAboutThisForm = 2503,		//(0,25) Label: 'About this &Form' NOTE: Ren
	msotcidHideShortcutBar = 2504,		//(0,25) Label: '&Hide Outlook Bar' NOTE: Ren
	msotcidInsertItem = 2505,		//(0,25) Label: 'It&em...' NOTE: Ren
	msotcidMove_foldername = 2506,		//(67,27) Label: 'Mo&ve \"<0s#25>\"...' NOTE: Ren
	msotcidSendAgain = 2507,		//(61,12) Label: '&Send Again...' NOTE: Ren
	msotcidOpenSavedSearch = 2508,		//(0,25) Label: 'Open Sea&rch...' NOTE: Ren
	msotcidShowWorkdays = 2509,		//(0,25) Label: 'Show &Only Working Hours' NOTE: Ren
	msotcidShowZoomedOut = 2510,		//(0,25) Label: 'Show &Zoomed Out' NOTE: Ren
	msotcidRecallMessage = 2511,		//(0,25) Label: '&Recall This Message...' NOTE: Ren
	msotcidRename_foldername = 2512,		//(67,28) Label: '&Rename<1P// \"/><0s#25><1P//\"/>...' NOTE: Ren
	msotcidSearchSubfolders = 2513,		//(0,25) Label: 'Search Su&bfolders' NOTE: Ren
	msotcidEditComposePage = 2514,		//(0,25) Label: 'Edit Compose Pa&ge' NOTE: Ren
	msotcidToggleShortcutBar = 2515,		//(0,25) Label: '&Outlook Bar' NOTE: Ren
	msotcidEditReadPage = 2516,		//(0,25) Label: 'E&dit Read Page' NOTE: Ren
	msotcidOpenAttendeesCalendar = 2517,		//(37,19) Label: '&Open Attendee's Calendar' NOTE: Ren
	msotcidAddToShortcutBar = 2518,		//(0,25) Label: 'A&dd to Outlook Bar' NOTE: Ren - equivalent to AddToFavorites
	msotcidDesignForm = 2519,		//(9,11) Label: 'Desi&gn Outlook Form' NOTE: Ren
	msotcidNewDefault = 2520,		//(0,11) Label: '&New' NOTE: default version of command, no dialog
	msotcidPrintDefault = 2521,		//(1,3) Label: '&Print' NOTE: default version of command, no dialog
	msotcidVersions = 2522,		//(42,20) Label: 'Ve&rsions...' NOTE: Word (and others?)
	msotcidTextColorMRUSwatch = 2523,		//(0,25) Label: '&Recently Used Colors' NOTE: PPT
	msotcidImportFile = 2524,		//(0,25) Label: '&Import File...' NOTE: Excel (cf. msotcidImport)
	msotcidToggleBookmark = 2525,		//(42,27) Label: 'Book&mark' NOTE: VBE
	msotcidNextBookmark = 2526,		//(42,28) Label: '&Next Bookmark' NOTE: VBE
	msotcidPreviousBookmark = 2527,		//(42,29) Label: '&Previous Bookmark' NOTE: VBE
	msotcidClearAllBookmarks = 2528,		//(43,0) Label: '&Clear All Bookmarks' NOTE: VBE
	msotcidSelectMember = 2529,		//(42,22) Label: '&List Properties/Methods' NOTE: VBE
	msotcidSelectConstant = 2530,		//(42,23) Label: 'Li&st Constants' NOTE: VBE
	msotcidQuickInfo = 2531,		//(42,24) Label: '&Quick Info' NOTE: VBE
	msotcidParameterInfo = 2532,		//(42,25) Label: 'Para&meter Info' NOTE: VBE
	msotcidCompleteWord = 2533,		//(48,5) Label: 'Complete &Word' NOTE: VBE
	msotcidCmdbarPropBarLabel = 2534,		//(0,25) Label: '&Toolbar:' NOTE: Access command bar property sheet
	msotcidCmdbarPropBarNameEdit = 2535,		//(0,25) Label: '&Name:' NOTE: more Access property sheet stuff...
	msotcidCmdbarPropBarTypeDropdown = 2536,		//(0,25) Label: '&Type:'
	msotcidCmdbarPropShowInBarList = 2537,		//(0,25) Label: '&Show in Toolbar List'
	msotcidCmdbarPropDockingDropdown = 2538,		//(0,25) Label: '&Docking:'
	msotcidCmdbarPropAllowBarCustomize = 2539,		//(0,25) Label: '&Allow Customize'
	msotcidCmdbarPropAllowBarResize = 2540,		//(0,25) Label: '&Allow Resize'
	msotcidCmdbarPropAllowBarMove = 2541,		//(0,25) Label: '&Allow Movement'
	msotcidCmdbarPropAllowBarHide = 2542,		//(0,25) Label: '&Allow Hiding'
	msotcidCmdbarPropControlLabel = 2543,		//(0,25) Label: '&Active Control:'
	msotcidCmdbarPropControlCaptionEdit = 2544,		//(0,25) Label: '&Caption:'
	msotcidCmdbarPropControlShortcutKeyEdit = 2545,		//(0,25) Label: '&Shortcut Key:'
	msotcidCmdbarPropControlTooltipEdit = 2546,		//(0,25) Label: '&Tooltip:'
	msotcidCmdbarPropControlOnActionEdit = 2547,		//(0,25) Label: '&OnAction:'
	msotcidCmdbarPropControlStyleDropdown = 2548,		//(0,25) Label: '&Style:'
	msotcidCmdbarPropControlHelpFileEdit = 2549,		//(0,25) Label: '&Help File:'
	msotcidCmdbarPropControlHelpIDEdit = 2550,		//(0,25) Label: '&Help ID:'
	msotcidCmdbarPropControlBeginGroup = 2551,		//(0,25) Label: '&Beginning of a Group'
	msotcidUnREM = 2552,		//(43,1) Label: '&Uncomment Block' NOTE: VBE
	msotcidViewVBEObject = 2553,		//(43,2) Label: '&View Object' NOTE: VBE
	msotcidImmediateWindow = 2554,		//(43,3) Label: '&Immediate Window Pane' NOTE: VBE
	msotcidLocalsWindow = 2555,		//(43,4) Label: '&Locals Window Pane' NOTE: VBE
	msotcidWatchWindow = 2556,		//(43,5) Label: '&Watch Window Pane' NOTE: VBE
	msotcidProjectExplorer = 2557,		//(28,8) Label: '&Project Explorer' NOTE: VBE
	msotcidCodeWindow = 2558,		//(43,7) Label: '&Code Window' NOTE: VBE
	msotcidStepOut = 2559,		//(43,8) Label: 'Step O&ut' NOTE: VBE
	msotcidBooksOnline = 2560,		//(43,9) Label: '&Visual Basic Books Online' NOTE: VBE
	msotcidTileWindowsVertically = 2561,		//(43,15) Label: '&Tile Vertically' NOTE: VBE, others
	msotcidTileWindowsHorizontally = 2562,		//(43,16) Label: 'T&ile Horizontally' NOTE: VBE, others
	msotcidTinyIconNormalView = 2563,		//(0,2) Label: '&Normal View' NOTE: Word - tiny view icons in scrollbar
	msotcidTinyIconOutlineView = 2564,		//(0,5) Label: '&Outline View' NOTE: Word
	msotcidTinyIconPageView = 2565,		//(0,4) Label: '&Print Layout View' NOTE: Word
	msotcidProofing = 2566,		//(1,5) Label: '&Spelling and Grammar...' NOTE: Word - replaces spelling & grammar
	msotcidPostToNotes = 2567,		//(0,25) Label: 'Notes Data&base...' NOTE: for use post 97?
	msotcidSendToNextRoutingRecipient = 2568,		//(61,12) Label: '&Next Routing Recipient...' NOTE: alternate text for msotcidSendToMailRecipient, used when a routing slip exists
	msotcidSendToOtherRoutingRecipient = 2569,		//(10,1) Label: 'Other &Routing Recipient...' NOTE: alternate text for msotcidRoutingRecipient, used when a routing slip exists
	msotcidStartLogging = 2570,		//(0,25) Label: 'Start &Logging' NOTE: Excel - Instrumented Version command?
	msotcidViewChartWindow = 2571,		//(0,25) Label: 'Chart &Window' NOTE: Excel - toggle chart window
	msotcidCopyToPersonalCalendar = 2572,		//(24,8) Label: 'Cop&y to Personal Calendar' NOTE: Ren
	msotcidCopyToPersonalTaskList = 2573,		//(27,19) Label: 'Cop&y to Personal Task List' NOTE: Ren
	msotcidCardViewShowEmptyFields = 2574,		//(0,25) Label: 'Show &Empty Fields' NOTE: Ren
	msotcidPostDocumentRen = 2575,		//(37,22) Label: 'Po&st' NOTE: Ren - same as msotcidPostDocument, but different string
	msotcidNewOfficeDocument = 2576,		//(0,11) Label: 'Office &Document' NOTE: Ren
	msotcidRenImport = 2577,		//(0,25) Label: 'Impor&t and Export...' NOTE: Ren - same as msotcidImport, but Ren really wants a different label
	msotcidVBProjectProperties = 2578,		//(33,29) Label: '&Project Properties...' NOTE: VBE
	msotcidInsertClassModule = 2579,		//(5,11) Label: '&Class Module' NOTE: VBE
	msotcidLearningVisualBasic = 2580,		//(34,2) Label: '&Learning Microsoft Visual Basic' NOTE: VB
	msotcidDlgFillColorMenu = 2581,		//(0,25) Label: 'Fill &Color' NOTE: Escher
	msotcidDlgFillColorAutomaticSwatch = 2582,		//(0,25) Label: '&Automatic' NOTE: Escher - used in a dialog
	msotcidDlgFillColorMore = 2583,		//(0,25) Label: '&More Colors...' NOTE: Escher
	msotcidDlgFillEffects = 2584,		//(0,25) Label: '&Fill Effects...' NOTE: Escher
	msotcidInsertTabControl = 2585,		//(33,28) Label: '&Tab Control' NOTE: Forms
	msotcidInsertFilenameExcel = 2586,		//(44,3) Label: '&File Name' NOTE: used in header/footer dialog
	msotcidInsertSheetName = 2587,		//(44,4) Label: '&Sheet Name' NOTE: used in header/footer dialog
	msotcidToggleFill = 2588,		//(43,29) Label: '&Toggle Fill On/Off' NOTE: Escher
	msotcidToggleLine = 2589,		//(36,7) Label: '&Toggle Line On/Off' NOTE: Escher
	msotcidRevisionsResolveConflicts = 2590,		//(0,25) Label: '&Resolve Conflicts...'
	msotcidTabControlNewPage = 2591,		//(44,5) Label: 'Insert Pa&ge' NOTE: Forms
	msotcidTabControlDeletePage = 2592,		//(44,6) Label: '&Delete Page' NOTE: Forms
	msotcidTabControlRenamePage = 2593,		//(44,7) Label: '&Rename...' NOTE: Forms
	msotcidTabControlMovePage = 2594,		//(44,8) Label: '&Move...' NOTE: Forms
	msotcidTabControlImportPage = 2595,		//(44,9) Label: '&Import Page...' NOTE: Forms
	msotcidTabControlExportPage = 2596,		//(44,10) Label: '&Export Page...' NOTE: Forms
	msotcidExitDesignMode = 2597,		//(9,11) Label: '&Exit Design Mode' NOTE: VBE - toggle text for msotcidToggleDesignMode
	msotcidOfficeLinksSplitMenu = 2598,		//(0,25) Label: 'Office &Links' NOTE: Access - goes with msotbidOfficeLinksSplitMenu
	msotcidNewDatabaseObjectSplitMenu = 2599,		//(0,11) Label: '&New Object' NOTE: Access - goes with msotbidNewDatabaseObjectMenu, also cf. msotcidNewMenu which is used for the same thing on the File menu
	msotcidTopJustify = 2600,		//(25,20) Label: '&Align Top' NOTE: Word
	msotcidBottomJustify = 2601,		//(25,21) Label: '&Align Bottom' NOTE: Word
	msotcidCenteredVertical = 2602,		//(25,22) Label: '&Center' NOTE: Word
	msotcidFullJustifyVertical = 2603,		//(44,18) Label: '&Justify' NOTE: Word
	msotcidPreviousRevision = 2604,		//(44,22) Label: 'Pre&vious Change' NOTE: Word
	msotcidNextRevision = 2605,		//(44,23) Label: '&Next Change' NOTE: Word
	msotcidGoToThisDay = 2606,		//(0,25) Label: 'Go to This &Day' NOTE: Ren
	msotcidFindMessagesFromSender = 2607,		//(0,25) Label: '&Messages from Sender...' NOTE: Ren
	msotcidNewRecurringAppointment = 2608,		//(38,3) Label: 'New Recurring &Appointment' NOTE: Ren
	msotcidNewRecurringEvent = 2609,		//(0,25) Label: 'New Recurring E&vent' NOTE: Ren
	msotcidNewRecurringMeeting = 2610,		//(0,25) Label: 'New Re&curring Meeting' NOTE: Ren
	msotcidFontColorNoPreview = 2611,		//(2,19) Label: '&Font Color' NOTE: Ren - can't use msotcidFontColor because of the preview area
	msotcidSave_RenAlternateString = 2612,		//(1,0) Label: 'Sav&e' NOTE: Ren - next time they should use the standard msotcidSave and override the string
	msotcidDesignOutlookForm = 2613,		//(0,25) Label: 'Desi&gn Outlook Form' NOTE: Ren
	msotcidNextItemSplitMenu = 2614,		//(17,8) Label: 'Next &Item' NOTE: Ren
	msotcidPreviousItemSplitMenu = 2615,		//(55,10) Label: 'Previous &Item' NOTE: Ren
	msotcidDialSplitMenu = 2616,		//(62,23) Label: '&Dial' NOTE: Ren
	msotcidSendDefault = 2617,		//(61,12) Label: '&Send' NOTE: Ren
	msotcidMessageProperties = 2618,		//(5,13) Label: '&Properties' NOTE: WordMail
	msotcidInsertPictureFromFile = 2619,		//(2,16) Label: '&From File...' NOTE: Escher - on the Insert/Picture cascade
	msotcidFormatDrawingObject2 = 2620,		//(68,21) Label: 'Format Aut&oShape...' NOTE: Escher - alternate text for use on context menus
	msotcidFormatPicture2 = 2621,		//(68,21) Label: 'Format P&icture...' NOTE: Escher - alternate text for use on context menus
	msotcidBorderWidthDropdown = 2622,		//(0,25) Label: '&Border Width' NOTE: Word
	msotcidAddInList = 2623,		//(0,25) Label: '&Add-In name goes here' NOTE: Access, maybe others - use once for each addin that appears in the menu
	msotcidFormatObject2 = 2624,		//(68,21) Label: '&Format Object...' NOTE: Escher - cf. FormatObject, different text for use on shortcut menus
	msotcidColumnsDropdown = 2625,		//(0,25) Label: '&Columns' NOTE: cf. msotcidColumns
	msotcidShowTableGridlines = 2626,		//(16,27) Label: 'Show &Gridlines' NOTE: Word - toggles with msotcidHideTableGridlines
	msotcidHideTableGridlines = 2627,		//(16,27) Label: 'Hide &Gridlines' NOTE: Word
	msotcidTableBorderColorSplitDropdown = 2628,		//(6,24) Label: '&Border Color' NOTE: Word
	msotcidAnnotTBLabel = 2629,		//(0,25) Label: 'Comments F&rom:' NOTE: Word - label used in comment pane
	msotcidShowAutoShapesAndDrawingBars = 2630,		//(23,8) Label: '&AutoShapes' NOTE: Escher
	msotcidLineToolsButtonMenu = 2631,		//(44,27) Label: '&Lines' NOTE: Escher - cascade menu of line tools
	msotcidShapeToolsButtonMenu = 2632,		//(3,19) Label: '&Basic Shapes' NOTE: Escher - cascade menu for shape tools
	msotcidConnectorToolsButtonmenu = 2633,		//(44,29) Label: 'Co&nnectors' NOTE: Escher - cascade of connector tools
	msotcidShapeSun = 2634,		//(45,0) Label: '&Sun' NOTE: Escher
	msotcidShapeMoon = 2635,		//(45,1) Label: '&Moon' NOTE: Escher
	msotcidShapeBracketPair = 2636,		//(45,2) Label: '&Double Bracket' NOTE: Escher
	msotcidShapeBracePair = 2637,		//(45,3) Label: '&Double Brace' NOTE: Escher
	msotcidShapeSeal4 = 2638,		//(45,4) Label: '&4-Point Star' NOTE: Escher
	msotcidShapeDoubleWave = 2639,		//(45,5) Label: '&Double Wave' NOTE: Escher
	msotcidStraightArrowConnector = 2640,		//(45,6) Label: '&Straight Arrow Connector' NOTE: Escher
	msotcidStraightDoubleArrowConnector = 2641,		//(45,7) Label: '&Straight Double-Arrow Connector' NOTE: Escher
	msotcidAngledArrowConnector = 2642,		//(45,8) Label: '&Elbow Arrow Connector' NOTE: Escher
	msotcidAngledDoubleArrowConnector = 2643,		//(45,9) Label: '&Elbow Double-Arrow Connector' NOTE: Escher
	msotcidCurvedArrowConnector = 2644,		//(45,10) Label: '&Curved Arrow Connector' NOTE: Escher
	msotcidCurvedDoubleArrowConnector = 2645,		//(45,11) Label: '&Curved Double-Arrow Connector' NOTE: Escher
	msotcidSourceSafeAddObjects = 2646,		//(45,12) Label: '&Add Objects to SourceSafe...' NOTE: SourceSafe - used by Access
	msotcidSourceSafeGetLatestVersion = 2647,		//(45,13) Label: '&Get Latest Version...' NOTE: SourceSafe
	msotcidSourceSafeCheckOut = 2648,		//(45,14) Label: 'Check &Out...' NOTE: SourceSafe
	msotcidSourceSafeCheckIn = 2649,		//(45,15) Label: 'Check &In...' NOTE: SourceSafe
	msotcidSourceSafeUndoCheckOut = 2650,		//(45,16) Label: '&Undo Check Out...' NOTE: SourceSafe
	msotcidSourceSafeShareObjects = 2651,		//(45,17) Label: '&Share Objects...' NOTE: SourceSafe
	msotcidSourceSafeShowDifferences = 2652,		//(45,18) Label: 'Show &Differences...' NOTE: SourceSafe
	msotcidSourceSafeShowHistory = 2653,		//(45,19) Label: 'Show &History...' NOTE: SourceSafe
	msotcidSourceSafeRun = 2654,		//(45,20) Label: '&Run SourceSafe...' NOTE: SourceSafe
	msotcidSourceSafeProperties = 2655,		//(0,25) Label: 'SourceSafe &Properties...' NOTE: SourceSafe
	msotcidSourceSafeCreateDatabaseFromProject = 2656,		//(0,25) Label: '&Create Database from SourceSafe Project...' NOTE: SourceSafe
	msotcidSourceSafeAddDatabase = 2657,		//(0,25) Label: '&Add Database to SourceSafe...' NOTE: SourceSafe
	msotcidSourceSafeOptions = 2658,		//(0,25) Label: 'Op&tions...' NOTE: SourceSafe
	msotcidSourceSafeRefreshObjectStatus = 2659,		//(0,25) Label: 'Re&fresh Object Status' NOTE: SourceSafe
	msotcidAccessPublishToWeb = 2660,		//(0,25) Label: '&Publish to the Web...' NOTE: Access
	msotcidAccessSaveToHTML = 2661,		//(0,25) Label: '&Save to HTML' NOTE: Access
	msotcidAccessSavetoIDC_HTX = 2662,		//(0,25) Label: 'Save to &IDC/HTX' NOTE: Access
	msotcidAccessWebPublishDefaults = 2663,		//(0,25) Label: 'Publish &Defaults...' NOTE: Access
	msotcidWebOpenHyperlink = 2664,		//(0,25) Label: '&Open Hyperlink' NOTE: opens selected link
	msotcidEnterEditMode = 2665,		//(0,25) Label: '&Edit Mode' NOTE: Access
	msotcidAnalysisSplitMenu = 2666,		//(0,25) Label: '&Analyze' NOTE: Access
	msotcidSeparatorBeforeControl = 2667,		//(0,25) Label: 'Begin a &Group' NOTE: office internal use only
	msotcidChartFillEffects = 2668,		//(0,25) Label: '&Fill Effects...' NOTE: Graph
	msotcidSourceSafeQuickGet = 2669,		//(45,13) Label: '&Get Latest Version' NOTE: SourceSafe - uses defaults
	msotcidSourceSafeQuickCheckout = 2670,		//(45,14) Label: 'Check &Out' NOTE: SourceSafe - uses defaults
	msotcidSourceSafeQuickUndoCheckOut = 2671,		//(45,16) Label: 'Undo C&heck Out' NOTE: SourceSafe - uses defaults
	msotcidCheckmarkUnchecked = 2672,		//(45,24) Label: '&Reserved' NOTE: office internal use only
	msotcidCmdbarPropControlParameter = 2673,		//(0,25) Label: '&Parameter' NOTE: Access cmdbar property sheet
	msotcidCmdbarPropControlTag = 2674,		//(0,25) Label: '&Tag' NOTE: Access cmdbar property sheet
	msotcidCmdbarPropControlShowLabel = 2675,		//(0,25) Label: '&Show Label' NOTE: Access cmdbar property sheet
	msotcidInsertVBEObjectSplitMenu = 2676,		//(0,25) Label: '&Insert Object' NOTE: VBE - allows insertion of dialogs, modules, etc.
	msotcidChangeToShapeSun = 2677,		//(45,0) Label: '&Change Shape to Sun' NOTE: Escher
	msotcidChangeToShapeMoon = 2678,		//(45,1) Label: '&Change Shape to Moon' NOTE: Escher
	msotcidChangeToShapeBracketPair = 2679,		//(45,2) Label: '&Change Shape to Double Bracket' NOTE: Escher
	msotcidChateToShapeBracePair = 2680,		//(45,3) Label: '&Change Shape to Double Brace' NOTE: Escher
	msotcidChangeToShapeSeal4 = 2681,		//(45,4) Label: '&Change Shape to 4-Point Star' NOTE: Escher
	msotcidChangeToShapeDoubleWave = 2682,		//(45,5) Label: '&Change Shape to Double Wave' NOTE: Escher
	msotcidFindItems = 2683,		//(23,14) Label: '&Find Items...' NOTE: Ren
	msotcidFindRelatedMessages = 2684,		//(0,25) Label: '&Related Messages...' NOTE: Ren
	msotcidInsertRecurringTask = 2685,		//(18,23) Label: '&Recurring Task...' NOTE: Project
	msotcidSetGridSize = 2686,		//(0,25) Label: '&Set Grid Size...' NOTE: Ren (PGM-may be obsolete with Grid2??)
	msotcidNewPostInThisFolder3 = 2687,		//(37,22) Label: '&Post in This Folder' NOTE: Ren
	msotcidPasteShortcut = 2688,		//(0,25) Label: 'Paste &Shortcut' NOTE: Ren
	msotcidObjectBrowserShowHiddenMembers = 2689,		//(0,25) Label: 'Show &Hidden Members' NOTE: Access
	msotcidObjectBrowserViewDefinition = 2690,		//(0,25) Label: 'View &Definition' NOTE: Access
	msotcidSplitNode = 2691,		//(0,25) Label: 'Spli&t Point' NOTE: Escher
	msotcidDeleteSegment = 2692,		//(0,25) Label: 'De&lete Segment' NOTE: Escher
	msotcidOpenCurve = 2693,		//(0,25) Label: 'Open &Path' NOTE: Escher
	msotcidApplyDefault = 2694,		//(28,22) Label: 'Apply &Default' NOTE: Access - apply default style/format
	msotcidPackAndGo = 2695,		//(0,25) Label: 'Pac&k and Go...' NOTE: PPT
	msotcidDeleteSlide = 2696,		//(0,25) Label: '&Delete Slide' NOTE: PPT
	msotcidViewTitleMaster = 2697,		//(0,25) Label: '&Title Master' NOTE: PPT
	msotcidViewHandoutMaster = 2698,		//(0,25) Label: 'Han&dout Master' NOTE: PPT
	msotcidViewNotesMaster = 2699,		//(0,25) Label: '&Notes Master' NOTE: PPT
	msotcidSendToWord = 2700,		//(0,25) Label: 'Microsoft &Word' NOTE: PPT
	msotcidMicrosoftHomePage = 2701,		//(0,25) Label: '&Microsoft Corporation Home Page' NOTE: all apps, on Help / Web cascade
	msotcidMicrosoftNetworkHomePage = 2702,		//(0,25) Label: 'Microsoft &Network Home Page' NOTE: all apps
	msotcidInsertSlidesFromFile = 2703,		//(0,25) Label: 'Slides from &Files...' NOTE: PPT
	msotcidInsertSlidesFromOutline = 2704,		//(0,25) Label: 'Slides from Out&line...' NOTE: PPT
	msotcidInsertMovieFromGallery = 2705,		//(47,18) Label: '&Movie from Organizer...' NOTE: PPT
	msotcidInsertMovieFromFile = 2706,		//(0,25) Label: 'Movie from &File...' NOTE: PPT
	msotcidInsertSoundFromGallery = 2707,		//(48,3) Label: '&Sound from Clip Organizer...' NOTE: PPT
	msotcidInsertSoundFromFile = 2708,		//(0,25) Label: 'Sou&nd from File...' NOTE: PPT
	msotcidPlayCDAudioTrack = 2709,		//(0,25) Label: 'Play &CD Audio Track...' NOTE: PPT
	msotcidFormatLineSpacing = 2710,		//(6,10) Label: 'Line &Spacing...' NOTE: PPT
	msotcidReplaceFonts = 2711,		//(0,25) Label: '&Replace Fonts' NOTE: PPT
	msotcidNextSlide = 2712,		//(0,25) Label: '&Next Slide' NOTE: PPT
	msotcidPreviousSlide = 2713,		//(0,25) Label: '&Previous Slide' NOTE: PPT
	msotcidFirstSlide = 2714,		//(0,25) Label: '&First Slide' NOTE: PPT
	msotcidLastSlide = 2715,		//(0,25) Label: '&Last Slide' NOTE: PPT
	msotcidToggleCase = 2716,		//(0,25) Label: '&Toggle Case' NOTE: PPT
	msotcidSlideColorScheme = 2717,		//(0,25) Label: 'Slide &Color Scheme...' NOTE: PPT
	msotcidStyleChecker = 2718,		//(0,25) Label: 'St&yle Checker...' NOTE: PPT
	msotcidPresentationConference = 2719,		//(0,25) Label: '&Presentation Conference...' NOTE: PPT
	msotcidMeetingMinder = 2720,		//(0,25) Label: 'Mee&ting Minder...' NOTE: PPT
	msotcidSpeakerNotes = 2721,		//(46,19) Label: 'Spea&ker Notes' NOTE: PPT
	msotcidFormatAlignment = 2722,		//(0,25) Label: '&Alignment' NOTE: PPT
	msotcidSlideShowPenWhite = 2723,		//(0,25) Label: '&White' NOTE: PPT
	msotcidSlideShowPenRed = 2724,		//(0,25) Label: '&Red' NOTE: PPT
	msotcidSlideShowPenGreen = 2725,		//(0,25) Label: '&Green' NOTE: PPT
	msotcidSlideShowPenBlue = 2726,		//(0,25) Label: '&Blue' NOTE: PPT
	msotcidSlideShowPenCyan = 2727,		//(0,25) Label: '&Cyan' NOTE: PPT
	msotcidSlideShowPenMagenta = 2728,		//(0,25) Label: '&Magenta' NOTE: PPT
	msotcidSlideShowPenYellow = 2729,		//(0,25) Label: '&Yellow' NOTE: PPT
	msotcidSlideShowPenGray = 2730,		//(0,25) Label: '&Gray' NOTE: PPT
	msotcidSlideShowPenReset = 2731,		//(0,25) Label: '&Reset' NOTE: PPT
	msotcidEndSlideShow = 2732,		//(0,25) Label: '&End Show' NOTE: PPT
	msotcidBWAutomatic = 2733,		//(0,25) Label: 'B & W Automatic' NOTE: PPT
	msotcidBWBlack = 2734,		//(0,25) Label: 'B & W ' NOTE: PPT
	msotcidBWBlackWithGrayscaleFill = 2735,		//(0,25) Label: 'B & W Black with Grayscale Fill' NOTE: PPT
	msotcidBWBlackWithWhiteFill = 2736,		//(0,25) Label: 'B & W Black with White Fill' NOTE: PPT
	msotcidBWDontShow = 2737,		//(0,25) Label: 'B & W Don't Show' NOTE: PPT
	msotcidBWGrayWithWhiteFill = 2738,		//(0,25) Label: 'B & W Gray with White Fill' NOTE: PPT
	msotcidBWGrayscale = 2739,		//(0,25) Label: 'B & W Grayscale' NOTE: PPT
	msotcidBWInverseGrayscale = 2740,		//(0,25) Label: 'B & W Inverse Grayscale' NOTE: PPT
	msotcidBWWhite = 2741,		//(0,25) Label: 'B & W White' NOTE: PPT
	msotcidBWLightGrayscale = 2742,		//(0,25) Label: 'B & W Light Grayscale' NOTE: PPT
	msotcidRecordNarration = 2743,		//(0,25) Label: 'Record &Narration' NOTE: PPT
	msotcidSetUpShow = 2744,		//(0,25) Label: '&Set Up Show...' NOTE: PPT
	msotcidViewTwoScreens = 2745,		//(0,25) Label: 'View T&wo Screens...' NOTE: PPT
	msotcidDummyRolandrAnimationPreview = 2746,		//(0,25) Label: '' NOTE: Formerly AnimationPreview
	msotcidDummy2747 = 2747,		//(0,25) Label: '&Formerly AnimationOff' NOTE: PPT
	msotcidAnimationFlashOnce = 2748,		//(0,25) Label: 'Flas&h Once' NOTE: PPT
	msotcidDummy2749 = 2749,		//(0,25) Label: '&Formerly AnimationWipeUp' NOTE: PPT
	msotcidDummy2750 = 2750,		//(0,25) Label: '&Formerly AnimationWipRight' NOTE: PPT
	msotcidDummy2751 = 2751,		//(0,25) Label: '&Formerly AnimationDissolve' NOTE: PPT
	msotcidDummy2752 = 2752,		//(0,25) Label: '&Formerly AnimationSplitVerticalOut' NOTE: PPT
	msotcidAnimationFlyTextFromBottom = 2753,		//(0,25) Label: '&Fly From Bottom' NOTE: PPT
	msotcidAnimationFlyTextFromLeft = 2754,		//(0,25) Label: '&Fly From Left' NOTE: PPT
	msotcidAnimationAppear = 2755,		//(0,25) Label: '&Appear' NOTE: PPT
	msotcidDummy2756 = 2756,		//(0,25) Label: '&Formerly AnimationNone' NOTE: PPT
	msotcidAnimationOther = 2757,		//(0,25) Label: '&Other Effect' NOTE: PPT
	msotcidDummy2758 = 2758,		//(0,25) Label: '&Formerly AnimationFlyTextFromTop' NOTE: PPT
	msotcidDummy2759 = 2759,		//(0,25) Label: '&Formerly AnimationOrder' NOTE: PPT
	msotcidGoToMasterPage = 2760,		//(0,25) Label: '&Go To Master Page' NOTE: PPT
	msotcidSummarizeSlide = 2761,		//(47,16) Label: '&Summarize Slide' NOTE: PPT
	msotcidActivePageTabOrder = 2762,		//(0,25) Label: 'Active Page Tab Ord&er' NOTE: Access
	msotcidPageOrder = 2763,		//(0,25) Label: 'Page &Order...' NOTE: Access
	msotcidShowColumns = 2764,		//(0,25) Label: '&Unhide Columns...' NOTE: Access
	msotcidXLAuditNoCirc = 2765,		//(12,8) Label: '.' NOTE: Excel - image only - used in auditing dialog
	msotcidTextWrapTopBottom = 2766,		//(27,28) Label: 'T&op and Bottom' NOTE: Escher
	msotcidTextWrapThrough = 2767,		//(13,13) Label: 'T&hrough' NOTE: Escher
	msotcidToolbarDroppedControlIndicator = 2768,		//(21,5) Label: '&Toolbar too small to show all tools' NOTE: office internal use only - the indicator that appears on right of bars with dropped controls
	msotcidCloseFilter = 2769,		//(0,25) Label: '&Close' NOTE: Access
	msotcidPropertySheet = 2770,		//(5,13) Label: '&Property Sheet' NOTE: Access
	msotcidTableProperties = 2771,		//(5,13) Label: '&Properties' NOTE: Access
	msotcidObjectDefinition = 2772,		//(0,25) Label: '&Object Definition...' NOTE: Access
	msotcidCmdbarPropertySheet = 2773,		//(5,13) Label: '&Properties' NOTE: Access - brings up their cmdbar property sheet in customize
	msotcidSendWithShortcut = 2774,		//(0,25) Label: '&Send with Shortcut' NOTE: Ren
	msotcidSendWithAttachment = 2775,		//(0,25) Label: '&Send with Attachment' NOTE: Ren
	msotcidClearMessageFlag = 2776,		//(0,25) Label: 'Clea&r Message Flag' NOTE: Ren
	msotcidNewMeetingRequest = 2777,		//(67,29) Label: 'New Meeting Re&quest' NOTE: Ren - cf. msotcidMeetingRequest
	msotcidMoveToFolderButtonMenu = 2778,		//(6,2) Label: '&Move to Folder' NOTE: Ren - cf. msotcidMoveToFolder
	msotcidOpenOutlookItem = 2779,		//(0,25) Label: '&Open' NOTE: Ren
	msotcidSwitcher_Record_StopRecorder = 2780,		//(48,13) Label: '&Record Macro / Stop Recorder' NOTE: Word
	msotcidAutoManager = 2781,		//(0,25) Label: '&AutoManager...' NOTE: Word
	msotcidChooseAutoText = 2782,		//(0,25) Label: '&Choose AutoText' NOTE: Word
	msotcidSwitcher_ConvertToEndnote_ConvertToFootnote = 2783,		//(48,13) Label: '&Convert Endnote/Footnote' NOTE: Word
	msotcidConvertToEndnote = 2784,		//(0,25) Label: 'Con&vert to Endnote' NOTE: Word
	msotcidConvertToFootnote = 2785,		//(0,25) Label: 'Con&vert to Footnote' NOTE: Word
	msotcidResetFootnoteSeparator = 2786,		//(0,25) Label: '&Reset' NOTE: Word
	msotcidPasteAsHyperlink = 2787,		//(0,25) Label: 'Paste as &Hyperlink' NOTE: Web
	msotcidToolsOptionsProofing = 2788,		//(0,25) Label: '&Options...' NOTE: Word
	msotcidToolsOptionsGrammar = 2789,		//(0,25) Label: '&Grammar Options' NOTE: Word
	msotcidIndentFirstCharacter = 2790,		//(0,25) Label: '&Indent First Character' NOTE: Word
	msotcidUnindentFirstCharacter = 2791,		//(0,25) Label: '&Unindent First Character' NOTE: Word
	msotcidDistributeParagraph = 2792,		//(3,0) Label: '&Distributed' NOTE: Word - cf. DistributeParagraphVerticalTB and VerticalBT icons
	msotcidChangeByte = 2793,		//(0,25) Label: '&Change Byte' NOTE: Word
	msotcidChangeKana = 2794,		//(0,25) Label: '&Change Kana' NOTE: Word
	msotcidFixSpellingIgnore = 2795,		//(0,25) Label: '&Ignore' NOTE: Word - ignore this spelling error
	msotcidFixSpellingIgnoreAll = 2796,		//(0,25) Label: '&Ignore All' NOTE: Word
	msotcidFixSpellingAdd = 2797,		//(0,25) Label: '&Add to Dictionary' NOTE: Word
	msotcidFixSpellingDelete = 2798,		//(0,25) Label: '&Delete Repeated Word' NOTE: Word
	msotcidNoSpellingSuggestions = 2799,		//(0,25) Label: '&(no spelling suggestions)' NOTE: Word
	msotcidHyphenation = 2800,		//(0,25) Label: '&Hyphenation...' NOTE: Word
	msotcidSwitcher_DistributeRow_DistributeColumn = 2801,		//(8,24) Label: '&Distribute Rows/Columns' NOTE: Word
	msotcidSwitcher_MergeCells_SplitCells = 2802,		//(39,11) Label: 'Mer&ge/Split Cells' NOTE: Word
	msotcidOutlineFont = 2803,		//(0,25) Label: '&Outline' NOTE: Word
	msotcidShadowFont = 2804,		//(0,25) Label: '&Shadow' NOTE: Word
	msotcidDotAccent = 2805,		//(30,10) Label: '&Dot Accent' NOTE: Word
	msotcidCommaAccent = 2806,		//(32,3) Label: '&Comma Accent' NOTE: Word
	msotcidToolsOptionsFuzzy = 2807,		//(0,25) Label: '&Tools Options Fuzzy' NOTE: Word
	msotcidToolsOptionsTypography = 2808,		//(0,25) Label: '&Typography Options' NOTE: Word
	msotcidToolsOptionsHHC = 2809,		//(0,25) Label: '&Tools Options HHC' NOTE: Word
	msotcidExtendedFormattingToolbar = 2810,		//(28,7) Label: '&Extended Formatting Toolbar' NOTE: Word
	msotcidServerZoom = 2811,		//(0,25) Label: '&Server Zoom' NOTE: Word
	msotcidFormatList = 2812,		//(0,25) Label: '&Format List' NOTE: Word
	msotcidRubyKumimoji = 2813,		//(0,25) Label: '&Ruby Kumimoji' NOTE: Word
	msotcidIchitaroHelp = 2814,		//(0,25) Label: '&Ichitaro Help' NOTE: Word - FE competitor
	msotcidToolsConsistency = 2815,		//(0,25) Label: 'Japanese Consistenc&y Checker...' NOTE: Word - FE: consistency checker
	msotcidSwitcher_ShowGridlines_HideGridlines = 2816,		//(16,27) Label: 'Grid&lines' NOTE: Word
	msotcidAutoSummaryResummarize = 2817,		//(68,23) Label: '&Resummarize' NOTE: Word
	msotcidAutoSummaryUpdateProperties = 2818,		//(0,25) Label: '&Update Properties' NOTE: Word
	msotcidAutoSummaryViewByHiding = 2819,		//(0,25) Label: '&View Summary by Hiding' NOTE: Word
	msotcidDeleteWord = 2820,		//(0,25) Label: '&Delete Word' NOTE: Word
	msotcidDeleteBackWord = 2821,		//(0,25) Label: '&Delete Back Word' NOTE: Word
	msotcidResetCharacterFormatting = 2822,		//(0,25) Label: '&Reset Character Formatting' NOTE: Word
	msotcidApplyFontName = 2823,		//(4,25) Label: '&Font Name' NOTE: Word
	msotcidEditGlossary = 2824,		//(0,25) Label: '&Edit Glossary' NOTE: Word
	msotcidViewFooter = 2825,		//(0,25) Label: '&View Footer' NOTE: Word
	msotcidHeadingNumbers = 2826,		//(0,25) Label: '&Heading Numbers' NOTE: Word
	msotcidSetTransparentColor = 2827,		//(24,0) Label: '&Set Transparent Color' NOTE: Escher - sets transparent color of bitmap, for Web
	msotcidNameOfCommandKey = 2828,		//(0,25) Label: '&Cmd' NOTE: office use only
	msotcidNameOfControlKey = 2829,		//(0,25) Label: '&Ctrl' NOTE: office use only
	msotcidNameOfShiftKey = 2830,		//(0,25) Label: '&Shift' NOTE: office use only
	msotcidNameOfOptionKey = 2831,		//(0,25) Label: '&Opt' NOTE: office use only
	msotcidToolbarDroppedControlIndicatorVertical = 2832,		//(20,10) Label: '&Toolbar too small to show all tools' NOTE: office use only
	msotcidCustomizeContextDD = 2833,		//(0,25) Label: '&Context' NOTE: office internal use only
	msotcidCustomizeAttachBtn = 2834,		//(0,25) Label: '&Attach' NOTE: office internal use only
	msotcidCustomizeAllocCmdsDD = 2835,		//(0,25) Label: '&Allocated Commands' NOTE: office internal use only
	msotcidCustomizeCmdsExtraEdit = 2836,		//(0,25) Label: '&Parameters' NOTE: office internal use only
	msotcidInsertTableExpandingGrid = 2837,		//(0,25) Label: '&Insert Table' NOTE: Word - cf. msotcidTable which should be used for the Insert menu item
	msotcidPages2x1 = 2838,		//(0,25) Label: '&2x1' NOTE: Access
	msotcidPages3x1 = 2839,		//(0,25) Label: '&3x1' NOTE: Access
	msotcidPages4x1 = 2840,		//(0,25) Label: '&4x1' NOTE: Access
	msotcidPages1x2 = 2841,		//(0,25) Label: '&1x2' NOTE: Access
	msotcidPages2x2 = 2842,		//(0,25) Label: '&2x2' NOTE: Access
	msotcidPages3x2 = 2843,		//(0,25) Label: '&3x2' NOTE: Access
	msotcidPages4x2 = 2844,		//(0,25) Label: '&4x2' NOTE: Access
	msotcidPages1x3 = 2845,		//(0,25) Label: '&1x3' NOTE: Access
	msotcidPages2x3 = 2846,		//(0,25) Label: '&2x3' NOTE: Access
	msotcidPages3x3 = 2847,		//(0,25) Label: '&3x3' NOTE: Access
	msotcidPages4x3 = 2848,		//(0,25) Label: '&4x3' NOTE: Access
	msotcidPages1x4 = 2849,		//(0,25) Label: '&1x4' NOTE: Access
	msotcidPages2x4 = 2850,		//(0,25) Label: '&2x4' NOTE: Access
	msotcidPages3x4 = 2851,		//(0,25) Label: '&3x4' NOTE: Access
	msotcidPages4x4 = 2852,		//(0,25) Label: '&4x4' NOTE: Access
	msotcidPages1x5 = 2853,		//(0,25) Label: '&1x5' NOTE: Access
	msotcidPages2x5 = 2854,		//(0,25) Label: '&2x5' NOTE: Access
	msotcidPages3x5 = 2855,		//(0,25) Label: '&3x5' NOTE: Access
	msotcidPages4x5 = 2856,		//(0,25) Label: '&4x5' NOTE: Access
	msotcidFormatBackgroundMoreColors = 2857,		//(0,25) Label: '&More Colors...' NOTE: Word - on Format Background cascade
	msotcidFormatBackgroundFillEffects = 2858,		//(0,25) Label: '&Fill Effects...' NOTE: Word - on Format Background Cascade
	msotcidFindNextWordUnderCursor = 2859,		//(0,25) Label: '&Find Next Word Under Cursor' NOTE: Access
	msotcidFindPreviousWordUnderCursor = 2860,		//(0,25) Label: '&Find Previous Word Under Cursor' NOTE: Access
	msotcidGoToRecord = 2861,		//(0,25) Label: '&Go To Record' NOTE: Access
	msotcidRequery = 2862,		//(0,25) Label: 'Req&uery' NOTE: Access
	msotcidFilterFor = 2863,		//(0,25) Label: '&Filter For:' NOTE: Access
	msotcidThickTopBorder = 2864,		//(24,5) Label: '&Thick Top Border'
	msotcidThickLeftBorder = 2865,		//(24,6) Label: '&Thick Left Border'
	msotcidThickRightBorder = 2866,		//(24,7) Label: '&Thick Right Border'
	msotcidWordTopBorder = 2867,		//(36,23) Label: '&Top Border' NOTE: Word
	msotcidWordBottomBorder = 2868,		//(6,21) Label: '&Bottom Border' NOTE: Word
	msotcidWordLeftBorder = 2869,		//(36,24) Label: 'Left Border' NOTE: Word
	msotcidWordRightBorder = 2870,		//(36,25) Label: '&Right Border' NOTE: Word
	msotcidParameterQueryType = 2871,		//(18,6) Label: '&Parameter Query' NOTE: Access
	msotcidTextFlowHorizontal = 2872,		//(17,22) Label: '&Change Text Direction' NOTE: FE - normal horizontal text flow
	msotcidTextFlowVerticalTBA = 2873,		//(7,7) Label: '&Change Text Direction' NOTE: FE - top-to-bottom, non-rotated letters
	msotcidTextFlowVerticalBT = 2874,		//(24,10) Label: '&Change Text Direction' NOTE: FE - bottom-to-top text flow
	msotcidTextFlowVerticalTBN = 2875,		//(24,11) Label: '&Change Text Direction' NOTE: FE - top-to-bottom, rotated letters
	msotcidRunAccessMacro = 2876,		//(11,12) Label: 'Run &Macro' NOTE: Access
	msotcidExitTextEditMode = 2877,		//(0,25) Label: 'Exit Edit Te&xt' NOTE: Escher
	msotcidCustomShows = 2878,		//(46,20) Label: 'Custom Sho&ws...' NOTE: PPT
	msotcidFitWindowToPage = 2879,		//(0,25) Label: '&Fit to Page' NOTE: PPT
	msotcidPresetAnimation = 2880,		//(0,25) Label: '&Preset Animation' NOTE: PPT
	msotcidRecordSound = 2881,		//(0,25) Label: '&Record Sound' NOTE: PPT
	msotcidViewShow = 2882,		//(15,0) Label: '&View Show' NOTE: PPT
	msotcidApplyStyle = 2883,		//(0,25) Label: '&Apply Style' NOTE: PPT
	msotcidContentNavigator = 2884,		//(0,25) Label: 'Content &Navigator...' NOTE: PPT
	msotcidTogglePeriods = 2885,		//(0,25) Label: '&Periods' NOTE: PPT
	msotcidShowTitles = 2886,		//(0,25) Label: '&Show Titles' NOTE: PPT
	msotcidSlideMeter = 2887,		//(0,25) Label: '&Slide Meter...' NOTE: PPT
	msotcidSlideNavigator = 2888,		//(0,25) Label: '&Slide Navigator...' NOTE: PPT
	msotcidBuildSlideText = 2889,		//(0,25) Label: '&Build Slide Text' NOTE: PPT
	msotcidDuplicateSlide = 2890,		//(0,25) Label: '&Duplicate Slide' NOTE: PPT
	msotcidSendToGenigraphics = 2891,		//(62,21) Label: '&Genigraphics...' NOTE: PPT
	msotcidInteractiveSettings = 2892,		//(48,22) Label: '&Action Settings...' NOTE: PPT
	msotcidAutoClipArt = 2893,		//(0,25) Label: 'A&utoClipArt...' NOTE: PPT
	msotcidAnimationEffects = 2894,		//(61,28) Label: 'Animation S&chemes...' NOTE: PPT
	msotcidAutoQuote = 2895,		//(36,21) Label: 'Auto&Quote...' NOTE: PPT
	msotcidCustomAnimation = 2896,		//(48,24) Label: 'Custom &Animation' NOTE: PPT
	msotcidInsertInteractiveButton = 2897,		//(14,6) Label: 'Interactive &Button' NOTE: PPT
	msotcidMakeTopicSlide = 2898,		//(37,13) Label: 'Mak&e Topic Slide' NOTE: PPT
	msotcidSlideMiniature = 2899,		//(37,17) Label: 'Slide M&iniature' NOTE: PPT
	msotcidChangeBullet = 2900,		//(0,25) Label: '&Bullet' NOTE: PPT
	msotcidSlideShowPenErase = 2901,		//(0,25) Label: '&Erase Pen' NOTE: PPT
	msotcidMSWebNewsAbout = 2902,		//(0,25) Label: '&News about Microsoft <application>' NOTE: Microsoft on the Web submenu
	msotcidMSWebOnlineSupport = 2903,		//(0,25) Label: '&Online Support for Microsoft <application>' NOTE: Microsoft on the Web submenu
	msotcidSlideShowPenBlack = 2904,		//(0,25) Label: '&Black' NOTE: PPT
	msotcidSlideShowBlackScreen = 2905,		//(0,25) Label: '&Blank Screen' NOTE: PPT
	msotcidSlideShowArrowMode = 2906,		//(0,25) Label: '&Arrow' NOTE: PPT
	msotcidSlideShowPenMode = 2907,		//(0,25) Label: '&Pen' NOTE: PPT
	msotcidSlideShowPreviousSlide = 2908,		//(0,25) Label: '&Previous' NOTE: PPT - slide show popup; cf. msotcidPreviousSlide
	msotcidSlideShowNextSlide = 2909,		//(0,25) Label: '&Next' NOTE: PPT
	msotcidSlideShowPause = 2910,		//(0,25) Label: 'Pau&se' NOTE: PPT
	msotcidSlideShowGoToHiddenSlide = 2911,		//(0,25) Label: '&Hidden Slide' NOTE: PPT
	msotcidSlideShowHidePointerNow = 2912,		//(0,25) Label: '&Hide Now' NOTE: PPT
	msotcidSlideShowHidePointerAlways = 2913,		//(0,25) Label: '&Hide Always' NOTE: PPT
	msotcidPivotTableFormulaSolveOrder = 2914,		//(0,25) Label: '&Solve Order...' NOTE: Excel
	msotcidPivotTableReport = 2915,		//(14,26) Label: '&PivotTable and PivotChart Report...' NOTE: Excel
	msotcidSortDialogRen = 2916,		//(1,21) Label: 'So&rt...' NOTE: Ren - alternate string
	msotcidLineStyleSwatch = 2917,		//(0,25) Label: '&Line Style' NOTE: Escher
	msotcidMoreShapes5 = 2918,		//(44,1) Label: 'Act&ion Buttons' NOTE: Escher
	msotcidActionButtonBlank = 2919,		//(24,13) Label: '&Action Button: Custom' NOTE: Escher
	msotcidActionButtonHome = 2920,		//(24,4) Label: '&Action Button: Home' NOTE: Escher
	msotcidActionButtonHelp = 2921,		//(56,9) Label: '&Action Button: Help' NOTE: Escher
	msotcidActionButtonInformation = 2922,		//(39,15) Label: '&Action Button: Information' NOTE: Escher
	msotcidActionButtonBackPrevious = 2923,		//(39,17) Label: '&Action Button: Back or Previous' NOTE: Escher
	msotcidActionButtonForwardNext = 2924,		//(39,18) Label: '&Action Button: Forward or Next' NOTE: Escher
	msotcidActionButtonBeginning = 2925,		//(48,14) Label: '&Action Button: Beginning' NOTE: Escher
	msotcidActionButtonEnd = 2926,		//(10,9) Label: '&Action Button: End' NOTE: Escher
	msotcidActionButtonReturn = 2927,		//(43,20) Label: '&Action Button: Return' NOTE: Escher
	msotcidActionButtonDocument = 2928,		//(47,20) Label: '&Action Button: Document' NOTE: Escher
	msotcidActionButtonSound = 2929,		//(47,21) Label: '&Action Button: Sound' NOTE: Escher
	msotcidActionButtonMovie = 2930,		//(61,2) Label: '&Action Button: Movie' NOTE: Escher
	msotcidControlDefaults = 2931,		//(0,25) Label: 'Set &Control Defaults' NOTE: Access
	msotcidInsertOLEControl = 2932,		//(9,9) Label: 'ActiveX &Control' NOTE: Access
	msotcidRegisterOLEControls = 2933,		//(9,9) Label: '&ActiveX Controls' NOTE: Access
	msotcidToggleWebToolbar = 2934,		//(36,14) Label: '&Web Toolbar' NOTE: Web
	msotcidOLEUpdateNow = 2935,		//(0,25) Label: '&Update Now' NOTE: Access - used during in-place activation
	msotcidNewDatabase = 2936,		//(0,11) Label: '&New...' NOTE: Access
	msotcidOpenDatabase = 2937,		//(0,10) Label: '&Open...' NOTE: Access
	msotcidSaveAsExport = 2938,		//(0,25) Label: 'Save &As/Export...' NOTE: Access
	msotcidDatabaseProperties = 2939,		//(5,13) Label: 'Da&tabase Properties' NOTE: Access
	msotcidAccessDeleteColumns = 2940,		//(10,3) Label: 'Delete Colu&mn' NOTE: Access
	msotcidAccessSelectAll = 2941,		//(0,25) Label: 'Select &All' NOTE: Access - alternate string
	msotcidDDELinks = 2942,		//(0,25) Label: 'OLE/DDE Lin&ks' NOTE: Access
	msotcidTotals = 2943,		//(1,20) Label: 'Tota&ls' NOTE: Access
	msotcidObjectBrowserGoBack = 2944,		//(46,14) Label: 'Go &Back' NOTE: Access
	msotcidObjectBrowserGoForward = 2945,		//(46,15) Label: 'Go F&orward' NOTE: Access
	msotcidShowToolboxBar = 2946,		//(4,1) Label: '&Toolbox' NOTE: Access - different label than msotcidToolbox
	msotcidShadingColor = 2947,		//(2,17) Label: '&Shading Color' NOTE: Word - table toolbar
	msotcidConvertMacrosToVisualBasic = 2948,		//(0,25) Label: 'Convert Macros to Visual &Basic' NOTE: Access
	msotcidNewCustomMenuItem = 2949,		//(0,25) Label: '&Custom Menu Item' NOTE: Excel - used in customize
	msotcidNewCustomButton = 2950,		//(7,23) Label: '&Custom Button' NOTE: Excel - used in customize
	msotcidCloseFullScreenView = 2951,		//(0,25) Label: '&Close Full Screen' NOTE: used on full screen toolbar
	msotcidDesignView = 2952,		//(9,11) Label: '&Design View' NOTE: Access
	msotcidObjectBrowserSearchWholeWord = 2953,		//(0,25) Label: 'Find &Whole Word Only' NOTE: VB
	msotcidHideIconOnMenus = 2954,		//(0,25) Label: 'Text &Only (in Menus)' NOTE: office -- used by customize
	msotcidClearHyperlinks = 2955,		//(0,25) Label: '&Hyperlinks' NOTE: Excel - on Edit Clear submenu
	msotcidBreakLink = 2956,		//(0,25) Label: '&Break Link' NOTE: PPT
	msotcidChangeLink = 2957,		//(0,25) Label: '&Change Link' NOTE: PPT
	msotcidOpenLinkSource = 2958,		//(0,25) Label: '&Open Link Source' NOTE: PPT
	msotcidUpdateLinks = 2959,		//(0,25) Label: '&Update Links' NOTE: PPT
	msotcidColorsAndLines = 2960,		//(0,25) Label: 'Colors and Li&nes' NOTE: PPT
	msotcidExpandSlide = 2961,		//(46,18) Label: 'E&xpand Slide' NOTE: PPT
	msotcidLowerBaseline = 2962,		//(0,25) Label: '&Lower Baseline' NOTE: PPT
	msotcidRaiseBaseline = 2963,		//(0,25) Label: '&Raise Baseline' NOTE: PPT
	msotcidNewPresentationDialog = 2964,		//(0,25) Label: '&New Presentation Dialog' NOTE: PPT
	msotcidNormalCharacterFormatting = 2965,		//(0,25) Label: '&Normal' NOTE: PPT
	msotcidAttachToolbars = 2966,		//(0,25) Label: '&Attach Toolbars...' NOTE: PPT
	msotcidToolsProtection = 2967,		//(0,25) Label: '&Protection' NOTE: PPT
	msotcidInsertSoundObject = 2968,		//(34,29) Label: '&Insert Sound Object' NOTE: PPT
	msotcidSlideShowInAWindow = 2969,		//(47,7) Label: '&Slide Show in a Window' NOTE: PPT
	msotcidAlignFontHanging = 2970,		//(0,25) Label: '&Hanging' NOTE: PPT - FE
	msotcidAlignFontCenter = 2971,		//(0,25) Label: '&Center' NOTE: PPT - FE
	msotcidAlignFontRoman = 2972,		//(0,25) Label: '&Roman' NOTE: PPT - FE
	msotcidAlignFontUpholdFixed = 2973,		//(0,25) Label: '&Uphold Fixed' NOTE: PPT - FE
	msotcidSlideMiniaturePreviewColor = 2974,		//(0,25) Label: '&Color' NOTE: PPT
	msotcidSlideMiniaturePreviewBlackWhite = 2975,		//(0,25) Label: '&Black and White' NOTE: PPT
	msotcidKinsoku = 2976,		//(0,25) Label: '&Kinsoku...' NOTE: PPT - FE
	msotcidTeisai = 2977,		//(0,25) Label: '&Teisai...' NOTE: PPT - FE
	msotcidHangeulHanjarConversion = 2978,		//(0,25) Label: '&Hangul Hanja Conversion' NOTE: PPT - FE
	msotcidDlgBuildHideAfter = 2979,		//(0,25) Label: '&Hide After' NOTE: PPT - in build dialog
	msotcidDlgBuildHideAfterMouseClick = 2980,		//(0,25) Label: '&Hide After Mouse Click' NOTE: PPT - in build dialog
	msotcidDlgBuildDontDimAfter = 2981,		//(0,25) Label: '&Don't Dim After' NOTE: PPT - in build dialog
	msotcidFixSpellingSuggestionList = 2982,		//(0,25) Label: '&<suggested spelling>' NOTE: list of spelling suggestions - override string
	msotcidReturnToTaskList = 2983,		//(0,25) Label: 'Return to Tas&k List' NOTE: Ren
	msotcidAutoLayout = 2984,		//(0,25) Label: 'AutoLa&yout' NOTE: Ren
	msotcidMarkTaskComplete = 2985,		//(46,17) Label: '&Mark Complete' NOTE: Ren
	msotcidNewMailMessage2 = 2986,		//(2,25) Label: '&New Mail Message' NOTE: Ren - alternate underlined letter from msotcidNewMailMessage
	msotcidUnmarkForDeletion = 2987,		//(0,25) Label: '&Unmark for Deletion' NOTE: Ren
	msotcidPostDocumentRen2 = 2988,		//(37,22) Label: 'Pos&t' NOTE: Ren - alternate underlined letter
	msotcidPostReplyToFolder2 = 2989,		//(45,28) Label: 'Post Repl&y' NOTE: Ren - alternate text
	msotcidRemoveColumn = 2990,		//(0,25) Label: '&Remove This Column' NOTE: Ren
	msotcidRenShowGrid = 2991,		//(11,16) Label: 'Sho&w Grid' NOTE: Ren - diff. string from msotcidShowGrid
	msotcidRenSizeToGrid = 2992,		//(18,19) Label: 'Si&ze to Grid' NOTE: Ren - diff. string from msotcidSizeToGrid
	msotcidRenSnapToGrid = 2993,		//(18,18) Label: 'S&nap to Grid' NOTE: Ren - diff. string form msotcidSnapToGrid
	msotcidRenTabOrder = 2994,		//(15,28) Label: '&Tab Order' NOTE: Ren - diff. string from msotcidTabOrder
	msotcidInsertObject2 = 2995,		//(0,25) Label: 'Insert Ob&ject...' NOTE: Access - alternate string from msotcidInsertObject
	msotcidCompileAndSaveAll = 2996,		//(0,25) Label: 'Compile and Sa&ve All Modules' NOTE: Access
	msotcidGoContinue = 2997,		//(4,17) Label: 'Go/&Continue' NOTE: Access
	msotcidEnd = 2998,		//(26,1) Label: '&End' NOTE: Access
	msotcidSingleStep = 2999,		//(24,28) Label: '&Single Step' NOTE: Access
	};

enum
	{
	msotcidActiveXControls = 3000,		//(9,9) Label: 'Active&X Controls...' NOTE: Access - tools menu
	msotcidChangeShapeActionButtonBlank = 3001,		//(24,13) Label: '&Change Shape to Action Button: Custom' NOTE: Escher
	msotcidChangeShapeActionButtonHome = 3002,		//(24,4) Label: '&Change Shape to Action Button: Home' NOTE: Escher
	msotcidChangeShapeActionButtonHelp = 3003,		//(56,9) Label: '&Change Shape to Action Button: Help' NOTE: Escher
	msotcidChangeShapeActionButtonInformation = 3004,		//(39,15) Label: '&Change Shape to Action Button: Information' NOTE: Escher
	msotcidChangeShapeActionButtonBackPrevious = 3005,		//(39,17) Label: '&Change Shape to Action Button: Back or Previous' NOTE: Escher
	msotcidChangeShapeActionButtonForwardNext = 3006,		//(39,18) Label: '&Change Shape to Action Button: Forward or Next' NOTE: Escher
	msotcidChangeShapeActionButtonBeginning = 3007,		//(48,14) Label: '&Change Shape to Action Button: Beginning' NOTE: Escher
	msotcidChangeShapeActionButtonEnd = 3008,		//(10,9) Label: '&Change Shape to Action Button: End' NOTE: Escher
	msotcidChangeShapeActionButtonReturn = 3009,		//(43,20) Label: '&Change Shape to Action Button: Return' NOTE: Escher
	msotcidChangeShapeActionButtonDocument = 3010,		//(47,20) Label: '&Change Shape to Action Button: Document' NOTE: Escher
	msotcidChangeShapeActionButtonSound = 3011,		//(47,21) Label: '&Change Shape to Action Button: Sound' NOTE: Escher
	msotcidChangeShapeActionButtonMovie = 3012,		//(61,2) Label: '&Change Shape to Action Button: Movie' NOTE: Escher
	msotcidChangeShapeMenu5 = 3013,		//(44,1) Label: 'Ac&tion Buttons' NOTE: Escher
	msotcidCopyHereAsAttachment = 3014,		//(0,25) Label: '&Copy Here as Attachment' NOTE: Word
	msotcidCopyHereAsLinkedAttachment = 3015,		//(0,25) Label: 'Copy Here as &Linked Attachment' NOTE: Word
	msotcidCopyHereAsContent = 3016,		//(0,25) Label: '&Copy Here as Content' NOTE: Word
	msotcidFilterExcludingSelection = 3017,		//(0,25) Label: 'Filter E&xcluding Selection' NOTE: Access
	msotcidBackColorSplitDropdown = 3018,		//(2,17) Label: '&Back Color' NOTE: Access - different label from msotcidFillColorSplitDropdown
	msotcidChooseWindowDialog = 3019,		//(0,25) Label: '&use msotcidMoreWindows instead' NOTE: PGM - OBSOLETE
	msotcidKeisen = 3020,		//(1,13) Label: '&Keisen' NOTE: PPT - FE cmd to insert freeform Word table
	msotcidWebHelp01 = 3021,		//(7,18) Label: '&Web Help 1' NOTE: commands on Help/Microsoft on the Web
	msotcidWebHelp02 = 3022,		//(7,18) Label: '&Web Help 2' NOTE: commands on Help/Microsoft on the Web
	msotcidWebHelp03 = 3023,		//(7,18) Label: '&Web Help 3' NOTE: commands on Help/Microsoft on the Web
	msotcidWebHelp04 = 3024,		//(7,18) Label: '&Web Help 4' NOTE: commands on Help/Microsoft on the Web
	msotcidWebHelp05 = 3025,		//(7,18) Label: '&Web Help 5' NOTE: commands on Help/Microsoft on the Web
	msotcidWebHelp06 = 3026,		//(7,18) Label: '&Web Help 6' NOTE: commands on Help/Microsoft on the Web
	msotcidWebHelp07 = 3027,		//(7,18) Label: '&Web Help 7' NOTE: commands on Help/Microsoft on the Web
	msotcidWebHelp08 = 3028,		//(7,18) Label: '&Web Help 8' NOTE: commands on Help/Microsoft on the Web
	msotcidWebHelp09 = 3029,		//(7,18) Label: '&Web Help 9' NOTE: commands on Help/Microsoft on the Web
	msotcidWebHelp10 = 3030,		//(7,18) Label: '&Web Help 10' NOTE: commands on Help/Microsoft on the Web
	msotcidWebHelp11 = 3031,		//(7,18) Label: '&Web Help 11' NOTE: commands on Help/Microsoft on the Web
	msotcidWebHelp12 = 3032,		//(7,18) Label: '&Web Help 12' NOTE: commands on Help/Microsoft on the Web
	msotcidWebHelp13 = 3033,		//(7,18) Label: '&Web Help 13' NOTE: commands on Help/Microsoft on the Web
	msotcidWebHelp14 = 3034,		//(7,18) Label: '&Web Help 14' NOTE: commands on Help/Microsoft on the Web
	msotcidWebHelp15 = 3035,		//(7,18) Label: '&Web Help 15' NOTE: commands on Help/Microsoft on the Web
	msotcidWebHelp16 = 3036,		//(7,18) Label: '&Web Help 16' NOTE: commands on Help/Microsoft on the Web
	msotcidRenSend = 3037,		//(61,12) Label: 'S&end' NOTE: Ren - different string from Send2
	msotcidAddVBForm = 3038,		//(23,26) Label: '&Add Form' NOTE: VBE
	msotcidAddVBModule = 3039,		//(27,22) Label: '&Add Module' NOTE: VBE
	msotcidAddMDIForm = 3040,		//(46,21) Label: '&Add MDI Form' NOTE: VBE
	msotcidAddUserControl = 3041,		//(46,22) Label: '&Add User Control' NOTE: VBE
	msotcidAddPropertyPage = 3042,		//(46,23) Label: '&Add Property page' NOTE: VBE
	msotcidAddOLEDesigner = 3043,		//(46,24) Label: '&Add OLE Designer' NOTE: VBE
	msotcidAddDocumentDesigner = 3044,		//(46,25) Label: '&Add Document Designer' NOTE: VBE
	msotcidViewPropertyPages = 3045,		//(46,26) Label: '&Property Pages' NOTE: VBE
	msotcidVBEPreview = 3046,		//(46,27) Label: '&Preview' NOTE: VBE
	msotcidProjectTypeStandardEXE = 3047,		//(46,28) Label: '&Standard EXE' NOTE: VBE
	msotcidProjectTypeEXEServer = 3048,		//(46,29) Label: '&EXE Server' NOTE: VBE
	msotcidProjectTypeOLEDLL = 3049,		//(47,0) Label: '&OLE DLL' NOTE: VBE
	msotcidProjectTypeControl = 3050,		//(47,1) Label: '&Control' NOTE: VBE
	msotcidSlideMiniature2PerPage = 3051,		//(47,2) Label: '&Show position of 2 per page handouts' NOTE: PPT
	msotcidSlideMiniature3PerPage = 3052,		//(47,3) Label: '&Show position of 3 per page handouts' NOTE: PPT
	msotcidSlideMiniature6PerPage = 3053,		//(47,4) Label: '&Show position of 6 per page handouts' NOTE: PPT
	msotcidSlideMiniatureOutline = 3054,		//(47,5) Label: '&Show position of outline' NOTE: PPT
	msotcidInsertDrawingAndDiagram = 3055,		//(0,25) Label: '&Drawing and Diagram...' NOTE: PPT
	msotcidAccessToolsOptions = 3056,		//(37,15) Label: '&Options...' NOTE: Access - used to use this icon for Tools Options
	msotcidChartImportFile = 3057,		//(5,17) Label: '&Import File...' NOTE: Graph
	msotcidConditionalFormatting = 3058,		//(0,25) Label: 'Con&ditional Formatting...' NOTE: Excel
	msotcidProtectSharing = 3059,		//(57,7) Label: 'Protect &Sharing' NOTE: Excel
	msotcidFormatControl = 3060,		//(68,21) Label: 'C&ontrol...' NOTE: Escher - also see FormatPicture, FormatObject, FormatDrawingObject
	msotcidFormatControl2 = 3061,		//(68,21) Label: '&Format Control...' NOTE: Escher - the "2" versions are for use on context menus
	msotcidFormatWordArt = 3062,		//(68,21) Label: 'W&ordArt...' NOTE: Escher
	msotcidFormatWordArt2 = 3063,		//(68,21) Label: 'Format W&ordArt...' NOTE: Escher
	msotcidFormatTextBox = 3064,		//(68,21) Label: 'Text B&ox...' NOTE: Escher
	msotcidFormatTextBox2 = 3065,		//(68,21) Label: 'Format Text B&ox...' NOTE: Escher
	msotcidFormatPlaceholder = 3066,		//(68,21) Label: 'Placeh&older...' NOTE: Escher
	msotcidFormatPlaceholder2 = 3067,		//(68,21) Label: 'Format Placeh&older...' NOTE: Escher
	msotcidFormatComment = 3068,		//(68,21) Label: 'C&omment...' NOTE: Escher
	msotcidFormatComment2 = 3069,		//(68,21) Label: 'Format C&omment...' NOTE: Escher
	msotcidAlignObjectsLeft2 = 3070,		//(22,13) Label: '&Left' NOTE: Ren
	msotcidAlignObjectsRight2 = 3071,		//(22,14) Label: '&Right' NOTE: Ren
	msotcidAlignObjectsTop2 = 3072,		//(22,15) Label: '&Top' NOTE: Ren
	msotcidAlignObjectsBottom2 = 3073,		//(22,16) Label: '&Bottom' NOTE: Ren
	msotcidAlignObjectsCenteredHorizontal2 = 3074,		//(22,17) Label: '&Center' NOTE: Ren
	msotcidAlignObjectsCenteredVertical2 = 3075,		//(22,18) Label: '&Middle' NOTE: Ren
	msotcidFontForeColorSplitDropdown = 3076,		//(2,19) Label: 'Fo&nt/Fore Color' NOTE: Access - alternate string from FontColor
	msotcidFillBackColorSplitDropdown = 3077,		//(2,17) Label: 'Fi&ll/Back Color' NOTE: Access - alternate string from FillColorSplitDropdown
	msotcidLineBorderColorSplitDropdown = 3078,		//(2,18) Label: '&Line/Border Color' NOTE: Access - alternate string from LineColorSpltiDropdown
	msotcidFormDesignFontColorSwatch = 3079,		//(0,25) Label: '&Font/Fore Color' NOTE: Access
	msotcidDatasheetFontColorSwatch = 3080,		//(0,25) Label: '&Font/Fore Color' NOTE: Access
	msotcidFormDesignFillColorSwatch = 3081,		//(0,25) Label: '&Fill/Back Color' NOTE: Access
	msotcidDatasheetFillColorSwatch = 3082,		//(0,25) Label: '&Fill/Back Color' NOTE: Access
	msotcidFormDesignLineColorSwatch = 3083,		//(0,25) Label: '&Line/Border Color' NOTE: Access
	msotcidDatasheetLineColorSwatch = 3084,		//(0,25) Label: '&Line/Border Color' NOTE: Access
	msotcidLinkObjectHere = 3085,		//(0,25) Label: '&Link Object Here' NOTE: right-drag
	msotcidCreateShortcutHereAsText = 3086,		//(0,25) Label: 'C&reate Shortcut Here as Text' NOTE: right-drag
	msotcidCreateShortcutHereAsIcon = 3087,		//(0,25) Label: 'Create Shortcut Here as &Icon' NOTE: right-drag
	msotcidInsertShortcuHereAsText = 3088,		//(0,25) Label: '&Insert Shortcut Here as Text' NOTE: right-drag
	msotcidAttachShortcutToObject = 3089,		//(0,25) Label: '&Attach Shortcut to Object' NOTE: right-drag
	msotcidQueryParameters2 = 3090,		//(18,6) Label: 'Query P&arameters...' NOTE: alternate string
	msotcidWebHelp17 = 3091,		//(7,18) Label: '&Web help 17' NOTE: on Help submenu
	msotcidBulletsVerticalTB = 3092,		//(42,26) Label: '&Bullets' NOTE: Word - used for rotated text
	msotcidBulletsVerticalBT = 3093,		//(47,22) Label: '&Bullets' NOTE: Word - used for rotated text
	msotcidNumberingVerticalTB = 3094,		//(47,23) Label: '&Numbering' NOTE: Word - used for rotated text
	msotcidNumberingVerticalBT = 3095,		//(47,24) Label: '&Numbering' NOTE: Word - used for rotated text
	msotcidIndentVerticalTB = 3096,		//(47,25) Label: '&Increase Indent' NOTE: Word - used for rotated text
	msotcidIndentVerticalBT = 3097,		//(47,26) Label: '&Increase Indent' NOTE: Word - used for rotated text
	msotcidOutdentVerticalTB = 3098,		//(47,27) Label: '&Decrease Indent' NOTE: Word - used for rotated text
	msotcidOutdentVerticalBT = 3099,		//(47,28) Label: '&Decrease Indent' NOTE: Word - used for rotated text
	msotcidDistributeParagraphVerticalTB = 3100,		//(47,29) Label: '&Distributed Paragraph' NOTE: Word - used for rotated text
	msotcidDistributeParagraphVerticalBT = 3101,		//(48,0) Label: '&Distributed Paragraph' NOTE: Word - used for rotated text
	msotcidSaveForm = 3102,		//(1,0) Label: '&Save Form' NOTE: Access
	msotcidSaveQuery = 3103,		//(1,0) Label: '&Save Query' NOTE: Access
	msotcidSaveTable = 3104,		//(1,0) Label: '&Save Table' NOTE: Access
	msotcidOLEObjectConvertToPicture = 3105,		//(0,25) Label: '&Convert...' NOTE: Access - internal command
	msotcidSaveFormAs = 3106,		//(0,25) Label: 'Save Form &As...' NOTE: Access
	msotcidSaveQueryAs = 3107,		//(0,25) Label: 'Save Query &As...' NOTE: Access
	msotcidQueryDesignToggleSortRow = 3108,		//(0,25) Label: '&Sort' NOTE: Access
	msotcidObjectBrowserHelp = 3109,		//(0,25) Label: '&Help' NOTE: Access - help on selected item in Obj Browser
	msotcidChangeToCheckBox = 3110,		//(38,12) Label: 'C&heck Box' NOTE: Access
	msotcidChangeToCombo = 3111,		//(38,18) Label: '&Combo Box' NOTE: Access
	msotcidChangeToButton = 3112,		//(38,15) Label: 'Co&mmand Button' NOTE: Access
	msotcidChangeToImage = 3113,		//(40,6) Label: '&Image' NOTE: Access
	msotcidChangeToLabel = 3114,		//(38,22) Label: '&Label' NOTE: Access
	msotcidChangeToListBox = 3115,		//(38,17) Label: 'Li&st Box' NOTE: Access
	msotcidChangeToRadioButton = 3116,		//(38,16) Label: '&Option Button' NOTE: Access
	msotcidChangeToTextbox = 3117,		//(38,14) Label: '&Text Box' NOTE: Access
	msotcidChangeToToggleButton = 3118,		//(38,19) Label: 'To&ggle Button' NOTE: Access
	msotcidAccessNewClassModule = 3119,		//(5,11) Label: '&Class Module' NOTE: Access - other apps should use msotcidInsertClassModule
	msotcidAccessSizeToGrid = 3120,		//(18,19) Label: 'To &Grid' NOTE: Access - cf. SizeToGrid
	msotcidAccessSizeToFit = 3121,		//(18,20) Label: 'To &Fit' NOTE: Access - cf. SizeToFit
	msotcidOLEUpdate = 3122,		//(1,0) Label: '&Update' NOTE: used by OLE servers when running in Open mode -- OLE usage flag is set to Neither
	msotcidViewGrid = 3123,		//(0,25) Label: 'View &Grid' NOTE: Access
	msotcidManageFields = 3124,		//(38,13) Label: '&Manage Fields' NOTE: Word
	msotcidClearContents2 = 3125,		//(0,25) Label: 'Clear Co&ntents' NOTE: Excel - alternate text used in shortcut menu
	msotcidExcelColorPickerSwatch = 3126,		//(0,25) Label: '&Standard Colors' NOTE: used by Excel for both drawing objects & excel objects
	msotcidGoToInbox = 3127,		//(0,25) Label: '&Inbox' NOTE: Ren
	msotcidGoToCalendar = 3128,		//(0,25) Label: '&Calendar' NOTE: Ren
	msotcidGoToContacts = 3129,		//(0,25) Label: 'C&ontacts' NOTE: Ren
	msotcidGoToTasks = 3130,		//(0,25) Label: '&Tasks' NOTE: Ren
	msotcidGoToNotes = 3131,		//(0,25) Label: '&Notes' NOTE: Ren
	msotcidGoToJournal = 3132,		//(0,25) Label: '&Journal' NOTE: Ren
	msotcidGoToSentMail = 3133,		//(0,25) Label: '&Sent Items' NOTE: Ren
	msotcidGoToDeletedItems = 3134,		//(0,25) Label: '&Deleted Items' NOTE: Ren
	msotcidGoToMyComputer = 3135,		//(0,25) Label: '&My Computer' NOTE: Ren
	msotcidGoToMyDocuments = 3136,		//(0,25) Label: 'M&y Documents' NOTE: Ren
	msotcidHorizontalSpacingMakeEqual = 3137,		//(13,27) Label: 'Make &Equal' NOTE: Access, Ren, Forms - same as DistributeHorizontally, diff. label
	msotcidVerticalSpacingMakeEqual = 3138,		//(15,24) Label: 'Make &Equal' NOTE: Access, Ren, Forms - same as DistributeVertically, diff. label
	msotcidExcelColorSchemeSwatch = 3139,		//(0,25) Label: '&Color Scheme' NOTE: used by XL for both drawing & XL objects
	msotcidExcelLineColorAutomaticSwatch = 3140,		//(0,25) Label: '&Automatic Color' NOTE: used by XL for both drawing and XL objects
	msotcidExcelPatternColorAutomaticSwatch = 3141,		//(0,25) Label: '&Automatic Color' NOTE: used by XL for both drawing and XL objects
	msotcidAlignToGrid2 = 3142,		//(19,12) Label: 'To &Grid' NOTE: Ren, Access - alt. string
	msotcidInsertTextboxHorizontal = 3143,		//(5,29) Label: '&Horizontal' NOTE: Word FE - alternate string, cf. msotcidTextbox
	msotcidInsertTextboxVertical = 3144,		//(2,12) Label: '&Vertical' NOTE: Word FE - alternate string, cf. msotcidTextboxVertical
	msotcidCopySlide = 3145,		//(1,7) Label: '&Copy Slide' NOTE: PPT
	msotcidEditSlide = 3146,		//(0,25) Label: '&Edit Slide' NOTE: PPT
	msotcidSaveAsHTML = 3147,		//(0,25) Label: 'Save as &HTML...'
	msotcidPauseNarration = 3148,		//(0,25) Label: '&Pause Narration' NOTE: PPT - cf. RecordNarration
	msotcidPowerPointCentral = 3149,		//(0,25) Label: 'PowerPoint Cent&ral' NOTE: PPT
	msotcidSlideShowGoToPreviousViewed = 3150,		//(0,25) Label: '&Previous Viewed' NOTE: PPT
	msotcidSingleSpacingVertical = 3151,		//(48,12) Label: '&Single Spacing' NOTE: Word - FE
	msotcidOneAndAHalfSpacingVertical = 3152,		//(48,8) Label: '&1.5 Spacing' NOTE: Word - FE
	msotcidDoubleSpacingVertical = 3153,		//(48,9) Label: '&Double Spacing' NOTE: Word - FE
	msotcidColumnsVertical = 3154,		//(48,10) Label: '&Columns' NOTE: Word - FE
	msotcidFrameVertical = 3155,		//(48,11) Label: 'Vertical &Frame' NOTE: Word - FE
	msotcidInsertFileIntoModule = 3156,		//(7,27) Label: 'Fi&le...' NOTE: Access
	msotcidSortUpWord = 3157,		//(1,21) Label: 'Sort &Ascending' NOTE: Word - because they need a different quicktip
	msotcidSortDownWord = 3158,		//(1,22) Label: 'Sort Des&cending' NOTE: Word - because they need a different quicktip
	msotcidGroupCells = 3159,		//(60,26) Label: '&Group...' NOTE: Excel - cf. msotcidRightArrow
	msotcidUngroupCells = 3160,		//(56,7) Label: '&Ungroup...' NOTE: Excel - cf. msotcidLeftArrow
	msotcidIndentExcel = 3161,		//(0,29) Label: '&Increase Indent' NOTE: Excel - needs a different quicktip
	msotcidOutdentExcel = 3162,		//(0,28) Label: '&Decrease Indent' NOTE: Excel - needs a different quicktip
	msotcidSwitcher_BlankIcon = 3163,		//(48,13) Label: '&This ID is reserved' NOTE: this blank image is used by Switcher ID's to keep them from becoming text-only
	msotcidObjectBrowserGroupMembers = 3164,		//(0,25) Label: 'Group &Members'
	msotcidResendMessage = 3165,		//(0,25) Label: 'Resend T&his Message...' NOTE: Ren
	msotcidAdvancedProperties = 3166,		//(0,25) Label: '&Advanced Properties' NOTE: Ren
	msotcidSaveAttachments = 3167,		//(0,25) Label: 'Save Attac&hments...' NOTE: Ren
	msotcidLookupField = 3168,		//(0,25) Label: '&Lookup Field...' NOTE: Access - cf. similar cmd LookupColumn
	msotcidInsertHyperlinkColumn = 3169,		//(0,25) Label: '&Hyperlink Column' NOTE: Access
	msotcidAccessViewVisualBasicCode = 3170,		//(5,11) Label: '&Code' NOTE: Access - different icon/string from ViewVisualBasicCode
	msotcidGoToOutbox = 3171,		//(0,25) Label: 'Outbo&x' NOTE: Ren
	msotcidInsertTextBoxVertical2 = 3172,		//(2,12) Label: 'Insert Vertical Text B&ox' NOTE: Word - cf. msotcidInsertTextBox; don't confuse with InsertTextBoxVertical !
	msotcidSlideShowHistory = 3173,		//(0,25) Label: '&History...' NOTE: PPT
	msotcidInsertFrameHorizontal = 3174,		//(25,7) Label: '&Horizontal Frame' NOTE: Word - FE
	msotcidInsertFrameVertical = 3175,		//(48,11) Label: '&Vertical' NOTE: Word - FE
	msotcidChooseTemplate = 3176,		//(0,25) Label: 'C&hoose Template...' NOTE: Ren
	msotcidWW7NudgeUp = 3177,		//(26,17) Label: 'Nudge &Up One Pixel' NOTE: Word - backward compatibility IDs
	msotcidWW7NudgeDown = 3178,		//(26,18) Label: 'Nudge &Down One Pixel' NOTE: Word
	msotcidWW7NudgeLeft = 3179,		//(26,19) Label: 'Nudge &Left One Pixel' NOTE: Word
	msotcidWW7NudgeRight = 3180,		//(26,20) Label: 'Nudge &Right One Pixel' NOTE: Word
	msotcidInsertCells3 = 3181,		//(10,4) Label: '&Insert...' NOTE: Excel - used on context menu
	msotcidInsertCellsNoEllipsis = 3182,		//(10,4) Label: 'C&ells' NOTE: Excel
	msotcidInsertCells3NoEllipsis = 3183,		//(10,4) Label: '&Insert' NOTE: Excel
	msotcidInsertCopiedCells = 3184,		//(10,4) Label: 'Copied C&ells...' NOTE: Excel
	msotcidInsertCopiedCells2 = 3185,		//(10,4) Label: 'Insert Copied C&ells...' NOTE: Excel
	msotcidInsertCopiedCellsNoEllipsis = 3186,		//(10,4) Label: 'Copied C&ells' NOTE: Excel
	msotcidInsertCopiedCells2NoEllipsis = 3187,		//(10,4) Label: 'Insert Copied C&ells' NOTE: Excel
	msotcidInsertCutCells = 3188,		//(10,4) Label: 'Cut C&ells...' NOTE: Excel
	msotcidInsertCutCells2 = 3189,		//(10,4) Label: 'Insert Cut C&ells...' NOTE: Excel
	msotcidInsertCutCellsNoEllipsis = 3190,		//(10,4) Label: 'Cut C&ells' NOTE: Excel
	msotcidInsertCutCells2NoEllipsis = 3191,		//(10,4) Label: 'Insert Cut C&ells' NOTE: Excel
	msotcidPivotTableInsertField2 = 3192,		//(0,25) Label: 'Calculated F&ield...' NOTE: Excel
	msotcidPivotTableInsertItem2 = 3193,		//(0,25) Label: 'Calculated &Item' NOTE: Excel
	msotcidInsertFilterRow = 3194,		//(10,5) Label: '&Insert Row' NOTE: Excel
	msotcidInsertPasteFilterRow = 3195,		//(10,5) Label: '&Insert Paste Row' NOTE: Excel
	msotcidInsertProject = 3196,		//(18,24) Label: '&Project...' NOTE: Project
	msotcidTeamInbox = 3197,		//(24,14) Label: 'Team&Inbox...' NOTE: Project
	msotcidShareResources = 3198,		//(23,5) Label: '&Share Resources...' NOTE: Project
	msotcidUpdateResourcePool = 3199,		//(34,3) Label: '&Update Resource Pool' NOTE: Project
	msotcidRefreshResourcePool = 3200,		//(34,4) Label: '&Refresh Resouce Pool' NOTE: Project
	msotcidProgressLine = 3201,		//(34,21) Label: 'Progress &Line...' NOTE: Project
	msotcidSplitTask = 3202,		//(34,22) Label: '&Split Task' NOTE: Project
	msotcidShowAssignments = 3203,		//(34,23) Label: 'Show Assign&ments' NOTE: Project
	msotcidHideAssignments = 3204,		//(34,23) Label: 'Hide Assign&ments' NOTE: Project
	msotcidNewResource = 3205,		//(34,24) Label: '&New Resource' NOTE: Project
	msotcidNewAssignment = 3206,		//(34,25) Label: 'New &Assignment' NOTE: Project
	msotcidSaveAsDynamicHTML = 3207,		//(0,25) Label: 'Save As &Dynamic HTML' NOTE: Access
	msotcidInsertFrameHorizontalInVertical = 3208,		//(48,17) Label: '&Frame' NOTE: Word
	msotcidInsertFrameVerticalInVertical = 3209,		//(48,18) Label: 'Vertical &Frame' NOTE: Word
	msotcidAutoTextList = 3210,		//(0,25) Label: '&AutoText' NOTE: Word
	msotcidFormatFrameFull = 3211,		//(0,25) Label: 'Format Fra&me...' NOTE: Word - for shortcut menus
	msotcidFormatPictureFull = 3212,		//(0,25) Label: 'Format Pictu&re...' NOTE: Word
	msotcidFormatDrawingObjectFull = 3213,		//(0,25) Label: 'Format Drawing &Object' NOTE: Word
	msotcidToggleFieldCodes = 3214,		//(0,25) Label: '&Toggle Field Codes' NOTE: Word - cf. FieldCodes
	msotcidViewFootnoteArea = 3215,		//(0,25) Label: '&Go to Footnote' NOTE: Word
	msotcidViewEndnoteArea = 3216,		//(0,25) Label: '&Go to Endnote' NOTE: Word
	msotcidHideBackgroundSpellingErrors = 3217,		//(0,25) Label: '&Hide Spelling Errors' NOTE: Word
	msotcidHideBackgroundGrammarErrors = 3218,		//(0,25) Label: '&Hide Grammar Errors' NOTE: Word
	msotcidToolsDictionary = 3219,		//(0,25) Label: '&Dictionary...' NOTE: Word
	msotcidSwitcher_PublisherOptions_SubscriberOptions = 3220,		//(0,25) Label: '&Publish/Subscribe Options' NOTE: Word
	msotcidSummaryInformation = 3221,		//(0,25) Label: '&Summary Information...' NOTE: Word
	msotcidFootnoteEndnoteOptions = 3222,		//(0,25) Label: '&Footnote/Endnote Options' NOTE: Word
	msotcidFormatBackgroundColorNoneSwatch = 3223,		//(0,25) Label: '&No Color' NOTE: Word
	msotcidFormatBackgroundColorPickerSwatch = 3224,		//(0,25) Label: '&Standard Colors' NOTE: Word
	msotcidDottedUnderline = 3225,		//(0,25) Label: '&Dotted Underline' NOTE: Word
	msotcidNewLabelLabel = 3226,		//(0,25) Label: '&New Label' NOTE: post 97, used by office customize
	msotcidHyperlinkNameEdit = 3227,		//(0,25) Label: '&Display Text:' NOTE: Access
	msotcidRemoveNumbering = 3228,		//(0,25) Label: '&Remove Numbering' NOTE: Word
	msotcidToolsCustomizeToolbars = 3229,		//(0,25) Label: '&Customize Toolbars' NOTE: Word - 95 compatibility - tbcuNeither
	msotcidToolsCustomizeMenus = 3230,		//(0,25) Label: '&Customize Menus' NOTE: Word - 95 compatibility - tbcuNeither
	msotcidWW7EditPicture = 3231,		//(0,25) Label: '&Picture' NOTE: Word - 95 compatibility
	msotcidGoToStartOfWindow = 3232,		//(0,25) Label: '&Start of Window' NOTE: Word
	msotcidGoToEndOfWindow = 3233,		//(0,25) Label: '&End of Window' NOTE: Word
	msotcidMultiUserDocumentOptions = 3234,		//(0,25) Label: '&Multi-user document options' NOTE: Word
	msotcidFootnoteToolbarLabel = 3235,		//(0,25) Label: 'Footn&otes' NOTE: Word - label control
	msotcidEndnoteToolbarLabel = 3236,		//(0,25) Label: 'Endn&otes' NOTE: Word - label control
	msotcidShadingColorNoneSwatch = 3237,		//(0,25) Label: '&No Color' NOTE: Word
	msotcidShadingColorPickerSwatch = 3238,		//(0,25) Label: '&Standard Colors' NOTE: Word
	msotcidHighlightColorNoneSwatch = 3239,		//(0,25) Label: '&No Color' NOTE: Word
	msotcidHighlightColorPickerSwatch = 3240,		//(0,25) Label: '&Standard Colors' NOTE: Word
	msotcidBorderColorNoneSwatch = 3241,		//(0,25) Label: '&No Color' NOTE: Word
	msotcidBorderColorPickerSwatch = 3242,		//(0,25) Label: '&Standard Colors' NOTE: Word
	msotcidRecentFileListPlaceholder = 3243,		//(0,25) Label: '&(List of Recently Used Files)' NOTE: Word - placeholders used in customize mode
	msotcidWindowListPlaceholder = 3244,		//(0,25) Label: '&(List of Current Windows)' NOTE: Word
	msotcidFixSpellingSuggestionListPlaceholder = 3245,		//(0,25) Label: '&(List of Spelling Commands)' NOTE: Word
	msotcidFontListPlaceholder = 3246,		//(0,25) Label: '&(List of Fonts)' NOTE: Word
	msotcidMSWordToolsAutoCorrectHECorrect = 3247,		//(0,25) Label: '&HECorrect' NOTE: Word
	msotcidFixGrammarSuggestionListPlaceholder = 3248,		//(0,25) Label: '&(List of Grammar Commands)' NOTE: Word
	msotcidSwitcher_FormatAutoShape_FormatPicture = 3249,		//(68,21) Label: '&Format AutoShape/Picture' NOTE: Word
	msotcidMSWordOptionsW7 = 3250,		//(0,25) Label: '&Options...' NOTE: Word
	msotcidSendToPowerpoint = 3251,		//(9,24) Label: 'Send to Microsoft &PowerPoint' NOTE: Word - longer text for msotcidPresentIt
	msotcidShowParagraphMarks = 3252,		//(0,25) Label: '&Show Paragraph Marks' NOTE: Word - diff. from msotcidParagraphMark (Show All)
	msotcidInsertFrameVertical2 = 3253,		//(48,11) Label: 'Insert &Vertical Frame' NOTE: Word - full text
	msotcidHeaderToolbarLabel = 3254,		//(0,25) Label: '.' NOTE: Word - string gets overridden
	msotcidFrame2 = 3255,		//(25,7) Label: 'Insert &Frame' NOTE: Word - full text
	msotcidViewNotePanes = 3256,		//(0,25) Label: '&View Note Panes...' NOTE: Word
	msotcidEditObjectPrivate = 3257,		//(0,25) Label: '&Object' NOTE: Word - internal ID
	msotcidEditObjectCore = 3258,		//(0,25) Label: '.' NOTE: Word - internal ID
	msotcidWorkFileListPlaceholder = 3259,		//(0,25) Label: '&(List of Work Files)' NOTE: Word - placeholder ID for customize
	msotcidAutoTextListPlaceholder = 3260,		//(0,25) Label: '&(List of AutoText Entries)' NOTE: Word - placeholder ID for customize
	msotcidAutoTextListFieldListPlaceholder = 3261,		//(0,25) Label: '&(List of AutoText List Fields)' NOTE: Word - placeholder ID for customize
	msotcidFormatDrawingObjectW7 = 3262,		//(0,25) Label: 'Aut&oShape...' NOTE: Word - compatibility ID
	msotcidApplyFormatToDefaults = 3263,		//(0,25) Label: '&Apply Formats To Defaults' NOTE: Escher
	msotcidGoToProperty = 3264,		//(0,25) Label: '&Go to Property...' NOTE: PPT
	msotcidDeclineTask = 3265,		//(48,6) Label: '&Decline' NOTE: Ren
	msotcidGoToCustomShowList = 3266,		//(0,25) Label: '&<custom show name goes here>' NOTE: PPT - list of custom shows in Go/CustomShows right-click submenu
	msotcidGoToSlideByTitleList = 3267,		//(0,25) Label: '&<slide title goes here>' NOTE: PPT - appears on slide show right click menu under Go/By Title
	msotcidCustomizeShowOnAllTabs = 3268,		//(0,25) Label: '&Visible on All Tabs' NOTE: used by command bars, post 97
	msotcidCustomizeNewHorizontalSeparatorLine = 3269,		//(0,25) Label: '&Horizontal Line' NOTE: used by command bars, post 97
	msotcidCustomizeNewVerticalSeparatorLine = 3270,		//(0,25) Label: '&Vertical Line' NOTE: used by command bars, post 97
	msotcidWordAutoFormatNow = 3271,		//(65,11) Label: '&AutoFormat...' NOTE: Word - bug 136181
	msotcidMSWordDataForm = 3272,		//(12,5) Label: '&Data Form' NOTE: Word - bug 137646
	msotcidReviseContents = 3273,		//(0,25) Label: 'Re&vise Contents' NOTE: Ren
	msotcidNudgeUpOne = 3274,		//(26,17) Label: '&Nudge Up One Pixel' NOTE: Word
	msotcidNudgeDownOne = 3275,		//(26,18) Label: '&Nudge Down One Pixel' NOTE: Word
	msotcidNudgeLeftOne = 3276,		//(26,19) Label: '&NudgeLeftOnePixel' NOTE: Word
	msotcidNudgeRightOne = 3277,		//(26,20) Label: '&Nudge Right One Pixel' NOTE: Word
	msotcidHelpContents = 3278,		//(25,10) Label: '&Contents and Index' NOTE: Word - internal use only -- other apps should only use HelpTopics
	msotcidWorkFileList = 3279,		//(0,25) Label: '&<work file name goes here>' NOTE: Word
	msotcidOpenSpecificFile = 3280,		//(0,25) Label: '&<file name goes here>' NOTE: Word
	msotcidFutureUse000 = 3281,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse001 = 3282,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse002 = 3283,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse003 = 3284,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse004 = 3285,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse005 = 3286,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse006 = 3287,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse007 = 3288,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse008 = 3289,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse009 = 3290,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse010 = 3291,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse011 = 3292,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse012 = 3293,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse013 = 3294,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse014 = 3295,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse015 = 3296,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse016 = 3297,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse017 = 3298,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse018 = 3299,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse019 = 3300,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse020 = 3301,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse021 = 3302,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse022 = 3303,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse023 = 3304,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse024 = 3305,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse025 = 3306,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse026 = 3307,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse027 = 3308,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse028 = 3309,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse029 = 3310,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse030 = 3311,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse031 = 3312,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse032 = 3313,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse033 = 3314,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse034 = 3315,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse035 = 3316,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse036 = 3317,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse037 = 3318,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse038 = 3319,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse039 = 3320,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse040 = 3321,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse041 = 3322,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse042 = 3323,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse043 = 3324,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse044 = 3325,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse045 = 3326,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse046 = 3327,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse047 = 3328,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse048 = 3329,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse049 = 3330,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse050 = 3331,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse051 = 3332,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse052 = 3333,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse053 = 3334,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse054 = 3335,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse055 = 3336,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse056 = 3337,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse057 = 3338,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse058 = 3339,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse059 = 3340,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse060 = 3341,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse061_Container = 3342,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse062_Container = 3343,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse063_Container = 3344,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse064_Container = 3345,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse065_Container = 3346,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse066_Container = 3347,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse067_Container = 3348,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse068_Container = 3349,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse069_Container = 3350,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse070_Container = 3351,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse071_Container = 3352,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse072_ContainerAndServer = 3353,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse073_ContainerAndServer = 3354,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse074_ContainerAndServer = 3355,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse075_ContainerAndServer = 3356,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse076_ContainerAndServer = 3357,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidFutureUse077_ContainerAndServer = 3358,		//(0,25) Label: '' NOTE: reserved for future versions
	msotcidMSWordToolsBulletDefault = 3359,		//(0,27) Label: '&Tools Bullet List Default' NOTE: Word
	msotcidMSWordToolsNumberDefault = 3360,		//(0,26) Label: '&Tools Number List Default' NOTE: Word
	msotcidMSWordFormatMultilevelListDefault = 3361,		//(0,26) Label: '&Format Outline Number Default' NOTE: Word
	msotcidMSWordFormatNumberDefault = 3362,		//(0,26) Label: '&Format Number Default' NOTE: Word
	msotcidLettersWizard = 3363,		//(0,25) Label: 'Letter Wi&zard...' NOTE: Word - cf. msotcidLetters
	msotcidMSWordUpdateTocFull = 3364,		//(0,25) Label: '&Rebuild Table of Contents' NOTE: Word
	msotcidFootnoteEndnote = 3365,		//(39,26) Label: 'Foot&note...' NOTE: Word - cf. Footnote
	msotcidMSWordHelpKeyboard = 3366,		//(0,25) Label: '&Help Keyboard' NOTE: Word
	msotcidMSWordHelpActiveWindow = 3367,		//(0,25) Label: '&Help Active Window' NOTE: Word
	msotcidMSWordUpdateFieldsVBA = 3368,		//(0,25) Label: '&Update Fields' NOTE: Word
	msotcidMSWordUnlinkFieldsVBA = 3369,		//(0,25) Label: '&Unlink Fields' NOTE: Word
	msotcidMSWordCharColor = 3370,		//(0,25) Label: '&Char Color' NOTE: Word
	msotcidMSWordDocumentStatistics = 3371,		//(0,25) Label: '&Document Statistics' NOTE: Word
	msotcidMSWordEditFindFont = 3372,		//(0,25) Label: '&Edit Find Font' NOTE: Word
	msotcidMSWordEditFindPara = 3373,		//(0,25) Label: '&Edit Find Paragraph' NOTE: Word
	msotcidMSWordEditFindTabs = 3374,		//(0,25) Label: '&Edit Find Tabs' NOTE: Word
	msotcidMSWordEditFindBorder = 3375,		//(0,25) Label: '&Edit Find Border' NOTE: Word
	msotcidMSWordEditFindLang = 3376,		//(0,25) Label: '&Edit Find Language' NOTE: Word
	msotcidMSWordEditFindFrame = 3377,		//(0,25) Label: '&Edit Find Frame' NOTE: Word
	msotcidMSWordEditFindStyle = 3378,		//(0,25) Label: '&Edit Find Style' NOTE: Word
	msotcidMSWordEditFindHighlight = 3379,		//(0,25) Label: '&Edit Find Highlight' NOTE: Word
	msotcidMSWordEditFindNotHighlight = 3380,		//(0,25) Label: '&Edit Find Not Highlight' NOTE: Word
	msotcidMSWordEditFindClearFormatting = 3381,		//(0,25) Label: '&Edit Find Clear Formatting' NOTE: Word
	msotcidMSWordEditReplaceFont = 3382,		//(0,25) Label: '&Edit Replace Font' NOTE: Word
	msotcidMSWordEditReplacePara = 3383,		//(0,25) Label: '&Edit Replace Paragraph' NOTE: Word
	msotcidMSWordEditReplaceTabs = 3384,		//(0,25) Label: '&Edit Replace Tabs' NOTE: Word
	msotcidMSWordEditReplaceBorder = 3385,		//(0,25) Label: '&Edit Replace Border' NOTE: Word
	msotcidMSWordEditReplaceLang = 3386,		//(0,25) Label: '&Edit Replace Language' NOTE: Word
	msotcidMSWordEditReplaceFrame = 3387,		//(0,25) Label: '&Edit Replace Frame' NOTE: Word
	msotcidMSWordEditReplaceStyle = 3388,		//(0,25) Label: '&Edit Replace Style' NOTE: Word
	msotcidMSWordEditReplaceHighlight = 3389,		//(0,25) Label: '&Edit Replace Highlight' NOTE: Word
	msotcidMSWordEditReplaceNotHighlight = 3390,		//(0,25) Label: '&Edit Replace Not Highlight' NOTE: Word
	msotcidEditReplaceClearFormatting = 3391,		//(0,25) Label: '&Edit Replace Clear Formatting' NOTE: Word
	msotcidMSWordTableInsertTable = 3392,		//(1,14) Label: '&Insert Table...' NOTE: Word
	msotcidMSWordToolsProtectSection = 3393,		//(0,25) Label: '&Tools Protect Section' NOTE: Word
	msotcidMSWordFormatDefineStyleFont = 3394,		//(0,25) Label: '&Format Define Style Font' NOTE: Word
	msotcidMSWordFormatDefineStylePara = 3395,		//(0,25) Label: '&Format Define Style Para' NOTE: Word
	msotcidMSWordFormatDefineStyleTabs = 3396,		//(0,25) Label: '&Format Define Style Tabs' NOTE: Word
	msotcidMSWordFormatDefineStyleFrame = 3397,		//(0,25) Label: '&Format Define Style Frame' NOTE: Word
	msotcidMSWordFormatDefineStyleBorders = 3398,		//(0,25) Label: '&Format Define Style Borders' NOTE: Word
	msotcidMSWordFormatDefineStyleLang = 3399,		//(0,25) Label: '&Format Define Style Language' NOTE: Word
	msotcidMSWordFormatDefineStyleNumbers = 3400,		//(0,25) Label: '&Format Define Style Numbers' NOTE: Word
	msotcidMSWordFormatBullet = 3401,		//(0,25) Label: '&Format Bullet' NOTE: Word
	msotcidMSWordFormatNumber = 3402,		//(0,25) Label: '&Format Number' NOTE: Word
	msotcidMSWordFormatMultilevel = 3403,		//(0,25) Label: '&Format Multilevel' NOTE: Word
	msotcidMSWordFormatHeadingNumber = 3404,		//(0,25) Label: '&Format Heading Number' NOTE: Word
	msotcidMSWordFixGrammarChange = 3405,		//(0,25) Label: '&Fix Grammar Change' NOTE: Word
	msotcidMSWordToolsCustomizeMenuBar = 3406,		//(0,25) Label: '&Tools Customize Menu Bar' NOTE: Word
	msotcidMSWordToolsAdvancedSettings = 3407,		//(0,25) Label: '&Tools Advanced Settings' NOTE: Word
	msotcidMSWordIconBarMode = 3408,		//(0,25) Label: '&Icon Bar Mode' NOTE: Word
	msotcidMSWordUserDialog = 3409,		//(0,25) Label: '&User Dialog' NOTE: Word
	msotcidMSWordCopyFile = 3410,		//(0,25) Label: '&Copy File' NOTE: Word
	msotcidMSWordClearFormField = 3411,		//(17,9) Label: '&Clear Form Field' NOTE: Word
	msotcidMSWordWW2_RulerMode = 3412,		//(0,25) Label: '&Ruler Mode' NOTE: Word
	msotcidMSWordWW2_FileTemplates = 3413,		//(0,25) Label: '&File Templates' NOTE: Word
	msotcidMSWordWW2_PrintMergeToPrinter = 3414,		//(12,3) Label: '&Print Merge To Printer' NOTE: Word
	msotcidMSWordWW2_PrintMergeToDocument = 3415,		//(64,27) Label: '&Print Merge To Document' NOTE: Word
	msotcidMSWordWW2_PrintMergeCheck = 3416,		//(0,25) Label: '&Print Merge Check' NOTE: Word
	msotcidMSWordWW2_PrintMerge = 3417,		//(0,25) Label: '&Print Merge' NOTE: Word
	msotcidMSWordWW2_PrintMergeSelection = 3418,		//(0,25) Label: '&Print Merge Selection' NOTE: Word
	msotcidMSWordWW2_PrintMergeHelper = 3419,		//(0,25) Label: '&Print Merge Helper' NOTE: Word
	msotcidMSWordWW2_PrintMergeCreateDataSource = 3420,		//(0,25) Label: '&Print Merge Create Data Source' NOTE: Word
	msotcidMSWordWW2_PrintMergeCreateHeaderSource = 3421,		//(0,25) Label: '&Print Merge Create Header Source' NOTE: Word
	msotcidMSWordWW2_EditFind = 3422,		//(0,25) Label: '&Edit Find' NOTE: Word
	msotcidMSWordWW2_EditFindChar = 3423,		//(0,25) Label: '&Edit Find Character' NOTE: Word
	msotcidMSWordWW2_EditReplace = 3424,		//(0,25) Label: '&Edit Replace' NOTE: Word
	msotcidMSWordWW2_EditReplaceChar = 3425,		//(0,25) Label: '&Edit Replace Character' NOTE: Word
	msotcidMSWordWW2_TableRowHeight = 3426,		//(0,25) Label: '&Table Row Height' NOTE: Word
	msotcidMSWordWW2_TableColumnWidth = 3427,		//(0,25) Label: '&Table Column Width' NOTE: Word
	msotcidMSWordWW2_ViewZoom = 3428,		//(0,25) Label: '&View Zoom' NOTE: Word
	msotcidMSWordWW2_InsertFootnote = 3429,		//(0,25) Label: '&Insert Footnote' NOTE: Word
	msotcidMSWordWW2_InsertSymbol = 3430,		//(0,25) Label: '&Insert Symbol' NOTE: Word
	msotcidMSWordWW2_InsertIndex = 3431,		//(0,25) Label: '&Insert Index' NOTE: Word
	msotcidMSWordWW2_InsertTableOfContents = 3432,		//(0,25) Label: '&Insert Table Of Contents' NOTE: Word
	msotcidMSWordWW2_FormatCharacter = 3433,		//(0,25) Label: '&Format Character' NOTE: Word
	msotcidMSWordWW2_FormatDefinteStyleChar = 3434,		//(0,25) Label: '&Format Definte Style Character' NOTE: Word
	msotcidMSWordWW2_ToolsHyphenation = 3435,		//(0,25) Label: '&Tools Hyphenation' NOTE: Word
	msotcidMSWordWW2_ToolsRevisionsMark = 3436,		//(0,25) Label: '&Tools Revisions Mark' NOTE: Word
	msotcidMSWordWW2_ToolsOptionsGeneral = 3437,		//(0,25) Label: '&Tools Options General' NOTE: Word
	msotcidMSWordWW2_ToolsOptionsView = 3438,		//(0,25) Label: '&Tools Options View' NOTE: Word
	msotcidMSWordWW2_ToolsOptionsMenus = 3439,		//(0,25) Label: '&Tools Options Menus' NOTE: Word
	msotcidMSWordWW2_ToolsOptionsKeyboard = 3440,		//(0,25) Label: '&Tools Options Keyboard' NOTE: Word
	msotcidMSWordWW2_ToolsOpitonsPrint = 3441,		//(0,25) Label: '&Tools Options Print' NOTE: Word
	msotcidMSWordWW2_ToolsOptionsToolbar = 3442,		//(0,25) Label: '&Tools Options Toolbar' NOTE: Word
	msotcidMSWordWW2_ChangeRulerMode = 3443,		//(0,25) Label: '&Change Ruler Mode' NOTE: Word
	msotcidMSWordWW2_FootnoteOptions = 3444,		//(0,25) Label: '&Footnote Options' NOTE: Word
	msotcidMSWordWW2_FormatBordersAndShading = 3445,		//(0,25) Label: '&Format Borders And Shading' NOTE: Word
	msotcidMSWordWW7_ToolsGrammar = 3446,		//(0,25) Label: '&Grammar' NOTE: Word
	msotcidMSWordToolsSpellingRange = 3447,		//(0,25) Label: '&Tools Spelling Range' NOTE: Word
	msotcidMSWordToolsGrammarRange = 3448,		//(0,25) Label: '&Tools Grammar Range' NOTE: Word
	msotcidWW7SendToBack = 3449,		//(46,3) Label: 'Send to Bac&k' NOTE: Word - should have same string as SendToBack
	msotcidWW7BringToFront = 3450,		//(3,10) Label: 'Bring to Fron&t' NOTE: Word - should have same string as BringToFront
	msotcidWW7AboveText = 3451,		//(28,15) Label: 'Bring in F&ront of Text' NOTE: Word - should have same string as AboveText
	msotcidWW7BehindText = 3452,		//(37,21) Label: 'Send Be&hind Text' NOTE: Word - should have same string as BehindText
	msotcidWW7Arc = 3453,		//(29,20) Label: '&Arc' NOTE: Word - should have same string as Arc
	msotcidWW7Group = 3454,		//(8,1) Label: '&Group' NOTE: Word - should have same string as Group
	msotcidWW7Ungroup = 3455,		//(8,2) Label: '&Ungroup' NOTE: Word - should have same string as Ungroup
	msotcidWW7BringForward = 3456,		//(28,10) Label: 'Bring &Forward' NOTE: Word - should have same string as BringForward
	msotcidWW7SendBackward = 3457,		//(37,25) Label: 'Send &Backward' NOTE: Word - should have same string as SendBackward
	msotcidWW7RotateRight = 3458,		//(36,8) Label: 'Rotate &Right' NOTE: Word - same string as RotateRight
	msotcidWW7RotateLeft = 3459,		//(37,16) Label: 'Rotate &Left' NOTE: Word - same string as RotateLeft
	msotcidWW7FlipHorizontal = 3460,		//(37,18) Label: 'Flip &Horizontal' NOTE: Word - same string as FlipHorizontal
	msotcidWW7FlipVertical = 3461,		//(37,10) Label: 'Flip &Vertical' NOTE: Word - same string as FlipVertical
	msotcidPageBreakAndEOP = 3462,		//(15,18) Label: 'Page &Break' NOTE: Word
	msotcidMSWordToggleMacroRun = 3463,		//(4,17) Label: '&Toggle Macro Run' NOTE: Word
	msotcidMSWordStartMacro = 3464,		//(4,17) Label: '&Start Macro' NOTE: Word
	msotcidNoSpellingSuggestionsAC = 3465,		//(0,25) Label: '&(no spelling suggestions)' NOTE: Word -same string as NoSpellingSuggestions
	msotcidWW7BorderShadingDialog = 3466,		//(0,25) Label: '&Borders and Shading...' NOTE: Word - same string as BorderShadingDialog
	msotcidWW7Textbox = 3467,		//(5,29) Label: 'Te&xt Box' NOTE: Word - same string as Textbox
	msotcidWW7TextboxVertical = 3468,		//(0,25) Label: '&Vertical Text Box' NOTE: Word - same string as TextboxVertical
	msotcidWW7GoTo = 3469,		//(44,14) Label: '&Go To...' NOTE: Word
	msotcidWW7Indent = 3470,		//(0,29) Label: '&Increase Indent' NOTE: Word - same string as Indent
	msotcidWW7Outdent = 3471,		//(0,28) Label: '&Decrease Indent' NOTE: Word - same string as Outdent
	msotcidListIndent = 3472,		//(0,29) Label: '&Increase Indent' NOTE: Word - same string as Indent
	msotcidListOutdent = 3473,		//(0,28) Label: '&Decrease Indent' NOTE: Word - same string as Outdent
	msotcidIndentCharacterWidth = 3474,		//(0,29) Label: '&Increase Indent' NOTE: Word - same string as Indent
	msotcidOutdentCharacterWidth = 3475,		//(0,28) Label: '&Decrease Indent' NOTE: Word - same string as Outdent
	msotcidKeisenToolbar = 3476,		//(12,7) Label: '&Borders' NOTE: Word - FE command
	msotcidWW7Pointer = 3477,		//(2,6) Label: '&Select Objects' NOTE: Word
	msotcidWW7Callout = 3478,		//(46,4) Label: '&Callout' NOTE: Word
	msotcidWW7AutoText = 3479,		//(46,8) Label: 'AutoTe&xt...' NOTE: Word
	msotcidWW7EditPolygon = 3480,		//(0,25) Label: '&Edit Points' NOTE: Word
	msotcidWW7InsertTextEffect = 3481,		//(2,13) Label: '&WordArt...' NOTE: Word
	msotcidWW7Line = 3482,		//(2,7) Label: '&Line' NOTE: Word
	msotcidWW7PolygonFreehand = 3483,		//(36,6) Label: '&Freeform' NOTE: Word
	msotcidListMacros = 3484,		//(23,21) Label: '&List Macros' NOTE: Word
	msotcidGlossaryButton = 3485,		//(46,8) Label: '&AutoText' NOTE: Word
	msotcidMacPageSetupGX = 3486,		//(0,25) Label: 'PageSet&up...' NOTE: Word
	msotcidDrawingSelection = 3487,		//(0,25) Label: '&Drawing Selection' NOTE: Word
	msotcidAddDocumentToFavorites = 3488,		//(0,25) Label: '&Add Document to Favorites...' NOTE: Word
	msotcidFormatBackground = 3489,		//(4,28) Label: 'Bac&kground' NOTE: Word - similar to WebSetBackground
	msotcidListReviewers = 3490,		//(0,25) Label: '&List Reviewers' NOTE: Word
	msotcidMSWordLinkToPreviousHeader = 3491,		//(0,25) Label: '&Link to Previous' NOTE: Word
	msotcidToolsHHC = 3492,		//(0,25) Label: 'Han&gul Hanja Conversion...' NOTE: Word - hangeul/hanja conversion
	msotcidOutdentLine = 3493,		//(0,28) Label: '&Decrease Indent' NOTE: Word
	msotcidOutdentFirstLine = 3494,		//(0,28) Label: '&Decrease First Line Indent' NOTE: Word
	msotcidIndentLine = 3495,		//(0,29) Label: '&Increase Indent' NOTE: Word
	msotcidIndentFirstLine = 3496,		//(0,29) Label: '&Increase First Line Indent' NOTE: Word
	msotcidEditHeaderSource = 3497,		//(12,5) Label: '&Edit Header Source' NOTE: Word
	msotcidMSWordFile1 = 3498,		//(0,25) Label: '&File1' NOTE: Word - separate commands for each file MRU
	msotcidMSWordFile2 = 3499,		//(0,25) Label: '&File2' NOTE: Word
	msotcidMSWordFile3 = 3500,		//(0,25) Label: '&File3' NOTE: Word
	msotcidMSWordFile4 = 3501,		//(0,25) Label: '&File4' NOTE: Word
	msotcidMSWordFile5 = 3502,		//(0,25) Label: '&File5' NOTE: Word
	msotcidMSWordFile6 = 3503,		//(0,25) Label: '&File6' NOTE: Word
	msotcidMSWordFile7 = 3504,		//(0,25) Label: '&File7' NOTE: Word
	msotcidMSWordFile8 = 3505,		//(0,25) Label: '&File8' NOTE: Word
	msotcidMSWordFile9 = 3506,		//(0,25) Label: '&File9' NOTE: Word
	msotcidDemoteList = 3507,		//(0,29) Label: '&Increase Indent' NOTE: Word
	msotcidPromoteList = 3508,		//(0,28) Label: '&Decrease Indent' NOTE: Word
	msotcidChangeCaseFE = 3509,		//(10,18) Label: 'Change Cas&e...' NOTE: Word
	msotcidDistributeParaChar = 3510,		//(3,0) Label: 'F&it Text...' NOTE: Word
	msotcidFormatRuby = 3511,		//(48,21) Label: 'Phonetic G&uide...' NOTE: Word
	msotcidFormatKumimoji = 3512,		//(51,22) Label: '&Combine Characters...' NOTE: Word
	msotcidPostcardWizard = 3513,		//(0,25) Label: '&Japanese Postcard Wizard...' NOTE: Word
	msotcidPhoneticList = 3514,		//(0,25) Label: '&Phonetic Information' NOTE: Excel FE
	msotcidBrace = 3515,		//(15,8) Label: '&Brace' NOTE: Word - FE
	msotcidBracket = 3516,		//(23,28) Label: '&Bracket' NOTE: Word - FE
	msotcidDefaultCharBorder = 3517,		//(23,29) Label: '&Character Border' NOTE: Word - FE
	msotcidDefautlCharShading = 3518,		//(35,8) Label: '&Character Shading' NOTE: Word
	msotcidCondSumWiz = 3519,		//(0,25) Label: '&Conditional Sum...' NOTE: Conditional Sum Wizard
	msotcidLookupWiz = 3520,		//(0,25) Label: '&Lookup...' NOTE: Lookup Wizard
	msotcidReportManager = 3521,		//(0,25) Label: '&Report Manager...' NOTE: Report Manager Add-in
	msotcidFileConvWiz = 3522,		//(0,25) Label: '&File Conversion...' NOTE: File Conversion Wizard
	msotcidTemplateWiz = 3523,		//(0,25) Label: 'Te&mplate Wizard...' NOTE: Template Wizard
	msotcidMoviePlay = 3524,		//(53,21) Label: '&Play' NOTE: Movie - Play
	msotcidMovieShowController = 3525,		//(53,22) Label: '&Show Controller' NOTE: Movie - Show Controller
	msotcidMovieLoop = 3526,		//(53,23) Label: '&Loop' NOTE: Movie - Loop
	msotcidMovieSetAsPosterFrame = 3527,		//(53,24) Label: '&Set as Poster Frame' NOTE: Movie - Set as Poster Frame
	msotcidInsertMovie = 3528,		//(53,25) Label: 'Mo&vie...' NOTE: Insert Movie
	msotcid51Borders = 3529,		//(53,26) Label: '&Borders'
	msotcid51CenterTab = 3530,		//(53,27) Label: '&Center Tab'
	msotcid51DecimalTab = 3531,		//(53,28) Label: '&Decimal Tab'
	msotcid51InsertComment = 3532,		//(53,29) Label: '&Insert Comment'
	msotcid51LeftTab = 3533,		//(54,0) Label: '&Left Tab'
	msotcid51PageBreak = 3534,		//(54,1) Label: '&Page Break'
	msotcid51PageLayout = 3535,		//(54,2) Label: '&Page Layout'
	msotcid51PrintPreview = 3536,		//(54,3) Label: '&Print Preview'
	msotcid51RightTab = 3537,		//(54,4) Label: '&Right Tab'
	msotcid51Subscript = 3538,		//(54,5) Label: '&Subscript'
	msotcid51Superscript = 3539,		//(54,6) Label: '&Superscript'
	msotcid51Symbol = 3540,		//(54,7) Label: '&Symbol'
	msotcid51Table = 3541,		//(54,8) Label: '&Table'
	msotcid51Undo = 3542,		//(54,9) Label: '&Undo'
	msotcidMacFuture3543 = 3543,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3544 = 3544,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidBackgroundToolbar = 3545,		//(4,28) Label: 'Bac&kground'
	msotcidShowWhiteSpace = 3546,		//(3,14) Label: 'Show White Sp&ace'
	msotcidFileOpenURL = 3547,		//(0,25) Label: 'Open Web Pa&ge...'
	msotcidMW5LeftTab = 3548,		//(0,25) Label: '&Left Tab'
	msotcidMW5CenterTab = 3549,		//(0,25) Label: '&Center Tab'
	msotcidMW5RightTab = 3550,		//(0,25) Label: '&Right Tab'
	msotcidMW5DecimalTab = 3551,		//(0,25) Label: '&Decimal Tab'
	msotcidFru = 3552,		//(0,25) Label: '&Find and Upgrade'
	msotcidFixSynonymSuggestionPlaceholder = 3553,		//(0,25) Label: '&Thesaurus Suggestions'
	msotcidRibbon = 3554,		//(0,25) Label: 'R&ibbon'
	msotcidSwitchToFrom51 = 3555,		//(0,25) Label: '&Word 5.1 Menus'
	msotcidNoThesSuggestions = 3556,		//(0,25) Label: '&Synonym Suggestions'
	msotcidRevealFormatting = 3557,		//(0,25) Label: 'Re&veal Formatting'
	msotcidShowMovieBar = 3558,		//(0,25) Label: 'Show &Movie Toolbar'
	msotcidHideMovieBar = 3559,		//(0,25) Label: 'Hide &Movie Toolbar'
	msotcid51ShowComment = 3560,		//(0,25) Label: '&Comment'
	msotcidMacFuture3561 = 3561,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3562 = 3562,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3563 = 3563,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3564 = 3564,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3565 = 3565,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3566 = 3566,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3567 = 3567,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3568 = 3568,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3569 = 3569,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3570 = 3570,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3571 = 3571,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3572 = 3572,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3573 = 3573,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3574 = 3574,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3575 = 3575,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3576 = 3576,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3577 = 3577,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3578 = 3578,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3579 = 3579,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3580 = 3580,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3581 = 3581,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3582 = 3582,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3583 = 3583,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3584 = 3584,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3585 = 3585,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3586 = 3586,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3587 = 3587,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3588 = 3588,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3589 = 3589,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3590 = 3590,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3591 = 3591,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3592 = 3592,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3593 = 3593,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3594 = 3594,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3595 = 3595,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3596 = 3596,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3597 = 3597,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3598 = 3598,		//(0,25) Label: '&[Command not available]' NOTE: reserved for future Mac versions
	msotcidMacFuture3599 = 3599,		//(0,25) Label: '&[Command not available]' NOTE: reserved for future Mac versions
	msotcidMacFuture3600 = 3600,		//(0,25) Label: '&[Command not available]' NOTE: reserved for future Mac versions
	msotcidMacFuture3601 = 3601,		//(0,25) Label: '&[Command not available]' NOTE: reserved for future Mac versions
	msotcidMacFuture3602 = 3602,		//(0,25) Label: '&[Command not available]' NOTE: reserved for future Mac versions
	msotcidMacFuture3603 = 3603,		//(0,25) Label: '&[Command not available]' NOTE: reserved for future Mac versions
	msotcidMacFuture3604 = 3604,		//(0,25) Label: '&[Command not available]' NOTE: reserved for future Mac versions
	msotcidMacFuture3605 = 3605,		//(0,25) Label: '&[Command not available]' NOTE: reserved for future Mac versions
	msotcidMacFuture3606 = 3606,		//(0,25) Label: '&[Command not available]' NOTE: reserved for future Mac versions
	msotcidMacFuture3607 = 3607,		//(0,25) Label: '&[Command not available]' NOTE: reserved for future Mac versions
	msotcidMacFuture3608 = 3608,		//(0,25) Label: '&[Command not available]' NOTE: reserved for future Mac versions
	msotcidMacFuture3609 = 3609,		//(0,25) Label: '&[Command not available]' NOTE: reserved for future Mac versions
	msotcidMacFuture3610 = 3610,		//(0,25) Label: '&[Command not available]' NOTE: reserved for future Mac versions
	msotcidMacFuture3611 = 3611,		//(0,25) Label: '&[Command not available]' NOTE: reserved for future Mac versions
	msotcidMacFuture3612 = 3612,		//(0,25) Label: '&[Command not available]' NOTE: reserved for future Mac versions
	msotcidMacFuture3613 = 3613,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3614 = 3614,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3615 = 3615,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3616 = 3616,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3617 = 3617,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidMacFuture3618 = 3618,		//(0,25) Label: '' NOTE: reserved for future Mac versions
	msotcidSlideMiniature4PerPage = 3619,		//(35,15) Label: '&Show positioning of 4-per-page handouts' NOTE: PPT Handout Master
	msotcidSlideMiniature9PerPage = 3620,		//(35,16) Label: '&Show positioning of 9-per-page handouts' NOTE: PPT Handout Master
	msotcidWebLayoutView = 3621,		//(4,19) Label: '&Web Layout' NOTE: Word Web Layout
	msotcidTinyIconWebView = 3622,		//(0,3) Label: '&Web Layout View'
	msotcidWebTheme = 3623,		//(4,29) Label: 'T&heme...'
	msotcidPasteAlternative = 3624,		//(1,8) Label: '&Paste Table' NOTE: on right mouse only, used when there are 2 contexts of paste
	msotcidPasteAsNestedTable = 3625,		//(1,8) Label: 'Paste as &Nested Table'
	msotcidDeleteHyperlink = 3626,		//(0,25) Label: '&Remove Hyperlink'
	msotcidVBASecurity = 3627,		//(0,25) Label: '&Security...'
	msotcidInsertScript = 3628,		//(0,25) Label: '&Insert Script'
	msotcidEditScript = 3629,		//(0,25) Label: 'V&iew Script'
	msotcidRemoveAllScripts = 3630,		//(0,25) Label: 'Remove All S&cripts'
	msotcidVisualScriptEnvironment = 3631,		//(5,12) Label: 'Microsoft Script &Editor' NOTE: Programmability
	msotcidPasteMRU = 3632,		//(0,25) Label: '&Empty' NOTE: collect and copy
	msotcidPasteAll = 3633,		//(39,10) Label: '&Paste All' NOTE: collect and copy
	msotcidPasteClear = 3634,		//(47,19) Label: '&Clear All' NOTE: collect and copy
	msotcidSxLabelDman = 3635,		//(0,25) Label: '&Drag Pivot Table fields from here' NOTE: pivot table
	msotcidSxFieldDman11 = 3636,		//(0,25) Label: '&Field 1' NOTE: pivot table
	msotcidSxFieldDman12 = 3637,		//(0,25) Label: '&Field 2' NOTE: pivot table
	msotcidSxFieldDman13 = 3638,		//(0,25) Label: '&Field 3' NOTE: pivot table
	msotcidSxFieldDman14 = 3639,		//(0,25) Label: '&Field 4' NOTE: pivot table
	msotcidSxFieldDman21 = 3640,		//(0,25) Label: '&Field 6' NOTE: pivot table
	msotcidSxFieldDman22 = 3641,		//(0,25) Label: '&Field 7' NOTE: pivot table
	msotcidSxFieldDman23 = 3642,		//(0,25) Label: '&Field 8' NOTE: pivot table
	msotcidSxFieldDman24 = 3643,		//(0,25) Label: '&Field 9' NOTE: pivot table
	msotcidSxFieldDman31 = 3644,		//(0,25) Label: '&Field 11' NOTE: pivot table
	msotcidSxFieldDman32 = 3645,		//(0,25) Label: '&Field 12' NOTE: pivot table
	msotcidSxFieldDman33 = 3646,		//(0,25) Label: '&Field 13' NOTE: pivot table
	msotcidSxFieldDman34 = 3647,		//(0,25) Label: '&Field 14' NOTE: pivot table
	msotcidSxUpArrowDman = 3648,		//(55,10) Label: '&Up Arrow' NOTE: pivot table
	msotcidSxEmptyDman = 3649,		//(0,25) Label: '' NOTE: pivot table
	msotcidSxDownArrowDman = 3650,		//(17,8) Label: '&Down Arrow' NOTE: pivot table
	msotcidFormatHorizRule = 3651,		//(68,21) Label: 'Horizontal &Line...'
	msotcidFormatHorizRule2 = 3652,		//(68,21) Label: 'Format Horizontal &Line'
	msotcidInsertHorizRule = 3653,		//(53,12) Label: 'Horizontal &Line...'
	msotcidInsertHorizRule2 = 3654,		//(53,12) Label: '&Horizontal Line'
	msotcidWebPagePreview = 3655,		//(3,12) Label: 'We&b Page Preview'
	msotcidOnOffAssistant = 3656,		//(0,25) Label: '&Turn On Assistant'
	msotcidBidiHelp = 3657,		//(0,25) Label: 'Bidirectional &Features' NOTE: bidi word97
	msotcidDictionaryCompleted = 3658,		//(0,25) Label: '&Dictionary Completed' NOTE: bidi word97
	msotcidBiLanguageSplitMenu = 3659,		//(0,25) Label: '&Keyboard Language' NOTE: bidi word97
	msotcidBiLanguageList = 3660,		//(0,25) Label: '&Bidi Language List' NOTE: bidi word97
	msotcidRtlRun = 3661,		//(0,25) Label: '&Rtl Run' NOTE: bidi word97
	msotcidLtrRun = 3662,		//(0,25) Label: '&Ltr Run' NOTE: bidi word97
	msotcidRTLMacroDialogs = 3663,		//(0,25) Label: '&RTL Macro Dialogs' NOTE: bidi word97
	msotcidLTRMacroDialogs = 3664,		//(0,25) Label: '&LTR Macro Dialogs' NOTE: bidi word97
	msotcidParaLTRBi = 3665,		//(0,25) Label: '&Para LTR Bi' NOTE: bidi word97
	msotcidParaRTLBi = 3666,		//(0,25) Label: '&Para RTL Bi' NOTE: bidi word97
	msotcidBidiKeyb = 3667,		//(0,25) Label: '&Bidi Keyboard' NOTE: bidi word97
	msotcidLatinKeyb = 3668,		//(0,25) Label: '&Latin Keyb' NOTE: bidi word97
	msotcidBoldRun = 3669,		//(0,25) Label: '&Bold Run' NOTE: bidi word97
	msotcidItalicRun = 3670,		//(0,25) Label: '&Italic Run' NOTE: bidi word97
	msotcidToolsOptionsBidi = 3671,		//(0,25) Label: '&Tools Options Bidi' NOTE: bidi word97
	msotcidPresAdvisorSuggest = 3672,		//(0,25) Label: '&Presentation Advisor Suggestion' NOTE: label is dynamic
	msotcidPresAdvisorIgnore = 3673,		//(0,25) Label: '&Ignore Rule'
	msotcidPresAdvisorDialog = 3674,		//(0,25) Label: '&Style Options...'
	msotcidSxFieldDman15 = 3675,		//(0,25) Label: '&Field 5' NOTE: pivot table
	msotcidSxFieldDman25 = 3676,		//(0,25) Label: '&Field 10' NOTE: pivot table
	msotcidSxFieldDman35 = 3677,		//(0,25) Label: '&Field 15' NOTE: pivot table
	msotcidSelectCell = 3678,		//(0,25) Label: 'Select C&ell' NOTE: word tables
	msotcidDeleteTable = 3679,		//(0,25) Label: 'Delete &Table' NOTE: word tables
	msotcidInsertTable = 3680,		//(1,14) Label: '&Table...' NOTE: word and PP tables
	msotcidInsertRowsAbove = 3681,		//(23,6) Label: 'Rows &Above' NOTE: word tables
	msotcidInsertRowsAbove2 = 3682,		//(23,6) Label: 'Insert Rows &Above' NOTE: word tables
	msotcidInsertRowsBelow = 3683,		//(23,7) Label: 'Rows &Below' NOTE: word tables
	msotcidInsertRowsBelow2 = 3684,		//(23,7) Label: 'Insert Rows &Below' NOTE: word tables
	msotcidInsertColumnsLeft = 3685,		//(23,9) Label: 'Columns to the &Left' NOTE: word tables
	msotcidInsertColumnsLeft2 = 3686,		//(23,9) Label: 'Insert Columns to the &Left' NOTE: word tables
	msotcidInsertColumnsRight = 3687,		//(23,10) Label: 'Columns to the &Right' NOTE: word tables
	msotcidInsertColumnsRight2 = 3688,		//(23,10) Label: 'Insert Columns to the &Right' NOTE: word tables
	msotcidShowScriptAnchor = 3689,		//(0,25) Label: 'Show &All Scripts'
	msotcidCollectCopy = 3690,		//(48,23) Label: 'Sho&w Clipboard' NOTE: collect and copy
	msotcidPasteStop = 3691,		//(0,25) Label: '&Close' NOTE: collect and copy
	msotcidToggleContextHelp = 3692,		//(0,25) Label: '&Toggle Context Help' NOTE: Word
	msotcidTableInsertPalette = 3693,		//(0,25) Label: '&Table Insert' NOTE: word tables
	msotcidWW8EditPaste = 3694,		//(0,25) Label: '&Paste' NOTE: word
	msotcidDeleteTable3 = 3695,		//(0,25) Label: '&Table' NOTE: word tables
	msotcidDeleteRows3 = 3696,		//(0,25) Label: '&Rows' NOTE: word tables
	msotcidDeleteColumns3 = 3697,		//(0,25) Label: '&Columns' NOTE: word tables
	msotcidSelectTable2 = 3698,		//(0,25) Label: '&Table' NOTE: word tables
	msotcidSelectRow2 = 3699,		//(0,25) Label: '&Row' NOTE: word tables
	msotcidSelectColumn2 = 3700,		//(0,25) Label: '&Column' NOTE: word tables
	msotcidSelectCell2 = 3701,		//(0,25) Label: 'C&ell' NOTE: word tables
	msotcidTextToTable2 = 3702,		//(0,25) Label: 'Te&xt to Table...' NOTE: word tables
	msotcidTableToText2 = 3703,		//(0,25) Label: 'Ta&ble to Text...' NOTE: word tables
	msotcidTableCellProperties = 3704,		//(0,25) Label: 'Table P&roperties...' NOTE: word tables
	msotcidTableOptions = 3705,		//(0,25) Label: 'Table &Options...' NOTE: word tables
	msotcidCellOptions = 3706,		//(0,25) Label: 'Cell &Options...' NOTE: word tables
	msotcidDeleteCells3 = 3707,		//(0,25) Label: 'C&ells...' NOTE: word tables
	msotcidEnvelopeSendNow = 3708,		//(61,12) Label: '&Send Now' NOTE: mail header
	msotcidEnvelopeSelectNames = 3709,		//(12,11) Label: '&Select Names' NOTE: mail header
	msotcidEnvelopeCheckNames = 3710,		//(67,25) Label: '&Check Names' NOTE: mail header
	msotcidEnvelopeFocusTo = 3711,		//(0,25) Label: '&To: Focus' NOTE: mail header
	msotcidEnvelopeFocusCc = 3712,		//(0,25) Label: '&CC: Focus' NOTE: mail header
	msotcidEnvelopeFocusBcc = 3713,		//(0,25) Label: '&Bcc: Focus' NOTE: mail header
	msotcidEnvelopeFocusSubject = 3714,		//(0,25) Label: '&Subject Focus' NOTE: mail header
	msotcidEnvelopeOptions = 3715,		//(24,9) Label: '&Mail Options' NOTE: mail header
	msotcidEnvelopeFlag = 3716,		//(7,22) Label: '&Mail Flag' NOTE: mail header
	msotcidEnvelopeSaveAttachment = 3717,		//(0,25) Label: '&Save Mail Attachments' NOTE: mail header
	msotcidFileNewMessage = 3718,		//(0,25) Label: '&New Message' NOTE: mail header
	msotcidCloseOrExit = 3719,		//(0,25) Label: '&Close or Exit' NOTE: hidden to switch between Word SDI close and exit
	msotcidIMEReconvert = 3720,		//(0,25) Label: 'Recon&vert'
	msotcidModifyComposeStyle = 3721,		//(0,25) Label: '&Modify your Compose Style'
	msotcidModifyReplyStyle = 3722,		//(0,25) Label: '&Modify your Reply Style'
	msotcidFormatTable = 3723,		//(68,21) Label: '&Table...' NOTE: ppt tables
	msotcidWebXL = 3724,		//(43,14) Label: '&Web Calc' NOTE: Access Control toolbox
	msotcidWebDB = 3725,		//(50,12) Label: '&Pivot List' NOTE: Access Control toolbox
	msotcidWebChart = 3726,		//(1,23) Label: '&Web Chart' NOTE: Access Control toolbox
	msotcidConference = 3727,		//(13,21) Label: '&Meet Now' NOTE: NetMeeting
	msotcidConfSendFile = 3728,		//(0,25) Label: '&Online Meeting Participant' NOTE: NetMeeting
	msotcidConfParticipants = 3729,		//(0,25) Label: '&Participant List' NOTE: NetMeeting
	msotcidConfAudio = 3730,		//(49,25) Label: 'A&udio' NOTE: NetMeeting
	msotcidConfVideo = 3731,		//(47,18) Label: '&Video' NOTE: NetMeeting
	msotcidConfAdd = 3732,		//(49,26) Label: '&Call Participant' NOTE: NetMeeting
	msotcidConfCollaborate = 3733,		//(49,27) Label: '&Allow Others to Edit' NOTE: NetMeeting
	msotcidConfRemove = 3734,		//(49,28) Label: '&Remove Participants' NOTE: NetMeeting
	msotcidConfChat = 3735,		//(49,29) Label: '&Display Chat Window' NOTE: NetMeeting
	msotcidConfWhiteboard = 3736,		//(50,0) Label: 'Display &Whiteboard' NOTE: NetMeeting
	msotcidConfEnd = 3737,		//(49,23) Label: '&End Meeting' NOTE: NetMeeting
	msotcidEnvelopeSend = 3738,		//(1,1) Label: '&Mail Recipient' NOTE: Show/Hide Mail Header command
	msotcidEnvelopeSendAsAttachment = 3739,		//(23,3) Label: 'M&ail Recipient (as Attachment)' NOTE: new command in 9?
	msotcidEnvelopeSendAsText = 3740,		//(23,11) Label: 'Ma&il Recipient (as Text)' NOTE: new command in 9?
	msotcidToolsBusu = 3741,		//(0,25) Label: 'Hanja &Radical Input...' NOTE: shipped with Word97 FE Korea
	msotcidHtmlResAnchor = 3742,		//(0,25) Label: '&HTML Res Anchor' NOTE: shipped with Word97, for W95 Macrobutton fields
	msotcidFramesetTOC = 3743,		//(52,19) Label: '&Table of Contents in Frame' NOTE: Word
	msotcidFixSpellingLang = 3744,		//(0,25) Label: '&Language' NOTE: shipped with Office97
	msotcidLangDropdown = 3745,		//(0,25) Label: '&Language' NOTE: shipped with Office97
	msotcidMailHeader = 3746,		//(0,25) Label: '&Envelope' NOTE: mail header item
	msotcidCommandBarOptions = 3747,		//(0,25) Label: '&Toolbar Options' NOTE: white widget dropdown at the end of toolbars
	msotcidDummy3748 = 3748,		//(0,25) Label: '&Dummy'
	msotcidDummy3749 = 3749,		//(0,25) Label: '&Dummy'
	msotcidResetToolbar = 3750,		//(0,25) Label: '&Reset Toolbar'
	msotcidTableWrapping = 3751,		//(0,25) Label: 'Table Wrappi&ng'
	msotcidAutoSigList = 3752,		//(0,25) Label: '&Open Signature'
	msotcidWordMailOptions = 3753,		//(0,25) Label: '&E-mail Options...'
	msotcidAddInsX = 3754,		//(0,25) Label: '&COM Add-Ins...'
	msotcidPlacesBarItem = 3755,		//(0,25) Label: '&Places Bar Item' NOTE: file open
	msotcidDummy3756 = 3756,		//(0,25) Label: '&Dummy'
	msotcidDummy3757 = 3757,		//(0,25) Label: '&Dummy'
	msotcidDummy3758 = 3758,		//(0,25) Label: '&Dummy'
	msotcidDummy3759 = 3759,		//(0,25) Label: '&Dummy'
	msotcidDummy3760 = 3760,		//(0,25) Label: '&Dummy'
	msotcidDummy3761 = 3761,		//(0,25) Label: '&Dummy'
	msotcidDummy3762 = 3762,		//(0,25) Label: '&Dummy'
	msotcidToolboxAddSnippet = 3763,		//(50,23) Label: '&Add Fragment'
	msotcidToolboxDelSnippet = 3764,		//(50,19) Label: '&Remove Fragment'
	msotcidToolboxSnippetA = 3765,		//(50,27) Label: '&Fragment -A'
	msotcidAutoSigOptions = 3766,		//(0,25) Label: '&E-mail Signature...'
	msotcidFramesetBorder = 3767,		//(0,25) Label: '&Frame Border'
	msotcidFramesetProperties = 3768,		//(52,7) Label: 'Frame &Properties...'
	msotcidFramesetTOCUpdate = 3769,		//(0,25) Label: 'Update Frame &Table of Contents' NOTE: Word
	msotcidOpenInBrowser = 3770,		//(0,25) Label: '&Open...'
	msotcidInsertPicInFile = 3771,		//(0,25) Label: '&Insert Picture...'
	msotcidRemoveHyperlink = 3772,		//(0,25) Label: '&Remove Link'
	msotcidSignMacros = 3773,		//(0,25) Label: 'Sig&n Macros...'
	msotcidFixMe = 3774,		//(0,25) Label: 'Detect and &Repair...'
	msotcidOfficeOnTheWeb = 3775,		//(0,25) Label: 'Office on the &Web'
	msotcidIMESetDefault = 3776,		//(0,25) Label: '&Change Default IME'
	msotcidIMECmdbarF1 = 3777,		//(23,12) Label: '&Function Key 1' NOTE: icons not accessible
	msotcidIMECmdbarF2 = 3778,		//(23,13) Label: '&Function Key 2' NOTE: icon not accessible
	msotcidIMECmdbarF3 = 3779,		//(23,15) Label: '&Function Key 3' NOTE: icon not accessible
	msotcidIMECmdbarF4 = 3780,		//(23,16) Label: '&Function Key 4' NOTE: icon not accessible
	msotcidIMECmdbarF5 = 3781,		//(23,17) Label: '&Function Key 5' NOTE: icon not accessible
	msotcidIMECmdbarF6 = 3782,		//(23,19) Label: '&Function Key 6' NOTE: icon not accessible
	msotcidIMECmdbarF7 = 3783,		//(23,22) Label: '&Function Key 7' NOTE: icon not accessible
	msotcidIMECmdbarF8 = 3784,		//(23,25) Label: '&Function Key 8' NOTE: icon not accessible
	msotcidIMECmdbarF9 = 3785,		//(24,1) Label: '&Function Key 9' NOTE: icon not accessible
	msotcidIMECmdbarF10 = 3786,		//(40,4) Label: '&Function Key 10' NOTE: icon not accessible
	msotcidIMECmdbarF11 = 3787,		//(48,25) Label: '&Function Key 11' NOTE: icon not accessible
	msotcidIMECmdbarF12 = 3788,		//(48,26) Label: '&Function Key 12' NOTE: icon not accessible
	msotcidSxChart = 3789,		//(1,23) Label: 'Pivot&Chart'
	msotcidSxShowFieldDman = 3790,		//(17,0) Label: '&Show Field List' NOTE: Pivot
	msotcidSaveFrameset = 3791,		//(1,0) Label: '&Save Frameset...'
	msotcidFileNewContext = 3792,		//(0,11) Label: '&New' NOTE: Word File new split dropdown
	msotcidInsertPictureBullet = 3793,		//(0,27) Label: '&Picture Bullets...'
	msotcidFileNewWeb = 3794,		//(60,24) Label: 'New &Web Page' NOTE: Word File new split dropdown
	msotcidFileNewEmail = 3795,		//(18,8) Label: 'New &E-mail Message' NOTE: Word File new split dropdown
	msotcidToolboxBkgImage = 3796,		//(0,25) Label: '&Background Image'
	msotcidDummy3797 = 3797,		//(0,25) Label: '&Dummy'
	msotcidToolboxAudio = 3798,		//(24,15) Label: '&Sound'
	msotcidToolboxVideo = 3799,		//(51,0) Label: '&Movie'
	msotcidToolboxMarquee = 3800,		//(50,25) Label: 'Sc&rolling Text'
	msotcidToolboxHTMLTable = 3801,		//(0,25) Label: '&HTML Table'
	msotcidDummy3802 = 3802,		//(0,25) Label: '&Dummy'
	msotcidToolboxHyperlinkTxt = 3803,		//(49,22) Label: '&Hyperlink'
	msotcidToolboxHyperlinkImg = 3804,		//(51,23) Label: 'Image &Hyperlink'
	msotcidDummy3805 = 3805,		//(0,25) Label: '&Dummy'
	msotcidDummy3806 = 3806,		//(0,25) Label: '&Dummy'
	msotcidDummy3807 = 3807,		//(0,25) Label: '&Dummy'
	msotcidDummy3808 = 3808,		//(0,25) Label: '&Dummy'
	msotcidDummy3809 = 3809,		//(0,25) Label: '&Dummy'
	msotcidDummy3810 = 3810,		//(0,25) Label: '&Dummy'
	msotcidNewStoredProcedure = 3811,		//(50,18) Label: 'Stor&ed Procedure' NOTE: Access Insert menu
	msotcidRefreshDBC = 3812,		//(0,25) Label: 'Re&fresh' NOTE: Access File menu
	msotcidFileNewPrint = 3813,		//(0,11) Label: 'New &Blank Document' NOTE: Word File new split dropdown
	msotcidFileNewDialog = 3814,		//(0,25) Label: '&Other...' NOTE: Word File new split dropdown
	msotcidDummy3815 = 3815,		//(0,25) Label: '&Dummy'
	msotcidNormalViewPPT = 3816,		//(44,25) Label: '&Normal' NOTE: PPT
	msotcidSynchronizeHTML = 3817,		//(5,7) Label: 'Refre&sh' NOTE: Programmability
	msotcidDummy3818 = 3818,		//(0,25) Label: '&Dummy' NOTE: Programmability
	msotcidIgnoreHTMLChanges = 3819,		//(51,14) Label: 'Do &Not Refresh' NOTE: Programmability
	msotcidBroadcastBegin = 3820,		//(60,10) Label: 'Start &Live Broadcast Now...' NOTE: PPT
	msotcidBroadcastSchedule = 3821,		//(55,9) Label: '&Schedule a Live Broadcast...' NOTE: PPT
	msotcidPastePaste = 3822,		//(0,25) Label: '&Paste:' NOTE: collect and copy
	msotcidSaveAsWebPage = 3823,		//(4,13) Label: 'Save as Web Pa&ge...' NOTE: publish
	msotcidInsertHorizRulePicture = 3824,		//(53,12) Label: 'Horizontal &Line...'
	msotcidWebServerDiscussionPrev = 3825,		//(23,1) Label: '&Previous' NOTE: Web Server discussions
	msotcidWebServerDiscussionNext = 3826,		//(23,2) Label: '&Next' NOTE: Web Server discussions
	msotcidMSWordFixGrammarIgnoreAll = 3827,		//(0,25) Label: 'Ignore &All...' NOTE: Word grammar
	msotcidNewDataPage = 3828,		//(9,5) Label: '&Page' NOTE: new data page
	msotcidNewWebQuery = 3829,		//(22,28) Label: 'New W&eb Query' NOTE: create new web query
	msotcidEnabled = 3830,		//(23,0) Label: '&Enabled' NOTE: Access Conditional Formatting dialog
	msotcidWebOptionsDialog = 3831,		//(0,25) Label: '&Web Options...' NOTE: cmd well only
	msotcidOpenOnDBC = 3832,		//(9,10) Label: '&Open' NOTE: open button on DBC toolbar
	msotcidFramesetWizard = 3833,		//(0,25) Label: '&New Frames Page' NOTE: Web Frames
	msotcidFrameCreateAbove = 3834,		//(54,15) Label: 'New Fra&me Above' NOTE: Web Frames
	msotcidFrameCreateBelow = 3835,		//(54,16) Label: 'New Frame &Below' NOTE: Web Frames
	msotcidFrameCreateLeft = 3836,		//(54,17) Label: 'New Frame &Left' NOTE: Web Frames
	msotcidFrameCreateRight = 3837,		//(54,18) Label: 'New Frame &Right' NOTE: Web Frames
	msotcidFrameRemoveSplit = 3838,		//(54,19) Label: '&Delete Frame' NOTE: Web Frames
	msotcidModifyPersonalStyle = 3839,		//(0,25) Label: '&Modify Personal Style' NOTE: WordMail
	msotcidPrintRelationships = 3840,		//(0,25) Label: 'Print &Relationships...' NOTE: Access file menu
	msotcidDummy3841 = 3841,		//(50,1) Label: '&Dummy' NOTE: Acess Insert menu
	msotcidNewView = 3842,		//(9,2) Label: '&View' NOTE: Access Insert menu
	msotcidDatabaseShowDatapages = 3843,		//(50,15) Label: '&Pages' NOTE: Access
	msotcidImportTextFile = 3844,		//(50,3) Label: 'Import &Text File...'
	msotcidRehearseTotalTime = 3845,		//(0,25) Label: '&Total Time' NOTE: PP slide show rehearsal toolbar
	msotcidRehearseSlideTime = 3846,		//(0,25) Label: '&Slide Time' NOTE: PP slide show rehearsal toolbar
	msotcidRehearseRepeat = 3847,		//(35,14) Label: '&Repeat' NOTE: PP slide show rehearsal toolbar
	msotcidRehearsePause = 3848,		//(50,4) Label: '&Pause' NOTE: PP slide show rehearsal toolbar
	msotcidRehearseNext = 3849,		//(50,5) Label: '&Next' NOTE: PP slide show rehearsal toolbar
	msotcidConnectDatabase = 3850,		//(0,25) Label: 'Connec&tion...'
	msotcidRemoveSubdatasheet = 3851,		//(0,25) Label: '&Remove'
	msotcidInsertSubdatasheet = 3852,		//(52,26) Label: '&Subdatasheet...'
	msotcidQuickCustom = 3853,		//(0,25) Label: '' NOTE: placeholder for Customize... on QC menu (can't use regular msotcidCustom here)
	msotcidFormatTable2 = 3854,		//(68,21) Label: 'Format &Table...' NOTE: PP table context menu
	msotcidViewDirLeftToRight = 3855,		//(0,25) Label: '&Left-to-Right' NOTE: BiDi
	msotcidViewDirRightToLeft = 3856,		//(0,25) Label: '&Right-to-Left' NOTE: BiDi
	msotcidDiagramNewTextAnnotation = 3857,		//(0,25) Label: '&New Label' NOTE: Access Diagram menu
	msotcidDiagramAddRelatedTables = 3858,		//(0,25) Label: '&Add Related Tables' NOTE: Access Diagram menu
	msotcidDiagramShowRelationshipLabels = 3859,		//(0,25) Label: '&Show Relationship Labels' NOTE: Access Diagram menu
	msotcidDiagramModifyUserDefinedView = 3860,		//(0,25) Label: 'Modify &Custom View' NOTE: Access Diagram menu
	msotcidDiagramViewPageBreaks = 3861,		//(0,25) Label: '&View Page Breaks' NOTE: Access Diagram menu
	msotcidDiagramRecalculatePageBreaks = 3862,		//(0,25) Label: '&Recalculate Page Breaks' NOTE: Access Diagram menu
	msotcidDiagramAutosizeSelectedLabels = 3863,		//(0,25) Label: 'A&utosize Selected Labels' NOTE: Access Diagram menu
	msotcidDiagramLayoutSelection = 3864,		//(0,25) Label: 'Arran&ge Selection' NOTE: Access
	msotcidDiagramLayoutDiagram = 3865,		//(0,25) Label: 'Arrange &Tables' NOTE: Access Diagram menu
	msotcidDiagramNewTable = 3866,		//(0,25) Label: 'New Ta&ble' NOTE: Access Diagram menu
	msotcidDiagramShowTables = 3867,		//(0,25) Label: 'S&how Tables...' NOTE: Access Diagram menu
	msotcidDiagramPaste = 3868,		//(0,25) Label: '&Paste' NOTE: Access Diagram menu
	msotcidDiagramSelectAll = 3869,		//(0,25) Label: 'Select &All' NOTE: Access Diagram menu
	msotcidDiagramZoom = 3870,		//(0,25) Label: '&Zoom' NOTE: Access Diagram menu
	msotcidDiagramProperties = 3871,		//(0,25) Label: 'Pr&operties' NOTE: Access Diagram menu
	msotcidDiagramColumnProperties = 3872,		//(54,14) Label: '&Column Properties' NOTE: Access Diagram menu
	msotcidDiagramColumnNames = 3873,		//(54,10) Label: 'Colu&mn Names' NOTE: Access Diagram menu
	msotcidDiagramKeys = 3874,		//(54,11) Label: '&Keys' NOTE: Access Diagram menu
	msotcidDiagramNameOnly = 3875,		//(54,12) Label: '&Name Only' NOTE: Access Diagram menu
	msotcidDiagramUserDefined = 3876,		//(54,13) Label: 'Custom &View' NOTE: Access Diagram menu
	msotcidDiagramPrimaryKey = 3877,		//(0,25) Label: 'P&rimary Key' NOTE: Access Diagram menu
	msotcidDiagramInsertRows = 3878,		//(0,25) Label: '&Insert Rows' NOTE: Access Diagram menu
	msotcidDiagramDeleteRows = 3879,		//(0,25) Label: 'D&elete Rows' NOTE: Access Diagram menu
	msotcidDiagramDeleteTable = 3880,		//(0,25) Label: 'D&elete Table from Database' NOTE: Access Diagram menu
	msotcidDiagramHideTable = 3881,		//(24,12) Label: '&Hide Table' NOTE: Access Diagram menu
	msotcidDiagramAutosizeSelectedTables = 3882,		//(0,25) Label: 'Autosi&ze Selected Tables' NOTE: Access Diagram menu
	msotcidDiagramZoomSelection = 3883,		//(0,25) Label: 'Zoom &Selection' NOTE: Access Diagram menu
	msotcidDiagramDeleteRelationship = 3884,		//(0,25) Label: 'Dele&te Relationship from Database' NOTE: Access Diagram menu
	msotcidUserDatapage = 3885,		//(50,15) Label: '&Web Page' NOTE: Access overwrites the string
	msotcidUserView = 3886,		//(50,20) Label: '&View' NOTE: Access overwrites the string
	msotcidDummy3887 = 3887,		//(0,25) Label: '&Dummy' NOTE: DO NOT USE; this was horse-traded with UserDiagram (3983) and Access will probably not be happy if you reuse this TCID
	msotcidUserStoredProcedure = 3888,		//(52,4) Label: 'S&tored Procedure' NOTE: Access overwrites the string
	msotcidMoreAutoShapes = 3889,		//(50,6) Label: '&More AutoShapes...'
	msotcidInsertBackgroundSound = 3890,		//(50,7) Label: '&Sound...'
	msotcidInsertBackgroundImage = 3891,		//(50,8) Label: '&Picture...'
	msotcidInsertWebRecalcGrid = 3892,		//(50,9) Label: 'Office &Spreadsheet'
	msotcidInsert2dRegions = 3893,		//(50,10) Label: '&Unbound Section'
	msotcidInsertPivotList = 3894,		//(50,12) Label: 'Office Piv&otTable'
	msotcidInsertWebChart = 3895,		//(1,23) Label: 'Office C&hart'
	msotcidSelectWebPage = 3896,		//(0,25) Label: 'Select Pa&ge'
	msotcidInsertVBDataGrid = 3897,		//(50,14) Label: 'Data&Grid'
	msotcidNextPane = 3898,		//(0,25) Label: 'Next &Pane' NOTE: on system menu to change active pane
	msotcidMoveSplitterBar = 3899,		//(0,25) Label: 'Move S&plit' NOTE: on document window's system menu, for arrow key nudging of splitter bars in Normal View
	msotcidFEParagraphMark = 3900,		//(42,21) Label: '&Show/Hide Editing Marks' NOTE: Word uses a different show 
	msotcidMSWordFixGrammarIgnoreError = 3901,		//(0,25) Label: '&Ignore' NOTE: johnwana added this
	msotcidViewHTMLSource = 3902,		//(0,25) Label: 'HTML Sourc&e' NOTE: launches VSE
	msotcidFilePublishAsWebPage = 3903,		//(47,13) Label: 'Publis&h as Web Page...' NOTE: only in the command well, not the default menus
	msotcidToolboxDynaLink = 3904,		//(52,15) Label: '&Bound Hyperlink'
	msotcidToolboxReadOnlyHTML = 3905,		//(16,2) Label: '&Bound HTML'
	msotcidToolboxReadOnlyText = 3906,		//(50,21) Label: '&Bound Span'
	msotcidTableAutoFitContent = 3907,		//(8,25) Label: 'Auto&Fit to Contents' NOTE: icon
	msotcidTableAutoFitWindow = 3908,		//(50,22) Label: 'AutoFit to &Window' NOTE: icon
	msotcidTableAutoFitNormal = 3909,		//(52,13) Label: 'Fi&xed Column Width' NOTE: icon
	msotcidTableAutoFitFixed = 3910,		//(0,25) Label: 'Fi&xed Width' NOTE: icon
	msotcidUnderlineColor = 3911,		//(51,15) Label: '&Underline Color' NOTE: mskim
	msotcidUnderlineColorAutomaticSwatch = 3912,		//(0,25) Label: '&Automatic' NOTE: mskim
	msotcidUnderlineColorPickerSwatch = 3913,		//(0,25) Label: '&Color' NOTE: mskim
	msotcidAlignTableCellTopLeft = 3914,		//(52,14) Label: '&Align Top Left' NOTE: icon
	msotcidAlignTableCellTopCenter = 3915,		//(52,5) Label: '&Align Top Center' NOTE: icon
	msotcidAlignTableCellTopRight = 3916,		//(52,16) Label: '&Align Top Right' NOTE: icon
	msotcidAlignTableCellMiddleLeft = 3917,		//(52,17) Label: '&Align Center Left' NOTE: icon
	msotcidAlignTableCellMiddleCenter = 3918,		//(50,29) Label: '&Align Center' NOTE: icon
	msotcidAlignTableCellMiddleRight = 3919,		//(52,6) Label: '&Align Center Right' NOTE: icon
	msotcidAlignTableCellBottomLeft = 3920,		//(51,1) Label: '&Align Bottom Left' NOTE: icon
	msotcidAlignTableCellBottomCenter = 3921,		//(51,2) Label: '&Align Bottom Center' NOTE: icon
	msotcidAlignTableCellBottomRight = 3922,		//(51,3) Label: '&Align Bottom Right' NOTE: icon
	msotcidAlignVertTableCellTopLeft = 3923,		//(51,4) Label: '&Align Top Left' NOTE: icon
	msotcidAlignVertTableCellTopCenter = 3924,		//(51,5) Label: '&Align Top Center' NOTE: icon
	msotcidAlignVertTableCellTopRight = 3925,		//(51,6) Label: '&Align Top Right' NOTE: icon
	msotcidAlignVertTableCellMiddleLeft = 3926,		//(51,7) Label: '&Align Center Left' NOTE: icon
	msotcidAlignVertTableCellMiddleCenter = 3927,		//(51,8) Label: '&Align Center' NOTE: icon
	msotcidAlignVertTableCellMiddleRight = 3928,		//(51,9) Label: '&Align Center Right' NOTE: icon
	msotcidAlignVertTableCellBottomLeft = 3929,		//(51,10) Label: '&Align Bottom Left' NOTE: icon
	msotcidAlignVertTableCellBottomCenter = 3930,		//(51,11) Label: '&Align Bottom Center' NOTE: icon
	msotcidAlignVertTableCellBottomRight = 3931,		//(51,12) Label: '&Align Bottom Right' NOTE: icon
	msotcidAlignTableCellTopLeftJust = 3932,		//(51,13) Label: '&Align Top Justified' NOTE: icon
	msotcidDummy3933 = 3933,		//(0,25) Label: '&Dummy'
	msotcidDummy3934 = 3934,		//(0,25) Label: '&Dummy'
	msotcidAlignVertTableCellTopLeftJust = 3935,		//(51,16) Label: '&Align Justified Left' NOTE: icon
	msotcidAlignVertTableCellTopCenterJust = 3936,		//(51,17) Label: '&Align Justified Center' NOTE: icon
	msotcidAlignVertTableCellTopRightJust = 3937,		//(51,18) Label: '&Align Justified Right' NOTE: icon
	msotcidServerQuickFilter = 3938,		//(51,19) Label: 'A&pply Server Filter' NOTE: icon
	msotcidHTMLCheckbox = 3939,		//(38,12) Label: '&Checkbox' NOTE: icon Word -- HTML forms toolbar
	msotcidHTMLOptionButton = 3940,		//(38,16) Label: '&Option Button' NOTE: icon Word -- HTML forms toolbar
	msotcidHTMLDropdownBox = 3941,		//(38,18) Label: '&Drop-Down Box' NOTE: icon Word -- HTML forms toolbar
	msotcidHTMLListBox = 3942,		//(38,17) Label: '&List Box' NOTE: icon Word -- HTML forms toolbar
	msotcidHTMLTextbox = 3943,		//(38,14) Label: '&Textbox' NOTE: icon Word -- HTML forms toolbar
	msotcidHTMLTextArea = 3944,		//(51,25) Label: 'T&ext Area' NOTE: icon Word -- HTML forms toolbar
	msotcidHTMLSubmit = 3945,		//(51,26) Label: '&Submit' NOTE: icon Word -- HTML forms toolbar
	msotcidHTMLImageSubmit = 3946,		//(51,27) Label: 'Submit with &Image' NOTE: icon Word -- HTML forms toolbar
	msotcidHTMLReset = 3947,		//(51,28) Label: '&Reset' NOTE: icon Word -- HTML forms toolbar
	msotcidHTMLHidden = 3948,		//(51,29) Label: '&Hidden' NOTE: icon Word -- HTML forms toolbar
	msotcidHTMLPassword = 3949,		//(52,0) Label: '&Password' NOTE: icon Word -- HTML forms toolbar
	msotcidDummy3950 = 3950,		//(0,25) Label: '&Dummy' NOTE: replaced by ToolboxVideo
	msotcidDummy3951 = 3951,		//(0,25) Label: '&Dummy' NOTE: replaced by ToolboxAudio
	msotcidDummy3952 = 3952,		//(0,25) Label: '&Dummy' NOTE: replaced by ToolboxMarquee
	msotcidUnderlineMoreColors = 3953,		//(0,25) Label: '&More Colors...' NOTE: mskim
	msotcidSetLTRTable = 3954,		//(50,26) Label: 'Set &Left-to-Right Table' NOTE: icon PPT
	msotcidSetRTLTable = 3955,		//(50,28) Label: 'Set &Right-to-Left Table' NOTE: icon PPT
	msotcidHidePivotChartFields = 3956,		//(0,25) Label: '&Hide Pivot Fields' NOTE: on above context menu -- allows user to hide all pivot table buttons on a pivot chart
	msotcidWebDiscussions = 3957,		//(0,25) Label: '&Web Discussions' NOTE: no icon WORD
	msotcidTCSCTranslator = 3958,		//(0,25) Label: 'Chi&nese Translation...' NOTE: Word -- Chinese translator.
	msotcidHanjaDictionary = 3959,		//(0,25) Label: 'Hanja Di&ctionary...' NOTE: noicon WORD
	msotcidJapaneseInput = 3960,		//(0,25) Label: 'Japane&se Input...' NOTE: noicon WORD
	msotcidTableWizard = 3961,		//(0,25) Label: 'Insert M&ultidiagonal Cell...' NOTE: noicon WORD
	msotcidUnderlineStyle = 3962,		//(0,22) Label: '&Underline' NOTE: mskim
	msotcidFormatTatenakayoko = 3963,		//(0,25) Label: 'Horizon&tal in Vertical...' NOTE: noicon Word FE Format - AsianLayout Menu item
	msotcidFormatWarichu = 3964,		//(0,25) Label: 'T&wo Lines in One...' NOTE: noicon Word FE Format - AsianLayout Menu item
	msotcidAccessRevert = 3965,		//(0,25) Label: '&Revert' NOTE: Access -- menu item to revert an open
	msotcidDummy3966 = 3966,		//(0,25) Label: '&Dummy' NOTE: reuse, but not in Access!
	msotcidAccessViewWebPageProps = 3967,		//(0,25) Label: 'Page P&roperties' NOTE: icon Access -- show MSO doc properties for Web Page
	msotcidAccessSelectWebPage = 3968,		//(0,25) Label: 'Select Web Pa&ge' NOTE: no icon Access -- used to select the BODY of the Web Page
	msotcidEncloseChar = 3969,		//(52,18) Label: '&Enclose Characters...' NOTE: mskim
	msotcidAccessDBCAddToGroup = 3970,		//(0,25) Label: 'Add &To Group...' NOTE: no icon Access -- item to add a dbc object to a particular group
	msotcidServerFormFilter = 3971,		//(52,11) Label: 'Ser&ver Filter by Form' NOTE: icon Access: Records
	msotcidEnvelopeWizard = 3972,		//(0,25) Label: 'Chinese En&velope Wizard...' NOTE: no icon Word
	msotcidPPTResumeSlideShow = 3973,		//(0,25) Label: '&Resume Slide Show' NOTE: Powerpoint multiple monitor support during slide show
	msotcidAccessSaveAs97 = 3974,		//(0,25) Label: 'To &Prior Access Database Version...' NOTE: erical
	msotcidDatabaseShowDiagrams = 3975,		//(50,16) Label: '&Diagrams'
	msotcidDatabaseShowViews = 3976,		//(50,20) Label: '&Views'
	msotcidDatabaseShowStoredProcedures = 3977,		//(52,4) Label: '&Stored Procedures'
	msotcidViewVerifySQLSyntax = 3978,		//(52,22) Label: 'Verify SQL Synta&x'
	msotcidDiagramFitToSelection = 3979,		//(0,25) Label: '&Fit to Selection'
	msotcidTableModesDropdown = 3980,		//(0,25) Label: '&Table Modes Dropdown' NOTE: reuse, but not in Access!
	msotcidZoomModesDropdown = 3981,		//(52,24) Label: '&Zoom Modes Dropdown'
	msotcidNewDiagram = 3982,		//(52,25) Label: '&Diagram' NOTE: Access insert menu
	msotcidUserDiagram = 3983,		//(50,16) Label: '&Diagram' NOTE: Access overwrites the string
	msotcidViewDesign = 3984,		//(9,11) Label: 'View &Design' NOTE: reuse, but not in Access!
	msotcidStoredProcedureDesign = 3985,		//(9,11) Label: 'Stored Procedure &Design' NOTE: reuse, but not in Access!
	msotcidExpandAllSubdatasheets = 3986,		//(52,29) Label: '&Expand All'
	msotcidCollapseAllSubdatasheets = 3987,		//(53,0) Label: '&Collapse All'
	msotcidLaunchSlicer = 3988,		//(0,25) Label: 'Off&line OLAP...' NOTE: on Excel's Pivot Table toolbar
	msotcidLangWithDictionary = 3989,		//(1,5) Label: '&Language' NOTE: language dropdown same icon as msotcidSpelling
	msotcidMultiSelect = 3990,		//(53,2) Label: '&Select Multiple Objects' NOTE: Escher button in Customize-Commands-Drawing
	msotcidSpecialEffectNone = 3991,		//(53,3) Label: '&Special Effect: None' NOTE: Border style dropdown for datapages
	msotcidSpecialEffectDouble = 3992,		//(53,4) Label: '&Special Effect: Double' NOTE: Border style dropdown for datapages
	msotcidSpecialEffectRidged = 3993,		//(53,5) Label: '&Special Effect: Ridged' NOTE: Border style dropdown for datapages
	msotcidGroupByTable = 3994,		//(53,6) Label: '&Group by Table' NOTE: Datapages
	msotcidQuickDatapage = 3995,		//(53,7) Label: 'AutoPa&ge' NOTE: goes with QuickForm and QuickReport on the Insert Menu
	msotcidLinkedTableManager = 3996,		//(0,25) Label: '&Linked Table Manager'
	msotcidSCTCTranslate = 3997,		//(3,9) Label: 'Translate to &Traditional Chinese'
	msotcidShowGrammarExplain = 3998,		//(0,19) Label: 'A&bout This Sentence'
	msotcidAddGrammarDictionary = 3999,		//(0,25) Label: '&Add to Dictionary'
	};

enum
	{
	msotcidTextWrapBehind = 4000,		//(53,10) Label: 'Behin&d Text'
	msotcidTextWrapFront = 4001,		//(53,11) Label: 'I&n Front of Text'
	msotcidPivotChartSeriesShowDetail = 4002,		//(0,25) Label: 'Sho&w Detail'
	msotcidFormatBackgroundWatermark = 4003,		//(0,25) Label: 'Printed &Watermark...'
	msotcidFileSaveFrameAs = 4004,		//(1,0) Label: 'S&ave Current Frame As...' NOTE: text popup menu only showing when in a frameset allows user to save current frame only
	msotcidAccessEncapsulateData = 4005,		//(53,13) Label: '&Encapsulate Data' NOTE: Toolbar button for encapsulating data
	msotcidTableSelectAllColumns = 4006,		//(0,25) Label: '&Select All Columns'
	msotcidViewLeftJoinSelectAll = 4007,		//(0,25) Label: '&Select All Rows from <tableA>'
	msotcidViewRightJoinSelectAll = 4008,		//(0,25) Label: 'S&elect All Rows from <tableB>'
	msotcidViewTableRemove = 4009,		//(53,14) Label: 'Remo&ve'
	msotcidViewGroupBy = 4010,		//(53,15) Label: '&Group By'
	msotcidViewHidePane = 4011,		//(0,25) Label: '&Hide Pane'
	msotcidViewShowDiagramPane = 4012,		//(53,16) Label: '&Diagram'
	msotcidViewShowGridPane = 4013,		//(53,17) Label: '&Grid'
	msotcidViewShowSQLPane = 4014,		//(53,18) Label: '&SQL'
	msotcidViewAddToOutput = 4015,		//(0,25) Label: 'Add to &Output'
	msotcidViewSortAscending = 4016,		//(1,21) Label: 'Sort &Ascending'
	msotcidViewSortDescending = 4017,		//(1,22) Label: 'Sort &Descending'
	msotcidDatabaseSplitter = 4018,		//(0,25) Label: '&Database Splitter'
	msotcidPartialReplica = 4019,		//(0,25) Label: '&Partial Replica Wizard'
	msotcidWebToolbox = 4020,		//(0,25) Label: '&Web Toolbox'
	msotcidTextDirectionContext = 4021,		//(24,25) Label: '&Context' NOTE:  XL BIDI context dependent reading order
	msotcidTunnelToFormatFont = 4022,		//(0,25) Label: '&Font...' NOTE: label supposedly never seen by user -- contact TakeS
	msotcidTunnelToFormatColumns = 4023,		//(0,25) Label: '&Columns...' NOTE: label supposedly never seen by user -- contact TakeS
	msotcidTunnelToSnapToGrid = 4024,		//(0,25) Label: '&Grid...' NOTE: label supposedly never seen by user -- contact TakeS
	msotcidTCSCTranslate = 4025,		//(53,19) Label: 'Translate to &Simplified Chinese'
	msotcidChineseTranslator = 4026,		//(3,9) Label: 'Chinese T&ranslation...'
	msotcidReadingOrderMenu = 4027,		//(0,25) Label: '&Text Direction' NOTE: XL Bidi, context-dependent reading order
	msotcidDotAccentBelow = 4028,		//(10,27) Label: '&Dot Accent' NOTE: under dot and over dot for FE
	msotcidAlignTableCellBottomLeftJust = 4029,		//(38,10) Label: '&Align Bottom Justified' NOTE: Alignment toolbar
	msotcidAlignTableCellMiddleLeftJust = 4030,		//(38,11) Label: '&Align Center Justified' NOTE: Alignment toolbar
	msotcidShowConsistency = 4031,		//(51,21) Label: '&Show Related Words' NOTE: icon, Word
	msotcidShowAllConsistency = 4032,		//(51,21) Label: '&Show Related Words' NOTE: icon, Word
	msotcidTriggerEditor = 4033,		//(53,1) Label: '&Triggers...' NOTE: noicon, Access
	msotcidWebDesignMode = 4034,		//(0,25) Label: 'Web &Design Mode' NOTE: Word, Identical to msotcidToggleDesignMode
	msotcidSymbolBarChar1 = 4035,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar2 = 4036,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar3 = 4037,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar4 = 4038,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar5 = 4039,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar6 = 4040,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar7 = 4041,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar8 = 4042,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar9 = 4043,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar10 = 4044,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar11 = 4045,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar12 = 4046,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar13 = 4047,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar14 = 4048,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar15 = 4049,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar16 = 4050,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar17 = 4051,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar18 = 4052,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar19 = 4053,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar20 = 4054,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar21 = 4055,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar22 = 4056,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar23 = 4057,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar24 = 4058,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar25 = 4059,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar26 = 4060,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar27 = 4061,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar28 = 4062,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar29 = 4063,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar30 = 4064,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar31 = 4065,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar32 = 4066,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar33 = 4067,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar34 = 4068,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar35 = 4069,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar36 = 4070,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar37 = 4071,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar38 = 4072,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar39 = 4073,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolBarChar40 = 4074,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidSymbolPanel = 4075,		//(0,25) Label: '&Symbol' NOTE: noicon, Word
	msotcidInsertSpecialSymbol = 4076,		//(53,9) Label: 'Special S&ymbol' NOTE: icon, Word
	msotcidFixSynonymChange = 4077,		//(0,25) Label: '&Synonyms' NOTE: noicon, Word
	msotcidMoreDBCGroups = 4078,		//(0,25) Label: '&More Groups...' NOTE: noicon, Access
	msotcidNewDBCGroup = 4079,		//(0,25) Label: '&New Group...' NOTE: noicon, Access
	msotcidCreateNewDBCGroup = 4080,		//(0,25) Label: '&Create New Group' NOTE: noicon, Access
	msotcidRenameDBCGroup = 4081,		//(0,25) Label: 'Rena&me Group...' NOTE: noicon, Access
	msotcidDeleteDBCGroup = 4082,		//(0,25) Label: '&Delete Group' NOTE: noicon, Access
	msotcidDBCCustomGroupList = 4083,		//(60,16) Label: '&Custom Group List' NOTE: noicon, Access - text never appears
	msotcidToggleParaDir = 4084,		//(0,25) Label: '&Paragraph Direction' NOTE: noicon, Word
	msotcidDMBackBtn = 4085,		//(6,12) Label: '&Back' NOTE: Back button for FileOpen
	msotcidDMParentFolderBtn = 4086,		//(6,13) Label: '&Up One Level' NOTE: Up dir button for FileOpen
	msotcidDMSearchWebBtn = 4087,		//(6,14) Label: '&Search the Web' NOTE: Search the web button for FileOpen
	msotcidDMNewFolderBtn = 4088,		//(0,18) Label: '&Create New Folder' NOTE: New Folder button for file open
	msotcidDMOpenBtn = 4089,		//(0,25) Label: '&Open' NOTE: Open button for the dropdown in FileOpen
	msotcidDMOpenRO = 4090,		//(0,25) Label: 'Open &Read-Only' NOTE: Open Read Only button for the dropdown in FileOpen
	msotcidDMOpenAsCopy = 4091,		//(0,25) Label: 'Open as &Copy' NOTE: Open as Copy button for the dropdown in FileOpen
	msotcidDMSorting = 4092,		//(0,25) Label: '&Sorting...' NOTE: Item for the FileOpen tools menu
	msotcidDMIncludeSubfolders = 4093,		//(0,25) Label: 'Searc&h Subfolders' NOTE: Item for the FileOpen tools menu
	msotcidDMShowGroups = 4094,		//(0,25) Label: '&Group files by folder' NOTE: Item for the FileOpen tools menu
	msotcidDMFTPSites = 4095,		//(0,25) Label: 'Add/Modify &FTP Locations...' NOTE: Item for the FileOpen tools menu
	msotcidDMToggleFuzzy = 4096,		//(0,25) Label: '&Fuzzy Find' NOTE: Item for the FileOpen tools menu
	msotcidDMOpenInBrowser = 4097,		//(0,25) Label: 'Open in &Browser' NOTE: Item for the FileOpen tools menu
	msotcidDMOpenInNativeApp = 4098,		//(0,25) Label: 'Open in &Current Application' NOTE: Item for the FileOpen tools menu
	msotcidDMFind = 4099,		//(4,16) Label: '&Find...' NOTE: Item for the FileOpen tools menu
	msotcidDMDeleteBtn = 4100,		//(6,3) Label: '&Delete' NOTE: Item for the FileOpen tools menu
	msotcidDMRename = 4101,		//(0,25) Label: 'Rena&me' NOTE: Item for the FileOpen tools menu
	msotcidDMPrint = 4102,		//(0,25) Label: '&Print' NOTE: Item for the FileOpen tools menu
	msotcidDMAddToFavs = 4103,		//(0,25) Label: 'Add to F&avorites' NOTE: Item for the FileOpen tools menu
	msotcidDMAddToPlaces = 4104,		//(0,25) Label: 'Add to My P&laces' NOTE: Item for the FileOpen tools menu
	msotcidDMMapNetworkDrive = 4105,		//(0,25) Label: 'Map N&etwork Drive...' NOTE: Item for the FileOpen tools menu
	msotcidDMProperties = 4106,		//(0,25) Label: 'Pr&operties' NOTE: Item for the FileOpen tools menu
	msotcidDMAppTools1 = 4107,		//(0,25) Label: '&Tools' NOTE: App custom item for the FileOpen tools menu
	msotcidDMAppTools2 = 4108,		//(0,25) Label: '&Tools' NOTE: App custom item for the FileOpen tools menu
	msotcidDMAppTools3 = 4109,		//(0,25) Label: '&Tools' NOTE: App custom item for the FileOpen tools menu
	msotcidDMAppTools4 = 4110,		//(0,25) Label: '&Tools' NOTE: App custom item for the FileOpen tools menu
	msotcidDMAppTools5 = 4111,		//(0,25) Label: '&Tools' NOTE: App custom item for the FileOpen tools menu
	msotcidDMAppTools6 = 4112,		//(0,25) Label: '&Tools' NOTE: App custom item for the FileOpen tools menu
	msotcidDMAppTools7 = 4113,		//(0,25) Label: '&Tools' NOTE: App custom item for the FileOpen tools menu
	msotcidDMAppTools8 = 4114,		//(0,25) Label: '&Tools' NOTE: App custom item for the FileOpen tools menu
	msotcidDMAppTools9 = 4115,		//(0,25) Label: '&Tools' NOTE: App custom item for the FileOpen tools menu
	msotcidDMOpenDropdn1 = 4116,		//(0,25) Label: '&Open Button' NOTE: App custom item for the FileOpen open button menu
	msotcidDMOpenDropdn2 = 4117,		//(0,25) Label: '&Open Button' NOTE: App custom item for the FileOpen open button menu
	msotcidDMOpenDropdn3 = 4118,		//(0,25) Label: '&Open Button' NOTE: App custom item for the FileOpen open button menu
	msotcidDMOpenDropdn4 = 4119,		//(0,25) Label: '&Open Button' NOTE: App custom item for the FileOpen open button menu
	msotcidDMOpenDropdn5 = 4120,		//(0,25) Label: '&Open Button' NOTE: App custom item for the FileOpen open button menu
	msotcidDMOpenDropdn6 = 4121,		//(0,25) Label: '&Open Button' NOTE: App custom item for the FileOpen open button menu
	msotcidDMOpenDropdn7 = 4122,		//(0,25) Label: '&Open Button' NOTE: App custom item for the FileOpen open button menu
	msotcidDMOpenDropdn8 = 4123,		//(0,25) Label: '&Open Button' NOTE: App custom item for the FileOpen open button menu
	msotcidDMOpenDropdn9 = 4124,		//(0,25) Label: '&Open Button' NOTE: App custom item for the FileOpen open button menu
	msotcidDMViewList = 4125,		//(54,28) Label: '&List' NOTE: List on the FileOpen Tools View menu
	msotcidDMViewDetails = 4126,		//(54,29) Label: '&Details' NOTE: Details on the FileOpen Tools View menu
	msotcidDMViewProperties = 4127,		//(55,0) Label: 'P&roperties' NOTE: Properties on the FileOpen Tools View menu
	msotcidDMViewPreview = 4128,		//(54,21) Label: 'Pre&view' NOTE: Preview on the FileOpen Tools View menu
	msotcidDMArrangeByName = 4129,		//(0,25) Label: 'by &Name' NOTE: Item on the FileOpen Tools View ArrangeIcons menu
	msotcidDMArrangeByType = 4130,		//(0,25) Label: 'by &Type' NOTE: Item on the FileOpen Tools View ArrangeIcons menu
	msotcidDMArrangeBySize = 4131,		//(0,25) Label: 'by Si&ze' NOTE: Item on the FileOpen Tools View ArrangeIcons menu
	msotcidDMArrangeByDate = 4132,		//(0,25) Label: 'by &Date' NOTE: Item on the FileOpen Tools View ArrangeIcons menu
	msotcidBackupDatabase = 4133,		//(0,25) Label: '&Backup SQL Database...' NOTE: Item on tools DatabaseUtilities menu
	msotcidRestoreDatabase = 4134,		//(0,25) Label: '&Restore SQL Database...' NOTE: Item on tools DatabaseUtilities menu
	msotcidMakeADEFile = 4135,		//(0,25) Label: 'Make &ADE File...' NOTE: Item on tools DatabaseUtilities menu
	msotcidDropSQLDb = 4136,		//(0,25) Label: '&Drop SQL Database...' NOTE: Item on tools DatabaseUtilities menu
	msotcidReplCreatePublication = 4137,		//(0,25) Label: '&Create Publication...' NOTE: Item on tools Replication menu
	msotcidReplPullSubscription = 4138,		//(0,25) Label: 'P&ull Subscription...' NOTE: Item on tools Replication menu
	msotcidReplPushSubscription = 4139,		//(0,25) Label: 'Pus&h Subscription...' NOTE: Item on tools Replication menu
	msotcidReplSubscriptionProperties = 4140,		//(0,25) Label: 'Su&bscription Properties...' NOTE: Item on tools Replication menu
	msotcidReplPublisherProperties = 4141,		//(0,25) Label: 'Pub&lisher Properties...' NOTE: Item on tools Replication menu
	msotcidSQLSecurity = 4142,		//(0,25) Label: '&Set Login Password...' NOTE: Item on Tools security
	msotcidUpsizingWizard = 4143,		//(0,25) Label: '&Upsizing Wizard' NOTE: Access, item on Tools DatabaseUtilities menu
	msotcidDiacriticColor = 4144,		//(0,25) Label: '&Diacritic Color' NOTE: Word, this is inside Tools/Options/Right to Left Dialog only
	msotcidDiacriticColorAutomaticSwatch = 4145,		//(0,25) Label: '&Automatic Diacritic Color' NOTE: Word, this is inside Tools/Options/Right to Left Dialog only
	msotcidDiacriticColorPickerSwatch = 4146,		//(0,25) Label: '&Diacritic Color List' NOTE: Word, this is inside Tools/Options/Right to Left Dialog only
	msotcidDiacriticMoreColors = 4147,		//(0,25) Label: '&More Diacritic Color' NOTE: Word, this is inside Tools/Options/Right to Left Dialog only
	msotcidSxMoveDataItemTop = 4148,		//(0,25) Label: 'Move to Be&ginning' NOTE: Excel:Item on Reordering Data Menu:Move to Top
	msotcidSxMoveDataItemUp = 4149,		//(0,25) Label: 'Move &Up' NOTE: Excel:Item on Reordering Data Menu:Move Up
	msotcidSxMoveDataItemDown = 4150,		//(0,25) Label: 'Move &Down' NOTE: Excel:Item on Reordering Data Menu:Move Down
	msotcidSxMoveDataItemBottom = 4151,		//(0,25) Label: 'Move to &End' NOTE: Excel:Item on Reordering Data Menu:Move Bottom
	msotcidDummy4152 = 4152,		//(0,25) Label: '&Dummy'
	msotcidToolboxExpando = 4153,		//(50,13) Label: '&Expand' NOTE: icon, Access Data Page Expando control
	msotcidToolboxNavControl = 4154,		//(50,24) Label: '&Record Navigation' NOTE: icon, Access Data Page Record Navigation control
	msotcidSizeToMyWidth = 4155,		//(51,20) Label: 'Size to &Width' NOTE: icon, Access DataPage sizing toolbar, size to width of selcted control
	msotcidSizeToMyHeight = 4156,		//(52,1) Label: 'Size to &Height' NOTE: icon, Access DataPage sizing toolbar, size to height of selcted control
	msotcidSizeToMySize = 4157,		//(52,10) Label: 'Size to &Size' NOTE: icon, Access DataPage sizing toolbar, size to size of selcted control
	msotcidWebServerTogglePane = 4158,		//(52,20) Label: '&Show/Hide Discussion Pane' NOTE: icon, Web Discussions toolbar
	msotcidWebServerShowGeneral = 4159,		//(51,24) Label: '&Show General Discussions' NOTE: icon, Web Discussions toolbar
	msotcidSwitchboardManager = 4160,		//(0,25) Label: '&Switchboard Manager' NOTE: item on Tools DatabaseUtilities menu
	msotcidDMView = 4161,		//(6,15) Label: '&Views' NOTE: View split menu in FileOpen
	msotcidFieldListShortcutBanded = 4162,		//(52,3) Label: '&Columnar'
	msotcidFieldListShortcutGrid = 4163,		//(43,6) Label: '&PivotTable'
	msotcidFieldListShortcutDatasheet = 4164,		//(24,29) Label: '&Datasheet'
	msotcidSawpInteractiveCalc = 4165,		//(50,9) Label: '&Spreadsheet Functionality' NOTE: Save As Web Page dialog
	msotcidSawpInteractiveChart = 4166,		//(1,23) Label: '&PivotTable Functionality'
	msotcidSawpInteractiveList = 4167,		//(50,12) Label: '&Chart Functionality'
	msotcidInsertDhtmlPage = 4168,		//(50,2) Label: '&DHTML Page'
	msotcidSawpPublishWebPage = 4169,		//(25,12) Label: '&Publish As Web Page' NOTE: Publish Layout, contact sabrinan
	msotcidNumberingRTL = 4170,		//(34,0) Label: '&Numbering' NOTE: BiDi -- ShAsh
	msotcidBulletsRTL = 4171,		//(55,1) Label: '&Bullets' NOTE: BiDi -- ShAsh
	msotcidOutdentRTL = 4172,		//(54,26) Label: '&Decrease Indent' NOTE: BiDi -- ShAsh
	msotcidIndentRTL = 4173,		//(54,27) Label: '&Increase Indent' NOTE: BiDi -- ShAsh
	msotcidSawpPPHTML = 4174,		//(52,28) Label: '&HTML' NOTE: used in Save As Web Page dlg
	msotcidDotAccentCircle = 4175,		//(0,25) Label: '&Circle Accent' NOTE: Korean equivalent of DotAccentBelow
	msotcidToolboxDropdownList = 4176,		//(55,5) Label: '&Dropdown List' NOTE: Access dp toolbox (contact: BrettT)
	msotcidWebServerDiscussions = 4177,		//(52,2) Label: '&Web Discussions' NOTE: samseng, O9 bug 81203
	msotcidWebServerStop = 4178,		//(52,8) Label: '&Stop Communication with Discussion Server' NOTE: samseng, O9 bug 44910
	msotcidConfScheduleMeeting = 4179,		//(0,25) Label: '&Schedule Meeting...' NOTE: NetMeeting
	msotcidCloseWeb = 4180,		//(0,25) Label: 'C&lose Web' NOTE: FP bulk import
	msotcidPublishWeb = 4181,		//(5,4) Label: 'P&ublish Web...' NOTE: FP
	msotcidDeleteWeb = 4182,		//(6,3) Label: '&Delete Web...' NOTE: FP bulk import
	msotcidPageProperties = 4183,		//(0,25) Label: 'Propert&ies...' NOTE: FP bulk import
	msotcidInsertDIV = 4184,		//(0,25) Label: 'Position Bo&x' NOTE: FP bulk import
	msotcidTaskHistory = 4185,		//(0,25) Label: 'Show &History' NOTE: FP bulk import
	msotcidShowTags = 4186,		//(0,25) Label: 'Reveal Ta&gs' NOTE: FP bulk import
	msotcidFilterSiteSummary = 4187,		//(0,25) Label: 'Site Su&mmary' NOTE: FP bulk import
	msotcidFilterAllFiles = 4188,		//(0,25) Label: '&All Files' NOTE: FP bulk import
	msotcidFilterRecentlyAddedFiles = 4189,		//(0,25) Label: 'Recently A&dded Files' NOTE: FP bulk import
	msotcidFilterRecentlyChangedFiles = 4190,		//(0,25) Label: 'Recently C&hanged Files' NOTE: FP bulk import
	msotcidFilterOlderFiles = 4191,		//(0,25) Label: '&Older Files' NOTE: FP bulk import
	msotcidFilterUnlinkedFiles = 4192,		//(0,25) Label: '&Unlinked Files' NOTE: FP bulk import
	msotcidFilterSlowPages = 4193,		//(0,25) Label: '&Slow Pages' NOTE: FP bulk import
	msotcidFilterBrokenHyperlinks = 4194,		//(0,25) Label: '&Broken Hyperlinks' NOTE: FP bulk import
	msotcidFilterComponentErrors = 4195,		//(0,25) Label: 'Component &Errors' NOTE: FP bulk import
	msotcidFilterReviewStatus = 4196,		//(0,25) Label: '&Review Status' NOTE: FP bulk import
	msotcidFilterAssignedTo = 4197,		//(0,25) Label: 'Assigned &To' NOTE: FP bulk import
	msotcidFilterCategories = 4198,		//(0,25) Label: '&Categories' NOTE: FP bulk import
	msotcidFilterPublishStatus = 4199,		//(0,25) Label: '&Publish Status' NOTE: FP bulk import
	msotcidFilterCheckoutStatus = 4200,		//(0,25) Label: 'Chec&kout Status' NOTE: FP bulk import
	msotcidInsertHR = 4201,		//(0,25) Label: 'Horizontal &Line' NOTE: FP bulk import
	msotcidMorePages = 4202,		//(0,25) Label: '&More Pages...' NOTE: FP Used if more than 9 pages
	msotcidInsertNavBar = 4203,		//(0,25) Label: 'Na&vigation...' NOTE: FP bulk import
	msotcidInsertBanner = 4204,		//(0,25) Label: 'Page Ba&nner...' NOTE: FP bulk import
	msotcidRecentWebList = 4205,		//(0,25) Label: '&Recent Web Name Goes Here' NOTE: FP Every web in the MRU uses this ID, w/o the string
	msotcidHoverButton = 4206,		//(57,11) Label: '&Hover Button...' NOTE: FP guidFPIcon32
	msotcidHitCounter = 4207,		//(57,12) Label: 'Hit &Counter...' NOTE: FP guidFPIcon33
	msotcidMarquee = 4208,		//(57,13) Label: '&Marquee...' NOTE: FP guidFPIcon34
	msotcidSearchForm = 4209,		//(57,14) Label: '&Search Form...' NOTE: FP guidFPIcon35
	msotcidBannerAdManager = 4210,		//(57,15) Label: 'Ba&nner Ad Manager...' NOTE: FP guidFPIcon36
	msotcidConfirmationField = 4211,		//(57,16) Label: 'Confirmation &Field...' NOTE: FP guidFPIcon37
	msotcidIncludePage = 4212,		//(57,17) Label: '&Include Page...' NOTE: FP guidFPIcon38
	msotcidScheduledImage = 4213,		//(57,18) Label: 'Scheduled &Picture...' NOTE: FP guidFPIcon39
	msotcidScheduledIncludePage = 4214,		//(57,19) Label: 'Scheduled Inclu&de Page...' NOTE: FP guidFPIcon40
	msotcidSubstitution = 4215,		//(57,20) Label: 'Su&bstitution...' NOTE: FP guidFPIcon41
	msotcidAdditionalComponents = 4216,		//(57,21) Label: '&Additional Components...' NOTE: FP guidFPIcon42
	msotcidWebInsertBookmark = 4217,		//(0,25) Label: 'Boo&kmark...' NOTE: FP bulk import
	msotcidDBRegionWizard = 4218,		//(0,25) Label: '&Results...' NOTE: FP bulk import
	msotcidDBColumnValue = 4219,		//(0,25) Label: '&Column Value...' NOTE: FP bulk import
	msotcidPositioning = 4220,		//(0,25) Label: 'P&osition...' NOTE: FP bulk import
	msotcidSharedBorders = 4221,		//(0,25) Label: 'Share&d Borders...' NOTE: FP bulk import
	msotcidRemoveFormatting = 4222,		//(0,25) Label: '&Remove Formatting' NOTE: FP bulk import
	msotcidLinkStylesheet = 4223,		//(0,25) Label: 'Style Sheet &Links...' NOTE: FP bulk import
	msotcidAutoThumbnail = 4224,		//(8,21) Label: 'A&uto Thumbnail' NOTE: FP
	msotcidRecalcHyperlinks = 4225,		//(0,25) Label: '&Recalculate Hyperlinks...' NOTE: FP bulk import
	msotcidCopyFormat2 = 4226,		//(36,17) Label: '&Copy Format' NOTE: FP bulk import
	msotcidPageOptions = 4227,		//(0,25) Label: 'P&age Options...' NOTE: FP bulk import
	msotcidWebSettings = 4228,		//(0,25) Label: '&Web Settings...' NOTE: FP bulk import
	msotcidChangePassword = 4229,		//(0,25) Label: 'C&hange Password...' NOTE: FP bulk import
	msotcidInsertRowsOrColumns = 4230,		//(0,25) Label: 'Rows or Colum&ns...' NOTE: FP bulk import
	msotcidCaptionProperties = 4231,		//(0,25) Label: 'Capti&on' NOTE: FP bulk import
	msotcidInsertCaption = 4232,		//(0,25) Label: 'C&aption' NOTE: FP bulk import
	msotcidSplitFrame = 4233,		//(0,25) Label: 'Split &Frame' NOTE: FP bulk import
	msotcidDeleteFrame = 4234,		//(0,25) Label: '&Delete Frame' NOTE: FP bulk import
	msotcidSetFrameSource = 4235,		//(0,25) Label: 'Set &Initial Page' NOTE: FP bulk import
	msotcidFrameProperties = 4236,		//(0,25) Label: 'Frame &Properties...' NOTE: FP bulk import
	msotcidOpenFrame = 4237,		//(0,25) Label: '&Open Page in New Window' NOTE: FP bulk import
	msotcidSaveFrame = 4238,		//(0,25) Label: '&Save Page' NOTE: FP bulk import
	msotcidSaveFrameAs = 4239,		//(0,25) Label: 'Save Page &As...' NOTE: FP bulk import
	msotcidShowDHTMLToolbar = 4240,		//(0,25) Label: 'Dynamic HTML &Effects' NOTE: FP bulk import
	msotcidPasteFormat2 = 4241,		//(28,22) Label: '&Paste Format' NOTE: FP bulk import
	msotcidDHTMLRemove = 4242,		//(57,23) Label: '&Remove Effect' NOTE: FP guidFPIcon28
	msotcidNewWeb2 = 4243,		//(57,27) Label: 'New &Web...' NOTE: guidFPIcon46
	msotcidDHTMLHighlight = 4244,		//(57,24) Label: '&Highlight Dynamic HTML Effects' NOTE: FP guidFPIcon30
	msotcidFPTableOfContents = 4245,		//(57,25) Label: 'Table of C&ontents...' NOTE: FP guidFPIcon44
	msotcidCategoriesBot = 4246,		//(57,26) Label: 'Cate&gories...' NOTE: FP guidFPIcon45
	msotcidNewWeb = 4247,		//(57,27) Label: '&Web...' NOTE: FP guidFPIcon46
	msotcidShowAllHyperlinks = 4248,		//(0,25) Label: 'Sho&w All Hyperlinks' NOTE: FP bulk import
	msotcidEditPage = 4249,		//(0,25) Label: 'Edit &Page' NOTE: FP bulk import
	msotcidOpenSpecificFile2 = 4250,		//(0,10) Label: '&Open' NOTE: FP bulk import
	msotcidOpenSpecificFileWith = 4251,		//(0,10) Label: 'Open &With...' NOTE: FP bulk import
	msotcidConvertToWeb = 4252,		//(0,25) Label: 'Convert to &Web' NOTE: FP bulk import
	msotcidConvertToFolder = 4253,		//(0,25) Label: 'Convert to F&older' NOTE: FP bulk import
	msotcidShowPageTitles = 4254,		//(0,25) Label: 'Show Page &Titles' NOTE: FP bulk import
	msotcidShowImageHyperlinks = 4255,		//(0,25) Label: 'Hyperlinks to P&ictures' NOTE: FP bulk import
	msotcidShowRepeatedHyperlinks = 4256,		//(0,25) Label: 'R&epeated Hyperlinks' NOTE: FP bulk import
	msotcidShowSelfHyperlinks = 4257,		//(0,25) Label: 'Hyperlinks Inside &Page' NOTE: FP bulk import
	msotcidCenterInView = 4258,		//(0,25) Label: '&Move to Center' NOTE: FP bulk import
	msotcidFindInNavigation = 4259,		//(0,25) Label: '&Find in Navigation' NOTE: FP bulk import
	msotcidHighlightColorAutomaticSwatch = 4260,		//(0,25) Label: '&Automatic Color' NOTE: FP bulk import
	msotcidMoreHighlightColors = 4261,		//(0,25) Label: '&More Colors...' NOTE: FP bulk import
	msotcidMoreFontColors = 4262,		//(0,25) Label: '&More Colors...' NOTE: FP bulk import
	msotcidFrontPage4263 = 4263,		//(0,25) Label: '&FrontPage'
	msotcidPageTransition = 4264,		//(15,19) Label: 'P&age Transition...' NOTE: FP bulk import
	msotcidInsertVideo = 4265,		//(51,0) Label: '&Video...' NOTE: FP bulk import
	msotcidFormProperties = 4266,		//(5,13) Label: 'Form P&roperties...' NOTE: FP bulk import
	msotcidOCXImage2 = 4267,		//(40,6) Label: '&Picture...' NOTE: FP bulk import
	msotcidHTMLPushButton = 4268,		//(38,15) Label: 'Push &Button' NOTE: FP bulk import
	msotcidHTMLCheckbox2 = 4269,		//(38,12) Label: '&Check Box' NOTE: FP bulk import
	msotcidHTMLTextArea2 = 4270,		//(51,25) Label: '&Scrolling Text Box' NOTE: FP bulk import
	msotcidHTMLTextbox2 = 4271,		//(38,14) Label: '&One-Line Text Box' NOTE: FP bulk import
	msotcidHTMLForm = 4272,		//(13,29) Label: '&Form' NOTE: FP bulk import
	msotcidInsertComponentMenu = 4273,		//(5,6) Label: 'C&omponent' NOTE: FP IDI_COMPONENT_MENU
	msotcidNewComment3 = 4274,		//(5,28) Label: 'Co&mment...' NOTE: FP bulk import
	msotcidToggleViewBar = 4275,		//(0,25) Label: '&Views Bar' NOTE: FP bulk import
	msotcidAddTask = 4276,		//(0,25) Label: '&Add Task...' NOTE: FP bulk import
	msotcidEditTask = 4277,		//(0,25) Label: '&Edit Task...' NOTE: FP bulk import
	msotcidStartTask = 4278,		//(0,25) Label: '&Start Task' NOTE: FP bulk import
	msotcidDebug = 4279,		//(0,25) Label: '&Debug' NOTE: FP debug man add AHW
	msotcidFrontPage4280 = 4280,		//(0,25) Label: '&FrontPage'
	msotcidFrontPage4281 = 4281,		//(0,25) Label: '&FrontPage'
	msotcidFrontPage4282 = 4282,		//(0,25) Label: '&FrontPage'
	msotcidFrontPage4283 = 4283,		//(0,25) Label: '&FrontPage'
	msotcidFrontPage4284 = 4284,		//(0,25) Label: '&FrontPage'
	msotcidFrontPage4285 = 4285,		//(0,25) Label: '&FrontPage'
	msotcidFrontPage4286 = 4286,		//(0,25) Label: '&FrontPage'
	msotcidFrontPage4287 = 4287,		//(0,25) Label: '&FrontPage'
	msotcidFrontPage4288 = 4288,		//(0,25) Label: '&FrontPage'
	msotcidFrontPage4289 = 4289,		//(0,25) Label: '&FrontPage'
	msotcidFrontPage4290 = 4290,		//(0,25) Label: '&FrontPage'
	msotcidFrontPage4291 = 4291,		//(0,25) Label: '&FrontPage'
	msotcidFrontPage4292 = 4292,		//(0,25) Label: '&FrontPage'
	msotcidFrontPage4293 = 4293,		//(0,25) Label: '&FrontPage'
	msotcidPageView = 4294,		//(8,12) Label: '&Page' NOTE: FP guidFPIcon2
	msotcidFolderView = 4295,		//(8,13) Label: '&Folders' NOTE: FP guidFPIcon3
	msotcidReportsViewMenu = 4296,		//(8,14) Label: '&Reports' NOTE: FP IDI_VIEW_ASSETS
	msotcidNavigationView = 4297,		//(8,15) Label: '&Navigation' NOTE: FP guidFPIcon5
	msotcidHyperlinksView = 4298,		//(8,16) Label: '&Hyperlinks' NOTE: FP guidFPIcon6
	msotcidTasksView = 4299,		//(8,17) Label: 'T&asks' NOTE: FP guidFPIcon7
	msotcidShowDTCs = 4300,		//(58,5) Label: '&Show Design-Time Controls As Text' NOTE: FP guidFPIcon43
	msotcidInsertHTML = 4301,		//(58,6) Label: '&HTML...' NOTE: FP guidFPIcon10 FP
	msotcidInsertDTC = 4302,		//(58,7) Label: '&Design-Time Control...' NOTE: FP guidFPIcon11 FP
	msotcidInsertApplet = 4303,		//(58,8) Label: '&Java Applet...' NOTE: FP guidFPIcon12 FP
	msotcidInsertPlugin = 4304,		//(58,9) Label: '&Plug-In...' NOTE: FP guidFPIcon13 FP
	msotcidInsertControl = 4305,		//(58,10) Label: '&ActiveX Control...' NOTE: FP guidFPIcon14 FP
	msotcidVerifyHyperlinks = 4306,		//(58,11) Label: '&Verify Hyperlinks...' NOTE: FP guidFPIcon8
	msotcidInsertRowsOrColumns2 = 4307,		//(0,25) Label: 'Insert Rows or Colum&ns...' NOTE: FP bulk import
	msotcidPublishWebDirect = 4308,		//(5,4) Label: 'Publis&h Web' NOTE: FP guidFPIcon1 FP
	msotcidShowHotspots = 4309,		//(58,13) Label: '&Highlight Hotspots' NOTE: FP guidFPIcon19
	msotcidWashout = 4310,		//(58,14) Label: 'Wash &Out' NOTE: FP guidFPIcon20
	msotcidBlackAndWhite = 4311,		//(58,15) Label: 'Black and &White' NOTE: FP guidFPIcon21
	msotcidBevel = 4312,		//(58,16) Label: '&Bevel' NOTE: FP guidFPIcon22
	msotcidResample = 4313,		//(58,17) Label: '&Resample' NOTE: FP guidFPIcon23
	msotcidPositionAbsolute = 4314,		//(58,18) Label: '&Position Absolutely' NOTE: FP guidFPIcon16 FP
	msotcidViewSubtree = 4315,		//(58,12) Label: '&View Subtree Only' NOTE: FP guidFPIcon26
	msotcidZoomFullSize = 4316,		//(0,25) Label: '&100%' NOTE: FP bulk import
	msotcidZoomSizeToFit = 4317,		//(0,25) Label: 'Si&ze To Fit' NOTE: FP bulk import
	msotcidApplyNavigationChanges = 4318,		//(0,25) Label: '&Apply Changes' NOTE: FP bulk import
	msotcidNewGlobalPage = 4319,		//(0,25) Label: '&Top Page' NOTE: FP bulk import
	msotcidConnectionSpeed144 = 4320,		//(0,25) Label: '&14.4' NOTE: FP bulk import
	msotcidConnectionSpeed288 = 4321,		//(0,25) Label: '&28.8' NOTE: FP bulk import
	msotcidConnectionSpeed56K = 4322,		//(0,25) Label: '&56K' NOTE: FP bulk import
	msotcidConnectionSpeedISDN = 4323,		//(0,25) Label: '&ISDN' NOTE: FP bulk import
	msotcidConnectionSpeedT1 = 4324,		//(0,25) Label: '&T1' NOTE: FP bulk import
	msotcidConnectionSpeedT3 = 4325,		//(0,25) Label: 'T&3' NOTE: FP bulk import
	msotcidRightDragCopyConvert = 4326,		//(0,25) Label: 'Copy &Here as Web Format' NOTE: FP bulk import
	msotcidFollowHyperlink = 4327,		//(0,25) Label: '&Follow Hyperlink' NOTE: FP bulk import
	msotcidColorCoding = 4328,		//(0,25) Label: 'S&how Color Coding' NOTE: FP bulk import
	msotcidTagProperties = 4329,		//(0,25) Label: 'Tag Pr&operties...' NOTE: FP bulk import
	msotcidListProperties = 4330,		//(0,25) Label: '&List Properties...' NOTE: FP bulk import
	msotcidListItemProperties = 4331,		//(0,25) Label: 'List &Item Properties...' NOTE: FP bulk import
	msotcidPluginProperties = 4332,		//(0,25) Label: 'Plu&g-In Properties...' NOTE: FP bulk import
	msotcidAppletProperties = 4333,		//(0,25) Label: '&Java Applet Properties...' NOTE: FP bulk import
	msotcidOleObjectProperties = 4334,		//(0,25) Label: 'Active&X Control Properties...' NOTE: FP bulk import
	msotcidFormFieldValidation = 4335,		//(0,25) Label: 'Form Field &Validation...' NOTE: FP bulk import
	msotcidFormFieldProperties = 4336,		//(0,25) Label: 'For&m Field Properties...' NOTE: FP bulk import
	msotcidImageProperties = 4337,		//(0,25) Label: 'Picture Pr&operties...' NOTE: FP bulk import
	msotcidImageHotspotProperties = 4338,		//(0,25) Label: 'Picture Hotspot Pr&operties...' NOTE: FP bulk import
	msotcidParagraphProperties = 4339,		//(4,26) Label: 'Para&graph...' NOTE: FP bulk import
	msotcidFontProperties = 4340,		//(4,25) Label: '&Font...' NOTE: FP bulk import
	msotcidHorizontalLineProperties = 4341,		//(0,25) Label: 'Hori&zontal Line Properties...' NOTE: FP bulk import
	msotcidBreakProperties = 4342,		//(0,25) Label: 'Line Brea&k Properties...' NOTE: FP bulk import
	msotcidHyperlinkProperties = 4343,		//(0,25) Label: 'Hyperlin&k Properties...' NOTE: FP bulk import
	msotcidBookmarkProperties = 4344,		//(0,25) Label: 'Bookmar&k Properties...' NOTE: FP bulk import
	msotcidMarqueeProperties = 4345,		//(0,25) Label: 'Mar&quee Properties...' NOTE: FP bulk import
	msotcidBotProperties = 4346,		//(0,25) Label: 'FrontPa&ge Component Properties...' NOTE: FP bulk import
	msotcidDatabaseResultsProperties = 4347,		//(0,25) Label: '&Database Results Properties...' NOTE: FP bulk import
	msotcidVerifyHyperlinkTo = 4348,		//(58,11) Label: '&Verify Hyperlink' NOTE: FP guidFPIcon8
	msotcidVerifySelectedHyperlinks = 4349,		//(58,11) Label: '&Verify Hyperlink' NOTE: FP guidFPIcon8
	msotcidOpenWeb = 4350,		//(8,9) Label: 'Open &Web...' NOTE: FP bulk import
	msotcidPreviewInBrowser = 4351,		//(3,12) Label: 'Preview in &Browser...' NOTE: FP bulk import
	msotcidPreviewInBrowserDefault = 4352,		//(3,12) Label: 'Preview in &Browser' NOTE: FP bulk import
	msotcidUndoSplitDropdown = 4353,		//(1,10) Label: '&Undo' NOTE: FP bulk import
	msotcidRedoSplitDropdown = 4354,		//(1,11) Label: '&Redo' NOTE: FP bulk import
	msotcidRefresh = 4355,		//(5,7) Label: 'Refre&sh' NOTE: FP bulk import
	msotcidCancelRequest = 4356,		//(5,8) Label: '&Stop' NOTE: FP bulk import
	msotcidAddImageText = 4357,		//(38,22) Label: '&Text' NOTE: FP bulk import
	msotcidPointer2 = 4358,		//(2,6) Label: '&Select' NOTE: FP bulk import
	msotcidRectangleHotspot = 4359,		//(37,26) Label: '&Rectangular Hotspot' NOTE: FP bulk import
	msotcidCircleHotspot = 4360,		//(24,18) Label: '&Circular Hotspot' NOTE: FP bulk import
	msotcidPolygonHotspot = 4361,		//(14,0) Label: '&Polygonal Hotspot' NOTE: FP bulk import
	msotcidRestorePicture = 4362,		//(33,21) Label: 'R&estore' NOTE: FP bulk import
	msotcidReportCombo = 4363,		//(0,25) Label: '&Report' NOTE: FP bulk import
	msotcidReportSettingsCombo = 4364,		//(0,25) Label: 'Report &Setting' NOTE: FP bulk import
	msotcidZIndex = 4365,		//(0,25) Label: '&Z-Index' NOTE: FP bulk import
	msotcidNewExternalNavigationLink = 4366,		//(1,12) Label: 'Add &Existing Page...' NOTE: FP bulk import
	msotcidIncludeInNavigationBars = 4367,		//(47,17) Label: 'Included in Navigation &Bars' NOTE: FP bulk import
	msotcidDHTMLEventCombo = 4368,		//(0,25) Label: '&On' NOTE: FP bulk import
	msotcidDHTMLEffectCombo = 4369,		//(0,25) Label: '&Apply' NOTE: FP bulk import
	msotcidDHTMLEffectSettingsCombo = 4370,		//(0,25) Label: '&Effect' NOTE: FP bulk import
	msotcidInsertCell = 4371,		//(0,25) Label: 'C&ell' NOTE: FP bulk import
	msotcidTableToText3 = 4372,		//(0,25) Label: 'Ta&ble to Text' NOTE: FP bulk import
	msotcidTableProperties2 = 4373,		//(5,13) Label: '&Table' NOTE: FP bulk import
	msotcidCellProperties = 4374,		//(0,25) Label: 'C&ell' NOTE: FP bulk import
	msotcidPermissions2 = 4375,		//(19,11) Label: '&Permissions...' NOTE: FP bulk import
	msotcidSendAsAttachmentToMailRecipient = 4376,		//(2,4) Label: 'Sen&d...' NOTE: FP bulk import
	msotcidNewPage = 4377,		//(0,11) Label: '&Page...' NOTE: FP bulk import
	msotcidNewTask3 = 4378,		//(57,28) Label: '&Task...' NOTE: FP bulk import
	msotcidHTMLRadioButton = 4379,		//(38,16) Label: '&Radio Button' NOTE: FP bulk import
	msotcidNewTask4 = 4380,		//(57,28) Label: 'New &Task...' NOTE: FP bulk import
	msotcidDpBanded = 4381,		//(0,25) Label: '&Specify option for drag/drop from Field List' NOTE: Access datapage field list drop - Office 9 bug 87319
	msotcidDpGrid = 4382,		//(0,25) Label: '&Specify option for drag/drop from Field List' NOTE: Access datapage field list drop - Office 9 bug 87319
	msotcidDpGroupFilter = 4383,		//(0,25) Label: '&Specify option for drag/drop from Field List' NOTE: Access datapage field list drop Office 9 bug 87319
	msotcidWebServerInsertGeneral = 4384,		//(53,20) Label: '&Insert Discussion about the Document' NOTE: Web Server samseng O9 bug 91854
	msotcidWebServerInsertInline = 4385,		//(52,27) Label: 'Insert &Discussion in the Document' NOTE: Web Server samseng O9 bug 91854
	msotcidDummyPleaseUse = 4386,		//(0,25) Label: '&Dummy'
	msotcidViewOutlineMaster = 4387,		//(4,21) Label: '&Outline' NOTE: Office 9 bug 75455; this sets outline *and* master view
	msotcidSxFieldDmanTensorMeasure1 = 4388,		//(52,23) Label: '&Data Area' NOTE: Office 9 bug 88918
	msotcidSxFieldDmanTensorMeasure2 = 4389,		//(52,23) Label: '&Data Area' NOTE: Office 9 bug 88918
	msotcidSxFieldDmanTensorMeasure3 = 4390,		//(52,23) Label: '&Data Area' NOTE: Office 9 bug 88918
	msotcidSxFieldDmanTensorHierarchy1 = 4391,		//(52,9) Label: '&Non-Data Area' NOTE: Office 9 bug 88918
	msotcidSxFieldDmanTensorHierarchy2 = 4392,		//(52,9) Label: '&Non-Data Area' NOTE: Office 9 bug 88918
	msotcidSxFieldDmanTensorHierarchy3 = 4393,		//(52,9) Label: '&Non-Data Area' NOTE: Office 9 bug 88918
	msotcidOutlook4394 = 4394,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4395 = 4395,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4396 = 4396,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4397 = 4397,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4398 = 4398,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4399 = 4399,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4400 = 4400,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4401 = 4401,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4402 = 4402,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4403 = 4403,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4404 = 4404,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4405 = 4405,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4406 = 4406,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4407 = 4407,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4408 = 4408,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4409 = 4409,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4410 = 4410,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4411 = 4411,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4412 = 4412,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4413 = 4413,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4414 = 4414,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4415 = 4415,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4416 = 4416,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4417 = 4417,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4418 = 4418,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4419 = 4419,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4420 = 4420,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4421 = 4421,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4422 = 4422,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4423 = 4423,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4424 = 4424,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4425 = 4425,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4426 = 4426,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4427 = 4427,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4428 = 4428,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4429 = 4429,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4430 = 4430,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4431 = 4431,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4432 = 4432,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4433 = 4433,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4434 = 4434,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4435 = 4435,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4436 = 4436,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4437 = 4437,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4438 = 4438,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4439 = 4439,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4440 = 4440,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4441 = 4441,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4442 = 4442,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4443 = 4443,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4444 = 4444,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4445 = 4445,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4446 = 4446,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4447 = 4447,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4448 = 4448,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4449 = 4449,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4450 = 4450,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4451 = 4451,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4452 = 4452,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4453 = 4453,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4454 = 4454,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4455 = 4455,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4456 = 4456,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4457 = 4457,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4458 = 4458,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4459 = 4459,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4460 = 4460,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4461 = 4461,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4462 = 4462,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4463 = 4463,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4464 = 4464,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4465 = 4465,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4466 = 4466,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4467 = 4467,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4468 = 4468,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4469 = 4469,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4470 = 4470,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4471 = 4471,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4472 = 4472,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4473 = 4473,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4474 = 4474,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4475 = 4475,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4476 = 4476,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4477 = 4477,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4478 = 4478,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4479 = 4479,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4480 = 4480,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4481 = 4481,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4482 = 4482,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4483 = 4483,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4484 = 4484,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4485 = 4485,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4486 = 4486,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4487 = 4487,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4488 = 4488,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4489 = 4489,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4490 = 4490,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4491 = 4491,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4492 = 4492,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4493 = 4493,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4494 = 4494,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4495 = 4495,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4496 = 4496,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4497 = 4497,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4498 = 4498,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4499 = 4499,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4500 = 4500,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4501 = 4501,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4502 = 4502,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4503 = 4503,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4504 = 4504,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4505 = 4505,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4506 = 4506,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4507 = 4507,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4508 = 4508,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4509 = 4509,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4510 = 4510,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4511 = 4511,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4512 = 4512,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4513 = 4513,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4514 = 4514,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4515 = 4515,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4516 = 4516,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4517 = 4517,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4518 = 4518,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4519 = 4519,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4520 = 4520,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4521 = 4521,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4522 = 4522,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4523 = 4523,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4524 = 4524,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4525 = 4525,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4526 = 4526,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4527 = 4527,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4528 = 4528,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4529 = 4529,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4530 = 4530,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4531 = 4531,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4532 = 4532,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4533 = 4533,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4534 = 4534,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4535 = 4535,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4536 = 4536,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4537 = 4537,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4538 = 4538,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4539 = 4539,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4540 = 4540,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4541 = 4541,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4542 = 4542,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4543 = 4543,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4544 = 4544,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4545 = 4545,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4546 = 4546,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4547 = 4547,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4548 = 4548,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4549 = 4549,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4550 = 4550,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4551 = 4551,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4552 = 4552,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4553 = 4553,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4554 = 4554,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4555 = 4555,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4556 = 4556,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4557 = 4557,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4558 = 4558,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4559 = 4559,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4560 = 4560,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4561 = 4561,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4562 = 4562,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4563 = 4563,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4564 = 4564,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4565 = 4565,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4566 = 4566,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4567 = 4567,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4568 = 4568,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4569 = 4569,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4570 = 4570,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4571 = 4571,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4572 = 4572,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4573 = 4573,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4574 = 4574,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4575 = 4575,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4576 = 4576,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4577 = 4577,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4578 = 4578,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4579 = 4579,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4580 = 4580,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4581 = 4581,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4582 = 4582,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4583 = 4583,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4584 = 4584,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4585 = 4585,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4586 = 4586,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4587 = 4587,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4588 = 4588,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4589 = 4589,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4590 = 4590,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4591 = 4591,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4592 = 4592,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4593 = 4593,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4594 = 4594,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4595 = 4595,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4596 = 4596,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4597 = 4597,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4598 = 4598,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4599 = 4599,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4600 = 4600,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4601 = 4601,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4602 = 4602,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4603 = 4603,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4604 = 4604,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4605 = 4605,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4606 = 4606,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4607 = 4607,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4608 = 4608,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4609 = 4609,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4610 = 4610,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4611 = 4611,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4612 = 4612,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4613 = 4613,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4614 = 4614,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4615 = 4615,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4616 = 4616,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4617 = 4617,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4618 = 4618,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4619 = 4619,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4620 = 4620,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4621 = 4621,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4622 = 4622,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4623 = 4623,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4624 = 4624,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4625 = 4625,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4626 = 4626,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4627 = 4627,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4628 = 4628,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4629 = 4629,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4630 = 4630,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4631 = 4631,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4632 = 4632,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4633 = 4633,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4634 = 4634,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4635 = 4635,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4636 = 4636,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4637 = 4637,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4638 = 4638,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4639 = 4639,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4640 = 4640,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4641 = 4641,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4642 = 4642,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4643 = 4643,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4644 = 4644,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4645 = 4645,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4646 = 4646,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4647 = 4647,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4648 = 4648,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4649 = 4649,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4650 = 4650,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4651 = 4651,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4652 = 4652,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4653 = 4653,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4654 = 4654,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4655 = 4655,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4656 = 4656,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4657 = 4657,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4658 = 4658,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4659 = 4659,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4660 = 4660,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4661 = 4661,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4662 = 4662,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4663 = 4663,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4664 = 4664,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4665 = 4665,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4666 = 4666,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4667 = 4667,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4668 = 4668,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4669 = 4669,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4670 = 4670,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4671 = 4671,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4672 = 4672,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4673 = 4673,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4674 = 4674,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4675 = 4675,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4676 = 4676,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4677 = 4677,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4678 = 4678,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4679 = 4679,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4680 = 4680,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4681 = 4681,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4682 = 4682,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4683 = 4683,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4684 = 4684,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4685 = 4685,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4686 = 4686,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4687 = 4687,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4688 = 4688,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4689 = 4689,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4690 = 4690,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4691 = 4691,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4692 = 4692,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4693 = 4693,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4694 = 4694,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4695 = 4695,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4696 = 4696,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4697 = 4697,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4698 = 4698,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4699 = 4699,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4700 = 4700,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4701 = 4701,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4702 = 4702,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4703 = 4703,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4704 = 4704,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4705 = 4705,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4706 = 4706,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4707 = 4707,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4708 = 4708,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4709 = 4709,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4710 = 4710,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4711 = 4711,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4712 = 4712,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4713 = 4713,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4714 = 4714,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4715 = 4715,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4716 = 4716,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4717 = 4717,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4718 = 4718,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4719 = 4719,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4720 = 4720,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4721 = 4721,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4722 = 4722,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4723 = 4723,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4724 = 4724,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4725 = 4725,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4726 = 4726,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4727 = 4727,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4728 = 4728,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4729 = 4729,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4730 = 4730,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4731 = 4731,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4732 = 4732,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4733 = 4733,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4734 = 4734,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4735 = 4735,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4736 = 4736,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4737 = 4737,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4738 = 4738,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4739 = 4739,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4740 = 4740,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4741 = 4741,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4742 = 4742,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4743 = 4743,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4744 = 4744,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4745 = 4745,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4746 = 4746,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4747 = 4747,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4748 = 4748,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4749 = 4749,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4750 = 4750,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4751 = 4751,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4752 = 4752,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4753 = 4753,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4754 = 4754,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4755 = 4755,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4756 = 4756,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4757 = 4757,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4758 = 4758,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4759 = 4759,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4760 = 4760,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4761 = 4761,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4762 = 4762,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4763 = 4763,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4764 = 4764,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4765 = 4765,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4766 = 4766,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4767 = 4767,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4768 = 4768,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4769 = 4769,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4770 = 4770,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4771 = 4771,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4772 = 4772,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4773 = 4773,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4774 = 4774,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4775 = 4775,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4776 = 4776,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4777 = 4777,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4778 = 4778,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4779 = 4779,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4780 = 4780,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4781 = 4781,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4782 = 4782,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4783 = 4783,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4784 = 4784,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4785 = 4785,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4786 = 4786,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4787 = 4787,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4788 = 4788,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4789 = 4789,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4790 = 4790,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4791 = 4791,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4792 = 4792,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4793 = 4793,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4794 = 4794,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4795 = 4795,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4796 = 4796,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4797 = 4797,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4798 = 4798,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4799 = 4799,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4800 = 4800,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4801 = 4801,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4802 = 4802,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4803 = 4803,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4804 = 4804,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4805 = 4805,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4806 = 4806,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4807 = 4807,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4808 = 4808,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4809 = 4809,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4810 = 4810,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4811 = 4811,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4812 = 4812,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4813 = 4813,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4814 = 4814,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4815 = 4815,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4816 = 4816,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4817 = 4817,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4818 = 4818,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4819 = 4819,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4820 = 4820,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4821 = 4821,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4822 = 4822,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4823 = 4823,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4824 = 4824,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4825 = 4825,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4826 = 4826,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4827 = 4827,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4828 = 4828,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4829 = 4829,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4830 = 4830,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4831 = 4831,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4832 = 4832,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4833 = 4833,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4834 = 4834,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4835 = 4835,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4836 = 4836,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4837 = 4837,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4838 = 4838,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4839 = 4839,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidOutlook4840 = 4840,		//(0,25) Label: '' NOTE: Reserved for Outlook
	msotcidFontColorLabelCustom = 4841,		//(0,25) Label: '&Custom Colors' NOTE: FP bulk import
	msotcidFontColorCustomSwatch = 4842,		//(0,25) Label: '&Custom Font Colors' NOTE: FP bulk import
	msotcidHighlightColorLabelCustom = 4843,		//(0,25) Label: '&Custom Colors' NOTE: FP bulk import
	msotcidHighlightColorCustomSwatch = 4844,		//(0,25) Label: '&Custom Highlight Colors' NOTE: FP bulk import
	msotcidFillColorLabelCustom = 4845,		//(0,25) Label: '&Custom Colors' NOTE: FP bulk import
	msotcidFillColorCustomSwatch = 4846,		//(0,25) Label: '&Custom Fill Colors' NOTE: FP bulk import
	msotcidFontColorLabelTheme = 4847,		//(0,25) Label: '&Theme's Colors' NOTE: FP bulk import
	msotcidFontColorTheme1Swatch = 4848,		//(0,25) Label: '&Theme 1's Font Colors' NOTE: FP bulk import
	msotcidFontColorTheme2Swatch = 4849,		//(0,25) Label: '&Theme 2's Font Colors' NOTE: FP bulk import
	msotcidHighlightColorLabelTheme = 4850,		//(0,25) Label: '&Theme's Colors' NOTE: FP bulk import
	msotcidHighlightColorTheme1Swatch = 4851,		//(0,25) Label: '&Theme 1's Highlight Colors' NOTE: FP bulk import
	msotcidHighlightColorTheme2Swatch = 4852,		//(0,25) Label: '&Theme 2's Highlight Colors' NOTE: FP bulk import
	msotcidFillColorLabelTheme = 4853,		//(0,25) Label: '&Theme's Colors' NOTE: FP bulk import
	msotcidFillColorTheme1Swatch = 4854,		//(0,25) Label: '&Theme 1's Fill Colors' NOTE: FP bulk import
	msotcidFillColorTheme2Swatch = 4855,		//(0,25) Label: '&Theme 2's Fill Colors' NOTE: FP bulk import
	msotcidFontColorLabelDocument = 4856,		//(0,25) Label: '&Document's Colors' NOTE: FP bulk import
	msotcidFontColorDocument1Swatch = 4857,		//(0,25) Label: '&Document 1's Font Colors' NOTE: FP bulk import
	msotcidFontColorDocument2Swatch = 4858,		//(0,25) Label: '&Document 2's Font Colors' NOTE: FP bulk import
	msotcidHighlightColorLabelDocument = 4859,		//(0,25) Label: '&Document's Colors' NOTE: FP bulk import
	msotcidHighlightColorDocument1Swatch = 4860,		//(0,25) Label: '&Document 1's Highlight Colors' NOTE: FP bulk import
	msotcidHighlightColorDocument2Swatch = 4861,		//(0,25) Label: '&Document 2's Highlight Colors' NOTE: FP bulk import
	msotcidFillColorLabelDocument = 4862,		//(0,25) Label: '&Document's Colors' NOTE: FP bulk import
	msotcidFillColorDocument1Swatch = 4863,		//(0,25) Label: '&Document 1's Fill Colors' NOTE: FP bulk import
	msotcidFillColorDocument2Swatch = 4864,		//(0,25) Label: '&Document 2's Fill Colors' NOTE: FP bulk import
	msotcidFontColorLabelStandard = 4865,		//(0,25) Label: '&Standard Colors' NOTE: FP bulk import
	msotcidHighlightColorLabelStandard = 4866,		//(0,25) Label: '&Standard Colors' NOTE: FP bulk import
	msotcidFillColorLabelStandard = 4867,		//(0,25) Label: '&Standard Colors' NOTE: FP bulk import
	msotcidInsertTableExpandingGrid2 = 4868,		//(1,14) Label: '&Insert Table' NOTE: FP bulk import
	msotcidFillColorSplitMenu = 4869,		//(2,17) Label: '&Fill Color' NOTE: FP bulk import
	msotcidHideShortcutBar2 = 4870,		//(0,25) Label: '&Hide Views Bar' NOTE: FP bulk import
	msotcidNewNormalPage = 4871,		//(0,11) Label: '&New Page' NOTE: FP bulk import
	msotcidNewFolder2 = 4872,		//(44,28) Label: 'New &Folder' NOTE: FP bulk import
	msotcidPasteIn = 4873,		//(1,8) Label: '&Paste' NOTE: FP bulk import
	msotcidDeleteTask = 4874,		//(6,3) Label: '&Delete Task' NOTE: FP bulk import
	msotcidAddLinkedTask = 4875,		//(0,25) Label: '&Add Task...' NOTE: FP bulk import
	msotcidNewNavigationLink = 4876,		//(0,25) Label: '&Page' NOTE: FP bulk import
	msotcidRenameNavigationLink = 4877,		//(0,25) Label: 'Rena&me' NOTE: FP bulk import
	msotcidDeleteNavigationLink = 4878,		//(6,3) Label: '&Delete' NOTE: FP bulk import
	msotcidRightDragCreateHyperlink = 4879,		//(1,12) Label: '&Link Here' NOTE: FP bulk import
	msotcidPageProperties2 = 4880,		//(0,25) Label: 'P&age Properties...' NOTE: FP bulk import
	msotcidTableProperties3 = 4881,		//(5,13) Label: 'Ta&ble Properties...' NOTE: FP bulk import
	msotcidCaptionProperties2 = 4882,		//(0,25) Label: 'Capti&on Properties...' NOTE: FP bulk import
	msotcidCellProperties2 = 4883,		//(0,25) Label: 'Cell P&roperties...' NOTE: FP bulk import
	msotcidDatabaseObjectProperties = 4884,		//(0,25) Label: 'Database &Object Properties...' NOTE: FP bulk import
	msotcidWebInsertHyperlink2 = 4885,		//(1,12) Label: 'Hyperl&ink...' NOTE: FP bulk import
	msotcidInsertCaption2 = 4886,		//(0,25) Label: 'Insert C&aption' NOTE: ahw man add
	msotcidRightDragCreateHyperlink2 = 4887,		//(0,25) Label: '&Create Hyperlink' NOTE: ahw man add
	msotcidRightDragOpen = 4888,		//(0,25) Label: '&Open File' NOTE: ahw man add
	msotcidRightDragInsert = 4889,		//(0,25) Label: '&Insert File' NOTE: ahw man add
	msotcidRightDragAutoThumbnail = 4890,		//(8,21) Label: 'Auto &Thumbnail' NOTE: ahw man add
	msotcidOpenInNewWindow = 4891,		//(0,25) Label: 'Open &in New Window' NOTE: ahw man add
	msotcidNoPublish = 4892,		//(0,25) Label: 'Don't &Publish' NOTE: ahw man add
	msotcidFrontPage4893 = 4893,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4894 = 4894,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4895 = 4895,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4896 = 4896,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4897 = 4897,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4898 = 4898,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4899 = 4899,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4900 = 4900,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4901 = 4901,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4902 = 4902,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4903 = 4903,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4904 = 4904,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4905 = 4905,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4906 = 4906,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4907 = 4907,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4908 = 4908,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4909 = 4909,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4910 = 4910,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4911 = 4911,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4912 = 4912,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4913 = 4913,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4914 = 4914,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4915 = 4915,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4916 = 4916,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4917 = 4917,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4918 = 4918,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4919 = 4919,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4920 = 4920,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4921 = 4921,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4922 = 4922,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4923 = 4923,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4924 = 4924,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4925 = 4925,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4926 = 4926,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4927 = 4927,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4928 = 4928,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4929 = 4929,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4930 = 4930,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4931 = 4931,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4932 = 4932,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4933 = 4933,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4934 = 4934,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4935 = 4935,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4936 = 4936,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4937 = 4937,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4938 = 4938,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4939 = 4939,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4940 = 4940,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4941 = 4941,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4942 = 4942,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4943 = 4943,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4944 = 4944,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4945 = 4945,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4946 = 4946,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4947 = 4947,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4948 = 4948,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4949 = 4949,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4950 = 4950,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4951 = 4951,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4952 = 4952,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4953 = 4953,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4954 = 4954,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4955 = 4955,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4956 = 4956,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4957 = 4957,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4958 = 4958,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4959 = 4959,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4960 = 4960,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4961 = 4961,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4962 = 4962,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4963 = 4963,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4964 = 4964,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4965 = 4965,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4966 = 4966,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4967 = 4967,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4968 = 4968,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4969 = 4969,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4970 = 4970,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4971 = 4971,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4972 = 4972,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4973 = 4973,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4974 = 4974,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4975 = 4975,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4976 = 4976,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4977 = 4977,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4978 = 4978,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4979 = 4979,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4980 = 4980,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4981 = 4981,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4982 = 4982,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4983 = 4983,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4984 = 4984,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4985 = 4985,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4986 = 4986,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4987 = 4987,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4988 = 4988,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4989 = 4989,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4990 = 4990,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4991 = 4991,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4992 = 4992,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4993 = 4993,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4994 = 4994,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4995 = 4995,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4996 = 4996,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4997 = 4997,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4998 = 4998,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage4999 = 4999,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	};

enum
	{
	msotcidFrontPage5000 = 5000,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5001 = 5001,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5002 = 5002,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5003 = 5003,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5004 = 5004,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5005 = 5005,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5006 = 5006,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5007 = 5007,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5008 = 5008,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5009 = 5009,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5010 = 5010,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5011 = 5011,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5012 = 5012,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5013 = 5013,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5014 = 5014,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5015 = 5015,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5016 = 5016,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5017 = 5017,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5018 = 5018,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5019 = 5019,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5020 = 5020,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5021 = 5021,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5022 = 5022,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5023 = 5023,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5024 = 5024,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5025 = 5025,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5026 = 5026,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5027 = 5027,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5028 = 5028,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5029 = 5029,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5030 = 5030,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5031 = 5031,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5032 = 5032,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5033 = 5033,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5034 = 5034,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5035 = 5035,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5036 = 5036,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5037 = 5037,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5038 = 5038,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5039 = 5039,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5040 = 5040,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidFrontPage5041 = 5041,		//(0,25) Label: '' NOTE: Reserved for FrontPage
	msotcidDeco5042 = 5042,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5043 = 5043,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5044 = 5044,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5045 = 5045,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5046 = 5046,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5047 = 5047,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5048 = 5048,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5049 = 5049,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5050 = 5050,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5051 = 5051,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5052 = 5052,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5053 = 5053,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5054 = 5054,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5055 = 5055,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5056 = 5056,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5057 = 5057,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5058 = 5058,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5059 = 5059,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5060 = 5060,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5061 = 5061,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5062 = 5062,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5063 = 5063,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5064 = 5064,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5065 = 5065,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5066 = 5066,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5067 = 5067,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5068 = 5068,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5069 = 5069,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5070 = 5070,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5071 = 5071,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5072 = 5072,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5073 = 5073,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5074 = 5074,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5075 = 5075,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5076 = 5076,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5077 = 5077,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5078 = 5078,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5079 = 5079,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5080 = 5080,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5081 = 5081,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5082 = 5082,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5083 = 5083,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5084 = 5084,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5085 = 5085,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5086 = 5086,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5087 = 5087,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5088 = 5088,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5089 = 5089,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5090 = 5090,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5091 = 5091,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5092 = 5092,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5093 = 5093,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5094 = 5094,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5095 = 5095,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5096 = 5096,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5097 = 5097,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5098 = 5098,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5099 = 5099,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5100 = 5100,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5101 = 5101,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5102 = 5102,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5103 = 5103,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5104 = 5104,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5105 = 5105,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5106 = 5106,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5107 = 5107,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5108 = 5108,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5109 = 5109,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5110 = 5110,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5111 = 5111,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5112 = 5112,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5113 = 5113,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5114 = 5114,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5115 = 5115,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5116 = 5116,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5117 = 5117,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5118 = 5118,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5119 = 5119,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5120 = 5120,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5121 = 5121,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5122 = 5122,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5123 = 5123,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5124 = 5124,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5125 = 5125,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5126 = 5126,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5127 = 5127,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5128 = 5128,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5129 = 5129,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5130 = 5130,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5131 = 5131,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5132 = 5132,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5133 = 5133,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5134 = 5134,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5135 = 5135,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5136 = 5136,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5137 = 5137,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5138 = 5138,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5139 = 5139,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5140 = 5140,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5141 = 5141,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidDeco5142 = 5142,		//(0,25) Label: '' NOTE: Reserved for Deco
	msotcidPublisher5143 = 5143,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5144 = 5144,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5145 = 5145,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5146 = 5146,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5147 = 5147,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5148 = 5148,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5149 = 5149,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5150 = 5150,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5151 = 5151,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5152 = 5152,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5153 = 5153,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5154 = 5154,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5155 = 5155,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5156 = 5156,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5157 = 5157,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5158 = 5158,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5159 = 5159,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5160 = 5160,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5161 = 5161,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5162 = 5162,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5163 = 5163,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5164 = 5164,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5165 = 5165,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5166 = 5166,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5167 = 5167,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5168 = 5168,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5169 = 5169,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5170 = 5170,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5171 = 5171,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5172 = 5172,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5173 = 5173,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5174 = 5174,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5175 = 5175,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5176 = 5176,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5177 = 5177,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5178 = 5178,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5179 = 5179,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5180 = 5180,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5181 = 5181,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5182 = 5182,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5183 = 5183,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5184 = 5184,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5185 = 5185,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5186 = 5186,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5187 = 5187,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5188 = 5188,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5189 = 5189,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5190 = 5190,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5191 = 5191,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5192 = 5192,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5193 = 5193,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5194 = 5194,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5195 = 5195,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5196 = 5196,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5197 = 5197,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5198 = 5198,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5199 = 5199,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5200 = 5200,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5201 = 5201,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5202 = 5202,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5203 = 5203,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5204 = 5204,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5205 = 5205,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5206 = 5206,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5207 = 5207,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5208 = 5208,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5209 = 5209,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5210 = 5210,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5211 = 5211,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5212 = 5212,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5213 = 5213,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5214 = 5214,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5215 = 5215,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5216 = 5216,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5217 = 5217,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5218 = 5218,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5219 = 5219,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5220 = 5220,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5221 = 5221,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5222 = 5222,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5223 = 5223,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5224 = 5224,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5225 = 5225,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5226 = 5226,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5227 = 5227,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5228 = 5228,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5229 = 5229,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5230 = 5230,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5231 = 5231,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5232 = 5232,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5233 = 5233,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5234 = 5234,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5235 = 5235,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5236 = 5236,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5237 = 5237,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5238 = 5238,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5239 = 5239,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5240 = 5240,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5241 = 5241,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5242 = 5242,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidPublisher5243 = 5243,		//(0,25) Label: '' NOTE: Reserved for Publisher
	msotcidFutureUse5244 = 5244,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5245 = 5245,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5246 = 5246,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5247 = 5247,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5248 = 5248,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5249 = 5249,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5250 = 5250,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5251 = 5251,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5252 = 5252,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5253 = 5253,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5254 = 5254,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5255 = 5255,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5256 = 5256,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5257 = 5257,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5258 = 5258,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5259 = 5259,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5260 = 5260,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5261 = 5261,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5262 = 5262,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5263 = 5263,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5264 = 5264,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5265 = 5265,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5266 = 5266,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5267 = 5267,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5268 = 5268,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5269 = 5269,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5270 = 5270,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5271 = 5271,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5272 = 5272,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5273 = 5273,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5274 = 5274,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5275 = 5275,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5276 = 5276,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5277 = 5277,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5278 = 5278,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5279 = 5279,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5280 = 5280,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5281 = 5281,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5282 = 5282,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5283 = 5283,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5284 = 5284,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5285 = 5285,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5286 = 5286,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5287 = 5287,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5288 = 5288,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5289 = 5289,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5290 = 5290,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5291 = 5291,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5292 = 5292,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5293 = 5293,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5294 = 5294,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5295 = 5295,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5296 = 5296,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5297 = 5297,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5298 = 5298,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5299 = 5299,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5300 = 5300,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5301 = 5301,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5302 = 5302,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5303 = 5303,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5304 = 5304,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5305 = 5305,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5306 = 5306,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5307 = 5307,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5308 = 5308,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5309 = 5309,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5310 = 5310,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5311 = 5311,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5312 = 5312,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5313 = 5313,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5314 = 5314,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5315 = 5315,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5316 = 5316,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5317 = 5317,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5318 = 5318,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5319 = 5319,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5320 = 5320,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5321 = 5321,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5322 = 5322,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5323 = 5323,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5324 = 5324,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5325 = 5325,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5326 = 5326,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5327 = 5327,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5328 = 5328,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5329 = 5329,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5330 = 5330,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5331 = 5331,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5332 = 5332,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5333 = 5333,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5334 = 5334,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5335 = 5335,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5336 = 5336,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5337 = 5337,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5338 = 5338,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5339 = 5339,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5340 = 5340,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5341 = 5341,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5342 = 5342,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5343 = 5343,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5344 = 5344,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5345 = 5345,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5346 = 5346,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5347 = 5347,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5348 = 5348,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5349 = 5349,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5350 = 5350,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5351 = 5351,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5352 = 5352,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5353 = 5353,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5354 = 5354,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5355 = 5355,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5356 = 5356,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5357 = 5357,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5358 = 5358,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5359 = 5359,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5360 = 5360,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5361 = 5361,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5362 = 5362,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5363 = 5363,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5364 = 5364,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5365 = 5365,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5366 = 5366,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5367 = 5367,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5368 = 5368,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5369 = 5369,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5370 = 5370,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5371 = 5371,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5372 = 5372,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5373 = 5373,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5374 = 5374,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5375 = 5375,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5376 = 5376,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5377 = 5377,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5378 = 5378,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5379 = 5379,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5380 = 5380,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5381 = 5381,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5382 = 5382,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5383 = 5383,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5384 = 5384,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5385 = 5385,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5386 = 5386,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5387 = 5387,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5388 = 5388,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5389 = 5389,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5390 = 5390,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5391 = 5391,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5392 = 5392,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5393 = 5393,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5394 = 5394,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5395 = 5395,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5396 = 5396,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5397 = 5397,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5398 = 5398,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5399 = 5399,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidFutureUse5400 = 5400,		//(0,25) Label: '' NOTE: Reserved for future use
	msotcidWebServerInsertInlinePPT = 5401,		//(52,27) Label: '&Insert in the Slide...' NOTE: 88800
	msotcidWebServerInsertInlineExcel = 5402,		//(52,27) Label: '&Insert in the Sheet...'
	msotcidWebServerInsertInlineWord = 5403,		//(52,27) Label: '&Insert in the Document...'
	msotcidWebServerInsertGeneralPPT = 5404,		//(53,20) Label: 'I&nsert about the Presentation...'
	msotcidWebServerInsertGeneralExcel = 5405,		//(53,20) Label: 'I&nsert about the Workbook...'
	msotcidWebServerInsertGeneralWord = 5406,		//(53,20) Label: 'I&nsert about the Document...'
	msotcidWebServerRefresh = 5407,		//(0,25) Label: '&Refresh Discussions'
	msotcidWebServerFilter = 5408,		//(0,25) Label: '&Filter Discussions...'
	msotcidWebServerPrintBand = 5409,		//(0,25) Label: '&Print Discussions...'
	msotcidWebServerOptions = 5410,		//(0,25) Label: '&Discussion Options...'
	msotcidWebServerSubscription = 5411,		//(0,25) Label: '&Subscribe...'
	msotcidWebServerCloseDiscussions = 5412,		//(0,25) Label: '&Close'
	msotcidWebServerCommentPane = 5413,		//(0,25) Label: '&Web Discussions'
	msotcidWebThemeName = 5414,		//(0,25) Label: '&Web Theme Name' NOTE: O9 bug 60916; not in a menu or toolbar, just there for undo
	msotcidTogglePublishMode = 5415,		//(12,0) Label: '&Toggle Publish Mode' NOTE: mail request from Doug Franklin (VBE)
	msotcidPivotChartRemoveFields = 5416,		//(17,9) Label: 'Remo&ve Fields'
	msotcidAPPT_VIEW_NS = 5417,		//(54,20) Label: 'View Windows &Media'
	msotcidNEW_LOG_DOC_LINK = 5418,		//(0,25) Label: '&File...'
	msotcidLINKITEM = 5419,		//(0,25) Label: '&Items...'
	msotcidADDCTCT = 5420,		//(0,25) Label: '&Add Contacts...'
	msotcidUSE_RICHTEXT = 5421,		//(0,25) Label: 'Microsoft &Outlook Rich Text'
	msotcidUSE_PLAINTEXT = 5422,		//(0,25) Label: '&Plain Text'
	msotcidAUTOPICK_ALLATTEND = 5423,		//(0,25) Label: '&All People and Resources'
	msotcidAUTOPICK_REQATTEND = 5424,		//(0,25) Label: '&Required People'
	msotcidAUTOPICK_ALLATTENDRESOURCE = 5425,		//(0,25) Label: 'All &People and One Resource'
	msotcidAUTOPICK_REQATTENDRESOURCE = 5426,		//(0,25) Label: 'R&equired People and One Resource'
	msotcidVIEW_ENCODING_MRU = 5427,		//(0,25) Label: ''
	msotcidFORMAT_ENCODING_MRU = 5428,		//(0,25) Label: ''
	msotcidADD_WEBPAGE_TO_OUTLBAR = 5429,		//(0,25) Label: 'Outlook Bar Shortcut to &Web Page...'
	msotcidAPPT_CHANGE_ATTENDEES = 5430,		//(0,25) Label: 'Add or Remo&ve Attendees...'
	msotcidCTX_APPT_CHANGE_ATTENDEES = 5431,		//(0,25) Label: 'Add or R&emove Attendees...'
	msotcidWEBVIEW_TOGGLE = 5432,		//(7,16) Label: 'Show Folder &Home Page'
	msotcidCONTACT_NEWAPPT = 5433,		//(0,25) Label: 'New A&ppointment with Contact'
	msotcidNEW_DIST_LIST = 5434,		//(52,21) Label: 'Distribution &List'
	msotcidNEW_DIST_LIST_DSPACC1 = 5435,		//(52,21) Label: 'Distribution &List'
	msotcidNEW_DIST_LIST_DSPACC2 = 5436,		//(52,21) Label: 'New &Distribution List'
	msotcidSYNC_SETTINGS = 5437,		//(0,25) Label: '&Offline Folder Settings...'
	msotcidTOOLS_FIND_PUBLIC_FOLDER = 5438,		//(0,25) Label: 'Find &Public Folder...'
	msotcidFLDFIND_OPEN = 5439,		//(0,25) Label: '&Open'
	msotcidFLDFIND_COPY = 5440,		//(0,25) Label: '&Copy...'
	msotcidFLDFIND_PROPERTIES = 5441,		//(0,25) Label: 'Propert&ies...'
	msotcidFLDFIND_RENAME = 5442,		//(0,25) Label: '&Rename...'
	msotcidCONTACT_MAILMERGE = 5443,		//(0,25) Label: '&Mail Merge...'
	msotcidCTX_APPT_MAKEFREE = 5444,		//(0,25) Label: '&Free'
	msotcidCTX_APPT_MAKETENT = 5445,		//(0,25) Label: '&Tentative'
	msotcidCTX_APPT_MAKEBUSY = 5446,		//(0,25) Label: '&Busy'
	msotcidCTX_APPT_MAKEOOF = 5447,		//(0,25) Label: '&Out of Office'
	msotcidCONTACT_VIEW = 5448,		//(0,25) Label: 'Contact&s...'
	msotcidFOLDER_SENDLINK = 5449,		//(0,25) Label: '&Send Link to This Folder'
	msotcidRUN_RULES_NOW = 5450,		//(0,25) Label: '&Run Rules Now...'
	msotcidDL_REFRESH = 5451,		//(0,25) Label: '&Refresh'
	msotcidNEW_DIST_LIST_DSPACC3 = 5452,		//(52,21) Label: 'New Distribution &List'
	msotcidNEW_DIST_LIST_DSPACC4 = 5453,		//(52,21) Label: 'Distribution &List'
	msotcidCONTACT_QUICKFIND_COMBO = 5454,		//(0,25) Label: '&Find a Contact'
	msotcidDIALUP_USEEXISTING = 5455,		//(0,25) Label: '&Use Existing Connection (LAN)'
	msotcidSEND_WEB_PAGE = 5456,		//(0,25) Label: 'Send We&b Page by E-mail'
	msotcidCONTACT_QUICKFIND_ACCEL = 5457,		//(0,25) Label: ''
	msotcidSEND_MTG_AS_ICAL = 5458,		//(0,25) Label: 'Send as &iCalendar'
	msotcidFORWARD_AS_ICAL = 5459,		//(0,25) Label: 'Forward as iCa&lendar'
	msotcidPROGRSSCTL_SHOWMENU = 5460,		//(0,25) Label: '&Show Progress Menu'
	msotcidRECEIVE_FAX = 5461,		//(0,25) Label: 'Receive Fa&x'
	msotcidWEB_GO_COMBO_ACCEL = 5462,		//(0,25) Label: ''
	msotcidDummy5463 = 5463,		//(0,25) Label: '&Dummy' NOTE: VIEW_ENCODING_MORE
	msotcidDummy5464 = 5464,		//(0,25) Label: '&Dummy' NOTE: FORMAT_ENCODING_MORE
	msotcidDummy5465 = 5465,		//(0,25) Label: '&Dummy' NOTE: ADDRBOOK_DIST_LIST
	msotcidDummy5466 = 5466,		//(0,25) Label: '&Dummy' NOTE: DIALUP_CONNECTION
	msotcidDummy5467 = 5467,		//(0,25) Label: '&Dummy' NOTE: LINK_DROPDOWN
	msotcidDummy5468 = 5468,		//(0,25) Label: '&Dummy' NOTE: CTX_LINK_DROPDOWN
	msotcidSEND_OMI = 5469,		//(0,25) Label: '&Send'
	msotcidDummy5470 = 5470,		//(0,25) Label: '&Dummy' NOTE: NEWENVDOC
	msotcidHTMLDirect = 5471,		//(0,25) Label: '&HTML Direct' NOTE: MAC
	msotcidUnoptimizedRecalc = 5472,		//(0,25) Label: '&TBA'
	msotcidFormatReport = 5473,		//(6,28) Label: 'Table Auto&Format...' NOTE: duplicate of TableAutoFormat -- of different quicktip
	msotcidOpentype = 5474,		//(55,2) Label: '&Opentype Font' NOTE: for NT5
	msotcidAdobe = 5475,		//(55,3) Label: '&Adobe Font' NOTE: for NT5 fonts
	msotcidOPENSELECTEDITMES = 5476,		//(0,25) Label: '&Selected Items' NOTE: Opens the selected item
	msotcidOPENOTHERS_PST = 5477,		//(0,25) Label: '&Personal Folders File (.pst)...' NOTE: Opens another user's Folder
	msotcidADDTOADDRESSLIST = 5478,		//(0,25) Label: 'Add To C&ontact Manager' NOTE: Add the item to current contacts list
	msotcidADDTOCALENDAR = 5479,		//(0,25) Label: 'Add To &Calendar' NOTE: Adds the item to current Calendar
	msotcidADDTOTASKLIST = 5480,		//(0,25) Label: 'Add To Tas&k Manager' NOTE: Adds the item to current Task List
	msotcidADDTONOTES = 5481,		//(0,25) Label: 'Add To No&tes' NOTE: Adds the item to current Notes
	msotcidFORMATBULLET = 5482,		//(0,25) Label: 'Bullets and &Numbering...' NOTE: Changes the appearance of bullets and line numbers
	msotcidVIEWRECEIPT = 5483,		//(0,25) Label: '&View Receipt...' NOTE: View the Non-Delivery Report
	msotcidADDRGENERALPAGE = 5484,		//(0,25) Label: '&General Page' NOTE: Switch to the general page
	msotcidADDRCONTACTLOGPAGE = 5485,		//(0,25) Label: 'Contact &Log Page' NOTE: Switch to the contact log page
	msotcidAPPT_MAKEEVENT = 5486,		//(0,25) Label: '&Event' NOTE: Turn this item into an event.
	msotcidHIDEFOLDERLIST = 5487,		//(0,25) Label: '&Hide Folder List' NOTE: Hides folder list
	msotcidDELIVERMAIL = 5488,		//(6,7) Label: 'Send/Re&ceive' NOTE: Send and receive mail
	msotcidVIEWMEETING = 5489,		//(0,25) Label: '&View Meeting' NOTE: Views associated meeting
	msotcidABREMINDERS = 5490,		//(0,25) Label: '&Reminders...' NOTE: Changes reminder settings
	msotcidABMAILMERGE = 5491,		//(0,25) Label: 'Mail Mer&ge...' NOTE: Performs a mail merge
	msotcidCONTACT_MEMO = 5492,		//(0,25) Label: 'M&emo...' NOTE: Send a memo to the selected people
	msotcidCONTACT_SENDCARD = 5493,		//(0,25) Label: '&Send Card...' NOTE: Send your business card to the selected people
	msotcidCONTACT_OTHER = 5494,		//(0,25) Label: '&Other...' NOTE: Do other contact stuff
	msotcidAPPT_INSERTAPPOINTMENT = 5495,		//(0,25) Label: '&Appointment' NOTE: Inserts a new appointment
	msotcidAPPT_INSERTTASK = 5496,		//(0,25) Label: '&Task' NOTE: Inserts a new task
	msotcidAPPT_TODAY = 5497,		//(0,25) Label: '&Today' NOTE: View
	msotcidNEW_EVENT = 5498,		//(0,25) Label: 'New All Day &Event' NOTE: Create a new multi-day event
	msotcidSTATUSREQUEST = 5499,		//(0,25) Label: '&Send Status Request...' NOTE: Request status report
	msotcidNEW_ANNUALEVENT = 5500,		//(0,25) Label: 'Ne&w Annual Event' NOTE: Create a new annual multi-day event
	msotcidREPLY_MEETING = 5501,		//(0,25) Label: '&Appointment' NOTE: Reply to message with a meeting request
	msotcidREPLY_TASK = 5502,		//(0,25) Label: '&Task' NOTE: Reply to message with a task request
	msotcidBOGUS = 5503,		//(0,25) Label: '&Bogus' NOTE: Bogus
	msotcidAPPT_SEND_RESP = 5504,		//(0,25) Label: 'Send &Response' NOTE: Send a response to the meeting organizer
	msotcidTOOLS_FIND = 5505,		//(0,25) Label: 'A&dvanced Find...'
	msotcidCTX_CONNECT = 5506,		//(0,25) Label: '&Personal Folders File (.pst)...'
	msotcidCTX_CREATEFAVORITE = 5507,		//(0,25) Label: 'Outlook &Bar Shortcut...' NOTE: This is the command to create a new shortcut via a dialog box
	msotcidCTX_NYI = 5508,		//(0,25) Label: '&NYI - See Specs'
	msotcidSC_SIZE = 5509,		//(0,25) Label: '&Size' NOTE: Change window size
	msotcidSC_MOVE = 5510,		//(0,25) Label: '&Move' NOTE: Change window position
	msotcidSC_RESTORE = 5511,		//(0,25) Label: '&Restore' NOTE: Restore window to normal size
	msotcidCENTER_FORM_BUTTON = 5512,		//(0,25) Label: '&Center in Form' NOTE: Center controls
	msotcidMAKESAMESIZE_BUTTON = 5513,		//(0,25) Label: '&Make Same Size' NOTE: Make controls the same size
	msotcidPREVIEW_PANE_SHOW = 5514,		//(7,14) Label: 'Preview Pa&ne' NOTE: Toggle the Preview pane
	msotcidPREVIEW_PANE_HEADER = 5515,		//(0,25) Label: 'Header &Information' NOTE: Toggle the preview pane header on/off
	msotcidPREVIEW_PANE_OPTIONS = 5516,		//(0,25) Label: 'Preview Pane &Options...' NOTE: Opens the Preview Pane's options page
	msotcidNEW_NEWS = 5517,		//(0,25) Label: 'New&s Message' NOTE: Creates a new note
	msotcidNEW_NEWS_DSPACC1 = 5518,		//(0,25) Label: 'New&s Message' NOTE: Creates a new note
	msotcidNEW_NEWS_DSPACC2 = 5519,		//(0,25) Label: '&New News Message' NOTE: Creates a new note
	msotcidNEW_NEWSGROUPS = 5520,		//(0,25) Label: 'News&groups...' NOTE: Opens up the Athena newsgroup subscription dialog
	msotcidCANCEL_ARTICLE = 5521,		//(0,25) Label: '&Cancel Message'
	msotcidKILL_THREAD = 5522,		//(0,25) Label: 'Kill T&hread'
	msotcidKILL_AUTHOR = 5523,		//(0,25) Label: 'Kill Auth&or'
	msotcidMARK_THREAD_AS_READ = 5524,		//(0,25) Label: 'Ma&rk Thread As Read'
	msotcidNEWS_DOWNLOAD = 5525,		//(0,25) Label: 'Mark M&essage'
	msotcidNEWS_THREAD_DOWNLOAD = 5526,		//(0,25) Label: 'Mark &Thread for Retrieval'
	msotcidNEWS_ALL_DOWNLOAD = 5527,		//(0,25) Label: 'Mark &All Messages'
	msotcidROT13 = 5528,		//(0,25) Label: 'Unscram&ble (ROT13)'
	msotcidNEWS_ADDRESS_BOOK = 5529,		//(0,25) Label: 'Ne&ws Address Book'
	msotcidNEWS_SIGNATURES = 5530,		//(0,25) Label: 'Signa&tures...' NOTE: Edit news signatures
	msotcidNEWS_STOP = 5531,		//(0,25) Label: '&Stop'
	msotcidNEWS_GET_ALL_HEADERS = 5532,		//(0,25) Label: 'Get All Hea&ders'
	msotcidNEWS_GET_NEXT_HEADERS = 5533,		//(0,25) Label: 'Get Next <0d> &Headers'
	msotcidNEWS_GET_ALL_ARTICLES = 5534,		//(0,25) Label: 'Get All Messa&ges'
	msotcidNEWS_GET_NEXT_ARTICLES = 5535,		//(0,25) Label: 'Get Next <0d> M&essages'
	msotcidNEWS_GET_MARKED_ARTICLES = 5536,		//(0,25) Label: 'Get &Marked Message'
	msotcidNEWS_CATCH_UP = 5537,		//(0,25) Label: 'Catc&h Up'
	msotcidNEWS_FILTERS = 5538,		//(0,25) Label: '&Kill List'
	msotcidNEWS_GROUP_UNSUBSCRIBE = 5539,		//(0,25) Label: 'Unsubs&cribe'
	msotcidACCOUNTS = 5540,		//(0,25) Label: '&Accounts...'
	msotcidNEWS_FOLLOWUP = 5541,		//(0,25) Label: 'Re&ply to Newsgroup' NOTE: Follow up
	msotcidNEWS_REPLY_AUTHOR = 5542,		//(0,25) Label: '&Reply to Author'
	msotcidNEWS_REPLY_ALL = 5543,		//(0,25) Label: 'R&eply to Newsgroup and Author'
	msotcidNEWS_REPLY_AUTHOR_BOTH = 5544,		//(0,25) Label: '&Reply to Author' NOTE: Reply to message - Text and Icon version
	msotcidNEWS_FOLLOWUP_BOTH = 5545,		//(0,25) Label: 'Re&ply to Newsgroup' NOTE: Follow up to newsgroup
	msotcidNEWS_HEADERS = 5546,		//(0,25) Label: '&News Headers'
	msotcidNEWS_POST = 5547,		//(0,25) Label: '&Post'
	msotcidNEWS_INSERT_SIG = 5548,		//(0,25) Label: 'News Signa&ture' NOTE: Add news signature
	msotcidMAIL_HEADERS = 5549,		//(0,25) Label: '&Mail Headers'
	msotcidROT13_MODULE = 5550,		//(0,25) Label: 'Unscram&ble (ROT13)'
	msotcidNEWS_SYNC_NEWSGROUP = 5551,		//(0,25) Label: '&Update this Newsgroup...'
	msotcidNEWS_SYNC_SERVER = 5552,		//(0,25) Label: '&Update this server'
	msotcidNEWS_SYNC_WIZARD = 5553,		//(0,25) Label: 'Synch&ronize Wizard'
	msotcidNEWS_SEND_MESSAGE = 5554,		//(0,25) Label: 'Send &Messages'
	msotcidHORZRULE = 5555,		//(55,6) Label: 'Horizontal &Line' NOTE: Inserts a horizontal line
	msotcidAPPT_WORKWEEKVIEW = 5556,		//(55,7) Label: 'Wo&rk Week'
	msotcidSCRIPT_DEBUG = 5557,		//(0,25) Label: 'Script &Debugger' NOTE: Launch Script Debugger
	msotcidRUN_START = 5558,		//(0,25) Label: 'Run This &Form'
	msotcidRUN_END = 5559,		//(0,25) Label: '&End'
	msotcidRUN_RESTART = 5560,		//(0,25) Label: '&Restart'
	msotcidCONDFMT = 5561,		//(0,25) Label: 'Automat&ic Formatting...'
	msotcidFORMAT_BACK_IMAGE = 5562,		//(0,25) Label: '&Picture...' NOTE: Format background image
	msotcidFORMAT_PLAINTEXT = 5563,		//(0,25) Label: 'Plain &Text' NOTE: Set the message to plain text format
	msotcidFORMAT_HTML = 5564,		//(0,25) Label: '&HTML' NOTE: Set the message to HTML format
	msotcidFORMAT_RICHTEXT = 5565,		//(0,25) Label: '&Rich Text' NOTE: Set the message to Rich Text format
	msotcidFONTZOOM_LARGEST = 5566,		//(0,25) Label: 'Lar&gest' NOTE: Changes to use the largest font
	msotcidFONTZOOM_LARGER = 5567,		//(0,25) Label: '&Larger' NOTE: Changes to use a larger font
	msotcidFONTZOOM_MEDIUM = 5568,		//(0,25) Label: '&Medium' NOTE: Changes to use the medium font
	msotcidFONTZOOM_SMALLER = 5569,		//(0,25) Label: '&Smaller' NOTE: Changes to use a smaller font
	msotcidFONTZOOM_SMALLEST = 5570,		//(0,25) Label: 'Sm&allest' NOTE: Changes to use the smallest font
	msotcidFONTZOOM_NEXT = 5571,		//(55,8) Label: '&Font Size' NOTE: Change the size of the display font
	msotcidEXPVCARD = 5572,		//(0,25) Label: 'E&xport to vCard file...'
	msotcidFORWARDASVCARD = 5573,		//(0,25) Label: 'Forward as &vCard'
	msotcidFORWARD_AS_VCAL = 5574,		//(0,25) Label: 'Forward as &vCalendar' NOTE: Forward selected appointments as vCalendar attachments
	msotcidCREATE_PST = 5575,		//(0,25) Label: 'Personal Folders &File (.pst)...'
	msotcidOPEN_PST = 5576,		//(0,25) Label: 'O&pen Personal Folders File (.pst)...'
	msotcidSENDMAIL = 5577,		//(0,25) Label: '&Send'
	msotcidNEWS_GET_NEW_ARTICLES = 5578,		//(0,25) Label: 'Get New &Messages'
	msotcidNEWS_GET_NEW_HEADERS = 5579,		//(0,25) Label: 'Get New &Headers'
	msotcidNEWS_UPDATE_BUTTON = 5580,		//(0,25) Label: 'News &Update'
	msotcidFIND_PEOPLE = 5581,		//(0,25) Label: 'Find &People...'
	msotcidDEBUG_USEWORDMAIL = 5582,		//(0,25) Label: 'Use Word as the &E-Mail Editor'
	msotcidIMAP_EXPUNGE = 5583,		//(0,25) Label: 'Purge Deleted Me&ssages' NOTE: Purges all items that are marked for deletion in this folder
	msotcidIMAP_UNDELETE = 5584,		//(0,25) Label: '&Undelete' NOTE: Unmarks the item for deletion
	msotcidNEWOUTLOOKBAR = 5585,		//(0,25) Label: '&New Outlook Bar...'
	msotcidATTACHPANE_LARGEICON = 5586,		//(0,25) Label: 'Lar&ge Icon'
	msotcidATTACHPANE_SMALLICON = 5587,		//(0,25) Label: 'S&mall Icon'
	msotcidATTACHPANE_LIST = 5588,		//(0,25) Label: '&List'
	msotcidQUICKVIEW = 5589,		//(0,25) Label: '&Quick View'
	msotcidADDRITEM_CUSTOMIZE_VIEW = 5590,		//(0,25) Label: '&Customize Current View...'
	msotcidADDRITEM_FORMAT_COLUMNS = 5591,		//(0,25) Label: 'For&mat Columns...'
	msotcidFINDTOOL = 5592,		//(6,0) Label: 'F&ind'
	msotcidORGTOOL = 5593,		//(6,8) Label: 'Organi&ze'
	msotcidOPENOTHERSTOOL = 5594,		//(0,25) Label: '&Open Other's Calendar'
	msotcidIMAP_SUBSCRIBE = 5595,		//(0,25) Label: 'I&MAP Folders...' NOTE: Displays the subscription dialog
	msotcidAPPT_JOIN_CONF = 5596,		//(55,23) Label: 'Join &Conference' NOTE: Joins an Exchange Conference
	msotcidADDR_START_NM = 5597,		//(55,23) Label: 'Call Using N&etMeeting' NOTE: Starts a NetMeeting Call with the selected contact
	msotcidMAIL_OPTIONS = 5598,		//(55,11) Label: 'O&ptions...'
	msotcidGOTOTODAYSOUTLOOK = 5599,		//(55,12) Label: 'Outloo&k Today'
	msotcidPROGRESSCTL_DETAILS = 5600,		//(0,25) Label: '&Details...'
	msotcidPROGRESSCTL_CANCEL = 5601,		//(0,25) Label: '&Cancel'
	msotcidADDR_GETMAP = 5602,		//(55,13) Label: '&Display Map of Address' NOTE: View Map button for the customized contact page
	msotcidVIEWSOURCE = 5603,		//(0,25) Label: 'View &Source' NOTE: View HTML Source
	msotcidEDITMESSAGE = 5604,		//(0,25) Label: '&Edit Message' NOTE: Edit Message
	msotcidBROWSEMESSAGE = 5605,		//(0,25) Label: 'Browse &View' NOTE: Browse View
	msotcidSAVEPICTUREAS = 5606,		//(0,25) Label: '&Save Picture As' NOTE: Save Picture As
	msotcidSAVEBACKGROUNDAS = 5607,		//(0,25) Label: '&Save Background As' NOTE: Save Background as
	msotcidSIGNATURE_COMBO = 5608,		//(55,14) Label: '&Signature' NOTE: Insert the selected signature
	msotcidINSERT_SIGNATURE = 5609,		//(0,25) Label: '&More...' NOTE: Choose a signature to insert
	msotcidUSE_DEFAULT_STATIONERY = 5610,		//(0,25) Label: '&HTML (No Stationery)' NOTE: Compose a message using the Outlook Default Stationery
	msotcidUSE_STATIONERY = 5611,		//(0,25) Label: '&More Stationery...' NOTE: Choose a stationery to compose a new message with
	msotcidINSERT_PICTURE = 5612,		//(0,25) Label: '&Picture...'
	msotcidTOGGLE_ONLINE = 5613,		//(0,25) Label: 'Wor&k Offline' NOTE: Enters the offline state
	msotcidSTYLEDROPDOWN = 5614,		//(0,25) Label: '&Style' NOTE: Selects the current style
	msotcidANTI_SPAM_ADDTOJUNKLIST = 5615,		//(0,25) Label: 'Add to &Junk Senders list'
	msotcidPUBLISHFORMAS = 5616,		//(0,25) Label: 'Pu&blish Form As...'
	msotcidDESIGNFORM2 = 5617,		//(0,25) Label: 'D&esign a Form...' NOTE: New message using a form
	msotcidAPPT_JOIN_NM = 5618,		//(55,23) Label: 'Join &NetMeeting' NOTE: Joins a NetMeeting
	msotcidPUBLISH_FREEBUSY = 5619,		//(0,25) Label: '&Free/Busy Information'
	msotcidANTI_SPAM_ADULTLIST = 5620,		//(0,25) Label: 'Add to &Adult Content Senders list'
	msotcidEXT_OOFASST = 5621,		//(0,25) Label: 'O&ut of Office Assistant...' NOTE: Informs other senders you are out of office
	msotcidEXT_NEWTEAMSTATUS = 5622,		//(55,15) Label: 'New TeamStatus &Report'
	msotcidEXT_SHOWSCHEDULE = 5623,		//(55,16) Label: '&Launch Schedule+'
	msotcidEXT_SYNCALLFOLDERS = 5624,		//(0,25) Label: '&All Folders'
	msotcidEXT_SYNCTHISFOLDER = 5625,		//(0,25) Label: 'This &Folder'
	msotcidEXT_DOWNLOADAB = 5626,		//(0,25) Label: '&Download Address Book...'
	msotcidEXT_ADDPUBFOLDFAV = 5627,		//(0,25) Label: 'Add to Public Folder Favori&tes'
	msotcidEXT_REMOVEPUBFOLDFAV = 5628,		//(0,25) Label: 'Remove from Public Folder Favori&tes'
	msotcidEXT_COPYFOLDDESIGN = 5629,		//(0,25) Label: 'Cop&y Folder Design...'
	msotcidEXT_FAXSENDOPTIONS = 5630,		//(0,25) Label: 'Send &Options'
	msotcidEXT_FAXWIZARD = 5631,		//(0,25) Label: 'Fax Addressing &Wizard...'
	msotcidEXT_NEWFAX = 5632,		//(0,25) Label: 'New Fa&x Message'
	msotcidEXT_FAXHELP = 5633,		//(0,25) Label: 'Microsoft Fa&x Help Topics'
	msotcidEXT_FAXREQUEST = 5634,		//(0,25) Label: '&Request a Fax...'
	msotcidEXT_FAXADVANCEDSECURITY = 5635,		//(0,25) Label: '&Advanced Security...'
	msotcidEXT_FAXSHOWOUTGOING = 5636,		//(0,25) Label: 'S&how Outgoing Faxes'
	msotcidEXT_FAXOPTIONS = 5637,		//(0,25) Label: '&Options...'
	msotcidEXT_MSMAILHELP = 5638,		//(0,25) Label: 'Microsoft Mail H&elp Topics'
	msotcidEXT_MSMAILCHANGEPASSWORD = 5639,		//(0,25) Label: '&Change Mailbox Password...'
	msotcidEXT_MSMAILDOWNLOADAL = 5640,		//(0,25) Label: '&Download Address Lists'
	msotcidEXT_MSMAILREMOTEDELIVERY = 5641,		//(0,25) Label: '&Schedule Remote Mail Delivery...'
	msotcidEXT_MSMAILSETDIALINGLOCATION = 5642,		//(0,25) Label: 'Set Dialing &Location...'
	msotcidEXT_MSMAILVIEWSESSIONLOG = 5643,		//(0,25) Label: '&View Session Log'
	msotcidEXT_NETMEETINGPLACECALL = 5644,		//(55,23) Label: '&From Address Book...'
	msotcidEXT_SAVEANDCLOSE = 5645,		//(55,17) Label: 'Save && Cl&ose'
	msotcidEXT_SHARECALENDAR = 5646,		//(0,25) Label: '&Calendar...'
	msotcidEXT_SHARETASKS = 5647,		//(0,25) Label: '&Tasks...'
	msotcidEXT_SHARECONTACTS = 5648,		//(0,25) Label: 'C&ontacts...'
	msotcidEXT_SHARETHISFOLDER = 5649,		//(0,25) Label: 'T&his Folder...'
	msotcidEXT_TM_FORTEAMMEMBERS = 5650,		//(55,18) Label: 'Team Manager &for team members'
	msotcidEXT_TM_SENDUPDATES = 5651,		//(0,25) Label: 'Send Up&dates...'
	msotcidEXT_TM_VIEWTEAMSTATUS = 5652,		//(55,19) Label: 'View &Team Status'
	msotcidEXT_WINCE_INBOX_TRANSFER = 5653,		//(55,20) Label: '&Windows CE Inbox Transfer...'
	msotcidEXT_DUMPSTER = 5654,		//(7,21) Label: 'Recover Dele&ted Items...'
	msotcidEXT_RESERVED3 = 5655,		//(0,25) Label: '&Reserved...'
	msotcidSYNC_ALLFOLDERS = 5656,		//(0,25) Label: '&All Folders' NOTE: syncronize all folders
	msotcidSYNC_THISFOLDER = 5657,		//(0,25) Label: 'This &Folder' NOTE: syncronize this folders
	msotcidSYNC_ADDRBOOK = 5658,		//(0,25) Label: '&Download Address Book...' NOTE: syncronize all folders
	msotcidIMAP_CONNECT = 5659,		//(0,25) Label: '&Connect to IMAP Server' NOTE: Re-opens a connection to the IMAP server
	msotcidNEW_WORDMAIL_NOTE = 5660,		//(0,25) Label: 'Microsoft &Word'
	msotcidIMAP_DOWNLOAD_HIERARCHY = 5661,		//(0,25) Label: 'Folder &List' NOTE: Downloads the entire hierarchy for this server
	msotcidIMAP_DOWNLOAD_HEADERS = 5662,		//(0,25) Label: 'H&eaders' NOTE: Downloads new headers into this folder
	msotcidIMAP_DOWNLOAD_SELECTED = 5663,		//(0,25) Label: '&Selected Items' NOTE: Downloads the selected items
	msotcidIMAP_DOWNLOAD_ALL = 5664,		//(0,25) Label: '&All Items' NOTE: Downloads all messages in this folder
	msotcidNEWWEBFORM = 5665,		//(0,25) Label: 'We&b Form' NOTE: launch kluane to compose a new message based on a web form
	msotcidSAVE_AS_STATIONERY = 5666,		//(0,25) Label: 'Sa&ve Stationery...' NOTE: Saves the stationery settings of the current message
	msotcidAPPLY_STATIONERY = 5667,		//(0,25) Label: 'A&pply Stationery...' NOTE: Apply stationery to the current message
	msotcidCOERCE_VCARD = 5668,		//(0,25) Label: 'Copy Here as &vCard' NOTE: Creates a contact from a vCard
	msotcidSEND_PICTURES = 5669,		//(0,25) Label: 'Send Pictures from the &Internet' NOTE: Sends image files with the message for offline viewing
	msotcidCTX_IMAP_DOWNLOAD_HIERARCHY = 5670,		//(0,25) Label: 'Download Folder &List' NOTE: Downloads the entire hierarchy for this server
	msotcidCTX_OPEN = 5671,		//(0,25) Label: '&Open Selected Items'
	msotcidGO_NEWS = 5672,		//(0,25) Label: 'New&s'
	msotcidGO_INTERNET = 5673,		//(0,25) Label: 'Web Bro&wser'
	msotcidGO_CALL = 5674,		//(0,25) Label: 'Internet Ca&ll'
	msotcidNEW_FAX = 5675,		//(0,25) Label: 'Fa&x Message' NOTE: Creates a new fax message
	msotcidGO_CALL2 = 5676,		//(0,25) Label: 'Internet Ca&ll'
	msotcidJOURNAL_FOR_CONTACT = 5677,		//(0,25) Label: 'New &Journal Entry for Contact' NOTE: creates a journal item for the contact
	msotcidNEW_FAX2 = 5678,		//(0,25) Label: 'New Fa&x Message' NOTE: Creates a new fax message
	msotcidCOERCE_VCAL = 5679,		//(0,25) Label: 'Copy Here as &vCalendar' NOTE: Creates an appointment from a vCalendar file
	msotcidAPPT_INVITEALL_OMI = 5680,		//(55,22) Label: '&Send' NOTE: OMI Send Button
	msotcidAPPT_START_NM = 5681,		//(55,23) Label: 'Start &NetMeeting' NOTE: Starts a NetMeeting
	msotcidEXT_FAXEXT_ATTRIBUTES = 5682,		//(55,24) Label: 'Fa&x Attributes...'
	msotcidPPTtutorialShowMe = 5683,		//(0,25) Label: '' NOTE: Never seen in the UI just for UA
	msotcidCellWatchPane = 5684,		//(0,25) Label: '&Watch Window' NOTE: noicon Tools.../Auditing.../Formula Watch pane control to hold
	msotcidToggleCellWatch = 5685,		//(0,25) Label: '&Add Watch' NOTE: noicon GridCellPopup/[Add|Delete] Watch (toggles menuitem text)
	msotcidToggleCellWatchToolbar = 5686,		//(55,25) Label: 'Show &Watch Window' NOTE: icon Tools.../Auditing/Debugging.../Show Cell Watch Toolbar button/menuitem
	msotcidFormulaEvaluator = 5687,		//(55,26) Label: 'Evaluate &Formula' NOTE: icon Tools.../Auditing/Debugging.../Formula Evaluator button/menuitem
	msotcidAddCellWatch = 5688,		//(55,27) Label: 'Add Watch...' NOTE: icon  button on Cell Watch Toolbar
	msotcidDeleteCellWatch = 5689,		//(55,28) Label: 'Delete Watch' NOTE: icon button on Cell Watch Toolbar
	msotcidOOCLightAuto = 5690,		//(55,29) Label: '&Light-weight auto 0' NOTE: Icon - contact GlennF - Placeholder for usability testing
	msotcidOOCLightAuto1 = 5691,		//(0,25) Label: '&Light-weight auto1' NOTE: Icon
	msotcidOOCLightAuto2 = 5692,		//(0,25) Label: '&Light-weight auto 2' NOTE: Icon
	msotcidOOCLightAuto3 = 5693,		//(0,25) Label: '&Light-weight auto 3' NOTE: Icon
	msotcidOOCLightAuto4 = 5694,		//(0,25) Label: '&Light-weight auto 4' NOTE: Icon
	msotcidOOCLightAuto5 = 5695,		//(0,25) Label: '&Light-weight auto 5' NOTE: Icon
	msotcidOOCLightAuto6 = 5696,		//(0,25) Label: '&Light-weight auto 6' NOTE: Icon
	msotcidOOCLightAuto7 = 5697,		//(0,25) Label: '&Light-weight auto 7' NOTE: Icon
	msotcidOOCLightAuto8 = 5698,		//(0,25) Label: '&Light-weight auto 8' NOTE: Icon
	msotcidOOCLightAuto9 = 5699,		//(0,25) Label: '&Light-weight auto 9' NOTE: Icon
	msotcidOOCHeavyAuto = 5700,		//(65,6) Label: '&Heavy-weight auto 0' NOTE: Icon - contact GlennF - Placeholder for usability testing
	msotcidOOCHeavyAuto1 = 5701,		//(0,25) Label: '&Heavy-weight auto 1' NOTE: Icon
	msotcidOOCHeavyAuto2 = 5702,		//(0,25) Label: '&Heavy-weight auto 2' NOTE: Icon
	msotcidOOCHeavyAuto3 = 5703,		//(0,25) Label: '&Heavy-weight auto 3' NOTE: Icon
	msotcidOOCHeavyAuto4 = 5704,		//(0,25) Label: '&Heavy-weight auto 4' NOTE: Icon
	msotcidOOCHeavyAuto5 = 5705,		//(0,25) Label: '&Heavy-weight auto 5' NOTE: Icon
	msotcidOOCHeavyAuto6 = 5706,		//(0,25) Label: '&Heavy-weight auto 6' NOTE: Icon
	msotcidOOCHeavyAuto7 = 5707,		//(0,25) Label: '&Heavy-weight auto 7' NOTE: Icon
	msotcidOOCHeavyAuto8 = 5708,		//(0,25) Label: '&Heavy-weight auto 8' NOTE: Icon
	msotcidOOCHeavyAuto9 = 5709,		//(0,25) Label: '&Heavy-weight auto 9' NOTE: Icon
	msotcidOOCLightPaste = 5710,		//(56,19) Label: '&Light-weight Paste 0' NOTE: Icon - contact GlennF - Placeholder for usability testing
	msotcidOOCLightPaste1 = 5711,		//(0,25) Label: '&Light-weight Paste 1' NOTE: Icon
	msotcidOOCLightPaste2 = 5712,		//(0,25) Label: '&Light-weight Paste 2' NOTE: Icon
	msotcidOOCLightPaste3 = 5713,		//(0,25) Label: '&Light-weight Paste 3' NOTE: Icon
	msotcidOOCLightPaste4 = 5714,		//(0,25) Label: '&Light-weight Paste 4' NOTE: Icon
	msotcidOOCLightPaste5 = 5715,		//(0,25) Label: '&Light-weight Paste 5' NOTE: Icon
	msotcidOOCLightPaste6 = 5716,		//(0,25) Label: '&Light-weight Paste 6' NOTE: Icon
	msotcidOOCLightPaste7 = 5717,		//(0,25) Label: '&Light-weight Paste 7' NOTE: Icon
	msotcidOOCLightPaste8 = 5718,		//(0,25) Label: '&Light-weight Paste 8' NOTE: Icon
	msotcidOOCLightPaste9 = 5719,		//(0,25) Label: '&Light-weight Paste 9' NOTE: Icon
	msotcidOOCHeavyPaste = 5720,		//(56,29) Label: '&Heavy-weight Paste 0' NOTE: Icon - contact GlennF - Placeholder for usability testing
	msotcidOOCHeavyPaste1 = 5721,		//(0,25) Label: '&Heavy-weight Paste 1' NOTE: Icon
	msotcidOOCHeavyPaste2 = 5722,		//(0,25) Label: '&Heavy-weight Paste 2' NOTE: Icon
	msotcidOOCHeavyPaste3 = 5723,		//(0,25) Label: '&Heavy-weight Paste 3' NOTE: Icon
	msotcidOOCHeavyPaste4 = 5724,		//(0,25) Label: '&Heavy-weight Paste 4' NOTE: Icon
	msotcidOOCHeavyPaste5 = 5725,		//(0,25) Label: '&Heavy-weight Paste 5' NOTE: Icon
	msotcidOOCHeavyPaste6 = 5726,		//(0,25) Label: '&Heavy-weight Paste 6' NOTE: Icon
	msotcidOOCHeavyPaste7 = 5727,		//(0,25) Label: '&Heavy-weight Paste 7' NOTE: Icon
	msotcidOOCHeavyPaste8 = 5728,		//(0,25) Label: '&Heavy-weight Paste 8' NOTE: Icon
	msotcidOOCHeavyPaste9 = 5729,		//(0,25) Label: '&Heavy-weight Paste 9' NOTE: Icon
	msotcidTogglePageBoundaries = 5730,		//(0,25) Label: 'White Space &Between Pages' NOTE: noicon
	msotcidFormatField = 5731,		//(0,25) Label: '&Edit Field...' NOTE: Word: change field props
	msotcidReplaceEMailSignature = 5732,		//(0,25) Label: '&Replace E-mail Signature' NOTE: noicon
	msotcidDMBackMenuItems = 5733,		//(0,25) Label: '&Go Back' NOTE: noicon
	msotcidLineSpacing = 5734,		//(6,10) Label: '&Line spacing' NOTE: noicon
	msotcidFixHHCChange = 5735,		//(0,25) Label: '&Hangul/Hanja Conversion' NOTE: noicon
	msotcidSaveAsPicture = 5736,		//(0,25) Label: '&Save as Picture...' NOTE: noicon -  for drawn object pop menu in PPT
	msotcidTransitionDropdown = 5737,		//(0,25) Label: '&Slide Transition Effects' NOTE: noicon -  for transition effect dropdown on slide sorter tb in PPT
	msotcidBuildDropdown = 5738,		//(0,25) Label: '&Preset Animation' NOTE: noicon -  for animation effect dropdown on slide sorter tb in PPT
	msotcidWordCountRecount = 5739,		//(0,25) Label: 'Re&count' NOTE: Word noicon: recount words in the document
	msotcidWordCountList = 5740,		//(60,18) Label: '&Word Count Statistics' NOTE: Word noicon: list control reflecting number of words in document
	msotcidModifyStyle = 5741,		//(0,25) Label: '&Modify Style' NOTE: Word: change style props
	msotcidStyleByExample = 5742,		//(0,25) Label: '&Style by Example' NOTE: Word: Style by example
	msotcidCssLinks = 5743,		//(0,25) Label: 'Edit &CSS Links' NOTE: noicon
	msotcidExportToHTML = 5744,		//(0,25) Label: 'Export To &HTML...' NOTE: TBD -- ask MarcinS
	msotcidAccRunMacro = 5745,		//(67,26) Label: 'Run &Macro...' NOTE: same as msotcidRunMacro but different accelerator #4594
	msotcidWorkPane = 5746,		//(0,25) Label: 'Tas&k Pane' NOTE: noicon
	msotcidTabColor = 5747,		//(0,25) Label: '&Tab Color...' NOTE: Excel Tab Color
	msotcidServerProperties = 5748,		//(57,9) Label: 'S&erver Properties' NOTE: icon -  under View menu tcid for dlg displaying backend server props
	msotcidFieldListPane = 5749,		//(0,25) Label: '&Field List Pane' NOTE: pane control to hold Field Well
	msotcidInsertPictureFromFile2 = 5750,		//(0,25) Label: '&Insert Picture' NOTE: Insert-Picture dialog from Format-Bullets/Numbering no icon needed
	msotcidToolsOfflineProperties = 5751,		//(0,25) Label: '&Offline Configure...' NOTE: Configuration dialog for access offline properties
	msotcidToolsMakeOffline = 5752,		//(0,25) Label: '&Make Available Offline' NOTE: Make access data project available for offline
	msotcidToolsSynchronize = 5753,		//(0,25) Label: '&Synchronize...' NOTE: Synchronize publication/subscription
	msotcidFileWorkOffline = 5754,		//(0,25) Label: '&Work Offline' NOTE: Toggles online/offline working mode
	msotcidWebPaneControl = 5755,		//(0,25) Label: '&Web Pane Control' NOTE: A control hosting a web browser no icon needed
	msotcidSignature = 5756,		//(38,24) Label: 'S&ignature' NOTE: icon -digital signatrue button on reviewing
	msotcidStylePane = 5757,		//(2,27) Label: '&Styles and Formatting...' NOTE: Word: Style Work Pane
	msotcidStyleDelete = 5758,		//(0,25) Label: '&Delete Style' NOTE: Word: Delete style
	msotcidStyleRename = 5759,		//(0,25) Label: '&Rename Style' NOTE: Word: Rename existing style
	msotcidMailAsPlainText = 5760,		//(0,25) Label: '&Mail As Plain Text' NOTE: noicon
	msotcidMailAsRTF = 5761,		//(0,25) Label: '&Mail As RTF' NOTE: noicon
	msotcidMailAsHTML = 5762,		//(0,25) Label: '&Mail As HTML' NOTE: noicon
	msotcidModifyTextStyle = 5763,		//(0,25) Label: '&Modify Plain Text Style' NOTE: noicon
	msotcidSpeech = 5764,		//(0,25) Label: 'Speec&h' NOTE: Tools:Speech control for all apps supporting Speech
	msotcidSpeechMic = 5765,		//(58,19) Label: '&Microphone On' NOTE: icon, Speech Toolbar microphone button
	msotcidSpeechDictation = 5766,		//(58,20) Label: '&Dictation' NOTE: icon, Speech Toolbar Dictation button
	msotcidSpeechCandC = 5767,		//(58,21) Label: '&Command and Control' NOTE: icon, Speech Toolbar Command and Control button
	msotcidSpeechCorrection = 5768,		//(58,22) Label: '&Correction' NOTE: icon, Speech Toolbar Bring up Correction UI
	msotcidNewDocumentLibrary = 5769,		//(58,24) Label: 'Document &Library' NOTE: icon -  Creates a new Document Library
	msotcidSpeechOptions = 5770,		//(0,25) Label: '&Options' NOTE: Speech Menu bring up Speech Options Dialog
	msotcidSpeechTraining = 5771,		//(0,25) Label: '&Training' NOTE: Speech Menu bring up Traning Dialog
	msotcidSpeechUser = 5772,		//(0,25) Label: '&Change User' NOTE: Speech Menu bring up Speech User Dialog
	msotcidSpeechWhatSay = 5773,		//(0,25) Label: '&What Can I Say?' NOTE: Speech Menu bring up What can I say dialog
	msotcidSpeechTipLabel = 5774,		//(0,25) Label: '&Speech Tip' NOTE: Speech Toolbar SpeechTip label
	msotcidOOCUndo = 5775,		//(1,10) Label: '&Undo <S>' NOTE: noicon -  used in the On Object Control
	msotcidOOCRedo = 5776,		//(1,11) Label: '&Redo <S>' NOTE: noicon -  used in the On Object Control
	msotcidOOCAutoFirstCap = 5777,		//(0,25) Label: 'S&top Auto-capitalizing After \"<S>\"' NOTE: noicon -  used in the On Object Control
	msotcidOOCAutoFirstCapTables = 5778,		//(0,25) Label: '&Stop Auto-capitalizing First Letter of Table Cells' NOTE: noicon -  used in the On Object Control
	msotcidOOCAutoFirstCapBegin = 5779,		//(0,25) Label: '&Stop Auto-capitalizing First Letter of Sentences' NOTE: noicon -  used in the On Object Control
	msotcidOOCAutoTwoCap = 5780,		//(0,25) Label: 'Stop &Automatically Correcting \"<Z>\"' NOTE: noicon -  used in the On Object Control
	msotcidOOCAutoCorrect = 5781,		//(0,25) Label: 'Stop &Automatically Correcting \"<Z>\"' NOTE: noicon -  used in the On Object Control
	msotcidOOCAutoIac = 5782,		//(0,25) Label: 'Stop &Automatically Correcting \"<Z>\"' NOTE: noicon -  used in the On Object Control
	msotcidOOCAutoOrdinal = 5783,		//(0,25) Label: '&Stop Automatically Superscripting Ordinals' NOTE: noicon -  used in the On Object Control
	msotcidOOCAutoFraction = 5784,		//(0,25) Label: '&Stop Automatically Creating Fractions' NOTE: noicon -  used in the On Object Control
	msotcidOOCAutoHyphens = 5785,		//(0,25) Label: '&Stop Automatically Creating Dashes' NOTE: noicon -  used in the On Object Control
	msotcidOOCAutoFormatting = 5786,		//(0,25) Label: '&Never Automatically Bold and Italicize' NOTE: Not used
	msotcidOOCAutoCapDays = 5787,		//(0,25) Label: '&Stop Auto-capitalizing Names of Days' NOTE: noicon -  used in the On Object Control
	msotcidOOCAutoLine = 5788,		//(0,25) Label: '&Stop Automatically Creating Border Lines' NOTE: noicon -  used in the On Object Control
	msotcidOOCAutoBulletList = 5789,		//(0,25) Label: '&Stop Automatically Creating Bulleted Lists' NOTE: noicon -  used in the On Object Control
	msotcidOOCAutoNumList = 5790,		//(0,25) Label: '&Stop Automatically Creating Numbered Lists' NOTE: noicon -  used in the On Object Control
	msotcidOOCAutoSmartQuote = 5791,		//(0,25) Label: '&Never Automatically Replace Straight Quotes' NOTE: Not used
	msotcidOOCAutoHyperlink = 5792,		//(0,25) Label: '&Stop Automatically Creating Hyperlinks' NOTE: noicon -  used in the On Object Control
	msotcidOOCAutoCorrectString = 5793,		//(0,25) Label: 'AutoCorrect' NOTE: noicon -  used in the On Object Control
	msotcidOOCAutoFormatString = 5794,		//(0,25) Label: 'AutoFormat' NOTE: noicon -  used in the On Object Control
	msotcidOOCAutoCorrectOptions = 5795,		//(65,6) Label: '&Control AutoCorrect Options...' NOTE:  Alias -  used in the On Object Control
	msotcidOOCAutoFormatOptions = 5796,		//(65,6) Label: '&Control AutoCorrect Options...' NOTE:  Alias -  used in the On Object Control
	msotcidToolbarSize = 5797,		//(0,25) Label: '&Size' NOTE: no icon -  toolbar options menu item
	msotcidToolbarMove = 5798,		//(0,25) Label: '&Move' NOTE: no icon -  toolbar options menu item
	msotcidNewDocumentLibrary2 = 5799,		//(58,24) Label: '&Document Library...' NOTE: icon -  Creates a new Document Library
	msotcidOpenSubform = 5800,		//(0,25) Label: 'Subform in New &Window' NOTE: noicon -  on Access form design context menu on Access View menu
	msotcidOpenSubreport = 5801,		//(0,25) Label: 'Subreport in New &Window' NOTE: noicon -  same as OpenSubform but for reports
	msotcidPrtPageSetup = 5802,		//(0,25) Label: '&Setup' NOTE: noicon -  same as msotcidPageSetup but different caption
	msotcidAutoAverage = 5803,		//(0,25) Label: '&Average' NOTE: noicon for XL AutoSum dropdrop menu
	msotcidAutoCount = 5804,		//(0,25) Label: '&Count' NOTE: noicon for XL AutoSum dropdrop menu
	msotcidAutoCountA = 5805,		//(0,25) Label: 'C&ountA' NOTE: noicon for XL AutoSum dropdrop menu
	msotcidAutoMax = 5806,		//(0,25) Label: '&Max' NOTE: noicon for XL AutoSum dropdrop menu
	msotcidAutoMin = 5807,		//(0,25) Label: 'M&in' NOTE: noicon for XL AutoSum dropdrop menu
	msotcidAutoSumMoreFunctions = 5808,		//(0,25) Label: 'More &Functions...' NOTE: noicon for XL AutoSum dropdrop menu
	msotcidSelectNumber = 5809,		//(0,25) Label: '&Select Number' NOTE: noicon
	msotcidRestartNumbering = 5810,		//(0,25) Label: '&Restart Numbering' NOTE: noicon
	msotcidDrawingCanvas = 5811,		//(10,14) Label: '&New Drawing' NOTE: noicon same as bringing up the Drawing Toolbar please Insert->Picture->New Drawing creates drawing canvas
	msotcidChangeToOrgChart = 5812,		//(47,17) Label: '&Change To OrgChart' NOTE: icon -  Change Diagram to OrgChart
	msotcidMSWordToolsOptionsAcetate = 5813,		//(0,25) Label: '&Markup balloon settings...' NOTE: noicon -  Acetate options
	msotcidPivotTableView = 5814,		//(50,12) Label: 'Piv&otTable View' NOTE: noicon same as msotcidInsertPivotList - switch Access object to Pivot Table view
	msotcidPivotChartView = 5815,		//(1,23) Label: 'Pi&votChart View' NOTE: noicon same as msotcidInsertWebChart - switch Access object to Pivot Chart view
	msotcidFixUIMChange = 5816,		//(0,25) Label: '&(no suggestions)' NOTE: noicon -  UIM's correction altanatives
	msotcidUIMCorrectionUI = 5817,		//(56,6) Label: 'M&ore...' NOTE: noicon
	msotcidUIMDelete = 5818,		//(0,25) Label: 'D&elete' NOTE: noicon -  UIM's correction altanatives
	msotcidSlideFormat = 5819,		//(2,3) Label: 'Slide &Design...' NOTE: noicon - Format|Slides... in PPT
	msotcidSlideFormatPaneDlg = 5820,		//(0,25) Label: '&Format Slides' NOTE: noicon -  for PPT slide formatting work pane dialog
	msotcidSlideFormatPaneSchemeEdit = 5821,		//(0,25) Label: '&Edit Color Scheme...' NOTE: noicon -  for PPT scheme gallery menu in slide formatting work pane
	msotcidSlideFormatPaneSchemeApplyAll = 5822,		//(0,25) Label: '&Apply to All Slides' NOTE: noicon -  for PPT scheme gallery menu in slide formatting work pane
	msotcidSlideFormatPaneSchemeDelete = 5823,		//(0,25) Label: '&Delete Color Scheme' NOTE: noicon -  for PPT scheme gallery menu in slide formatting work pane
	msotcidRadialChart = 5824,		//(58,25) Label: '&Radial Diagram' NOTE: icon -  Insert Radial Chart
	msotcidCycleChart = 5825,		//(58,26) Label: '&Cycle Diagram' NOTE: icon -  Insert Cycle Chart
	msotcidStackedChart = 5826,		//(58,27) Label: '&Pyramid Diagram' NOTE: icon -  Insert Stacked Chart
	msotcidBullsEyeChart = 5827,		//(58,28) Label: '&Target Diagram' NOTE: icon -  Insert BullEye Chart
	msotcidVennDiagram = 5828,		//(58,29) Label: '&Venn Diagram' NOTE: icon -  Insert Venn Diagram
	msotcidChangeToRadialChart = 5829,		//(63,4) Label: '&Radial' NOTE: icon -  Change Diagram to RadialChart
	msotcidChangeToCycleChart = 5830,		//(63,5) Label: '&Cycle' NOTE: icon -  Change Diagram to CycleChart
	msotcidDummy5831 = 5831,		//(0,25) Label: '&Dummy5831' NOTE: Formerly ChangeToStackedChart, cut by ShawnV
	msotcidChangeToBullsEyeChart = 5832,		//(58,28) Label: '&Target' NOTE: icon -  Change Diagram to BullEyeChart
	msotcidChangeToVennDiagram = 5833,		//(63,6) Label: '&Venn' NOTE: icon -  Change Diagram to VennDiagram
	msotcidRecUI = 5834,		//(0,25) Label: '&Reconciliation UI' NOTE: noicon -  CDL dialog in CommandBar
	msotcidSaveBackground = 5835,		//(0,25) Label: '&Save Background...' NOTE: noicon -  for drawn object pop menu in PPT
	msotcidPasteFormulas = 5836,		//(0,25) Label: '&Formulas' NOTE: noicon -  Paste special dropdown in Xl's standard toolbar - paste formulas
	msotcidPasteNoBorders = 5837,		//(0,25) Label: 'No &Borders' NOTE: noicon -  Paste special dropdown in Xl's standard toolbar - paste no borders
	msotcidPasteTranspose = 5838,		//(0,25) Label: '&Transpose' NOTE: noicon -  Paste special dropdown in Xl's standard toolbar - paste transpose
	msotcidSpeechAddDelWords = 5839,		//(0,25) Label: '&Add/Delete Words...' NOTE: noicon Speech Menu bring up Add Delete Words dialog
	msotcidMSWordToolsOptionsEditCopyPaste = 5840,		//(0,25) Label: 'Copy & paste settings...' NOTE: no icon -  accessed from ToolsOptionsEdit as a new submenu.
	msotcidEditPasteAsNewList = 5841,		//(1,8) Label: 'Paste as &New List' NOTE: noicon  clipbord paste -  restarts numbered list on paste
	msotcidEditPasteAppendTable = 5842,		//(1,8) Label: 'Paste b&y Appending Table' NOTE: noicon
	msotcidEditPasteAndMergeStyles = 5843,		//(1,8) Label: 'Paste and Merge &Styles' NOTE: noicon  clipbord paste -  merges styles on paste
	msotcidEditPasteAndMergeText = 5844,		//(1,8) Label: 'Paste and Merge &Text' NOTE: noicon clipbord paste -  merges text on paste
	msotcidEditPasteAndPreserveAllFormatting = 5845,		//(1,8) Label: 'Paste and Preserve all &Formatting' NOTE: noicon  clipbord paste-  preserves all formatting on paste
	msotcidChangeMailFormat = 5846,		//(0,25) Label: '&Change Mail Format' NOTE: noicon - Called through IOleCommandTarget
	msotcidSlideFormatPaneSchemeApplyMatching = 5847,		//(0,25) Label: 'Apply to &Master' NOTE: noicon -  for PPT scheme gallery menu in slide formatting work pane
	msotcidSlideFormatPaneSchemeApplySelected = 5848,		//(0,25) Label: '&Apply to Selected Slides' NOTE: noicon -  for PPT scheme gallery menu in slide formatting work pane
	msotcidOrgChartInsertAssistant = 5849,		//(59,0) Label: '&Assistant' NOTE: icon -  Insert an assistant in orgchart
	msotcidOrgChartLayoutHorizontal1 = 5850,		//(59,1) Label: '&Horizontal Style 1' NOTE: icon -  OrgChart: Layout horizontal
	msotcidOrgChartLayoutHorizontal2 = 5851,		//(59,2) Label: '&Horizontal Style 2' NOTE: icon -  OrgChart: Layout horizontal 2
	msotcidOrgChartLayoutVertical1 = 5852,		//(59,3) Label: '&Vertical Style 1' NOTE: icon -  OrgChart: Layout vertical 1
	msotcidOrgChartLayoutVertical2 = 5853,		//(59,4) Label: '&Vertical Style 2' NOTE: icon -  OrgChart: Layout vertical 2
	msotcidDummy5854 = 5854,		//(0,25) Label: '&[removed by aaronwe]' NOTE: formerly OrgChartStyle
	msotcidOrgChartInsertCoworker = 5855,		//(62,24) Label: '&Coworker' NOTE: noicon For prototyping OrgChart in PPT
	msotcidOrgChartInsertSubordinate = 5856,		//(62,25) Label: '&Subordinate' NOTE: noicon orgchart
	msotcidDummyRolandrOrgChartPopup = 5857,		//(0,25) Label: '&Organization Chart Popup' NOTE: noicon orgchart pop up menu
	msotcidOrgChartDeleteNode = 5858,		//(0,25) Label: '&Delete' NOTE: noicon -  OrgChart: Delete a node
	msotcidInsertOrgChart = 5859,		//(47,17) Label: '&Insert Organization Chart' NOTE: noicon -  Insert Organization Chart
	msotcidAnswerWizardMenuBarDropDown = 5860,		//(0,25) Label: 'Ask a &Question' NOTE: noicon -  for the answer wizard entry window on the menu-bar
	msotcidSlideFormatPaneTemplateApplyAll = 5861,		//(0,25) Label: 'Apply to &All Slides' NOTE: noicon -  for PPT templates gallery menu in slide formatting work pane
	msotcidSlideFormatPaneTemplateApplyLike = 5862,		//(0,25) Label: 'Apply to &Master' NOTE: noicon -  for PPT templates gallery menu in slide formatting work pane
	msotcidSlideFormatPaneTemplateApplySel = 5863,		//(0,25) Label: 'Apply to &Selected Slides' NOTE: noicon -  for PPT templates gallery menu in slide formatting work pane
	msotcidSlideFormatPaneTemplateApply = 5864,		//(0,25) Label: '&Apply Design Template' NOTE: noicon -  Undo string for PPT templates gallery menu in slide formatting work pane
	msotcidDavSPEditSql = 5865,		//(59,5) Label: 'Edit S&QL' NOTE: icon -  on Access C/S Stored Proc editor brings up the davinci visual editor
	msotcidCanvasFit = 5866,		//(59,6) Label: 'Fit' NOTE: icon
	msotcidCanvasResize = 5867,		//(24,21) Label: 'Re&size' NOTE: noicon
	msotcidShowCanvasBar = 5868,		//(0,25) Label: 'Show Drawing Canvas Tool&bar' NOTE: noicon -  control on Canvas popup
	msotcidHideCanvasBar = 5869,		//(0,25) Label: 'Hide Drawing Canvas Tool&bar' NOTE: noicon -  control on Canvas popup
	msotcidFormatCanvas = 5870,		//(68,21) Label: '&Drawing Canvas...' NOTE: noicon -  same icon as FormatDrawingObject for Canvas popup
	msotcidFormatCanvas2 = 5871,		//(68,21) Label: '&Format Drawing Canvas...' NOTE: noicon -  same icon as FormatDrawingObject for Canvas popup
	msotcidColorModeMenu = 5872,		//(7,11) Label: '&Color/Grayscale' NOTE: icon -  PPT Standard View Print Preview toolbars.
	msotcidDisplayInColor = 5873,		//(7,11) Label: '&Color' NOTE: icon -  PPT Print Preview & Standard toolbar - PPT display in color
	msotcidDisplayInGrayscale = 5874,		//(59,10) Label: '&Grayscale' NOTE: icon -  PPT Print Preview & Standard toolbar - PPT display in 'smart' grayscale
	msotcidDisplayInHighContrast = 5875,		//(59,11) Label: '&High Contrast' NOTE: icon -  PPT Standard toolbar - PPT display in High Contrast mode
	msotcidDisplayInPureBlackAndWhite = 5876,		//(59,12) Label: 'P&ure Black and White' NOTE: icon -  PPT Print Preview & Standard toolbar - PPT display in pure black and white
	msotcidPrintWhatDropdown = 5877,		//(0,25) Label: '&Print What' NOTE: noicon -  nolabel PPT Print Preview
	msotcidPrintScaleToFit = 5878,		//(0,25) Label: '&Scale to Fit Paper' NOTE: icon
	msotcidPrintFrameSlides = 5879,		//(0,25) Label: '&Frame Slides' NOTE: icon
	msotcidPrintHiddenSlides = 5880,		//(0,25) Label: '&Print Hidden Slides' NOTE: icon
	msotcidPrintIncludeAnimations = 5881,		//(0,25) Label: '&Include Animations' NOTE: icon
	msotcidPrintHandoutsHorizontal = 5882,		//(59,17) Label: '&Horizontal' NOTE: icon -  PPT Print Preview - draw handout slides by rows
	msotcidPrintHandoutsVertical = 5883,		//(59,18) Label: '&Vertical' NOTE: icon -  PPT Print Preview - draw handout slides by columns
	msotcidPivotAutoFilter = 5884,		//(59,19) Label: 'Auto&Filter' NOTE: icon -  Access pivot menu
	msotcidDummy5885 = 5885,		//(0,25) Label: '&[removed by aaronwe]' NOTE: Formerly PivotAutoCalcPopup
	msotcidPivotAutoCalcSum = 5886,		//(0,25) Label: '&Sum' NOTE: noicon -  on PivotAutoCalc submenu
	msotcidPivotAutoCalcCount = 5887,		//(0,25) Label: '&Count' NOTE: noicon -  on PivotAutoCalc submenu
	msotcidPivotAutoCalcMin = 5888,		//(0,25) Label: '&Min' NOTE: noicon -  on PivotAutoCalc submenu
	msotcidPivotAutoCalcMax = 5889,		//(0,25) Label: 'Ma&x' NOTE: noicon -  on PivotAutoCalc submenu
	msotcidPivotSubtotal = 5890,		//(59,20) Label: 'Su&btotal' NOTE: icon -  Access pivot menu
	msotcidPivotRefresh = 5891,		//(59,21) Label: 'Refres&h' NOTE: icon -  Access pivot menu
	msotcidPivotMoveToRowArea = 5892,		//(59,22) Label: 'Move to Ro&w Area' NOTE: icon -  Access Pivot menu
	msotcidPivotMoveToColumnArea = 5893,		//(59,23) Label: 'Move to Colum&n Area' NOTE: icon -  Access Pivot menu
	msotcidPivotMoveToFilterArea = 5894,		//(59,24) Label: 'Move to Fi&lter Area' NOTE: icon -  Access Pivot menu
	msotcidPivotMoveToDetailArea = 5895,		//(59,25) Label: 'Move to De&tail Area' NOTE: icon -  Access Pivot menu
	msotcidPivotExpand = 5896,		//(59,26) Label: '&Expand' NOTE: icon -  Access Pivot menu
	msotcidPivotExportToExcel = 5897,		//(59,27) Label: 'E&xport to Microsoft Excel' NOTE: icon
	msotcidPivotExpandIndicators = 5898,		//(59,28) Label: '&Expand Indicators' NOTE: icon -  Access View menu
	msotcidPivotDropAreas = 5899,		//(59,29) Label: 'D&rop Areas' NOTE: icon -  Access View menu
	msotcidEditComment = 5900,		//(0,25) Label: '&Edit Comment' NOTE: icon
	msotcidSlideFormatPaneBackgroundApplyAll = 5901,		//(0,25) Label: '&Apply to All Slides' NOTE: noicon -  for PPT backgrounds gallery menu in slide formatting work pane
	msotcidSlideFormatPaneBackgroundApplyMatching = 5902,		//(0,25) Label: '&Apply to Matching Slides' NOTE: noicon -  for PPT backgrounds gallery menu in slide formatting work pane
	msotcidSlideFormatPaneBackgroundApplySelected = 5903,		//(0,25) Label: '&Apply to Selected Slides' NOTE: noicon -  for PPT backgrounds gallery menu in slide formatting work pane
	msotcidSlideFormatPaneBackgroundApply = 5904,		//(0,25) Label: '&Apply Background' NOTE: noicon -  Undo string for PPT backgrounds gallery menu in slide formatting work pane
	msotcidSearchUI = 5905,		//(1,2) Label: 'Searc&h...' NOTE: icon Tools/Search for all apps
	msotcidToolsLabelOptions = 5906,		//(0,25) Label: '&Label Options...' NOTE: noicon
	msotcidToolsEnvelopeSetup = 5907,		//(0,25) Label: '&Envelope Setup...' NOTE: noicon
	msotcidMergeToEMail = 5908,		//(64,25) Label: '&Merge to E-mail' NOTE: noicon
	msotcidMergeToFax = 5909,		//(64,26) Label: '&Merge to Fax' NOTE: noicon
	msotcidDummy5910 = 5910,		//(0,25) Label: '&Removed by AaronWe' NOTE: Formerly MailMergeMenu2
	msotcidMailMergeToolbar = 5911,		//(0,25) Label: 'Show Mail Merge &Toolbar' NOTE: noicon
	msotcidMailMergeCreateList = 5912,		//(0,25) Label: '&Create Mail Merge List' NOTE: noicon
	msotcidMailMergeEditList = 5913,		//(0,25) Label: '&Edit Mail Merge List' NOTE: noicon
	msotcidDMViewThumbnails = 5914,		//(60,2) Label: '&Thumbnails' NOTE: icon -  FileOpen|Save: View menu
	msotcidSlideFormatPaneSchemeApply = 5915,		//(0,25) Label: '&Apply Color Scheme' NOTE: noicon -  Undo string for PPT color schemes gallery menu in slide formatting work pane
	msotcidCanvasExpand = 5916,		//(59,7) Label: 'Ex&pand' NOTE: icon
	msotcidDMClearHistory = 5917,		//(0,25) Label: '&Clear History' NOTE: noicon -  for File Open Dialog under Tools menu
	msotcidManageWebDrive = 5918,		//(0,25) Label: 'Mana&ge' NOTE: noicon -  File/Open/Tools/Manage: allows users to manage their WebDrive
	msotcidSxVisTotals = 5919,		//(7,2) Label: 'Hidden Items in Tota&ls' NOTE: icon on a toolbar to toggle PivotTable visible totals
	msotcidSxImmItems = 5920,		//(7,3) Label: '&Always Display Items' NOTE: icon on a toolbar to toggle PivotTable Immediate Items on Drop
	msotcidOrgChartStyle1 = 5921,		//(0,25) Label: '&Style 1' NOTE: noicon -  OrgChart style
	msotcidOrgChartStyle2 = 5922,		//(0,25) Label: '&Style 2' NOTE: noicon -  OrgChart style
	msotcidOrgChartStyle3 = 5923,		//(0,25) Label: '&Style 3' NOTE: noicon -  OrgChart style
	msotcidOrgChartStyle4 = 5924,		//(0,25) Label: '&Style 4' NOTE: noicon -  OrgChart style
	msotcidOrgChartStyle5 = 5925,		//(0,25) Label: '&Style 5' NOTE: noicon -  OrgChart style
	msotcidOrgChartStyle6 = 5926,		//(0,25) Label: '&Style 6' NOTE: noicon -  OrgChart style
	msotcidOrgChartStyle7 = 5927,		//(0,25) Label: '&Style 7' NOTE: noicon -  OrgChart style
	msotcidOrgChartStyle8 = 5928,		//(0,25) Label: '&Style 8' NOTE: noicon -  OrgChart style
	msotcidOrgChartStyle9 = 5929,		//(0,25) Label: '&Style 9' NOTE: noicon -  OrgChart style
	msotcidOrgChartStyle10 = 5930,		//(0,25) Label: '&Style 10' NOTE: noicon -  OrgChart style
	msotcidOrgChartStyle11 = 5931,		//(0,25) Label: '&Style 11' NOTE: noicon -  OrgChart style
	msotcidOrgChartStyle12 = 5932,		//(0,25) Label: '&Style 12' NOTE: noicon -  OrgChart style
	msotcidLicenseVerification = 5933,		//(0,25) Label: 'Acti&vate Product...' NOTE: noicon
	msotcidTextWrapInline = 5934,		//(60,6) Label: '&In Line With Text' NOTE: icon -  similar to format autoshape dialog icon
	msotcidFindFormatPicker = 5935,		//(0,25) Label: '&Choose Format From Cell...' NOTE: icon
	msotcidReplFormatPicker = 5936,		//(0,25) Label: '&Choose Format From Cell...' NOTE: icon
	msotcidFindFormatClearAll = 5937,		//(0,25) Label: 'Clea&r Find Format' NOTE: icon
	msotcidReplFormatClearAll = 5938,		//(0,25) Label: 'Clea&r Replace Format' NOTE: icon
	msotcidFindFormatSet = 5939,		//(0,25) Label: '&Format...' NOTE: icon
	msotcidReplFormatSet = 5940,		//(0,25) Label: '&Format...' NOTE: icon
	msotcidDummy5941 = 5941,		//(0,25) Label: '&[removed by aaronwe]' NOTE: Formerly ImportOwsCommentsMenu - aaronwe
	msotcidImportOwsComments = 5942,		//(0,25) Label: '&- blank -' NOTE: noicon -  text replaced menu item of above submenu
	msotcidDummy5943 = 5943,		//(0,25) Label: '&[removed by aaronwe]' NOTE: Formerly FlushOwsCommentsMenu - aaronwe
	msotcidFlushOwsComments = 5944,		//(0,25) Label: '&- blank -' NOTE: noicon -  text replaced menu item of above submenu
	msotcidFormatConsistencyCheck = 5945,		//(0,25) Label: 'C&onsistency Check...' NOTE: noicon consistancy check
	msotcidFccFPaneSelAll = 5946,		//(0,25) Label: '&Select Text with Similar Formatting' NOTE: noicon
	msotcidFccFPaneDefSty = 5947,		//(0,25) Label: '&Named this foarmmting...' NOTE: noicon consistancy check
	msotcidSlideMiniature1PerPage = 5948,		//(60,13) Label: '&Show positioning of 1-per-page handouts' NOTE: icon -  PPT Handout Master
	msotcidViewUrlSource = 5949,		//(0,25) Label: '&Open Original' NOTE: noicon -  tcid for View URL Source item in the Collect & Paste Work Pane's Gallery control
	msotcidSignOutOfPassport = 5950,		//(0,25) Label: 'Sign ou&t' NOTE: noicon
	msotcidFmtInsp = 5951,		//(65,27) Label: '&Format Inspector' NOTE: noicon -  Word->View-> right before Document Map- invokes Format inspector
	msotcidWQSaveQuery = 5952,		//(60,12) Label: '&Save Web Query' NOTE: icon -  XL new web query dialog save query button
	msotcidWQOptions = 5953,		//(0,25) Label: '&Options...' NOTE: noicon XL new web query dialog options button
	msotcidNewFunction = 5954,		//(0,25) Label: 'New &Function' NOTE: icon,
	msotcidSxShowHideLevels = 5955,		//(0,25) Label: '&Show Levels' NOTE: noicon -  PivotTable context menu
	msotcidPublishSelected = 5956,		//(0,25) Label: 'Publi&sh Selected Files...' NOTE: noicon -  on FP folder view context menu - publish selected files
	msotcidBroadcastRecord = 5957,		//(60,9) Label: '&Record and Save a Broadcast...' NOTE: noicon
	msotcidSendForReview = 5958,		//(60,14) Label: 'Send for &Review...' NOTE: icon -  Word/Excel/Powerpoint Tools > Online Collaboration menu
	msotcidWorkgroupAdmin = 5959,		//(60,15) Label: 'Work&group Administrator...' NOTE: icon -  Tools|Security|Workgroup Administrator
	msotcidRecUIGallery = 5960,		//(0,25) Label: '&Revisions Pane' NOTE: noicon - Revisions Pane in PPT
	msotcidInsertInlineFrame = 5961,		//(0,25) Label: 'Inlin&e Frame' NOTE: noicon -  Insert Inline Frame
	msotcidInlineFrameProperties = 5962,		//(0,25) Label: '&Inline Frame Properties...' NOTE: noicon -  Inline Frame Properties
	msotcidDavSDFitAllToWindow = 5963,		//(0,25) Label: 'Size &Diagram to Window' NOTE: icon Fits entire schema display into current window size
	msotcidDavAddTableDlg = 5964,		//(17,29) Label: 'Add Ta&ble...' NOTE: noicon same as msotcidAddTable - Invoke Davinci add table dlg
	msotcidWebPageComponent = 5965,		//(5,6) Label: '&Web Component...' NOTE: icon -  Insert Web Page Component
	msotcidDlgTintBaseColorPickerSwatch = 5966,		//(0,25) Label: '' NOTE: noicon -  Fill Effects dlg Tint tab color dropdown standard color swatch
	msotcidDlgTintBaseColorMRUSwatch = 5967,		//(0,25) Label: '' NOTE: noicon -  Fill Effects dlg Tint tab color dropdown
	msotcidDlgTintBaseColorMoreSwatch = 5968,		//(0,25) Label: '&More Colors...' NOTE: noicon -  Fill Effects dlg Tint tab color dropdown More Colors button
	msotcidDlgTintBaseColorSchemeSwatch = 5969,		//(0,25) Label: '' NOTE: noicon -  Fill Effects dlg Tint tab color dropdown scheme color swatch
	msotcidDlgGradientColor1MoreEffectsSwatch = 5970,		//(0,25) Label: '&Fill Effects...' NOTE: noicon -  Fill Effects dlg Gradient tab color 1 dropdown Fill Effects button
	msotcidDlgGradientColor2MoreEffectsSwatch = 5971,		//(0,25) Label: '&Fill Effects...' NOTE: noicon -  Fill Effects dlg Gradient tab color 2 dropdown Fill Effects button
	msotcidDlgPatternForegroundColorEffectsSwatch = 5972,		//(0,25) Label: '&Fill Effects...' NOTE: noicon -  Fill Effects dlg Pattern tab color 1 dropdown Fill Effects button
	msotcidDlgPatternBackgroundColorEffectsSwatch = 5973,		//(0,25) Label: '&Fill Effects...' NOTE: noicon -  Fill Effects dlg Pattern tab color 2 dropdown Fill Effects button
	msotcidShadowColorTint = 5974,		//(0,25) Label: '&Fill Effects...' NOTE: noicon -  Shadow Color dropdown
	msotcidExtrusionColorTint = 5975,		//(0,25) Label: '&Fill Effects...' NOTE: noicon -  3D Extrusion Color dropdown
	msotcidAlignRelativeToCanvas = 5976,		//(0,25) Label: 'Relative t&o Canvas' NOTE: noicon -  for align/distribute menu
	msotcidFieldSetProperties = 5977,		//(0,25) Label: 'G&roup Box Properties...' NOTE: noicon frontpage groupbox properties menu.
	msotcidFormatDiagram = 5978,		//(68,21) Label: '&Diagram...' NOTE: noicon -  same icon as FormatDrawingObject for Diagram popup
	msotcidFormatDiagram2 = 5979,		//(68,21) Label: '&Format Diagram...' NOTE: noicon -  same icon as FormatDrawingObject for Diagram popup
	msotcidShowOrgChartBar = 5980,		//(0,25) Label: 'Show Organization Chart Tool&bar' NOTE: noicon -  control on Orgchart popup
	msotcidHideOrgChartBar = 5981,		//(0,25) Label: 'Hide Organization Chart Tool&bar' NOTE: noicon -  control on Orgchart popup
	msotcidOrgChartBackgroundPopup = 5982,		//(0,25) Label: '&OrgChart Background PopUp' NOTE: noicon -  context menu for the orgchart bg shape
	msotcidFormatOrgChart = 5983,		//(68,21) Label: '&Organization Chart...' NOTE: noicon -  same icon as FormatDrawingObject for Diagram popup
	msotcidFormatOrgChart2 = 5984,		//(68,21) Label: '&Format Organization Chart...' NOTE: noicon -  same icon as FormatDrawingObject for Diagram popup
	msotcidEditPasteOriginalPowerpointFormat = 5985,		//(1,8) Label: 'Paste using original &Powerpoint format' NOTE: alias paste icon -  used as a Word paste recovery option
	msotcidEditPasteOriginalExcelFormat = 5986,		//(1,8) Label: 'Paste using original &Excel format' NOTE: alias paste icon -  used as a Word paste recovery option
	msotcidEditPastePreserveSingleCellTables = 5987,		//(1,8) Label: 'Paste without converting single-cell &tables to text' NOTE: alias paste icon -  used as a Word paste recovery option
	msotcidEditPasteOriginalTableFormat = 5988,		//(1,8) Label: 'Paste using &original table format' NOTE: alias paste icon -  used as a Word paste recovery option
	msotcidSlideMiniature3PerPageRTL = 5989,		//(50,11) Label: '&Show positioning of 3-per-page handouts' NOTE: icon -  3-per-page Handout Master in RTL view
	msotcidMyDocuments = 5990,		//(58,23) Label: '' NOTE: Inserting Path into Excel custom Header/FooterSubmenu.  Please remove MailMergeMenu2
	msotcidDummy5991 = 5991,		//(0,25) Label: '&[Removed by AaronWe]' NOTE: formerly SourceSafeQuickCheckIn
	msotcidDummy5992 = 5992,		//(0,25) Label: '&[Removed by AaronWe]' NOTE: formerly DavQrySelect
	msotcidDummy5993 = 5993,		//(0,25) Label: '&[Removed by AaronWe]' NOTE: formerly DavQryMakeTable
	msotcidDummy5994 = 5994,		//(0,25) Label: '&[Removed by AaronWe]' NOTE: formerly DavQryUpdate
	msotcidDummy5995 = 5995,		//(0,25) Label: '&[Removed by AaronWe]' NOTE: formerly DavQryAppend
	msotcidDummy5996 = 5996,		//(0,25) Label: '&[Removed by AaronWe]' NOTE: icon, formerly DavQryAppendValues
	msotcidDummy5997 = 5997,		//(0,25) Label: '&[Removed by AaronWe]' NOTE: formerly DavQryDelete
	msotcidDummy5998 = 5998,		//(0,25) Label: '&[Removed by AaronWe]' NOTE: formerly DavQryTypeDropdown
	msotcidDummy5999 = 5999,		//(0,25) Label: '&[Removed by AaronWe]' NOTE: formerly SetMaxRecords
	};

enum
	{
	msotcidVerticalTextDirectionLeftToRight = 6000,		//(60,20) Label: '&VerticalTextDirectionLeftToRight' NOTE: icon; menu for text direction on Formatting toolbar
	msotcidVerticalTextDirectionRightToLeft = 6001,		//(60,19) Label: '&VerticalTextDirectionRightToLeft' NOTE: icon; menu for text direction on Formatting toolbar
	msotcidPasteSpecialDD = 6002,		//(0,25) Label: '&Paste' NOTE: noicon on a toolbar for paste special dropdown
	msotcidInsertFile2 = 6003,		//(7,27) Label: '&File...' NOTE: NOTE: Insert File (different mnemonic from msotcidInsertFile)
	msotcidHTMLDropdown = 6004,		//(38,18) Label: '&Drop-Down Menu' NOTE: NOTE: FrontPage -- HTML Form toolbar
	msotcidInsertTitleMaster = 6005,		//(57,3) Label: 'Ins&ert Title Master' NOTE: icon -  PPT insert menu for multiple master feature
	msotcidPublishSelectedNoDlg = 6006,		//(0,25) Label: 'Publi&sh Selected Files' NOTE: no icon -  FrontPage publish dlg context menu
	msotcidDMViewLargeIcons = 6007,		//(8,27) Label: 'Lar&ge Icons' NOTE: noicon -  FileOpen|Save: View menu
	msotcidDMViewSmallIcons = 6008,		//(8,28) Label: 'S&mall Icons' NOTE: noicon -  FileOpen|Save: View menu
	msotcidChangeToPyramidChart = 6009,		//(60,21) Label: '&Pyramid' NOTE: icon -  for OfficeArt diagramming
	msotcidMoveDiagramShapeUp = 6010,		//(60,22) Label: 'Move Shape &Backward' NOTE: icon -  for OfficeArt diagramming
	msotcidMoveDiagramShapeDown = 6011,		//(60,23) Label: 'Move Shape &Forward' NOTE: icon -  for OfficeArt diagramming
	msotcidInsertDiagramShape = 6012,		//(62,26) Label: 'I&nsert Shape' NOTE: noicon -  for OfficeArt diagramming
	msotcidLockMaster = 6013,		//(65,24) Label: 'Preserve &Master' NOTE: noicon
	msotcidRenameMaster = 6014,		//(64,22) Label: 'Re&name Master' NOTE: noicon -  PPT multipe master feature
	msotcidToggleOutlineThumbnails = 6015,		//(0,25) Label: 'Show Out&line' NOTE: noicon PPT: toggle outline and thumbnail view
	msotcidPrintComments = 6016,		//(0,25) Label: 'Incl&ude Comment Pages' NOTE: noicon -  PPT popup menu item to print comments
	msotcidEditPasteRecovery = 6017,		//(0,25) Label: '&<default paste recovery text>' NOTE: noicon -  this tcid is used by paste recovery in Word.
	msotcidEditPasteAndMergeFormatting = 6018,		//(1,8) Label: 'Paste and Merge &Formatting' NOTE: paste icon -  this tcid is used to merge formatting on paste in Word.
	msotcidEditPasteAsPlainText = 6019,		//(1,8) Label: 'Paste as P&lain Text' NOTE: paste icon -  this tcid is used to paste as plain text in Word.
	msotcidWPForward = 6020,		//(0,7) Label: '&Forward' NOTE: icon -  no caption found on workpane command bar
	msotcidWPBackward = 6021,		//(0,8) Label: '&Back' NOTE: icon -  no caption found on workpane command bar
	msotcidCmdBarClose = 6022,		//(0,9) Label: '&Close' NOTE: icon -  no caption found on workpane command bar
	msotcidOOCLightCellError = 6023,		//(60,27) Label: '&Light-weight Cell Error' NOTE: icon -  Excel's light-weight OOC icon for Error Checking
	msotcidOOCHeavyCellError = 6024,		//(60,28) Label: '&Heavy-weight Cell Error' NOTE: icon -  Excel's heavy-weight OOC icon for Error Checking
	msotcidEditPasteAsWordTable = 6025,		//(1,8) Label: 'Paste as &Word formatted table' NOTE: paste icon -  this tcid is used to paste as a Word table.
	msotcidEditPasteAsLinkedExcelTable = 6026,		//(1,8) Label: 'Paste as linked &Excel table and preserve Excel formatting' NOTE: paste icon -  this tcid is used to paste in Word.
	msotcidEditPasteAsLinkedWordTable = 6027,		//(1,8) Label: 'Paste as &linked Excel table with Word formatting' NOTE: paste icon -  used in Words
	msotcidEditPasteAlternativeOriginal = 6028,		//(1,8) Label: 'Paste using &original table formatting' NOTE: paste icon -  used in Words
	msotcidEditPasteAsEmbedded = 6029,		//(1,8) Label: 'Paste as &embedded object' NOTE: paste icon -  used in Words
	msotcidEditPasteAsLinkedEmbedded = 6030,		//(1,8) Label: 'Paste as &linked embedded object' NOTE: paste icon -  used in Words
	msotcidOOCAutoListCreateBul = 6031,		//(0,25) Label: '&Stop Automatically Creating Bulleted Lists' NOTE: noicon: OOUI for auto lists menu item
	msotcidToggleCharacterCode = 6032,		//(60,29) Label: '&Toggle Character Code' NOTE: icon  - Word
	msotcidLineColorLabelStandard = 6033,		//(0,25) Label: '&Standard Colors' NOTE: noicon -  FP: Standard line colors
	msotcidLineColorLabelCustom = 6034,		//(0,25) Label: '&Custom Colors' NOTE: noicon -  FP: custom line colors
	msotcidLineColorCustomSwatch = 6035,		//(0,25) Label: '&Custom Line Colors' NOTE: noicon -  FP: custom line colors
	msotcidLineColorLabelTheme = 6036,		//(0,25) Label: '&Theme's Colors' NOTE: noicon -  FP: Themes line Colors
	msotcidLineColorTheme1Swatch = 6037,		//(0,25) Label: '&Theme 1's Line Colors' NOTE: noicon -  FP: theme 1 line colors
	msotcidLineColorTheme2Swatch = 6038,		//(0,25) Label: '&Theme 2's Line Colors' NOTE: noicon -  FP: theme 2 line colors
	msotcidLineColorLabelDocument = 6039,		//(0,25) Label: '&Document's Colors' NOTE: noicon -  FP: Document line Colors
	msotcidLineColorDocument1Swatch = 6040,		//(0,25) Label: '&Document 1's Line Colors' NOTE: noicon -  FP: document 1 line colors
	msotcidLineColorDocument2Swatch = 6041,		//(0,25) Label: '&Document 2's Line Colors' NOTE: noicon -  FP: document 2 line colors
	msotcidToolsOptionsFactoid = 6042,		//(0,25) Label: '&Tools Options Smart Tag' NOTE: noicon -  Word: Tools/AutoCorrect/Factoid dialog
	msotcidSelectWord = 6043,		//(0,25) Label: 'Select &Word' NOTE: noicon -  FP: for speech use only
	msotcidSelectLine = 6044,		//(0,25) Label: 'Select &Line' NOTE: noicon -  FP: for speech use only
	msotcidSelectParagraph = 6045,		//(0,25) Label: 'Select &Paragraph' NOTE: noicon -  FP: for speech use only
	msotcidNewSequence = 6046,		//(0,25) Label: 'Custom &Link Bar' NOTE: noicon; on-page context menu in nav tree in FP; adds a new nav sequence
	msotcidNewSequenceFileNew = 6047,		//(0,25) Label: 'Custom Link &Bar' NOTE: noicon; file | new (new option) ; adds a new nav sequence
	msotcidBorderDrawTool = 6048,		//(6,22) Label: '&Draw Border' NOTE: noicon -  same as msotcidTableDrawTool; Excel Borders toolbar button
	msotcidBorderEraseTool = 6049,		//(6,23) Label: '&Erase Border' NOTE: noicon -  same as msotcidTableEraseTool; Excel Borders toolbar button
	msotcidBorderStyle = 6050,		//(2,20) Label: '&Line Style' NOTE: noicon -  same as msotcidLineStyle; Excel Borders toolbar button
	msotcidBorderColorSplitDropdown = 6051,		//(6,24) Label: '&Line Color' NOTE: noicon -  same as msotcidTableBorderColorSplitDropdown; Excel Borders toolbar button
	msotcidBorderColorSchemeSwatch = 6052,		//(0,25) Label: '&Color Scheme' NOTE: noicon; Excel Borders color scheme swatch
	msotcidBorderColorAutomaticSwatch = 6053,		//(0,25) Label: '&Automatic Color' NOTE: noicon; Excel Borders automatic color swatch
	msotcidToggleBorderDragMode = 6054,		//(0,25) Label: '&Filled Grid' NOTE: icon;
	msotcidBorders2 = 6055,		//(0,25) Label: '&Borders' NOTE: icon;
	msotcidDrawBorder = 6056,		//(1,13) Label: '&Draw Borders...' NOTE: icon; Excel New Borders Activation button
	msotcidEnvelopeFocusIntroduction = 6057,		//(0,25) Label: '&Introduction Focus' NOTE: noicon -  for mail header
	msotcidStyleVisibility = 6058,		//(0,25) Label: '&Style Visibility' NOTE: noicon for Word
	msotcidToggleFormulaAuditMode = 6059,		//(61,3) Label: 'Formula Auditing &Mode' NOTE: icon -  Excel's Standard toolbar - toggles auditing mode
	msotcidNewNormalPage2 = 6060,		//(0,25) Label: '&Page' NOTE: noicon -  FP: Folder tree context menu
	msotcidNewFolder3 = 6061,		//(0,25) Label: '&Folder' NOTE: noicon -  FP: Folder tree context menu
	msotcidNewPageWeb = 6062,		//(0,25) Label: '&Page or Web...' NOTE: noicon -  FP: new->page or web menu item.
	msotcidSaveAllRecords = 6063,		//(61,16) Label: 'Save All Rec&ords' NOTE: icon -  Acc C/S Transacted updates
	msotcidUndoAllRecords = 6064,		//(61,17) Label: '&Undo All Records' NOTE: icon -  Acc C/S transacted updates
	msotcidDummy6065 = 6065,		//(0,25) Label: '&Dummy6065' NOTE: formerly FccPopupMenu - moved into menu range o10 bug 167297
	msotcidCopyDBFile = 6066,		//(0,25) Label: 'Co&py Database File...' NOTE: Access Tools | Database Utilities | Copy Database File
	msotcidTransferDB = 6067,		//(0,25) Label: 'Trans&fer Database...' NOTE: Access Tools | Database Utilities | Transfer Database
	msotcidDiagramStyle = 6068,		//(63,2) Label: '&AutoFormat' NOTE: noicon -  draw: diagram styles
	msotcidShadeMergeFields = 6069,		//(61,5) Label: '&Highlight Merge Fields' NOTE: icon -  for MailMerge Field Highlighting
	msotcidMailMergeWizard = 6070,		//(0,25) Label: '&Mail Merge Wizard...' NOTE: icon
	msotcidOrgChartAutoLayout = 6071,		//(62,27) Label: '&AutoLayout' NOTE: no icon -  draw: for autolayout in orgchart
	msotcidOrgChartSelectLevel = 6072,		//(62,28) Label: '&Level' NOTE: no icon -  draw: Orgchart select a level
	msotcidOrgChartSelectBranch = 6073,		//(62,29) Label: '&Branch' NOTE: no icon -  draw: Orgchart select a branch
	msotcidOrgChartSelectAllAssistants = 6074,		//(63,0) Label: 'All &Assistants' NOTE: no icon -  draw: Orgchart select all assistants
	msotcidOrgChartSelectAllConnectors = 6075,		//(63,1) Label: 'All &Connecting Lines' NOTE: no icon -  draw: Orgchart select all connectors
	msotcidOLAPMemberProperties = 6076,		//(61,7) Label: 'Property F&ields...' NOTE: icon Excel PivotTable command bar PivotTable menu: OLAP Member Properties Dialog
	msotcidFactoidSettings = 6077,		//(0,25) Label: '&Smart Tag Options...' NOTE: noicon -  factoid OOUI menu item in Word
	msotcidFactoidDelete = 6078,		//(0,25) Label: '&Remove this Smart Tag' NOTE: noicon
	msotcidFactoidCheckAction = 6079,		//(0,25) Label: '&Check for New Actions...' NOTE: noicon -  factoid OOUI menu item in Word
	msotcidOOCLightFactoid = 6080,		//(61,8) Label: '&Light-weight Factoid' NOTE: icon -  factoid OOUI button (light) in Word
	msotcidOOCHeavyFactoid = 6081,		//(61,9) Label: '&Heavy-weight Factoid' NOTE: icon -  factoid OOUI button (heavy) in Word
	msotcidRadioButtonSelected = 6082,		//(61,10) Label: '&Selected' NOTE: icon -  Paste Recovery OOUI in several apps
	msotcidRadioButtonUnselected = 6083,		//(61,11) Label: '&Unselected' NOTE: icon -  Paste Recovery OOUI in several apps
	msotcidDummyRolandrSlideFormatPaneAnimationAutoPreview = 6084,		//(0,25) Label: 'Auto&Preview' NOTE: noicon; in PPT animation gallery menu in slide formatting work pane; if checked animations will be previewed immediately when applied
	msotcidWPFontApplyScheme = 6085,		//(0,25) Label: '&Apply Scheme' NOTE: noicon -  PUB: font scheme workpane
	msotcidWPFontEditScheme = 6086,		//(0,25) Label: '&Edit Scheme' NOTE: noicon -  PUB: font scheme workpane
	msotcidWPFontDuplicateScheme = 6087,		//(0,25) Label: 'Du&plicate Scheme' NOTE: noicon -  PUB: font scheme workpane
	msotcidWPFontRenameScheme = 6088,		//(0,25) Label: '&Rename Scheme' NOTE: noicon -  PUB: font scheme workpane
	msotcidWPFontDeleteScheme = 6089,		//(0,25) Label: '&Delete Scheme' NOTE: noicon -  PUB: font scheme workpane
	msotcidJapaneseGreeting = 6090,		//(0,25) Label: '&Greeting...' NOTE: noicon; Word: Japanese Greeting Wizard
	msotcidJapaneseGreetingOpeningSentence = 6091,		//(0,25) Label: 'O&pening...' NOTE: noicon; Word: Japanese Greeting Wizard opening sentence
	msotcidJapaneseGreetingClosingSentence = 6092,		//(0,25) Label: 'Clo&sing...' NOTE: noicon; Word: Japanese Greeting Wizard closing sentence
	msotcidJapaneseGreetingPreviousGreeting = 6093,		//(0,25) Label: 'I&nsert Previous Greeting' NOTE: noicon; Word: Japanese Greeting Wizard previous greeting
	msotcidFormatInspector = 6094,		//(4,24) Label: 'Re&veal Formatting...' NOTE: icon
	msotcidFormatInspectorChangeProperty = 6095,		//(0,25) Label: '&Change' NOTE: noicon -  item on popup menu inside Word's Format Inspector
	msotcidFormatInspectorResetProperty = 6096,		//(0,25) Label: '&Reset' NOTE: noicon -  item on popup menu inside Word's Format Inspector
	msotcidShowDiagramBar = 6097,		//(0,25) Label: 'Show Diagram Tool&bar' NOTE: noicon -  Item on diagram popup menu
	msotcidHideDiagramBar = 6098,		//(0,25) Label: 'Hide Diagram Tool&bar' NOTE: noicon -  Item on diagram popup menu
	msotcidDiagramReverse = 6099,		//(63,3) Label: '&Reverse Diagram' NOTE: noicon -  Item on diagram toolbar
	msotcidDiagramAutoLayout = 6100,		//(62,11) Label: '&AutoLayout' NOTE: noicon -  Item on diagram toolbar
	msotcidThaiDistributed = 6101,		//(61,13) Label: '&Thai Distributed' NOTE: icon -  Format/Alignment/Thai Distributed menu item in PPT
	msotcidJustifyLow = 6102,		//(61,14) Label: 'Justify Lo&w' NOTE: icon -  Format/Alignment/Justify Low menu item in PPT
	msotcidEditPasteFromExcel = 6103,		//(1,8) Label: 'Paste table from &Excel' NOTE: paste icon: consolidates previous paste from excel commands
	msotcidTxbxAutosize = 6104,		//(0,25) Label: '&Autosize textbox' NOTE: no icon -  used by Word to autosize textboxes.
	msotcidMonthlyPageHits = 6105,		//(0,25) Label: '&Monthly Page Hits' NOTE: no icon -  FP usage report
	msotcidWeeklyPageHits = 6106,		//(0,25) Label: '&Weekly Page Hits' NOTE: no icon -  FP usage report
	msotcidDailyPageHits = 6107,		//(0,25) Label: '&Daily Page Hits' NOTE: no icon -  FP usgae report
	msotcidMonthlySummary = 6108,		//(0,25) Label: 'Mont&hly Summary' NOTE: no icon -  FP usage report
	msotcidWeeklySummary = 6109,		//(0,25) Label: 'W&eekly Summary' NOTE: no icon -  FP usage report
	msotcidDailySummary = 6110,		//(0,25) Label: 'D&aily Summary' NOTE: no icon -  FP usage report
	msotcidTranslationPane = 6111,		//(0,25) Label: 'Tr&anslate...' NOTE: noicon -  Word: translation workpane
	msotcidDMViewWebView = 6112,		//(61,15) Label: '&WebView' NOTE: icon; FileOpen|Save : View menu; switches the view to WebView for document libraries
	msotcidSourceSafeQuickCheckIn = 6113,		//(45,15) Label: 'Check &In' NOTE: same as icon(45-15) NOTE: SourceSafe
	msotcidGotoTOC = 6114,		//(61,18) Label: '&Go to TOC' NOTE: icon - Word goto TOC command (for icon see ashokk)
	msotcidUpdateTOC = 6115,		//(61,19) Label: '&Update TOC' NOTE: icon Word update TOC command (for icon see ashokk)
	msotcidOutlineLevel = 6116,		//(0,25) Label: '&Outline Level' NOTE: noicon - Word dropdown list on outlining toolbar
	msotcidDisplayOtlLevel = 6117,		//(0,25) Label: '&Show Level' NOTE: noicon - Word dropdown list on outlining toolbar
	msotcidOOCAutoListCreateNum = 6118,		//(0,25) Label: '&Stop Automatically Creating Numbered Lists' NOTE: noicon: OOUI for auto lists menu item
	msotcidOOCAutoListNew = 6119,		//(0,25) Label: '&Restart Numbering' NOTE: noicon:
	msotcidOOCAutoListRenumberUndo = 6120,		//(0,25) Label: '&Automatic Renumbering' NOTE: noicon: OOUI for auto lists menu item
	msotcidOOCAutoListLeadin = 6121,		//(0,25) Label: '&Stop Automatically Formatting Beginning of Lists' NOTE: noicon: OOUI for auto lists menu item
	msotcidErrorChecking = 6122,		//(14,27) Label: 'Error Chec&king...' NOTE: icon - Tools/Audit/Error Checking...
	msotcidOOCBulletsAndNumberingOptions = 6123,		//(4,27) Label: 'Bullets and &Numbering...' NOTE: noicon: same as bullets & numbering- OOUI options tunnel menu item
	msotcidOOCAutoListCont = 6124,		//(0,25) Label: '&Continue Numbering' NOTE: noicon: OOUI for auto lists menu item
	msotcidContinueNumbering = 6125,		//(0,25) Label: '&Continue Numbering' NOTE: noicon: fciContinueNumbering
	msotcidConnectList = 6126,		//(0,25) Label: '&Connect List' NOTE: noicon: fciConnectList
	msotcidTahoeCheckout = 6127,		//(0,25) Label: 'Ch&eck Out' NOTE: noicon - File Menu Checks out document from Tahoe server
	msotcidTahoeCheckin = 6128,		//(0,25) Label: 'Ch&eck In' NOTE: noicon - File Menu Checks in document from Tahoe server
	msotcidTahoeMakePublc = 6129,		//(0,25) Label: 'Ma&ke Public' NOTE: noicon - File Menu Publishes a document from Tahoe server
	msotcidShrinkMultiSel = 6130,		//(0,25) Label: '&Shrink a discontiguous selection' NOTE: noicon - Item doesn't appear in UI
	msotcidOrgChartLayoutStandard = 6131,		//(61,20) Label: '&Standard' NOTE: icon - Item on Orgchart toolbar
	msotcidOrgChartLayoutBothHanging = 6132,		//(61,21) Label: '&Both Hanging' NOTE: icon - Item on Orgchart toolbar
	msotcidOrgChartLayoutLeftHanging = 6133,		//(61,22) Label: '&Left Hanging' NOTE: icon - Item on Orgchart toolbar
	msotcidOrgChartLayoutRightHanging = 6134,		//(61,23) Label: '&Right Hanging' NOTE: icon - Item on Orgchart toolbar
	msotcidDpDataOutlinePane = 6135,		//(0,25) Label: '&Data Outline' NOTE: noicon - Access Datapage Outline Pane
	msotcidGenerateGetPivotData = 6136,		//(61,24) Label: '&Generate GetPivotData' NOTE: icon - Item on Excel's PivotTable Well Turns on GetPivotData semiselect behavior
	msotcidShowReviewerFilter = 6137,		//(0,25) Label: '&Reviewers...' NOTE: icon - Item on Reviewing Toolbar pops up a list of reviewers
	msotcidShowReviewerGallery = 6138,		//(61,26) Label: '&Revisions Pane' NOTE: icon - Item on PPT Reviewing Toolbar pops up the Revisions Pane
	msotcidReturnReview = 6139,		//(61,27) Label: 'Reply with &Changes...' NOTE: icon - reviewing toolbar shows when document is in a review cycle
	msotcidViewReviewStatus = 6140,		//(0,25) Label: 'View Review Stat&us...' NOTE: noicon - reviewing toolbar shows when document is in a review cycle
	msotcidEndReview = 6141,		//(0,25) Label: 'E&nd Review...' NOTE: noicon - reviewing toolbar shows when document is in a review cycle
	msotcidStopTabIndent = 6142,		//(0,25) Label: '&Stop Setting Indent on Tabs and Backspace' NOTE: noicon - TabAsIndent OOUI button in Word
	msotcidOOCAutoDashLike = 6143,		//(0,25) Label: '&Stop Automatically Replacing Long Vowel Sounds' NOTE: noicon -  used in the On Object Control
	msotcidACBStartCollecting = 6144,		//(4,15) Label: '&Show Office Clipboard' NOTE: nocion; Office Clipboard System Tray menu; Shows ACB workpane in topmost office app
	msotcidACBStopCollecting = 6145,		//(0,25) Label: 'Sto&p Collecting' NOTE: nocion; Office Clipboard System Tray menu; Closes ACB workpane in all office apps
	msotcidACBUnknownHost = 6146,		//(50,27) Label: '' NOTE: icon; Office Clipboard image origin unknownicon;Turn on ACB collect an image fromnon-office app; Displays that host is unknown
	msotcidACBShowSystrayIcon = 6147,		//(0,25) Label: 'Show Office Clipboard Icon on &Taskbar' NOTE: noicon;
	msotcidACBShowSystemTrayTips = 6148,		//(0,25) Label: 'Show &Status Near Taskbar When Copying' NOTE: nocion;
	msotcidACBAlwaysCollect = 6149,		//(0,25) Label: '&Collect Without Showing Office Clipboard' NOTE: noicon;
	msotcidACBUseTriggers = 6150,		//(0,25) Label: 'Show Office Clipboard &Automatically' NOTE: noicon;
	msotcidReportsViewCopyReport = 6151,		//(0,25) Label: 'Copy &Report' NOTE: noicon - copies report to clipboard
	msotcidOOCLightAutoFitUS = 6152,		//(61,29) Label: '' NOTE: icon - PPT: OOUI
	msotcidOOCHeavyAutoFitUS = 6153,		//(62,0) Label: '' NOTE: icon - PPT: OOUI
	msotcidOOCLightAutoFitFE = 6154,		//(62,1) Label: '' NOTE: icon - PPT: OOUI
	msotcidOOCHeavyAutoFitFE = 6155,		//(62,2) Label: '' NOTE: icon - PPT: OOUI
	msotcidReferringDomains = 6156,		//(0,25) Label: '&Referring Domains' NOTE: noicon - FP usage report
	msotcidReferringURLs = 6157,		//(0,25) Label: 'Referring UR&Ls' NOTE: noicon - FP usage report
	msotcidSearchStrings = 6158,		//(0,25) Label: '&Search Strings' NOTE: noicon - FP usage report
	msotcidCtryCode = 6159,		//(0,25) Label: '&Country Codes' NOTE: noicon - FP usage report
	msotcidDomains = 6160,		//(0,25) Label: 'Domai&ns' NOTE: noicon - FP usage report
	msotcidOsTypes = 6161,		//(0,25) Label: '&Operating Systems' NOTE: noicon - FP usage report
	msotcidBrowserTypes = 6162,		//(0,25) Label: '&Browsers' NOTE: noicon - FP usage report
	msotcidUsageSummary = 6163,		//(0,25) Label: '&Usage Summary' NOTE: noicon - FP usage report
	msotcidFccNormalize = 6164,		//(0,25) Label: '&Normalize text' NOTE: noicon - draw: popup menu for FCC
	msotcidFccIgnore = 6165,		//(0,25) Label: '&Ignore' NOTE: noicon - draw: popup menu for FCC
	msotcidFccIgnoreAll = 6166,		//(0,25) Label: 'Ignore &All' NOTE: noicon - draw: popup menu for FCC
	msotcidViewRevisionsPane = 6167,		//(0,25) Label: 'Tr&acked Changes' NOTE: noicon - fciViewRevisionsPane
	msotcidFPDocViewNormal = 6168,		//(62,3) Label: 'No&rmal' NOTE: icon - fp view menu; switches current document tonormal view
	msotcidFPDocViewHTML = 6169,		//(62,4) Label: 'HTM&L' NOTE: icon - fp view menu; switches current document to html view
	msotcidFPDocViewPreview = 6170,		//(62,5) Label: 'Previe&w' NOTE: icon - fp view menu; switches current document to preview view
	msotcidFPDocViewNoFrames = 6171,		//(62,6) Label: 'N&o Frames' NOTE: icon - fp view menu; switches current document tono frames view
	msotcidFPDocViewFramesPageHTML = 6172,		//(62,7) Label: 'Fra&mes Page HTML' NOTE: icon - fp view menu; switches current document to frames page html view
	msotcidFPFolderPaneViewNavigation = 6173,		//(8,18) Label: 'Nav&igation Pane' NOTE: icon - fp view menu; switches folder pane to navigation view
	msotcidStyleSeparator = 6174,		//(62,9) Label: '&Style Separator' NOTE: icon - Word see ErikR foricon
	msotcidSlideFormatPaneAnimationApply = 6175,		//(0,25) Label: '' NOTE: noicon - PPT Easy animation workpane
	msotcidDummyRolandrSlideFormatPaneAnimationApplyAll = 6176,		//(0,25) Label: '' NOTE: noicon - PPT Easy animation workpane
	msotcidDummyRolandrSlideFormatPaneAnimationApplyLike = 6177,		//(0,25) Label: '' NOTE: noicon - PPT Easy animation workpane
	msotcidDummyRolandrSlideFormatPaneAnimationApplySel = 6178,		//(0,25) Label: '' NOTE: noicon - PPT Easy animation workpane
	msotcidSlideFormatPanePreviewSize = 6179,		//(0,25) Label: 'Show &Large Previews' NOTE: noicon - PPT slide formatting workpanes
	msotcidTabularLayout = 6180,		//(62,10) Label: '&Tabular' NOTE: icon - layout choice on datapage right-click-drag-drop context menu
	msotcidPageRelationships = 6181,		//(0,25) Label: '&Relationships...' NOTE: noicon - datapage design object context menu brings up relwiz
	msotcidSampleDB = 6182,		//(0,25) Label: '' NOTE: noicon - Used to open specific sample dbs
	msotcidSampleDBOtherDBs = 6183,		//(0,25) Label: '&Other Sample Databases...' NOTE: noicon - Invokes dialog for opening sample dbs
	msotcidPhotoGalleryProperties = 6184,		//(68,13) Label: 'Ph&oto Gallery Properties' NOTE: noicon - FP photo gallery
	msotcidInsertPhotoGallery = 6185,		//(68,13) Label: 'New &Photo Gallery...' NOTE: noicon - FP photo gallery
	msotcidFrontPageChart = 6186,		//(5,22) Label: '&Usage Chart' NOTE: noicon - FP usage report
	msotcidSRLearnWord = 6187,		//(0,25) Label: '&Learn from document...' NOTE: noicon - Word: learn words from document for speech
	msotcidOOCChangeBack = 6188,		//(0,25) Label: 'C&hange back to \"<Z>\"' NOTE: noicon - OOUI for undo. as per Project HappyStrings
	msotcidOOCAutoCaptilizationString = 6189,		//(0,25) Label: 'Automatic Capitalization' NOTE: noicon - Used in OOUI Control.
	msotcidOOCAutoBulletsString = 6190,		//(0,25) Label: 'Automatic Bullets' NOTE: noicon - Used in OOUI Control.
	msotcidOOCAutoNumberingString = 6191,		//(0,25) Label: 'Automatic Numbering' NOTE: noicon - Used in OOUI Control.
	msotcidOOCOrdinalsString = 6192,		//(0,25) Label: 'Superscript' NOTE: noicon - Used in OOUI Control.
	msotcidOOCFractionString = 6193,		//(0,25) Label: 'Fraction' NOTE: noicon - Used in OOUI Control.
	msotcidOOCHyphensString = 6194,		//(0,25) Label: 'Dash' NOTE: noicon - Used in OOUI Control.
	msotcidOOCHyperlinkString = 6195,		//(0,25) Label: 'Hyperlink' NOTE: noicon - Used in OOUI Control.
	msotcidOOCAutoCorrectionsString = 6196,		//(0,25) Label: 'Automatic Corrections' NOTE: noicon - Used in OOUI Control.
	msotcidOOCAutoBorders = 6197,		//(0,25) Label: '&Stop Automatically Creating Border Lines' NOTE: noicon - OOUI for AutoBorders Menu Item
	msotcidOOCAutoBordersString = 6198,		//(0,25) Label: 'Border Line' NOTE: noicon - Used in OOUI Control
	msotcidShowRepairs = 6199,		//(0,25) Label: 'Show &Repairs' NOTE: icon - Document Recovery Workpane
	msotcidNewList = 6200,		//(62,12) Label: '&List...' NOTE: icon - creates new List on Office Web Server from File New
	msotcidNewListViewPage = 6201,		//(0,25) Label: 'List &View Page' NOTE: noicon - creates new List View for Office Web Server from context menu
	msotcidInsertListField = 6202,		//(64,16) Label: 'Li&st Field...' NOTE: noicon - inserts an Office Web Server List Field
	msotcidNewSurvey = 6203,		//(61,25) Label: '&Survey...' NOTE: noicon - creates new Survey on Office Web Server from File New
	msotcidListStyle = 6204,		//(62,13) Label: '&List style' NOTE: icon: %Word%\src\res\lbox #10
	msotcidTableStyle = 6205,		//(62,14) Label: '&Table style' NOTE: icon: %Word%\src\res\lbox #8
	msotcidBorderDrawToolLine = 6206,		//(6,22) Label: '&Draw Border' NOTE: noicon - same as msotcidTableDrawTool; Excel Borders Draw Border dropdown button
	msotcidBorderDrawToolGrid = 6207,		//(62,15) Label: '&Draw Border Grid' NOTE: icon; Excel Borders Draw Border Grid dropdown button
	msotcidEditPicAsCanvas = 6208,		//(0,25) Label: '&Edit Picture' NOTE: noicon - used in context menu for Word inline pics like msotcidWW7EditPicture
	msotcidCommandBarOptionsLabels = 6209,		//(0,25) Label: '' NOTE: noicon - label will be set on the fly Used for commandbar options menu (hidden labels).
	msotcidOOCHighContrastLightAuto = 6210,		//(62,16) Label: '' NOTE: icon; Used foricon the On Object Control for Auto when in High Contrast mode
	msotcidOOCHighContrastLightPaste = 6211,		//(62,17) Label: '' NOTE: icon; Used foricon the On Object Control for Auto when in High Contrast mode
	msotcidOOCHighContrastLightCellError = 6212,		//(62,18) Label: '' NOTE: icon; Used foricon the On Object Control for Auto when in High Contrast mode
	msotcidOOCHighContrastLightFactoid = 6213,		//(62,19) Label: '' NOTE: icon; Used foricon the On Object Control for Auto when in High Contrast mode
	msotcidDoubleLeftArrow = 6214,		//(62,20) Label: '&Promote to Heading 1' NOTE: icon - Word Outline toolbar (icon is reverse of msotcidDoubleRightArrow)
	msotcidAutoSumStandardDeviation = 6215,		//(0,25) Label: '&StDev' NOTE: noicon - Used in Access Datapages AutoSum dropdown
	msotcidAutoSumAny = 6216,		//(0,25) Label: '&Any' NOTE: noicon - Used in Access Datapages AutoSum dropdown
	msotcidDatapageGroupCaption = 6217,		//(0,25) Label: '&Caption' NOTE: noicon - Used in Access Datapages section dropdown menu
	msotcidDatapageGroupHeader = 6218,		//(0,25) Label: '&Header' NOTE: noicon - Used in Access Datapages section dropdown menu
	msotcidDatapageGroupFooter = 6219,		//(0,25) Label: '&Footer' NOTE: noicon - Used in Access Datapages section dropdown menu
	msotcidDatapageGroupNavigation = 6220,		//(0,25) Label: 'Record &Navigation' NOTE: noicon - Used in Access Datapages section dropdown menu
	msotcidMSWordFormatDefineStyleTable = 6221,		//(0,25) Label: '&Format Define Style Table' NOTE: noicon - define style table tunnel
	msotcidMSWordFormatDefineStyleStripes = 6222,		//(0,25) Label: '&Format Define Style Stripes' NOTE: noicon - define style stripes tunnel
	msotcidUndoReverseAutoCorrect = 6223,		//(0,25) Label: '&Reverse AutoCorrect' NOTE: noicon -  used in PPT's Undo stack
	msotcidFrontpage = 6224,		//(63,7) Label: '&Microsoft FrontPage' NOTE: icon; small icon that Office Clipboard will show when something is copied from Frontpage; Indicates clipping is from Frontpage
	msotcidOutlook = 6225,		//(63,8) Label: '&Microsoft Outlook' NOTE: icon; small icon that Office Clipboard will show when something is copied from Outlook; Indicates clipping is from Outlook
	msotcidPhotodraw = 6226,		//(63,9) Label: '&Microsoft PhotoDraw' NOTE: icon; small icon that Office Clipboard will show when something is copied from Photodraw; Indicates clipping is from Photodraw
	msotcidNoteOptions = 6227,		//(0,25) Label: '&Note options...' NOTE: noicon -  tunnels to footnote/endnote dialog
	msotcidReplyToComment = 6228,		//(0,25) Label: 'Reply To Com&ment' NOTE: no icon -  WORD:  sometimes replaces insert commment in Word's insert menu or on comment context menu
	msotcidViewMarkup = 6229,		//(0,25) Label: 'M&arkup' NOTE: noicon
	msotcidShowAcetateMarkup = 6230,		//(0,25) Label: 'Show &Markup' NOTE: noicon -  WORD: toggles acetate layer markup balloons (revision toolbar)
	msotcidShowAcetateComments = 6231,		//(0,25) Label: '&Comments' NOTE: noicon -  WORD: toggles acetate layer comment balloons (Show Markup split)
	msotcidShowAcetateInsDel = 6232,		//(0,25) Label: '&Insertions and Deletions' NOTE: noicon -  WORD: toggles acetate layer Ins/Del balloons (Show Markup split)
	msotcidShowAcetateProps = 6233,		//(0,25) Label: '&Formatting' NOTE: noicon -  WORD: toggles acetate layer format balloons (Show Markup split)
	msotcidShowAcetateChanged = 6234,		//(0,25) Label: 'Preview &Accept All Changes' NOTE: noicon -  WORD: Shows insetions inline deleteions in bubbles and new properties (Show Markup split)
	msotcidShowAcetateOriginal = 6235,		//(0,25) Label: 'Preview &Reject All Changes' NOTE: noicon -  WORD: Shows deletions inline insertions in bubbles and old properties (Show Markup split)
	msotcidShowAcetateMixed = 6236,		//(0,25) Label: '&Mix Insertions and Deletions' NOTE: noicon -  WORD: Shows deletions and insertions inline and new properties (Show Markup split)
	msotcidPrevAcetateBubble = 6237,		//(67,22) Label: '&Previous' NOTE: icon(mrigler) WORD: Next comment or revision (Reviewing toolbar)
	msotcidNextAcetateBubble = 6238,		//(67,21) Label: '&Next' NOTE: icon(mrigler) WORD: Previous comment or revision (Reviewing toolbar)
	msotcidOpenRevisionPane = 6239,		//(63,12) Label: 'Reviewing &Pane' NOTE: icon(mrigler) WORD: Next comment or revision (Reviewing toolbar)
	msotcidAcceptChange = 6240,		//(44,19) Label: '&Accept Change' NOTE: icon(mrigler) WORD: Accepts the current revision
	msotcidAcceptAllChangesShown = 6241,		//(0,25) Label: 'Accept All Changes &Shown' NOTE: noicon -  WORD: Accpet all revisions seen through filter (Accept split on reviewing toolbar)
	msotcidAcceptAllChangesInDoc = 6242,		//(0,25) Label: 'Accept All C&hanges in Document' NOTE: noicon -  WORD: Accpet all revisions ignore filter (Accept split on reviewing toolbar)
	msotcidRejectChangeDelComment = 6243,		//(44,20) Label: '&Reject Change/Delete Comment' NOTE: icon
	msotcidRejectAllChangesShown = 6244,		//(0,25) Label: 'Reject All Changes &Shown' NOTE: noicon -  WORD: Accpet all revisions seen through filter (Reject split on reviewing toolbar)
	msotcidRejectAllChangesInDoc = 6245,		//(0,25) Label: 'Reject All C&hanges in Document' NOTE: noicon -  WORD: Accpet all revisions ignore filter (Reject split on reviewing toolbar)
	msotcidDeleteAllCommentsShown = 6246,		//(0,25) Label: '&Delete All Comments Shown' NOTE: noicon -  WORD: Accpet all revisions seen through filter (Reject split on reviewing toolbar)
	msotcidDeleteAllCommentsInDoc = 6247,		//(0,25) Label: 'Delete All Co&mments in Document' NOTE: noicon -  WORD: Accpet all revisions ignore filter (Reject split on reviewing toolbar)
	msotcidPushpinNormal = 6248,		//(63,15) Label: '' NOTE: icon -  A push pin icon for outlook's folder bar in the normal state
	msotcidPushpinPushed = 6249,		//(63,16) Label: '' NOTE: icon -  A push pin icon for outlook's folder bar in the pushed state
	msotcidJapaneseGreetingToolbar = 6250,		//(0,25) Label: 'Show Japanese &Greetings Toolbar' NOTE: noicon -  Word: Show Japanese Greetings Toolbar
	msotcidApplyRevision = 6251,		//(44,19) Label: '&Apply' NOTE: icon
	msotcidApplyRevisionSlide = 6252,		//(0,25) Label: 'Apply All Changes to the Current &Slide' NOTE: noicon -  PPT Reviewing Toolbar
	msotcidApplyRevisionPres = 6253,		//(0,25) Label: 'Apply A&ll Changes to the Presentation' NOTE: noicon -  PPT Reviewing Toolbar
	msotcidUnapplyRevision = 6254,		//(63,18) Label: '&Unapply' NOTE: icon -  PPT Reviewing Toolbar
	msotcidUnapplyRevisionSlide = 6255,		//(0,25) Label: 'Unapply All Changes to the Current &Slide' NOTE: noicon -  PPT Reviewing Toolbar
	msotcidUnapplyRevisionPres = 6256,		//(0,25) Label: 'Unapply A&ll Changes to the Presentation' NOTE: noicon -  PPT Reviewing Toolbar
	msotcidShowMarkerDetails = 6257,		//(0,25) Label: 'Show &Details...' NOTE: icon -  PPT revision marker popup
	msotcidLandscape = 6258,		//(63,20) Label: '&Landscape' NOTE: icon -  PPT: PrintPreview landscape orientation
	msotcidPortrait = 6259,		//(63,21) Label: 'Por&trait' NOTE: icon -  PPT: PrintPreview portrait orientation
	msotcidBroadcastSettings = 6260,		//(0,25) Label: 'Se&ttings...' NOTE: noicon -  PPT Online Broadcast
	msotcidPreviewVideo = 6261,		//(0,25) Label: '&Video' NOTE: noicon -  PPT Slide Show
	msotcidImportData = 6262,		//(63,22) Label: 'Import External &Data' NOTE: icon -  Excel Import External Data menu changes
	msotcidSlideLayoutPaneApplySelected = 6263,		//(0,25) Label: 'Apply to &Selected Slides' NOTE: noicon -  PPT: Slide layout workpane gallery dropdown menu command
	msotcidSlideLayoutPaneApplyMasterStyle = 6264,		//(0,25) Label: 'Reapply &Layout' NOTE: noicon -  PPT: Slide layout workpane gallery dropdown menu command
	msotcidWordShowRepairs = 6265,		//(0,25) Label: '&Show Repairs' NOTE: noicon -  Word: BulletProofer repairs
	msotcidCustomAnimationEffectMRUItem = 6266,		//(0,25) Label: '' NOTE: noicon -  PPT Custom Animation WP Add/Change Effect submenu
	msotcidCustomAnimationEffectMRUMore = 6267,		//(0,25) Label: '&More Effects...' NOTE: noicon -  PPT Custom Animation WP Add/Change Effect submenu
	msotcidCustomAnimationShowTemplateGallery = 6268,		//(0,25) Label: '&Templates...' NOTE: noicon -  PPT Custom Animation WP Add/Change Effect menu
	msotcidCustomAnimationApplyLastTemplate = 6269,		//(0,25) Label: '' NOTE: noicon -  PPT Custom Animation WP Add/Change Effect menu
	msotcidCustomAnimationEffectOnClick = 6270,		//(63,23) Label: 'Start On &Click' NOTE: icon - PPT Custom Animation WP Effect context menu
	msotcidCustomAnimationEffectWithPrevious = 6271,		//(65,20) Label: 'Start &With Previous' NOTE: noicon -  PPT Custom Animation WP Effect context menu
	msotcidCustomAnimationEffectAfterPrevious = 6272,		//(63,24) Label: 'Start &After Previous' NOTE: icon - PPT Custom Animation WP Effect context menu
	msotcidCustomAnimationEffectChange = 6273,		//(0,25) Label: 'Change &Effect' NOTE: noicon -  PPT Custom Animation WP Effect context menu
	msotcidCustomAnimationEffectOptions = 6274,		//(0,25) Label: '&Effect Options...' NOTE: noicon -  PPT Custom Animation WP Effect context menu
	msotcidCustomAnimationEffectDelete = 6275,		//(0,25) Label: '&Remove' NOTE: icon
	msotcidCustomAnimationToggleTimeline = 6276,		//(0,25) Label: 'Show &Timeline' NOTE: icon
	msotcidCustomAnimationTimelineZoomIn = 6277,		//(63,27) Label: 'Zoom &In' NOTE: icon -  PPT Custom Animation WP timeline zoom drop down menu
	msotcidCustomAnimationTimelineZoomOut = 6278,		//(63,28) Label: 'Zoom &Out' NOTE: icon -  PPT Custom Animation WP timeline zoom drop down menu
	msotcidAnimEffectPropFromTopLeft = 6279,		//(67,13) Label: 'From T&op-Left' NOTE: icon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropFromTop = 6280,		//(67,14) Label: 'From &Top' NOTE: icon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropFromTopRight = 6281,		//(67,15) Label: 'From To&p-Right' NOTE: icon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropFromRight = 6282,		//(67,16) Label: 'From &Right' NOTE: icon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropFromBottomRight = 6283,		//(67,17) Label: 'From Bottom-R&ight' NOTE: icon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropFromBottom = 6284,		//(67,18) Label: 'From &Bottom' NOTE: icon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropFromBottomLeft = 6285,		//(65,13) Label: 'From Bottom-L&eft' NOTE: icon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropFromLeft = 6286,		//(65,15) Label: 'From &Left' NOTE: icon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropToTopLeft = 6287,		//(67,17) Label: 'To T&op-Left' NOTE: icon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropToTop = 6288,		//(67,18) Label: 'To &Top' NOTE: icon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropToTopRight = 6289,		//(65,13) Label: 'To To&p-Right' NOTE: icon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropToRight = 6290,		//(65,15) Label: 'To &Right' NOTE: icon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropToBottomRight = 6291,		//(67,13) Label: 'To Bottom-R&ight' NOTE: icon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropToBottom = 6292,		//(67,14) Label: 'To &Bottom' NOTE: icon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropToBottomLeft = 6293,		//(67,15) Label: 'To Bottom-L&eft' NOTE: icon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropToLeft = 6294,		//(67,16) Label: 'To &Left' NOTE: icon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropHorizontal = 6295,		//(0,25) Label: '&Horizontal' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropVertical = 6296,		//(0,25) Label: '&Vertical' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropIn = 6297,		//(0,25) Label: '&In' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropOut = 6298,		//(0,25) Label: '&Out' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropAcross = 6299,		//(0,25) Label: '&Across' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropClockwise = 6300,		//(0,25) Label: '&Clockwise' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropCounterclockwise = 6301,		//(0,25) Label: 'C&ounterclockwise' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropHorizontalIn = 6302,		//(0,25) Label: '&Horizontal In' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropHorizontalOut = 6303,		//(0,25) Label: 'H&orizontal Out' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropVerticalIn = 6304,		//(0,25) Label: '&Vertical In' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropVerticalOut = 6305,		//(0,25) Label: 'V&ertical Out' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropLeftDown = 6306,		//(0,25) Label: '&Left Down' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropLeftUp = 6307,		//(0,25) Label: 'L&eft Up' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropRightDown = 6308,		//(0,25) Label: '&Right Down' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropRightUp = 6309,		//(0,25) Label: 'R&ight Up' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectProp1Spoke = 6310,		//(0,25) Label: '&1 Spoke' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectProp2Spokes = 6311,		//(0,25) Label: '&2 Spokes' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectProp3Spokes = 6312,		//(0,25) Label: '&3 Spokes' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectProp4Spokes = 6313,		//(0,25) Label: '&4 Spokes' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectProp8Spokes = 6314,		//(0,25) Label: '&8 Spokes' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropLeft = 6315,		//(0,25) Label: '&Left' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropUp = 6316,		//(0,25) Label: '&Up' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropRight = 6317,		//(0,25) Label: '&Right' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropDown = 6318,		//(0,25) Label: '&Down' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropInSlightly = 6319,		//(0,25) Label: 'I&n Slightly' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropInFromCenter = 6320,		//(0,25) Label: 'In From Screen &Center' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidDummy6321 = 6321,		//(0,25) Label: '' NOTE: Formerly AnimEffectPropInFromBottom
	msotcidAnimEffectPropOutSlightly = 6322,		//(0,25) Label: 'O&ut Slightly' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidDummy6323 = 6323,		//(0,25) Label: '' NOTE: Formerly AnimEffectPropOutFromCenter
	msotcidAnimEffectPropOutFromBottom = 6324,		//(0,25) Label: 'Out From Screen &Bottom' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropOutToCenter = 6325,		//(0,25) Label: 'Out To Screen &Center' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidDummy6326 = 6326,		//(0,25) Label: '' NOTE: Formerly AnimEffectPropOutToBottom
	msotcidDummy6327 = 6327,		//(0,25) Label: '' NOTE: Formerly AnimEffectPropInToCenter
	msotcidAnimEffectPropInToBottom = 6328,		//(0,25) Label: 'In To Screen &Bottom' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropTiny = 6329,		//(0,25) Label: '&Tiny' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropSmaller = 6330,		//(0,25) Label: '&Smaller' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropLarger = 6331,		//(0,25) Label: '&Larger' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropHuge = 6332,		//(0,25) Label: 'Hug&e' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropBoth = 6333,		//(0,25) Label: '&Both' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropCustom = 6334,		//(0,25) Label: 'C&ustom:' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropQuarterSpin = 6335,		//(0,25) Label: '&Quarter Spin' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropHalfSpin = 6336,		//(0,25) Label: '&Half Spin' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropFullSpin = 6337,		//(0,25) Label: '&Full Spin' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropTwoSpins = 6338,		//(0,25) Label: '&Two Spins' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropTransparent25 = 6339,		//(0,25) Label: '&25%' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropTransparent50 = 6340,		//(0,25) Label: '&50%' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropTransparent75 = 6341,		//(0,25) Label: '&75%' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropTransparent100 = 6342,		//(0,25) Label: '&100%' NOTE: noicon -  PPT Custom Animation WP Effect Properties popup menu
	msotcidAnimEffectPropPathReverse = 6343,		//(64,2) Label: '&Reverse Path Direction' NOTE: noicon
	msotcidWordClearFormatting = 6344,		//(0,25) Label: '&Clear Formatting' NOTE: no icon
	msotcidMailMergeFieldMapping = 6345,		//(63,29) Label: '&Match Fields' NOTE: icon -  Office Mail Merge Field Mapping
	msotcidMailMergeInsertAddressBlock = 6346,		//(64,0) Label: '&Insert Address Block' NOTE: icon -  Office Mail Merge Address Block
	msotcidMailMergeInsertGreetingLine = 6347,		//(64,1) Label: '&Insert Greeting Line' NOTE: icon -  Office Mail Merge Greeting Line
	msotcidMailMergeInsertFields = 6348,		//(17,0) Label: '&Insert Merge Fields' NOTE: icon -  Office Mail Merge Insert Fields
	msotcidMailMergeRecipients = 6349,		//(64,3) Label: '&Mail Merge Recipients' NOTE: icon -  Office Mail Merge Recipients
	msotcidMailMergeEmailOptions = 6350,		//(0,25) Label: '&Mail Merge E-Mail Options' NOTE: icon
	msotcidMailMergePrintOptions = 6351,		//(0,25) Label: '&Mail Merge Print Options' NOTE: icon
	msotcidMailMergeFaxOptions = 6352,		//(0,25) Label: '&Mail Merge Fax Options' NOTE: icon
	msotcidMailMergeNewDocOptions = 6353,		//(0,25) Label: '&Mail Merge to New Document Options' NOTE: noicon -  Word: Mail Merge to new document options dialog
	msotcidMMWPrevious = 6354,		//(64,7) Label: '&Previous wizard step' NOTE: icon
	msotcidMMWNext = 6355,		//(64,8) Label: '&Next wizard step' NOTE: icon
	msotcidMMWChooseTemplate = 6356,		//(64,9) Label: '&Select mail merge template' NOTE: icon
	msotcidMMWEnvelopeOptions = 6357,		//(25,26) Label: '&Set Envelope Options' NOTE: icon -  Mail Merge Envelope Options (Setup)
	msotcidMMWLabelOptions = 6358,		//(64,11) Label: '&Select label size' NOTE: icon
	msotcidMMWBrowse = 6359,		//(64,12) Label: '&Select recipient list file' NOTE: icon
	msotcidMMWChooseContacts = 6360,		//(64,12) Label: '&Select contacts folder' NOTE: icon
	msotcidMMWCreateAddressList = 6361,		//(64,14) Label: '&Create new recipient list' NOTE: icon
	msotcidMMWMatchFields = 6362,		//(0,25) Label: '&Match Fields' NOTE: icon
	msotcidMMWSelectRecipients = 6363,		//(64,3) Label: '&Change recipient list' NOTE: icon
	msotcidMMWInsertAddressBlock = 6364,		//(64,0) Label: '&Insert formatted address' NOTE: icon
	msotcidMMWInsertGreetingLine = 6365,		//(64,1) Label: '&Insert formatted salutation' NOTE: icon
	msotcidMMWInsertPostalBarCode = 6366,		//(64,19) Label: '&Insert US postal bar code' NOTE: icon
	msotcidMMWInsertElectronicPostage = 6367,		//(64,20) Label: '&Insert electronic postage' NOTE: icon
	msotcidMMWInsertMergeField = 6368,		//(17,0) Label: '&Insert merge field' NOTE: icon
	msotcidMMWFind = 6369,		//(21,11) Label: '&Find in recipient list' NOTE: icon
	msotcidMMWEditRecipients = 6370,		//(64,3) Label: '&Change recipient list' NOTE: icon
	msotcidMMWMergeToPrinter = 6371,		//(12,3) Label: '&Merge to printer' NOTE: icon
	msotcidMMWMergeToEMail = 6372,		//(64,25) Label: '&Merge to e-mail' NOTE: icon
	msotcidMMWMergeToFax = 6373,		//(64,26) Label: '&Merge to fax' NOTE: icon
	msotcidMMWMergeToDocument = 6374,		//(64,27) Label: '&Merge to new document' NOTE: icon
	msotcidMMWSendToPrintShop = 6375,		//(64,28) Label: '&Merge' NOTE: icon
	msotcidHTMLAdvancedButton = 6376,		//(64,29) Label: 'Ad&vanced Button' NOTE: icon -  FP: Insert HTML <BUTTON> tag
	msotcidHTMLAdvancedButtonProperties = 6377,		//(0,25) Label: 'Adva&nced Button Properties...' NOTE: noicon -  FP: Properties for HTML <BUTTON> tag
	msotcidOOCLightDragFill = 6378,		//(65,0) Label: '' NOTE: icon -  Excel drag-fill OOUI
	msotcidOOCHeavyDragFill = 6379,		//(65,1) Label: '' NOTE: icon -  Excel drag-fill OOUI
	msotcidOOCHighContrastLightDragFill = 6380,		//(65,2) Label: '' NOTE: icon - Excel drag-fill OOUI
	msotcidOptimizePict = 6381,		//(0,25) Label: '&Compress Pictures...' NOTE: icon
	msotcidOptimizePictDialog = 6382,		//(65,4) Label: '&Compress Pictures...' NOTE: icon -  MSO launch optimize pictures dialog
	msotcidRunTextDirectionLTR = 6383,		//(5,0) Label: 'RunTextDirection&LTR' NOTE: icon -  FrontPage: LTR Run Text Direction
	msotcidRunTextDirectionRTL = 6384,		//(5,1) Label: 'RunTextDirection&RTL' NOTE: icon -  FrontPage: RTL Run Text Direction
	msotcidMSWordToolsOptionsSecurity = 6385,		//(0,25) Label: '&Security' NOTE: noicon -  security options panel
	msotcidTableAutoFormatCombo = 6386,		//(0,25) Label: 'Table &AutoFormat Combo' NOTE: noicon -  FP table autoformat combo in table toolbar.
	msotcidPropertySheetPane = 6387,		//(0,25) Label: '&Property Sheet' NOTE: no icon -  Access Property Sheet Pane
	msotcidPPTSpeechSelectWord = 6388,		//(0,25) Label: '&Select Word' NOTE: noicon -  PPT Select Word for speech control
	msotcidPPTSpeechSelectParagraph = 6389,		//(0,25) Label: '&Select Paragraph' NOTE: noicon -  PPT Select Paragraph for speech control
	msotcidCollabApplyRevisionReviewer = 6390,		//(0,25) Label: '&Apply Changes By This Reviewer' NOTE: noicon -  PPT: Reconciliation gallery menu
	msotcidCollabUnApplyRevisionReviewer = 6391,		//(0,25) Label: '&Unapply Changes By This Reviewer' NOTE: noicon -  PPT: Reconciliation gallery menu
	msotcidCollabShowOnlyReviewerChanges = 6392,		//(0,25) Label: '&Show Only This Reviewer's Changes' NOTE: noicon -  PPT: Reconciliation gallery menu
	msotcidCollabPreviewAnimation = 6393,		//(0,25) Label: '&Preview Animation' NOTE: noicon -  PPT: Reconciliation gallery menu
	msotcidCollabDoneForThisReviewer = 6394,		//(0,25) Label: '&Done With This Reviewer' NOTE: noicon -  PPT: Reconciliation gallery menu
	msotcidMergeWithPresentation = 6395,		//(0,25) Label: 'Com&pare and Merge Presentations...' NOTE: noicon -  PPT: File menu
	msotcidOOCLightXLInsert = 6396,		//(65,7) Label: '' NOTE: icon; Excel Insert OOUI
	msotcidOOCHeavyXLInsert = 6397,		//(65,8) Label: '' NOTE: icon; Excel Insert OOUI
	msotcidOOCHighContrastLightXLInsert = 6398,		//(65,9) Label: '' NOTE: icon; Excel Insert OOUI
	msotcidBorderDrawTool2 = 6399,		//(62,15) Label: '&Draw Border Grid' NOTE: icon -  same as msotcidBorderDrawToolGrid; Excel Borders toolbar button
	msotcidTableAutoFormatStyle = 6400,		//(6,28) Label: 'Table Auto&Format...' NOTE: icon -  same as msotcidTableAutoFormat
	msotcidCustomAnimationPathMRUMore = 6401,		//(0,25) Label: '&More Motion Paths...' NOTE: noicon -  PPT Custom Animation WP Add/Change Effect submenu
	msotcidCustomAnimationDrawCustomPath = 6402,		//(67,20) Label: '&Draw Custom Path' NOTE: noicon
	msotcidDatapageConnection = 6403,		//(65,12) Label: 'Page &Connection...' NOTE: icon -  Page connection command for Access datapages
	msotcidDPGroupFilterControl = 6404,		//(0,25) Label: 'Group &Filter Control' NOTE: noicon -  Access datapage command to make current selection the Group Filter Control
	msotcidDPPivotFieldList = 6405,		//(0,25) Label: '&Field List...' NOTE: nicon -  Bring up field list for pivot table in Access datapage
	msotcidDPPivotProperties = 6406,		//(0,25) Label: '&Commands and Options...' NOTE: nicon
	msotcidDPNavFirst = 6407,		//(0,25) Label: '&First' NOTE: noicon -  Toggle 'Move First' button in navigation control
	msotcidDPNavPrevious = 6408,		//(0,25) Label: '&Previous' NOTE: noicon -  Toggle 'Move Previous' button in navigation control
	msotcidDPNavRecordsetLabel = 6409,		//(0,25) Label: '&Recordset Label' NOTE: noicon -  Toggle Recordset Label in navigation control
	msotcidDPNavNext = 6410,		//(0,25) Label: '&Next' NOTE: noicon -  Toggle 'Move Next' button in navigation control
	msotcidDPNavLast = 6411,		//(0,25) Label: '&Last' NOTE: noicon -  Toggle 'Move Last' button in navigation control
	msotcidDPNavNew = 6412,		//(0,25) Label: 'N&ew' NOTE: noicon -  Toggle 'Move New' button in navigation control
	msotcidDPNavDelete = 6413,		//(0,25) Label: '&Delete' NOTE: noicon -  Toggle 'Delete' button in navigation control
	msotcidDPNavSave = 6414,		//(0,25) Label: '&Save' NOTE: noicon -  Toggle 'Save' button in navigation control
	msotcidDPNavSaveBatch = 6415,		//(0,25) Label: 'Sa&ve All Records' NOTE: noicon -  Toggle 'Save Batch' button in navigation control
	msotcidDPNavUndo = 6416,		//(0,25) Label: '&Undo' NOTE: noicon -  Toggle 'Undo' button in navigation control
	msotcidDPNavSortAsc = 6417,		//(0,25) Label: 'Sort &Ascending' NOTE: noicon -  Toggle 'Sort Ascending' button in navigation control
	msotcidDPNavSortDesc = 6418,		//(0,25) Label: 'Sort &Descending' NOTE: noicon -  Toggle 'Sort Descending' button in navigation control
	msotcidDPNavFilterBySel = 6419,		//(0,25) Label: 'F&ilter By Selection' NOTE: noicon -  Toggle 'Filter By Selection' button in navigation control
	msotcidDPNavFilter = 6420,		//(0,25) Label: 'Filter &Toggle' NOTE: noicon -  Toggle 'Filter Toggle' button in navigation control
	msotcidDPNavHelp = 6421,		//(0,25) Label: '&Help' NOTE: noicon -  Toggle 'Help' button in navigation control
	msotcidDummyRolandrSlideTransitionPaneApplyAll = 6422,		//(0,25) Label: 'Apply to &All Slides' NOTE: noicon -  for PPT slide transition gallery menu in slide transition work pane
	msotcidDummyRolandrSlideTransitionPaneApplyLike = 6423,		//(0,25) Label: 'Apply to &Matching Slides' NOTE: noicon -  for PPT slide transition gallery menu in slide transition work pane
	msotcidDummyRolandrSlideTransitionPaneApplySel = 6424,		//(0,25) Label: 'Apply to &Selected Slides' NOTE: noicon -  for PPT slide transition gallery menu in slide transition work pane
	msotcidSlideTransitionPaneApply = 6425,		//(0,25) Label: '&Apply Slide Transition' NOTE: noicon -  for PPT slide transition gallery menu in slide transition work pane (for Undo)
	msotcidDummyRolandrSlideTransitionPaneAutoPreview = 6426,		//(0,25) Label: 'Auto&Preview' NOTE: noicon -  for PPT slide transition gallery menu in slide transition work pane; if checked transitions will be previewed immediately when applied
	msotcidPivotShow1 = 6427,		//(0,25) Label: '&1' NOTE: noicon -  Access menu item for Show Only the Top/Bottom menus
	msotcidPivotShow2 = 6428,		//(0,25) Label: '&2' NOTE: noicon -  Access menu item for Show Only the Top/Bottom menus
	msotcidPivotShow5 = 6429,		//(0,25) Label: '&5' NOTE: noicon -  Access menu item for Show Only the Top/Bottom menus
	msotcidPivotShow10 = 6430,		//(0,25) Label: '&10' NOTE: noicon -  Access menu item for Show Only the Top/Bottom menus
	msotcidPivotShow25 = 6431,		//(0,25) Label: '&25' NOTE: noicon -  Access menu item for Show Only the Top/Bottom menus
	msotcidPivotShow1Percent = 6432,		//(0,25) Label: '&1%' NOTE: noicon -  Access menu item for Show Only the Top/Bottom menus
	msotcidPivotShow2Percent = 6433,		//(0,25) Label: '&2%' NOTE: noicon -  Access menu item for Show Only the Top/Bottom menus
	msotcidPivotShow5Percent = 6434,		//(0,25) Label: '&5%' NOTE: noicon -  Access menu item for Show Only the Top/Bottom menus
	msotcidPivotShow10Percent = 6435,		//(0,25) Label: '&10%' NOTE: noicon -  Access menu item for Show Only the Top/Bottom menus
	msotcidPivotShow25Percent = 6436,		//(0,25) Label: '&25%' NOTE: noicon -  Access menu item for Show Only the Top/Bottom menus
	msotcidPivotShowOther = 6437,		//(0,25) Label: '&Other...' NOTE: noicon -  Access menu item for Show Only the Top/Bottom menus
	msotcidPivotShowAll = 6438,		//(0,25) Label: 'Show &All' NOTE: noicon -  Access menu item for Conditional Filter menu
	msotcidPivotAutoAverage = 6439,		//(0,25) Label: '&Average' NOTE: noicon -  Access PivotTable view menu items
	msotcidPivotAutoStdDev = 6440,		//(0,25) Label: 'Stan&dard Deviation' NOTE: noicon -  Access PivotTable view menu items
	msotcidPivotAutoStdDevP = 6441,		//(0,25) Label: 'S&tandard Deviation Population' NOTE: noicon -  Access PivotTable view menu items
	msotcidPivotAutoVar = 6442,		//(0,25) Label: '&Variance' NOTE: noicon -  Access PivotTable view menu items
	msotcidPivotAutoVarP = 6443,		//(0,25) Label: 'Va&riance Population' NOTE: noicon -  Access PivotTable view menu items
	msotcidPivotCreateCalcTotal = 6444,		//(0,25) Label: 'Create Calculated &Total...' NOTE: noicon -  Access menu item for Calc Totals/Items/Fields menu
	msotcidPivotCreateCalcItem = 6445,		//(0,25) Label: 'Create Calculated &Item...' NOTE: noicon -  Access menu item for Calc Totals/Items/Fields menu
	msotcidPivotCreateCalcField = 6446,		//(0,25) Label: 'Create Calculated Detail &Field...' NOTE: noicon -  Access menu item for Calc Totals/Items/Fields menu
	msotcidDummy6447 = 6447,		//(0,25) Label: '&Removed by AaronWe' NOTE: icon Formerly PivotCalcTotalItemField " Items and Fields"" -  Access toolbar split button portion"
	msotcidPivotAutoCalc = 6448,		//(65,14) Label: 'Auto&Calc' NOTE: icon -  Access toolbar split button portion
	msotcidDummy6449 = 6449,		//(0,25) Label: '&Removed by AaronWe' NOTE: icon -  formerly PivotConditionalFilter Access toolbar split button portion
	msotcidPivotChartType = 6450,		//(65,16) Label: 'Chart &Type' NOTE: icon -  Access menu item for PivotChart menu
	msotcidChartMultiplePlots = 6451,		//(65,17) Label: '&Multiple Plots' NOTE: icon -  Access menu item for PivotChart menu
	msotcidChartMultipleUnified = 6452,		//(65,18) Label: 'M&ultiple Plots Unified Scale' NOTE: icon -  Access menu item for PivotChart menu
	msotcidPivotChartShowLegend = 6453,		//(65,19) Label: 'Show &Legend' NOTE: icon -  Access menu item for PivotChart menu
	msotcidChartByRowCol = 6454,		//(56,14) Label: 'By &Row/By Column' NOTE: noicon -  Access PivotChart view menu items
	msotcidChartDrill = 6455,		//(56,13) Label: 'Drill &Into' NOTE: noicon -  Access PivotChart view menu items
	msotcidDummy6456 = 6456,		//(0,25) Label: '&Dummy6456' NOTE: Removed by AaronWe at ScottOv's request.  icon -  Access DAP fieldlist connection btn
	msotcidDpFieldListRefresh = 6457,		//(65,21) Label: '&Refresh' NOTE: icon -  Access DAP fieldlist refresh btn
	msotcidDpAddToPage = 6458,		//(65,22) Label: '&Add To Page' NOTE: icon -  Access DAP fieldlist AddToPage btn
	msotcidChartLayout = 6459,		//(0,25) Label: 'PivotC&hart' NOTE: icon
	msotcidSpreadsheetLayout = 6460,		//(0,25) Label: '&Office Spreadsheet' NOTE: icon
	msotcidPictureEditInPhotoDraw = 6461,		//(63,9) Label: '&Edit in Microsoft PhotoDraw' NOTE: icon -  start editing session in PhotoDraw for raster image
	msotcidPictureInsertFromPhotoDraw = 6462,		//(63,9) Label: '&New Microsoft PhotoDraw Picture' NOTE: icon -  insert a new picture and edit it in PhotoDraw
	msotcidZoom500 = 6463,		//(0,25) Label: '&500%' NOTE: noicon -  Access Zoom power in print preview
	msotcidZoom1000 = 6464,		//(0,25) Label: '&1000%' NOTE: noicon -  Access. Zoom power in print preview
	msotcidDummy6465 = 6465,		//(0,25) Label: '&Dummy6465' NOTE: Formerly SetSelectInto
	msotcidXMLFormat = 6466,		//(0,25) Label: 'Apply &XML Formatting Rules' NOTE: noicon -  FP htmlview context menu
	msotcidBeautify = 6467,		//(0,25) Label: 'Reformat HT&ML' NOTE: noicon -  FP htmlview context menu
	msotcidMailMergeEditAddressBlock = 6468,		//(0,25) Label: '&Edit Address Block...' NOTE: noicon -  Word Edit Address Block
	msotcidMailMergeEditGreetingLine = 6469,		//(0,25) Label: '&Edit Greeting Line...' NOTE: noicon -  Word Edit Greeting Line
	msotcidNewPageWeb2 = 6470,		//(0,25) Label: '&Page or Web...' NOTE: icon
	msotcidSetHomePage = 6471,		//(0,25) Label: '&Set as Home Page' NOTE: noicon -  fp set as homepage context menu item.
	msotcidHomePage = 6472,		//(0,25) Label: '&HomePage' NOTE: icon
	msotcidHomePageOpen = 6473,		//(0,25) Label: '&HomePage in open' NOTE: icon
	msotcidSharedBorderProps = 6474,		//(0,25) Label: 'Border &Properties...' NOTE: noicon -  FP context menu that brings up shared border properties dialog
	msotcidHTMLFileChooser = 6475,		//(72,25) Label: 'File &Upload' NOTE: noicon per o10 157028-  FP insert file input control into form.
	msotcidFmtInspModifyProp = 6476,		//(0,25) Label: '&Modify' NOTE: noicon -  item on popup menu inside Word's Format Inspector
	msotcidFmtInspApplyPropOfSurrounding = 6477,		//(0,25) Label: '&Match Property to Formatting of Surrounding Text' NOTE: noicon -  item on popup menu inside Word's Format Inspector
	msotcidFmtInspApplyPropOfOriginal = 6478,		//(0,25) Label: '&Match Property to Formatting of Original Selection' NOTE: noicon -  item on popup menu inside Word's Format Inspector
	msotcidFmtInspSelectSimilarFmt = 6479,		//(0,25) Label: '&Select All Text with Similar Formatting' NOTE: noicon -  item on preview gallery menu inside Word's Format Inspector
	msotcidFmtInspCompareFmt = 6480,		//(0,25) Label: '&Compare Formatting with Other Text' NOTE: noicon -  item on preview gallery menu inside Word's Format Inspector
	msotcidFmtInspApplyFmtOfSurrounding = 6481,		//(0,25) Label: '&Apply Formatting of Surrounding Text' NOTE: noicon -  item on preview gallery menu inside Word's Format Inspector
	msotcidFmtInspApplyFmtOfOriginal = 6482,		//(0,25) Label: '&Apply Formatting of Original Selection' NOTE: noicon -  item on preview gallery menu inside Word's Format Inspector
	msotcidFmtInspStopComparing = 6483,		//(0,25) Label: '&Stop Comparing Properties' NOTE: noicon -  item on preview gallery menu inside Word's Format Inspector
	msotcidOOCHighContrastLightAutoFit = 6484,		//(65,29) Label: '' NOTE: icon; PPT AutoFit OOUI high contrast icon
	msotcidOOCLightAutoFlow = 6485,		//(0,25) Label: '' NOTE: Formerly OOCLightAutoFlow
	msotcidOOCHeavyAutoFlow = 6486,		//(0,25) Label: '' NOTE: Formerly OOCHeavyAutoFlow
	msotcidOOCHighContrastLightAutoFlow = 6487,		//(0,25) Label: '' NOTE: Formerly OOCHighContrastLightAutoFlow
	msotcidOOCLightPictResize = 6488,		//(0,25) Label: '' NOTE: Formerly OOCLightPictResize
	msotcidOOCHeavyPictResize = 6489,		//(0,25) Label: '' NOTE: Formerly OOCHeavyPictResize
	msotcidOOCHighContrastLightPictResize = 6490,		//(0,25) Label: '' NOTE: Formerly OOCHighContrastLightPictResize
	msotcidInsertListForm = 6491,		//(56,21) Label: '&List Form...' NOTE: noicon -  FP insert form menu
	msotcidCustomizeLayout = 6492,		//(0,25) Label: '&Layout Customization View' NOTE: noicon -  FP bot context menu
	msotcidPreviewLiveData = 6493,		//(0,25) Label: 'Live &Data View' NOTE: noicon -  FP bot context menu
	msotcidFPAdminHome = 6494,		//(0,25) Label: '&Administration Home...' NOTE: noicon -  FP command off Tools:Server menu for accessing server extension properties
	msotcidContentFolderMenu = 6495,		//(66,17) Label: '&Content Folder' NOTE: icon - Visio 1st drop - visio icon 1,1
	msotcidOpenStencil = 6496,		//(66,18) Label: '&Open Stencil' NOTE: icon - Visio 1st drop - visio icon 1,2
	msotcidShapeExtensions = 6497,		//(66,19) Label: '&Shape Extensions' NOTE: icon - Visio 1st drop - visio icon 1,3
	msotcidDistributeShapes = 6498,		//(66,20) Label: '&Distribute Shapes' NOTE: icon - Visio 1st drop - visio icon 1,4
	msotcidFillPattern = 6499,		//(66,21) Label: '&Fill Pattern' NOTE: icon - Visio 1st drop - visio icon 1,5
	msotcidCornerRounding = 6500,		//(66,22) Label: '&Corner Rounding' NOTE: icon - Visio 1st drop - visio icon 1,6
	msotcidPointerTool = 6501,		//(66,23) Label: '&Pointer Tool' NOTE: icon - Visio 1st drop - visio icon 1,7
	msotcidConnectorTool = 6502,		//(66,24) Label: '&Connector Tool' NOTE: icon - Visio 1st drop - visio icon 1,8
	msotcidConnectionPointTool = 6503,		//(66,25) Label: '&Connection Point Tool' NOTE: icon - Visio 1st drop - visio icon 1,9
	msotcidStampTool = 6504,		//(66,26) Label: '&Stamp Tol' NOTE: icon - Visio 1st drop - visio icon 1,10
	msotcidTextTool = 6505,		//(66,27) Label: '&Text Tool' NOTE: icon - Visio 1st drop - visio icon 1,11
	msotcidTextBlockTool = 6506,		//(66,28) Label: '&Text Block Tool' NOTE: icon - Visio 1st drop - visio icon 1,12
	msotcidRectangleTool = 6507,		//(66,29) Label: '&Rectangle Tool' NOTE: icon - Visio 1st drop - visio icon 1,13
	msotcidEllipseTool = 6508,		//(67,0) Label: '&Ellipse Tool' NOTE: icon - Visio 1st drop - visio icon 1,14
	msotcidLineTool = 6509,		//(67,1) Label: '&Line Tool' NOTE: icon - Visio 1st drop - visio icon 1,15
	msotcidArcTool = 6510,		//(67,2) Label: '&Arc Tool' NOTE: icon - Visio 1st drop - visio icon 1,16
	msotcidFreeformTool = 6511,		//(67,3) Label: '&Freeform Tool' NOTE: icon - Visio 1st drop - visio icon 1,17
	msotcidPencilTool = 6512,		//(67,4) Label: '&Pencil Tool' NOTE: icon - Visio 1st drop - visio icon 1,18
	msotcidRotationTool = 6513,		//(67,5) Label: '&Rotation Tool' NOTE: icon - Visio 1st drop - visio icon 1,19
	msotcidCropTool = 6514,		//(67,6) Label: '&Crop Tool' NOTE: icon - Visio 1st drop - visio icon 1,20
	msotcidAddJumpsToNoLines = 6515,		//(67,7) Label: '&No Lines' NOTE: icon - Visio 1st drop - visio icon 1,21
	msotcidAddJumpsToHorzLines = 6516,		//(67,8) Label: '&Horizontal Lines' NOTE: icon - Visio 1st drop - visio icon 1,22
	msotcidAddJumpsToVertLines = 6517,		//(67,9) Label: '&Vertical Lines' NOTE: icon - Visio 1st drop - visio icon 1,23
	msotcidAddJumpsToLastRoutedLine = 6518,		//(67,10) Label: '&Routed line' NOTE: icon - Visio 1st drop - visio icon 1,24
	msotcidAddJumpsToLastDispLine = 6519,		//(67,11) Label: '&Last Line' NOTE: icon - Visio 1st drop - visio icon 1,25
	msotcidAddJumpsToFirstDispLine = 6520,		//(67,12) Label: '&First Line' NOTE: icon - Visio 1st drop - visio icon 1,26
	msotcidRoutingDirectionUp = 6521,		//(66,3) Label: '&Route Up' NOTE: icon - Visio 1st drop - visio icon 1,27
	msotcidRoutingDirectionDown = 6522,		//(66,4) Label: '&Route Down' NOTE: icon - Visio 1st drop - visio icon 1,28
	msotcidRoutingDirectionLeft = 6523,		//(66,5) Label: '&Route Left' NOTE: icon - Visio 1st drop - visio icon 1,29
	msotcidRoutingDirectionRight = 6524,		//(66,6) Label: '&Route Right' NOTE: icon - Visio 1st drop - visio icon 1,30
	msotcidJumpStylePageDefault = 6525,		//(66,7) Label: '&Page Default' NOTE: icon - Visio 1st drop - visio icon 2,1
	msotcidJumpStyleArc = 6526,		//(66,8) Label: '&Arc' NOTE: icon - Visio 1st drop - visio icon 2,2
	msotcidJumpStyleGap = 6527,		//(66,9) Label: '&Gap' NOTE: icon - Visio 1st drop - visio icon 2,3
	msotcidJumpStyleSquare = 6528,		//(66,10) Label: '&Square' NOTE: icon - Visio 1st drop - visio icon 2,4
	msotcidJumpStyle2Sides = 6529,		//(66,11) Label: '&2 Sides' NOTE: icon - Visio 1st drop - visio icon 2,5
	msotcidJumpStyle3Sides = 6530,		//(66,12) Label: '&3 Sides' NOTE: icon - Visio 1st drop - visio icon 2,6
	msotcidJumpStyle4Sides = 6531,		//(66,13) Label: '&4 Sides' NOTE: icon - Visio 1st drop - visio icon 2,7
	msotcidJumpStyle5Sides = 6532,		//(66,14) Label: '&5 Sides' NOTE: icon - Visio 1st drop - visio icon 2,8
	msotcidJumpStyle6Sides = 6533,		//(66,15) Label: '&6 Sides' NOTE: icon - Visio 1st drop - visio icon 2,9
	msotcidJumpStyle7Sides = 6534,		//(66,16) Label: '&7 Sides' NOTE: icon - Visio 1st drop - visio icon 2,10
	msotcidFormatPageBackgroundApplyBoth = 6535,		//(0,25) Label: 'Apply to &Both Pages' NOTE: noicon -  context menu on format page background workpane publisher
	msotcidFormatPageBackgroundApplyLeft = 6536,		//(0,25) Label: 'Apply to &Left Page' NOTE: noicon -  context menu on format page background workpane publisher
	msotcidFormatPageBackgroundApplyRight = 6537,		//(0,25) Label: 'Apply to &Right Page' NOTE: noicon -  context menu on format page background workpane publisher
	msotcidFormatPageBackgroundApplyAll = 6538,		//(0,25) Label: 'Apply to All &Pages' NOTE: noicon
	msotcidMMFindEntry = 6539,		//(21,11) Label: '&Find Entry' NOTE: icon -  Word Mail Merge Find Entry dialog
	msotcidCombineChanges = 6540,		//(0,25) Label: '&Combine Changes...' NOTE: noicon -  Word Combine Changes menu item
	msotcidLegalComparison = 6541,		//(0,25) Label: '&Legal Comparison...' NOTE: noicon -  Word Legal Comparison menu item
	msotcidCenterVertical = 6542,		//(25,22) Label: '&Center Vertically' NOTE: noicon -  same as msotcidCenteredVertical; Excel Vertical Alignment
	msotcidDistributeVertical = 6543,		//(47,29) Label: '&Vertically Distributed' NOTE: noicon -  same as msotcidDistributeParagraphVerticalTB; Excel Vertical Alignment
	msotcidDeleteMarker = 6544,		//(6,3) Label: '&Delete Comment' NOTE: icon -  PPT Reviewing Toolbar delete comment or revision
	msotcidNextMarker = 6545,		//(67,21) Label: '&Next Item' NOTE: icon -  PPT Reviewing Toolbar next comment or revision
	msotcidPrevMarker = 6546,		//(67,22) Label: '&Previous Item' NOTE: icon -  PPT Reviewing Toolbar prev comment or revision
	msotcidShowHideMarker = 6547,		//(15,23) Label: 'M&arkup' NOTE: icon
	msotcidImportWordDocument = 6548,		//(0,25) Label: 'Import &Word Document...' NOTE: noicon
	msotcidDeleteText = 6549,		//(0,25) Label: 'Delete Te&xt' NOTE: noicon -  item on Pub's Edit menu
	msotcidDeleteObject = 6550,		//(0,25) Label: '&Delete Object' NOTE: noicon -  item on Pub's Edit menu
	msotcidDeletePage = 6551,		//(0,25) Label: 'Delete P&age' NOTE: noicon -  item on Pub's Edit menu
	msotcidGoToPage = 6552,		//(0,25) Label: '&Go to Page...' NOTE: noicon -  item on Pub's Edit menu
	msotcidViewMasterPage = 6553,		//(0,25) Label: '&Master Page' NOTE: noicon -  item on Pub's View menu
	msotcidIgnoreMasterPage = 6554,		//(0,25) Label: '&Ignore Master Page' NOTE: noicon -  item on Pub's View menu
	msotcidPictureDisplay = 6555,		//(0,25) Label: '&Pictures...' NOTE: noicon -  item on Pub's View menu
	msotcidViewBoundaries = 6556,		//(0,25) Label: '&Boundaries and Guides' NOTE: noicon -  item on Pub's View menu
	msotcidSpecialPaper = 6557,		//(0,25) Label: '&Special Paper...' NOTE: noicon -  item on Pub's View menu
	msotcidInsertPage = 6558,		//(0,25) Label: 'Pa&ge...' NOTE: noicon -  item on Pub's Insert menu
	msotcidCharacterSpacingDialog = 6559,		//(0,25) Label: 'Cha&racter Spacing...' NOTE: noicon -  item on Pub's Format menu
	msotcidIndentsAndListsDialog = 6560,		//(0,25) Label: '&Indents and Lists...' NOTE: noicon -  item on Pub's Format menu
	msotcidCopyFitNone = 6561,		//(0,25) Label: '&None' NOTE: noicon -  item on Pub's Format menu under tcidCopyFitMenu
	msotcidCopyFitUnmatched = 6562,		//(0,25) Label: '&Best Fit' NOTE: noicon -  item on Pub's Format menu under tcidCopyFitMenu
	msotcidCopyFitHalfMatched = 6563,		//(0,25) Label: '&Shrink Text On Overflow' NOTE: noicon -  item on Pub's Format menu under tcidCopyFitMenu
	msotcidDesignGallery = 6564,		//(3,23) Label: '&Design Gallery Object...' NOTE: icon -  item on Pub's Insert menu and Object toolbar
	msotcidDesignGalleryAddSelection = 6565,		//(0,25) Label: '&Add Selection to Design Gallery...' NOTE: noicon -  item on Pub's Insert menu
	msotcidDesignChecker = 6566,		//(0,25) Label: 'Desig&n Checker...' NOTE: noicon -  item on Pub's Tools menu
	msotcidSnapToRulerMarks = 6567,		//(0,25) Label: 'To Ruler &Marks' NOTE: noicon -  item on Pub's Arrange menu under tcidSnapMenu
	msotcidSnapToGuides = 6568,		//(0,25) Label: 'To &Guides' NOTE: noicon -  item on Pub's Arrange menu under tcidSnapMenu
	msotcidLayoutGuidesDialog = 6569,		//(0,25) Label: '&Layout Guides...' NOTE: noicon -  item on Pub's Arrange menu
	msotcidSendToMasterPage = 6570,		//(0,25) Label: 'Send to &Master Page' NOTE: noicon -  item on Pub's Arrange menu. Note: text dynamically updated to Send to Foreground when on Master Page
	msotcidTableCellDiagonalsDialog = 6571,		//(0,25) Label: '&Cell Diagonals...' NOTE: noicon -  item on Pub's Table menu
	msotcidTableAutogrow = 6572,		//(0,25) Label: '&Grow to Fit Text' NOTE: noicon -  item on Pub's Table menu
	msotcidAddHorizontalRulerGuide = 6573,		//(0,25) Label: 'Add &Horizontal Ruler Guide' NOTE: noicon -  item on Pub's Arrange menu under tcidRulerGuidesMenu
	msotcidAddVerticalRulerGuide = 6574,		//(0,25) Label: 'Add &Vertical Ruler Guide' NOTE: noicon -  item on Pub's Arrange menu under tcidRulerGuidesMenu
	msotcidClearRulerGuides = 6575,		//(0,25) Label: '&Clear All Ruler Guides' NOTE: noicon -  item on Pub's Arrange menu under tcidRulerGuidesMenu
	msotcidEditTextInWord = 6576,		//(0,25) Label: 'Edit Story in Microsoft &Word' NOTE: noicon -  item on Pub's Edit menu: sends text in current frame to Word for editing
	msotcidSpellingOptions = 6577,		//(0,25) Label: 'Spelling &Options...' NOTE: noicon -  item on Pub's Tools menu under tcidSpellingMenu
	msotcidPictureFrame = 6578,		//(3,17) Label: '&Picture Frame' NOTE: icon -  item on Pub's Objects toolbar: user draws frame then picks picture
	msotcidCagFrame = 6579,		//(3,18) Label: '&Clip Organizer Frame' NOTE: icon
	msotcidHotspot = 6580,		//(3,20) Label: '&Hot Spot' NOTE: icon -  item on Pub's Objects toolbar: user creates hotspot for imagemap
	msotcidHTMLCodeFragment = 6581,		//(3,22) Label: '&HTML Code Fragment...' NOTE: icon -  item on Pub's Object menu and Insert toolbar for creating HTML code fragment
	msotcidAsianNewspaperJustify = 6582,		//(2,29) Label: '&Justify' NOTE: icon -  item on Pub's Formatting toolbar
	msotcidAsianNewspaperJustifyVertical = 6583,		//(68,9) Label: '&Justify' NOTE: item on Pub's Formatting toolbar
	msotcidColorSeparationsDialog = 6584,		//(0,25) Label: '&Color Printing...' NOTE: noicon -  item on Pub's Tools menu under tcidPrepressMenu
	msotcidTrappingPreferencesDialog = 6585,		//(0,25) Label: '&Preferences...' NOTE: noicon -  item on Pub's Tools menu under tcidPrepressMenu and tcidTrappingMenu
	msotcidTrappingObjectsDialog = 6586,		//(0,25) Label: 'Per &Object Trapping...' NOTE: noicon -  item on Pub's Tools menu under tcidPrepressMenu and tcidTrappingMenu
	msotcidGraphicsManagerDialog = 6587,		//(0,25) Label: '&Graphics Manager...' NOTE: noicon -  item on Pub's Tools menu under tcidPrepressMenu
	msotcidFontManagerDialog = 6588,		//(0,25) Label: '&Fonts...' NOTE: noicon -  item on Pub's Tools menu under tcidPrepressMenu
	msotcidIdentityInsertName = 6589,		//(0,25) Label: '&Personal Name' NOTE: noicon -  item on Publisher's Insert menu to insert Identity frame prepopulated with Name: code depends on order
	msotcidIdentityInsertTitle = 6590,		//(0,25) Label: '&Job Title' NOTE: noicon -  item on Publisher's Insert menu to insert Identity frame prepopulated with Job Title: code depends on order
	msotcidIdentityInsertAddress = 6591,		//(0,25) Label: '&Address' NOTE: noicon -  item on Publisher's Insert menu to insert Identity frame prepopulated with Address: code depends on order
	msotcidIdentityInsertOrgName = 6592,		//(0,25) Label: '&Organization Name' NOTE: noicon -  item on Publisher's Insert menu to insert Identity frame prepopulated with Org. Name: code depends on order
	msotcidIdentityInsertContact = 6593,		//(0,25) Label: 'Pho&ne/Fax/E-mail' NOTE: noicon -  item on Publisher's Insert menu to insert Identity frame prepopulated with Contact Info: code depends on order
	msotcidIdentityInsertTagLine = 6594,		//(0,25) Label: '&Tag Line' NOTE: noicon -  item on Publisher's Insert menu to insert Identity frame prepopulated with Tag Line: code depends on order
	msotcidIdentityInsertLogo = 6595,		//(0,25) Label: '&Logo' NOTE: noicon -  item on Publisher's Insert menu to insert Identity Logo frame: code depends on order
	msotcidIdentityEdit = 6596,		//(0,25) Label: 'Perso&nal Information...' NOTE: noicon -  item on Publisher's Edit menu to change data used for Identity feature
	msotcidRuledLinesDialog = 6597,		//(0,25) Label: '&Horizontal Rules...' NOTE: noicon -  item on Pub's Format menu
	msotcidApplyFormattingHere = 6598,		//(0,25) Label: 'Appl&y Formatting Here' NOTE: noicon -  item on popup when dragging one object atop another in Pub
	msotcidDesignGalleryInsertObject = 6599,		//(0,25) Label: '&Insert This Object' NOTE: noicon -  item on popup when DGal is open in Pub
	msotcidDesignGalleryRenameObject = 6600,		//(0,25) Label: '&Rename This Object...' NOTE: noicon -  item on popup when DGal is open in Pub
	msotcidDesignGalleryDeleteObject = 6601,		//(0,25) Label: '&Delete This Object' NOTE: noicon -  item on popup when DGal is open in Pub
	msotcidDesignGalleryNewCategory = 6602,		//(0,25) Label: '&New Category...' NOTE: noicon -  item on popup when DGal is open in Pub
	msotcidDesignGalleryEditCategory = 6603,		//(0,25) Label: 'Edi&t Category...' NOTE: noicon -  item on popup when DGal is open in Pub
	msotcidDesignGalleryEditCategories = 6604,		//(0,25) Label: '&Edit Categories...' NOTE: noicon -  item on popup when DGal is open in Pub
	msotcidDesignGalleryRenameCategory = 6605,		//(0,25) Label: 'Rename &This Category...' NOTE: noicon -  item on popup when DGal is open in Pub
	msotcidDesignGalleryDeleteCategory = 6606,		//(0,25) Label: 'Delete This &Category' NOTE: noicon -  item on popup when DGal is open in Pub
	msotcidDesignGalleryImport = 6607,		//(0,25) Label: '&Browse...' NOTE: noicon -  item on popup when DGal is open in Pub
	msotcidDesignGalleryRevert = 6608,		//(0,25) Label: '&View Gallery for Current Publication' NOTE: noicon -  item on popup when DGal is open in Pub
	msotcidSmartObjectProperties = 6609,		//(0,25) Label: '&Wizard For This Object...' NOTE: noicon -  item in Pub's Format menu
	msotcidFixSpellingSuggestionNone = 6610,		//(0,25) Label: '&(no spelling suggestions)' NOTE: noicon -  item on Pub's spelling popup
	msotcidZoomToSelection = 6611,		//(0,25) Label: '&Selected Objects' NOTE: noicon -  item in Pub's View menu in Zoom submenu
	msotcidZoom3 = 6612,		//(0,25) Label: '&3%' NOTE: noicon -  item in Pub's View menu in Zoom submenu
	msotcidZoom5 = 6613,		//(0,25) Label: '&5%' NOTE: noicon -  item in Pub's View menu in Zoom submenu
	msotcidZoom7 = 6614,		//(0,25) Label: '&7%' NOTE: noicon -  item in Pub's View menu in Zoom submenu
	msotcidZoom33 = 6615,		//(0,25) Label: '&33%' NOTE: noicon -  item in Pub's View menu in Zoom submenu
	msotcidZoom66 = 6616,		//(0,25) Label: '&66%' NOTE: noicon -  item in Pub's View menu in Zoom submenu
	msotcidZoom400 = 6617,		//(0,25) Label: '&400%' NOTE: noicon -  item in Pub's View menu in Zoom submenu
	msotcidChangeSpotColors = 6618,		//(0,25) Label: 'Change S&pot Color...' NOTE: noicon -  item in Pub's Format menu
	msotcidPackForAnotherComputer = 6619,		//(0,25) Label: 'Take to Another &Computer...' NOTE: noicon -  item in Pub's File menu under tcidPackAndGoMenu
	msotcidPackForCommercialPrinter = 6620,		//(0,25) Label: 'Take to a Commercial &Printing Service...' NOTE: noicon -  item in Pub's File menu under tcidPackAndGoMenu
	msotcidEmbossFont = 6621,		//(0,25) Label: '&Emboss' NOTE: noicon -  item in Pub's Formatting toolbar quick customize well
	msotcidEngraveFont = 6622,		//(0,25) Label: '&Engrave' NOTE: noicon -  item in Pub's Formatting toolbar quick customize well
	msotcidSection = 6623,		//(0,25) Label: 'Se&ction...' NOTE: noicon -  item in Pub's Insert menu
	msotcidPrintPreviewZoomCombo = 6624,		//(0,25) Label: '&Zoom' NOTE: noicon -  item on Pub's Print Preview toolbar
	msotcidPrintPreviewEditPublication = 6625,		//(0,25) Label: '&Edit Publication @UE' NOTE: noicon -  item on Pub's Print Preview toolbar
	msotcidPrintPreviewGoToFirst = 6626,		//(0,25) Label: 'Preview &First Page' NOTE: noicon -  item on Pub's Print Preview toolbar
	msotcidPrintPreviewGoToLast = 6627,		//(0,25) Label: 'Preview &Last Page' NOTE: noicon -  item on Pub's Print Preview toolbar
	msotcidMeasurementLeft = 6628,		//(0,25) Label: '&Horizontal Position' NOTE: noicon -  item on Pub's Measurements toolbar: code depends on order
	msotcidMeasurementTop = 6629,		//(0,25) Label: '&Vertical Position' NOTE: noicon -  item on Pub's Measurements toolbar: code depends on order
	msotcidMeasurementWidth = 6630,		//(0,25) Label: '&Width' NOTE: noicon -  item on Pub's Measurements toolbar: code depends on order
	msotcidMeasurementHeight = 6631,		//(0,25) Label: '&Height' NOTE: noicon -  item on Pub's Measurements toolbar: code depends on order
	msotcidMeasurementRotation = 6632,		//(0,25) Label: '&Rotation' NOTE: noicon -  item on Pub's Measurements toolbar: code depends on order
	msotcidMeasurementTracking = 6633,		//(0,25) Label: '&Tracking' NOTE: noicon -  item on Pub's Measurements toolbar: code depends on order
	msotcidMeasurementScaling = 6634,		//(0,25) Label: '&Text Scaling' NOTE: noicon -  item on Pub's Measurements toolbar: code depends on order
	msotcidMeasurementKerning = 6635,		//(0,25) Label: '&Kerning' NOTE: noicon -  item on Pub's Measurements toolbar: code depends on order
	msotcidMeasurementLineSpacing = 6636,		//(0,25) Label: '&Line Spacing' NOTE: noicon -  item on Pub's Measurements toolbar: code depends on order
	msotcidMeasurementLeftLabel = 6637,		//(0,25) Label: '&Horizontal Position' NOTE: noicon -  item on Pub's Measurements toolbar: code depends on order
	msotcidMeasurementTopLabel = 6638,		//(0,25) Label: '&Vertical Position' NOTE: noicon -  item on Pub's Measurements toolbar: code depends on order
	msotcidMeasurementWidthLabel = 6639,		//(0,25) Label: '&Width' NOTE: noicon -  item on Pub's Measurements toolbar: code depends on order
	msotcidMeasurementHeightLabel = 6640,		//(0,25) Label: '&Height' NOTE: noicon -  item on Pub's Measurements toolbar: code depends on order
	msotcidMeasurementRotationLabel = 6641,		//(0,25) Label: '&Rotation' NOTE: noicon -  item on Pub's Measurements toolbar: code depends on order
	msotcidMeasurementTrackingLabel = 6642,		//(0,25) Label: '&Tracking' NOTE: noicon -  item on Pub's Measurements toolbar: code depends on order
	msotcidMeasurementScalingLabel = 6643,		//(0,25) Label: '&Text Scaling' NOTE: noicon -  item on Pub's Measurements toolbar: code depends on order
	msotcidMeasurementKerningLabel = 6644,		//(0,25) Label: '&Kerning' NOTE: noicon -  item on Pub's Measurements toolbar: code depends on order
	msotcidMeasurementLineSpacingLabel = 6645,		//(0,25) Label: '&Line Spacing' NOTE: noicon -  item on Pub's Measurements toolbar: code depends on order
	msotcidBorderArtStyle = 6646,		//(0,25) Label: '&Border Art Style @UE' NOTE: noicon -  item in Pub's format object dialog
	msotcidDefaultLineColor = 6647,		//(0,25) Label: '&Default Line Color @UE' NOTE: noicon -  item in Pub's format object dialog
	msotcidFormControl = 6648,		//(0,25) Label: '&Form Control @UE' NOTE: noicon -  Form Control insertion tool on Pub's XXXX toolbar
	msotcidFontScheme = 6649,		//(3,27) Label: 'Fo&nt Schemes...' NOTE: noicon
	msotcidBidiMirrorLayout = 6650,		//(0,25) Label: '&Bi-directional Mirroring' NOTE: item on Pub's Tools menu
	msotcidMMPOpenDataSource = 6651,		//(0,25) Label: '&Open Data Source...' NOTE: item on Pub's Mail Merge menu
	msotcidMMPInsertMergeField = 6652,		//(0,25) Label: 'I&nsert Field...' NOTE: item on Pub's Mail Merge menu
	msotcidMMPMerge = 6653,		//(0,25) Label: 'Mer&ge' NOTE: item on Pub's Mail Merge menu
	msotcidMMPFilterOrSort = 6654,		//(0,25) Label: 'Filter or &Sort...' NOTE: item on Pub's Mail Merge menu
	msotcidMMPEditAddressList = 6655,		//(0,25) Label: '&Edit Address List...' NOTE: item on Pub's Mail Merge menu
	msotcidMMPCancel = 6656,		//(0,25) Label: 'C&ancel Merge' NOTE: item on Pub's Mail Merge menu
	msotcidAcquireImage = 6657,		//(0,25) Label: '&Acquire Image...' NOTE: item on Pub's Insert menu
	msotcidSelectImageDevice = 6658,		//(0,25) Label: '&Select Device...' NOTE: item on Pub's Insert menu
	msotcidFillColorSpotSwatch = 6659,		//(0,25) Label: '&Fill Color Spot @UE' NOTE: noicon -  item on Pub's formatting toolbar
	msotcidDlgFillColorSpotSwatch = 6660,		//(0,25) Label: '&Fill Color Spot @UE' NOTE: noicon -  item on Pub's format object dlg (etc.)
	msotcidGradientColor1SpotSwatch = 6661,		//(0,25) Label: '&Gradient Color 1 Spot @UE' NOTE: noicon -  item on Pub's format object dlg (etc.)
	msotcidGradientColor2SpotSwatch = 6662,		//(0,25) Label: '&Gradient Color 2 Spot @UE' NOTE: noicon -  item on Pub's format object dlg (etc.)
	msotcidPatternForegroundColorSpotSwatch = 6663,		//(0,25) Label: '&Pattern Foreground Color Spot @UE' NOTE: noicon -  item on Pub's format object dlg (etc.)
	msotcidPatternBackgroundColorSpotSwatch = 6664,		//(0,25) Label: '&Pattern Background Color Spot @UE' NOTE: noicon -  item on Pub's format object dlg (etc.)
	msotcidTintBaseColorSpotSwatch = 6665,		//(0,25) Label: '&Tint Base Color Spot @UE' NOTE: noicon -  item on Pub's format object dlg (etc.)
	msotcidLineColorSpotSwatch = 6666,		//(0,25) Label: '&Line Color Spot @UE' NOTE: noicon -  item on Pub's formatting toolbar
	msotcidDlgLineColorSpotSwatch = 6667,		//(0,25) Label: '&Line Color Spot @UE' NOTE: noicon -  item on Pub's format object dlg (etc.)
	msotcidFontColorSpotSwatch = 6668,		//(0,25) Label: '&Font Color Spot @UE' NOTE: noicon -  item on Pub's formatting toolbar
	msotcidShadowColorSpotSwatch = 6669,		//(0,25) Label: '&Shadow Color Spot @UE' NOTE: noicon -  item on Pub's format object dlg (etc.)
	msotcid3DColorSpotSwatch = 6670,		//(0,25) Label: '&3D Color Spot @UE' NOTE: noicon -  item on Pub's format object dlg (etc.)
	msotcidWPPublicationOptions = 6671,		//(3,24) Label: 'Publication O&ptions...' NOTE: noicon
	msotcidWPPageContent = 6672,		//(68,10) Label: 'Pa&ge Content...' NOTE: noicon
	msotcidWPPublicationDesigns = 6673,		//(3,25) Label: 'P&ublication Designs...' NOTE: noicon
	msotcidWPColorSchemes = 6674,		//(3,26) Label: '&Color Schemes...' NOTE: noicon
	msotcidHTMLControlMenu = 6675,		//(3,21) Label: '&Form Control' NOTE: icon -  item on Pub's Objects toolbar and in Insert menu
	msotcidCustomShapesMenu = 6676,		//(0,25) Label: '&Custom Shapes @UE' NOTE: icon
	msotcidSaveDrpAs = 6677,		//(1,0) Label: '&Save As...' NOTE: noicon (should use same icon as msotcidSave) Document Recovery Workpane
	msotcidResetFormField = 6678,		//(17,9) Label: '&Reset Form Fields' NOTE: icon -  Word reset form field button
	msotcidEditInPhd = 6679,		//(63,9) Label: '&Edit in Microsoft PhotoDraw' NOTE: icon -  icon should be the PHD logo FP context menu
	msotcidnewInPhd = 6680,		//(63,9) Label: 'New &Microsoft PhotoDraw Picture' NOTE: icon -  icon should be the PHD logo FP insert menu
	msotcidWebComponentMenu = 6681,		//(4,23) Label: '&Web Components' NOTE: icon -  Publisher web component list
	msotcidWebComponentList = 6682,		//(0,25) Label: '&WebComponent' NOTE: (renamed by AaronWe 5/5/00) noicon -  Publisher web component list - dynamically populated
	msotcidWebServiceList = 6683,		//(0,25) Label: '&WebService' NOTE: (renamed by AaronWe 5/5/00) noicon -  Publisher web service list - dynamically populated
	msotcidRightDragMoveInline = 6684,		//(0,25) Label: 'Mo&ve into Text Flow Here' NOTE: noicon
	msotcidRightDragCopyInline = 6685,		//(0,25) Label: 'Co&py into Text Flow Here' NOTE: noicon
	msotcidDatabaseShowFunctions = 6686,		//(68,6) Label: 'Fu&nctions' NOTE: icon -  Used in Access view database objects menu
	msotcidPivotSortAndFilter = 6687,		//(0,25) Label: 'Sort &and Top 10...' NOTE: noicon -  Excel PivotTable menu
	msotcidSxMoveFieldToAxis = 6688,		//(0,25) Label: 'Move to &Column' NOTE: noicon -  item on Excel's PivotTable context menu in the Order sub-menu moves data field to a different PivotTable orientation
	msotcidSxSubtotals = 6689,		//(0,25) Label: 'S&ubtotals' NOTE: noicon -  item on Excel's PivotTable menu on the PivotTable command bar turns subtotals on or off for the currently selected PivotTable field
	msotcidOOCAutoLeadinString = 6690,		//(0,25) Label: '&Automatic Emphasis' NOTE: noicon -  Used in OOUI Control
	msotcidOOCAutoIndentCase1 = 6691,		//(1,10) Label: 'C&hange Back to Tab' NOTE: noicon -  Used in Word's OOUI Control
	msotcidOOCAutoIndentCase2 = 6692,		//(0,25) Label: 'Left Indent' NOTE: noicon
	msotcidMMPropagateLabel = 6693,		//(61,19) Label: '&Propagate Labels' NOTE: icon -  Word Mail Merge propagate labels
	msotcidRaftStdFmt = 6694,		//(0,25) Label: 'S&how Buttons on One Row' NOTE: noicon, on toolbar options menu
	msotcidAnimEffectPropPathAbsolute = 6695,		//(0,25) Label: '&Locked' NOTE: noicon, PPT, Custom Animation WP, Effect Properties popup menu
	msotcidAnimEffectPropPathRelative = 6696,		//(0,25) Label: '&Unlocked' NOTE: noicon, PPT, Custom Animation WP, Effect Properties popup menu
	msotcidReportsViewSaveCustom = 6697,		//(38,27) Label: '&Save Report Settings' NOTE: icon, FP: Save Custom Report settings
	msotcidSlideLayoutPaneInsertSlide = 6698,		//(0,25) Label: 'Insert &New Slide' NOTE: noicon, PPT: Slide layout workpane gallery dropdown menu command
	msotcidPivotCalcTotalItemField = 6699,		//(68,14) Label: 'Calc&ulated Totals and Fields' NOTE: icon
	msotcidPivotConditionalFilter = 6700,		//(68,15) Label: 'Show To&p/Bottom Items' NOTE: icon
	msotcidPivotCollapse = 6701,		//(68,16) Label: 'C&ollapse' NOTE: icon - Access PivotTable view menu items
	msotcidPivotCopy = 6702,		//(0,25) Label: '&Copy' NOTE: noicon - Access PivotTable view menu items
	msotcidPivotShowDetails = 6703,		//(68,17) Label: 'Show Deta&ils' NOTE: icon - Access PivotTable view menu items
	msotcidPivotHideDetails = 6704,		//(68,18) Label: 'Hide De&tails' NOTE: icon - Access PivotTable view menu items
	msotcidChartUndo = 6705,		//(1,10) Label: '&Undo' NOTE: noicon - Access PivotChart view menu items
	msotcidChartDeleteSelection = 6706,		//(68,19) Label: '&Delete' NOTE: icon - Access PivotChart view menu items
	msotcidChartShowLegend = 6707,		//(65,19) Label: 'Show &Legend' NOTE: noicon - Access PivotChart view menu items
	msotcidMMPCreateAddressList = 6708,		//(68,20) Label: '&Create Address List' NOTE: icon - Publisher's mail merge menu (in place of MMWCreateAddressList uses same icon)
	msotcidWPFontUpdateScheme = 6709,		//(0,25) Label: '&Update Scheme to Match Current Publication' NOTE: noicon
	msotcidCreateNewExistingPub = 6710,		//(3,29) Label: '&Create new from existing Publisher publication @UE' NOTE: icon - Publisher's New Publication Pane (formerly known as Start Working)
	msotcidCreateNewExistingWord = 6711,		//(68,22) Label: '&Create new from existing Word document @UE' NOTE: icon - Publisher's New Publication Pane (formerly known as Start Working)
	msotcidPublisherDoc = 6712,		//(4,0) Label: '&Publisher publication @UE' NOTE: icon - Publisher's New Publication Pane (formerly known as Start Working)
	msotcidWordDoc = 6713,		//(68,24) Label: '&Word document @UE' NOTE: icon - Publisher's New Publication Pane (formerly known as Start Working)
	msotcidToggleColorMode = 6714,		//(68,25) Label: '&Color/Grayscale' NOTE: icon
	msotcidSubformForm = 6715,		//(17,1) Label: '&Form' NOTE: icon - Access View\Subform submenu
	msotcidSubformPivotTable = 6716,		//(50,12) Label: 'Pivot&Table' NOTE: icon - Access View\Subform submenu
	msotcidSubformPivotChart = 6717,		//(1,23) Label: 'Pivot&Chart' NOTE: icon - Access View\Subform submenu
	msotcidVisitingUsers = 6718,		//(0,25) Label: '&Visiting Users' NOTE: noicon - FP usage report
	msotcidFormProperties2 = 6719,		//(0,25) Label: 'Format Form Propert&ies...' NOTE: noicon - Publisher; Equivalent to msotcidFormatProperties but with the 'Format' string prefix
	msotcidSlideFormatPaneTemplateAddDesigns = 6720,		//(0,25) Label: 'Add &Design' NOTE: noicon - PPT Design Templates WP Add Designs dropdown menu item
	msotcidAnimFxDefault = 6721,		//(68,29) Label: '' NOTE: icon
	msotcidAnimFxOLEVerb = 6722,		//(69,0) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxMediaAudio = 6723,		//(69,1) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxMediaVideo = 6724,		//(69,2) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxMediaPlay = 6725,		//(69,3) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxMediaStop = 6726,		//(69,4) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxMediaPause = 6727,		//(69,5) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxEmphasisTextColor = 6728,		//(69,6) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxEmphasisFillColor = 6729,		//(69,7) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxEmphasisLineColor = 6730,		//(69,8) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxEmphasisFont = 6731,		//(69,9) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxEmphasisFontStyle = 6732,		//(69,10) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxEmphasisFontSize = 6733,		//(69,11) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxEntranceMotion = 6734,		//(69,12) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxEntranceAppear = 6735,		//(69,13) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxEntranceReveal = 6736,		//(69,14) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxEntranceDistort = 6737,		//(69,15) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxEntranceRandom = 6738,		//(69,16) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxEntranceRotate = 6739,		//(69,17) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxEntranceScale = 6740,		//(69,18) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxEntranceColor = 6741,		//(69,19) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxExitMotion = 6742,		//(69,20) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxExitAppear = 6743,		//(69,21) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxExitReveal = 6744,		//(69,22) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxExitDistort = 6745,		//(69,23) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxExitRandom = 6746,		//(69,24) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxExitRotate = 6747,		//(69,25) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxExitScale = 6748,		//(69,26) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxExitColor = 6749,		//(69,27) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxEmphasisMotion = 6750,		//(69,28) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxEmphasisAppear = 6751,		//(69,29) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxEmphasisReveal = 6752,		//(70,0) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxEmphasisDistort = 6753,		//(70,1) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxEmphasisRotate = 6754,		//(70,2) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxEmphasisScale = 6755,		//(70,3) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxEmphasisTransparent = 6756,		//(70,4) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxEmphasisColor = 6757,		//(70,5) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxEmphasisShadow = 6758,		//(70,6) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxEmphasisMask = 6759,		//(70,7) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxEmphasisListTrack = 6760,		//(70,8) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathCustom = 6761,		//(67,20) Label: '' NOTE: icon
	msotcidAnimFxPathCircle = 6762,		//(70,10) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathRightTriangle = 6763,		//(70,11) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathDiamond = 6764,		//(70,12) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathHexagon = 6765,		//(70,13) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPath5PointStar = 6766,		//(70,14) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathCrescentMoon = 6767,		//(70,15) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathSquare = 6768,		//(70,16) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathTrapezoid = 6769,		//(70,17) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathHeart = 6770,		//(70,18) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathOctagon = 6771,		//(70,19) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPath6PointStar = 6772,		//(70,20) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathFootball = 6773,		//(70,21) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathEqualTriangle = 6774,		//(70,22) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathParallelogram = 6775,		//(70,23) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathPentagon = 6776,		//(70,24) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPath4PointStar = 6777,		//(70,25) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPath8PointStar = 6778,		//(70,26) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathTeardrop = 6779,		//(70,27) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathPointyStar = 6780,		//(70,28) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathCurvedSquare = 6781,		//(70,29) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathCurvedX = 6782,		//(71,0) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathVerticalFigure8 = 6783,		//(71,1) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathCurvyStar = 6784,		//(71,2) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathLoopdeLoop = 6785,		//(71,3) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathBuzzsaw = 6786,		//(71,4) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathHorizontalFigure8 = 6787,		//(71,5) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathPeanut = 6788,		//(71,6) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathFigure8Four = 6789,		//(71,7) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathNeutron = 6790,		//(71,8) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathSwoosh = 6791,		//(71,9) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathBean = 6792,		//(71,10) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathPlus = 6793,		//(71,11) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathInvertedTriangle = 6794,		//(71,12) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathInvertedSquare = 6795,		//(71,13) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathLeft = 6796,		//(71,14) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathTurnRight = 6797,		//(71,15) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathArcDown = 6798,		//(71,16) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathZigzag = 6799,		//(71,17) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathSCurve2 = 6800,		//(71,18) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathSineWave = 6801,		//(71,19) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathBounceLeft = 6802,		//(71,20) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathDown = 6803,		//(71,21) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathTurnUp = 6804,		//(71,22) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathArcUp = 6805,		//(71,23) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathHeartbeat = 6806,		//(71,24) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathSpiralRight = 6807,		//(71,25) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathWave = 6808,		//(71,26) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathCurvyLeft = 6809,		//(71,27) Label: '' NOTE: icon
	msotcidAnimFxPathDiagonalDownRight = 6810,		//(71,28) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathTurnDown = 6811,		//(71,29) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathArcLeft = 6812,		//(72,0) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathFunnel = 6813,		//(72,1) Label: '' NOTE: icon
	msotcidAnimFxPathSpring = 6814,		//(72,2) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathBounceRight = 6815,		//(72,3) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathSpiralLeft = 6816,		//(72,4) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathDiagonalUpRight = 6817,		//(72,5) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathTurnUpRight = 6818,		//(72,6) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathArcRight = 6819,		//(72,7) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathSCurve1 = 6820,		//(72,8) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathDecayingWave = 6821,		//(72,9) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathCurvyRight = 6822,		//(72,10) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidAnimFxPathStairsDown = 6823,		//(72,11) Label: '' NOTE: icon - PPT Custom Animation Effect
	msotcidFloatingTextbox = 6824,		//(5,29) Label: 'Te&xt Box' NOTE: icon
	msotcidFloatingTextboxVertical = 6825,		//(2,12) Label: '&Floating Vertical Text Box' NOTE: icon similar to msotcidTextboxVertical for Word's Insert Menu
	msotcidDiagramFit = 6826,		//(59,6) Label: '&Fit Diagram to Contents' NOTE: noicon - same icon as CanvasFit
	msotcidDiagramResize = 6827,		//(24,21) Label: 'Resi&ze Diagram' NOTE: noicon
	msotcidDiagramExpand = 6828,		//(59,7) Label: '&Expand Diagram' NOTE: noicon - same icon as CanvasExpand
	msotcidDiagramDeleteShape = 6829,		//(0,25) Label: '&Delete Shape' NOTE: icon
	msotcidDummyRolandrDiagramPopup = 6830,		//(0,25) Label: '&Diagram Popup' NOTE: noicon - diagram popup menu
	msotcidPivotShowAs = 6831,		//(72,15) Label: 'Sho&w As' NOTE: icon
	msotcidPivotShowAsNormal = 6832,		//(0,25) Label: '&Normal' NOTE: noicon - Access PivotTable\Show Data As submenu
	msotcidPivotShowAsPercentOfRowTotal = 6833,		//(0,25) Label: 'Percent of &Row Total' NOTE: noicon - Access PivotTable\Show Data As submenu
	msotcidPivotShowAsPercentOfColumnTotal = 6834,		//(0,25) Label: 'Percent of &Column Total' NOTE: noicon - Access PivotTable\Show Data As submenu
	msotcidPivotShowAsPercentOfParentRowItem = 6835,		//(0,25) Label: 'Percent of &Parent Row Item' NOTE: noicon - Access PivotTable\Show Data As submenu
	msotcidPivotShowAsPercentOfParentColumnItem = 6836,		//(0,25) Label: 'Percent of P&arent Column Item' NOTE: noicon - Access PivotTable\Show Data As submenu
	msotcidPivotShowAsPercentOfGrandTotal = 6837,		//(0,25) Label: 'Percent of &Grand Total' NOTE: noicon - Access PivotTable\Show Data As submenu
	msotcidOrgChartFit = 6838,		//(59,6) Label: '&Fit Organization Chart to Contents' NOTE: noicon - same icon as CanvasFit
	msotcidOrgChartResize = 6839,		//(24,21) Label: 'Resi&ze Organization Chart' NOTE: noicon
	msotcidOrgChartExpand = 6840,		//(59,7) Label: '&Expand Organization Chart' NOTE: noicon - same icon as CanvasExpand
	msotcidOrgChartInsertShape = 6841,		//(0,25) Label: 'I&nsert Shape' NOTE: icon
	msotcidOrgChartSetAsAssistant = 6842,		//(0,25) Label: 'Set As &Assistant' NOTE: icon
	msotcidAcceptProposal = 6843,		//(56,24) Label: 'A&ccept Proposal' NOTE: noicon; Outlook: meeting counter-proposal Actions menu and item toolbar
	msotcidAddFavorite = 6844,		//(0,25) Label: '&Add to Favorites...' NOTE: noicon; Outlook: replaces msotcidAddToFavorites on the top level Favorites menu
	msotcidOrganizeFavorites = 6845,		//(0,25) Label: '&Organize Favorites...' NOTE: noicon; Outlook: replaces msotcidFavorites on the top level Favorites menu
	msotcidAddFromAddressBook = 6846,		//(0,25) Label: 'Add from &Address Book...' NOTE: noicon; Outlook: Appointment scheduling Add Others dropdown menu
	msotcidAddPublicFolder = 6847,		//(0,25) Label: 'Add &Public Folder...' NOTE: noicon;
	msotcidAllowNewTimeProposals = 6848,		//(0,25) Label: '&Allow New Time Proposals' NOTE: noicon; Outlook: Appointment item Actions menu
	msotcidAppointmentColor0 = 6849,		//(72,18) Label: '&Appointment Color 0 (None)' NOTE: icon; Outlook: Appointment coloring dropdown menu
	msotcidAppointmentColor1 = 6850,		//(72,19) Label: '&Appointment Color 1 (Red)' NOTE: icon; Outlook: Appointment coloring dropdown menu
	msotcidAppointmentColor2 = 6851,		//(72,20) Label: '&Appointment Color 2 (Blue)' NOTE: icon; Outlook: Appointment coloring dropdown menu
	msotcidAppointmentColor3 = 6852,		//(72,21) Label: '&Appointment Color 3 (Green)' NOTE: icon; Outlook: Appointment coloring dropdown menu
	msotcidAppointmentColor4 = 6853,		//(72,22) Label: '&Appointment Color 4 (Purple)' NOTE: icon; Outlook: Appointment coloring dropdown menu
	msotcidAppointmentColor5 = 6854,		//(56,18) Label: '&Appointment Color 5 (Maroon)' NOTE: icon; Outlook: Appointment coloring dropdown menu
	msotcidAppointmentColor6 = 6855,		//(56,17) Label: '&Appointment Color 6 (Olive)' NOTE: icon; Outlook: Appointment coloring dropdown menu
	msotcidAppointmentColor7 = 6856,		//(56,16) Label: '&Appointment Color 7 (Teal)' NOTE: icon; Outlook: Appointment coloring dropdown menu
	msotcidAppointmentColor8 = 6857,		//(56,15) Label: '&Appointment Color 8 (Yellow)' NOTE: icon;
	msotcidAppointmentColor9 = 6858,		//(72,16) Label: '&Appointment Color 9 (Dark Blue)' NOTE: icon;
	msotcidAppointmentColor10 = 6859,		//(72,17) Label: '&Appointment Color 10 (Cyan)' NOTE: icon;
	msotcidAppointmentColorAssign = 6860,		//(0,25) Label: '&Assign...' NOTE: noicon; Outlook: Appointment coloring dropdown menu
	msotcidAppointmentColorMore = 6861,		//(0,25) Label: '&More...' NOTE: noicon; Outlook: Appointment coloring dropdown menu
	msotcidAppointmentColorPopup = 6862,		//(64,23) Label: '&Appointment Color' NOTE: icon; Outlook: Appointment coloring popup button
	msotcidConfigureAccounts = 6863,		//(0,25) Label: 'E-mail &Accounts...' NOTE: noicon; Outlook: Tools menu
	msotcidCtxAddIEFavorite = 6864,		//(0,25) Label: '&Add to Favorites...' NOTE: noicon; Outlook: folder context menu
	msotcidCtxRemoveURL = 6865,		//(0,25) Label: 'Re&move \"<0w#25>\"' NOTE: noicon;
	msotcidDeclineProposeNewTime = 6866,		//(0,25) Label: 'D&ecline and Propose New Time' NOTE: noicon; Outlook: Appointment item Actions menu
	msotcidDisableAutoSendReceive = 6867,		//(0,25) Label: '&Disable Auto Send/Receive' NOTE: noicon; Outlook: File menu
	msotcidDraftFont = 6868,		//(0,25) Label: '&Draft Font' NOTE: noicon; Outlook: item View menu
	msotcidIMLogOff = 6869,		//(0,25) Label: 'Log &off' NOTE: noicon; Outlook: Tools -> Instant Messaging
	msotcidIMLogOn = 6870,		//(0,25) Label: '&Log on...' NOTE: noicon; Outlook: Tools -> Instant Messaging
	msotcidIMOptions = 6871,		//(0,25) Label: 'O&ptions...' NOTE: noicon; Outlook: Tools -> Instant Messaging
	msotcidDummy6872 = 6872,		//(0,25) Label: '&Removed' NOTE: formerly IMStatus - needs menu tct
	msotcidIMStatusAppearOffline = 6873,		//(0,25) Label: 'Appear O&ffline' NOTE: noicon; Outlook: Tools -> Instant Messaging
	msotcidIMStatusAway = 6874,		//(0,25) Label: '&Away' NOTE: noicon; Outlook: Tools -> Instant Messaging
	msotcidIMStatusBeRightBack = 6875,		//(0,25) Label: 'B&e Right Back' NOTE: noicon; Outlook: Tools -> Instant Messaging
	msotcidIMStatusBusy = 6876,		//(0,25) Label: '&Busy' NOTE: noicon; Outlook: Tools -> Instant Messaging
	msotcidIMStatusOnThePhone = 6877,		//(0,25) Label: 'On The &Phone' NOTE: noicon; Outlook: Tools -> Instant Messaging
	msotcidIMStatusOnline = 6878,		//(0,25) Label: '&Online' NOTE: noicon; Outlook: Tools -> Instant Messaging
	msotcidIMStatusOutToLunch = 6879,		//(0,25) Label: 'Out To &Lunch' NOTE: noicon; Outlook: Tools -> Instant Messaging
	msotcidNewInstantMessage = 6880,		//(0,25) Label: 'New In&stant Message' NOTE: noicon; Outlook: Message and Contact Actions menu
	msotcidNavBack = 6881,		//(2,26) Label: '&Back' NOTE: icon; Outlook: Address bar web toolbar
	msotcidNavForward = 6882,		//(6,1) Label: '&Forward' NOTE: icon; Outlook: Address bar web toolbar
	msotcidWebGoButton = 6883,		//(63,13) Label: '&Go' NOTE: icon; Outlook: Address bar web toolbar
	msotcidFBNewAppointment = 6884,		//(0,25) Label: 'New &Appointment...' NOTE: noicon; Outlook: Appointment scheduling Free/Busy context menu
	msotcidFBNewMailMessage = 6885,		//(0,25) Label: 'New &Mail Message...' NOTE: noicon; Outlook: Appointment scheduling Free/Busy context menu
	msotcidFBNewMailMessageWithAll = 6886,		//(0,25) Label: 'New Mail Me&ssage with All...' NOTE: noicon; Outlook: Appointment scheduling Free/Busy context menu
	msotcidFBNewMeeting = 6887,		//(0,25) Label: '&New Meeting...' NOTE: noicon; Outlook: Appointment scheduling Free/Busy context menu
	msotcidFBNewMeetingAsResource = 6888,		//(0,25) Label: 'New Meeting as &Resource...' NOTE: noicon; Outlook: Appointment scheduling Free/Busy context menu
	msotcidFBNewMeetingWithAll = 6889,		//(0,25) Label: 'New Meeting with &All...' NOTE: noicon; Outlook: Appointment scheduling Free/Busy context menu
	msotcidDummy6890 = 6890,		//(0,25) Label: '&Removed by AaronWe' NOTE: formerly OpenOtherFolder - needs menu tct
	msotcidPrintAllFields = 6891,		//(0,25) Label: '&Print All Fields' NOTE: noicon; Outlook: File menu
	msotcidProposeNewTime = 6892,		//(65,25) Label: 'Propo&se New Time' NOTE: noicon;
	msotcidRereadFreeBusy = 6893,		//(0,25) Label: '&Refresh Free/Busy' NOTE: noicon; Outlook: Appointment scheduling Options dropdown menu
	msotcidShowRemindersWindow = 6894,		//(0,25) Label: 'Reminders W&indow' NOTE: noicon;
	msotcidStripSearchBody = 6895,		//(0,25) Label: 'Search All Text in Each Message' NOTE: noicon; Outlook: search strip options dropdown menu
	msotcidStripSearchClear = 6896,		//(0,25) Label: 'Clear' NOTE: noicon; Outlook: search strip
	msotcidStripSearchClose = 6897,		//(72,12) Label: 'Close' NOTE: noicon; Outlook: search strip
	msotcidDummy6898 = 6898,		//(0,25) Label: 'Dummy6898' NOTE: formerly StripSearchOptionsMenu, moved to menu list by aaronwe o10 bug 258764
	msotcidStripSearchFindSplitMenu = 6899,		//(63,11) Label: 'Find Now' NOTE: icon; Outlook: search strip
	msotcidStripSearchWhat = 6900,		//(0,25) Label: '&Look For' NOTE: noicon; Outlook: search strip
	msotcidSyncGroupSettings = 6901,		//(0,25) Label: 'Send/Receive &Settings...' NOTE: noicon; Outlook: Tools -> Send/Receive
	msotcidSyncStatus = 6902,		//(0,25) Label: 'Send/Receive &Details...' NOTE: noicon; Outlook: Tools -> Send/Receive
	msotcidSyncThisfolderMarked = 6903,		//(0,25) Label: '&This Folder' NOTE: noicon; Outlook: Tools -> Send/Receive
	msotcidSyncThisfolderNew = 6904,		//(0,25) Label: '&This Folder' NOTE: noicon; Outlook: Tools -> Send/Receive
	msotcidTentativeProposeNewTime = 6905,		//(0,25) Label: '&Tentative and Propose New Time' NOTE: noicon; Outlook: Appointment Actions menu
	msotcidUnwrapText = 6906,		//(0,25) Label: '&Unwrap Text' NOTE: noicon; Outlook: Item View menu
	msotcidViewAllProposals = 6907,		//(7,5) Label: 'Vie&w All Proposals' NOTE: noicon;
	msotcidUseInternetZone = 6908,		//(0,25) Label: 'View in Internet &Zone' NOTE: noicon; Outlook: HTML compose item View menu
	msotcidDownloadHeaders = 6909,		//(0,25) Label: 'Download &Headers' NOTE: noicon; Outlook: Tools -> Work With Headers
	msotcidProcessMarkedHeaders = 6910,		//(0,25) Label: '&Process Marked Headers' NOTE: noicon; Outlook: Tools -> Work With Headers
	msotcidDialupMoreLocations = 6911,		//(0,25) Label: '&More Locations...' NOTE: noicon; Outlook: Tools -> Dial-Up Connection
	msotcidWebImport = 6912,		//(0,25) Label: 'I&mport...' NOTE: noicon; FrontPage: File
	msotcidShowHideAWDropdown = 6913,		//(0,25) Label: '&Show Ask a Question Box' NOTE: noicon
	msotcidCustomAnimationEntranceMRUMenu = 6914,		//(63,10) Label: '&Entrance' NOTE: icon -  PPT Custom Animation WP Add/Change Effect menu
	msotcidCustomAnimationEmphasisMRUMenu = 6915,		//(63,14) Label: 'E&mphasis' NOTE: icon -  PPT Custom Animation WP Add/Change Effect menu
	msotcidCustomAnimationExitMRUMenu = 6916,		//(63,17) Label: 'E&xit' NOTE: icon -  PPT Custom Animation WP Add/Change Effect menu
	msotcidCustomAnimationPathMRUMenu = 6917,		//(68,1) Label: 'Motion &Paths' NOTE: icon -  PPT Custom Animation WP Add/Change Effect menu
	msotcidUnRaftStdFmt = 6918,		//(0,25) Label: 'S&how Buttons on Two Rows' NOTE: noicon - on toolbar options menu
	msotcidDeleteMarkerSlide = 6919,		//(0,25) Label: 'Delete All Markers on the Current &Slide' NOTE: noicon - PPT Reviewing toolbar
	msotcidViewDrp = 6920,		//(0,25) Label: '&View' NOTE: noicon; Document Recovery Workpane
	msotcidEditPasteOption = 6921,		//(1,8) Label: 'Paste &Option' NOTE: noicon - same as paste: used by word for paste recovery.  Please remove msotcidEditPasteRecovery this replaces it!
	msotcidOOCAutoIndentCase1Redo = 6922,		//(1,11) Label: 'Redo &First Indent' NOTE: noicon: Word: Used in TabIndent OOUI Control
	msotcidFormatPageBackgroundApplySingle = 6923,		//(0,25) Label: '&Apply to the Page' NOTE: noicon; PUB: background UI submenu selection
	msotcidPrettyPrintHTML = 6924,		//(0,25) Label: 'Ref&ormat HTML' NOTE: noicon; FP pretty print HTML
	msotcidOrgChartInsertDropdown = 6925,		//(65,3) Label: 'I&nsert Shape' NOTE: icon; ppt word excel: OrgChart Toolbar
	msotcidMMSetDocumentType = 6926,		//(64,15) Label: '&Main document setup' NOTE: icon - Word Mail Merge document type setup
	msotcidShowPTToolbar = 6927,		//(0,25) Label: 'Show PivotTable &Toolbar' NOTE: menu item to show/hide PT toolbar
	msotcidACBThumbnailLoading = 6928,		//(64,6) Label: '' NOTE: icon; ACB: icon shown when a thumbnail is not yet generated and is loading.  Edit->Office Clipboard and copy an image.
	msotcidNewDocLibViewPage = 6929,		//(0,25) Label: 'Document Library &View Page' NOTE: noicon; FrontPage: creates new Doc Lib View for Office Web Server from context menu
	msotcidFPFolderPaneViewFolder = 6930,		//(7,13) Label: 'Fold&er List' NOTE: icon; FrontPage: Change to folder list within the pane
	msotcidNavLinkShowNavigationPane = 6931,		//(7,13) Label: 'Fold&er List' NOTE: icon; FrontPage: Toggle folder list from within Nav or Link views
	msotcidFPNavLinkFolderPaneViewFolder = 6932,		//(7,13) Label: 'Fold&er List' NOTE: icon; FrontPage: Change to folder list in the pane from within Nav or Link views
	msotcidInsertCycleShape = 6933,		//(63,25) Label: 'I&nsert Shape' NOTE: icon
	msotcidInsertPyramidShape = 6934,		//(61,4) Label: 'I&nsert Shape' NOTE: icon
	msotcidInsertRadialShape = 6935,		//(61,1) Label: 'I&nsert Shape' NOTE: icon
	msotcidInsertVennShape = 6936,		//(61,0) Label: 'I&nsert Shape' NOTE: icon
	msotcidInsertTargetShape = 6937,		//(60,11) Label: 'I&nsert Shape' NOTE: icon
	msotcidNewSlideMaster = 6938,		//(64,13) Label: 'Ne&w Slide Master' NOTE: icon; ppt: Insert menu and Master view floating toolbar
	msotcidDeleteMaster = 6939,		//(64,21) Label: '&Delete Master' NOTE: icon; ppt: Edit menu and Master view floating toolbar
	msotcidoocHighContrastLightAutoFitFE = 6940,		//(68,7) Label: '' NOTE: icon - for PPT's AutoFit OOUI.  See O10 150801
	msotcidMovePyramidShapeUp = 6941,		//(72,14) Label: 'Move Shape &Backward' NOTE: icon - for Diagram toolbar
	msotcidMoveRadialShapeUp = 6942,		//(57,8) Label: 'Move Shape &Backward' NOTE: icon - for Diagram toolbar
	msotcidMoveVennShapeUp = 6943,		//(56,4) Label: 'Move Shape &Backward' NOTE: icon - for Diagram toolbar
	msotcidMoveTargetShapeUp = 6944,		//(56,0) Label: 'Move Shape &Backward' NOTE: icon - for Diagram toolbar
	msotcidMovePyramidShapeDown = 6945,		//(60,5) Label: 'Move Shape &Forward' NOTE: icon - for Diagram toolbar
	msotcidMoveRadialShapeDown = 6946,		//(63,26) Label: 'Move Shape &Forward' NOTE: icon - for Diagram toolbar
	msotcidMoveVennShapeDown = 6947,		//(64,4) Label: 'Move Shape &Forward' NOTE: icon - for Diagram toolbar
	msotcidMoveTargetShapeDown = 6948,		//(64,5) Label: 'Move Shape &Forward' NOTE: icon - for Diagram toolbar
	msotcidOrgChartStyle = 6949,		//(63,2) Label: '&Autoformat' NOTE: noicon
	msotcidReportsViewShowAll = 6950,		//(0,25) Label: 'Remove Fi&lters' NOTE: noicon; FP removes autofilters applied to reports
	msotcidDavQrySelect = 6951,		//(18,0) Label: 'Se&lect Query' NOTE: icon
	msotcidDavQryMakeTable = 6952,		//(18,2) Label: 'Ma&ke-Table Query...' NOTE: icon make table qry
	msotcidDavQryUpdate = 6953,		//(18,3) Label: '&Update Query' NOTE: icon update qry
	msotcidDavQryAppend = 6954,		//(18,4) Label: 'A&ppend Query...' NOTE: icon append qry
	msotcidDavQryAppendValues = 6955,		//(57,4) Label: 'Append Values &Query' NOTE: icon
	msotcidDavQryDelete = 6956,		//(18,5) Label: 'Delete Quer&y' NOTE: icon
	msotcidDavQryTypeDropdown = 6957,		//(0,25) Label: 'Choose Quer&y Type...' NOTE: noicon -  dropdown to pick query type
	msotcidSetMaxRecords = 6958,		//(0,25) Label: 'Ma&ximum Records...' NOTE: noicon -  invoke dlg to set max records
	msotcidCustomAnimationMovieMRUMenu = 6959,		//(69,2) Label: 'Movie &Actions' NOTE: icon; NORMAL RANGE bug 155868 - NOT MENU PPT Custom Animation effects for movies
	msotcidCustomAnimationSoundMRUMenu = 6960,		//(69,1) Label: 'Sound &Actions' NOTE: icon; NORMAL RANGE bug 155868 - NOT MENU PPT Custom Animation effects for sounds
	msotcidCustomAnimationEffectMediaPlay = 6961,		//(69,3) Label: '&Play' NOTE: icon sameas AnimFXMediaPlay; PPT Custom Animation effect for media
	msotcidCustomAnimationEffectMediaPause = 6962,		//(69,5) Label: 'Pau&se' NOTE: icon; sameas AnimFxMediaPause PPT Custom Animation effect for media
	msotcidCustomAnimationEffectMediaStop = 6963,		//(69,4) Label: 'S&top' NOTE: icon;  sameas AnimFxMeediaStop PPT Custom Animation effect for media
	msotcidFPExport = 6964,		//(17,24) Label: 'Expor&t...' NOTE: icon: same as msotcidExport; FrontPage
	msotcidFPBreak = 6965,		//(0,25) Label: '&Break...' NOTE: noicon; FrontPage: Differs from msotcidBreak by translation (see bug #139367)
	msotcidFPTableDrawTool = 6966,		//(6,22) Label: 'Dra&w Table' NOTE: icon: same as msotcidTableDrawTool; FrontPage: Differs from msotcidTableDrawTool by translation (see bug #139367)
	msotcidFPBorderShadingDialog = 6967,		//(0,25) Label: '&Borders and Shading...' NOTE: noicon; FrontPage: Differs from msotcidBorderShadingDialog by translation (see bug #139367)
	msotcidAcetateViewMode = 6968,		//(0,25) Label: '&Display for Review' NOTE: noicon WORD dropdown on revewing toolbar
	msotcidNewCommentSplit = 6969,		//(5,28) Label: 'Ne&w Comment' NOTE: icon WORD should be identical to msotcidNewComment (needs to be distinct to avoid duplicate tcid)
	msotcidAcceptDeletion = 6970,		//(44,19) Label: 'Acc&ept Deletion' NOTE: icon
	msotcidAcceptInsertion = 6971,		//(44,19) Label: 'Acc&ept Insertion' NOTE: icon
	msotcidAcceptFormatChange = 6972,		//(44,19) Label: 'Acc&ept Format Change' NOTE: icon
	msotcidRejectDeletion = 6973,		//(44,20) Label: '&Reject Deletion' NOTE: icon
	msotcidRejectInsertion = 6974,		//(44,20) Label: '&Reject Insertion' NOTE: icon
	msotcidRejectFormatChange = 6975,		//(44,20) Label: '&Reject Format Change' NOTE: icon
	msotcidWordEmailMessage = 6976,		//(0,13) Label: '' NOTE: icon; for HL control in FN workpane; use WordEmailMessage.bmp
	msotcidWordHtmlTemplate = 6977,		//(0,12) Label: '' NOTE: icon; for HL control in FN workpane; use WordHtmlTemplate.bmp
	msotcidWordTemplate = 6978,		//(0,15) Label: '' NOTE: icon; for HL control in FN workpane; use WordTemplate.bmp
	msotcidFrontPageTemplate = 6979,		//(56,8) Label: '' NOTE: icon; for HL control in FN workpane; use FrontPageTemplate.bmp
	msotcidPowerPointWizardTemplate = 6980,		//(2,0) Label: '' NOTE: icon; for HL control in FN workpane; use PowerPointWizardTemplate.bmp
	msotcidPowerPointTemplate = 6981,		//(2,2) Label: '' NOTE: icon; for HL control in FN workpane; use PowerPointTemplate.bmp
	msotcidAccessNewDatabase = 6982,		//(22,26) Label: '' NOTE: icon; for HL control in FN workpane; use AccessNewDatabase.bmp
	msotcidAccessWizardDatabase = 6983,		//(56,26) Label: '' NOTE: icon; for HL control in FN workpane; use AccessWizardDatabase.bmp
	msotcidAccessADPTemplate = 6984,		//(56,27) Label: '' NOTE: icon; for HL control in FN workpane; use AccessADPTemplate.bmp
	msotcidAccessHtmlTemplate = 6985,		//(56,28) Label: '' NOTE: icon; for HL control in FN workpane; use AccessHtmlTemplate.bmp
	msotcidExcelTemplate = 6986,		//(1,26) Label: '' NOTE: icon; for HL control in FN workpane; use ExcelTemplate.bmp
	msotcidNewAccessFile = 6987,		//(57,1) Label: '' NOTE: icon; for HL control in FN workpane; use NewAccessFile.bmp
	msotcidNewFrontPageFile = 6988,		//(57,2) Label: '' NOTE: icon; for HL control in FN workpane; use NewFrontPageFile.bmp
	msotcidNewPowerPointFile = 6989,		//(2,1) Label: '' NOTE: icon; for HL control in FN workpane; use NewPowerPointFile.bmp
	msotcidNewWordFile = 6990,		//(0,14) Label: '' NOTE: icon; for HL control in FN workpane; use NewWordFile.bmp
	msotcidNewExcelFile = 6991,		//(1,25) Label: '' NOTE: icon; for HL control in FN workpane; use NewExcelFile.bmp
	msotcidDummy6992 = 6992,		//(0,25) Label: '&[Removed by AaronWe]' NOTE: Formerly ActionButtons, moved to Other Controls
	msotcidTemplatesOnMyWeb = 6993,		//(0,16) Label: '' NOTE: icon;
	msotcidMSWordMailMergeQueryOptionsPre10 = 6994,		//(0,25) Label: '' NOTE: noicon; internal query command; hook to old query options command
	msotcidPaneViewsMenu = 6995,		//(5,5) Label: '&Toggle Pane' NOTE: icon; NOT A MENU TCID - normal range FrontPage: Menu to change the view within the pane
	msotcidDPNavUndoBatch = 6996,		//(0,25) Label: 'Und&o All Records' NOTE: noicon -  Toggle 'UndoBatch' button in navigation control (context menu only item)
	msotcidAllowUsersToEditRanges = 6997,		//(56,20) Label: '&Allow Users to Edit Ranges...' NOTE: icon; Excel Protection toolbar (O10 #160903)
	msotcidCustomAnimationEffectTiming = 6998,		//(0,25) Label: '&Timing...' NOTE: noicon;
	msotcidShowAllReviewers = 6999,		//(0,25) Label: '&All Reviewers' NOTE: noicon WORD: top of reviewers menu
	};

enum
	{
	msotcidDiagramAutoFormat = 7000,		//(0,25) Label: 'Use A&utoFormat' NOTE: noicon
	msotcidGroupSchedules = 7001,		//(68,12) Label: '&Schedules...' NOTE: icon; OLK: Calendar module Standard toolbar; Group Calendaring
	msotcidViewGroupSchedules = 7002,		//(68,12) Label: 'View &Group Schedules...' NOTE: icon; OLK: Calendar module Actions menu; Group Calendaring (same icon as msotcidGroupSchedules)
	msotcidReportsViewCustomMenu = 7003,		//(0,25) Label: '&Custom...' NOTE: moved by AaronWe from Other Controls noicon brings up menu of 'Custom' reports
	msotcidCustomAnimationVerbMRUMenu = 7004,		//(69,0) Label: '&Verb' NOTE: noicon -  PPT Custom Animation WP Add/Change Effect menu
	msotcidOOCDashesString = 7005,		//(0,25) Label: 'Dash' NOTE: noicon;
	msotcidTTSSpeakSelection = 7006,		//(22,25) Label: 'S&peak Cells' NOTE: icon;
	msotcidTTSStopSpeak = 7007,		//(22,23) Label: '&Stop Speaking' NOTE: icon;
	msotcidTTSRowEnum = 7008,		//(22,22) Label: 'By &Rows' NOTE: icon;
	msotcidTTSColEnum = 7009,		//(22,21) Label: 'By &Columns' NOTE: icon;
	msotcidTTSOnCellEntry = 7010,		//(35,9) Label: 'Speak On &Enter' NOTE: noicon;
	msotcidTTSToolbar = 7011,		//(0,25) Label: 'Show &Text To Speech Toolbar' NOTE: noicon;
	msotcidACBUnknownText = 7012,		//(22,20) Label: '&Text' NOTE: Icon
	msotcidACBUnknownImage = 7013,		//(22,19) Label: '&Image' NOTE: Icon
	msotcidACBUnknownHtml = 7014,		//(68,28) Label: '&HTML' NOTE: Icon
	msotcidWordClipping = 7015,		//(68,27) Label: '&Word' NOTE: Icon
	msotcidExcelClipping = 7016,		//(68,26) Label: '&Excel' NOTE: Icon
	msotcidPPTClipping = 7017,		//(68,2) Label: '&PowerPoint' NOTE: Icon
	msotcidAccessClipping = 7018,		//(66,2) Label: '&Access' NOTE: Icon
	msotcidFPClipping = 7019,		//(66,1) Label: '&FrontPage' NOTE: Icon
	msotcidTemplatesOnTheWeb = 7020,		//(0,17) Label: '' NOTE: noicon; for HL control in FN workpane; use TemplatesOnTheWeb.bmp
	msotcidTranslate = 7021,		//(0,25) Label: 'Tr&anslate' NOTE: noicon; Word: context menu for translating words
	msotcidVisioSAWP = 7022,		//(66,0) Label: 'Save as Web P&age...' NOTE: icon;
	msotcidFPNewIFramePage = 7023,		//(0,25) Label: '&New Inline Frame Page' NOTE: noicon; RAID 95901; context menu for inline frame to create a new empty page in the frame
	msotcidWordClearContents = 7024,		//(0,25) Label: '&Contents' NOTE: noicon; same as msotcidClearContents
	msotcidChangePictureFromFile = 7025,		//(2,16) Label: '&From File...' NOTE: noicon (same as msotcidInsertPictureFromFile); Raid 193541; Pub: picture context menu; same as msotcidInsertPictureFromFile except replaces currently selected picture
	msotcidExpandLeft = 7026,		//(65,28) Label: '' NOTE: icon; PUB: expand icon for the expand control on the start working pane
	msotcidCollapseLeft = 7027,		//(3,28) Label: '' NOTE: icon; PUB: collapse icon for the expand control on the start working pane
	msotcidPubHtmlFile = 7028,		//(65,10) Label: '' NOTE: icon; PUB: icon for Publisher html file
	msotcidPubMHtmlFile = 7029,		//(61,6) Label: '' NOTE: icon; PUB: icon for Publisher mhtml file
	msotcidFPInsertRows = 7030,		//(10,5) Label: 'I&nsert Rows' NOTE: noicon;
	msotcidFPInsertColumns = 7031,		//(10,6) Label: 'Insert Column&s' NOTE: noicon;
	msotcidEServices = 7032,		//(0,25) Label: 'Tools on the We&b...' NOTE: noicon;
	msotcidOrder = 7033,		//(3,10) Label: '' NOTE: noicon is the same as for msotcidBringToFront
	msotcidRotateFlip = 7034,		//(3,11) Label: '' NOTE: noicon is the same as for msotcidRotate
	msotcidOpenDrp = 7035,		//(0,10) Label: '&Open' NOTE: noicon (same as msotcidOpen); Word/Excel/PPT Document Recovery Workpane
	msotcidDeleteDrp = 7036,		//(6,3) Label: '&Delete' NOTE: noicon (same as msotcidDelete); Word/Excel/PPT Document Recovery Workpane
	msotcidCloseDrp = 7037,		//(0,25) Label: '&Close' NOTE: noicon; Word/Excel/PPT Document Recovery Workpane
	msotcidFontFillEffects = 7038,		//(0,25) Label: '&Fill Effects...' NOTE: noicon; Raid 162707; Pub: on the font color dropdown from the from the formatting toolbar
	msotcidHTMLFragmentProperties = 7039,		//(56,12) Label: '&HTML Code Fragment Properties...' NOTE: icon; PUB: context menu for html fragments; RAID #111974
	msotcidOutlookClipping = 7040,		//(11,18) Label: '&Outlook' NOTE: icon;
	msotcidPublisherClipping = 7041,		//(60,3) Label: '&Publisher' NOTE: icon;
	msotcidWQShowHideIcons = 7042,		//(70,9) Label: '&Hide Icons' NOTE: icon;
	msotcidPivotClearCustomOrdering = 7043,		//(0,25) Label: 'Clear C&ustom Ordering' NOTE: noicon; Access for main Pivot context menu
	msotcidPivotFilterBySelection = 7044,		//(0,25) Label: 'Filter B&y Selection' NOTE: noicon; Access for main Pivot context menu
	msotcidPivotRemoveTotal = 7045,		//(0,25) Label: '&Remove' NOTE: noicon; Access for main Pivot context menu
	msotcidPivotGroupItems = 7046,		//(0,25) Label: '&Group Items' NOTE: noicon; Access for main Pivot context menu
	msotcidPivotUngroupItems = 7047,		//(0,25) Label: 'U&ngroup Items' NOTE: noicon; Access for main Pivot context menu
	msotcidChartDrillOut = 7048,		//(56,5) Label: '&Drill Out' NOTE: icon;
	msotcidDavManageIndexes = 7049,		//(0,25) Label: 'Manage &Indexes...' NOTE: noicon; Access menuitem on context menu for server side views
	msotcidAccessibility = 7050,		//(0,25) Label: 'Check Accessi&bility...' NOTE: icon; Tools menu; Activates the Accessibility Checker
	msotcidAnimFxPathUp = 7051,		//(56,3) Label: '' NOTE: icon;
	msotcidAnimFxPathRight = 7052,		//(56,2) Label: '' NOTE: icon;
	msotcidWebComponentProperties = 7053,		//(56,1) Label: '&Web Component...' NOTE: icon;
	msotcidPrintWhatDropdownLabel = 7054,		//(0,25) Label: '&Print What:' NOTE: noicon; PPT: static label for msotcidPrintWhatDropdown control Raid 196765
	msotcidGridToggle = 7055,		//(7,10) Label: 'Show/Hide &Grid' NOTE: noicon; PPT button on Standard toolbar same icon as msotcidGrid2
	msotcidFPAddInManager = 7056,		//(0,25) Label: 'Add-&Ins...' NOTE: noicon; FP: Same as msotcidAddInManager different translation RAID #162550
	msotcidFPMarkTaskComplete = 7057,		//(46,17) Label: '&Mark Complete' NOTE: noicon; FP: Same as msotcidMarkTaskComplete different translation RAID #204574
	msotcidDavRemoveFilter = 7058,		//(0,25) Label: 'Remove &Filter' NOTE: noicon; Access menuitem on context menu for davinci field list RAID 209809
	msotcidDavIndexesKeys = 7059,		//(0,25) Label: 'Inde&xes / Keys' NOTE: noicon; Access menuitem on edit menu for davinci table design RAID 209809
	msotcidDavRelationships = 7060,		//(0,25) Label: 'Relations&hips' NOTE: noicon; Access menuitem on edit menu for davinci table design RAID 209809
	msotcidDavConstraints = 7061,		//(0,25) Label: 'Co&nstraints' NOTE: noicon; Access menuitem on edit menu for davinci table design RAID 209809
	msotcidDiagramCopyToClipboard = 7062,		//(0,25) Label: 'Copy Dia&gram to Clipboard' NOTE: noicon; Access menuitem on edit menu for diagrams RAID 209809
	msotcidNewPhotoAlbum = 7063,		//(0,25) Label: 'New &Photo Album...' NOTE: noicon; PPT Insert Picture New Photo Album; Create New Photo Album (#202295)
	msotcidFormatPhotoAlbum = 7064,		//(0,25) Label: '&Photo Album...' NOTE: noicon; PPT Format Photo Album; Allows editing of a photo album (#202292)
	msotcidDesignTemplates = 7065,		//(1,29) Label: '' NOTE: icon;
	msotcidShowCalendarDetails = 7066,		//(0,25) Label: '&Show Calendar Details' NOTE: noicon; OLK: Appointment Scheduling tab -> Options button; Toggles display of Free/Busy details
	msotcidCanvasScale = 7067,		//(60,8) Label: 'S&cale Drawing' NOTE: noicon;
	msotcidOrgChartScale = 7068,		//(60,8) Label: 'S&cale Organization Chart' NOTE: noicon;
	msotcidDiagramScale = 7069,		//(60,8) Label: 'S&cale Diagram' NOTE: noicon;
	msotcidAlignRelativeToOrgChart = 7070,		//(0,25) Label: 'Relative t&o Organization Chart' NOTE: noicon;
	msotcidAlignRelativeToDiagram = 7071,		//(0,25) Label: 'Relative t&o Diagram' NOTE: noicon;
	msotcidVisioDrawing = 7072,		//(60,0) Label: '&Microsoft Visio Drawing' NOTE: manual
	msotcidVisioTemplate = 7073,		//(64,24) Label: '&Microsoft Visio Template' NOTE: manual
	msotcidVisioStencil = 7074,		//(59,13) Label: '&Microsoft Visio Stencil' NOTE: manual
	msotcidVisioAddon = 7075,		//(60,7) Label: '&Microsoft Visio Add-On' NOTE: manual
	msotcidVisioProduct = 7076,		//(59,14) Label: '&Microsoft Visio' NOTE: manual
	msotcidVisioProduct2 = 7077,		//(0,25) Label: '&Microsoft Visio' NOTE: manual add by AaronWe for visio
	msotcidVisioProduct3 = 7078,		//(0,25) Label: '&Microsoft Visio' NOTE: manual add by AaronWe for visio
	msotcidVisioNewFromExisting = 7079,		//(59,15) Label: '&Microsoft Visio' NOTE: manual
	msotcidTrueTypeCollection = 7080,		//(59,16) Label: '&Microsoft Visio' NOTE: manual
	msotcidVectorFont = 7081,		//(67,19) Label: '&Microsoft Visio' NOTE: manual
	msotcidCreateNewFromTemplatePub = 7082,		//(3,29) Label: '&Create publication from template' NOTE: noicon same as msotcidCreateNewExistingPub Pub: Workpane item to create a pub from template
	msotcidSelectionProperties = 7083,		//(5,13) Label: 'Proper&ties' NOTE: noicon same as msotcidQueryProperties FP needs different accelerator
	msotcidChangePictureFromScanner = 7084,		//(37,28) Label: 'From &Scanner or Camera...' NOTE: noicon - sameas msotcidImagerScan Pub: context menu for Change Picture -> From scanner...
	msotcidPrintPreviewSeparationsCombo = 7085,		//(0,25) Label: '&Color Separations' NOTE: noicon; Pub: print preview window; allows previewing process or spot print separations individually
	msotcidRightDragMoveOutline = 7086,		//(0,25) Label: 'Mo&ve out of Text Flow Here' NOTE: noicon; Pub: context menu for moving objects outline; allows user to drag inline objects out of container
	msotcidRightDragCopyOutline = 7087,		//(0,25) Label: 'Co&py out of Text Flow Here' NOTE: noicon; Pub: context menu for copying objects outline; allows user to copy inline objects out of container
	msotcidRepairFont = 7088,		//(0,25) Label: '&Repair fonts' NOTE: noicon on Word Tools.Language menu bug 231056
	msotcidFixBrokenText = 7089,		//(0,25) Label: 'Fi&x Broken Text...' NOTE: noicon - on Word Tools menu bug 240253
	msotcidDummy7090 = 7090,		//(0,25) Label: '&Dummy7090' NOTE: Formerly FPInsertFormMenu, moved to menu range
	msotcidDataFileManagement = 7091,		//(0,25) Label: 'Data Fil&e Management...' NOTE: noicon; OLK: appears on Tools menu
	msotcidMailboxCleanup = 7092,		//(0,25) Label: 'Mailbo&x Cleanup' NOTE: noicon; OLK: appears on Tools menu
	msotcidMakeThisFolderAvailableOffline = 7093,		//(0,25) Label: 'Make This Folder Available &Offline' NOTE: noicon; OLK: appears on Retrieve Mail Settings menu
	msotcidStartOfficeDesigner = 7094,		//(0,25) Label: 'Start Microsoft Solution De&signer' NOTE: noicon; OLK: appears on Tools Form menu
	msotcidSyncGroups = 7095,		//(0,25) Label: 'All &Groups' NOTE: noicon; OLK: appears on Retrieve Mail From menu
	msotcidChartSortAscByTotal = 7096,		//(0,25) Label: 'Ascending &by Total' NOTE: noicon; Access; appears on PivotChart\Sort submenu
	msotcidChartSortDescByTotal = 7097,		//(0,25) Label: 'Descending by &Total' NOTE: noicon; Access; appears on PivotChart\Sort submenu
	msotcidDesigner = 7098,		//(72,23) Label: 'Microsoft Solution Designer' NOTE: icon; Designer; app icon for Designer
	msotcidMSPaper = 7099,		//(72,24) Label: 'Microsoft Office Document Imaging' NOTE: icon; MSPaper; app icon for MSPaper
	msotcidEditMasterEffect = 7100,		//(0,25) Label: '&Copy Effects to Slide' NOTE: noicon; PowerPnt, fixes for master animation UI, O10#278127
	msotcidViewMasterEffect = 7101,		//(0,25) Label: '&View Slide Master' NOTE: noicon; PowerPnt, fixes for master animation UI, O10#278127
	msotcidPublishToSiteManager = 7102,		//(0,25) Label: 'Publish as Web Si&te...' NOTE: noicon; Publisher; contact rodgerb for details
	msotcidBtnRealMax
	};
#include "tmpbtn.h"

